diff -pruN 1.10.19-1/bin/compile 2.0.9-1/bin/compile
--- 1.10.19-1/bin/compile	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/bin/compile	2021-01-27 15:09:27.000000000 +0000
@@ -20,7 +20,7 @@ require __DIR__.'/../src/bootstrap.php';
 use Composer\Compiler;
 
 error_reporting(-1);
-ini_set('display_errors', 1);
+ini_set('display_errors', '1');
 
 try {
     $compiler = new Compiler();
diff -pruN 1.10.19-1/bin/composer 2.0.9-1/bin/composer
--- 1.10.19-1/bin/composer	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/bin/composer	2021-01-27 15:09:27.000000000 +0000
@@ -24,35 +24,37 @@ if (defined('HHVM_VERSION') && version_c
 }
 
 if (function_exists('ini_set')) {
-    @ini_set('display_errors', 1);
+    @ini_set('display_errors', '1');
 
-    $memoryInBytes = function ($value) {
-        $unit = strtolower(substr($value, -1, 1));
-        $value = (int) $value;
-        switch($unit) {
-            case 'g':
-                $value *= 1024;
-                // no break (cumulative multiplier)
-            case 'm':
-                $value *= 1024;
-                // no break (cumulative multiplier)
-            case 'k':
-                $value *= 1024;
-        }
-
-        return $value;
-    };
-
-    $memoryLimit = trim(ini_get('memory_limit'));
-    // Increase memory_limit if it is lower than 1.5GB
-    if ($memoryLimit != -1 && $memoryInBytes($memoryLimit) < 1024 * 1024 * 1536) {
-        @ini_set('memory_limit', '1536M');
-    }
     // Set user defined memory limit
     if ($memoryLimit = getenv('COMPOSER_MEMORY_LIMIT')) {
         @ini_set('memory_limit', $memoryLimit);
+    } else {
+        $memoryInBytes = function ($value) {
+            $unit = strtolower(substr($value, -1, 1));
+            $value = (int) $value;
+            switch($unit) {
+                case 'g':
+                    $value *= 1024;
+                    // no break (cumulative multiplier)
+                case 'm':
+                    $value *= 1024;
+                    // no break (cumulative multiplier)
+                case 'k':
+                    $value *= 1024;
+            }
+
+            return $value;
+        };
+
+        $memoryLimit = trim(ini_get('memory_limit'));
+        // Increase memory_limit if it is lower than 1.5GB
+        if ($memoryLimit != -1 && $memoryInBytes($memoryLimit) < 1024 * 1024 * 1536) {
+            @ini_set('memory_limit', '1536M');
+        }
+        unset($memoryInBytes);
     }
-    unset($memoryInBytes, $memoryLimit);
+    unset($memoryLimit);
 }
 
 putenv('COMPOSER_BINARY='.realpath($_SERVER['argv'][0]));
diff -pruN 1.10.19-1/CHANGELOG.md 2.0.9-1/CHANGELOG.md
--- 1.10.19-1/CHANGELOG.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/CHANGELOG.md	2021-01-27 15:09:27.000000000 +0000
@@ -1,3 +1,174 @@
+### [2.0.9] 2021-01-27
+
+  * Added warning if the curl extension is not enabled as it significantly degrades performance
+  * Fixed InstalledVersions to report all packages when several vendor dirs are present in the same runtime
+  * Fixed download speed when downloading large files
+  * Fixed `archive` and path repo copies mishandling some .gitignore paths
+  * Fixed root package classes not being available to the plugins/scripts during the initial install
+  * Fixed cache writes to be atomic and better support multiple Composer processes running in parallel
+  * Fixed preg jit issues when `config` or `require` modifies large composer.json files
+  * Fixed compatibility with envs having open_basedir restrictions
+  * Fixed exclude-from-classmap causing regex issues when having too many paths
+  * Fixed compatibility issue with Symfony 4/5
+  * Several small performance and debug output improvements
+
+### [2.0.8] 2020-12-03
+
+  * Fixed packages with aliases not matching conflicts which match the alias
+  * Fixed invalid reports of uncommitted changes when using non-default remotes in vendor dir
+  * Fixed curl error handling edge cases
+  * Fixed cached git repositories becoming stale by having a `git gc` applied to them periodically
+  * Fixed issue initializing plugins when using dev packages
+  * Fixed update --lock / mirrors failing to update in some edge cases
+  * Fixed partial update with --with-dependencies failing in some edge cases with some nonsensical error
+
+### [2.0.7] 2020-11-13
+
+  * Fixed detection of TTY mode, made input non-interactive automatically if STDIN is not a TTY
+  * Fixed root aliases not being present in lock file if not required by anything else
+  * Fixed `remove` command requiring a lock file to be present
+  * Fixed `Composer\InstalledVersions` to always contain up to date data during installation
+  * Fixed `status` command breaking on slow networks
+  * Fixed order of POST_PACKAGE_* events to occur together once all installations of a package batch are done
+
+### [2.0.6] 2020-11-07
+
+  * Fixed regression in 2.0.5 dealing with custom installers which do not pass absolute paths
+
+### [2.0.5] 2020-11-06
+
+  * Disabled platform-check verification of extensions by default (now defaulting `php-only`), set platform-check to `true` if you want a complete check
+  * Improved platform-check handling of issue reporting
+  * Fixed platform-check to only check non-dev requires even if require-dev dependencies are installed
+  * Fixed issues dealing with custom installers which return trailing slashes in getInstallPath (ideally avoid doing this as there might be other issues left)
+  * Fixed issues when curl functions are disabled
+  * Fixed gitlab-domains/github-domains to make sure if they are overridden the default value remains present
+  * Fixed issues removing/upgrading packages from path repositories on Windows
+  * Fixed regression in 2.0.4 when handling of git@bitbucket.org URLs in vcs repositories
+  * Fixed issue running create-project in current directory on Windows
+
+### [2.0.4] 2020-10-30
+
+  * Fixed `check-platform-req` command not being clear on what packages are checked, and added a --lock flag to explicitly check the locked packages
+  * Fixed `config` & `create-project` adding of repositories to make sure they are prepended as order is much more important in Composer 2, also added a --append flag to `config` to restore the old behavior in the unlikely case this is needed
+  * Fixed curl downloader failing on old PHP releases or when using self-signed SSL certificates
+  * Fixed Bitbucket API authentication issue
+
+### [2.0.3] 2020-10-28
+
+  * Fixed bug in `outdated` command where dev packages with branch-aliases where always shown as being outdated
+  * Fixed issue in lock file interoperability with composer 1.x when using `dev-master as xxx` aliases
+  * Fixed new `--locked` option being missing from `outdated` command, for checking outdated packages directly from the lock file
+  * Fixed a few debug/error reporting strings
+
+### [2.0.2] 2020-10-25
+
+  * Fixed regression handling `composer show -s` in projects where no version can be guessed from VCS
+  * Fixed regression handling partial updates/`require` when a lock file was missing
+  * Fixed interop issue with plugins that need to update dist URLs of packages, [see docs](https://getcomposer.org/doc/articles/plugins.md#plugin-modifies-downloads) if you need this
+
+### [2.0.1] 2020-10-24
+
+  * Fixed crash on PHP8
+
+### [2.0.0] 2020-10-24
+
+  * Fixed proxy handling issues when combined with our new curl-based downloader
+  * Fixed solver bug resulting in endless loops in some cases
+  * Fixed solver output being extremely long due to learnt rules
+  * Fixed solver bug with multi literals
+  * Fixed a couple minor regressions
+
+### [2.0.0-RC2] 2020-10-14
+
+  * Breaking: Removed `OperationInterface::getReason` as the data was not accurate
+  * Added automatic removal of packages which are not required anymore whenever an update is done, this will purge packages previously left over by partial updates and `require`/`remove`
+  * Added shorthand aliases `-w` for `--with-dependencies` and `-W` for `--with-all-dependencies` on `update`/`require`/`remove` commands
+  * Added `COMPOSER_DEBUG_EVENTS=1` env var support for plugin authors to figure out which events are triggered when
+  * Added `setCustomCacheKey` to `PreFileDownloadEvent` and fixed a cache bug for integrations changing the processed url of package archives
+  * Added `Composer\Util\SyncHelper` for plugin authors to deal with async Promises more easily
+  * Added `$composer->getLoop()->getHttpDownloader()` to get access to the main HttpDownloader instance in plugins
+  * Added a non-zero exit code (2) and warning to `remove` command when a package to be removed could not be removed
+  * Added `--apcu-autoloader-prefix` (or `--apcu-prefix` for `dump-autoload` command) flag to let people use apcu autoloading in a deterministic output way if that is needed
+  * Fixed version guesser to look at remote branches as well as local ones
+  * Lots of minor bug fixes and improvements
+
+### [2.0.0-RC1] 2020-09-10
+
+  * Added more advanced filtering to avoid loading all versions of all referenced packages when resolving dependencies, which should reduce memory usage further in some cases
+  * Added support for many new `lib-*` packages in the platform repository and improved version detection for some `ext-*` and `lib-*` packages
+  * Added an `--ask` flag to `create-project` command to make Composer prompt for the install dir name, [useful for project install instructions](https://github.com/composer/composer/pull/9181)
+  * Added support for tar in artifact repositories
+  * Added a `cache-read-only` config option to make the cache usable in read only mode for containers and such
+  * Added better error reporting for a few more specific cases
+  * Added a new optional `available-package-patterns` attribute for v2-format Composer repositories, see [UPGRADE](UPGRADE-2.0.md) for details
+  * Fixed more PHP 8 compatibility issues
+  * Lots of minor bug fixes for regressions
+
+### [2.0.0-alpha3] 2020-08-03
+
+  * Breaking: Zip archives loaded by artifact repositories must now have a composer.json on top level, or a max of one folder on top level of the archive
+  * Added --no-dev support to `show` and `outdated` commands to skip dev requirements
+  * Added support for multiple --repository flags being passed into the `create-project` command, only useful in combination with `--add-repository` to persist them to composer.json
+  * Added a new optional `list` API endpoint for v2-format Composer repositories, see [UPGRADE](UPGRADE-2.0.md) for details
+  * Fixed `show -a` command not listing anything
+  * Fixed solver bug where it ended in a "Reached invalid decision id 0"
+  * Fixed updates of git-installed packages on windows
+  * Lots of minor bug fixes
+
+### [2.0.0-alpha2] 2020-06-24
+
+  * Added parallel installation of packages (requires OSX/Linux/WSL, and that `unzip` is present in PATH)
+  * Added optimization of constraints by compiling them to PHP code, which should reduce CPU time of updates
+  * Added handling of Ctrl-C on Windows for PHP 7.4+
+  * Added better support for default branch names other than `master`
+  * Added --format=summary flag to `license` command
+  * Fixed issue in platform check when requiring ext-zend-opcache
+  * Fixed inline aliases issues
+  * Fixed git integration issue when signatures are set to be shown by default
+
+### [2.0.0-alpha1] 2020-06-03
+
+  * Breaking: This is a major release and while we tried to keep things compatible for most users, you might want to have a look at the [UPGRADE](UPGRADE-2.0.md) guides
+  * Many CPU and memory performance improvements
+  * The update command is now much more deterministic as it does not take the already installed packages into account
+  * Package installation now performs all network operations first before doing any changes on disk, to reduce the chances of ending up with a partially updated vendor dir
+  * Partial updates and require/remove are now much faster as they only load the metadata required for the updated packages
+  * Added a [platform-check step](doc/07-runtime.md#platform-check) when vendor/autoload.php gets initialized which checks the current PHP version/extensions match what is expected and fails hard otherwise. Can be disabled with the platform-check config option
+  * Added a [`Composer\InstalledVersions`](doc/07-runtime.md#installed-versions) class which is autoloaded in every project and lets you check which packages/versions are present at runtime
+  * Added a `composer-runtime-api` virtual package which you can require (as e.g. `^2.0`) to ensure things like the InstalledVersions class above are present. It will effectively force people to use Composer 2.x to install your project
+  * Added support for parallel downloads of package metadata and zip files, this requires that the curl extension is present and we thus strongly recommend enabling curl
+  * Added much clearer dependency resolution error reporting for common error cases
+  * Added support for updating to a specific version with partial updates, as well as a [--with flag](doc/03-cli.md#update--u) to pass in temporary constraint overrides
+  * Added support for TTY mode on Linux/OSX/WSL so that script handlers now run in interactive mode
+  * Added `only`, `exclude` and `canonical` options to all repositories, see [repository priorities](https://getcomposer.org/repoprio) for details
+  * Added support for lib-zip platform package
+  * Added `pre-operations-exec` event to be fired before the packages get installed/upgraded/removed
+  * Added `pre-pool-create` event to be fired before the package pool for the dependency solver is created, which lets you modify the list of packages going in
+  * Added `post-file-download` event to be fired after package dist files are downloaded, which lets you do additional checks on the files
+  * Added --locked flag to `show` command to see the packages from the composer.lock file
+  * Added --unused flag to `remove` command to make sure any packages which are not needed anymore get removed
+  * Added --dry-run flag to `require` and `remove` commands
+  * Added --no-install flag to `update`, `require` and `remove` commands to disable the install step and only do the update step (composer.lock file update)
+  * Added --with-dependencies and --with-all-dependencies flag aliases to `require` and `remove` commands for consistency with `update`
+  * Added more info to `vendor/composer/installed.json`, a dev key stores whether dev requirements were installed, and every package now has an install-path key with its install location
+  * Added COMPOSER_DISABLE_NETWORK which if set makes Composer do its best to run offline. This can be useful when you have poor connectivity or to do benchmarking without network jitter
+  * Added --json and --merge flags to `config` command to allow editing complex `extra.*` values by using json as input
+  * Added confirmation prompt when running Composer as superuser in interactive mode
+  * Added --no-check-version to `validate` command to remove the warning in case the version is defined
+  * Added --ignore-platform-req (without s) to all commands supporting --ignore-platform-reqs, which accepts a package name so you can ignore only specific platform requirements
+  * Added support for wildcards (`*`) in classmap autoloader paths
+  * Added support for configuring GitLab deploy tokens in addition to private tokens, see [gitlab-token](doc/06-config.md#gitlab-token)
+  * Added support for package version guessing for require and init command to take all platform packages into account, not just php version
+  * Fixed package ordering when autoloading and especially when loading plugins, to make sure dependencies are loaded before their dependents
+  * Fixed suggest output being very spammy, it now is only one line long and shows more rarely
+  * Fixed conflict rules like e.g. >=5 from matching dev-master, as it is not normalized to 9999999-dev internally anymore
+
+### [1.10.20] 2021-01-27
+
+  * Fixed exclude-from-classmap causing regex issues when having too many paths
+  * Fixed compatibility issue with Symfony 4/5
+
 ### [1.10.19] 2020-12-04
 
   * Fixed regression on PHP 8.0
@@ -132,7 +303,7 @@
   * Fixed archive command to persist file permissions inside the zip files
   * Fixed init/require command to avoid suggesting packages which are already selected in the search results
   * Fixed create-project UX issues
-  * Fixed filemtime for vendor/composer/* files is now only changing when the files actually change
+  * Fixed filemtime for `vendor/composer/*` files is now only changing when the files actually change
   * Fixed issues detecting docker environment with an active open_basedir
 
 ### [1.9.3] 2020-02-04
@@ -142,7 +313,7 @@
 ### [1.9.2] 2020-01-14
 
   * Fixed minor git driver bugs
-  * Fixed schema validation for version field to allow dev-* versions too
+  * Fixed schema validation for version field to allow `dev-*` versions too
   * Fixed external processes' output being formatted even though it should not
   * Fixed issue with path repositories when trying to install feature branches
 
@@ -443,7 +614,7 @@
   * Fixed dist downloads from Bitbucket
   * Fixed some regressions related to xdebug disabling
   * Fixed `--minor-only` flag in `outdated` command
-  * Fixed handling of config.platform.php which did not replace other php-* package's versions
+  * Fixed handling of config.platform.php which did not replace other `php-*` package's versions
 
 ### [1.3.0] - 2016-12-24
 
@@ -815,7 +986,7 @@
 ### [1.0.0-alpha6] - 2012-10-23
 
   * Schema: Added ability to pass additional options to repositories (i.e. ssh keys/client certificates to secure private repos)
-  * Schema: Added a new `~` operator that should be preferred over `>=`, see http://getcomposer.org/doc/01-basic-usage.md#package-versions
+  * Schema: Added a new `~` operator that should be preferred over `>=`, see https://getcomposer.org/doc/01-basic-usage.md#package-versions
   * Schema: Version constraints `<x.y` are assumed to be `<x.y-dev` unless specified as `<x.y-stable` to reduce confusion
   * Added `config` command to edit/list config values, including --global switch for system config
   * Added OAuth token support for the GitHub API
@@ -865,7 +1036,7 @@
   * Added a recommendation for package names to be `lower-cased/with-dashes`, it will be enforced for new packages on Pacakgist
   * Added `require` command to add a package to your requirements and install it
   * Added a whitelist to `update`. Calling `composer update foo/bar foo/baz` allows you to update only those packages
-  * Added support for overriding repositories in the system config (define repositories in ~/.composer/config.json)
+  * Added support for overriding repositories in the system config (define repositories in `~/.composer/config.json`)
   * Added `lib-*` packages to the platform repository, e.g. `lib-pcre` contains the pcre version
   * Added caching of GitHub metadata (faster startup time with custom GitHub VCS repos)
   * Added caching of SVN metadata (faster startup time with custom SVN VCS repos)
@@ -924,6 +1095,22 @@
 
   * Initial release
 
+[2.0.9]: https://github.com/composer/composer/compare/2.0.8...2.0.9
+[2.0.8]: https://github.com/composer/composer/compare/2.0.7...2.0.8
+[2.0.7]: https://github.com/composer/composer/compare/2.0.6...2.0.7
+[2.0.6]: https://github.com/composer/composer/compare/2.0.5...2.0.6
+[2.0.5]: https://github.com/composer/composer/compare/2.0.4...2.0.5
+[2.0.4]: https://github.com/composer/composer/compare/2.0.3...2.0.4
+[2.0.3]: https://github.com/composer/composer/compare/2.0.2...2.0.3
+[2.0.2]: https://github.com/composer/composer/compare/2.0.1...2.0.2
+[2.0.1]: https://github.com/composer/composer/compare/2.0.0...2.0.1
+[2.0.0]: https://github.com/composer/composer/compare/2.0.0-RC2...2.0.0
+[2.0.0-RC2]: https://github.com/composer/composer/compare/2.0.0-RC1...2.0.0-RC2
+[2.0.0-RC1]: https://github.com/composer/composer/compare/2.0.0-alpha3...2.0.0-RC1
+[2.0.0-alpha3]: https://github.com/composer/composer/compare/2.0.0-alpha2...2.0.0-alpha3
+[2.0.0-alpha2]: https://github.com/composer/composer/compare/2.0.0-alpha1...2.0.0-alpha2
+[2.0.0-alpha1]: https://github.com/composer/composer/compare/1.10.7...2.0.0-alpha1
+[1.10.20]: https://github.com/composer/composer/compare/1.10.19...1.10.20
 [1.10.19]: https://github.com/composer/composer/compare/1.10.18...1.10.19
 [1.10.18]: https://github.com/composer/composer/compare/1.10.17...1.10.18
 [1.10.17]: https://github.com/composer/composer/compare/1.10.16...1.10.17
diff -pruN 1.10.19-1/CODE_OF_CONDUCT.md 2.0.9-1/CODE_OF_CONDUCT.md
--- 1.10.19-1/CODE_OF_CONDUCT.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/CODE_OF_CONDUCT.md	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,76 @@
+# Contributor Covenant Code of Conduct
+
+## Our Pledge
+
+In the interest of fostering an open and welcoming environment, we as
+contributors and maintainers pledge to making participation in our project and
+our community a harassment-free experience for everyone, regardless of age, body
+size, disability, ethnicity, sex characteristics, gender identity and expression,
+level of experience, education, socio-economic status, nationality, personal
+appearance, race, religion, or sexual identity and orientation.
+
+## Our Standards
+
+Examples of behavior that contributes to creating a positive environment
+include:
+
+* Using welcoming and inclusive language
+* Being respectful of differing viewpoints and experiences
+* Gracefully accepting constructive criticism
+* Focusing on what is best for the community
+* Showing empathy towards other community members
+
+Examples of unacceptable behavior by participants include:
+
+* The use of sexualized language or imagery and unwelcome sexual attention or
+ advances
+* Trolling, insulting/derogatory comments, and personal or political attacks
+* Public or private harassment
+* Publishing others' private information, such as a physical or electronic
+ address, without explicit permission
+* Other conduct which could reasonably be considered inappropriate in a
+ professional setting
+
+## Our Responsibilities
+
+Project maintainers are responsible for clarifying the standards of acceptable
+behavior and are expected to take appropriate and fair corrective action in
+response to any instances of unacceptable behavior.
+
+Project maintainers have the right and responsibility to remove, edit, or
+reject comments, commits, code, wiki edits, issues, and other contributions
+that are not aligned to this Code of Conduct, or to ban temporarily or
+permanently any contributor for other behaviors that they deem inappropriate,
+threatening, offensive, or harmful.
+
+## Scope
+
+This Code of Conduct applies both within project spaces and in public spaces
+when an individual is representing the project or its community. Examples of
+representing a project or community include using an official project e-mail
+address, posting via an official social media account, or acting as an appointed
+representative at an online or offline event. Representation of a project may be
+further defined and clarified by project maintainers.
+
+## Enforcement
+
+Instances of abusive, harassing, or otherwise unacceptable behavior may be
+reported by contacting the project team at contact@packagist.org. All
+complaints will be reviewed and investigated and will result in a response that
+is deemed necessary and appropriate to the circumstances. The project team is
+obligated to maintain confidentiality with regard to the reporter of an incident.
+Further details of specific enforcement policies may be posted separately.
+
+Project maintainers who do not follow or enforce the Code of Conduct in good
+faith may face temporary or permanent repercussions as determined by other
+members of the project's leadership.
+
+## Attribution
+
+This Code of Conduct is adapted from the [Contributor Covenant][homepage], version 1.4,
+available at https://www.contributor-covenant.org/version/1/4/code-of-conduct.html
+
+[homepage]: https://www.contributor-covenant.org
+
+For answers to common questions about this code of conduct, see
+https://www.contributor-covenant.org/faq
diff -pruN 1.10.19-1/composer.json 2.0.9-1/composer.json
--- 1.10.19-1/composer.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/composer.json	2021-01-27 15:09:27.000000000 +0000
@@ -13,34 +13,32 @@
         {
             "name": "Nils Adermann",
             "email": "naderman@naderman.de",
-            "homepage": "http://www.naderman.de"
+            "homepage": "https://www.naderman.de"
         },
         {
             "name": "Jordi Boggiano",
             "email": "j.boggiano@seld.be",
-            "homepage": "http://seld.be"
+            "homepage": "https://seld.be"
         }
     ],
     "require": {
         "php": "^5.3.2 || ^7.0 || ^8.0",
         "composer/ca-bundle": "^1.0",
-        "composer/semver": "^1.0",
+        "composer/semver": "^3.0",
         "composer/spdx-licenses": "^1.2",
         "composer/xdebug-handler": "^1.1",
         "justinrainbow/json-schema": "^5.2.10",
         "psr/log": "^1.0",
         "seld/jsonlint": "^1.4",
         "seld/phar-utils": "^1.0",
-        "symfony/console": "^2.7 || ^3.0 || ^4.0 || ^5.0",
-        "symfony/filesystem": "^2.7 || ^3.0 || ^4.0 || ^5.0",
-        "symfony/finder": "^2.7 || ^3.0 || ^4.0 || ^5.0",
-        "symfony/process": "^2.7 || ^3.0 || ^4.0 || ^5.0"
-    },
-    "conflict": {
-        "symfony/console": "2.8.38"
+        "symfony/console": "^2.8.52 || ^3.4.35 || ^4.4 || ^5.0",
+        "symfony/filesystem": "^2.8.52 || ^3.4.35 || ^4.4 || ^5.0",
+        "symfony/finder": "^2.8.52 || ^3.4.35 || ^4.4 || ^5.0",
+        "symfony/process": "^2.8.52 || ^3.4.35 || ^4.4 || ^5.0",
+        "react/promise": "^1.2 || ^2.7"
     },
     "require-dev": {
-        "symfony/phpunit-bridge": "^4.2",
+        "symfony/phpunit-bridge": "^4.2 || ^5.0",
         "phpspec/prophecy": "^1.10"
     },
     "suggest": {
@@ -51,11 +49,12 @@
     "config": {
         "platform": {
             "php": "5.3.9"
-        }
+        },
+        "platform-check": false
     },
     "extra": {
         "branch-alias": {
-            "dev-master": "1.10-dev"
+            "dev-master": "2.0-dev"
         }
     },
     "autoload": {
@@ -65,8 +64,13 @@
     },
     "autoload-dev": {
         "psr-4": {
-            "Composer\\Test\\": "tests/Composer/Test"
-        }
+            "Composer\\Test\\": "tests/Composer/Test",
+            "Composer\\PHPStanRules\\": "phpstan/Rules/src",
+            "Composer\\PHPStanRulesTests\\": "phpstan/Rules/tests"
+        },
+        "classmap": [
+            "phpstan/Rules/tests/data"
+        ]
     },
     "bin": [
         "bin/composer"
diff -pruN 1.10.19-1/composer.lock 2.0.9-1/composer.lock
--- 1.10.19-1/composer.lock	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/composer.lock	2021-01-27 15:09:27.000000000 +0000
@@ -4,20 +4,20 @@
         "Read more about it at https://getcomposer.org/doc/01-basic-usage.md#installing-dependencies",
         "This file is @generated automatically"
     ],
-    "content-hash": "f572867898a016e14b08d0b15faedffb",
+    "content-hash": "9b94ece2895724239b36aec399e5321a",
     "packages": [
         {
             "name": "composer/ca-bundle",
-            "version": "1.2.8",
+            "version": "1.2.9",
             "source": {
                 "type": "git",
                 "url": "https://github.com/composer/ca-bundle.git",
-                "reference": "8a7ecad675253e4654ea05505233285377405215"
+                "reference": "78a0e288fdcebf92aa2318a8d3656168da6ac1a5"
             },
             "dist": {
                 "type": "zip",
-                "url": "https://api.github.com/repos/composer/ca-bundle/zipball/8a7ecad675253e4654ea05505233285377405215",
-                "reference": "8a7ecad675253e4654ea05505233285377405215",
+                "url": "https://api.github.com/repos/composer/ca-bundle/zipball/78a0e288fdcebf92aa2318a8d3656168da6ac1a5",
+                "reference": "78a0e288fdcebf92aa2318a8d3656168da6ac1a5",
                 "shasum": ""
             },
             "require": {
@@ -26,14 +26,15 @@
                 "php": "^5.3.2 || ^7.0 || ^8.0"
             },
             "require-dev": {
-                "phpunit/phpunit": "^4.8.35 || ^5.7 || 6.5 - 8",
+                "phpstan/phpstan": "^0.12.55",
                 "psr/log": "^1.0",
+                "symfony/phpunit-bridge": "^4.2 || ^5",
                 "symfony/process": "^2.5 || ^3.0 || ^4.0 || ^5.0"
             },
             "type": "library",
             "extra": {
                 "branch-alias": {
-                    "dev-master": "1.x-dev"
+                    "dev-main": "1.x-dev"
                 }
             },
             "autoload": {
@@ -63,7 +64,7 @@
             "support": {
                 "irc": "irc://irc.freenode.org/composer",
                 "issues": "https://github.com/composer/ca-bundle/issues",
-                "source": "https://github.com/composer/ca-bundle/tree/1.2.8"
+                "source": "https://github.com/composer/ca-bundle/tree/1.2.9"
             },
             "funding": [
                 {
@@ -79,32 +80,33 @@
                     "type": "tidelift"
                 }
             ],
-            "time": "2020-08-23T12:54:47+00:00"
+            "time": "2021-01-12T12:10:35+00:00"
         },
         {
             "name": "composer/semver",
-            "version": "1.7.2",
+            "version": "3.2.4",
             "source": {
                 "type": "git",
                 "url": "https://github.com/composer/semver.git",
-                "reference": "647490bbcaf7fc4891c58f47b825eb99d19c377a"
+                "reference": "a02fdf930a3c1c3ed3a49b5f63859c0c20e10464"
             },
             "dist": {
                 "type": "zip",
-                "url": "https://api.github.com/repos/composer/semver/zipball/647490bbcaf7fc4891c58f47b825eb99d19c377a",
-                "reference": "647490bbcaf7fc4891c58f47b825eb99d19c377a",
+                "url": "https://api.github.com/repos/composer/semver/zipball/a02fdf930a3c1c3ed3a49b5f63859c0c20e10464",
+                "reference": "a02fdf930a3c1c3ed3a49b5f63859c0c20e10464",
                 "shasum": ""
             },
             "require": {
                 "php": "^5.3.2 || ^7.0 || ^8.0"
             },
             "require-dev": {
-                "phpunit/phpunit": "^4.5 || ^5.0.5"
+                "phpstan/phpstan": "^0.12.54",
+                "symfony/phpunit-bridge": "^4.2 || ^5"
             },
             "type": "library",
             "extra": {
                 "branch-alias": {
-                    "dev-master": "1.x-dev"
+                    "dev-main": "3.x-dev"
                 }
             },
             "autoload": {
@@ -140,6 +142,11 @@
                 "validation",
                 "versioning"
             ],
+            "support": {
+                "irc": "irc://irc.freenode.org/composer",
+                "issues": "https://github.com/composer/semver/issues",
+                "source": "https://github.com/composer/semver/tree/3.2.4"
+            },
             "funding": [
                 {
                     "url": "https://packagist.com",
@@ -154,7 +161,7 @@
                     "type": "tidelift"
                 }
             ],
-            "time": "2020-12-03T15:47:16+00:00"
+            "time": "2020-11-13T08:59:24+00:00"
         },
         {
             "name": "composer/spdx-licenses",
@@ -214,6 +221,11 @@
                 "spdx",
                 "validator"
             ],
+            "support": {
+                "irc": "irc://irc.freenode.org/composer",
+                "issues": "https://github.com/composer/spdx-licenses/issues",
+                "source": "https://github.com/composer/spdx-licenses/tree/1.5.5"
+            },
             "funding": [
                 {
                     "url": "https://packagist.com",
@@ -414,6 +426,54 @@
             "time": "2020-03-23T09:12:05+00:00"
         },
         {
+            "name": "react/promise",
+            "version": "v1.2.1",
+            "source": {
+                "type": "git",
+                "url": "https://github.com/reactphp/promise.git",
+                "reference": "eefff597e67ff66b719f8171480add3c91474a1e"
+            },
+            "dist": {
+                "type": "zip",
+                "url": "https://api.github.com/repos/reactphp/promise/zipball/eefff597e67ff66b719f8171480add3c91474a1e",
+                "reference": "eefff597e67ff66b719f8171480add3c91474a1e",
+                "shasum": ""
+            },
+            "require": {
+                "php": ">=5.3.3"
+            },
+            "type": "library",
+            "extra": {
+                "branch-alias": {
+                    "dev-master": "1.1-dev"
+                }
+            },
+            "autoload": {
+                "psr-0": {
+                    "React\\Promise": "src/"
+                },
+                "files": [
+                    "src/React/Promise/functions_include.php"
+                ]
+            },
+            "notification-url": "https://packagist.org/downloads/",
+            "license": [
+                "MIT"
+            ],
+            "authors": [
+                {
+                    "name": "Jan Sorgalla",
+                    "email": "jsorgalla@gmail.com"
+                }
+            ],
+            "description": "A lightweight implementation of CommonJS Promises/A for PHP",
+            "support": {
+                "issues": "https://github.com/reactphp/promise/issues",
+                "source": "https://github.com/reactphp/promise/tree/1.0"
+            },
+            "time": "2016-03-07T13:46:50+00:00"
+        },
+        {
             "name": "seld/jsonlint",
             "version": "1.8.3",
             "source": {
@@ -1477,5 +1537,5 @@
     "platform-overrides": {
         "php": "5.3.9"
     },
-    "plugin-api-version": "1.1.0"
+    "plugin-api-version": "2.0.0"
 }
diff -pruN 1.10.19-1/debian/autoload.php.tpl 2.0.9-1/debian/autoload.php.tpl
--- 1.10.19-1/debian/autoload.php.tpl	2020-12-11 15:22:03.000000000 +0000
+++ 2.0.9-1/debian/autoload.php.tpl	2021-01-28 22:53:16.000000000 +0000
@@ -11,6 +11,7 @@ require_once 'Symfony/Component/Console/
 require_once 'Symfony/Component/Filesystem/autoload.php';
 require_once 'Symfony/Component/Finder/autoload.php';
 require_once 'Symfony/Component/Process/autoload.php';
+require_once 'React/Promise/autoload.php';
 
 // @codingStandardsIgnoreFile
 // @codeCoverageIgnoreStart
diff -pruN 1.10.19-1/debian/changelog 2.0.9-1/debian/changelog
--- 1.10.19-1/debian/changelog	2020-12-11 15:30:40.000000000 +0000
+++ 2.0.9-1/debian/changelog	2021-01-29 00:05:13.000000000 +0000
@@ -1,3 +1,40 @@
+composer (2.0.9-1) unstable; urgency=medium
+
+  [ Jordi Boggiano ]
+  * Release 2.0.9
+
+  [ David Prévot ]
+  * Simplify gbp import-orig workflow
+
+ -- David Prévot <taffit@debian.org>  Thu, 28 Jan 2021 20:05:13 -0400
+
+composer (2.0.8-2) unstable; urgency=medium
+
+  * Upload to unstable in sync with PHPUnit 9
+
+ -- David Prévot <taffit@debian.org>  Sun, 20 Dec 2020 17:04:35 -0400
+
+composer (2.0.8-1) experimental; urgency=medium
+
+  * Upload new major release to experimental
+
+  [ Jordi Boggiano ]
+  * Update react/promise requirement
+  * Fix php8 build bootstrap
+  * Try to workaround react/promise php8 issue
+  * Bump to use composer/semver 3.x
+  * Release 2.0.8
+
+  [ David Prévot ]
+  * Install upgrade documentation
+  * Build-Depend on php-react-promise
+  * Build-Depend on recent php-composer-semver
+  * Ignore Class Redeclarations in test files
+  * Use recent PHPUnit to run tests
+  * Use php-intl for the testsuite
+
+ -- David Prévot <taffit@debian.org>  Fri, 11 Dec 2020 14:05:54 -0400
+
 composer (1.10.19-1) unstable; urgency=medium
 
   [ Jordi Boggiano ]
diff -pruN 1.10.19-1/debian/control 2.0.9-1/debian/control
--- 1.10.19-1/debian/control	2020-12-11 15:30:21.000000000 +0000
+++ 2.0.9-1/debian/control	2021-01-29 00:04:50.000000000 +0000
@@ -9,19 +9,21 @@ Build-Depends: debhelper-compat (= 13),
                jsonlint,
                mercurial,
                php-composer-ca-bundle,
-               php-composer-semver,
+               php-composer-semver (>= 3),
                php-composer-spdx-licenses,
                php-composer-xdebug-handler,
+               php-intl,
                php-json-schema,
                php-mbstring,
                php-psr-log,
+               php-react-promise,
                php-symfony-console,
                php-symfony-filesystem,
                php-symfony-finder,
                php-symfony-process,
                php-zip,
                phpab,
-               phpunit,
+               phpunit (>= 9),
                pkg-php-tools
 Standards-Version: 4.5.1
 Homepage: https://getcomposer.org/
diff -pruN 1.10.19-1/debian/docs 2.0.9-1/debian/docs
--- 1.10.19-1/debian/docs	2020-12-11 15:22:03.000000000 +0000
+++ 2.0.9-1/debian/docs	2021-01-28 22:53:16.000000000 +0000
@@ -1,2 +1,3 @@
 README.md
+UPGRADE-*.md
 doc/*
diff -pruN 1.10.19-1/debian/gbp.conf 2.0.9-1/debian/gbp.conf
--- 1.10.19-1/debian/gbp.conf	2020-12-11 15:22:03.000000000 +0000
+++ 2.0.9-1/debian/gbp.conf	2021-01-28 22:53:16.000000000 +0000
@@ -1,9 +1,5 @@
 [DEFAULT]
 debian-branch = debian/latest
 pristine-tar = True
-pristine-tar-commit = True
-
-## Once --filter support gets added to gbp import-ref, we should be able
-## to simplify the workflow and ignore the upstream branch.
-# filter = [ '.gitattributes' ]
-# upstream-tag = %(version%~%-)s
+filter = [ '.gitattributes' ]
+upstream-vcs-tag = %(version%~%-)s
diff -pruN 1.10.19-1/debian/patches/0001-Use-homade-autoload-for-CLI.patch 2.0.9-1/debian/patches/0001-Use-homade-autoload-for-CLI.patch
--- 1.10.19-1/debian/patches/0001-Use-homade-autoload-for-CLI.patch	2020-12-11 15:23:21.000000000 +0000
+++ 2.0.9-1/debian/patches/0001-Use-homade-autoload-for-CLI.patch	2021-01-28 22:53:34.000000000 +0000
@@ -8,7 +8,7 @@ Forwarded: not-needed
  1 file changed, 2 insertions(+), 2 deletions(-)
 
 diff --git a/bin/composer b/bin/composer
-index b7ab531..b8ca294 100755
+index cadff6d..5b1c87c 100755
 --- a/bin/composer
 +++ b/bin/composer
 @@ -1,4 +1,4 @@
diff -pruN 1.10.19-1/debian/patches/0002-Adapt-res-path.patch 2.0.9-1/debian/patches/0002-Adapt-res-path.patch
--- 1.10.19-1/debian/patches/0002-Adapt-res-path.patch	2020-12-11 15:23:21.000000000 +0000
+++ 2.0.9-1/debian/patches/0002-Adapt-res-path.patch	2021-01-28 22:53:34.000000000 +0000
@@ -8,7 +8,7 @@ Forwarded: not-needed
  1 file changed, 1 insertion(+), 1 deletion(-)
 
 diff --git a/src/Composer/Json/JsonFile.php b/src/Composer/Json/JsonFile.php
-index 89524df..315148c 100644
+index e794fe6..865c797 100644
 --- a/src/Composer/Json/JsonFile.php
 +++ b/src/Composer/Json/JsonFile.php
 @@ -34,7 +34,7 @@ class JsonFile
@@ -19,4 +19,4 @@ index 89524df..315148c 100644
 +    const COMPOSER_SCHEMA_PATH = '/../../data/Composer/res/composer-schema.json';
  
      private $path;
-     private $rfs;
+     private $httpDownloader;
diff -pruN 1.10.19-1/debian/patches/0004-Adapt-LICENSE-path.patch 2.0.9-1/debian/patches/0004-Adapt-LICENSE-path.patch
--- 1.10.19-1/debian/patches/0004-Adapt-LICENSE-path.patch	2020-12-11 15:23:21.000000000 +0000
+++ 2.0.9-1/debian/patches/0004-Adapt-LICENSE-path.patch	2021-01-28 22:53:34.000000000 +0000
@@ -8,15 +8,15 @@ Forwarded: not needed
  1 file changed, 1 insertion(+), 1 deletion(-)
 
 diff --git a/src/Composer/Autoload/AutoloadGenerator.php b/src/Composer/Autoload/AutoloadGenerator.php
-index 863ceac..0341ecf 100644
+index fa5dd9c..e5fd610 100644
 --- a/src/Composer/Autoload/AutoloadGenerator.php
 +++ b/src/Composer/Autoload/AutoloadGenerator.php
-@@ -315,7 +315,7 @@ EOF;
-         $this->filePutContentsIfModified($targetDir.'/autoload_real.php', $this->getAutoloadRealFile(true, (bool) $includePathFileContents, $targetDirLoader, (bool) $includeFilesFileContents, $vendorPathCode, $appBaseDirCode, $suffix, $useGlobalIncludePath, $prependAutoloader, $staticPhpVersion));
+@@ -373,7 +373,7 @@ EOF;
+         $filesystem->filePutContentsIfModified($targetDir.'/autoload_real.php', $this->getAutoloadRealFile(true, (bool) $includePathFileContents, $targetDirLoader, (bool) $includeFilesFileContents, $vendorPathCode, $appBaseDirCode, $suffix, $useGlobalIncludePath, $prependAutoloader, $staticPhpVersion, $checkPlatform));
  
-         $this->safeCopy(__DIR__.'/ClassLoader.php', $targetDir.'/ClassLoader.php');
--        $this->safeCopy(__DIR__.'/../../../LICENSE', $targetDir.'/LICENSE');
-+        $this->safeCopy(__DIR__.'/../../data/Composer/LICENSE', $targetDir.'/LICENSE');
+         $filesystem->safeCopy(__DIR__.'/ClassLoader.php', $targetDir.'/ClassLoader.php');
+-        $filesystem->safeCopy(__DIR__.'/../../../LICENSE', $targetDir.'/LICENSE');
++        $filesystem->safeCopy(__DIR__.'/../../data/Composer/LICENSE', $targetDir.'/LICENSE');
  
          if ($this->runScripts) {
              $this->eventDispatcher->dispatchScript(ScriptEvents::POST_AUTOLOAD_DUMP, $this->devMode, array(), array(
diff -pruN 1.10.19-1/debian/patches/0006-Tag-tests-relying-on-remote-network.patch 2.0.9-1/debian/patches/0006-Tag-tests-relying-on-remote-network.patch
--- 1.10.19-1/debian/patches/0006-Tag-tests-relying-on-remote-network.patch	2020-12-11 15:23:21.000000000 +0000
+++ 2.0.9-1/debian/patches/0006-Tag-tests-relying-on-remote-network.patch	2021-01-28 22:53:34.000000000 +0000
@@ -1,39 +1,16 @@
 From: =?utf-8?q?David_Pr=C3=A9vot?= <taffit@debian.org>
-Date: Sun, 6 Aug 2017 13:20:24 -0400
+Date: Fri, 11 Dec 2020 11:49:36 -0400
 Subject: Tag tests relying on remote network
 
 ---
- tests/Composer/Test/Repository/PearRepositoryTest.php | 4 ++++
- tests/Composer/Test/Util/RemoteFilesystemTest.php     | 2 ++
- 2 files changed, 6 insertions(+)
+ tests/Composer/Test/Util/RemoteFilesystemTest.php | 2 ++
+ 1 file changed, 2 insertions(+)
 
-diff --git a/tests/Composer/Test/Repository/PearRepositoryTest.php b/tests/Composer/Test/Repository/PearRepositoryTest.php
-index b1a3c0b..fea9bbf 100644
---- a/tests/Composer/Test/Repository/PearRepositoryTest.php
-+++ b/tests/Composer/Test/Repository/PearRepositoryTest.php
-@@ -30,6 +30,9 @@ class PearRepositoryTest extends TestCase
-      */
-     private $remoteFilesystem;
- 
-+    /**
-+     * @group remote
-+     */
-     public function testComposerShouldSetIncludePath()
-     {
-         $url = 'pear.phpmd.org';
-@@ -62,6 +65,7 @@ class PearRepositoryTest extends TestCase
-      * @dataProvider repositoryDataProvider
-      * @param string $url
-      * @param array  $expectedPackages
-+     * @group remote
-      */
-     public function testRepositoryRead($url, array $expectedPackages)
-     {
 diff --git a/tests/Composer/Test/Util/RemoteFilesystemTest.php b/tests/Composer/Test/Util/RemoteFilesystemTest.php
-index 486ad9a..f414ce4 100644
+index 98f0114..c1fde47 100644
 --- a/tests/Composer/Test/Util/RemoteFilesystemTest.php
 +++ b/tests/Composer/Test/Util/RemoteFilesystemTest.php
-@@ -222,6 +222,7 @@ class RemoteFilesystemTest extends TestCase
+@@ -282,6 +282,7 @@ class RemoteFilesystemTest extends TestCase
       * @param string $url
       * @param string $contents
       * @dataProvider provideBitbucketPublicDownloadUrls
@@ -41,7 +18,7 @@ index 486ad9a..f414ce4 100644
       */
      public function testBitBucketPublicDownload($url, $contents)
      {
-@@ -244,6 +245,7 @@ class RemoteFilesystemTest extends TestCase
+@@ -305,6 +306,7 @@ class RemoteFilesystemTest extends TestCase
       * @param string $url
       * @param string $contents
       * @dataProvider provideBitbucketPublicDownloadUrls
diff -pruN 1.10.19-1/debian/patches/0007-Tag-test-relying-on-git-repository.patch 2.0.9-1/debian/patches/0007-Tag-test-relying-on-git-repository.patch
--- 1.10.19-1/debian/patches/0007-Tag-test-relying-on-git-repository.patch	2020-12-11 15:23:21.000000000 +0000
+++ 2.0.9-1/debian/patches/0007-Tag-test-relying-on-git-repository.patch	2021-01-28 22:53:34.000000000 +0000
@@ -7,10 +7,10 @@ Subject: Tag test relying on git reposit
  1 file changed, 3 insertions(+)
 
 diff --git a/tests/Composer/Test/AllFunctionalTest.php b/tests/Composer/Test/AllFunctionalTest.php
-index 5e8ebb5..59f1c33 100644
+index a38eda1..1e8df2f 100644
 --- a/tests/Composer/Test/AllFunctionalTest.php
 +++ b/tests/Composer/Test/AllFunctionalTest.php
-@@ -64,6 +64,9 @@ class AllFunctionalTest extends TestCase
+@@ -63,6 +63,9 @@ class AllFunctionalTest extends TestCase
          $fs->removeDirectory(dirname(self::$pharPath));
      }
  
diff -pruN 1.10.19-1/debian/patches/0007-Use-expectException-instead-of-setExpectedException.patch 2.0.9-1/debian/patches/0007-Use-expectException-instead-of-setExpectedException.patch
--- 1.10.19-1/debian/patches/0007-Use-expectException-instead-of-setExpectedException.patch	2020-12-11 15:23:21.000000000 +0000
+++ 2.0.9-1/debian/patches/0007-Use-expectException-instead-of-setExpectedException.patch	2021-01-28 22:53:34.000000000 +0000
@@ -16,13 +16,13 @@ Subject: Use expectException instead of
  tests/Composer/Test/Package/LockerTest.php                   |  4 ++--
  tests/Composer/Test/Repository/RepositoryManagerTest.php     |  2 +-
  .../Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php  |  2 +-
- tests/Composer/Test/Util/ErrorHandlerTest.php                |  4 ++--
+ tests/Composer/Test/Util/ErrorHandlerTest.php                |  8 ++++----
  tests/Composer/Test/Util/FilesystemTest.php                  |  2 +-
  tests/Composer/Test/Util/SilencerTest.php                    |  2 +-
- 16 files changed, 28 insertions(+), 28 deletions(-)
+ 16 files changed, 30 insertions(+), 30 deletions(-)
 
 diff --git a/tests/Composer/Test/Command/InitCommandTest.php b/tests/Composer/Test/Command/InitCommandTest.php
-index 06d8a00..e6c7fbc 100644
+index d1c3b62..32b91d3 100644
 --- a/tests/Composer/Test/Command/InitCommandTest.php
 +++ b/tests/Composer/Test/Command/InitCommandTest.php
 @@ -82,14 +82,14 @@ class InitCommandTest extends TestCase
@@ -43,10 +43,10 @@ index 06d8a00..e6c7fbc 100644
      }
  }
 diff --git a/tests/Composer/Test/ConfigTest.php b/tests/Composer/Test/ConfigTest.php
-index 750dd62..72c6d80 100644
+index 4a4bf01..52fb026 100644
 --- a/tests/Composer/Test/ConfigTest.php
 +++ b/tests/Composer/Test/ConfigTest.php
-@@ -239,7 +239,7 @@ class ConfigTest extends TestCase
+@@ -238,7 +238,7 @@ class ConfigTest extends TestCase
       */
      public function testProhibitedUrlsThrowException($url)
      {
@@ -56,38 +56,38 @@ index 750dd62..72c6d80 100644
              'Your configuration does not allow connections to ' . $url
          );
 diff --git a/tests/Composer/Test/DependencyResolver/SolverTest.php b/tests/Composer/Test/DependencyResolver/SolverTest.php
-index 4dadee7..19f4d01 100644
+index cf916fb..24cde47 100644
 --- a/tests/Composer/Test/DependencyResolver/SolverTest.php
 +++ b/tests/Composer/Test/DependencyResolver/SolverTest.php
-@@ -445,7 +445,7 @@ class SolverTest extends TestCase
-         $this->request->install('A');
+@@ -415,7 +415,7 @@ class SolverTest extends TestCase
+         $this->request->requireName('A');
  
          // must explicitly pick the provider, so error in this case
 -        $this->setExpectedException('Composer\DependencyResolver\SolverProblemsException');
 +        $this->expectException('Composer\DependencyResolver\SolverProblemsException');
+         $this->createSolver();
          $this->solver->solve($this->request);
      }
+@@ -449,7 +449,7 @@ class SolverTest extends TestCase
  
-@@ -478,7 +478,7 @@ class SolverTest extends TestCase
- 
-         $this->request->install('A');
+         $this->request->requireName('A');
  
 -        $this->setExpectedException('Composer\DependencyResolver\SolverProblemsException');
 +        $this->expectException('Composer\DependencyResolver\SolverProblemsException');
+         $this->createSolver();
          $this->solver->solve($this->request);
      }
+@@ -621,7 +621,7 @@ class SolverTest extends TestCase
  
-@@ -649,7 +649,7 @@ class SolverTest extends TestCase
- 
-         $this->request->install('C', $this->getVersionConstraint('==', '2.0.0.0-dev'));
+         $this->request->requireName('C', $this->getVersionConstraint('==', '2.0.0.0-dev'));
  
 -        $this->setExpectedException('Composer\DependencyResolver\SolverProblemsException');
 +        $this->expectException('Composer\DependencyResolver\SolverProblemsException');
  
+         $this->createSolver();
          $this->solver->solve($this->request);
-     }
 diff --git a/tests/Composer/Test/Downloader/DownloadManagerTest.php b/tests/Composer/Test/Downloader/DownloadManagerTest.php
-index b5c63a8..90a98f9 100644
+index 4253882..b755e33 100644
 --- a/tests/Composer/Test/Downloader/DownloadManagerTest.php
 +++ b/tests/Composer/Test/Downloader/DownloadManagerTest.php
 @@ -34,7 +34,7 @@ class DownloadManagerTest extends TestCase
@@ -106,7 +106,7 @@ index b5c63a8..90a98f9 100644
 -        $this->setExpectedException('InvalidArgumentException');
 +        $this->expectException('InvalidArgumentException');
  
-         $manager->getDownloaderForInstalledPackage($package);
+         $manager->getDownloaderForPackage($package);
      }
 @@ -114,7 +114,7 @@ class DownloadManagerTest extends TestCase
              ->with('git')
@@ -115,7 +115,7 @@ index b5c63a8..90a98f9 100644
 -        $this->setExpectedException('LogicException');
 +        $this->expectException('LogicException');
  
-         $manager->getDownloaderForInstalledPackage($package);
+         $manager->getDownloaderForPackage($package);
      }
 @@ -180,7 +180,7 @@ class DownloadManagerTest extends TestCase
              ->with('pear')
@@ -124,7 +124,7 @@ index b5c63a8..90a98f9 100644
 -        $this->setExpectedException('LogicException');
 +        $this->expectException('LogicException');
  
-         $manager->getDownloaderForInstalledPackage($package);
+         $manager->getDownloaderForPackage($package);
      }
 @@ -304,7 +304,7 @@ class DownloadManagerTest extends TestCase
  
@@ -145,10 +145,10 @@ index b5c63a8..90a98f9 100644
      }
  
 diff --git a/tests/Composer/Test/EventDispatcher/EventDispatcherTest.php b/tests/Composer/Test/EventDispatcher/EventDispatcherTest.php
-index f1a7bb1..ed64c19 100644
+index bbf3e6b..54934a0 100644
 --- a/tests/Composer/Test/EventDispatcher/EventDispatcherTest.php
 +++ b/tests/Composer/Test/EventDispatcher/EventDispatcherTest.php
-@@ -522,7 +522,7 @@ class EventDispatcherTest extends TestCase
+@@ -543,7 +543,7 @@ class EventDispatcherTest extends TestCase
              ->method('writeError')
              ->with($this->equalTo('<error>Script '.$code.' handling the post-install-cmd event returned with error code 1</error>'));
  
@@ -158,10 +158,10 @@ index f1a7bb1..ed64c19 100644
      }
  
 diff --git a/tests/Composer/Test/Installer/InstallationManagerTest.php b/tests/Composer/Test/Installer/InstallationManagerTest.php
-index 477cbbe..62f457e 100644
+index c7256fe..692aa1d 100644
 --- a/tests/Composer/Test/Installer/InstallationManagerTest.php
 +++ b/tests/Composer/Test/Installer/InstallationManagerTest.php
-@@ -43,7 +43,7 @@ class InstallationManagerTest extends TestCase
+@@ -48,7 +48,7 @@ class InstallationManagerTest extends TestCase
          $manager->addInstaller($installer);
          $this->assertSame($installer, $manager->getInstaller('vendor'));
  
@@ -171,7 +171,7 @@ index 477cbbe..62f457e 100644
      }
  
 diff --git a/tests/Composer/Test/Installer/LibraryInstallerTest.php b/tests/Composer/Test/Installer/LibraryInstallerTest.php
-index d92ed33..efccfeb 100644
+index 4bf81ea..f0f509d 100644
 --- a/tests/Composer/Test/Installer/LibraryInstallerTest.php
 +++ b/tests/Composer/Test/Installer/LibraryInstallerTest.php
 @@ -187,7 +187,7 @@ class LibraryInstallerTest extends TestCase
@@ -215,10 +215,10 @@ index 481de79..f26ba0b 100644
          $this->installer->uninstall($this->repository, $package);
      }
 diff --git a/tests/Composer/Test/InstallerTest.php b/tests/Composer/Test/InstallerTest.php
-index 90f295d..42d8c18 100644
+index 0d503a4..4ac3e5c 100644
 --- a/tests/Composer/Test/InstallerTest.php
 +++ b/tests/Composer/Test/InstallerTest.php
-@@ -162,7 +162,7 @@ class InstallerTest extends TestCase
+@@ -211,7 +211,7 @@ class InstallerTest extends TestCase
          // Prepare for exceptions
          if (!is_int($expectResult)) {
              $normalizedOutput = rtrim(str_replace("\n", PHP_EOL, $expect));
@@ -228,10 +228,10 @@ index 90f295d..42d8c18 100644
  
          // Create Composer mock object according to configuration
 diff --git a/tests/Composer/Test/Package/Archiver/ArchiveManagerTest.php b/tests/Composer/Test/Package/Archiver/ArchiveManagerTest.php
-index f9fe308..63150eb 100644
+index 2c99ac6..4bdac61 100644
 --- a/tests/Composer/Test/Package/Archiver/ArchiveManagerTest.php
 +++ b/tests/Composer/Test/Package/Archiver/ArchiveManagerTest.php
-@@ -36,7 +36,7 @@ class ArchiveManagerTest extends ArchiverTest
+@@ -47,7 +47,7 @@ class ArchiveManagerTest extends ArchiverTest
  
      public function testUnknownFormat()
      {
@@ -241,10 +241,10 @@ index f9fe308..63150eb 100644
          $package = $this->setupPackage();
  
 diff --git a/tests/Composer/Test/Package/LockerTest.php b/tests/Composer/Test/Package/LockerTest.php
-index 04e8e6c..d5c36f3 100644
+index 29f3e7c..15205e1 100644
 --- a/tests/Composer/Test/Package/LockerTest.php
 +++ b/tests/Composer/Test/Package/LockerTest.php
-@@ -55,7 +55,7 @@ class LockerTest extends TestCase
+@@ -53,7 +53,7 @@ class LockerTest extends TestCase
              ->method('exists')
              ->will($this->returnValue(false));
  
@@ -253,7 +253,7 @@ index 04e8e6c..d5c36f3 100644
  
          $locker->getLockedRepository();
      }
-@@ -175,7 +175,7 @@ class LockerTest extends TestCase
+@@ -170,7 +170,7 @@ class LockerTest extends TestCase
              ->method('getPrettyName')
              ->will($this->returnValue('pkg1'));
  
@@ -263,10 +263,10 @@ index 04e8e6c..d5c36f3 100644
          $locker->setLockData(array($package1), array(), array(), array(), array(), 'dev', array(), false, false, array());
      }
 diff --git a/tests/Composer/Test/Repository/RepositoryManagerTest.php b/tests/Composer/Test/Repository/RepositoryManagerTest.php
-index f09b55a..ae3f133 100644
+index 1d59b63..7d545df 100644
 --- a/tests/Composer/Test/Repository/RepositoryManagerTest.php
 +++ b/tests/Composer/Test/Repository/RepositoryManagerTest.php
-@@ -55,7 +55,7 @@ class RepositoryManagerTest extends TestCase
+@@ -56,7 +56,7 @@ class RepositoryManagerTest extends TestCase
      public function testRepoCreation($type, $options, $exception = null)
      {
          if ($exception) {
@@ -276,10 +276,10 @@ index f09b55a..ae3f133 100644
  
          $rm = new RepositoryManager(
 diff --git a/tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php b/tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php
-index 8d711e8..15cdf39 100644
+index 2dae0ab..0bad336 100644
 --- a/tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php
 +++ b/tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php
-@@ -78,7 +78,7 @@ class GitBitbucketDriverTest extends TestCase
+@@ -80,7 +80,7 @@ class GitBitbucketDriverTest extends TestCase
  
      public function testGetRootIdentifierWrongScmType()
      {
@@ -289,29 +289,35 @@ index 8d711e8..15cdf39 100644
              'https://bitbucket.org/user/repo.git does not appear to be a git repository, use https://bitbucket.org/user/repo if this is a mercurial bitbucket repository'
          );
 diff --git a/tests/Composer/Test/Util/ErrorHandlerTest.php b/tests/Composer/Test/Util/ErrorHandlerTest.php
-index 89cc8b4..05909c2 100644
+index c7651b8..486aa1c 100644
 --- a/tests/Composer/Test/Util/ErrorHandlerTest.php
 +++ b/tests/Composer/Test/Util/ErrorHandlerTest.php
-@@ -35,7 +35,7 @@ class ErrorHandlerTest extends TestCase
-      */
+@@ -36,9 +36,9 @@ class ErrorHandlerTest extends TestCase
      public function testErrorHandlerCaptureNotice()
      {
--        $this->setExpectedException('\ErrorException', 'Undefined index: baz');
-+        $this->expectException('\ErrorException', 'Undefined index: baz');
+         if (PHP_VERSION_ID >= 80000) {
+-            $this->setExpectedException('\ErrorException', 'Undefined array key "baz"');
++            $this->expectException('\ErrorException', 'Undefined array key "baz"');
+         } else {
+-            $this->setExpectedException('\ErrorException', 'Undefined index: baz');
++            $this->expectException('\ErrorException', 'Undefined index: baz');
+         }
  
          $array = array('foo' => 'bar');
-         $array['baz'];
-@@ -46,7 +46,7 @@ class ErrorHandlerTest extends TestCase
-      */
+@@ -51,9 +51,9 @@ class ErrorHandlerTest extends TestCase
      public function testErrorHandlerCaptureWarning()
      {
--        $this->setExpectedException('\ErrorException', 'array_merge');
-+        $this->expectException('\ErrorException', 'array_merge');
+         if (PHP_VERSION_ID >= 80000) {
+-            $this->setExpectedException('TypeError', 'array_merge');
++            $this->expectException('TypeError', 'array_merge');
+         } else {
+-            $this->setExpectedException('ErrorException', 'array_merge');
++            $this->expectException('ErrorException', 'array_merge');
+         }
  
          array_merge(array(), 'string');
-     }
 diff --git a/tests/Composer/Test/Util/FilesystemTest.php b/tests/Composer/Test/Util/FilesystemTest.php
-index f3fb302..806a2a2 100644
+index 0fb4bab..d821c05 100644
 --- a/tests/Composer/Test/Util/FilesystemTest.php
 +++ b/tests/Composer/Test/Util/FilesystemTest.php
 @@ -292,7 +292,7 @@ class FilesystemTest extends TestCase
diff -pruN 1.10.19-1/debian/patches/0008-Compatibility-with-recent-PHPUnit-8.patch 2.0.9-1/debian/patches/0008-Compatibility-with-recent-PHPUnit-8.patch
--- 1.10.19-1/debian/patches/0008-Compatibility-with-recent-PHPUnit-8.patch	2020-12-11 15:23:21.000000000 +0000
+++ 2.0.9-1/debian/patches/0008-Compatibility-with-recent-PHPUnit-8.patch	2021-01-28 22:53:35.000000000 +0000
@@ -9,9 +9,8 @@ Subject: Compatibility with recent PHPUn
  tests/Composer/Test/Config/JsonConfigSourceTest.php               | 4 ++--
  tests/Composer/Test/DependencyResolver/DefaultPolicyTest.php      | 2 +-
  tests/Composer/Test/DependencyResolver/RuleSetIteratorTest.php    | 2 +-
- tests/Composer/Test/DependencyResolver/RuleSetTest.php            | 2 +-
- tests/Composer/Test/DependencyResolver/RuleTest.php               | 2 +-
  tests/Composer/Test/DependencyResolver/SolverTest.php             | 2 +-
+ tests/Composer/Test/DependencyResolver/TransactionTest.php        | 2 +-
  tests/Composer/Test/Downloader/DownloadManagerTest.php            | 2 +-
  tests/Composer/Test/Downloader/FossilDownloaderTest.php           | 4 ++--
  tests/Composer/Test/Downloader/GitDownloaderTest.php              | 4 ++--
@@ -20,6 +19,7 @@ Subject: Compatibility with recent PHPUn
  tests/Composer/Test/Downloader/XzDownloaderTest.php               | 4 ++--
  tests/Composer/Test/Downloader/ZipDownloaderTest.php              | 4 ++--
  tests/Composer/Test/IO/ConsoleIOTest.php                          | 2 +-
+ tests/Composer/Test/InstalledVersionsTest.php                     | 2 +-
  tests/Composer/Test/Installer/InstallationManagerTest.php         | 2 +-
  tests/Composer/Test/Installer/LibraryInstallerTest.php            | 4 ++--
  tests/Composer/Test/Installer/MetapackageInstallerTest.php        | 2 +-
@@ -31,9 +31,10 @@ Subject: Compatibility with recent PHPUn
  tests/Composer/Test/Package/Dumper/ArrayDumperTest.php            | 2 +-
  tests/Composer/Test/Package/Loader/ArrayLoaderTest.php            | 2 +-
  tests/Composer/Test/Package/Version/VersionGuesserTest.php        | 2 +-
+ tests/Composer/Test/Platform/HhvmDetectorTest.php                 | 2 +-
  tests/Composer/Test/Plugin/PluginInstallerTest.php                | 4 ++--
  tests/Composer/Test/Repository/ArtifactRepositoryTest.php         | 2 +-
- tests/Composer/Test/Repository/PearRepositoryTest.php             | 2 +-
+ tests/Composer/Test/Repository/FilterRepositoryTest.php           | 2 +-
  tests/Composer/Test/Repository/RepositoryManagerTest.php          | 4 ++--
  tests/Composer/Test/Repository/Vcs/FossilDriverTest.php           | 4 ++--
  tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php     | 4 ++--
@@ -43,20 +44,23 @@ Subject: Compatibility with recent PHPUn
  tests/Composer/Test/Repository/Vcs/PerforceDriverTest.php         | 4 ++--
  tests/Composer/Test/Repository/Vcs/SvnDriverTest.php              | 4 ++--
  tests/Composer/Test/Repository/VcsRepositoryTest.php              | 4 ++--
+ tests/Composer/Test/Util/AuthHelperTest.php                       | 2 +-
  tests/Composer/Test/Util/BitbucketTest.php                        | 2 +-
  tests/Composer/Test/Util/ErrorHandlerTest.php                     | 4 ++--
  tests/Composer/Test/Util/FilesystemTest.php                       | 4 ++--
  tests/Composer/Test/Util/GitTest.php                              | 2 +-
+ tests/Composer/Test/Util/Http/ProxyHelperTest.php                 | 4 ++--
+ tests/Composer/Test/Util/Http/ProxyManagerTest.php                | 4 ++--
  tests/Composer/Test/Util/IniHelperTest.php                        | 4 ++--
  tests/Composer/Test/Util/PerforceTest.php                         | 4 ++--
  tests/Composer/Test/Util/StreamContextFactoryTest.php             | 4 ++--
- 47 files changed, 78 insertions(+), 78 deletions(-)
+ 51 files changed, 84 insertions(+), 84 deletions(-)
 
 diff --git a/tests/Composer/Test/AllFunctionalTest.php b/tests/Composer/Test/AllFunctionalTest.php
-index 59f1c33..b3dc069 100644
+index 1e8df2f..26a8c9a 100644
 --- a/tests/Composer/Test/AllFunctionalTest.php
 +++ b/tests/Composer/Test/AllFunctionalTest.php
-@@ -27,14 +27,14 @@ class AllFunctionalTest extends TestCase
+@@ -26,14 +26,14 @@ class AllFunctionalTest extends TestCase
      protected $testDir;
      private static $pharPath;
  
@@ -73,7 +77,7 @@ index 59f1c33..b3dc069 100644
      {
          chdir($this->oldcwd);
  
-@@ -53,12 +53,12 @@ class AllFunctionalTest extends TestCase
+@@ -52,12 +52,12 @@ class AllFunctionalTest extends TestCase
          }
      }
  
@@ -89,10 +93,10 @@ index 59f1c33..b3dc069 100644
          $fs = new Filesystem;
          $fs->removeDirectory(dirname(self::$pharPath));
 diff --git a/tests/Composer/Test/Autoload/AutoloadGeneratorTest.php b/tests/Composer/Test/Autoload/AutoloadGeneratorTest.php
-index 3cd8f7f..98bad24 100644
+index 134ebd6..e98ad6f 100644
 --- a/tests/Composer/Test/Autoload/AutoloadGeneratorTest.php
 +++ b/tests/Composer/Test/Autoload/AutoloadGeneratorTest.php
-@@ -85,7 +85,7 @@ class AutoloadGeneratorTest extends TestCase
+@@ -88,7 +88,7 @@ class AutoloadGeneratorTest extends TestCase
       */
      public $configValueMap;
  
@@ -101,7 +105,7 @@ index 3cd8f7f..98bad24 100644
      {
          $this->fs = new Filesystem;
          $that = $this;
-@@ -138,7 +138,7 @@ class AutoloadGeneratorTest extends TestCase
+@@ -147,7 +147,7 @@ class AutoloadGeneratorTest extends TestCase
          $this->generator = new AutoloadGenerator($this->eventDispatcher);
      }
  
@@ -111,11 +115,11 @@ index 3cd8f7f..98bad24 100644
          chdir($this->origDir);
  
 diff --git a/tests/Composer/Test/CacheTest.php b/tests/Composer/Test/CacheTest.php
-index 693753a..3050fd7 100644
+index fbf188d..288cae6 100644
 --- a/tests/Composer/Test/CacheTest.php
 +++ b/tests/Composer/Test/CacheTest.php
-@@ -22,7 +22,7 @@ class CacheTest extends TestCase
-     private $finder;
+@@ -23,7 +23,7 @@ class CacheTest extends TestCase
+     private $filesystem;
      private $cache;
  
 -    public function setUp()
@@ -123,7 +127,7 @@ index 693753a..3050fd7 100644
      {
          $this->root = $this->getUniqueTmpDirectory();
          $this->files = array();
-@@ -46,7 +46,7 @@ class CacheTest extends TestCase
+@@ -48,7 +48,7 @@ class CacheTest extends TestCase
              ->will($this->returnValue($this->finder));
      }
  
@@ -153,7 +157,7 @@ index 8c5d641..daa530c 100644
          if (is_dir($this->workingDir)) {
              $this->fs->removeDirectory($this->workingDir);
 diff --git a/tests/Composer/Test/DependencyResolver/DefaultPolicyTest.php b/tests/Composer/Test/DependencyResolver/DefaultPolicyTest.php
-index 2611d77..a882cb1 100644
+index 42a8f2d..335a211 100644
 --- a/tests/Composer/Test/DependencyResolver/DefaultPolicyTest.php
 +++ b/tests/Composer/Test/DependencyResolver/DefaultPolicyTest.php
 @@ -32,7 +32,7 @@ class DefaultPolicyTest extends TestCase
@@ -163,10 +167,10 @@ index 2611d77..a882cb1 100644
 -    public function setUp()
 +    public function setUp(): void
      {
-         $this->pool = new Pool('dev');
+         $this->repositorySet = new RepositorySet('dev');
          $this->repo = new ArrayRepository;
 diff --git a/tests/Composer/Test/DependencyResolver/RuleSetIteratorTest.php b/tests/Composer/Test/DependencyResolver/RuleSetIteratorTest.php
-index f38c48e..dda68f6 100644
+index 379fcf4..ef8a9ae 100644
 --- a/tests/Composer/Test/DependencyResolver/RuleSetIteratorTest.php
 +++ b/tests/Composer/Test/DependencyResolver/RuleSetIteratorTest.php
 @@ -24,7 +24,7 @@ class RuleSetIteratorTest extends TestCase
@@ -176,49 +180,36 @@ index f38c48e..dda68f6 100644
 -    protected function setUp()
 +    protected function setUp(): void
      {
-         $this->pool = new Pool;
+         $this->pool = new Pool();
  
-diff --git a/tests/Composer/Test/DependencyResolver/RuleSetTest.php b/tests/Composer/Test/DependencyResolver/RuleSetTest.php
-index 22c1c15..bb5f84c 100644
---- a/tests/Composer/Test/DependencyResolver/RuleSetTest.php
-+++ b/tests/Composer/Test/DependencyResolver/RuleSetTest.php
-@@ -23,7 +23,7 @@ class RuleSetTest extends TestCase
- {
+diff --git a/tests/Composer/Test/DependencyResolver/SolverTest.php b/tests/Composer/Test/DependencyResolver/SolverTest.php
+index 24cde47..7e173c9 100644
+--- a/tests/Composer/Test/DependencyResolver/SolverTest.php
++++ b/tests/Composer/Test/DependencyResolver/SolverTest.php
+@@ -35,7 +35,7 @@ class SolverTest extends TestCase
+     protected $solver;
      protected $pool;
  
 -    public function setUp()
 +    public function setUp(): void
      {
-         $this->pool = new Pool;
-     }
-diff --git a/tests/Composer/Test/DependencyResolver/RuleTest.php b/tests/Composer/Test/DependencyResolver/RuleTest.php
-index 19f5fdd..d7b11c8 100644
---- a/tests/Composer/Test/DependencyResolver/RuleTest.php
-+++ b/tests/Composer/Test/DependencyResolver/RuleTest.php
-@@ -23,7 +23,7 @@ class RuleTest extends TestCase
- {
-     protected $pool;
+         $this->repoSet = new RepositorySet();
+         $this->repo = new ArrayRepository;
+diff --git a/tests/Composer/Test/DependencyResolver/TransactionTest.php b/tests/Composer/Test/DependencyResolver/TransactionTest.php
+index 39354c0..3c3c087 100644
+--- a/tests/Composer/Test/DependencyResolver/TransactionTest.php
++++ b/tests/Composer/Test/DependencyResolver/TransactionTest.php
+@@ -18,7 +18,7 @@ use Composer\Test\TestCase;
  
+ class TransactionTest extends TestCase
+ {
 -    public function setUp()
 +    public function setUp(): void
      {
-         $this->pool = new Pool;
      }
-diff --git a/tests/Composer/Test/DependencyResolver/SolverTest.php b/tests/Composer/Test/DependencyResolver/SolverTest.php
-index 19f4d01..754b5dc 100644
---- a/tests/Composer/Test/DependencyResolver/SolverTest.php
-+++ b/tests/Composer/Test/DependencyResolver/SolverTest.php
-@@ -32,7 +32,7 @@ class SolverTest extends TestCase
-     protected $policy;
-     protected $solver;
  
--    public function setUp()
-+    public function setUp(): void
-     {
-         $this->pool = new Pool;
-         $this->repo = new ArrayRepository;
 diff --git a/tests/Composer/Test/Downloader/DownloadManagerTest.php b/tests/Composer/Test/Downloader/DownloadManagerTest.php
-index 90a98f9..5bd056d 100644
+index b755e33..e61a365 100644
 --- a/tests/Composer/Test/Downloader/DownloadManagerTest.php
 +++ b/tests/Composer/Test/Downloader/DownloadManagerTest.php
 @@ -20,7 +20,7 @@ class DownloadManagerTest extends TestCase
@@ -231,7 +222,7 @@ index 90a98f9..5bd056d 100644
          $this->filesystem = $this->getMockBuilder('Composer\Util\Filesystem')->getMock();
          $this->io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
 diff --git a/tests/Composer/Test/Downloader/FossilDownloaderTest.php b/tests/Composer/Test/Downloader/FossilDownloaderTest.php
-index 9770643..8109d8d 100644
+index 5121d85..dbd07cd 100644
 --- a/tests/Composer/Test/Downloader/FossilDownloaderTest.php
 +++ b/tests/Composer/Test/Downloader/FossilDownloaderTest.php
 @@ -22,12 +22,12 @@ class FossilDownloaderTest extends TestCase
@@ -250,10 +241,10 @@ index 9770643..8109d8d 100644
          if (is_dir($this->workingDir)) {
              $fs = new Filesystem;
 diff --git a/tests/Composer/Test/Downloader/GitDownloaderTest.php b/tests/Composer/Test/Downloader/GitDownloaderTest.php
-index 5bf75d4..776dca7 100644
+index c16c925..e09b6d4 100644
 --- a/tests/Composer/Test/Downloader/GitDownloaderTest.php
 +++ b/tests/Composer/Test/Downloader/GitDownloaderTest.php
-@@ -27,7 +27,7 @@ class GitDownloaderTest extends TestCase
+@@ -26,7 +26,7 @@ class GitDownloaderTest extends TestCase
      /** @var string */
      private $workingDir;
  
@@ -262,7 +253,7 @@ index 5bf75d4..776dca7 100644
      {
          $this->skipIfNotExecutable('git');
  
-@@ -37,7 +37,7 @@ class GitDownloaderTest extends TestCase
+@@ -36,7 +36,7 @@ class GitDownloaderTest extends TestCase
          $this->workingDir = $this->getUniqueTmpDirectory();
      }
  
@@ -272,7 +263,7 @@ index 5bf75d4..776dca7 100644
          if (is_dir($this->workingDir)) {
              $this->fs->removeDirectory($this->workingDir);
 diff --git a/tests/Composer/Test/Downloader/HgDownloaderTest.php b/tests/Composer/Test/Downloader/HgDownloaderTest.php
-index c074e18..61966f5 100644
+index cecf78b..64f72d1 100644
 --- a/tests/Composer/Test/Downloader/HgDownloaderTest.php
 +++ b/tests/Composer/Test/Downloader/HgDownloaderTest.php
 @@ -22,12 +22,12 @@ class HgDownloaderTest extends TestCase
@@ -291,10 +282,10 @@ index c074e18..61966f5 100644
          if (is_dir($this->workingDir)) {
              $fs = new Filesystem;
 diff --git a/tests/Composer/Test/Downloader/PerforceDownloaderTest.php b/tests/Composer/Test/Downloader/PerforceDownloaderTest.php
-index 3b5f416..ab2bac4 100644
+index ca93863..407e09c 100644
 --- a/tests/Composer/Test/Downloader/PerforceDownloaderTest.php
 +++ b/tests/Composer/Test/Downloader/PerforceDownloaderTest.php
-@@ -34,7 +34,7 @@ class PerforceDownloaderTest extends TestCase
+@@ -35,7 +35,7 @@ class PerforceDownloaderTest extends TestCase
      protected $repository;
      protected $testPath;
  
@@ -303,7 +294,7 @@ index 3b5f416..ab2bac4 100644
      {
          $this->testPath = $this->getUniqueTmpDirectory();
          $this->repoConfig = $this->getRepoConfig();
-@@ -46,7 +46,7 @@ class PerforceDownloaderTest extends TestCase
+@@ -47,7 +47,7 @@ class PerforceDownloaderTest extends TestCase
          $this->downloader = new PerforceDownloader($this->io, $this->config, $this->processExecutor);
      }
  
@@ -313,10 +304,10 @@ index 3b5f416..ab2bac4 100644
          $this->downloader = null;
          $this->package = null;
 diff --git a/tests/Composer/Test/Downloader/XzDownloaderTest.php b/tests/Composer/Test/Downloader/XzDownloaderTest.php
-index 6df782d..b26d72a 100644
+index 1b28e70..7032004 100644
 --- a/tests/Composer/Test/Downloader/XzDownloaderTest.php
 +++ b/tests/Composer/Test/Downloader/XzDownloaderTest.php
-@@ -30,7 +30,7 @@ class XzDownloaderTest extends TestCase
+@@ -31,7 +31,7 @@ class XzDownloaderTest extends TestCase
       */
      private $testDir;
  
@@ -325,7 +316,7 @@ index 6df782d..b26d72a 100644
      {
          if (Platform::isWindows()) {
              $this->markTestSkipped('Skip test on Windows');
-@@ -38,7 +38,7 @@ class XzDownloaderTest extends TestCase
+@@ -39,7 +39,7 @@ class XzDownloaderTest extends TestCase
          $this->testDir = $this->getUniqueTmpDirectory();
      }
  
@@ -335,19 +326,20 @@ index 6df782d..b26d72a 100644
          $this->fs = new Filesystem;
          $this->fs->removeDirectory($this->testDir);
 diff --git a/tests/Composer/Test/Downloader/ZipDownloaderTest.php b/tests/Composer/Test/Downloader/ZipDownloaderTest.php
-index 4ff3f05..b343ed9 100644
+index e210784..db43598 100644
 --- a/tests/Composer/Test/Downloader/ZipDownloaderTest.php
 +++ b/tests/Composer/Test/Downloader/ZipDownloaderTest.php
-@@ -26,14 +26,14 @@ class ZipDownloaderTest extends TestCase
-     private $io;
+@@ -30,7 +30,7 @@ class ZipDownloaderTest extends TestCase
      private $config;
+     private $package;
  
 -    public function setUp()
 +    public function setUp(): void
      {
          $this->testDir = $this->getUniqueTmpDirectory();
          $this->io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
-         $this->config = $this->getMockBuilder('Composer\Config')->getMock();
+@@ -40,7 +40,7 @@ class ZipDownloaderTest extends TestCase
+         $this->package = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
      }
  
 -    public function tearDown()
@@ -356,33 +348,46 @@ index 4ff3f05..b343ed9 100644
          $fs = new Filesystem;
          $fs->removeDirectory($this->testDir);
 diff --git a/tests/Composer/Test/IO/ConsoleIOTest.php b/tests/Composer/Test/IO/ConsoleIOTest.php
-index ef50963..7d9efa4 100644
+index 1ff8617..16dc26f 100644
 --- a/tests/Composer/Test/IO/ConsoleIOTest.php
 +++ b/tests/Composer/Test/IO/ConsoleIOTest.php
 @@ -86,7 +86,7 @@ class ConsoleIOTest extends TestCase
                      $result = preg_match("[(.*)/(.*) First line]", $messages[0]) > 0;
-                     $result &= preg_match("[(.*)/(.*) Second line]", $messages[1]) > 0;
+                     $result = $result && preg_match("[(.*)/(.*) Second line]", $messages[1]) > 0;
  
 -                    return $result;
 +                    return (bool) $result;
                  }),
                  $this->equalTo(false)
              );
+diff --git a/tests/Composer/Test/InstalledVersionsTest.php b/tests/Composer/Test/InstalledVersionsTest.php
+index c1f4bb1..58cf1d3 100644
+--- a/tests/Composer/Test/InstalledVersionsTest.php
++++ b/tests/Composer/Test/InstalledVersionsTest.php
+@@ -17,7 +17,7 @@ use Composer\Semver\VersionParser;
+ 
+ class InstalledVersionsTest extends TestCase
+ {
+-    public function setUp()
++    public function setUp(): void
+     {
+         InstalledVersions::reload(require __DIR__.'/Repository/Fixtures/installed.php');
+     }
 diff --git a/tests/Composer/Test/Installer/InstallationManagerTest.php b/tests/Composer/Test/Installer/InstallationManagerTest.php
-index 62f457e..54ebf6a 100644
+index 692aa1d..434b2e2 100644
 --- a/tests/Composer/Test/Installer/InstallationManagerTest.php
 +++ b/tests/Composer/Test/Installer/InstallationManagerTest.php
-@@ -22,7 +22,7 @@ class InstallationManagerTest extends TestCase
- {
-     protected $repository;
+@@ -25,7 +25,7 @@ class InstallationManagerTest extends TestCase
+     protected $loop;
+     protected $io;
  
 -    public function setUp()
 +    public function setUp(): void
      {
+         $this->loop = $this->getMockBuilder('Composer\Util\Loop')->disableOriginalConstructor()->getMock();
          $this->repository = $this->getMockBuilder('Composer\Repository\InstalledRepositoryInterface')->getMock();
-     }
 diff --git a/tests/Composer/Test/Installer/LibraryInstallerTest.php b/tests/Composer/Test/Installer/LibraryInstallerTest.php
-index efccfeb..e87998f 100644
+index f0f509d..b182fb8 100644
 --- a/tests/Composer/Test/Installer/LibraryInstallerTest.php
 +++ b/tests/Composer/Test/Installer/LibraryInstallerTest.php
 @@ -30,7 +30,7 @@ class LibraryInstallerTest extends TestCase
@@ -417,7 +422,7 @@ index f26ba0b..4edbb7c 100644
          $this->repository = $this->getMockBuilder('Composer\Repository\InstalledRepositoryInterface')->getMock();
  
 diff --git a/tests/Composer/Test/Installer/SuggestedPackagesReporterTest.php b/tests/Composer/Test/Installer/SuggestedPackagesReporterTest.php
-index 03bb0b5..42a8a9e 100644
+index fb80033..daae95d 100644
 --- a/tests/Composer/Test/Installer/SuggestedPackagesReporterTest.php
 +++ b/tests/Composer/Test/Installer/SuggestedPackagesReporterTest.php
 @@ -23,7 +23,7 @@ class SuggestedPackagesReporterTest extends TestCase
@@ -430,10 +435,10 @@ index 03bb0b5..42a8a9e 100644
          $this->io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
  
 diff --git a/tests/Composer/Test/InstallerTest.php b/tests/Composer/Test/InstallerTest.php
-index 42d8c18..ebb99ee 100644
+index 4ac3e5c..8bd541d 100644
 --- a/tests/Composer/Test/InstallerTest.php
 +++ b/tests/Composer/Test/InstallerTest.php
-@@ -37,13 +37,13 @@ class InstallerTest extends TestCase
+@@ -41,13 +41,13 @@ class InstallerTest extends TestCase
      protected $prevCwd;
      protected $tempComposerHome;
  
@@ -450,7 +455,7 @@ index 42d8c18..ebb99ee 100644
          chdir($this->prevCwd);
          if (is_dir($this->tempComposerHome)) {
 diff --git a/tests/Composer/Test/Package/Archiver/ArchivableFilesFinderTest.php b/tests/Composer/Test/Package/Archiver/ArchivableFilesFinderTest.php
-index f6afe10..02cb92d 100644
+index b8f1109..969469b 100644
 --- a/tests/Composer/Test/Package/Archiver/ArchivableFilesFinderTest.php
 +++ b/tests/Composer/Test/Package/Archiver/ArchivableFilesFinderTest.php
 @@ -23,7 +23,7 @@ class ArchivableFilesFinderTest extends TestCase
@@ -472,10 +477,10 @@ index f6afe10..02cb92d 100644
          $fs = new Filesystem;
          $fs->removeDirectory($this->sources);
 diff --git a/tests/Composer/Test/Package/Archiver/ArchiveManagerTest.php b/tests/Composer/Test/Package/Archiver/ArchiveManagerTest.php
-index 63150eb..2657454 100644
+index 4bdac61..008f0bb 100644
 --- a/tests/Composer/Test/Package/Archiver/ArchiveManagerTest.php
 +++ b/tests/Composer/Test/Package/Archiver/ArchiveManagerTest.php
-@@ -25,7 +25,7 @@ class ArchiveManagerTest extends ArchiverTest
+@@ -29,7 +29,7 @@ class ArchiveManagerTest extends ArchiverTest
  
      protected $targetDir;
  
@@ -506,7 +511,7 @@ index 8926d76..72f80b2 100644
          $this->filesystem->removeDirectory($this->testDir);
      }
 diff --git a/tests/Composer/Test/Package/Dumper/ArrayDumperTest.php b/tests/Composer/Test/Package/Dumper/ArrayDumperTest.php
-index ca7d609..61d2968 100644
+index dbcdf84..947da11 100644
 --- a/tests/Composer/Test/Package/Dumper/ArrayDumperTest.php
 +++ b/tests/Composer/Test/Package/Dumper/ArrayDumperTest.php
 @@ -28,7 +28,7 @@ class ArrayDumperTest extends TestCase
@@ -532,7 +537,7 @@ index 1d4f866..f6bc66b 100644
          $this->loader = new ArrayLoader(null);
      }
 diff --git a/tests/Composer/Test/Package/Version/VersionGuesserTest.php b/tests/Composer/Test/Package/Version/VersionGuesserTest.php
-index 337438f..3e76aae 100644
+index 8df182d..2a829c8 100644
 --- a/tests/Composer/Test/Package/Version/VersionGuesserTest.php
 +++ b/tests/Composer/Test/Package/Version/VersionGuesserTest.php
 @@ -21,7 +21,7 @@ use Composer\Util\ProcessExecutor;
@@ -544,11 +549,24 @@ index 337438f..3e76aae 100644
      {
          if (!function_exists('proc_open')) {
              $this->markTestSkipped('proc_open() is not available');
+diff --git a/tests/Composer/Test/Platform/HhvmDetectorTest.php b/tests/Composer/Test/Platform/HhvmDetectorTest.php
+index 68dc4a8..7a371dc 100644
+--- a/tests/Composer/Test/Platform/HhvmDetectorTest.php
++++ b/tests/Composer/Test/Platform/HhvmDetectorTest.php
+@@ -22,7 +22,7 @@ class HhvmDetectorTest extends TestCase
+ {
+     private $hhvmDetector;
+ 
+-    protected function setUp()
++    protected function setUp(): void
+     {
+         $this->hhvmDetector = new HhvmDetector();
+         $this->hhvmDetector->reset();
 diff --git a/tests/Composer/Test/Plugin/PluginInstallerTest.php b/tests/Composer/Test/Plugin/PluginInstallerTest.php
-index d56e054..15a72e4 100644
+index c5c587b..d212798 100644
 --- a/tests/Composer/Test/Plugin/PluginInstallerTest.php
 +++ b/tests/Composer/Test/Plugin/PluginInstallerTest.php
-@@ -65,7 +65,7 @@ class PluginInstallerTest extends TestCase
+@@ -68,7 +68,7 @@ class PluginInstallerTest extends TestCase
       */
      protected $io;
  
@@ -557,7 +575,7 @@ index d56e054..15a72e4 100644
      {
          $loader = new JsonLoader(new ArrayLoader());
          $this->packages = array();
-@@ -121,7 +121,7 @@ class PluginInstallerTest extends TestCase
+@@ -126,7 +126,7 @@ class PluginInstallerTest extends TestCase
          ));
      }
  
@@ -567,10 +585,10 @@ index d56e054..15a72e4 100644
          $filesystem = new Filesystem();
          $filesystem->removeDirectory($this->directory);
 diff --git a/tests/Composer/Test/Repository/ArtifactRepositoryTest.php b/tests/Composer/Test/Repository/ArtifactRepositoryTest.php
-index 506a033..83252e8 100644
+index b164a43..49c37a6 100644
 --- a/tests/Composer/Test/Repository/ArtifactRepositoryTest.php
 +++ b/tests/Composer/Test/Repository/ArtifactRepositoryTest.php
-@@ -20,7 +20,7 @@ use Composer\Package\BasePackage;
+@@ -19,7 +19,7 @@ use Composer\Package\BasePackage;
  
  class ArtifactRepositoryTest extends TestCase
  {
@@ -579,21 +597,21 @@ index 506a033..83252e8 100644
      {
          parent::setUp();
          if (!extension_loaded('zip')) {
-diff --git a/tests/Composer/Test/Repository/PearRepositoryTest.php b/tests/Composer/Test/Repository/PearRepositoryTest.php
-index fea9bbf..9a807be 100644
---- a/tests/Composer/Test/Repository/PearRepositoryTest.php
-+++ b/tests/Composer/Test/Repository/PearRepositoryTest.php
-@@ -144,7 +144,7 @@ class PearRepositoryTest extends TestCase
-         $this->repository = new PearRepository($repoConfig, $ioInterface, $config, null);
-     }
+diff --git a/tests/Composer/Test/Repository/FilterRepositoryTest.php b/tests/Composer/Test/Repository/FilterRepositoryTest.php
+index 645d5cb..c1f974e 100644
+--- a/tests/Composer/Test/Repository/FilterRepositoryTest.php
++++ b/tests/Composer/Test/Repository/FilterRepositoryTest.php
+@@ -22,7 +22,7 @@ class FilterRepositoryTest extends TestCase
+ {
+     private $arrayRepo;
  
--    protected function tearDown()
-+    protected function tearDown(): void
+-    public function setUp()
++    public function setUp(): void
      {
-         $this->repository = null;
-         $this->remoteFilesystem = null;
+         $this->arrayRepo = new ArrayRepository();
+         $this->arrayRepo->addPackage($this->getPackage('foo/aaa', '1.0.0'));
 diff --git a/tests/Composer/Test/Repository/RepositoryManagerTest.php b/tests/Composer/Test/Repository/RepositoryManagerTest.php
-index ae3f133..f3d189f 100644
+index 7d545df..50bf1c7 100644
 --- a/tests/Composer/Test/Repository/RepositoryManagerTest.php
 +++ b/tests/Composer/Test/Repository/RepositoryManagerTest.php
 @@ -20,12 +20,12 @@ class RepositoryManagerTest extends TestCase
@@ -612,10 +630,10 @@ index ae3f133..f3d189f 100644
          if (is_dir($this->tmpdir)) {
              $fs = new Filesystem();
 diff --git a/tests/Composer/Test/Repository/Vcs/FossilDriverTest.php b/tests/Composer/Test/Repository/Vcs/FossilDriverTest.php
-index f39a3b8..3248b86 100644
+index a6953f8..4b2266e 100644
 --- a/tests/Composer/Test/Repository/Vcs/FossilDriverTest.php
 +++ b/tests/Composer/Test/Repository/Vcs/FossilDriverTest.php
-@@ -23,7 +23,7 @@ class FossilDriverTest extends TestCase
+@@ -22,7 +22,7 @@ class FossilDriverTest extends TestCase
      protected $home;
      protected $config;
  
@@ -624,7 +642,7 @@ index f39a3b8..3248b86 100644
      {
          $this->home = $this->getUniqueTmpDirectory();
          $this->config = new Config();
-@@ -34,7 +34,7 @@ class FossilDriverTest extends TestCase
+@@ -33,7 +33,7 @@ class FossilDriverTest extends TestCase
          ));
      }
  
@@ -634,10 +652,10 @@ index f39a3b8..3248b86 100644
          $fs = new Filesystem();
          $fs->removeDirectory($this->home);
 diff --git a/tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php b/tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php
-index 15cdf39..6cf3703 100644
+index 0bad336..970e053 100644
 --- a/tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php
 +++ b/tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php
-@@ -33,7 +33,7 @@ class GitBitbucketDriverTest extends TestCase
+@@ -35,7 +35,7 @@ class GitBitbucketDriverTest extends TestCase
      /** @type string */
      private $originUrl = 'bitbucket.org';
  
@@ -646,7 +664,7 @@ index 15cdf39..6cf3703 100644
      {
          $this->io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
  
-@@ -51,7 +51,7 @@ class GitBitbucketDriverTest extends TestCase
+@@ -53,7 +53,7 @@ class GitBitbucketDriverTest extends TestCase
              ->getMock();
      }
  
@@ -656,10 +674,10 @@ index 15cdf39..6cf3703 100644
          $fs = new Filesystem;
          $fs->removeDirectory($this->home);
 diff --git a/tests/Composer/Test/Repository/Vcs/GitHubDriverTest.php b/tests/Composer/Test/Repository/Vcs/GitHubDriverTest.php
-index 45df0ce..4001b46 100644
+index 7c2727c..1bc7809 100644
 --- a/tests/Composer/Test/Repository/Vcs/GitHubDriverTest.php
 +++ b/tests/Composer/Test/Repository/Vcs/GitHubDriverTest.php
-@@ -23,7 +23,7 @@ class GitHubDriverTest extends TestCase
+@@ -24,7 +24,7 @@ class GitHubDriverTest extends TestCase
      private $home;
      private $config;
  
@@ -668,7 +686,7 @@ index 45df0ce..4001b46 100644
      {
          $this->home = $this->getUniqueTmpDirectory();
          $this->config = new Config();
-@@ -34,7 +34,7 @@ class GitHubDriverTest extends TestCase
+@@ -35,7 +35,7 @@ class GitHubDriverTest extends TestCase
          ));
      }
  
@@ -678,20 +696,20 @@ index 45df0ce..4001b46 100644
          $fs = new Filesystem;
          $fs->removeDirectory($this->home);
 diff --git a/tests/Composer/Test/Repository/Vcs/GitLabDriverTest.php b/tests/Composer/Test/Repository/Vcs/GitLabDriverTest.php
-index 81e6231..3f42595 100644
+index 0fd2fa9..6680ae1 100644
 --- a/tests/Composer/Test/Repository/Vcs/GitLabDriverTest.php
 +++ b/tests/Composer/Test/Repository/Vcs/GitLabDriverTest.php
-@@ -29,7 +29,7 @@ class GitLabDriverTest extends TestCase
+@@ -30,7 +30,7 @@ class GitLabDriverTest extends TestCase
      private $process;
-     private $remoteFilesystem;
+     private $httpDownloader;
  
 -    public function setUp()
 +    public function setUp(): void
      {
          $this->home = $this->getUniqueTmpDirectory();
          $this->config = new Config();
-@@ -50,7 +50,7 @@ class GitLabDriverTest extends TestCase
-         $this->remoteFilesystem = $this->prophesize('Composer\Util\RemoteFilesystem');
+@@ -51,7 +51,7 @@ class GitLabDriverTest extends TestCase
+         $this->httpDownloader = $this->prophesize('Composer\Util\HttpDownloader');
      }
  
 -    public function tearDown()
@@ -722,7 +740,7 @@ index 11143b4..c22439b 100644
          $fs = new Filesystem;
          $fs->removeDirectory($this->home);
 diff --git a/tests/Composer/Test/Repository/Vcs/PerforceDriverTest.php b/tests/Composer/Test/Repository/Vcs/PerforceDriverTest.php
-index a5e5d4b..fc296b8 100644
+index 1c44e82..2ad7efc 100644
 --- a/tests/Composer/Test/Repository/Vcs/PerforceDriverTest.php
 +++ b/tests/Composer/Test/Repository/Vcs/PerforceDriverTest.php
 @@ -36,7 +36,7 @@ class PerforceDriverTest extends TestCase
@@ -744,10 +762,10 @@ index a5e5d4b..fc296b8 100644
          //cleanup directory under test path
          $fs = new Filesystem;
 diff --git a/tests/Composer/Test/Repository/Vcs/SvnDriverTest.php b/tests/Composer/Test/Repository/Vcs/SvnDriverTest.php
-index 4ef0d9b..1a379fe 100644
+index 9c61c31..edb6be8 100644
 --- a/tests/Composer/Test/Repository/Vcs/SvnDriverTest.php
 +++ b/tests/Composer/Test/Repository/Vcs/SvnDriverTest.php
-@@ -23,7 +23,7 @@ class SvnDriverTest extends TestCase
+@@ -22,7 +22,7 @@ class SvnDriverTest extends TestCase
      protected $home;
      protected $config;
  
@@ -756,7 +774,7 @@ index 4ef0d9b..1a379fe 100644
      {
          $this->home = $this->getUniqueTmpDirectory();
          $this->config = new Config();
-@@ -34,7 +34,7 @@ class SvnDriverTest extends TestCase
+@@ -33,7 +33,7 @@ class SvnDriverTest extends TestCase
          ));
      }
  
@@ -766,10 +784,10 @@ index 4ef0d9b..1a379fe 100644
          $fs = new Filesystem();
          $fs->removeDirectory($this->home);
 diff --git a/tests/Composer/Test/Repository/VcsRepositoryTest.php b/tests/Composer/Test/Repository/VcsRepositoryTest.php
-index 72fd36a..2065938 100644
+index b1d0e5a..223ba99 100644
 --- a/tests/Composer/Test/Repository/VcsRepositoryTest.php
 +++ b/tests/Composer/Test/Repository/VcsRepositoryTest.php
-@@ -115,7 +115,7 @@ class VcsRepositoryTest extends TestCase
+@@ -118,7 +118,7 @@ class VcsRepositoryTest extends TestCase
          chdir($oldCwd);
      }
  
@@ -778,7 +796,7 @@ index 72fd36a..2065938 100644
      {
          if (!self::$gitRepo) {
              $this->initialize();
-@@ -125,7 +125,7 @@ class VcsRepositoryTest extends TestCase
+@@ -128,7 +128,7 @@ class VcsRepositoryTest extends TestCase
          }
      }
  
@@ -787,11 +805,24 @@ index 72fd36a..2065938 100644
      {
          $fs = new Filesystem;
          $fs->removeDirectory(self::$composerHome);
+diff --git a/tests/Composer/Test/Util/AuthHelperTest.php b/tests/Composer/Test/Util/AuthHelperTest.php
+index 33f6438..c4e0e21 100644
+--- a/tests/Composer/Test/Util/AuthHelperTest.php
++++ b/tests/Composer/Test/Util/AuthHelperTest.php
+@@ -31,7 +31,7 @@ class AuthHelperTest extends TestCase
+     /** @type AuthHelper */
+     private $authHelper;
+ 
+-    protected function setUp()
++    protected function setUp(): void
+     {
+         $this->io = $this
+             ->getMockBuilder('Composer\IO\IOInterface')
 diff --git a/tests/Composer/Test/Util/BitbucketTest.php b/tests/Composer/Test/Util/BitbucketTest.php
-index c89b393..c17ff48 100644
+index 3262c2f..4ddfd48 100644
 --- a/tests/Composer/Test/Util/BitbucketTest.php
 +++ b/tests/Composer/Test/Util/BitbucketTest.php
-@@ -39,7 +39,7 @@ class BitbucketTest extends TestCase
+@@ -40,7 +40,7 @@ class BitbucketTest extends TestCase
      /** @var int */
      private $time;
  
@@ -801,7 +832,7 @@ index c89b393..c17ff48 100644
          $this->io = $this
              ->getMockBuilder('Composer\IO\ConsoleIO')
 diff --git a/tests/Composer/Test/Util/ErrorHandlerTest.php b/tests/Composer/Test/Util/ErrorHandlerTest.php
-index 05909c2..0c5123b 100644
+index 486aa1c..66bf41f 100644
 --- a/tests/Composer/Test/Util/ErrorHandlerTest.php
 +++ b/tests/Composer/Test/Util/ErrorHandlerTest.php
 @@ -20,12 +20,12 @@ use Composer\Test\TestCase;
@@ -820,7 +851,7 @@ index 05909c2..0c5123b 100644
          restore_error_handler();
      }
 diff --git a/tests/Composer/Test/Util/FilesystemTest.php b/tests/Composer/Test/Util/FilesystemTest.php
-index 806a2a2..5932079 100644
+index d821c05..deb3c98 100644
 --- a/tests/Composer/Test/Util/FilesystemTest.php
 +++ b/tests/Composer/Test/Util/FilesystemTest.php
 @@ -32,14 +32,14 @@ class FilesystemTest extends TestCase
@@ -841,10 +872,10 @@ index 806a2a2..5932079 100644
          if (is_dir($this->workingDir)) {
              $this->fs->removeDirectory($this->workingDir);
 diff --git a/tests/Composer/Test/Util/GitTest.php b/tests/Composer/Test/Util/GitTest.php
-index d534573..0475c86 100644
+index 66ad8ff..349b586 100644
 --- a/tests/Composer/Test/Util/GitTest.php
 +++ b/tests/Composer/Test/Util/GitTest.php
-@@ -22,7 +22,7 @@ class GitTest extends TestCase
+@@ -32,7 +32,7 @@ class GitTest extends TestCase
      /** @var Filesystem&\PHPUnit_Framework_MockObject_MockObject */
      private $fs;
  
@@ -853,8 +884,52 @@ index d534573..0475c86 100644
      {
          $this->io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
          $this->config = $this->getMockBuilder('Composer\Config')->disableOriginalConstructor()->getMock();
+diff --git a/tests/Composer/Test/Util/Http/ProxyHelperTest.php b/tests/Composer/Test/Util/Http/ProxyHelperTest.php
+index c79ad25..3436b2e 100644
+--- a/tests/Composer/Test/Util/Http/ProxyHelperTest.php
++++ b/tests/Composer/Test/Util/Http/ProxyHelperTest.php
+@@ -17,7 +17,7 @@ use Composer\Test\TestCase;
+ 
+ class ProxyHelperTest extends TestCase
+ {
+-    protected function setUp()
++    protected function setUp(): void
+     {
+         unset(
+             $_SERVER['HTTP_PROXY'],
+@@ -30,7 +30,7 @@ class ProxyHelperTest extends TestCase
+         );
+     }
+ 
+-    protected function tearDown()
++    protected function tearDown(): void
+     {
+         unset(
+             $_SERVER['HTTP_PROXY'],
+diff --git a/tests/Composer/Test/Util/Http/ProxyManagerTest.php b/tests/Composer/Test/Util/Http/ProxyManagerTest.php
+index 1a2cc4e..4c487fa 100644
+--- a/tests/Composer/Test/Util/Http/ProxyManagerTest.php
++++ b/tests/Composer/Test/Util/Http/ProxyManagerTest.php
+@@ -17,7 +17,7 @@ use Composer\Test\TestCase;
+ 
+ class ProxyManagerTest extends TestCase
+ {
+-    protected function setUp()
++    protected function setUp(): void
+     {
+         unset(
+             $_SERVER['HTTP_PROXY'],
+@@ -31,7 +31,7 @@ class ProxyManagerTest extends TestCase
+         ProxyManager::reset();
+     }
+ 
+-    protected function tearDown()
++    protected function tearDown(): void
+     {
+         unset(
+             $_SERVER['HTTP_PROXY'],
 diff --git a/tests/Composer/Test/Util/IniHelperTest.php b/tests/Composer/Test/Util/IniHelperTest.php
-index a77c117..30fd915 100644
+index 4304898..64dcd35 100644
 --- a/tests/Composer/Test/Util/IniHelperTest.php
 +++ b/tests/Composer/Test/Util/IniHelperTest.php
 @@ -70,7 +70,7 @@ class IniHelperTest extends TestCase
@@ -898,24 +973,22 @@ index 2c86227..6483df7 100644
          $this->perforce = null;
          $this->io = null;
 diff --git a/tests/Composer/Test/Util/StreamContextFactoryTest.php b/tests/Composer/Test/Util/StreamContextFactoryTest.php
-index 34de2fa..6375409 100644
+index c28b95b..0f6d741 100644
 --- a/tests/Composer/Test/Util/StreamContextFactoryTest.php
 +++ b/tests/Composer/Test/Util/StreamContextFactoryTest.php
-@@ -17,7 +17,7 @@ use Composer\Test\TestCase;
+@@ -18,13 +18,13 @@ use Composer\Test\TestCase;
  
  class StreamContextFactoryTest extends TestCase
  {
 -    protected function setUp()
 +    protected function setUp(): void
      {
-         unset($_SERVER['HTTP_PROXY']);
-         unset($_SERVER['http_proxy']);
-@@ -27,7 +27,7 @@ class StreamContextFactoryTest extends TestCase
-         unset($_SERVER['no_proxy']);
+         unset($_SERVER['HTTP_PROXY'], $_SERVER['http_proxy'], $_SERVER['HTTPS_PROXY'], $_SERVER['https_proxy'], $_SERVER['NO_PROXY'], $_SERVER['no_proxy']);
+         ProxyManager::reset();
      }
  
 -    protected function tearDown()
 +    protected function tearDown(): void
      {
-         unset($_SERVER['HTTP_PROXY']);
-         unset($_SERVER['http_proxy']);
+         unset($_SERVER['HTTP_PROXY'], $_SERVER['http_proxy'], $_SERVER['HTTPS_PROXY'], $_SERVER['https_proxy'], $_SERVER['NO_PROXY'], $_SERVER['no_proxy']);
+         ProxyManager::reset();
diff -pruN 1.10.19-1/debian/README.source 2.0.9-1/debian/README.source
--- 1.10.19-1/debian/README.source	2020-12-11 15:22:03.000000000 +0000
+++ 2.0.9-1/debian/README.source	2021-01-28 22:53:16.000000000 +0000
@@ -1,8 +1,4 @@
 Starting with 1.8.5, we are merging the signed upstream tags as
 upstream, instead of using the tarball that doesn’t ship tests.
 
-# Example to import upstream 1.8.7 version
-version=1.8.7
-# We still use the upstream branch to drop the .gitattributes file from upstream
-gbp import-ref --upstream-tag=%\(version%~%-\)s -u$version --debian-branch=upstream
-gbp import-ref --upstream-tree=BRANCH -u$version
+gbp import-orig --uscan
diff -pruN 1.10.19-1/debian/rules 2.0.9-1/debian/rules
--- 1.10.19-1/debian/rules	2020-12-11 15:22:03.000000000 +0000
+++ 2.0.9-1/debian/rules	2021-01-28 22:53:16.000000000 +0000
@@ -14,6 +14,7 @@ override_dh_auto_build:
 		src/Composer
 	mkdir --parents vendor
 	phpab \
+		--tolerant \
 		--output vendor/autoload.php \
 		--template debian/autoload.tests.php.tpl \
 		--exclude tests/Composer/Test/Plugin/Fixtures/plugin-v9/Installer/Plugin.php \
diff -pruN 1.10.19-1/debian/tests/control 2.0.9-1/debian/tests/control
--- 1.10.19-1/debian/tests/control	2020-12-11 15:22:03.000000000 +0000
+++ 2.0.9-1/debian/tests/control	2021-01-28 22:53:16.000000000 +0000
@@ -1,2 +1,10 @@
-Test-Command: mkdir -p vendor && phpab -o vendor/autoload.php -t debian/autoload.tests.php.tpl -e tests/Composer/Test/Plugin/Fixtures/plugin-v9/Installer/Plugin.php -e tests/Composer/Test/Plugin/Fixtures/plugin-v2/Installer/Plugin2.php -e tests/Composer/Test/Plugin/Fixtures/plugin-v3/Installer/Plugin2.php -e tests/Composer/Test/Autoload/Fixtures/autoload_static_functions_with_removed_include_paths_and_autolad_files.php -e tests/Composer/Test/Autoload/Fixtures/autoload_static_functions_with_include_paths.php -e tests/Composer/Test/Autoload/Fixtures/autoload_real_functions_with_include_paths.php -e tests/Composer/Test/Autoload/Fixtures/autoload_real_functions_with_removed_include_paths_and_autolad_files.php tests/Composer/Test && phpunit --exclude-group remote,git
-Depends: git, mercurial, php-mbstring, php-zip, phpab, phpunit, xz-utils, @
+Test-Command: mkdir -p vendor && phpab --tolerant -o vendor/autoload.php -t debian/autoload.tests.php.tpl -e tests/Composer/Test/Plugin/Fixtures/plugin-v9/Installer/Plugin.php -e tests/Composer/Test/Plugin/Fixtures/plugin-v2/Installer/Plugin2.php -e tests/Composer/Test/Plugin/Fixtures/plugin-v3/Installer/Plugin2.php -e tests/Composer/Test/Autoload/Fixtures/autoload_static_functions_with_removed_include_paths_and_autolad_files.php -e tests/Composer/Test/Autoload/Fixtures/autoload_static_functions_with_include_paths.php -e tests/Composer/Test/Autoload/Fixtures/autoload_real_functions_with_include_paths.php -e tests/Composer/Test/Autoload/Fixtures/autoload_real_functions_with_removed_include_paths_and_autolad_files.php tests/Composer/Test && phpunit --exclude-group remote,git
+Depends: git,
+         mercurial,
+         php-intl,
+         php-mbstring,
+         php-zip,
+         phpab,
+         phpunit (>= 9),
+         xz-utils,
+         @
diff -pruN 1.10.19-1/debian/watch 2.0.9-1/debian/watch
--- 1.10.19-1/debian/watch	2020-12-11 15:24:31.000000000 +0000
+++ 2.0.9-1/debian/watch	2021-01-28 22:53:16.000000000 +0000
@@ -1,4 +1,4 @@
 version=4
-options=uversionmangle=s/-?([^\d.]+)/~$1/i;tr/A-Z/a-z/ \
-https://github.com/composer/composer/releases \
-.*/v?(\d.+)\.tar\.gz
+options=uversionmangle=s/-?([^\d.]+)/~$1/i;tr/A-Z/a-z/,mode=git,gitmode=full,gitexport=all \
+https://github.com/composer/composer \
+refs/tags/v?(\d.+)
diff -pruN 1.10.19-1/doc/00-intro.md 2.0.9-1/doc/00-intro.md
--- 1.10.19-1/doc/00-intro.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/00-intro.md	2021-01-27 15:09:27.000000000 +0000
@@ -9,7 +9,7 @@ for you.
 Composer is **not** a package manager in the same sense as Yum or Apt are. Yes,
 it deals with "packages" or libraries, but it manages them on a per-project
 basis, installing them in a directory (e.g. `vendor`) inside your project. By
-default it does not install anything globally. Thus, it is a dependency
+default, it does not install anything globally. Thus, it is a dependency
 manager. It does however support a "global" project for convenience via the
 [global](03-cli.md#global) command.
 
diff -pruN 1.10.19-1/doc/01-basic-usage.md 2.0.9-1/doc/01-basic-usage.md
--- 1.10.19-1/doc/01-basic-usage.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/01-basic-usage.md	2021-01-27 15:09:27.000000000 +0000
@@ -13,7 +13,10 @@ a logging library. If you have not yet i
 
 To start using Composer in your project, all you need is a `composer.json`
 file. This file describes the dependencies of your project and may contain
-other metadata as well.
+other metadata as well. It typically should go in the top-most directory of
+your project/VCS repository. You can technically run Composer anywhere but
+if you want to publish a package to Packagist.org, it will have to be able
+to find the file at the top of your VCS repository.
 
 ### The `require` key
 
@@ -77,7 +80,7 @@ versions, how versions relate to each ot
 
 > **Note:** If you are trying to require a package but Composer throws an error
 > regarding package stability, the version you have specified may not meet your
-> default minimum stability requirements. By default only stable releases are taken
+> default minimum stability requirements. By default, only stable releases are taken
 > into consideration when searching for valid package versions in your VCS.
 >
 > You might run into this if you are trying to require dev, alpha, beta, or RC
@@ -87,7 +90,7 @@ versions, how versions relate to each ot
 ## Installing dependencies
 
 To install the defined dependencies for your project, run the
-[`install`](03-cli.md#install) command.
+[`install`](03-cli.md#install-i) command.
 
 ```sh
 php composer.phar install
@@ -142,11 +145,14 @@ reinstalling the project you can feel co
 still working even if your dependencies released many new versions since then.
 (See note below about using the `update` command.)
 
+> **Note:** For libraries it is not necessary to commit the lock
+> file, see also: [Libraries - Lock file](02-libraries.md#lock-file).
+
 ## Updating dependencies to their latest versions
 
 As mentioned above, the `composer.lock` file prevents you from automatically getting
 the latest versions of your dependencies. To update to the latest versions, use the
-[`update`](03-cli.md#update) command. This will fetch the latest matching
+[`update`](03-cli.md#update-u) command. This will fetch the latest matching
 versions (according to your `composer.json` file) and update the lock file
 with the new versions. (This is equivalent to deleting the `composer.lock` file
 and running `install` again.)
@@ -159,15 +165,12 @@ php composer.phar update
 > if the `composer.lock` has not been updated since changes were made to the
 > `composer.json` that might affect dependency resolution.
 
-If you only want to install or update one dependency, you can allow them:
+If you only want to install, upgrade or remove one dependency, you can explicitly list it as an argument:
 
 ```sh
 php composer.phar update monolog/monolog [...]
 ```
 
-> **Note:** For libraries it is not necessary to commit the lock
-> file, see also: [Libraries - Lock file](02-libraries.md#lock-file).
-
 ## Packagist
 
 [Packagist](https://packagist.org/) is the main Composer repository. A Composer
@@ -233,7 +236,7 @@ You can even add your own code to the au
 }
 ```
 
-Composer will register a [PSR-4](http://www.php-fig.org/psr/psr-4/) autoloader
+Composer will register a [PSR-4](https://www.php-fig.org/psr/psr-4/) autoloader
 for the `Acme` namespace.
 
 You define a mapping from namespaces to directories. The `src` directory would
diff -pruN 1.10.19-1/doc/02-libraries.md 2.0.9-1/doc/02-libraries.md
--- 1.10.19-1/doc/02-libraries.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/02-libraries.md	2021-01-27 15:09:27.000000000 +0000
@@ -26,14 +26,14 @@ In this case the project name is `acme/h
 name. Supplying a vendor name is mandatory.
 
 > **Note:** If you don't know what to use as a vendor name, your GitHub
-> username is usually a good bet. While package names are case insensitive, the
+> username is usually a good bet. While package names are case-insensitive, the
 > convention is all lowercase and dashes for word separation.
 
 ## Library Versioning
 
 In the vast majority of cases, you will be maintaining your library using some
 sort of version control system like git, svn, hg or fossil. In these cases,
-Composer infers versions from your VCS and you **should not** specify a version
+Composer infers versions from your VCS, and you **should not** specify a version
 in your `composer.json` file. (See the [Versions article](articles/versions.md)
 to learn about how Composer uses VCS branches and tags to resolve version
 constraints.)
@@ -69,7 +69,7 @@ can help your team to always test agains
 However, this lock file will not have any effect on other projects that depend
 on it. It only has an effect on the main project.
 
-If you do not want to commit the lock file and you are using git, add it to
+If you do not want to commit the lock file, and you are using git, add it to
 the `.gitignore`.
 
 ## Publishing to a VCS
diff -pruN 1.10.19-1/doc/03-cli.md 2.0.9-1/doc/03-cli.md
--- 1.10.19-1/doc/03-cli.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/03-cli.md	2021-01-27 15:09:27.000000000 +0000
@@ -105,16 +105,21 @@ resolution.
 * **--no-scripts:** Skips execution of scripts defined in `composer.json`.
 * **--no-progress:** Removes the progress display that can mess with some
   terminals or scripts which don't handle backspace characters.
-* **--no-suggest:** Skips suggested packages in the output.
 * **--optimize-autoloader (-o):** Convert PSR-0/4 autoloading to classmap to get a faster
   autoloader. This is recommended especially for production, but can take
   a bit of time to run so it is currently not done by default.
 * **--classmap-authoritative (-a):** Autoload classes from the classmap only.
   Implicitly enables `--optimize-autoloader`.
 * **--apcu-autoloader:** Use APCu to cache found/not-found classes.
-* **--ignore-platform-reqs:** ignore `php`, `hhvm`, `lib-*` and `ext-*`
-  requirements and force the installation even if the local machine does not
-  fulfill these. See also the [`platform`](06-config.md#platform) config option.
+* **--apcu-autoloader-prefix:** Use a custom prefix for the APCu autoloader cache.
+  Implicitly enables `--apcu-autoloader`.
+* **--ignore-platform-reqs:** ignore all platform requirements (`php`, `hhvm`,
+  `lib-*` and `ext-*`) and force the installation even if the local machine does
+  not fulfill these.
+  See also the [`platform`](06-config.md#platform) config option.
+* **--ignore-platform-req:** ignore a specific platform requirement(`php`,
+  `hhvm`, `lib-*` and `ext-*`) and force the installation even if the local machine
+  does not fulfill it.
 
 ## update / u
 
@@ -142,6 +147,26 @@ You can also use wildcards to update a b
 php composer.phar update "vendor/*"
 ```
 
+
+If you want to downgrade a package to a specific version without changing your
+composer.json you can use `--with` and provide a custom version constraint:
+
+```sh
+php composer.phar update --with vendor/package:2.0.1
+```
+
+The custom constraint has to be a subset of the existing constraint you have,
+and this feature is only available for your root package dependencies.
+
+If you only want to update the package(s) for which you provide custom constraints
+using `--with`, you can skip `--with` and just use constraints with the partial
+update syntax:
+
+```sh
+php composer.phar update vendor/package:2.0.1 vendor/package2:3.0.*
+```
+
+
 ### Options
 
 * **--prefer-source:** Install packages from `source` when available.
@@ -149,24 +174,31 @@ php composer.phar update "vendor/*"
 * **--dry-run:** Simulate the command without actually doing anything.
 * **--dev:** Install packages listed in `require-dev` (this is the default behavior).
 * **--no-dev:** Skip installing packages listed in `require-dev`. The autoloader generation skips the `autoload-dev` rules.
+* **--no-install:** Does not run the install step after updating the composer.lock file.
 * **--lock:** Only updates the lock file hash to suppress warning about the
   lock file being out of date.
+* **--with:** Temporary version constraint to add, e.g. foo/bar:1.0.0 or foo/bar=1.0.0
 * **--no-autoloader:** Skips autoloader generation.
 * **--no-scripts:** Skips execution of scripts defined in `composer.json`.
 * **--no-progress:** Removes the progress display that can mess with some
   terminals or scripts which don't handle backspace characters.
-* **--no-suggest:** Skips suggested packages in the output.
-* **--with-dependencies:** Add also dependencies of allowed packages to the allow list, except those that are root requirements.
-* **--with-all-dependencies:** Add also all dependencies of allowed packages to the allow list, including those that are root requirements.
+* **--with-dependencies (-w):** Update also dependencies of packages in the argument list, except those which are root requirements.
+* **--with-all-dependencies (-W):** Update also dependencies of packages in the argument list, including those which are root requirements.
 * **--optimize-autoloader (-o):** Convert PSR-0/4 autoloading to classmap to get a faster
   autoloader. This is recommended especially for production, but can take
-  a bit of time to run so it is currently not done by default.
+  a bit of time to run, so it is currently not done by default.
 * **--classmap-authoritative (-a):** Autoload classes from the classmap only.
   Implicitly enables `--optimize-autoloader`.
 * **--apcu-autoloader:** Use APCu to cache found/not-found classes.
-* **--ignore-platform-reqs:** ignore `php`, `hhvm`, `lib-*` and `ext-*`
-  requirements and force the installation even if the local machine does not
-  fulfill these. See also the [`platform`](06-config.md#platform) config option.
+* **--apcu-autoloader-prefix:** Use a custom prefix for the APCu autoloader cache.
+  Implicitly enables `--apcu-autoloader`.
+* **--ignore-platform-reqs:** ignore all platform requirements (`php`, `hhvm`,
+  `lib-*` and `ext-*`) and force the installation even if the local machine does
+  not fulfill these.
+  See also the [`platform`](06-config.md#platform) config option.
+* **--ignore-platform-req:** ignore a specific platform requirement(`php`,
+  `hhvm`, `lib-*` and `ext-*`) and force the installation even if the local machine
+  does not fulfill it.
 * **--prefer-stable:** Prefer stable versions of dependencies.
 * **--prefer-lowest:** Prefer lowest versions of dependencies. Useful for testing minimal
   versions of requirements, generally used with `--prefer-stable`.
@@ -199,29 +231,36 @@ If you do not specify a package, compose
 ### Options
 
 * **--dev:** Add packages to `require-dev`.
+* **--dry-run:** Simulate the command without actually doing anything.
 * **--prefer-source:** Install packages from `source` when available.
 * **--prefer-dist:** Install packages from `dist` when available.
 * **--no-progress:** Removes the progress display that can mess with some
   terminals or scripts which don't handle backspace characters.
-* **--no-suggest:** Skips suggested packages in the output.
-* **--no-update:** Disables the automatic update of the dependencies.
+* **--no-update:** Disables the automatic update of the dependencies (implies --no-install).
+* **--no-install:** Does not run the install step after updating the composer.lock file.
 * **--no-scripts:** Skips execution of scripts defined in `composer.json`.
 * **--update-no-dev:** Run the dependency update with the `--no-dev` option.
-* **--update-with-dependencies:** Also update dependencies of the newly required packages, except those that are root requirements.
-* **--update-with-all-dependencies:** Also update dependencies of the newly required packages, including those that are root requirements.
-* **--ignore-platform-reqs:** ignore `php`, `hhvm`, `lib-*` and `ext-*`
-  requirements and force the installation even if the local machine does not
-  fulfill these. See also the [`platform`](06-config.md#platform) config option.
+* **--update-with-dependencies (-w):** Also update dependencies of the newly required packages, except those that are root requirements.
+* **--update-with-all-dependencies (-W):** Also update dependencies of the newly required packages, including those that are root requirements.
+* **--ignore-platform-reqs:** ignore all platform requirements (`php`, `hhvm`,
+  `lib-*` and `ext-*`) and force the installation even if the local machine does
+  not fulfill these.
+  See also the [`platform`](06-config.md#platform) config option.
+* **--ignore-platform-req:** ignore a specific platform requirement(`php`,
+  `hhvm`, `lib-*` and `ext-*`) and force the installation even if the local machine
+  does not fulfill it.
 * **--prefer-stable:** Prefer stable versions of dependencies.
 * **--prefer-lowest:** Prefer lowest versions of dependencies. Useful for testing minimal
   versions of requirements, generally used with `--prefer-stable`.
 * **--sort-packages:** Keep packages sorted in `composer.json`.
 * **--optimize-autoloader (-o):** Convert PSR-0/4 autoloading to classmap to
   get a faster autoloader. This is recommended especially for production, but
-  can take a bit of time to run so it is currently not done by default.
+  can take a bit of time to run, so it is currently not done by default.
 * **--classmap-authoritative (-a):** Autoload classes from the classmap only.
   Implicitly enables `--optimize-autoloader`.
 * **--apcu-autoloader:** Use APCu to cache found/not-found classes.
+* **--apcu-autoloader-prefix:** Use a custom prefix for the APCu autoloader cache.
+  Implicitly enables `--apcu-autoloader`.
 
 ## remove
 
@@ -237,21 +276,32 @@ uninstalled.
 
 ### Options
 * **--dev:** Remove packages from `require-dev`.
+* **--dry-run:** Simulate the command without actually doing anything.
 * **--no-progress:** Removes the progress display that can mess with some
   terminals or scripts which don't handle backspace characters.
-* **--no-update:** Disables the automatic update of the dependencies.
+* **--no-update:** Disables the automatic update of the dependencies (implies --no-install).
+* **--no-install:** Does not run the install step after updating the composer.lock file.
 * **--no-scripts:** Skips execution of scripts defined in `composer.json`.
 * **--update-no-dev:** Run the dependency update with the --no-dev option.
-* **--update-with-dependencies:** Also update dependencies of the removed packages.
-* **--ignore-platform-reqs:** ignore `php`, `hhvm`, `lib-*` and `ext-*`
-  requirements and force the installation even if the local machine does not
-  fulfill these. See also the [`platform`](06-config.md#platform) config option.
+* **--update-with-dependencies (-w):** Also update dependencies of the removed packages.
+  (Deprecrated, is now default behavior)
+* **--update-with-all-dependencies (-W):** Allows all inherited dependencies to be updated,
+  including those that are root requirements.
+* **--ignore-platform-reqs:** ignore all platform requirements (`php`, `hhvm`,
+  `lib-*` and `ext-*`) and force the installation even if the local machine does
+  not fulfill these.
+  See also the [`platform`](06-config.md#platform) config option.
+* **--ignore-platform-req:** ignore a specific platform requirement(`php`,
+  `hhvm`, `lib-*` and `ext-*`) and force the installation even if the local machine
+  does not fulfill it.
 * **--optimize-autoloader (-o):** Convert PSR-0/4 autoloading to classmap to
   get a faster autoloader. This is recommended especially for production, but
   can take a bit of time to run so it is currently not done by default.
 * **--classmap-authoritative (-a):** Autoload classes from the classmap only.
   Implicitly enables `--optimize-autoloader`.
 * **--apcu-autoloader:** Use APCu to cache found/not-found classes.
+* **--apcu-autoloader-prefix:** Use a custom prefix for the APCu autoloader cache.
+  Implicitly enables `--apcu-autoloader`.
 
 ## check-platform-reqs
 
@@ -359,6 +409,7 @@ php composer.phar show monolog/monolog 1
 
 * **--all :** List all packages available in all your repositories.
 * **--installed (-i):** List the packages that are installed (this is enabled by default, and deprecated).
+* **--locked:** List the locked packages from composer.lock.
 * **--platform (-p):** List only platform packages (php & extensions).
 * **--available (-a):** List available packages only.
 * **--self (-s):** List the root package info.
@@ -367,6 +418,7 @@ php composer.phar show monolog/monolog 1
 * **--tree (-t):** List your dependencies as a tree. If you pass a package name it will show the dependency tree for that package.
 * **--latest (-l):** List all installed packages including their latest version.
 * **--outdated (-o):** Implies --latest, but this lists *only* packages that have a newer version available.
+* **--no-dev:** Filters dev dependencies from the package list.
 * **--minor-only (-m):** Use with --latest. Only shows packages that have minor SemVer-compatible updates.
 * **--direct (-D):** Restricts the list of packages to your direct dependencies.
 * **--strict:** Return a non-zero exit code when there are outdated packages.
@@ -381,7 +433,7 @@ including their current and latest versi
 The color coding is as such:
 
 - **green (=)**: Dependency is in the latest version and is up to date.
-- **yellow (~)**: Dependency has a new version available that includes backwards compatibility breaks according to semver, so upgrade when
+- **yellow (`~`)**: Dependency has a new version available that includes backwards compatibility breaks according to semver, so upgrade when
   you can but it may involve work.
 - **red (!)**: Dependency has a new version that is semver-compatible and you should upgrade it.
 
@@ -392,6 +444,8 @@ The color coding is as such:
 * **--strict:** Returns non-zero exit code if any package is outdated.
 * **--minor-only (-m):** Only shows packages that have minor SemVer-compatible updates.
 * **--format (-f):** Lets you pick between text (default) or json output format.
+* **--no-dev:** Do not show outdated dev dependencies.
+* **--locked:** Shows updates for packages from the lock file, regardless of what is currently in vendor dir.
 
 ## browse / home
 
@@ -409,16 +463,18 @@ Lists all packages suggested by currentl
 optionally pass one or multiple package names in the format of `vendor/package`
 to limit output to suggestions made by those packages only.
 
-Use the `--by-package` or `--by-suggestion` flags to group the output by
+Use the `--by-package` (default) or `--by-suggestion` flags to group the output by
 the package offering the suggestions or the suggested packages respectively.
 
-Use the `--verbose (-v)` flag to display the suggesting package and the suggestion reason.
-This implies `--by-package --by-suggestion`, showing both lists.
+If you only want a list of suggested package names, use `--list`.
 
 ### Options
 
-* **--by-package:** Groups output by suggesting package.
+* **--by-package:** Groups output by suggesting package (default).
 * **--by-suggestion:** Groups output by suggested package.
+* **--all:** Show suggestions from all dependencies, including transitive ones (by
+  default only direct dependencies' suggestions are shown).
+* **--list:** Show only list of suggested package names.
 * **--no-dev:** Excludes suggestions from `require-dev` packages.
 
 ## fund
@@ -552,6 +608,9 @@ you may have to run the command with `ro
 sudo -H composer self-update
 ```
 
+If Composer was not installed as a PHAR, this command is not available.
+(This is sometimes the case when Composer was installed by an operating system package manager.)
+
 ### Options
 
 * **--rollback (-r):** Rollback to the last version you had installed.
@@ -562,6 +621,9 @@ sudo -H composer self-update
 * **--stable:** Force an update to the stable channel.
 * **--preview:** Force an update to the preview channel.
 * **--snapshot:** Force an update to the snapshot channel.
+* **--1:** Force an update to the stable channel, but only use 1.x versions
+* **--2:** Force an update to the stable channel, but only use 2.x versions
+* **--set-channel-only:** Only store the channel as the default one and then exit
 
 ## config
 
@@ -603,8 +665,10 @@ See the [Config](06-config.md) chapter f
   option this lists the global configuration only.
 * **--file="..." (-f):** Operate on a specific file instead of composer.json. Note
   that this cannot be used in conjunction with the `--global` option.
-* **--absolute:** Returns absolute paths when fetching *-dir config values
+* **--absolute:** Returns absolute paths when fetching `*-dir` config values
   instead of relative.
+* **--json:** JSON decode the setting value, to be used with `extra.*` keys.
+* **--merge:** Merge the setting value with the current value, to be used with `extra.*` keys in combination with `--json`.
 
 ### Modifying Repositories
 
@@ -633,6 +697,13 @@ php composer.phar config extra.foo.bar v
 The dots indicate array nesting, a max depth of 3 levels is allowed though. The above
 would set `"extra": { "foo": { "bar": "value" } }`.
 
+If you have a complex value to add/modify, you can use the `--json` and `--merge` flags
+to edit extra fields as json:
+
+```sh
+php composer.phar config --json extra.foo.bar '{"baz": true, "qux": []}'
+```
+
 ## create-project
 
 You can use Composer to create new projects from an existing package. This is
@@ -670,8 +741,9 @@ By default the command checks for the pa
   which will be used instead of packagist. Can be either an HTTP URL pointing
   to a `composer` repository, a path to a local `packages.json` file, or a
   JSON string which similar to what the [repositories](04-schema.md#repositories)
-  key accepts.
-* **--add-repository:** Add the repository option to the composer.json.
+  key accepts. You can use this multiple times to configure multiple repositories.
+* **--add-repository:** Add the custom repository in the composer.json. If a lock
+  file is present it will be deleted and an update will be run instead of install.
 * **--dev:** Install packages listed in `require-dev`.
 * **--no-dev:** Disables installation of require-dev packages.
 * **--no-scripts:** Disables the execution of the scripts defined in the root
@@ -686,9 +758,14 @@ By default the command checks for the pa
   mode.
 * **--remove-vcs:** Force-remove the VCS metadata without prompting.
 * **--no-install:** Disables installation of the vendors.
-* **--ignore-platform-reqs:** ignore `php`, `hhvm`, `lib-*` and `ext-*`
-  requirements and force the installation even if the local machine does not
-  fulfill these.
+* **--ignore-platform-reqs:** ignore all platform requirements (`php`, `hhvm`,
+  `lib-*` and `ext-*`) and force the installation even if the local machine does
+  not fulfill these.
+  See also the [`platform`](06-config.md#platform) config option.
+* **--ignore-platform-req:** ignore a specific platform requirement(`php`,
+  `hhvm`, `lib-*` and `ext-*`) and force the installation even if the local machine
+  does not fulfill it.
+* **--ask:** Ask user to provide target directory for new project.
 
 ## dump-autoload (dumpautoload)
 
@@ -707,11 +784,18 @@ performance.
 * **--no-scripts:** Skips the execution of all scripts defined in `composer.json` file.
 * **--optimize (-o):** Convert PSR-0/4 autoloading to classmap to get a faster
   autoloader. This is recommended especially for production, but can take
-  a bit of time to run so it is currently not done by default.
+  a bit of time to run, so it is currently not done by default.
 * **--classmap-authoritative (-a):** Autoload classes from the classmap only.
   Implicitly enables `--optimize`.
 * **--apcu:** Use APCu to cache found/not-found classes.
+* **--apcu-prefix:** Use a custom prefix for the APCu autoloader cache.
+  Implicitly enables `--apcu`.
 * **--no-dev:** Disables autoload-dev rules.
+* **--ignore-platform-reqs:** ignore all `php`, `hhvm`, `lib-*` and `ext-*`
+  requirements and skip the [platform check](07-runtime.md#platform-check) for these.
+  See also the [`platform`](06-config.md#platform) config option.
+* **--ignore-platform-req:** ignore a specific platform requirement (`php`, `hhvm`,
+  `lib-*` and `ext-*`) and skip the [platform check](07-runtime.md#platform-check) for it.
 
 ## clear-cache / clearcache / cc
 
@@ -720,11 +804,11 @@ Deletes all content from Composer's cach
 ## licenses
 
 Lists the name, version and license of every package installed. Use
-`--format=json` to get machine readable output.
+`--format=json` to get machine-readable output.
 
 ### Options
 
-* **--format:** Format of the output: text or json (default: "text")
+* **--format:** Format of the output: text, json or summary (default: "text")
 * **--no-dev:** Remove dev dependencies from the output
 
 ## run-script
@@ -822,9 +906,10 @@ If set to 1, this env allows running Com
 ### COMPOSER_AUTH
 
 The `COMPOSER_AUTH` var allows you to set up authentication as an environment variable.
-The contents of the variable should be a JSON formatted object containing http-basic,
-github-oauth, bitbucket-oauth, ... objects as needed, and following the
-[spec from the config](06-config.md#gitlab-oauth).
+The contents of the variable should be a JSON formatted object containing [http-basic,
+github-oauth, bitbucket-oauth, ... objects as needed](articles/authentication-for-private-packages.md),
+and following the
+[spec from the config](06-config.md).
 
 ### COMPOSER_BIN_DIR
 
@@ -836,7 +921,7 @@ directory to something other than `vendo
 The `COMPOSER_CACHE_DIR` var allows you to change the Composer cache directory,
 which is also configurable via the [`cache-dir`](06-config.md#cache-dir) option.
 
-By default it points to `$COMPOSER_HOME/cache` on \*nix and macOS, and
+By default, it points to `$COMPOSER_HOME/cache` on \*nix and macOS, and
 `C:\Users\<user>\AppData\Local\Composer` (or `%LOCALAPPDATA%/Composer`) on Windows.
 
 ### COMPOSER_CAFILE
@@ -858,7 +943,9 @@ The `COMPOSER_HOME` var allows you to ch
 is a hidden, global (per-user on the machine) directory that is shared between
 all projects.
 
-By default it points to `C:\Users\<user>\AppData\Roaming\Composer` on Windows
+Use `composer config --global home` to see the location of the home directory.
+
+By default, it points to `C:\Users\<user>\AppData\Roaming\Composer` on Windows
 and `/Users/<user>/.composer` on macOS. On \*nix systems that follow the [XDG Base
 Directory Specifications](https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html),
 it points to `$XDG_CONFIG_HOME/composer`. On other \*nix systems, it points to
@@ -903,8 +990,8 @@ commands) to finish executing. The defau
 
 ### COMPOSER_ROOT_VERSION
 
-By setting this var you can specify the version of the root package, if it can
-not be guessed from VCS info and is not present in `composer.json`.
+By setting this var you can specify the version of the root package, if it
+cannot be guessed from VCS info and is not present in `composer.json`.
 
 ### COMPOSER_VENDOR_DIR
 
@@ -929,13 +1016,13 @@ details.
 
 ### HTTP_PROXY_REQUEST_FULLURI
 
-If you use a proxy but it does not support the request_fulluri flag, then you
+If you use a proxy, but it does not support the request_fulluri flag, then you
 should set this env var to `false` or `0` to prevent Composer from setting the
 request_fulluri option.
 
 ### HTTPS_PROXY_REQUEST_FULLURI
 
-If you use a proxy but it does not support the request_fulluri flag for HTTPS
+If you use a proxy, but it does not support the request_fulluri flag for HTTPS
 requests, then you should set this env var to `false` or `0` to prevent Composer
 from setting the request_fulluri option.
 
@@ -953,4 +1040,17 @@ The env var accepts domains, IP addresse
 notation. You can restrict the filter to a particular port (e.g. `:80`). You
 can also set it to `*` to ignore the proxy for all HTTP requests.
 
+### COMPOSER_DISABLE_NETWORK
+
+If set to `1`, disables network access (best effort). This can be used for debugging or
+to run Composer on a plane or a starship with poor connectivity.
+
+If set to `prime`, GitHub VCS repositories will prime the cache, so it can then be used
+fully offline with `1`.
+
+### COMPOSER_DEBUG_EVENTS
+
+If set to `1`, outputs information about events being dispatched, which can be
+useful for plugin authors to identify what is firing when exactly.
+
 &larr; [Libraries](02-libraries.md)  |  [Schema](04-schema.md) &rarr;
diff -pruN 1.10.19-1/doc/04-schema.md 2.0.9-1/doc/04-schema.md
--- 1.10.19-1/doc/04-schema.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/04-schema.md	2021-01-27 15:09:27.000000000 +0000
@@ -1,10 +1,10 @@
-# The composer.json Schema
+# The composer.json schema
 
 This chapter will explain all of the fields available in `composer.json`.
 
 ## JSON schema
 
-We have a [JSON schema](http://json-schema.org) that documents the format and
+We have a [JSON schema](https://json-schema.org) that documents the format and
 can also be used to validate your `composer.json`. In fact, it is used by the
 `validate` command. You can find it at: https://getcomposer.org/schema.json
 
@@ -34,12 +34,12 @@ separated by `/`. Examples:
 * monolog/monolog
 * igorw/event-source
 
-The name can contain any character, including white spaces, and it's case
-insensitive (`foo/bar` and `Foo/Bar` are considered the same package). In order
-to simplify its installation, it's recommended to define a short and lowercase
-name that doesn't include non-alphanumeric characters or white spaces.
+The name must be lowercased and consist of words separated by `-`, `.` or `_`.
+The complete name should match `^[a-z0-9]([_.-]?[a-z0-9]+)*/[a-z0-9](([_.]?|-{0,2})[a-z0-9]+)*$`.
 
-Required for published packages (libraries).
+The `name` property is required for published packages (libraries).
+
+> **Note:** Before Composer version 2.0, a name could contain any character, including white spaces.
 
 ### description
 
@@ -123,7 +123,7 @@ Optional.
 
 ### homepage
 
-An URL to the website of the project.
+A URL to the website of the project.
 
 Optional.
 
@@ -184,7 +184,7 @@ An Example for disjunctive licenses:
 }
 ```
 
-Alternatively they can be separated with "or" and enclosed in parenthesis;
+Alternatively they can be separated with "or" and enclosed in parentheses;
 
 ```json
 {
@@ -192,8 +192,8 @@ Alternatively they can be separated with
 }
 ```
 
-Similarly when multiple licenses need to be applied ("conjunctive license"),
-they should be separated with "and" and enclosed in parenthesis.
+Similarly, when multiple licenses need to be applied ("conjunctive license"),
+they should be separated with "and" and enclosed in parentheses.
 
 ### authors
 
@@ -214,7 +214,7 @@ An example:
         {
             "name": "Nils Adermann",
             "email": "naderman@naderman.de",
-            "homepage": "http://www.naderman.de",
+            "homepage": "https://www.naderman.de",
             "role": "Developer"
         },
         {
@@ -265,8 +265,8 @@ development of new functionality.
 
 Each entry consists of the following
 
-* **type:** The type of funding or the platform through which funding can be provided, e.g. patreon, opencollective, tidelift or github.
-* **url:** URL to a website with details and a way to fund the package.
+* **type:** The type of funding, or the platform through which funding can be provided, e.g. patreon, opencollective, tidelift or github.
+* **url:** URL to a website with details, and a way to fund the package.
 
 An example:
 
@@ -310,7 +310,7 @@ Example:
 All links are optional fields.
 
 `require` and `require-dev` additionally support _stability flags_ ([root-only](04-schema.md#root-package)).
-They take the form "_constraint_@_stability flag_". 
+They take the form "_constraint_@_stability flag_".
 These allow you to further restrict or expand the stability of a package beyond
 the scope of the [minimum-stability](#minimum-stability) setting. You can apply
 them to a constraint, or apply them to an empty _constraint_ if you want to
@@ -382,7 +382,7 @@ Example:
 ```json
 {
     "require" : {
-        "php" : "^5.5 || ^7.0",
+        "php" : ">=7.4",
         "ext-mbstring": "*"
     }
 }
@@ -401,19 +401,19 @@ Example:
 
 #### require
 
-Lists packages required by this package. The package will not be installed
+Map of packages required by this package. The package will not be installed
 unless those requirements can be met.
 
 #### require-dev <span>([root-only](04-schema.md#root-package))</span>
 
-Lists packages required for developing this package, or running
+Map of packages required for developing this package, or running
 tests, etc. The dev requirements of the root package are installed by default.
 Both `install` or `update` support the `--no-dev` option that prevents dev
 dependencies from being installed.
 
 #### conflict
 
-Lists packages that conflict with this version of this package. They
+Map of packages that conflict with this version of this package. They
 will not be allowed to be installed together with your package.
 
 Note that when specifying ranges like `<1.0 >=1.1` in a `conflict` link,
@@ -423,7 +423,7 @@ probably want to go for `<1.0 || >=1.1`
 
 #### replace
 
-Lists packages that are replaced by this package. This allows you to fork a
+Map of packages that are replaced by this package. This allows you to fork a
 package, publish it under a different name with its own version numbers, while
 packages requiring the original package continue to work with your fork because
 it replaces the original package.
@@ -441,10 +441,12 @@ that exact version, and not any other ve
 
 #### provide
 
-List of other packages that are provided by this package. This is mostly
+Map of packages that are provided by this package. This is mostly
 useful for implementations of common interfaces. A package could depend on
-some virtual `logger-implementation` package, any library that implements
-this logger interface would list it in `provide`.
+some virtual package e.g. `psr/logger-implementation`, any library that implements
+this logger interface would list it in `provide`. Implementors can then
+be [found on Packagist.org](https://packagist.org/providers/psr/log-implementation).
+
 Using `provide` with the name of an actual package rather than a virtual one
 implies that the code of that package is also shipped, in which case `replace`
 is generally a better choice. A common convention for packages providing an
@@ -477,7 +479,7 @@ Example:
 
 Autoload mapping for a PHP autoloader.
 
-[`PSR-4`](http://www.php-fig.org/psr/psr-4/) and [`PSR-0`](http://www.php-fig.org/psr/psr-0/)
+[`PSR-4`](https://www.php-fig.org/psr/psr-4/) and [`PSR-0`](http://www.php-fig.org/psr/psr-0/)
 autoloading, `classmap` generation and `files` includes are supported.
 
 PSR-4 is the recommended way since it offers greater ease of use (no need
@@ -616,6 +618,18 @@ Example:
 }
 ```
 
+Wildcards (`*`) are also supported in a classmap paths, and expand to match any directory name:
+
+Example:
+
+```json
+{
+    "autoload": {
+        "classmap": ["src/addons/*/lib/", "3rd-party/*", "Something.php"]
+    }
+}
+```
+
 #### Files
 
 If you want to require certain files explicitly on every request then you can use
@@ -776,8 +790,6 @@ The following repository types are suppo
   using the `options` parameter.
 * **vcs:** The version control system repository can fetch packages from git,
   svn, fossil and hg repositories.
-* **pear:** With this you can import any pear repository into your Composer
-  project.
 * **package:** If you depend on a project that does not have any support for
   composer whatsoever you can define the package inline using a `package`
   repository. You basically inline the `composer.json` object.
@@ -807,10 +819,6 @@ Example:
             "url": "https://github.com/Seldaek/monolog"
         },
         {
-            "type": "pear",
-            "url": "https://pear2.php.net"
-        },
-        {
             "type": "package",
             "package": {
                 "name": "smarty/smarty",
@@ -889,6 +897,21 @@ A set of options for creating package ar
 
 The following options are supported:
 
+* **name:** Allows configuring base name for archive.
+  By default (if not configured, and `--file` is not passed as command-line argument),
+  `preg_replace('#[^a-z0-9-_]#i', '-', name)` is used.
+
+Example:
+
+```json
+{
+    "name": "org/strangeName",
+    "archive": {
+        "name": "Strange_name"
+    }
+}
+```
+
 * **exclude:** Allows configuring a list of patterns for excluded paths. The
   pattern syntax matches .gitignore files. A leading exclamation mark (!) will
   result in any matching files to be included even if a previous pattern
@@ -919,7 +942,7 @@ It can be boolean or a package name/URL
 Examples:
 
 Use `"abandoned": true` to indicates this package is abandoned.
-Use `"abandoned": "monolog/monolog"` to indicates this package is abandoned and the
+Use `"abandoned": "monolog/monolog"` to indicates this package is abandoned, and the
 recommended alternative is  `monolog/monolog`.
 
 Defaults to false.
@@ -934,7 +957,7 @@ that will NOT be handled as feature bran
 If you have non-numeric branch names, for example like "latest", "current", "latest-stable"
 or something, that do not look like a version number, then Composer handles such branches
 as feature branches. This means it searches for parent branches, that look like a version
-or ends at special branches (like master) and the root package version number becomes the
+or ends at special branches (like master), and the root package version number becomes the
 version of the parent branch or at least master or something.
 
 To handle non-numeric named branches as versions instead of searching for a parent branch
diff -pruN 1.10.19-1/doc/05-repositories.md 2.0.9-1/doc/05-repositories.md
--- 1.10.19-1/doc/05-repositories.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/05-repositories.md	2021-01-27 15:09:27.000000000 +0000
@@ -6,7 +6,7 @@ of repositories are available, and how t
 ## Concepts
 
 Before we look at the different types of repositories that exist, we need to
-understand some of the basic concepts that Composer is built on.
+understand some basic concepts that Composer is built on.
 
 ### Package
 
@@ -41,7 +41,7 @@ be preferred.
 A repository is a package source. It's a list of packages/versions. Composer
 will look in all your repositories to find the packages your project requires.
 
-By default only the Packagist repository is registered in Composer. You can
+By default, only the Packagist.org repository is registered in Composer. You can
 add more repositories to your project by declaring them in `composer.json`.
 
 Repositories are only available to the root package and the repositories
@@ -49,6 +49,12 @@ defined in your dependencies will not be
 [FAQ entry](faqs/why-can't-composer-load-repositories-recursively.md) if you
 want to learn why.
 
+When resolving dependencies, packages are looked up from repositories from
+top to bottom, and by default, as soon as a package is found in one, Composer
+stops looking in other repositories. Read the
+[repository priorities](articles/repository-priorities.md) article for more
+details and to see how to change this behavior.
+
 ## Types
 
 ### Composer
@@ -62,6 +68,17 @@ In the case of packagist, that file is l
 the repository would be `repo.packagist.org`. For `example.org/packages.json` the
 repository URL would be `example.org`.
 
+```json
+{
+    "repositories": [
+        {
+            "type": "composer",
+            "url": "https://example.org"
+        }
+    ]
+}
+```
+
 #### packages
 
 The only required field is `packages`. The JSON structure is as follows:
@@ -105,7 +122,7 @@ It may include any of the other fields s
 
 The `notify-batch` field allows you to specify a URL that will be called
 every time a user installs a package. The URL can be either an absolute path
-(that will use the same domain as the repository) or a fully qualified URL.
+(that will use the same domain as the repository), or a fully qualified URL.
 
 An example value:
 
@@ -200,7 +217,7 @@ from these systems.
 
 There are a few use cases for this. The most common one is maintaining your
 own fork of a third party library. If you are using a certain library for your
-project and you decide to change something in the library, you will want your
+project, and you decide to change something in the library, you will want your
 project to use the patched version. If the library is on GitHub (this is the
 case most of the time), you can fork it there and push your changes to
 your fork. After that you update the project's `composer.json`. All you have
@@ -299,23 +316,10 @@ Please note:
 
 #### BitBucket Driver Configuration
 
-The BitBucket driver uses OAuth to access your private repositories via the BitBucket REST APIs and you will need to create an OAuth consumer to use the driver, please refer to [Atlassian's Documentation](https://confluence.atlassian.com/bitbucket/oauth-on-bitbucket-cloud-238027431.html). You will need to fill the callback url with something to satisfy BitBucket, but the address does not need to go anywhere and is not used by Composer.
-
-After creating an OAuth consumer in the BitBucket control panel, you need to setup your auth.json file with
-the credentials like this (more info [here](https://getcomposer.org/doc/06-config.md#bitbucket-oauth)):
-```json
-{
-    "bitbucket-oauth": {
-        "bitbucket.org": {
-            "consumer-key": "myKey",
-            "consumer-secret": "mySecret"
-        }
-    }
-}
-```
-**Note that the repository endpoint needs to be https rather than git.**
+> **Note that the repository endpoint for BitBucket needs to be https rather than git.**
 
-Alternatively if you prefer not to have your OAuth credentials on your filesystem you may export the ```bitbucket-oauth``` block above to the [COMPOSER_AUTH](https://getcomposer.org/doc/03-cli.md#composer-auth) environment variable instead.
+After setting up your bitbucket repository, you will also need to
+[set up authentication](articles/authentication-for-private-packages.md#bitbucket-oauth).
 
 #### Subversion Options
 
@@ -378,92 +382,6 @@ for this server will be overwritten. To
 }
 ```
 
-### PEAR
-
-It is possible to install packages from any PEAR channel by using the `pear`
-repository. Composer will prefix all package names with `pear-{channelName}/`
-to avoid conflicts. All packages are also aliased with prefix
-`pear-{channelAlias}/`.
-
-Example using `pear2.php.net`:
-
-```json
-{
-    "repositories": [
-        {
-            "type": "pear",
-            "url": "https://pear2.php.net"
-        }
-    ],
-    "require": {
-        "pear-pear2.php.net/PEAR2_Text_Markdown": "*",
-        "pear-pear2/PEAR2_HTTP_Request": "*"
-    }
-}
-```
-
-In this case the short name of the channel is `pear2`, so the
-`PEAR2_HTTP_Request` package name becomes `pear-pear2/PEAR2_HTTP_Request`.
-
-> **Note:** The `pear` repository requires doing quite a few requests per
-> package, so this may considerably slow down the installation process.
-
-#### Custom vendor alias
-
-It is possible to alias PEAR channel packages with a custom vendor name.
-
-Example:
-
-Suppose you have a private PEAR repository and wish to use Composer to
-incorporate dependencies from a VCS. Your PEAR repository contains the
-following packages:
-
- * `BasePackage`
- * `IntermediatePackage`, which depends on `BasePackage`
- * `TopLevelPackage1` and `TopLevelPackage2` which both depend
-    on `IntermediatePackage`
-
-Without a vendor alias, Composer will use the PEAR channel name as the
-vendor portion of the package name:
-
- * `pear-pear.foobar.repo/BasePackage`
- * `pear-pear.foobar.repo/IntermediatePackage`
- * `pear-pear.foobar.repo/TopLevelPackage1`
- * `pear-pear.foobar.repo/TopLevelPackage2`
-
-Suppose at a later time you wish to migrate your PEAR packages to a
-Composer repository and naming scheme, and adopt the vendor name of `foobar`.
-Projects using your PEAR packages would not see the updated packages, since
-they have a different vendor name (`foobar/IntermediatePackage` vs
-`pear-pear.foobar.repo/IntermediatePackage`).
-
-By specifying `vendor-alias` for the PEAR repository from the start, you can
-avoid this scenario and future-proof your package names.
-
-To illustrate, the following example would get the `BasePackage`,
-`TopLevelPackage1`, and `TopLevelPackage2` packages from your PEAR repository
-and `IntermediatePackage` from a Github repository:
-
-```json
-{
-    "repositories": [
-        {
-            "type": "git",
-            "url": "https://github.com/foobar/intermediate.git"
-        },
-        {
-            "type": "pear",
-            "url": "http://pear.foobar.repo",
-            "vendor-alias": "foobar"
-        }
-    ],
-    "require": {
-        "foobar/TopLevelPackage1": "*",
-        "foobar/TopLevelPackage2": "*"
-    }
-}
-```
-
 ### Package
 
 If you want to use a project that does not support Composer through any of the
@@ -506,7 +424,7 @@ Here is an example for the smarty templa
 }
 ```
 
-Typically you would leave the source part off, as you don't really need it.
+Typically, you would leave the source part off, as you don't really need it.
 
 > **Note**: This repository type has a few limitations and should be avoided
 > whenever possible:
@@ -576,7 +494,7 @@ package repository definitions. It will
 `require`d and dump a `packages.json` that is your `composer` repository.
 
 Check [the satis GitHub repository](https://github.com/composer/satis) and
-the [Satis article](articles/handling-private-packages-with-satis.md) for more
+the [handling private packages article](articles/handling-private-packages.md) for more
 information.
 
 ### Artifact
@@ -585,8 +503,8 @@ There are some cases, when there is no a
 mentioned repository types online, even the VCS one. A typical example could be
 cross-organisation library exchange through build artifacts. Of course, most
 of the time these are private. To use these archives as-is, one can use a
-repository of type `artifact` with a folder containing ZIP archives of those
-private packages:
+repository of type `artifact` with a folder containing ZIP or TAR archives of
+those private packages:
 
 ```json
 {
@@ -658,14 +576,23 @@ the branch or tag that is currently chec
 be explicitly defined in the package's `composer.json` file. If the version
 cannot be resolved by these means, it is assumed to be `dev-master`.
 
-When the version cannot be inferred from the local VCS repository, you should use
-the special `branch-version` entry under `extra` instead of `version`:
+When the version cannot be inferred from the local VCS repository, or when you
+want to override the version, you can use the `versions` option when declaring
+the repository:
 
 ```json
 {
-    "extra": {
-        "branch-version": "4.2-dev"
-    }
+    "repositories": [
+        {
+            "type": "path",
+            "url": "../../packages/my-package",
+            "options": {
+                "versions": {
+                    "my/package": "4.2-dev"
+                }
+            }
+        }
+    ]
 }
 ```
 
@@ -703,8 +630,8 @@ variables are parsed in both Windows and
 `/home/<username>/git/mypackage`, equivalent to `$HOME/git/mypackage` or
 `%USERPROFILE%/git/mypackage`.
 
-> **Note:** Repository paths can also contain wildcards like ``*`` and ``?``.
-> For details, see the [PHP glob function](http://php.net/glob).
+> **Note:** Repository paths can also contain wildcards like `*` and `?`.
+> For details, see the [PHP glob function](https://php.net/glob).
 
 ## Disabling Packagist.org
 
diff -pruN 1.10.19-1/doc/06-config.md 2.0.9-1/doc/06-config.md
--- 1.10.19-1/doc/06-config.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/06-config.md	2021-01-27 15:09:27.000000000 +0000
@@ -5,7 +5,8 @@ This chapter will describe the `config`
 
 ## process-timeout
 
-Defaults to `300`. The duration processes like git clones can run before
+The timeout in seconds for process executions, defaults to 300 (5mins).
+The duration processes like git clones can run before
 Composer assumes they died out. You may need to make this higher if you have a
 slow connection or huge vendors.
 
@@ -71,9 +72,9 @@ URL.
 A list of domain names and oauth keys. For example using `{"github.com":
 "oauthtoken"}` as the value of this option will use `oauthtoken` to access
 private repositories on github and to circumvent the low IP-based rate limiting
-of their API. [Read
-more](articles/troubleshooting.md#api-rate-limit-and-oauth-tokens) on how to get
-an OAuth token for GitHub.
+of their API. Composer may prompt for credentials when needed, but these can also be
+manually set. Read more on how to get an OAuth token for GitHub and cli syntax
+[here](articles/authentication-for-private-packages.md#github-oauth).
 
 ## gitlab-oauth
 
@@ -82,14 +83,21 @@ A list of domain names and oauth keys. F
 private repositories on gitlab. Please note: If the package is not hosted at
 gitlab.com the domain names must be also specified with the
 [`gitlab-domains`](06-config.md#gitlab-domains) option.
+Further info can also be found [here](articles/authentication-for-private-packages.md#gitlab-oauth)
 
 ## gitlab-token
 
-A list of domain names and private tokens. For example using `{"gitlab.com":
+A list of domain names and private tokens. Private token can be either simple
+string, or array with username and token. For example using `{"gitlab.com":
 "privatetoken"}` as the value of this option will use `privatetoken` to access
-private repositories on gitlab. Please note: If the package is not hosted at
+private repositories on gitlab. Using `{"gitlab.com": {"username": "gitlabuser",
+ "token": "privatetoken"}}` will use both username and token for gitlab deploy
+token functionality (https://docs.gitlab.com/ee/user/project/deploy_tokens/)
+Please note: If the package is not hosted at
 gitlab.com the domain names must be also specified with the
-[`gitlab-domains`](06-config.md#gitlab-domains) option.
+[`gitlab-domains`](06-config.md#gitlab-domains) option. The token must have
+`api` or `read_api` scope.
+Further info can also be found [here](articles/authentication-for-private-packages.md#gitlab-token)
 
 ## disable-tls
 
@@ -109,8 +117,8 @@ get a free SSL certificate is generally
 ## bitbucket-oauth
 
 A list of domain names and consumers. For example using `{"bitbucket.org":
-{"consumer-key": "myKey", "consumer-secret": "mySecret"}}`. [Read](https://confluence.atlassian.com/bitbucket/oauth-on-bitbucket-cloud-238027431.html)
-how to set up a consumer on Bitbucket.
+{"consumer-key": "myKey", "consumer-secret": "mySecret"}}`.
+Read more [here](articles/authentication-for-private-packages.md#bitbucket-oauth).
 
 ## cafile
 
@@ -129,11 +137,7 @@ capath must be a correctly hashed certif
 A list of domain names and username/passwords to authenticate against them. For
 example using `{"example.org": {"username": "alice", "password": "foo"}}` as the
 value of this option will let Composer authenticate against example.org.
-
-> **Note:** Authentication-related config options like `http-basic`, `bearer` and
-> `github-oauth` can also be specified inside a `auth.json` file that goes
-> besides your `composer.json`. That way you can gitignore it and every
-> developer can place their own credentials in there.
+More info can be found [here](articles/authentication-for-private-packages.md#http-basic).
 
 ## bearer
 
@@ -147,6 +151,21 @@ Lets you fake platform packages (PHP and
 production env or define your target platform in the config. Example: `{"php":
 "7.0.3", "ext-something": "4.0.3"}`.
 
+This will make sure that no package requiring more than PHP 7.0.3 can be installed
+regardless of the actual PHP version you run locally. However it also means
+the dependencies are not checked correctly anymore, if you run PHP 5.6 it will
+install fine as it assumes 7.0.3, but then it will fail at runtime.
+
+Therefore if you use this it is recommended, and safer, to also run the
+[`check-platform-reqs`](03-cli.md#check-platform-reqs) command as part of your
+deployment strategy.
+
+If a dependency requires some extension that you do not have installed locally
+you may ignore it instead by passing `--ignore-platform-req=ext-foo` to `update`,
+`install` or `require`. In the long run though you should install required
+extensions as if you ignore one now and a new package you add a month later also
+requires it, you may introduce issues in production unknowingly.
+
 ## vendor-dir
 
 Defaults to `vendor`. You can install dependencies into a different directory if
@@ -189,18 +208,22 @@ metadata for the `git`/`hg` types and to
 
 ## cache-files-ttl
 
-Defaults to `15552000` (6 months). Composer caches all dist (zip, tar, ..)
+Defaults to `15552000` (6 months). Composer caches all dist (zip, tar, ...)
 packages that it downloads. Those are purged after six months of being unused by
 default. This option allows you to tweak this duration (in seconds) or disable
 it completely by setting it to 0.
 
 ## cache-files-maxsize
 
-Defaults to `300MiB`. Composer caches all dist (zip, tar, ..) packages that it
+Defaults to `300MiB`. Composer caches all dist (zip, tar, ...) packages that it
 downloads. When the garbage collection is periodically ran, this is the maximum
 size the cache will be able to use. Older (less used) files will be removed
 first until the cache fits.
 
+## cache-read-only
+
+Defaults to `false`. Whether to use the Composer cache in read-only mode.
+
 ## bin-compat
 
 Defaults to `auto`. Determines the compatibility of the binaries to be installed.
@@ -306,4 +329,10 @@ in the composer home, cache, and data di
 Defaults to `true`. If set to `false`, Composer will not create a `composer.lock`
 file.
 
-&larr; [Repositories](05-repositories.md)  |  [Community](07-community.md) &rarr;
+## platform-check
+
+Defaults to `php-only` which only checks the PHP version. Set to `true` to also
+check the presence of extension. If set to `false`, Composer will not create and
+require a `platform_check.php` file as part of the autoloader bootstrap.
+
+&larr; [Repositories](05-repositories.md)  |  [Runtime](07-runtime.md) &rarr;
diff -pruN 1.10.19-1/doc/07-community.md 2.0.9-1/doc/07-community.md
--- 1.10.19-1/doc/07-community.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/07-community.md	1970-01-01 00:00:00.000000000 +0000
@@ -1,35 +0,0 @@
-# Community
-
-There are many people using Composer already, and quite a few of them are
-contributing.
-
-## Contributing
-
-If you would like to contribute to Composer, please read the
-[README](https://github.com/composer/composer) and
-[CONTRIBUTING](https://github.com/composer/composer/blob/master/.github/CONTRIBUTING.md)
-documents.
-
-The most important guidelines are described as follows:
-
-> All code contributions - including those of people having commit access - must
-> go through a pull request and approved by a core developer before being
-> merged. This is to ensure proper review of all the code.
->
-> Fork the project, create a feature branch, and send us a pull request.
->
-> To ensure a consistent code base, you should make sure the code follows
-> the [PSR-2 Coding Standards](http://www.php-fig.org/psr/psr-2/).
-
-## IRC / mailing list
-
-Mailing lists for [user support](https://groups.google.com/group/composer-users) and
-[development](https://groups.google.com/group/composer-dev).
-
-IRC channels are on irc.freenode.org: [#composer](irc://irc.freenode.org/composer)
-for users and [#composer-dev](irc://irc.freenode.org/composer-dev) for development.
-
-Stack Overflow has a growing collection of
-[Composer related questions](https://stackoverflow.com/questions/tagged/composer-php).
-
-&larr; [Config](06-config.md)
diff -pruN 1.10.19-1/doc/07-runtime.md 2.0.9-1/doc/07-runtime.md
--- 1.10.19-1/doc/07-runtime.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/doc/07-runtime.md	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,114 @@
+# Runtime Composer utilities
+
+While Composer is mostly used around your project to install its dependencies,
+there are a few things which are made available to you at runtime.
+
+If you need to rely on some of these in a specific version, you can require
+the `composer-runtime-api` package.
+
+## Autoload
+
+The autoloader is the most used one, and is already covered in our
+[basic usage guide](01-basic-usage.md#autoloading). It is available in all
+Composer versions.
+
+## Installed versions
+
+composer-runtime-api 2.0 introduced a new `Composer\InstalledVersions` class which offers
+a few static methods to inspect which versions are currently installed. This is
+automatically available to your code as long as you include the Composer autoloader.
+
+The main use cases for this class are the following:
+
+### Knowing whether package X (or virtual package) is present
+
+```php
+\Composer\InstalledVersions::isInstalled('vendor/package'); // returns bool
+\Composer\InstalledVersions::isInstalled('psr/log-implementation'); // returns bool
+```
+
+Note that this can not be used to check whether platform packages are installed.
+
+### Knowing whether package X is installed in version Y
+
+> **Note:** To use this, your package must require `"composer/semver": "^2.0"`.
+
+```php
+use Composer\Semver\VersionParser;
+
+\Composer\InstalledVersions::satisfies(new VersionParser, 'vendor/package', '2.0.*');
+\Composer\InstalledVersions::satisfies(new VersionParser, 'psr/log-implementation', '^1.0');
+```
+
+This will return true if e.g. vendor/package is installed in a version matching
+`2.0.*`, but also if the given package name is replaced or provided by some other
+package.
+
+### Knowing the version of package X
+
+> **Note:** This will return `null` if the package name you ask for is not itself installed
+> but merely provided or replaced by another package. We therefore recommend using satisfies()
+> in library code at least. In application code you have a bit more control and it is less
+> important.
+
+```php
+// returns a normalized version (e.g. 1.2.3.0) if vendor/package is installed,
+// or null if it is provided/replaced,
+// or throws OutOfBoundsException if the package is not installed at all
+\Composer\InstalledVersions::getVersion('vendor/package');
+```
+
+```php
+// returns the original version (e.g. v1.2.3) if vendor/package is installed,
+// or null if it is provided/replaced,
+// or throws OutOfBoundsException if the package is not installed at all
+\Composer\InstalledVersions::getPrettyVersion('vendor/package');
+```
+
+```php
+// returns the package dist or source reference (e.g. a git commit hash) if vendor/package is installed,
+// or null if it is provided/replaced,
+// or throws OutOfBoundsException if the package is not installed at all
+\Composer\InstalledVersions::getReference('vendor/package');
+```
+
+### Knowing a package's own installed version
+
+If you are only interested in getting a package's own version, e.g. in the source of acme/foo you want
+to know which version acme/foo is currently running to display that to the user, then it is
+acceptable to use getVersion/getPrettyVersion/getReference.
+
+The warning in the section above does not apply in this case as you are sure the package is present
+and not being replaced if your code is running.
+
+It is nonetheless a good idea to make sure you handle the `null` return value as gracefully as
+possible for safety.
+
+----
+
+A few other methods are available for more complex usages, please refer to the
+source/docblocks of the class itself.
+
+## Platform check
+
+composer-runtime-api 2.0 introduced a new `vendor/composer/platform_check.php` file, which
+is included automatically when you include the Composer autoloader.
+
+It verifies that platform requirements (i.e. php and php extensions) are fulfilled
+by the PHP process currently running. If the requirements are not met, the script
+prints a warning with the missing requirements and exits with code 104.
+
+To avoid an unexpected white page of death with some obscure PHP extension warning in
+production, you can run `composer check-platform-reqs` as part of your
+deployment/build and if that returns a non-0 code you should abort.
+
+The default value is `php-only` which only checks the PHP version.
+
+If you for some reason do not want to use this safety check, and would rather
+risk runtime errors when your code executes, you can disable this by setting the
+[`platform-check`](06-config.md#platform-check) config option to `false`.
+
+If you want the check to include verifying the presence of PHP extensions,
+set the config option to `true`.
+
+&larr; [Config](06-config.md)  |  [Community](08-community.md) &rarr;
diff -pruN 1.10.19-1/doc/08-community.md 2.0.9-1/doc/08-community.md
--- 1.10.19-1/doc/08-community.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/doc/08-community.md	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,35 @@
+# Community
+
+There are many people using Composer already, and quite a few of them are
+contributing.
+
+## Contributing
+
+If you would like to contribute to Composer, please read the
+[README](https://github.com/composer/composer) and
+[CONTRIBUTING](https://github.com/composer/composer/blob/master/.github/CONTRIBUTING.md)
+documents.
+
+The most important guidelines are described as follows:
+
+> All code contributions - including those of people having commit access - must
+> go through a pull request and approved by a core developer before being
+> merged. This is to ensure proper review of all the code.
+>
+> Fork the project, create a feature branch, and send us a pull request.
+>
+> To ensure a consistent code base, you should make sure the code follows
+> the [PSR-2 Coding Standards](https://www.php-fig.org/psr/psr-2/).
+
+## IRC / mailing list
+
+Mailing lists for [user support](https://groups.google.com/group/composer-users) and
+[development](https://groups.google.com/group/composer-dev).
+
+IRC channels are on irc.freenode.org: [#composer](irc://irc.freenode.org/composer)
+for users and [#composer-dev](irc://irc.freenode.org/composer-dev) for development.
+
+Stack Overflow has a growing collection of
+[Composer related questions](https://stackoverflow.com/questions/tagged/composer-php).
+
+&larr; [Config](07-runtime.md)
diff -pruN 1.10.19-1/doc/articles/aliases.md 2.0.9-1/doc/articles/aliases.md
--- 1.10.19-1/doc/articles/aliases.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/articles/aliases.md	2021-01-27 15:09:27.000000000 +0000
@@ -107,5 +107,5 @@ and alias it to `1.0.x-dev`.
 > inline-aliased again in A's `composer.json`.
 
 > **Note:** Inline aliasing should be avoided, especially for published
-> packages/libraries. If you found a bug, try and get your fix merged upstream.
+> packages/libraries. If you found a bug, try to get your fix merged upstream.
 > This helps to avoid issues for users of your package.
diff -pruN 1.10.19-1/doc/articles/authentication-for-private-packages.md 2.0.9-1/doc/articles/authentication-for-private-packages.md
--- 1.10.19-1/doc/articles/authentication-for-private-packages.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/doc/articles/authentication-for-private-packages.md	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,298 @@
+<!--
+    tagline: Access privately hosted packages/repositories
+-->
+
+# Authentication for privately hosted packages and repositories
+
+Your [private package server](handling-private-packages.md) or version control system is probably secured with one
+or more authentication options. In order to allow your project to have access to these
+packages and repositories you will have to tell Composer how to authenticate with the server that hosts them.
+
+# Authentication principles
+
+Whenever Composer encounters a protected Composer repository it will try to authenticate
+using already defined credentials first. When none of those credentials apply it will prompt
+for credentials and save them (or a token if Composer is able to retrieve one).
+
+|type|Generated by Prompt?|
+|---|---|
+|[http-basic](#http-basic)|yes|
+|[Inline http-basic](#inline-http-basic)|no|
+|[Custom header](#custom-token-authentication)|no|
+|[gitlab-oauth](#gitlab-oauth)|yes|
+|[gitlab-token](#gitlab-token)|yes|
+|[github-oauth](#github-oauth)|yes|
+|[bitbucket-oauth](#bitbucket-oauth)|yes|
+
+Sometimes automatic authentication is not possible, or you may want to predefine
+authentication credentials.
+
+Credentials can be stored on 3 different places; in an `auth.json` for the project, a global
+`auth.json` or in the `composer.json` itself.
+
+## Authentication in auth.json per project
+
+In this authentication storage method, an `auth.json` file will be present in the same folder
+as the projects' `composer.json` file. You can either create and edit this file using the
+command line or manually edit or create it.
+
+> **Note: Make sure the `auth.json` file is in `.gitignore`** to avoid
+> leaking credentials into your git history.
+
+## Global authentication credentials
+
+If you don't want to supply credentials for every project you work on, storing your credentials
+globally might be a better idea. These credentials are stored in a global `auth.json` in your
+Composer home directory.
+
+### Command line global credential editing
+
+For all authentication methods it is possible to edit them using the command line;
+ - [http-basic](#command-line-http-basic)
+ - [Inline http-basic](#command-line-inline-http-basic)
+ - [gitlab-oauth](#command-line-gitlab-oauth)
+ - [gitlab-token](#command-line-gitlab-token)
+ - [github-oauth](#command-line-github-oauth)
+ - [bitbucket-oauth](#command-line-bitbucket-oauth)
+
+### Manually editing global authentication credentials
+
+> **Note:** It is not recommended to manually edit your authentication options as this might
+> result in invalid json. Instead preferably use [the command line](#command-line-global-credential-editing).
+
+To manually edit it, run:
+
+```sh
+composer config --global --editor [--auth]
+```
+
+For specific authentication implementations, see their sections;
+ - [http-basic](#manual-http-basic)
+ - [Inline http-basic](#manual-inline-http-basic)
+ - [custom header](#manual-custom-token-authentication)
+ - [gitlab-oauth](#manual-gitlab-oauth)
+ - [gitlab-token](#manual-gitlab-token)
+ - [github-oauth](#manual-github-oauth)
+ - [bitbucket-oauth](#manual-bitbucket-oauth)
+
+Manually editing this file instead of using the command line may result in invalid json errors.
+To fix this you need to open the file in an editor and fix the error. To find the location of
+your global `auth.json`, execute:
+
+```sh
+composer config --global home
+```
+
+The folder will contain your global `auth.json` if it exists.
+
+You can open this file in your favorite editor and fix the error.
+
+## Authentication in composer.json file itself
+
+> **Note:** **This is not recommended** as these credentials are visible
+> to anyone who has access to the composer.json, either when it is shared through
+> a version control system like git or when an attacker gains (read) access to
+> your production server files.
+
+It is also possible to add credentials to a `composer.json` on a per-project basis in the `config`
+section or directly in the repository definition.
+
+## Authentication using the COMPOSER_AUTH environment variable
+
+> **Note:** Using the command line environment variable method also has security implications.
+> These credentials will most likely be stored in memory,
+> and on be persisted to a file like `~/.bash_history`(linux) or `ConsoleHost_history.txt`
+> (PowerShell on Windows) when closing a session.
+
+The final option to supply Composer with credentials is to use the `COMPOSER_AUTH` environment variable.
+These variables can be either passed as command line variables or set in actual environment variables.
+Read more about the usage of this environment variable [here](../03-cli.md#COMPOSER_AUTH).
+
+# Authentication methods
+
+## http-basic
+
+### Command line http-basic
+
+```sh
+composer config [--global] http-basic.example.org username password
+```
+
+### Manual http-basic
+
+```sh
+composer config [--global] --editor --auth
+```
+
+```json
+{
+    "http-basic": {
+        "example.org": {
+            "username": "username",
+            "password": "password"
+        }
+    }
+}
+```
+
+## Inline http-basic
+
+For the inline http-basic authentication method the credentials are not stored in a separate
+`auth.json` in the project or globally, but in the `composer.json` or global configuration
+in the same place where the Composer repository definition is defined.
+
+Make sure that the username and password are encoded according to [RFC 3986](http://www.faqs.org/rfcs/rfc3986.html) (2.1. Percent-Encoding).
+If the username e.g. is an email address it needs to be passed as `name%40example.com`.
+
+### Command line inline http-basic
+
+```sh
+composer config [--global] repositories composer.unique-name https://username:password@repo.example.org
+```
+
+### Manual inline http-basic
+
+```sh
+composer config [--global] --editor
+```
+
+```json
+{
+    "repositories": [
+        {
+            "type": "composer",
+            "url": "https://username:password@example.org"
+        }
+    ]
+}
+```
+
+## Custom token authentication
+
+### Manual custom token authentication
+
+```sh
+composer config [--global] --editor
+```
+
+```json
+{
+    "repositories": [
+        {
+            "type": "composer",
+            "url": "https://example.org",
+            "options":  {
+              "http": {
+                "header": [
+                  "API-TOKEN: YOUR-API-TOKEN"
+                ]
+              }
+            }
+        }
+    ]
+}
+```
+
+## gitlab-oauth
+
+> **Note:** For the gitlab authentication to work on private gitlab instances, the
+> [`gitlab-domains`](../06-config.md#gitlab-domains) section should also contain the url.
+
+### Command line gitlab-oauth
+
+```sh
+composer config [--global] gitlab-oauth.example.org token
+```
+
+### Manual gitlab-oauth
+
+```sh
+composer config [--global] --editor --auth
+```
+
+```json
+{
+    "gitlab-oauth": {
+        "example.org": "token"
+    }
+}
+```
+
+## gitlab-token
+
+> **Note:** For the gitlab authentication to work on private gitlab instances, the
+> [`gitlab-domains`](../06-config.md#gitlab-domains) section should also contain the url.
+
+When creating a gitlab token manually, make sure it has either the `read_api` or `api` scope.
+
+### Command line gitlab-token
+
+```sh
+composer config [--global] gitlab-token.example.org token
+```
+
+### Manual gitlab-token
+
+```sh
+composer config [--global] --editor --auth
+```
+
+```json
+{
+    "gitlab-token": {
+        "example.org": "token"
+    }
+}
+```
+
+## github-oauth
+
+To create a new access token, head to your [token settings section on Github](https://github.com/settings/tokens) and [generate a new token](https://github.com/settings/tokens/new). For public repositories when rate limited, the `public_repo` scope is required, for private repositories the `repo:status` scope is needed.
+Read more about it [here](https://github.com/blog/1509-personal-api-tokens).
+
+### Command line github-oauth
+
+```sh
+composer config [--global] github-oauth.github.com token
+```
+
+### Manual github-oauth
+
+```sh
+composer config [--global] --editor --auth
+```
+
+```json
+{
+    "github-oauth": {
+        "github.com": "token"
+    }
+}
+```
+
+## bitbucket-oauth
+
+The BitBucket driver uses OAuth to access your private repositories via the BitBucket REST APIs, and you will need to create an OAuth consumer to use the driver, please refer to [Atlassian's Documentation](https://support.atlassian.com/bitbucket-cloud/docs/use-oauth-on-bitbucket-cloud/). You will need to fill the callback url with something to satisfy BitBucket, but the address does not need to go anywhere and is not used by Composer.
+
+### Command line bitbucket-oauth
+
+```sh
+composer config [--global] bitbucket-oauth.bitbucket.org consumer-key consumer-secret
+```
+
+### Manual bitbucket-oauth
+
+```sh
+composer config [--global] --editor --auth
+```
+
+```json
+{
+    "bitbucket-oauth": {
+        "bitbucket.org": {
+             "consumer-key": "key",
+             "consumer-secret": "secret"
+        }
+    }
+}
+```
diff -pruN 1.10.19-1/doc/articles/autoloader-optimization.md 2.0.9-1/doc/articles/autoloader-optimization.md
--- 1.10.19-1/doc/articles/autoloader-optimization.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/articles/autoloader-optimization.md	2021-01-27 15:09:27.000000000 +0000
@@ -2,7 +2,7 @@
     tagline: How to reduce the performance impact of the autoloader
 -->
 
-# Autoloader Optimization
+# Autoloader optimization
 
 By default, the Composer autoloader runs relatively fast. However, due to the way
 PSR-4 and PSR-0 autoloading rules are set up, it needs to check the filesystem
@@ -48,7 +48,7 @@ There are no real trade-offs with this m
 production.
 
 The only issue is it does not keep track of autoload misses (i.e. when
-it can not find a given class), so those fallback to PSR-4 rules and can still
+it cannot find a given class), so those fallback to PSR-4 rules and can still
 result in slow filesystem checks. To solve this issue two Level 2 optimization
 options exist, and you can decide to enable either if you have a lot of
 class_exists checks that are done for classes that do not exist in your project.
@@ -78,7 +78,7 @@ also means that in case a class is gener
 not be allowed to be autoloaded. If your project or any of your dependencies does that
 then you might experience "class not found" issues in production. Enable this with care.
 
-> Note: This can not be combined with Level 2/B optimizations. You have to choose one as
+> Note: This cannot be combined with Level 2/B optimizations. You have to choose one as
 > they address the same issue in different ways.
 
 ## Optimization Level 2/B: APCu cache
@@ -97,15 +97,15 @@ This option adds an APCu cache as a fall
 automatically generate the class map though, so you should still enable Level 1
 optimizations manually if you so desire.
 
-Whether a class is found or not, that fact is always cached in APCu so it can be
+Whether a class is found or not, that fact is always cached in APCu, so it can be
 returned quickly on the next request.
 
 ### Trade-offs
 
 This option requires APCu which may or may not be available to you. It also
-uses APCu memory for autoloading purposes, but it is safe to use and can not
+uses APCu memory for autoloading purposes, but it is safe to use and cannot
 result in classes not being found like the authoritative class map
 optimization above.
 
-> Note: This can not be combined with Level 2/A optimizations. You have to choose one as
+> Note: This cannot be combined with Level 2/A optimizations. You have to choose one as
 > they address the same issue in different ways.
diff -pruN 1.10.19-1/doc/articles/custom-installers.md 2.0.9-1/doc/articles/custom-installers.md
--- 1.10.19-1/doc/articles/custom-installers.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/articles/custom-installers.md	2021-01-27 15:09:27.000000000 +0000
@@ -6,7 +6,7 @@
 
 ## Synopsis
 
-At times it may be necessary for a package to require additional actions during
+At times, it may be necessary for a package to require additional actions during
 installation, such as installing packages outside of the default `vendor`
 library.
 
@@ -149,6 +149,7 @@ source for the exact signature):
   when the package needs to be removed.
 * **getInstallPath()**, this method should return the location where the
   package is to be installed, _relative from the location of composer.json._
+  The path _must not end with a slash._
 
 Example:
 
diff -pruN 1.10.19-1/doc/articles/handling-private-packages.md 2.0.9-1/doc/articles/handling-private-packages.md
--- 1.10.19-1/doc/articles/handling-private-packages.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/doc/articles/handling-private-packages.md	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,340 @@
+<!--
+    tagline: Hosting and installing private Composer packages
+-->
+
+# Handling private packages
+
+# Private Packagist
+
+[Private Packagist](https://packagist.com) is a commercial package hosting product
+offering professional support and web based management of private and public packages,
+and granular access permissions. Private Packagist provides mirroring for packages' zip
+files which makes installs faster and independent from third party systems - e.g.
+you can deploy even if GitHub is down because your zip files are mirrored.
+
+Private Packagist is available as a hosted SaaS solution or as an on-premise self-hosted
+package, providing an interactive set up experience.
+
+Some of Private Packagist's revenue is used to pay for Composer and Packagist.org
+development and hosting so using it is a good way to support the maintenance of
+these open source projects financially. You can find more information about how to
+set up your own package archive on [Packagist.com](https://packagist.com).
+
+# Satis
+
+Satis on the other hand is open source but only a static `composer` repository
+generator. It is a bit like an ultra-lightweight, static file-based version of
+packagist and can be used to host the metadata of your company's private
+packages, or your own. You can get it from
+[GitHub](https://github.com/composer/satis) or install via CLI:
+
+    php composer.phar create-project composer/satis --stability=dev --keep-vcs
+
+## Setup
+
+For example let's assume you have a few packages you want to reuse across your
+company but don't really want to open-source. You would first define a Satis
+configuration: a json file with an arbitrary name that lists your curated
+[repositories](../05-repositories.md).
+
+Here is an example configuration, you see that it holds a few VCS repositories,
+but those could be any types of [repositories](../05-repositories.md). Then it
+uses `"require-all": true` which selects all versions of all packages in the
+repositories you defined.
+
+The default file Satis looks for is `satis.json` in the root of the repository.
+
+```json
+{
+  "name": "My Repository",
+  "homepage": "http://packages.example.org",
+  "repositories": [
+    { "type": "vcs", "url": "https://github.com/mycompany/privaterepo" },
+    { "type": "vcs", "url": "http://svn.example.org/private/repo" },
+    { "type": "vcs", "url": "https://github.com/mycompany/privaterepo2" }
+  ],
+  "require-all": true
+}
+```
+
+If you want to cherry pick which packages you want, you can list all the
+packages you want to have in your satis repository inside the classic composer
+`require` key, using a `"*"` constraint to make sure all versions are selected,
+or another constraint if you want really specific versions.
+
+```json
+{
+  "repositories": [
+    { "type": "vcs", "url": "https://github.com/mycompany/privaterepo" },
+    { "type": "vcs", "url": "http://svn.example.org/private/repo" },
+    { "type": "vcs", "url": "https://github.com/mycompany/privaterepo2" }
+  ],
+  "require": {
+    "company/package": "*",
+    "company/package2": "*",
+    "company/package3": "2.0.0"
+  }
+}
+```
+
+Once you've done this, you run:
+
+    php bin/satis build <configuration file> <build dir>
+
+When you ironed out that process, what you would typically do is run this
+command as a cron job on a server. It would then update all your package info
+much like Packagist does.
+
+Note that if your private packages are hosted on GitHub, your server should
+have an ssh key that gives it access to those packages, and then you should add
+the `--no-interaction` (or `-n`) flag to the command to make sure it falls back
+to ssh key authentication instead of prompting for a password. This is also a
+good trick for continuous integration servers.
+
+Set up a virtual-host that points to that `web/` directory, let's say it is
+`packages.example.org`. Alternatively, with PHP >= 5.4.0, you can use the
+built-in CLI server `php -S localhost:port -t satis-output-dir/` for a
+temporary solution.
+
+### Partial Updates
+
+You can tell Satis to selectively update only particular packages or process
+only a repository with a given URL. This cuts down the time it takes to rebuild
+the `package.json` file and is helpful if you use (custom) webhooks to trigger
+rebuilds whenever code is pushed into one of your repositories.
+
+To rebuild only particular packages, pass the package names on the command line
+like so:
+
+    php bin/satis build satis.json web/ this/package that/other-package
+
+Note that this will still need to pull and scan all of your VCS repositories
+because any VCS repository might contain (on any branch) one of the selected
+packages.
+
+If you want to scan only the selected package and not all VCS repositories you need
+to declare a *name* for all your package (this only work on VCS repositories type) :
+
+```json
+{
+  "repositories": [
+    { "name": "company/privaterepo", "type": "vcs", "url": "https://github.com/mycompany/privaterepo" },
+    { "name": "private/repo", "type": "vcs", "url": "http://svn.example.org/private/repo" },
+    { "name": "mycompany/privaterepo2", "type": "vcs", "url": "https://github.com/mycompany/privaterepo2" }
+  ]
+}
+```
+
+If you want to scan only a single repository and update all packages found in
+it, pass the VCS repository URL as an optional argument:
+
+    php bin/satis build --repository-url https://only.my/repo.git satis.json web/
+
+## Usage
+
+In your projects all you need to add now is your own composer repository using
+the `packages.example.org` as URL, then you can require your private packages
+and everything should work smoothly. You don't need to copy all your
+repositories in every project anymore. Only that one unique repository that
+will update itself.
+
+```json
+{
+  "repositories": [ { "type": "composer", "url": "http://packages.example.org/" } ],
+  "require": {
+    "company/package": "1.2.0",
+    "company/package2": "1.5.2",
+    "company/package3": "dev-master"
+  }
+}
+```
+
+### Security
+
+To secure your private repository you can host it over SSH or SSL using a client
+certificate. In your project you can use the `options` parameter to specify the
+connection options for the server.
+
+Example using a custom repository using SSH (requires the SSH2 PECL extension):
+
+```json
+{
+  "repositories": [{
+    "type": "composer",
+    "url": "ssh2.sftp://example.org",
+    "options": {
+      "ssh2": {
+        "username": "composer",
+        "pubkey_file": "/home/composer/.ssh/id_rsa.pub",
+        "privkey_file": "/home/composer/.ssh/id_rsa"
+      }
+    }
+  }]
+}
+```
+
+> **Tip:** See [ssh2 context options] for more information.
+
+Example using SSL/TLS (HTTPS) using a client certificate:
+
+```json
+{
+  "repositories": [{
+     "type": "composer",
+     "url": "https://example.org",
+     "options": {
+       "ssl": {
+         "local_cert": "/home/composer/.ssl/composer.pem"
+       }
+     }
+  }]
+}
+```
+
+> **Tip:** See [ssl context options] for more information.
+
+Example using a custom HTTP Header field for token authentication:
+
+```json
+{
+  "repositories": [{
+    "type": "composer",
+    "url": "https://example.org",
+    "options":  {
+      "http": {
+        "header": [
+          "API-TOKEN: YOUR-API-TOKEN"
+        ]
+      }
+    }
+  }]
+}
+```
+
+### Authentication
+
+Authentication can be handled in [several different ways](authentication-for-private-packages.md).
+
+### Downloads
+
+When GitHub, GitLab or BitBucket repositories are mirrored on your local satis, the
+build process will include the location of the downloads these platforms make
+available. This means that the repository and your setup depend on the
+availability of these services.
+
+At the same time, this implies that all code which is hosted somewhere else (on
+another service or for example in Subversion) will not have downloads available
+and thus installations usually take a lot longer.
+
+To enable your satis installation to create downloads for all (Git, Mercurial
+and Subversion) your packages, add the following to your `satis.json`:
+
+``` json
+{
+  "archive": {
+    "directory": "dist",
+    "format": "tar",
+    "prefix-url": "https://amazing.cdn.example.org",
+    "skip-dev": true
+  }
+}
+```
+
+#### Options explained
+
+ * `directory`: required, the location of the dist files (inside the
+   `output-dir`)
+ * `format`: optional, `zip` (default) or `tar`
+ * `prefix-url`: optional, location of the downloads, homepage (from
+   `satis.json`) followed by `directory` by default
+ * `skip-dev`: optional, `false` by default, when enabled (`true`) satis will
+   not create downloads for branches
+ * `absolute-directory`: optional, a _local_ directory where the dist files are
+   dumped instead of `output-dir`/`directory`
+ * `whitelist`: optional, if set as a list of package names, satis will only
+   dump the dist files of these packages
+ * `blacklist`: optional, if set as a list of package names, satis will not
+   dump the dist files of these packages
+ * `checksum`: optional, `true` by default, when disabled (`false`) satis will
+   not provide the sha1 checksum for the dist files
+
+Once enabled, all downloads (include those from GitHub and BitBucket) will be
+replaced with a _local_ version.
+
+#### prefix-url
+
+Prefixing the URL with another host is especially helpful if the downloads end
+up in a private Amazon S3 bucket or on a CDN host. A CDN would drastically
+improve download times and therefore package installation.
+
+Example: A `prefix-url` of `https://my-bucket.s3.amazonaws.com` (and
+`directory` set to `dist`) creates download URLs which look like the following:
+`https://my-bucket.s3.amazonaws.com/dist/vendor-package-version-ref.zip`.
+
+### Web outputs
+
+ * `output-html`: optional, `true` by default, when disabled (`false`) satis
+   will not generate the `output-dir`/index.html page.
+ * `twig-template`: optional, a path to a personalized [Twig] template for
+   the `output-dir`/index.html page.
+
+### Abandoned packages
+
+To enable your satis installation to indicate that some packages are abandoned,
+add the following to your `satis.json`:
+
+```json
+{
+  "abandoned": {
+    "company/package": true,
+    "company/package2": "company/newpackage"
+  }
+}
+```
+
+The `true` value indicates that the package is truly abandoned while the
+`"company/newpackage"` value specifies that the package is replaced by the
+`company/newpackage` package.
+
+Note that all packages set as abandoned in their own `composer.json` file will
+be marked abandoned as well.
+
+### Resolving dependencies
+
+It is possible to make satis automatically resolve and add all dependencies for
+your projects. This can be used with the Downloads functionality to have a
+complete local mirror of packages. Add the following to your `satis.json`:
+
+```json
+{
+  "require-dependencies": true,
+  "require-dev-dependencies": true
+}
+```
+
+When searching for packages, satis will attempt to resolve all the required
+packages from the listed repositories.  Therefore, if you are requiring a
+package from Packagist, you will need to define it in your `satis.json`.
+
+Dev dependencies are packaged only if the `require-dev-dependencies` parameter
+is set to true.
+
+### Other options
+
+ * `providers`: optional, `false` by default, when enabled (`true`) each
+   package will be dumped into a separate include file which will be only
+   loaded by composer when the package is really required. Speeds up composer
+   handling for repositories with huge number of packages like f.i. packagist.
+ * `output-dir`: optional, defines where to output the repository files if not
+   provided as an argument when calling the `build` command.
+ * `config`: optional, lets you define all config options from composer, except
+   `archive-format` and `archive-dir` as the configuration is done through
+   [archive](#downloads) instead. See docs on [config schema] for more details.
+ * `notify-batch`: optional, specify a URL that will be called every time a
+   user installs a package. See [notify-batch].
+
+[ssh2 context options]: https://secure.php.net/manual/en/wrappers.ssh2.php#refsect1-wrappers.ssh2-options
+[ssl context options]: https://secure.php.net/manual/en/context.ssl.php
+[Twig]: https://twig.sensiolabs.org/
+[config schema]: https://getcomposer.org/doc/04-schema.md#config
+[notify-batch]: https://getcomposer.org/doc/05-repositories.md#notify-batch
diff -pruN 1.10.19-1/doc/articles/handling-private-packages-with-satis.md 2.0.9-1/doc/articles/handling-private-packages-with-satis.md
--- 1.10.19-1/doc/articles/handling-private-packages-with-satis.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/articles/handling-private-packages-with-satis.md	1970-01-01 00:00:00.000000000 +0000
@@ -1,356 +0,0 @@
-<!--
-    tagline: Hosting and installing private Composer packages
--->
-
-# Handling private packages
-
-# Private Packagist
-
-[Private Packagist](https://packagist.com) is a commercial package hosting product
-offering professional support and web based management of private and public packages,
-and granular access permissions. Private Packagist provides mirroring for packages' zip
-files which makes installs faster and independent from third party systems - e.g.
-you can deploy even if GitHub is down because your zip files are mirrored.
-
-Private Packagist is available as a hosted SaaS solution or as an on-premise self-hosted
-package, providing an interactive set up experience.
-
-Some of Private Packagist's revenue is used to pay for Composer and Packagist.org
-development and hosting so using it is a good way to support the maintenance of
-these open source projects financially. You can find more information about how to
-set up your own package archive on [Packagist.com](https://packagist.com).
-
-# Satis
-
-Satis on the other hand is open source but only a static `composer` repository
-generator. It is a bit like an ultra-lightweight, static file-based version of
-packagist and can be used to host the metadata of your company's private
-packages, or your own. You can get it from
-[GitHub](https://github.com/composer/satis) or install via CLI:
-
-    php composer.phar create-project composer/satis --stability=dev --keep-vcs
-
-## Setup
-
-For example let's assume you have a few packages you want to reuse across your
-company but don't really want to open-source. You would first define a Satis
-configuration: a json file with an arbitrary name that lists your curated
-[repositories](../05-repositories.md).
-
-Here is an example configuration, you see that it holds a few VCS repositories,
-but those could be any types of [repositories](../05-repositories.md). Then it
-uses `"require-all": true` which selects all versions of all packages in the
-repositories you defined.
-
-The default file Satis looks for is `satis.json` in the root of the repository.
-
-```json
-{
-  "name": "My Repository",
-  "homepage": "http://packages.example.org",
-  "repositories": [
-    { "type": "vcs", "url": "https://github.com/mycompany/privaterepo" },
-    { "type": "vcs", "url": "http://svn.example.org/private/repo" },
-    { "type": "vcs", "url": "https://github.com/mycompany/privaterepo2" }
-  ],
-  "require-all": true
-}
-```
-
-If you want to cherry pick which packages you want, you can list all the
-packages you want to have in your satis repository inside the classic composer
-`require` key, using a `"*"` constraint to make sure all versions are selected,
-or another constraint if you want really specific versions.
-
-```json
-{
-  "repositories": [
-    { "type": "vcs", "url": "https://github.com/mycompany/privaterepo" },
-    { "type": "vcs", "url": "http://svn.example.org/private/repo" },
-    { "type": "vcs", "url": "https://github.com/mycompany/privaterepo2" }
-  ],
-  "require": {
-    "company/package": "*",
-    "company/package2": "*",
-    "company/package3": "2.0.0"
-  }
-}
-```
-
-Once you've done this, you run:
-
-    php bin/satis build <configuration file> <build dir>
-
-When you ironed out that process, what you would typically do is run this
-command as a cron job on a server. It would then update all your package info
-much like Packagist does.
-
-Note that if your private packages are hosted on GitHub, your server should
-have an ssh key that gives it access to those packages, and then you should add
-the `--no-interaction` (or `-n`) flag to the command to make sure it falls back
-to ssh key authentication instead of prompting for a password. This is also a
-good trick for continuous integration servers.
-
-Set up a virtual-host that points to that `web/` directory, let's say it is
-`packages.example.org`. Alternatively, with PHP >= 5.4.0, you can use the
-built-in CLI server `php -S localhost:port -t satis-output-dir/` for a
-temporary solution.
-
-### Partial Updates
-
-You can tell Satis to selectively update only particular packages or process
-only a repository with a given URL. This cuts down the time it takes to rebuild
-the `package.json` file and is helpful if you use (custom) webhooks to trigger
-rebuilds whenever code is pushed into one of your repositories.
-
-To rebuild only particular packages, pass the package names on the command line
-like so:
-
-    php bin/satis build satis.json web/ this/package that/other-package
-
-Note that this will still need to pull and scan all of your VCS repositories
-because any VCS repository might contain (on any branch) one of the selected
-packages.
-
-If you want to scan only the selected package and not all VCS repositories you need
-to declare a *name* for all your package (this only work on VCS repositories type) :
-
-```json
-{
-  "repositories": [
-    { "name": "company/privaterepo", "type": "vcs", "url": "https://github.com/mycompany/privaterepo" },
-    { "name": "private/repo", "type": "vcs", "url": "http://svn.example.org/private/repo" },
-    { "name": "mycompany/privaterepo2", "type": "vcs", "url": "https://github.com/mycompany/privaterepo2" }
-  ]
-}
-```
-
-If you want to scan only a single repository and update all packages found in
-it, pass the VCS repository URL as an optional argument:
-
-    php bin/satis build --repository-url https://only.my/repo.git satis.json web/
-
-## Usage
-
-In your projects all you need to add now is your own composer repository using
-the `packages.example.org` as URL, then you can require your private packages
-and everything should work smoothly. You don't need to copy all your
-repositories in every project anymore. Only that one unique repository that
-will update itself.
-
-```json
-{
-  "repositories": [ { "type": "composer", "url": "http://packages.example.org/" } ],
-  "require": {
-    "company/package": "1.2.0",
-    "company/package2": "1.5.2",
-    "company/package3": "dev-master"
-  }
-}
-```
-
-### Security
-
-To secure your private repository you can host it over SSH or SSL using a client
-certificate. In your project you can use the `options` parameter to specify the
-connection options for the server.
-
-Example using a custom repository using SSH (requires the SSH2 PECL extension):
-
-```json
-{
-  "repositories": [{
-    "type": "composer",
-    "url": "ssh2.sftp://example.org",
-    "options": {
-      "ssh2": {
-        "username": "composer",
-        "pubkey_file": "/home/composer/.ssh/id_rsa.pub",
-        "privkey_file": "/home/composer/.ssh/id_rsa"
-      }
-    }
-  }]
-}
-```
-
-> **Tip:** See [ssh2 context options] for more information.
-
-Example using SSL/TLS (HTTPS) using a client certificate:
-
-```json
-{
-  "repositories": [{
-     "type": "composer",
-     "url": "https://example.org",
-     "options": {
-       "ssl": {
-         "local_cert": "/home/composer/.ssl/composer.pem"
-       }
-     }
-  }]
-}
-```
-
-> **Tip:** See [ssl context options] for more information.
-
-Example using a custom HTTP Header field for token authentication:
-
-```json
-{
-  "repositories": [{
-    "type": "composer",
-    "url": "https://example.org",
-    "options":  {
-      "http": {
-        "header": [
-          "API-TOKEN: YOUR-API-TOKEN"
-        ]
-      }
-    }
-  }]
-}
-```
-
-### Authentication
-
-When your private repositories are password protected, you can store the
-authentication details permanently.  The first time Composer needs to
-authenticate against some domain it will prompt you for a username/password and
-then you will be asked whether you want to store it.
-
-The storage can be done either globally in the `COMPOSER_HOME/auth.json` file
-(`COMPOSER_HOME` defaults to `~/.composer` or `%APPDATA%/Composer` on Windows)
-or also in the project directory directly sitting besides your composer.json.
-
-You can also configure these by hand using the config command if you need to
-configure a production machine to be able to run non-interactive installs. For
-example to enter credentials for example.org one could type:
-
-    composer config http-basic.example.org username password
-
-That will store it in the current directory's auth.json, but if you want it
-available globally you can use the `--global` (`-g`) flag.
-
-### Downloads
-
-When GitHub, GitLab or BitBucket repositories are mirrored on your local satis, the
-build process will include the location of the downloads these platforms make
-available. This means that the repository and your setup depend on the
-availability of these services.
-
-At the same time, this implies that all code which is hosted somewhere else (on
-another service or for example in Subversion) will not have downloads available
-and thus installations usually take a lot longer.
-
-To enable your satis installation to create downloads for all (Git, Mercurial
-and Subversion) your packages, add the following to your `satis.json`:
-
-``` json
-{
-  "archive": {
-    "directory": "dist",
-    "format": "tar",
-    "prefix-url": "https://amazing.cdn.example.org",
-    "skip-dev": true
-  }
-}
-```
-
-#### Options explained
-
- * `directory`: required, the location of the dist files (inside the
-   `output-dir`)
- * `format`: optional, `zip` (default) or `tar`
- * `prefix-url`: optional, location of the downloads, homepage (from
-   `satis.json`) followed by `directory` by default
- * `skip-dev`: optional, `false` by default, when enabled (`true`) satis will
-   not create downloads for branches
- * `absolute-directory`: optional, a _local_ directory where the dist files are
-   dumped instead of `output-dir`/`directory`
- * `whitelist`: optional, if set as a list of package names, satis will only
-   dump the dist files of these packages
- * `blacklist`: optional, if set as a list of package names, satis will not
-   dump the dist files of these packages
- * `checksum`: optional, `true` by default, when disabled (`false`) satis will
-   not provide the sha1 checksum for the dist files
-
-Once enabled, all downloads (include those from GitHub and BitBucket) will be
-replaced with a _local_ version.
-
-#### prefix-url
-
-Prefixing the URL with another host is especially helpful if the downloads end
-up in a private Amazon S3 bucket or on a CDN host. A CDN would drastically
-improve download times and therefore package installation.
-
-Example: A `prefix-url` of `https://my-bucket.s3.amazonaws.com` (and
-`directory` set to `dist`) creates download URLs which look like the following:
-`https://my-bucket.s3.amazonaws.com/dist/vendor-package-version-ref.zip`.
-
-### Web outputs
-
- * `output-html`: optional, `true` by default, when disabled (`false`) satis
-   will not generate the `output-dir`/index.html page.
- * `twig-template`: optional, a path to a personalized [Twig] template for
-   the `output-dir`/index.html page.
-
-### Abandoned packages
-
-To enable your satis installation to indicate that some packages are abandoned,
-add the following to your `satis.json`:
-
-```json
-{
-  "abandoned": {
-    "company/package": true,
-    "company/package2": "company/newpackage"
-  }
-}
-```
-
-The `true` value indicates that the package is truly abandoned while the
-`"company/newpackage"` value specifies that the package is replaced by the
-`company/newpackage` package.
-
-Note that all packages set as abandoned in their own `composer.json` file will
-be marked abandoned as well.
-
-### Resolving dependencies
-
-It is possible to make satis automatically resolve and add all dependencies for
-your projects. This can be used with the Downloads functionality to have a
-complete local mirror of packages. Add the following to your `satis.json`:
-
-```json
-{
-  "require-dependencies": true,
-  "require-dev-dependencies": true
-}
-```
-
-When searching for packages, satis will attempt to resolve all the required
-packages from the listed repositories.  Therefore, if you are requiring a
-package from Packagist, you will need to define it in your `satis.json`.
-
-Dev dependencies are packaged only if the `require-dev-dependencies` parameter
-is set to true.
-
-### Other options
-
- * `providers`: optional, `false` by default, when enabled (`true`) each
-   package will be dumped into a separate include file which will be only
-   loaded by composer when the package is really required. Speeds up composer
-   handling for repositories with huge number of packages like f.i. packagist.
- * `output-dir`: optional, defines where to output the repository files if not
-   provided as an argument when calling the `build` command.
- * `config`: optional, lets you define all config options from composer, except
-   `archive-format` and `archive-dir` as the configuration is done through
-   [archive](#downloads) instead. See docs on [config schema] for more details.
- * `notify-batch`: optional, specify a URL that will be called every time a
-   user installs a package. See [notify-batch].
-
-[ssh2 context options]: https://secure.php.net/manual/en/wrappers.ssh2.php#refsect1-wrappers.ssh2-options
-[ssl context options]: https://secure.php.net/manual/en/context.ssl.php
-[Twig]: https://twig.sensiolabs.org/
-[config schema]: https://getcomposer.org/doc/04-schema.md#config
-[notify-batch]: https://getcomposer.org/doc/05-repositories.md#notify-batch
diff -pruN 1.10.19-1/doc/articles/http-basic-authentication.md 2.0.9-1/doc/articles/http-basic-authentication.md
--- 1.10.19-1/doc/articles/http-basic-authentication.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/articles/http-basic-authentication.md	1970-01-01 00:00:00.000000000 +0000
@@ -1,59 +0,0 @@
-<!--
-    tagline: Access privately hosted packages
--->
-
-# HTTP basic authentication
-
-Your [Satis or Private Packagist](handling-private-packages-with-satis.md) server
-could be secured with http basic authentication. In order to allow your project
-to have access to these packages you will have to tell composer how to
-authenticate with your credentials.
-
-The simplest way to provide your credentials is providing your set
-of credentials inline with the repository specification such as:
-
-```json
-{
-    "repositories": [
-        {
-            "type": "composer",
-            "url": "https://extremely:secret@repo.example.org"
-        }
-    ]
-}
-```
-
-This will basically teach composer how to authenticate automatically
-when reading packages from the provided composer repository.
-
-This does not work for everybody especially when you don't want to
-hard code your credentials into your composer.json. There is a second
-way to provide these details and it is via interaction. If you don't
-provide the authentication credentials composer will prompt you upon
-connection to enter the username and password.
-
-The third way if you want to pre-configure it is via an `auth.json` file
-located in your `COMPOSER_HOME` or besides your `composer.json`.
-
-The file should contain a set of hostnames followed each with their own
-username/password pairs, for example:
-
-```json
-{
-    "http-basic": {
-        "repo.example1.org": {
-            "username": "my-username1",
-            "password": "my-secret-password1"
-        },
-        "repo.example2.org": {
-            "username": "my-username2",
-            "password": "my-secret-password2"
-        }
-    }
-}
-```
-
-The main advantage of the auth.json file is that it can be gitignored so
-that every developer in your team can place their own credentials in there,
-which makes revocation of credentials much easier than if you all share the
-same.
diff -pruN 1.10.19-1/doc/articles/plugins.md 2.0.9-1/doc/articles/plugins.md
--- 1.10.19-1/doc/articles/plugins.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/articles/plugins.md	2021-01-27 15:09:27.000000000 +0000
@@ -9,7 +9,7 @@
 You may wish to alter or expand Composer's functionality with your own. For
 example if your environment poses special requirements on the behaviour of
 Composer which do not apply to the majority of its users or if you wish to
-accomplish something with composer in a way that is not desired by most users.
+accomplish something with Composer in a way that is not desired by most users.
 
 In these cases you could consider creating a plugin to handle your
 specific logic.
@@ -30,21 +30,29 @@ requirements:
    multiple plugins, this can be array of class names.
 3. You must require the special package called `composer-plugin-api`
    to define which Plugin API versions your plugin is compatible with.
+   Requiring this package doesn't actually include any extra dependencies,
+   it only specifies which version of the plugin API to use.
+
+> **Note:** When developing a plugin, although not required, it's useful to add
+> a require-dev dependency on `composer/composer` to have IDE auto completion on Composer classes.
 
 The required version of the `composer-plugin-api` follows the same [rules][7]
 as a normal package's.
 
-The current composer plugin API version is 1.1.0.
+The current Composer plugin API version is `2.0.0`.
 
 An example of a valid plugin `composer.json` file (with the autoloading
-part omitted):
+part omitted and an optional require-dev dependency on `composer/composer` for IDE auto completion):
 
 ```json
 {
     "name": "my/plugin-package",
     "type": "composer-plugin",
     "require": {
-        "composer-plugin-api": "^1.1"
+        "composer-plugin-api": "^2.0"
+    },
+    "require-dev": {
+        "composer/composer": "^2.0"
     },
     "extra": {
         "class": "My\\Plugin"
@@ -94,6 +102,10 @@ and have it return an array. The array k
 [event name](https://getcomposer.org/doc/articles/scripts.md#event-names)
 and the value is the name of the method in this class to be called.
 
+> **Note:** If you don't know which event to listen to, you can run a Composer
+> command with the COMPOSER_DEBUG_EVENTS=1 environment variable set, which might
+> help you identify what event you are looking for.
+
 ```php
 public static function getSubscribedEvents()
 {
@@ -161,6 +173,14 @@ class AwsPlugin implements PluginInterfa
         $this->io = $io;
     }
 
+    public function deactivate(Composer $composer, IOInterface $io)
+    {
+    }
+
+    public function uninstall(Composer $composer, IOInterface $io)
+    {
+    }
+
     public static function getSubscribedEvents()
     {
         return array(
@@ -175,9 +195,7 @@ class AwsPlugin implements PluginInterfa
         $protocol = parse_url($event->getProcessedUrl(), PHP_URL_SCHEME);
 
         if ($protocol === 's3') {
-            $awsClient = new AwsClient($this->io, $this->composer->getConfig());
-            $s3RemoteFilesystem = new S3RemoteFilesystem($this->io, $event->getRemoteFilesystem()->getOptions(), $awsClient);
-            $event->setRemoteFilesystem($s3RemoteFilesystem);
+            // ...
         }
     }
 }
@@ -223,7 +241,7 @@ class Plugin implements PluginInterface,
 ### Command provider
 
 The [`Composer\Plugin\Capability\CommandProvider`][9] capability allows to register
-additional commands for Composer :
+additional commands for Composer:
 
 ```php
 <?php
@@ -263,21 +281,48 @@ Now the `custom-plugin-command` is avail
 
 ## Running plugins manually
 
-Plugins for an event can be run manually by the `run-script` command. This works the same way as 
+Plugins for an event can be run manually by the `run-script` command. This works the same way as
 [running scripts manually](scripts.md#running-scripts-manually).
 
 ## Using Plugins
 
 Plugin packages are automatically loaded as soon as they are installed and will
-be loaded when composer starts up if they are found in the current project's
+be loaded when Composer starts up if they are found in the current project's
 list of installed packages. Additionally all plugin packages installed in the
-`COMPOSER_HOME` directory using the composer global command are loaded before
+`COMPOSER_HOME` directory using the Composer global command are loaded before
 local project plugins are loaded.
 
-> You may pass the `--no-plugins` option to composer commands to disable all
+> You may pass the `--no-plugins` option to Composer commands to disable all
 > installed plugins. This may be particularly helpful if any of the plugins
 > causes errors and you wish to update or uninstall it.
 
+## Plugin Helpers
+
+As of Composer 2, due to the fact that DownloaderInterface can sometimes return Promises
+and have been split up in more steps than they used to, we provide a [SyncHelper][11]
+to make downloading and installing packages easier.
+
+## Plugin Extra Attributes
+
+A few special plugin capabilities can be unlocked using extra attributes in the plugin's composer.json.
+
+### class
+
+[See above](#plugin-package) for an explanation of the class attribute and how it works.
+
+### plugin-modifies-downloads
+
+Some special plugins need to update package download URLs before they get downloaded.
+
+As of Composer 2.0, all packages are downloaded before they get installed. This means
+on the first installation, your plugin is not yet installed when the download occurs,
+and it does not get a chance to update the URLs on time.
+
+Specifying `{"extra": {"plugin-modifies-downloads": true}}` in your composer.json will
+hint to Composer that the plugin should be installed on its own before proceeding with
+the rest of the package downloads. This slightly slows down the overall installation
+process however, so do not use it in plugins which do not absolutely require it.
+
 [1]: ../04-schema.md#type
 [2]: ../04-schema.md#extra
 [3]: https://github.com/composer/composer/blob/master/src/Composer/Plugin/PluginInterface.php
@@ -288,3 +333,4 @@ local project plugins are loaded.
 [8]: https://github.com/composer/composer/blob/master/src/Composer/Plugin/Capable.php
 [9]: https://github.com/composer/composer/blob/master/src/Composer/Plugin/Capability/CommandProvider.php
 [10]: https://symfony.com/doc/current/components/console.html
+[11]: https://github.com/composer/composer/blob/master/src/Composer/Util/SyncHelper.php
diff -pruN 1.10.19-1/doc/articles/repository-priorities.md 2.0.9-1/doc/articles/repository-priorities.md
--- 1.10.19-1/doc/articles/repository-priorities.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/doc/articles/repository-priorities.md	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,95 @@
+<!--
+    tagline: Configure which packages are found in which repositories
+-->
+
+# Repository priorities
+
+## Canonical repositories
+
+When Composer resolves dependencies, it will look up a given package in the
+topmost repository. If that repository does not contain the package, it
+goes on to the next one, until one repository contains it and the process ends.
+
+Canonical repositories are better for a few reasons:
+
+- Performance wise, it is more efficient to stop looking for a package once it
+has been found somewhere. It also avoids loading duplicate packages in case
+the same package is present in several of your repositories.
+- Security wise, it is safer to treat them canonically as it means that packages you
+expect to come from your most important repositories will never be loaded from 
+another repository instead. Let's
+say you have a private repository which is not canonical, and you require your
+private package `foo/bar ^2.0` for example. Now if someone publishes
+`foo/bar 2.999` to packagist.org, suddenly Composer will pick that package as it
+has a higher version than your latest release (say 2.4.3), and you end up installing
+something you may not have meant to. If the private repository is canonical
+however, that 2.999 version from packagist.org will not be considered at all.
+
+There are however a few cases where you may want to specifically load some packages
+from a given repository, but not all. Or you may want a given repository to not be
+canonical, and to be only preferred if it has higher package versions than the
+repositories defined below.
+
+## Default behavior
+
+By default in Composer 2.x all repositories are canonical. Composer 1.x treated
+all repositories as non-canonical.
+
+Another default is that the packagist.org repository is always added implicitly
+as the last repository, unless you [disable it](../05-repositories.md#disabling-packagist-org).
+
+## Making repositories non-canonical
+
+You can add the canonical option to any repository to disable this default behavior
+and make sure Composer keeps looking in other repositories, even if that repository
+contains a given package.
+
+```json
+{
+    "repositories": [
+        {
+            "type": "composer",
+            "url": "https://example.org",
+            "canonical": false
+        }
+    ]
+}
+```
+
+## Filtering packages
+
+You can also filter packages which a repository will be able to load, either by
+selecting which ones you want, or by excluding those you do not want.
+
+For example here we want to pick only the package `foo/bar` and all the packages from
+`some-vendor/` from this composer repository.
+
+```json
+{
+    "repositories": [
+        {
+            "type": "composer",
+            "url": "https://example.org",
+            "only": ["foo/bar", "some-vendor/*"]
+        }
+    ]
+}
+```
+
+And in this other example we exclude `toy/package` from a repository, which
+we may not want to load in this project.
+
+```json
+{
+    "repositories": [
+        {
+            "type": "composer",
+            "url": "https://example.org",
+            "exclude": ["toy/package"]
+        }
+    ]
+}
+```
+
+Both `only` and `exclude` should be arrays of package names, which can also
+contain wildcards (`*`) which will match any characters.
diff -pruN 1.10.19-1/doc/articles/resolving-merge-conflicts.md 2.0.9-1/doc/articles/resolving-merge-conflicts.md
--- 1.10.19-1/doc/articles/resolving-merge-conflicts.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/doc/articles/resolving-merge-conflicts.md	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,62 @@
+<!--
+    tagline: On gracefully resolving conflicts while merging
+-->
+
+# Resolving merge conflicts
+
+When working as a team on the same Composer project, you will eventually run into a scenario
+where multiple people added, updated or removed something in the `composer.json` and
+`composer.lock` files in multiple branches. When those branches are eventually merged
+together, you will get merge conflicts. Resolving these merge conflicts is not as straight
+forward as on other files, especially not regarding the `composer.lock` file.
+
+> **Note:** It might not immediately be obvious why text based merging is not possible for
+> lock files, so let's imagine the following example where we want to merge two branches;
+>
+> - Branch 1 has added package A which requires package B. Package B is locked at version `1.0.0`.
+> - Branch 2 has added package C which conflicts with all versions below `1.2.0` of package B.
+>
+> A text based merge would result in package A version `1.0.0`, package B version `1.0.0`
+> and package C version `1.0.0`. This is an invalid result, as the conflict of package C
+> was not considered and would require an upgrade of package B.
+
+## 1. Reapplying changes
+
+The safest method to merge Composer files is to accept the version from one branch and apply
+the changes from the other branch.
+
+An example where we have two branches:
+
+1. Package 'A' has been added
+2. Package 'B' has been removed and package 'C' is added.
+
+To resolve the conflict when we merge these two branches:
+
+- We choose the branch that has the most changes, and accept the `composer.json` and `composer.lock`
+  files from that branch. In this case, we choose the composer files from branch 2.
+- We reapply the changes from the other branch (branch 1). In this case we have to run
+  ```composer require package/A``` again.
+
+## 2. Validating your merged files
+
+Before committing, make sure the resulting `composer.json` and `composer.lock` files are valid.
+To do this, run the following commands:
+
+```sh
+composer validate
+composer install [--dry-run]
+```
+
+## Important considerations
+
+Keep in mind that whenever merge conflicts occur on the lock file, the information about the exact version
+new packages were locked on for one of the branches gets lost. When package A in branch 1 is constrained
+as `^1.2.0` and locked as `1.2.0`, it might get updated when branch 2 is used as baseline and a new
+`composer require package/A:^1.2.0` is executed, as that will use the most recent version that the
+constraint allows when possible. There might be a version 1.3.0 for that package available by now, which
+will now be used instead.
+
+Choosing the correct [version constraints](../articles/versions.md) and making sure the packages adhere
+to [semantic versioning](https://semver.org/) when using
+[next significant release operators](versions.md#next-significant-release-operators) should make sure
+that merging branches does not break anything by accidentally updating a dependency.
diff -pruN 1.10.19-1/doc/articles/scripts.md 2.0.9-1/doc/articles/scripts.md
--- 1.10.19-1/doc/articles/scripts.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/articles/scripts.md	2021-01-27 15:09:27.000000000 +0000
@@ -29,6 +29,7 @@ Composer fires the following named event
   the `install` command is executed without a lock file present.
 - **post-update-cmd**: occurs after the `update` command has been executed, or
   after the `install` command has been executed without a lock file present.
+- **pre-status-cmd**: occurs before the `status` command is executed.
 - **post-status-cmd**: occurs after the `status` command has been executed.
 - **pre-archive-cmd**: occurs before the `archive` command is executed.
 - **post-archive-cmd**: occurs after the `archive` command has been executed.
@@ -37,14 +38,15 @@ Composer fires the following named event
 - **post-autoload-dump**: occurs after the autoloader has been dumped, either
   during `install`/`update`, or via the `dump-autoload` command.
 - **post-root-package-install**: occurs after the root package has been
-  installed, during the `create-project` command.
+  installed during the `create-project` command (but before its
+  dependencies are installed).
 - **post-create-project-cmd**: occurs after the `create-project` command has
   been executed.
 
 ### Installer Events
 
-- **pre-dependencies-solving**: occurs before the dependencies are resolved.
-- **post-dependencies-solving**: occurs after the dependencies have been resolved.
+- **pre-operations-exec**: occurs before the install/upgrade/.. operations
+  are executed when installing a lock file.
 
 ### Package Events
 
@@ -61,11 +63,15 @@ Composer fires the following named event
 - **command**: occurs before any Composer Command is executed on the CLI. It
   provides you with access to the input and output objects of the program.
 - **pre-file-download**: occurs before files are downloaded and allows
-  you to manipulate the `RemoteFilesystem` object prior to downloading files
+  you to manipulate the `HttpDownloader` object prior to downloading files
   based on the URL to be downloaded.
+- **post-file-download**: occurs after package dist files are downloaded and
+  allows you to perform additional checks on the file if required.
 - **pre-command-run**: occurs before a command is executed and allows you to
   manipulate the `InputInterface` object's options and arguments to tweak
   a command's behavior.
+- **pre-pool-create**: occurs before the Pool of packages is created, and lets
+  you filter the list of packages which is going to enter the Solver.
 
 > **Note:** Composer makes no assumptions about the state of your dependencies
 > prior to `install` or `update`. Therefore, you should not specify scripts
@@ -179,6 +185,7 @@ objects:
   - init: [`Composer\EventDispatcher\Event`](https://getcomposer.org/apidoc/master/Composer/EventDispatcher/Event.html)
   - command: [`Composer\Plugin\CommandEvent`](https://getcomposer.org/apidoc/master/Composer/Plugin/CommandEvent.html)
   - pre-file-download: [`Composer\Plugin\PreFileDownloadEvent`](https://getcomposer.org/apidoc/master/Composer/Plugin/PreFileDownloadEvent.html)
+  - post-file-download: [`Composer\Plugin\PostFileDownloadEvent`](https://getcomposer.org/apidoc/master/Composer/Plugin/PostFileDownloadEvent.html)
 
 ## Running scripts manually
 
@@ -369,4 +376,7 @@ You can set custom script descriptions w
 }
 ```
 
+The descriptions are used in `composer list` or `composer run -l` commands to
+describe what the scripts do when the command is run.
+
 > **Note:** You can only set custom descriptions of custom commands.
diff -pruN 1.10.19-1/doc/articles/troubleshooting.md 2.0.9-1/doc/articles/troubleshooting.md
--- 1.10.19-1/doc/articles/troubleshooting.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/articles/troubleshooting.md	2021-01-27 15:09:27.000000000 +0000
@@ -177,12 +177,7 @@ Because of GitHub's rate limits on their
 for authentication asking your username and password so it can go ahead with its work.
 
 If you would prefer not to provide your GitHub credentials to Composer you can
-manually create a token using the following procedure:
-
-1. [Create](https://github.com/settings/tokens) an OAuth token on GitHub.
-[Read more](https://github.com/blog/1509-personal-api-tokens) on this.
-
-2. Add it to the configuration running `composer config -g github-oauth.github.com <oauthtoken>`
+manually create a token using the [procedure documented here](authentication-for-private-packages.md#github-oauth).
 
 Now Composer should install/update without asking for authentication.
 
@@ -207,6 +202,7 @@ To enable the swap you can use for examp
 ```sh
 /bin/dd if=/dev/zero of=/var/swap.1 bs=1M count=1024
 /sbin/mkswap /var/swap.1
+/bin/chmod 0600 /var/swap.1
 /sbin/swapon /var/swap.1
 ```
 You can make a permanent swap file following this [tutorial](https://www.digitalocean.com/community/tutorials/how-to-add-swap-on-ubuntu-14-04).
diff -pruN 1.10.19-1/doc/articles/versions.md 2.0.9-1/doc/articles/versions.md
--- 1.10.19-1/doc/articles/versions.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/articles/versions.md	2021-01-27 15:09:27.000000000 +0000
@@ -80,6 +80,19 @@ In the above example, if you wanted to c
 
 When branch names look like versions, we have to clarify for composer that we're trying to check out a branch and not a tag. In the above example, we have two version branches: `v1` and `v2`. To get Composer to check out one of these branches, you must specify a version constraint that looks like this: `v1.x-dev`. The `.x` is an arbitrary string that Composer requires to tell it that we're talking about the `v1` branch and not a `v1` tag (alternatively, you can name the branch `v1.x` instead of `v1`). In the case of a branch with a version-like name (`v1`, in this case), you append `-dev` as a suffix, rather than using `dev-` as a prefix.
 
+### Stabilities
+
+Composer recognizes the following stabilities (in order of stability): dev,
+alpha, beta, RC, and stable where RC stands for release candidate. The stability
+of a version is defined by its suffix e.g version `v1.1-BETA` has a stability of
+`beta` and `v1.1-RC1` has a stability of `RC`. If such a suffix is missing
+e.g. version `v1.1` then Composer considers that version `stable`. In addition
+to that Composer automatically adds a `-dev` suffix to all numeric branches and
+prefixes all other branches imported from a VCS repository with `dev-`. In both
+cases the stability `dev` gets assigned.
+
+Keeping this in mind will help you in the next section.
+
 ### Minimum Stability
 
 There's one more thing that will affect which files are checked out of a library's VCS and added to your project: Composer allows you to specify stability constraints to limit which tags are considered valid. In the above example, note that the library released a beta and two release candidates for version `1.1` before the final official release. To receive these versions when running `composer install` or `composer update`, we have to explicitly tell Composer that we are ok with release candidates and beta releases (and alpha releases, if we want those). This can be done using either a project-wide `minimum-stability` value in `composer.json` or using "stability flags" in version constraints. Read more on the [schema page](../04-schema.md#minimum-stability).
@@ -117,7 +130,7 @@ Examples:
 * `>=1.0 <2.0`
 * `>=1.0 <1.1 || >=1.2`
 
-### Hyphenated Version Range ( - )
+### Hyphenated Version Range (` - `)
 
 Inclusive set of versions. Partial versions on the right include are completed
 with a wildcard. For example `1.0 - 2.0` is equivalent to `>=1.0.0 <2.1` as the
@@ -126,7 +139,7 @@ with a wildcard. For example `1.0 - 2.0`
 
 Example: `1.0 - 2.0`
 
-### Wildcard Version Range (.*)
+### Wildcard Version Range (`.*`)
 
 You can specify a pattern with a `*` wildcard. `1.0.*` is the equivalent of
 `>=1.0 <1.1`.
@@ -135,7 +148,7 @@ Example: `1.0.*`
 
 ## Next Significant Release Operators
 
-### Tilde Version Range (~)
+### Tilde Version Range (`~`)
 
 The `~` operator is best explained by example: `~1.2` is equivalent to
 `>=1.2 <2.0.0`, while `~1.2.3` is equivalent to `>=1.2.3 <1.3.0`. As you can see
@@ -157,9 +170,9 @@ Example: `~1.2`
 > it will not allow the major number to increase trying to keep backwards
 > compatibility.
 
-### Caret Version Range (^)
+### Caret Version Range (`^`)
 
-The `^` operator behaves very similarly but it sticks closer to semantic
+The `^` operator behaves very similarly, but it sticks closer to semantic
 versioning, and will always allow non-breaking updates. For example `^1.2.3`
 is equivalent to `>=1.2.3 <2.0.0` as none of the releases until 2.0 should
 break backwards compatibility. For pre-1.0 versions it also acts with safety
diff -pruN 1.10.19-1/doc/faqs/how-do-i-install-a-package-to-a-custom-path-for-my-framework.md 2.0.9-1/doc/faqs/how-do-i-install-a-package-to-a-custom-path-for-my-framework.md
--- 1.10.19-1/doc/faqs/how-do-i-install-a-package-to-a-custom-path-for-my-framework.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/faqs/how-do-i-install-a-package-to-a-custom-path-for-my-framework.md	2021-01-27 15:09:27.000000000 +0000
@@ -7,7 +7,7 @@ the default `vendor` folder by using
 
 If you are a **package author** and want your package installed to a custom
 directory, require `composer/installers` and set the appropriate `type`.
-Specifying the package type, will override the default installer path. 
+Specifying the package type, will override the default installer path.
 This is common if your package is intended for a specific framework such as
 CakePHP, Drupal or WordPress. Here is an example composer.json file for a
 WordPress theme:
@@ -46,7 +46,7 @@ for a module that uses composer/installe
 ```
 
 Now the package would be installed to your folder location, rather than the default
-composer/installers determined location. In addition, `installer-paths` is 
+composer/installers determined location. In addition, `installer-paths` is
 order-dependent, which means moving a package by name should come before the installer
 path of a `type:*` that matches the same package.
 
diff -pruN 1.10.19-1/doc/faqs/how-to-install-composer-programmatically.md 2.0.9-1/doc/faqs/how-to-install-composer-programmatically.md
--- 1.10.19-1/doc/faqs/how-to-install-composer-programmatically.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/faqs/how-to-install-composer-programmatically.md	2021-01-27 15:09:27.000000000 +0000
@@ -9,7 +9,7 @@ An alternative is to use this script whi
 ```bash
 #!/bin/sh
 
-EXPECTED_CHECKSUM="$(wget -q -O - https://composer.github.io/installer.sig)"
+EXPECTED_CHECKSUM="$(php -r 'copy("https://composer.github.io/installer.sig", "php://stdout");')"
 php -r "copy('https://getcomposer.org/installer', 'composer-setup.php');"
 ACTUAL_CHECKSUM="$(php -r "echo hash_file('sha384', 'composer-setup.php');")"
 
diff -pruN 1.10.19-1/doc/faqs/should-i-commit-the-dependencies-in-my-vendor-directory.md 2.0.9-1/doc/faqs/should-i-commit-the-dependencies-in-my-vendor-directory.md
--- 1.10.19-1/doc/faqs/should-i-commit-the-dependencies-in-my-vendor-directory.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/faqs/should-i-commit-the-dependencies-in-my-vendor-directory.md	2021-01-27 15:09:27.000000000 +0000
@@ -25,7 +25,7 @@ If you really feel like you must do this
 3. Remove the `.git` directory of every dependency after the installation, then
    you can add them to your git repo. You can do that with `rm -rf vendor/**/.git`
    in ZSH or `find vendor/ -type d -name ".git" -exec rm -rf {} \;` in Bash.
-   but this means you will have to delete those dependencies from disk before
+   But this means you will have to delete those dependencies from disk before
    running composer update.
 4. Add a .gitignore rule (`/vendor/**/.git`) to ignore all the vendor `.git` folders.
    This approach does not require that you delete dependencies from disk prior to
diff -pruN 1.10.19-1/doc/faqs/why-are-unbound-version-constraints-a-bad-idea.md 2.0.9-1/doc/faqs/why-are-unbound-version-constraints-a-bad-idea.md
--- 1.10.19-1/doc/faqs/why-are-unbound-version-constraints-a-bad-idea.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/faqs/why-are-unbound-version-constraints-a-bad-idea.md	2021-01-27 15:09:27.000000000 +0000
@@ -5,7 +5,7 @@ A version constraint without an upper bo
 This includes major versions breaking backward compatibility.
 
 Once a release of your package is tagged, you cannot tweak its dependencies
-anymore in case a dependency breaks BC - you have to do a new release but the
+anymore in case a dependency breaks BC - you have to do a new release, but the
 previous one stays broken.
 
 The only good alternative is to define an upper bound on your constraints,
@@ -16,6 +16,6 @@ For example instead of using `>=3.4` you
 versions up to `3.999` but does not include `4.0` and above. The `^` operator
 works very well with libraries following [semantic versioning](https://semver.org).
 
-**Note:** As a package maintainer, you can make the help your users
+**Note:** As a package maintainer, you can help your users
 by providing an [alias version](../articles/aliases.md) for your development
 branch to allow it to match bound constraints.
diff -pruN 1.10.19-1/doc/faqs/why-can't-composer-load-repositories-recursively.md 2.0.9-1/doc/faqs/why-can't-composer-load-repositories-recursively.md
--- 1.10.19-1/doc/faqs/why-can't-composer-load-repositories-recursively.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/faqs/why-can't-composer-load-repositories-recursively.md	2021-01-27 15:09:27.000000000 +0000
@@ -24,7 +24,7 @@ their package's packages, etc, then reso
 slows down the initialization a lot since VCS repos can each take a few seconds,
 and it could end up in a completely broken state since many versions of a package
 could define the same packages inside a package repository, but with different
-dist/source. There are many many ways this could go wrong.
+dist/source. There are many ways this could go wrong.
 
 - Fetch the repositories of root package, then fetch the repositories of the
 first level dependencies, then fetch the repositories of their dependencies, etc,
diff -pruN 1.10.19-1/doc/fixtures/fixtures.md 2.0.9-1/doc/fixtures/fixtures.md
--- 1.10.19-1/doc/fixtures/fixtures.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/doc/fixtures/fixtures.md	2021-01-27 15:09:27.000000000 +0000
@@ -12,11 +12,10 @@ also be used as (initial) fixtures for t
 
 All these repositories contain the following packages.
 
-* `foo/bar` versions 1.0.0, 1.0.1 and 1.1.0; dev-default and 1.0.x-dev branches.
-   On dev-default and in 1.1.0, `bar/baz` ~1.0 is required.
-* `qux/quux` only has a dev-default branch. It `replace`s `gar/nix`.
-* `gar/nix` has a 1.0.0 version and a dev-default branch. It is being replaced
+* `foo/bar` versions `1.0.0`, `1.0.1` and `1.1.0`; `dev-default` and `1.0.x-dev` branches.
+   On `dev-default` and in `1.1.0`, `bar/baz` `~1.0` is required.
+* `qux/quux` only has a `dev-default` branch. It `replace`s `gar/nix`.
+* `gar/nix` has a `1.0.0` version and a `dev-default` branch. It is being replaced
    by `qux/quux`.
-* `bar/baz` has a 1.0.0 version and 1.0.x-dev as well as dev-default branches.
-   Additionally, 1.1.x-dev is a branch alias for dev-default.
-
+* `bar/baz` has a `1.0.0` version and `1.0.x-dev` as well as `dev-default` branches.
+   Additionally, `1.1.x-dev` is a branch alias for `dev-default`.
diff -pruN 1.10.19-1/.gitattributes 2.0.9-1/.gitattributes
--- 1.10.19-1/.gitattributes	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/.gitattributes	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,18 @@
+# Auto-detect text files, ensure they use LF.
+*       text=auto eol=lf
+
+# These files are always considered text and should use LF.
+# See core.whitespace @ https://git-scm.com/docs/git-config for whitespace flags.
+*.php   text eol=lf whitespace=blank-at-eol,blank-at-eof,space-before-tab,tab-in-indent,tabwidth=4 diff=php
+*.json  text eol=lf whitespace=blank-at-eol,blank-at-eof,space-before-tab,tab-in-indent,tabwidth=4
+*.test  text eol=lf whitespace=blank-at-eol,blank-at-eof,space-before-tab,tab-in-indent,tabwidth=4
+*.yml   text eol=lf whitespace=blank-at-eol,blank-at-eof,space-before-tab,tab-in-indent,tabwidth=2
+
+# Exclude non-essential files from dist
+/tests export-ignore
+.github export-ignore
+.php_cs export-ignore
+.travis.yml export-ignore
+appveyor.yml export-ignore
+phpunit.xml.dist export-ignore
+/phpstan/ export-ignore
diff -pruN 1.10.19-1/.github/CONTRIBUTING.md 2.0.9-1/.github/CONTRIBUTING.md
--- 1.10.19-1/.github/CONTRIBUTING.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/.github/CONTRIBUTING.md	2021-01-27 15:09:27.000000000 +0000
@@ -2,7 +2,7 @@ Contributing to Composer
 ========================
 
 Please note that this project is released with a
-[Contributor Code of Conduct](http://contributor-covenant.org/version/1/4/).
+[Contributor Code of Conduct](https://github.com/composer/composer/blob/master/CODE_OF_CONDUCT.md).
 By participating in this project you agree to abide by its terms.
 
 Reporting Issues
diff -pruN 1.10.19-1/.github/ISSUE_TEMPLATE.md 2.0.9-1/.github/ISSUE_TEMPLATE.md
--- 1.10.19-1/.github/ISSUE_TEMPLATE.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/.github/ISSUE_TEMPLATE.md	2021-01-27 15:09:27.000000000 +0000
@@ -1,3 +1,8 @@
+<!--
+The information we ask for below is IMPORTANT. It will help us help you faster.
+Please FOLLOW THE ISSUE TEMPLATE unless you have a good reason not to, and help avoid wasting everyone's time.
+-->
+
 My `composer.json`:
 
 ```json
@@ -10,13 +15,13 @@ Output of `composer diagnose`:
 ...replace me...
 ```
 
-When I run this command:
+When I run this command: <!-- run it with `-vvv` added to it ideally to get full debug output -->
 
 ```
 ...replace me...
 ```
 
-I get the following output:
+I get the following output: <!-- FULL OUTPUT please, not just what you think is relevant -->
 
 ```
 ...replace me...
diff -pruN 1.10.19-1/.github/workflows/continuous-integration.yml 2.0.9-1/.github/workflows/continuous-integration.yml
--- 1.10.19-1/.github/workflows/continuous-integration.yml	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/.github/workflows/continuous-integration.yml	2021-01-27 15:09:27.000000000 +0000
@@ -9,7 +9,11 @@ on:
       - 'doc/**'
 
 env:
-  COMPOSER_FLAGS: "--ansi --no-interaction --no-progress --no-suggest --prefer-dist"
+  COMPOSER_FLAGS: "--ansi --no-interaction --no-progress --prefer-dist"
+  COMPOSER_UPDATE_FLAGS: ""
+  COMPOSER_TESTS_ARE_RUNNING: "1"
+  SYMFONY_PHPUNIT_VERSION: "8.5"
+  SYMFONY_PHPUNIT_REMOVE_RETURN_TYPEHINT: "1"
 
 jobs:
   tests:
@@ -34,54 +38,91 @@ jobs:
         os: [ubuntu-latest]
         experimental: [false]
         include:
-          - php-version: 5.3
+          - php-version: "5.3"
             dependencies: highest
             os: ubuntu-latest
             experimental: false
-          - php-version: 7.4
+          - php-version: "5.3"
+            dependencies: lowest
+            os: ubuntu-latest
+            experimental: false
+          - php-version: "7.4"
+            dependencies: highest
+            os: ubuntu-latest
+            experimental: false
+          - php-version: "7.4"
             os: windows-latest
             dependencies: locked
             experimental: false
-          - php-version: 7.4
+          - php-version: "7.4"
             os: macos-latest
             dependencies: locked
             experimental: false
+          - php-version: "8.0"
+            dependencies: lowest-ignore
+            os: ubuntu-latest
+            experimental: true
+          - php-version: "8.0"
+            dependencies: highest-ignore
+            os: ubuntu-latest
+            experimental: true
 
     steps:
       - name: "Checkout"
         uses: "actions/checkout@v2"
 
+      - name: "Choose PHPUnit version"
+        if: "!startsWith(matrix.os, 'windows')"
+        run: |
+          if [ "${{ matrix.php-version }}" = "5.3" ] || [ "${{ matrix.php-version }}" = "5.4" ] || [ "${{ matrix.php-version }}" = "5.5" ]; then
+            echo "SYMFONY_PHPUNIT_VERSION=4.8" >> $GITHUB_ENV;
+          elif [ "${{ matrix.php-version }}" = "5.6" ]; then
+            echo "SYMFONY_PHPUNIT_VERSION=5.7" >> $GITHUB_ENV;
+          elif [ "${{ matrix.php-version }}" = "7.0" ]; then
+            echo "SYMFONY_PHPUNIT_VERSION=6.5" >> $GITHUB_ENV;
+          elif [ "${{ matrix.php-version }}" = "7.1" ]; then
+            echo "SYMFONY_PHPUNIT_VERSION=7.5" >> $GITHUB_ENV;
+          elif [ "${{ matrix.php-version }}" = "8.0" ]; then
+            echo "SYMFONY_PHPUNIT_VERSION=9.4" >> $GITHUB_ENV;
+          else
+            echo "SYMFONY_PHPUNIT_VERSION=8.5" >> $GITHUB_ENV;
+          fi
+
       - name: "Install PHP"
         uses: "shivammathur/setup-php@v2"
         with:
           coverage: "none"
-          extensions: "intl"
-          ini-values: "memory_limit=-1"
+          extensions: "intl, zip"
+          ini-values: "memory_limit=-1, phar.readonly=0"
           php-version: "${{ matrix.php-version }}"
+          tools: composer
 
-      - name: "Determine composer cache directory"
-        id: "determine-composer-cache-directory"
-        run: "echo \"::set-output name=directory::$(composer config cache-dir)\""
-
-      - name: "Cache dependencies installed with composer"
-        uses: "actions/cache@v1"
-        with:
-          path: "${{ steps.determine-composer-cache-directory.outputs.directory }}"
-          key: "php-${{ matrix.php-version }}-symfony-php-unit-version-${{ env.SYMFONY_PHPUNIT_VERSION }}-${{ hashFiles('**/composer.lock') }}"
-          restore-keys: "php-${{ matrix.php-version }}-symfony-php-unit-version-${{ env.SYMFONY_PHPUNIT_VERSION }}"
-
-      - name: "Install highest dependencies from composer.json using composer binary provided by system"
-        if: "matrix.dependencies == 'highest'"
-        run: "composer config platform --unset && composer update ${{ env.COMPOSER_FLAGS }}"
-
-      - name: "Install lowest dependencies from composer.json using composer binary provided by system"
-        if: "matrix.dependencies == 'lowest'"
-        run: "composer update ${{ env.COMPOSER_FLAGS }} --prefer-lowest"
+      - name: "Handle lowest dependencies update"
+        if: "contains(matrix.dependencies, 'lowest')"
+        run: "echo \"COMPOSER_UPDATE_FLAGS=$COMPOSER_UPDATE_FLAGS --prefer-lowest\" >> $GITHUB_ENV"
+
+      - name: "Handle ignore-platform-reqs dependencies update"
+        if: "contains(matrix.dependencies, 'ignore')"
+        run: "echo \"COMPOSER_FLAGS=$COMPOSER_FLAGS --ignore-platform-req=php\" >> $GITHUB_ENV"
+
+      - name: "Remove platform config to get latest dependencies for current PHP version when build is not locked"
+        run: "composer config platform --unset"
+
+      - name: "Update dependencies from composer.json using composer binary provided by system"
+        if: "contains(matrix.dependencies, 'highest') || contains(matrix.dependencies, 'lowest')"
+        run: "composer update ${{ env.COMPOSER_UPDATE_FLAGS }} ${{ env.COMPOSER_FLAGS }}"
 
       - name: "Install dependencies from composer.lock using composer binary provided by system"
         if: "matrix.dependencies == 'locked'"
         run: "composer install ${{ env.COMPOSER_FLAGS }}"
 
+      - name: "Require latest PHPUnitBridge for PHP 8"
+        if: "matrix.php-version == '8.0'"
+        run: composer require --no-update --dev symfony/phpunit-bridge:^5.1
+
+      - name: "Update Symfony's PHPUnitBridge to latest available for the current PHP always as it is not really a dependency of the project"
+        run: "composer update ${{ env.COMPOSER_FLAGS }} symfony/phpunit-bridge"
+
       - name: "Run install again using composer binary from source"
         run: "bin/composer install ${{ env.COMPOSER_FLAGS }}"
 
@@ -91,9 +132,10 @@ jobs:
       - name: "Prepare git environment"
         run: "git config --global user.name composer && git config --global user.email composer@example.com"
 
-      - name: "Set SYMFONY_PHPUNIT_VERSION environment variable"
-        if: "matrix.php-version == '7.4'"
-        run: "echo \"SYMFONY_PHPUNIT_VERSION=7.5\" >> $GITHUB_ENV"
-
       - name: "Run tests"
-        run: "vendor/bin/simple-phpunit"
+        if: "matrix.php-version != '7.3'"
+        run: "vendor/bin/simple-phpunit --verbose"
+
+      - name: "Run complete test suite on 7.3"
+        if: "matrix.php-version == '7.3'"
+        run: "vendor/bin/simple-phpunit --configuration tests/complete.phpunit.xml"
diff -pruN 1.10.19-1/.github/workflows/phpstan.yml 2.0.9-1/.github/workflows/phpstan.yml
--- 1.10.19-1/.github/workflows/phpstan.yml	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/.github/workflows/phpstan.yml	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,56 @@
+name: "PHPStan"
+
+on:
+  push:
+    paths-ignore:
+      - 'doc/**'
+  pull_request:
+    paths-ignore:
+      - 'doc/**'
+
+env:
+  COMPOSER_FLAGS: "--ansi --no-interaction --no-progress --prefer-dist"
+  SYMFONY_PHPUNIT_VERSION: ""
+
+jobs:
+  tests:
+    name: "PHPStan"
+
+    runs-on: ubuntu-latest
+
+    strategy:
+      matrix:
+        php-version:
+          - "7.4"
+
+    steps:
+      - name: "Checkout"
+        uses: "actions/checkout@v2"
+
+      - name: "Install PHP"
+        uses: "shivammathur/setup-php@v2"
+        with:
+          coverage: "none"
+          extensions: "intl, zip"
+          ini-values: "memory_limit=-1"
+          php-version: "${{ matrix.php-version }}"
+
+      - name: "Determine composer cache directory"
+        id: "determine-composer-cache-directory"
+        run: "echo \"::set-output name=directory::$(composer config cache-dir)\""
+
+      - name: "Cache dependencies installed with composer"
+        uses: "actions/cache@v2"
+        with:
+          path: "${{ steps.determine-composer-cache-directory.outputs.directory }}"
+          key: "php-${{ matrix.php-version }}-symfony-php-unit-version-${{ env.SYMFONY_PHPUNIT_VERSION }}-${{ hashFiles('**/composer.lock') }}"
+          restore-keys: "php-${{ matrix.php-version }}-symfony-php-unit-version-${{ env.SYMFONY_PHPUNIT_VERSION }}"
+
+      - name: "Install highest dependencies from composer.json using composer binary provided by system"
+        run: "composer config platform --unset && composer update ${{ env.COMPOSER_FLAGS }}"
+
+      - name: Run PHPStan
+        # Locked to phpunit 7.5 here as newer ones have void return types which break inheritance
+        run: |
+          bin/composer require --dev phpstan/phpstan:^0.12.69 phpunit/phpunit:^7.5.20 --with-all-dependencies ${{ env.COMPOSER_FLAGS }}
+          vendor/bin/phpstan analyse --configuration=phpstan/config.neon
diff -pruN 1.10.19-1/.github/workflows/release.yml 2.0.9-1/.github/workflows/release.yml
--- 1.10.19-1/.github/workflows/release.yml	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/.github/workflows/release.yml	2021-01-27 15:09:27.000000000 +0000
@@ -57,6 +57,27 @@ jobs:
           asset_name: composer.phar
           asset_content_type: application/octet-stream
 
+      - name: Configure GPG key and sign phar
+        run: |
+          mkdir -p ~/.gnupg/
+          chmod 0700 ~/.gnupg/
+          echo "$GPG_SIGNING_KEY" > ~/.gnupg/private.key
+          gpg --import ~/.gnupg/private.key
+          gpg -u contact@packagist.com --detach-sign --output composer.phar.asc composer.phar
+        env:
+          GPG_SIGNING_KEY: |
+            ${{ secrets.GPG_KEY_161DFBE342889F01DDAC4E61CBB3D576F2A0946F }}
+
+      - name: Upload phar signature
+        uses: actions/upload-release-asset@v1
+        env:
+          GITHUB_TOKEN: ${{ secrets.GITHUB_TOKEN }}
+        with:
+          upload_url: ${{ steps.create_release.outputs.upload_url }}
+          asset_path: ./composer.phar.asc
+          asset_name: composer.phar.asc
+          asset_content_type: application/octet-stream
+
       # This step requires a secret token with `pull` access to composer/docker. The default
       # secrets.GITHUB_TOKEN is scoped to this repository only which is not sufficient.
       - name: "Open issue @ Docker repository"
diff -pruN 1.10.19-1/phpstan/config.neon 2.0.9-1/phpstan/config.neon
--- 1.10.19-1/phpstan/config.neon	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/phpstan/config.neon	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,59 @@
+parameters:
+    level: 1
+    checkClassCaseSensitivity: true # Level 2 rule
+    excludes_analyse:
+       - '../tests/Composer/Test/Fixtures/*'
+       - '../tests/Composer/Test/Autoload/Fixtures/*'
+       - '../tests/Composer/Test/Plugin/Fixtures/*'
+       - '../tests/Composer/Test/PolyfillTestCase.php'
+    ignoreErrors:
+        # unused parameters
+        - '~^Constructor of class Composer\\Repository\\VcsRepository has an unused parameter \$dispatcher\.$~'
+        - '~^Constructor of class Composer\\Util\\Http\\CurlDownloader has an unused parameter \$disableTls\.$~'
+        - '~^Constructor of class Composer\\Util\\Http\\CurlDownloader has an unused parameter \$options\.$~'
+
+        # ion cube is not installed
+        - '~^Function ioncube_loader_\w+ not found\.$~'
+
+        # variables from global scope
+        - '~^Undefined variable: \$vendorDir$~'
+        - '~^Undefined variable: \$baseDir$~'
+
+        # variable defined in eval
+        - '~^Undefined variable: \$res$~'
+
+        # we don't have different constructors for parent/child
+        - '~^Unsafe usage of new static\(\)\.$~'
+
+        # BC with older PHPUnit
+        - '~^Call to an undefined static method Composer\\Test\\PolyfillTestCase::setExpectedException\(\)\.$~'
+        - '~^Call to an undefined method Composer\\Test\\[a-zA-Z0-9\\]+::(assertFileDoesNotExist|assertMatchesRegularExpression)\(\)\.$~'
+
+    paths:
+        - ../src
+        - ../tests
+
+rules:
+    - Composer\PHPStanRules\AnonymousFunctionWithThisRule
+    # Level 2 rules
+    - PHPStan\Rules\Cast\EchoRule
+    - PHPStan\Rules\Cast\InvalidCastRule
+    - PHPStan\Rules\Cast\InvalidPartOfEncapsedStringRule
+    - PHPStan\Rules\Cast\PrintRule
+    - PHPStan\Rules\Functions\IncompatibleDefaultParameterTypeRule
+    - PHPStan\Rules\Generics\ClassAncestorsRule
+    - PHPStan\Rules\Generics\ClassTemplateTypeRule
+    - PHPStan\Rules\Generics\FunctionTemplateTypeRule
+    - PHPStan\Rules\Generics\FunctionSignatureVarianceRule
+    - PHPStan\Rules\Generics\InterfaceAncestorsRule
+    - PHPStan\Rules\Generics\InterfaceTemplateTypeRule
+    - PHPStan\Rules\Generics\MethodTemplateTypeRule
+    - PHPStan\Rules\Generics\MethodSignatureVarianceRule
+    - PHPStan\Rules\Generics\TraitTemplateTypeRule
+    - PHPStan\Rules\Operators\InvalidBinaryOperationRule
+    - PHPStan\Rules\Operators\InvalidUnaryOperationRule
+    - PHPStan\Rules\Operators\InvalidComparisonOperationRule
+    - PHPStan\Rules\PhpDoc\IncompatiblePhpDocTypeRule
+    - PHPStan\Rules\PhpDoc\IncompatiblePropertyPhpDocTypeRule
+    - PHPStan\Rules\PhpDoc\InvalidPhpDocTagValueRule
+    - PHPStan\Rules\PhpDoc\InvalidPHPStanDocTagRule
diff -pruN 1.10.19-1/phpstan/Rules/src/AnonymousFunctionWithThisRule.php 2.0.9-1/phpstan/Rules/src/AnonymousFunctionWithThisRule.php
--- 1.10.19-1/phpstan/Rules/src/AnonymousFunctionWithThisRule.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/phpstan/Rules/src/AnonymousFunctionWithThisRule.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,46 @@
+<?php declare(strict_types = 1);
+
+namespace Composer\PHPStanRules;
+
+use PhpParser\Node;
+use PHPStan\Analyser\Scope;
+use PHPStan\Rules\Rule;
+
+/**
+ * @phpstan-implements Rule<\PhpParser\Node\Expr\Variable>
+ */
+final class AnonymousFunctionWithThisRule implements Rule
+{
+    /**
+     * @inheritDoc
+     */
+    public function getNodeType(): string
+    {
+        return \PhpParser\Node\Expr\Variable::class;
+    }
+
+    /**
+     * @inheritDoc
+     */
+    public function processNode(Node $node, Scope $scope): array
+    {
+        if (!\is_string($node->name) || $node->name !== 'this') {
+            return [];
+        }
+
+        if ($scope->isInClosureBind()) {
+            return [];
+        }
+
+        if (!$scope->isInClass()) {
+            // reported in other standard rule on level 0
+            return [];
+        }
+
+        if ($scope->isInAnonymousFunction()) {
+            return ['Using $this inside anonymous function is prohibited because of PHP 5.3 support.'];
+        }
+
+        return [];
+    }
+}
diff -pruN 1.10.19-1/phpstan/Rules/tests/AnonymousFunctionWithThisRuleTest.php 2.0.9-1/phpstan/Rules/tests/AnonymousFunctionWithThisRuleTest.php
--- 1.10.19-1/phpstan/Rules/tests/AnonymousFunctionWithThisRuleTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/phpstan/Rules/tests/AnonymousFunctionWithThisRuleTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,28 @@
+<?php declare(strict_types = 1);
+
+namespace Composer\PHPStanRulesTests;
+
+use Composer\PHPStanRules\AnonymousFunctionWithThisRule;
+use PHPStan\Testing\RuleTestCase;
+
+/**
+ * @phpstan-extends RuleTestCase<AnonymousFunctionWithThisRule>
+ */
+final class AnonymousFunctionWithThisRuleTest extends RuleTestCase
+{
+    /**
+     * @inheritDoc
+     */
+    protected function getRule(): \PHPStan\Rules\Rule
+    {
+        return new AnonymousFunctionWithThisRule();
+    }
+
+    public function testWithThis(): void
+    {
+        $this->analyse([__DIR__ . '/data/method-with-this.php'], [
+            ['Using $this inside anonymous function is prohibited because of PHP 5.3 support.', 13],
+            ['Using $this inside anonymous function is prohibited because of PHP 5.3 support.', 17],
+        ]);
+    }
+}
diff -pruN 1.10.19-1/phpstan/Rules/tests/data/method-with-this.php 2.0.9-1/phpstan/Rules/tests/data/method-with-this.php
--- 1.10.19-1/phpstan/Rules/tests/data/method-with-this.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/phpstan/Rules/tests/data/method-with-this.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,34 @@
+<?php
+
+class FirstClass
+{
+    /**
+     * @var int
+     */
+    private $firstProp = 9;
+
+    public function funMethod()
+    {
+        function() {
+            $this->firstProp;
+        };
+
+        call_user_func(function() {
+            $this->funMethod();
+        }, $this);
+
+        $bind = 'bind';
+        function() use($bind) {
+
+        };
+    }
+}
+
+function global_ok() {
+    $_SERVER['REMOTE_ADDR'];
+}
+
+function global_this() {
+    // not checked by our rule, it is checked with standard phpstan rule on level 0
+    $this['REMOTE_ADDR'];
+}
diff -pruN 1.10.19-1/phpunit.xml.dist 2.0.9-1/phpunit.xml.dist
--- 1.10.19-1/phpunit.xml.dist	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/phpunit.xml.dist	2021-01-27 15:09:27.000000000 +0000
@@ -10,7 +10,6 @@
          convertNoticesToExceptions="true"
          convertWarningsToExceptions="true"
          failOnRisky="true"
-         strict="false"
          processIsolation="false"
          stopOnFailure="false"
          bootstrap="tests/bootstrap.php"
diff -pruN 1.10.19-1/README.md 2.0.9-1/README.md
--- 1.10.19-1/README.md	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/README.md	2021-01-27 15:09:27.000000000 +0000
@@ -5,8 +5,7 @@ Composer helps you declare, manage, and
 
 See [https://getcomposer.org/](https://getcomposer.org/) for more information and documentation.
 
-[![Continuous Integration](https://github.com/composer/composer.svg/workflows/Continuous%20Integration/badge.svg?branch=master)](https://github.com/composer/composer.svg/actions)
-[![Build Status](https://travis-ci.org/composer/composer.svg?branch=master)](https://travis-ci.org/composer/composer)
+[![Continuous Integration](https://github.com/composer/composer/workflows/Continuous%20Integration/badge.svg?branch=master)](https://github.com/composer/composer/actions)
 
 Installation / Usage
 --------------------
@@ -30,7 +29,7 @@ For support, Stack Overflow also offers
 [Composer related questions](https://stackoverflow.com/questions/tagged/composer-php).
 
 Please note that this project is released with a
-[Contributor Code of Conduct](http://contributor-covenant.org/version/1/4/).
+[Contributor Code of Conduct](https://www.contributor-covenant.org/version/1/4/code-of-conduct/).
 By participating in this project and its community you agree to abide by those terms.
 
 Requirements
@@ -41,8 +40,8 @@ PHP 5.3.2 or above (at least 5.3.4 recom
 Authors
 -------
 
-- Nils Adermann  | [GitHub](https://github.com/naderman)  | [Twitter](https://twitter.com/naderman) | <naderman@naderman.de> | [naderman.de](http://naderman.de)
-- Jordi Boggiano | [GitHub](https://github.com/Seldaek) | [Twitter](https://twitter.com/seldaek) | <j.boggiano@seld.be> | [seld.be](http://seld.be)
+- Nils Adermann  | [GitHub](https://github.com/naderman)  | [Twitter](https://twitter.com/naderman) | <naderman@naderman.de> | [naderman.de](https://naderman.de)
+- Jordi Boggiano | [GitHub](https://github.com/Seldaek) | [Twitter](https://twitter.com/seldaek) | <j.boggiano@seld.be> | [seld.be](https://seld.be)
 
 See also the list of [contributors](https://github.com/composer/composer/contributors) who participated in this project.
 
@@ -54,7 +53,7 @@ Please send any sensitive issue to [secu
 License
 -------
 
-Composer is licensed under the MIT License - see the [LICENSE](LICENSE) file for details
+Composer is licensed under the MIT License - see the [LICENSE](LICENSE) file for details.
 
 Acknowledgments
 ---------------
diff -pruN 1.10.19-1/res/composer-repository-schema.json 2.0.9-1/res/composer-repository-schema.json
--- 1.10.19-1/res/composer-repository-schema.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/res/composer-repository-schema.json	2021-01-27 15:09:27.000000000 +0000
@@ -1,5 +1,5 @@
 {
-    "$schema": "http://json-schema.org/draft-04/schema#",
+    "$schema": "https://json-schema.org/draft-04/schema#",
     "description": "A representation of packages metadata.",
     "type": "object",
     "oneOf": [
diff -pruN 1.10.19-1/res/composer-schema.json 2.0.9-1/res/composer-schema.json
--- 1.10.19-1/res/composer-schema.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/res/composer-schema.json	2021-01-27 15:09:27.000000000 +0000
@@ -1,5 +1,5 @@
 {
-    "$schema": "http://json-schema.org/draft-04/schema#",
+    "$schema": "https://json-schema.org/draft-04/schema#",
     "name": "Package",
     "type": "object",
     "additionalProperties": false,
@@ -7,7 +7,8 @@
     "properties": {
         "name": {
             "type": "string",
-            "description": "Package name, including 'vendor-name/' prefix."
+            "description": "Package name, including 'vendor-name/' prefix.",
+            "pattern": "^[a-z0-9]([_.-]?[a-z0-9]+)*/[a-z0-9](([_.]?|-{0,2})[a-z0-9]+)*$"
         },
         "type": {
             "description": "Package type, either 'library' for common packages, 'composer-plugin' for plugins, 'metapackage' for empty packages, or a custom type ([a-z0-9-]+) defined by whatever project this package applies to.",
@@ -236,6 +237,10 @@
                     "type": ["string", "integer"],
                     "description": "The cache max size for the files cache, defaults to \"300MiB\"."
                 },
+                "cache-read-only": {
+                    "type": ["boolean"],
+                    "description": "Whether to use the Composer cache in read-only mode."
+                },
                 "bin-compat": {
                     "enum": ["auto", "full"],
                     "description": "The compatibility of the binaries, defaults to \"auto\" (automatically guessed) and can be \"full\" (compatible with both Windows and Unix-based systems)."
@@ -305,6 +310,10 @@
                 "lock": {
                     "type": "boolean",
                     "description": "Defaults to true. If set to false, Composer will not create a composer.lock file."
+                },
+                "platform-check": {
+                    "type": ["boolean", "string"],
+                    "description": "Defaults to \"php-only\" which checks only the PHP version. Setting to true will also check the presence of required PHP extensions. If set to false, Composer will not create and require a platform_check.php file as part of the autoloader bootstrap."
                 }
             }
         },
@@ -342,7 +351,7 @@
                 },
                 "classmap": {
                     "type": "array",
-                    "description": "This is an array of directories that contain classes to be included in the class-map generation process."
+                    "description": "This is an array of paths that contain classes to be included in the class-map generation process."
                 },
                 "files": {
                     "type": "array",
@@ -354,6 +363,10 @@
             "type": ["object"],
             "description": "Options for creating package archives for distribution.",
             "properties": {
+                "name": {
+                    "type": "string",
+                    "description": "A base name for archive."
+                },
                 "exclude": {
                     "type": "array",
                     "description": "A list of patterns for paths to exclude or include if prefixed with an exclamation mark."
@@ -556,6 +569,10 @@
                 "type": "string"
             }
         },
+        "default-branch": {
+            "type": ["boolean"],
+            "description": "Internal use only, do not specify this in composer.json. Indicates whether this version is the default branch of the linked VCS repository. Defaults to false."
+        },
         "abandoned": {
             "type": ["boolean", "string"],
             "description": "Indicates whether this package has been abandoned, it can be boolean or a package name/URL pointing to a recommended alternative. Defaults to false."
@@ -621,7 +638,7 @@
                 },
                 "classmap": {
                     "type": "array",
-                    "description": "This is an array of directories that contain classes to be included in the class-map generation process."
+                    "description": "This is an array of paths that contain classes to be included in the class-map generation process."
                 },
                 "files": {
                     "type": "array",
@@ -650,6 +667,19 @@
             "properties": {
                 "type": { "type": "string", "enum": ["composer"] },
                 "url": { "type": "string" },
+                "canonical": { "type": "boolean" },
+                "only": {
+                    "type": "array",
+                    "items": {
+                        "type": "string"
+                    }
+                },
+                "exclude": {
+                    "type": "array",
+                    "items": {
+                        "type": "string"
+                    }
+                },
                 "options": {
                     "type": "object",
                     "additionalProperties": true
@@ -664,6 +694,19 @@
             "properties": {
                 "type": { "type": "string", "enum": ["vcs", "github", "git", "gitlab", "git-bitbucket", "hg", "hg-bitbucket", "fossil", "perforce", "svn"] },
                 "url": { "type": "string" },
+                "canonical": { "type": "boolean" },
+                "only": {
+                    "type": "array",
+                    "items": {
+                        "type": "string"
+                    }
+                },
+                "exclude": {
+                    "type": "array",
+                    "items": {
+                        "type": "string"
+                    }
+                },
                 "no-api": { "type": "boolean" },
                 "secure-http": { "type": "boolean" },
                 "svn-cache-credentials": { "type": "boolean" },
@@ -684,6 +727,19 @@
             "properties": {
                 "type": { "type": "string", "enum": ["path"] },
                 "url": { "type": "string" },
+                "canonical": { "type": "boolean" },
+                "only": {
+                    "type": "array",
+                    "items": {
+                        "type": "string"
+                    }
+                },
+                "exclude": {
+                    "type": "array",
+                    "items": {
+                        "type": "string"
+                    }
+                },
                 "options": {
                     "type": "object",
                     "properties": {
@@ -698,7 +754,20 @@
             "required": ["type", "url"],
             "properties": {
                 "type": { "type": "string", "enum": ["artifact"] },
-                "url": { "type": "string" }
+                "url": { "type": "string" },
+                "canonical": { "type": "boolean" },
+                "only": {
+                    "type": "array",
+                    "items": {
+                        "type": "string"
+                    }
+                },
+                "exclude": {
+                    "type": "array",
+                    "items": {
+                        "type": "string"
+                    }
+                }
             }
         },
         "pear-repository": {
@@ -707,6 +776,19 @@
             "properties": {
                 "type": { "type": "string", "enum": ["pear"] },
                 "url": { "type": "string" },
+                "canonical": { "type": "boolean" },
+                "only": {
+                    "type": "array",
+                    "items": {
+                        "type": "string"
+                    }
+                },
+                "exclude": {
+                    "type": "array",
+                    "items": {
+                        "type": "string"
+                    }
+                },
                 "vendor-alias": { "type": "string" }
             }
         },
@@ -715,6 +797,19 @@
             "required": ["type", "package"],
             "properties": {
                 "type": { "type": "string", "enum": ["package"] },
+                "canonical": { "type": "boolean" },
+                "only": {
+                    "type": "array",
+                    "items": {
+                        "type": "string"
+                    }
+                },
+                "exclude": {
+                    "type": "array",
+                    "items": {
+                        "type": "string"
+                    }
+                },
                 "package": {
                     "oneOf": [
                         { "$ref": "#/definitions/inline-package" },
diff -pruN 1.10.19-1/src/Composer/Autoload/AutoloadGenerator.php 2.0.9-1/src/Composer/Autoload/AutoloadGenerator.php
--- 1.10.19-1/src/Composer/Autoload/AutoloadGenerator.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Autoload/AutoloadGenerator.php	2021-01-27 15:09:27.000000000 +0000
@@ -18,7 +18,11 @@ use Composer\Installer\InstallationManag
 use Composer\IO\IOInterface;
 use Composer\Package\AliasPackage;
 use Composer\Package\PackageInterface;
+use Composer\Package\RootPackageInterface;
 use Composer\Repository\InstalledRepositoryInterface;
+use Composer\Repository\PlatformRepository;
+use Composer\Semver\Constraint\Bound;
+use Composer\Semver\Constraint\MatchAllConstraint;
 use Composer\Util\Filesystem;
 use Composer\Script\ScriptEvents;
 use Composer\Util\PackageSorter;
@@ -55,10 +59,20 @@ class AutoloadGenerator
     private $apcu = false;
 
     /**
+     * @var string|null
+     */
+    private $apcuPrefix;
+
+    /**
      * @var bool
      */
     private $runScripts = false;
 
+    /**
+     * @var bool|array
+     */
+    private $ignorePlatformReqs = false;
+
     public function __construct(EventDispatcher $eventDispatcher, IOInterface $io = null)
     {
         $this->eventDispatcher = $eventDispatcher;
@@ -84,11 +98,13 @@ class AutoloadGenerator
     /**
      * Whether or not generated autoloader considers APCu caching.
      *
-     * @param bool $apcu
+     * @param bool        $apcu
+     * @param string|null $apcuPrefix
      */
-    public function setApcu($apcu)
+    public function setApcu($apcu, $apcuPrefix = null)
     {
         $this->apcu = (bool) $apcu;
+        $this->apcuPrefix = $apcuPrefix !== null ? (string) $apcuPrefix : $apcuPrefix;
     }
 
     /**
@@ -101,7 +117,27 @@ class AutoloadGenerator
         $this->runScripts = (bool) $runScripts;
     }
 
-    public function dump(Config $config, InstalledRepositoryInterface $localRepo, PackageInterface $mainPackage, InstallationManager $installationManager, $targetDir, $scanPsrPackages = false, $suffix = '')
+    /**
+     * Sets whether platform requirements should be ignored
+     *
+     * If this is set to true, the platform check file will not be generated
+     * If this is set to false, the platform check file will be generated with all requirements
+     * If this is set to string[], those packages will be ignored from the platform check file
+     *
+     * @param array|bool $ignorePlatformReqs
+     */
+    public function setIgnorePlatformRequirements($ignorePlatformReqs)
+    {
+        if (is_array($ignorePlatformReqs)) {
+            $this->ignorePlatformReqs = array_filter($ignorePlatformReqs, function ($req) {
+                return PlatformRepository::isPlatformPackage($req);
+            });
+        } else {
+            $this->ignorePlatformReqs = (bool) $ignorePlatformReqs;
+        }
+    }
+
+    public function dump(Config $config, InstalledRepositoryInterface $localRepo, RootPackageInterface $rootPackage, InstallationManager $installationManager, $targetDir, $scanPsrPackages = false, $suffix = '')
     {
         if ($this->classMapAuthoritative) {
             // Force scanPsrPackages when classmap is authoritative
@@ -157,8 +193,16 @@ return array(
 EOF;
 
         // Collect information from all packages.
-        $packageMap = $this->buildPackageMap($installationManager, $mainPackage, $localRepo->getCanonicalPackages());
-        $autoloads = $this->parseAutoloads($packageMap, $mainPackage, $this->devMode === false);
+        $devPackageNames = $localRepo->getDevPackageNames();
+        $packageMap = $this->buildPackageMap($installationManager, $rootPackage, $localRepo->getCanonicalPackages());
+        if ($this->devMode) {
+            // if dev mode is enabled, then we do not filter any dev packages out so disable this entirely
+            $filteredDevPackages = false;
+        } else {
+            // if the list of dev package names is available we use that straight, otherwise pass true which means use legacy algo to figure them out
+            $filteredDevPackages = $devPackageNames ?: true;
+        }
+        $autoloads = $this->parseAutoloads($packageMap, $rootPackage, $filteredDevPackages);
 
         // Process the 'psr-0' base directories.
         foreach ($autoloads['psr-0'] as $namespace => $paths) {
@@ -198,9 +242,9 @@ EOF;
 
         // add custom psr-0 autoloading if the root package has a target dir
         $targetDirLoader = null;
-        $mainAutoload = $mainPackage->getAutoload();
-        if ($mainPackage->getTargetDir() && !empty($mainAutoload['psr-0'])) {
-            $levels = substr_count($filesystem->normalizePath($mainPackage->getTargetDir()), '/') + 1;
+        $mainAutoload = $rootPackage->getAutoload();
+        if ($rootPackage->getTargetDir() && !empty($mainAutoload['psr-0'])) {
+            $levels = substr_count($filesystem->normalizePath($rootPackage->getTargetDir()), '/') + 1;
             $prefixes = implode(', ', array_map(function ($prefix) {
                 return var_export($prefix, true);
             }, array_keys($mainAutoload['psr-0'])));
@@ -231,7 +275,7 @@ EOF;
 
         $excluded = null;
         if (!empty($autoloads['exclude-from-classmap'])) {
-            $excluded = '{(' . implode('|', $autoloads['exclude-from-classmap']) . ')}';
+            $excluded = $autoloads['exclude-from-classmap'];
         }
 
         $classMap = array();
@@ -276,6 +320,7 @@ EOF;
             );
         }
 
+        $classMap['Composer\\InstalledVersions'] = "\$vendorDir . '/composer/InstalledVersions.php',\n";
         ksort($classMap);
         foreach ($classMap as $class => $code) {
             $classmapFile .= '    '.var_export($class, true).' => '.$code;
@@ -295,27 +340,40 @@ EOF;
             }
         }
 
-        $this->filePutContentsIfModified($targetDir.'/autoload_namespaces.php', $namespacesFile);
-        $this->filePutContentsIfModified($targetDir.'/autoload_psr4.php', $psr4File);
-        $this->filePutContentsIfModified($targetDir.'/autoload_classmap.php', $classmapFile);
+        $filesystem->filePutContentsIfModified($targetDir.'/autoload_namespaces.php', $namespacesFile);
+        $filesystem->filePutContentsIfModified($targetDir.'/autoload_psr4.php', $psr4File);
+        $filesystem->filePutContentsIfModified($targetDir.'/autoload_classmap.php', $classmapFile);
         $includePathFilePath = $targetDir.'/include_paths.php';
         if ($includePathFileContents = $this->getIncludePathsFile($packageMap, $filesystem, $basePath, $vendorPath, $vendorPathCode52, $appBaseDirCode)) {
-            $this->filePutContentsIfModified($includePathFilePath, $includePathFileContents);
+            $filesystem->filePutContentsIfModified($includePathFilePath, $includePathFileContents);
         } elseif (file_exists($includePathFilePath)) {
             unlink($includePathFilePath);
         }
         $includeFilesFilePath = $targetDir.'/autoload_files.php';
         if ($includeFilesFileContents = $this->getIncludeFilesFile($autoloads['files'], $filesystem, $basePath, $vendorPath, $vendorPathCode52, $appBaseDirCode)) {
-            $this->filePutContentsIfModified($includeFilesFilePath, $includeFilesFileContents);
+            $filesystem->filePutContentsIfModified($includeFilesFilePath, $includeFilesFileContents);
         } elseif (file_exists($includeFilesFilePath)) {
             unlink($includeFilesFilePath);
         }
-        $this->filePutContentsIfModified($targetDir.'/autoload_static.php', $this->getStaticFile($suffix, $targetDir, $vendorPath, $basePath, $staticPhpVersion));
-        $this->filePutContentsIfModified($vendorPath.'/autoload.php', $this->getAutoloadFile($vendorPathToTargetDirCode, $suffix));
-        $this->filePutContentsIfModified($targetDir.'/autoload_real.php', $this->getAutoloadRealFile(true, (bool) $includePathFileContents, $targetDirLoader, (bool) $includeFilesFileContents, $vendorPathCode, $appBaseDirCode, $suffix, $useGlobalIncludePath, $prependAutoloader, $staticPhpVersion));
+        $filesystem->filePutContentsIfModified($targetDir.'/autoload_static.php', $this->getStaticFile($suffix, $targetDir, $vendorPath, $basePath, $staticPhpVersion));
+        $checkPlatform = $config->get('platform-check') && $this->ignorePlatformReqs !== true;
+        $platformCheckContent = null;
+        if ($checkPlatform) {
+            $platformCheckContent = $this->getPlatformCheck($packageMap, $this->ignorePlatformReqs ?: array(), $config->get('platform-check'), $devPackageNames);
+            if (null === $platformCheckContent) {
+                $checkPlatform = false;
+            }
+        }
+        if ($checkPlatform) {
+            $filesystem->filePutContentsIfModified($targetDir.'/platform_check.php', $platformCheckContent);
+        } elseif (file_exists($targetDir.'/platform_check.php')) {
+            unlink($targetDir.'/platform_check.php');
+        }
+        $filesystem->filePutContentsIfModified($vendorPath.'/autoload.php', $this->getAutoloadFile($vendorPathToTargetDirCode, $suffix));
+        $filesystem->filePutContentsIfModified($targetDir.'/autoload_real.php', $this->getAutoloadRealFile(true, (bool) $includePathFileContents, $targetDirLoader, (bool) $includeFilesFileContents, $vendorPathCode, $appBaseDirCode, $suffix, $useGlobalIncludePath, $prependAutoloader, $staticPhpVersion, $checkPlatform));
 
-        $this->safeCopy(__DIR__.'/ClassLoader.php', $targetDir.'/ClassLoader.php');
-        $this->safeCopy(__DIR__.'/../../../LICENSE', $targetDir.'/LICENSE');
+        $filesystem->safeCopy(__DIR__.'/ClassLoader.php', $targetDir.'/ClassLoader.php');
+        $filesystem->safeCopy(__DIR__.'/../../../LICENSE', $targetDir.'/LICENSE');
 
         if ($this->runScripts) {
             $this->eventDispatcher->dispatchScript(ScriptEvents::POST_AUTOLOAD_DUMP, $this->devMode, array(), array(
@@ -326,16 +384,6 @@ EOF;
         return count($classMap);
     }
 
-    private function filePutContentsIfModified($path, $content)
-    {
-        $currentContent = @file_get_contents($path);
-        if (!$currentContent || ($currentContent != $content)) {
-            return file_put_contents($path, $content);
-        }
-
-        return 0;
-    }
-
     private function addClassMapCode($filesystem, $basePath, $vendorPath, $dir, $excluded, $namespaceFilter, $autoloadType, array $classMap, array &$ambiguousClasses, array &$scannedFiles)
     {
         foreach ($this->generateClassMap($dir, $excluded, $namespaceFilter, $autoloadType, true, $scannedFiles) as $class => $path) {
@@ -350,15 +398,41 @@ EOF;
         return $classMap;
     }
 
+    /**
+     * @param ?array $excluded
+     */
     private function generateClassMap($dir, $excluded, $namespaceFilter, $autoloadType, $showAmbiguousWarning, array &$scannedFiles)
     {
+        if ($excluded) {
+            // filter excluded patterns here to only use those matching $dir
+            // exclude-from-classmap patterns are all realpath'd so we can only filter them if $dir exists so that realpath($dir) will work
+            // if $dir does not exist, it should anyway not find anything there so no trouble
+            if (file_exists($dir)) {
+                // transform $dir in the same way that exclude-from-classmap patterns are transformed so we can match them against each other
+                $dirMatch = preg_quote(strtr(realpath($dir), '\\', '/'));
+                foreach ($excluded as $index => $pattern) {
+                    // extract the constant string prefix of the pattern here, until we reach a non-escaped regex special character
+                    $pattern = preg_replace('{^(([^.+*?\[^\]$(){}=!<>|:\\\\#-]+|\\\\[.+*?\[^\]$(){}=!<>|:#-])*).*}', '$1', $pattern);
+                    // if the pattern is not a subset or superset of $dir, it is unrelated and we skip it
+                    if (0 !== strpos($pattern, $dirMatch) && 0 !== strpos($dirMatch, $pattern)) {
+                        unset($excluded[$index]);
+                    }
+                }
+            }
+
+            $excluded = $excluded ? '{(' . implode('|', $excluded) . ')}' : null;
+        }
+
         return ClassMapGenerator::createMap($dir, $excluded, $showAmbiguousWarning ? $this->io : null, $namespaceFilter, $autoloadType, $scannedFiles);
     }
 
-    public function buildPackageMap(InstallationManager $installationManager, PackageInterface $mainPackage, array $packages)
+    /**
+     * @param RootPackageInterface $rootPackage
+     */
+    public function buildPackageMap(InstallationManager $installationManager, PackageInterface $rootPackage, array $packages)
     {
         // build package => install path map
-        $packageMap = array(array($mainPackage, ''));
+        $packageMap = array(array($rootPackage, ''));
 
         foreach ($packages as $package) {
             if ($package instanceof AliasPackage) {
@@ -400,26 +474,30 @@ EOF;
     /**
      * Compiles an ordered list of namespace => path mappings
      *
-     * @param  array            $packageMap                  array of array(package, installDir-relative-to-composer.json)
-     * @param  PackageInterface $mainPackage                 root package instance
-     * @param  bool             $filterOutRequireDevPackages whether to filter out require-dev packages
-     * @return array            array('psr-0' => array('Ns\\Foo' => array('installDir')))
+     * @param  array                $packageMap          array of array(package, installDir-relative-to-composer.json)
+     * @param  RootPackageInterface $rootPackage         root package instance
+     * @param  bool|string[]        $filteredDevPackages If an array, the list of packages that must be removed. If bool, whether to filter out require-dev packages
+     * @return array                array('psr-0' => array('Ns\\Foo' => array('installDir')))
      */
-    public function parseAutoloads(array $packageMap, PackageInterface $mainPackage, $filterOutRequireDevPackages = false)
+    public function parseAutoloads(array $packageMap, PackageInterface $rootPackage, $filteredDevPackages = false)
     {
-        $mainPackageMap = array_shift($packageMap);
-        if ($filterOutRequireDevPackages) {
-            $packageMap = $this->filterPackageMap($packageMap, $mainPackage);
+        $rootPackageMap = array_shift($packageMap);
+        if (is_array($filteredDevPackages)) {
+            $packageMap = array_filter($packageMap, function ($item) use ($filteredDevPackages) {
+                return !in_array($item[0]->getName(), $filteredDevPackages, true);
+            });
+        } elseif ($filteredDevPackages) {
+            $packageMap = $this->filterPackageMap($packageMap, $rootPackage);
         }
         $sortedPackageMap = $this->sortPackageMap($packageMap);
-        $sortedPackageMap[] = $mainPackageMap;
-        array_unshift($packageMap, $mainPackageMap);
+        $sortedPackageMap[] = $rootPackageMap;
+        array_unshift($packageMap, $rootPackageMap);
 
-        $psr0 = $this->parseAutoloadsType($packageMap, 'psr-0', $mainPackage);
-        $psr4 = $this->parseAutoloadsType($packageMap, 'psr-4', $mainPackage);
-        $classmap = $this->parseAutoloadsType(array_reverse($sortedPackageMap), 'classmap', $mainPackage);
-        $files = $this->parseAutoloadsType($sortedPackageMap, 'files', $mainPackage);
-        $exclude = $this->parseAutoloadsType($sortedPackageMap, 'exclude-from-classmap', $mainPackage);
+        $psr0 = $this->parseAutoloadsType($packageMap, 'psr-0', $rootPackage);
+        $psr4 = $this->parseAutoloadsType($packageMap, 'psr-4', $rootPackage);
+        $classmap = $this->parseAutoloadsType(array_reverse($sortedPackageMap), 'classmap', $rootPackage);
+        $files = $this->parseAutoloadsType($sortedPackageMap, 'files', $rootPackage);
+        $exclude = $this->parseAutoloadsType($sortedPackageMap, 'exclude-from-classmap', $rootPackage);
 
         krsort($psr0);
         krsort($psr4);
@@ -458,7 +536,7 @@ EOF;
         if (isset($autoloads['classmap'])) {
             $excluded = null;
             if (!empty($autoloads['exclude-from-classmap'])) {
-                $excluded = '{(' . implode('|', $autoloads['exclude-from-classmap']) . ')}';
+                $excluded = $autoloads['exclude-from-classmap'];
             }
 
             $scannedFiles = array();
@@ -570,6 +648,158 @@ EOF;
         return $baseDir . (($path !== false) ? var_export($path, true) : "");
     }
 
+    protected function getPlatformCheck(array $packageMap, array $ignorePlatformReqs, $checkPlatform, array $devPackageNames)
+    {
+        $lowestPhpVersion = Bound::zero();
+        $requiredExtensions = array();
+        $extensionProviders = array();
+
+        foreach ($packageMap as $item) {
+            $package = $item[0];
+            foreach (array_merge($package->getReplaces(), $package->getProvides()) as $link) {
+                if (preg_match('{^ext-(.+)$}iD', $link->getTarget(), $match)) {
+                    $extensionProviders[$match[1]][] = $link->getConstraint() ?: new MatchAllConstraint();
+                }
+            }
+        }
+
+        foreach ($packageMap as $item) {
+            $package = $item[0];
+            // skip dev dependencies platform requirements as platform-check really should only be a production safeguard
+            if (in_array($package->getName(), $devPackageNames, true)) {
+                continue;
+            }
+
+            foreach ($package->getRequires() as $link) {
+                if (in_array($link->getTarget(), $ignorePlatformReqs, true)) {
+                    continue;
+                }
+
+                if ('php' === $link->getTarget() && ($constraint = $link->getConstraint())) {
+                    if ($constraint->getLowerBound()->compareTo($lowestPhpVersion, '>')) {
+                        $lowestPhpVersion = $constraint->getLowerBound();
+                    }
+                }
+
+                if ($checkPlatform === true && preg_match('{^ext-(.+)$}iD', $link->getTarget(), $match)) {
+                    // skip extension checks if they have a valid provider/replacer
+                    if (isset($extensionProviders[$match[1]])) {
+                        foreach ($extensionProviders[$match[1]] as $provided) {
+                            if (!$link->getConstraint() || $provided->matches($link->getConstraint())) {
+                                continue 2;
+                            }
+                        }
+                    }
+
+                    if ($match[1] === 'zend-opcache') {
+                        $match[1] = 'zend opcache';
+                    }
+
+                    $extension = var_export($match[1], true);
+                    if ($match[1] === 'pcntl' || $match[1] === 'readline') {
+                        $requiredExtensions[$extension] = "PHP_SAPI !== 'cli' || extension_loaded($extension) || \$missingExtensions[] = $extension;\n";
+                    } else {
+                        $requiredExtensions[$extension] = "extension_loaded($extension) || \$missingExtensions[] = $extension;\n";
+                    }
+                }
+            }
+        }
+
+        ksort($requiredExtensions);
+
+        $formatToPhpVersionId = function (Bound $bound) {
+            if ($bound->isZero()) {
+                return 0;
+            }
+
+            if ($bound->isPositiveInfinity()) {
+                return 99999;
+            }
+
+            $version = str_replace('-', '.', $bound->getVersion());
+            $chunks = array_map('intval', explode('.', $version));
+
+            return $chunks[0] * 10000 + $chunks[1] * 100 + $chunks[2];
+        };
+
+        $formatToHumanReadable = function (Bound $bound) {
+            if ($bound->isZero()) {
+                return 0;
+            }
+
+            if ($bound->isPositiveInfinity()) {
+                return 99999;
+            }
+
+            $version = str_replace('-', '.', $bound->getVersion());
+            $chunks = explode('.', $version);
+            $chunks = array_slice($chunks, 0, 3);
+
+            return implode('.', $chunks);
+        };
+
+        $requiredPhp = '';
+        $requiredPhpError = '';
+        if (!$lowestPhpVersion->isZero()) {
+            $operator = $lowestPhpVersion->isInclusive() ? '>=' : '>';
+            $requiredPhp = 'PHP_VERSION_ID '.$operator.' '.$formatToPhpVersionId($lowestPhpVersion);
+            $requiredPhpError = '"'.$operator.' '.$formatToHumanReadable($lowestPhpVersion).'"';
+        }
+
+        if ($requiredPhp) {
+            $requiredPhp = <<<PHP_CHECK
+
+if (!($requiredPhp)) {
+    \$issues[] = 'Your Composer dependencies require a PHP version $requiredPhpError. You are running ' . PHP_VERSION . '.';
+}
+
+PHP_CHECK;
+        }
+
+        $requiredExtensions = implode('', $requiredExtensions);
+        if ('' !== $requiredExtensions) {
+            $requiredExtensions = <<<EXT_CHECKS
+
+\$missingExtensions = array();
+$requiredExtensions
+if (\$missingExtensions) {
+    \$issues[] = 'Your Composer dependencies require the following PHP extensions to be installed: ' . implode(', ', \$missingExtensions) . '.';
+}
+
+EXT_CHECKS;
+        }
+
+        if (!$requiredPhp && !$requiredExtensions) {
+            return null;
+        }
+
+        return <<<PLATFORM_CHECK
+<?php
+
+// platform_check.php @generated by Composer
+
+\$issues = array();
+${requiredPhp}${requiredExtensions}
+if (\$issues) {
+    if (!headers_sent()) {
+        header('HTTP/1.1 500 Internal Server Error');
+    }
+    if (!ini_get('display_errors')) {
+        if (PHP_SAPI === 'cli' || PHP_SAPI === 'phpdbg') {
+            fwrite(STDERR, 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . implode(PHP_EOL, \$issues) . PHP_EOL.PHP_EOL);
+        } elseif (!headers_sent()) {
+            echo 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . str_replace('You are running '.PHP_VERSION.'.', '', implode(PHP_EOL, \$issues)) . PHP_EOL.PHP_EOL;
+        }
+    }
+    trigger_error(
+        'Composer detected issues in your platform: ' . implode(' ', \$issues),
+        E_USER_ERROR
+    );
+}
+
+PLATFORM_CHECK;
+    }
+
     protected function getAutoloadFile($vendorPathToTargetDirCode, $suffix)
     {
         $lastChar = $vendorPathToTargetDirCode[strlen($vendorPathToTargetDirCode) - 1];
@@ -591,7 +821,7 @@ return ComposerAutoloaderInit$suffix::ge
 AUTOLOAD;
     }
 
-    protected function getAutoloadRealFile($useClassMap, $useIncludePath, $targetDirLoader, $useIncludeFiles, $vendorPathCode, $appBaseDirCode, $suffix, $useGlobalIncludePath, $prependAutoloader, $staticPhpVersion = 70000)
+    protected function getAutoloadRealFile($useClassMap, $useIncludePath, $targetDirLoader, $useIncludeFiles, $vendorPathCode, $appBaseDirCode, $suffix, $useGlobalIncludePath, $prependAutoloader, $staticPhpVersion, $checkPlatform)
     {
         $file = <<<HEADER
 <?php
@@ -618,12 +848,24 @@ class ComposerAutoloaderInit$suffix
             return self::\$loader;
         }
 
+
+HEADER;
+
+        if ($checkPlatform) {
+            $file .= <<<'PLATFORM_CHECK'
+        require __DIR__ . '/platform_check.php';
+
+
+PLATFORM_CHECK;
+        }
+
+        $file .= <<<CLASSLOADER_INIT
         spl_autoload_register(array('ComposerAutoloaderInit$suffix', 'loadClassLoader'), true, $prependAutoloader);
-        self::\$loader = \$loader = new \\Composer\\Autoload\\ClassLoader();
+        self::\$loader = \$loader = new \\Composer\\Autoload\\ClassLoader(\\dirname(\\dirname(__FILE__)));
         spl_autoload_unregister(array('ComposerAutoloaderInit$suffix', 'loadClassLoader'));
 
 
-HEADER;
+CLASSLOADER_INIT;
 
         if ($useIncludePath) {
             $file .= <<<'INCLUDE_PATH'
@@ -638,7 +880,7 @@ INCLUDE_PATH;
         $file .= <<<STATIC_INIT
         \$useStaticLoader = PHP_VERSION_ID >= $staticPhpVersion && !defined('HHVM_VERSION') && (!function_exists('zend_loader_file_encoded') || !zend_loader_file_encoded());
         if (\$useStaticLoader) {
-            require_once __DIR__ . '/autoload_static.php';
+            require __DIR__ . '/autoload_static.php';
 
             call_user_func(\Composer\Autoload\ComposerStaticInit$suffix::getInitializer(\$loader));
         } else {
@@ -681,9 +923,9 @@ CLASSMAPAUTHORITATIVE;
         }
 
         if ($this->apcu) {
-            $apcuPrefix = substr(base64_encode(md5(uniqid('', true), true)), 0, -3);
+            $apcuPrefix = var_export(($this->apcuPrefix !== null ? $this->apcuPrefix : substr(base64_encode(md5(uniqid('', true), true)), 0, -3)), true);
             $file .= <<<APCU
-        \$loader->setApcuPrefix('$apcuPrefix');
+        \$loader->setApcuPrefix($apcuPrefix);
 
 APCU;
         }
@@ -849,7 +1091,7 @@ $initializer
 INITIALIZER;
     }
 
-    protected function parseAutoloadsType(array $packageMap, $type, PackageInterface $mainPackage)
+    protected function parseAutoloadsType(array $packageMap, $type, RootPackageInterface $rootPackage)
     {
         $autoloads = array();
 
@@ -857,7 +1099,7 @@ INITIALIZER;
             list($package, $installPath) = $item;
 
             $autoload = $package->getAutoload();
-            if ($this->devMode && $package === $mainPackage) {
+            if ($this->devMode && $package === $rootPackage) {
                 $autoload = array_merge_recursive($autoload, $package->getDevAutoload());
             }
 
@@ -865,7 +1107,7 @@ INITIALIZER;
             if (!isset($autoload[$type]) || !is_array($autoload[$type])) {
                 continue;
             }
-            if (null !== $package->getTargetDir() && $package !== $mainPackage) {
+            if (null !== $package->getTargetDir() && $package !== $rootPackage) {
                 $installPath = substr($installPath, 0, -strlen('/'.$package->getTargetDir()));
             }
 
@@ -873,7 +1115,7 @@ INITIALIZER;
                 foreach ((array) $paths as $path) {
                     if (($type === 'files' || $type === 'classmap' || $type === 'exclude-from-classmap') && $package->getTargetDir() && !is_readable($installPath.'/'.$path)) {
                         // remove target-dir from file paths of the root package
-                        if ($package === $mainPackage) {
+                        if ($package === $rootPackage) {
                             $targetDir = str_replace('\\<dirsep\\>', '[\\\\/]', preg_quote(str_replace(array('/', '\\'), '<dirsep>', $package->getTargetDir())));
                             $path = ltrim(preg_replace('{^'.$targetDir.'}', '', ltrim($path, '\\/')), '\\/');
                         } else {
@@ -887,8 +1129,7 @@ INITIALIZER;
                         $path = preg_replace('{/+}', '/', preg_quote(trim(strtr($path, '\\', '/'), '/')));
 
                         // add support for wildcards * and **
-                        $path = str_replace('\\*\\*', '.+?', $path);
-                        $path = str_replace('\\*', '[^/]+?', $path);
+                        $path = strtr($path, array('\\*\\*' => '.+?', '\\*' => '[^/]+?'));
 
                         // add support for up-level relative paths
                         $updir = null;
@@ -918,7 +1159,8 @@ INITIALIZER;
                     if ($type === 'files') {
                         $autoloads[$this->getFileIdentifier($package, $path)] = $relativePath;
                         continue;
-                    } elseif ($type === 'classmap') {
+                    }
+                    if ($type === 'classmap') {
                         $autoloads[] = $relativePath;
                         continue;
                     }
@@ -939,11 +1181,11 @@ INITIALIZER;
     /**
      * Filters out dev-dependencies
      *
-     * @param  array            $packageMap
-     * @param  PackageInterface $mainPackage
+     * @param  array                $packageMap
+     * @param  RootPackageInterface $rootPackage
      * @return array
      */
-    protected function filterPackageMap(array $packageMap, PackageInterface $mainPackage)
+    protected function filterPackageMap(array $packageMap, RootPackageInterface $rootPackage)
     {
         $packages = array();
         $include = array();
@@ -972,7 +1214,7 @@ INITIALIZER;
                 }
             }
         };
-        $add($mainPackage);
+        $add($rootPackage);
 
         return array_filter(
             $packageMap,
@@ -1020,51 +1262,4 @@ INITIALIZER;
 
         return $sortedPackageMap;
     }
-
-    /**
-     * Copy file using stream_copy_to_stream to work around https://bugs.php.net/bug.php?id=6463
-     *
-     * @param string $source
-     * @param string $target
-     */
-    protected function safeCopy($source, $target)
-    {
-        if (!file_exists($target) || !file_exists($source) || !$this->filesAreEqual($source, $target)) {
-            $source = fopen($source, 'r');
-            $target = fopen($target, 'w+');
-
-            stream_copy_to_stream($source, $target);
-            fclose($source);
-            fclose($target);
-        }
-    }
-
-    /**
-     * compare 2 files
-     * https://stackoverflow.com/questions/3060125/can-i-use-file-get-contents-to-compare-two-files
-     */
-    private function filesAreEqual($a, $b)
-    {
-        // Check if filesize is different
-        if (filesize($a) !== filesize($b)) {
-            return false;
-        }
-
-        // Check if content is different
-        $ah = fopen($a, 'rb');
-        $bh = fopen($b, 'rb');
-
-        $result = true;
-        while (!feof($ah)) {
-            if (fread($ah, 8192) != fread($bh, 8192)) {
-                $result = false;
-                break;
-            }
-        }
-
-        fclose($ah);
-        fclose($bh);
-
-        return $result;
-    }
 }
diff -pruN 1.10.19-1/src/Composer/Autoload/ClassLoader.php 2.0.9-1/src/Composer/Autoload/ClassLoader.php
--- 1.10.19-1/src/Composer/Autoload/ClassLoader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Autoload/ClassLoader.php	2021-01-27 15:09:27.000000000 +0000
@@ -37,11 +37,13 @@ namespace Composer\Autoload;
  *
  * @author Fabien Potencier <fabien@symfony.com>
  * @author Jordi Boggiano <j.boggiano@seld.be>
- * @see    http://www.php-fig.org/psr/psr-0/
- * @see    http://www.php-fig.org/psr/psr-4/
+ * @see    https://www.php-fig.org/psr/psr-0/
+ * @see    https://www.php-fig.org/psr/psr-4/
  */
 class ClassLoader
 {
+    private $vendorDir;
+
     // PSR-4
     private $prefixLengthsPsr4 = array();
     private $prefixDirsPsr4 = array();
@@ -57,6 +59,13 @@ class ClassLoader
     private $missingClasses = array();
     private $apcuPrefix;
 
+    private static $registeredLoaders = array();
+
+    public function __construct($vendorDir = null)
+    {
+        $this->vendorDir = $vendorDir;
+    }
+
     public function getPrefixes()
     {
         if (!empty($this->prefixesPsr0)) {
@@ -300,6 +309,15 @@ class ClassLoader
     public function register($prepend = false)
     {
         spl_autoload_register(array($this, 'loadClass'), true, $prepend);
+
+        if (null === $this->vendorDir) {
+            //no-op
+        } elseif ($prepend) {
+            self::$registeredLoaders = array($this->vendorDir => $this) + self::$registeredLoaders;
+        } else {
+            unset(self::$registeredLoaders[$this->vendorDir]);
+            self::$registeredLoaders[$this->vendorDir] = $this;
+        }
     }
 
     /**
@@ -308,6 +326,10 @@ class ClassLoader
     public function unregister()
     {
         spl_autoload_unregister(array($this, 'loadClass'));
+
+        if (null !== $this->vendorDir) {
+            unset(self::$registeredLoaders[$this->vendorDir]);
+        }
     }
 
     /**
@@ -367,6 +389,16 @@ class ClassLoader
         return $file;
     }
 
+    /**
+     * Returns the currently registered loaders indexed by their corresponding vendor directories.
+     *
+     * @return self[]
+     */
+    public static function getRegisteredLoaders()
+    {
+        return self::$registeredLoaders;
+    }
+
     private function findFileWithExtension($class, $ext)
     {
         // PSR-4 lookup
diff -pruN 1.10.19-1/src/Composer/Autoload/ClassMapGenerator.php 2.0.9-1/src/Composer/Autoload/ClassMapGenerator.php
--- 1.10.19-1/src/Composer/Autoload/ClassMapGenerator.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Autoload/ClassMapGenerator.php	2021-01-27 15:09:27.000000000 +0000
@@ -51,7 +51,7 @@ class ClassMapGenerator
      * Iterate over all files in the given directory searching for classes
      *
      * @param \Iterator|string $path         The path to search in or an iterator
-     * @param string           $excluded    Regex that matches against the file path that exclude from the classmap.
+     * @param string           $excluded     Regex that matches file paths to be excluded from the classmap
      * @param IOInterface      $io           IO object
      * @param string           $namespace    Optional namespace prefix to filter by
      * @param string           $autoloadType psr-0|psr-4 Optional autoload standard to use mapping rules
@@ -61,11 +61,11 @@ class ClassMapGenerator
      */
     public static function createMap($path, $excluded = null, IOInterface $io = null, $namespace = null, $autoloadType = null, &$scannedFiles = array())
     {
+        $basePath = $path;
         if (is_string($path)) {
-            $basePath = $path;
             if (is_file($path)) {
                 $path = array(new \SplFileInfo($path));
-            } elseif (is_dir($path)) {
+            } elseif (is_dir($path) || strpos($path, '*') !== false) {
                 $path = Finder::create()->files()->followLinks()->name('/\.(php|inc|hh)$/')->in($path);
             } else {
                 throw new \RuntimeException(
@@ -113,10 +113,10 @@ class ClassMapGenerator
 
             $classes = self::findClasses($filePath);
             if (null !== $autoloadType) {
-                list($classes, $validClasses) = self::filterByNamespace($classes, $filePath, $namespace, $autoloadType, $basePath, $io);
+                $classes = self::filterByNamespace($classes, $filePath, $namespace, $autoloadType, $basePath, $io);
 
                 // if no valid class was found in the file then we do not mark it as scanned as it might still be matched by another rule later
-                if ($validClasses) {
+                if ($classes) {
                     $scannedFiles[$realPath] = true;
                 }
             } else {
@@ -126,8 +126,7 @@ class ClassMapGenerator
 
             foreach ($classes as $class) {
                 // skip classes not within the given namespace prefix
-                // TODO enable in Composer v1.11 or 2.0 whichever comes first
-                if (/* null === $autoloadType && */ null !== $namespace && '' !== $namespace && 0 !== strpos($class, $namespace)) {
+                if (null === $autoloadType && null !== $namespace && '' !== $namespace && 0 !== strpos($class, $namespace)) {
                     continue;
                 }
 
@@ -148,13 +147,13 @@ class ClassMapGenerator
     /**
      * Remove classes which could not have been loaded by namespace autoloaders
      *
-     * @param array       $classes       found classes in given file
-     * @param string      $filePath      current file
-     * @param string      $baseNamespace prefix of given autoload mapping
-     * @param string      $namespaceType psr-0|psr-4
-     * @param string      $basePath      root directory of given autoload mapping
-     * @param IOInterface $io            IO object
-     * @return array      valid classes
+     * @param  array       $classes       found classes in given file
+     * @param  string      $filePath      current file
+     * @param  string      $baseNamespace prefix of given autoload mapping
+     * @param  string      $namespaceType psr-0|psr-4
+     * @param  string      $basePath      root directory of given autoload mapping
+     * @param  IOInterface $io            IO object
+     * @return array       valid classes
      */
     private static function filterByNamespace($classes, $filePath, $baseNamespace, $namespaceType, $basePath, $io)
     {
@@ -177,8 +176,7 @@ class ClassMapGenerator
                     $className = substr($class, $namespaceLength + 1);
                     $subPath = str_replace('\\', DIRECTORY_SEPARATOR, $namespace)
                         . str_replace('_', DIRECTORY_SEPARATOR, $className);
-                }
-                else {
+                } else {
                     $subPath = str_replace('_', DIRECTORY_SEPARATOR, $class);
                 }
             } elseif ('psr-4' === $namespaceType) {
@@ -196,19 +194,15 @@ class ClassMapGenerator
         // warn only if no valid classes, else silently skip invalid
         if (empty($validClasses)) {
             foreach ($rejectedClasses as $class) {
-                trigger_error(
-                    "Class $class located in ".preg_replace('{^'.preg_quote(getcwd()).'}', '.', $filePath, 1)." does not comply with $namespaceType autoloading standard. It will not autoload anymore in Composer v2.0.",
-                    E_USER_DEPRECATED
-                );
+                if ($io) {
+                    $io->writeError("<warning>Class $class located in ".preg_replace('{^'.preg_quote(getcwd()).'}', '.', $filePath, 1)." does not comply with $namespaceType autoloading standard. Skipping.</warning>");
+                }
             }
 
-            // TODO enable in Composer 2.0
-            //return array();
+            return array();
         }
 
-        // TODO enable in Composer 2.0 & unskip test in AutoloadGeneratorTest::testPSRToClassMapIgnoresNonPSRClasses
-        //return $validClasses;
-        return array($classes, $validClasses);
+        return $validClasses;
     }
 
     /**
@@ -256,7 +250,7 @@ class ClassMapGenerator
         // strip strings
         $contents = preg_replace('{"[^"\\\\]*+(\\\\.[^"\\\\]*+)*+"|\'[^\'\\\\]*+(\\\\.[^\'\\\\]*+)*+\'}s', 'null', $contents);
         // strip leading non-php code if needed
-        if (substr($contents, 0, 2) !== '<?') {
+        if (strpos($contents, '<?') !== 0) {
             $contents = preg_replace('{^.+?<\?}s', '<?', $contents, 1, $replacements);
             if ($replacements === 0) {
                 return array();
diff -pruN 1.10.19-1/src/Composer/Cache.php 2.0.9-1/src/Composer/Cache.php
--- 1.10.19-1/src/Composer/Cache.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Cache.php	2021-01-27 15:09:27.000000000 +0000
@@ -28,21 +28,24 @@ class Cache
     private $io;
     private $root;
     private $enabled = true;
-    private $allowList;
+    private $allowlist;
     private $filesystem;
+    private $readOnly;
 
     /**
      * @param IOInterface $io
      * @param string      $cacheDir   location of the cache
-     * @param string      $allowList  List of characters that are allowed in path names (used in a regex character class)
+     * @param string      $allowlist  List of characters that are allowed in path names (used in a regex character class)
      * @param Filesystem  $filesystem optional filesystem instance
+     * @param bool        $readOnly   whether the cache is in readOnly mode
      */
-    public function __construct(IOInterface $io, $cacheDir, $allowList = 'a-z0-9.', Filesystem $filesystem = null)
+    public function __construct(IOInterface $io, $cacheDir, $allowlist = 'a-z0-9.', Filesystem $filesystem = null, $readOnly = false)
     {
         $this->io = $io;
         $this->root = rtrim($cacheDir, '/\\') . '/';
-        $this->allowList = $allowList;
+        $this->allowlist = $allowlist;
         $this->filesystem = $filesystem ?: new Filesystem();
+        $this->readOnly = (bool) $readOnly;
 
         if (!self::isUsable($cacheDir)) {
             $this->enabled = false;
@@ -59,6 +62,22 @@ class Cache
         }
     }
 
+    /**
+     * @param bool $readOnly
+     */
+    public function setReadOnly($readOnly)
+    {
+        $this->readOnly = (bool) $readOnly;
+    }
+
+    /**
+     * @return bool
+     */
+    public function isReadOnly()
+    {
+        return $this->readOnly;
+    }
+
     public static function isUsable($path)
     {
         return !preg_match('{(^|[\\\\/])(\$null|nul|NUL|/dev/null)([\\\\/]|$)}', $path);
@@ -77,7 +96,7 @@ class Cache
     public function read($file)
     {
         if ($this->enabled) {
-            $file = preg_replace('{[^'.$this->allowList.']}i', '-', $file);
+            $file = preg_replace('{[^'.$this->allowlist.']}i', '-', $file);
             if (file_exists($this->root . $file)) {
                 $this->io->writeError('Reading '.$this->root . $file.' from cache', true, IOInterface::DEBUG);
 
@@ -90,25 +109,26 @@ class Cache
 
     public function write($file, $contents)
     {
-        if ($this->enabled) {
-            $file = preg_replace('{[^'.$this->allowList.']}i', '-', $file);
+        if ($this->enabled && !$this->readOnly) {
+            $file = preg_replace('{[^'.$this->allowlist.']}i', '-', $file);
 
             $this->io->writeError('Writing '.$this->root . $file.' into cache', true, IOInterface::DEBUG);
 
+            $tempFileName = $this->root . $file . uniqid('.', true) . '.tmp';
             try {
-                return file_put_contents($this->root . $file, $contents);
+                return file_put_contents($tempFileName, $contents) !== false && rename($tempFileName, $this->root . $file);
             } catch (\ErrorException $e) {
                 $this->io->writeError('<warning>Failed to write into cache: '.$e->getMessage().'</warning>', true, IOInterface::DEBUG);
                 if (preg_match('{^file_put_contents\(\): Only ([0-9]+) of ([0-9]+) bytes written}', $e->getMessage(), $m)) {
                     // Remove partial file.
-                    unlink($this->root . $file);
+                    unlink($tempFileName);
 
                     $message = sprintf(
                         '<warning>Writing %1$s into cache failed after %2$u of %3$u bytes written, only %4$u bytes of free space available</warning>',
-                        $this->root . $file,
+                        $tempFileName,
                         $m[1],
                         $m[2],
-                        @disk_free_space($this->root . dirname($file))
+                        @disk_free_space(dirname($tempFileName))
                     );
 
                     $this->io->writeError($message);
@@ -128,8 +148,8 @@ class Cache
      */
     public function copyFrom($file, $source)
     {
-        if ($this->enabled) {
-            $file = preg_replace('{[^'.$this->allowList.']}i', '-', $file);
+        if ($this->enabled && !$this->readOnly) {
+            $file = preg_replace('{[^'.$this->allowlist.']}i', '-', $file);
             $this->filesystem->ensureDirectoryExists(dirname($this->root . $file));
 
             if (!file_exists($source)) {
@@ -150,7 +170,7 @@ class Cache
     public function copyTo($file, $target)
     {
         if ($this->enabled) {
-            $file = preg_replace('{[^'.$this->allowList.']}i', '-', $file);
+            $file = preg_replace('{[^'.$this->allowlist.']}i', '-', $file);
             if (file_exists($this->root . $file)) {
                 try {
                     touch($this->root . $file, filemtime($this->root . $file), time());
@@ -177,7 +197,7 @@ class Cache
     public function remove($file)
     {
         if ($this->enabled) {
-            $file = preg_replace('{[^'.$this->allowList.']}i', '-', $file);
+            $file = preg_replace('{[^'.$this->allowlist.']}i', '-', $file);
             if (file_exists($this->root . $file)) {
                 return $this->filesystem->unlink($this->root . $file);
             }
@@ -190,6 +210,7 @@ class Cache
     {
         if ($this->enabled) {
             $this->filesystem->emptyDirectory($this->root);
+
             return true;
         }
 
@@ -229,7 +250,7 @@ class Cache
     public function sha1($file)
     {
         if ($this->enabled) {
-            $file = preg_replace('{[^'.$this->allowList.']}i', '-', $file);
+            $file = preg_replace('{[^'.$this->allowlist.']}i', '-', $file);
             if (file_exists($this->root . $file)) {
                 return sha1_file($this->root . $file);
             }
@@ -241,7 +262,7 @@ class Cache
     public function sha256($file)
     {
         if ($this->enabled) {
-            $file = preg_replace('{[^'.$this->allowList.']}i', '-', $file);
+            $file = preg_replace('{[^'.$this->allowlist.']}i', '-', $file);
             if (file_exists($this->root . $file)) {
                 return hash_file('sha256', $this->root . $file);
             }
diff -pruN 1.10.19-1/src/Composer/Command/ArchiveCommand.php 2.0.9-1/src/Composer/Command/ArchiveCommand.php
--- 1.10.19-1/src/Composer/Command/ArchiveCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/ArchiveCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -22,6 +22,8 @@ use Composer\Script\ScriptEvents;
 use Composer\Plugin\CommandEvent;
 use Composer\Plugin\PluginEvents;
 use Composer\Util\Filesystem;
+use Composer\Util\Loop;
+use Composer\Util\ProcessExecutor;
 use Symfony\Component\Console\Input\InputArgument;
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Input\InputOption;
@@ -111,8 +113,10 @@ EOT
             $archiveManager = $composer->getArchiveManager();
         } else {
             $factory = new Factory;
-            $downloadManager = $factory->createDownloadManager($io, $config);
-            $archiveManager = $factory->createArchiveManager($config, $downloadManager);
+            $process = new ProcessExecutor();
+            $httpDownloader = Factory::createHttpDownloader($io, $config);
+            $downloadManager = $factory->createDownloadManager($io, $config, $httpDownloader, $process);
+            $archiveManager = $factory->createArchiveManager($config, $downloadManager, new Loop($httpDownloader, $process));
         }
 
         if ($packageName) {
diff -pruN 1.10.19-1/src/Composer/Command/BaseCommand.php 2.0.9-1/src/Composer/Command/BaseCommand.php
--- 1.10.19-1/src/Composer/Command/BaseCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/BaseCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -19,7 +19,9 @@ use Composer\Factory;
 use Composer\IO\IOInterface;
 use Composer\IO\NullIO;
 use Composer\Plugin\PreCommandRunEvent;
+use Composer\Package\Version\VersionParser;
 use Composer\Plugin\PluginEvents;
+use Symfony\Component\Console\Helper\Table;
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Output\OutputInterface;
 use Symfony\Component\Console\Command\Command;
@@ -27,6 +29,8 @@ use Symfony\Component\Console\Command\Co
 /**
  * Base class for Composer commands
  *
+ * @method Application getApplication()
+ *
  * @author Ryan Weaver <ryan@knplabs.com>
  * @author Konstantin Kudryashov <ever.zet@gmail.com>
  */
@@ -46,7 +50,7 @@ abstract class BaseCommand extends Comma
      * @param  bool              $required
      * @param  bool|null         $disablePlugins
      * @throws \RuntimeException
-     * @return Composer
+     * @return Composer|null
      */
     public function getComposer($required = true, $disablePlugins = null)
     {
@@ -173,9 +177,44 @@ abstract class BaseCommand extends Comma
 
         if ($input->getOption('prefer-source') || $input->getOption('prefer-dist') || ($keepVcsRequiresPreferSource && $input->hasOption('keep-vcs') && $input->getOption('keep-vcs'))) {
             $preferSource = $input->getOption('prefer-source') || ($keepVcsRequiresPreferSource && $input->hasOption('keep-vcs') && $input->getOption('keep-vcs'));
-            $preferDist = $input->getOption('prefer-dist');
+            $preferDist = (bool) $input->getOption('prefer-dist');
         }
 
         return array($preferSource, $preferDist);
     }
+
+    protected function formatRequirements(array $requirements)
+    {
+        $requires = array();
+        $requirements = $this->normalizeRequirements($requirements);
+        foreach ($requirements as $requirement) {
+            if (!isset($requirement['version'])) {
+                throw new \UnexpectedValueException('Option '.$requirement['name'] .' is missing a version constraint, use e.g. '.$requirement['name'].':^1.0');
+            }
+            $requires[$requirement['name']] = $requirement['version'];
+        }
+
+        return $requires;
+    }
+
+    protected function normalizeRequirements(array $requirements)
+    {
+        $parser = new VersionParser();
+
+        return $parser->parseNameVersionPairs($requirements);
+    }
+
+    protected function renderTable(array $table, OutputInterface $output)
+    {
+        $renderer = new Table($output);
+        $renderer->setStyle('compact');
+        $rendererStyle = $renderer->getStyle();
+        if (method_exists($rendererStyle, 'setVerticalBorderChars')) {
+            $rendererStyle->setVerticalBorderChars('');
+        } else {
+            $rendererStyle->setVerticalBorderChar('');
+        }
+        $rendererStyle->setCellRowContentFormat('%s  ');
+        $renderer->setRows($table)->render();
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Command/BaseDependencyCommand.php 2.0.9-1/src/Composer/Command/BaseDependencyCommand.php
--- 1.10.19-1/src/Composer/Command/BaseDependencyCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/BaseDependencyCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,18 +12,19 @@
 
 namespace Composer\Command;
 
-use Composer\DependencyResolver\Pool;
 use Composer\Package\Link;
 use Composer\Package\PackageInterface;
-use Composer\Repository\ArrayRepository;
+use Composer\Package\RootPackage;
+use Composer\Repository\InstalledArrayRepository;
 use Composer\Repository\CompositeRepository;
+use Composer\Repository\RootPackageRepository;
+use Composer\Repository\InstalledRepository;
 use Composer\Repository\PlatformRepository;
 use Composer\Repository\RepositoryFactory;
 use Composer\Plugin\CommandEvent;
 use Composer\Plugin\PluginEvents;
 use Symfony\Component\Console\Formatter\OutputFormatterStyle;
 use Composer\Package\Version\VersionParser;
-use Symfony\Component\Console\Helper\Table;
 use Symfony\Component\Console\Input\InputArgument;
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Input\InputOption;
@@ -71,15 +72,12 @@ class BaseDependencyCommand extends Base
         $commandEvent = new CommandEvent(PluginEvents::COMMAND, $this->getName(), $input, $output);
         $composer->getEventDispatcher()->dispatch($commandEvent->getName(), $commandEvent);
 
-        // Prepare repositories and set up a pool
         $platformOverrides = $composer->getConfig()->get('platform') ?: array();
-        $repository = new CompositeRepository(array(
-            new ArrayRepository(array($composer->getPackage())),
+        $installedRepo = new InstalledRepository(array(
+            new RootPackageRepository($composer->getPackage()),
             $composer->getRepositoryManager()->getLocalRepository(),
             new PlatformRepository(array(), $platformOverrides),
         ));
-        $pool = new Pool();
-        $pool->addRepository($repository);
 
         // Parse package name and constraint
         list($needle, $textConstraint) = array_pad(
@@ -89,17 +87,17 @@ class BaseDependencyCommand extends Base
         );
 
         // Find packages that are or provide the requested package first
-        $packages = $pool->whatProvides(strtolower($needle));
+        $packages = $installedRepo->findPackagesWithReplacersAndProviders($needle);
         if (empty($packages)) {
             throw new \InvalidArgumentException(sprintf('Could not find package "%s" in your project', $needle));
         }
 
         // If the version we ask for is not installed then we need to locate it in remote repos and add it.
         // This is needed for why-not to resolve conflicts from an uninstalled version against installed packages.
-        if (!$repository->findPackage($needle, $textConstraint)) {
+        if (!$installedRepo->findPackage($needle, $textConstraint)) {
             $defaultRepos = new CompositeRepository(RepositoryFactory::defaultRepos($this->getIO()));
             if ($match = $defaultRepos->findPackage($needle, $textConstraint)) {
-                $repository->addRepository(new ArrayRepository(array(clone $match)));
+                $installedRepo->addRepository(new InstalledArrayRepository(array(clone $match)));
             }
         }
 
@@ -126,7 +124,7 @@ class BaseDependencyCommand extends Base
         $recursive = $renderTree || $input->getOption(self::OPTION_RECURSIVE);
 
         // Resolve dependencies
-        $results = $repository->getDependents($needles, $constraint, $inverted, $recursive);
+        $results = $installedRepo->getDependents($needles, $constraint, $inverted, $recursive);
         if (empty($results)) {
             $extra = (null !== $constraint) ? sprintf(' in versions %smatching %s', $inverted ? 'not ' : '', $textConstraint) : '';
             $this->getIO()->writeError(sprintf(
@@ -170,7 +168,7 @@ class BaseDependencyCommand extends Base
                     continue;
                 }
                 $doubles[$unique] = true;
-                $version = (strpos($package->getPrettyVersion(), 'No version set') === 0) ? '-' : $package->getPrettyVersion();
+                $version = $package->getPrettyVersion() === RootPackage::DEFAULT_PRETTY_VERSION ? '-' : $package->getPrettyVersion();
                 $rows[] = array($package->getPrettyName(), $version, $link->getDescription(), sprintf('%s (%s)', $link->getTarget(), $link->getPrettyConstraint()));
                 if ($children) {
                     $queue = array_merge($queue, $children);
@@ -180,17 +178,7 @@ class BaseDependencyCommand extends Base
             $table = array_merge($rows, $table);
         } while (!empty($results));
 
-        // Render table
-        $renderer = new Table($output);
-        $renderer->setStyle('compact');
-        $rendererStyle = $renderer->getStyle();
-        if (method_exists($rendererStyle, 'setVerticalBorderChars')) {
-            $rendererStyle->setVerticalBorderChars('');
-        } else {
-            $rendererStyle->setVerticalBorderChar('');
-        }
-        $rendererStyle->setCellRowContentFormat('%s  ');
-        $renderer->setRows($table)->render();
+        $this->renderTable($table, $output);
     }
 
     /**
@@ -236,7 +224,7 @@ class BaseDependencyCommand extends Base
             $color = $this->colors[$level % count($this->colors)];
             $prevColor = $this->colors[($level - 1) % count($this->colors)];
             $isLast = (++$idx == $count);
-            $versionText = (strpos($package->getPrettyVersion(), 'No version set') === 0) ? '' : $package->getPrettyVersion();
+            $versionText = $package->getPrettyVersion() === RootPackage::DEFAULT_PRETTY_VERSION ? '' : $package->getPrettyVersion();
             $packageText = rtrim(sprintf('<%s>%s</%1$s> %s', $color, $package->getPrettyName(), $versionText));
             $linkText = sprintf('%s <%s>%s</%2$s> %s', $link->getDescription(), $prevColor, $link->getTarget(), $link->getPrettyConstraint());
             $circularWarn = $children === false ? '(circular dependency aborted here)' : '';
diff -pruN 1.10.19-1/src/Composer/Command/CheckPlatformReqsCommand.php 2.0.9-1/src/Composer/Command/CheckPlatformReqsCommand.php
--- 1.10.19-1/src/Composer/Command/CheckPlatformReqsCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/CheckPlatformReqsCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,13 +13,13 @@
 namespace Composer\Command;
 
 use Composer\Package\Link;
-use Composer\Package\PackageInterface;
 use Composer\Semver\Constraint\Constraint;
-use Symfony\Component\Console\Helper\Table;
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Input\InputOption;
 use Symfony\Component\Console\Output\OutputInterface;
 use Composer\Repository\PlatformRepository;
+use Composer\Repository\RootPackageRepository;
+use Composer\Repository\InstalledRepository;
 
 class CheckPlatformReqsCommand extends BaseCommand
 {
@@ -29,6 +29,7 @@ class CheckPlatformReqsCommand extends B
             ->setDescription('Check that platform requirements are satisfied.')
             ->setDefinition(array(
                 new InputOption('no-dev', null, InputOption::VALUE_NONE, 'Disables checking of require-dev packages requirements.'),
+                new InputOption('lock', null, InputOption::VALUE_NONE, 'Checks requirements only from the lock file, not from installed packages.'),
             ))
             ->setHelp(
                 <<<EOT
@@ -46,22 +47,38 @@ EOT
     {
         $composer = $this->getComposer();
 
-        $requires = $composer->getPackage()->getRequires();
-        if ($input->getOption('no-dev')) {
-            $dependencies = $composer->getLocker()->getLockedRepository(!$input->getOption('no-dev'))->getPackages();
+        $requires = array();
+        $removePackages = array();
+        if ($input->getOption('lock')) {
+            $this->getIO()->writeError('<info>Checking '.($input->getOption('no-dev') ? 'non-dev ' : '').'platform requirements using the lock file</info>');
+            $installedRepo = $composer->getLocker()->getLockedRepository(!$input->getOption('no-dev'));
         } else {
-            $dependencies = $composer->getRepositoryManager()->getLocalRepository()->getPackages();
+            $installedRepo = $composer->getRepositoryManager()->getLocalRepository();
             // fallback to lockfile if installed repo is empty
-            if (!$dependencies) {
-                $dependencies = $composer->getLocker()->getLockedRepository(true)->getPackages();
+            if (!$installedRepo->getPackages()) {
+                $this->getIO()->writeError('<warning>No vendor dir present, checking '.($input->getOption('no-dev') ? 'non-dev ' : '').'platform requirements from the lock file</warning>');
+                $installedRepo = $composer->getLocker()->getLockedRepository(!$input->getOption('no-dev'));
+            } else {
+                if ($input->getOption('no-dev')) {
+                    $removePackages = $installedRepo->getDevPackageNames();
+                }
+
+                $this->getIO()->writeError('<info>Checking '.($input->getOption('no-dev') ? 'non-dev ' : '').'platform requirements for packages in the vendor dir</info>');
             }
+        }
+        if (!$input->getOption('no-dev')) {
             $requires += $composer->getPackage()->getDevRequires();
         }
+
         foreach ($requires as $require => $link) {
             $requires[$require] = array($link);
         }
 
-        foreach ($dependencies as $package) {
+        $installedRepo = new InstalledRepository(array($installedRepo, new RootPackageRepository($composer->getPackage())));
+        foreach ($installedRepo->getPackages() as $package) {
+            if (in_array($package->getName(), $removePackages, true)) {
+                continue;
+            }
             foreach ($package->getRequires() as $require => $link) {
                 $requires[$require][] = $link;
             }
@@ -69,62 +86,78 @@ EOT
 
         ksort($requires);
 
-        $platformRepo = new PlatformRepository(array(), array());
-        $currentPlatformPackages = $platformRepo->getPackages();
-        $currentPlatformPackageMap = array();
-
-        /**
-         * @var PackageInterface $currentPlatformPackage
-         */
-        foreach ($currentPlatformPackages as $currentPlatformPackage) {
-            $currentPlatformPackageMap[$currentPlatformPackage->getName()] = $currentPlatformPackage;
-        }
+        $installedRepo->addRepository(new PlatformRepository(array(), array()));
 
         $results = array();
-
         $exitCode = 0;
 
         /**
          * @var Link[] $links
          */
         foreach ($requires as $require => $links) {
-            if (preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $require)) {
-                if (isset($currentPlatformPackageMap[$require])) {
-                    $pass = true;
-                    $version = $currentPlatformPackageMap[$require]->getVersion();
-
-                    foreach ($links as $link) {
-                        if (!$link->getConstraint()->matches(new Constraint('=', $version))) {
-                            $results[] = array(
-                                $currentPlatformPackageMap[$require]->getPrettyName(),
-                                $currentPlatformPackageMap[$require]->getPrettyVersion(),
-                                $link,
-                                '<error>failed</error>',
-                            );
-                            $pass = false;
+            if (PlatformRepository::isPlatformPackage($require)) {
+                $candidates = $installedRepo->findPackagesWithReplacersAndProviders($require);
+                if ($candidates) {
+                    $reqResults = array();
+                    foreach ($candidates as $candidate) {
+                        $candidateConstraint = null;
+                        if ($candidate->getName() === $require) {
+                            $candidateConstraint = new Constraint('=', $candidate->getVersion());
+                            $candidateConstraint->setPrettyString($candidate->getPrettyVersion());
+                        } else {
+                            foreach (array_merge($candidate->getProvides(), $candidate->getReplaces()) as $link) {
+                                if ($link->getTarget() === $require) {
+                                    $candidateConstraint = $link->getConstraint();
+                                    break;
+                                }
+                            }
+                        }
 
-                            $exitCode = max($exitCode, 1);
+                        // safety check for phpstan, but it should not be possible to get a candidate out of findPackagesWithReplacersAndProviders without a constraint matching $require
+                        if (!$candidateConstraint) {
+                            continue;
+                        }
+
+                        foreach ($links as $link) {
+                            if (!$link->getConstraint()->matches($candidateConstraint)) {
+                                $reqResults[] = array(
+                                    $candidate->getName() === $require ? $candidate->getPrettyName() : $require,
+                                    $candidateConstraint->getPrettyString(),
+                                    $link,
+                                    '<error>failed</error>'.($candidate->getName() === $require ? '' : ' <comment>provided by '.$candidate->getPrettyName().'</comment>'),
+                                );
+
+                                // skip to next candidate
+                                continue 2;
+                            }
                         }
-                    }
 
-                    if ($pass) {
                         $results[] = array(
-                            $currentPlatformPackageMap[$require]->getPrettyName(),
-                            $currentPlatformPackageMap[$require]->getPrettyVersion(),
+                            $candidate->getName() === $require ? $candidate->getPrettyName() : $require,
+                            $candidateConstraint->getPrettyString(),
                             null,
-                            '<info>success</info>',
+                            '<info>success</info>'.($candidate->getName() === $require ? '' : ' <comment>provided by '.$candidate->getPrettyName().'</comment>'),
                         );
+
+                        // candidate matched, skip to next requirement
+                        continue 2;
                     }
-                } else {
-                    $results[] = array(
-                        $require,
-                        'n/a',
-                        $links[0],
-                        '<error>missing</error>',
-                    );
 
-                    $exitCode = max($exitCode, 2);
+                    // show the first error from every failed candidate
+                    $results = array_merge($results, $reqResults);
+                    $exitCode = max($exitCode, 1);
+
+                    continue;
                 }
+
+                $results[] = array(
+                    $require,
+                    'n/a',
+                    $links[0],
+                    '<error>missing</error>',
+                );
+
+                $exitCode = max($exitCode, 2);
             }
         }
 
@@ -135,7 +168,6 @@ EOT
 
     protected function printTable(OutputInterface $output, $results)
     {
-        $table = array();
         $rows = array();
         foreach ($results as $result) {
             /**
@@ -149,18 +181,7 @@ EOT
                 $status,
             );
         }
-        $table = array_merge($rows, $table);
 
-        // Render table
-        $renderer = new Table($output);
-        $renderer->setStyle('compact');
-        $rendererStyle = $renderer->getStyle();
-        if (method_exists($rendererStyle, 'setVerticalBorderChars')) {
-            $rendererStyle->setVerticalBorderChars('');
-        } else {
-            $rendererStyle->setVerticalBorderChar('');
-        }
-        $rendererStyle->setCellRowContentFormat('%s  ');
-        $renderer->setRows($table)->render();
+        $this->renderTable($rows, $output);
     }
 }
diff -pruN 1.10.19-1/src/Composer/Command/ClearCacheCommand.php 2.0.9-1/src/Composer/Command/ClearCacheCommand.php
--- 1.10.19-1/src/Composer/Command/ClearCacheCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/ClearCacheCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -59,6 +59,7 @@ EOT
                 continue;
             }
             $cache = new Cache($io, $cachePath);
+            $cache->setReadOnly($config->get('cache-read-only'));
             if (!$cache->isEnabled()) {
                 $io->writeError("<info>Cache is not enabled ($key): $cachePath</info>");
 
diff -pruN 1.10.19-1/src/Composer/Command/ConfigCommand.php 2.0.9-1/src/Composer/Command/ConfigCommand.php
--- 1.10.19-1/src/Composer/Command/ConfigCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/ConfigCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -73,6 +73,9 @@ class ConfigCommand extends BaseCommand
                 new InputOption('list', 'l', InputOption::VALUE_NONE, 'List configuration settings'),
                 new InputOption('file', 'f', InputOption::VALUE_REQUIRED, 'If you want to choose a different composer.json or config.json'),
                 new InputOption('absolute', null, InputOption::VALUE_NONE, 'Returns absolute paths when fetching *-dir config values instead of relative'),
+                new InputOption('json', 'j', InputOption::VALUE_NONE, 'JSON decode the setting value, to be used with extra.* keys'),
+                new InputOption('merge', 'm', InputOption::VALUE_NONE, 'Merge the setting value with the current value, to be used with extra.* keys in combination with --json'),
+                new InputOption('append', null, InputOption::VALUE_NONE, 'When adding a repository, append it (lowest priority) to the existing ones instead of prepending it (highest priority)'),
                 new InputArgument('setting-key', null, 'Setting key'),
                 new InputArgument('setting-value', InputArgument::IS_ARRAY, 'Setting value'),
             ))
@@ -119,6 +122,10 @@ To add or edit extra properties you can
 
     <comment>%command.full_name% extra.property value</comment>
 
+Or to add a complex value you can use json with:
+
+    <comment>%command.full_name% extra.property --json '{"foo":true, "bar": []}'</comment>
+
 To edit the file in an external editor:
 
     <comment>%command.full_name% --editor</comment>
@@ -236,7 +243,7 @@ EOT
         }
 
         $settingKey = $input->getArgument('setting-key');
-        if (!$settingKey) {
+        if (!$settingKey || !is_string($settingKey)) {
             return 0;
         }
 
@@ -285,7 +292,7 @@ EOT
                 $value = $data;
             } elseif (isset($data['config'][$settingKey])) {
                 $value = $this->config->get($settingKey, $input->getOption('absolute') ? 0 : Config::RELATIVE_PATHS);
-            } elseif (in_array($settingKey, $properties, true) && isset($rawData[$settingKey])) {
+            } elseif (isset($rawData[$settingKey]) && in_array($settingKey, $properties, true)) {
                 $value = $rawData[$settingKey];
             } else {
                 throw new \RuntimeException($settingKey.' is not defined');
@@ -421,6 +428,18 @@ EOT
             'github-expose-hostname' => array($booleanValidator, $booleanNormalizer),
             'htaccess-protect' => array($booleanValidator, $booleanNormalizer),
             'lock' => array($booleanValidator, $booleanNormalizer),
+            'platform-check' => array(
+                function ($val) {
+                    return in_array($val, array('php-only', 'true', 'false', '1', '0'), true);
+                },
+                function ($val) {
+                    if ('php-only' === $val) {
+                        return 'php-only';
+                    }
+
+                    return $val !== 'false' && (bool) $val;
+                },
+            ),
         );
         $multiConfigValues = array(
             'github-protocols' => array(
@@ -558,7 +577,7 @@ EOT
             ),
         );
 
-        if ($input->getOption('global') && (isset($uniqueProps[$settingKey]) || isset($multiProps[$settingKey]) || substr($settingKey, 0, 6) === 'extra.')) {
+        if ($input->getOption('global') && (isset($uniqueProps[$settingKey]) || isset($multiProps[$settingKey]) || strpos($settingKey, 'extra.') === 0)) {
             throw new \InvalidArgumentException('The '.$settingKey.' property can not be set in the global config.json file. Use `composer global config` to apply changes to the global composer.json');
         }
         if ($input->getOption('unset') && (isset($uniqueProps[$settingKey]) || isset($multiProps[$settingKey]))) {
@@ -589,7 +608,7 @@ EOT
                 $this->configSource->addRepository($matches[1], array(
                     'type' => $values[0],
                     'url' => $values[1],
-                ));
+                ), $input->getOption('append'));
 
                 return 0;
             }
@@ -598,13 +617,13 @@ EOT
                 $value = strtolower($values[0]);
                 if (true === $booleanValidator($value)) {
                     if (false === $booleanNormalizer($value)) {
-                        $this->configSource->addRepository($matches[1], false);
+                        $this->configSource->addRepository($matches[1], false, $input->getOption('append'));
 
                         return 0;
                     }
                 } else {
                     $value = JsonFile::parseJson($values[0]);
-                    $this->configSource->addRepository($matches[1], $value);
+                    $this->configSource->addRepository($matches[1], $value, $input->getOption('append'));
 
                     return 0;
                 }
@@ -621,7 +640,21 @@ EOT
                 return 0;
             }
 
-            $this->configSource->addProperty($settingKey, $values[0]);
+            $value = $values[0];
+            if ($input->getOption('json')) {
+                $value = JsonFile::parseJson($value);
+                if ($input->getOption('merge')) {
+                    $currentValue = $this->configFile->read();
+                    $bits = explode('.', $settingKey);
+                    foreach ($bits as $bit) {
+                        $currentValue = isset($currentValue[$bit]) ? $currentValue[$bit] : null;
+                    }
+                    if (is_array($currentValue)) {
+                        $value = array_merge($currentValue, $value);
+                    }
+                }
+            }
+            $this->configSource->addProperty($settingKey, $value);
 
             return 0;
         }
@@ -681,6 +714,9 @@ EOT
                 }
                 $this->configSource->removeConfigSetting($matches[1].'.'.$matches[2]);
                 $this->authConfigSource->addConfigSetting($matches[1].'.'.$matches[2], array('consumer-key' => $values[0], 'consumer-secret' => $values[1]));
+            } elseif ($matches[1] === 'gitlab-token' && 2 === count($values)) {
+                $this->configSource->removeConfigSetting($matches[1].'.'.$matches[2]);
+                $this->authConfigSource->addConfigSetting($matches[1].'.'.$matches[2], array('username' => $values[0], 'token' => $values[1]));
             } elseif (in_array($matches[1], array('github-oauth', 'gitlab-oauth', 'gitlab-token', 'bearer'), true)) {
                 if (1 !== count($values)) {
                     throw new \RuntimeException('Too many arguments, expected only one token');
diff -pruN 1.10.19-1/src/Composer/Command/CreateProjectCommand.php 2.0.9-1/src/Composer/Command/CreateProjectCommand.php
--- 1.10.19-1/src/Composer/Command/CreateProjectCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/CreateProjectCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,11 +16,9 @@ use Composer\Config;
 use Composer\Factory;
 use Composer\Installer;
 use Composer\Installer\ProjectInstaller;
-use Composer\Installer\InstallationManager;
 use Composer\Installer\SuggestedPackagesReporter;
 use Composer\IO\IOInterface;
 use Composer\Package\BasePackage;
-use Composer\DependencyResolver\Pool;
 use Composer\DependencyResolver\Operation\InstallOperation;
 use Composer\Package\Version\VersionSelector;
 use Composer\Package\AliasPackage;
@@ -28,6 +26,7 @@ use Composer\Repository\RepositoryFactor
 use Composer\Repository\CompositeRepository;
 use Composer\Repository\PlatformRepository;
 use Composer\Repository\InstalledFilesystemRepository;
+use Composer\Repository\RepositorySet;
 use Composer\Script\ScriptEvents;
 use Composer\Util\Silencer;
 use Symfony\Component\Console\Input\InputArgument;
@@ -38,8 +37,8 @@ use Symfony\Component\Finder\Finder;
 use Composer\Json\JsonFile;
 use Composer\Config\JsonConfigSource;
 use Composer\Util\Filesystem;
+use Composer\Util\ProcessExecutor;
 use Composer\Package\Version\VersionParser;
-use Composer\EventDispatcher\EventDispatcher;
 
 /**
  * Install a package as new project into new directory.
@@ -68,9 +67,9 @@ class CreateProjectCommand extends BaseC
                 new InputOption('stability', 's', InputOption::VALUE_REQUIRED, 'Minimum-stability allowed (unless a version is specified).'),
                 new InputOption('prefer-source', null, InputOption::VALUE_NONE, 'Forces installation from package sources when possible, including VCS information.'),
                 new InputOption('prefer-dist', null, InputOption::VALUE_NONE, 'Forces installation from package dist even for dev versions.'),
-                new InputOption('repository', null, InputOption::VALUE_REQUIRED, 'Pick a different repository (as url or json config) to look for the package.'),
+                new InputOption('repository', null, InputOption::VALUE_REQUIRED | InputOption::VALUE_IS_ARRAY, 'Add custom repositories to look the package up, either by URL or using JSON arrays'),
                 new InputOption('repository-url', null, InputOption::VALUE_REQUIRED, 'DEPRECATED: Use --repository instead.'),
-                new InputOption('add-repository', null, InputOption::VALUE_NONE, 'Add the repository option to the composer.json.'),
+                new InputOption('add-repository', null, InputOption::VALUE_NONE, 'Add the custom repository in the composer.json. If a lock file is present it will be deleted and an update will be run instead of install.'),
                 new InputOption('dev', null, InputOption::VALUE_NONE, 'Enables installation of require-dev packages (enabled by default, only present for BC).'),
                 new InputOption('no-dev', null, InputOption::VALUE_NONE, 'Disables installation of require-dev packages.'),
                 new InputOption('no-custom-installers', null, InputOption::VALUE_NONE, 'DEPRECATED: Use no-plugins instead.'),
@@ -80,7 +79,9 @@ class CreateProjectCommand extends BaseC
                 new InputOption('keep-vcs', null, InputOption::VALUE_NONE, 'Whether to prevent deleting the vcs folder.'),
                 new InputOption('remove-vcs', null, InputOption::VALUE_NONE, 'Whether to force deletion of the vcs folder without prompting.'),
                 new InputOption('no-install', null, InputOption::VALUE_NONE, 'Whether to skip installation of the package dependencies.'),
-                new InputOption('ignore-platform-reqs', null, InputOption::VALUE_NONE, 'Ignore platform requirements (php & ext- packages).'),
+                new InputOption('ignore-platform-req', null, InputOption::VALUE_REQUIRED | InputOption::VALUE_IS_ARRAY, 'Ignore a specific platform requirement (php & ext- packages).'),
+                new InputOption('ignore-platform-reqs', null, InputOption::VALUE_NONE, 'Ignore all platform requirements (php & ext- packages).'),
+                new InputOption('ask', null, InputOption::VALUE_NONE, 'Whether to ask for project directory.'),
             ))
             ->setHelp(
                 <<<EOT
@@ -127,6 +128,13 @@ EOT
             $input->setOption('no-plugins', true);
         }
 
+        if ($input->isInteractive() && $input->getOption('ask')) {
+            $parts = explode("/", strtolower($input->getArgument('package')), 2);
+            $input->setArgument('directory', $io->ask('New project directory [<comment>'.array_pop($parts).'</comment>]: '));
+        }
+
+        $ignorePlatformReqs = $input->getOption('ignore-platform-reqs') ?: ($input->getOption('ignore-platform-req') ?: false);
+
         return $this->installProject(
             $io,
             $config,
@@ -143,49 +151,60 @@ EOT
             $input->getOption('no-scripts'),
             $input->getOption('no-progress'),
             $input->getOption('no-install'),
-            $input->getOption('ignore-platform-reqs'),
+            $ignorePlatformReqs,
             !$input->getOption('no-secure-http'),
             $input->getOption('add-repository')
         );
     }
 
-    public function installProject(IOInterface $io, Config $config, InputInterface $input, $packageName, $directory = null, $packageVersion = null, $stability = 'stable', $preferSource = false, $preferDist = false, $installDevPackages = false, $repository = null, $disablePlugins = false, $noScripts = false, $noProgress = false, $noInstall = false, $ignorePlatformReqs = false, $secureHttp = true, $addRepository = false)
+    public function installProject(IOInterface $io, Config $config, InputInterface $input, $packageName, $directory = null, $packageVersion = null, $stability = 'stable', $preferSource = false, $preferDist = false, $installDevPackages = false, $repositories = null, $disablePlugins = false, $noScripts = false, $noProgress = false, $noInstall = false, $ignorePlatformReqs = false, $secureHttp = true, $addRepository = false)
     {
         $oldCwd = getcwd();
 
+        if ($repositories !== null && !is_array($repositories)) {
+            $repositories = (array) $repositories;
+        }
+
         // we need to manually load the configuration to pass the auth credentials to the io interface!
         $io->loadConfiguration($config);
 
         $this->suggestedPackagesReporter = new SuggestedPackagesReporter($io);
 
         if ($packageName !== null) {
-            $installedFromVcs = $this->installRootPackage($io, $config, $packageName, $directory, $packageVersion, $stability, $preferSource, $preferDist, $installDevPackages, $repository, $disablePlugins, $noScripts, $noProgress, $ignorePlatformReqs, $secureHttp);
+            $installedFromVcs = $this->installRootPackage($io, $config, $packageName, $directory, $packageVersion, $stability, $preferSource, $preferDist, $installDevPackages, $repositories, $disablePlugins, $noScripts, $noProgress, $ignorePlatformReqs, $secureHttp);
         } else {
             $installedFromVcs = false;
         }
 
+        if ($repositories !== null && $addRepository && is_file('composer.lock')) {
+            unlink('composer.lock');
+        }
+
         $composer = Factory::create($io, null, $disablePlugins);
 
         // add the repository to the composer.json and use it for the install run later
-        if ($repository !== null && $addRepository) {
-            if ($composer->getLocker()->isLocked()) {
-                $io->writeError('<error>Adding a repository when creating a project that provides a composer.lock file is not supported</error>');
+        if ($repositories !== null && $addRepository) {
+            foreach ($repositories as $index => $repo) {
+                $repoConfig = RepositoryFactory::configFromString($io, $composer->getConfig(), $repo, true);
+                $composerJsonRepositoriesConfig = $composer->getConfig()->getRepositories();
+                $name = RepositoryFactory::generateRepositoryName($index, $repoConfig, $composerJsonRepositoriesConfig);
+                $configSource = new JsonConfigSource(new JsonFile('composer.json'));
+
+                if (
+                    (isset($repoConfig['packagist']) && $repoConfig === array('packagist' => false))
+                    || (isset($repoConfig['packagist.org']) && $repoConfig === array('packagist.org' => false))
+                ) {
+                    $configSource->addRepository('packagist.org', false);
+                } else {
+                    $configSource->addRepository($name, $repoConfig, false);
+                }
 
-                return false;
+                $composer = Factory::create($io, null, $disablePlugins);
             }
-
-            $repoConfig = RepositoryFactory::configFromString($io, $composer->getConfig(), $repository, true);
-            $composerJsonRepositoriesConfig = $composer->getConfig()->getRepositories();
-            $name = RepositoryFactory::generateRepositoryName(0, $repoConfig, $composerJsonRepositoriesConfig);
-            $configSource = new JsonConfigSource(new JsonFile('composer.json'));
-            $configSource->addRepository($name, $repoConfig);
-
-            $composer = Factory::create($io, null, $disablePlugins);
         }
 
-        $composer->getDownloadManager()->setOutputProgress(!$noProgress);
-
-        $fs = new Filesystem();
+        $process = new ProcessExecutor($io);
+        $fs = new Filesystem($process);
 
         if ($noScripts === false) {
             // dispatch event
@@ -198,6 +217,8 @@ EOT
 
         // install dependencies of the created project
         if ($noInstall === false) {
+            $composer->getInstallationManager()->setOutputProgress(!$noProgress);
+
             $installer = Installer::create($io, $composer);
             $installer->setPreferSource($preferSource)
                 ->setPreferDist($preferDist)
@@ -209,6 +230,10 @@ EOT
                 ->setClassMapAuthoritative($config->get('classmap-authoritative'))
                 ->setApcuAutoloader($config->get('apcu-autoloader'));
 
+            if (!$composer->getLocker()->isLocked()) {
+                $installer->setUpdate(true);
+            }
+
             if ($disablePlugins) {
                 $installer->disablePlugins();
             }
@@ -226,7 +251,7 @@ EOT
             && (
                 $input->getOption('remove-vcs')
                 || !$io->isInteractive()
-                || $io->askConfirmation('<info>Do you want to remove the existing VCS (.git, .svn..) history?</info> [<comment>Y,n</comment>]? ', true)
+                || $io->askConfirmation('<info>Do you want to remove the existing VCS (.git, .svn..) history?</info> [<comment>Y,n</comment>]? ')
             )
         ) {
             $finder = new Finder();
@@ -281,22 +306,12 @@ EOT
         return 0;
     }
 
-    protected function installRootPackage(IOInterface $io, Config $config, $packageName, $directory = null, $packageVersion = null, $stability = 'stable', $preferSource = false, $preferDist = false, $installDevPackages = false, $repository = null, $disablePlugins = false, $noScripts = false, $noProgress = false, $ignorePlatformReqs = false, $secureHttp = true)
+    protected function installRootPackage(IOInterface $io, Config $config, $packageName, $directory = null, $packageVersion = null, $stability = 'stable', $preferSource = false, $preferDist = false, $installDevPackages = false, array $repositories = null, $disablePlugins = false, $noScripts = false, $noProgress = false, $ignorePlatformReqs = false, $secureHttp = true)
     {
         if (!$secureHttp) {
             $config->merge(array('config' => array('secure-http' => false)));
         }
 
-        $composer = Factory::create($io, $config->all(), $disablePlugins);
-        $config = $composer->getConfig();
-        $rm = $composer->getRepositoryManager();
-
-        if (null === $repository) {
-            $sourceRepo = new CompositeRepository(RepositoryFactory::defaultRepos($io, $config, $rm));
-        } else {
-            $sourceRepo = RepositoryFactory::fromString($io, $config, $repository, true, $rm);
-        }
-
         $parser = new VersionParser();
         $requirements = $parser->parseNameVersionPairs(array($packageName));
         $name = strtolower($requirements[0]['name']);
@@ -310,7 +325,8 @@ EOT
             $directory = getcwd() . DIRECTORY_SEPARATOR . array_pop($parts);
         }
 
-        $fs = new Filesystem();
+        $process = new ProcessExecutor($io);
+        $fs = new Filesystem($process);
         if (!$fs->isAbsolutePath($directory)) {
             $directory = getcwd() . DIRECTORY_SEPARATOR . $directory;
         }
@@ -320,7 +336,8 @@ EOT
         if (file_exists($directory)) {
             if (!is_dir($directory)) {
                 throw new \InvalidArgumentException('Cannot create project directory at "'.$directory.'", it exists as a file.');
-            } elseif (!$fs->isDirEmpty($directory)) {
+            }
+            if (!$fs->isDirEmpty($directory)) {
                 throw new \InvalidArgumentException('Project directory "'.$directory.'" is not empty.');
             }
         }
@@ -339,28 +356,37 @@ EOT
             throw new \InvalidArgumentException('Invalid stability provided ('.$stability.'), must be one of: '.implode(', ', array_keys(BasePackage::$stabilities)));
         }
 
-        $pool = new Pool($stability);
-        $pool->addRepository($sourceRepo);
+        $composer = Factory::create($io, $config->all(), $disablePlugins);
+        $config = $composer->getConfig();
+        $rm = $composer->getRepositoryManager();
 
-        $phpVersion = null;
-        $prettyPhpVersion = null;
-        if (!$ignorePlatformReqs) {
-            $platformOverrides = $config->get('platform') ?: array();
-            // initialize $this->repos as it is used by the parent InitCommand
-            $platform = new PlatformRepository(array(), $platformOverrides);
-            $phpPackage = $platform->findPackage('php', '*');
-            $phpVersion = $phpPackage->getVersion();
-            $prettyPhpVersion = $phpPackage->getPrettyVersion();
+        $repositorySet = new RepositorySet($stability);
+        if (null === $repositories) {
+            $repositorySet->addRepository(new CompositeRepository(RepositoryFactory::defaultRepos($io, $config, $rm)));
+        } else {
+            foreach ($repositories as $repo) {
+                $repoConfig = RepositoryFactory::configFromString($io, $config, $repo, true);
+                if (
+                    (isset($repoConfig['packagist']) && $repoConfig === array('packagist' => false))
+                    || (isset($repoConfig['packagist.org']) && $repoConfig === array('packagist.org' => false))
+                ) {
+                    continue;
+                }
+                $repositorySet->addRepository(RepositoryFactory::createRepo($io, $config, $repoConfig, $rm));
+            }
         }
 
+        $platformOverrides = $config->get('platform') ?: array();
+        $platformRepo = new PlatformRepository(array(), $platformOverrides);
+
         // find the latest version if there are multiple
-        $versionSelector = new VersionSelector($pool);
-        $package = $versionSelector->findBestCandidate($name, $packageVersion, $phpVersion, $stability);
+        $versionSelector = new VersionSelector($repositorySet, $platformRepo);
+        $package = $versionSelector->findBestCandidate($name, $packageVersion, $stability, $ignorePlatformReqs);
 
         if (!$package) {
             $errorMessage = "Could not find package $name with " . ($packageVersion ? "version $packageVersion" : "stability $stability");
-            if ($phpVersion && $versionSelector->findBestCandidate($name, $packageVersion, null, $stability)) {
-                throw new \InvalidArgumentException($errorMessage .' in a version installable using your PHP version '.$prettyPhpVersion.'.');
+            if (true !== $ignorePlatformReqs && $versionSelector->findBestCandidate($name, $packageVersion, $stability, true)) {
+                throw new \InvalidArgumentException($errorMessage .' in a version installable using your PHP version, PHP extensions and Composer version.');
             }
 
             throw new \InvalidArgumentException($errorMessage .'.');
@@ -378,6 +404,22 @@ EOT
                 });
             }
         }
+        // handler Ctrl+C for Windows on PHP 7.4+
+        if (function_exists('sapi_windows_set_ctrl_handler')) {
+            @mkdir($directory, 0777, true);
+            if ($realDir = realpath($directory)) {
+                sapi_windows_set_ctrl_handler(function () use ($realDir) {
+                    $fs = new Filesystem();
+                    $fs->removeDirectory($realDir);
+                    exit(130);
+                });
+            }
+        }
+
+        // avoid displaying 9999999-dev as version if default-branch was selected
+        if ($package instanceof AliasPackage && $package->getPrettyVersion() === VersionParser::DEFAULT_BRANCH_ALIAS) {
+            $package = $package->getAliasOf();
+        }
 
         $io->writeError('<info>Installing ' . $package->getName() . ' (' . $package->getFullPrettyVersion(false) . ')</info>');
 
@@ -391,13 +433,13 @@ EOT
 
         $dm = $composer->getDownloadManager();
         $dm->setPreferSource($preferSource)
-            ->setPreferDist($preferDist)
-            ->setOutputProgress(!$noProgress);
+            ->setPreferDist($preferDist);
 
-        $projectInstaller = new ProjectInstaller($directory, $dm);
+        $projectInstaller = new ProjectInstaller($directory, $dm, $fs);
         $im = $composer->getInstallationManager();
+        $im->setOutputProgress(!$noProgress);
         $im->addInstaller($projectInstaller);
-        $im->install(new InstalledFilesystemRepository(new JsonFile('php://memory')), new InstallOperation($package));
+        $im->execute(new InstalledFilesystemRepository(new JsonFile('php://memory')), array(new InstallOperation($package)));
         $im->notifyInstalls($io);
 
         // collect suggestions
diff -pruN 1.10.19-1/src/Composer/Command/DependsCommand.php 2.0.9-1/src/Composer/Command/DependsCommand.php
--- 1.10.19-1/src/Composer/Command/DependsCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/DependsCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -52,6 +52,6 @@ EOT
      */
     protected function execute(InputInterface $input, OutputInterface $output)
     {
-        return parent::doExecute($input, $output, false);
+        return parent::doExecute($input, $output);
     }
 }
diff -pruN 1.10.19-1/src/Composer/Command/DiagnoseCommand.php 2.0.9-1/src/Composer/Command/DiagnoseCommand.php
--- 1.10.19-1/src/Composer/Command/DiagnoseCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/DiagnoseCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -22,21 +22,22 @@ use Composer\Plugin\PluginEvents;
 use Composer\Util\ConfigValidator;
 use Composer\Util\IniHelper;
 use Composer\Util\ProcessExecutor;
-use Composer\Util\RemoteFilesystem;
+use Composer\Util\HttpDownloader;
 use Composer\Util\StreamContextFactory;
 use Composer\SelfUpdate\Keys;
 use Composer\SelfUpdate\Versions;
 use Composer\IO\NullIO;
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Output\OutputInterface;
+use Symfony\Component\Process\ExecutableFinder;
 
 /**
  * @author Jordi Boggiano <j.boggiano@seld.be>
  */
 class DiagnoseCommand extends BaseCommand
 {
-    /** @var RemoteFilesystem */
-    protected $rfs;
+    /** @var HttpDownloader */
+    protected $httpDownloader;
 
     /** @var ProcessExecutor */
     protected $process;
@@ -86,7 +87,7 @@ EOT
         $config->merge(array('config' => array('secure-http' => false)));
         $config->prohibitUrlByConfig('http://repo.packagist.org', new NullIO);
 
-        $this->rfs = Factory::createRemoteFilesystem($io, $config);
+        $this->httpDownloader = Factory::createHttpDownloader($io, $config);
         $this->process = new ProcessExecutor($io);
 
         $io->write('Checking platform settings: ', false);
@@ -105,10 +106,6 @@ EOT
         if (!empty($opts['http']['proxy'])) {
             $io->write('Checking HTTP proxy: ', false);
             $this->outputResult($this->checkHttpProxy());
-            $io->write('Checking HTTP proxy support for request_fulluri: ', false);
-            $this->outputResult($this->checkHttpProxyFullUriRequestParam());
-            $io->write('Checking HTTPS proxy support for request_fulluri: ', false);
-            $this->outputResult($this->checkHttpsProxyFullUriRequestParam());
         }
 
         if ($oauth = $config->get('github-oauth')) {
@@ -148,7 +145,7 @@ EOT
         $io->write('Checking disk free space: ', false);
         $this->outputResult($this->checkDiskSpace($config));
 
-        if ('phar:' === substr(__FILE__, 0, 5)) {
+        if (strpos(__FILE__, 'phar:') === 0) {
             $io->write('Checking pubkeys: ', false);
             $this->outputResult($this->checkPubKeys($config));
 
@@ -156,7 +153,7 @@ EOT
             $this->outputResult($this->checkVersion($config));
         }
 
-        $io->write(sprintf('Composer version: <comment>%s</comment>', Composer::VERSION));
+        $io->write(sprintf('Composer version: <comment>%s</comment>', Composer::getVersion()));
 
         $platformOverrides = $config->get('platform') ?: array();
         $platformRepo = new PlatformRepository(array(), $platformOverrides);
@@ -173,6 +170,14 @@ EOT
         }
 
         $io->write('OpenSSL version: ' . (defined('OPENSSL_VERSION_TEXT') ? '<comment>'.OPENSSL_VERSION_TEXT.'</comment>' : '<error>missing</error>'));
+        $io->write('cURL version: ' . $this->getCurlVersion());
+
+        $finder = new ExecutableFinder;
+        $hasSystemUnzip = (bool) $finder->find('unzip');
+        $io->write(
+            'zip: ' . (extension_loaded('zip') ? '<comment>extension present</comment>' : '<comment>extension not loaded</comment>')
+            . ', ' . ($hasSystemUnzip ? '<comment>unzip present</comment>' : '<comment>unzip not available</comment>')
+        );
 
         return $this->exitCode;
     }
@@ -218,26 +223,25 @@ EOT
             return $result;
         }
 
-        $disableTls = false;
         $result = array();
         if ($proto === 'https' && $config->get('disable-tls') === true) {
-            $disableTls = true;
-            $result[] = '<warning>Composer is configured to disable SSL/TLS protection. This will leave remote HTTPS requests vulnerable to Man-In-The-Middle attacks.</warning>';
-        }
-        if ($proto === 'https' && !extension_loaded('openssl') && !$disableTls) {
-            $result[] = '<error>Composer is configured to use SSL/TLS protection but the openssl extension is not available.</error>';
+            $tlsWarning = '<warning>Composer is configured to disable SSL/TLS protection. This will leave remote HTTPS requests vulnerable to Man-In-The-Middle attacks.</warning>';
         }
 
         try {
-            $this->rfs->getContents('packagist.org', $proto . '://repo.packagist.org/packages.json', false);
+            $this->httpDownloader->get($proto . '://repo.packagist.org/packages.json');
         } catch (TransportException $e) {
-            if (false !== strpos($e->getMessage(), 'cafile')) {
-                $result[] = '<error>[' . get_class($e) . '] ' . $e->getMessage() . '</error>';
-                $result[] = '<error>Unable to locate a valid CA certificate file. You must set a valid \'cafile\' option.</error>';
-                $result[] = '<error>You can alternatively disable this error, at your own risk, by enabling the \'disable-tls\' option.</error>';
-            } else {
-                array_unshift($result, '[' . get_class($e) . '] ' . $e->getMessage());
+            if ($hints = HttpDownloader::getExceptionHints($e)) {
+                foreach ($hints as $hint) {
+                    $result[] = $hint;
+                }
             }
+
+            $result[] = '<error>[' . get_class($e) . '] ' . $e->getMessage() . '</error>';
+        }
+
+        if (isset($tlsWarning)) {
+            $result[] = $tlsWarning;
         }
 
         if (count($result) > 0) {
@@ -256,11 +260,11 @@ EOT
 
         $protocol = extension_loaded('openssl') ? 'https' : 'http';
         try {
-            $json = json_decode($this->rfs->getContents('packagist.org', $protocol . '://repo.packagist.org/packages.json', false), true);
+            $json = $this->httpDownloader->get($protocol . '://repo.packagist.org/packages.json')->decodeJson();
             $hash = reset($json['provider-includes']);
             $hash = $hash['sha256'];
             $path = str_replace('%hash%', $hash, key($json['provider-includes']));
-            $provider = $this->rfs->getContents('packagist.org', $protocol . '://repo.packagist.org/'.$path, false);
+            $provider = $this->httpDownloader->get($protocol . '://repo.packagist.org/'.$path)->getBody();
 
             if (hash('sha256', $provider) !== $hash) {
                 return 'It seems that your proxy is modifying http traffic on the fly';
@@ -272,70 +276,6 @@ EOT
         return true;
     }
 
-    /**
-     * Due to various proxy servers configurations, some servers can't handle non-standard HTTP "http_proxy_request_fulluri" parameter,
-     * and will return error 500/501 (as not implemented), see discussion @ https://github.com/composer/composer/pull/1825.
-     * This method will test, if you need to disable this parameter via setting extra environment variable in your system.
-     *
-     * @return bool|string
-     */
-    private function checkHttpProxyFullUriRequestParam()
-    {
-        $result = $this->checkConnectivity();
-        if ($result !== true) {
-            return $result;
-        }
-
-        $url = 'http://repo.packagist.org/packages.json';
-        try {
-            $this->rfs->getContents('packagist.org', $url, false);
-        } catch (TransportException $e) {
-            try {
-                $this->rfs->getContents('packagist.org', $url, false, array('http' => array('request_fulluri' => false)));
-            } catch (TransportException $e) {
-                return 'Unable to assess the situation, maybe packagist.org is down ('.$e->getMessage().')';
-            }
-
-            return 'It seems there is a problem with your proxy server, try setting the "HTTP_PROXY_REQUEST_FULLURI" and "HTTPS_PROXY_REQUEST_FULLURI" environment variables to "false"';
-        }
-
-        return true;
-    }
-
-    /**
-     * Due to various proxy servers configurations, some servers can't handle non-standard HTTP "http_proxy_request_fulluri" parameter,
-     * and will return error 500/501 (as not implemented), see discussion @ https://github.com/composer/composer/pull/1825.
-     * This method will test, if you need to disable this parameter via setting extra environment variable in your system.
-     *
-     * @return bool|string
-     */
-    private function checkHttpsProxyFullUriRequestParam()
-    {
-        $result = $this->checkConnectivity();
-        if ($result !== true) {
-            return $result;
-        }
-
-        if (!extension_loaded('openssl')) {
-            return 'You need the openssl extension installed for this check';
-        }
-
-        $url = 'https://api.github.com/repos/Seldaek/jsonlint/zipball/1.0.0';
-        try {
-            $this->rfs->getContents('github.com', $url, false);
-        } catch (TransportException $e) {
-            try {
-                $this->rfs->getContents('github.com', $url, false, array('http' => array('request_fulluri' => false)));
-            } catch (TransportException $e) {
-                return 'Unable to assess the situation, maybe github is down ('.$e->getMessage().')';
-            }
-
-            return 'It seems there is a problem with your proxy server, try setting the "HTTPS_PROXY_REQUEST_FULLURI" environment variable to "false"';
-        }
-
-        return true;
-    }
-
     private function checkGithubOauth($domain, $token)
     {
         $result = $this->checkConnectivity();
@@ -347,7 +287,7 @@ EOT
         try {
             $url = $domain === 'github.com' ? 'https://api.'.$domain.'/' : 'https://'.$domain.'/api/v3/';
 
-            return $this->rfs->getContents($domain, $url, false, array(
+            return $this->httpDownloader->get($url, array(
                 'retry-auth-failure' => false,
             )) ? true : 'Unexpected error';
         } catch (\Exception $e) {
@@ -377,8 +317,7 @@ EOT
         }
 
         $url = $domain === 'github.com' ? 'https://api.'.$domain.'/rate_limit' : 'https://'.$domain.'/api/rate_limit';
-        $json = $this->rfs->getContents($domain, $url, false, array('retry-auth-failure' => false));
-        $data = json_decode($json, true);
+        $data = $this->httpDownloader->get($url, array('retry-auth-failure' => false))->decodeJson();
 
         return $data['resources']['core'];
     }
@@ -431,7 +370,7 @@ EOT
             return $result;
         }
 
-        $versionsUtil = new Versions($config, $this->rfs);
+        $versionsUtil = new Versions($config, $this->httpDownloader);
         try {
             $latest = $versionsUtil->getLatest();
         } catch (\Exception $e) {
@@ -445,6 +384,23 @@ EOT
         return true;
     }
 
+    private function getCurlVersion()
+    {
+        if (extension_loaded('curl')) {
+            if (!HttpDownloader::isCurlEnabled()) {
+                return '<error>disabled via disable_functions, using php streams fallback, which reduces performance</error>';
+            }
+
+            $version = curl_version();
+
+            return '<comment>'.$version['version'].'</comment> '.
+                'libz <comment>'.(isset($version['libz_version']) ? $version['libz_version'] : 'missing').'</comment> '.
+                'ssl <comment>'.(isset($version['ssl_version']) ? $version['ssl_version'] : 'missing').'</comment>';
+        }
+
+        return '<error>missing, using php streams fallback, which reduces performance</error>';
+    }
+
     /**
      * @param bool|string|\Exception $result
      */
@@ -617,20 +573,6 @@ EOT
                         $text .= "Install either of them or recompile php without --disable-iconv";
                         break;
 
-                    case 'unicode':
-                        $text = PHP_EOL."The detect_unicode setting must be disabled.".PHP_EOL;
-                        $text .= "Add the following to the end of your `php.ini`:".PHP_EOL;
-                        $text .= "    detect_unicode = Off";
-                        $displayIniMessage = true;
-                        break;
-
-                    case 'suhosin':
-                        $text = PHP_EOL."The suhosin.executor.include.whitelist setting is incorrect.".PHP_EOL;
-                        $text .= "Add the following to the end of your `php.ini` or suhosin.ini (Example path [for Debian]: /etc/php5/cli/conf.d/suhosin.ini):".PHP_EOL;
-                        $text .= "    suhosin.executor.include.whitelist = phar ".$current;
-                        $displayIniMessage = true;
-                        break;
-
                     case 'php':
                         $text = PHP_EOL."Your PHP ({$current}) is too old, you must upgrade to PHP 5.3.2 or higher.";
                         break;
@@ -653,6 +595,9 @@ EOT
                         $text = PHP_EOL."The openssl extension is missing, which means that secure HTTPS transfers are impossible.".PHP_EOL;
                         $text .= "If possible you should enable it or recompile php with --with-openssl";
                         break;
+
+                    default:
+                        throw new \InvalidArgumentException(sprintf("DiagnoseCommand: Unknown error type \"%s\". Please report at https://github.com/composer/composer/issues/new.", $error));
                 }
                 $out($text, 'error');
             }
@@ -717,6 +662,9 @@ EOT
                         $text = "The Windows OneDrive folder is not supported on PHP versions below 7.2.23 and 7.3.10.".PHP_EOL;
                         $text .= "Upgrade your PHP ({$current}) to use this location with Composer.".PHP_EOL;
                         break;
+
+                    default:
+                        throw new \InvalidArgumentException(sprintf("DiagnoseCommand: Unknown warning type \"%s\". Please report at https://github.com/composer/composer/issues/new.", $warning));
                 }
                 $out($text, 'comment');
             }
@@ -729,17 +677,15 @@ EOT
         return !$warnings && !$errors ? true : $output;
     }
 
-
     /**
      * Check if allow_url_fopen is ON
      *
-     * @return bool|string
+     * @return true|string
      */
     private function checkConnectivity()
     {
         if (!ini_get('allow_url_fopen')) {
-            $result = '<info>Skipped because allow_url_fopen is missing.</info>';
-            return $result;
+            return '<info>Skipped because allow_url_fopen is missing.</info>';
         }
 
         return true;
diff -pruN 1.10.19-1/src/Composer/Command/DumpAutoloadCommand.php 2.0.9-1/src/Composer/Command/DumpAutoloadCommand.php
--- 1.10.19-1/src/Composer/Command/DumpAutoloadCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/DumpAutoloadCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -34,7 +34,10 @@ class DumpAutoloadCommand extends BaseCo
                 new InputOption('optimize', 'o', InputOption::VALUE_NONE, 'Optimizes PSR0 and PSR4 packages to be loaded with classmaps too, good for production.'),
                 new InputOption('classmap-authoritative', 'a', InputOption::VALUE_NONE, 'Autoload classes from the classmap only. Implicitly enables `--optimize`.'),
                 new InputOption('apcu', null, InputOption::VALUE_NONE, 'Use APCu to cache found/not-found classes.'),
+                new InputOption('apcu-prefix', null, InputOption::VALUE_REQUIRED, 'Use a custom prefix for the APCu autoloader cache. Implicitly enables --apcu'),
                 new InputOption('no-dev', null, InputOption::VALUE_NONE, 'Disables autoload-dev rules.'),
+                new InputOption('ignore-platform-req', null, InputOption::VALUE_REQUIRED | InputOption::VALUE_IS_ARRAY, 'Ignore a specific platform requirement (php & ext- packages).'),
+                new InputOption('ignore-platform-reqs', null, InputOption::VALUE_NONE, 'Ignore all platform requirements (php & ext- packages).'),
             ))
             ->setHelp(
                 <<<EOT
@@ -60,7 +63,8 @@ EOT
 
         $optimize = $input->getOption('optimize') || $config->get('optimize-autoloader');
         $authoritative = $input->getOption('classmap-authoritative') || $config->get('classmap-authoritative');
-        $apcu = $input->getOption('apcu') || $config->get('apcu-autoloader');
+        $apcuPrefix = $input->getOption('apcu-prefix');
+        $apcu = $apcuPrefix !== null || $input->getOption('apcu') || $config->get('apcu-autoloader');
 
         if ($authoritative) {
             $this->getIO()->write('<info>Generating optimized autoload files (authoritative)</info>');
@@ -70,11 +74,14 @@ EOT
             $this->getIO()->write('<info>Generating autoload files</info>');
         }
 
+        $ignorePlatformReqs = $input->getOption('ignore-platform-reqs') ?: ($input->getOption('ignore-platform-req') ?: false);
+
         $generator = $composer->getAutoloadGenerator();
         $generator->setDevMode(!$input->getOption('no-dev'));
         $generator->setClassMapAuthoritative($authoritative);
-        $generator->setApcu($apcu);
+        $generator->setApcu($apcu, $apcuPrefix);
         $generator->setRunScripts(!$input->getOption('no-scripts'));
+        $generator->setIgnorePlatformRequirements($ignorePlatformReqs);
         $numberOfClasses = $generator->dump($config, $localRepo, $package, $installationManager, 'composer', $optimize);
 
         if ($authoritative) {
diff -pruN 1.10.19-1/src/Composer/Command/FundCommand.php 2.0.9-1/src/Composer/Command/FundCommand.php
--- 1.10.19-1/src/Composer/Command/FundCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/FundCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,9 +14,10 @@ namespace Composer\Command;
 
 use Composer\Package\CompletePackageInterface;
 use Composer\Package\AliasPackage;
+use Composer\Package\BasePackage;
+use Composer\Semver\Constraint\MatchAllConstraint;
 use Composer\Repository\CompositeRepository;
 use Symfony\Component\Console\Input\InputInterface;
-use Symfony\Component\Console\Input\InputOption;
 use Symfony\Component\Console\Output\OutputInterface;
 
 /**
@@ -39,15 +40,38 @@ class FundCommand extends BaseCommand
         $repo = $composer->getRepositoryManager()->getLocalRepository();
         $remoteRepos = new CompositeRepository($composer->getRepositoryManager()->getRepositories());
         $fundings = array();
+
+        $packagesToLoad = array();
         foreach ($repo->getPackages() as $package) {
             if ($package instanceof AliasPackage) {
                 continue;
             }
-            $latest = $remoteRepos->findPackage($package->getName(), 'dev-master');
-            if ($latest instanceof CompletePackageInterface && $latest->getFunding()) {
-                $fundings = $this->insertFundingData($fundings, $latest);
+            $packagesToLoad[$package->getName()] = new MatchAllConstraint();
+        }
+
+        // load all packages dev versions in parallel
+        $result = $remoteRepos->loadPackages($packagesToLoad, array('dev' => BasePackage::STABILITY_DEV), array());
+
+        // collect funding data from default branches
+        foreach ($result['packages'] as $package) {
+            if (
+                !$package instanceof AliasPackage
+                && $package instanceof CompletePackageInterface
+                && $package->isDefaultBranch()
+                && $package->getFunding()
+                && isset($packagesToLoad[$package->getName()])
+            ) {
+                $fundings = $this->insertFundingData($fundings, $package);
+                unset($packagesToLoad[$package->getName()]);
+            }
+        }
+
+        // collect funding from installed packages if none was found in the default branch above
+        foreach ($repo->getPackages() as $package) {
+            if ($package instanceof AliasPackage || !isset($packagesToLoad[$package->getName()])) {
                 continue;
             }
+
             if ($package instanceof CompletePackageInterface && $package->getFunding()) {
                 $fundings = $this->insertFundingData($fundings, $package);
             }
diff -pruN 1.10.19-1/src/Composer/Command/HomeCommand.php 2.0.9-1/src/Composer/Command/HomeCommand.php
--- 1.10.19-1/src/Composer/Command/HomeCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/HomeCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,7 +14,7 @@ namespace Composer\Command;
 
 use Composer\Package\CompletePackageInterface;
 use Composer\Repository\RepositoryInterface;
-use Composer\Repository\ArrayRepository;
+use Composer\Repository\RootPackageRepository;
 use Composer\Repository\RepositoryFactory;
 use Composer\Util\Platform;
 use Composer\Util\ProcessExecutor;
@@ -157,7 +157,7 @@ EOT
 
         if ($composer) {
             return array_merge(
-                array(new ArrayRepository(array($composer->getPackage()))), // root package
+                array(new RootPackageRepository($composer->getPackage())), // root package
                 array($composer->getRepositoryManager()->getLocalRepository()), // installed packages
                 $composer->getRepositoryManager()->getRepositories() // remotes
             );
diff -pruN 1.10.19-1/src/Composer/Command/InitCommand.php 2.0.9-1/src/Composer/Command/InitCommand.php
--- 1.10.19-1/src/Composer/Command/InitCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/InitCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,7 +12,6 @@
 
 namespace Composer\Command;
 
-use Composer\DependencyResolver\Pool;
 use Composer\Factory;
 use Composer\Json\JsonFile;
 use Composer\Package\BasePackage;
@@ -22,6 +21,7 @@ use Composer\Package\Version\VersionSele
 use Composer\Repository\CompositeRepository;
 use Composer\Repository\PlatformRepository;
 use Composer\Repository\RepositoryFactory;
+use Composer\Repository\RepositorySet;
 use Composer\Util\ProcessExecutor;
 use Symfony\Component\Console\Input\ArrayInput;
 use Symfony\Component\Console\Input\InputInterface;
@@ -42,8 +42,8 @@ class InitCommand extends BaseCommand
     /** @var array */
     private $gitConfig;
 
-    /** @var Pool[] */
-    private $pools;
+    /** @var RepositorySet[] */
+    private $repositorySets;
 
     /**
      * {@inheritdoc}
@@ -86,8 +86,8 @@ EOT
     {
         $io = $this->getIO();
 
-        $allowList = array('name', 'description', 'author', 'type', 'homepage', 'require', 'require-dev', 'stability', 'license');
-        $options = array_filter(array_intersect_key($input->getOptions(), array_flip($allowList)));
+        $allowlist = array('name', 'description', 'author', 'type', 'homepage', 'require', 'require-dev', 'stability', 'license');
+        $options = array_filter(array_intersect_key($input->getOptions(), array_flip($allowlist)));
 
         if (isset($options['author'])) {
             $options['authors'] = $this->formatAuthors($options['author']);
@@ -98,7 +98,7 @@ EOT
         if ($repositories) {
             $config = Factory::createConfig($io);
             foreach ($repositories as $repo) {
-                $options['repositories'][] = RepositoryFactory::configFromString($io, $config, $repo);
+                $options['repositories'][] = RepositoryFactory::configFromString($io, $config, $repo, true);
             }
         }
 
@@ -120,15 +120,21 @@ EOT
         }
 
         $file = new JsonFile(Factory::getComposerFile());
-        $json = $file->encode($options);
+        $json = JsonFile::encode($options);
 
         if ($input->isInteractive()) {
             $io->writeError(array('', $json, ''));
-            if (!$io->askConfirmation('Do you confirm generation [<comment>yes</comment>]? ', true)) {
+            if (!$io->askConfirmation('Do you confirm generation [<comment>yes</comment>]? ')) {
                 $io->writeError('<error>Command aborted</error>');
 
                 return 1;
             }
+        } else {
+            if (json_encode($options) === '{"require":{}}') {
+                throw new \RuntimeException('You have to run this command in interactive mode, or specify at least some data using --name, --require, etc.');
+            }
+
+            $io->writeError('Writing composer.json');
         }
 
         $file->write($options);
@@ -143,14 +149,14 @@ EOT
             if (!$this->hasVendorIgnore($ignoreFile)) {
                 $question = 'Would you like the <info>vendor</info> directory added to your <info>.gitignore</info> [<comment>yes</comment>]? ';
 
-                if ($io->askConfirmation($question, true)) {
+                if ($io->askConfirmation($question)) {
                     $this->addVendorIgnore($ignoreFile);
                 }
             }
         }
 
         $question = 'Would you like to install dependencies now [<comment>yes</comment>]? ';
-        if ($input->isInteractive() && $this->hasDependencies($options) && $io->askConfirmation($question, true)) {
+        if ($input->isInteractive() && $this->hasDependencies($options) && $io->askConfirmation($question)) {
             $this->installDependencies($output);
         }
 
@@ -173,7 +179,7 @@ EOT
             $repos = array(new PlatformRepository);
             $createDefaultPackagistRepo = true;
             foreach ($repositories as $repo) {
-                $repoConfig = RepositoryFactory::configFromString($io, $config, $repo);
+                $repoConfig = RepositoryFactory::configFromString($io, $config, $repo, true);
                 if (
                     (isset($repoConfig['packagist']) && $repoConfig === array('packagist' => false))
                     || (isset($repoConfig['packagist.org']) && $repoConfig === array('packagist.org' => false))
@@ -277,7 +283,7 @@ EOT
                 $author_email = $git['user.email'];
             }
 
-            if (isset($author_name) && isset($author_email)) {
+            if (isset($author_name, $author_email)) {
                 $author = sprintf('%s <%s>', $author_name, $author_email);
             }
         }
@@ -345,21 +351,29 @@ EOT
         // prepare to resolve dependencies
         $repos = $this->getRepos();
         $preferredStability = $minimumStability ?: 'stable';
-        $phpVersion = $repos->findPackage('php', '*')->getPrettyVersion();
+        $platformRepo = null;
+        if ($repos instanceof CompositeRepository) {
+            foreach ($repos->getRepositories() as $candidateRepo) {
+                if ($candidateRepo instanceof PlatformRepository) {
+                    $platformRepo = $candidateRepo;
+                    break;
+                }
+            }
+        }
 
         $question = 'Would you like to define your dependencies (require) interactively [<comment>yes</comment>]? ';
         $require = $input->getOption('require');
         $requirements = array();
-        if ($require || $io->askConfirmation($question, true)) {
-            $requirements = $this->determineRequirements($input, $output, $require, $phpVersion, $preferredStability);
+        if ($require || $io->askConfirmation($question)) {
+            $requirements = $this->determineRequirements($input, $output, $require, $platformRepo, $preferredStability);
         }
         $input->setOption('require', $requirements);
 
         $question = 'Would you like to define your dev dependencies (require-dev) interactively [<comment>yes</comment>]? ';
         $requireDev = $input->getOption('require-dev');
         $devRequirements = array();
-        if ($requireDev || $io->askConfirmation($question, true)) {
-            $devRequirements = $this->determineRequirements($input, $output, $requireDev, $phpVersion, $preferredStability);
+        if ($requireDev || $io->askConfirmation($question)) {
+            $devRequirements = $this->determineRequirements($input, $output, $requireDev, $platformRepo, $preferredStability);
         }
         $input->setOption('require-dev', $devRequirements);
     }
@@ -403,7 +417,7 @@ EOT
         return $this->repos;
     }
 
-    final protected function determineRequirements(InputInterface $input, OutputInterface $output, $requires = array(), $phpVersion = null, $preferredStability = 'stable', $checkProvidedVersions = true, $fixed = false)
+    final protected function determineRequirements(InputInterface $input, OutputInterface $output, $requires = array(), PlatformRepository $platformRepo = null, $preferredStability = 'stable', $checkProvidedVersions = true, $fixed = false)
     {
         if ($requires) {
             $requires = $this->normalizeRequirements($requires);
@@ -413,7 +427,7 @@ EOT
             foreach ($requires as $requirement) {
                 if (!isset($requirement['version'])) {
                     // determine the best version automatically
-                    list($name, $version) = $this->findBestVersionAndNameForPackage($input, $requirement['name'], $phpVersion, $preferredStability, null, null, $fixed);
+                    list($name, $version) = $this->findBestVersionAndNameForPackage($input, $requirement['name'], $platformRepo, $preferredStability, null, null, $fixed);
                     $requirement['version'] = $version;
 
                     // replace package name from packagist.org
@@ -426,7 +440,7 @@ EOT
                     ));
                 } else {
                     // check that the specified version/constraint exists before we proceed
-                    list($name, $version) = $this->findBestVersionAndNameForPackage($input, $requirement['name'], $phpVersion, $preferredStability, $checkProvidedVersions ? $requirement['version'] : null, 'dev', $fixed);
+                    list($name) = $this->findBestVersionAndNameForPackage($input, $requirement['name'], $platformRepo, $preferredStability, $checkProvidedVersions ? $requirement['version'] : null, 'dev', $fixed);
 
                     // replace package name from packagist.org
                     $requirement['name'] = $name;
@@ -547,7 +561,7 @@ EOT
                     );
 
                     if (false === $constraint) {
-                        list($name, $constraint) = $this->findBestVersionAndNameForPackage($input, $package, $phpVersion, $preferredStability);
+                        list(, $constraint) = $this->findBestVersionAndNameForPackage($input, $package, $platformRepo, $preferredStability);
 
                         $io->writeError(sprintf(
                             'Using version <info>%s</info> for <info>%s</info>',
@@ -574,17 +588,6 @@ EOT
         return array($this->parseAuthorString($author));
     }
 
-    protected function formatRequirements(array $requirements)
-    {
-        $requires = array();
-        $requirements = $this->normalizeRequirements($requirements);
-        foreach ($requirements as $requirement) {
-            $requires[$requirement['name']] = $requirement['version'];
-        }
-
-        return $requires;
-    }
-
     protected function getGitConfig()
     {
         if (null !== $this->gitConfig) {
@@ -649,20 +652,13 @@ EOT
         return false;
     }
 
-    protected function normalizeRequirements(array $requirements)
-    {
-        $parser = new VersionParser();
-
-        return $parser->parseNameVersionPairs($requirements);
-    }
-
     protected function addVendorIgnore($ignoreFile, $vendor = '/vendor/')
     {
         $contents = "";
         if (file_exists($ignoreFile)) {
             $contents = file_get_contents($ignoreFile);
 
-            if ("\n" !== substr($contents, 0, -1)) {
+            if (strpos($contents, "\n") !== 0) {
                 $contents .= "\n";
             }
         }
@@ -685,16 +681,16 @@ EOT
         return false !== filter_var($email, FILTER_VALIDATE_EMAIL);
     }
 
-    private function getPool(InputInterface $input, $minimumStability = null)
+    private function getRepositorySet(InputInterface $input, $minimumStability = null)
     {
         $key = $minimumStability ?: 'default';
 
-        if (!isset($this->pools[$key])) {
-            $this->pools[$key] = $pool = new Pool($minimumStability ?: $this->getMinimumStability($input));
-            $pool->addRepository($this->getRepos());
+        if (!isset($this->repositorySets[$key])) {
+            $this->repositorySets[$key] = $repositorySet = new RepositorySet($minimumStability ?: $this->getMinimumStability($input));
+            $repositorySet->addRepository($this->getRepos());
         }
 
-        return $this->pools[$key];
+        return $this->repositorySets[$key];
     }
 
     private function getMinimumStability(InputInterface $input)
@@ -720,7 +716,7 @@ EOT
      *
      * @param  InputInterface            $input
      * @param  string                    $name
-     * @param  string|null               $phpVersion
+     * @param  PlatformRepository|null   $platformRepo
      * @param  string                    $preferredStability
      * @param  string|null               $requiredVersion
      * @param  string                    $minimumStability
@@ -728,64 +724,75 @@ EOT
      * @throws \InvalidArgumentException
      * @return array                     name version
      */
-    private function findBestVersionAndNameForPackage(InputInterface $input, $name, $phpVersion, $preferredStability = 'stable', $requiredVersion = null, $minimumStability = null, $fixed = null)
+    private function findBestVersionAndNameForPackage(InputInterface $input, $name, PlatformRepository $platformRepo = null, $preferredStability = 'stable', $requiredVersion = null, $minimumStability = null, $fixed = null)
     {
-        // find the latest version allowed in this pool
-        $versionSelector = new VersionSelector($this->getPool($input, $minimumStability));
-        $ignorePlatformReqs = $input->hasOption('ignore-platform-reqs') && $input->getOption('ignore-platform-reqs');
-
-        // ignore phpVersion if platform requirements are ignored
-        if ($ignorePlatformReqs) {
-            $phpVersion = null;
+        // handle ignore-platform-reqs flag if present
+        $ignorePlatformReqs = false;
+        if ($input->hasOption('ignore-platform-reqs') && $input->hasOption('ignore-platform-req')) {
+            $ignorePlatformReqs = $input->getOption('ignore-platform-reqs') ?: ($input->getOption('ignore-platform-req') ?: false);
         }
 
-        $package = $versionSelector->findBestCandidate($name, $requiredVersion, $phpVersion, $preferredStability);
+        // find the latest version allowed in this repo set
+        $versionSelector = new VersionSelector($this->getRepositorySet($input, $minimumStability), $platformRepo);
+
+        $package = $versionSelector->findBestCandidate($name, $requiredVersion, $preferredStability, $ignorePlatformReqs);
 
         if (!$package) {
             // platform packages can not be found in the pool in versions other than the local platform's has
             // so if platform reqs are ignored we just take the user's word for it
-            if ($ignorePlatformReqs && preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $name)) {
+            if ((true === $ignorePlatformReqs || (is_array($ignorePlatformReqs) && in_array($name, $ignorePlatformReqs))) && PlatformRepository::isPlatformPackage($name)) {
                 return array($name, $requiredVersion ?: '*');
             }
 
             // Check whether the PHP version was the problem
-            if ($phpVersion && $versionSelector->findBestCandidate($name, $requiredVersion, null, $preferredStability)) {
+            if (true !== $ignorePlatformReqs && $versionSelector->findBestCandidate($name, $requiredVersion, $preferredStability, true)) {
                 throw new \InvalidArgumentException(sprintf(
-                    'Package %s at version %s has a PHP requirement incompatible with your PHP version (%s)',
+                    'Package %s%s has a PHP requirement incompatible with your PHP version, PHP extensions and Composer version',
                     $name,
-                    $requiredVersion,
-                    $phpVersion
+                    $requiredVersion ? ' at version '.$requiredVersion : ''
+                ));
+            }
+            // Check whether the minimum stability was the problem but the package exists
+            if ($package = $versionSelector->findBestCandidate($name, $requiredVersion, $preferredStability, $ignorePlatformReqs, RepositorySet::ALLOW_UNACCEPTABLE_STABILITIES)) {
+                // we must first verify if a valid package would be found in a lower priority repository
+                if ($allReposPackage = $versionSelector->findBestCandidate($name, $requiredVersion, $preferredStability, $ignorePlatformReqs, RepositorySet::ALLOW_SHADOWED_REPOSITORIES)) {
+                    throw new \InvalidArgumentException(
+                        'Package '.$name.' exists in '.$allReposPackage->getRepository()->getRepoName().' and '.$package->getRepository()->getRepoName().' which has a higher repository priority. The packages with higher priority do not match your minimum-stability and are therefore not installable. See https://getcomposer.org/repoprio for details and assistance.'
+                    );
+                }
+
+                throw new \InvalidArgumentException(sprintf(
+                    'Could not find a version of package %s matching your minimum-stability (%s). Require it with an explicit version constraint allowing its desired stability.',
+                    $name,
+                    $this->getMinimumStability($input)
                 ));
             }
             // Check whether the required version was the problem
-            if ($requiredVersion && $versionSelector->findBestCandidate($name, null, $phpVersion, $preferredStability)) {
+            if ($requiredVersion && $package = $versionSelector->findBestCandidate($name, null, $preferredStability, $ignorePlatformReqs)) {
+                // we must first verify if a valid package would be found in a lower priority repository
+                if ($allReposPackage = $versionSelector->findBestCandidate($name, $requiredVersion, $preferredStability, false, RepositorySet::ALLOW_SHADOWED_REPOSITORIES)) {
+                    throw new \InvalidArgumentException(
+                        'Package '.$name.' exists in '.$allReposPackage->getRepository()->getRepoName().' and '.$package->getRepository()->getRepoName().' which has a higher repository priority. The packages with higher priority do not match your constraint and are therefore not installable. See https://getcomposer.org/repoprio for details and assistance.'
+                    );
+                }
+
                 throw new \InvalidArgumentException(sprintf(
                     'Could not find package %s in a version matching %s',
                     $name,
                     $requiredVersion
                 ));
             }
-            // Check whether the PHP version was the problem
-            if ($phpVersion && $versionSelector->findBestCandidate($name)) {
+            // Check whether the PHP version was the problem for all versions
+            if (true !== $ignorePlatformReqs && $versionSelector->findBestCandidate($name, null, $preferredStability, true)) {
                 throw new \InvalidArgumentException(sprintf(
-                    'Could not find package %s in any version matching your PHP version (%s)',
-                    $name,
-                    $phpVersion
+                    'Could not find package %s in any version matching your PHP version, PHP extensions and Composer version',
+                    $name
                 ));
             }
 
             // Check for similar names/typos
             $similar = $this->findSimilar($name);
             if ($similar) {
-                // Check whether the minimum stability was the problem but the package exists
-                if ($requiredVersion === null && in_array($name, $similar, true)) {
-                    throw new \InvalidArgumentException(sprintf(
-                        'Could not find a version of package %s matching your minimum-stability (%s). Require it with an explicit version constraint allowing its desired stability.',
-                        $name,
-                        $this->getMinimumStability($input)
-                    ));
-                }
-
                 throw new \InvalidArgumentException(sprintf(
                     "Could not find package %s.\n\nDid you mean " . (count($similar) > 1 ? 'one of these' : 'this') . "?\n    %s",
                     $name,
@@ -838,7 +845,6 @@ EOT
         } catch (\Exception $e) {
             $this->getIO()->writeError('Could not install dependencies. Run `composer install` to see more information.');
         }
-
     }
 
     private function hasDependencies($options)
diff -pruN 1.10.19-1/src/Composer/Command/InstallCommand.php 2.0.9-1/src/Composer/Command/InstallCommand.php
--- 1.10.19-1/src/Composer/Command/InstallCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/InstallCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -15,6 +15,7 @@ namespace Composer\Command;
 use Composer\Installer;
 use Composer\Plugin\CommandEvent;
 use Composer\Plugin\PluginEvents;
+use Composer\Util\HttpDownloader;
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Input\InputOption;
 use Symfony\Component\Console\Input\InputArgument;
@@ -38,18 +39,20 @@ class InstallCommand extends BaseCommand
                 new InputOption('prefer-source', null, InputOption::VALUE_NONE, 'Forces installation from package sources when possible, including VCS information.'),
                 new InputOption('prefer-dist', null, InputOption::VALUE_NONE, 'Forces installation from package dist even for dev versions.'),
                 new InputOption('dry-run', null, InputOption::VALUE_NONE, 'Outputs the operations but will not execute anything (implicitly enables --verbose).'),
-                new InputOption('dev', null, InputOption::VALUE_NONE, 'Enables installation of require-dev packages (enabled by default, only present for BC).'),
+                new InputOption('dev', null, InputOption::VALUE_NONE, 'DEPRECATED: Enables installation of require-dev packages (enabled by default, only present for BC).'),
+                new InputOption('no-suggest', null, InputOption::VALUE_NONE, 'DEPRECATED: This flag does not exist anymore.'),
                 new InputOption('no-dev', null, InputOption::VALUE_NONE, 'Disables installation of require-dev packages.'),
-                new InputOption('no-custom-installers', null, InputOption::VALUE_NONE, 'DEPRECATED: Use no-plugins instead.'),
                 new InputOption('no-autoloader', null, InputOption::VALUE_NONE, 'Skips autoloader generation'),
                 new InputOption('no-scripts', null, InputOption::VALUE_NONE, 'Skips the execution of all scripts defined in composer.json file.'),
                 new InputOption('no-progress', null, InputOption::VALUE_NONE, 'Do not output download progress.'),
-                new InputOption('no-suggest', null, InputOption::VALUE_NONE, 'Do not show package suggestions.'),
+                new InputOption('no-install', null, InputOption::VALUE_NONE, 'Do not use, only defined here to catch misuse of the install command.'),
                 new InputOption('verbose', 'v|vv|vvv', InputOption::VALUE_NONE, 'Shows more details including new commits pulled in when updating packages.'),
                 new InputOption('optimize-autoloader', 'o', InputOption::VALUE_NONE, 'Optimize autoloader during autoloader dump'),
                 new InputOption('classmap-authoritative', 'a', InputOption::VALUE_NONE, 'Autoload classes from the classmap only. Implicitly enables `--optimize-autoloader`.'),
                 new InputOption('apcu-autoloader', null, InputOption::VALUE_NONE, 'Use APCu to cache found/not-found classes.'),
-                new InputOption('ignore-platform-reqs', null, InputOption::VALUE_NONE, 'Ignore platform requirements (php & ext- packages).'),
+                new InputOption('apcu-autoloader-prefix', null, InputOption::VALUE_REQUIRED, 'Use a custom prefix for the APCu autoloader cache. Implicitly enables --apcu-autoloader'),
+                new InputOption('ignore-platform-req', null, InputOption::VALUE_REQUIRED | InputOption::VALUE_IS_ARRAY, 'Ignore a specific platform requirement (php & ext- packages).'),
+                new InputOption('ignore-platform-reqs', null, InputOption::VALUE_NONE, 'Ignore all platform requirements (php & ext- packages).'),
                 new InputArgument('packages', InputArgument::IS_ARRAY | InputArgument::OPTIONAL, 'Should not be provided, use composer require instead to add a given package to composer.json.'),
             ))
             ->setHelp(
@@ -70,23 +73,30 @@ EOT
     protected function execute(InputInterface $input, OutputInterface $output)
     {
         $io = $this->getIO();
+        if ($input->getOption('dev')) {
+            $io->writeError('<warning>You are using the deprecated option "--dev". It has no effect and will break in Composer 3.</warning>');
+        }
+        if ($input->getOption('no-suggest')) {
+            $io->writeError('<warning>You are using the deprecated option "--no-suggest". It has no effect and will break in Composer 3.</warning>');
+        }
+
         if ($args = $input->getArgument('packages')) {
             $io->writeError('<error>Invalid argument '.implode(' ', $args).'. Use "composer require '.implode(' ', $args).'" instead to add packages to your composer.json.</error>');
 
             return 1;
         }
 
-        if ($input->getOption('no-custom-installers')) {
-            $io->writeError('<warning>You are using the deprecated option "no-custom-installers". Use "no-plugins" instead.</warning>');
-            $input->setOption('no-plugins', true);
-        }
+        if ($input->getOption('no-install')) {
+            $io->writeError('<error>Invalid option "--no-install". Use "composer update --no-install" instead if you are trying to update the composer.lock file.</error>');
 
-        if ($input->getOption('dev')) {
-            $io->writeError('<warning>You are using the deprecated option "dev". Dev packages are installed by default now.</warning>');
+            return 1;
         }
 
         $composer = $this->getComposer(true, $input->getOption('no-plugins'));
-        $composer->getDownloadManager()->setOutputProgress(!$input->getOption('no-progress'));
+
+        if ((!$composer->getLocker() || !$composer->getLocker()->isLocked()) && !HttpDownloader::isCurlEnabled()) {
+            $io->writeError('<warning>Composer is operating significantly slower than normal because you do not have the PHP curl extension enabled.</warning>');
+        }
 
         $commandEvent = new CommandEvent(PluginEvents::COMMAND, 'install', $input, $output);
         $composer->getEventDispatcher()->dispatch($commandEvent->getName(), $commandEvent);
@@ -98,7 +108,12 @@ EOT
 
         $optimize = $input->getOption('optimize-autoloader') || $config->get('optimize-autoloader');
         $authoritative = $input->getOption('classmap-authoritative') || $config->get('classmap-authoritative');
-        $apcu = $input->getOption('apcu-autoloader') || $config->get('apcu-autoloader');
+        $apcuPrefix = $input->getOption('apcu-autoloader-prefix');
+        $apcu = $apcuPrefix !== null || $input->getOption('apcu-autoloader') || $config->get('apcu-autoloader');
+
+        $ignorePlatformReqs = $input->getOption('ignore-platform-reqs') ?: ($input->getOption('ignore-platform-req') ?: false);
+
+        $composer->getInstallationManager()->setOutputProgress(!$input->getOption('no-progress'));
 
         $install
             ->setDryRun($input->getOption('dry-run'))
@@ -108,11 +123,10 @@ EOT
             ->setDevMode(!$input->getOption('no-dev'))
             ->setDumpAutoloader(!$input->getOption('no-autoloader'))
             ->setRunScripts(!$input->getOption('no-scripts'))
-            ->setSkipSuggest($input->getOption('no-suggest'))
             ->setOptimizeAutoloader($optimize)
             ->setClassMapAuthoritative($authoritative)
-            ->setApcuAutoloader($apcu)
-            ->setIgnorePlatformRequirements($input->getOption('ignore-platform-reqs'))
+            ->setApcuAutoloader($apcu, $apcuPrefix)
+            ->setIgnorePlatformRequirements($ignorePlatformReqs)
         ;
 
         if ($input->getOption('no-plugins')) {
diff -pruN 1.10.19-1/src/Composer/Command/LicensesCommand.php 2.0.9-1/src/Composer/Command/LicensesCommand.php
--- 1.10.19-1/src/Composer/Command/LicensesCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/LicensesCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -21,6 +21,7 @@ use Symfony\Component\Console\Helper\Tab
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Input\InputOption;
 use Symfony\Component\Console\Output\OutputInterface;
+use Symfony\Component\Console\Style\SymfonyStyle;
 
 /**
  * @author Benoît Merlet <benoit.merlet@gmail.com>
@@ -33,7 +34,7 @@ class LicensesCommand extends BaseComman
             ->setName('licenses')
             ->setDescription('Shows information about licenses of dependencies.')
             ->setDefinition(array(
-                new InputOption('format', 'f', InputOption::VALUE_REQUIRED, 'Format of the output: text or json', 'text'),
+                new InputOption('format', 'f', InputOption::VALUE_REQUIRED, 'Format of the output: text, json or summary', 'text'),
                 new InputOption('no-dev', null, InputOption::VALUE_NONE, 'Disables search in require-dev packages.'),
             ))
             ->setHelp(
@@ -111,6 +112,31 @@ EOT
                 )));
                 break;
 
+            case 'summary':
+                $usedLicenses = array();
+                foreach ($packages as $package) {
+                    $license = $package->getLicense();
+                    $licenseName = $license[0];
+                    if (!isset($usedLicenses[$licenseName])) {
+                        $usedLicenses[$licenseName] = 0;
+                    }
+                    $usedLicenses[$licenseName]++;
+                }
+
+                // Sort licenses so that the most used license will appear first
+                arsort($usedLicenses, SORT_NUMERIC);
+
+                $rows = array();
+                foreach ($usedLicenses as $usedLicense => $numberOfDependencies) {
+                    $rows[] = array($usedLicense, $numberOfDependencies);
+                }
+
+                $symfonyIo = new SymfonyStyle($input, $output);
+                $symfonyIo->table(
+                    array('License', 'Number of dependencies'),
+                    $rows
+                );
+                break;
             default:
                 throw new \RuntimeException(sprintf('Unsupported format "%s".  See help for supported formats.', $format));
         }
diff -pruN 1.10.19-1/src/Composer/Command/OutdatedCommand.php 2.0.9-1/src/Composer/Command/OutdatedCommand.php
--- 1.10.19-1/src/Composer/Command/OutdatedCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/OutdatedCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -32,11 +32,13 @@ class OutdatedCommand extends ShowComman
                 new InputArgument('package', InputArgument::OPTIONAL, 'Package to inspect. Or a name including a wildcard (*) to filter lists of packages instead.'),
                 new InputOption('outdated', 'o', InputOption::VALUE_NONE, 'Show only packages that are outdated (this is the default, but present here for compat with `show`'),
                 new InputOption('all', 'a', InputOption::VALUE_NONE, 'Show all installed packages with their latest versions'),
+                new InputOption('locked', null, InputOption::VALUE_NONE, 'Shows updates for packages from the lock file, regardless of what is currently in vendor dir'),
                 new InputOption('direct', 'D', InputOption::VALUE_NONE, 'Shows only packages that are directly required by the root package'),
                 new InputOption('strict', null, InputOption::VALUE_NONE, 'Return a non-zero exit code when there are outdated packages'),
                 new InputOption('minor-only', 'm', InputOption::VALUE_NONE, 'Show only packages that have minor SemVer-compatible updates. Use with the --outdated option.'),
                 new InputOption('format', 'f', InputOption::VALUE_REQUIRED, 'Format of the output: text or json', 'text'),
                 new InputOption('ignore', null, InputOption::VALUE_REQUIRED | InputOption::VALUE_IS_ARRAY, 'Ignore specified package(s). Use it with the --outdated option if you don\'t want to be informed about new versions of some packages.'),
+                new InputOption('no-dev', null, InputOption::VALUE_NONE, 'Disables search in require-dev packages.'),
             ))
             ->setHelp(
                 <<<EOT
@@ -77,6 +79,12 @@ EOT
         if ($input->getOption('minor-only')) {
             $args['--minor-only'] = true;
         }
+        if ($input->getOption('locked')) {
+            $args['--locked'] = true;
+        }
+        if ($input->getOption('no-dev')) {
+            $args['--no-dev'] = true;
+        }
         $args['--format'] = $input->getOption('format');
         $args['--ignore'] = $input->getOption('ignore');
 
diff -pruN 1.10.19-1/src/Composer/Command/RemoveCommand.php 2.0.9-1/src/Composer/Command/RemoveCommand.php
--- 1.10.19-1/src/Composer/Command/RemoveCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/RemoveCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,7 @@
 namespace Composer\Command;
 
 use Composer\Config\JsonConfigSource;
+use Composer\DependencyResolver\Request;
 use Composer\Installer;
 use Composer\Plugin\CommandEvent;
 use Composer\Plugin\PluginEvents;
@@ -38,16 +39,23 @@ class RemoveCommand extends BaseCommand
             ->setDefinition(array(
                 new InputArgument('packages', InputArgument::IS_ARRAY | InputArgument::REQUIRED, 'Packages that should be removed.'),
                 new InputOption('dev', null, InputOption::VALUE_NONE, 'Removes a package from the require-dev section.'),
+                new InputOption('dry-run', null, InputOption::VALUE_NONE, 'Outputs the operations but will not execute anything (implicitly enables --verbose).'),
                 new InputOption('no-progress', null, InputOption::VALUE_NONE, 'Do not output download progress.'),
-                new InputOption('no-update', null, InputOption::VALUE_NONE, 'Disables the automatic update of the dependencies.'),
+                new InputOption('no-update', null, InputOption::VALUE_NONE, 'Disables the automatic update of the dependencies (implies --no-install).'),
+                new InputOption('no-install', null, InputOption::VALUE_NONE, 'Skip the install step after updating the composer.lock file.'),
                 new InputOption('no-scripts', null, InputOption::VALUE_NONE, 'Skips the execution of all scripts defined in composer.json file.'),
                 new InputOption('update-no-dev', null, InputOption::VALUE_NONE, 'Run the dependency update with the --no-dev option.'),
-                new InputOption('update-with-dependencies', null, InputOption::VALUE_NONE, 'Allows inherited dependencies to be updated with explicit dependencies. (Deprecrated, is now default behavior)'),
+                new InputOption('update-with-dependencies', 'w', InputOption::VALUE_NONE, 'Allows inherited dependencies to be updated with explicit dependencies. (Deprecrated, is now default behavior)'),
+                new InputOption('update-with-all-dependencies', 'W', InputOption::VALUE_NONE, 'Allows all inherited dependencies to be updated, including those that are root requirements.'),
+                new InputOption('with-all-dependencies', null, InputOption::VALUE_NONE, 'Alias for --update-with-all-dependencies'),
                 new InputOption('no-update-with-dependencies', null, InputOption::VALUE_NONE, 'Does not allow inherited dependencies to be updated with explicit dependencies.'),
-                new InputOption('ignore-platform-reqs', null, InputOption::VALUE_NONE, 'Ignore platform requirements (php & ext- packages).'),
+                new InputOption('unused', null, InputOption::VALUE_NONE, 'Remove all packages which are locked but not required by any other package.'),
+                new InputOption('ignore-platform-req', null, InputOption::VALUE_REQUIRED | InputOption::VALUE_IS_ARRAY, 'Ignore a specific platform requirement (php & ext- packages).'),
+                new InputOption('ignore-platform-reqs', null, InputOption::VALUE_NONE, 'Ignore all platform requirements (php & ext- packages).'),
                 new InputOption('optimize-autoloader', 'o', InputOption::VALUE_NONE, 'Optimize autoloader during autoloader dump'),
                 new InputOption('classmap-authoritative', 'a', InputOption::VALUE_NONE, 'Autoload classes from the classmap only. Implicitly enables `--optimize-autoloader`.'),
                 new InputOption('apcu-autoloader', null, InputOption::VALUE_NONE, 'Use APCu to cache found/not-found classes.'),
+                new InputOption('apcu-autoloader-prefix', null, InputOption::VALUE_REQUIRED, 'Use a custom prefix for the APCu autoloader cache. Implicitly enables --apcu-autoloader'),
             ))
             ->setHelp(
                 <<<EOT
@@ -62,6 +70,53 @@ EOT
         ;
     }
 
+    protected function interact(InputInterface $input, OutputInterface $output)
+    {
+        if ($input->getOption('unused')) {
+            $composer = $this->getComposer();
+            $locker = $composer->getLocker();
+            if (!$locker->isLocked()) {
+                throw new \UnexpectedValueException('A valid composer.lock file is required to run this command with --unused');
+            }
+
+            $lockedPackages = $locker->getLockedRepository()->getPackages();
+
+            $required = array();
+            foreach (array_merge($composer->getPackage()->getRequires(), $composer->getPackage()->getDevRequires()) as $link) {
+                $required[$link->getTarget()] = true;
+            }
+
+            do {
+                $found = false;
+                foreach ($lockedPackages as $index => $package) {
+                    foreach ($package->getNames() as $name) {
+                        if (isset($required[$name])) {
+                            foreach ($package->getRequires() as $link) {
+                                $required[$link->getTarget()] = true;
+                            }
+                            $found = true;
+                            unset($lockedPackages[$index]);
+                            break;
+                        }
+                    }
+                }
+            } while ($found);
+
+            $unused = array();
+            foreach ($lockedPackages as $package) {
+                $unused[] = $package->getName();
+            }
+            $input->setArgument('packages', array_merge($input->getArgument('packages'), $unused));
+
+            if (!$input->getArgument('packages')) {
+                $this->getIO()->writeError('<info>No unused packages to remove</info>');
+                $this->setCode(function () {
+                    return 0;
+                });
+            }
+        }
+    }
+
     protected function execute(InputInterface $input, OutputInterface $output)
     {
         $packages = $input->getArgument('packages');
@@ -92,26 +147,44 @@ EOT
             }
         }
 
+        $dryRun = $input->getOption('dry-run');
+        $toRemove = array();
         foreach ($packages as $package) {
             if (isset($composer[$type][$package])) {
-                $json->removeLink($type, $composer[$type][$package]);
+                if ($dryRun) {
+                    $toRemove[$type][] = $composer[$type][$package];
+                } else {
+                    $json->removeLink($type, $composer[$type][$package]);
+                }
             } elseif (isset($composer[$altType][$package])) {
                 $io->writeError('<warning>' . $composer[$altType][$package] . ' could not be found in ' . $type . ' but it is present in ' . $altType . '</warning>');
                 if ($io->isInteractive()) {
-                    if ($io->askConfirmation('Do you want to remove it from ' . $altType . ' [<comment>yes</comment>]? ', true)) {
-                        $json->removeLink($altType, $composer[$altType][$package]);
+                    if ($io->askConfirmation('Do you want to remove it from ' . $altType . ' [<comment>yes</comment>]? ')) {
+                        if ($dryRun) {
+                            $toRemove[$altType][] = $composer[$altType][$package];
+                        } else {
+                            $json->removeLink($altType, $composer[$altType][$package]);
+                        }
                     }
                 }
             } elseif (isset($composer[$type]) && $matches = preg_grep(BasePackage::packageNameToRegexp($package), array_keys($composer[$type]))) {
                 foreach ($matches as $matchedPackage) {
-                    $json->removeLink($type, $matchedPackage);
+                    if ($dryRun) {
+                        $toRemove[$type][] = $matchedPackage;
+                    } else {
+                        $json->removeLink($type, $matchedPackage);
+                    }
                 }
             } elseif (isset($composer[$altType]) && $matches = preg_grep(BasePackage::packageNameToRegexp($package), array_keys($composer[$altType]))) {
                 foreach ($matches as $matchedPackage) {
                     $io->writeError('<warning>' . $matchedPackage . ' could not be found in ' . $type . ' but it is present in ' . $altType . '</warning>');
                     if ($io->isInteractive()) {
-                        if ($io->askConfirmation('Do you want to remove it from ' . $altType . ' [<comment>yes</comment>]? ', true)) {
-                            $json->removeLink($altType, $matchedPackage);
+                        if ($io->askConfirmation('Do you want to remove it from ' . $altType . ' [<comment>yes</comment>]? ')) {
+                            if ($dryRun) {
+                                $toRemove[$altType][] = $matchedPackage;
+                            } else {
+                                $json->removeLink($altType, $matchedPackage);
+                            }
                         }
                     }
                 }
@@ -120,6 +193,8 @@ EOT
             }
         }
 
+        $io->writeError('<info>'.$file.' has been updated</info>');
+
         if ($input->getOption('no-update')) {
             return 0;
         }
@@ -127,37 +202,85 @@ EOT
         // Update packages
         $this->resetComposer();
         $composer = $this->getComposer(true, $input->getOption('no-plugins'));
-        $composer->getDownloadManager()->setOutputProgress(!$input->getOption('no-progress'));
+
+        if ($dryRun) {
+            $rootPackage = $composer->getPackage();
+            $links = array(
+                'require' => $rootPackage->getRequires(),
+                'require-dev' => $rootPackage->getDevRequires(),
+            );
+            foreach ($toRemove as $type => $names) {
+                foreach ($names as $name) {
+                    unset($links[$type][$name]);
+                }
+            }
+            $rootPackage->setRequires($links['require']);
+            $rootPackage->setDevRequires($links['require-dev']);
+        }
 
         $commandEvent = new CommandEvent(PluginEvents::COMMAND, 'remove', $input, $output);
         $composer->getEventDispatcher()->dispatch($commandEvent->getName(), $commandEvent);
 
+        $composer->getInstallationManager()->setOutputProgress(!$input->getOption('no-progress'));
+
         $install = Installer::create($io, $composer);
 
         $updateDevMode = !$input->getOption('update-no-dev');
         $optimize = $input->getOption('optimize-autoloader') || $composer->getConfig()->get('optimize-autoloader');
         $authoritative = $input->getOption('classmap-authoritative') || $composer->getConfig()->get('classmap-authoritative');
-        $apcu = $input->getOption('apcu-autoloader') || $composer->getConfig()->get('apcu-autoloader');
+        $apcuPrefix = $input->getOption('apcu-autoloader-prefix');
+        $apcu = $apcuPrefix !== null || $input->getOption('apcu-autoloader') || $composer->getConfig()->get('apcu-autoloader');
+
+        $updateAllowTransitiveDependencies = Request::UPDATE_LISTED_WITH_TRANSITIVE_DEPS_NO_ROOT_REQUIRE;
+        $flags = '';
+        if ($input->getOption('update-with-all-dependencies') || $input->getOption('with-all-dependencies')) {
+            $updateAllowTransitiveDependencies = Request::UPDATE_LISTED_WITH_TRANSITIVE_DEPS;
+            $flags .= ' --with-all-dependencies';
+        } elseif ($input->getOption('no-update-with-dependencies')) {
+            $updateAllowTransitiveDependencies = Request::UPDATE_ONLY_LISTED;
+            $flags .= ' --with-dependencies';
+        }
+
+        $io->writeError('<info>Running composer update '.implode(' ', $packages).$flags.'</info>');
+
+        $ignorePlatformReqs = $input->getOption('ignore-platform-reqs') ?: ($input->getOption('ignore-platform-req') ?: false);
 
         $install
             ->setVerbose($input->getOption('verbose'))
             ->setDevMode($updateDevMode)
             ->setOptimizeAutoloader($optimize)
             ->setClassMapAuthoritative($authoritative)
-            ->setApcuAutoloader($apcu)
+            ->setApcuAutoloader($apcu, $apcuPrefix)
             ->setUpdate(true)
-            ->setUpdateAllowList($packages)
-            ->setAllowListTransitiveDependencies(!$input->getOption('no-update-with-dependencies'))
-            ->setIgnorePlatformRequirements($input->getOption('ignore-platform-reqs'))
+            ->setInstall(!$input->getOption('no-install'))
+            ->setUpdateAllowTransitiveDependencies($updateAllowTransitiveDependencies)
+            ->setIgnorePlatformRequirements($ignorePlatformReqs)
             ->setRunScripts(!$input->getOption('no-scripts'))
+            ->setDryRun($dryRun)
         ;
 
+        // if no lock is present, we do not do a partial update as
+        // this is not supported by the Installer
+        if ($composer->getLocker()->isLocked()) {
+            $install->setUpdateAllowList($packages);
+        }
+
         $status = $install->run();
         if ($status !== 0) {
             $io->writeError("\n".'<error>Removal failed, reverting '.$file.' to its original content.</error>');
             file_put_contents($jsonFile->getPath(), $composerBackup);
         }
 
+        if (!$dryRun) {
+            foreach ($packages as $package) {
+                if ($composer->getRepositoryManager()->getLocalRepository()->findPackages($package)) {
+                    $io->writeError('<error>Removal failed, '.$package.' is still present, it may be required by another package. See `composer why '.$package.'`.</error>');
+
+                    return 2;
+                }
+            }
+        }
+
         return $status;
     }
 }
diff -pruN 1.10.19-1/src/Composer/Command/RequireCommand.php 2.0.9-1/src/Composer/Command/RequireCommand.php
--- 1.10.19-1/src/Composer/Command/RequireCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/RequireCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,6 +12,7 @@
 
 namespace Composer\Command;
 
+use Composer\DependencyResolver\Request;
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Input\InputArgument;
 use Symfony\Component\Console\Input\InputOption;
@@ -21,6 +22,8 @@ use Composer\Installer;
 use Composer\Json\JsonFile;
 use Composer\Json\JsonManipulator;
 use Composer\Package\Version\VersionParser;
+use Composer\Package\Loader\ArrayLoader;
+use Composer\Package\BasePackage;
 use Composer\Plugin\CommandEvent;
 use Composer\Plugin\PluginEvents;
 use Composer\Repository\CompositeRepository;
@@ -35,9 +38,14 @@ use Composer\Util\Silencer;
 class RequireCommand extends InitCommand
 {
     private $newlyCreated;
+    private $firstRequire;
     private $json;
     private $file;
     private $composerBackup;
+    /** @var string file name */
+    private $lock;
+    /** @var ?string contents before modification if the lock file exists */
+    private $lockBackup;
 
     protected function configure()
     {
@@ -47,23 +55,29 @@ class RequireCommand extends InitCommand
             ->setDefinition(array(
                 new InputArgument('packages', InputArgument::IS_ARRAY | InputArgument::OPTIONAL, 'Optional package name can also include a version constraint, e.g. foo/bar or foo/bar:1.0.0 or foo/bar=1.0.0 or "foo/bar 1.0.0"'),
                 new InputOption('dev', null, InputOption::VALUE_NONE, 'Add requirement to require-dev.'),
+                new InputOption('dry-run', null, InputOption::VALUE_NONE, 'Outputs the operations but will not execute anything (implicitly enables --verbose).'),
                 new InputOption('prefer-source', null, InputOption::VALUE_NONE, 'Forces installation from package sources when possible, including VCS information.'),
                 new InputOption('prefer-dist', null, InputOption::VALUE_NONE, 'Forces installation from package dist even for dev versions.'),
                 new InputOption('fixed', null, InputOption::VALUE_NONE, 'Write fixed version to the composer.json.'),
+                new InputOption('no-suggest', null, InputOption::VALUE_NONE, 'DEPRECATED: This flag does not exist anymore.'),
                 new InputOption('no-progress', null, InputOption::VALUE_NONE, 'Do not output download progress.'),
-                new InputOption('no-suggest', null, InputOption::VALUE_NONE, 'Do not show package suggestions.'),
-                new InputOption('no-update', null, InputOption::VALUE_NONE, 'Disables the automatic update of the dependencies.'),
+                new InputOption('no-update', null, InputOption::VALUE_NONE, 'Disables the automatic update of the dependencies (implies --no-install).'),
+                new InputOption('no-install', null, InputOption::VALUE_NONE, 'Skip the install step after updating the composer.lock file.'),
                 new InputOption('no-scripts', null, InputOption::VALUE_NONE, 'Skips the execution of all scripts defined in composer.json file.'),
                 new InputOption('update-no-dev', null, InputOption::VALUE_NONE, 'Run the dependency update with the --no-dev option.'),
-                new InputOption('update-with-dependencies', null, InputOption::VALUE_NONE, 'Allows inherited dependencies to be updated, except those that are root requirements.'),
-                new InputOption('update-with-all-dependencies', null, InputOption::VALUE_NONE, 'Allows all inherited dependencies to be updated, including those that are root requirements.'),
-                new InputOption('ignore-platform-reqs', null, InputOption::VALUE_NONE, 'Ignore platform requirements (php & ext- packages).'),
+                new InputOption('update-with-dependencies', 'w', InputOption::VALUE_NONE, 'Allows inherited dependencies to be updated, except those that are root requirements.'),
+                new InputOption('update-with-all-dependencies', 'W', InputOption::VALUE_NONE, 'Allows all inherited dependencies to be updated, including those that are root requirements.'),
+                new InputOption('with-dependencies', null, InputOption::VALUE_NONE, 'Alias for --update-with-dependencies'),
+                new InputOption('with-all-dependencies', null, InputOption::VALUE_NONE, 'Alias for --update-with-all-dependencies'),
+                new InputOption('ignore-platform-req', null, InputOption::VALUE_REQUIRED | InputOption::VALUE_IS_ARRAY, 'Ignore a specific platform requirement (php & ext- packages).'),
+                new InputOption('ignore-platform-reqs', null, InputOption::VALUE_NONE, 'Ignore all platform requirements (php & ext- packages).'),
                 new InputOption('prefer-stable', null, InputOption::VALUE_NONE, 'Prefer stable versions of dependencies.'),
                 new InputOption('prefer-lowest', null, InputOption::VALUE_NONE, 'Prefer lowest versions of dependencies.'),
                 new InputOption('sort-packages', null, InputOption::VALUE_NONE, 'Sorts packages when adding/updating a new dependency'),
                 new InputOption('optimize-autoloader', 'o', InputOption::VALUE_NONE, 'Optimize autoloader during autoloader dump'),
                 new InputOption('classmap-authoritative', 'a', InputOption::VALUE_NONE, 'Autoload classes from the classmap only. Implicitly enables `--optimize-autoloader`.'),
                 new InputOption('apcu-autoloader', null, InputOption::VALUE_NONE, 'Use APCu to cache found/not-found classes.'),
+                new InputOption('apcu-autoloader-prefix', null, InputOption::VALUE_REQUIRED, 'Use a custom prefix for the APCu autoloader cache. Implicitly enables --apcu-autoloader'),
             ))
             ->setHelp(
                 <<<EOT
@@ -94,6 +108,10 @@ EOT
         $this->file = Factory::getComposerFile();
         $io = $this->getIO();
 
+        if ($input->getOption('no-suggest')) {
+            $io->writeError('<warning>You are using the deprecated option "--no-suggest". It has no effect and will break in Composer 3.</warning>');
+        }
+
         $this->newlyCreated = !file_exists($this->file);
         if ($this->newlyCreated && !file_put_contents($this->file, "{\n}\n")) {
             $io->writeError('<error>'.$this->file.' could not be created.</error>');
@@ -113,7 +131,9 @@ EOT
         }
 
         $this->json = new JsonFile($this->file);
+        $this->lock = Factory::getLockFile($this->file);
         $this->composerBackup = file_get_contents($this->json->getPath());
+        $this->lockBackup = file_exists($this->lock) ? file_get_contents($this->lock) : null;
 
         // check for writability by writing to the file as is_writable can not be trusted on network-mounts
         // see https://github.com/composer/composer/issues/8231 and https://bugs.php.net/bug.php?id=68926
@@ -148,7 +168,7 @@ EOT
         $platformOverrides = $composer->getConfig()->get('platform') ?: array();
         // initialize $this->repos as it is used by the parent InitCommand
         $this->repos = new CompositeRepository(array_merge(
-            array(new PlatformRepository(array(), $platformOverrides)),
+            array($platformRepo = new PlatformRepository(array(), $platformOverrides)),
             $repos
         ));
 
@@ -158,12 +178,19 @@ EOT
             $preferredStability = $composer->getPackage()->getMinimumStability();
         }
 
-        $phpVersion = $this->repos->findPackage('php', '*')->getPrettyVersion();
         try {
-            $requirements = $this->determineRequirements($input, $output, $input->getArgument('packages'), $phpVersion, $preferredStability, !$input->getOption('no-update'), $input->getOption('fixed'));
+            $requirements = $this->determineRequirements(
+                $input,
+                $output,
+                $input->getArgument('packages'),
+                $platformRepo,
+                $preferredStability,
+                !$input->getOption('no-update'),
+                $input->getOption('fixed')
+            );
         } catch (\Exception $e) {
             if ($this->newlyCreated) {
-                throw new \RuntimeException('No composer.json present in the current directory, this may be the cause of the following exception.', 0, $e);
+                throw new \RuntimeException('No composer.json present in the current directory ('.$this->file.'), this may be the cause of the following exception.', 0, $e);
             }
 
             throw $e;
@@ -186,11 +213,22 @@ EOT
 
         $sortPackages = $input->getOption('sort-packages') || $composer->getConfig()->get('sort-packages');
 
-        if (!$this->updateFileCleanly($this->json, $requirements, $requireKey, $removeKey, $sortPackages)) {
+        $this->firstRequire = $this->newlyCreated;
+        if (!$this->firstRequire) {
+            $composerDefinition = $this->json->read();
+            if (empty($composerDefinition['require']) && empty($composerDefinition['require-dev'])) {
+                $this->firstRequire = true;
+            }
+        }
+
+        if (!$input->getOption('dry-run') && !$this->updateFileCleanly($this->json, $requirements, $requireKey, $removeKey, $sortPackages)) {
             $composerDefinition = $this->json->read();
             foreach ($requirements as $package => $version) {
                 $composerDefinition[$requireKey][$package] = $version;
                 unset($composerDefinition[$removeKey][$package]);
+                if (isset($composerDefinition[$removeKey]) && count($composerDefinition[$removeKey]) === 0) {
+                    unset($composerDefinition[$removeKey]);
+                }
             }
             $this->json->write($composerDefinition);
         }
@@ -202,49 +240,86 @@ EOT
         }
 
         try {
-            return $this->doUpdate($input, $output, $io, $requirements);
+            return $this->doUpdate($input, $output, $io, $requirements, $requireKey, $removeKey);
         } catch (\Exception $e) {
             $this->revertComposerFile(false);
             throw $e;
         }
     }
 
-    private function doUpdate(InputInterface $input, OutputInterface $output, IOInterface $io, array $requirements)
+    private function doUpdate(InputInterface $input, OutputInterface $output, IOInterface $io, array $requirements, $requireKey, $removeKey)
     {
         // Update packages
         $this->resetComposer();
         $composer = $this->getComposer(true, $input->getOption('no-plugins'));
-        $composer->getDownloadManager()->setOutputProgress(!$input->getOption('no-progress'));
+
+        if ($input->getOption('dry-run')) {
+            $rootPackage = $composer->getPackage();
+            $links = array(
+                'require' => $rootPackage->getRequires(),
+                'require-dev' => $rootPackage->getDevRequires(),
+            );
+            $loader = new ArrayLoader();
+            $newLinks = $loader->parseLinks($rootPackage->getName(), $rootPackage->getPrettyVersion(), BasePackage::$supportedLinkTypes[$requireKey]['description'], $requirements);
+            $links[$requireKey] = array_merge($links[$requireKey], $newLinks);
+            foreach ($requirements as $package => $constraint) {
+                unset($links[$removeKey][$package]);
+            }
+            $rootPackage->setRequires($links['require']);
+            $rootPackage->setDevRequires($links['require-dev']);
+        }
 
         $updateDevMode = !$input->getOption('update-no-dev');
         $optimize = $input->getOption('optimize-autoloader') || $composer->getConfig()->get('optimize-autoloader');
         $authoritative = $input->getOption('classmap-authoritative') || $composer->getConfig()->get('classmap-authoritative');
-        $apcu = $input->getOption('apcu-autoloader') || $composer->getConfig()->get('apcu-autoloader');
+        $apcuPrefix = $input->getOption('apcu-autoloader-prefix');
+        $apcu = $apcuPrefix !== null || $input->getOption('apcu-autoloader') || $composer->getConfig()->get('apcu-autoloader');
+
+        $updateAllowTransitiveDependencies = Request::UPDATE_ONLY_LISTED;
+        $flags = '';
+        if ($input->getOption('update-with-all-dependencies') || $input->getOption('with-all-dependencies')) {
+            $updateAllowTransitiveDependencies = Request::UPDATE_LISTED_WITH_TRANSITIVE_DEPS;
+            $flags .= ' --with-all-dependencies';
+        } elseif ($input->getOption('update-with-dependencies') || $input->getOption('with-dependencies')) {
+            $updateAllowTransitiveDependencies = Request::UPDATE_LISTED_WITH_TRANSITIVE_DEPS_NO_ROOT_REQUIRE;
+            $flags .= ' --with-dependencies';
+        }
+
+        $io->writeError('<info>Running composer update '.implode(' ', array_keys($requirements)).$flags.'</info>');
 
         $commandEvent = new CommandEvent(PluginEvents::COMMAND, 'require', $input, $output);
         $composer->getEventDispatcher()->dispatch($commandEvent->getName(), $commandEvent);
 
+        $composer->getInstallationManager()->setOutputProgress(!$input->getOption('no-progress'));
+
         $install = Installer::create($io, $composer);
 
+        $ignorePlatformReqs = $input->getOption('ignore-platform-reqs') ?: ($input->getOption('ignore-platform-req') ?: false);
+
         $install
+            ->setDryRun($input->getOption('dry-run'))
             ->setVerbose($input->getOption('verbose'))
             ->setPreferSource($input->getOption('prefer-source'))
             ->setPreferDist($input->getOption('prefer-dist'))
             ->setDevMode($updateDevMode)
             ->setRunScripts(!$input->getOption('no-scripts'))
-            ->setSkipSuggest($input->getOption('no-suggest'))
             ->setOptimizeAutoloader($optimize)
             ->setClassMapAuthoritative($authoritative)
-            ->setApcuAutoloader($apcu)
+            ->setApcuAutoloader($apcu, $apcuPrefix)
             ->setUpdate(true)
-            ->setUpdateAllowList(array_keys($requirements))
-            ->setAllowListTransitiveDependencies($input->getOption('update-with-dependencies'))
-            ->setAllowListAllDependencies($input->getOption('update-with-all-dependencies'))
-            ->setIgnorePlatformRequirements($input->getOption('ignore-platform-reqs'))
+            ->setInstall(!$input->getOption('no-install'))
+            ->setUpdateAllowTransitiveDependencies($updateAllowTransitiveDependencies)
+            ->setIgnorePlatformRequirements($ignorePlatformReqs)
             ->setPreferStable($input->getOption('prefer-stable'))
             ->setPreferLowest($input->getOption('prefer-lowest'))
         ;
 
+        // if no lock is present, or the file is brand new, we do not do a
+        // partial update as this is not supported by the Installer
+        if (!$this->firstRequire && $composer->getLocker()->isLocked()) {
+            $install->setUpdateAllowList(array_keys($requirements));
+        }
+
         $status = $install->run();
         if ($status !== 0) {
             $this->revertComposerFile(false);
@@ -268,6 +343,8 @@ EOT
             }
         }
 
+        $manipulator->removeMainKeyIfEmpty($removeKey);
+
         file_put_contents($json->getPath(), $manipulator->getContents());
 
         return true;
@@ -285,9 +362,19 @@ EOT
         if ($this->newlyCreated) {
             $io->writeError("\n".'<error>Installation failed, deleting '.$this->file.'.</error>');
             unlink($this->json->getPath());
+            if (file_exists($this->lock)) {
+                unlink($this->lock);
+            }
         } else {
-            $io->writeError("\n".'<error>Installation failed, reverting '.$this->file.' to its original content.</error>');
+            $msg = ' to its ';
+            if ($this->lockBackup) {
+                $msg = ' and '.$this->lock.' to their ';
+            }
+            $io->writeError("\n".'<error>Installation failed, reverting '.$this->file.$msg.'original content.</error>');
             file_put_contents($this->json->getPath(), $this->composerBackup);
+            if ($this->lockBackup) {
+                file_put_contents($this->lock, $this->lockBackup);
+            }
         }
 
         if ($hardExit) {
diff -pruN 1.10.19-1/src/Composer/Command/RunScriptCommand.php 2.0.9-1/src/Composer/Command/RunScriptCommand.php
--- 1.10.19-1/src/Composer/Command/RunScriptCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/RunScriptCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -19,7 +19,6 @@ use Symfony\Component\Console\Input\Inpu
 use Symfony\Component\Console\Input\InputOption;
 use Symfony\Component\Console\Input\InputArgument;
 use Symfony\Component\Console\Output\OutputInterface;
-use Symfony\Component\Console\Helper\Table;
 
 /**
  * @author Fabien Potencier <fabien.potencier@gmail.com>
@@ -74,7 +73,8 @@ EOT
     {
         if ($input->getOption('list')) {
             return $this->listScripts($output);
-        } elseif (!$input->getArgument('script')) {
+        }
+        if (!$input->getArgument('script')) {
             throw new \RuntimeException('Missing required argument "script"');
         }
 
@@ -130,16 +130,7 @@ EOT
             $table[] = array('  '.$name, $description);
         }
 
-        $renderer = new Table($output);
-        $renderer->setStyle('compact');
-        $rendererStyle = $renderer->getStyle();
-        if (method_exists($rendererStyle, 'setVerticalBorderChars')) {
-            $rendererStyle->setVerticalBorderChars('');
-        } else {
-            $rendererStyle->setVerticalBorderChar('');
-        }
-        $rendererStyle->setCellRowContentFormat('%s  ');
-        $renderer->setRows($table)->render();
+        $this->renderTable($table, $output);
 
         return 0;
     }
diff -pruN 1.10.19-1/src/Composer/Command/SelfUpdateCommand.php 2.0.9-1/src/Composer/Command/SelfUpdateCommand.php
--- 1.10.19-1/src/Composer/Command/SelfUpdateCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/SelfUpdateCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -21,6 +21,7 @@ use Composer\SelfUpdate\Keys;
 use Composer\SelfUpdate\Versions;
 use Composer\IO\IOInterface;
 use Composer\Downloader\FilesystemException;
+use Composer\Downloader\TransportException;
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Input\InputOption;
 use Symfony\Component\Console\Input\InputArgument;
@@ -80,9 +81,9 @@ EOT
         }
 
         $io = $this->getIO();
-        $remoteFilesystem = Factory::createRemoteFilesystem($io, $config);
+        $httpDownloader = Factory::createHttpDownloader($io, $config);
 
-        $versionsUtil = new Versions($config, $remoteFilesystem);
+        $versionsUtil = new Versions($config, $httpDownloader);
 
         // switch channel if requested
         $requestedChannel = null;
@@ -124,8 +125,8 @@ EOT
         if (function_exists('posix_getpwuid') && function_exists('posix_geteuid')) {
             $composeUser = posix_getpwuid(posix_geteuid());
             $homeOwner = posix_getpwuid(fileowner($home));
-            if (isset($composeUser['name']) && isset($homeOwner['name']) && $composeUser['name'] !== $homeOwner['name']) {
-                $io->writeError('<warning>You are running composer as "'.$composeUser['name'].'", while "'.$home.'" is owned by "'.$homeOwner['name'].'"</warning>');
+            if (isset($composeUser['name'], $homeOwner['name']) && $composeUser['name'] !== $homeOwner['name']) {
+                $io->writeError('<warning>You are running Composer as "'.$composeUser['name'].'", while "'.$home.'" is owned by "'.$homeOwner['name'].'"</warning>');
             }
         }
 
@@ -166,7 +167,7 @@ EOT
             }
         }
 
-        if ($requestedChannel && is_numeric($requestedChannel) && substr($latestStable['version'], 0, 1) !== $requestedChannel) {
+        if ($requestedChannel && is_numeric($requestedChannel) && strpos($latestStable['version'], $requestedChannel) !== 0) {
             $io->writeError('<warning>Warning: You forced the install of '.$latestVersion.' via --'.$requestedChannel.', but '.$latestStable['version'].' is the latest stable version. Updating to it via composer self-update --stable is recommended.</warning>');
         }
 
@@ -184,7 +185,7 @@ EOT
         if (Composer::VERSION === $updateVersion) {
             $io->writeError(
                 sprintf(
-                    '<info>You are already using composer version %s (%s channel).</info>',
+                    '<info>You are already using the latest available Composer version %s (%s channel).</info>',
                     $updateVersion,
                     $channelString
                 )
@@ -209,11 +210,18 @@ EOT
 
         $updatingToTag = !preg_match('{^[0-9a-f]{40}$}', $updateVersion);
 
-        $io->write(sprintf("Updating to version <info>%s</info> (%s channel).", $updateVersion, $channelString));
+        $io->write(sprintf("Upgrading to version <info>%s</info> (%s channel).", $updateVersion, $channelString));
         $remoteFilename = $baseUrl . ($updatingToTag ? "/download/{$updateVersion}/composer.phar" : '/composer.phar');
-        $signature = $remoteFilesystem->getContents(self::HOMEPAGE, $remoteFilename.'.sig', false);
+        try {
+            $signature = $httpDownloader->get($remoteFilename.'.sig')->getBody();
+        } catch (TransportException $e) {
+            if ($e->getStatusCode() === 404) {
+                throw new \InvalidArgumentException('Version "'.$updateVersion.'" could not be found.', 0, $e);
+            }
+            throw $e;
+        }
         $io->writeError('   ', false);
-        $remoteFilesystem->copy(self::HOMEPAGE, $remoteFilename, $tempFilename, !$input->getOption('no-progress'));
+        $httpDownloader->copy($remoteFilename, $tempFilename);
         $io->writeError('');
 
         if (!file_exists($tempFilename) || !$signature) {
@@ -389,11 +397,11 @@ TAGSPUBKEY
     /**
      * Checks if the downloaded/rollback phar is valid then moves it
      *
-     * @param  string $localFilename The composer.phar location
-     * @param  string $newFilename The downloaded or backup phar
-     * @param  string $backupTarget The filename to use for the backup
-     * @throws \FilesystemException If the file cannot be moved
-     * @return bool Whether the phar is valid and has been moved
+     * @param  string              $localFilename The composer.phar location
+     * @param  string              $newFilename   The downloaded or backup phar
+     * @param  string              $backupTarget  The filename to use for the backup
+     * @throws FilesystemException If the file cannot be moved
+     * @return bool                Whether the phar is valid and has been moved
      */
     protected function setLocalPhar($localFilename, $newFilename, $backupTarget = null)
     {
@@ -464,26 +472,24 @@ TAGSPUBKEY
 
     protected function getOldInstallationFinder($rollbackDir)
     {
-        $finder = Finder::create()
+        return Finder::create()
             ->depth(0)
             ->files()
             ->name('*' . self::OLD_INSTALL_EXT)
             ->in($rollbackDir);
-
-        return $finder;
     }
 
     /**
      * Validates the downloaded/backup phar file
      *
-     * @param string $pharFile The downloaded or backup phar
-     * @param null|string $error Set by method on failure
+     * @param string      $pharFile The downloaded or backup phar
+     * @param null|string $error    Set by method on failure
      *
      * Code taken from getcomposer.org/installer. Any changes should be made
      * there and replicated here
      *
-     * @return bool If the operation succeeded
      * @throws \Exception
+     * @return bool       If the operation succeeded
      */
     protected function validatePhar($pharFile, &$error)
     {
@@ -530,9 +536,9 @@ TAGSPUBKEY
      *
      * Uses a .vbs script to elevate and run the cmd.exe move command.
      *
-     * @param string $localFilename The composer.phar location
-     * @param string $newFilename The downloaded or backup phar
-     * @return bool Whether composer.phar has been updated
+     * @param  string $localFilename The composer.phar location
+     * @param  string $newFilename   The downloaded or backup phar
+     * @return bool   Whether composer.phar has been updated
      */
     protected function tryAsWindowsAdmin($localFilename, $newFilename)
     {
@@ -573,7 +579,7 @@ EOT;
             $io->writeError('<info>Operation succeeded.</info>');
         } else {
             $io->writeError('<error>Operation failed (file not written). '.$helpMessage.'</error>');
-        };
+        }
 
         return $result;
     }
diff -pruN 1.10.19-1/src/Composer/Command/ShowCommand.php 2.0.9-1/src/Composer/Command/ShowCommand.php
--- 1.10.19-1/src/Composer/Command/ShowCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/ShowCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,21 +14,25 @@ namespace Composer\Command;
 
 use Composer\Composer;
 use Composer\DependencyResolver\DefaultPolicy;
-use Composer\DependencyResolver\Pool;
 use Composer\Json\JsonFile;
 use Composer\Package\BasePackage;
 use Composer\Package\CompletePackageInterface;
+use Composer\Package\Link;
+use Composer\Package\AliasPackage;
 use Composer\Package\PackageInterface;
 use Composer\Package\Version\VersionParser;
 use Composer\Package\Version\VersionSelector;
 use Composer\Plugin\CommandEvent;
 use Composer\Plugin\PluginEvents;
-use Composer\Repository\ArrayRepository;
+use Composer\Repository\InstalledArrayRepository;
 use Composer\Repository\ComposerRepository;
 use Composer\Repository\CompositeRepository;
 use Composer\Repository\PlatformRepository;
 use Composer\Repository\RepositoryFactory;
+use Composer\Repository\InstalledRepository;
 use Composer\Repository\RepositoryInterface;
+use Composer\Repository\RepositorySet;
+use Composer\Repository\RootPackageRepository;
 use Composer\Semver\Constraint\ConstraintInterface;
 use Composer\Semver\Semver;
 use Composer\Spdx\SpdxLicenses;
@@ -52,8 +56,8 @@ class ShowCommand extends BaseCommand
     protected $versionParser;
     protected $colors;
 
-    /** @var Pool */
-    private $pool;
+    /** @var RepositorySet */
+    private $repositorySet;
 
     protected function configure()
     {
@@ -65,6 +69,7 @@ class ShowCommand extends BaseCommand
                 new InputArgument('package', InputArgument::OPTIONAL, 'Package to inspect. Or a name including a wildcard (*) to filter lists of packages instead.'),
                 new InputArgument('version', InputArgument::OPTIONAL, 'Version or version constraint to inspect'),
                 new InputOption('all', null, InputOption::VALUE_NONE, 'List all packages'),
+                new InputOption('locked', null, InputOption::VALUE_NONE, 'List all locked packages'),
                 new InputOption('installed', 'i', InputOption::VALUE_NONE, 'List installed packages only (enabled by default, only present for BC).'),
                 new InputOption('platform', 'p', InputOption::VALUE_NONE, 'List platform packages only'),
                 new InputOption('available', 'a', InputOption::VALUE_NONE, 'List available packages only'),
@@ -79,6 +84,7 @@ class ShowCommand extends BaseCommand
                 new InputOption('direct', 'D', InputOption::VALUE_NONE, 'Shows only packages that are directly required by the root package'),
                 new InputOption('strict', null, InputOption::VALUE_NONE, 'Return a non-zero exit code when there are outdated packages'),
                 new InputOption('format', 'f', InputOption::VALUE_REQUIRED, 'Format of the output: text or json', 'text'),
+                new InputOption('no-dev', null, InputOption::VALUE_NONE, 'Disables search in require-dev packages.'),
             ))
             ->setHelp(
                 <<<EOT
@@ -148,21 +154,23 @@ EOT
             $platformOverrides = $composer->getConfig()->get('platform') ?: array();
         }
         $platformRepo = new PlatformRepository(array(), $platformOverrides);
-        $phpVersion = $platformRepo->findPackage('php', '*')->getVersion();
+        $lockedRepo = null;
 
         if ($input->getOption('self')) {
             $package = $this->getComposer()->getPackage();
             if ($input->getOption('name-only')) {
                 $io->write($package->getName());
+
                 return 0;
             }
-            $repos = $installedRepo = new ArrayRepository(array($package));
+            $repos = $installedRepo = new InstalledRepository(array(new RootPackageRepository($package)));
         } elseif ($input->getOption('platform')) {
-            $repos = $installedRepo = $platformRepo;
+            $repos = $installedRepo = new InstalledRepository(array($platformRepo));
         } elseif ($input->getOption('available')) {
-            $installedRepo = $platformRepo;
+            $installedRepo = new InstalledRepository(array($platformRepo));
             if ($composer) {
                 $repos = new CompositeRepository($composer->getRepositoryManager()->getRepositories());
+                $installedRepo->addRepository($composer->getRepositoryManager()->getLocalRepository());
             } else {
                 $defaultRepos = RepositoryFactory::defaultRepos($io);
                 $repos = new CompositeRepository($defaultRepos);
@@ -170,16 +178,41 @@ EOT
             }
         } elseif ($input->getOption('all') && $composer) {
             $localRepo = $composer->getRepositoryManager()->getLocalRepository();
-            $installedRepo = new CompositeRepository(array($localRepo, $platformRepo));
+            $locker = $composer->getLocker();
+            if ($locker->isLocked()) {
+                $lockedRepo = $locker->getLockedRepository(true);
+                $installedRepo = new InstalledRepository(array($lockedRepo, $localRepo, $platformRepo));
+            } else {
+                $installedRepo = new InstalledRepository(array($localRepo, $platformRepo));
+            }
             $repos = new CompositeRepository(array_merge(array($installedRepo), $composer->getRepositoryManager()->getRepositories()));
         } elseif ($input->getOption('all')) {
             $defaultRepos = RepositoryFactory::defaultRepos($io);
             $io->writeError('No composer.json found in the current directory, showing available packages from ' . implode(', ', array_keys($defaultRepos)));
-            $installedRepo = $platformRepo;
+            $installedRepo = new InstalledRepository(array($platformRepo));
             $repos = new CompositeRepository(array_merge(array($installedRepo), $defaultRepos));
+        } elseif ($input->getOption('locked')) {
+            if (!$composer || !$composer->getLocker()->isLocked()) {
+                throw new \UnexpectedValueException('A valid composer.json and composer.lock files is required to run this command with --locked');
+            }
+            $locker = $composer->getLocker();
+            $lockedRepo = $locker->getLockedRepository(true);
+            $repos = $installedRepo = new InstalledRepository(array($lockedRepo));
         } else {
-            $repos = $installedRepo = $this->getComposer()->getRepositoryManager()->getLocalRepository();
-            $rootPkg = $this->getComposer()->getPackage();
+            // --installed / default case
+            if (!$composer) {
+                $composer = $this->getComposer();
+            }
+            $rootPkg = $composer->getPackage();
+            $repos = $installedRepo = new InstalledRepository(array($composer->getRepositoryManager()->getLocalRepository()));
+
+            if ($input->getOption('no-dev')) {
+                $packages = $this->filterRequiredPackages($installedRepo, $rootPkg);
+                $repos = $installedRepo = new InstalledRepository(array(new InstalledArrayRepository(array_map(function ($pkg) {
+                    return clone $pkg;
+                }, $packages))));
+            }
+
             if (!$installedRepo->getPackages() && ($rootPkg->getRequires() || $rootPkg->getDevRequires())) {
                 $io->writeError('<warning>No dependencies installed. Try running composer install or update.</warning>');
             }
@@ -205,7 +238,7 @@ EOT
                 if (empty($package)) {
                     $options = $input->getOptions();
                     if (!isset($options['working-dir']) || !file_exists('composer.json')) {
-                        if (preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $input->getArgument('package')) && !$input->getOption('platform')) {
+                        if (PlatformRepository::isPlatformPackage($input->getArgument('package')) && !$input->getOption('platform')) {
                             throw new \InvalidArgumentException('Package ' . $packageFilter . ' not found, try using --platform (-p) to show platform packages.');
                         }
                         throw new \InvalidArgumentException('Package ' . $packageFilter . ' not found');
@@ -231,7 +264,7 @@ EOT
             } else {
                 $latestPackage = null;
                 if ($input->getOption('latest')) {
-                    $latestPackage = $this->findLatestPackage($package, $composer, $phpVersion);
+                    $latestPackage = $this->findLatestPackage($package, $composer, $platformRepo, $input->getOption('minor-only'));
                 }
                 if ($input->getOption('outdated') && $input->getOption('strict') && $latestPackage && $latestPackage->getFullPrettyVersion() !== $package->getFullPrettyVersion() && !$latestPackage->isAbandoned()) {
                     $exitCode = 1;
@@ -282,8 +315,9 @@ EOT
 
         // list packages
         $packages = array();
+        $packageFilterRegex = null;
         if (null !== $packageFilter) {
-            $packageFilter = '{^'.str_replace('\\*', '.*?', preg_quote($packageFilter)).'$}i';
+            $packageFilterRegex = '{^'.str_replace('\\*', '.*?', preg_quote($packageFilter)).'$}i';
         }
 
         $packageListFilter = array();
@@ -317,19 +351,16 @@ EOT
         foreach ($repos as $repo) {
             if ($repo === $platformRepo) {
                 $type = 'platform';
-            } elseif (
-                $repo === $installedRepo
-                || ($installedRepo instanceof CompositeRepository && in_array($repo, $installedRepo->getRepositories(), true))
-            ) {
+            } elseif ($lockedRepo !== null && $repo === $lockedRepo) {
+                $type = 'locked';
+            } elseif ($repo === $installedRepo || in_array($repo, $installedRepo->getRepositories(), true)) {
                 $type = 'installed';
             } else {
                 $type = 'available';
             }
-            if ($repo instanceof ComposerRepository && $repo->hasProviders()) {
-                foreach ($repo->getProviderNames() as $name) {
-                    if (!$packageFilter || preg_match($packageFilter, $name)) {
-                        $packages[$type][$name] = $name;
-                    }
+            if ($repo instanceof ComposerRepository) {
+                foreach ($repo->getPackageNames($packageFilter) as $name) {
+                    $packages[$type][$name] = $name;
                 }
             } else {
                 foreach ($repo->getPackages() as $package) {
@@ -337,7 +368,10 @@ EOT
                         || !is_object($packages[$type][$package->getName()])
                         || version_compare($packages[$type][$package->getName()]->getVersion(), $package->getVersion(), '<')
                     ) {
-                        if (!$packageFilter || preg_match($packageFilter, $package->getName())) {
+                        while ($package instanceof AliasPackage) {
+                            $package = $package->getAliasOf();
+                        }
+                        if (!$packageFilterRegex || preg_match($packageFilterRegex, $package->getName())) {
                             if (!$packageListFilter || in_array($package->getName(), $packageListFilter, true)) {
                                 $packages[$type][$package->getName()] = $package;
                             }
@@ -356,7 +390,7 @@ EOT
         $exitCode = 0;
         $viewData = array();
         $viewMetaData = array();
-        foreach (array('platform' => true, 'available' => false, 'installed' => true) as $type => $showVersion) {
+        foreach (array('platform' => true, 'locked' => true, 'available' => false, 'installed' => true) as $type => $showVersion) {
             if (isset($packages[$type])) {
                 ksort($packages[$type]);
 
@@ -365,7 +399,7 @@ EOT
                 if ($showLatest && $showVersion) {
                     foreach ($packages[$type] as $package) {
                         if (is_object($package)) {
-                            $latestPackage = $this->findLatestPackage($package, $composer, $phpVersion, $showMinorOnly);
+                            $latestPackage = $this->findLatestPackage($package, $composer, $platformRepo, $showMinorOnly);
                             if ($latestPackage === false) {
                                 continue;
                             }
@@ -396,7 +430,9 @@ EOT
                         $packageIsIgnored = \in_array($package->getPrettyName(), $ignoredPackages, true);
                         if ($input->getOption('outdated') && ($packageIsUpToDate || $packageIsIgnored)) {
                             continue;
-                        } elseif ($input->getOption('outdated') || $input->getOption('strict')) {
+                        }
+
+                        if ($input->getOption('outdated') || $input->getOption('strict')) {
                             $hasOutdatedPackages = true;
                         }
 
@@ -532,32 +568,32 @@ EOT
     /**
      * finds a package by name and version if provided
      *
-     * @param  RepositoryInterface        $installedRepo
+     * @param  InstalledRepository        $installedRepo
      * @param  RepositoryInterface        $repos
      * @param  string                     $name
      * @param  ConstraintInterface|string $version
      * @throws \InvalidArgumentException
      * @return array                      array(CompletePackageInterface, array of versions)
      */
-    protected function getPackage(RepositoryInterface $installedRepo, RepositoryInterface $repos, $name, $version = null)
+    protected function getPackage(InstalledRepository $installedRepo, RepositoryInterface $repos, $name, $version = null)
     {
         $name = strtolower($name);
         $constraint = is_string($version) ? $this->versionParser->parseConstraints($version) : $version;
 
         $policy = new DefaultPolicy();
-        $pool = new Pool('dev');
-        $pool->addRepository($repos);
+        $repositorySet = new RepositorySet('dev');
+        $repositorySet->allowInstalledRepositories();
+        $repositorySet->addRepository($repos);
 
         $matchedPackage = null;
         $versions = array();
+        if (PlatformRepository::isPlatformPackage($name)) {
+            $pool = $repositorySet->createPoolWithAllPackages();
+        } else {
+            $pool = $repositorySet->createPoolForPackage($name);
+        }
         $matches = $pool->whatProvides($name, $constraint);
         foreach ($matches as $index => $package) {
-            // skip providers/replacers
-            if ($package->getName() !== $name) {
-                unset($matches[$index]);
-                continue;
-            }
-
             // select an exact match if it is in the installed repo and no specific version was required
             if (null === $version && $installedRepo->hasPackage($package)) {
                 $matchedPackage = $package;
@@ -568,7 +604,7 @@ EOT
         }
 
         // select preferred package according to policy rules
-        if (!$matchedPackage && $matches && $preferred = $policy->selectPreferredPackages($pool, array(), $matches)) {
+        if (!$matchedPackage && $matches && $preferred = $policy->selectPreferredPackages($pool, $matches)) {
             $matchedPackage = $pool->literalToPackage($preferred[0]);
         }
 
@@ -580,16 +616,16 @@ EOT
      *
      * @param CompletePackageInterface $package
      * @param array                    $versions
-     * @param RepositoryInterface      $installedRepo
+     * @param InstalledRepository      $installedRepo
      * @param PackageInterface|null    $latestPackage
      */
-    protected function printPackageInfo(CompletePackageInterface $package, array $versions, RepositoryInterface $installedRepo, PackageInterface $latestPackage = null)
+    protected function printPackageInfo(CompletePackageInterface $package, array $versions, InstalledRepository $installedRepo, PackageInterface $latestPackage = null)
     {
         $io = $this->getIO();
 
         $this->printMeta($package, $versions, $installedRepo, $latestPackage ?: null);
-        $this->printLinks($package, 'requires');
-        $this->printLinks($package, 'devRequires', 'requires (dev)');
+        $this->printLinks($package, Link::TYPE_REQUIRE);
+        $this->printLinks($package, Link::TYPE_DEV_REQUIRE, 'requires (dev)');
 
         if ($package->getSuggests()) {
             $io->write("\n<info>suggests</info>");
@@ -598,9 +634,9 @@ EOT
             }
         }
 
-        $this->printLinks($package, 'provides');
-        $this->printLinks($package, 'conflicts');
-        $this->printLinks($package, 'replaces');
+        $this->printLinks($package, Link::TYPE_PROVIDE);
+        $this->printLinks($package, Link::TYPE_CONFLICT);
+        $this->printLinks($package, Link::TYPE_REPLACE);
     }
 
     /**
@@ -608,10 +644,10 @@ EOT
      *
      * @param CompletePackageInterface $package
      * @param array                    $versions
-     * @param RepositoryInterface      $installedRepo
+     * @param InstalledRepository      $installedRepo
      * @param PackageInterface|null    $latestPackage
      */
-    protected function printMeta(CompletePackageInterface $package, array $versions, RepositoryInterface $installedRepo, PackageInterface $latestPackage = null)
+    protected function printMeta(CompletePackageInterface $package, array $versions, InstalledRepository $installedRepo, PackageInterface $latestPackage = null)
     {
         $io = $this->getIO();
         $io->write('<info>name</info>     : ' . $package->getPrettyName());
@@ -656,11 +692,7 @@ EOT
             foreach ($package->getAutoload() as $type => $autoloads) {
                 $io->write('<comment>' . $type . '</comment>');
 
-                if ($type === 'psr-0') {
-                    foreach ($autoloads as $name => $path) {
-                        $io->write(($name ?: '*') . ' => ' . (is_array($path) ? implode(', ', $path) : ($path ?: '.')));
-                    }
-                } elseif ($type === 'psr-4') {
+                if ($type === 'psr-0' || $type === 'psr-4') {
                     foreach ($autoloads as $name => $path) {
                         $io->write(($name ?: '*') . ' => ' . (is_array($path) ? implode(', ', $path) : ($path ?: '.')));
                     }
@@ -680,19 +712,21 @@ EOT
      *
      * @param CompletePackageInterface $package
      * @param array                    $versions
-     * @param RepositoryInterface      $installedRepo
+     * @param InstalledRepository      $installedRepo
      */
-    protected function printVersions(CompletePackageInterface $package, array $versions, RepositoryInterface $installedRepo)
+    protected function printVersions(CompletePackageInterface $package, array $versions, InstalledRepository $installedRepo)
     {
-        uasort($versions, 'version_compare');
-        $versions = array_keys(array_reverse($versions));
+        $versions = array_keys($versions);
+        $versions = Semver::rsort($versions);
 
         // highlight installed version
-        if ($installedRepo->hasPackage($package)) {
-            $installedVersion = $package->getPrettyVersion();
-            $key = array_search($installedVersion, $versions);
-            if (false !== $key) {
-                $versions[$key] = '<info>* ' . $installedVersion . '</info>';
+        if ($installedPackages = $installedRepo->findPackages($package->getName())) {
+            foreach ($installedPackages as $installedPackage) {
+                $installedVersion = $installedPackage->getPrettyVersion();
+                $key = array_search($installedVersion, $versions);
+                if (false !== $key) {
+                    $versions[$key] = '<info>* ' . $installedVersion . '</info>';
+                }
             }
         }
 
@@ -756,10 +790,10 @@ EOT
      *
      * @param CompletePackageInterface $package
      * @param array                    $versions
-     * @param RepositoryInterface      $installedRepo
+     * @param InstalledRepository      $installedRepo
      * @param PackageInterface|null    $latestPackage
      */
-    protected function printPackageInfoAsJson(CompletePackageInterface $package, array $versions, RepositoryInterface $installedRepo, PackageInterface $latestPackage = null)
+    protected function printPackageInfoAsJson(CompletePackageInterface $package, array $versions, InstalledRepository $installedRepo, PackageInterface $latestPackage = null)
     {
         $json = array(
             'name' => $package->getPrettyName(),
@@ -767,7 +801,7 @@ EOT
             'keywords' => $package->getKeywords() ?: array(),
             'type' => $package->getType(),
             'homepage' => $package->getHomepage(),
-            'names' => $package->getNames()
+            'names' => $package->getNames(),
         );
 
         $json = $this->appendVersions($json, $versions);
@@ -783,7 +817,7 @@ EOT
             $json['source'] = array(
                 'type' => $package->getSourceType(),
                 'url' => $package->getSourceUrl(),
-                'reference' => $package->getSourceReference()
+                'reference' => $package->getSourceReference(),
             );
         }
 
@@ -791,7 +825,7 @@ EOT
             $json['dist'] = array(
                 'type' => $package->getDistType(),
                 'url' => $package->getDistUrl(),
-                'reference' => $package->getDistReference()
+                'reference' => $package->getDistReference(),
             );
         }
 
@@ -849,7 +883,7 @@ EOT
                 return array(
                     'name' => $license[0],
                     'osi' => $licenseId,
-                    'url' => $license[2]
+                    'url' => $license[2],
                 );
             }, $licenses);
         }
@@ -888,7 +922,7 @@ EOT
 
     private function appendLinks($json, CompletePackageInterface $package)
     {
-        foreach (array('requires', 'devRequires', 'provides', 'conflicts', 'replaces') as $linkType) {
+        foreach (Link::$TYPES as $linkType) {
             $json = $this->appendLink($json, $package, $linkType);
         }
 
@@ -979,15 +1013,15 @@ EOT
     /**
      * Generate the package tree
      *
-     * @param  PackageInterface $package
-     * @param  RepositoryInterface     $installedRepo
-     * @param  RepositoryInterface     $distantRepos
+     * @param  PackageInterface    $package
+     * @param  InstalledRepository $installedRepo
+     * @param  RepositoryInterface $remoteRepos
      * @return array
      */
     protected function generatePackageTree(
         PackageInterface $package,
-        RepositoryInterface $installedRepo,
-        RepositoryInterface $distantRepos
+        InstalledRepository $installedRepo,
+        RepositoryInterface $remoteRepos
     ) {
         $requires = $package->getRequires();
         ksort($requires);
@@ -1000,7 +1034,7 @@ EOT
                 'version' => $require->getPrettyConstraint(),
             );
 
-            $deepChildren = $this->addTree($requireName, $require, $installedRepo, $distantRepos, $packagesInTree);
+            $deepChildren = $this->addTree($requireName, $require, $installedRepo, $remoteRepos, $packagesInTree);
 
             if ($deepChildren) {
                 $treeChildDesc['requires'] = $deepChildren;
@@ -1024,10 +1058,10 @@ EOT
     /**
      * Display a package tree
      *
-     * @param PackageInterface|string $package
-     * @param array                   $packagesInTree
-     * @param string                  $previousTreeBar
-     * @param int                     $level
+     * @param array|string $package
+     * @param array        $packagesInTree
+     * @param string       $previousTreeBar
+     * @param int          $level
      */
     protected function displayTree(
         $package,
@@ -1036,7 +1070,7 @@ EOT
         $level = 1
     ) {
         $previousTreeBar = str_replace('├', '│', $previousTreeBar);
-        if (isset($package['requires'])) {
+        if (is_array($package) && isset($package['requires'])) {
             $requires = $package['requires'];
             $treeBar = $previousTreeBar . '  ├';
             $i = 0;
@@ -1079,22 +1113,22 @@ EOT
      *
      * @param  string                  $name
      * @param  PackageInterface|string $package
-     * @param  RepositoryInterface     $installedRepo
-     * @param  RepositoryInterface     $distantRepos
+     * @param  InstalledRepository     $installedRepo
+     * @param  RepositoryInterface     $remoteRepos
      * @param  array                   $packagesInTree
      * @return array
      */
     protected function addTree(
         $name,
         $package,
-        RepositoryInterface $installedRepo,
-        RepositoryInterface $distantRepos,
+        InstalledRepository $installedRepo,
+        RepositoryInterface $remoteRepos,
         array $packagesInTree
     ) {
         $children = array();
-        list($package, $versions) = $this->getPackage(
+        list($package) = $this->getPackage(
             $installedRepo,
-            $distantRepos,
+            $remoteRepos,
             $name,
             $package->getPrettyConstraint() === 'self.version' ? $package->getConstraint() : $package->getPrettyConstraint()
         );
@@ -1111,7 +1145,7 @@ EOT
 
                 if (!in_array($requireName, $currentTree, true)) {
                     $currentTree[] = $requireName;
-                    $deepChildren = $this->addTree($requireName, $require, $installedRepo, $distantRepos, $currentTree);
+                    $deepChildren = $this->addTree($requireName, $require, $installedRepo, $remoteRepos, $currentTree);
                     if ($deepChildren) {
                         $treeChildDesc['requires'] = $deepChildren;
                     }
@@ -1164,18 +1198,18 @@ EOT
     /**
      * Given a package, this finds the latest package matching it
      *
-     * @param PackageInterface $package
-     * @param Composer         $composer
-     * @param string           $phpVersion
-     * @param bool             $minorOnly
+     * @param PackageInterface   $package
+     * @param Composer           $composer
+     * @param PlatformRepository $platformRepo
+     * @param bool               $minorOnly
      *
-     * @return PackageInterface|null
+     * @return PackageInterface|false
      */
-    private function findLatestPackage(PackageInterface $package, Composer $composer, $phpVersion, $minorOnly = false)
+    private function findLatestPackage(PackageInterface $package, Composer $composer, PlatformRepository $platformRepo, $minorOnly = false)
     {
-        // find the latest version allowed in this pool
+        // find the latest version allowed in this repo set
         $name = $package->getName();
-        $versionSelector = new VersionSelector($this->getPool($composer));
+        $versionSelector = new VersionSelector($this->getRepositorySet($composer), $platformRepo);
         $stability = $composer->getPackage()->getMinimumStability();
         $flags = $composer->getPackage()->getStabilityFlags();
         if (isset($flags[$name])) {
@@ -1196,16 +1230,48 @@ EOT
             $targetVersion = '^' . $package->getVersion();
         }
 
-        return $versionSelector->findBestCandidate($name, $targetVersion, $phpVersion, $bestStability);
+        $candidate = $versionSelector->findBestCandidate($name, $targetVersion, $bestStability);
+        while ($candidate instanceof AliasPackage) {
+            $candidate = $candidate->getAliasOf();
+        }
+
+        return $candidate;
     }
 
-    private function getPool(Composer $composer)
+    private function getRepositorySet(Composer $composer)
     {
-        if (!$this->pool) {
-            $this->pool = new Pool($composer->getPackage()->getMinimumStability(), $composer->getPackage()->getStabilityFlags());
-            $this->pool->addRepository(new CompositeRepository($composer->getRepositoryManager()->getRepositories()));
+        if (!$this->repositorySet) {
+            $this->repositorySet = new RepositorySet($composer->getPackage()->getMinimumStability(), $composer->getPackage()->getStabilityFlags());
+            $this->repositorySet->addRepository(new CompositeRepository($composer->getRepositoryManager()->getRepositories()));
+        }
+
+        return $this->repositorySet;
+    }
+
+    /**
+     * Find package requires and child requires
+     *
+     * @param  RepositoryInterface $repo
+     * @param  PackageInterface    $package
+     * @param  array               $bucket
+     * @return array
+     */
+    private function filterRequiredPackages(RepositoryInterface $repo, PackageInterface $package, $bucket = array())
+    {
+        $requires = $package->getRequires();
+
+        foreach ($repo->getPackages() as $candidate) {
+            foreach ($candidate->getNames() as $name) {
+                if (isset($requires[$name])) {
+                    if (!in_array($candidate, $bucket, true)) {
+                        $bucket[] = $candidate;
+                        $bucket = $this->filterRequiredPackages($repo, $candidate, $bucket);
+                    }
+                    break;
+                }
+            }
         }
 
-        return $this->pool;
+        return $bucket;
     }
 }
diff -pruN 1.10.19-1/src/Composer/Command/StatusCommand.php 2.0.9-1/src/Composer/Command/StatusCommand.php
--- 1.10.19-1/src/Composer/Command/StatusCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/StatusCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -73,7 +73,7 @@ EOT
         // Dispatch pre-status-command
         $composer->getEventDispatcher()->dispatchScript(ScriptEvents::PRE_STATUS_CMD, true);
 
-        $exitCode = $this->doExecute($input, $output);
+        $exitCode = $this->doExecute($input);
 
         // Dispatch post-status-command
         $composer->getEventDispatcher()->dispatchScript(ScriptEvents::POST_STATUS_CMD, true);
@@ -82,11 +82,10 @@ EOT
     }
 
     /**
-     * @param  InputInterface  $input
-     * @param  OutputInterface $output
+     * @param  InputInterface $input
      * @return int
      */
-    private function doExecute(InputInterface $input, OutputInterface $output)
+    private function doExecute(InputInterface $input)
     {
         // init repos
         $composer = $this->getComposer();
@@ -107,7 +106,7 @@ EOT
 
         // list packages
         foreach ($installedRepo->getCanonicalPackages() as $package) {
-            $downloader = $dm->getDownloaderForInstalledPackage($package);
+            $downloader = $dm->getDownloaderForPackage($package);
             $targetDir = $im->getInstallPath($package);
 
             if ($downloader instanceof ChangeReportInterface) {
@@ -121,7 +120,7 @@ EOT
             }
 
             if ($downloader instanceof VcsCapableDownloaderInterface) {
-                if ($currentRef = $downloader->getVcsReference($package, $targetDir)) {
+                if ($downloader->getVcsReference($package, $targetDir)) {
                     switch ($package->getInstallationSource()) {
                         case 'source':
                             $previousRef = $package->getSourceReference();
diff -pruN 1.10.19-1/src/Composer/Command/SuggestsCommand.php 2.0.9-1/src/Composer/Command/SuggestsCommand.php
--- 1.10.19-1/src/Composer/Command/SuggestsCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/SuggestsCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,9 @@
 namespace Composer\Command;
 
 use Composer\Repository\PlatformRepository;
+use Composer\Repository\RootPackageRepository;
+use Composer\Repository\InstalledRepository;
+use Composer\Installer\SuggestedPackagesReporter;
 use Symfony\Component\Console\Input\InputArgument;
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Input\InputOption;
@@ -26,8 +29,10 @@ class SuggestsCommand extends BaseComman
             ->setName('suggests')
             ->setDescription('Shows package suggestions.')
             ->setDefinition(array(
-                new InputOption('by-package', null, InputOption::VALUE_NONE, 'Groups output by suggesting package'),
+                new InputOption('by-package', null, InputOption::VALUE_NONE, 'Groups output by suggesting package (default)'),
                 new InputOption('by-suggestion', null, InputOption::VALUE_NONE, 'Groups output by suggested package'),
+                new InputOption('all', 'a', InputOption::VALUE_NONE, 'Show suggestions from all dependencies, including transitive ones'),
+                new InputOption('list', null, InputOption::VALUE_NONE, 'Show only list of suggested package names'),
                 new InputOption('no-dev', null, InputOption::VALUE_NONE, 'Exclude suggestions from require-dev packages'),
                 new InputArgument('packages', InputArgument::IS_ARRAY | InputArgument::OPTIONAL, 'Packages that you want to list suggestions from.'),
             ))
@@ -36,118 +41,63 @@ class SuggestsCommand extends BaseComman
 
 The <info>%command.name%</info> command shows a sorted list of suggested packages.
 
-Enabling <info>-v</info> implies <info>--by-package --by-suggestion</info>, showing both lists.
-
 Read more at https://getcomposer.org/doc/03-cli.md#suggests
 EOT
             )
         ;
     }
 
+    /**
+     * {@inheritDoc}
+     */
     protected function execute(InputInterface $input, OutputInterface $output)
     {
-        $lock = $this->getComposer()->getLocker()->getLockData();
+        $composer = $this->getComposer();
 
-        if (empty($lock)) {
-            throw new \RuntimeException('Lockfile seems to be empty?');
+        $installedRepos = array(
+            new RootPackageRepository(clone $composer->getPackage()),
+        );
+
+        $locker = $composer->getLocker();
+        if ($locker->isLocked()) {
+            $installedRepos[] = new PlatformRepository(array(), $locker->getPlatformOverrides());
+            $installedRepos[] = $locker->getLockedRepository(!$input->getOption('no-dev'));
+        } else {
+            $installedRepos[] = new PlatformRepository(array(), $composer->getConfig()->get('platform') ?: array());
+            $installedRepos[] = $composer->getRepositoryManager()->getLocalRepository();
         }
 
-        $packages = $lock['packages'];
-
-        if (!$input->getOption('no-dev')) {
-            $packages += $lock['packages-dev'];
-        }
+        $installedRepo = new InstalledRepository($installedRepos);
+        $reporter = new SuggestedPackagesReporter($this->getIO());
 
         $filter = $input->getArgument('packages');
-
-        // First assemble lookup list of packages that are installed, replaced or provided
-        $installed = array();
+        $packages = $installedRepo->getPackages();
+        $packages[] = $composer->getPackage();
         foreach ($packages as $package) {
-            $installed[] = $package['name'];
-
-            if (!empty($package['provide'])) {
-                $installed = array_merge($installed, array_keys($package['provide']));
+            if (!empty($filter) && !in_array($package->getName(), $filter)) {
+                continue;
             }
 
-            if (!empty($package['replace'])) {
-                $installed = array_merge($installed, array_keys($package['replace']));
-            }
+            $reporter->addSuggestionsFromPackage($package);
         }
 
-        // Undub and sort the install list into a sorted lookup array
-        $installed = array_flip($installed);
-        ksort($installed);
-
-        // Init platform repo
-        $platform = new PlatformRepository(array(), $this->getComposer()->getConfig()->get('platform') ?: array());
-
-        // Next gather all suggestions that are not in that list
-        $suggesters = array();
-        $suggested = array();
-        foreach ($packages as $package) {
-            $packageName = $package['name'];
-            if ((!empty($filter) && !in_array($packageName, $filter)) || empty($package['suggest'])) {
-                continue;
-            }
-            foreach ($package['suggest'] as $suggestion => $reason) {
-                if (preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $suggestion) && null !== $platform->findPackage($suggestion, '*')) {
-                    continue;
-                }
-                if (!isset($installed[$suggestion])) {
-                    $suggesters[$packageName][$suggestion] = $reason;
-                    $suggested[$suggestion][$packageName] = $reason;
-                }
-            }
-        }
-        ksort($suggesters);
-        ksort($suggested);
+        // Determine output mode, default is by-package
+        $mode = SuggestedPackagesReporter::MODE_BY_PACKAGE;
 
-        // Determine output mode
-        $mode = 0;
-        $io = $this->getIO();
-        if ($input->getOption('by-package') || $io->isVerbose()) {
-            $mode |= 1;
-        }
+        // if by-suggestion is given we override the default
         if ($input->getOption('by-suggestion')) {
-            $mode |= 2;
+            $mode = SuggestedPackagesReporter::MODE_BY_SUGGESTION;
         }
-
-        // Simple mode
-        if ($mode === 0) {
-            foreach (array_keys($suggested) as $suggestion) {
-                $io->write(sprintf('<info>%s</info>', $suggestion));
-            }
-
-            return 0;
+        // unless by-package is also present then we enable both
+        if ($input->getOption('by-package')) {
+            $mode |= SuggestedPackagesReporter::MODE_BY_PACKAGE;
         }
-
-        // Grouped by package
-        if ($mode & 1) {
-            foreach ($suggesters as $suggester => $suggestions) {
-                $io->write(sprintf('<comment>%s</comment> suggests:', $suggester));
-
-                foreach ($suggestions as $suggestion => $reason) {
-                    $io->write(sprintf(' - <info>%s</info>: %s', $suggestion, $reason ?: '*'));
-                }
-                $io->write('');
-            }
+        // list is exclusive and overrides everything else
+        if ($input->getOption('list')) {
+            $mode = SuggestedPackagesReporter::MODE_LIST;
         }
 
-        // Grouped by suggestion
-        if ($mode & 2) {
-            // Improve readability in full mode
-            if ($mode & 1) {
-                $io->write(str_repeat('-', 78));
-            }
-            foreach ($suggested as $suggestion => $suggesters) {
-                $io->write(sprintf('<comment>%s</comment> is suggested by:', $suggestion));
-
-                foreach ($suggesters as $suggester => $reason) {
-                    $io->write(sprintf(' - <info>%s</info>: %s', $suggester, $reason ?: '*'));
-                }
-                $io->write('');
-            }
-        }
+        $reporter->output($mode, $installedRepo, empty($filter) && !$input->getOption('all') ? $composer->getPackage() : null);
 
         return 0;
     }
diff -pruN 1.10.19-1/src/Composer/Command/UpdateCommand.php 2.0.9-1/src/Composer/Command/UpdateCommand.php
--- 1.10.19-1/src/Composer/Command/UpdateCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/UpdateCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,10 +13,15 @@
 namespace Composer\Command;
 
 use Composer\Composer;
+use Composer\DependencyResolver\Request;
 use Composer\Installer;
 use Composer\IO\IOInterface;
 use Composer\Plugin\CommandEvent;
 use Composer\Plugin\PluginEvents;
+use Composer\Package\Version\VersionParser;
+use Composer\Util\HttpDownloader;
+use Composer\Semver\Constraint\MultiConstraint;
+use Composer\Package\Link;
 use Symfony\Component\Console\Helper\Table;
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Input\InputOption;
@@ -38,24 +43,27 @@ class UpdateCommand extends BaseCommand
             ->setDescription('Upgrades your dependencies to the latest version according to composer.json, and updates the composer.lock file.')
             ->setDefinition(array(
                 new InputArgument('packages', InputArgument::IS_ARRAY | InputArgument::OPTIONAL, 'Packages that should be updated, if not provided all packages are.'),
+                new InputOption('with', null, InputOption::VALUE_IS_ARRAY | InputOption::VALUE_REQUIRED, 'Temporary version constraint to add, e.g. foo/bar:1.0.0 or foo/bar=1.0.0'),
                 new InputOption('prefer-source', null, InputOption::VALUE_NONE, 'Forces installation from package sources when possible, including VCS information.'),
                 new InputOption('prefer-dist', null, InputOption::VALUE_NONE, 'Forces installation from package dist even for dev versions.'),
                 new InputOption('dry-run', null, InputOption::VALUE_NONE, 'Outputs the operations but will not execute anything (implicitly enables --verbose).'),
-                new InputOption('dev', null, InputOption::VALUE_NONE, 'Enables installation of require-dev packages (enabled by default, only present for BC).'),
+                new InputOption('dev', null, InputOption::VALUE_NONE, 'DEPRECATED: Enables installation of require-dev packages (enabled by default, only present for BC).'),
                 new InputOption('no-dev', null, InputOption::VALUE_NONE, 'Disables installation of require-dev packages.'),
-                new InputOption('lock', null, InputOption::VALUE_NONE, 'Only updates the lock file hash to suppress warning about the lock file being out of date.'),
-                new InputOption('no-custom-installers', null, InputOption::VALUE_NONE, 'DEPRECATED: Use no-plugins instead.'),
+                new InputOption('lock', null, InputOption::VALUE_NONE, 'Overwrites the lock file hash to suppress warning about the lock file being out of date without updating package versions. Package metadata like mirrors and URLs are updated if they changed.'),
+                new InputOption('no-install', null, InputOption::VALUE_NONE, 'Skip the install step after updating the composer.lock file.'),
                 new InputOption('no-autoloader', null, InputOption::VALUE_NONE, 'Skips autoloader generation'),
                 new InputOption('no-scripts', null, InputOption::VALUE_NONE, 'Skips the execution of all scripts defined in composer.json file.'),
+                new InputOption('no-suggest', null, InputOption::VALUE_NONE, 'DEPRECATED: This flag does not exist anymore.'),
                 new InputOption('no-progress', null, InputOption::VALUE_NONE, 'Do not output download progress.'),
-                new InputOption('no-suggest', null, InputOption::VALUE_NONE, 'Do not show package suggestions.'),
-                new InputOption('with-dependencies', null, InputOption::VALUE_NONE, 'Add also dependencies of allowed packages to the allow list, except those defined in root package.'),
-                new InputOption('with-all-dependencies', null, InputOption::VALUE_NONE, 'Add also all dependencies of allowed packages to the allow list, including those defined in root package.'),
+                new InputOption('with-dependencies', 'w', InputOption::VALUE_NONE, 'Update also dependencies of packages in the argument list, except those which are root requirements.'),
+                new InputOption('with-all-dependencies', 'W', InputOption::VALUE_NONE, 'Update also dependencies of packages in the argument list, including those which are root requirements.'),
                 new InputOption('verbose', 'v|vv|vvv', InputOption::VALUE_NONE, 'Shows more details including new commits pulled in when updating packages.'),
                 new InputOption('optimize-autoloader', 'o', InputOption::VALUE_NONE, 'Optimize autoloader during autoloader dump.'),
                 new InputOption('classmap-authoritative', 'a', InputOption::VALUE_NONE, 'Autoload classes from the classmap only. Implicitly enables `--optimize-autoloader`.'),
                 new InputOption('apcu-autoloader', null, InputOption::VALUE_NONE, 'Use APCu to cache found/not-found classes.'),
-                new InputOption('ignore-platform-reqs', null, InputOption::VALUE_NONE, 'Ignore platform requirements (php & ext- packages).'),
+                new InputOption('apcu-autoloader-prefix', null, InputOption::VALUE_REQUIRED, 'Use a custom prefix for the APCu autoloader cache. Implicitly enables --apcu-autoloader'),
+                new InputOption('ignore-platform-req', null, InputOption::VALUE_REQUIRED | InputOption::VALUE_IS_ARRAY, 'Ignore a specific platform requirement (php & ext- packages).'),
+                new InputOption('ignore-platform-reqs', null, InputOption::VALUE_NONE, 'Ignore all platform requirements (php & ext- packages).'),
                 new InputOption('prefer-stable', null, InputOption::VALUE_NONE, 'Prefer stable versions of dependencies.'),
                 new InputOption('prefer-lowest', null, InputOption::VALUE_NONE, 'Prefer lowest versions of dependencies.'),
                 new InputOption('interactive', 'i', InputOption::VALUE_NONE, 'Interactive interface with autocompletion to select the packages to update.'),
@@ -79,6 +87,14 @@ from a specific vendor:
 
 <info>php composer.phar update vendor/package1 foo/* [...]</info>
 
+To run an update with more restrictive constraints you can use:
+
+<info>php composer.phar update --with vendor/package:1.0.*</info>
+
+To run a partial update with more restrictive constraints you can use the shorthand:
+
+<info>php composer.phar update vendor/package:1.0.*</info>
+
 To select packages names interactively with auto-completion use <info>-i</info>.
 
 Read more at https://getcomposer.org/doc/03-cli.md#update-u
@@ -90,42 +106,89 @@ EOT
     protected function execute(InputInterface $input, OutputInterface $output)
     {
         $io = $this->getIO();
-        if ($input->getOption('no-custom-installers')) {
-            $io->writeError('<warning>You are using the deprecated option "no-custom-installers". Use "no-plugins" instead.</warning>');
-            $input->setOption('no-plugins', true);
-        }
-
         if ($input->getOption('dev')) {
-            $io->writeError('<warning>You are using the deprecated option "dev". Dev packages are installed by default now.</warning>');
+            $io->writeError('<warning>You are using the deprecated option "--dev". It has no effect and will break in Composer 3.</warning>');
+        }
+        if ($input->getOption('no-suggest')) {
+            $io->writeError('<warning>You are using the deprecated option "--no-suggest". It has no effect and will break in Composer 3.</warning>');
         }
 
         $composer = $this->getComposer(true, $input->getOption('no-plugins'));
 
+        if (!HttpDownloader::isCurlEnabled()) {
+            $io->writeError('<warning>Composer is operating significantly slower than normal because you do not have the PHP curl extension enabled.</warning>');
+        }
+
         $packages = $input->getArgument('packages');
+        $reqs = $this->formatRequirements($input->getOption('with'));
+
+        // extract --with shorthands from the allowlist
+        if ($packages) {
+            $allowlistPackagesWithRequirements = array_filter($packages, function ($pkg) {
+                return preg_match('{\S+[ =:]\S+}', $pkg) > 0;
+            });
+            foreach ($this->formatRequirements($allowlistPackagesWithRequirements) as $package => $constraint) {
+                $reqs[$package] = $constraint;
+            }
+
+            // replace the foo/bar:req by foo/bar in the allowlist
+            foreach ($allowlistPackagesWithRequirements as $package) {
+                $packageName = preg_replace('{^([^ =:]+)[ =:].*$}', '$1', $package);
+                $index = array_search($package, $packages);
+                $packages[$index] = $packageName;
+            }
+        }
+
+        $rootRequires = $composer->getPackage()->getRequires();
+        $rootDevRequires = $composer->getPackage()->getDevRequires();
+        foreach ($reqs as $package => $constraint) {
+            if (isset($rootRequires[$package])) {
+                $rootRequires[$package] = $this->appendConstraintToLink($rootRequires[$package], $constraint);
+            } elseif (isset($rootDevRequires[$package])) {
+                $rootDevRequires[$package] = $this->appendConstraintToLink($rootDevRequires[$package], $constraint);
+            } else {
+                throw new \UnexpectedValueException('Only root package requirements can receive temporary constraints and '.$package.' is not one');
+            }
+        }
+        $composer->getPackage()->setRequires($rootRequires);
+        $composer->getPackage()->setDevRequires($rootDevRequires);
 
         if ($input->getOption('interactive')) {
             $packages = $this->getPackagesInteractively($io, $input, $output, $composer, $packages);
         }
 
         if ($input->getOption('root-reqs')) {
-            $require = array_keys($composer->getPackage()->getRequires());
+            $requires = array_keys($rootRequires);
             if (!$input->getOption('no-dev')) {
-                $requireDev = array_keys($composer->getPackage()->getDevRequires());
-                $require = array_merge($require, $requireDev);
+                $requires = array_merge($requires, array_keys($rootDevRequires));
             }
 
             if (!empty($packages)) {
-                $packages = array_intersect($packages, $require);
+                $packages = array_intersect($packages, $requires);
             } else {
-                $packages = $require;
+                $packages = $requires;
             }
         }
 
-        $composer->getDownloadManager()->setOutputProgress(!$input->getOption('no-progress'));
+        // the arguments lock/nothing/mirrors are not package names but trigger a mirror update instead
+        // they are further mutually exclusive with listing actual package names
+        $filteredPackages = array_filter($packages, function ($package) {
+            return !in_array($package, array('lock', 'nothing', 'mirrors'), true);
+        });
+        $updateMirrors = $input->getOption('lock') || count($filteredPackages) != count($packages);
+        $packages = $filteredPackages;
+
+        if ($updateMirrors && !empty($packages)) {
+            $io->writeError('<error>You cannot simultaneously update only a selection of packages and regenerate the lock file metadata.</error>');
+
+            return -1;
+        }
 
         $commandEvent = new CommandEvent(PluginEvents::COMMAND, 'update', $input, $output);
         $composer->getEventDispatcher()->dispatch($commandEvent->getName(), $commandEvent);
 
+        $composer->getInstallationManager()->setOutputProgress(!$input->getOption('no-progress'));
+
         $install = Installer::create($io, $composer);
 
         $config = $composer->getConfig();
@@ -133,7 +196,17 @@ EOT
 
         $optimize = $input->getOption('optimize-autoloader') || $config->get('optimize-autoloader');
         $authoritative = $input->getOption('classmap-authoritative') || $config->get('classmap-authoritative');
-        $apcu = $input->getOption('apcu-autoloader') || $config->get('apcu-autoloader');
+        $apcuPrefix = $input->getOption('apcu-autoloader-prefix');
+        $apcu = $apcuPrefix !== null || $input->getOption('apcu-autoloader') || $config->get('apcu-autoloader');
+
+        $updateAllowTransitiveDependencies = Request::UPDATE_ONLY_LISTED;
+        if ($input->getOption('with-all-dependencies')) {
+            $updateAllowTransitiveDependencies = Request::UPDATE_LISTED_WITH_TRANSITIVE_DEPS;
+        } elseif ($input->getOption('with-dependencies')) {
+            $updateAllowTransitiveDependencies = Request::UPDATE_LISTED_WITH_TRANSITIVE_DEPS_NO_ROOT_REQUIRE;
+        }
+
+        $ignorePlatformReqs = $input->getOption('ignore-platform-reqs') ?: ($input->getOption('ignore-platform-req') ?: false);
 
         $install
             ->setDryRun($input->getOption('dry-run'))
@@ -143,15 +216,15 @@ EOT
             ->setDevMode(!$input->getOption('no-dev'))
             ->setDumpAutoloader(!$input->getOption('no-autoloader'))
             ->setRunScripts(!$input->getOption('no-scripts'))
-            ->setSkipSuggest($input->getOption('no-suggest'))
             ->setOptimizeAutoloader($optimize)
             ->setClassMapAuthoritative($authoritative)
-            ->setApcuAutoloader($apcu)
+            ->setApcuAutoloader($apcu, $apcuPrefix)
             ->setUpdate(true)
-            ->setUpdateAllowList($input->getOption('lock') ? array('lock') : $packages)
-            ->setAllowListTransitiveDependencies($input->getOption('with-dependencies'))
-            ->setAllowListAllDependencies($input->getOption('with-all-dependencies'))
-            ->setIgnorePlatformRequirements($input->getOption('ignore-platform-reqs'))
+            ->setInstall(!$input->getOption('no-install'))
+            ->setUpdateMirrors($updateMirrors)
+            ->setUpdateAllowList($packages)
+            ->setUpdateAllowTransitiveDependencies($updateAllowTransitiveDependencies)
+            ->setIgnorePlatformRequirements($ignorePlatformReqs)
             ->setPreferStable($input->getOption('prefer-stable'))
             ->setPreferLowest($input->getOption('prefer-lowest'))
         ;
@@ -219,10 +292,26 @@ EOT
         if ($io->askConfirmation(sprintf(
             'Would you like to continue and update the above package%s [<comment>yes</comment>]? ',
             1 === count($packages) ? '' : 's'
-        ), true)) {
+        ))) {
             return $packages;
         }
 
         throw new \RuntimeException('Installation aborted.');
     }
+
+    private function appendConstraintToLink(Link $link, $constraint)
+    {
+        $parser = new VersionParser;
+        $oldPrettyString = $link->getConstraint()->getPrettyString();
+        $newConstraint = MultiConstraint::create(array($link->getConstraint(), $parser->parseConstraints($constraint)));
+        $newConstraint->setPrettyString($oldPrettyString.', '.$constraint);
+
+        return new Link(
+            $link->getSource(),
+            $link->getTarget(),
+            $newConstraint,
+            $link->getDescription(),
+            $link->getPrettyConstraint() . ', ' . $constraint
+        );
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Command/ValidateCommand.php 2.0.9-1/src/Composer/Command/ValidateCommand.php
--- 1.10.19-1/src/Composer/Command/ValidateCommand.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Command/ValidateCommand.php	2021-01-27 15:09:27.000000000 +0000
@@ -42,6 +42,7 @@ class ValidateCommand extends BaseComman
                 new InputOption('no-check-all', null, InputOption::VALUE_NONE, 'Do not validate requires for overly strict/loose constraints'),
                 new InputOption('no-check-lock', null, InputOption::VALUE_NONE, 'Do not check if lock file is up to date'),
                 new InputOption('no-check-publish', null, InputOption::VALUE_NONE, 'Do not check for publish errors'),
+                new InputOption('no-check-version', null, InputOption::VALUE_NONE, 'Do not report a warning if the version field is present'),
                 new InputOption('with-dependencies', 'A', InputOption::VALUE_NONE, 'Also validate the composer.json of all installed dependencies'),
                 new InputOption('strict', null, InputOption::VALUE_NONE, 'Return a non-zero exit code for warnings as well as errors'),
                 new InputArgument('file', InputArgument::OPTIONAL, 'path to composer.json file'),
@@ -86,8 +87,9 @@ EOT
         $checkAll = $input->getOption('no-check-all') ? 0 : ValidatingArrayLoader::CHECK_ALL;
         $checkPublish = !$input->getOption('no-check-publish');
         $checkLock = !$input->getOption('no-check-lock');
+        $checkVersion = $input->getOption('no-check-version') ? 0 : ConfigValidator::CHECK_VERSION;
         $isStrict = $input->getOption('strict');
-        list($errors, $publishErrors, $warnings) = $validator->validate($file, $checkAll);
+        list($errors, $publishErrors, $warnings) = $validator->validate($file, $checkAll, $checkVersion);
 
         $lockErrors = array();
         $composer = Factory::create($io, $file, $input->hasParameterOption('--no-plugins'));
@@ -107,7 +109,7 @@ EOT
                 $path = $composer->getInstallationManager()->getInstallPath($package);
                 $file = $path . '/composer.json';
                 if (is_dir($path) && file_exists($file)) {
-                    list($errors, $publishErrors, $warnings) = $validator->validate($file, $checkAll);
+                    list($errors, $publishErrors, $warnings) = $validator->validate($file, $checkAll, $checkVersion);
 
                     $this->outputResult($io, $package->getPrettyName(), $errors, $warnings, $checkPublish, $publishErrors);
 
@@ -120,9 +122,8 @@ EOT
 
         $commandEvent = new CommandEvent(PluginEvents::COMMAND, 'validate', $input, $output);
         $eventCode = $composer->getEventDispatcher()->dispatch($commandEvent->getName(), $commandEvent);
-        $exitCode = max($eventCode, $exitCode);
 
-        return $exitCode;
+        return max($eventCode, $exitCode);
     }
 
     private function outputResult($io, $name, &$errors, &$warnings, $checkPublish = false, $publishErrors = array(), $checkLock = false, $lockErrors = array(), $printSchemaUrl = false)
diff -pruN 1.10.19-1/src/Composer/Compiler.php 2.0.9-1/src/Composer/Compiler.php
--- 1.10.19-1/src/Composer/Compiler.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Compiler.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,7 +13,6 @@
 namespace Composer;
 
 use Composer\Json\JsonFile;
-use Composer\Spdx\SpdxLicenses;
 use Composer\CaBundle\CaBundle;
 use Symfony\Component\Finder\Finder;
 use Symfony\Component\Process\Process;
@@ -80,6 +79,7 @@ class Compiler
             return strcmp(strtr($a->getRealPath(), '\\', '/'), strtr($b->getRealPath(), '\\', '/'));
         };
 
+        // Add Composer sources
         $finder = new Finder();
         $finder->files()
             ->ignoreVCS(true)
@@ -89,63 +89,71 @@ class Compiler
             ->in(__DIR__.'/..')
             ->sort($finderSort)
         ;
-
         foreach ($finder as $file) {
             $this->addFile($phar, $file);
         }
+        // Add ClassLoader separately to make sure it retains the docblocks as it will get copied into projects
         $this->addFile($phar, new \SplFileInfo(__DIR__ . '/Autoload/ClassLoader.php'), false);
 
+        // Add Composer resources
         $finder = new Finder();
         $finder->files()
-            ->name('*.json')
             ->in(__DIR__.'/../../res')
-            ->in(SpdxLicenses::getResourcesDir())
             ->sort($finderSort)
         ;
-
         foreach ($finder as $file) {
             $this->addFile($phar, $file, false);
         }
-        $this->addFile($phar, new \SplFileInfo(__DIR__ . '/../../vendor/symfony/console/Resources/bin/hiddeninput.exe'), false);
-        $this->addFile($phar, new \SplFileInfo(__DIR__ . '/../../vendor/symfony/polyfill-mbstring/Resources/mb_convert_variables.php8'), false);
 
+        // Add vendor files
         $finder = new Finder();
         $finder->files()
             ->ignoreVCS(true)
-            ->name('*.php')
-            ->name('LICENSE')
+            ->notPath('/\/(composer\.(json|lock)|[A-Z]+\.md|\.gitignore|appveyor.yml|phpunit\.xml\.dist|phpstan\.neon\.dist|phpstan-config\.neon)$/')
+            ->notPath('/bin\/(jsonlint|validate-json|simple-phpunit)(\.bat)?$/')
+            ->notPath('symfony/debug/Resources/ext/')
+            ->notPath('justinrainbow/json-schema/demo/')
+            ->notPath('justinrainbow/json-schema/dist/')
+            ->notPath('composer/installed.json')
+            ->notPath('composer/LICENSE')
             ->exclude('Tests')
             ->exclude('tests')
             ->exclude('docs')
-            ->in(__DIR__.'/../../vendor/symfony/')
-            ->in(__DIR__.'/../../vendor/seld/jsonlint/')
-            ->in(__DIR__.'/../../vendor/justinrainbow/json-schema/')
-            ->in(__DIR__.'/../../vendor/composer/spdx-licenses/')
-            ->in(__DIR__.'/../../vendor/composer/semver/')
-            ->in(__DIR__.'/../../vendor/composer/ca-bundle/')
-            ->in(__DIR__.'/../../vendor/composer/xdebug-handler/')
-            ->in(__DIR__.'/../../vendor/psr/')
+            ->in(__DIR__.'/../../vendor/')
             ->sort($finderSort)
         ;
 
+        $extraFiles = array(
+            realpath(__DIR__ . '/../../vendor/composer/spdx-licenses/res/spdx-exceptions.json'),
+            realpath(__DIR__ . '/../../vendor/composer/spdx-licenses/res/spdx-licenses.json'),
+            realpath(CaBundle::getBundledCaBundlePath()),
+            realpath(__DIR__ . '/../../vendor/symfony/console/Resources/bin/hiddeninput.exe'),
+            realpath(__DIR__ . '/../../vendor/symfony/polyfill-mbstring/Resources/mb_convert_variables.php8'),
+        );
+        $unexpectedFiles = array();
+
         foreach ($finder as $file) {
-            $this->addFile($phar, $file);
-        }
+            if (in_array(realpath($file), $extraFiles, true)) {
+                unset($extraFiles[array_search(realpath($file), $extraFiles, true)]);
+            } elseif (!preg_match('{(/LICENSE|\.php)$}', $file)) {
+                $unexpectedFiles[] = (string) $file;
+            }
 
-        $this->addFile($phar, new \SplFileInfo(__DIR__.'/../../vendor/autoload.php'));
-        $this->addFile($phar, new \SplFileInfo(__DIR__.'/../../vendor/composer/autoload_namespaces.php'));
-        $this->addFile($phar, new \SplFileInfo(__DIR__.'/../../vendor/composer/autoload_psr4.php'));
-        $this->addFile($phar, new \SplFileInfo(__DIR__.'/../../vendor/composer/autoload_classmap.php'));
-        $this->addFile($phar, new \SplFileInfo(__DIR__.'/../../vendor/composer/autoload_files.php'));
-        $this->addFile($phar, new \SplFileInfo(__DIR__.'/../../vendor/composer/autoload_real.php'));
-        $this->addFile($phar, new \SplFileInfo(__DIR__.'/../../vendor/composer/autoload_static.php'));
-        if (file_exists(__DIR__.'/../../vendor/composer/include_paths.php')) {
-            $this->addFile($phar, new \SplFileInfo(__DIR__.'/../../vendor/composer/include_paths.php'));
+            if (preg_match('{\.php[\d.]*$}', $file)) {
+                $this->addFile($phar, $file);
+            } else {
+                $this->addFile($phar, $file, false);
+            }
         }
-        $this->addFile($phar, new \SplFileInfo(__DIR__.'/../../vendor/composer/ClassLoader.php'));
 
-        $this->addFile($phar, new \SplFileInfo(CaBundle::getBundledCaBundlePath()), false);
+        if ($extraFiles) {
+            throw new \RuntimeException('These files were expected but not added to the phar, they might be excluded or gone from the source package:'.PHP_EOL.implode(PHP_EOL, $extraFiles));
+        }
+        if ($unexpectedFiles) {
+            throw new \RuntimeException('These files were unexpectedly added to the phar, make sure they are excluded or listed in $extraFiles:'.PHP_EOL.implode(PHP_EOL, $unexpectedFiles));
+        }
 
+        // Add bin/composer
         $this->addComposerBin($phar);
 
         // Stubs
@@ -194,9 +202,14 @@ class Compiler
         }
 
         if ($path === 'src/Composer/Composer.php') {
-            $content = str_replace('@package_version@', $this->version, $content);
-            $content = str_replace('@package_branch_alias_version@', $this->branchAliasVersion, $content);
-            $content = str_replace('@release_date@', $this->versionDate->format('Y-m-d H:i:s'), $content);
+            $content = strtr(
+                $content,
+                array(
+                    '@package_version@' => $this->version,
+                    '@package_branch_alias_version@' => $this->branchAliasVersion,
+                    '@release_date@' => $this->versionDate->format('Y-m-d H:i:s'),
+                )
+            );
             $content = preg_replace('{SOURCE_VERSION = \'[^\']+\';}', 'SOURCE_VERSION = \'\';', $content);
         }
 
diff -pruN 1.10.19-1/src/Composer/Composer.php 2.0.9-1/src/Composer/Composer.php
--- 1.10.19-1/src/Composer/Composer.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Composer.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,6 +14,7 @@ namespace Composer;
 
 use Composer\Package\RootPackageInterface;
 use Composer\Package\Locker;
+use Composer\Util\Loop;
 use Composer\Repository\RepositoryManager;
 use Composer\Installer\InstallationManager;
 use Composer\Plugin\PluginManager;
@@ -50,9 +51,9 @@ class Composer
      * const RELEASE_DATE = '@release_date@';
      * const SOURCE_VERSION = '1.8-dev+source';
      */
-    const VERSION = '1.10.19';
+    const VERSION = '2.0.9';
     const BRANCH_ALIAS_VERSION = '';
-    const RELEASE_DATE = '2020-12-04 09:14:16';
+    const RELEASE_DATE = '2021-01-27 16:09:27';
     const SOURCE_VERSION = '';
 
     /**
@@ -64,7 +65,7 @@ class Composer
      *
      * @var string
      */
-    const RUNTIME_API_VERSION = '1.0.0';
+    const RUNTIME_API_VERSION = '2.0.0';
 
     public static function getVersion()
     {
@@ -82,7 +83,7 @@ class Composer
     }
 
     /**
-     * @var Package\RootPackageInterface
+     * @var RootPackageInterface
      */
     private $package;
 
@@ -92,6 +93,11 @@ class Composer
     private $locker;
 
     /**
+     * @var Loop
+     */
+    private $loop;
+
+    /**
      * @var Repository\RepositoryManager
      */
     private $repositoryManager;
@@ -132,7 +138,7 @@ class Composer
     private $archiveManager;
 
     /**
-     * @param  Package\RootPackageInterface $package
+     * @param  RootPackageInterface $package
      * @return void
      */
     public function setPackage(RootPackageInterface $package)
@@ -141,7 +147,7 @@ class Composer
     }
 
     /**
-     * @return Package\RootPackageInterface
+     * @return RootPackageInterface
      */
     public function getPackage()
     {
@@ -165,7 +171,7 @@ class Composer
     }
 
     /**
-     * @param Package\Locker $locker
+     * @param Locker $locker
      */
     public function setLocker(Locker $locker)
     {
@@ -173,7 +179,7 @@ class Composer
     }
 
     /**
-     * @return Package\Locker
+     * @return Locker
      */
     public function getLocker()
     {
@@ -181,7 +187,23 @@ class Composer
     }
 
     /**
-     * @param Repository\RepositoryManager $manager
+     * @param Loop $loop
+     */
+    public function setLoop(Loop $loop)
+    {
+        $this->loop = $loop;
+    }
+
+    /**
+     * @return Loop
+     */
+    public function getLoop()
+    {
+        return $this->loop;
+    }
+
+    /**
+     * @param RepositoryManager $manager
      */
     public function setRepositoryManager(RepositoryManager $manager)
     {
@@ -189,7 +211,7 @@ class Composer
     }
 
     /**
-     * @return Repository\RepositoryManager
+     * @return RepositoryManager
      */
     public function getRepositoryManager()
     {
@@ -197,7 +219,7 @@ class Composer
     }
 
     /**
-     * @param Downloader\DownloadManager $manager
+     * @param DownloadManager $manager
      */
     public function setDownloadManager(DownloadManager $manager)
     {
@@ -205,7 +227,7 @@ class Composer
     }
 
     /**
-     * @return Downloader\DownloadManager
+     * @return DownloadManager
      */
     public function getDownloadManager()
     {
@@ -229,7 +251,7 @@ class Composer
     }
 
     /**
-     * @param Installer\InstallationManager $manager
+     * @param InstallationManager $manager
      */
     public function setInstallationManager(InstallationManager $manager)
     {
@@ -237,7 +259,7 @@ class Composer
     }
 
     /**
-     * @return Installer\InstallationManager
+     * @return InstallationManager
      */
     public function getInstallationManager()
     {
@@ -245,7 +267,7 @@ class Composer
     }
 
     /**
-     * @param Plugin\PluginManager $manager
+     * @param PluginManager $manager
      */
     public function setPluginManager(PluginManager $manager)
     {
@@ -253,7 +275,7 @@ class Composer
     }
 
     /**
-     * @return Plugin\PluginManager
+     * @return PluginManager
      */
     public function getPluginManager()
     {
@@ -277,7 +299,7 @@ class Composer
     }
 
     /**
-     * @param Autoload\AutoloadGenerator $autoloadGenerator
+     * @param AutoloadGenerator $autoloadGenerator
      */
     public function setAutoloadGenerator(AutoloadGenerator $autoloadGenerator)
     {
@@ -285,7 +307,7 @@ class Composer
     }
 
     /**
-     * @return Autoload\AutoloadGenerator
+     * @return AutoloadGenerator
      */
     public function getAutoloadGenerator()
     {
diff -pruN 1.10.19-1/src/Composer/Config/ConfigSourceInterface.php 2.0.9-1/src/Composer/Config/ConfigSourceInterface.php
--- 1.10.19-1/src/Composer/Config/ConfigSourceInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Config/ConfigSourceInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -23,10 +23,10 @@ interface ConfigSourceInterface
     /**
      * Add a repository
      *
-     * @param string $name   Name
-     * @param array  $config Configuration
+     * @param string      $name   Name
+     * @param array|false $config Configuration
      */
-    public function addRepository($name, $config);
+    public function addRepository($name, $config, $append = true);
 
     /**
      * Remove a repository
@@ -38,7 +38,7 @@ interface ConfigSourceInterface
     /**
      * Add a config setting
      *
-     * @param string $name  Name
+     * @param string       $name  Name
      * @param string|array $value Value
      */
     public function addConfigSetting($name, $value);
diff -pruN 1.10.19-1/src/Composer/Config/JsonConfigSource.php 2.0.9-1/src/Composer/Config/JsonConfigSource.php
--- 1.10.19-1/src/Composer/Config/JsonConfigSource.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Config/JsonConfigSource.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,6 +14,7 @@ namespace Composer\Config;
 
 use Composer\Json\JsonFile;
 use Composer\Json\JsonManipulator;
+use Composer\Json\JsonValidationException;
 use Composer\Util\Silencer;
 
 /**
@@ -57,9 +58,9 @@ class JsonConfigSource implements Config
     /**
      * {@inheritdoc}
      */
-    public function addRepository($name, $config)
+    public function addRepository($name, $config, $append = true)
     {
-        $this->manipulateJson('addRepository', $name, $config, function (&$config, $repo, $repoConfig) {
+        $this->manipulateJson('addRepository', $name, $config, $append, function (&$config, $repo, $repoConfig) use ($append) {
             // if converting from an array format to hashmap format, and there is a {"packagist.org":false} repo, we have
             // to convert it to "packagist.org": false key on the hashmap otherwise it fails schema validation
             if (isset($config['repositories'])) {
@@ -75,7 +76,11 @@ class JsonConfigSource implements Config
                 }
             }
 
-            $config['repositories'][$repo] = $repoConfig;
+            if ($append) {
+                $config['repositories'][$repo] = $repoConfig;
+            } else {
+                $config['repositories'] = array($repo => $repoConfig) + $config['repositories'];
+            }
         });
     }
 
@@ -135,7 +140,7 @@ class JsonConfigSource implements Config
     public function addProperty($name, $value)
     {
         $this->manipulateJson('addProperty', $name, $value, function (&$config, $key, $val) {
-            if (substr($key, 0, 6) === 'extra.' || substr($key, 0, 8) === 'scripts.') {
+            if (strpos($key, 'extra.') === 0 || strpos($key, 'scripts.') === 0) {
                 $bits = explode('.', $key);
                 $last = array_pop($bits);
                 $arr = &$config[reset($bits)];
@@ -157,9 +162,8 @@ class JsonConfigSource implements Config
      */
     public function removeProperty($name)
     {
-        $authConfig = $this->authConfig;
         $this->manipulateJson('removeProperty', $name, function (&$config, $key) {
-            if (substr($key, 0, 6) === 'extra.' || substr($key, 0, 8) === 'scripts.') {
+            if (strpos($key, 'extra.') === 0 || strpos($key, 'scripts.') === 0) {
                 $bits = explode('.', $key);
                 $last = array_pop($bits);
                 $arr = &$config[reset($bits)];
@@ -193,7 +197,8 @@ class JsonConfigSource implements Config
     {
         $this->manipulateJson('removeSubNode', $type, $name, function (&$config, $type, $name) {
             unset($config[$type][$name]);
-
+        });
+        $this->manipulateJson('removeMainKeyIfEmpty', $type, function (&$config, $type) {
             if (0 === count($config[$type])) {
                 unset($config[$type]);
             }
@@ -247,14 +252,35 @@ class JsonConfigSource implements Config
             $this->arrayUnshiftRef($args, $config);
             call_user_func_array($fallback, $args);
             // avoid ending up with arrays for keys that should be objects
-            foreach (array('require', 'require-dev', 'conflict', 'provide', 'replace', 'suggest', 'config', 'autoload', 'autoload-dev') as $linkType) {
-                if (isset($config[$linkType]) && $config[$linkType] === array()) {
-                    $config[$linkType] = new \stdClass;
+            foreach (array('require', 'require-dev', 'conflict', 'provide', 'replace', 'suggest', 'config', 'autoload', 'autoload-dev', 'scripts', 'scripts-descriptions', 'support') as $prop) {
+                if (isset($config[$prop]) && $config[$prop] === array()) {
+                    $config[$prop] = new \stdClass;
+                }
+            }
+            foreach (array('psr-0', 'psr-4') as $prop) {
+                if (isset($config['autoload'][$prop]) && $config['autoload'][$prop] === array()) {
+                    $config['autoload'][$prop] = new \stdClass;
+                }
+                if (isset($config['autoload-dev'][$prop]) && $config['autoload-dev'][$prop] === array()) {
+                    $config['autoload-dev'][$prop] = new \stdClass;
+                }
+            }
+            foreach (array('platform', 'http-basic', 'bearer', 'gitlab-token', 'gitlab-oauth', 'github-oauth', 'preferred-install') as $prop) {
+                if (isset($config['config'][$prop]) && $config['config'][$prop] === array()) {
+                    $config['config'][$prop] = new \stdClass;
                 }
             }
             $this->file->write($config);
         }
 
+        try {
+            $this->file->validateSchema(JsonFile::LAX_SCHEMA);
+        } catch (JsonValidationException $e) {
+            // restore contents to the original state
+            file_put_contents($this->file->getPath(), $contents);
+            throw new \RuntimeException('Failed to update composer.json with a valid format, reverting to the original content. Please report an issue to us with details (command you run and a copy of your composer.json).', 0, $e);
+        }
+
         if ($newFile) {
             Silencer::call('chmod', $this->file->getPath(), 0600);
         }
@@ -265,7 +291,7 @@ class JsonConfigSource implements Config
      *
      * @param  array $array
      * @param  mixed $value
-     * @return array
+     * @return int
      */
     private function arrayUnshiftRef(&$array, &$value)
     {
diff -pruN 1.10.19-1/src/Composer/Config.php 2.0.9-1/src/Composer/Config.php
--- 1.10.19-1/src/Composer/Config.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Config.php	2021-01-27 15:09:27.000000000 +0000
@@ -41,6 +41,7 @@ class Config
         'cache-ttl' => 15552000, // 6 months
         'cache-files-ttl' => null, // fallback to cache-ttl
         'cache-files-maxsize' => '300MiB',
+        'cache-read-only' => false,
         'bin-compat' => 'auto',
         'discard-changes' => false,
         'autoloader-suffix' => null,
@@ -64,6 +65,7 @@ class Config
         'htaccess-protect' => true,
         'use-github-api' => true,
         'lock' => true,
+        'platform-check' => 'php-only',
         // valid keys without defaults (auth config stuff):
         // bitbucket-oauth
         // github-oauth
@@ -136,6 +138,8 @@ class Config
             foreach ($config['config'] as $key => $val) {
                 if (in_array($key, array('bitbucket-oauth', 'github-oauth', 'gitlab-oauth', 'gitlab-token', 'http-basic', 'bearer')) && isset($this->config[$key])) {
                     $this->config[$key] = array_merge($this->config[$key], $val);
+                } elseif (in_array($key, array('gitlab-domains', 'github-domains')) && isset($this->config[$key])) {
+                    $this->config[$key] = array_unique(array_merge($this->config[$key], $val));
                 } elseif ('preferred-install' === $key && isset($this->config[$key])) {
                     if (is_array($val) || is_array($this->config[$key])) {
                         if (is_string($val)) {
@@ -210,6 +214,7 @@ class Config
     public function get($key, $flags = 0)
     {
         switch ($key) {
+            // strings/paths with env var and {$refs} support
             case 'vendor-dir':
             case 'bin-dir':
             case 'process-timeout':
@@ -233,20 +238,40 @@ class Config
 
                 return (($flags & self::RELATIVE_PATHS) == self::RELATIVE_PATHS) ? $val : $this->realpath($val);
 
+            // booleans with env var support
+            case 'cache-read-only':
             case 'htaccess-protect':
-                $value = $this->getComposerEnv('COMPOSER_HTACCESS_PROTECT');
-                if (false === $value) {
-                    $value = $this->config[$key];
+                // convert foo-bar to COMPOSER_FOO_BAR and check if it exists since it overrides the local config
+                $env = 'COMPOSER_' . strtoupper(strtr($key, '-', '_'));
+
+                $val = $this->getComposerEnv($env);
+                if (false === $val) {
+                    $val = $this->config[$key];
                 }
-                return $value !== 'false' && (bool) $value;
 
+                return $val !== 'false' && (bool) $val;
+
+            // booleans without env var support
+            case 'disable-tls':
+            case 'secure-http':
+            case 'use-github-api':
+            case 'lock':
+                // special case for secure-http
+                if ($key === 'secure-http' && $this->get('disable-tls') === true) {
+                    return false;
+                }
+
+                return $this->config[$key] !== 'false' && (bool) $this->config[$key];
+
+            // ints without env var support
             case 'cache-ttl':
                 return (int) $this->config[$key];
 
+            // numbers with kb/mb/gb support, without env var support
             case 'cache-files-maxsize':
                 if (!preg_match('/^\s*([0-9.]+)\s*(?:([kmg])(?:i?b)?)?\s*$/i', $this->config[$key], $matches)) {
                     throw new \RuntimeException(
-                        "Could not parse the value of 'cache-files-maxsize': {$this->config[$key]}"
+                        "Could not parse the value of '$key': {$this->config[$key]}"
                     );
                 }
                 $size = $matches[1];
@@ -268,6 +293,7 @@ class Config
 
                 return $size;
 
+            // special cases below
             case 'cache-files-ttl':
                 if (isset($this->config[$key])) {
                     return (int) $this->config[$key];
@@ -325,18 +351,6 @@ class Config
 
                 return $protos;
 
-            case 'disable-tls':
-                return $this->config[$key] !== 'false' && (bool) $this->config[$key];
-            case 'secure-http':
-                if ($this->get('disable-tls') === true) {
-                    return false;
-                }
-
-                return $this->config[$key] !== 'false' && (bool) $this->config[$key];
-            case 'use-github-api':
-                return $this->config[$key] !== 'false' && (bool) $this->config[$key];
-            case 'lock':
-                return $this->config[$key] !== 'false' && (bool) $this->config[$key];
             default:
                 if (!isset($this->config[$key])) {
                     return null;
@@ -459,7 +473,8 @@ class Config
         if (in_array($scheme, array('http', 'git', 'ftp', 'svn'))) {
             if ($this->get('secure-http')) {
                 throw new TransportException("Your configuration does not allow connections to $url. See https://getcomposer.org/doc/06-config.md#secure-http for details.");
-            } elseif ($io) {
+            }
+            if ($io) {
                 $host = parse_url($url, PHP_URL_HOST);
                 if (!isset($this->warnedHosts[$host])) {
                     $io->writeError("<warning>Warning: Accessing $host over $scheme which is an insecure protocol.</warning>");
diff -pruN 1.10.19-1/src/Composer/Console/Application.php 2.0.9-1/src/Composer/Console/Application.php
--- 1.10.19-1/src/Composer/Console/Application.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Console/Application.php	2021-01-27 15:09:27.000000000 +0000
@@ -22,6 +22,7 @@ use Symfony\Component\Console\Helper\Que
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Input\InputOption;
 use Symfony\Component\Console\Output\OutputInterface;
+use Seld\JsonLint\ParsingException;
 use Composer\Command;
 use Composer\Composer;
 use Composer\Factory;
@@ -29,6 +30,7 @@ use Composer\IO\IOInterface;
 use Composer\IO\ConsoleIO;
 use Composer\Json\JsonValidationException;
 use Composer\Util\ErrorHandler;
+use Composer\Util\HttpDownloader;
 use Composer\EventDispatcher\ScriptExecutionException;
 use Composer\Exception\NoSslException;
 
@@ -65,7 +67,7 @@ class Application extends BaseApplicatio
     /**
      * @var string Store the initial working directory at startup time
      */
-    private $initialWorkingDirectory = '';
+    private $initialWorkingDirectory;
 
     public function __construct()
     {
@@ -81,6 +83,13 @@ class Application extends BaseApplicatio
         }
 
         if (!$shutdownRegistered) {
+            if (function_exists('pcntl_async_signals') && function_exists('pcntl_signal')) {
+                pcntl_async_signals(true);
+                pcntl_signal(SIGINT, function ($sig) {
+                    exit(130);
+                });
+            }
+
             $shutdownRegistered = true;
 
             register_shutdown_function(function () {
@@ -120,7 +129,7 @@ class Application extends BaseApplicatio
     {
         $this->disablePluginsByDefault = $input->hasParameterOption('--no-plugins');
 
-        if (getenv('COMPOSER_NO_INTERACTION')) {
+        if (getenv('COMPOSER_NO_INTERACTION') || !Platform::isTty(defined('STDIN') ? STDIN : fopen('php://stdin', 'r'))) {
             $input->setInteractive(false);
         }
 
@@ -149,8 +158,8 @@ class Application extends BaseApplicatio
             try {
                 $commandName = $this->find($name)->getName();
             } catch (CommandNotFoundException $e) {
-              // we'll check command validity again later after plugins are loaded
-              $commandName = false;
+                // we'll check command validity again later after plugins are loaded
+                $commandName = false;
             } catch (\InvalidArgumentException $e) {
             }
         }
@@ -163,7 +172,7 @@ class Application extends BaseApplicatio
             // abort when we reach the home dir or top of the filesystem
             while (dirname($dir) !== $dir && $dir !== $home) {
                 if (file_exists($dir.'/'.Factory::getComposerFile())) {
-                    if ($io->askConfirmation('<info>No composer.json in current directory, do you want to use the one at '.$dir.'?</info> [<comment>Y,n</comment>]? ', true)) {
+                    if ($io->askConfirmation('<info>No composer.json in current directory, do you want to use the one at '.$dir.'?</info> [<comment>Y,n</comment>]? ')) {
                         $oldWorkingDir = getcwd();
                         chdir($dir);
                     }
@@ -184,6 +193,20 @@ class Application extends BaseApplicatio
                 }
             } catch (NoSslException $e) {
                 // suppress these as they are not relevant at this point
+            } catch (ParsingException $e) {
+                $details = $e->getDetails();
+
+                $file = realpath(Factory::getComposerFile());
+
+                $line = null;
+                if ($details && isset($details['line'])) {
+                    $line = $details['line'];
+                }
+
+                $ghe = new GithubActionError($this->io);
+                $ghe->emit($e->getMessage(), $file, $line);
+
+                throw $e;
             }
 
             $this->hasPluginCommands = true;
@@ -214,11 +237,11 @@ class Application extends BaseApplicatio
             }
 
             if (extension_loaded('xdebug') && !getenv('COMPOSER_DISABLE_XDEBUG_WARN')) {
-                $io->writeError('<warning>You are running composer with Xdebug enabled. This has a major impact on runtime performance. See https://getcomposer.org/xdebug</warning>');
+                $io->writeError('<warning>Composer is operating slower than normal because you have Xdebug enabled. See https://getcomposer.org/xdebug</warning>');
             }
 
             if (defined('COMPOSER_DEV_WARNING_TIME') && $commandName !== 'self-update' && $commandName !== 'selfupdate' && time() > COMPOSER_DEV_WARNING_TIME) {
-                $io->writeError(sprintf('<warning>Warning: This development build of composer is over 60 days old. It is recommended to update it by running "%s self-update" to get the latest version.</warning>', $_SERVER['PHP_SELF']));
+                $io->writeError(sprintf('<warning>Warning: This development build of Composer is over 60 days old. It is recommended to update it by running "%s self-update" to get the latest version.</warning>', $_SERVER['PHP_SELF']));
             }
 
             if (
@@ -230,6 +253,12 @@ class Application extends BaseApplicatio
                 if (function_exists('posix_getuid') && posix_getuid() === 0) {
                     if ($commandName !== 'self-update' && $commandName !== 'selfupdate') {
                         $io->writeError('<warning>Do not run Composer as root/super user! See https://getcomposer.org/root for details</warning>');
+
+                        if ($io->isInteractive()) {
+                            if (!$io->askConfirmation('<info>Continue as root/super user</info> [<comment>yes</comment>]? ')) {
+                                return 1;
+                            }
+                        }
                     }
                     if ($uid = (int) getenv('SUDO_UID')) {
                         // Silently clobber any sudo credentials on the invoking user to avoid privilege escalations later on
@@ -280,8 +309,9 @@ class Application extends BaseApplicatio
 
             $result = parent::doRun($input, $output);
 
+            // chdir back to $oldWorkingDir if set
             if (isset($oldWorkingDir)) {
-                chdir($oldWorkingDir);
+                Silencer::call('chdir', $oldWorkingDir);
             }
 
             if (isset($startTime)) {
@@ -292,10 +322,15 @@ class Application extends BaseApplicatio
 
             return $result;
         } catch (ScriptExecutionException $e) {
-            return $e->getCode();
+            return (int) $e->getCode();
         } catch (\Exception $e) {
+            $ghe = new GithubActionError($this->io);
+            $ghe->emit($e->getMessage());
+
             $this->hintCommonErrors($e);
+
             restore_error_handler();
+
             throw $e;
         }
     }
@@ -349,6 +384,12 @@ class Application extends BaseApplicatio
             $io->writeError('<error>The following exception is caused by a lack of memory or swap, or not having swap configured</error>', true, IOInterface::QUIET);
             $io->writeError('<error>Check https://getcomposer.org/doc/articles/troubleshooting.md#proc-open-fork-failed-errors for details</error>', true, IOInterface::QUIET);
         }
+
+        if ($hints = HttpDownloader::getExceptionHints($exception)) {
+            foreach ($hints as $hint) {
+                $io->writeError($hint, true, IOInterface::QUIET);
+            }
+        }
     }
 
     /**
@@ -440,7 +481,7 @@ class Application extends BaseApplicatio
             new Command\FundCommand(),
         ));
 
-        if ('phar:' === substr(__FILE__, 0, 5)) {
+        if (strpos(__FILE__, 'phar:') === 0) {
             $commands[] = new Command\SelfUpdateCommand();
         }
 
@@ -485,7 +526,7 @@ class Application extends BaseApplicatio
 
         $composer = $this->getComposer(false, false);
         if (null === $composer) {
-            $composer = Factory::createGlobal($this->io, false);
+            $composer = Factory::createGlobal($this->io);
         }
 
         if (null !== $composer) {
@@ -508,7 +549,7 @@ class Application extends BaseApplicatio
     }
 
     /**
-     * Get the working directoy at startup time
+     * Get the working directory at startup time
      *
      * @return string
      */
diff -pruN 1.10.19-1/src/Composer/Console/GithubActionError.php 2.0.9-1/src/Composer/Console/GithubActionError.php
--- 1.10.19-1/src/Composer/Console/GithubActionError.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Console/GithubActionError.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,50 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Console;
+
+use Composer\IO\IOInterface;
+
+final class GithubActionError
+{
+    /**
+     * @var IOInterface
+     */
+    protected $io;
+
+    public function __construct(IOInterface  $io)
+    {
+        $this->io = $io;
+    }
+
+    /**
+     * @param string      $message
+     * @param null|string $file
+     * @param null|int    $line
+     */
+    public function emit($message, $file = null, $line = null)
+    {
+        if (getenv('GITHUB_ACTIONS') && !getenv('COMPOSER_TESTS_ARE_RUNNING')) {
+            // newlines need to be encoded
+            // see https://github.com/actions/starter-workflows/issues/68#issuecomment-581479448
+            $message = str_replace("\n", '%0A', $message);
+
+            if ($file && $line) {
+                $this->io->write("::error file=". $file .",line=". $line ."::". $message);
+            } elseif ($file) {
+                $this->io->write("::error file=". $file ."::". $message);
+            } else {
+                $this->io->write("::error ::". $message);
+            }
+        }
+    }
+}
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Decisions.php 2.0.9-1/src/Composer/DependencyResolver/Decisions.php
--- 1.10.19-1/src/Composer/DependencyResolver/Decisions.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Decisions.php	2021-01-27 15:09:27.000000000 +0000
@@ -108,17 +108,17 @@ class Decisions implements \Iterator, \C
 
     public function validOffset($queueOffset)
     {
-        return $queueOffset >= 0 && $queueOffset < count($this->decisionQueue);
+        return $queueOffset >= 0 && $queueOffset < \count($this->decisionQueue);
     }
 
     public function lastReason()
     {
-        return $this->decisionQueue[count($this->decisionQueue) - 1][self::DECISION_REASON];
+        return $this->decisionQueue[\count($this->decisionQueue) - 1][self::DECISION_REASON];
     }
 
     public function lastLiteral()
     {
-        return $this->decisionQueue[count($this->decisionQueue) - 1][self::DECISION_LITERAL];
+        return $this->decisionQueue[\count($this->decisionQueue) - 1][self::DECISION_LITERAL];
     }
 
     public function reset()
@@ -130,7 +130,7 @@ class Decisions implements \Iterator, \C
 
     public function resetToOffset($offset)
     {
-        while (count($this->decisionQueue) > $offset + 1) {
+        while (\count($this->decisionQueue) > $offset + 1) {
             $decision = array_pop($this->decisionQueue);
             $this->decisionMap[abs($decision[self::DECISION_LITERAL])] = 0;
         }
@@ -144,7 +144,7 @@ class Decisions implements \Iterator, \C
 
     public function count()
     {
-        return count($this->decisionQueue);
+        return \count($this->decisionQueue);
     }
 
     public function rewind()
@@ -174,7 +174,7 @@ class Decisions implements \Iterator, \C
 
     public function isEmpty()
     {
-        return count($this->decisionQueue) === 0;
+        return \count($this->decisionQueue) === 0;
     }
 
     protected function addDecision($literal, $level)
@@ -197,15 +197,21 @@ class Decisions implements \Iterator, \C
         }
     }
 
-    public function __toString()
+    public function toString(Pool $pool = null)
     {
         $decisionMap = $this->decisionMap;
         ksort($decisionMap);
         $str = '[';
         foreach ($decisionMap as $packageId => $level) {
-            $str .= $packageId.':'.$level.',';
+            $str .= (($pool) ? $pool->literalToPackage($packageId) : $packageId).':'.$level.',';
         }
         $str .= ']';
+
         return $str;
     }
+
+    public function __toString()
+    {
+        return $this->toString();
+    }
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/DefaultPolicy.php 2.0.9-1/src/Composer/DependencyResolver/DefaultPolicy.php
--- 1.10.19-1/src/Composer/DependencyResolver/DefaultPolicy.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/DefaultPolicy.php	2021-01-27 15:09:27.000000000 +0000
@@ -44,54 +44,33 @@ class DefaultPolicy implements PolicyInt
         return $constraint->matchSpecific($version, true);
     }
 
-    public function findUpdatePackages(Pool $pool, array $installedMap, PackageInterface $package, $mustMatchName = false)
+    public function selectPreferredPackages(Pool $pool, array $literals, $requiredPackage = null)
     {
-        $packages = array();
-
-        foreach ($pool->whatProvides($package->getName(), null, $mustMatchName) as $candidate) {
-            if ($candidate !== $package) {
-                $packages[] = $candidate;
-            }
-        }
-
-        return $packages;
-    }
+        $packages = $this->groupLiteralsByName($pool, $literals);
+        $policy = $this;
 
-    public function getPriority(Pool $pool, PackageInterface $package)
-    {
-        return $pool->getPriority($package->getRepository());
-    }
-
-    public function selectPreferredPackages(Pool $pool, array $installedMap, array $literals, $requiredPackage = null)
-    {
-        $packages = $this->groupLiteralsByNamePreferInstalled($pool, $installedMap, $literals);
-
-        foreach ($packages as &$literals) {
-            $policy = $this;
-            usort($literals, function ($a, $b) use ($policy, $pool, $installedMap, $requiredPackage) {
-                return $policy->compareByPriorityPreferInstalled($pool, $installedMap, $pool->literalToPackage($a), $pool->literalToPackage($b), $requiredPackage, true);
+        foreach ($packages as &$nameLiterals) {
+            usort($nameLiterals, function ($a, $b) use ($policy, $pool, $requiredPackage) {
+                return $policy->compareByPriority($pool, $pool->literalToPackage($a), $pool->literalToPackage($b), $requiredPackage, true);
             });
         }
 
-        foreach ($packages as &$literals) {
-            $literals = $this->pruneToHighestPriorityOrInstalled($pool, $installedMap, $literals);
-
-            $literals = $this->pruneToBestVersion($pool, $literals);
-
-            $literals = $this->pruneRemoteAliases($pool, $literals);
+        foreach ($packages as &$sortedLiterals) {
+            $sortedLiterals = $this->pruneToBestVersion($pool, $sortedLiterals);
+            $sortedLiterals = $this->pruneRemoteAliases($pool, $sortedLiterals);
         }
 
-        $selected = call_user_func_array('array_merge', array_values($packages));
+        $selected = \call_user_func_array('array_merge', array_values($packages));
 
         // now sort the result across all packages to respect replaces across packages
-        usort($selected, function ($a, $b) use ($policy, $pool, $installedMap, $requiredPackage) {
-            return $policy->compareByPriorityPreferInstalled($pool, $installedMap, $pool->literalToPackage($a), $pool->literalToPackage($b), $requiredPackage);
+        usort($selected, function ($a, $b) use ($policy, $pool, $requiredPackage) {
+            return $policy->compareByPriority($pool, $pool->literalToPackage($a), $pool->literalToPackage($b), $requiredPackage);
         });
 
         return $selected;
     }
 
-    protected function groupLiteralsByNamePreferInstalled(Pool $pool, array $installedMap, $literals)
+    protected function groupLiteralsByName(Pool $pool, $literals)
     {
         $packages = array();
         foreach ($literals as $literal) {
@@ -100,12 +79,7 @@ class DefaultPolicy implements PolicyInt
             if (!isset($packages[$packageName])) {
                 $packages[$packageName] = array();
             }
-
-            if (isset($installedMap[abs($literal)])) {
-                array_unshift($packages[$packageName], $literal);
-            } else {
-                $packages[$packageName][] = $literal;
-            }
+            $packages[$packageName][] = $literal;
         }
 
         return $packages;
@@ -114,61 +88,49 @@ class DefaultPolicy implements PolicyInt
     /**
      * @protected
      */
-    public function compareByPriorityPreferInstalled(Pool $pool, array $installedMap, PackageInterface $a, PackageInterface $b, $requiredPackage = null, $ignoreReplace = false)
+    public function compareByPriority(Pool $pool, PackageInterface $a, PackageInterface $b, $requiredPackage = null, $ignoreReplace = false)
     {
-        if ($a->getRepository() === $b->getRepository()) {
-            // prefer aliases to the original package
-            if ($a->getName() === $b->getName()) {
-                $aAliased = $a instanceof AliasPackage;
-                $bAliased = $b instanceof AliasPackage;
-                if ($aAliased && !$bAliased) {
-                    return -1; // use a
-                }
-                if (!$aAliased && $bAliased) {
-                    return 1; // use b
-                }
+        // prefer aliases to the original package
+        if ($a->getName() === $b->getName()) {
+            $aAliased = $a instanceof AliasPackage;
+            $bAliased = $b instanceof AliasPackage;
+            if ($aAliased && !$bAliased) {
+                return -1; // use a
             }
-
-            if (!$ignoreReplace) {
-                // return original, not replaced
-                if ($this->replaces($a, $b)) {
-                    return 1; // use b
-                }
-                if ($this->replaces($b, $a)) {
-                    return -1; // use a
-                }
-
-                // for replacers not replacing each other, put a higher prio on replacing
-                // packages with the same vendor as the required package
-                if ($requiredPackage && false !== ($pos = strpos($requiredPackage, '/'))) {
-                    $requiredVendor = substr($requiredPackage, 0, $pos);
-
-                    $aIsSameVendor = substr($a->getName(), 0, $pos) === $requiredVendor;
-                    $bIsSameVendor = substr($b->getName(), 0, $pos) === $requiredVendor;
-
-                    if ($bIsSameVendor !== $aIsSameVendor) {
-                        return $aIsSameVendor ? -1 : 1;
-                    }
-                }
+            if (!$aAliased && $bAliased) {
+                return 1; // use b
             }
+        }
 
-            // priority equal, sort by package id to make reproducible
-            if ($a->id === $b->id) {
-                return 0;
+        if (!$ignoreReplace) {
+            // return original, not replaced
+            if ($this->replaces($a, $b)) {
+                return 1; // use b
+            }
+            if ($this->replaces($b, $a)) {
+                return -1; // use a
             }
 
-            return ($a->id < $b->id) ? -1 : 1;
-        }
+            // for replacers not replacing each other, put a higher prio on replacing
+            // packages with the same vendor as the required package
+            if ($requiredPackage && false !== ($pos = strpos($requiredPackage, '/'))) {
+                $requiredVendor = substr($requiredPackage, 0, $pos);
+
+                $aIsSameVendor = strpos($a->getName(), $requiredVendor) === 0;
+                $bIsSameVendor = strpos($b->getName(), $requiredVendor) === 0;
 
-        if (isset($installedMap[$a->id])) {
-            return -1;
+                if ($bIsSameVendor !== $aIsSameVendor) {
+                    return $aIsSameVendor ? -1 : 1;
+                }
+            }
         }
 
-        if (isset($installedMap[$b->id])) {
-            return 1;
+        // priority equal, sort by package id to make reproducible
+        if ($a->id === $b->id) {
+            return 0;
         }
 
-        return ($this->getPriority($pool, $a) > $this->getPriority($pool, $b)) ? -1 : 1;
+        return ($a->id < $b->id) ? -1 : 1;
     }
 
     /**
@@ -219,37 +181,6 @@ class DefaultPolicy implements PolicyInt
     }
 
     /**
-     * Assumes that installed packages come first and then all highest priority packages
-     */
-    protected function pruneToHighestPriorityOrInstalled(Pool $pool, array $installedMap, array $literals)
-    {
-        $selected = array();
-
-        $priority = null;
-
-        foreach ($literals as $literal) {
-            $package = $pool->literalToPackage($literal);
-
-            if (isset($installedMap[$package->id])) {
-                $selected[] = $literal;
-                continue;
-            }
-
-            if (null === $priority) {
-                $priority = $this->getPriority($pool, $package);
-            }
-
-            if ($this->getPriority($pool, $package) != $priority) {
-                break;
-            }
-
-            $selected[] = $literal;
-        }
-
-        return $selected;
-    }
-
-    /**
      * Assumes that locally aliased (in root package requires) packages take priority over branch-alias ones
      *
      * If no package is a local alias, nothing happens
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/GenericRule.php 2.0.9-1/src/Composer/DependencyResolver/GenericRule.php
--- 1.10.19-1/src/Composer/DependencyResolver/GenericRule.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/GenericRule.php	2021-01-27 15:09:27.000000000 +0000
@@ -23,14 +23,13 @@ class GenericRule extends Rule
     protected $literals;
 
     /**
-     * @param array                 $literals
-     * @param int                   $reason     A RULE_* constant describing the reason for generating this rule
-     * @param Link|PackageInterface $reasonData
-     * @param array                 $job        The job this rule was created from
+     * @param array                          $literals
+     * @param int|null                       $reason     A RULE_* constant describing the reason for generating this rule
+     * @param Link|PackageInterface|int|null $reasonData
      */
-    public function __construct(array $literals, $reason, $reasonData, $job = null)
+    public function __construct(array $literals, $reason, $reasonData)
     {
-        parent::__construct($reason, $reasonData, $job);
+        parent::__construct($reason, $reasonData);
 
         // sort all packages ascending by id
         sort($literals);
@@ -65,7 +64,7 @@ class GenericRule extends Rule
 
     public function isAssertion()
     {
-        return 1 === count($this->literals);
+        return 1 === \count($this->literals);
     }
 
     /**
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/LocalRepoTransaction.php 2.0.9-1/src/Composer/DependencyResolver/LocalRepoTransaction.php
--- 1.10.19-1/src/Composer/DependencyResolver/LocalRepoTransaction.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/LocalRepoTransaction.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,30 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\DependencyResolver;
+
+use Composer\Repository\RepositoryInterface;
+
+/**
+ * @author Nils Adermann <naderman@naderman.de>
+ * @internal
+ */
+class LocalRepoTransaction extends Transaction
+{
+    public function __construct(RepositoryInterface $lockedRepository, $localRepository)
+    {
+        parent::__construct(
+            $localRepository->getPackages(),
+            $lockedRepository->getPackages()
+        );
+    }
+}
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/LockTransaction.php 2.0.9-1/src/Composer/DependencyResolver/LockTransaction.php
--- 1.10.19-1/src/Composer/DependencyResolver/LockTransaction.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/LockTransaction.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,136 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\DependencyResolver;
+
+use Composer\Package\AliasPackage;
+use Composer\Package\RootAliasPackage;
+
+/**
+ * @author Nils Adermann <naderman@naderman.de>
+ * @internal
+ */
+class LockTransaction extends Transaction
+{
+    /**
+     * packages in current lock file, platform repo or otherwise present
+     * @var array
+     */
+    protected $presentMap;
+
+    /**
+     * Packages which cannot be mapped, platform repo, root package, other fixed repos
+     * @var array
+     */
+    protected $unlockableMap;
+
+    /**
+     * @var array
+     */
+    protected $resultPackages;
+
+    public function __construct(Pool $pool, $presentMap, $unlockableMap, $decisions)
+    {
+        $this->presentMap = $presentMap;
+        $this->unlockableMap = $unlockableMap;
+
+        $this->setResultPackages($pool, $decisions);
+        parent::__construct($this->presentMap, $this->resultPackages['all']);
+    }
+
+    // TODO make this a bit prettier instead of the two text indexes?
+    public function setResultPackages(Pool $pool, Decisions $decisions)
+    {
+        $this->resultPackages = array('all' => array(), 'non-dev' => array(), 'dev' => array());
+        foreach ($decisions as $i => $decision) {
+            $literal = $decision[Decisions::DECISION_LITERAL];
+
+            if ($literal > 0) {
+                $package = $pool->literalToPackage($literal);
+
+                $this->resultPackages['all'][] = $package;
+                if (!isset($this->unlockableMap[$package->id])) {
+                    $this->resultPackages['non-dev'][] = $package;
+                }
+            }
+        }
+    }
+
+    public function setNonDevPackages(LockTransaction $extractionResult)
+    {
+        $packages = $extractionResult->getNewLockPackages(false);
+
+        $this->resultPackages['dev'] = $this->resultPackages['non-dev'];
+        $this->resultPackages['non-dev'] = array();
+
+        foreach ($packages as $package) {
+            foreach ($this->resultPackages['dev'] as $i => $resultPackage) {
+                // TODO this comparison is probably insufficient, aliases, what about modified versions? I guess they aren't possible?
+                if ($package->getName() == $resultPackage->getName()) {
+                    $this->resultPackages['non-dev'][] = $resultPackage;
+                    unset($this->resultPackages['dev'][$i]);
+                }
+            }
+        }
+    }
+
+    // TODO additionalFixedRepository needs to be looked at here as well?
+    public function getNewLockPackages($devMode, $updateMirrors = false)
+    {
+        $packages = array();
+        foreach ($this->resultPackages[$devMode ? 'dev' : 'non-dev'] as $package) {
+            if (!($package instanceof AliasPackage) && !($package instanceof RootAliasPackage)) {
+                // if we're just updating mirrors we need to reset references to the same as currently "present" packages' references to keep the lock file as-is
+                // we do not reset references if the currently present package didn't have any, or if the type of VCS has changed
+                if ($updateMirrors && !isset($this->presentMap[spl_object_hash($package)])) {
+                    foreach ($this->presentMap as $presentPackage) {
+                        if ($package->getName() == $presentPackage->getName() &&
+                            $package->getVersion() == $presentPackage->getVersion() &&
+                            $presentPackage->getSourceReference() &&
+                            $presentPackage->getSourceType() === $package->getSourceType()
+                        ) {
+                            $package->setSourceDistReferences($presentPackage->getSourceReference());
+                        }
+                    }
+                }
+                $packages[] = $package;
+            }
+        }
+
+        return $packages;
+    }
+
+    /**
+     * Checks which of the given aliases from composer.json are actually in use for the lock file
+     */
+    public function getAliases($aliases)
+    {
+        $usedAliases = array();
+
+        foreach ($this->resultPackages['all'] as $package) {
+            if ($package instanceof AliasPackage) {
+                foreach ($aliases as $index => $alias) {
+                    if ($alias['package'] === $package->getName()) {
+                        $usedAliases[] = $alias;
+                        unset($aliases[$index]);
+                    }
+                }
+            }
+        }
+
+        usort($usedAliases, function ($a, $b) {
+            return strcmp($a['package'], $b['package']);
+        });
+
+        return $usedAliases;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/MultiConflictRule.php 2.0.9-1/src/Composer/DependencyResolver/MultiConflictRule.php
--- 1.10.19-1/src/Composer/DependencyResolver/MultiConflictRule.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/MultiConflictRule.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,106 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\DependencyResolver;
+
+use Composer\Package\PackageInterface;
+use Composer\Package\Link;
+
+/**
+ * @author Nils Adermann <naderman@naderman.de>
+ *
+ * MultiConflictRule([A, B, C]) acts as Rule([-A, -B]), Rule([-A, -C]), Rule([-B, -C])
+ */
+class MultiConflictRule extends Rule
+{
+    protected $literals;
+
+    /**
+     * @param array                 $literals
+     * @param int                   $reason     A RULE_* constant describing the reason for generating this rule
+     * @param Link|PackageInterface $reasonData
+     */
+    public function __construct(array $literals, $reason, $reasonData)
+    {
+        parent::__construct($reason, $reasonData);
+
+        if (\count($literals) < 3) {
+            throw new \RuntimeException("multi conflict rule requires at least 3 literals");
+        }
+
+        // sort all packages ascending by id
+        sort($literals);
+
+        $this->literals = $literals;
+    }
+
+    public function getLiterals()
+    {
+        return $this->literals;
+    }
+
+    public function getHash()
+    {
+        $data = unpack('ihash', md5('c:'.implode(',', $this->literals), true));
+
+        return $data['hash'];
+    }
+
+    /**
+     * Checks if this rule is equal to another one
+     *
+     * Ignores whether either of the rules is disabled.
+     *
+     * @param  Rule $rule The rule to check against
+     * @return bool Whether the rules are equal
+     */
+    public function equals(Rule $rule)
+    {
+        if ($rule instanceof MultiConflictRule) {
+            return $this->literals === $rule->getLiterals();
+        }
+
+        return false;
+    }
+
+    public function isAssertion()
+    {
+        return false;
+    }
+
+    public function disable()
+    {
+        throw new \RuntimeException("Disabling multi conflict rules is not possible. Please contact composer at https://github.com/composer/composer to let us debug what lead to this situation.");
+    }
+
+    /**
+     * Formats a rule as a string of the format (Literal1|Literal2|...)
+     *
+     * @return string
+     */
+    public function __toString()
+    {
+        // TODO multi conflict?
+        $result = $this->isDisabled() ? 'disabled(multi(' : '(multi(';
+
+        foreach ($this->literals as $i => $literal) {
+            if ($i != 0) {
+                $result .= '|';
+            }
+            $result .= $literal;
+        }
+
+        $result .= '))';
+
+        return $result;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Operation/InstallOperation.php 2.0.9-1/src/Composer/DependencyResolver/Operation/InstallOperation.php
--- 1.10.19-1/src/Composer/DependencyResolver/Operation/InstallOperation.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Operation/InstallOperation.php	2021-01-27 15:09:27.000000000 +0000
@@ -19,20 +19,17 @@ use Composer\Package\PackageInterface;
  *
  * @author Konstantin Kudryashov <ever.zet@gmail.com>
  */
-class InstallOperation extends SolverOperation
+class InstallOperation extends SolverOperation implements OperationInterface
 {
-    protected $package;
+    const TYPE = 'install';
 
     /**
-     * Initializes operation.
-     *
-     * @param PackageInterface $package package instance
-     * @param string           $reason  operation reason
+     * @var PackageInterface
      */
-    public function __construct(PackageInterface $package, $reason = null)
-    {
-        parent::__construct($reason);
+    protected $package;
 
+    public function __construct(PackageInterface $package)
+    {
         $this->package = $package;
     }
 
@@ -47,20 +44,15 @@ class InstallOperation extends SolverOpe
     }
 
     /**
-     * Returns job type.
-     *
-     * @return string
+     * {@inheritDoc}
      */
-    public function getJobType()
+    public function show($lock)
     {
-        return 'install';
+        return self::format($this->package, $lock);
     }
 
-    /**
-     * {@inheritDoc}
-     */
-    public function __toString()
+    public static function format(PackageInterface $package, $lock = false)
     {
-        return 'Installing '.$this->package->getPrettyName().' ('.$this->formatVersion($this->package).')';
+        return ($lock ? 'Locking ' : 'Installing ').'<info>'.$package->getPrettyName().'</info> (<comment>'.$package->getFullPrettyVersion().'</comment>)';
     }
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Operation/MarkAliasInstalledOperation.php 2.0.9-1/src/Composer/DependencyResolver/Operation/MarkAliasInstalledOperation.php
--- 1.10.19-1/src/Composer/DependencyResolver/Operation/MarkAliasInstalledOperation.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Operation/MarkAliasInstalledOperation.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,34 +13,30 @@
 namespace Composer\DependencyResolver\Operation;
 
 use Composer\Package\AliasPackage;
-use Composer\Package\PackageInterface;
 
 /**
  * Solver install operation.
  *
  * @author Nils Adermann <naderman@naderman.de>
  */
-class MarkAliasInstalledOperation extends SolverOperation
+class MarkAliasInstalledOperation extends SolverOperation implements OperationInterface
 {
-    protected $package;
+    const TYPE = 'markAliasInstalled';
 
     /**
-     * Initializes operation.
-     *
-     * @param AliasPackage $package package instance
-     * @param string       $reason  operation reason
+     * @var AliasPackage
      */
-    public function __construct(AliasPackage $package, $reason = null)
-    {
-        parent::__construct($reason);
+    protected $package;
 
+    public function __construct(AliasPackage $package)
+    {
         $this->package = $package;
     }
 
     /**
      * Returns package instance.
      *
-     * @return PackageInterface
+     * @return AliasPackage
      */
     public function getPackage()
     {
@@ -48,20 +44,10 @@ class MarkAliasInstalledOperation extend
     }
 
     /**
-     * Returns job type.
-     *
-     * @return string
-     */
-    public function getJobType()
-    {
-        return 'markAliasInstalled';
-    }
-
-    /**
      * {@inheritDoc}
      */
-    public function __toString()
+    public function show($lock)
     {
-        return 'Marking '.$this->package->getPrettyName().' ('.$this->formatVersion($this->package).') as installed, alias of '.$this->package->getAliasOf()->getPrettyName().' ('.$this->formatVersion($this->package->getAliasOf()).')';
+        return 'Marking <info>'.$this->package->getPrettyName().'</info> (<comment>'.$this->package->getFullPrettyVersion().'</comment>) as installed, alias of <info>'.$this->package->getAliasOf()->getPrettyName().'</info> (<comment>'.$this->package->getAliasOf()->getFullPrettyVersion().'</comment>)';
     }
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Operation/MarkAliasUninstalledOperation.php 2.0.9-1/src/Composer/DependencyResolver/Operation/MarkAliasUninstalledOperation.php
--- 1.10.19-1/src/Composer/DependencyResolver/Operation/MarkAliasUninstalledOperation.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Operation/MarkAliasUninstalledOperation.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,34 +13,30 @@
 namespace Composer\DependencyResolver\Operation;
 
 use Composer\Package\AliasPackage;
-use Composer\Package\PackageInterface;
 
 /**
  * Solver install operation.
  *
  * @author Nils Adermann <naderman@naderman.de>
  */
-class MarkAliasUninstalledOperation extends SolverOperation
+class MarkAliasUninstalledOperation extends SolverOperation implements OperationInterface
 {
-    protected $package;
+    const TYPE = 'markAliasUninstalled';
 
     /**
-     * Initializes operation.
-     *
-     * @param AliasPackage $package package instance
-     * @param string       $reason  operation reason
+     * @var AliasPackage
      */
-    public function __construct(AliasPackage $package, $reason = null)
-    {
-        parent::__construct($reason);
+    protected $package;
 
+    public function __construct(AliasPackage $package)
+    {
         $this->package = $package;
     }
 
     /**
      * Returns package instance.
      *
-     * @return PackageInterface
+     * @return AliasPackage
      */
     public function getPackage()
     {
@@ -48,20 +44,10 @@ class MarkAliasUninstalledOperation exte
     }
 
     /**
-     * Returns job type.
-     *
-     * @return string
-     */
-    public function getJobType()
-    {
-        return 'markAliasUninstalled';
-    }
-
-    /**
      * {@inheritDoc}
      */
-    public function __toString()
+    public function show($lock)
     {
-        return 'Marking '.$this->package->getPrettyName().' ('.$this->formatVersion($this->package).') as uninstalled, alias of '.$this->package->getAliasOf()->getPrettyName().' ('.$this->formatVersion($this->package->getAliasOf()).')';
+        return 'Marking <info>'.$this->package->getPrettyName().'</info> (<comment>'.$this->package->getFullPrettyVersion().'</comment>) as uninstalled, alias of <info>'.$this->package->getAliasOf()->getPrettyName().'</info> (<comment>'.$this->package->getAliasOf()->getFullPrettyVersion().'</comment>)';
     }
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Operation/OperationInterface.php 2.0.9-1/src/Composer/DependencyResolver/Operation/OperationInterface.php
--- 1.10.19-1/src/Composer/DependencyResolver/Operation/OperationInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Operation/OperationInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -20,18 +20,19 @@ namespace Composer\DependencyResolver\Op
 interface OperationInterface
 {
     /**
-     * Returns job type.
+     * Returns operation type.
      *
      * @return string
      */
-    public function getJobType();
+    public function getOperationType();
 
     /**
-     * Returns operation reason.
+     * Serializes the operation in a human readable format
      *
+     * @param  bool   $lock Whether this is an operation on the lock file
      * @return string
      */
-    public function getReason();
+    public function show($lock);
 
     /**
      * Serializes the operation in a human readable format
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Operation/SolverOperation.php 2.0.9-1/src/Composer/DependencyResolver/Operation/SolverOperation.php
--- 1.10.19-1/src/Composer/DependencyResolver/Operation/SolverOperation.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Operation/SolverOperation.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,39 +12,30 @@
 
 namespace Composer\DependencyResolver\Operation;
 
-use Composer\Package\PackageInterface;
-
 /**
- * Abstract solver operation class.
+ * Abstract operation class.
  *
- * @author Konstantin Kudryashov <ever.zet@gmail.com>
+ * @author Aleksandr Bezpiatov <aleksandr.bezpiatov@spryker.com>
  */
 abstract class SolverOperation implements OperationInterface
 {
-    protected $reason;
+    const TYPE = null;
 
     /**
-     * Initializes operation.
+     * Returns operation type.
      *
-     * @param string $reason operation reason
+     * @return string
      */
-    public function __construct($reason = null)
+    public function getOperationType()
     {
-        $this->reason = $reason;
+        return static::TYPE;
     }
 
     /**
-     * Returns operation reason.
-     *
-     * @return string
+     * {@inheritDoc}
      */
-    public function getReason()
-    {
-        return $this->reason;
-    }
-
-    protected function formatVersion(PackageInterface $package)
+    public function __toString()
     {
-        return $package->getFullPrettyVersion();
+        return $this->show(false);
     }
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Operation/UninstallOperation.php 2.0.9-1/src/Composer/DependencyResolver/Operation/UninstallOperation.php
--- 1.10.19-1/src/Composer/DependencyResolver/Operation/UninstallOperation.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Operation/UninstallOperation.php	2021-01-27 15:09:27.000000000 +0000
@@ -19,20 +19,17 @@ use Composer\Package\PackageInterface;
  *
  * @author Konstantin Kudryashov <ever.zet@gmail.com>
  */
-class UninstallOperation extends SolverOperation
+class UninstallOperation extends SolverOperation implements OperationInterface
 {
-    protected $package;
+    const TYPE = 'uninstall';
 
     /**
-     * Initializes operation.
-     *
-     * @param PackageInterface $package package instance
-     * @param string           $reason  operation reason
+     * @var PackageInterface
      */
-    public function __construct(PackageInterface $package, $reason = null)
-    {
-        parent::__construct($reason);
+    protected $package;
 
+    public function __construct(PackageInterface $package)
+    {
         $this->package = $package;
     }
 
@@ -47,20 +44,15 @@ class UninstallOperation extends SolverO
     }
 
     /**
-     * Returns job type.
-     *
-     * @return string
+     * {@inheritDoc}
      */
-    public function getJobType()
+    public function show($lock)
     {
-        return 'uninstall';
+        return self::format($this->package, $lock);
     }
 
-    /**
-     * {@inheritDoc}
-     */
-    public function __toString()
+    public static function format(PackageInterface $package, $lock = false)
     {
-        return 'Uninstalling '.$this->package->getPrettyName().' ('.$this->formatVersion($this->package).')';
+        return 'Removing <info>'.$package->getPrettyName().'</info> (<comment>'.$package->getFullPrettyVersion().'</comment>)';
     }
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Operation/UpdateOperation.php 2.0.9-1/src/Composer/DependencyResolver/Operation/UpdateOperation.php
--- 1.10.19-1/src/Composer/DependencyResolver/Operation/UpdateOperation.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Operation/UpdateOperation.php	2021-01-27 15:09:27.000000000 +0000
@@ -20,22 +20,26 @@ use Composer\Package\Version\VersionPars
  *
  * @author Konstantin Kudryashov <ever.zet@gmail.com>
  */
-class UpdateOperation extends SolverOperation
+class UpdateOperation extends SolverOperation implements OperationInterface
 {
+    const TYPE = 'update';
+
+    /**
+     * @var PackageInterface
+     */
     protected $initialPackage;
+
+    /**
+     * @var PackageInterface
+     */
     protected $targetPackage;
 
     /**
-     * Initializes update operation.
-     *
      * @param PackageInterface $initial initial package
      * @param PackageInterface $target  target package (updated)
-     * @param string           $reason  update reason
      */
-    public function __construct(PackageInterface $initial, PackageInterface $target, $reason = null)
+    public function __construct(PackageInterface $initial, PackageInterface $target)
     {
-        parent::__construct($reason);
-
         $this->initialPackage = $initial;
         $this->targetPackage = $target;
     }
@@ -61,23 +65,28 @@ class UpdateOperation extends SolverOper
     }
 
     /**
-     * Returns job type.
-     *
-     * @return string
+     * {@inheritDoc}
      */
-    public function getJobType()
+    public function show($lock)
     {
-        return 'update';
+        return self::format($this->initialPackage, $this->targetPackage, $lock);
     }
 
-    /**
-     * {@inheritDoc}
-     */
-    public function __toString()
+    public static function format(PackageInterface $initialPackage, PackageInterface $targetPackage, $lock = false)
     {
-        $actionName = VersionParser::isUpgrade($this->initialPackage->getVersion(), $this->targetPackage->getVersion()) ? 'Updating' : 'Downgrading';
+        $fromVersion = $initialPackage->getFullPrettyVersion();
+        $toVersion = $targetPackage->getFullPrettyVersion();
+
+        if ($fromVersion === $toVersion && $initialPackage->getSourceReference() !== $targetPackage->getSourceReference()) {
+            $fromVersion = $initialPackage->getFullPrettyVersion(true, PackageInterface::DISPLAY_SOURCE_REF);
+            $toVersion = $targetPackage->getFullPrettyVersion(true, PackageInterface::DISPLAY_SOURCE_REF);
+        } elseif ($fromVersion === $toVersion && $initialPackage->getDistReference() !== $targetPackage->getDistReference()) {
+            $fromVersion = $initialPackage->getFullPrettyVersion(true, PackageInterface::DISPLAY_DIST_REF);
+            $toVersion = $targetPackage->getFullPrettyVersion(true, PackageInterface::DISPLAY_DIST_REF);
+        }
+
+        $actionName = VersionParser::isUpgrade($initialPackage->getVersion(), $targetPackage->getVersion()) ? 'Upgrading' : 'Downgrading';
 
-        return $actionName.' '.$this->initialPackage->getPrettyName().' ('.$this->formatVersion($this->initialPackage).') to '.
-            $this->targetPackage->getPrettyName(). ' ('.$this->formatVersion($this->targetPackage).')';
+        return $actionName.' <info>'.$initialPackage->getPrettyName().'</info> (<comment>'.$fromVersion.'</comment> => <comment>'.$toVersion.'</comment>)';
     }
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/PolicyInterface.php 2.0.9-1/src/Composer/DependencyResolver/PolicyInterface.php
--- 1.10.19-1/src/Composer/DependencyResolver/PolicyInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/PolicyInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -21,7 +21,5 @@ interface PolicyInterface
 {
     public function versionCompare(PackageInterface $a, PackageInterface $b, $operator);
 
-    public function findUpdatePackages(Pool $pool, array $installedMap, PackageInterface $package);
-
-    public function selectPreferredPackages(Pool $pool, array $installedMap, array $literals, $requiredPackage = null);
+    public function selectPreferredPackages(Pool $pool, array $literals, $requiredPackage = null);
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/PoolBuilder.php 2.0.9-1/src/Composer/DependencyResolver/PoolBuilder.php
--- 1.10.19-1/src/Composer/DependencyResolver/PoolBuilder.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/PoolBuilder.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,517 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\DependencyResolver;
+
+use Composer\EventDispatcher\EventDispatcher;
+use Composer\IO\IOInterface;
+use Composer\Package\AliasPackage;
+use Composer\Package\BasePackage;
+use Composer\Package\PackageInterface;
+use Composer\Package\Version\StabilityFilter;
+use Composer\Plugin\PluginEvents;
+use Composer\Plugin\PrePoolCreateEvent;
+use Composer\Repository\PlatformRepository;
+use Composer\Repository\RootPackageRepository;
+use Composer\Semver\CompilingMatcher;
+use Composer\Semver\Constraint\Constraint;
+use Composer\Semver\Constraint\ConstraintInterface;
+use Composer\Semver\Constraint\MatchAllConstraint;
+use Composer\Semver\Constraint\MultiConstraint;
+use Composer\Semver\Intervals;
+
+/**
+ * @author Nils Adermann <naderman@naderman.de>
+ */
+class PoolBuilder
+{
+    /**
+     * @var int[]
+     */
+    private $acceptableStabilities;
+    /**
+     * @var int[]
+     */
+    private $stabilityFlags;
+    /**
+     * @psalm-var array<string, array<string, array{alias: string, alias_normalized: string}>>
+     */
+    private $rootAliases;
+    /**
+     * @psalm-var array<string, string>
+     */
+    private $rootReferences;
+    /**
+     * @var EventDispatcher
+     */
+    private $eventDispatcher;
+    /**
+     * @var IOInterface
+     */
+    private $io;
+    /**
+     * @psalm-var array<string, AliasPackage>
+     */
+    private $aliasMap = array();
+    /**
+     * @psalm-var array<string, ConstraintInterface>
+     */
+    private $packagesToLoad = array();
+    /**
+     * @psalm-var array<string, ConstraintInterface>
+     */
+    private $loadedPackages = array();
+    /**
+     * @psalm-var array<int, array<string, array<string, PackageInterface>>>
+     */
+    private $loadedPerRepo = array();
+    /**
+     * @psalm-var Package[]
+     */
+    private $packages = array();
+    /**
+     * @psalm-var list<Package>
+     */
+    private $unacceptableFixedOrLockedPackages = array();
+    private $updateAllowList = array();
+    private $skippedLoad = array();
+
+    /**
+     * Keeps a list of dependencies which are root requirements, and as such
+     * have already their maximum required range loaded and can not be
+     * extended by markPackageNameForLoading
+     *
+     * Packages get cleared from this list if they get unlocked as in that case
+     * we need to actually load them
+     */
+    private $maxExtendedReqs = array();
+    /**
+     * @psalm-var array<string, bool>
+     */
+    private $updateAllowWarned = array();
+
+    private $indexCounter = 0;
+
+    /**
+     * @param int[] $acceptableStabilities array of stability => BasePackage::STABILITY_* value
+     * @psalm-param array<string, BasePackage::STABILITY_*> $acceptableStabilities
+     * @param int[] $stabilityFlags an array of package name => BasePackage::STABILITY_* value
+     * @psalm-param array<string, BasePackage::STABILITY_*> $stabilityFlags
+     * @param array[] $rootAliases
+     * @psalm-param array<string, array<string, array{alias: string, alias_normalized: string}>> $rootAliases
+     * @param string[] $rootReferences an array of package name => source reference
+     * @psalm-param array<string, string> $rootReferences
+     */
+    public function __construct(array $acceptableStabilities, array $stabilityFlags, array $rootAliases, array $rootReferences, IOInterface $io, EventDispatcher $eventDispatcher = null)
+    {
+        $this->acceptableStabilities = $acceptableStabilities;
+        $this->stabilityFlags = $stabilityFlags;
+        $this->rootAliases = $rootAliases;
+        $this->rootReferences = $rootReferences;
+        $this->eventDispatcher = $eventDispatcher;
+        $this->io = $io;
+    }
+
+    public function buildPool(array $repositories, Request $request)
+    {
+        if ($request->getUpdateAllowList()) {
+            $this->updateAllowList = $request->getUpdateAllowList();
+            $this->warnAboutNonMatchingUpdateAllowList($request);
+
+            foreach ($request->getLockedRepository()->getPackages() as $lockedPackage) {
+                if (!$this->isUpdateAllowed($lockedPackage)) {
+                    $request->lockPackage($lockedPackage);
+                    $lockedName = $lockedPackage->getName();
+                    // remember which packages we skipped loading remote content for in this partial update
+                    $this->skippedLoad[$lockedName] = $lockedName;
+                    foreach ($lockedPackage->getReplaces() as $link) {
+                        $this->skippedLoad[$link->getTarget()] = $lockedName;
+                    }
+                }
+            }
+        }
+
+        foreach ($request->getFixedOrLockedPackages() as $package) {
+            // using MatchAllConstraint here because fixed packages do not need to retrigger
+            // loading any packages
+            $this->loadedPackages[$package->getName()] = new MatchAllConstraint();
+
+            // replace means conflict, so if a fixed package replaces a name, no need to load that one, packages would conflict anyways
+            foreach ($package->getReplaces() as $link) {
+                $this->loadedPackages[$link->getTarget()] = new MatchAllConstraint();
+            }
+
+            // TODO in how far can we do the above for conflicts? It's more tricky cause conflicts can be limited to
+            // specific versions while replace is a conflict with all versions of the name
+
+            if (
+                $package->getRepository() instanceof RootPackageRepository
+                || $package->getRepository() instanceof PlatformRepository
+                || StabilityFilter::isPackageAcceptable($this->acceptableStabilities, $this->stabilityFlags, $package->getNames(), $package->getStability())
+            ) {
+                $this->loadPackage($request, $package, false);
+            } else {
+                $this->unacceptableFixedOrLockedPackages[] = $package;
+            }
+        }
+
+        foreach ($request->getRequires() as $packageName => $constraint) {
+            // fixed and locked packages have already been added, so if a root require needs one of them, no need to do anything
+            if (isset($this->loadedPackages[$packageName])) {
+                continue;
+            }
+
+            $this->packagesToLoad[$packageName] = $constraint;
+            $this->maxExtendedReqs[$packageName] = true;
+        }
+
+        // clean up packagesToLoad for anything we manually marked loaded above
+        foreach ($this->packagesToLoad as $name => $constraint) {
+            if (isset($this->loadedPackages[$name])) {
+                unset($this->packagesToLoad[$name]);
+            }
+        }
+
+        while (!empty($this->packagesToLoad)) {
+            $this->loadPackagesMarkedForLoading($request, $repositories);
+        }
+
+        foreach ($this->packages as $i => $package) {
+            // we check all alias related packages at once, so no need to check individual aliases
+            // isset also checks non-null value
+            if (!$package instanceof AliasPackage) {
+                $constraint = new Constraint('==', $package->getVersion());
+                $aliasedPackages = array($i => $package);
+                if (isset($this->aliasMap[spl_object_hash($package)])) {
+                    $aliasedPackages += $this->aliasMap[spl_object_hash($package)];
+                }
+
+                $found = false;
+                foreach ($aliasedPackages as $packageOrAlias) {
+                    if (CompilingMatcher::match($constraint, Constraint::OP_EQ, $packageOrAlias->getVersion())) {
+                        $found = true;
+                    }
+                }
+                if (!$found) {
+                    foreach ($aliasedPackages as $index => $packageOrAlias) {
+                        unset($this->packages[$index]);
+                    }
+                }
+            }
+        }
+
+        if ($this->eventDispatcher) {
+            $prePoolCreateEvent = new PrePoolCreateEvent(
+                PluginEvents::PRE_POOL_CREATE,
+                $repositories,
+                $request,
+                $this->acceptableStabilities,
+                $this->stabilityFlags,
+                $this->rootAliases,
+                $this->rootReferences,
+                $this->packages,
+                $this->unacceptableFixedOrLockedPackages
+            );
+            $this->eventDispatcher->dispatch($prePoolCreateEvent->getName(), $prePoolCreateEvent);
+            $this->packages = $prePoolCreateEvent->getPackages();
+            $this->unacceptableFixedOrLockedPackages = $prePoolCreateEvent->getUnacceptableFixedPackages();
+        }
+
+        $pool = new Pool($this->packages, $this->unacceptableFixedOrLockedPackages);
+
+        $this->aliasMap = array();
+        $this->packagesToLoad = array();
+        $this->loadedPackages = array();
+        $this->loadedPerRepo = array();
+        $this->packages = array();
+        $this->unacceptableFixedOrLockedPackages = array();
+        $this->maxExtendedReqs = array();
+        $this->skippedLoad = array();
+        $this->indexCounter = 0;
+
+        Intervals::clear();
+
+        return $pool;
+    }
+
+    private function markPackageNameForLoading(Request $request, $name, ConstraintInterface $constraint)
+    {
+        // Skip platform requires at this stage
+        if (PlatformRepository::isPlatformPackage($name)) {
+            return;
+        }
+
+        // Root require (which was not unlocked) already loaded the maximum range so no
+        // need to check anything here
+        if (isset($this->maxExtendedReqs[$name])) {
+            return;
+        }
+
+        // Root requires can not be overruled by dependencies so there is no point in
+        // extending the loaded constraint for those.
+        // This is triggered when loading a root require which was locked but got unlocked, then
+        // we make sure that we load at most the intervals covered by the root constraint.
+        $rootRequires = $request->getRequires();
+        if (isset($rootRequires[$name]) && !Intervals::isSubsetOf($constraint, $rootRequires[$name])) {
+            $constraint = $rootRequires[$name];
+        }
+
+        // Not yet loaded or already marked for a reload, set the constraint to be loaded
+        if (!isset($this->loadedPackages[$name])) {
+            // Maybe it was already marked before but not loaded yet. In that case
+            // we have to extend the constraint (we don't check if they are identical because
+            // MultiConstraint::create() will optimize anyway)
+            if (isset($this->packagesToLoad[$name])) {
+                // Already marked for loading and this does not expand the constraint to be loaded, nothing to do
+                if (Intervals::isSubsetOf($constraint, $this->packagesToLoad[$name])) {
+                    return;
+                }
+
+                // extend the constraint to be loaded
+                $constraint = Intervals::compactConstraint(MultiConstraint::create(array($this->packagesToLoad[$name], $constraint), false));
+            }
+
+            $this->packagesToLoad[$name] = $constraint;
+
+            return;
+        }
+
+        // No need to load this package with this constraint because it is
+        // a subset of the constraint with which we have already loaded packages
+        if (Intervals::isSubsetOf($constraint, $this->loadedPackages[$name])) {
+            return;
+        }
+
+        // We have already loaded that package but not in the constraint that's
+        // required. We extend the constraint and mark that package as not being loaded
+        // yet so we get the required package versions
+        $this->packagesToLoad[$name] = Intervals::compactConstraint(MultiConstraint::create(array($this->loadedPackages[$name], $constraint), false));
+        unset($this->loadedPackages[$name]);
+    }
+
+    private function loadPackagesMarkedForLoading(Request $request, $repositories)
+    {
+        foreach ($this->packagesToLoad as $name => $constraint) {
+            $this->loadedPackages[$name] = $constraint;
+        }
+
+        $packageBatch = $this->packagesToLoad;
+        $this->packagesToLoad = array();
+
+        foreach ($repositories as $repoIndex => $repository) {
+            if (empty($packageBatch)) {
+                break;
+            }
+
+            // these repos have their packages fixed or locked if they need to be loaded so we
+            // never need to load anything else from them
+            if ($repository instanceof PlatformRepository || $repository === $request->getLockedRepository()) {
+                continue;
+            }
+            $result = $repository->loadPackages($packageBatch, $this->acceptableStabilities, $this->stabilityFlags, isset($this->loadedPerRepo[$repoIndex]) ? $this->loadedPerRepo[$repoIndex] : array());
+
+            foreach ($result['namesFound'] as $name) {
+                // avoid loading the same package again from other repositories once it has been found
+                unset($packageBatch[$name]);
+            }
+            foreach ($result['packages'] as $package) {
+                $this->loadedPerRepo[$repoIndex][$package->getName()][$package->getVersion()] = $package;
+                $this->loadPackage($request, $package);
+            }
+        }
+    }
+
+    private function loadPackage(Request $request, PackageInterface $package, $propagateUpdate = true)
+    {
+        $index = $this->indexCounter++;
+        $this->packages[$index] = $package;
+
+        if ($package instanceof AliasPackage) {
+            $this->aliasMap[spl_object_hash($package->getAliasOf())][$index] = $package;
+        }
+
+        $name = $package->getName();
+
+        // we're simply setting the root references on all versions for a name here and rely on the solver to pick the
+        // right version. It'd be more work to figure out which versions and which aliases of those versions this may
+        // apply to
+        if (isset($this->rootReferences[$name])) {
+            // do not modify the references on already locked or fixed packages
+            if (!$request->isLockedPackage($package) && !$request->isFixedPackage($package)) {
+                $package->setSourceDistReferences($this->rootReferences[$name]);
+            }
+        }
+
+        // if propogateUpdate is false we are loading a fixed or locked package, root aliases do not apply as they are
+        // manually loaded as separate packages in this case
+        if ($propagateUpdate && isset($this->rootAliases[$name][$package->getVersion()])) {
+            $alias = $this->rootAliases[$name][$package->getVersion()];
+            if ($package instanceof AliasPackage) {
+                $basePackage = $package->getAliasOf();
+            } else {
+                $basePackage = $package;
+            }
+            $aliasPackage = new AliasPackage($basePackage, $alias['alias_normalized'], $alias['alias']);
+            $aliasPackage->setRootPackageAlias(true);
+
+            $newIndex = $this->indexCounter++;
+            $this->packages[$newIndex] = $aliasPackage;
+            $this->aliasMap[spl_object_hash($aliasPackage->getAliasOf())][$newIndex] = $aliasPackage;
+        }
+
+        foreach ($package->getRequires() as $link) {
+            $require = $link->getTarget();
+            $linkConstraint = $link->getConstraint();
+
+            // if the required package is loaded as a locked package only and hasn't had its deps analyzed
+            if (isset($this->skippedLoad[$require])) {
+                // if we're doing a full update or this is a partial update with transitive deps and we're currently
+                // looking at a package which needs to be updated we need to unlock the package we now know is a
+                // dependency of another package which we are trying to update, and then attempt to load it again
+                if ($propagateUpdate && $request->getUpdateAllowTransitiveDependencies()) {
+                    if ($request->getUpdateAllowTransitiveRootDependencies() || !$this->isRootRequire($request, $this->skippedLoad[$require])) {
+                        $this->unlockPackage($request, $require);
+                        $this->markPackageNameForLoading($request, $require, $linkConstraint);
+                    } elseif (!isset($this->updateAllowWarned[$this->skippedLoad[$require]])) {
+                        $this->updateAllowWarned[$this->skippedLoad[$require]] = true;
+                        $this->io->writeError('<warning>Dependency "'.$this->skippedLoad[$require].'" is also a root requirement. Package has not been listed as an update argument, so keeping locked at old version. Use --with-all-dependencies (-W) to include root dependencies.</warning>');
+                    }
+                }
+            } else {
+                $this->markPackageNameForLoading($request, $require, $linkConstraint);
+            }
+        }
+
+        // if we're doing a partial update with deps we also need to unlock packages which are being replaced in case
+        // they are currently locked and thus prevent this updateable package from being installable/updateable
+        if ($propagateUpdate && $request->getUpdateAllowTransitiveDependencies()) {
+            foreach ($package->getReplaces() as $link) {
+                $replace = $link->getTarget();
+                if (isset($this->loadedPackages[$replace], $this->skippedLoad[$replace])) {
+                    if ($request->getUpdateAllowTransitiveRootDependencies() || !$this->isRootRequire($request, $this->skippedLoad[$replace])) {
+                        $this->unlockPackage($request, $replace);
+                        $this->markPackageNameForLoading($request, $replace, $link->getConstraint());
+                    } elseif (!$request->getUpdateAllowTransitiveRootDependencies() && $this->isRootRequire($request, $replace) && !isset($this->updateAllowWarned[$replace])) {
+                        $this->updateAllowWarned[$replace] = true;
+                        $this->io->writeError('<warning>Dependency "'.$replace.'" is also a root requirement. Package has not been listed as an update argument, so keeping locked at old version. Use --with-all-dependencies (-W) to include root dependencies.</warning>');
+                    }
+                }
+            }
+        }
+    }
+
+    /**
+     * Checks if a particular name is required directly in the request
+     *
+     * @return bool
+     */
+    private function isRootRequire(Request $request, $name)
+    {
+        $rootRequires = $request->getRequires();
+
+        return isset($rootRequires[$name]);
+    }
+
+    /**
+     * Checks whether the update allow list allows this package in the lock file to be updated
+     * @return bool
+     */
+    private function isUpdateAllowed(PackageInterface $package)
+    {
+        foreach ($this->updateAllowList as $pattern => $void) {
+            $patternRegexp = BasePackage::packageNameToRegexp($pattern);
+            if (preg_match($patternRegexp, $package->getName())) {
+                return true;
+            }
+        }
+
+        return false;
+    }
+
+    private function warnAboutNonMatchingUpdateAllowList(Request $request)
+    {
+        foreach ($this->updateAllowList as $pattern => $void) {
+            $patternRegexp = BasePackage::packageNameToRegexp($pattern);
+            // update pattern matches a locked package? => all good
+            foreach ($request->getLockedRepository()->getPackages() as $package) {
+                if (preg_match($patternRegexp, $package->getName())) {
+                    continue 2;
+                }
+            }
+            // update pattern matches a root require? => all good, probably a new package
+            foreach ($request->getRequires() as $packageName => $constraint) {
+                if (preg_match($patternRegexp, $packageName)) {
+                    continue 2;
+                }
+            }
+            if (strpos($pattern, '*') !== false) {
+                $this->io->writeError('<warning>Pattern "' . $pattern . '" listed for update does not match any locked packages.</warning>');
+            } else {
+                $this->io->writeError('<warning>Package "' . $pattern . '" listed for update is not locked.</warning>');
+            }
+        }
+    }
+
+    /**
+     * Reverts the decision to use a locked package if a partial update with transitive dependencies
+     * found that this package actually needs to be updated
+     */
+    private function unlockPackage(Request $request, $name)
+    {
+
+        if (
+            // if we unfixed a replaced package name, we also need to unfix the replacer itself
+            $this->skippedLoad[$name] !== $name
+            // as long as it was not unfixed yet
+            && isset($this->skippedLoad[$this->skippedLoad[$name]])
+        ) {
+            $this->unlockPackage($request, $this->skippedLoad[$name]);
+        }
+
+        unset($this->skippedLoad[$name], $this->loadedPackages[$name], $this->maxExtendedReqs[$name]);
+
+        // remove locked package by this name which was already initialized
+        foreach ($request->getLockedPackages() as $lockedPackage) {
+            if (!($lockedPackage instanceof AliasPackage) && $lockedPackage->getName() === $name) {
+                if (false !== $index = array_search($lockedPackage, $this->packages, true)) {
+                    $request->unlockPackage($lockedPackage);
+                    $this->removeLoadedPackage($request, $lockedPackage, $index);
+
+                    // make sure that any requirements for this package by other locked or fixed packages are now
+                    // also loaded, as they were previously ignored because the locked (now unlocked) package already
+                    // satisfied their requirements
+                    foreach ($request->getFixedOrLockedPackages() as $fixedOrLockedPackage) {
+                        if ($fixedOrLockedPackage !== $lockedPackage && isset($this->skippedLoad[$fixedOrLockedPackage->getName()])) {
+                            foreach ($fixedOrLockedPackage->getRequires() as $requireLink) {
+                                if ($requireLink->getTarget() === $lockedPackage->getName()) {
+                                    $this->markPackageNameForLoading($request, $lockedPackage->getName(), $requireLink->getConstraint());
+                                }
+                            }
+                        }
+                    }
+                }
+            }
+        }
+    }
+
+    private function removeLoadedPackage(Request $request, PackageInterface $package, $index)
+    {
+        unset($this->packages[$index]);
+        if (isset($this->aliasMap[spl_object_hash($package)])) {
+            foreach ($this->aliasMap[spl_object_hash($package)] as $aliasIndex => $aliasPackage) {
+                $request->unlockPackage($aliasPackage);
+                unset($this->packages[$aliasIndex]);
+            }
+            unset($this->aliasMap[spl_object_hash($package)]);
+        }
+    }
+}
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Pool.php 2.0.9-1/src/Composer/DependencyResolver/Pool.php
--- 1.10.19-1/src/Composer/DependencyResolver/Pool.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Pool.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,150 +12,51 @@
 
 namespace Composer\DependencyResolver;
 
-use Composer\Package\BasePackage;
-use Composer\Package\AliasPackage;
 use Composer\Package\Version\VersionParser;
+use Composer\Semver\CompilingMatcher;
 use Composer\Semver\Constraint\ConstraintInterface;
 use Composer\Semver\Constraint\Constraint;
-use Composer\Semver\Constraint\EmptyConstraint;
-use Composer\Repository\RepositoryInterface;
-use Composer\Repository\CompositeRepository;
-use Composer\Repository\ComposerRepository;
-use Composer\Repository\InstalledRepositoryInterface;
-use Composer\Repository\PlatformRepository;
 use Composer\Package\PackageInterface;
 
 /**
- * A package pool contains repositories that provide packages.
+ * A package pool contains all packages for dependency resolution
  *
  * @author Nils Adermann <naderman@naderman.de>
  * @author Jordi Boggiano <j.boggiano@seld.be>
  */
 class Pool implements \Countable
 {
-    const MATCH_NAME = -1;
-    const MATCH_NONE = 0;
-    const MATCH = 1;
-    const MATCH_PROVIDE = 2;
-    const MATCH_REPLACE = 3;
-    const MATCH_FILTERED = 4;
-
-    protected $repositories = array();
-    protected $providerRepos = array();
     protected $packages = array();
     protected $packageByName = array();
-    protected $packageByExactName = array();
-    protected $acceptableStabilities;
-    protected $stabilityFlags;
     protected $versionParser;
     protected $providerCache = array();
-    protected $filterRequires;
-    protected $whitelist = null; // TODO 2.0 rename to allowList
-    protected $id = 1;
+    protected $unacceptableFixedOrLockedPackages;
 
-    public function __construct($minimumStability = 'stable', array $stabilityFlags = array(), array $filterRequires = array())
+    public function __construct(array $packages = array(), array $unacceptableFixedOrLockedPackages = array())
     {
         $this->versionParser = new VersionParser;
-        $this->acceptableStabilities = array();
-        foreach (BasePackage::$stabilities as $stability => $value) {
-            if ($value <= BasePackage::$stabilities[$minimumStability]) {
-                $this->acceptableStabilities[$stability] = $value;
-            }
-        }
-        $this->stabilityFlags = $stabilityFlags;
-        $this->filterRequires = $filterRequires;
-        foreach ($filterRequires as $name => $constraint) {
-            if (preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $name)) {
-                unset($this->filterRequires[$name]);
-            }
-        }
-    }
-
-    public function setAllowList($allowList)
-    {
-        // call original method for BC
-        $this->setWhitelist($allowList);
+        $this->setPackages($packages);
+        $this->unacceptableFixedOrLockedPackages = $unacceptableFixedOrLockedPackages;
     }
 
-    /**
-     * @deprecated use setAllowList instead
-     */
-    public function setWhitelist($whitelist)
-    {
-        $this->whitelist = $whitelist;
-        $this->providerCache = array();
-    }
-
-    /**
-     * Adds a repository and its packages to this package pool
-     *
-     * @param RepositoryInterface $repo        A package repository
-     * @param array               $rootAliases
-     */
-    public function addRepository(RepositoryInterface $repo, $rootAliases = array())
+    private function setPackages(array $packages)
     {
-        if ($repo instanceof CompositeRepository) {
-            $repos = $repo->getRepositories();
-        } else {
-            $repos = array($repo);
-        }
+        $id = 1;
 
-        foreach ($repos as $repo) {
-            $this->repositories[] = $repo;
+        foreach ($packages as $package) {
+            $this->packages[] = $package;
 
-            $exempt = $repo instanceof PlatformRepository || $repo instanceof InstalledRepositoryInterface;
+            $package->id = $id++;
 
-            if ($repo instanceof ComposerRepository && $repo->hasProviders()) {
-                $this->providerRepos[] = $repo;
-                $repo->setRootAliases($rootAliases);
-                $repo->resetPackageIds();
-            } else {
-                foreach ($repo->getPackages() as $package) {
-                    $names = $package->getNames();
-                    $stability = $package->getStability();
-                    if ($exempt || $this->isPackageAcceptable($names, $stability)) {
-                        $package->setId($this->id++);
-                        $this->packages[] = $package;
-                        $this->packageByExactName[$package->getName()][$package->id] = $package;
-
-                        foreach ($names as $provided) {
-                            $this->packageByName[$provided][] = $package;
-                        }
-
-                        // handle root package aliases
-                        $name = $package->getName();
-                        if (isset($rootAliases[$name][$package->getVersion()])) {
-                            $alias = $rootAliases[$name][$package->getVersion()];
-                            if ($package instanceof AliasPackage) {
-                                $package = $package->getAliasOf();
-                            }
-                            $aliasPackage = new AliasPackage($package, $alias['alias_normalized'], $alias['alias']);
-                            $aliasPackage->setRootPackageAlias(true);
-                            $aliasPackage->setId($this->id++);
-
-                            $package->getRepository()->addPackage($aliasPackage);
-                            $this->packages[] = $aliasPackage;
-                            $this->packageByExactName[$aliasPackage->getName()][$aliasPackage->id] = $aliasPackage;
-
-                            foreach ($aliasPackage->getNames() as $name) {
-                                $this->packageByName[$name][] = $aliasPackage;
-                            }
-                        }
-                    }
-                }
+            foreach ($package->getNames() as $provided) {
+                $this->packageByName[$provided][] = $package;
             }
         }
     }
 
-    public function getPriority(RepositoryInterface $repo)
+    public function getPackages()
     {
-        $priority = array_search($repo, $this->repositories, true);
-
-        if (false === $priority) {
-            throw new \RuntimeException("Could not determine repository priority. The repository was not registered in the pool.");
-        }
-
-        return -$priority;
+        return $this->packages;
     }
 
     /**
@@ -174,115 +75,45 @@ class Pool implements \Countable
      */
     public function count()
     {
-        return count($this->packages);
+        return \count($this->packages);
     }
 
     /**
      * Searches all packages providing the given package name and match the constraint
      *
-     * @param  string              $name          The package name to be searched for
-     * @param  ConstraintInterface $constraint    A constraint that all returned
-     *                                            packages must match or null to return all
-     * @param  bool                $mustMatchName Whether the name of returned packages
-     *                                            must match the given name
-     * @param  bool                $bypassFilters If enabled, filterRequires and stability matching is ignored
+     * @param  string              $name       The package name to be searched for
+     * @param  ConstraintInterface $constraint A constraint that all returned
+     *                                         packages must match or null to return all
      * @return PackageInterface[]  A set of packages
      */
-    public function whatProvides($name, ConstraintInterface $constraint = null, $mustMatchName = false, $bypassFilters = false)
+    public function whatProvides($name, ConstraintInterface $constraint = null)
     {
-        if ($bypassFilters) {
-            return $this->computeWhatProvides($name, $constraint, $mustMatchName, true);
-        }
-
-        $key = ((int) $mustMatchName).$constraint;
+        $key = (string) $constraint;
         if (isset($this->providerCache[$name][$key])) {
             return $this->providerCache[$name][$key];
         }
 
-        return $this->providerCache[$name][$key] = $this->computeWhatProvides($name, $constraint, $mustMatchName, $bypassFilters);
+        return $this->providerCache[$name][$key] = $this->computeWhatProvides($name, $constraint);
     }
 
     /**
      * @see whatProvides
      */
-    private function computeWhatProvides($name, $constraint, $mustMatchName = false, $bypassFilters = false)
+    private function computeWhatProvides($name, $constraint)
     {
-        $candidates = array();
-
-        foreach ($this->providerRepos as $repo) {
-            foreach ($repo->whatProvides($this, $name, $bypassFilters) as $candidate) {
-                $candidates[] = $candidate;
-                if ($candidate->id < 1) {
-                    $candidate->setId($this->id++);
-                    $this->packages[$this->id - 2] = $candidate;
-                }
-            }
-        }
-
-        if ($mustMatchName) {
-            $candidates = array_filter($candidates, function ($candidate) use ($name) {
-                return $candidate->getName() == $name;
-            });
-            if (isset($this->packageByExactName[$name])) {
-                $candidates = array_merge($candidates, $this->packageByExactName[$name]);
-            }
-        } elseif (isset($this->packageByName[$name])) {
-            $candidates = array_merge($candidates, $this->packageByName[$name]);
+        if (!isset($this->packageByName[$name])) {
+            return array();
         }
 
-        $matches = $provideMatches = array();
-        $nameMatch = false;
+        $matches = array();
 
-        foreach ($candidates as $candidate) {
-            $aliasOfCandidate = null;
-
-            // alias packages are not white listed, make sure that the package
-            // being aliased is white listed
-            if ($candidate instanceof AliasPackage) {
-                $aliasOfCandidate = $candidate->getAliasOf();
-            }
-
-            if ($this->whitelist !== null && !$bypassFilters && (
-                (!($candidate instanceof AliasPackage) && !isset($this->whitelist[$candidate->id])) ||
-                ($candidate instanceof AliasPackage && !isset($this->whitelist[$aliasOfCandidate->id]))
-            )) {
-                continue;
-            }
-            switch ($this->match($candidate, $name, $constraint, $bypassFilters)) {
-                case self::MATCH_NONE:
-                    break;
-
-                case self::MATCH_NAME:
-                    $nameMatch = true;
-                    break;
-
-                case self::MATCH:
-                    $nameMatch = true;
-                    $matches[] = $candidate;
-                    break;
-
-                case self::MATCH_PROVIDE:
-                    $provideMatches[] = $candidate;
-                    break;
-
-                case self::MATCH_REPLACE:
-                    $matches[] = $candidate;
-                    break;
-
-                case self::MATCH_FILTERED:
-                    break;
-
-                default:
-                    throw new \UnexpectedValueException('Unexpected match type');
+        foreach ($this->packageByName[$name] as $candidate) {
+            if ($this->match($candidate, $name, $constraint)) {
+                $matches[] = $candidate;
             }
         }
 
-        // if a package with the required name exists, we ignore providers
-        if ($nameMatch) {
-            return $matches;
-        }
-
-        return array_merge($matches, $provideMatches);
+        return $matches;
     }
 
     public function literalToPackage($literal)
@@ -305,53 +136,22 @@ class Pool implements \Countable
         return $prefix.' '.$package->getPrettyString();
     }
 
-    public function isPackageAcceptable($name, $stability)
-    {
-        foreach ((array) $name as $n) {
-            // allow if package matches the global stability requirement and has no exception
-            if (!isset($this->stabilityFlags[$n]) && isset($this->acceptableStabilities[$stability])) {
-                return true;
-            }
-
-            // allow if package matches the package-specific stability flag
-            if (isset($this->stabilityFlags[$n]) && BasePackage::$stabilities[$stability] <= $this->stabilityFlags[$n]) {
-                return true;
-            }
-        }
-
-        return false;
-    }
-
     /**
      * Checks if the package matches the given constraint directly or through
      * provided or replaced packages
      *
-     * @param  PackageInterface       $candidate
-     * @param  string                 $name       Name of the package to be matched
-     * @param  ConstraintInterface    $constraint The constraint to verify
-     * @return int                    One of the MATCH* constants of this class or 0 if there is no match
+     * @param  PackageInterface    $candidate
+     * @param  string              $name       Name of the package to be matched
+     * @param  ConstraintInterface $constraint The constraint to verify
+     * @return bool
      */
-    public function match($candidate, $name, ConstraintInterface $constraint = null, $bypassFilters)
+    public function match($candidate, $name, ConstraintInterface $constraint = null)
     {
         $candidateName = $candidate->getName();
         $candidateVersion = $candidate->getVersion();
-        $isDev = $candidate->getStability() === 'dev';
-        $isAlias = $candidate instanceof AliasPackage;
-
-        if (!$bypassFilters && !$isDev && !$isAlias && isset($this->filterRequires[$name])) {
-            $requireFilter = $this->filterRequires[$name];
-        } else {
-            $requireFilter = new EmptyConstraint;
-        }
 
         if ($candidateName === $name) {
-            $pkgConstraint = new Constraint('==', $candidateVersion);
-
-            if ($constraint === null || $constraint->matches($pkgConstraint)) {
-                return $requireFilter->matches($pkgConstraint) ? self::MATCH : self::MATCH_FILTERED;
-            }
-
-            return self::MATCH_NAME;
+            return $constraint === null || CompilingMatcher::match($constraint, Constraint::OP_EQ, $candidateVersion);
         }
 
         $provides = $candidate->getProvides();
@@ -361,27 +161,43 @@ class Pool implements \Countable
         if (isset($replaces[0]) || isset($provides[0])) {
             foreach ($provides as $link) {
                 if ($link->getTarget() === $name && ($constraint === null || $constraint->matches($link->getConstraint()))) {
-                    return $requireFilter->matches($link->getConstraint()) ? self::MATCH_PROVIDE : self::MATCH_FILTERED;
+                    return true;
                 }
             }
 
             foreach ($replaces as $link) {
                 if ($link->getTarget() === $name && ($constraint === null || $constraint->matches($link->getConstraint()))) {
-                    return $requireFilter->matches($link->getConstraint()) ? self::MATCH_REPLACE : self::MATCH_FILTERED;
+                    return true;
                 }
             }
 
-            return self::MATCH_NONE;
+            return false;
         }
 
         if (isset($provides[$name]) && ($constraint === null || $constraint->matches($provides[$name]->getConstraint()))) {
-            return $requireFilter->matches($provides[$name]->getConstraint()) ? self::MATCH_PROVIDE : self::MATCH_FILTERED;
+            return true;
         }
 
         if (isset($replaces[$name]) && ($constraint === null || $constraint->matches($replaces[$name]->getConstraint()))) {
-            return $requireFilter->matches($replaces[$name]->getConstraint()) ? self::MATCH_REPLACE : self::MATCH_FILTERED;
+            return true;
+        }
+
+        return false;
+    }
+
+    public function isUnacceptableFixedOrLockedPackage(PackageInterface $package)
+    {
+        return \in_array($package, $this->unacceptableFixedOrLockedPackages, true);
+    }
+
+    public function __toString()
+    {
+        $str = "Pool:\n";
+
+        foreach ($this->packages as $package) {
+            $str .= '- '.str_pad($package->id, 6, ' ', STR_PAD_LEFT).': '.$package->getName()."\n";
         }
 
-        return self::MATCH_NONE;
+        return $str;
     }
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Problem.php 2.0.9-1/src/Composer/DependencyResolver/Problem.php
--- 1.10.19-1/src/Composer/DependencyResolver/Problem.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Problem.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,11 @@
 namespace Composer\DependencyResolver;
 
 use Composer\Package\CompletePackageInterface;
+use Composer\Package\AliasPackage;
+use Composer\Repository\RepositorySet;
+use Composer\Repository\LockArrayRepository;
+use Composer\Semver\Constraint\Constraint;
+use Composer\Package\Version\VersionParser;
 
 /**
  * Represents a problem detected while solving dependencies
@@ -28,20 +33,13 @@ class Problem
     protected $reasonSeen;
 
     /**
-     * A set of reasons for the problem, each is a rule or a job and a rule
+     * A set of reasons for the problem, each is a rule or a root require and a rule
      * @var array
      */
     protected $reasons = array();
 
     protected $section = 0;
 
-    protected $pool;
-
-    public function __construct(Pool $pool)
-    {
-        $this->pool = $pool;
-    }
-
     /**
      * Add a rule as a reason
      *
@@ -49,10 +47,7 @@ class Problem
      */
     public function addRule(Rule $rule)
     {
-        $this->addReason(spl_object_hash($rule), array(
-            'rule' => $rule,
-            'job' => $rule->getJob(),
-        ));
+        $this->addReason(spl_object_hash($rule), $rule);
     }
 
     /**
@@ -68,124 +63,106 @@ class Problem
     /**
      * A human readable textual representation of the problem's reasons
      *
-     * @param  array  $installedMap A map of all installed packages
+     * @param  array  $installedMap A map of all present packages
      * @return string
      */
-    public function getPrettyString(array $installedMap = array())
+    public function getPrettyString(RepositorySet $repositorySet, Request $request, Pool $pool, $isVerbose, array $installedMap = array(), array $learnedPool = array())
     {
+        // TODO doesn't this entirely defeat the purpose of the problem sections? what's the point of sections?
         $reasons = call_user_func_array('array_merge', array_reverse($this->reasons));
 
         if (count($reasons) === 1) {
             reset($reasons);
-            $reason = current($reasons);
+            $rule = current($reasons);
 
-            $job = $reason['job'];
+            if (!in_array($rule->getReason(), array(Rule::RULE_ROOT_REQUIRE, Rule::RULE_FIXED), true)) {
+                throw new \LogicException("Single reason problems must contain a request rule.");
+            }
 
-            $packageName = $job['packageName'];
-            $constraint = $job['constraint'];
+            $reasonData = $rule->getReasonData();
+            $packageName = $reasonData['packageName'];
+            $constraint = $reasonData['constraint'];
 
             if (isset($constraint)) {
-                $packages = $this->pool->whatProvides($packageName, $constraint);
+                $packages = $pool->whatProvides($packageName, $constraint);
             } else {
                 $packages = array();
             }
 
-            if ($job && $job['cmd'] === 'install' && empty($packages)) {
-
-                // handle php/hhvm
-                if ($packageName === 'php' || $packageName === 'php-64bit' || $packageName === 'hhvm') {
-                    $version = phpversion();
-                    $available = $this->pool->whatProvides($packageName);
-
-                    if (count($available)) {
-                        $firstAvailable = reset($available);
-                        $version = $firstAvailable->getPrettyVersion();
-                        $extra = $firstAvailable->getExtra();
-                        if ($firstAvailable instanceof CompletePackageInterface && isset($extra['config.platform']) && $extra['config.platform'] === true) {
-                            $version .= '; ' . $firstAvailable->getDescription();
-                        }
-                    }
-
-                    $msg = "\n    - This package requires ".$packageName.$this->constraintToText($constraint).' but ';
-
-                    if (defined('HHVM_VERSION') || (count($available) && $packageName === 'hhvm')) {
-                        return $msg . 'your HHVM version does not satisfy that requirement.';
-                    }
+            if (empty($packages)) {
+                return "\n    ".implode(self::getMissingPackageReason($repositorySet, $request, $pool, $isVerbose, $packageName, $constraint));
+            }
+        }
 
-                    if ($packageName === 'hhvm') {
-                        return $msg . 'you are running this with PHP and not HHVM.';
-                    }
+        return self::formatDeduplicatedRules($reasons, '    ', $repositorySet, $request, $pool, $isVerbose, $installedMap, $learnedPool);
+    }
 
-                    return $msg . 'your PHP version ('. $version .') does not satisfy that requirement.';
-                }
+    /**
+     * @internal
+     */
+    public static function formatDeduplicatedRules($rules, $indent, RepositorySet $repositorySet, Request $request, Pool $pool, $isVerbose, array $installedMap = array(), array $learnedPool = array())
+    {
+        $messages = array();
+        $templates = array();
+        $parser = new VersionParser;
+        $deduplicatableRuleTypes = array(Rule::RULE_PACKAGE_REQUIRES, Rule::RULE_PACKAGE_CONFLICT);
+        foreach ($rules as $rule) {
+            $message = $rule->getPrettyString($repositorySet, $request, $pool, $isVerbose, $installedMap, $learnedPool);
+            if (in_array($rule->getReason(), $deduplicatableRuleTypes, true) && preg_match('{^(?P<package>\S+) (?P<version>\S+) (?P<type>requires|conflicts)}', $message, $m)) {
+                $template = preg_replace('{^\S+ \S+ }', '%s%s ', $message);
+                $messages[] = $template;
+                $templates[$template][$m[1]][$parser->normalize($m[2])] = $m[2];
+            } elseif ($message !== '') {
+                $messages[] = $message;
+            }
+        }
 
-                // handle php extensions
-                if (0 === stripos($packageName, 'ext-')) {
-                    if (false !== strpos($packageName, ' ')) {
-                        return "\n    - The requested PHP extension ".$packageName.' should be required as '.str_replace(' ', '-', $packageName).'.';
+        $result = array();
+        foreach (array_unique($messages) as $message) {
+            if (isset($templates[$message])) {
+                foreach ($templates[$message] as $package => $versions) {
+                    uksort($versions, 'version_compare');
+                    if (!$isVerbose) {
+                        $versions = self::condenseVersionList($versions, 1);
                     }
-
-                    $ext = substr($packageName, 4);
-                    $error = extension_loaded($ext) ? 'has the wrong version ('.(phpversion($ext) ?: '0').') installed' : 'is missing from your system';
-
-                    return "\n    - The requested PHP extension ".$packageName.$this->constraintToText($constraint).' '.$error.'. Install or enable PHP\'s '.$ext.' extension.';
-                }
-
-                // handle linked libs
-                if (0 === stripos($packageName, 'lib-')) {
-                    if (strtolower($packageName) === 'lib-icu') {
-                        $error = extension_loaded('intl') ? 'has the wrong version installed, try upgrading the intl extension.' : 'is missing from your system, make sure the intl extension is loaded.';
-
-                        return "\n    - The requested linked library ".$packageName.$this->constraintToText($constraint).' '.$error;
+                    if (count($versions) > 1) {
+                        // remove the s from requires/conflicts to correct grammar
+                        $message = preg_replace('{^(%s%s (?:require|conflict))s}', '$1', $message);
+                        $result[] = sprintf($message, $package, '['.implode(', ', $versions).']');
+                    } else {
+                        $result[] = sprintf($message, $package, ' '.reset($versions));
                     }
-
-                    return "\n    - The requested linked library ".$packageName.$this->constraintToText($constraint).' has the wrong version installed or is missing from your system, make sure to load the extension providing it.';
-                }
-
-                if (!preg_match('{^[A-Za-z0-9_./-]+$}', $packageName)) {
-                    $illegalChars = preg_replace('{[A-Za-z0-9_./-]+}', '', $packageName);
-
-                    return "\n    - The requested package ".$packageName.' could not be found, it looks like its name is invalid, "'.$illegalChars.'" is not allowed in package names.';
-                }
-
-                if ($providers = $this->pool->whatProvides($packageName, $constraint, true, true)) {
-                    return "\n    - The requested package ".$packageName.$this->constraintToText($constraint).' is satisfiable by '.$this->getPackageList($providers).' but these conflict with your requirements or minimum-stability.';
-                }
-
-                if ($providers = $this->pool->whatProvides($packageName, null, true, true)) {
-                    return "\n    - The requested package ".$packageName.$this->constraintToText($constraint).' exists as '.$this->getPackageList($providers).' but these are rejected by your constraint.';
                 }
-
-                return "\n    - The requested package ".$packageName.' could not be found in any version, there may be a typo in the package name.';
+            } else {
+                $result[] = $message;
             }
         }
 
-        $messages = array();
-
-        foreach ($reasons as $reason) {
-            $rule = $reason['rule'];
-            $job = $reason['job'];
+        return "\n$indent- ".implode("\n$indent- ", $result);
+    }
 
-            if ($job) {
-                $messages[] = $this->jobToText($job);
-            } elseif ($rule) {
-                if ($rule instanceof Rule) {
-                    $messages[] = $rule->getPrettyString($this->pool, $installedMap);
+    public function isCausedByLock(RepositorySet $repositorySet, Request $request, Pool $pool)
+    {
+        foreach ($this->reasons as $sectionRules) {
+            foreach ($sectionRules as $rule) {
+                if ($rule->isCausedByLock($repositorySet, $request, $pool)) {
+                    return true;
                 }
             }
         }
-
-        return "\n    - ".implode("\n    - ", $messages);
     }
 
     /**
      * Store a reason descriptor but ignore duplicates
      *
      * @param string $id     A canonical identifier for the reason
-     * @param string $reason The reason descriptor
+     * @param Rule   $reason The reason descriptor
      */
-    protected function addReason($id, $reason)
+    protected function addReason($id, Rule $reason)
     {
+        // TODO: if a rule is part of a problem description in two sections, isn't this going to remove a message
+        // that is important to understand the issue?
+
         if (!isset($this->reasonSeen[$id])) {
             $this->reasonSeen[$id] = true;
             $this->reasons[$this->section][] = $reason;
@@ -198,46 +175,173 @@ class Problem
     }
 
     /**
-     * Turns a job into a human readable description
-     *
-     * @param  array  $job
-     * @return string
+     * @internal
      */
-    protected function jobToText($job)
+    public static function getMissingPackageReason(RepositorySet $repositorySet, Request $request, Pool $pool, $isVerbose, $packageName, $constraint = null)
     {
-        $packageName = $job['packageName'];
-        $constraint = $job['constraint'];
-        switch ($job['cmd']) {
-            case 'install':
-                $packages = $this->pool->whatProvides($packageName, $constraint);
-                if (!$packages) {
-                    return 'No package found to satisfy install request for '.$packageName.$this->constraintToText($constraint);
+        // handle php/hhvm
+        if ($packageName === 'php' || $packageName === 'php-64bit' || $packageName === 'hhvm') {
+            $version = phpversion();
+            $available = $pool->whatProvides($packageName);
+
+            if (count($available)) {
+                $firstAvailable = reset($available);
+                $version = $firstAvailable->getPrettyVersion();
+                $extra = $firstAvailable->getExtra();
+                if ($firstAvailable instanceof CompletePackageInterface && isset($extra['config.platform']) && $extra['config.platform'] === true) {
+                    $version .= '; ' . str_replace('Package ', '', $firstAvailable->getDescription());
                 }
+            }
 
-                return 'Installation request for '.$packageName.$this->constraintToText($constraint).' -> satisfiable by '.$this->getPackageList($packages).'.';
-            case 'update':
-                return 'Update request for '.$packageName.$this->constraintToText($constraint).'.';
-            case 'remove':
-                return 'Removal request for '.$packageName.$this->constraintToText($constraint).'';
+            $msg = "- Root composer.json requires ".$packageName.self::constraintToText($constraint).' but ';
+
+            if (defined('HHVM_VERSION') || (count($available) && $packageName === 'hhvm')) {
+                return array($msg, 'your HHVM version does not satisfy that requirement.');
+            }
+
+            if ($packageName === 'hhvm') {
+                return array($msg, 'you are running this with PHP and not HHVM.');
+            }
+
+            return array($msg, 'your '.$packageName.' version ('. $version .') does not satisfy that requirement.');
+        }
+
+        // handle php extensions
+        if (0 === stripos($packageName, 'ext-')) {
+            if (false !== strpos($packageName, ' ')) {
+                return array('- ', "PHP extension ".$packageName.' should be required as '.str_replace(' ', '-', $packageName).'.');
+            }
+
+            $ext = substr($packageName, 4);
+            $error = extension_loaded($ext) ? 'it has the wrong version ('.(phpversion($ext) ?: '0').') installed' : 'it is missing from your system';
+
+            return array("- Root composer.json requires PHP extension ".$packageName.self::constraintToText($constraint).' but ', $error.'. Install or enable PHP\'s '.$ext.' extension.');
         }
 
-        if (isset($constraint)) {
-            $packages = $this->pool->whatProvides($packageName, $constraint);
-        } else {
-            $packages = array();
+        // handle linked libs
+        if (0 === stripos($packageName, 'lib-')) {
+            if (strtolower($packageName) === 'lib-icu') {
+                $error = extension_loaded('intl') ? 'it has the wrong version installed, try upgrading the intl extension.' : 'it is missing from your system, make sure the intl extension is loaded.';
+
+                return array("- Root composer.json requires linked library ".$packageName.self::constraintToText($constraint).' but ', $error);
+            }
+
+            return array("- Root composer.json requires linked library ".$packageName.self::constraintToText($constraint).' but ', 'it has the wrong version installed or is missing from your system, make sure to load the extension providing it.');
+        }
+
+        $lockedPackage = null;
+        foreach ($request->getLockedPackages() as $package) {
+            if ($package->getName() === $packageName) {
+                $lockedPackage = $package;
+                if ($pool->isUnacceptableFixedOrLockedPackage($package)) {
+                    return array("- ", $package->getPrettyName().' is fixed to '.$package->getPrettyVersion().' (lock file version) by a partial update but that version is rejected by your minimum-stability. Make sure you list it as an argument for the update command.');
+                }
+                break;
+            }
         }
 
-        return 'Job(cmd='.$job['cmd'].', target='.$packageName.', packages=['.$this->getPackageList($packages).'])';
+        // first check if the actual requested package is found in normal conditions
+        // if so it must mean it is rejected by another constraint than the one given here
+        if ($packages = $repositorySet->findPackages($packageName, $constraint)) {
+            $rootReqs = $repositorySet->getRootRequires();
+            if (isset($rootReqs[$packageName])) {
+                $filtered = array_filter($packages, function ($p) use ($rootReqs, $packageName) {
+                    return $rootReqs[$packageName]->matches(new Constraint('==', $p->getVersion()));
+                });
+                if (0 === count($filtered)) {
+                    return array("- Root composer.json requires $packageName".self::constraintToText($constraint) . ', ', 'found '.self::getPackageList($packages, $isVerbose).' but '.(self::hasMultipleNames($packages) ? 'these conflict' : 'it conflicts').' with your root composer.json require ('.$rootReqs[$packageName]->getPrettyString().').');
+                }
+            }
+
+            if ($lockedPackage) {
+                $fixedConstraint = new Constraint('==', $lockedPackage->getVersion());
+                $filtered = array_filter($packages, function ($p) use ($fixedConstraint) {
+                    return $fixedConstraint->matches(new Constraint('==', $p->getVersion()));
+                });
+                if (0 === count($filtered)) {
+                    return array("- Root composer.json requires $packageName".self::constraintToText($constraint) . ', ', 'found '.self::getPackageList($packages, $isVerbose).' but the package is fixed to '.$lockedPackage->getPrettyVersion().' (lock file version) by a partial update and that version does not match. Make sure you list it as an argument for the update command.');
+                }
+            }
+
+            $nonLockedPackages = array_filter($packages, function ($p) {
+                return !$p->getRepository() instanceof LockArrayRepository;
+            });
+
+            if (!$nonLockedPackages) {
+                return array("- Root composer.json requires $packageName".self::constraintToText($constraint) . ', ', 'found '.self::getPackageList($packages, $isVerbose).' in lock file but not in remote repositories, make sure you avoid updating this package to keep the one from lock file.');
+            }
+
+            return array("- Root composer.json requires $packageName".self::constraintToText($constraint) . ', ', 'found '.self::getPackageList($packages, $isVerbose).' but these were not loaded, likely because '.(self::hasMultipleNames($packages) ? 'they conflict' : 'it conflicts').' with another require.');
+        }
+
+        // check if the package is found when bypassing stability checks
+        if ($packages = $repositorySet->findPackages($packageName, $constraint, RepositorySet::ALLOW_UNACCEPTABLE_STABILITIES)) {
+            // we must first verify if a valid package would be found in a lower priority repository
+            if ($allReposPackages = $repositorySet->findPackages($packageName, $constraint, RepositorySet::ALLOW_SHADOWED_REPOSITORIES)) {
+                return self::computeCheckForLowerPrioRepo($isVerbose, $packageName, $constraint, $packages, $allReposPackages, 'minimum-stability');
+            }
+
+            return array("- Root composer.json requires $packageName".self::constraintToText($constraint) . ', ', 'found '.self::getPackageList($packages, $isVerbose).' but '.(self::hasMultipleNames($packages) ? 'these do' : 'it does').' not match your minimum-stability.');
+        }
+
+        // check if the package is found when bypassing the constraint and stability checks
+        if ($packages = $repositorySet->findPackages($packageName, null, RepositorySet::ALLOW_UNACCEPTABLE_STABILITIES)) {
+            // we must first verify if a valid package would be found in a lower priority repository
+            if ($allReposPackages = $repositorySet->findPackages($packageName, $constraint, RepositorySet::ALLOW_SHADOWED_REPOSITORIES)) {
+                return self::computeCheckForLowerPrioRepo($isVerbose, $packageName, $constraint, $packages, $allReposPackages, 'constraint');
+            }
+
+            return array("- Root composer.json requires $packageName".self::constraintToText($constraint) . ', ', 'found '.self::getPackageList($packages, $isVerbose).' but '.(self::hasMultipleNames($packages) ? 'these do' : 'it does').' not match the constraint.');
+        }
+
+        if (!preg_match('{^[A-Za-z0-9_./-]+$}', $packageName)) {
+            $illegalChars = preg_replace('{[A-Za-z0-9_./-]+}', '', $packageName);
+
+            return array("- Root composer.json requires $packageName, it ", 'could not be found, it looks like its name is invalid, "'.$illegalChars.'" is not allowed in package names.');
+        }
+
+        if ($providers = $repositorySet->getProviders($packageName)) {
+            $maxProviders = 20;
+            $providersStr = implode(array_map(function ($p) {
+                $description = $p['description'] ? ' '.substr($p['description'], 0, 100) : '';
+
+                return "      - ${p['name']}".$description."\n";
+            }, count($providers) > $maxProviders + 1 ? array_slice($providers, 0, $maxProviders) : $providers));
+            if (count($providers) > $maxProviders + 1) {
+                $providersStr .= '      ... and '.(count($providers) - $maxProviders).' more.'."\n";
+            }
+
+            return array("- Root composer.json requires $packageName".self::constraintToText($constraint).", it ", "could not be found in any version, but the following packages provide it:\n".$providersStr."      Consider requiring one of these to satisfy the $packageName requirement.");
+        }
+
+        return array("- Root composer.json requires $packageName, it ", "could not be found in any version, there may be a typo in the package name.");
     }
 
-    protected function getPackageList($packages)
+    /**
+     * @internal
+     */
+    public static function getPackageList(array $packages, $isVerbose)
     {
         $prepared = array();
+        $hasDefaultBranch = array();
         foreach ($packages as $package) {
             $prepared[$package->getName()]['name'] = $package->getPrettyName();
-            $prepared[$package->getName()]['versions'][$package->getVersion()] = $package->getPrettyVersion();
+            $prepared[$package->getName()]['versions'][$package->getVersion()] = $package->getPrettyVersion().($package instanceof AliasPackage ? ' (alias of '.$package->getAliasOf()->getPrettyVersion().')' : '');
+            if ($package->isDefaultBranch()) {
+                $hasDefaultBranch[$package->getName()] = true;
+            }
         }
         foreach ($prepared as $name => $package) {
+            // remove the implicit default branch alias to avoid cruft in the display
+            if (isset($package['versions'][VersionParser::DEFAULT_BRANCH_ALIAS], $hasDefaultBranch[$name])) {
+                unset($package['versions'][VersionParser::DEFAULT_BRANCH_ALIAS]);
+            }
+
+            uksort($package['versions'], 'version_compare');
+
+            if (!$isVerbose) {
+                $package['versions'] = self::condenseVersionList($package['versions'], 4);
+            }
             $prepared[$name] = $package['name'].'['.implode(', ', $package['versions']).']';
         }
 
@@ -245,12 +349,71 @@ class Problem
     }
 
     /**
-     * Turns a constraint into text usable in a sentence describing a job
+     * @param  string[]     $versions an array of pretty versions, with normalized versions as keys
+     * @return list<string> a list of pretty versions and '...' where versions were removed
+     */
+    private static function condenseVersionList(array $versions, $max)
+    {
+        if (count($versions) <= $max) {
+            return $versions;
+        }
+
+        $filtered = array();
+        $byMajor = array();
+        foreach ($versions as $version => $pretty) {
+            $byMajor[preg_replace('{^(\d+)\..*}', '$1', $version)][] = $pretty;
+        }
+        foreach ($byMajor as $versionsForMajor) {
+            if (count($versionsForMajor) > $max) {
+                $filtered[] = $versionsForMajor[0];
+                $filtered[] = '...';
+                $filtered[] = $versionsForMajor[count($versionsForMajor) - 1];
+            } else {
+                $filtered = array_merge($filtered, $versionsForMajor);
+            }
+        }
+
+        return $filtered;
+    }
+
+    private static function hasMultipleNames(array $packages)
+    {
+        $name = null;
+        foreach ($packages as $package) {
+            if ($name === null || $name === $package->getName()) {
+                $name = $package->getName();
+            } else {
+                return true;
+            }
+        }
+
+        return false;
+    }
+
+    private static function computeCheckForLowerPrioRepo($isVerbose, $packageName, $constraint, array $higherRepoPackages, array $allReposPackages, $reason)
+    {
+        $nextRepoPackages = array();
+        $nextRepo = null;
+
+        foreach ($allReposPackages as $package) {
+            if ($nextRepo === null || $nextRepo === $package->getRepository()) {
+                $nextRepoPackages[] = $package;
+                $nextRepo = $package->getRepository();
+            } else {
+                break;
+            }
+        }
+
+        return array("- Root composer.json requires $packageName".self::constraintToText($constraint) . ', it is ', 'satisfiable by '.self::getPackageList($nextRepoPackages, $isVerbose).' from '.$nextRepo->getRepoName().' but '.self::getPackageList($higherRepoPackages, $isVerbose).' from '.reset($higherRepoPackages)->getRepository()->getRepoName().' has higher repository priority. The packages with higher priority do not match your '.$reason.' and are therefore not installable. See https://getcomposer.org/repoprio for details and assistance.');
+    }
+
+    /**
+     * Turns a constraint into text usable in a sentence describing a request
      *
      * @param  \Composer\Semver\Constraint\ConstraintInterface $constraint
      * @return string
      */
-    protected function constraintToText($constraint)
+    protected static function constraintToText($constraint)
     {
         return $constraint ? ' '.$constraint->getPrettyString() : '';
     }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Request.php 2.0.9-1/src/Composer/DependencyResolver/Request.php
--- 1.10.19-1/src/Composer/DependencyResolver/Request.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Request.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,67 +12,187 @@
 
 namespace Composer\DependencyResolver;
 
+use Composer\Package\Package;
+use Composer\Package\PackageInterface;
+use Composer\Repository\LockArrayRepository;
 use Composer\Semver\Constraint\ConstraintInterface;
+use Composer\Semver\Constraint\MatchAllConstraint;
 
 /**
  * @author Nils Adermann <naderman@naderman.de>
  */
 class Request
 {
-    protected $jobs;
+    /**
+     * Identifies a partial update for listed packages only, all dependencies will remain at locked versions
+     */
+    const UPDATE_ONLY_LISTED = 0;
+
+    /**
+     * Identifies a partial update for listed packages and recursively all their dependencies, however dependencies
+     * also directly required by the root composer.json and their dependencies will remain at the locked version.
+     */
+    const UPDATE_LISTED_WITH_TRANSITIVE_DEPS_NO_ROOT_REQUIRE = 1;
+
+    /**
+     * Identifies a partial update for listed packages and recursively all their dependencies, even dependencies
+     * also directly required by the root composer.json will be updated.
+     */
+    const UPDATE_LISTED_WITH_TRANSITIVE_DEPS = 2;
 
-    public function __construct()
+    protected $lockedRepository;
+    protected $requires = array();
+    protected $fixedPackages = array();
+    protected $lockedPackages = array();
+    protected $fixedLockedPackages = array();
+    protected $updateAllowList = array();
+    protected $updateAllowTransitiveDependencies = false;
+
+    public function __construct(LockArrayRepository $lockedRepository = null)
     {
-        $this->jobs = array();
+        $this->lockedRepository = $lockedRepository;
     }
 
-    public function install($packageName, ConstraintInterface $constraint = null)
+    public function requireName($packageName, ConstraintInterface $constraint = null)
     {
-        $this->addJob($packageName, 'install', $constraint);
+        $packageName = strtolower($packageName);
+
+        if ($constraint === null) {
+            $constraint = new MatchAllConstraint();
+        }
+        if (isset($this->requires[$packageName])) {
+            throw new \LogicException('Overwriting requires seems like a bug ('.$packageName.' '.$this->requires[$packageName]->getPrettyString().' => '.$constraint->getPrettyString().', check why it is happening, might be a root alias');
+        }
+        $this->requires[$packageName] = $constraint;
     }
 
-    public function update($packageName, ConstraintInterface $constraint = null)
+    /**
+     * Mark a package as currently present and having to remain installed
+     *
+     * This is used for platform packages which cannot be modified by Composer. A rule enforcing their installation is
+     * generated for dependency resolution. Partial updates with dependencies cannot in any way modify these packages.
+     */
+    public function fixPackage(PackageInterface $package)
     {
-        $this->addJob($packageName, 'update', $constraint);
+        $this->fixedPackages[spl_object_hash($package)] = $package;
     }
 
-    public function remove($packageName, ConstraintInterface $constraint = null)
+    /**
+     * Mark a package as locked to a specific version but removable
+     *
+     * This is used for lock file packages which need to be treated similar to fixed packages by the pool builder in
+     * that by default they should really only have the currently present version loaded and no remote alternatives.
+     *
+     * However unlike fixed packages there will not be a special rule enforcing their installation for the solver, so
+     * if nothing requires these packages they will be removed. Additionally in a partial update these packages can be
+     * unlocked, meaning other versions can be installed if explicitly requested as part of the update.
+     */
+    public function lockPackage(PackageInterface $package)
     {
-        $this->addJob($packageName, 'remove', $constraint);
+        $this->lockedPackages[spl_object_hash($package)] = $package;
     }
 
     /**
-     * Mark an existing package as being installed and having to remain installed
-     *
-     * These jobs will not be tempered with by the solver
+     * Marks a locked package fixed. So it's treated irremovable like a platform package.
      *
-     * @param string                   $packageName
-     * @param ConstraintInterface|null $constraint
+     * This is necessary for the composer install step which verifies the lock file integrity and should not allow
+     * removal of any packages. At the same time lock packages there cannot simply be marked fixed, as error reporting
+     * would then report them as platform packages, so this still marks them as locked packages at the same time.
      */
-    public function fix($packageName, ConstraintInterface $constraint = null)
+    public function fixLockedPackage(PackageInterface $package)
     {
-        $this->addJob($packageName, 'install', $constraint, true);
+        $this->fixedPackages[spl_object_hash($package)] = $package;
+        $this->fixedLockedPackages[spl_object_hash($package)] = $package;
     }
 
-    protected function addJob($packageName, $cmd, ConstraintInterface $constraint = null, $fixed = false)
+    public function unlockPackage(PackageInterface $package)
     {
-        $packageName = strtolower($packageName);
+        unset($this->lockedPackages[spl_object_hash($package)]);
+    }
+
+    public function setUpdateAllowList($updateAllowList, $updateAllowTransitiveDependencies)
+    {
+        $this->updateAllowList = $updateAllowList;
+        $this->updateAllowTransitiveDependencies = $updateAllowTransitiveDependencies;
+    }
 
-        $this->jobs[] = array(
-            'cmd' => $cmd,
-            'packageName' => $packageName,
-            'constraint' => $constraint,
-            'fixed' => $fixed,
-        );
+    public function getUpdateAllowList()
+    {
+        return $this->updateAllowList;
     }
 
-    public function updateAll()
+    public function getUpdateAllowTransitiveDependencies()
     {
-        $this->jobs[] = array('cmd' => 'update-all');
+        return $this->updateAllowTransitiveDependencies !== self::UPDATE_ONLY_LISTED;
+    }
+
+    public function getUpdateAllowTransitiveRootDependencies()
+    {
+        return $this->updateAllowTransitiveDependencies === self::UPDATE_LISTED_WITH_TRANSITIVE_DEPS;
+    }
+
+    public function getRequires()
+    {
+        return $this->requires;
+    }
+
+    public function getFixedPackages()
+    {
+        return $this->fixedPackages;
+    }
+
+    public function isFixedPackage(PackageInterface $package)
+    {
+        return isset($this->fixedPackages[spl_object_hash($package)]);
+    }
+
+    public function getLockedPackages()
+    {
+        return $this->lockedPackages;
+    }
+
+    public function isLockedPackage(PackageInterface $package)
+    {
+        return isset($this->lockedPackages[spl_object_hash($package)]) || isset($this->fixedLockedPackages[spl_object_hash($package)]);
+    }
+
+    public function getFixedOrLockedPackages()
+    {
+        return array_merge($this->fixedPackages, $this->lockedPackages);
+    }
+
+    // TODO look into removing the packageIds option, the only place true is used is for the installed map in the solver problems
+    // some locked packages may not be in the pool so they have a package->id of -1
+    public function getPresentMap($packageIds = false)
+    {
+        $presentMap = array();
+
+        if ($this->lockedRepository) {
+            foreach ($this->lockedRepository->getPackages() as $package) {
+                $presentMap[$packageIds ? $package->id : spl_object_hash($package)] = $package;
+            }
+        }
+
+        foreach ($this->fixedPackages as $package) {
+            $presentMap[$packageIds ? $package->id : spl_object_hash($package)] = $package;
+        }
+
+        return $presentMap;
+    }
+
+    public function getFixedPackagesMap()
+    {
+        $fixedPackagesMap = array();
+
+        foreach ($this->fixedPackages as $package) {
+            $fixedPackagesMap[$package->id] = $package;
+        }
+
+        return $fixedPackagesMap;
     }
 
-    public function getJobs()
+    public function getLockedRepository()
     {
-        return $this->jobs;
+        return $this->lockedRepository;
     }
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Rule2Literals.php 2.0.9-1/src/Composer/DependencyResolver/Rule2Literals.php
--- 1.10.19-1/src/Composer/DependencyResolver/Rule2Literals.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Rule2Literals.php	2021-01-27 15:09:27.000000000 +0000
@@ -28,11 +28,10 @@ class Rule2Literals extends Rule
      * @param int                   $literal2
      * @param int                   $reason     A RULE_* constant describing the reason for generating this rule
      * @param Link|PackageInterface $reasonData
-     * @param array                 $job        The job this rule was created from
      */
-    public function __construct($literal1, $literal2, $reason, $reasonData, $job = null)
+    public function __construct($literal1, $literal2, $reason, $reasonData)
     {
-        parent::__construct($reason, $reasonData, $job);
+        parent::__construct($reason, $reasonData);
 
         if ($literal1 < $literal2) {
             $this->literal1 = $literal1;
@@ -77,7 +76,7 @@ class Rule2Literals extends Rule
         }
 
         $literals = $rule->getLiterals();
-        if (2 != count($literals)) {
+        if (2 != \count($literals)) {
             return false;
         }
 
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Rule.php 2.0.9-1/src/Composer/DependencyResolver/Rule.php
--- 1.10.19-1/src/Composer/DependencyResolver/Rule.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Rule.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,9 +12,13 @@
 
 namespace Composer\DependencyResolver;
 
-use Composer\Package\CompletePackage;
 use Composer\Package\Link;
 use Composer\Package\PackageInterface;
+use Composer\Package\AliasPackage;
+use Composer\Repository\RepositorySet;
+use Composer\Repository\PlatformRepository;
+use Composer\Package\Version\VersionParser;
+use Composer\Semver\Constraint\Constraint;
 
 /**
  * @author Nils Adermann <naderman@naderman.de>
@@ -23,17 +27,14 @@ use Composer\Package\PackageInterface;
 abstract class Rule
 {
     // reason constants
-    const RULE_INTERNAL_ALLOW_UPDATE = 1;
-    const RULE_JOB_INSTALL = 2;
-    const RULE_JOB_REMOVE = 3;
+    const RULE_ROOT_REQUIRE = 2;
+    const RULE_FIXED = 3;
     const RULE_PACKAGE_CONFLICT = 6;
     const RULE_PACKAGE_REQUIRES = 7;
-    const RULE_PACKAGE_OBSOLETES = 8;
-    const RULE_INSTALLED_PACKAGE_OBSOLETES = 9;
     const RULE_PACKAGE_SAME_NAME = 10;
-    const RULE_PACKAGE_IMPLICIT_OBSOLETES = 11;
     const RULE_LEARNED = 12;
     const RULE_PACKAGE_ALIAS = 13;
+    const RULE_PACKAGE_INVERSE_ALIAS = 14;
 
     // bitfield defs
     const BITFIELD_TYPE = 0;
@@ -41,22 +42,17 @@ abstract class Rule
     const BITFIELD_DISABLED = 16;
 
     protected $bitfield;
-    protected $job;
+    protected $request;
     protected $reasonData;
 
     /**
      * @param int                   $reason     A RULE_* constant describing the reason for generating this rule
      * @param Link|PackageInterface $reasonData
-     * @param array                 $job        The job this rule was created from
      */
-    public function __construct($reason, $reasonData, $job = null)
+    public function __construct($reason, $reasonData)
     {
         $this->reasonData = $reasonData;
 
-        if ($job) {
-            $this->job = $job;
-        }
-
         $this->bitfield = (0 << self::BITFIELD_DISABLED) |
             ($reason << self::BITFIELD_REASON) |
             (255 << self::BITFIELD_TYPE);
@@ -66,11 +62,6 @@ abstract class Rule
 
     abstract public function getHash();
 
-    public function getJob()
-    {
-        return $this->job;
-    }
-
     abstract public function equals(Rule $rule);
 
     public function getReason()
@@ -85,11 +76,17 @@ abstract class Rule
 
     public function getRequiredPackage()
     {
-        if ($this->getReason() === self::RULE_JOB_INSTALL) {
-            return $this->reasonData;
+        $reason = $this->getReason();
+
+        if ($reason === self::RULE_ROOT_REQUIRE) {
+            return $this->reasonData['packageName'];
         }
 
-        if ($this->getReason() === self::RULE_PACKAGE_REQUIRES) {
+        if ($reason === self::RULE_FIXED) {
+            return $this->reasonData['package']->getName();
+        }
+
+        if ($reason === self::RULE_PACKAGE_REQUIRES) {
             return $this->reasonData->getTarget();
         }
     }
@@ -126,37 +123,97 @@ abstract class Rule
 
     abstract public function isAssertion();
 
-    public function getPrettyString(Pool $pool, array $installedMap = array())
+    public function isCausedByLock(RepositorySet $repositorySet, Request $request, Pool $pool)
     {
-        $literals = $this->getLiterals();
+        if ($this->getReason() === self::RULE_PACKAGE_REQUIRES) {
+            if (PlatformRepository::isPlatformPackage($this->reasonData->getTarget())) {
+                return false;
+            }
+            if ($request->getLockedRepository()) {
+                foreach ($request->getLockedRepository()->getPackages() as $package) {
+                    if ($package->getName() === $this->reasonData->getTarget()) {
+                        if ($pool->isUnacceptableFixedOrLockedPackage($package)) {
+                            return true;
+                        }
+                        if (!$this->reasonData->getConstraint()->matches(new Constraint('=', $package->getVersion()))) {
+                            return true;
+                        }
+                        // required package was locked but has been unlocked and still matches
+                        if (!$request->isLockedPackage($package)) {
+                            return true;
+                        }
+                        break;
+                    }
+                }
+            }
+        }
 
-        $ruleText = '';
-        foreach ($literals as $i => $literal) {
-            if ($i != 0) {
-                $ruleText .= '|';
+        if ($this->getReason() === self::RULE_ROOT_REQUIRE) {
+            if (PlatformRepository::isPlatformPackage($this->reasonData['packageName'])) {
+                return false;
+            }
+            if ($request->getLockedRepository()) {
+                foreach ($request->getLockedRepository()->getPackages() as $package) {
+                    if ($package->getName() === $this->reasonData['packageName']) {
+                        if ($pool->isUnacceptableFixedOrLockedPackage($package)) {
+                            return true;
+                        }
+                        if (!$this->reasonData['constraint']->matches(new Constraint('=', $package->getVersion()))) {
+                            return true;
+                        }
+                        break;
+                    }
+                }
             }
-            $ruleText .= $pool->literalToPrettyString($literal, $installedMap);
         }
 
+        return false;
+    }
+
+    public function getPrettyString(RepositorySet $repositorySet, Request $request, Pool $pool, $isVerbose, array $installedMap = array(), array $learnedPool = array())
+    {
+        $literals = $this->getLiterals();
+
         switch ($this->getReason()) {
-            case self::RULE_INTERNAL_ALLOW_UPDATE:
-                return $ruleText;
+            case self::RULE_ROOT_REQUIRE:
+                $packageName = $this->reasonData['packageName'];
+                $constraint = $this->reasonData['constraint'];
+
+                $packages = $pool->whatProvides($packageName, $constraint);
+                if (!$packages) {
+                    return 'No package found to satisfy root composer.json require '.$packageName.($constraint ? ' '.$constraint->getPrettyString() : '');
+                }
 
-            case self::RULE_JOB_INSTALL:
-                return "Install command rule ($ruleText)";
+                $packagesNonAlias = array_values(array_filter($packages, function ($p) {
+                    return !($p instanceof AliasPackage);
+                }));
+                if (count($packagesNonAlias) === 1) {
+                    $package = $packagesNonAlias[0];
+                    if ($request->isLockedPackage($package)) {
+                        return $package->getPrettyName().' is locked to version '.$package->getPrettyVersion()." and an update of this package was not requested.";
+                    }
+                }
+
+                return 'Root composer.json requires '.$packageName.($constraint ? ' '.$constraint->getPrettyString() : '').' -> satisfiable by '.$this->formatPackagesUnique($pool, $packages, $isVerbose).'.';
+
+            case self::RULE_FIXED:
+                $package = $this->deduplicateDefaultBranchAlias($this->reasonData['package']);
+
+                if ($request->isLockedPackage($package)) {
+                    return $package->getPrettyName().' is locked to version '.$package->getPrettyVersion().' and an update of this package was not requested.';
+                }
 
-            case self::RULE_JOB_REMOVE:
-                return "Remove command rule ($ruleText)";
+                return $package->getPrettyName().' is present at version '.$package->getPrettyVersion() . ' and cannot be modified by Composer';
 
             case self::RULE_PACKAGE_CONFLICT:
-                $package1 = $pool->literalToPackage($literals[0]);
-                $package2 = $pool->literalToPackage($literals[1]);
+                $package1 = $this->deduplicateDefaultBranchAlias($pool->literalToPackage($literals[0]));
+                $package2 = $this->deduplicateDefaultBranchAlias($pool->literalToPackage($literals[1]));
 
-                return $package1->getPrettyString().' conflicts with '.$this->formatPackagesUnique($pool, array($package2)).'.';
+                return $package2->getPrettyString().' conflicts with '.$package1->getPrettyString().'.';
 
             case self::RULE_PACKAGE_REQUIRES:
                 $sourceLiteral = array_shift($literals);
-                $sourcePackage = $pool->literalToPackage($sourceLiteral);
+                $sourcePackage = $this->deduplicateDefaultBranchAlias($pool->literalToPackage($sourceLiteral));
 
                 $requires = array();
                 foreach ($literals as $literal) {
@@ -165,80 +222,124 @@ abstract class Rule
 
                 $text = $this->reasonData->getPrettyString($sourcePackage);
                 if ($requires) {
-                    $text .= ' -> satisfiable by ' . $this->formatPackagesUnique($pool, $requires) . '.';
+                    $text .= ' -> satisfiable by ' . $this->formatPackagesUnique($pool, $requires, $isVerbose) . '.';
                 } else {
                     $targetName = $this->reasonData->getTarget();
 
-                    if ($targetName === 'php' || $targetName === 'php-64bit' || $targetName === 'hhvm') {
-                        // handle php/hhvm
-                        if (defined('HHVM_VERSION')) {
-                            return $text . ' -> your HHVM version does not satisfy that requirement.';
-                        }
+                    $reason = Problem::getMissingPackageReason($repositorySet, $request, $pool, $isVerbose, $targetName, $this->reasonData->getConstraint());
 
-                        $packages = $pool->whatProvides($targetName);
-                        $package = count($packages) ? current($packages) : phpversion();
+                    return $text . ' -> ' . $reason[1];
+                }
 
-                        if ($targetName === 'hhvm') {
-                            if ($package instanceof CompletePackage) {
-                                return $text . ' -> your HHVM version ('.$package->getPrettyVersion().') does not satisfy that requirement.';
-                            } else {
-                                return $text . ' -> you are running this with PHP and not HHVM.';
-                            }
-                        }
+                return $text;
 
+            case self::RULE_PACKAGE_SAME_NAME:
+                $packageNames = array();
+                foreach ($literals as $literal) {
+                    $package = $pool->literalToPackage($literal);
+                    $packageNames[$package->getName()] = true;
+                }
+                $replacedName = $this->reasonData;
 
-                        if (!($package instanceof CompletePackage)) {
-                            return $text . ' -> your PHP version ('.phpversion().') does not satisfy that requirement.';
-                        }
+                if (count($packageNames) > 1) {
+                    $reason = null;
 
-                        $extra = $package->getExtra();
+                    if (!isset($packageNames[$replacedName])) {
+                        $reason = 'They '.(count($literals) == 2 ? 'both' : 'all').' replace '.$replacedName.' and thus cannot coexist.';
+                    } else {
+                        $replacerNames = $packageNames;
+                        unset($replacerNames[$replacedName]);
+                        $replacerNames = array_keys($replacerNames);
 
-                        if (!empty($extra['config.platform'])) {
-                            $text .= ' -> your PHP version ('.phpversion().') overridden by "config.platform.php" version ('.$package->getPrettyVersion().') does not satisfy that requirement.';
+                        if (count($replacerNames) == 1) {
+                            $reason = $replacerNames[0] . ' replaces ';
                         } else {
-                            $text .= ' -> your PHP version ('.$package->getPrettyVersion().') does not satisfy that requirement.';
+                            $reason = '['.implode(', ', $replacerNames).'] replace ';
                         }
-
-                        return $text;
+                        $reason .= $replacedName.' and thus cannot coexist with it.';
                     }
 
-                    if (0 === strpos($targetName, 'ext-')) {
-                        // handle php extensions
-                        $ext = substr($targetName, 4);
-                        $error = extension_loaded($ext) ? 'has the wrong version ('.(phpversion($ext) ?: '0').') installed' : 'is missing from your system';
+                    $installedPackages = array();
+                    $removablePackages = array();
+                    foreach ($literals as $literal) {
+                        if (isset($installedMap[abs($literal)])) {
+                            $installedPackages[] = $pool->literalToPackage($literal);
+                        } else {
+                            $removablePackages[] = $pool->literalToPackage($literal);
+                        }
+                    }
 
-                        return $text . ' -> the requested PHP extension '.$ext.' '.$error.'.';
+                    if ($installedPackages && $removablePackages) {
+                        return $this->formatPackagesUnique($pool, $removablePackages, $isVerbose).' cannot be installed as that would require removing '.$this->formatPackagesUnique($pool, $installedPackages, $isVerbose).'. '.$reason;
                     }
 
-                    if (0 === strpos($targetName, 'lib-')) {
-                        // handle linked libs
-                        $lib = substr($targetName, 4);
+                    return 'Only one of these can be installed: '.$this->formatPackagesUnique($pool, $literals, $isVerbose).'. '.$reason;
+                }
 
-                        return $text . ' -> the requested linked library '.$lib.' has the wrong version installed or is missing from your system, make sure to have the extension providing it.';
-                    }
+                return 'You can only install one version of a package, so only one of these can be installed: ' . $this->formatPackagesUnique($pool, $literals, $isVerbose) . '.';
+            case self::RULE_LEARNED:
+                /** @TODO currently still generates way too much output to be helpful, and in some cases can even lead to endless recursion */
+                // if (isset($learnedPool[$this->reasonData])) {
+                //     echo $this->reasonData."\n";
+                //     $learnedString = ', learned rules:' . Problem::formatDeduplicatedRules($learnedPool[$this->reasonData], '        ', $repositorySet, $request, $pool, $isVerbose, $installedMap, $learnedPool);
+                // } else {
+                //     $learnedString = ' (reasoning unavailable)';
+                // }
+                $learnedString = ' (conflict analysis result)';
+
+                if (count($literals) === 1) {
+                    $ruleText = $pool->literalToPrettyString($literals[0], $installedMap);
+                } else {
+                    $groups = array();
+                    foreach ($literals as $literal) {
+                        $package = $pool->literalToPackage($literal);
+                        if (isset($installedMap[$package->id])) {
+                            $group = $literal > 0 ? 'keep' : 'remove';
+                        } else {
+                            $group = $literal > 0 ? 'install' : 'don\'t install';
+                        }
 
-                    if ($providers = $pool->whatProvides($targetName, $this->reasonData->getConstraint(), true, true)) {
-                        return $text . ' -> satisfiable by ' . $this->formatPackagesUnique($pool, $providers) .' but these conflict with your requirements or minimum-stability.';
+                        $groups[$group][] = $this->deduplicateDefaultBranchAlias($package);
+                    }
+                    $ruleTexts = array();
+                    foreach ($groups as $group => $packages) {
+                        $ruleTexts[] = $group . (count($packages) > 1 ? ' one of' : '').' ' . $this->formatPackagesUnique($pool, $packages, $isVerbose);
                     }
 
-                    return $text . ' -> no matching package found.';
+                    $ruleText = implode(' | ', $ruleTexts);
                 }
 
-                return $text;
-
-            case self::RULE_PACKAGE_OBSOLETES:
-                return $ruleText;
-            case self::RULE_INSTALLED_PACKAGE_OBSOLETES:
-                return $ruleText;
-            case self::RULE_PACKAGE_SAME_NAME:
-                return 'Can only install one of: ' . $this->formatPackagesUnique($pool, $literals) . '.';
-            case self::RULE_PACKAGE_IMPLICIT_OBSOLETES:
-                return $ruleText;
-            case self::RULE_LEARNED:
-                return 'Conclusion: '.$ruleText;
+                return 'Conclusion: '.$ruleText.$learnedString;
             case self::RULE_PACKAGE_ALIAS:
-                return $ruleText;
+                $aliasPackage = $pool->literalToPackage($literals[0]);
+
+                // avoid returning content like "9999999-dev is an alias of dev-master" as it is useless
+                if ($aliasPackage->getVersion() === VersionParser::DEFAULT_BRANCH_ALIAS) {
+                    return '';
+                }
+                $package = $this->deduplicateDefaultBranchAlias($pool->literalToPackage($literals[1]));
+
+                return $aliasPackage->getPrettyString() .' is an alias of '.$package->getPrettyString().' and thus requires it to be installed too.';
+            case self::RULE_PACKAGE_INVERSE_ALIAS:
+                // inverse alias rules work the other way around than above
+                $aliasPackage = $pool->literalToPackage($literals[1]);
+
+                // avoid returning content like "9999999-dev is an alias of dev-master" as it is useless
+                if ($aliasPackage->getVersion() === VersionParser::DEFAULT_BRANCH_ALIAS) {
+                    return '';
+                }
+                $package = $this->deduplicateDefaultBranchAlias($pool->literalToPackage($literals[0]));
+
+                return $aliasPackage->getPrettyString() .' is an alias of '.$package->getPrettyString().' and must be installed with it.';
             default:
+                $ruleText = '';
+                foreach ($literals as $i => $literal) {
+                    if ($i != 0) {
+                        $ruleText .= '|';
+                    }
+                    $ruleText .= $pool->literalToPrettyString($literal, $installedMap);
+                }
+
                 return '('.$ruleText.')';
         }
     }
@@ -249,20 +350,23 @@ abstract class Rule
      *
      * @return string
      */
-    protected function formatPackagesUnique($pool, array $packages)
+    protected function formatPackagesUnique($pool, array $packages, $isVerbose)
     {
-        $prepared = array();
-        foreach ($packages as $package) {
-            if (!is_object($package)) {
-                $package = $pool->literalToPackage($package);
+        foreach ($packages as $index => $package) {
+            if (!\is_object($package)) {
+                $packages[$index] = $pool->literalToPackage($package);
             }
-            $prepared[$package->getName()]['name'] = $package->getPrettyName();
-            $prepared[$package->getName()]['versions'][$package->getVersion()] = $package->getPrettyVersion();
         }
-        foreach ($prepared as $name => $package) {
-            $prepared[$name] = $package['name'].'['.implode(', ', $package['versions']).']';
+
+        return Problem::getPackageList($packages, $isVerbose);
+    }
+
+    private function deduplicateDefaultBranchAlias(PackageInterface $package)
+    {
+        if ($package instanceof AliasPackage && $package->getPrettyVersion() === VersionParser::DEFAULT_BRANCH_ALIAS) {
+            $package = $package->getAliasOf();
         }
 
-        return implode(', ', $prepared);
+        return $package;
     }
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/RuleSetGenerator.php 2.0.9-1/src/Composer/DependencyResolver/RuleSetGenerator.php
--- 1.10.19-1/src/Composer/DependencyResolver/RuleSetGenerator.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/RuleSetGenerator.php	2021-01-27 15:09:27.000000000 +0000
@@ -24,13 +24,10 @@ class RuleSetGenerator
     protected $policy;
     protected $pool;
     protected $rules;
-    protected $jobs;
-    protected $installedMap;
-    protected $allowListedMap;
     protected $addedMap;
     protected $conflictAddedMap;
-    protected $addedPackages;
     protected $addedPackagesByNames;
+    protected $conflictsForName;
 
     public function __construct(PolicyInterface $policy, Pool $pool)
     {
@@ -50,7 +47,7 @@ class RuleSetGenerator
      *                                      reason for generating this rule
      * @param  mixed            $reasonData Any data, e.g. the requirement name,
      *                                      that goes with the reason
-     * @return Rule|null             The generated rule or null if tautological
+     * @return Rule|null        The generated rule or null if tautological
      */
     protected function createRequireRule(PackageInterface $package, array $providers, $reason, $reasonData = null)
     {
@@ -73,36 +70,20 @@ class RuleSetGenerator
      * The rule is (A|B|C) with A, B and C different packages. If the given
      * set of packages is empty an impossible rule is generated.
      *
-     * @param  array $packages The set of packages to choose from
-     * @param  int   $reason   A RULE_* constant describing the reason for
-     *                         generating this rule
-     * @param  array $job      The job this rule was created from
+     * @param  array $packages   The set of packages to choose from
+     * @param  int   $reason     A RULE_* constant describing the reason for
+     *                           generating this rule
+     * @param  array $reasonData Additional data like the root require or fix request info
      * @return Rule  The generated rule
      */
-    protected function createInstallOneOfRule(array $packages, $reason, $job)
+    protected function createInstallOneOfRule(array $packages, $reason, $reasonData)
     {
         $literals = array();
         foreach ($packages as $package) {
             $literals[] = $package->id;
         }
 
-        return new GenericRule($literals, $reason, $job['packageName'], $job);
-    }
-
-    /**
-     * Creates a rule to remove a package
-     *
-     * The rule for a package A is (-A).
-     *
-     * @param  PackageInterface $package The package to be removed
-     * @param  int              $reason  A RULE_* constant describing the
-     *                                   reason for generating this rule
-     * @param  array            $job     The job this rule was created from
-     * @return Rule             The generated rule
-     */
-    protected function createRemoveRule(PackageInterface $package, $reason, $job)
-    {
-        return new GenericRule(array(-$package->id), $reason, $job['packageName'], $job);
+        return new GenericRule($literals, $reason, $reasonData);
     }
 
     /**
@@ -117,7 +98,7 @@ class RuleSetGenerator
      *                                      reason for generating this rule
      * @param  mixed            $reasonData Any data, e.g. the package name, that
      *                                      goes with the reason
-     * @return Rule|null             The generated rule
+     * @return Rule|null        The generated rule
      */
     protected function createRule2Literals(PackageInterface $issuer, PackageInterface $provider, $reason, $reasonData = null)
     {
@@ -129,6 +110,20 @@ class RuleSetGenerator
         return new Rule2Literals(-$issuer->id, -$provider->id, $reason, $reasonData);
     }
 
+    protected function createMultiConflictRule(array $packages, $reason, $reasonData = null)
+    {
+        $literals = array();
+        foreach ($packages as $package) {
+            $literals[] = -$package->id;
+        }
+
+        if (\count($literals) == 2) {
+            return new Rule2Literals($literals[0], $literals[1], $reason, $reasonData);
+        }
+
+        return new MultiConflictRule($literals, $reason, $reasonData);
+    }
+
     /**
      * Adds a rule unless it duplicates an existing one of any type
      *
@@ -147,50 +142,6 @@ class RuleSetGenerator
         $this->rules->add($newRule, $type);
     }
 
-    protected function allowListFromPackage(PackageInterface $package)
-    {
-        // call original method for BC
-        $this->whitelistFromPackage($package);
-    }
-
-    /**
-     * @deprecated use whitelistFromPackage instead
-     */
-    protected function whitelistFromPackage(PackageInterface $package)
-    {
-        $workQueue = new \SplQueue;
-        $workQueue->enqueue($package);
-
-        while (!$workQueue->isEmpty()) {
-            $package = $workQueue->dequeue();
-            if (isset($this->allowListedMap[$package->id])) {
-                continue;
-            }
-
-            $this->allowListedMap[$package->id] = true;
-
-            foreach ($package->getRequires() as $link) {
-                $possibleRequires = $this->pool->whatProvides($link->getTarget(), $link->getConstraint(), true);
-
-                foreach ($possibleRequires as $require) {
-                    $workQueue->enqueue($require);
-                }
-            }
-
-            $obsoleteProviders = $this->pool->whatProvides($package->getName(), null, true);
-
-            foreach ($obsoleteProviders as $provider) {
-                if ($provider === $package) {
-                    continue;
-                }
-
-                if (($package instanceof AliasPackage) && $package->getAliasOf() === $provider) {
-                    $workQueue->enqueue($provider);
-                }
-            }
-        }
-    }
-
     protected function addRulesForPackage(PackageInterface $package, $ignorePlatformReqs)
     {
         $workQueue = new \SplQueue;
@@ -203,15 +154,28 @@ class RuleSetGenerator
                 continue;
             }
 
-            $this->addedMap[$package->id] = true;
+            $this->addedMap[$package->id] = $package;
 
-            $this->addedPackages[] = $package;
-            foreach ($package->getNames() as $name) {
-                $this->addedPackagesByNames[$name][] = $package;
+            if (!$package instanceof AliasPackage) {
+                foreach ($package->getNames(false) as $name) {
+                    $this->addedPackagesByNames[$name][] = $package;
+                }
+            } else {
+                $workQueue->enqueue($package->getAliasOf());
+                $this->addRule(RuleSet::TYPE_PACKAGE, $this->createRequireRule($package, array($package->getAliasOf()), Rule::RULE_PACKAGE_ALIAS, $package));
+
+                // aliases must be installed with their main package, so create a rule the other way around as well
+                $this->addRule(RuleSet::TYPE_PACKAGE, $this->createRequireRule($package->getAliasOf(), array($package), Rule::RULE_PACKAGE_INVERSE_ALIAS, $package->getAliasOf()));
+
+                // if alias package has no self.version requires, its requirements do not
+                // need to be added as the aliased package processing will take care of it
+                if (!$package->hasSelfVersionRequires()) {
+                    continue;
+                }
             }
 
             foreach ($package->getRequires() as $link) {
-                if ($ignorePlatformReqs && preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $link->getTarget())) {
+                if ((true === $ignorePlatformReqs || (is_array($ignorePlatformReqs) && in_array($link->getTarget(), $ignorePlatformReqs, true))) && PlatformRepository::isPlatformPackage($link->getTarget())) {
                     continue;
                 }
 
@@ -223,171 +187,120 @@ class RuleSetGenerator
                     $workQueue->enqueue($require);
                 }
             }
-
-            $packageName = $package->getName();
-            $obsoleteProviders = $this->pool->whatProvides($packageName, null);
-
-            foreach ($obsoleteProviders as $provider) {
-                if ($provider === $package) {
-                    continue;
-                }
-
-                if (($package instanceof AliasPackage) && $package->getAliasOf() === $provider) {
-                    $this->addRule(RuleSet::TYPE_PACKAGE, $this->createRequireRule($package, array($provider), Rule::RULE_PACKAGE_ALIAS, $package));
-                } elseif (!$this->obsoleteImpossibleForAlias($package, $provider)) {
-                    $reason = ($packageName == $provider->getName()) ? Rule::RULE_PACKAGE_SAME_NAME : Rule::RULE_PACKAGE_IMPLICIT_OBSOLETES;
-                    $this->addRule(RuleSet::TYPE_PACKAGE, $this->createRule2Literals($package, $provider, $reason, $package));
-                }
-            }
         }
     }
 
     protected function addConflictRules($ignorePlatformReqs = false)
     {
         /** @var PackageInterface $package */
-        foreach ($this->addedPackages as $package) {
+        foreach ($this->addedMap as $package) {
             foreach ($package->getConflicts() as $link) {
+                // even if conlict ends up being with an alias, there would be at least one actual package by this name
                 if (!isset($this->addedPackagesByNames[$link->getTarget()])) {
                     continue;
                 }
 
-                if ($ignorePlatformReqs && preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $link->getTarget())) {
+                if ((true === $ignorePlatformReqs || (is_array($ignorePlatformReqs) && in_array($link->getTarget(), $ignorePlatformReqs, true))) && PlatformRepository::isPlatformPackage($link->getTarget())) {
                     continue;
                 }
 
-                /** @var PackageInterface $possibleConflict */
-                foreach ($this->addedPackagesByNames[$link->getTarget()] as $possibleConflict) {
-                    $conflictMatch = $this->pool->match($possibleConflict, $link->getTarget(), $link->getConstraint(), true);
+                $conflicts = $this->pool->whatProvides($link->getTarget(), $link->getConstraint());
 
-                    if ($conflictMatch === Pool::MATCH || $conflictMatch === Pool::MATCH_REPLACE) {
-                        $this->addRule(RuleSet::TYPE_PACKAGE, $this->createRule2Literals($package, $possibleConflict, Rule::RULE_PACKAGE_CONFLICT, $link));
+                foreach ($conflicts as $conflict) {
+                    // define the conflict rule for regular packages, for alias packages it's only needed if the name
+                    // matches the conflict exactly, otherwise the name match is by provide/replace which means the
+                    // package which this is an alias of will conflict anyway, so no need to create additional rules
+                    if (!$conflict instanceof AliasPackage || $conflict->getName() === $link->getTarget()) {
+                        $this->addRule(RuleSet::TYPE_PACKAGE, $this->createRule2Literals($package, $conflict, Rule::RULE_PACKAGE_CONFLICT, $link));
                     }
-
                 }
             }
+        }
 
-            // check obsoletes and implicit obsoletes of a package
-            $isInstalled = isset($this->installedMap[$package->id]);
+        foreach ($this->addedPackagesByNames as $name => $packages) {
+            if (\count($packages) > 1) {
+                $reason = Rule::RULE_PACKAGE_SAME_NAME;
+                $this->addRule(RuleSet::TYPE_PACKAGE, $this->createMultiConflictRule($packages, $reason, $name));
+            }
+        }
+    }
 
-            foreach ($package->getReplaces() as $link) {
-                if (!isset($this->addedPackagesByNames[$link->getTarget()])) {
+    protected function addRulesForRequest(Request $request, $ignorePlatformReqs)
+    {
+        foreach ($request->getFixedPackages() as $package) {
+            if ($package->id == -1) {
+                // fixed package was not added to the pool as it did not pass the stability requirements, this is fine
+                if ($this->pool->isUnacceptableFixedOrLockedPackage($package)) {
                     continue;
                 }
 
-                /** @var PackageInterface $possibleConflict */
-                foreach ($this->addedPackagesByNames[$link->getTarget()] as $provider) {
-                    if ($provider === $package) {
-                        continue;
-                    }
-
-                    if (!$this->obsoleteImpossibleForAlias($package, $provider)) {
-                        $reason = $isInstalled ? Rule::RULE_INSTALLED_PACKAGE_OBSOLETES : Rule::RULE_PACKAGE_OBSOLETES;
-                        $this->addRule(RuleSet::TYPE_PACKAGE, $this->createRule2Literals($package, $provider, $reason, $link));
-                    }
-                }
+                // otherwise, looks like a bug
+                throw new \LogicException("Fixed package ".$package->getPrettyString()." was not added to solver pool.");
             }
-        }
-    }
 
-    protected function obsoleteImpossibleForAlias($package, $provider)
-    {
-        $packageIsAlias = $package instanceof AliasPackage;
-        $providerIsAlias = $provider instanceof AliasPackage;
+            $this->addRulesForPackage($package, $ignorePlatformReqs);
 
-        $impossible = (
-            ($packageIsAlias && $package->getAliasOf() === $provider) ||
-            ($providerIsAlias && $provider->getAliasOf() === $package) ||
-            ($packageIsAlias && $providerIsAlias && $provider->getAliasOf() === $package->getAliasOf())
-        );
+            $rule = $this->createInstallOneOfRule(array($package), Rule::RULE_FIXED, array(
+                'package' => $package,
+            ));
+            $this->addRule(RuleSet::TYPE_REQUEST, $rule);
+        }
 
-        return $impossible;
-    }
+        foreach ($request->getRequires() as $packageName => $constraint) {
+            if ((true === $ignorePlatformReqs || (is_array($ignorePlatformReqs) && in_array($packageName, $ignorePlatformReqs, true))) && PlatformRepository::isPlatformPackage($packageName)) {
+                continue;
+            }
 
-    protected function allowListFromJobs()
-    {
-        // call original method for BC
-        $this->whitelistFromJobs();
-    }
+            $packages = $this->pool->whatProvides($packageName, $constraint);
+            if ($packages) {
+                foreach ($packages as $package) {
+                    $this->addRulesForPackage($package, $ignorePlatformReqs);
+                }
 
-    /**
-     * @deprecated use allowListFromJobs instead
-     */
-    protected function whitelistFromJobs()
-    {
-        foreach ($this->jobs as $job) {
-            switch ($job['cmd']) {
-                case 'install':
-                    $packages = $this->pool->whatProvides($job['packageName'], $job['constraint'], true);
-                    foreach ($packages as $package) {
-                        $this->allowListFromPackage($package);
-                    }
-                    break;
+                $rule = $this->createInstallOneOfRule($packages, Rule::RULE_ROOT_REQUIRE, array(
+                    'packageName' => $packageName,
+                    'constraint' => $constraint,
+                ));
+                $this->addRule(RuleSet::TYPE_REQUEST, $rule);
             }
         }
     }
 
-    protected function addRulesForJobs($ignorePlatformReqs)
+    protected function addRulesForRootAliases($ignorePlatformReqs)
     {
-        foreach ($this->jobs as $job) {
-            switch ($job['cmd']) {
-                case 'install':
-                    if (!$job['fixed'] && $ignorePlatformReqs && preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $job['packageName'])) {
-                        break;
-                    }
-
-                    $packages = $this->pool->whatProvides($job['packageName'], $job['constraint']);
-                    if ($packages) {
-                        foreach ($packages as $package) {
-                            if (!isset($this->installedMap[$package->id])) {
-                                $this->addRulesForPackage($package, $ignorePlatformReqs);
-                            }
-                        }
-
-                        $rule = $this->createInstallOneOfRule($packages, Rule::RULE_JOB_INSTALL, $job);
-                        $this->addRule(RuleSet::TYPE_JOB, $rule);
-                    }
-                    break;
-                case 'remove':
-                    // remove all packages with this name including uninstalled
-                    // ones to make sure none of them are picked as replacements
-                    $packages = $this->pool->whatProvides($job['packageName'], $job['constraint']);
-                    foreach ($packages as $package) {
-                        $rule = $this->createRemoveRule($package, Rule::RULE_JOB_REMOVE, $job);
-                        $this->addRule(RuleSet::TYPE_JOB, $rule);
-                    }
-                    break;
+        foreach ($this->pool->getPackages() as $package) {
+            // ensure that rules for root alias packages and aliases of packages which were loaded are also loaded
+            // even if the alias itself isn't required, otherwise a package could be installed without its alias which
+            // leads to unexpected behavior
+            if (!isset($this->addedMap[$package->id]) &&
+                $package instanceof AliasPackage &&
+                ($package->isRootPackageAlias() || isset($this->addedMap[$package->getAliasOf()->id]))
+            ) {
+                $this->addRulesForPackage($package, $ignorePlatformReqs);
             }
         }
     }
 
-    public function getRulesFor($jobs, $installedMap, $ignorePlatformReqs = false)
+    /**
+     * @param bool|array $ignorePlatformReqs
+     */
+    public function getRulesFor(Request $request, $ignorePlatformReqs = false)
     {
-        $this->jobs = $jobs;
         $this->rules = new RuleSet;
-        $this->installedMap = $installedMap;
-
-        $this->allowListedMap = array();
-        foreach ($this->installedMap as $package) {
-            $this->allowListFromPackage($package);
-        }
-        $this->allowListFromJobs();
-
-        $this->pool->setAllowList($this->allowListedMap);
 
         $this->addedMap = array();
         $this->conflictAddedMap = array();
-        $this->addedPackages = array();
         $this->addedPackagesByNames = array();
-        foreach ($this->installedMap as $package) {
-            $this->addRulesForPackage($package, $ignorePlatformReqs);
-        }
+        $this->conflictsForName = array();
+
+        $this->addRulesForRequest($request, $ignorePlatformReqs);
 
-        $this->addRulesForJobs($ignorePlatformReqs);
+        $this->addRulesForRootAliases($ignorePlatformReqs);
 
         $this->addConflictRules($ignorePlatformReqs);
 
         // Remove references to packages
-        $this->addedPackages = $this->addedPackagesByNames = null;
+        $this->addedMap = $this->addedPackagesByNames = null;
 
         return $this->rules;
     }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/RuleSetIterator.php 2.0.9-1/src/Composer/DependencyResolver/RuleSetIterator.php
--- 1.10.19-1/src/Composer/DependencyResolver/RuleSetIterator.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/RuleSetIterator.php	2021-01-27 15:09:27.000000000 +0000
@@ -51,7 +51,7 @@ class RuleSetIterator implements \Iterat
             return;
         }
 
-        if ($this->currentOffset >= count($this->rules[$this->currentType])) {
+        if ($this->currentOffset >= \count($this->rules[$this->currentType])) {
             $this->currentOffset = 0;
 
             do {
@@ -63,7 +63,7 @@ class RuleSetIterator implements \Iterat
                 }
 
                 $this->currentType = $this->types[$this->currentTypeOffset];
-            } while (isset($this->types[$this->currentTypeOffset]) && !count($this->rules[$this->currentType]));
+            } while (isset($this->types[$this->currentTypeOffset]) && !\count($this->rules[$this->currentType]));
         }
     }
 
@@ -83,12 +83,11 @@ class RuleSetIterator implements \Iterat
             }
 
             $this->currentType = $this->types[$this->currentTypeOffset];
-        } while (isset($this->types[$this->currentTypeOffset]) && !count($this->rules[$this->currentType]));
+        } while (isset($this->types[$this->currentTypeOffset]) && !\count($this->rules[$this->currentType]));
     }
 
     public function valid()
     {
-        return isset($this->rules[$this->currentType])
-               && isset($this->rules[$this->currentType][$this->currentOffset]);
+        return isset($this->rules[$this->currentType], $this->rules[$this->currentType][$this->currentOffset]);
     }
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/RuleSet.php 2.0.9-1/src/Composer/DependencyResolver/RuleSet.php
--- 1.10.19-1/src/Composer/DependencyResolver/RuleSet.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/RuleSet.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,6 +12,8 @@
 
 namespace Composer\DependencyResolver;
 
+use Composer\Repository\RepositorySet;
+
 /**
  * @author Nils Adermann <naderman@naderman.de>
  */
@@ -19,7 +21,7 @@ class RuleSet implements \IteratorAggreg
 {
     // highest priority => lowest number
     const TYPE_PACKAGE = 0;
-    const TYPE_JOB = 1;
+    const TYPE_REQUEST = 1;
     const TYPE_LEARNED = 4;
 
     /**
@@ -32,7 +34,7 @@ class RuleSet implements \IteratorAggreg
     protected static $types = array(
         255 => 'UNKNOWN',
         self::TYPE_PACKAGE => 'PACKAGE',
-        self::TYPE_JOB => 'JOB',
+        self::TYPE_REQUEST => 'REQUEST',
         self::TYPE_LEARNED => 'LEARNED',
     );
 
@@ -63,7 +65,7 @@ class RuleSet implements \IteratorAggreg
         // Do not add if rule already exists
         if (isset($this->rulesByHash[$hash])) {
             $potentialDuplicates = $this->rulesByHash[$hash];
-            if (is_array($potentialDuplicates)) {
+            if (\is_array($potentialDuplicates)) {
                 foreach ($potentialDuplicates as $potentialDuplicate) {
                     if ($rule->equals($potentialDuplicate)) {
                         return;
@@ -88,7 +90,7 @@ class RuleSet implements \IteratorAggreg
 
         if (!isset($this->rulesByHash[$hash])) {
             $this->rulesByHash[$hash] = $rule;
-        } elseif (is_array($this->rulesByHash[$hash])) {
+        } elseif (\is_array($this->rulesByHash[$hash])) {
             $this->rulesByHash[$hash][] = $rule;
         } else {
             $originalRule = $this->rulesByHash[$hash];
@@ -118,7 +120,7 @@ class RuleSet implements \IteratorAggreg
 
     public function getIteratorFor($types)
     {
-        if (!is_array($types)) {
+        if (!\is_array($types)) {
             $types = array($types);
         }
 
@@ -134,7 +136,7 @@ class RuleSet implements \IteratorAggreg
 
     public function getIteratorWithout($types)
     {
-        if (!is_array($types)) {
+        if (!\is_array($types)) {
             $types = array($types);
         }
 
@@ -155,13 +157,13 @@ class RuleSet implements \IteratorAggreg
         return array_keys($types);
     }
 
-    public function getPrettyString(Pool $pool = null)
+    public function getPrettyString(RepositorySet $repositorySet = null, Request $request = null, Pool $pool = null, $isVerbose = false)
     {
         $string = "\n";
         foreach ($this->rules as $type => $rules) {
             $string .= str_pad(self::$types[$type], 8, ' ') . ": ";
             foreach ($rules as $rule) {
-                $string .= ($pool ? $rule->getPrettyString($pool) : $rule)."\n";
+                $string .= ($repositorySet && $request && $pool ? $rule->getPrettyString($repositorySet, $request, $pool, $isVerbose) : $rule)."\n";
             }
             $string .= "\n\n";
         }
@@ -171,6 +173,6 @@ class RuleSet implements \IteratorAggreg
 
     public function __toString()
     {
-        return $this->getPrettyString(null);
+        return $this->getPrettyString();
     }
 }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/RuleWatchGraph.php 2.0.9-1/src/Composer/DependencyResolver/RuleWatchGraph.php
--- 1.10.19-1/src/Composer/DependencyResolver/RuleWatchGraph.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/RuleWatchGraph.php	2021-01-27 15:09:27.000000000 +0000
@@ -44,12 +44,22 @@ class RuleWatchGraph
             return;
         }
 
-        foreach (array($node->watch1, $node->watch2) as $literal) {
-            if (!isset($this->watchChains[$literal])) {
-                $this->watchChains[$literal] = new RuleWatchChain;
+        if (!$node->getRule() instanceof MultiConflictRule) {
+            foreach (array($node->watch1, $node->watch2) as $literal) {
+                if (!isset($this->watchChains[$literal])) {
+                    $this->watchChains[$literal] = new RuleWatchChain;
+                }
+
+                $this->watchChains[$literal]->unshift($node);
             }
+        } else {
+            foreach ($node->getRule()->getLiterals() as $literal) {
+                if (!isset($this->watchChains[$literal])) {
+                    $this->watchChains[$literal] = new RuleWatchChain;
+                }
 
-            $this->watchChains[$literal]->unshift($node);
+                $this->watchChains[$literal]->unshift($node);
+            }
         }
     }
 
@@ -92,28 +102,40 @@ class RuleWatchGraph
         $chain->rewind();
         while ($chain->valid()) {
             $node = $chain->current();
-            $otherWatch = $node->getOtherWatch($literal);
+            if (!$node->getRule() instanceof MultiConflictRule) {
+                $otherWatch = $node->getOtherWatch($literal);
 
-            if (!$node->getRule()->isDisabled() && !$decisions->satisfy($otherWatch)) {
-                $ruleLiterals = $node->getRule()->getLiterals();
+                if (!$node->getRule()->isDisabled() && !$decisions->satisfy($otherWatch)) {
+                    $ruleLiterals = $node->getRule()->getLiterals();
 
-                $alternativeLiterals = array_filter($ruleLiterals, function ($ruleLiteral) use ($literal, $otherWatch, $decisions) {
-                    return $literal !== $ruleLiteral &&
-                        $otherWatch !== $ruleLiteral &&
-                        !$decisions->conflict($ruleLiteral);
-                });
-
-                if ($alternativeLiterals) {
-                    reset($alternativeLiterals);
-                    $this->moveWatch($literal, current($alternativeLiterals), $node);
-                    continue;
-                }
+                    $alternativeLiterals = array_filter($ruleLiterals, function ($ruleLiteral) use ($literal, $otherWatch, $decisions) {
+                        return $literal !== $ruleLiteral &&
+                            $otherWatch !== $ruleLiteral &&
+                            !$decisions->conflict($ruleLiteral);
+                    });
+
+                    if ($alternativeLiterals) {
+                        reset($alternativeLiterals);
+                        $this->moveWatch($literal, current($alternativeLiterals), $node);
+                        continue;
+                    }
+
+                    if ($decisions->conflict($otherWatch)) {
+                        return $node->getRule();
+                    }
 
-                if ($decisions->conflict($otherWatch)) {
-                    return $node->getRule();
+                    $decisions->decide($otherWatch, $level, $node->getRule());
                 }
+            } else {
+                foreach ($node->getRule()->getLiterals() as $otherLiteral) {
+                    if ($literal !== $otherLiteral && !$decisions->satisfy($otherLiteral)) {
+                        if ($decisions->conflict($otherLiteral)) {
+                            return $node->getRule();
+                        }
 
-                $decisions->decide($otherWatch, $level, $node->getRule());
+                        $decisions->decide($otherLiteral, $level, $node->getRule());
+                    }
+                }
             }
 
             $chain->next();
@@ -128,8 +150,8 @@ class RuleWatchGraph
      * The rule node's watched literals are updated accordingly.
      *
      * @param int           $fromLiteral A literal the node used to watch
-     * @param int           $toLiteral A literal the node should watch now
-     * @param RuleWatchNode $node The rule node to be moved
+     * @param int           $toLiteral   A literal the node should watch now
+     * @param RuleWatchNode $node        The rule node to be moved
      */
     protected function moveWatch($fromLiteral, $toLiteral, $node)
     {
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/RuleWatchNode.php 2.0.9-1/src/Composer/DependencyResolver/RuleWatchNode.php
--- 1.10.19-1/src/Composer/DependencyResolver/RuleWatchNode.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/RuleWatchNode.php	2021-01-27 15:09:27.000000000 +0000
@@ -37,7 +37,7 @@ class RuleWatchNode
 
         $literals = $rule->getLiterals();
 
-        $literalCount = count($literals);
+        $literalCount = \count($literals);
         $this->watch1 = $literalCount > 0 ? $literals[0] : 0;
         $this->watch2 = $literalCount > 1 ? $literals[1] : 0;
     }
@@ -55,7 +55,7 @@ class RuleWatchNode
         $literals = $this->rule->getLiterals();
 
         // if there are only 2 elements, both are being watched anyway
-        if (count($literals) < 3) {
+        if (\count($literals) < 3 || $this->rule instanceof MultiConflictRule) {
             return;
         }
 
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Solver.php 2.0.9-1/src/Composer/DependencyResolver/Solver.php
--- 1.10.19-1/src/Composer/DependencyResolver/Solver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Solver.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,7 +13,7 @@
 namespace Composer\DependencyResolver;
 
 use Composer\IO\IOInterface;
-use Composer\Repository\RepositoryInterface;
+use Composer\Package\PackageInterface;
 use Composer\Repository\PlatformRepository;
 
 /**
@@ -28,23 +28,16 @@ class Solver
     protected $policy;
     /** @var Pool */
     protected $pool;
-    /** @var RepositoryInterface */
-    protected $installed;
+
     /** @var RuleSet */
     protected $rules;
-    /** @var RuleSetGenerator */
-    protected $ruleSetGenerator;
-    /** @var array */
-    protected $jobs;
 
-    /** @var int[] */
-    protected $updateMap = array();
     /** @var RuleWatchGraph */
     protected $watchGraph;
     /** @var Decisions */
     protected $decisions;
-    /** @var int[] */
-    protected $installedMap;
+    /** @var PackageInterface[] */
+    protected $fixedMap;
 
     /** @var int */
     protected $propagateIndex;
@@ -64,18 +57,15 @@ class Solver
     protected $io;
 
     /**
-     * @param PolicyInterface     $policy
-     * @param Pool                $pool
-     * @param RepositoryInterface $installed
-     * @param IOInterface         $io
+     * @param PolicyInterface $policy
+     * @param Pool            $pool
+     * @param IOInterface     $io
      */
-    public function __construct(PolicyInterface $policy, Pool $pool, RepositoryInterface $installed, IOInterface $io)
+    public function __construct(PolicyInterface $policy, Pool $pool, IOInterface $io)
     {
         $this->io = $io;
         $this->policy = $policy;
         $this->pool = $pool;
-        $this->installed = $installed;
-        $this->ruleSetGenerator = new RuleSetGenerator($policy, $pool);
     }
 
     /**
@@ -83,16 +73,21 @@ class Solver
      */
     public function getRuleSetSize()
     {
-        return count($this->rules);
+        return \count($this->rules);
+    }
+
+    public function getPool()
+    {
+        return $this->pool;
     }
 
     // aka solver_makeruledecisions
 
     private function makeAssertionRuleDecisions()
     {
-        $decisionStart = count($this->decisions) - 1;
+        $decisionStart = \count($this->decisions) - 1;
 
-        $rulesCount = count($this->rules);
+        $rulesCount = \count($this->rules);
         for ($ruleIndex = 0; $ruleIndex < $rulesCount; $ruleIndex++) {
             $rule = $this->rules->ruleById[$ruleIndex];
 
@@ -121,23 +116,23 @@ class Solver
             $conflict = $this->decisions->decisionRule($literal);
 
             if ($conflict && RuleSet::TYPE_PACKAGE === $conflict->getType()) {
-                $problem = new Problem($this->pool);
+                $problem = new Problem();
 
                 $problem->addRule($rule);
                 $problem->addRule($conflict);
-                $this->disableProblem($rule);
+                $rule->disable();
                 $this->problems[] = $problem;
                 continue;
             }
 
-            // conflict with another job
-            $problem = new Problem($this->pool);
+            // conflict with another root require/fixed package
+            $problem = new Problem();
             $problem->addRule($rule);
             $problem->addRule($conflict);
 
-            // push all of our rules (can only be job rules)
+            // push all of our rules (can only be root require/fixed package rules)
             // asserting this literal on the problem stack
-            foreach ($this->rules->getIteratorFor(RuleSet::TYPE_JOB) as $assertRule) {
+            foreach ($this->rules->getIteratorFor(RuleSet::TYPE_REQUEST) as $assertRule) {
                 if ($assertRule->isDisabled() || !$assertRule->isAssertion()) {
                     continue;
                 }
@@ -148,9 +143,8 @@ class Solver
                 if (abs($literal) !== abs($assertRuleLiteral)) {
                     continue;
                 }
-
                 $problem->addRule($assertRule);
-                $this->disableProblem($assertRule);
+                $assertRule->disable();
             }
             $this->problems[] = $problem;
 
@@ -159,63 +153,47 @@ class Solver
         }
     }
 
-    protected function setupInstalledMap()
+    protected function setupFixedMap(Request $request)
     {
-        $this->installedMap = array();
-        foreach ($this->installed->getPackages() as $package) {
-            $this->installedMap[$package->id] = $package;
+        $this->fixedMap = array();
+        foreach ($request->getFixedPackages() as $package) {
+            $this->fixedMap[$package->id] = $package;
         }
     }
 
     /**
-     * @param bool $ignorePlatformReqs
+     * @param Request    $request
+     * @param bool|array $ignorePlatformReqs
      */
-    protected function checkForRootRequireProblems($ignorePlatformReqs)
+    protected function checkForRootRequireProblems(Request $request, $ignorePlatformReqs)
     {
-        foreach ($this->jobs as $job) {
-            switch ($job['cmd']) {
-                case 'update':
-                    $packages = $this->pool->whatProvides($job['packageName'], $job['constraint']);
-                    foreach ($packages as $package) {
-                        if (isset($this->installedMap[$package->id])) {
-                            $this->updateMap[$package->id] = true;
-                        }
-                    }
-                    break;
-
-                case 'update-all':
-                    foreach ($this->installedMap as $package) {
-                        $this->updateMap[$package->id] = true;
-                    }
-                    break;
-
-                case 'install':
-                    if ($ignorePlatformReqs && preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $job['packageName'])) {
-                        break;
-                    }
+        foreach ($request->getRequires() as $packageName => $constraint) {
+            if ((true === $ignorePlatformReqs || (is_array($ignorePlatformReqs) && in_array($packageName, $ignorePlatformReqs, true))) && PlatformRepository::isPlatformPackage($packageName)) {
+                continue;
+            }
 
-                    if (!$this->pool->whatProvides($job['packageName'], $job['constraint'])) {
-                        $problem = new Problem($this->pool);
-                        $problem->addRule(new GenericRule(array(), null, null, $job));
-                        $this->problems[] = $problem;
-                    }
-                    break;
+            if (!$this->pool->whatProvides($packageName, $constraint)) {
+                $problem = new Problem();
+                $problem->addRule(new GenericRule(array(), Rule::RULE_ROOT_REQUIRE, array('packageName' => $packageName, 'constraint' => $constraint)));
+                $this->problems[] = $problem;
             }
         }
     }
 
     /**
-     * @param  Request $request
-     * @param  bool    $ignorePlatformReqs
-     * @return array
+     * @param  Request         $request
+     * @param  bool|array      $ignorePlatformReqs
+     * @return LockTransaction
      */
     public function solve(Request $request, $ignorePlatformReqs = false)
     {
-        $this->jobs = $request->getJobs();
+        $this->setupFixedMap($request);
 
-        $this->setupInstalledMap();
-        $this->rules = $this->ruleSetGenerator->getRulesFor($this->jobs, $this->installedMap, $ignorePlatformReqs);
-        $this->checkForRootRequireProblems($ignorePlatformReqs);
+        $this->io->writeError('Generating rules', true, IOInterface::DEBUG);
+        $ruleSetGenerator = new RuleSetGenerator($this->policy, $this->pool);
+        $this->rules = $ruleSetGenerator->getRulesFor($request, $ignorePlatformReqs);
+        unset($ruleSetGenerator);
+        $this->checkForRootRequireProblems($request, $ignorePlatformReqs);
         $this->decisions = new Decisions($this->pool);
         $this->watchGraph = new RuleWatchGraph;
 
@@ -223,29 +201,20 @@ class Solver
             $this->watchGraph->insert(new RuleWatchNode($rule));
         }
 
-        /* make decisions based on job/update assertions */
+        /* make decisions based on root require/fix assertions */
         $this->makeAssertionRuleDecisions();
 
         $this->io->writeError('Resolving dependencies through SAT', true, IOInterface::DEBUG);
         $before = microtime(true);
-        $this->runSat(true);
+        $this->runSat();
         $this->io->writeError('', true, IOInterface::DEBUG);
         $this->io->writeError(sprintf('Dependency resolution completed in %.3f seconds', microtime(true) - $before), true, IOInterface::VERBOSE);
 
-        // decide to remove everything that's installed and undecided
-        foreach ($this->installedMap as $packageId => $void) {
-            if ($this->decisions->undecided($packageId)) {
-                $this->decisions->decide(-$packageId, 1, null);
-            }
-        }
-
         if ($this->problems) {
-            throw new SolverProblemsException($this->problems, $this->installedMap);
+            throw new SolverProblemsException($this->problems, $this->learnedPool);
         }
 
-        $transaction = new Transaction($this->policy, $this->pool, $this->installedMap, $this->decisions);
-
-        return $transaction->getOperations();
+        return new LockTransaction($this->pool, $request->getPresentMap(), $request->getFixedPackagesMap(), $this->decisions);
     }
 
     /**
@@ -299,10 +268,10 @@ class Solver
             }
 
             $this->decisions->revertLast();
-            $this->propagateIndex = count($this->decisions);
+            $this->propagateIndex = \count($this->decisions);
         }
 
-        while (!empty($this->branches) && $this->branches[count($this->branches) - 1][self::BRANCH_LEVEL] >= $level) {
+        while (!empty($this->branches) && $this->branches[\count($this->branches) - 1][self::BRANCH_LEVEL] >= $level) {
             array_pop($this->branches);
         }
     }
@@ -322,11 +291,10 @@ class Solver
      *
      * @param  int        $level
      * @param  string|int $literal
-     * @param  bool       $disableRules
      * @param  Rule       $rule
      * @return int
      */
-    private function setPropagateLearn($level, $literal, $disableRules, Rule $rule)
+    private function setPropagateLearn($level, $literal, Rule $rule)
     {
         $level++;
 
@@ -340,7 +308,7 @@ class Solver
             }
 
             if ($level == 1) {
-                return $this->analyzeUnsolvable($rule, $disableRules);
+                return $this->analyzeUnsolvable($rule);
             }
 
             // conflict
@@ -350,7 +318,8 @@ class Solver
                 throw new SolverBugException(
                     "Trying to revert to invalid level ".(int) $newLevel." from level ".(int) $level."."
                 );
-            } elseif (!$newRule) {
+            }
+            if (!$newRule) {
                 throw new SolverBugException(
                     "No rule was learned from analyzing $rule at level $level."
                 );
@@ -377,23 +346,22 @@ class Solver
     /**
      * @param  int   $level
      * @param  array $decisionQueue
-     * @param  bool  $disableRules
      * @param  Rule  $rule
      * @return int
      */
-    private function selectAndInstall($level, array $decisionQueue, $disableRules, Rule $rule)
+    private function selectAndInstall($level, array $decisionQueue, Rule $rule)
     {
         // choose best package to install from decisionQueue
-        $literals = $this->policy->selectPreferredPackages($this->pool, $this->installedMap, $decisionQueue, $rule->getRequiredPackage());
+        $literals = $this->policy->selectPreferredPackages($this->pool, $decisionQueue, $rule->getRequiredPackage());
 
         $selectedLiteral = array_shift($literals);
 
         // if there are multiple candidates, then branch
-        if (count($literals)) {
+        if (\count($literals)) {
             $this->branches[] = array($literals, $level);
         }
 
-        return $this->setPropagateLearn($level, $selectedLiteral, $disableRules, $rule);
+        return $this->setPropagateLearn($level, $selectedLiteral, $rule);
     }
 
     /**
@@ -410,14 +378,19 @@ class Solver
         $seen = array();
         $learnedLiterals = array(null);
 
-        $decisionId = count($this->decisions);
+        $decisionId = \count($this->decisions);
 
         $this->learnedPool[] = array();
 
         while (true) {
-            $this->learnedPool[count($this->learnedPool) - 1][] = $rule;
+            $this->learnedPool[\count($this->learnedPool) - 1][] = $rule;
 
             foreach ($rule->getLiterals() as $literal) {
+                // multiconflictrule is really a bunch of rules in one, so some may not have finished propagating yet
+                if ($rule instanceof MultiConflictRule && !$this->decisions->decided($literal)) {
+                    continue;
+                }
+
                 // skip the one true literal
                 if ($this->decisions->satisfy($literal)) {
                     continue;
@@ -443,6 +416,7 @@ class Solver
                     }
                 }
             }
+            unset($literal);
 
             $l1retry = true;
             while ($l1retry) {
@@ -490,6 +464,35 @@ class Solver
                     // only level 1 marks left
                     $l1num++;
                     $l1retry = true;
+                } else {
+                    $decision = $this->decisions->atOffset($decisionId);
+                    $rule = $decision[Decisions::DECISION_REASON];
+
+                    if ($rule instanceof MultiConflictRule) {
+                        // there is only ever exactly one positive decision in a multiconflict rule
+                        foreach ($rule->getLiterals() as $literal) {
+                            if (!isset($seen[abs($literal)]) && $this->decisions->satisfy(-$literal)) {
+                                $this->learnedPool[\count($this->learnedPool) - 1][] = $rule;
+                                $l = $this->decisions->decisionLevel($literal);
+                                if (1 === $l) {
+                                    $l1num++;
+                                } elseif ($level === $l) {
+                                    $num++;
+                                } else {
+                                    // not level1 or conflict level, add to new rule
+                                    $learnedLiterals[] = $literal;
+
+                                    if ($l > $ruleLevel) {
+                                        $ruleLevel = $l;
+                                    }
+                                }
+                                $seen[abs($literal)] = true;
+                                break;
+                            }
+                        }
+
+                        $l1retry = true;
+                    }
                 }
             }
 
@@ -497,7 +500,7 @@ class Solver
             $rule = $decision[Decisions::DECISION_REASON];
         }
 
-        $why = count($this->learnedPool) - 1;
+        $why = \count($this->learnedPool) - 1;
 
         if (!$learnedLiterals[0]) {
             throw new SolverBugException(
@@ -510,19 +513,19 @@ class Solver
         return array($learnedLiterals[0], $ruleLevel, $newRule, $why);
     }
 
-    /**
-     * @param Problem $problem
-     * @param Rule    $conflictRule
-     */
-    private function analyzeUnsolvableRule(Problem $problem, Rule $conflictRule)
+    private function analyzeUnsolvableRule(Problem $problem, Rule $conflictRule, array &$ruleSeen)
     {
+        $why = spl_object_hash($conflictRule);
+        $ruleSeen[$why] = true;
+
         if ($conflictRule->getType() == RuleSet::TYPE_LEARNED) {
-            $why = spl_object_hash($conflictRule);
             $learnedWhy = $this->learnedWhy[$why];
             $problemRules = $this->learnedPool[$learnedWhy];
 
             foreach ($problemRules as $problemRule) {
-                $this->analyzeUnsolvableRule($problem, $problemRule);
+                if (!isset($ruleSeen[spl_object_hash($problemRule)])) {
+                    $this->analyzeUnsolvableRule($problem, $problemRule, $ruleSeen);
+                }
             }
 
             return;
@@ -539,15 +542,16 @@ class Solver
 
     /**
      * @param  Rule $conflictRule
-     * @param  bool $disableRules
      * @return int
      */
-    private function analyzeUnsolvable(Rule $conflictRule, $disableRules)
+    private function analyzeUnsolvable(Rule $conflictRule)
     {
-        $problem = new Problem($this->pool);
+        $problem = new Problem();
         $problem->addRule($conflictRule);
 
-        $this->analyzeUnsolvableRule($problem, $conflictRule);
+        $ruleSeen = array();
+
+        $this->analyzeUnsolvableRule($problem, $conflictRule, $ruleSeen);
 
         $this->problems[] = $problem;
 
@@ -573,7 +577,7 @@ class Solver
             $why = $decision[Decisions::DECISION_REASON];
 
             $problem->addRule($why);
-            $this->analyzeUnsolvableRule($problem, $why);
+            $this->analyzeUnsolvableRule($problem, $why, $ruleSeen);
 
             $literals = $why->getLiterals();
 
@@ -586,53 +590,10 @@ class Solver
             }
         }
 
-        if ($disableRules) {
-            foreach ($this->problems[count($this->problems) - 1] as $reason) {
-                $this->disableProblem($reason['rule']);
-            }
-
-            $this->resetSolver();
-
-            return 1;
-        }
-
         return 0;
     }
 
     /**
-     * @param Rule $why
-     */
-    private function disableProblem(Rule $why)
-    {
-        $job = $why->getJob();
-
-        if (!$job) {
-            $why->disable();
-
-            return;
-        }
-
-        // disable all rules of this job
-        foreach ($this->rules as $rule) {
-            /** @var Rule $rule */
-            if ($job === $rule->getJob()) {
-                $rule->disable();
-            }
-        }
-    }
-
-    private function resetSolver()
-    {
-        $this->decisions->reset();
-
-        $this->propagateIndex = 0;
-        $this->branches = array();
-
-        $this->enableDisableLearnedRules();
-        $this->makeAssertionRuleDecisions();
-    }
-
-    /**
      * enable/disable learnt rules
      *
      * we have enabled or disabled some of our rules. We now re-enable all
@@ -661,29 +622,20 @@ class Solver
         }
     }
 
-    /**
-     * @param bool $disableRules
-     */
-    private function runSat($disableRules = true)
+    private function runSat()
     {
         $this->propagateIndex = 0;
 
         /*
          * here's the main loop:
          * 1) propagate new decisions (only needed once)
-         * 2) fulfill jobs
+         * 2) fulfill root requires/fixed packages
          * 3) fulfill all unresolved rules
          * 4) minimalize solution if we had choices
          * if we encounter a problem, we rewind to a safe level and restart
          * with step 1
          */
 
-        $decisionQueue = array();
-        /**
-         * @todo this makes $disableRules always false; determine the rationale and possibly remove dead code?
-         */
-        $disableRules = array();
-
         $level = 1;
         $systemLevel = $level + 1;
 
@@ -691,7 +643,7 @@ class Solver
             if (1 === $level) {
                 $conflictRule = $this->propagate($level);
                 if (null !== $conflictRule) {
-                    if ($this->analyzeUnsolvable($conflictRule, $disableRules)) {
+                    if ($this->analyzeUnsolvable($conflictRule)) {
                         continue;
                     }
 
@@ -699,9 +651,9 @@ class Solver
                 }
             }
 
-            // handle job rules
+            // handle root require/fixed package rules
             if ($level < $systemLevel) {
-                $iterator = $this->rules->getIteratorFor(RuleSet::TYPE_JOB);
+                $iterator = $this->rules->getIteratorFor(RuleSet::TYPE_REQUEST);
                 foreach ($iterator as $rule) {
                     if ($rule->isEnabled()) {
                         $decisionQueue = array();
@@ -717,27 +669,22 @@ class Solver
                             }
                         }
 
-                        if ($noneSatisfied && count($decisionQueue)) {
-                            // prune all update packages until installed version
-                            // except for requested updates
-                            if (count($this->installed) != count($this->updateMap)) {
-                                $prunedQueue = array();
-                                foreach ($decisionQueue as $literal) {
-                                    if (isset($this->installedMap[abs($literal)])) {
-                                        $prunedQueue[] = $literal;
-                                        if (isset($this->updateMap[abs($literal)])) {
-                                            $prunedQueue = $decisionQueue;
-                                            break;
-                                        }
-                                    }
+                        if ($noneSatisfied && \count($decisionQueue)) {
+                            // if any of the options in the decision queue are fixed, only use those
+                            $prunedQueue = array();
+                            foreach ($decisionQueue as $literal) {
+                                if (isset($this->fixedMap[abs($literal)])) {
+                                    $prunedQueue[] = $literal;
                                 }
+                            }
+                            if (!empty($prunedQueue)) {
                                 $decisionQueue = $prunedQueue;
                             }
                         }
 
-                        if ($noneSatisfied && count($decisionQueue)) {
+                        if ($noneSatisfied && \count($decisionQueue)) {
                             $oLevel = $level;
-                            $level = $this->selectAndInstall($level, $decisionQueue, $disableRules, $rule);
+                            $level = $this->selectAndInstall($level, $decisionQueue, $rule);
 
                             if (0 === $level) {
                                 return;
@@ -751,7 +698,7 @@ class Solver
 
                 $systemLevel = $level + 1;
 
-                // jobs left
+                // root requires/fixed packages left
                 $iterator->next();
                 if ($iterator->valid()) {
                     continue;
@@ -762,7 +709,7 @@ class Solver
                 $systemLevel = $level;
             }
 
-            $rulesCount = count($this->rules);
+            $rulesCount = \count($this->rules);
             $pass = 1;
 
             $this->io->writeError('Looking at all rules.', true, IOInterface::DEBUG);
@@ -809,18 +756,18 @@ class Solver
                 }
 
                 // need to have at least 2 item to pick from
-                if (count($decisionQueue) < 2) {
+                if (\count($decisionQueue) < 2) {
                     continue;
                 }
 
-                $level = $this->selectAndInstall($level, $decisionQueue, $disableRules, $rule);
+                $level = $this->selectAndInstall($level, $decisionQueue, $rule);
 
                 if (0 === $level) {
                     return;
                 }
 
                 // something changed, so look at all rules again
-                $rulesCount = count($this->rules);
+                $rulesCount = \count($this->rules);
                 $n = -1;
             }
 
@@ -829,13 +776,13 @@ class Solver
             }
 
             // minimization step
-            if (count($this->branches)) {
+            if (\count($this->branches)) {
                 $lastLiteral = null;
                 $lastLevel = null;
                 $lastBranchIndex = 0;
                 $lastBranchOffset = 0;
 
-                for ($i = count($this->branches) - 1; $i >= 0; $i--) {
+                for ($i = \count($this->branches) - 1; $i >= 0; $i--) {
                     list($literals, $l) = $this->branches[$i];
 
                     foreach ($literals as $offset => $literal) {
@@ -856,7 +803,7 @@ class Solver
 
                     $why = $this->decisions->lastReason();
 
-                    $level = $this->setPropagateLearn($level, $lastLiteral, $disableRules, $why);
+                    $level = $this->setPropagateLearn($level, $lastLiteral, $why);
 
                     if ($level == 0) {
                         return;
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/SolverProblemsException.php 2.0.9-1/src/Composer/DependencyResolver/SolverProblemsException.php
--- 1.10.19-1/src/Composer/DependencyResolver/SolverProblemsException.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/SolverProblemsException.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,7 @@
 namespace Composer\DependencyResolver;
 
 use Composer\Util\IniHelper;
+use Composer\Repository\RepositorySet;
 
 /**
  * @author Nils Adermann <naderman@naderman.de>
@@ -20,34 +21,64 @@ use Composer\Util\IniHelper;
 class SolverProblemsException extends \RuntimeException
 {
     protected $problems;
-    protected $installedMap;
+    protected $learnedPool;
 
-    public function __construct(array $problems, array $installedMap)
+    public function __construct(array $problems, array $learnedPool)
     {
         $this->problems = $problems;
-        $this->installedMap = $installedMap;
+        $this->learnedPool = $learnedPool;
 
-        parent::__construct($this->createMessage(), 2);
+        parent::__construct('Failed resolving dependencies with '.count($problems).' problems, call getPrettyString to get formatted details', 2);
     }
 
-    protected function createMessage()
+    public function getPrettyString(RepositorySet $repositorySet, Request $request, Pool $pool, $isVerbose, $isDevExtraction = false)
     {
-        $text = "\n";
+        $installedMap = $request->getPresentMap(true);
         $hasExtensionProblems = false;
-        foreach ($this->problems as $i => $problem) {
-            $text .= "  Problem ".($i + 1).$problem->getPrettyString($this->installedMap)."\n";
+        $isCausedByLock = false;
+
+        $problems = array();
+        foreach ($this->problems as $problem) {
+            $problems[] = $problem->getPrettyString($repositorySet, $request, $pool, $isVerbose, $installedMap, $this->learnedPool)."\n";
 
             if (!$hasExtensionProblems && $this->hasExtensionProblems($problem->getReasons())) {
                 $hasExtensionProblems = true;
             }
+
+            $isCausedByLock |= $problem->isCausedByLock($repositorySet, $request, $pool);
+        }
+
+        $i = 1;
+        $text = "\n";
+        foreach (array_unique($problems) as $problem) {
+            $text .= "  Problem ".($i++).$problem;
         }
 
-        if (strpos($text, 'could not be found') || strpos($text, 'no matching package found')) {
-            $text .= "\nPotential causes:\n - A typo in the package name\n - The package is not available in a stable-enough version according to your minimum-stability setting\n   see <https://getcomposer.org/doc/04-schema.md#minimum-stability> for more details.\n - It's a private package and you forgot to add a custom repository to find it\n\nRead <https://getcomposer.org/doc/articles/troubleshooting.md> for further common problems.";
+        $hints = array();
+        if (!$isDevExtraction && (strpos($text, 'could not be found') || strpos($text, 'no matching package found'))) {
+            $hints[] = "Potential causes:\n - A typo in the package name\n - The package is not available in a stable-enough version according to your minimum-stability setting\n   see <https://getcomposer.org/doc/04-schema.md#minimum-stability> for more details.\n - It's a private package and you forgot to add a custom repository to find it\n\nRead <https://getcomposer.org/doc/articles/troubleshooting.md> for further common problems.";
         }
 
         if ($hasExtensionProblems) {
-            $text .= $this->createExtensionHint();
+            $hints[] = $this->createExtensionHint();
+        }
+
+        if ($isCausedByLock && !$isDevExtraction) {
+            $hints[] = "Use the option --with-all-dependencies (-W) to allow upgrades, downgrades and removals for packages currently locked to specific versions.";
+        }
+
+        if (strpos($text, 'found composer-plugin-api[2.0.0] but it does not match') && strpos($text, '- ocramius/package-versions')) {
+            $hints[] = "<warning>ocramius/package-versions only provides support for Composer 2 in 1.8+, which requires PHP 7.4.</warning>\nIf you can not upgrade PHP you can require <info>composer/package-versions-deprecated</info> to resolve this with PHP 7.0+.";
+        }
+
+        if (!class_exists('PHPUnit\Framework\TestCase', false)) {
+            if (strpos($text, 'found composer-plugin-api[2.0.0] but it does not match')) {
+                $hints[] = "You are using Composer 2, which some of your plugins seem to be incompatible with. Make sure you update your plugins or report a plugin-issue to ask them to support Composer 2.";
+            }
+        }
+
+        if ($hints) {
+            $text .= "\n" . implode("\n\n", $hints);
         }
 
         return $text;
@@ -66,9 +97,9 @@ class SolverProblemsException extends \R
             return '';
         }
 
-        $text = "\n  To enable extensions, verify that they are enabled in your .ini files:\n    - ";
+        $text = "To enable extensions, verify that they are enabled in your .ini files:\n    - ";
         $text .= implode("\n    - ", $paths);
-        $text .= "\n  You can also run `php --ini` inside terminal to see which files are used by PHP in CLI mode.";
+        $text .= "\nYou can also run `php --ini` inside terminal to see which files are used by PHP in CLI mode.";
 
         return $text;
     }
@@ -76,8 +107,8 @@ class SolverProblemsException extends \R
     private function hasExtensionProblems(array $reasonSets)
     {
         foreach ($reasonSets as $reasonSet) {
-            foreach ($reasonSet as $reason) {
-                if (isset($reason["rule"]) && 0 === strpos($reason["rule"]->getRequiredPackage(), 'ext-')) {
+            foreach ($reasonSet as $rule) {
+                if (0 === strpos($rule->getRequiredPackage(), 'ext-')) {
                     return true;
                 }
             }
diff -pruN 1.10.19-1/src/Composer/DependencyResolver/Transaction.php 2.0.9-1/src/Composer/DependencyResolver/Transaction.php
--- 1.10.19-1/src/Composer/DependencyResolver/Transaction.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/DependencyResolver/Transaction.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,161 +13,211 @@
 namespace Composer\DependencyResolver;
 
 use Composer\Package\AliasPackage;
+use Composer\Package\Link;
+use Composer\Package\PackageInterface;
+use Composer\Repository\PlatformRepository;
 
 /**
  * @author Nils Adermann <naderman@naderman.de>
+ * @internal
  */
 class Transaction
 {
-    protected $policy;
-    protected $pool;
-    protected $installedMap;
-    protected $decisions;
-    protected $transaction;
-
-    public function __construct($policy, $pool, $installedMap, $decisions)
-    {
-        $this->policy = $policy;
-        $this->pool = $pool;
-        $this->installedMap = $installedMap;
-        $this->decisions = $decisions;
-        $this->transaction = array();
+    /**
+     * @var array
+     */
+    protected $operations;
+
+    /**
+     * Packages present at the beginning of the transaction
+     * @var array
+     */
+    protected $presentPackages;
+
+    /**
+     * Package set resulting from this transaction
+     * @var array
+     */
+    protected $resultPackageMap;
+
+    /**
+     * @var array
+     */
+    protected $resultPackagesByName = array();
+
+    public function __construct($presentPackages, $resultPackages)
+    {
+        $this->presentPackages = $presentPackages;
+        $this->setResultPackageMaps($resultPackages);
+        $this->operations = $this->calculateOperations();
     }
 
     public function getOperations()
     {
-        $installMeansUpdateMap = $this->findUpdates();
-
-        $updateMap = array();
-        $installMap = array();
-        $uninstallMap = array();
-
-        foreach ($this->decisions as $i => $decision) {
-            $literal = $decision[Decisions::DECISION_LITERAL];
-            $reason = $decision[Decisions::DECISION_REASON];
-
-            $package = $this->pool->literalToPackage($literal);
-
-            // wanted & installed || !wanted & !installed
-            if (($literal > 0) == isset($this->installedMap[$package->id])) {
-                continue;
-            }
+        return $this->operations;
+    }
 
-            if ($literal > 0) {
-                if (isset($installMeansUpdateMap[abs($literal)]) && !$package instanceof AliasPackage) {
-                    $source = $installMeansUpdateMap[abs($literal)];
-
-                    $updateMap[$package->id] = array(
-                        'package' => $package,
-                        'source' => $source,
-                        'reason' => $reason,
-                    );
-
-                    // avoid updates to one package from multiple origins
-                    unset($installMeansUpdateMap[abs($literal)]);
-                    $ignoreRemove[$source->id] = true;
-                } else {
-                    $installMap[$package->id] = array(
-                        'package' => $package,
-                        'reason' => $reason,
-                    );
+    private function setResultPackageMaps($resultPackages)
+    {
+        $packageSort = function (PackageInterface $a, PackageInterface $b) {
+            // sort alias packages by the same name behind their non alias version
+            if ($a->getName() == $b->getName()) {
+                if ($a instanceof AliasPackage != $b instanceof AliasPackage) {
+                    return $a instanceof AliasPackage ? -1 : 1;
                 }
+                // if names are the same, compare version, e.g. to sort aliases reliably, actual order does not matter
+                return strcmp($b->getVersion(), $a->getVersion());
             }
-        }
 
-        foreach ($this->decisions as $i => $decision) {
-            $literal = $decision[Decisions::DECISION_LITERAL];
-            $reason = $decision[Decisions::DECISION_REASON];
-            $package = $this->pool->literalToPackage($literal);
+            return strcmp($b->getName(), $a->getName());
+        };
 
-            if ($literal <= 0 &&
-                isset($this->installedMap[$package->id]) &&
-                !isset($ignoreRemove[$package->id])) {
-                $uninstallMap[$package->id] = array(
-                    'package' => $package,
-                    'reason' => $reason,
-                );
+        $this->resultPackageMap = array();
+        foreach ($resultPackages as $package) {
+            $this->resultPackageMap[spl_object_hash($package)] = $package;
+            foreach ($package->getNames() as $name) {
+                $this->resultPackagesByName[$name][] = $package;
             }
         }
 
-        $this->transactionFromMaps($installMap, $updateMap, $uninstallMap);
-
-        return $this->transaction;
+        uasort($this->resultPackageMap, $packageSort);
+        foreach ($this->resultPackagesByName as $name => $packages) {
+            uasort($this->resultPackagesByName[$name], $packageSort);
+        }
     }
 
-    protected function transactionFromMaps($installMap, $updateMap, $uninstallMap)
+    protected function calculateOperations()
     {
-        $queue = array_map(
-            function ($operation) {
-                return $operation['package'];
-            },
-            $this->findRootPackages($installMap, $updateMap)
-        );
+        $operations = array();
+
+        $presentPackageMap = array();
+        $removeMap = array();
+        $presentAliasMap = array();
+        $removeAliasMap = array();
+        foreach ($this->presentPackages as $package) {
+            if ($package instanceof AliasPackage) {
+                $presentAliasMap[$package->getName().'::'.$package->getVersion()] = $package;
+                $removeAliasMap[$package->getName().'::'.$package->getVersion()] = $package;
+            } else {
+                $presentPackageMap[$package->getName()] = $package;
+                $removeMap[$package->getName()] = $package;
+            }
+        }
+
+        $stack = $this->getRootPackages();
 
         $visited = array();
+        $processed = array();
+
+        while (!empty($stack)) {
+            $package = array_pop($stack);
 
-        while (!empty($queue)) {
-            $package = array_pop($queue);
-            $packageId = $package->id;
+            if (isset($processed[spl_object_hash($package)])) {
+                continue;
+            }
 
-            if (!isset($visited[$packageId])) {
-                $queue[] = $package;
+            if (!isset($visited[spl_object_hash($package)])) {
+                $visited[spl_object_hash($package)] = true;
 
+                $stack[] = $package;
                 if ($package instanceof AliasPackage) {
-                    $queue[] = $package->getAliasOf();
+                    $stack[] = $package->getAliasOf();
                 } else {
                     foreach ($package->getRequires() as $link) {
-                        $possibleRequires = $this->pool->whatProvides($link->getTarget(), $link->getConstraint());
+                        $possibleRequires = $this->getProvidersInResult($link);
 
                         foreach ($possibleRequires as $require) {
-                            $queue[] = $require;
+                            $stack[] = $require;
                         }
                     }
                 }
+            } elseif (!isset($processed[spl_object_hash($package)])) {
+                $processed[spl_object_hash($package)] = true;
 
-                $visited[$package->id] = true;
-            } else {
-                if (isset($installMap[$packageId])) {
-                    $this->install(
-                        $installMap[$packageId]['package'],
-                        $installMap[$packageId]['reason']
-                    );
-                    unset($installMap[$packageId]);
-                }
-                if (isset($updateMap[$packageId])) {
-                    $this->update(
-                        $updateMap[$packageId]['source'],
-                        $updateMap[$packageId]['package'],
-                        $updateMap[$packageId]['reason']
-                    );
-                    unset($updateMap[$packageId]);
+                if ($package instanceof AliasPackage) {
+                    $aliasKey = $package->getName().'::'.$package->getVersion();
+                    if (isset($presentAliasMap[$aliasKey])) {
+                        unset($removeAliasMap[$aliasKey]);
+                    } else {
+                        $operations[] = new Operation\MarkAliasInstalledOperation($package);
+                    }
+                } else {
+                    if (isset($presentPackageMap[$package->getName()])) {
+                        $source = $presentPackageMap[$package->getName()];
+
+                        // do we need to update?
+                        // TODO different for lock?
+                        if ($package->getVersion() != $presentPackageMap[$package->getName()]->getVersion() ||
+                            $package->getDistReference() !== $presentPackageMap[$package->getName()]->getDistReference() ||
+                            $package->getSourceReference() !== $presentPackageMap[$package->getName()]->getSourceReference()
+                        ) {
+                            $operations[] = new Operation\UpdateOperation($source, $package);
+                        }
+                        unset($removeMap[$package->getName()]);
+                    } else {
+                        $operations[] = new Operation\InstallOperation($package);
+                        unset($removeMap[$package->getName()]);
+                    }
                 }
             }
         }
 
-        foreach ($uninstallMap as $uninstall) {
-            $this->uninstall($uninstall['package'], $uninstall['reason']);
+        foreach ($removeMap as $name => $package) {
+            array_unshift($operations, new Operation\UninstallOperation($package));
         }
+        foreach ($removeAliasMap as $nameVersion => $package) {
+            $operations[] = new Operation\MarkAliasUninstalledOperation($package);
+        }
+
+        $operations = $this->movePluginsToFront($operations);
+        // TODO fix this:
+        // we have to do this again here even though the above stack code did it because moving plugins moves them before uninstalls
+        $operations = $this->moveUninstallsToFront($operations);
+
+        // TODO skip updates which don't update? is this needed? we shouldn't schedule this update in the first place?
+        /*
+        if ('update' === $opType) {
+            $targetPackage = $operation->getTargetPackage();
+            if ($targetPackage->isDev()) {
+                $initialPackage = $operation->getInitialPackage();
+                if ($targetPackage->getVersion() === $initialPackage->getVersion()
+                    && (!$targetPackage->getSourceReference() || $targetPackage->getSourceReference() === $initialPackage->getSourceReference())
+                    && (!$targetPackage->getDistReference() || $targetPackage->getDistReference() === $initialPackage->getDistReference())
+                ) {
+                    $this->io->writeError('  - Skipping update of ' . $targetPackage->getPrettyName() . ' to the same reference-locked version', true, IOInterface::DEBUG);
+                    $this->io->writeError('', true, IOInterface::DEBUG);
+
+                    continue;
+                }
+            }
+        }*/
+
+        return $this->operations = $operations;
     }
 
-    protected function findRootPackages($installMap, $updateMap)
+    /**
+     * Determine which packages in the result are not required by any other packages in it.
+     *
+     * These serve as a starting point to enumerate packages in a topological order despite potential cycles.
+     * If there are packages with a cycle on the top level the package with the lowest name gets picked
+     *
+     * @return array
+     */
+    protected function getRootPackages()
     {
-        $packages = $installMap + $updateMap;
-        $roots = $packages;
+        $roots = $this->resultPackageMap;
 
-        foreach ($packages as $packageId => $operation) {
-            $package = $operation['package'];
-
-            if (!isset($roots[$packageId])) {
+        foreach ($this->resultPackageMap as $packageHash => $package) {
+            if (!isset($roots[$packageHash])) {
                 continue;
             }
 
             foreach ($package->getRequires() as $link) {
-                $possibleRequires = $this->pool->whatProvides($link->getTarget(), $link->getConstraint());
+                $possibleRequires = $this->getProvidersInResult($link);
 
                 foreach ($possibleRequires as $require) {
                     if ($require !== $package) {
-                        unset($roots[$require->id]);
+                        unset($roots[spl_object_hash($require)]);
                     }
                 }
             }
@@ -176,69 +226,115 @@ class Transaction
         return $roots;
     }
 
-    protected function findUpdates()
+    protected function getProvidersInResult(Link $link)
     {
-        $installMeansUpdateMap = array();
+        if (!isset($this->resultPackagesByName[$link->getTarget()])) {
+            return array();
+        }
 
-        foreach ($this->decisions as $i => $decision) {
-            $literal = $decision[Decisions::DECISION_LITERAL];
-            $package = $this->pool->literalToPackage($literal);
+        return $this->resultPackagesByName[$link->getTarget()];
+    }
 
-            if ($package instanceof AliasPackage) {
+    /**
+     * Workaround: if your packages depend on plugins, we must be sure
+     * that those are installed / updated first; else it would lead to packages
+     * being installed multiple times in different folders, when running Composer
+     * twice.
+     *
+     * While this does not fix the root-causes of https://github.com/composer/composer/issues/1147,
+     * it at least fixes the symptoms and makes usage of composer possible (again)
+     * in such scenarios.
+     *
+     * @param  Operation\OperationInterface[] $operations
+     * @return Operation\OperationInterface[] reordered operation list
+     */
+    private function movePluginsToFront(array $operations)
+    {
+        $dlModifyingPluginsNoDeps = array();
+        $dlModifyingPluginsWithDeps = array();
+        $dlModifyingPluginRequires = array();
+        $pluginsNoDeps = array();
+        $pluginsWithDeps = array();
+        $pluginRequires = array();
+
+        foreach (array_reverse($operations, true) as $idx => $op) {
+            if ($op instanceof Operation\InstallOperation) {
+                $package = $op->getPackage();
+            } elseif ($op instanceof Operation\UpdateOperation) {
+                $package = $op->getTargetPackage();
+            } else {
                 continue;
             }
 
-            // !wanted & installed
-            if ($literal <= 0 && isset($this->installedMap[$package->id])) {
-                $updates = $this->policy->findUpdatePackages($this->pool, $this->installedMap, $package);
+            $isDownloadsModifyingPlugin = $package->getType() === 'composer-plugin' && ($extra = $package->getExtra()) && isset($extra['plugin-modifies-downloads']) && $extra['plugin-modifies-downloads'] === true;
 
-                $literals = array($package->id);
-
-                foreach ($updates as $update) {
-                    $literals[] = $update->id;
+            // is this a downloads modifying plugin or a dependency of one?
+            if ($isDownloadsModifyingPlugin || count(array_intersect($package->getNames(), $dlModifyingPluginRequires))) {
+                // get the package's requires, but filter out any platform requirements
+                $requires = array_filter(array_keys($package->getRequires()), function ($req) {
+                    return !PlatformRepository::isPlatformPackage($req);
+                });
+
+                // is this a plugin with no meaningful dependencies?
+                if ($isDownloadsModifyingPlugin && !count($requires)) {
+                    // plugins with no dependencies go to the very front
+                    array_unshift($dlModifyingPluginsNoDeps, $op);
+                } else {
+                    // capture the requirements for this package so those packages will be moved up as well
+                    $dlModifyingPluginRequires = array_merge($dlModifyingPluginRequires, $requires);
+                    // move the operation to the front
+                    array_unshift($dlModifyingPluginsWithDeps, $op);
                 }
 
-                foreach ($literals as $updateLiteral) {
-                    if ($updateLiteral !== $literal) {
-                        $installMeansUpdateMap[abs($updateLiteral)] = $package;
-                    }
-                }
+                unset($operations[$idx]);
+                continue;
             }
-        }
 
-        return $installMeansUpdateMap;
-    }
-
-    protected function install($package, $reason)
-    {
-        if ($package instanceof AliasPackage) {
-            return $this->markAliasInstalled($package, $reason);
-        }
+            // is this package a plugin?
+            $isPlugin = $package->getType() === 'composer-plugin' || $package->getType() === 'composer-installer';
 
-        $this->transaction[] = new Operation\InstallOperation($package, $reason);
-    }
-
-    protected function update($from, $to, $reason)
-    {
-        $this->transaction[] = new Operation\UpdateOperation($from, $to, $reason);
-    }
+            // is this a plugin or a dependency of a plugin?
+            if ($isPlugin || count(array_intersect($package->getNames(), $pluginRequires))) {
+                // get the package's requires, but filter out any platform requirements
+                $requires = array_filter(array_keys($package->getRequires()), function ($req) {
+                    return !PlatformRepository::isPlatformPackage($req);
+                });
+
+                // is this a plugin with no meaningful dependencies?
+                if ($isPlugin && !count($requires)) {
+                    // plugins with no dependencies go to the very front
+                    array_unshift($pluginsNoDeps, $op);
+                } else {
+                    // capture the requirements for this package so those packages will be moved up as well
+                    $pluginRequires = array_merge($pluginRequires, $requires);
+                    // move the operation to the front
+                    array_unshift($pluginsWithDeps, $op);
+                }
 
-    protected function uninstall($package, $reason)
-    {
-        if ($package instanceof AliasPackage) {
-            return $this->markAliasUninstalled($package, $reason);
+                unset($operations[$idx]);
+            }
         }
 
-        $this->transaction[] = new Operation\UninstallOperation($package, $reason);
+        return array_merge($dlModifyingPluginsNoDeps, $dlModifyingPluginsWithDeps, $pluginsNoDeps, $pluginsWithDeps, $operations);
     }
 
-    protected function markAliasInstalled($package, $reason)
+    /**
+     * Removals of packages should be executed before installations in
+     * case two packages resolve to the same path (due to custom installers)
+     *
+     * @param  Operation\OperationInterface[] $operations
+     * @return Operation\OperationInterface[] reordered operation list
+     */
+    private function moveUninstallsToFront(array $operations)
     {
-        $this->transaction[] = new Operation\MarkAliasInstalledOperation($package, $reason);
-    }
+        $uninstOps = array();
+        foreach ($operations as $idx => $op) {
+            if ($op instanceof Operation\UninstallOperation || $op instanceof Operation\MarkAliasUninstalledOperation) {
+                $uninstOps[] = $op;
+                unset($operations[$idx]);
+            }
+        }
 
-    protected function markAliasUninstalled($package, $reason)
-    {
-        $this->transaction[] = new Operation\MarkAliasUninstalledOperation($package, $reason);
+        return array_merge($uninstOps, $operations);
     }
 }
diff -pruN 1.10.19-1/src/Composer/Downloader/ArchiveDownloader.php 2.0.9-1/src/Composer/Downloader/ArchiveDownloader.php
--- 1.10.19-1/src/Composer/Downloader/ArchiveDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/ArchiveDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,7 +14,8 @@ namespace Composer\Downloader;
 
 use Composer\Package\PackageInterface;
 use Symfony\Component\Finder\Finder;
-use Composer\IO\IOInterface;
+use React\Promise\PromiseInterface;
+use Composer\DependencyResolver\Operation\InstallOperation;
 
 /**
  * Base downloader for archives
@@ -30,79 +31,122 @@ abstract class ArchiveDownloader extends
      * @throws \RuntimeException
      * @throws \UnexpectedValueException
      */
-    public function download(PackageInterface $package, $path, $output = true)
+    public function install(PackageInterface $package, $path, $output = true)
     {
-        $temporaryDir = $this->config->get('vendor-dir').'/composer/'.substr(md5(uniqid('', true)), 0, 8);
-        $retries = 3;
-        while ($retries--) {
-            $fileName = parent::download($package, $path, $output);
+        if ($output) {
+            $this->io->writeError("  - " . InstallOperation::format($package).": Extracting archive");
+        } else {
+            $this->io->writeError('Extracting archive', false);
+        }
+
+        $vendorDir = $this->config->get('vendor-dir');
+
+        // clean up the target directory, unless it contains the vendor dir, as the vendor dir contains
+        // the archive to be extracted. This is the case when installing with create-project in the current directory
+        // but in that case we ensure the directory is empty already in ProjectInstaller so no need to empty it here.
+        if (false === strpos($this->filesystem->normalizePath($vendorDir), $this->filesystem->normalizePath($path.DIRECTORY_SEPARATOR))) {
+            $this->filesystem->emptyDirectory($path);
+        }
+
+        do {
+            $temporaryDir = $vendorDir.'/composer/'.substr(md5(uniqid('', true)), 0, 8);
+        } while (is_dir($temporaryDir));
+
+        $this->addCleanupPath($package, $temporaryDir);
+        // avoid cleaning up $path if installing in "." for eg create-project as we can not
+        // delete the directory we are currently in on windows
+        if (!is_dir($path) || realpath($path) !== getcwd()) {
+            $this->addCleanupPath($package, $path);
+        }
+
+        $this->filesystem->ensureDirectoryExists($temporaryDir);
+        $fileName = $this->getFileName($package, $path);
+
+        $filesystem = $this->filesystem;
+        $self = $this;
 
-            if ($output) {
-                $this->io->writeError(' Extracting archive', false, IOInterface::VERBOSE);
+        $cleanup = function () use ($path, $filesystem, $temporaryDir, $package, $self) {
+            // remove cache if the file was corrupted
+            $self->clearLastCacheWrite($package);
+
+            // clean up
+            $filesystem->removeDirectory($temporaryDir);
+            if (is_dir($path) && realpath($path) !== getcwd()) {
+                $filesystem->removeDirectory($path);
             }
+            $self->removeCleanupPath($package, $temporaryDir);
+            $self->removeCleanupPath($package, realpath($path));
+        };
+
+        $promise = null;
+        try {
+            $promise = $this->extract($package, $fileName, $temporaryDir);
+        } catch (\Exception $e) {
+            $cleanup();
+            throw $e;
+        }
 
-            try {
-                $this->filesystem->ensureDirectoryExists($temporaryDir);
-                try {
-                    $this->extract($fileName, $temporaryDir);
-                } catch (\Exception $e) {
-                    // remove cache if the file was corrupted
-                    parent::clearLastCacheWrite($package);
-                    throw $e;
-                }
+        if (!$promise instanceof PromiseInterface) {
+            $promise = \React\Promise\resolve();
+        }
+
+        return $promise->then(function () use ($self, $package, $filesystem, $fileName, $temporaryDir, $path) {
+            $filesystem->unlink($fileName);
 
-                $this->filesystem->unlink($fileName);
+            /**
+             * Returns the folder content, excluding .DS_Store
+             *
+             * @param  string         $dir Directory
+             * @return \SplFileInfo[]
+             */
+            $getFolderContent = function ($dir) {
+                $finder = Finder::create()
+                    ->ignoreVCS(false)
+                    ->ignoreDotFiles(false)
+                    ->notName('.DS_Store')
+                    ->depth(0)
+                    ->in($dir);
+
+                return iterator_to_array($finder);
+            };
+
+            $renameAsOne = false;
+            if (!file_exists($path) || ($filesystem->isDirEmpty($path) && $filesystem->removeDirectory($path))) {
+                $renameAsOne = true;
+            }
 
-                $contentDir = $this->getFolderContent($temporaryDir);
+            $contentDir = $getFolderContent($temporaryDir);
+            $singleDirAtTopLevel = 1 === count($contentDir) && is_dir(reset($contentDir));
 
+            if ($renameAsOne) {
+                // if the target $path is clear, we can rename the whole package in one go instead of looping over the contents
+                if ($singleDirAtTopLevel) {
+                    $extractedDir = (string) reset($contentDir);
+                } else {
+                    $extractedDir = $temporaryDir;
+                }
+                $filesystem->rename($extractedDir, $path);
+            } else {
                 // only one dir in the archive, extract its contents out of it
-                if (1 === count($contentDir) && is_dir(reset($contentDir))) {
-                    $contentDir = $this->getFolderContent((string) reset($contentDir));
+                if ($singleDirAtTopLevel) {
+                    $contentDir = $getFolderContent((string) reset($contentDir));
                 }
 
                 // move files back out of the temp dir
                 foreach ($contentDir as $file) {
                     $file = (string) $file;
-                    $this->filesystem->rename($file, $path . '/' . basename($file));
-                }
-
-                $this->filesystem->removeDirectory($temporaryDir);
-                if ($this->filesystem->isDirEmpty($this->config->get('vendor-dir').'/composer/')) {
-                    $this->filesystem->removeDirectory($this->config->get('vendor-dir').'/composer/');
+                    $filesystem->rename($file, $path . '/' . basename($file));
                 }
-                if ($this->filesystem->isDirEmpty($this->config->get('vendor-dir'))) {
-                    $this->filesystem->removeDirectory($this->config->get('vendor-dir'));
-                }
-            } catch (\Exception $e) {
-                // clean up
-                $this->filesystem->removeDirectory($path);
-                $this->filesystem->removeDirectory($temporaryDir);
-
-                // retry downloading if we have an invalid zip file
-                if ($retries && $e instanceof \UnexpectedValueException && class_exists('ZipArchive') && $e->getCode() === \ZipArchive::ER_NOZIP) {
-                    $this->io->writeError('');
-                    if ($this->io->isDebug()) {
-                        $this->io->writeError('    Invalid zip file ('.$e->getMessage().'), retrying...');
-                    } else {
-                        $this->io->writeError('    Invalid zip file, retrying...');
-                    }
-                    usleep(500000);
-                    continue;
-                }
-
-                throw $e;
             }
 
-            break;
-        }
-    }
+            $filesystem->removeDirectory($temporaryDir);
+            $self->removeCleanupPath($package, $temporaryDir);
+            $self->removeCleanupPath($package, $path);
+        }, function ($e) use ($cleanup) {
+            $cleanup();
 
-    /**
-     * {@inheritdoc}
-     */
-    protected function getFileName(PackageInterface $package, $path)
-    {
-        return rtrim($path.'/'.md5($path.spl_object_hash($package)).'.'.pathinfo(parse_url($package->getDistUrl(), PHP_URL_PATH), PATHINFO_EXTENSION), '.');
+            throw $e;
+        });
     }
 
     /**
@@ -112,24 +156,7 @@ abstract class ArchiveDownloader extends
      * @param string $path Directory
      *
      * @throws \UnexpectedValueException If can not extract downloaded file to path
+     * @return PromiseInterface|null
      */
-    abstract protected function extract($file, $path);
-
-    /**
-     * Returns the folder content, excluding dotfiles
-     *
-     * @param  string         $dir Directory
-     * @return \SplFileInfo[]
-     */
-    private function getFolderContent($dir)
-    {
-        $finder = Finder::create()
-            ->ignoreVCS(false)
-            ->ignoreDotFiles(false)
-            ->notName('.DS_Store')
-            ->depth(0)
-            ->in($dir);
-
-        return iterator_to_array($finder);
-    }
+    abstract protected function extract(PackageInterface $package, $file, $path);
 }
diff -pruN 1.10.19-1/src/Composer/Downloader/DownloaderInterface.php 2.0.9-1/src/Composer/Downloader/DownloaderInterface.php
--- 1.10.19-1/src/Composer/Downloader/DownloaderInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/DownloaderInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,7 @@
 namespace Composer\Downloader;
 
 use Composer\Package\PackageInterface;
+use React\Promise\PromiseInterface;
 
 /**
  * Downloader interface.
@@ -30,12 +31,35 @@ interface DownloaderInterface
     public function getInstallationSource();
 
     /**
-     * Downloads specific package into specific folder.
+     * This should do any network-related tasks to prepare for an upcoming install/update
+     *
+     * @return PromiseInterface|null
+     */
+    public function download(PackageInterface $package, $path, PackageInterface $prevPackage = null);
+
+    /**
+     * Do anything that needs to be done between all downloads have been completed and the actual operation is executed
+     *
+     * All packages get first downloaded, then all together prepared, then all together installed/updated/uninstalled. Therefore
+     * for error recovery it is important to avoid failing during install/update/uninstall as much as possible, and risky things or
+     * user prompts should happen in the prepare step rather. In case of failure, cleanup() will be called so that changes can
+     * be undone as much as possible.
+     *
+     * @param  string                $type        one of install/update/uninstall
+     * @param  PackageInterface      $package     package instance
+     * @param  string                $path        download path
+     * @param  PackageInterface      $prevPackage previous package instance in case of an update
+     * @return PromiseInterface|null
+     */
+    public function prepare($type, PackageInterface $package, $path, PackageInterface $prevPackage = null);
+
+    /**
+     * Installs specific package into specific folder.
      *
      * @param PackageInterface $package package instance
      * @param string           $path    download path
      */
-    public function download(PackageInterface $package, $path);
+    public function install(PackageInterface $package, $path);
 
     /**
      * Updates specific package in specific folder from initial to target version.
@@ -55,10 +79,17 @@ interface DownloaderInterface
     public function remove(PackageInterface $package, $path);
 
     /**
-     * Sets whether to output download progress information or not
+     * Do anything to cleanup changes applied in the prepare or install/update/uninstall steps
+     *
+     * Note that cleanup will be called for all packages, either after install/update/uninstall is complete,
+     * or if any package failed any operation. This is to give all installers a change to cleanup things
+     * they did previously, so you need to keep track of changes applied in the installer/downloader themselves.
      *
-     * @param  bool                $outputProgress
-     * @return DownloaderInterface
+     * @param  string                $type        one of install/update/uninstall
+     * @param  PackageInterface      $package     package instance
+     * @param  string                $path        download path
+     * @param  PackageInterface      $prevPackage previous package instance in case of an update
+     * @return PromiseInterface|null
      */
-    public function setOutputProgress($outputProgress);
+    public function cleanup($type, PackageInterface $package, $path, PackageInterface $prevPackage = null);
 }
diff -pruN 1.10.19-1/src/Composer/Downloader/DownloadManager.php 2.0.9-1/src/Composer/Downloader/DownloadManager.php
--- 1.10.19-1/src/Composer/Downloader/DownloadManager.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/DownloadManager.php	2021-01-27 15:09:27.000000000 +0000
@@ -15,6 +15,8 @@ namespace Composer\Downloader;
 use Composer\Package\PackageInterface;
 use Composer\IO\IOInterface;
 use Composer\Util\Filesystem;
+use Composer\Exception\IrrecoverableDownloadException;
+use React\Promise\PromiseInterface;
 
 /**
  * Downloaders manager.
@@ -23,11 +25,17 @@ use Composer\Util\Filesystem;
  */
 class DownloadManager
 {
+    /** @var IOInterface */
     private $io;
+    /** @var bool */
     private $preferDist = false;
-    private $preferSource = false;
+    /** @var bool */
+    private $preferSource;
+    /** @var array<string, string> */
     private $packagePreferences = array();
+    /** @var Filesystem */
     private $filesystem;
+    /** @var array<string, DownloaderInterface> */
     private $downloaders = array();
 
     /**
@@ -84,22 +92,6 @@ class DownloadManager
     }
 
     /**
-     * Sets whether to output download progress information for all registered
-     * downloaders
-     *
-     * @param  bool            $outputProgress
-     * @return DownloadManager
-     */
-    public function setOutputProgress($outputProgress)
-    {
-        foreach ($this->downloaders as $downloader) {
-            $downloader->setOutputProgress($outputProgress);
-        }
-
-        return $this;
-    }
-
-    /**
      * Sets installer downloader for a specific installation type.
      *
      * @param  string              $type       installation type
@@ -140,7 +132,7 @@ class DownloadManager
      *                                           wrong type
      * @return DownloaderInterface|null
      */
-    public function getDownloaderForInstalledPackage(PackageInterface $package)
+    public function getDownloaderForPackage(PackageInterface $package)
     {
         $installationSource = $package->getInstallationSource();
 
@@ -154,7 +146,7 @@ class DownloadManager
             $downloader = $this->getDownloader($package->getSourceType());
         } else {
             throw new \InvalidArgumentException(
-                'Package '.$package.' seems not been installed properly'
+                'Package '.$package.' does not have an installation source set'
             );
         }
 
@@ -171,63 +163,117 @@ class DownloadManager
         return $downloader;
     }
 
+    public function getDownloaderType(DownloaderInterface $downloader)
+    {
+        return array_search($downloader, $this->downloaders);
+    }
+
     /**
      * Downloads package into target dir.
      *
-     * @param PackageInterface $package      package instance
-     * @param string           $targetDir    target dir
-     * @param bool             $preferSource prefer installation from source
+     * @param PackageInterface      $package     package instance
+     * @param string                $targetDir   target dir
+     * @param PackageInterface|null $prevPackage previous package instance in case of updates
      *
      * @throws \InvalidArgumentException if package have no urls to download from
      * @throws \RuntimeException
+     * @return PromiseInterface
      */
-    public function download(PackageInterface $package, $targetDir, $preferSource = null)
+    public function download(PackageInterface $package, $targetDir, PackageInterface $prevPackage = null)
     {
-        $preferSource = null !== $preferSource ? $preferSource : $this->preferSource;
-        $sourceType = $package->getSourceType();
-        $distType = $package->getDistType();
+        $targetDir = $this->normalizeTargetDir($targetDir);
+        $this->filesystem->ensureDirectoryExists(dirname($targetDir));
 
-        $sources = array();
-        if ($sourceType) {
-            $sources[] = 'source';
-        }
-        if ($distType) {
-            $sources[] = 'dist';
-        }
+        $sources = $this->getAvailableSources($package, $prevPackage);
 
-        if (empty($sources)) {
-            throw new \InvalidArgumentException('Package '.$package.' must have a source or dist specified');
-        }
-
-        if (!$preferSource && ($this->preferDist || 'dist' === $this->resolvePackageInstallPreference($package))) {
-            $sources = array_reverse($sources);
-        }
+        $io = $this->io;
+        $self = $this;
 
-        $this->filesystem->ensureDirectoryExists($targetDir);
-
-        foreach ($sources as $i => $source) {
-            if (isset($e)) {
-                $this->io->writeError('    <warning>Now trying to download from ' . $source . '</warning>');
+        $download = function ($retry = false) use (&$sources, $io, $package, $self, $targetDir, &$download, $prevPackage) {
+            $source = array_shift($sources);
+            if ($retry) {
+                $io->writeError('    <warning>Now trying to download from ' . $source . '</warning>');
             }
             $package->setInstallationSource($source);
-            try {
-                $downloader = $this->getDownloaderForInstalledPackage($package);
-                if ($downloader) {
-                    $downloader->download($package, $targetDir);
-                }
-                break;
-            } catch (\RuntimeException $e) {
-                if ($i === count($sources) - 1) {
-                    throw $e;
+
+            $downloader = $self->getDownloaderForPackage($package);
+            if (!$downloader) {
+                return \React\Promise\resolve();
+            }
+
+            $handleError = function ($e) use ($sources, $source, $package, $io, $download) {
+                if ($e instanceof \RuntimeException && !$e instanceof IrrecoverableDownloadException) {
+                    if (!$sources) {
+                        throw $e;
+                    }
+
+                    $io->writeError(
+                        '    <warning>Failed to download '.
+                        $package->getPrettyName().
+                        ' from ' . $source . ': '.
+                        $e->getMessage().'</warning>'
+                    );
+
+                    return $download(true);
                 }
 
-                $this->io->writeError(
-                    '    <warning>Failed to download '.
-                    $package->getPrettyName().
-                    ' from ' . $source . ': '.
-                    $e->getMessage().'</warning>'
-                );
+                throw $e;
+            };
+
+            try {
+                $result = $downloader->download($package, $targetDir, $prevPackage);
+            } catch (\Exception $e) {
+                return $handleError($e);
             }
+            if (!$result instanceof PromiseInterface) {
+                return \React\Promise\resolve($result);
+            }
+
+            $res = $result->then(function ($res) {
+                return $res;
+            }, $handleError);
+
+            return $res;
+        };
+
+        return $download();
+    }
+
+    /**
+     * Prepares an operation execution
+     *
+     * @param string                $type        one of install/update/uninstall
+     * @param PackageInterface      $package     package instance
+     * @param string                $targetDir   target dir
+     * @param PackageInterface|null $prevPackage previous package instance in case of updates
+     *
+     * @return PromiseInterface|null
+     */
+    public function prepare($type, PackageInterface $package, $targetDir, PackageInterface $prevPackage = null)
+    {
+        $targetDir = $this->normalizeTargetDir($targetDir);
+        $downloader = $this->getDownloaderForPackage($package);
+        if ($downloader) {
+            return $downloader->prepare($type, $package, $targetDir, $prevPackage);
+        }
+    }
+
+    /**
+     * Installs package into target dir.
+     *
+     * @param PackageInterface $package   package instance
+     * @param string           $targetDir target dir
+     *
+     * @throws \InvalidArgumentException if package have no urls to download from
+     * @throws \RuntimeException
+     * @return PromiseInterface|null
+     */
+    public function install(PackageInterface $package, $targetDir)
+    {
+        $targetDir = $this->normalizeTargetDir($targetDir);
+        $downloader = $this->getDownloaderForPackage($package);
+        if ($downloader) {
+            return $downloader->install($package, $targetDir);
         }
     }
 
@@ -239,51 +285,52 @@ class DownloadManager
      * @param string           $targetDir target dir
      *
      * @throws \InvalidArgumentException if initial package is not installed
+     * @return PromiseInterface|null
      */
     public function update(PackageInterface $initial, PackageInterface $target, $targetDir)
     {
-        $downloader = $this->getDownloaderForInstalledPackage($initial);
-        if (!$downloader) {
-            return;
-        }
-
-        $installationSource = $initial->getInstallationSource();
+        $targetDir = $this->normalizeTargetDir($targetDir);
+        $downloader = $this->getDownloaderForPackage($target);
+        $initialDownloader = $this->getDownloaderForPackage($initial);
 
-        if ('dist' === $installationSource) {
-            $initialType = $initial->getDistType();
-            $targetType = $target->getDistType();
-        } else {
-            $initialType = $initial->getSourceType();
-            $targetType = $target->getSourceType();
+        // no downloaders present means update from metapackage to metapackage, nothing to do
+        if (!$initialDownloader && !$downloader) {
+            return;
         }
 
-        // upgrading from a dist stable package to a dev package, force source reinstall
-        if ($target->isDev() && 'dist' === $installationSource) {
-            $downloader->remove($initial, $targetDir);
-            $this->download($target, $targetDir);
-
-            return;
+        // if we have a downloader present before, but not after, the package became a metapackage and its files should be removed
+        if (!$downloader) {
+            return $initialDownloader->remove($initial, $targetDir);
         }
 
+        $initialType = $this->getDownloaderType($initialDownloader);
+        $targetType = $this->getDownloaderType($downloader);
         if ($initialType === $targetType) {
-            $target->setInstallationSource($installationSource);
             try {
-                $downloader->update($initial, $target, $targetDir);
-
-                return;
+                return $downloader->update($initial, $target, $targetDir);
             } catch (\RuntimeException $e) {
                 if (!$this->io->isInteractive()) {
                     throw $e;
                 }
                 $this->io->writeError('<error>    Update failed ('.$e->getMessage().')</error>');
-                if (!$this->io->askConfirmation('    Would you like to try reinstalling the package instead [<comment>yes</comment>]? ', true)) {
+                if (!$this->io->askConfirmation('    Would you like to try reinstalling the package instead [<comment>yes</comment>]? ')) {
                     throw $e;
                 }
             }
         }
 
-        $downloader->remove($initial, $targetDir);
-        $this->download($target, $targetDir, 'source' === $installationSource);
+        // if downloader type changed, or update failed and user asks for reinstall,
+        // we wipe the dir and do a new install instead of updating it
+        $promise = $initialDownloader->remove($initial, $targetDir);
+        if ($promise) {
+            $self = $this;
+
+            return $promise->then(function ($res) use ($self, $target, $targetDir) {
+                return $self->install($target, $targetDir);
+            });
+        }
+
+        return $this->install($target, $targetDir);
     }
 
     /**
@@ -291,12 +338,34 @@ class DownloadManager
      *
      * @param PackageInterface $package   package instance
      * @param string           $targetDir target dir
+     *
+     * @return PromiseInterface|null
      */
     public function remove(PackageInterface $package, $targetDir)
     {
-        $downloader = $this->getDownloaderForInstalledPackage($package);
+        $targetDir = $this->normalizeTargetDir($targetDir);
+        $downloader = $this->getDownloaderForPackage($package);
         if ($downloader) {
-            $downloader->remove($package, $targetDir);
+            return $downloader->remove($package, $targetDir);
+        }
+    }
+
+    /**
+     * Cleans up a failed operation
+     *
+     * @param string                $type        one of install/update/uninstall
+     * @param PackageInterface      $package     package instance
+     * @param string                $targetDir   target dir
+     * @param PackageInterface|null $prevPackage previous package instance in case of updates
+     *
+     * @return PromiseInterface|null
+     */
+    public function cleanup($type, PackageInterface $package, $targetDir, PackageInterface $prevPackage = null)
+    {
+        $targetDir = $this->normalizeTargetDir($targetDir);
+        $downloader = $this->getDownloaderForPackage($package);
+        if ($downloader) {
+            return $downloader->cleanup($type, $package, $targetDir, $prevPackage);
         }
     }
 
@@ -322,4 +391,64 @@ class DownloadManager
 
         return $package->isDev() ? 'source' : 'dist';
     }
+
+    /**
+     * @return string[]
+     */
+    private function getAvailableSources(PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+        $sourceType = $package->getSourceType();
+        $distType = $package->getDistType();
+
+        // add source before dist by default
+        $sources = array();
+        if ($sourceType) {
+            $sources[] = 'source';
+        }
+        if ($distType) {
+            $sources[] = 'dist';
+        }
+
+        if (empty($sources)) {
+            throw new \InvalidArgumentException('Package '.$package.' must have a source or dist specified');
+        }
+
+        if (
+            $prevPackage
+            // if we are updating, we want to keep the same source as the previously installed package (if available in the new one)
+            && in_array($prevPackage->getInstallationSource(), $sources, true)
+            // unless the previous package was stable dist (by default) and the new package is dev, then we allow the new default to take over
+            && !(!$prevPackage->isDev() && $prevPackage->getInstallationSource() === 'dist' && $package->isDev())
+        ) {
+            $prevSource = $prevPackage->getInstallationSource();
+            usort($sources, function ($a, $b) use ($prevSource) {
+                return $a === $prevSource ? -1 : 1;
+            });
+
+            return $sources;
+        }
+
+        // reverse sources in case dist is the preferred source for this package
+        if (!$this->preferSource && ($this->preferDist || 'dist' === $this->resolvePackageInstallPreference($package))) {
+            $sources = array_reverse($sources);
+        }
+
+        return $sources;
+    }
+
+    /**
+     * Downloaders expect a /path/to/dir without trailing slash
+     *
+     * If any Installer provides a path with a trailing slash, this can cause bugs so make sure we remove them
+     *
+     * @return string
+     */
+    private function normalizeTargetDir($dir)
+    {
+        if ($dir === '\\' || $dir === '/') {
+            return $dir;
+        }
+
+        return rtrim($dir, '\\/');
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Downloader/FileDownloader.php 2.0.9-1/src/Composer/Downloader/FileDownloader.php
--- 1.10.19-1/src/Composer/Downloader/FileDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/FileDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,18 +14,22 @@ namespace Composer\Downloader;
 
 use Composer\Config;
 use Composer\Cache;
-use Composer\Factory;
 use Composer\IO\IOInterface;
 use Composer\IO\NullIO;
 use Composer\Package\Comparer\Comparer;
+use Composer\DependencyResolver\Operation\UpdateOperation;
+use Composer\DependencyResolver\Operation\InstallOperation;
+use Composer\DependencyResolver\Operation\UninstallOperation;
 use Composer\Package\PackageInterface;
-use Composer\Package\Version\VersionParser;
 use Composer\Plugin\PluginEvents;
+use Composer\Plugin\PostFileDownloadEvent;
 use Composer\Plugin\PreFileDownloadEvent;
 use Composer\EventDispatcher\EventDispatcher;
 use Composer\Util\Filesystem;
-use Composer\Util\RemoteFilesystem;
+use Composer\Util\HttpDownloader;
 use Composer\Util\Url as UrlUtil;
+use Composer\Util\ProcessExecutor;
+use React\Promise\PromiseInterface;
 
 /**
  * Base downloader for files
@@ -37,33 +41,45 @@ use Composer\Util\Url as UrlUtil;
  */
 class FileDownloader implements DownloaderInterface, ChangeReportInterface
 {
+    /** @var IOInterface */
     protected $io;
+    /** @var Config */
     protected $config;
-    protected $rfs;
+    /** @var HttpDownloader */
+    protected $httpDownloader;
+    /** @var Filesystem */
     protected $filesystem;
+    /** @var Cache */
     protected $cache;
-    protected $outputProgress = true;
-    private $lastCacheWrites = array();
-    private $eventDispatcher;
+    /** @var EventDispatcher */
+    protected $eventDispatcher;
+    /** @var ProcessExecutor */
+    protected $process;
+    /**
+     * @private this is only public for php 5.3 support in closures
+     */
+    public $lastCacheWrites = array();
+    private $additionalCleanupPaths = array();
 
     /**
      * Constructor.
      *
-     * @param IOInterface      $io              The IO instance
-     * @param Config           $config          The config
-     * @param EventDispatcher  $eventDispatcher The event dispatcher
-     * @param Cache            $cache           Optional cache instance
-     * @param RemoteFilesystem $rfs             The remote filesystem
-     * @param Filesystem       $filesystem      The filesystem
+     * @param IOInterface     $io              The IO instance
+     * @param Config          $config          The config
+     * @param HttpDownloader  $httpDownloader  The remote filesystem
+     * @param EventDispatcher $eventDispatcher The event dispatcher
+     * @param Cache           $cache           Cache instance
+     * @param Filesystem      $filesystem      The filesystem
      */
-    public function __construct(IOInterface $io, Config $config, EventDispatcher $eventDispatcher = null, Cache $cache = null, RemoteFilesystem $rfs = null, Filesystem $filesystem = null)
+    public function __construct(IOInterface $io, Config $config, HttpDownloader $httpDownloader, EventDispatcher $eventDispatcher = null, Cache $cache = null, Filesystem $filesystem = null, ProcessExecutor $process = null)
     {
         $this->io = $io;
         $this->config = $config;
         $this->eventDispatcher = $eventDispatcher;
-        $this->rfs = $rfs ?: Factory::createRemoteFilesystem($this->io, $config);
-        $this->filesystem = $filesystem ?: new Filesystem();
+        $this->httpDownloader = $httpDownloader;
         $this->cache = $cache;
+        $this->process = $process ?: new ProcessExecutor($io);
+        $this->filesystem = $filesystem ?: new Filesystem($this->process);
 
         if ($this->cache && $this->cache->gcIsNecessary()) {
             $this->cache->gc($config->get('cache-files-ttl'), $config->get('cache-files-maxsize'));
@@ -81,127 +97,224 @@ class FileDownloader implements Download
     /**
      * {@inheritDoc}
      */
-    public function download(PackageInterface $package, $path, $output = true)
+    public function download(PackageInterface $package, $path, PackageInterface $prevPackage = null, $output = true)
     {
         if (!$package->getDistUrl()) {
             throw new \InvalidArgumentException('The given package is missing url information');
         }
 
-        if ($output) {
-            $this->io->writeError("  - Installing <info>" . $package->getName() . "</info> (<comment>" . $package->getFullPrettyVersion() . "</comment>): ", false);
-        }
-
-        $urls = $package->getDistUrls();
-        while ($url = array_shift($urls)) {
-            try {
-                $fileName = $this->doDownload($package, $path, $url);
-                break;
-            } catch (\Exception $e) {
-                if ($this->io->isDebug()) {
-                    $this->io->writeError('');
-                    $this->io->writeError('Failed: ['.get_class($e).'] '.$e->getCode().': '.$e->getMessage());
-                } elseif (count($urls)) {
-                    $this->io->writeError('');
-                    $this->io->writeError(' Failed, trying the next URL ('.$e->getCode().': '.$e->getMessage().')', false);
-                }
+        $cacheKeyGenerator = function (PackageInterface $package, $key) {
+            $cacheKey = sha1($key);
 
-                if (!count($urls)) {
-                    throw $e;
-                }
-            }
-        }
+            return $package->getName().'/'.$cacheKey.'.'.$package->getDistType();
+        };
 
-        if ($output) {
-            $this->io->writeError('');
+        $retries = 3;
+        $urls = $package->getDistUrls();
+        foreach ($urls as $index => $url) {
+            $processedUrl = $this->processUrl($package, $url);
+            $urls[$index] = array(
+                'base' => $url,
+                'processed' => $processedUrl,
+                // we use the complete download url here to avoid conflicting entries
+                // from different packages, which would potentially allow a given package
+                // in a third party repo to pre-populate the cache for the same package in
+                // packagist for example.
+                'cacheKey' => $cacheKeyGenerator($package, $processedUrl),
+            );
         }
 
-        return $fileName;
-    }
-
-    protected function doDownload(PackageInterface $package, $path, $url)
-    {
-        $this->filesystem->emptyDirectory($path);
-
         $fileName = $this->getFileName($package, $path);
+        $this->filesystem->ensureDirectoryExists($path);
+        $this->filesystem->ensureDirectoryExists(dirname($fileName));
 
-        $processedUrl = $this->processUrl($package, $url);
-        $origin = RemoteFilesystem::getOrigin($processedUrl);
+        $io = $this->io;
+        $cache = $this->cache;
+        $httpDownloader = $this->httpDownloader;
+        $eventDispatcher = $this->eventDispatcher;
+        $filesystem = $this->filesystem;
+        $self = $this;
+
+        $accept = null;
+        $reject = null;
+        $download = function () use ($io, $output, $httpDownloader, $cache, $cacheKeyGenerator, $eventDispatcher, $package, $fileName, &$urls, &$accept, &$reject) {
+            $url = reset($urls);
+            $index = key($urls);
+
+            if ($eventDispatcher) {
+                $preFileDownloadEvent = new PreFileDownloadEvent(PluginEvents::PRE_FILE_DOWNLOAD, $httpDownloader, $url['processed'], 'package', $package);
+                $eventDispatcher->dispatch($preFileDownloadEvent->getName(), $preFileDownloadEvent);
+                if ($preFileDownloadEvent->getCustomCacheKey() !== null) {
+                    $url['cacheKey'] = $cacheKeyGenerator($package, $preFileDownloadEvent->getCustomCacheKey());
+                } elseif ($preFileDownloadEvent->getProcessedUrl() !== $url['processed']) {
+                    $url['cacheKey'] = $cacheKeyGenerator($package, $preFileDownloadEvent->getProcessedUrl());
+                }
+                $url['processed'] = $preFileDownloadEvent->getProcessedUrl();
+            }
 
-        $preFileDownloadEvent = new PreFileDownloadEvent(PluginEvents::PRE_FILE_DOWNLOAD, $this->rfs, $processedUrl);
-        if ($this->eventDispatcher) {
-            $this->eventDispatcher->dispatch($preFileDownloadEvent->getName(), $preFileDownloadEvent);
-        }
-        $rfs = $preFileDownloadEvent->getRemoteFilesystem();
+            $urls[$index] = $url;
 
-        try {
             $checksum = $package->getDistSha1Checksum();
-            $cacheKey = $this->getCacheKey($package, $processedUrl);
+            $cacheKey = $url['cacheKey'];
 
             // use from cache if it is present and has a valid checksum or we have no checksum to check against
-            if ($this->cache && (!$checksum || $checksum === $this->cache->sha1($cacheKey)) && $this->cache->copyTo($cacheKey, $fileName)) {
-                $this->io->writeError('Loading from cache', false);
+            if ($cache && (!$checksum || $checksum === $cache->sha1($cacheKey)) && $cache->copyTo($cacheKey, $fileName)) {
+                if ($output) {
+                    $io->writeError("  - Loading <info>" . $package->getName() . "</info> (<comment>" . $package->getFullPrettyVersion() . "</comment>) from cache", true, IOInterface::VERY_VERBOSE);
+                }
+                $result = \React\Promise\resolve($fileName);
             } else {
-                // download if cache restore failed
-                if (!$this->outputProgress) {
-                    $this->io->writeError('Downloading', false);
+                if ($output) {
+                    $io->writeError("  - Downloading <info>" . $package->getName() . "</info> (<comment>" . $package->getFullPrettyVersion() . "</comment>)");
                 }
 
-                // try to download 3 times then fail hard
-                $retries = 3;
-                while ($retries--) {
-                    try {
-                        $rfs->copy($origin, $processedUrl, $fileName, $this->outputProgress, $package->getTransportOptions());
-                        break;
-                    } catch (TransportException $e) {
-                        // if we got an http response with a proper code, then requesting again will probably not help, abort
-                        if ((0 !== $e->getCode() && !in_array($e->getCode(), array(500, 502, 503, 504))) || !$retries) {
-                            throw $e;
-                        }
-                        $this->io->writeError('');
-                        $this->io->writeError('    Download failed, retrying...', true, IOInterface::VERBOSE);
-                        usleep(500000);
-                    }
+                $result = $httpDownloader->addCopy($url['processed'], $fileName, $package->getTransportOptions())
+                    ->then($accept, $reject);
+            }
+
+            return $result->then(function ($result) use ($fileName, $checksum, $url, $package, $eventDispatcher) {
+                // in case of retry, the first call's Promise chain finally calls this twice at the end,
+                // once with $result being the returned $fileName from $accept, and then once for every
+                // failed request with a null result, which can be skipped.
+                if (null === $result) {
+                    return $fileName;
+                }
+
+                if (!file_exists($fileName)) {
+                    throw new \UnexpectedValueException($url['base'].' could not be saved to '.$fileName.', make sure the'
+                        .' directory is writable and you have internet connectivity');
                 }
 
-                if (!$this->outputProgress) {
-                    $this->io->writeError(' (<comment>100%</comment>)', false);
+                if ($checksum && hash_file('sha1', $fileName) !== $checksum) {
+                    throw new \UnexpectedValueException('The checksum verification of the file failed (downloaded from '.$url['base'].')');
                 }
 
-                if ($this->cache) {
-                    $this->lastCacheWrites[$package->getName()] = $cacheKey;
-                    $this->cache->copyFrom($cacheKey, $fileName);
+                if ($eventDispatcher) {
+                    $postFileDownloadEvent = new PostFileDownloadEvent(PluginEvents::POST_FILE_DOWNLOAD, $fileName, $checksum, $url['processed'], $package);
+                    $eventDispatcher->dispatch($postFileDownloadEvent->getName(), $postFileDownloadEvent);
                 }
+
+                return $fileName;
+            });
+        };
+
+        $accept = function ($response) use ($cache, $package, $fileName, $self, &$urls) {
+            $url = reset($urls);
+            $cacheKey = $url['cacheKey'];
+
+            if ($cache && !$cache->isReadOnly()) {
+                $self->lastCacheWrites[$package->getName()] = $cacheKey;
+                $cache->copyFrom($cacheKey, $fileName);
             }
 
-            if (!file_exists($fileName)) {
-                throw new \UnexpectedValueException($url.' could not be saved to '.$fileName.', make sure the'
-                    .' directory is writable and you have internet connectivity');
+            $response->collect();
+
+            return $fileName;
+        };
+
+        $reject = function ($e) use ($io, &$urls, $download, $fileName, $package, &$retries, $filesystem, $self) {
+            // clean up
+            if (file_exists($fileName)) {
+                $filesystem->unlink($fileName);
             }
+            $self->clearLastCacheWrite($package);
 
-            if ($checksum && hash_file('sha1', $fileName) !== $checksum) {
-                throw new \UnexpectedValueException('The checksum verification of the file failed (downloaded from '.$url.')');
+            if ($e instanceof TransportException) {
+                // if we got an http response with a proper code, then requesting again will probably not help, abort
+                if ((0 !== $e->getCode() && !in_array($e->getCode(), array(500, 502, 503, 504))) || !$retries) {
+                    $retries = 0;
+                }
             }
-        } catch (\Exception $e) {
-            // clean up
-            $this->filesystem->removeDirectory($path);
-            $this->clearLastCacheWrite($package);
+
+            // special error code returned when network is being artificially disabled
+            if ($e instanceof TransportException && $e->getStatusCode() === 499) {
+                $retries = 0;
+                $urls = array();
+            }
+
+            if ($retries) {
+                usleep(500000);
+                $retries--;
+
+                return $download();
+            }
+
+            array_shift($urls);
+            if ($urls) {
+                if ($io->isDebug()) {
+                    $io->writeError('    Failed downloading '.$package->getName().': ['.get_class($e).'] '.$e->getCode().': '.$e->getMessage());
+                    $io->writeError('    Trying the next URL for '.$package->getName());
+                } else {
+                    $io->writeError('    Failed downloading '.$package->getName().', trying the next URL ('.$e->getCode().': '.$e->getMessage().')');
+                }
+
+                $retries = 3;
+                usleep(100000);
+
+                return $download();
+            }
+
             throw $e;
+        };
+
+        return $download();
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function prepare($type, PackageInterface $package, $path, PackageInterface $prevPackage = null)
+    {
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function cleanup($type, PackageInterface $package, $path, PackageInterface $prevPackage = null)
+    {
+        $fileName = $this->getFileName($package, $path);
+        if (file_exists($fileName)) {
+            $this->filesystem->unlink($fileName);
         }
 
-        return $fileName;
+        $dirsToCleanUp = array(
+            $this->config->get('vendor-dir').'/composer/',
+            $this->config->get('vendor-dir'),
+            $path,
+        );
+
+        if (isset($this->additionalCleanupPaths[$package->getName()])) {
+            foreach ($this->additionalCleanupPaths[$package->getName()] as $path) {
+                $this->filesystem->remove($path);
+            }
+        }
+
+        foreach ($dirsToCleanUp as $dir) {
+            if (is_dir($dir) && $this->filesystem->isDirEmpty($dir) && realpath($dir) !== getcwd()) {
+                $this->filesystem->removeDirectory($dir);
+            }
+        }
     }
 
     /**
      * {@inheritDoc}
      */
-    public function setOutputProgress($outputProgress)
+    public function install(PackageInterface $package, $path, $output = true)
     {
-        $this->outputProgress = $outputProgress;
+        if ($output) {
+            $this->io->writeError("  - " . InstallOperation::format($package));
+        }
 
-        return $this;
+        $this->filesystem->emptyDirectory($path);
+        $this->filesystem->ensureDirectoryExists($path);
+        $this->filesystem->rename($this->getFileName($package, $path), $path . '/' . pathinfo(parse_url($package->getDistUrl(), PHP_URL_PATH), PATHINFO_BASENAME));
     }
 
-    protected function clearLastCacheWrite(PackageInterface $package)
+    /**
+     * TODO mark private in v3
+     * @protected This is public due to PHP 5.3
+     */
+    public function clearLastCacheWrite(PackageInterface $package)
     {
         if ($this->cache && isset($this->lastCacheWrites[$package->getName()])) {
             $this->cache->remove($this->lastCacheWrites[$package->getName()]);
@@ -210,21 +323,48 @@ class FileDownloader implements Download
     }
 
     /**
+     * TODO mark private in v3
+     * @protected This is public due to PHP 5.3
+     */
+    public function addCleanupPath(PackageInterface $package, $path)
+    {
+        $this->additionalCleanupPaths[$package->getName()][] = $path;
+    }
+
+    /**
+     * TODO mark private in v3
+     * @protected This is public due to PHP 5.3
+     */
+    public function removeCleanupPath(PackageInterface $package, $path)
+    {
+        if (isset($this->additionalCleanupPaths[$package->getName()])) {
+            $idx = array_search($path, $this->additionalCleanupPaths[$package->getName()]);
+            if (false !== $idx) {
+                unset($this->additionalCleanupPaths[$package->getName()][$idx]);
+            }
+        }
+    }
+
+    /**
      * {@inheritDoc}
      */
     public function update(PackageInterface $initial, PackageInterface $target, $path)
     {
-        $name = $target->getName();
-        $from = $initial->getFullPrettyVersion();
-        $to = $target->getFullPrettyVersion();
+        $this->io->writeError("  - " . UpdateOperation::format($initial, $target) . ": ", false);
 
-        $actionName = VersionParser::isUpgrade($initial->getVersion(), $target->getVersion()) ? 'Updating' : 'Downgrading';
-        $this->io->writeError("  - " . $actionName . " <info>" . $name . "</info> (<comment>" . $from . "</comment> => <comment>" . $to . "</comment>): ", false);
+        $promise = $this->remove($initial, $path, false);
+        if ($promise === null || !$promise instanceof PromiseInterface) {
+            $promise = \React\Promise\resolve();
+        }
+        $self = $this;
+        $io = $this->io;
 
-        $this->remove($initial, $path, false);
-        $this->download($target, $path, false);
+        return $promise->then(function () use ($self, $target, $path, $io) {
+            $promise = $self->install($target, $path, false);
+            $io->writeError('');
 
-        $this->io->writeError('');
+            return $promise;
+        });
     }
 
     /**
@@ -233,7 +373,7 @@ class FileDownloader implements Download
     public function remove(PackageInterface $package, $path, $output = true)
     {
         if ($output) {
-            $this->io->writeError("  - Removing <info>" . $package->getName() . "</info> (<comment>" . $package->getFullPrettyVersion() . "</comment>)");
+            $this->io->writeError("  - " . UninstallOperation::format($package));
         }
         if (!$this->filesystem->removeDirectory($path)) {
             throw new \RuntimeException('Could not completely delete '.$path.', aborting.');
@@ -249,7 +389,7 @@ class FileDownloader implements Download
      */
     protected function getFileName(PackageInterface $package, $path)
     {
-        return $path.'/'.pathinfo(parse_url($package->getDistUrl(), PHP_URL_PATH), PATHINFO_BASENAME);
+        return rtrim($this->config->get('vendor-dir').'/composer/tmp-'.md5($package.spl_object_hash($package)).'.'.pathinfo(parse_url($package->getDistUrl(), PHP_URL_PATH), PATHINFO_EXTENSION), '.');
     }
 
     /**
@@ -273,17 +413,6 @@ class FileDownloader implements Download
         return $url;
     }
 
-    private function getCacheKey(PackageInterface $package, $processedUrl)
-    {
-        // we use the complete download url here to avoid conflicting entries
-        // from different packages, which would potentially allow a given package
-        // in a third party repo to pre-populate the cache for the same package in
-        // packagist for example.
-        $cacheKey = sha1($processedUrl);
-
-        return $package->getName().'/'.$cacheKey.'.'.$package->getDistType();
-    }
-
     /**
      * {@inheritDoc}
      * @throws \RuntimeException
@@ -291,15 +420,22 @@ class FileDownloader implements Download
     public function getLocalChanges(PackageInterface $package, $targetDir)
     {
         $prevIO = $this->io;
-        $prevProgress = $this->outputProgress;
 
         $this->io = new NullIO;
         $this->io->loadConfiguration($this->config);
-        $this->outputProgress = false;
         $e = null;
+        $output = '';
 
+        $targetDir = Filesystem::trimTrailingSlash($targetDir);
         try {
-            $this->download($package, $targetDir.'_compare', false);
+            if (is_dir($targetDir.'_compare')) {
+                $this->filesystem->removeDirectory($targetDir.'_compare');
+            }
+
+            $this->download($package, $targetDir.'_compare', null, false);
+            $this->httpDownloader->wait();
+            $this->install($package, $targetDir.'_compare', false);
+            $this->process->wait();
 
             $comparer = new Comparer();
             $comparer->setSource($targetDir.'_compare');
@@ -311,7 +447,6 @@ class FileDownloader implements Download
         }
 
         $this->io = $prevIO;
-        $this->outputProgress = $prevProgress;
 
         if ($e) {
             throw $e;
diff -pruN 1.10.19-1/src/Composer/Downloader/FossilDownloader.php 2.0.9-1/src/Composer/Downloader/FossilDownloader.php
--- 1.10.19-1/src/Composer/Downloader/FossilDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/FossilDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -23,7 +23,14 @@ class FossilDownloader extends VcsDownlo
     /**
      * {@inheritDoc}
      */
-    public function doDownload(PackageInterface $package, $path, $url)
+    protected function doDownload(PackageInterface $package, $path, $url, PackageInterface $prevPackage = null)
+    {
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    protected function doInstall(PackageInterface $package, $path, $url)
     {
         // Ensure we are allowed to use this URL by config
         $this->config->prohibitUrlByConfig($url, $this->io);
@@ -49,12 +56,11 @@ class FossilDownloader extends VcsDownlo
     /**
      * {@inheritDoc}
      */
-    public function doUpdate(PackageInterface $initial, PackageInterface $target, $path, $url)
+    protected function doUpdate(PackageInterface $initial, PackageInterface $target, $path, $url)
     {
         // Ensure we are allowed to use this URL by config
         $this->config->prohibitUrlByConfig($url, $this->io);
 
-        $url = ProcessExecutor::escape($url);
         $ref = ProcessExecutor::escape($target->getSourceReference());
         $this->io->writeError(" Updating to ".$target->getSourceReference());
 
diff -pruN 1.10.19-1/src/Composer/Downloader/GitDownloader.php 2.0.9-1/src/Composer/Downloader/GitDownloader.php
--- 1.10.19-1/src/Composer/Downloader/GitDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/GitDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -17,6 +17,7 @@ use Composer\IO\IOInterface;
 use Composer\Package\PackageInterface;
 use Composer\Util\Filesystem;
 use Composer\Util\Git as GitUtil;
+use Composer\Util\Url;
 use Composer\Util\Platform;
 use Composer\Util\ProcessExecutor;
 use Composer\Cache;
@@ -26,9 +27,25 @@ use Composer\Cache;
  */
 class GitDownloader extends VcsDownloader implements DvcsDownloaderInterface
 {
-    private $hasStashedChanges = false;
-    private $hasDiscardedChanges = false;
+    /**
+     * @var bool[]
+     * @psalm-var array<string, bool>
+     */
+    private $hasStashedChanges = array();
+    /**
+     * @var bool[]
+     * @psalm-var array<string, bool>
+     */
+    private $hasDiscardedChanges = array();
+    /**
+     * @var GitUtil
+     */
     private $gitUtil;
+    /**
+     * @var array
+     * @psalm-var array<int, array<string, bool>>
+     */
+    private $cachedPackages = array();
 
     public function __construct(IOInterface $io, Config $config, ProcessExecutor $process = null, Filesystem $fs = null)
     {
@@ -39,39 +56,49 @@ class GitDownloader extends VcsDownloade
     /**
      * {@inheritDoc}
      */
-    public function doDownload(PackageInterface $package, $path, $url)
+    protected function doDownload(PackageInterface $package, $path, $url, PackageInterface $prevPackage = null)
     {
         GitUtil::cleanEnv();
-        $path = $this->normalizePath($path);
-        $cachePath = $this->config->get('cache-vcs-dir').'/'.preg_replace('{[^a-z0-9.]}i', '-', $url).'/';
-        $ref = $package->getSourceReference();
-        $flag = Platform::isWindows() ? '/D ' : '';
 
-        // --dissociate option is only available since git 2.3.0-rc0
+        $cachePath = $this->config->get('cache-vcs-dir').'/'.preg_replace('{[^a-z0-9.]}i', '-', $url).'/';
         $gitVersion = GitUtil::getVersion($this->process);
-        $msg = "Cloning ".$this->getShortHash($ref);
 
-        $command = 'git clone --no-checkout %url% %path% && cd '.$flag.'%path% && git remote add composer %url% && git fetch composer && git remote set-url origin %sanitizedUrl% && git remote set-url composer %sanitizedUrl%';
+        // --dissociate option is only available since git 2.3.0-rc0
         if ($gitVersion && version_compare($gitVersion, '2.3.0-rc0', '>=') && Cache::isUsable($cachePath)) {
-            $this->io->writeError('', true, IOInterface::DEBUG);
+            $this->io->writeError("  - Syncing <info>" . $package->getName() . "</info> (<comment>" . $package->getFullPrettyVersion() . "</comment>) into cache");
             $this->io->writeError(sprintf('    Cloning to cache at %s', ProcessExecutor::escape($cachePath)), true, IOInterface::DEBUG);
-            try {
-                if (!$this->gitUtil->fetchRefOrSyncMirror($url, $cachePath, $ref)) {
-                    $this->io->writeError('<error>Failed to update '.$url.' in cache, package installation for '.$package->getPrettyName().' might fail.</error>');
-                }
-                if (is_dir($cachePath)) {
-                    $command =
-                        'git clone --no-checkout %cachePath% %path% --dissociate --reference %cachePath% '
-                        . '&& cd '.$flag.'%path% '
-                        . '&& git remote set-url origin %sanitizedUrl% && git remote add composer %sanitizedUrl%';
-                    $msg = "Cloning ".$this->getShortHash($ref).' from cache';
-                }
-            } catch (\RuntimeException $e) {
-                if (0 === strpos(get_class($e), 'PHPUnit')) {
-                    throw $e;
-                }
+            $ref = $package->getSourceReference();
+            if ($this->gitUtil->fetchRefOrSyncMirror($url, $cachePath, $ref) && is_dir($cachePath)) {
+                $this->cachedPackages[$package->getId()][$ref] = true;
+            }
+        }
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    protected function doInstall(PackageInterface $package, $path, $url)
+    {
+        GitUtil::cleanEnv();
+        $path = $this->normalizePath($path);
+        $cachePath = $this->config->get('cache-vcs-dir').'/'.preg_replace('{[^a-z0-9.]}i', '-', $url).'/';
+        $ref = $package->getSourceReference();
+        $flag = Platform::isWindows() ? '/D ' : '';
+
+        if (!empty($this->cachedPackages[$package->getId()][$ref])) {
+            $msg = "Cloning ".$this->getShortHash($ref).' from cache';
+            $command =
+                'git clone --no-checkout %cachePath% %path% --dissociate --reference %cachePath% '
+                . '&& cd '.$flag.'%path% '
+                . '&& git remote set-url origin %sanitizedUrl% && git remote add composer %sanitizedUrl%';
+        } else {
+            $msg = "Cloning ".$this->getShortHash($ref);
+            $command = 'git clone --no-checkout %url% %path% && cd '.$flag.'%path% && git remote add composer %url% && git fetch composer && git remote set-url origin %sanitizedUrl% && git remote set-url composer %sanitizedUrl%';
+            if (getenv('COMPOSER_DISABLE_NETWORK')) {
+                throw new \RuntimeException('The required git reference for '.$package->getName().' is not in cache and network is disabled, aborting');
             }
         }
+
         $this->io->writeError($msg);
 
         $commandCallable = function ($url) use ($path, $command, $cachePath) {
@@ -105,34 +132,40 @@ class GitDownloader extends VcsDownloade
     /**
      * {@inheritDoc}
      */
-    public function doUpdate(PackageInterface $initial, PackageInterface $target, $path, $url)
+    protected function doUpdate(PackageInterface $initial, PackageInterface $target, $path, $url)
     {
         GitUtil::cleanEnv();
+        $path = $this->normalizePath($path);
         if (!$this->hasMetadataRepository($path)) {
             throw new \RuntimeException('The .git directory is missing from '.$path.', see https://getcomposer.org/commit-deps for more information');
         }
 
-        $updateOriginUrl = false;
-        if (
-            0 === $this->process->execute('git remote -v', $output, $path)
-            && preg_match('{^origin\s+(?P<url>\S+)}m', $output, $originMatch)
-            && preg_match('{^composer\s+(?P<url>\S+)}m', $output, $composerMatch)
-        ) {
-            if ($originMatch['url'] === $composerMatch['url'] && $composerMatch['url'] !== $target->getSourceUrl()) {
-                $updateOriginUrl = true;
+        $cachePath = $this->config->get('cache-vcs-dir').'/'.preg_replace('{[^a-z0-9.]}i', '-', $url).'/';
+        $ref = $target->getSourceReference();
+
+        if (!empty($this->cachedPackages[$target->getId()][$ref])) {
+            $msg = "Checking out ".$this->getShortHash($ref).' from cache';
+            $command = '(git rev-parse --quiet --verify %ref% || (git remote set-url composer %cachePath% && git fetch composer && git fetch --tags composer)) && git remote set-url composer %sanitizedUrl%';
+        } else {
+            $msg = "Checking out ".$this->getShortHash($ref);
+            $command = '(git remote set-url composer %url% && git rev-parse --quiet --verify %ref% || (git fetch composer && git fetch --tags composer)) && git remote set-url composer %sanitizedUrl%';
+            if (getenv('COMPOSER_DISABLE_NETWORK')) {
+                throw new \RuntimeException('The required git reference for '.$target->getName().' is not in cache and network is disabled, aborting');
             }
         }
 
-        $ref = $target->getSourceReference();
-        $this->io->writeError(" Checking out ".$this->getShortHash($ref));
-        $command = '(git remote set-url composer %s && git rev-parse --quiet --verify %s || (git fetch composer && git fetch --tags composer)) && git remote set-url composer %s';
+        $this->io->writeError($msg);
 
-        $commandCallable = function ($url) use ($command, $ref) {
-            return sprintf(
-                $command,
-                ProcessExecutor::escape($url),
-                ProcessExecutor::escape($ref.'^{commit}'),
-                ProcessExecutor::escape(preg_replace('{://([^@]+?):(.+?)@}', '://', $url))
+        $commandCallable = function ($url) use ($ref, $command, $cachePath) {
+            return str_replace(
+                array('%url%', '%ref%', '%cachePath%', '%sanitizedUrl%'),
+                array(
+                    ProcessExecutor::escape($url),
+                    ProcessExecutor::escape($ref.'^{commit}'),
+                    ProcessExecutor::escape($cachePath),
+                    ProcessExecutor::escape(preg_replace('{://([^@]+?):(.+?)@}', '://', $url)),
+                ),
+                $command
             );
         };
 
@@ -144,6 +177,16 @@ class GitDownloader extends VcsDownloade
             $target->setSourceReference($newRef);
         }
 
+        $updateOriginUrl = false;
+        if (
+            0 === $this->process->execute('git remote -v', $output, $path)
+            && preg_match('{^origin\s+(?P<url>\S+)}m', $output, $originMatch)
+            && preg_match('{^composer\s+(?P<url>\S+)}m', $output, $composerMatch)
+        ) {
+            if ($originMatch['url'] === $composerMatch['url'] && $composerMatch['url'] !== $target->getSourceUrl()) {
+                $updateOriginUrl = true;
+            }
+        }
         if ($updateOriginUrl) {
             $this->updateOriginUrl($path, $target->getSourceUrl());
         }
@@ -192,17 +235,23 @@ class GitDownloader extends VcsDownloade
             return;
         }
 
+        $candidateBranches = $matches[1];
         // use the first match as branch name for now
-        $branch = $matches[1][0];
+        $branch = $candidateBranches[0];
         $unpushedChanges = null;
+        $branchNotFoundError = false;
 
         // do two passes, as if we find anything we want to fetch and then re-try
         for ($i = 0; $i <= 1; $i++) {
-            // try to find the a matching branch name in the composer remote
-            foreach ($matches[1] as $candidate) {
-                if (preg_match('{^[a-f0-9]+ refs/remotes/((?:composer|origin)/'.preg_quote($candidate).')$}mi', $refs, $match)) {
-                    $branch = $candidate;
-                    $remoteBranch = $match[1];
+            $remoteBranches = array();
+
+            // try to find matching branch names in remote repos
+            foreach ($candidateBranches as $candidate) {
+                if (preg_match_all('{^[a-f0-9]+ refs/remotes/((?:[^/]+)/'.preg_quote($candidate).')$}mi', $refs, $matches)) {
+                    foreach ($matches[1] as $match) {
+                        $branch = $candidate;
+                        $remoteBranches[] = $match;
+                    }
                     break;
                 }
             }
@@ -210,21 +259,40 @@ class GitDownloader extends VcsDownloade
             // if it doesn't exist, then we assume it is an unpushed branch
             // this is bad as we have no reference point to do a diff so we just bail listing
             // the branch as being unpushed
-            if (!isset($remoteBranch)) {
-                $unpushedChanges = 'Branch ' . $branch . ' could not be found on the origin remote and appears to be unpushed';
+            if (!$remoteBranches) {
+                $unpushedChanges = 'Branch ' . $branch . ' could not be found on any remote and appears to be unpushed';
+                $branchNotFoundError = true;
             } else {
-                $command = sprintf('git diff --name-status %s...%s --', $remoteBranch, $branch);
-                if (0 !== $this->process->execute($command, $output, $path)) {
-                    throw new \RuntimeException('Failed to execute ' . $command . "\n\n" . $this->process->getErrorOutput());
+                // if first iteration found no remote branch but it has now found some, reset $unpushedChanges
+                // so we get the real diff output no matter its length
+                if ($branchNotFoundError) {
+                    $unpushedChanges = null;
                 }
+                foreach ($remoteBranches as $remoteBranch) {
+                    $command = sprintf('git diff --name-status %s...%s --', $remoteBranch, $branch);
+                    if (0 !== $this->process->execute($command, $output, $path)) {
+                        throw new \RuntimeException('Failed to execute ' . $command . "\n\n" . $this->process->getErrorOutput());
+                    }
 
-                $unpushedChanges = trim($output) ?: null;
+                    $output = trim($output);
+                    // keep the shortest diff from all remote branches we compare against
+                    if ($unpushedChanges === null || strlen($output) < strlen($unpushedChanges)) {
+                        $unpushedChanges = $output;
+                    }
+                }
             }
 
-            // first pass and we found unpushed changes, fetch from both remotes to make sure we have up to date
+            // first pass and we found unpushed changes, fetch from all remotes to make sure we have up to date
             // remotes and then try again as outdated remotes can sometimes cause false-positives
             if ($unpushedChanges && $i === 0) {
-                $this->process->execute('git fetch composer && git fetch origin', $output, $path);
+                $this->process->execute('git fetch --all', $output, $path);
+
+                // update list of refs after fetching
+                $command = 'git show-ref --head -d';
+                if (0 !== $this->process->execute($command, $output, $path)) {
+                    throw new \RuntimeException('Failed to execute ' . $command . "\n\n" . $this->process->getErrorOutput());
+                }
+                $refs = trim($output);
             }
 
             // abort after first pass if we didn't find anything
@@ -272,7 +340,7 @@ class GitDownloader extends VcsDownloade
         $changes = array_map(function ($elem) {
             return '    '.$elem;
         }, preg_split('{\s*\r?\n\s*}', $changes));
-        $this->io->writeError('    <error>The package has modified files:</error>');
+        $this->io->writeError('    <error>'.$package->getPrettyName().' has modified files:</error>');
         $this->io->writeError(array_slice($changes, 0, 10));
         if (count($changes) > 10) {
             $this->io->writeError('    <info>' . (count($changes) - 10) . ' more files modified, choose "v" to view the full list</info>');
@@ -327,15 +395,15 @@ class GitDownloader extends VcsDownloade
     protected function reapplyChanges($path)
     {
         $path = $this->normalizePath($path);
-        if ($this->hasStashedChanges) {
-            $this->hasStashedChanges = false;
+        if (!empty($this->hasStashedChanges[$path])) {
+            unset($this->hasStashedChanges[$path]);
             $this->io->writeError('    <info>Re-applying stashed changes</info>');
             if (0 !== $this->process->execute('git stash pop', $output, $path)) {
                 throw new \RuntimeException("Failed to apply stashed changes:\n\n".$this->process->getErrorOutput());
             }
         }
 
-        $this->hasDiscardedChanges = false;
+        unset($this->hasDiscardedChanges[$path]);
     }
 
     /**
@@ -350,7 +418,7 @@ class GitDownloader extends VcsDownloade
      */
     protected function updateToCommit($path, $reference, $branch, $date)
     {
-        $force = $this->hasDiscardedChanges || $this->hasStashedChanges ? '-f ' : '';
+        $force = !empty($this->hasDiscardedChanges[$path]) || !empty($this->hasStashedChanges[$path]) ? '-f ' : '';
 
         // This uses the "--" sequence to separate branch from file parameters.
         //
@@ -373,7 +441,7 @@ class GitDownloader extends VcsDownloade
         ) {
             $command = sprintf('git checkout '.$force.'-B %s %s -- && git reset --hard %2$s --', ProcessExecutor::escape($branch), ProcessExecutor::escape('composer/'.$reference));
             if (0 === $this->process->execute($command, $output, $path)) {
-                return;
+                return null;
             }
         }
 
@@ -386,19 +454,16 @@ class GitDownloader extends VcsDownloade
 
             $command = sprintf('git checkout %s --', ProcessExecutor::escape($branch));
             $fallbackCommand = sprintf('git checkout '.$force.'-B %s %s --', ProcessExecutor::escape($branch), ProcessExecutor::escape('composer/'.$branch));
-            if (0 === $this->process->execute($command, $output, $path)
-                || 0 === $this->process->execute($fallbackCommand, $output, $path)
-            ) {
-                $command = sprintf('git reset --hard %s --', ProcessExecutor::escape($reference));
-                if (0 === $this->process->execute($command, $output, $path)) {
-                    return;
-                }
+            $resetCommand = sprintf('git reset --hard %s --', ProcessExecutor::escape($reference));
+
+            if (0 === $this->process->execute("($command || $fallbackCommand) && $resetCommand", $output, $path)) {
+                return null;
             }
         }
 
         $command = sprintf($template, ProcessExecutor::escape($gitRef));
         if (0 === $this->process->execute($command, $output, $path)) {
-            return;
+            return null;
         }
 
         // reference was not found (prints "fatal: reference is not a tree: $ref")
@@ -406,7 +471,7 @@ class GitDownloader extends VcsDownloade
             $this->io->writeError('    <warning>'.$reference.' is gone (history was rewritten?)</warning>');
         }
 
-        throw new \RuntimeException(GitUtil::sanitizeUrl('Failed to execute ' . $command . "\n\n" . $this->process->getErrorOutput()));
+        throw new \RuntimeException(Url::sanitize('Failed to execute ' . $command . "\n\n" . $this->process->getErrorOutput()));
     }
 
     protected function updateOriginUrl($path, $url)
@@ -445,7 +510,7 @@ class GitDownloader extends VcsDownloade
     }
 
     /**
-     * @param string $path
+     * @param  string            $path
      * @throws \RuntimeException
      */
     protected function discardChanges($path)
@@ -455,11 +520,11 @@ class GitDownloader extends VcsDownloade
             throw new \RuntimeException("Could not reset changes\n\n:".$this->process->getErrorOutput());
         }
 
-        $this->hasDiscardedChanges = true;
+        $this->hasDiscardedChanges[$path] = true;
     }
 
     /**
-     * @param string $path
+     * @param  string            $path
      * @throws \RuntimeException
      */
     protected function stashChanges($path)
@@ -469,11 +534,11 @@ class GitDownloader extends VcsDownloade
             throw new \RuntimeException("Could not stash changes\n\n:".$this->process->getErrorOutput());
         }
 
-        $this->hasStashedChanges = true;
+        $this->hasStashedChanges[$path] = true;
     }
 
     /**
-     * @param string $path
+     * @param  string            $path
      * @throws \RuntimeException
      */
     protected function viewDiff($path)
diff -pruN 1.10.19-1/src/Composer/Downloader/GzipDownloader.php 2.0.9-1/src/Composer/Downloader/GzipDownloader.php
--- 1.10.19-1/src/Composer/Downloader/GzipDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/GzipDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,14 +12,9 @@
 
 namespace Composer\Downloader;
 
-use Composer\Config;
-use Composer\Cache;
-use Composer\EventDispatcher\EventDispatcher;
 use Composer\Package\PackageInterface;
 use Composer\Util\Platform;
 use Composer\Util\ProcessExecutor;
-use Composer\Util\RemoteFilesystem;
-use Composer\IO\IOInterface;
 
 /**
  * GZip archive downloader.
@@ -28,17 +23,10 @@ use Composer\IO\IOInterface;
  */
 class GzipDownloader extends ArchiveDownloader
 {
-    protected $process;
-
-    public function __construct(IOInterface $io, Config $config, EventDispatcher $eventDispatcher = null, Cache $cache = null, ProcessExecutor $process = null, RemoteFilesystem $rfs = null)
-    {
-        $this->process = $process ?: new ProcessExecutor($io);
-        parent::__construct($io, $config, $eventDispatcher, $cache, $rfs);
-    }
-
-    protected function extract($file, $path)
+    protected function extract(PackageInterface $package, $file, $path)
     {
-        $targetFilepath = $path . DIRECTORY_SEPARATOR . basename(substr($file, 0, -3));
+        $filename = pathinfo(parse_url($package->getDistUrl(), PHP_URL_PATH), PATHINFO_FILENAME);
+        $targetFilepath = $path . DIRECTORY_SEPARATOR . $filename;
 
         // Try to use gunzip on *nix
         if (!Platform::isWindows()) {
@@ -63,14 +51,6 @@ class GzipDownloader extends ArchiveDown
         $this->extractUsingExt($file, $targetFilepath);
     }
 
-    /**
-     * {@inheritdoc}
-     */
-    protected function getFileName(PackageInterface $package, $path)
-    {
-        return $path.'/'.pathinfo(parse_url($package->getDistUrl(), PHP_URL_PATH), PATHINFO_BASENAME);
-    }
-
     private function extractUsingExt($file, $targetFilepath)
     {
         $archiveFile = gzopen($file, 'rb');
diff -pruN 1.10.19-1/src/Composer/Downloader/HgDownloader.php 2.0.9-1/src/Composer/Downloader/HgDownloader.php
--- 1.10.19-1/src/Composer/Downloader/HgDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/HgDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -24,7 +24,14 @@ class HgDownloader extends VcsDownloader
     /**
      * {@inheritDoc}
      */
-    public function doDownload(PackageInterface $package, $path, $url)
+    protected function doDownload(PackageInterface $package, $path, $url, PackageInterface $prevPackage = null)
+    {
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    protected function doInstall(PackageInterface $package, $path, $url)
     {
         $hgUtils = new HgUtils($this->io, $this->config, $this->process);
 
@@ -44,7 +51,7 @@ class HgDownloader extends VcsDownloader
     /**
      * {@inheritDoc}
      */
-    public function doUpdate(PackageInterface $initial, PackageInterface $target, $path, $url)
+    protected function doUpdate(PackageInterface $initial, PackageInterface $target, $path, $url)
     {
         $hgUtils = new HgUtils($this->io, $this->config, $this->process);
 
diff -pruN 1.10.19-1/src/Composer/Downloader/MaxFileSizeExceededException.php 2.0.9-1/src/Composer/Downloader/MaxFileSizeExceededException.php
--- 1.10.19-1/src/Composer/Downloader/MaxFileSizeExceededException.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/MaxFileSizeExceededException.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,17 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Downloader;
+
+class MaxFileSizeExceededException extends TransportException
+{
+}
diff -pruN 1.10.19-1/src/Composer/Downloader/PathDownloader.php 2.0.9-1/src/Composer/Downloader/PathDownloader.php
--- 1.10.19-1/src/Composer/Downloader/PathDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/PathDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -18,10 +18,11 @@ use Composer\Package\PackageInterface;
 use Composer\Package\Version\VersionGuesser;
 use Composer\Package\Version\VersionParser;
 use Composer\Util\Platform;
-use Composer\Util\ProcessExecutor;
-use Composer\Util\Filesystem as ComposerFilesystem;
+use Composer\Util\Filesystem;
 use Symfony\Component\Filesystem\Exception\IOException;
-use Symfony\Component\Filesystem\Filesystem;
+use Symfony\Component\Filesystem\Filesystem as SymfonyFilesystem;
+use Composer\DependencyResolver\Operation\InstallOperation;
+use Composer\DependencyResolver\Operation\UninstallOperation;
 
 /**
  * Download a package from a local path.
@@ -37,8 +38,9 @@ class PathDownloader extends FileDownloa
     /**
      * {@inheritdoc}
      */
-    public function download(PackageInterface $package, $path, $output = true)
+    public function download(PackageInterface $package, $path, PackageInterface $prevPackage = null, $output = true)
     {
+        $path = Filesystem::trimTrailingSlash($path);
         $url = $package->getDistUrl();
         $realUrl = realpath($url);
         if (false === $realUrl || !file_exists($realUrl) || !is_dir($realUrl)) {
@@ -50,14 +52,6 @@ class PathDownloader extends FileDownloa
         }
 
         if (realpath($path) === $realUrl) {
-            if ($output) {
-                $this->io->writeError(sprintf(
-                    '  - Installing <info>%s</info> (<comment>%s</comment>): Source already present',
-                    $package->getName(),
-                    $package->getFullPrettyVersion()
-                ));
-            }
-
             return;
         }
 
@@ -73,6 +67,26 @@ class PathDownloader extends FileDownloa
                 $realUrl
             ));
         }
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function install(PackageInterface $package, $path, $output = true)
+    {
+        $path = Filesystem::trimTrailingSlash($path);
+        $url = $package->getDistUrl();
+        $realUrl = realpath($url);
+
+        if (realpath($path) === $realUrl) {
+            if ($output) {
+                $this->io->writeError("  - " . InstallOperation::format($package).': Source already present');
+            } else {
+                $this->io->writeError('Source already present', false);
+            }
+
+            return;
+        }
 
         // Get the transport options with default values
         $transportOptions = $package->getTransportOptions() + array('symlink' => null, 'relative' => true);
@@ -100,15 +114,11 @@ class PathDownloader extends FileDownloa
             $allowedStrategies = array(self::STRATEGY_MIRROR);
         }
 
-        $fileSystem = new Filesystem();
+        $symfonyFilesystem = new SymfonyFilesystem();
         $this->filesystem->removeDirectory($path);
 
         if ($output) {
-            $this->io->writeError(sprintf(
-                '  - Installing <info>%s</info> (<comment>%s</comment>): ',
-                $package->getName(),
-                $package->getFullPrettyVersion()
-            ), false);
+            $this->io->writeError("  - " . InstallOperation::format($package).': ', false);
         }
 
         $isFallback = false;
@@ -127,9 +137,9 @@ class PathDownloader extends FileDownloa
                     $path = rtrim($path, "/");
                     $this->io->writeError(sprintf('Symlinking from %s', $url), false);
                     if ($transportOptions['relative']) {
-                        $fileSystem->symlink($shortestPath, $path);
+                        $symfonyFilesystem->symlink($shortestPath, $path);
                     } else {
-                        $fileSystem->symlink($realUrl, $path);
+                        $symfonyFilesystem->symlink($realUrl, $path);
                     }
                 }
             } catch (IOException $e) {
@@ -146,15 +156,16 @@ class PathDownloader extends FileDownloa
 
         // Fallback if symlink failed or if symlink is not allowed for the package
         if (self::STRATEGY_MIRROR == $currentStrategy) {
-            $fs = new ComposerFilesystem();
-            $realUrl = $fs->normalizePath($realUrl);
+            $realUrl = $this->filesystem->normalizePath($realUrl);
 
             $this->io->writeError(sprintf('%sMirroring from %s', $isFallback ? '    ' : '', $url), false);
             $iterator = new ArchivableFilesFinder($realUrl, array());
-            $fileSystem->mirror($realUrl, $path, $iterator);
+            $symfonyFilesystem->mirror($realUrl, $path, $iterator);
         }
 
-        $this->io->writeError('');
+        if ($output) {
+            $this->io->writeError('');
+        }
     }
 
     /**
@@ -162,29 +173,28 @@ class PathDownloader extends FileDownloa
      */
     public function remove(PackageInterface $package, $path, $output = true)
     {
-        $realUrl = realpath($package->getDistUrl());
-
-        if (realpath($path) === $realUrl) {
-            if ($output) {
-                $this->io->writeError("  - Removing <info>" . $package->getName() . "</info> (<comment>" . $package->getFullPrettyVersion() . "</comment>), source is still present in $path");
-            }
-
-            return;
-        }
-
+        $path = Filesystem::trimTrailingSlash($path);
         /**
+         * realpath() may resolve Windows junctions to the source path, so we'll check for a junction first
+         * to prevent a false positive when checking if the dist and install paths are the same.
+         * See https://bugs.php.net/bug.php?id=77639
+         *
          * For junctions don't blindly rely on Filesystem::removeDirectory as it may be overzealous. If a process
          * inadvertently locks the file the removal will fail, but it would fall back to recursive delete which
          * is disastrous within a junction. So in that case we have no other real choice but to fail hard.
          */
         if (Platform::isWindows() && $this->filesystem->isJunction($path)) {
             if ($output) {
-                $this->io->writeError("  - Removing junction for <info>" . $package->getName() . "</info> (<comment>" . $package->getFullPrettyVersion() . "</comment>)");
+                $this->io->writeError("  - " . UninstallOperation::format($package).", source is still present in $path");
             }
             if (!$this->filesystem->removeJunction($path)) {
                 $this->io->writeError("    <warning>Could not remove junction at " . $path . " - is another process locking it?</warning>");
                 throw new \RuntimeException('Could not reliably remove junction for package ' . $package->getName());
             }
+        } elseif (realpath($path) === realpath($package->getDistUrl())) {
+            if ($output) {
+                $this->io->writeError("  - " . UninstallOperation::format($package).", source is still present in $path");
+            }
         } else {
             parent::remove($package, $path, $output);
         }
@@ -195,8 +205,9 @@ class PathDownloader extends FileDownloa
      */
     public function getVcsReference(PackageInterface $package, $path)
     {
+        $path = Filesystem::trimTrailingSlash($path);
         $parser = new VersionParser;
-        $guesser = new VersionGuesser($this->config, new ProcessExecutor($this->io), $parser);
+        $guesser = new VersionGuesser($this->config, $this->process, $parser);
         $dumper = new ArrayDumper;
 
         $packageConfig = $dumper->dump($package);
diff -pruN 1.10.19-1/src/Composer/Downloader/PearPackageExtractor.php 2.0.9-1/src/Composer/Downloader/PearPackageExtractor.php
--- 1.10.19-1/src/Composer/Downloader/PearPackageExtractor.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/PearPackageExtractor.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,266 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Downloader;
-
-use Composer\Util\Filesystem;
-
-/**
- * Extractor for pear packages.
- *
- * Composer cannot rely on tar files structure when place it inside package target dir. Correct source files
- * disposition must be read from package.xml
- * This extract pear package source files to target dir.
- *
- * @author Alexey Prilipko <palex@farpost.com>
- */
-class PearPackageExtractor
-{
-    private static $rolesWithoutPackageNamePrefix = array('php', 'script', 'www');
-    /** @var Filesystem */
-    private $filesystem;
-    private $file;
-
-    public function __construct($file)
-    {
-        if (!is_file($file)) {
-            throw new \UnexpectedValueException('PEAR package file is not found at '.$file);
-        }
-
-        $this->filesystem = new Filesystem();
-        $this->file = $file;
-    }
-
-    /**
-     * Installs PEAR source files according to package.xml definitions and removes extracted files
-     *
-     * @param  string                    $target target install location. all source installation would be performed relative to target path.
-     * @param  array                     $roles  types of files to install. default role for PEAR source files are 'php'.
-     * @param  array                     $vars   used for replacement tasks
-     * @throws \RuntimeException
-     * @throws \UnexpectedValueException
-     */
-    public function extractTo($target, array $roles = array('php' => '/', 'script' => '/bin'), $vars = array())
-    {
-        $extractionPath = $target.'/tarball';
-
-        try {
-            $archive = new \PharData($this->file);
-            $archive->extractTo($extractionPath, null, true);
-
-            if (!is_file($this->combine($extractionPath, '/package.xml'))) {
-                throw new \RuntimeException('Invalid PEAR package. It must contain package.xml file.');
-            }
-
-            $fileCopyActions = $this->buildCopyActions($extractionPath, $roles, $vars);
-            $this->copyFiles($fileCopyActions, $extractionPath, $target, $roles, $vars);
-            $this->filesystem->removeDirectory($extractionPath);
-        } catch (\Exception $exception) {
-            throw new \UnexpectedValueException(sprintf('Failed to extract PEAR package %s to %s. Reason: %s', $this->file, $target, $exception->getMessage()), 0, $exception);
-        }
-    }
-
-    /**
-     * Perform copy actions on files
-     *
-     * @param array $files array of copy actions ('from', 'to') with relative paths
-     * @param string $source path to source dir.
-     * @param string $target path to destination dir
-     * @param array $roles array [role => roleRoot] relative root for files having that role
-     * @param array $vars  list of values can be used for replacement tasks
-     */
-    private function copyFiles($files, $source, $target, $roles, $vars)
-    {
-        foreach ($files as $file) {
-            $from = $this->combine($source, $file['from']);
-            $to = $this->combine($target, $roles[$file['role']]);
-            $to = $this->combine($to, $file['to']);
-            $tasks = $file['tasks'];
-            $this->copyFile($from, $to, $tasks, $vars);
-        }
-    }
-
-    private function copyFile($from, $to, $tasks, $vars)
-    {
-        if (!is_file($from)) {
-            throw new \RuntimeException('Invalid PEAR package. package.xml defines file that is not located inside tarball.');
-        }
-
-        $this->filesystem->ensureDirectoryExists(dirname($to));
-
-        if (0 == count($tasks)) {
-            $copied = copy($from, $to);
-        } else {
-            $content = file_get_contents($from);
-            $replacements = array();
-            foreach ($tasks as $task) {
-                $pattern = $task['from'];
-                $varName = $task['to'];
-                if (isset($vars[$varName])) {
-                    if ($varName === 'php_bin' && false === strpos($to, '.bat')) {
-                        $replacements[$pattern] = preg_replace('{\.bat$}', '', $vars[$varName]);
-                    } else {
-                        $replacements[$pattern] = $vars[$varName];
-                    }
-                }
-            }
-            $content = strtr($content, $replacements);
-
-            $copied = file_put_contents($to, $content);
-        }
-
-        if (false === $copied) {
-            throw new \RuntimeException(sprintf('Failed to copy %s to %s', $from, $to));
-        }
-    }
-
-    /**
-     * Builds list of copy and list of remove actions that would transform extracted PEAR tarball into installed package.
-     *
-     * @param  string            $source string path to extracted files
-     * @param  array             $roles  array [role => roleRoot] relative root for files having that role
-     * @param  array             $vars   list of values can be used for replacement tasks
-     * @throws \RuntimeException
-     * @return array             array of 'source' => 'target', where source is location of file in the tarball (relative to source
-     *                                  path, and target is destination of file (also relative to $source path)
-     */
-    private function buildCopyActions($source, array $roles, $vars)
-    {
-        /** @var \SimpleXmlElement $package */
-        $package = simplexml_load_string(file_get_contents($this->combine($source, 'package.xml')));
-        if (false === $package) {
-            throw new \RuntimeException('Package definition file is not valid.');
-        }
-
-        $packageSchemaVersion = $package['version'];
-        if ('1.0' == $packageSchemaVersion) {
-            $children = $package->release->filelist->children();
-            $packageName = (string) $package->name;
-            $packageVersion = (string) $package->release->version;
-            $sourceDir = $packageName . '-' . $packageVersion;
-            $result = $this->buildSourceList10($children, $roles, $sourceDir, '', null, $packageName);
-        } elseif ('2.0' == $packageSchemaVersion || '2.1' == $packageSchemaVersion) {
-            $children = $package->contents->children();
-            $packageName = (string) $package->name;
-            $packageVersion = (string) $package->version->release;
-            $sourceDir = $packageName . '-' . $packageVersion;
-            $result = $this->buildSourceList20($children, $roles, $sourceDir, '', null, $packageName);
-
-            $namespaces = $package->getNamespaces();
-            $package->registerXPathNamespace('ns', $namespaces['']);
-            $releaseNodes = $package->xpath('ns:phprelease');
-            $this->applyRelease($result, $releaseNodes, $vars);
-        } else {
-            throw new \RuntimeException('Unsupported schema version of package definition file.');
-        }
-
-        return $result;
-    }
-
-    private function applyRelease(&$actions, $releaseNodes, $vars)
-    {
-        foreach ($releaseNodes as $releaseNode) {
-            $requiredOs = $releaseNode->installconditions && $releaseNode->installconditions->os && $releaseNode->installconditions->os->name ? (string) $releaseNode->installconditions->os->name : '';
-            if ($requiredOs && $vars['os'] != $requiredOs) {
-                continue;
-            }
-
-            if ($releaseNode->filelist) {
-                foreach ($releaseNode->filelist->children() as $action) {
-                    if ('install' == $action->getName()) {
-                        $name = (string) $action['name'];
-                        $as = (string) $action['as'];
-                        if (isset($actions[$name])) {
-                            $actions[$name]['to'] = $as;
-                        }
-                    } elseif ('ignore' == $action->getName()) {
-                        $name = (string) $action['name'];
-                        unset($actions[$name]);
-                    } else {
-                        // unknown action
-                    }
-                }
-            }
-            break;
-        }
-    }
-
-    private function buildSourceList10($children, $targetRoles, $source, $target, $role, $packageName)
-    {
-        $result = array();
-
-        // enumerating files
-        foreach ($children as $child) {
-            /** @var $child \SimpleXMLElement */
-            if ($child->getName() == 'dir') {
-                $dirSource = $this->combine($source, (string) $child['name']);
-                $dirTarget = $child['baseinstalldir'] ?: $target;
-                $dirRole = $child['role'] ?: $role;
-                $dirFiles = $this->buildSourceList10($child->children(), $targetRoles, $dirSource, $dirTarget, $dirRole, $packageName);
-                $result = array_merge($result, $dirFiles);
-            } elseif ($child->getName() == 'file') {
-                $fileRole = (string) $child['role'] ?: $role;
-                if (isset($targetRoles[$fileRole])) {
-                    $fileName = (string) ($child['name'] ?: $child[0]); // $child[0] means text content
-                    $fileSource = $this->combine($source, $fileName);
-                    $fileTarget = $this->combine((string) $child['baseinstalldir'] ?: $target, $fileName);
-                    if (!in_array($fileRole, self::$rolesWithoutPackageNamePrefix)) {
-                        $fileTarget = $packageName . '/' . $fileTarget;
-                    }
-                    $result[(string) $child['name']] = array('from' => $fileSource, 'to' => $fileTarget, 'role' => $fileRole, 'tasks' => array());
-                }
-            }
-        }
-
-        return $result;
-    }
-
-    private function buildSourceList20($children, $targetRoles, $source, $target, $role, $packageName)
-    {
-        $result = array();
-
-        // enumerating files
-        foreach ($children as $child) {
-            /** @var $child \SimpleXMLElement */
-            if ('dir' == $child->getName()) {
-                $dirSource = $this->combine($source, $child['name']);
-                $dirTarget = $child['baseinstalldir'] ?: $target;
-                $dirRole = $child['role'] ?: $role;
-                $dirFiles = $this->buildSourceList20($child->children(), $targetRoles, $dirSource, $dirTarget, $dirRole, $packageName);
-                $result = array_merge($result, $dirFiles);
-            } elseif ('file' == $child->getName()) {
-                $fileRole = (string) $child['role'] ?: $role;
-                if (isset($targetRoles[$fileRole])) {
-                    $fileSource = $this->combine($source, (string) $child['name']);
-                    $fileTarget = $this->combine((string) ($child['baseinstalldir'] ?: $target), (string) $child['name']);
-                    $fileTasks = array();
-                    foreach ($child->children('http://pear.php.net/dtd/tasks-1.0') as $taskNode) {
-                        if ('replace' == $taskNode->getName()) {
-                            $fileTasks[] = array('from' => (string) $taskNode->attributes()->from, 'to' => (string) $taskNode->attributes()->to);
-                        }
-                    }
-                    if (!in_array($fileRole, self::$rolesWithoutPackageNamePrefix)) {
-                        $fileTarget = $packageName . '/' . $fileTarget;
-                    }
-                    $result[(string) $child['name']] = array('from' => $fileSource, 'to' => $fileTarget, 'role' => $fileRole, 'tasks' => $fileTasks);
-                }
-            }
-        }
-
-        return $result;
-    }
-
-    private function combine($left, $right)
-    {
-        return rtrim($left, '/') . '/' . ltrim($right, '/');
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Downloader/PerforceDownloader.php 2.0.9-1/src/Composer/Downloader/PerforceDownloader.php
--- 1.10.19-1/src/Composer/Downloader/PerforceDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/PerforceDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -27,7 +27,14 @@ class PerforceDownloader extends VcsDown
     /**
      * {@inheritDoc}
      */
-    public function doDownload(PackageInterface $package, $path, $url)
+    protected function doDownload(PackageInterface $package, $path, $url, PackageInterface $prevPackage = null)
+    {
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function doInstall(PackageInterface $package, $path, $url)
     {
         $ref = $package->getSourceReference();
         $label = $this->getLabelFromSourceReference($ref);
@@ -76,9 +83,9 @@ class PerforceDownloader extends VcsDown
     /**
      * {@inheritDoc}
      */
-    public function doUpdate(PackageInterface $initial, PackageInterface $target, $path, $url)
+    protected function doUpdate(PackageInterface $initial, PackageInterface $target, $path, $url)
     {
-        $this->doDownload($target, $path, $url);
+        $this->doInstall($target, $path, $url);
     }
 
     /**
@@ -86,7 +93,7 @@ class PerforceDownloader extends VcsDown
      */
     public function getLocalChanges(PackageInterface $package, $path)
     {
-        $this->io->writeError('Perforce driver does not check for local changes before overriding', true);
+        $this->io->writeError('Perforce driver does not check for local changes before overriding');
     }
 
     /**
diff -pruN 1.10.19-1/src/Composer/Downloader/PharDownloader.php 2.0.9-1/src/Composer/Downloader/PharDownloader.php
--- 1.10.19-1/src/Composer/Downloader/PharDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/PharDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,6 +12,8 @@
 
 namespace Composer\Downloader;
 
+use Composer\Package\PackageInterface;
+
 /**
  * Downloader for phar files
  *
@@ -22,7 +24,7 @@ class PharDownloader extends ArchiveDown
     /**
      * {@inheritDoc}
      */
-    protected function extract($file, $path)
+    protected function extract(PackageInterface $package, $file, $path)
     {
         // Can throw an UnexpectedValueException
         $archive = new \Phar($file);
diff -pruN 1.10.19-1/src/Composer/Downloader/RarDownloader.php 2.0.9-1/src/Composer/Downloader/RarDownloader.php
--- 1.10.19-1/src/Composer/Downloader/RarDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/RarDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,14 +12,10 @@
 
 namespace Composer\Downloader;
 
-use Composer\Config;
-use Composer\Cache;
-use Composer\EventDispatcher\EventDispatcher;
 use Composer\Util\IniHelper;
 use Composer\Util\Platform;
 use Composer\Util\ProcessExecutor;
-use Composer\Util\RemoteFilesystem;
-use Composer\IO\IOInterface;
+use Composer\Package\PackageInterface;
 use RarArchive;
 
 /**
@@ -31,15 +27,7 @@ use RarArchive;
  */
 class RarDownloader extends ArchiveDownloader
 {
-    protected $process;
-
-    public function __construct(IOInterface $io, Config $config, EventDispatcher $eventDispatcher = null, Cache $cache = null, ProcessExecutor $process = null, RemoteFilesystem $rfs = null)
-    {
-        $this->process = $process ?: new ProcessExecutor($io);
-        parent::__construct($io, $config, $eventDispatcher, $cache, $rfs);
-    }
-
-    protected function extract($file, $path)
+    protected function extract(PackageInterface $package, $file, $path)
     {
         $processError = null;
 
diff -pruN 1.10.19-1/src/Composer/Downloader/SvnDownloader.php 2.0.9-1/src/Composer/Downloader/SvnDownloader.php
--- 1.10.19-1/src/Composer/Downloader/SvnDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/SvnDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -28,7 +28,14 @@ class SvnDownloader extends VcsDownloade
     /**
      * {@inheritDoc}
      */
-    public function doDownload(PackageInterface $package, $path, $url)
+    protected function doDownload(PackageInterface $package, $path, $url, PackageInterface $prevPackage = null)
+    {
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    protected function doInstall(PackageInterface $package, $path, $url)
     {
         SvnUtil::cleanEnv();
         $ref = $package->getSourceReference();
@@ -42,13 +49,13 @@ class SvnDownloader extends VcsDownloade
         }
 
         $this->io->writeError(" Checking out ".$package->getSourceReference());
-        $this->execute($url, "svn co", sprintf("%s/%s", $url, $ref), null, $path);
+        $this->execute($package, $url, "svn co", sprintf("%s/%s", $url, $ref), null, $path);
     }
 
     /**
      * {@inheritDoc}
      */
-    public function doUpdate(PackageInterface $initial, PackageInterface $target, $path, $url)
+    protected function doUpdate(PackageInterface $initial, PackageInterface $target, $path, $url)
     {
         SvnUtil::cleanEnv();
         $ref = $target->getSourceReference();
@@ -57,14 +64,14 @@ class SvnDownloader extends VcsDownloade
             throw new \RuntimeException('The .svn directory is missing from '.$path.', see https://getcomposer.org/commit-deps for more information');
         }
 
-        $util = new SvnUtil($url, $this->io, $this->config);
+        $util = new SvnUtil($url, $this->io, $this->config, $this->process);
         $flags = "";
         if (version_compare($util->binaryVersion(), '1.7.0', '>=')) {
             $flags .= ' --ignore-ancestry';
         }
 
         $this->io->writeError(" Checking out " . $ref);
-        $this->execute($url, "svn switch" . $flags, sprintf("%s/%s", $url, $ref), $path);
+        $this->execute($target, $url, "svn switch" . $flags, sprintf("%s/%s", $url, $ref), $path);
     }
 
     /**
@@ -93,15 +100,15 @@ class SvnDownloader extends VcsDownloade
      * @throws \RuntimeException
      * @return string
      */
-    protected function execute($baseUrl, $command, $url, $cwd = null, $path = null)
+    protected function execute(PackageInterface $package, $baseUrl, $command, $url, $cwd = null, $path = null)
     {
-        $util = new SvnUtil($baseUrl, $this->io, $this->config);
+        $util = new SvnUtil($baseUrl, $this->io, $this->config, $this->process);
         $util->setCacheCredentials($this->cacheCredentials);
         try {
             return $util->execute($command, $url, $cwd, $path, $this->io->isVerbose());
         } catch (\RuntimeException $e) {
             throw new \RuntimeException(
-                'Package could not be downloaded, '.$e->getMessage()
+                $package->getPrettyName().' could not be downloaded, '.$e->getMessage()
             );
         }
     }
@@ -127,7 +134,7 @@ class SvnDownloader extends VcsDownloade
             return '    '.$elem;
         }, preg_split('{\s*\r?\n\s*}', $changes));
         $countChanges = count($changes);
-        $this->io->writeError(sprintf('    <error>The package has modified file%s:</error>', $countChanges === 1 ? '' : 's'));
+        $this->io->writeError(sprintf('    <error>'.$package->getPrettyName().' has modified file%s:</error>', $countChanges === 1 ? '' : 's'));
         $this->io->writeError(array_slice($changes, 0, 10));
         if ($countChanges > 10) {
             $remainingChanges = $countChanges - 10;
@@ -170,7 +177,7 @@ class SvnDownloader extends VcsDownloade
      */
     protected function getCommitLogs($fromReference, $toReference, $path)
     {
-        if (preg_match('{.*@(\d+)$}', $fromReference) && preg_match('{.*@(\d+)$}', $toReference)) {
+        if (preg_match('{@(\d+)$}', $fromReference) && preg_match('{@(\d+)$}', $toReference)) {
             // retrieve the svn base url from the checkout folder
             $command = sprintf('svn info --non-interactive --xml %s', ProcessExecutor::escape($path));
             if (0 !== $this->process->execute($command, $output, $path)) {
@@ -194,7 +201,7 @@ class SvnDownloader extends VcsDownloade
 
             $command = sprintf('svn log -r%s:%s --incremental', ProcessExecutor::escape($fromRevision), ProcessExecutor::escape($toRevision));
 
-            $util = new SvnUtil($baseUrl, $this->io, $this->config);
+            $util = new SvnUtil($baseUrl, $this->io, $this->config, $this->process);
             $util->setCacheCredentials($this->cacheCredentials);
             try {
                 return $util->executeLocal($command, $path, null, $this->io->isVerbose());
diff -pruN 1.10.19-1/src/Composer/Downloader/TarDownloader.php 2.0.9-1/src/Composer/Downloader/TarDownloader.php
--- 1.10.19-1/src/Composer/Downloader/TarDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/TarDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,6 +12,8 @@
 
 namespace Composer\Downloader;
 
+use Composer\Package\PackageInterface;
+
 /**
  * Downloader for tar files: tar, tar.gz or tar.bz2
  *
@@ -22,7 +24,7 @@ class TarDownloader extends ArchiveDownl
     /**
      * {@inheritDoc}
      */
-    protected function extract($file, $path)
+    protected function extract(PackageInterface $package, $file, $path)
     {
         // Can throw an UnexpectedValueException
         $archive = new \PharData($file);
diff -pruN 1.10.19-1/src/Composer/Downloader/TransportException.php 2.0.9-1/src/Composer/Downloader/TransportException.php
--- 1.10.19-1/src/Composer/Downloader/TransportException.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/TransportException.php	2021-01-27 15:09:27.000000000 +0000
@@ -20,6 +20,7 @@ class TransportException extends \Runtim
     protected $headers;
     protected $response;
     protected $statusCode;
+    protected $responseInfo = array();
 
     public function setHeaders($headers)
     {
@@ -50,4 +51,20 @@ class TransportException extends \Runtim
     {
         return $this->statusCode;
     }
+
+    /**
+     * @return array
+     */
+    public function getResponseInfo()
+    {
+        return $this->responseInfo;
+    }
+
+    /**
+     * @param array $responseInfo
+     */
+    public function setResponseInfo(array $responseInfo)
+    {
+        $this->responseInfo = $responseInfo;
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Downloader/VcsDownloader.php 2.0.9-1/src/Composer/Downloader/VcsDownloader.php
--- 1.10.19-1/src/Composer/Downloader/VcsDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/VcsDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -20,6 +20,10 @@ use Composer\Package\Version\VersionPars
 use Composer\Util\ProcessExecutor;
 use Composer\IO\IOInterface;
 use Composer\Util\Filesystem;
+use React\Promise\PromiseInterface;
+use Composer\DependencyResolver\Operation\UpdateOperation;
+use Composer\DependencyResolver\Operation\InstallOperation;
+use Composer\DependencyResolver\Operation\UninstallOperation;
 
 /**
  * @author Jordi Boggiano <j.boggiano@seld.be>
@@ -34,6 +38,8 @@ abstract class VcsDownloader implements
     protected $process;
     /** @var Filesystem */
     protected $filesystem;
+    /** @var array */
+    protected $hasCleanedChanges = array();
 
     public function __construct(IOInterface $io, Config $config, ProcessExecutor $process = null, Filesystem $fs = null)
     {
@@ -54,44 +60,79 @@ abstract class VcsDownloader implements
     /**
      * {@inheritDoc}
      */
-    public function download(PackageInterface $package, $path)
+    public function download(PackageInterface $package, $path, PackageInterface $prevPackage = null)
     {
         if (!$package->getSourceReference()) {
             throw new \InvalidArgumentException('Package '.$package->getPrettyName().' is missing reference information');
         }
 
-        $this->io->writeError("  - Installing <info>" . $package->getName() . "</info> (<comment>" . $package->getFullPrettyVersion() . "</comment>): ", false);
-        $this->filesystem->emptyDirectory($path);
+        $urls = $this->prepareUrls($package->getSourceUrls());
 
-        $urls = $package->getSourceUrls();
         while ($url = array_shift($urls)) {
             try {
-                if (Filesystem::isLocalPath($url)) {
-                    // realpath() below will not understand
-                    // url that starts with "file://"
-                    $needle = 'file://';
-                    $isFileProtocol = false;
-                    if (0 === strpos($url, $needle)) {
-                        $url = substr($url, strlen($needle));
-                        $isFileProtocol = true;
-                    }
-
-                    // realpath() below will not understand %20 spaces etc.
-                    if (false !== strpos($url, '%')) {
-                        $url = rawurldecode($url);
-                    }
-
-                    $url = realpath($url);
-
-                    if ($isFileProtocol) {
-                        $url = $needle . $url;
-                    }
+                return $this->doDownload($package, $path, $url, $prevPackage);
+            } catch (\Exception $e) {
+                // rethrow phpunit exceptions to avoid hard to debug bug failures
+                if ($e instanceof \PHPUnit\Framework\Exception) {
+                    throw $e;
+                }
+                if ($this->io->isDebug()) {
+                    $this->io->writeError('Failed: ['.get_class($e).'] '.$e->getMessage());
+                } elseif (count($urls)) {
+                    $this->io->writeError('    Failed, trying the next URL');
+                }
+                if (!count($urls)) {
+                    throw $e;
                 }
-                $this->doDownload($package, $path, $url);
+            }
+        }
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function prepare($type, PackageInterface $package, $path, PackageInterface $prevPackage = null)
+    {
+        if ($type === 'update') {
+            $this->cleanChanges($prevPackage, $path, true);
+            $this->hasCleanedChanges[$prevPackage->getUniqueName()] = true;
+        } elseif ($type === 'install') {
+            $this->filesystem->emptyDirectory($path);
+        } elseif ($type === 'uninstall') {
+            $this->cleanChanges($package, $path, false);
+        }
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function cleanup($type, PackageInterface $package, $path, PackageInterface $prevPackage = null)
+    {
+        if ($type === 'update' && isset($this->hasCleanedChanges[$prevPackage->getUniqueName()])) {
+            $this->reapplyChanges($path);
+            unset($this->hasCleanedChanges[$prevPackage->getUniqueName()]);
+        }
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function install(PackageInterface $package, $path)
+    {
+        if (!$package->getSourceReference()) {
+            throw new \InvalidArgumentException('Package '.$package->getPrettyName().' is missing reference information');
+        }
+
+        $this->io->writeError("  - " . InstallOperation::format($package).': ', false);
+
+        $urls = $this->prepareUrls($package->getSourceUrls());
+        while ($url = array_shift($urls)) {
+            try {
+                $this->doInstall($package, $path, $url);
                 break;
             } catch (\Exception $e) {
                 // rethrow phpunit exceptions to avoid hard to debug bug failures
-                if ($e instanceof \PHPUnit_Framework_Exception) {
+                if ($e instanceof \PHPUnit\Framework\Exception) {
                     throw $e;
                 }
                 if ($this->io->isDebug()) {
@@ -115,40 +156,20 @@ abstract class VcsDownloader implements
             throw new \InvalidArgumentException('Package '.$target->getPrettyName().' is missing reference information');
         }
 
-        $name = $target->getName();
-        if ($initial->getPrettyVersion() == $target->getPrettyVersion()) {
-            if ($target->getSourceType() === 'svn') {
-                $from = $initial->getSourceReference();
-                $to = $target->getSourceReference();
-            } else {
-                $from = substr($initial->getSourceReference(), 0, 7);
-                $to = substr($target->getSourceReference(), 0, 7);
-            }
-            $name .= ' '.$initial->getPrettyVersion();
-        } else {
-            $from = $initial->getFullPrettyVersion();
-            $to = $target->getFullPrettyVersion();
-        }
+        $this->io->writeError("  - " . UpdateOperation::format($initial, $target).': ', false);
 
-        $actionName = VersionParser::isUpgrade($initial->getVersion(), $target->getVersion()) ? 'Updating' : 'Downgrading';
-        $this->io->writeError("  - " . $actionName . " <info>" . $name . "</info> (<comment>" . $from . "</comment> => <comment>" . $to . "</comment>): ", false);
-
-        $this->cleanChanges($initial, $path, true);
-        $urls = $target->getSourceUrls();
+        $urls = $this->prepareUrls($target->getSourceUrls());
 
         $exception = null;
         while ($url = array_shift($urls)) {
             try {
-                if (Filesystem::isLocalPath($url)) {
-                    $url = realpath($url);
-                }
                 $this->doUpdate($initial, $target, $path, $url);
 
                 $exception = null;
                 break;
             } catch (\Exception $exception) {
                 // rethrow phpunit exceptions to avoid hard to debug bug failures
-                if ($exception instanceof \PHPUnit_Framework_Exception) {
+                if ($exception instanceof \PHPUnit\Framework\Exception) {
                     throw $exception;
                 }
                 if ($this->io->isDebug()) {
@@ -159,8 +180,6 @@ abstract class VcsDownloader implements
             }
         }
 
-        $this->reapplyChanges($path);
-
         // print the commit logs if in verbose mode and VCS metadata is present
         // because in case of missing metadata code would trigger another exception
         if (!$exception && $this->io->isVerbose() && $this->hasMetadataRepository($path)) {
@@ -195,23 +214,13 @@ abstract class VcsDownloader implements
      */
     public function remove(PackageInterface $package, $path)
     {
-        $this->io->writeError("  - Removing <info>" . $package->getName() . "</info> (<comment>" . $package->getPrettyVersion() . "</comment>)");
-        $this->cleanChanges($package, $path, false);
+        $this->io->writeError("  - " . UninstallOperation::format($package));
         if (!$this->filesystem->removeDirectory($path)) {
             throw new \RuntimeException('Could not completely delete '.$path.', aborting.');
         }
     }
 
     /**
-     * Download progress information is not available for all VCS downloaders.
-     * {@inheritDoc}
-     */
-    public function setOutputProgress($outputProgress)
-    {
-        return $this;
-    }
-
-    /**
      * {@inheritDoc}
      */
     public function getVcsReference(PackageInterface $package, $path)
@@ -244,7 +253,7 @@ abstract class VcsDownloader implements
     }
 
     /**
-     * Guarantee that no changes have been made to the local copy
+     * Reapply previously stashes changes if applicable, only called after an update (regardless if successful or not)
      *
      * @param  string            $path
      * @throws \RuntimeException in case the operation must be aborted or the patch does not apply cleanly
@@ -254,13 +263,27 @@ abstract class VcsDownloader implements
     }
 
     /**
+     * Downloads data needed to run an install/update later
+     *
+     * @param PackageInterface      $package     package instance
+     * @param string                $path        download path
+     * @param string                $url         package url
+     * @param PackageInterface|null $prevPackage previous package (in case of an update)
+     *
+     * @return PromiseInterface|null
+     */
+    abstract protected function doDownload(PackageInterface $package, $path, $url, PackageInterface $prevPackage = null);
+
+    /**
      * Downloads specific package into specific folder.
      *
      * @param PackageInterface $package package instance
      * @param string           $path    download path
      * @param string           $url     package url
+     *
+     * @return PromiseInterface|null
      */
-    abstract protected function doDownload(PackageInterface $package, $path, $url);
+    abstract protected function doInstall(PackageInterface $package, $path, $url);
 
     /**
      * Updates specific package in specific folder from initial to target version.
@@ -269,6 +292,8 @@ abstract class VcsDownloader implements
      * @param PackageInterface $target  updated package
      * @param string           $path    download path
      * @param string           $url     package url
+     *
+     * @return PromiseInterface|null
      */
     abstract protected function doUpdate(PackageInterface $initial, PackageInterface $target, $path, $url);
 
@@ -290,4 +315,33 @@ abstract class VcsDownloader implements
      * @return bool
      */
     abstract protected function hasMetadataRepository($path);
+
+    private function prepareUrls(array $urls)
+    {
+        foreach ($urls as $index => $url) {
+            if (Filesystem::isLocalPath($url)) {
+                // realpath() below will not understand
+                // url that starts with "file://"
+                $fileProtocol = 'file://';
+                $isFileProtocol = false;
+                if (0 === strpos($url, $fileProtocol)) {
+                    $url = substr($url, strlen($fileProtocol));
+                    $isFileProtocol = true;
+                }
+
+                // realpath() below will not understand %20 spaces etc.
+                if (false !== strpos($url, '%')) {
+                    $url = rawurldecode($url);
+                }
+
+                $urls[$index] = realpath($url);
+
+                if ($isFileProtocol) {
+                    $urls[$index] = $fileProtocol . $urls[$index];
+                }
+            }
+        }
+
+        return $urls;
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Downloader/XzDownloader.php 2.0.9-1/src/Composer/Downloader/XzDownloader.php
--- 1.10.19-1/src/Composer/Downloader/XzDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/XzDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,13 +12,8 @@
 
 namespace Composer\Downloader;
 
-use Composer\Config;
-use Composer\Cache;
-use Composer\EventDispatcher\EventDispatcher;
 use Composer\Package\PackageInterface;
 use Composer\Util\ProcessExecutor;
-use Composer\Util\RemoteFilesystem;
-use Composer\IO\IOInterface;
 
 /**
  * Xz archive downloader.
@@ -28,16 +23,7 @@ use Composer\IO\IOInterface;
  */
 class XzDownloader extends ArchiveDownloader
 {
-    protected $process;
-
-    public function __construct(IOInterface $io, Config $config, EventDispatcher $eventDispatcher = null, Cache $cache = null, ProcessExecutor $process = null, RemoteFilesystem $rfs = null)
-    {
-        $this->process = $process ?: new ProcessExecutor($io);
-
-        parent::__construct($io, $config, $eventDispatcher, $cache, $rfs);
-    }
-
-    protected function extract($file, $path)
+    protected function extract(PackageInterface $package, $file, $path)
     {
         $command = 'tar -xJf ' . ProcessExecutor::escape($file) . ' -C ' . ProcessExecutor::escape($path);
 
@@ -49,12 +35,4 @@ class XzDownloader extends ArchiveDownlo
 
         throw new \RuntimeException($processError);
     }
-
-    /**
-     * {@inheritdoc}
-     */
-    protected function getFileName(PackageInterface $package, $path)
-    {
-        return $path.'/'.pathinfo(parse_url($package->getDistUrl(), PHP_URL_PATH), PATHINFO_BASENAME);
-    }
 }
diff -pruN 1.10.19-1/src/Composer/Downloader/ZipDownloader.php 2.0.9-1/src/Composer/Downloader/ZipDownloader.php
--- 1.10.19-1/src/Composer/Downloader/ZipDownloader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Downloader/ZipDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,15 +12,10 @@
 
 namespace Composer\Downloader;
 
-use Composer\Config;
-use Composer\Cache;
-use Composer\EventDispatcher\EventDispatcher;
 use Composer\Package\PackageInterface;
 use Composer\Util\IniHelper;
 use Composer\Util\Platform;
 use Composer\Util\ProcessExecutor;
-use Composer\Util\RemoteFilesystem;
-use Composer\IO\IOInterface;
 use Symfony\Component\Process\ExecutableFinder;
 use ZipArchive;
 
@@ -33,19 +28,13 @@ class ZipDownloader extends ArchiveDownl
     private static $hasZipArchive;
     private static $isWindows;
 
-    protected $process;
+    /** @var ZipArchive|null */
     private $zipArchiveObject;
 
-    public function __construct(IOInterface $io, Config $config, EventDispatcher $eventDispatcher = null, Cache $cache = null, ProcessExecutor $process = null, RemoteFilesystem $rfs = null)
-    {
-        $this->process = $process ?: new ProcessExecutor($io);
-        parent::__construct($io, $config, $eventDispatcher, $cache, $rfs);
-    }
-
     /**
      * {@inheritDoc}
      */
-    public function download(PackageInterface $package, $path, $output = true)
+    public function download(PackageInterface $package, $path, PackageInterface $prevPackage = null, $output = true)
     {
         if (null === self::$hasSystemUnzip) {
             $finder = new ExecutableFinder;
@@ -74,18 +63,17 @@ class ZipDownloader extends ArchiveDownl
             }
         }
 
-        return parent::download($package, $path, $output);
+        return parent::download($package, $path, $prevPackage, $output);
     }
 
     /**
      * extract $file to $path with "unzip" command
      *
-     * @param  string $file         File to extract
-     * @param  string $path         Path where to extract file
-     * @param  bool   $isLastChance If true it is called as a fallback and should throw an exception
-     * @return bool   Success status
+     * @param string $file         File to extract
+     * @param string $path         Path where to extract file
+     * @param bool   $isLastChance If true it is called as a fallback and should throw an exception
      */
-    protected function extractWithSystemUnzip($file, $path, $isLastChance)
+    private function extractWithSystemUnzip(PackageInterface $package, $file, $path, $isLastChance, $async = false)
     {
         if (!self::$hasZipArchive) {
             // Force Exception throwing if the Other alternative is not available
@@ -95,18 +83,56 @@ class ZipDownloader extends ArchiveDownl
         if (!self::$hasSystemUnzip && !$isLastChance) {
             // This was call as the favorite extract way, but is not available
             // We switch to the alternative
-            return $this->extractWithZipArchive($file, $path, true);
+            return $this->extractWithZipArchive($package, $file, $path, true);
         }
 
-        $processError = null;
         // When called after a ZipArchive failed, perhaps there is some files to overwrite
         $overwrite = $isLastChance ? '-o' : '';
-
         $command = 'unzip -qq '.$overwrite.' '.ProcessExecutor::escape($file).' -d '.ProcessExecutor::escape($path);
 
+        if ($async) {
+            $self = $this;
+            $io = $this->io;
+            $tryFallback = function ($processError) use ($isLastChance, $io, $self, $file, $path, $package) {
+                if ($isLastChance) {
+                    throw $processError;
+                }
+
+                if (!is_file($file)) {
+                    $io->writeError('    <warning>'.$processError->getMessage().'</warning>');
+                    $io->writeError('    <warning>This most likely is due to a custom installer plugin not handling the returned Promise from the downloader</warning>');
+                    $io->writeError('    <warning>See https://github.com/composer/installers/commit/5006d0c28730ade233a8f42ec31ac68fb1c5c9bb for an example fix</warning>');
+                } else {
+                    $io->writeError('    <warning>'.$processError->getMessage().'</warning>');
+                    $io->writeError('    The archive may contain identical file names with different capitalization (which fails on case insensitive filesystems)');
+                    $io->writeError('    Unzip with unzip command failed, falling back to ZipArchive class');
+                }
+
+                return $self->extractWithZipArchive($package, $file, $path, true);
+            };
+
+            try {
+                $promise = $this->process->executeAsync($command);
+
+                return $promise->then(function ($process) use ($tryFallback, $command, $package, $file) {
+                    if (!$process->isSuccessful()) {
+                        $output = $process->getErrorOutput();
+                        $output = str_replace(', '.$file.'.zip or '.$file.'.ZIP', '', $output);
+
+                        return $tryFallback(new \RuntimeException('Failed to extract '.$package->getName().': ('.$process->getExitCode().') '.$command."\n\n".$output));
+                    }
+                });
+            } catch (\Exception $e) {
+                return $tryFallback($e);
+            } catch (\Throwable $e) {
+                return $tryFallback($e);
+            }
+        }
+
+        $processError = null;
         try {
             if (0 === $exitCode = $this->process->execute($command, $ignoredOutput)) {
-                return true;
+                return \React\Promise\resolve();
             }
 
             $processError = new \RuntimeException('Failed to execute ('.$exitCode.') '.$command."\n\n".$this->process->getErrorOutput());
@@ -118,22 +144,24 @@ class ZipDownloader extends ArchiveDownl
             throw $processError;
         }
 
-        $this->io->writeError('    '.$processError->getMessage());
+        $this->io->writeError('    <warning>'.$processError->getMessage().'</warning>');
         $this->io->writeError('    The archive may contain identical file names with different capitalization (which fails on case insensitive filesystems)');
         $this->io->writeError('    Unzip with unzip command failed, falling back to ZipArchive class');
 
-        return $this->extractWithZipArchive($file, $path, true);
+        return $this->extractWithZipArchive($package, $file, $path, true);
     }
 
     /**
      * extract $file to $path with ZipArchive
      *
-     * @param  string $file         File to extract
-     * @param  string $path         Path where to extract file
-     * @param  bool   $isLastChance If true it is called as a fallback and should throw an exception
-     * @return bool   Success status
+     * @param string $file         File to extract
+     * @param string $path         Path where to extract file
+     * @param bool   $isLastChance If true it is called as a fallback and should throw an exception
+     *
+     * TODO v3 should make this private once we can drop PHP 5.3 support
+     * @protected
      */
-    protected function extractWithZipArchive($file, $path, $isLastChance)
+    public function extractWithZipArchive(PackageInterface $package, $file, $path, $isLastChance)
     {
         if (!self::$hasSystemUnzip) {
             // Force Exception throwing if the Other alternative is not available
@@ -143,7 +171,7 @@ class ZipDownloader extends ArchiveDownl
         if (!self::$hasZipArchive && !$isLastChance) {
             // This was call as the favorite extract way, but is not available
             // We switch to the alternative
-            return $this->extractWithSystemUnzip($file, $path, true);
+            return $this->extractWithSystemUnzip($package, $file, $path, true);
         }
 
         $processError = null;
@@ -156,7 +184,7 @@ class ZipDownloader extends ArchiveDownl
                 if (true === $extractResult) {
                     $zipArchive->close();
 
-                    return true;
+                    return \React\Promise\resolve();
                 }
 
                 $processError = new \RuntimeException(rtrim("There was an error extracting the ZIP file, it is either corrupted or using an invalid format.\n"));
@@ -167,16 +195,18 @@ class ZipDownloader extends ArchiveDownl
             $processError = new \RuntimeException('The archive may contain identical file names with different capitalization (which fails on case insensitive filesystems): '.$e->getMessage(), 0, $e);
         } catch (\Exception $e) {
             $processError = $e;
+        } catch (\Throwable $e) {
+            $processError = $e;
         }
 
         if ($isLastChance) {
             throw $processError;
         }
 
-        $this->io->writeError('    '.$processError->getMessage());
+        $this->io->writeError('    <warning>'.$processError->getMessage().'</warning>');
         $this->io->writeError('    Unzip with ZipArchive class failed, falling back to unzip command');
 
-        return $this->extractWithSystemUnzip($file, $path, true);
+        return $this->extractWithSystemUnzip($package, $file, $path, true);
     }
 
     /**
@@ -184,15 +214,18 @@ class ZipDownloader extends ArchiveDownl
      *
      * @param string $file File to extract
      * @param string $path Path where to extract file
+     *
+     * TODO v3 should make this private once we can drop PHP 5.3 support
+     * @protected
      */
-    public function extract($file, $path)
+    public function extract(PackageInterface $package, $file, $path)
     {
         // Each extract calls its alternative if not available or fails
         if (self::$isWindows) {
-            $this->extractWithZipArchive($file, $path, false);
-        } else {
-            $this->extractWithSystemUnzip($file, $path, false);
+            return $this->extractWithZipArchive($package, $file, $path, false);
         }
+
+        return $this->extractWithSystemUnzip($package, $file, $path, false, true);
     }
 
     /**
diff -pruN 1.10.19-1/src/Composer/EventDispatcher/EventDispatcher.php 2.0.9-1/src/Composer/EventDispatcher/EventDispatcher.php
--- 1.10.19-1/src/Composer/EventDispatcher/EventDispatcher.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/EventDispatcher/EventDispatcher.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,19 +12,18 @@
 
 namespace Composer\EventDispatcher;
 
-use Composer\DependencyResolver\PolicyInterface;
-use Composer\DependencyResolver\Pool;
-use Composer\DependencyResolver\Request;
+use Composer\DependencyResolver\Transaction;
 use Composer\Installer\InstallerEvent;
 use Composer\IO\IOInterface;
 use Composer\Composer;
 use Composer\DependencyResolver\Operation\OperationInterface;
-use Composer\Repository\CompositeRepository;
+use Composer\Repository\RepositoryInterface;
 use Composer\Script;
 use Composer\Installer\PackageEvent;
 use Composer\Installer\BinaryInstaller;
 use Composer\Util\ProcessExecutor;
 use Composer\Script\Event as ScriptEvent;
+use Composer\ClassLoader;
 use Symfony\Component\Process\PhpExecutableFinder;
 
 /**
@@ -42,11 +41,17 @@ use Symfony\Component\Process\PhpExecuta
  */
 class EventDispatcher
 {
+    /** @var Composer */
     protected $composer;
+    /** @var IOInterface */
     protected $io;
+    /** @var ?ClassLoader */
     protected $loader;
+    /** @var ProcessExecutor */
     protected $process;
-    protected $listeners;
+    /** @var array<string, array<int, array<callable|string>>> */
+    protected $listeners = array();
+    /** @var list<string> */
     private $eventStack;
 
     /**
@@ -99,40 +104,34 @@ class EventDispatcher
     /**
      * Dispatch a package event.
      *
-     * @param string              $eventName     The constant in PackageEvents
-     * @param bool                $devMode       Whether or not we are in dev mode
-     * @param PolicyInterface     $policy        The policy
-     * @param Pool                $pool          The pool
-     * @param CompositeRepository $installedRepo The installed repository
-     * @param Request             $request       The request
-     * @param array               $operations    The list of operations
-     * @param OperationInterface  $operation     The package being installed/updated/removed
+     * @param string              $eventName  The constant in PackageEvents
+     * @param bool                $devMode    Whether or not we are in dev mode
+     * @param RepositoryInterface $localRepo  The installed repository
+     * @param array               $operations The list of operations
+     * @param OperationInterface  $operation  The package being installed/updated/removed
      *
      * @return int return code of the executed script if any, for php scripts a false return
      *             value is changed to 1, anything else to 0
      */
-    public function dispatchPackageEvent($eventName, $devMode, PolicyInterface $policy, Pool $pool, CompositeRepository $installedRepo, Request $request, array $operations, OperationInterface $operation)
+    public function dispatchPackageEvent($eventName, $devMode, RepositoryInterface $localRepo, array $operations, OperationInterface $operation)
     {
-        return $this->doDispatch(new PackageEvent($eventName, $this->composer, $this->io, $devMode, $policy, $pool, $installedRepo, $request, $operations, $operation));
+        return $this->doDispatch(new PackageEvent($eventName, $this->composer, $this->io, $devMode, $localRepo, $operations, $operation));
     }
 
     /**
      * Dispatch a installer event.
      *
-     * @param string              $eventName     The constant in InstallerEvents
-     * @param bool                $devMode       Whether or not we are in dev mode
-     * @param PolicyInterface     $policy        The policy
-     * @param Pool                $pool          The pool
-     * @param CompositeRepository $installedRepo The installed repository
-     * @param Request             $request       The request
-     * @param array               $operations    The list of operations
+     * @param string      $eventName         The constant in InstallerEvents
+     * @param bool        $devMode           Whether or not we are in dev mode
+     * @param bool        $executeOperations True if operations will be executed, false in --dry-run
+     * @param Transaction $transaction       The transaction contains the list of operations
      *
      * @return int return code of the executed script if any, for php scripts a false return
      *             value is changed to 1, anything else to 0
      */
-    public function dispatchInstallerEvent($eventName, $devMode, PolicyInterface $policy, Pool $pool, CompositeRepository $installedRepo, Request $request, array $operations = array())
+    public function dispatchInstallerEvent($eventName, $devMode, $executeOperations, Transaction $transaction)
     {
-        return $this->doDispatch(new InstallerEvent($eventName, $this->composer, $this->io, $devMode, $policy, $pool, $installedRepo, $request, $operations));
+        return $this->doDispatch(new InstallerEvent($eventName, $this->composer, $this->io, $devMode, $executeOperations, $transaction));
     }
 
     /**
@@ -145,13 +144,20 @@ class EventDispatcher
      */
     protected function doDispatch(Event $event)
     {
+        if (getenv('COMPOSER_DEBUG_EVENTS')) {
+            $details = null;
+            if ($event instanceof PackageEvent) {
+                $details = (string) $event->getOperation();
+            }
+            $this->io->writeError('Dispatching <info>'.$event->getName().'</info>'.($details ? ' ('.$details.')' : '').' event');
+        }
+
         $listeners = $this->getListeners($event);
 
         $this->pushEvent($event);
 
         $return = 0;
         foreach ($listeners as $callable) {
-
             $this->ensureBinDirIsInPath();
 
             if (!is_string($callable)) {
@@ -160,7 +166,9 @@ class EventDispatcher
 
                     throw new \RuntimeException('Subscriber '.$className.'::'.$callable[1].' for event '.$event->getName().' is not callable, make sure the function is defined and public');
                 }
-                $event = $this->checkListenerExpectedEvent($callable, $event);
+                if (is_array($callable) && (is_string($callable[0]) || is_object($callable[0])) && is_string($callable[1])) {
+                    $this->io->writeError(sprintf('> %s: %s', $event->getName(), (is_object($callable[0]) ? get_class($callable[0]) : $callable[0]).'->'.$callable[1]), true, IOInterface::VERBOSE);
+                }
                 $return = false === call_user_func($callable, $event) ? 1 : 0;
             } elseif ($this->isComposerScript($callable)) {
                 $this->io->writeError(sprintf('> %s: %s', $event->getName(), $callable), true, IOInterface::VERBOSE);
@@ -171,9 +179,9 @@ class EventDispatcher
 
                 $args = array_merge($script, $event->getArguments());
                 $flags = $event->getFlags();
-                if (substr($callable, 0, 10) === '@composer ') {
-                    $exec = $this->getPhpExecCommand() . ' ' . ProcessExecutor::escape(getenv('COMPOSER_BINARY')) . substr($callable, 9);
-                    if (0 !== ($exitCode = $this->process->execute($exec))) {
+                if (strpos($callable, '@composer ') === 0) {
+                    $exec = $this->getPhpExecCommand() . ' ' . ProcessExecutor::escape(getenv('COMPOSER_BINARY')) . ' ' . implode(' ', $args);
+                    if (0 !== ($exitCode = $this->executeTty($exec))) {
                         $this->io->writeError(sprintf('<error>Script %s handling the %s event returned with error code '.$exitCode.'</error>', $callable, $event->getName()), true, IOInterface::QUIET);
 
                         throw new ScriptExecutionException('Error Output: '.$this->process->getErrorOutput(), $exitCode);
@@ -184,6 +192,7 @@ class EventDispatcher
                     }
 
                     try {
+                        /** @var InstallerEvent $event */
                         $scriptEvent = new Script\Event($scriptName, $event->getComposer(), $event->getIO(), $event->isDevMode(), $args, $flags);
                         $scriptEvent->setOriginatingEvent($event);
                         $return = $this->dispatch($scriptName, $scriptEvent);
@@ -232,11 +241,14 @@ class EventDispatcher
                     }
                 }
 
-                if (substr($exec, 0, 8) === '@putenv ') {
+                if (strpos($exec, '@putenv ') === 0) {
                     putenv(substr($exec, 8));
+                    list($var, $value) = explode('=', substr($exec, 8), 2);
+                    $_SERVER[$var] = $value;
 
                     continue;
-                } elseif (substr($exec, 0, 5) === '@php ') {
+                }
+                if (strpos($exec, '@php ') === 0) {
                     $exec = $this->getPhpExecCommand() . ' ' . substr($exec, 5);
                 } else {
                     $finder = new PhpExecutableFinder();
@@ -250,11 +262,11 @@ class EventDispatcher
                 // if composer is being executed, make sure it runs the expected composer from current path
                 // resolution, even if bin-dir contains composer too because the project requires composer/composer
                 // see https://github.com/composer/composer/issues/8748
-                if (substr($exec, 0, 9) === 'composer ') {
+                if (strpos($exec, 'composer ') === 0) {
                     $exec = $this->getPhpExecCommand() . ' ' . ProcessExecutor::escape(getenv('COMPOSER_BINARY')) . substr($exec, 8);
                 }
 
-                if (0 !== ($exitCode = $this->process->execute($exec))) {
+                if (0 !== ($exitCode = $this->executeTty($exec))) {
                     $this->io->writeError(sprintf('<error>Script %s handling the %s event returned with error code '.$exitCode.'</error>', $callable, $event->getName()), true, IOInterface::QUIET);
 
                     throw new ScriptExecutionException('Error Output: '.$this->process->getErrorOutput(), $exitCode);
@@ -271,6 +283,15 @@ class EventDispatcher
         return $return;
     }
 
+    protected function executeTty($exec)
+    {
+        if ($this->io->isInteractive()) {
+            return $this->process->executeTty($exec);
+        }
+
+        return $this->process->execute($exec);
+    }
+
     protected function getPhpExecCommand()
     {
         $finder = new PhpExecutableFinder();
@@ -294,8 +315,6 @@ class EventDispatcher
      */
     protected function executeEventPhpScript($className, $methodName, Event $event)
     {
-        $event = $this->checkListenerExpectedEvent(array($className, $methodName), $event);
-
         if ($this->io->isVerbose()) {
             $this->io->writeError(sprintf('> %s: %s::%s', $event->getName(), $className, $methodName));
         } else {
@@ -306,102 +325,6 @@ class EventDispatcher
     }
 
     /**
-     * @param  mixed $target
-     * @param  Event $event
-     * @return Event
-     */
-    protected function checkListenerExpectedEvent($target, Event $event)
-    {
-        if (in_array($event->getName(), array(
-            'init',
-            'command',
-            'pre-file-download',
-        ), true)) {
-            return $event;
-        }
-
-        try {
-            $reflected = new \ReflectionParameter($target, 0);
-        } catch (\Exception $e) {
-            return $event;
-        }
-
-        $expected = null;
-        $isClass = false;
-        if (\PHP_VERSION_ID >= 70000) {
-            $reflectionType = $reflected->getType();
-            if ($reflectionType) {
-                $expected = $reflectionType instanceof \ReflectionNamedType ? $reflectionType->getName() : (string)$reflectionType;
-                $isClass = !$reflectionType->isBuiltin();
-            }
-        } else {
-            $expected = $reflected->getClass() ? $reflected->getClass()->getName() : null;
-            $isClass = null !== $expected;
-        }
-
-        if (!$isClass) {
-            return $event;
-        }
-
-        // BC support
-        if (!$event instanceof $expected && $expected === 'Composer\Script\CommandEvent') {
-            trigger_error('The callback '.$this->serializeCallback($target).' declared at '.$reflected->getDeclaringFunction()->getFileName().' accepts a '.$expected.' but '.$event->getName().' events use a '.get_class($event).' instance. Please adjust your type hint accordingly, see https://getcomposer.org/doc/articles/scripts.md#event-classes', E_USER_DEPRECATED);
-            $event = new \Composer\Script\CommandEvent(
-                $event->getName(),
-                $event->getComposer(),
-                $event->getIO(),
-                $event->isDevMode(),
-                $event->getArguments()
-            );
-        }
-        if (!$event instanceof $expected && $expected === 'Composer\Script\PackageEvent') {
-            trigger_error('The callback '.$this->serializeCallback($target).' declared at '.$reflected->getDeclaringFunction()->getFileName().' accepts a '.$expected.' but '.$event->getName().' events use a '.get_class($event).' instance. Please adjust your type hint accordingly, see https://getcomposer.org/doc/articles/scripts.md#event-classes', E_USER_DEPRECATED);
-            $event = new \Composer\Script\PackageEvent(
-                $event->getName(),
-                $event->getComposer(),
-                $event->getIO(),
-                $event->isDevMode(),
-                $event->getPolicy(),
-                $event->getPool(),
-                $event->getInstalledRepo(),
-                $event->getRequest(),
-                $event->getOperations(),
-                $event->getOperation()
-            );
-        }
-        if (!$event instanceof $expected && $expected === 'Composer\Script\Event') {
-            trigger_error('The callback '.$this->serializeCallback($target).' declared at '.$reflected->getDeclaringFunction()->getFileName().' accepts a '.$expected.' but '.$event->getName().' events use a '.get_class($event).' instance. Please adjust your type hint accordingly, see https://getcomposer.org/doc/articles/scripts.md#event-classes', E_USER_DEPRECATED);
-            $event = new \Composer\Script\Event(
-                $event->getName(),
-                $event->getComposer(),
-                $event->getIO(),
-                $event->isDevMode(),
-                $event->getArguments(),
-                $event->getFlags()
-            );
-        }
-
-        return $event;
-    }
-
-    private function serializeCallback($cb)
-    {
-        if (is_array($cb) && count($cb) === 2) {
-            if (is_object($cb[0])) {
-                $cb[0] = get_class($cb[0]);
-            }
-            if (is_string($cb[0]) && is_string($cb[1])) {
-                $cb = implode('::', $cb);
-            }
-        }
-        if (is_string($cb)) {
-            return $cb;
-        }
-
-        return var_export($cb, true);
-    }
-
-    /**
      * Add a listener for a particular event
      *
      * @param string   $eventName The event name - typically a constant
@@ -414,6 +337,22 @@ class EventDispatcher
     }
 
     /**
+     * @param callable|object $listener A callable or an object instance for which all listeners should be removed
+     */
+    public function removeListener($listener)
+    {
+        foreach ($this->listeners as $eventName => $priorities) {
+            foreach ($priorities as $priority => $listeners) {
+                foreach ($listeners as $index => $candidate) {
+                    if ($listener === $candidate || (is_array($candidate) && is_object($listener) && $candidate[0] === $listener)) {
+                        unset($this->listeners[$eventName][$priority][$index]);
+                    }
+                }
+            }
+        }
+    }
+
+    /**
      * Adds object methods as listeners for the events in getSubscribedEvents
      *
      * @see EventSubscriberInterface
@@ -521,7 +460,7 @@ class EventDispatcher
      */
     protected function isComposerScript($callable)
     {
-        return '@' === substr($callable, 0, 1) && '@php ' !== substr($callable, 0, 5) && '@putenv ' !== substr($callable, 0, 8);
+        return strpos($callable, '@') === 0 && strpos($callable, '@php ') !== 0 && strpos($callable, '@putenv ') !== 0;
     }
 
     /**
@@ -529,7 +468,7 @@ class EventDispatcher
      *
      * @param  Event             $event
      * @throws \RuntimeException
-     * @return number
+     * @return int
      */
     protected function pushEvent(Event $event)
     {
diff -pruN 1.10.19-1/src/Composer/Exception/IrrecoverableDownloadException.php 2.0.9-1/src/Composer/Exception/IrrecoverableDownloadException.php
--- 1.10.19-1/src/Composer/Exception/IrrecoverableDownloadException.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Exception/IrrecoverableDownloadException.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,20 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Exception;
+
+/**
+ * @author Jordi Boggiano <j.boggiano@seld.be>
+ */
+class IrrecoverableDownloadException extends \RuntimeException
+{
+}
diff -pruN 1.10.19-1/src/Composer/Exception/NoSslException.php 2.0.9-1/src/Composer/Exception/NoSslException.php
--- 1.10.19-1/src/Composer/Exception/NoSslException.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Exception/NoSslException.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,8 @@
 namespace Composer\Exception;
 
 /**
+ * Specific exception for Composer\Util\HttpDownloader creation.
+ *
  * @author Jordi Boggiano <j.boggiano@seld.be>
  */
 class NoSslException extends \RuntimeException
diff -pruN 1.10.19-1/src/Composer/Factory.php 2.0.9-1/src/Composer/Factory.php
--- 1.10.19-1/src/Composer/Factory.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Factory.php	2021-01-27 15:09:27.000000000 +0000
@@ -17,13 +17,15 @@ use Composer\Json\JsonFile;
 use Composer\IO\IOInterface;
 use Composer\Package\Archiver;
 use Composer\Package\Version\VersionGuesser;
+use Composer\Package\RootPackageInterface;
 use Composer\Repository\RepositoryManager;
 use Composer\Repository\RepositoryFactory;
 use Composer\Repository\WritableRepositoryInterface;
 use Composer\Util\Filesystem;
 use Composer\Util\Platform;
 use Composer\Util\ProcessExecutor;
-use Composer\Util\RemoteFilesystem;
+use Composer\Util\HttpDownloader;
+use Composer\Util\Loop;
 use Composer\Util\Silencer;
 use Composer\Plugin\PluginEvents;
 use Composer\EventDispatcher\Event;
@@ -67,18 +69,29 @@ class Factory
         }
 
         $userDir = self::getUserDir();
-        if (is_dir($userDir . '/.composer')) {
-            return $userDir . '/.composer';
-        }
+        $dirs = array();
 
         if (self::useXdg()) {
             // XDG Base Directory Specifications
-            $xdgConfig = getenv('XDG_CONFIG_HOME') ?: $userDir . '/.config';
+            $xdgConfig = getenv('XDG_CONFIG_HOME');
+            if (!$xdgConfig) {
+                $xdgConfig = $userDir . '/.config';
+            }
+
+            $dirs[] = $xdgConfig . '/composer';
+        }
+
+        $dirs[] = $userDir . '/.composer';
 
-            return $xdgConfig . '/composer';
+        // select first dir which exists of: $XDG_CONFIG_HOME/composer or ~/.composer
+        foreach ($dirs as $dir) {
+            if (Silencer::call('is_dir', $dir)) {
+                return $dir;
+            }
         }
 
-        return $userDir . '/.composer';
+        // if none exists, we default to first defined one (XDG one if system uses it, or ~/.composer otherwise)
+        return $dirs[0];
     }
 
     /**
@@ -222,6 +235,13 @@ class Factory
         return trim(getenv('COMPOSER')) ?: './composer.json';
     }
 
+    public static function getLockFile($composerFile)
+    {
+        return "json" === pathinfo($composerFile, PATHINFO_EXTENSION)
+                ? substr($composerFile, 0, -4).'lock'
+                : $composerFile . '.lock';
+    }
+
     public static function createAdditionalStyles()
     {
         return array(
@@ -244,14 +264,6 @@ class Factory
     }
 
     /**
-     * @deprecated Use Composer\Repository\RepositoryFactory::defaultRepos instead
-     */
-    public static function createDefaultRepositories(IOInterface $io = null, Config $config = null, RepositoryManager $rm = null)
-    {
-        return RepositoryFactory::defaultRepos($io, $config, $rm);
-    }
-
-    /**
      * Creates a Composer instance
      *
      * @param  IOInterface               $io             IO instance
@@ -283,7 +295,7 @@ class Factory
                 } else {
                     $message = 'Composer could not find the config file: '.$localConfig;
                 }
-                $instructions = 'To initialize a project, please create a composer.json file as described in the https://getcomposer.org/ "Getting Started" section';
+                $instructions = $fullLoad ? 'To initialize a project, please create a composer.json file as described in the https://getcomposer.org/ "Getting Started" section' : '';
                 throw new \InvalidArgumentException($message.PHP_EOL.$instructions);
             }
 
@@ -303,7 +315,7 @@ class Factory
         $config = static::createConfig($io, $cwd);
         $config->merge($localConfig);
         if (isset($composerFile)) {
-            $io->writeError('Loading config file ' . $composerFile, true, IOInterface::DEBUG);
+            $io->writeError('Loading config file ' . $composerFile .' ('.realpath($composerFile).')', true, IOInterface::DEBUG);
             $config->setConfigSource(new JsonConfigSource(new JsonFile(realpath($composerFile), null, $io)));
 
             $localAuthFile = new JsonFile(dirname(realpath($composerFile)) . '/auth.json', null, $io);
@@ -323,21 +335,26 @@ class Factory
         if ($fullLoad) {
             // load auth configs into the IO instance
             $io->loadConfiguration($config);
+
+            // load existing Composer\InstalledVersions instance if available
+            if (!class_exists('Composer\InstalledVersions', false) && file_exists($installedVersionsPath = $config->get('vendor-dir').'/composer/InstalledVersions.php')) {
+                include $installedVersionsPath;
+            }
         }
 
-        $rfs = self::createRemoteFilesystem($io, $config);
+        $httpDownloader = self::createHttpDownloader($io, $config);
+        $process = new ProcessExecutor($io);
+        $loop = new Loop($httpDownloader, $process);
+        $composer->setLoop($loop);
 
         // initialize event dispatcher
-        $dispatcher = new EventDispatcher($composer, $io);
+        $dispatcher = new EventDispatcher($composer, $io, $process);
         $composer->setEventDispatcher($dispatcher);
 
         // initialize repository manager
-        $rm = RepositoryFactory::manager($io, $config, $dispatcher, $rfs);
+        $rm = RepositoryFactory::manager($io, $config, $httpDownloader, $dispatcher, $process);
         $composer->setRepositoryManager($rm);
 
-        // load local repository
-        $this->addLocalRepository($io, $rm, $vendorDir);
-
         // force-set the version of the global package if not defined as
         // guessing it adds no value and only takes time
         if (!$fullLoad && !isset($localConfig['version'])) {
@@ -346,18 +363,21 @@ class Factory
 
         // load package
         $parser = new VersionParser;
-        $guesser = new VersionGuesser($config, new ProcessExecutor($io), $parser);
-        $loader = new Package\Loader\RootPackageLoader($rm, $config, $parser, $guesser, $io);
+        $guesser = new VersionGuesser($config, $process, $parser);
+        $loader = $this->loadRootPackage($rm, $config, $parser, $guesser, $io);
         $package = $loader->load($localConfig, 'Composer\Package\RootPackage', $cwd);
         $composer->setPackage($package);
 
+        // load local repository
+        $this->addLocalRepository($io, $rm, $vendorDir, $package);
+
         // initialize installation manager
-        $im = $this->createInstallationManager();
+        $im = $this->createInstallationManager($loop, $io, $dispatcher);
         $composer->setInstallationManager($im);
 
         if ($fullLoad) {
             // initialize download manager
-            $dm = $this->createDownloadManager($io, $config, $dispatcher, $rfs);
+            $dm = $this->createDownloadManager($io, $config, $httpDownloader, $process, $dispatcher);
             $composer->setDownloadManager($dm);
 
             // initialize autoload generator
@@ -365,12 +385,12 @@ class Factory
             $composer->setAutoloadGenerator($generator);
 
             // initialize archive manager
-            $am = $this->createArchiveManager($config, $dm);
+            $am = $this->createArchiveManager($config, $dm, $loop);
             $composer->setArchiveManager($am);
         }
 
         // add installers to the manager (must happen after download manager is created since they read it out of $composer)
-        $this->createDefaultInstallers($im, $composer, $io);
+        $this->createDefaultInstallers($im, $composer, $io, $process);
 
         if ($fullLoad) {
             $globalComposer = null;
@@ -386,11 +406,9 @@ class Factory
 
         // init locker if possible
         if ($fullLoad && isset($composerFile)) {
-            $lockFile = "json" === pathinfo($composerFile, PATHINFO_EXTENSION)
-                ? substr($composerFile, 0, -4).'lock'
-                : $composerFile . '.lock';
+            $lockFile = self::getLockFile($composerFile);
 
-            $locker = new Package\Locker($io, new JsonFile($lockFile, null, $io), $rm, $im, file_get_contents($composerFile));
+            $locker = new Package\Locker($io, new JsonFile($lockFile, null, $io), $im, file_get_contents($composerFile), $process);
             $composer->setLocker($locker);
         }
 
@@ -409,9 +427,9 @@ class Factory
     }
 
     /**
-     * @param  IOInterface $io             IO instance
-     * @param  bool        $disablePlugins Whether plugins should not be loaded
-     * @return Composer
+     * @param  IOInterface   $io             IO instance
+     * @param  bool          $disablePlugins Whether plugins should not be loaded
+     * @return Composer|null
      */
     public static function createGlobal(IOInterface $io, $disablePlugins = false)
     {
@@ -424,9 +442,9 @@ class Factory
      * @param Repository\RepositoryManager $rm
      * @param string                       $vendorDir
      */
-    protected function addLocalRepository(IOInterface $io, RepositoryManager $rm, $vendorDir)
+    protected function addLocalRepository(IOInterface $io, RepositoryManager $rm, $vendorDir, RootPackageInterface $rootPackage)
     {
-        $rm->setLocalRepository(new Repository\InstalledFilesystemRepository(new JsonFile($vendorDir.'/composer/installed.json', null, $io)));
+        $rm->setLocalRepository(new Repository\InstalledFilesystemRepository(new JsonFile($vendorDir.'/composer/installed.json', null, $io), true, $rootPackage));
     }
 
     /**
@@ -451,14 +469,17 @@ class Factory
      * @param  EventDispatcher            $eventDispatcher
      * @return Downloader\DownloadManager
      */
-    public function createDownloadManager(IOInterface $io, Config $config, EventDispatcher $eventDispatcher = null, RemoteFilesystem $rfs = null)
+    public function createDownloadManager(IOInterface $io, Config $config, HttpDownloader $httpDownloader, ProcessExecutor $process, EventDispatcher $eventDispatcher = null)
     {
         $cache = null;
         if ($config->get('cache-files-ttl') > 0) {
             $cache = new Cache($io, $config->get('cache-files-dir'), 'a-z0-9_./');
+            $cache->setReadOnly($config->get('cache-read-only'));
         }
 
-        $dm = new Downloader\DownloadManager($io);
+        $fs = new Filesystem($process);
+
+        $dm = new Downloader\DownloadManager($io, false, $fs);
         switch ($preferred = $config->get('preferred-install')) {
             case 'dist':
                 $dm->setPreferDist(true);
@@ -476,22 +497,19 @@ class Factory
             $dm->setPreferences($preferred);
         }
 
-        $executor = new ProcessExecutor($io);
-        $fs = new Filesystem($executor);
-
-        $dm->setDownloader('git', new Downloader\GitDownloader($io, $config, $executor, $fs));
-        $dm->setDownloader('svn', new Downloader\SvnDownloader($io, $config, $executor, $fs));
-        $dm->setDownloader('fossil', new Downloader\FossilDownloader($io, $config, $executor, $fs));
-        $dm->setDownloader('hg', new Downloader\HgDownloader($io, $config, $executor, $fs));
-        $dm->setDownloader('perforce', new Downloader\PerforceDownloader($io, $config));
-        $dm->setDownloader('zip', new Downloader\ZipDownloader($io, $config, $eventDispatcher, $cache, $executor, $rfs));
-        $dm->setDownloader('rar', new Downloader\RarDownloader($io, $config, $eventDispatcher, $cache, $executor, $rfs));
-        $dm->setDownloader('tar', new Downloader\TarDownloader($io, $config, $eventDispatcher, $cache, $rfs));
-        $dm->setDownloader('gzip', new Downloader\GzipDownloader($io, $config, $eventDispatcher, $cache, $executor, $rfs));
-        $dm->setDownloader('xz', new Downloader\XzDownloader($io, $config, $eventDispatcher, $cache, $executor, $rfs));
-        $dm->setDownloader('phar', new Downloader\PharDownloader($io, $config, $eventDispatcher, $cache, $rfs));
-        $dm->setDownloader('file', new Downloader\FileDownloader($io, $config, $eventDispatcher, $cache, $rfs));
-        $dm->setDownloader('path', new Downloader\PathDownloader($io, $config, $eventDispatcher, $cache, $rfs));
+        $dm->setDownloader('git', new Downloader\GitDownloader($io, $config, $process, $fs));
+        $dm->setDownloader('svn', new Downloader\SvnDownloader($io, $config, $process, $fs));
+        $dm->setDownloader('fossil', new Downloader\FossilDownloader($io, $config, $process, $fs));
+        $dm->setDownloader('hg', new Downloader\HgDownloader($io, $config, $process, $fs));
+        $dm->setDownloader('perforce', new Downloader\PerforceDownloader($io, $config, $process, $fs));
+        $dm->setDownloader('zip', new Downloader\ZipDownloader($io, $config, $httpDownloader, $eventDispatcher, $cache, $fs, $process));
+        $dm->setDownloader('rar', new Downloader\RarDownloader($io, $config, $httpDownloader, $eventDispatcher, $cache, $fs, $process));
+        $dm->setDownloader('tar', new Downloader\TarDownloader($io, $config, $httpDownloader, $eventDispatcher, $cache, $fs, $process));
+        $dm->setDownloader('gzip', new Downloader\GzipDownloader($io, $config, $httpDownloader, $eventDispatcher, $cache, $fs, $process));
+        $dm->setDownloader('xz', new Downloader\XzDownloader($io, $config, $httpDownloader, $eventDispatcher, $cache, $fs, $process));
+        $dm->setDownloader('phar', new Downloader\PharDownloader($io, $config, $httpDownloader, $eventDispatcher, $cache, $fs, $process));
+        $dm->setDownloader('file', new Downloader\FileDownloader($io, $config, $httpDownloader, $eventDispatcher, $cache, $fs, $process));
+        $dm->setDownloader('path', new Downloader\PathDownloader($io, $config, $httpDownloader, $eventDispatcher, $cache, $fs, $process));
 
         return $dm;
     }
@@ -501,15 +519,9 @@ class Factory
      * @param  Downloader\DownloadManager $dm     Manager use to download sources
      * @return Archiver\ArchiveManager
      */
-    public function createArchiveManager(Config $config, Downloader\DownloadManager $dm = null)
+    public function createArchiveManager(Config $config, Downloader\DownloadManager $dm, Loop $loop)
     {
-        if (null === $dm) {
-            $io = new IO\NullIO();
-            $io->loadConfiguration($config);
-            $dm = $this->createDownloadManager($io, $config);
-        }
-
-        $am = new Archiver\ArchiveManager($dm);
+        $am = new Archiver\ArchiveManager($dm, $loop);
         $am->addArchiver(new Archiver\ZipArchiver);
         $am->addArchiver(new Archiver\PharArchiver);
 
@@ -531,9 +543,9 @@ class Factory
     /**
      * @return Installer\InstallationManager
      */
-    protected function createInstallationManager()
+    public function createInstallationManager(Loop $loop, IOInterface $io, EventDispatcher $eventDispatcher = null)
     {
-        return new Installer\InstallationManager();
+        return new Installer\InstallationManager($loop, $io, $eventDispatcher);
     }
 
     /**
@@ -541,11 +553,13 @@ class Factory
      * @param Composer                      $composer
      * @param IO\IOInterface                $io
      */
-    protected function createDefaultInstallers(Installer\InstallationManager $im, Composer $composer, IOInterface $io)
+    protected function createDefaultInstallers(Installer\InstallationManager $im, Composer $composer, IOInterface $io, ProcessExecutor $process = null)
     {
-        $im->addInstaller(new Installer\LibraryInstaller($io, $composer, null));
-        $im->addInstaller(new Installer\PearInstaller($io, $composer, 'pear-library'));
-        $im->addInstaller(new Installer\PluginInstaller($io, $composer));
+        $fs = new Filesystem($process);
+        $binaryInstaller = new Installer\BinaryInstaller($io, rtrim($composer->getConfig()->get('bin-dir'), '/'), $composer->getConfig()->get('bin-compat'), $fs);
+
+        $im->addInstaller(new Installer\LibraryInstaller($io, $composer, null, $fs, $binaryInstaller));
+        $im->addInstaller(new Installer\PluginInstaller($io, $composer, $fs, $binaryInstaller));
         $im->addInstaller(new Installer\MetapackageInstaller($io));
     }
 
@@ -562,6 +576,11 @@ class Factory
         }
     }
 
+    protected function loadRootPackage(RepositoryManager $rm, Config $config, VersionParser $parser, VersionGuesser $guesser, IOInterface $io)
+    {
+        return new Package\Loader\RootPackageLoader($rm, $config, $parser, $guesser, $io);
+    }
+
     /**
      * @param  IOInterface $io             IO instance
      * @param  mixed       $config         either a configuration array or a filename to read from, if null it will read from
@@ -577,12 +596,14 @@ class Factory
     }
 
     /**
-     * @param  IOInterface      $io      IO instance
-     * @param  Config           $config  Config instance
-     * @param  array            $options Array of options passed directly to RemoteFilesystem constructor
-     * @return RemoteFilesystem
+     * If you are calling this in a plugin, you probably should instead use $composer->getLoop()->getHttpDownloader()
+     *
+     * @param  IOInterface    $io      IO instance
+     * @param  Config         $config  Config instance
+     * @param  array          $options Array of options passed directly to HttpDownloader constructor
+     * @return HttpDownloader
      */
-    public static function createRemoteFilesystem(IOInterface $io, Config $config = null, $options = array())
+    public static function createHttpDownloader(IOInterface $io, Config $config, $options = array())
     {
         static $warned = false;
         $disableTls = false;
@@ -600,18 +621,18 @@ class Factory
             throw new Exception\NoSslException('The openssl extension is required for SSL/TLS protection but is not available. '
                 . 'If you can not enable the openssl extension, you can disable this error, at your own risk, by setting the \'disable-tls\' option to true.');
         }
-        $remoteFilesystemOptions = array();
+        $httpDownloaderOptions = array();
         if ($disableTls === false) {
             if ($config && $config->get('cafile')) {
-                $remoteFilesystemOptions['ssl']['cafile'] = $config->get('cafile');
+                $httpDownloaderOptions['ssl']['cafile'] = $config->get('cafile');
             }
             if ($config && $config->get('capath')) {
-                $remoteFilesystemOptions['ssl']['capath'] = $config->get('capath');
+                $httpDownloaderOptions['ssl']['capath'] = $config->get('capath');
             }
-            $remoteFilesystemOptions = array_replace_recursive($remoteFilesystemOptions, $options);
+            $httpDownloaderOptions = array_replace_recursive($httpDownloaderOptions, $options);
         }
         try {
-            $remoteFilesystem = new RemoteFilesystem($io, $config, $remoteFilesystemOptions, $disableTls);
+            $httpDownloader = new HttpDownloader($io, $config, $httpDownloaderOptions, $disableTls);
         } catch (TransportException $e) {
             if (false !== strpos($e->getMessage(), 'cafile')) {
                 $io->write('<error>Unable to locate a valid CA certificate file. You must set a valid \'cafile\' option.</error>');
@@ -624,7 +645,7 @@ class Factory
             throw $e;
         }
 
-        return $remoteFilesystem;
+        return $httpDownloader;
     }
 
     /**
@@ -633,11 +654,15 @@ class Factory
     private static function useXdg()
     {
         foreach (array_keys($_SERVER) as $key) {
-            if (substr($key, 0, 4) === 'XDG_') {
+            if (strpos($key, 'XDG_') === 0) {
                 return true;
             }
         }
 
+        if (Silencer::call('is_dir', '/etc/xdg')) {
+            return true;
+        }
+
         return false;
     }
 
diff -pruN 1.10.19-1/src/Composer/InstalledVersions.php 2.0.9-1/src/Composer/InstalledVersions.php
--- 1.10.19-1/src/Composer/InstalledVersions.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/InstalledVersions.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,261 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer;
+
+use Composer\Autoload\ClassLoader;
+use Composer\Semver\VersionParser;
+
+/**
+ * This class is copied in every Composer installed project and available to all
+ *
+ * To require it's presence, you can require `composer-runtime-api ^2.0`
+ */
+class InstalledVersions
+{
+    private static $installed;
+    private static $canGetVendors;
+    private static $installedByVendor = array();
+
+    /**
+     * Returns a list of all package names which are present, either by being installed, replaced or provided
+     *
+     * @return string[]
+     * @psalm-return list<string>
+     */
+    public static function getInstalledPackages()
+    {
+        $packages = array();
+        foreach (self::getInstalled() as $installed) {
+            $packages[] = array_keys($installed['versions']);
+        }
+
+
+        if (1 === \count($packages)) {
+            return $packages[0];
+        }
+
+        return array_keys(array_flip(\call_user_func_array('array_merge', $packages)));
+    }
+
+    /**
+     * Checks whether the given package is installed
+     *
+     * This also returns true if the package name is provided or replaced by another package
+     *
+     * @param  string $packageName
+     * @return bool
+     */
+    public static function isInstalled($packageName)
+    {
+        foreach (self::getInstalled() as $installed) {
+            if (isset($installed['versions'][$packageName])) {
+                return true;
+            }
+        }
+
+        return false;
+    }
+
+    /**
+     * Checks whether the given package satisfies a version constraint
+     *
+     * e.g. If you want to know whether version 2.3+ of package foo/bar is installed, you would call:
+     *
+     *   Composer\InstalledVersions::satisfies(new VersionParser, 'foo/bar', '^2.3')
+     *
+     * @param VersionParser $parser      Install composer/semver to have access to this class and functionality
+     * @param string        $packageName
+     * @param string|null   $constraint  A version constraint to check for, if you pass one you have to make sure composer/semver is required by your package
+     *
+     * @return bool
+     */
+    public static function satisfies(VersionParser $parser, $packageName, $constraint)
+    {
+        $constraint = $parser->parseConstraints($constraint);
+        $provided = $parser->parseConstraints(self::getVersionRanges($packageName));
+
+        return $provided->matches($constraint);
+    }
+
+    /**
+     * Returns a version constraint representing all the range(s) which are installed for a given package
+     *
+     * It is easier to use this via isInstalled() with the $constraint argument if you need to check
+     * whether a given version of a package is installed, and not just whether it exists
+     *
+     * @param  string $packageName
+     * @return string Version constraint usable with composer/semver
+     */
+    public static function getVersionRanges($packageName)
+    {
+        foreach (self::getInstalled() as $installed) {
+            if (!isset($installed['versions'][$packageName])) {
+                continue;
+            }
+
+            $ranges = array();
+            if (isset($installed['versions'][$packageName]['pretty_version'])) {
+                $ranges[] = $installed['versions'][$packageName]['pretty_version'];
+            }
+            if (array_key_exists('aliases', $installed['versions'][$packageName])) {
+                $ranges = array_merge($ranges, $installed['versions'][$packageName]['aliases']);
+            }
+            if (array_key_exists('replaced', $installed['versions'][$packageName])) {
+                $ranges = array_merge($ranges, $installed['versions'][$packageName]['replaced']);
+            }
+            if (array_key_exists('provided', $installed['versions'][$packageName])) {
+                $ranges = array_merge($ranges, $installed['versions'][$packageName]['provided']);
+            }
+
+            return implode(' || ', $ranges);
+        }
+
+        throw new \OutOfBoundsException('Package "' . $packageName . '" is not installed');
+    }
+
+    /**
+     * @param  string      $packageName
+     * @return string|null If the package is being replaced or provided but is not really installed, null will be returned as version, use satisfies or getVersionRanges if you need to know if a given version is present
+     */
+    public static function getVersion($packageName)
+    {
+        foreach (self::getInstalled() as $installed) {
+            if (!isset($installed['versions'][$packageName])) {
+                continue;
+            }
+
+            if (!isset($installed['versions'][$packageName]['version'])) {
+                return null;
+            }
+
+            return $installed['versions'][$packageName]['version'];
+        }
+
+        throw new \OutOfBoundsException('Package "' . $packageName . '" is not installed');
+    }
+
+    /**
+     * @param  string      $packageName
+     * @return string|null If the package is being replaced or provided but is not really installed, null will be returned as version, use satisfies or getVersionRanges if you need to know if a given version is present
+     */
+    public static function getPrettyVersion($packageName)
+    {
+        foreach (self::getInstalled() as $installed) {
+            if (!isset($installed['versions'][$packageName])) {
+                continue;
+            }
+
+            if (!isset($installed['versions'][$packageName]['pretty_version'])) {
+                return null;
+            }
+
+            return $installed['versions'][$packageName]['pretty_version'];
+        }
+
+        throw new \OutOfBoundsException('Package "' . $packageName . '" is not installed');
+    }
+
+    /**
+     * @param  string      $packageName
+     * @return string|null If the package is being replaced or provided but is not really installed, null will be returned as reference
+     */
+    public static function getReference($packageName)
+    {
+        foreach (self::getInstalled() as $installed) {
+            if (!isset($installed['versions'][$packageName])) {
+                continue;
+            }
+
+            if (!isset($installed['versions'][$packageName]['reference'])) {
+                return null;
+            }
+
+            return $installed['versions'][$packageName]['reference'];
+        }
+
+        throw new \OutOfBoundsException('Package "' . $packageName . '" is not installed');
+    }
+
+    /**
+     * @return array
+     * @psalm-return array{name: string, version: string, reference: string, pretty_version: string, aliases: string[]}
+     */
+    public static function getRootPackage()
+    {
+        $installed = self::getInstalled();
+
+        return $installed[0]['root'];
+    }
+
+    /**
+     * Returns the raw installed.php data for custom implementations
+     *
+     * @return array[]
+     * @psalm-return array{root: array{name: string, version: string, reference: string, pretty_version: string, aliases: string[]}, versions: list<string, array{pretty_version: ?string, version: ?string, aliases: ?string[], reference: ?string, replaced: ?string[], provided: ?string[]}>}
+     */
+    public static function getRawData()
+    {
+        return self::$installed;
+    }
+
+    /**
+     * Lets you reload the static array from another file
+     *
+     * This is only useful for complex integrations in which a project needs to use
+     * this class but then also needs to execute another project's autoloader in process,
+     * and wants to ensure both projects have access to their version of installed.php.
+     *
+     * A typical case would be PHPUnit, where it would need to make sure it reads all
+     * the data it needs from this class, then call reload() with
+     * `require $CWD/vendor/composer/installed.php` (or similar) as input to make sure
+     * the project in which it runs can then also use this class safely, without
+     * interference between PHPUnit's dependencies and the project's dependencies.
+     *
+     * @param  array[] $data A vendor/composer/installed.php data set
+     * @return void
+     *
+     * @psalm-param array{root: array{name: string, version: string, reference: string, pretty_version: string, aliases: string[]}, versions: list<string, array{pretty_version: ?string, version: ?string, aliases: ?string[], reference: ?string, replaced: ?string[], provided: ?string[]}>} $data
+     */
+    public static function reload($data)
+    {
+        self::$installed = $data;
+        self::$installedByVendor = array();
+    }
+
+    /**
+     * @return array[]
+     */
+    private static function getInstalled()
+    {
+        if (null === self::$canGetVendors) {
+            self::$canGetVendors = method_exists('Composer\Autoload\ClassLoader', 'getRegisteredLoaders');
+        }
+
+        $installed = array();
+
+        if (self::$canGetVendors) {
+            // @phpstan-ignore-next-line
+            foreach (ClassLoader::getRegisteredLoaders() as $vendorDir => $loader) {
+                if (isset(self::$installedByVendor[$vendorDir])) {
+                    $installed[] = self::$installedByVendor[$vendorDir];
+                } elseif (is_file($vendorDir.'/composer/installed.php')) {
+                    $installed[] = self::$installedByVendor[$vendorDir] = require $vendorDir.'/composer/installed.php';
+                }
+            }
+        }
+
+        $installed[] = self::$installed;
+
+        return $installed;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Installer/InstallationManager.php 2.0.9-1/src/Composer/Installer/InstallationManager.php
--- 1.10.19-1/src/Composer/Installer/InstallationManager.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/InstallationManager.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,7 @@
 namespace Composer\Installer;
 
 use Composer\IO\IOInterface;
+use Composer\IO\ConsoleIO;
 use Composer\Package\PackageInterface;
 use Composer\Package\AliasPackage;
 use Composer\Repository\RepositoryInterface;
@@ -23,7 +24,9 @@ use Composer\DependencyResolver\Operatio
 use Composer\DependencyResolver\Operation\UninstallOperation;
 use Composer\DependencyResolver\Operation\MarkAliasInstalledOperation;
 use Composer\DependencyResolver\Operation\MarkAliasUninstalledOperation;
-use Composer\Util\StreamContextFactory;
+use Composer\EventDispatcher\EventDispatcher;
+use Composer\Util\Loop;
+use React\Promise\PromiseInterface;
 
 /**
  * Package operation manager.
@@ -34,9 +37,27 @@ use Composer\Util\StreamContextFactory;
  */
 class InstallationManager
 {
+    /** @var array<InstallerInterface> */
     private $installers = array();
+    /** @var array<string, InstallerInterface> */
     private $cache = array();
+    /** @var array<string, array<PackageInterface>> */
     private $notifiablePackages = array();
+    /** @var Loop */
+    private $loop;
+    /** @var IOInterface */
+    private $io;
+    /** @var EventDispatcher */
+    private $eventDispatcher;
+    /** @var bool */
+    private $outputProgress;
+
+    public function __construct(Loop $loop, IOInterface $io, EventDispatcher $eventDispatcher = null)
+    {
+        $this->loop = $loop;
+        $this->io = $io;
+        $this->eventDispatcher = $eventDispatcher;
+    }
 
     public function reset()
     {
@@ -151,13 +172,289 @@ class InstallationManager
     /**
      * Executes solver operation.
      *
-     * @param RepositoryInterface $repo      repository in which to check
-     * @param OperationInterface  $operation operation instance
+     * @param RepositoryInterface  $repo       repository in which to add/remove/update packages
+     * @param OperationInterface[] $operations operations to execute
+     * @param bool                 $devMode    whether the install is being run in dev mode
+     * @param bool                 $runScripts whether to dispatch script events
+     */
+    public function execute(RepositoryInterface $repo, array $operations, $devMode = true, $runScripts = true)
+    {
+        $cleanupPromises = array();
+
+        $loop = $this->loop;
+        $io = $this->io;
+        $runCleanup = function () use (&$cleanupPromises, $loop) {
+            $promises = array();
+
+            $loop->abortJobs();
+
+            foreach ($cleanupPromises as $cleanup) {
+                $promises[] = new \React\Promise\Promise(function ($resolve, $reject) use ($cleanup) {
+                    $promise = $cleanup();
+                    if (!$promise instanceof PromiseInterface) {
+                        $resolve();
+                    } else {
+                        $promise->then(function () use ($resolve) {
+                            $resolve();
+                        });
+                    }
+                });
+            }
+
+            if (!empty($promises)) {
+                $loop->wait($promises);
+            }
+        };
+
+        $handleInterruptsUnix = function_exists('pcntl_async_signals') && function_exists('pcntl_signal');
+        $handleInterruptsWindows = function_exists('sapi_windows_set_ctrl_handler');
+        $prevHandler = null;
+        $windowsHandler = null;
+        if ($handleInterruptsUnix) {
+            pcntl_async_signals(true);
+            $prevHandler = pcntl_signal_get_handler(SIGINT);
+            pcntl_signal(SIGINT, function ($sig) use ($runCleanup, $prevHandler, $io) {
+                $io->writeError('Received SIGINT, aborting', true, IOInterface::DEBUG);
+                $runCleanup();
+
+                if (!in_array($prevHandler, array(SIG_DFL, SIG_IGN), true)) {
+                    call_user_func($prevHandler, $sig);
+                }
+
+                exit(130);
+            });
+        }
+        if ($handleInterruptsWindows) {
+            $windowsHandler = function ($event) use ($runCleanup, $io) {
+                if ($event !== PHP_WINDOWS_EVENT_CTRL_C) {
+                    return;
+                }
+                $io->writeError('Received CTRL+C, aborting', true, IOInterface::DEBUG);
+                $runCleanup();
+
+                exit(130);
+            };
+            sapi_windows_set_ctrl_handler($windowsHandler);
+        }
+
+        try {
+            // execute operations in batches to make sure download-modifying-plugins are installed
+            // before the other packages get downloaded
+            $batches = array();
+            $batch = array();
+            foreach ($operations as $index => $operation) {
+                if (in_array($operation->getOperationType(), array('update', 'install'), true)) {
+                    $package = $operation->getOperationType() === 'update' ? $operation->getTargetPackage() : $operation->getPackage();
+                    if ($package->getType() === 'composer-plugin' && ($extra = $package->getExtra()) && isset($extra['plugin-modifies-downloads']) && $extra['plugin-modifies-downloads'] === true) {
+                        if ($batch) {
+                            $batches[] = $batch;
+                        }
+                        $batches[] = array($index => $operation);
+                        $batch = array();
+
+                        continue;
+                    }
+                }
+                $batch[$index] = $operation;
+            }
+
+            if ($batch) {
+                $batches[] = $batch;
+            }
+
+            foreach ($batches as $batch) {
+                $this->downloadAndExecuteBatch($repo, $batch, $cleanupPromises, $devMode, $runScripts, $operations);
+            }
+        } catch (\Exception $e) {
+            $runCleanup();
+
+            if ($handleInterruptsUnix) {
+                pcntl_signal(SIGINT, $prevHandler);
+            }
+            if ($handleInterruptsWindows) {
+                sapi_windows_set_ctrl_handler($prevHandler, false);
+            }
+
+            throw $e;
+        }
+
+        if ($handleInterruptsUnix) {
+            pcntl_signal(SIGINT, $prevHandler);
+        }
+        if ($handleInterruptsWindows) {
+            sapi_windows_set_ctrl_handler($prevHandler, false);
+        }
+
+        // do a last write so that we write the repository even if nothing changed
+        // as that can trigger an update of some files like InstalledVersions.php if
+        // running a new composer version
+        $repo->write($devMode, $this);
+    }
+
+    /**
+     * @param array $operations    List of operations to execute in this batch
+     * @param array $allOperations Complete list of operations to be executed in the install job, used for event listeners
      */
-    public function execute(RepositoryInterface $repo, OperationInterface $operation)
+    private function downloadAndExecuteBatch(RepositoryInterface $repo, array $operations, array &$cleanupPromises, $devMode, $runScripts, array $allOperations)
     {
-        $method = $operation->getJobType();
-        $this->$method($repo, $operation);
+        $promises = array();
+
+        foreach ($operations as $index => $operation) {
+            $opType = $operation->getOperationType();
+
+            // ignoring alias ops as they don't need to execute anything at this stage
+            if (!in_array($opType, array('update', 'install', 'uninstall'))) {
+                continue;
+            }
+
+            if ($opType === 'update') {
+                $package = $operation->getTargetPackage();
+                $initialPackage = $operation->getInitialPackage();
+            } else {
+                $package = $operation->getPackage();
+                $initialPackage = null;
+            }
+            $installer = $this->getInstaller($package->getType());
+
+            $cleanupPromises[$index] = function () use ($opType, $installer, $package, $initialPackage) {
+                // avoid calling cleanup if the download was not even initialized for a package
+                // as without installation source configured nothing will work
+                if (!$package->getInstallationSource()) {
+                    return;
+                }
+
+                return $installer->cleanup($opType, $package, $initialPackage);
+            };
+
+            if ($opType !== 'uninstall') {
+                $promise = $installer->download($package, $initialPackage);
+                if ($promise) {
+                    $promises[] = $promise;
+                }
+            }
+        }
+
+        // execute all downloads first
+        if (count($promises)) {
+            $this->waitOnPromises($promises);
+        }
+
+        // execute operations in batches to make sure every plugin is installed in the
+        // right order and activated before the packages depending on it are installed
+        $batches = array();
+        $batch = array();
+        foreach ($operations as $index => $operation) {
+            if (in_array($operation->getOperationType(), array('update', 'install'), true)) {
+                $package = $operation->getOperationType() === 'update' ? $operation->getTargetPackage() : $operation->getPackage();
+                if ($package->getType() === 'composer-plugin' || $package->getType() === 'composer-installer') {
+                    if ($batch) {
+                        $batches[] = $batch;
+                    }
+                    $batches[] = array($index => $operation);
+                    $batch = array();
+
+                    continue;
+                }
+            }
+            $batch[$index] = $operation;
+        }
+
+        if ($batch) {
+            $batches[] = $batch;
+        }
+
+        foreach ($batches as $batch) {
+            $this->executeBatch($repo, $batch, $cleanupPromises, $devMode, $runScripts, $allOperations);
+        }
+    }
+
+    /**
+     * @param array $operations    List of operations to execute in this batch
+     * @param array $allOperations Complete list of operations to be executed in the install job, used for event listeners
+     */
+    private function executeBatch(RepositoryInterface $repo, array $operations, array $cleanupPromises, $devMode, $runScripts, array $allOperations)
+    {
+        $promises = array();
+        $postExecCallbacks = array();
+
+        foreach ($operations as $index => $operation) {
+            $opType = $operation->getOperationType();
+
+            // ignoring alias ops as they don't need to execute anything
+            if (!in_array($opType, array('update', 'install', 'uninstall'))) {
+                // output alias ops in debug verbosity as they have no output otherwise
+                if ($this->io->isDebug()) {
+                    $this->io->writeError('  - ' . $operation->show(false));
+                }
+                $this->$opType($repo, $operation);
+
+                continue;
+            }
+
+            if ($opType === 'update') {
+                $package = $operation->getTargetPackage();
+                $initialPackage = $operation->getInitialPackage();
+            } else {
+                $package = $operation->getPackage();
+                $initialPackage = null;
+            }
+            $installer = $this->getInstaller($package->getType());
+
+            $event = 'Composer\Installer\PackageEvents::PRE_PACKAGE_'.strtoupper($opType);
+            if (defined($event) && $runScripts && $this->eventDispatcher) {
+                $this->eventDispatcher->dispatchPackageEvent(constant($event), $devMode, $repo, $allOperations, $operation);
+            }
+
+            $dispatcher = $this->eventDispatcher;
+            $installManager = $this;
+            $io = $this->io;
+
+            $promise = $installer->prepare($opType, $package, $initialPackage);
+            if (!$promise instanceof PromiseInterface) {
+                $promise = \React\Promise\resolve();
+            }
+
+            $promise = $promise->then(function () use ($opType, $installManager, $repo, $operation) {
+                return $installManager->$opType($repo, $operation);
+            })->then($cleanupPromises[$index])
+            ->then(function () use ($installManager, $devMode, $repo) {
+                $repo->write($devMode, $installManager);
+            }, function ($e) use ($opType, $package, $io) {
+                $io->writeError('    <error>' . ucfirst($opType) .' of '.$package->getPrettyName().' failed</error>');
+
+                throw $e;
+            });
+
+            $postExecCallbacks[] = function () use ($opType, $runScripts, $dispatcher, $devMode, $repo, $allOperations, $operation) {
+                $event = 'Composer\Installer\PackageEvents::POST_PACKAGE_'.strtoupper($opType);
+                if (defined($event) && $runScripts && $dispatcher) {
+                    $dispatcher->dispatchPackageEvent(constant($event), $devMode, $repo, $allOperations, $operation);
+                }
+            };
+
+            $promises[] = $promise;
+        }
+
+        // execute all prepare => installs/updates/removes => cleanup steps
+        if (count($promises)) {
+            $this->waitOnPromises($promises);
+        }
+
+        foreach ($postExecCallbacks as $cb) {
+            $cb();
+        }
+    }
+
+    private function waitOnPromises(array $promises)
+    {
+        $progress = null;
+        if ($this->outputProgress && $this->io instanceof ConsoleIO && !$this->io->isDebug() && count($promises) > 1) {
+            $progress = $this->io->getProgressBar();
+        }
+        $this->loop->wait($promises, $progress);
+        if ($progress) {
+            $progress->clear();
+        }
     }
 
     /**
@@ -170,8 +467,10 @@ class InstallationManager
     {
         $package = $operation->getPackage();
         $installer = $this->getInstaller($package->getType());
-        $installer->install($repo, $package);
+        $promise = $installer->install($repo, $package);
         $this->markForNotification($package);
+
+        return $promise;
     }
 
     /**
@@ -190,12 +489,15 @@ class InstallationManager
 
         if ($initialType === $targetType) {
             $installer = $this->getInstaller($initialType);
-            $installer->update($repo, $initial, $target);
+            $promise = $installer->update($repo, $initial, $target);
             $this->markForNotification($target);
         } else {
             $this->getInstaller($initialType)->uninstall($repo, $initial);
-            $this->getInstaller($targetType)->install($repo, $target);
+            $installer = $this->getInstaller($targetType);
+            $promise = $installer->install($repo, $target);
         }
+
+        return $promise;
     }
 
     /**
@@ -208,7 +510,8 @@ class InstallationManager
     {
         $package = $operation->getPackage();
         $installer = $this->getInstaller($package->getType());
-        $installer->uninstall($repo, $package);
+
+        return $installer->uninstall($repo, $package);
     }
 
     /**
@@ -252,66 +555,65 @@ class InstallationManager
         return $installer->getInstallPath($package);
     }
 
+    public function setOutputProgress($outputProgress)
+    {
+        $this->outputProgress = $outputProgress;
+    }
+
     public function notifyInstalls(IOInterface $io)
     {
-        foreach ($this->notifiablePackages as $repoUrl => $packages) {
-            $repositoryName = parse_url($repoUrl, PHP_URL_HOST);
-            if ($io->hasAuthentication($repositoryName)) {
-                $auth = $io->getAuthentication($repositoryName);
-                $authStr = base64_encode($auth['username'] . ':' . $auth['password']);
-                $authHeader = 'Authorization: Basic '.$authStr;
-            }
+        $promises = array();
 
-            // non-batch API, deprecated
-            if (strpos($repoUrl, '%package%')) {
-                foreach ($packages as $package) {
-                    $url = str_replace('%package%', $package->getPrettyName(), $repoUrl);
+        try {
+            foreach ($this->notifiablePackages as $repoUrl => $packages) {
+                // non-batch API, deprecated
+                if (strpos($repoUrl, '%package%')) {
+                    foreach ($packages as $package) {
+                        $url = str_replace('%package%', $package->getPrettyName(), $repoUrl);
+
+                        $params = array(
+                            'version' => $package->getPrettyVersion(),
+                            'version_normalized' => $package->getVersion(),
+                        );
+                        $opts = array(
+                            'retry-auth-failure' => false,
+                            'http' => array(
+                                'method' => 'POST',
+                                'header' => array('Content-type: application/x-www-form-urlencoded'),
+                                'content' => http_build_query($params, '', '&'),
+                                'timeout' => 3,
+                            ),
+                        );
 
-                    $params = array(
-                        'version' => $package->getPrettyVersion(),
-                        'version_normalized' => $package->getVersion(),
-                    );
-                    $opts = array('http' =>
-                        array(
-                            'method' => 'POST',
-                            'header' => array('Content-type: application/x-www-form-urlencoded'),
-                            'content' => http_build_query($params, '', '&'),
-                            'timeout' => 3,
-                        ),
-                    );
-                    if (isset($authHeader)) {
-                        $opts['http']['header'][] = $authHeader;
+                        $promises[] = $this->loop->getHttpDownloader()->add($url, $opts);
                     }
 
-                    $context = StreamContextFactory::getContext($url, $opts);
-                    @file_get_contents($url, false, $context);
+                    continue;
                 }
 
-                continue;
-            }
+                $postData = array('downloads' => array());
+                foreach ($packages as $package) {
+                    $postData['downloads'][] = array(
+                        'name' => $package->getPrettyName(),
+                        'version' => $package->getVersion(),
+                    );
+                }
 
-            $postData = array('downloads' => array());
-            foreach ($packages as $package) {
-                $postData['downloads'][] = array(
-                    'name' => $package->getPrettyName(),
-                    'version' => $package->getVersion(),
+                $opts = array(
+                    'retry-auth-failure' => false,
+                    'http' => array(
+                        'method' => 'POST',
+                        'header' => array('Content-Type: application/json'),
+                        'content' => json_encode($postData),
+                        'timeout' => 6,
+                    ),
                 );
-            }
 
-            $opts = array('http' =>
-                array(
-                    'method' => 'POST',
-                    'header' => array('Content-Type: application/json'),
-                    'content' => json_encode($postData),
-                    'timeout' => 6,
-                ),
-            );
-            if (isset($authHeader)) {
-                $opts['http']['header'][] = $authHeader;
+                $promises[] = $this->loop->getHttpDownloader()->add($repoUrl, $opts);
             }
 
-            $context = StreamContextFactory::getContext($repoUrl, $opts);
-            @file_get_contents($repoUrl, false, $context);
+            $this->loop->wait($promises);
+        } catch (\Exception $e) {
         }
 
         $this->reset();
diff -pruN 1.10.19-1/src/Composer/Installer/InstallerEvent.php 2.0.9-1/src/Composer/Installer/InstallerEvent.php
--- 1.10.19-1/src/Composer/Installer/InstallerEvent.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/InstallerEvent.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,19 +13,10 @@
 namespace Composer\Installer;
 
 use Composer\Composer;
-use Composer\DependencyResolver\PolicyInterface;
-use Composer\DependencyResolver\Operation\OperationInterface;
-use Composer\DependencyResolver\Pool;
-use Composer\DependencyResolver\Request;
+use Composer\DependencyResolver\Transaction;
 use Composer\EventDispatcher\Event;
 use Composer\IO\IOInterface;
-use Composer\Repository\CompositeRepository;
 
-/**
- * An event for all installer.
- *
- * @author François Pluchino <francois.pluchino@gmail.com>
- */
 class InstallerEvent extends Event
 {
     /**
@@ -44,55 +35,34 @@ class InstallerEvent extends Event
     private $devMode;
 
     /**
-     * @var PolicyInterface
-     */
-    private $policy;
-
-    /**
-     * @var Pool
-     */
-    private $pool;
-
-    /**
-     * @var CompositeRepository
-     */
-    private $installedRepo;
-
-    /**
-     * @var Request
+     * @var bool
      */
-    private $request;
+    private $executeOperations;
 
     /**
-     * @var OperationInterface[]
+     * @var Transaction
      */
-    private $operations;
+    private $transaction;
 
     /**
      * Constructor.
      *
-     * @param string               $eventName
-     * @param Composer             $composer
-     * @param IOInterface          $io
-     * @param bool                 $devMode
-     * @param PolicyInterface      $policy
-     * @param Pool                 $pool
-     * @param CompositeRepository  $installedRepo
-     * @param Request              $request
-     * @param OperationInterface[] $operations
+     * @param string      $eventName
+     * @param Composer    $composer
+     * @param IOInterface $io
+     * @param bool        $devMode
+     * @param bool        $executeOperations
+     * @param Transaction $transaction
      */
-    public function __construct($eventName, Composer $composer, IOInterface $io, $devMode, PolicyInterface $policy, Pool $pool, CompositeRepository $installedRepo, Request $request, array $operations = array())
+    public function __construct($eventName, Composer $composer, IOInterface $io, $devMode, $executeOperations, Transaction $transaction)
     {
         parent::__construct($eventName);
 
         $this->composer = $composer;
         $this->io = $io;
         $this->devMode = $devMode;
-        $this->policy = $policy;
-        $this->pool = $pool;
-        $this->installedRepo = $installedRepo;
-        $this->request = $request;
-        $this->operations = $operations;
+        $this->executeOperations = $executeOperations;
+        $this->transaction = $transaction;
     }
 
     /**
@@ -120,42 +90,18 @@ class InstallerEvent extends Event
     }
 
     /**
-     * @return PolicyInterface
-     */
-    public function getPolicy()
-    {
-        return $this->policy;
-    }
-
-    /**
-     * @return Pool
-     */
-    public function getPool()
-    {
-        return $this->pool;
-    }
-
-    /**
-     * @return CompositeRepository
-     */
-    public function getInstalledRepo()
-    {
-        return $this->installedRepo;
-    }
-
-    /**
-     * @return Request
+     * @return bool
      */
-    public function getRequest()
+    public function isExecutingOperations()
     {
-        return $this->request;
+        return $this->executeOperations;
     }
 
     /**
-     * @return OperationInterface[]
+     * @return Transaction|null
      */
-    public function getOperations()
+    public function getTransaction()
     {
-        return $this->operations;
+        return $this->transaction;
     }
 }
diff -pruN 1.10.19-1/src/Composer/Installer/InstallerEvents.php 2.0.9-1/src/Composer/Installer/InstallerEvents.php
--- 1.10.19-1/src/Composer/Installer/InstallerEvents.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/InstallerEvents.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,32 +12,15 @@
 
 namespace Composer\Installer;
 
-/**
- * The Installer Events.
- *
- * @author François Pluchino <francois.pluchino@gmail.com>
- */
 class InstallerEvents
 {
     /**
-     * The PRE_DEPENDENCIES_SOLVING event occurs as a installer begins
-     * resolve operations.
+     * The PRE_OPERATIONS_EXEC event occurs before the lock file gets
+     * installed and operations are executed.
      *
-     * The event listener method receives a
-     * Composer\Installer\InstallerEvent instance.
+     * The event listener method receives an Composer\Installer\InstallerEvent instance.
      *
      * @var string
      */
-    const PRE_DEPENDENCIES_SOLVING = 'pre-dependencies-solving';
-
-    /**
-     * The POST_DEPENDENCIES_SOLVING event occurs as a installer after
-     * resolve operations.
-     *
-     * The event listener method receives a
-     * Composer\Installer\InstallerEvent instance.
-     *
-     * @var string
-     */
-    const POST_DEPENDENCIES_SOLVING = 'post-dependencies-solving';
+    const PRE_OPERATIONS_EXEC = 'pre-operations-exec';
 }
diff -pruN 1.10.19-1/src/Composer/Installer/InstallerInterface.php 2.0.9-1/src/Composer/Installer/InstallerInterface.php
--- 1.10.19-1/src/Composer/Installer/InstallerInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/InstallerInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -15,6 +15,7 @@ namespace Composer\Installer;
 use Composer\Package\PackageInterface;
 use Composer\Repository\InstalledRepositoryInterface;
 use InvalidArgumentException;
+use React\Promise\PromiseInterface;
 
 /**
  * Interface for the package installation manager.
@@ -43,33 +44,73 @@ interface InstallerInterface
     public function isInstalled(InstalledRepositoryInterface $repo, PackageInterface $package);
 
     /**
+     * Downloads the files needed to later install the given package.
+     *
+     * @param  PackageInterface      $package     package instance
+     * @param  PackageInterface      $prevPackage previous package instance in case of an update
+     * @return PromiseInterface|null
+     */
+    public function download(PackageInterface $package, PackageInterface $prevPackage = null);
+
+    /**
+     * Do anything that needs to be done between all downloads have been completed and the actual operation is executed
+     *
+     * All packages get first downloaded, then all together prepared, then all together installed/updated/uninstalled. Therefore
+     * for error recovery it is important to avoid failing during install/update/uninstall as much as possible, and risky things or
+     * user prompts should happen in the prepare step rather. In case of failure, cleanup() will be called so that changes can
+     * be undone as much as possible.
+     *
+     * @param  string                $type        one of install/update/uninstall
+     * @param  PackageInterface      $package     package instance
+     * @param  PackageInterface      $prevPackage previous package instance in case of an update
+     * @return PromiseInterface|null
+     */
+    public function prepare($type, PackageInterface $package, PackageInterface $prevPackage = null);
+
+    /**
      * Installs specific package.
      *
-     * @param InstalledRepositoryInterface $repo    repository in which to check
-     * @param PackageInterface             $package package instance
+     * @param  InstalledRepositoryInterface $repo    repository in which to check
+     * @param  PackageInterface             $package package instance
+     * @return PromiseInterface|null
      */
     public function install(InstalledRepositoryInterface $repo, PackageInterface $package);
 
     /**
      * Updates specific package.
      *
-     * @param InstalledRepositoryInterface $repo    repository in which to check
-     * @param PackageInterface             $initial already installed package version
-     * @param PackageInterface             $target  updated version
-     *
-     * @throws InvalidArgumentException if $initial package is not installed
+     * @param  InstalledRepositoryInterface $repo    repository in which to check
+     * @param  PackageInterface             $initial already installed package version
+     * @param  PackageInterface             $target  updated version
+     * @throws InvalidArgumentException     if $initial package is not installed
+     * @return PromiseInterface|null
      */
     public function update(InstalledRepositoryInterface $repo, PackageInterface $initial, PackageInterface $target);
 
     /**
      * Uninstalls specific package.
      *
-     * @param InstalledRepositoryInterface $repo    repository in which to check
-     * @param PackageInterface             $package package instance
+     * @param  InstalledRepositoryInterface $repo    repository in which to check
+     * @param  PackageInterface             $package package instance
+     * @return PromiseInterface|null
      */
     public function uninstall(InstalledRepositoryInterface $repo, PackageInterface $package);
 
     /**
+     * Do anything to cleanup changes applied in the prepare or install/update/uninstall steps
+     *
+     * Note that cleanup will be called for all packages regardless if they failed an operation or not, to give
+     * all installers a change to cleanup things they did previously, so you need to keep track of changes
+     * applied in the installer/downloader themselves.
+     *
+     * @param  string                $type        one of install/update/uninstall
+     * @param  PackageInterface      $package     package instance
+     * @param  PackageInterface      $prevPackage previous package instance in case of an update
+     * @return PromiseInterface|null
+     */
+    public function cleanup($type, PackageInterface $package, PackageInterface $prevPackage = null);
+
+    /**
      * Returns the installation path of a package
      *
      * @param  PackageInterface $package
diff -pruN 1.10.19-1/src/Composer/Installer/LibraryInstaller.php 2.0.9-1/src/Composer/Installer/LibraryInstaller.php
--- 1.10.19-1/src/Composer/Installer/LibraryInstaller.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/LibraryInstaller.php	2021-01-27 15:09:27.000000000 +0000
@@ -19,6 +19,7 @@ use Composer\Package\PackageInterface;
 use Composer\Util\Filesystem;
 use Composer\Util\Silencer;
 use Composer\Util\Platform;
+use React\Promise\PromiseInterface;
 
 /**
  * Package installation manager.
@@ -43,7 +44,7 @@ class LibraryInstaller implements Instal
      *
      * @param IOInterface     $io
      * @param Composer        $composer
-     * @param string          $type
+     * @param string|null     $type
      * @param Filesystem      $filesystem
      * @param BinaryInstaller $binaryInstaller
      */
@@ -88,6 +89,39 @@ class LibraryInstaller implements Instal
     /**
      * {@inheritDoc}
      */
+    public function download(PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+        $this->initializeVendorDir();
+        $downloadPath = $this->getInstallPath($package);
+
+        return $this->downloadManager->download($package, $downloadPath, $prevPackage);
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function prepare($type, PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+        $this->initializeVendorDir();
+        $downloadPath = $this->getInstallPath($package);
+
+        return $this->downloadManager->prepare($type, $package, $downloadPath, $prevPackage);
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function cleanup($type, PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+        $this->initializeVendorDir();
+        $downloadPath = $this->getInstallPath($package);
+
+        return $this->downloadManager->cleanup($type, $package, $downloadPath, $prevPackage);
+    }
+
+    /**
+     * {@inheritDoc}
+     */
     public function install(InstalledRepositoryInterface $repo, PackageInterface $package)
     {
         $this->initializeVendorDir();
@@ -98,11 +132,20 @@ class LibraryInstaller implements Instal
             $this->binaryInstaller->removeBinaries($package);
         }
 
-        $this->installCode($package);
-        $this->binaryInstaller->installBinaries($package, $this->getInstallPath($package));
-        if (!$repo->hasPackage($package)) {
-            $repo->addPackage(clone $package);
+        $promise = $this->installCode($package);
+        if (!$promise instanceof PromiseInterface) {
+            $promise = \React\Promise\resolve();
         }
+
+        $binaryInstaller = $this->binaryInstaller;
+        $installPath = $this->getInstallPath($package);
+
+        return $promise->then(function () use ($binaryInstaller, $installPath, $package, $repo) {
+            $binaryInstaller->installBinaries($package, $installPath);
+            if (!$repo->hasPackage($package)) {
+                $repo->addPackage(clone $package);
+            }
+        });
     }
 
     /**
@@ -117,12 +160,21 @@ class LibraryInstaller implements Instal
         $this->initializeVendorDir();
 
         $this->binaryInstaller->removeBinaries($initial);
-        $this->updateCode($initial, $target);
-        $this->binaryInstaller->installBinaries($target, $this->getInstallPath($target));
-        $repo->removePackage($initial);
-        if (!$repo->hasPackage($target)) {
-            $repo->addPackage(clone $target);
+        $promise = $this->updateCode($initial, $target);
+        if (!$promise instanceof PromiseInterface) {
+            $promise = \React\Promise\resolve();
         }
+
+        $binaryInstaller = $this->binaryInstaller;
+        $installPath = $this->getInstallPath($target);
+
+        return $promise->then(function () use ($binaryInstaller, $installPath, $target, $initial, $repo) {
+            $binaryInstaller->installBinaries($target, $installPath);
+            $repo->removePackage($initial);
+            if (!$repo->hasPackage($target)) {
+                $repo->addPackage(clone $target);
+            }
+        });
     }
 
     /**
@@ -134,17 +186,26 @@ class LibraryInstaller implements Instal
             throw new \InvalidArgumentException('Package is not installed: '.$package);
         }
 
-        $this->removeCode($package);
-        $this->binaryInstaller->removeBinaries($package);
-        $repo->removePackage($package);
+        $promise = $this->removeCode($package);
+        if (!$promise instanceof PromiseInterface) {
+            $promise = \React\Promise\resolve();
+        }
 
+        $binaryInstaller = $this->binaryInstaller;
         $downloadPath = $this->getPackageBasePath($package);
-        if (strpos($package->getName(), '/')) {
-            $packageVendorDir = dirname($downloadPath);
-            if (is_dir($packageVendorDir) && $this->filesystem->isDirEmpty($packageVendorDir)) {
-                Silencer::call('rmdir', $packageVendorDir);
+        $filesystem = $this->filesystem;
+
+        return $promise->then(function () use ($binaryInstaller, $filesystem, $downloadPath, $package, $repo) {
+            $binaryInstaller->removeBinaries($package);
+            $repo->removePackage($package);
+
+            if (strpos($package->getName(), '/')) {
+                $packageVendorDir = dirname($downloadPath);
+                if (is_dir($packageVendorDir) && $filesystem->isDirEmpty($packageVendorDir)) {
+                    Silencer::call('rmdir', $packageVendorDir);
+                }
             }
-        }
+        });
     }
 
     /**
@@ -194,7 +255,8 @@ class LibraryInstaller implements Instal
     protected function installCode(PackageInterface $package)
     {
         $downloadPath = $this->getInstallPath($package);
-        $this->downloadManager->download($package, $downloadPath);
+
+        return $this->downloadManager->install($package, $downloadPath);
     }
 
     protected function updateCode(PackageInterface $initial, PackageInterface $target)
@@ -204,24 +266,37 @@ class LibraryInstaller implements Instal
         if ($targetDownloadPath !== $initialDownloadPath) {
             // if the target and initial dirs intersect, we force a remove + install
             // to avoid the rename wiping the target dir as part of the initial dir cleanup
-            if (substr($initialDownloadPath, 0, strlen($targetDownloadPath)) === $targetDownloadPath
-                || substr($targetDownloadPath, 0, strlen($initialDownloadPath)) === $initialDownloadPath
+            if (strpos($initialDownloadPath, $targetDownloadPath) === 0
+                || strpos($targetDownloadPath, $initialDownloadPath) === 0
             ) {
-                $this->removeCode($initial);
-                $this->installCode($target);
-
-                return;
+                $promise = $this->removeCode($initial);
+                if (!$promise instanceof PromiseInterface) {
+                    $promise = \React\Promise\resolve();
+                }
+
+                $self = $this;
+
+                return $promise->then(function () use ($self, $target) {
+                    $reflMethod = new \ReflectionMethod($self, 'installCode');
+                    $reflMethod->setAccessible(true);
+
+                    // equivalent of $this->installCode($target) with php 5.3 support
+                    // TODO remove this once 5.3 support is dropped
+                    return $reflMethod->invoke($self, $target);
+                });
             }
 
             $this->filesystem->rename($initialDownloadPath, $targetDownloadPath);
         }
-        $this->downloadManager->update($initial, $target, $targetDownloadPath);
+
+        return $this->downloadManager->update($initial, $target, $targetDownloadPath);
     }
 
     protected function removeCode(PackageInterface $package)
     {
         $downloadPath = $this->getPackageBasePath($package);
-        $this->downloadManager->remove($package, $downloadPath);
+
+        return $this->downloadManager->remove($package, $downloadPath);
     }
 
     protected function initializeVendorDir()
diff -pruN 1.10.19-1/src/Composer/Installer/MetapackageInstaller.php 2.0.9-1/src/Composer/Installer/MetapackageInstaller.php
--- 1.10.19-1/src/Composer/Installer/MetapackageInstaller.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/MetapackageInstaller.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,8 +14,10 @@ namespace Composer\Installer;
 
 use Composer\Repository\InstalledRepositoryInterface;
 use Composer\Package\PackageInterface;
-use Composer\Package\Version\VersionParser;
 use Composer\IO\IOInterface;
+use Composer\DependencyResolver\Operation\UpdateOperation;
+use Composer\DependencyResolver\Operation\InstallOperation;
+use Composer\DependencyResolver\Operation\UninstallOperation;
 
 /**
  * Metapackage installation manager.
@@ -50,9 +52,33 @@ class MetapackageInstaller implements In
     /**
      * {@inheritDoc}
      */
+    public function download(PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+        // noop
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function prepare($type, PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+        // noop
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function cleanup($type, PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+        // noop
+    }
+
+    /**
+     * {@inheritDoc}
+     */
     public function install(InstalledRepositoryInterface $repo, PackageInterface $package)
     {
-        $this->io->writeError("  - Installing <info>" . $package->getName() . "</info> (<comment>" . $package->getFullPrettyVersion() . "</comment>)");
+        $this->io->writeError("  - " . InstallOperation::format($package));
 
         $repo->addPackage(clone $package);
     }
@@ -66,11 +92,7 @@ class MetapackageInstaller implements In
             throw new \InvalidArgumentException('Package is not installed: '.$initial);
         }
 
-        $name = $target->getName();
-        $from = $initial->getFullPrettyVersion();
-        $to = $target->getFullPrettyVersion();
-        $actionName = VersionParser::isUpgrade($initial->getVersion(), $target->getVersion()) ? 'Updating' : 'Downgrading';
-        $this->io->writeError("  - " . $actionName . " <info>" . $name . "</info> (<comment>" . $from . "</comment> => <comment>" . $to . "</comment>)");
+        $this->io->writeError("  - " . UpdateOperation::format($initial, $target));
 
         $repo->removePackage($initial);
         $repo->addPackage(clone $target);
@@ -85,7 +107,7 @@ class MetapackageInstaller implements In
             throw new \InvalidArgumentException('Package is not installed: '.$package);
         }
 
-        $this->io->writeError("  - Removing <info>" . $package->getName() . "</info> (<comment>" . $package->getFullPrettyVersion() . "</comment>)");
+        $this->io->writeError("  - " . UninstallOperation::format($package));
 
         $repo->removePackage($package);
     }
diff -pruN 1.10.19-1/src/Composer/Installer/NoopInstaller.php 2.0.9-1/src/Composer/Installer/NoopInstaller.php
--- 1.10.19-1/src/Composer/Installer/NoopInstaller.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/NoopInstaller.php	2021-01-27 15:09:27.000000000 +0000
@@ -43,6 +43,27 @@ class NoopInstaller implements Installer
     /**
      * {@inheritDoc}
      */
+    public function download(PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function prepare($type, PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function cleanup($type, PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+    }
+
+    /**
+     * {@inheritDoc}
+     */
     public function install(InstalledRepositoryInterface $repo, PackageInterface $package)
     {
         if (!$repo->hasPackage($package)) {
diff -pruN 1.10.19-1/src/Composer/Installer/PackageEvent.php 2.0.9-1/src/Composer/Installer/PackageEvent.php
--- 1.10.19-1/src/Composer/Installer/PackageEvent.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/PackageEvent.php	2021-01-27 15:09:27.000000000 +0000
@@ -15,20 +15,43 @@ namespace Composer\Installer;
 use Composer\Composer;
 use Composer\IO\IOInterface;
 use Composer\DependencyResolver\Operation\OperationInterface;
-use Composer\DependencyResolver\PolicyInterface;
-use Composer\DependencyResolver\Pool;
-use Composer\DependencyResolver\Request;
-use Composer\Repository\CompositeRepository;
+use Composer\Repository\RepositoryInterface;
+use Composer\EventDispatcher\Event;
 
 /**
  * The Package Event.
  *
  * @author Jordi Boggiano <j.boggiano@seld.be>
  */
-class PackageEvent extends InstallerEvent
+class PackageEvent extends Event
 {
     /**
-     * @var OperationInterface The package instance
+     * @var Composer
+     */
+    private $composer;
+
+    /**
+     * @var IOInterface
+     */
+    private $io;
+
+    /**
+     * @var bool
+     */
+    private $devMode;
+
+    /**
+     * @var RepositoryInterface
+     */
+    private $localRepo;
+
+    /**
+     * @var OperationInterface[]
+     */
+    private $operations;
+
+    /**
+     * @var OperationInterface The operation instance which is being executed
      */
     private $operation;
 
@@ -39,21 +62,63 @@ class PackageEvent extends InstallerEven
      * @param Composer             $composer
      * @param IOInterface          $io
      * @param bool                 $devMode
-     * @param PolicyInterface      $policy
-     * @param Pool                 $pool
-     * @param CompositeRepository  $installedRepo
-     * @param Request              $request
+     * @param RepositoryInterface  $localRepo
      * @param OperationInterface[] $operations
      * @param OperationInterface   $operation
      */
-    public function __construct($eventName, Composer $composer, IOInterface $io, $devMode, PolicyInterface $policy, Pool $pool, CompositeRepository $installedRepo, Request $request, array $operations, OperationInterface $operation)
+    public function __construct($eventName, Composer $composer, IOInterface $io, $devMode, RepositoryInterface $localRepo, array $operations, OperationInterface $operation)
     {
-        parent::__construct($eventName, $composer, $io, $devMode, $policy, $pool, $installedRepo, $request, $operations);
+        parent::__construct($eventName);
 
+        $this->composer = $composer;
+        $this->io = $io;
+        $this->devMode = $devMode;
+        $this->localRepo = $localRepo;
+        $this->operations = $operations;
         $this->operation = $operation;
     }
 
     /**
+     * @return Composer
+     */
+    public function getComposer()
+    {
+        return $this->composer;
+    }
+
+    /**
+     * @return IOInterface
+     */
+    public function getIO()
+    {
+        return $this->io;
+    }
+
+    /**
+     * @return bool
+     */
+    public function isDevMode()
+    {
+        return $this->devMode;
+    }
+
+    /**
+     * @return RepositoryInterface
+     */
+    public function getLocalRepo()
+    {
+        return $this->localRepo;
+    }
+
+    /**
+     * @return OperationInterface[]
+     */
+    public function getOperations()
+    {
+        return $this->operations;
+    }
+
+    /**
      * Returns the package instance.
      *
      * @return OperationInterface
diff -pruN 1.10.19-1/src/Composer/Installer/PearBinaryInstaller.php 2.0.9-1/src/Composer/Installer/PearBinaryInstaller.php
--- 1.10.19-1/src/Composer/Installer/PearBinaryInstaller.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/PearBinaryInstaller.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,144 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Installer;
-
-use Composer\IO\IOInterface;
-use Composer\Package\PackageInterface;
-use Composer\Util\Filesystem;
-use Composer\Util\ProcessExecutor;
-
-/**
- * Utility to handle installation of package "bin"/binaries for PEAR packages
- *
- * @author Jordi Boggiano <j.boggiano@seld.be>
- */
-class PearBinaryInstaller extends BinaryInstaller
-{
-    private $installer;
-    private $vendorDir;
-
-    /**
-     * @param IOInterface   $io
-     * @param string        $binDir
-     * @param string        $vendorDir
-     * @param string        $binCompat
-     * @param Filesystem    $filesystem
-     * @param PearInstaller $installer
-     */
-    public function __construct(IOInterface $io, $binDir, $vendorDir, $binCompat, Filesystem $filesystem, PearInstaller $installer)
-    {
-        parent::__construct($io, $binDir, $binCompat, $filesystem);
-        $this->installer = $installer;
-        $this->vendorDir = $vendorDir;
-    }
-
-    protected function getBinaries(PackageInterface $package)
-    {
-        $binariesPath = $this->installer->getInstallPath($package) . '/bin/';
-        $binaries = array();
-        if (file_exists($binariesPath)) {
-            foreach (new \FilesystemIterator($binariesPath, \FilesystemIterator::KEY_AS_FILENAME | \FilesystemIterator::CURRENT_AS_FILEINFO) as $fileName => $value) {
-                if (!$value->isDir()) {
-                    $binaries[] = 'bin/'.$fileName;
-                }
-            }
-        }
-
-        return $binaries;
-    }
-
-    protected function initializeBinDir()
-    {
-        parent::initializeBinDir();
-        file_put_contents($this->binDir.'/composer-php', $this->generateUnixyPhpProxyCode());
-        @chmod($this->binDir.'/composer-php', 0777 & ~umask());
-        file_put_contents($this->binDir.'/composer-php.bat', $this->generateWindowsPhpProxyCode());
-        @chmod($this->binDir.'/composer-php.bat', 0777 & ~umask());
-    }
-
-    protected function generateWindowsProxyCode($bin, $link)
-    {
-        $binPath = $this->filesystem->findShortestPath($link, $bin);
-        if ('.bat' === substr($bin, -4)) {
-            $caller = 'call';
-        } else {
-            $handle = fopen($bin, 'r');
-            $line = fgets($handle);
-            fclose($handle);
-            if (preg_match('{^#!/(?:usr/bin/env )?(?:[^/]+/)*(.+)$}m', $line, $match)) {
-                $caller = trim($match[1]);
-            } else {
-                $caller = 'php';
-            }
-
-            if ($caller === 'php') {
-                return "@echo off\r\n".
-                    "pushd .\r\n".
-                    "cd %~dp0\r\n".
-                    "set PHP_PROXY=%CD%\\composer-php.bat\r\n".
-                    "cd ".ProcessExecutor::escape(dirname($binPath))."\r\n".
-                    "set BIN_TARGET=%CD%\\".basename($binPath)."\r\n".
-                    "popd\r\n".
-                    "%PHP_PROXY% \"%BIN_TARGET%\" %*\r\n";
-            }
-        }
-
-        return "@echo off\r\n".
-            "pushd .\r\n".
-            "cd %~dp0\r\n".
-            "cd ".ProcessExecutor::escape(dirname($binPath))."\r\n".
-            "set BIN_TARGET=%CD%\\".basename($binPath)."\r\n".
-            "popd\r\n".
-            $caller." \"%BIN_TARGET%\" %*\r\n";
-    }
-
-    private function generateWindowsPhpProxyCode()
-    {
-        $binToVendor = $this->filesystem->findShortestPath($this->binDir, $this->vendorDir, true);
-
-        return
-            "@echo off\r\n" .
-            "setlocal enabledelayedexpansion\r\n" .
-            "set BIN_DIR=%~dp0\r\n" .
-            "set VENDOR_DIR=%BIN_DIR%\\".$binToVendor."\r\n" .
-            "set DIRS=.\r\n" .
-            "FOR /D %%V IN (%VENDOR_DIR%\\*) DO (\r\n" .
-            "    FOR /D %%P IN (%%V\\*) DO (\r\n" .
-            "        set DIRS=!DIRS!;%%~fP\r\n" .
-            "    )\r\n" .
-            ")\r\n" .
-            "php.exe -d include_path=!DIRS! %*\r\n";
-    }
-
-    private function generateUnixyPhpProxyCode()
-    {
-        $binToVendor = $this->filesystem->findShortestPath($this->binDir, $this->vendorDir, true);
-
-        return
-            "#!/usr/bin/env sh\n".
-            "SRC_DIR=`pwd`\n".
-            "BIN_DIR=`dirname $0`\n".
-            "VENDOR_DIR=\$BIN_DIR/".escapeshellarg($binToVendor)."\n".
-            "DIRS=\"\"\n".
-            "for vendor in \$VENDOR_DIR/*; do\n".
-            "    if [ -d \"\$vendor\" ]; then\n".
-            "        for package in \$vendor/*; do\n".
-            "            if [ -d \"\$package\" ]; then\n".
-            "                DIRS=\"\${DIRS}:\${package}\"\n".
-            "            fi\n".
-            "        done\n".
-            "    fi\n".
-            "done\n".
-            "php -d include_path=\".\$DIRS\" $@\n";
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Installer/PearInstaller.php 2.0.9-1/src/Composer/Installer/PearInstaller.php
--- 1.10.19-1/src/Composer/Installer/PearInstaller.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/PearInstaller.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,84 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Installer;
-
-use Composer\IO\IOInterface;
-use Composer\Composer;
-use Composer\Downloader\PearPackageExtractor;
-use Composer\Repository\InstalledRepositoryInterface;
-use Composer\Package\PackageInterface;
-use Composer\Util\Platform;
-use Composer\Util\Filesystem;
-
-/**
- * Package installation manager.
- *
- * @author Jordi Boggiano <j.boggiano@seld.be>
- * @author Konstantin Kudryashov <ever.zet@gmail.com>
- */
-class PearInstaller extends LibraryInstaller
-{
-    /**
-     * Initializes library installer.
-     *
-     * @param IOInterface $io       io instance
-     * @param Composer    $composer
-     * @param string      $type     package type that this installer handles
-     */
-    public function __construct(IOInterface $io, Composer $composer, $type = 'pear-library')
-    {
-        $filesystem = new Filesystem();
-        $binaryInstaller = new PearBinaryInstaller($io, rtrim($composer->getConfig()->get('bin-dir'), '/'), rtrim($composer->getConfig()->get('vendor-dir'), '/'), $composer->getConfig()->get('bin-compat'), $filesystem, $this);
-
-        parent::__construct($io, $composer, $type, $filesystem, $binaryInstaller);
-    }
-
-    /**
-     * {@inheritDoc}
-     */
-    public function update(InstalledRepositoryInterface $repo, PackageInterface $initial, PackageInterface $target)
-    {
-        $this->uninstall($repo, $initial);
-        $this->install($repo, $target);
-    }
-
-    protected function installCode(PackageInterface $package)
-    {
-        parent::installCode($package);
-
-        $isWindows = Platform::isWindows();
-        $php_bin = $this->binDir . ($isWindows ? '/composer-php.bat' : '/composer-php');
-
-        if (!$isWindows) {
-            $php_bin = '/usr/bin/env ' . $php_bin;
-        }
-
-        $installPath = $this->getInstallPath($package);
-        $vars = array(
-            'os' => $isWindows ? 'windows' : 'linux',
-            'php_bin' => $php_bin,
-            'pear_php' => $installPath,
-            'php_dir' => $installPath,
-            'bin_dir' => $installPath . '/bin',
-            'data_dir' => $installPath . '/data',
-            'version' => $package->getPrettyVersion(),
-        );
-
-        $packageArchive = $this->getInstallPath($package).'/'.pathinfo($package->getDistUrl(), PATHINFO_BASENAME);
-        $pearExtractor = new PearPackageExtractor($packageArchive);
-        $pearExtractor->extractTo($this->getInstallPath($package), array('php' => '/', 'script' => '/bin', 'data' => '/data'), $vars);
-
-        $this->io->writeError('    Cleaning up', true, IOInterface::VERBOSE);
-        $this->filesystem->unlink($packageArchive);
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Installer/PluginInstaller.php 2.0.9-1/src/Composer/Installer/PluginInstaller.php
--- 1.10.19-1/src/Composer/Installer/PluginInstaller.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/PluginInstaller.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,6 +16,8 @@ use Composer\Composer;
 use Composer\IO\IOInterface;
 use Composer\Repository\InstalledRepositoryInterface;
 use Composer\Package\PackageInterface;
+use Composer\Util\Filesystem;
+use React\Promise\PromiseInterface;
 
 /**
  * Installer for plugin packages
@@ -25,18 +27,15 @@ use Composer\Package\PackageInterface;
  */
 class PluginInstaller extends LibraryInstaller
 {
-    private $installationManager;
-
     /**
      * Initializes Plugin installer.
      *
      * @param IOInterface $io
      * @param Composer    $composer
      */
-    public function __construct(IOInterface $io, Composer $composer)
+    public function __construct(IOInterface $io, Composer $composer, Filesystem $fs = null, BinaryInstaller $binaryInstaller = null)
     {
-        parent::__construct($io, $composer, 'composer-plugin');
-        $this->installationManager = $composer->getInstallationManager();
+        parent::__construct($io, $composer, 'composer-plugin', $fs, $binaryInstaller);
     }
 
     /**
@@ -50,22 +49,36 @@ class PluginInstaller extends LibraryIns
     /**
      * {@inheritDoc}
      */
-    public function install(InstalledRepositoryInterface $repo, PackageInterface $package)
+    public function download(PackageInterface $package, PackageInterface $prevPackage = null)
     {
         $extra = $package->getExtra();
         if (empty($extra['class'])) {
             throw new \UnexpectedValueException('Error while installing '.$package->getPrettyName().', composer-plugin packages should have a class defined in their extra key to be usable.');
         }
 
-        parent::install($repo, $package);
-        try {
-            $this->composer->getPluginManager()->registerPackage($package, true);
-        } catch (\Exception $e) {
-            // Rollback installation
-            $this->io->writeError('Plugin installation failed ('.$e->getMessage().'), rolling back');
-            parent::uninstall($repo, $package);
-            throw $e;
+        return parent::download($package, $prevPackage);
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function install(InstalledRepositoryInterface $repo, PackageInterface $package)
+    {
+        $promise = parent::install($repo, $package);
+        if (!$promise instanceof PromiseInterface) {
+            $promise = \React\Promise\resolve();
         }
+
+        $pluginManager = $this->composer->getPluginManager();
+        $self = $this;
+
+        return $promise->then(function () use ($self, $pluginManager, $package, $repo) {
+            try {
+                $pluginManager->registerPackage($package, true);
+            } catch (\Exception $e) {
+                $self->rollbackInstall($e, $repo, $package);
+            }
+        });
     }
 
     /**
@@ -73,12 +86,39 @@ class PluginInstaller extends LibraryIns
      */
     public function update(InstalledRepositoryInterface $repo, PackageInterface $initial, PackageInterface $target)
     {
-        $extra = $target->getExtra();
-        if (empty($extra['class'])) {
-            throw new \UnexpectedValueException('Error while installing '.$target->getPrettyName().', composer-plugin packages should have a class defined in their extra key to be usable.');
+        $promise = parent::update($repo, $initial, $target);
+        if (!$promise instanceof PromiseInterface) {
+            $promise = \React\Promise\resolve();
         }
 
-        parent::update($repo, $initial, $target);
-        $this->composer->getPluginManager()->registerPackage($target, true);
+        $pluginManager = $this->composer->getPluginManager();
+        $self = $this;
+
+        return $promise->then(function () use ($self, $pluginManager, $initial, $target, $repo) {
+            try {
+                $pluginManager->deactivatePackage($initial, true);
+                $pluginManager->registerPackage($target, true);
+            } catch (\Exception $e) {
+                $self->rollbackInstall($e, $repo, $target);
+            }
+        });
+    }
+
+    public function uninstall(InstalledRepositoryInterface $repo, PackageInterface $package)
+    {
+        $this->composer->getPluginManager()->uninstallPackage($package, true);
+
+        return parent::uninstall($repo, $package);
+    }
+
+    /**
+     * TODO v3 should make this private once we can drop PHP 5.3 support
+     * @private
+     */
+    public function rollbackInstall(\Exception $e, InstalledRepositoryInterface $repo, PackageInterface $package)
+    {
+        $this->io->writeError('Plugin initialization failed ('.$e->getMessage().'), uninstalling plugin');
+        parent::uninstall($repo, $package);
+        throw $e;
     }
 }
diff -pruN 1.10.19-1/src/Composer/Installer/ProjectInstaller.php 2.0.9-1/src/Composer/Installer/ProjectInstaller.php
--- 1.10.19-1/src/Composer/Installer/ProjectInstaller.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/ProjectInstaller.php	2021-01-27 15:09:27.000000000 +0000
@@ -29,11 +29,11 @@ class ProjectInstaller implements Instal
     private $downloadManager;
     private $filesystem;
 
-    public function __construct($installPath, DownloadManager $dm)
+    public function __construct($installPath, DownloadManager $dm, Filesystem $fs)
     {
         $this->installPath = rtrim(strtr($installPath, '\\', '/'), '/').'/';
         $this->downloadManager = $dm;
-        $this->filesystem = new Filesystem;
+        $this->filesystem = $fs;
     }
 
     /**
@@ -58,7 +58,7 @@ class ProjectInstaller implements Instal
     /**
      * {@inheritDoc}
      */
-    public function install(InstalledRepositoryInterface $repo, PackageInterface $package)
+    public function download(PackageInterface $package, PackageInterface $prevPackage = null)
     {
         $installPath = $this->installPath;
         if (file_exists($installPath) && !$this->filesystem->isDirEmpty($installPath)) {
@@ -67,7 +67,32 @@ class ProjectInstaller implements Instal
         if (!is_dir($installPath)) {
             mkdir($installPath, 0777, true);
         }
-        $this->downloadManager->download($package, $installPath);
+
+        return $this->downloadManager->download($package, $installPath, $prevPackage);
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function prepare($type, PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+        return $this->downloadManager->prepare($type, $package, $this->installPath, $prevPackage);
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function cleanup($type, PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+        return $this->downloadManager->cleanup($type, $package, $this->installPath, $prevPackage);
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function install(InstalledRepositoryInterface $repo, PackageInterface $package)
+    {
+        return $this->downloadManager->install($package, $this->installPath);
     }
 
     /**
diff -pruN 1.10.19-1/src/Composer/Installer/SuggestedPackagesReporter.php 2.0.9-1/src/Composer/Installer/SuggestedPackagesReporter.php
--- 1.10.19-1/src/Composer/Installer/SuggestedPackagesReporter.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer/SuggestedPackagesReporter.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,7 +14,7 @@ namespace Composer\Installer;
 
 use Composer\IO\IOInterface;
 use Composer\Package\PackageInterface;
-use Composer\Repository\RepositoryInterface;
+use Composer\Repository\InstalledRepository;
 use Symfony\Component\Console\Formatter\OutputFormatter;
 
 /**
@@ -24,6 +24,10 @@ use Symfony\Component\Console\Formatter\
  */
 class SuggestedPackagesReporter
 {
+    const MODE_LIST = 1;
+    const MODE_BY_PACKAGE = 2;
+    const MODE_BY_SUGGESTION = 4;
+
     /**
      * @var array
      */
@@ -91,38 +95,128 @@ class SuggestedPackagesReporter
 
     /**
      * Output suggested packages.
+     *
      * Do not list the ones already installed if installed repository provided.
      *
-     * @param  RepositoryInterface       $installedRepo Installed packages
+     * @param  int                       $mode             One of the MODE_* constants from this class
+     * @param  InstalledRepository|null  $installedRepo    If passed in, suggested packages which are installed already will be skipped
+     * @param  PackageInterface|null     $onlyDependentsOf If passed in, only the suggestions from direct dependents of that package, or from the package itself, will be shown
+     * @return SuggestedPackagesReporter
+     */
+    public function output($mode, InstalledRepository $installedRepo = null, PackageInterface $onlyDependentsOf = null)
+    {
+        $suggestedPackages = $this->getFilteredSuggestions($installedRepo, $onlyDependentsOf);
+
+        $suggesters = array();
+        $suggested = array();
+        foreach ($suggestedPackages as $suggestion) {
+            $suggesters[$suggestion['source']][$suggestion['target']] = $suggestion['reason'];
+            $suggested[$suggestion['target']][$suggestion['source']] = $suggestion['reason'];
+        }
+        ksort($suggesters);
+        ksort($suggested);
+
+        // Simple mode
+        if ($mode & self::MODE_LIST) {
+            foreach (array_keys($suggested) as $name) {
+                $this->io->write(sprintf('<info>%s</info>', $name));
+            }
+
+            return 0;
+        }
+
+        // Grouped by package
+        if ($mode & self::MODE_BY_PACKAGE) {
+            foreach ($suggesters as $suggester => $suggestions) {
+                $this->io->write(sprintf('<comment>%s</comment> suggests:', $suggester));
+
+                foreach ($suggestions as $suggestion => $reason) {
+                    $this->io->write(sprintf(' - <info>%s</info>' . ($reason ? ': %s' : ''), $suggestion, $this->escapeOutput($reason)));
+                }
+                $this->io->write('');
+            }
+        }
+
+        // Grouped by suggestion
+        if ($mode & self::MODE_BY_SUGGESTION) {
+            // Improve readability in full mode
+            if ($mode & self::MODE_BY_PACKAGE) {
+                $this->io->write(str_repeat('-', 78));
+            }
+            foreach ($suggested as $suggestion => $suggesters) {
+                $this->io->write(sprintf('<comment>%s</comment> is suggested by:', $suggestion));
+
+                foreach ($suggesters as $suggester => $reason) {
+                    $this->io->write(sprintf(' - <info>%s</info>' . ($reason ? ': %s' : ''), $suggester, $this->escapeOutput($reason)));
+                }
+                $this->io->write('');
+            }
+        }
+
+        if ($onlyDependentsOf) {
+            $allSuggestedPackages = $this->getFilteredSuggestions($installedRepo);
+            $diff = count($allSuggestedPackages) - count($suggestedPackages);
+            if ($diff) {
+                $this->io->write('<info>'.$diff.' additional suggestions</info> by transitive dependencies can be shown with <info>--all</info>');
+            }
+        }
+
+        return $this;
+    }
+
+    /**
+     * Output number of new suggested packages and a hint to use suggest command.
+     *
+     * @param  InstalledRepository|null  $installedRepo    If passed in, suggested packages which are installed already will be skipped
+     * @param  PackageInterface|null     $onlyDependentsOf If passed in, only the suggestions from direct dependents of that package, or from the package itself, will be shown
      * @return SuggestedPackagesReporter
      */
-    public function output(RepositoryInterface $installedRepo = null)
+    public function outputMinimalistic(InstalledRepository $installedRepo = null, PackageInterface $onlyDependentsOf = null)
+    {
+        $suggestedPackages = $this->getFilteredSuggestions($installedRepo, $onlyDependentsOf);
+        if ($suggestedPackages) {
+            $this->io->writeError('<info>'.count($suggestedPackages).' package suggestions were added by new dependencies, use `composer suggest` to see details.</info>');
+        }
+
+        return $this;
+    }
+
+    /**
+     * @param  InstalledRepository|null $installedRepo    If passed in, suggested packages which are installed already will be skipped
+     * @param  PackageInterface|null    $onlyDependentsOf If passed in, only the suggestions from direct dependents of that package, or from the package itself, will be shown
+     * @return array[]
+     */
+    private function getFilteredSuggestions(InstalledRepository $installedRepo = null, PackageInterface $onlyDependentsOf = null)
     {
         $suggestedPackages = $this->getPackages();
-        $installedPackages = array();
-        if (null !== $installedRepo && ! empty($suggestedPackages)) {
+        $installedNames = array();
+        if (null !== $installedRepo && !empty($suggestedPackages)) {
             foreach ($installedRepo->getPackages() as $package) {
-                $installedPackages = array_merge(
-                    $installedPackages,
+                $installedNames = array_merge(
+                    $installedNames,
                     $package->getNames()
                 );
             }
         }
 
+        $sourceFilter = array();
+        if ($onlyDependentsOf) {
+            $sourceFilter = array_map(function ($link) {
+                return $link->getTarget();
+            }, array_merge($onlyDependentsOf->getRequires(), $onlyDependentsOf->getDevRequires()));
+            $sourceFilter[] = $onlyDependentsOf->getName();
+        }
+
+        $suggestions = array();
         foreach ($suggestedPackages as $suggestion) {
-            if (in_array($suggestion['target'], $installedPackages)) {
+            if (in_array($suggestion['target'], $installedNames) || ($sourceFilter && !in_array($suggestion['source'], $sourceFilter))) {
                 continue;
             }
 
-            $this->io->writeError(sprintf(
-                '%s suggests installing %s%s',
-                $suggestion['source'],
-                $this->escapeOutput($suggestion['target']),
-                $this->escapeOutput('' !== $suggestion['reason'] ? ' ('.$suggestion['reason'].')' : '')
-            ));
+            $suggestions[] = $suggestion;
         }
 
-        return $this;
+        return $suggestions;
     }
 
     /**
diff -pruN 1.10.19-1/src/Composer/Installer.php 2.0.9-1/src/Composer/Installer.php
--- 1.10.19-1/src/Composer/Installer.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Installer.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,42 +13,49 @@
 namespace Composer;
 
 use Composer\Autoload\AutoloadGenerator;
+use Composer\Console\GithubActionError;
 use Composer\DependencyResolver\DefaultPolicy;
+use Composer\DependencyResolver\LocalRepoTransaction;
+use Composer\DependencyResolver\LockTransaction;
 use Composer\DependencyResolver\Operation\UpdateOperation;
 use Composer\DependencyResolver\Operation\InstallOperation;
 use Composer\DependencyResolver\Operation\UninstallOperation;
-use Composer\DependencyResolver\Operation\MarkAliasUninstalledOperation;
-use Composer\DependencyResolver\Operation\OperationInterface;
-use Composer\DependencyResolver\PolicyInterface;
 use Composer\DependencyResolver\Pool;
 use Composer\DependencyResolver\Request;
-use Composer\DependencyResolver\Rule;
 use Composer\DependencyResolver\Solver;
 use Composer\DependencyResolver\SolverProblemsException;
+use Composer\DependencyResolver\PolicyInterface;
 use Composer\Downloader\DownloadManager;
 use Composer\EventDispatcher\EventDispatcher;
 use Composer\Installer\InstallationManager;
 use Composer\Installer\InstallerEvents;
-use Composer\Installer\NoopInstaller;
 use Composer\Installer\SuggestedPackagesReporter;
 use Composer\IO\IOInterface;
 use Composer\Package\AliasPackage;
+use Composer\Package\RootAliasPackage;
 use Composer\Package\BasePackage;
 use Composer\Package\CompletePackage;
 use Composer\Package\CompletePackageInterface;
 use Composer\Package\Link;
 use Composer\Package\Loader\ArrayLoader;
 use Composer\Package\Dumper\ArrayDumper;
+use Composer\Package\Version\VersionParser;
+use Composer\Package\Package;
+use Composer\Repository\ArrayRepository;
+use Composer\Repository\RepositorySet;
+use Composer\Repository\CompositeRepository;
 use Composer\Semver\Constraint\Constraint;
 use Composer\Package\Locker;
-use Composer\Package\PackageInterface;
 use Composer\Package\RootPackageInterface;
-use Composer\Repository\CompositeRepository;
 use Composer\Repository\InstalledArrayRepository;
+use Composer\Repository\InstalledRepositoryInterface;
+use Composer\Repository\InstalledRepository;
+use Composer\Repository\FilterRepository;
+use Composer\Repository\RootPackageRepository;
 use Composer\Repository\PlatformRepository;
 use Composer\Repository\RepositoryInterface;
 use Composer\Repository\RepositoryManager;
-use Composer\Repository\WritableRepositoryInterface;
+use Composer\Repository\LockArrayRepository;
 use Composer\Script\ScriptEvents;
 
 /**
@@ -74,6 +81,12 @@ class Installer
      */
     protected $package;
 
+    // TODO can we get rid of the below and just use the package itself?
+    /**
+     * @var RootPackageInterface
+     */
+    protected $fixedRootPackage;
+
     /**
      * @var DownloadManager
      */
@@ -109,16 +122,17 @@ class Installer
     protected $optimizeAutoloader = false;
     protected $classMapAuthoritative = false;
     protected $apcuAutoloader = false;
+    protected $apcuAutoloaderPrefix;
     protected $devMode = false;
     protected $dryRun = false;
     protected $verbose = false;
     protected $update = false;
+    protected $install = true;
     protected $dumpAutoloader = true;
     protected $runScripts = true;
     protected $ignorePlatformReqs = false;
     protected $preferStable = false;
     protected $preferLowest = false;
-    protected $skipSuggest = false;
     protected $writeLock;
     protected $executeOperations = true;
 
@@ -127,9 +141,9 @@ class Installer
      *
      * @var array|null
      */
-    protected $updateWhitelist = null; // TODO 2.0 rename to updateAllowList
-    protected $whitelistDependencies = false; // TODO 2.0 rename to allowListTransitiveDependencies
-    protected $whitelistAllDependencies = false; // TODO 2.0 rename to allowListAllDependencies
+    protected $updateMirrors = false;
+    protected $updateAllowList;
+    protected $updateAllowTransitiveDependencies = Request::UPDATE_ONLY_LISTED;
 
     /**
      * @var SuggestedPackagesReporter
@@ -139,7 +153,7 @@ class Installer
     /**
      * @var RepositoryInterface
      */
-    protected $additionalInstalledRepository;
+    protected $additionalFixedRepository;
 
     /**
      * Constructor
@@ -184,8 +198,15 @@ class Installer
         gc_collect_cycles();
         gc_disable();
 
+        if ($this->updateAllowList && $this->updateMirrors) {
+            throw new \RuntimeException("The installer options updateMirrors and updateAllowList are mutually exclusive.");
+        }
+
+        $isFreshInstall = $this->repositoryManager->getLocalRepository()->isFresh();
+
         // Force update if there is no lock file present
         if (!$this->update && !$this->locker->isLocked()) {
+            $this->io->writeError('<warning>No lock file found. Updating dependencies instead of installing from lock file. Use composer update over composer install if you do not have a lock file.</warning>');
             $this->update = true;
         }
 
@@ -195,15 +216,19 @@ class Installer
             $this->executeOperations = false;
             $this->writeLock = false;
             $this->dumpAutoloader = false;
-            $this->installationManager->addInstaller(new NoopInstaller);
             $this->mockLocalRepositories($this->repositoryManager);
         }
 
+        if ($this->update && !$this->install) {
+            $this->dumpAutoloader = false;
+        }
+
         if ($this->runScripts) {
             $_SERVER['COMPOSER_DEV_MODE'] = $this->devMode ? '1' : '0';
             putenv('COMPOSER_DEV_MODE='.$_SERVER['COMPOSER_DEV_MODE']);
 
             // dispatch pre event
+            // should we treat this more strictly as running an update and then running an install, triggering events multiple times?
             $eventName = $this->update ? ScriptEvents::PRE_UPDATE_CMD : ScriptEvents::PRE_INSTALL_CMD;
             $this->eventDispatcher->dispatchScript($eventName, $this->devMode);
         }
@@ -211,46 +236,47 @@ class Installer
         $this->downloadManager->setPreferSource($this->preferSource);
         $this->downloadManager->setPreferDist($this->preferDist);
 
-        // create installed repo, this contains all local packages + platform packages (php & extensions)
         $localRepo = $this->repositoryManager->getLocalRepository();
-        if ($this->update) {
-            $platformOverrides = $this->config->get('platform') ?: array();
-        } else {
-            $platformOverrides = $this->locker->getPlatformOverrides();
-        }
-        $platformRepo = new PlatformRepository(array(), $platformOverrides);
-        $installedRepo = $this->createInstalledRepo($localRepo, $platformRepo);
-
-        $aliases = $this->getRootAliases();
-        $this->aliasPlatformPackages($platformRepo, $aliases);
 
         if (!$this->suggestedPackagesReporter) {
             $this->suggestedPackagesReporter = new SuggestedPackagesReporter($this->io);
         }
 
         try {
-            list($res, $devPackages) = $this->doInstall($localRepo, $installedRepo, $platformRepo, $aliases);
+            if ($this->update) {
+                $res = $this->doUpdate($localRepo, $this->install);
+            } else {
+                $res = $this->doInstall($localRepo);
+            }
             if ($res !== 0) {
                 return $res;
             }
         } catch (\Exception $e) {
-            if ($this->executeOperations && $this->config->get('notify-on-install')) {
+            if ($this->executeOperations && $this->install && $this->config->get('notify-on-install')) {
                 $this->installationManager->notifyInstalls($this->io);
             }
 
             throw $e;
         }
-        if ($this->executeOperations && $this->config->get('notify-on-install')) {
+        if ($this->executeOperations && $this->install && $this->config->get('notify-on-install')) {
             $this->installationManager->notifyInstalls($this->io);
         }
 
-        // output suggestions if we're in dev mode
-        if ($this->devMode && !$this->skipSuggest) {
-            $this->suggestedPackagesReporter->output($installedRepo);
+        if ($this->update) {
+            $installedRepo = new InstalledRepository(array(
+                $this->locker->getLockedRepository($this->devMode),
+                $this->createPlatformRepo(false),
+                new RootPackageRepository(clone $this->package),
+            ));
+            if ($isFreshInstall) {
+                $this->suggestedPackagesReporter->addSuggestionsFromPackage($this->package);
+            }
+            $this->suggestedPackagesReporter->outputMinimalistic($installedRepo);
         }
 
-        # Find abandoned packages and warn user
-        foreach ($localRepo->getPackages() as $package) {
+        // Find abandoned packages and warn user
+        $lockedRepository = $this->locker->getLockedRepository(true);
+        foreach ($lockedRepository->getPackages() as $package) {
             if (!$package instanceof CompletePackage || !$package->isAbandoned()) {
                 continue;
             }
@@ -268,30 +294,6 @@ class Installer
             );
         }
 
-        // write lock
-        if ($this->update && $this->writeLock) {
-            $localRepo->reload();
-
-            $platformReqs = $this->extractPlatformRequirements($this->package->getRequires());
-            $platformDevReqs = $this->extractPlatformRequirements($this->package->getDevRequires());
-
-            $updatedLock = $this->locker->setLockData(
-                array_diff($localRepo->getCanonicalPackages(), $devPackages),
-                $devPackages,
-                $platformReqs,
-                $platformDevReqs,
-                $aliases,
-                $this->package->getMinimumStability(),
-                $this->package->getStabilityFlags(),
-                $this->preferStable || $this->package->getPreferStable(),
-                $this->preferLowest,
-                $this->config->get('platform') ?: array()
-            );
-            if ($updatedLock) {
-                $this->io->writeError('<info>Writing lock file</info>');
-            }
-        }
-
         if ($this->dumpAutoloader) {
             // write autoloader
             if ($this->optimizeAutoloader) {
@@ -302,12 +304,13 @@ class Installer
 
             $this->autoloadGenerator->setDevMode($this->devMode);
             $this->autoloadGenerator->setClassMapAuthoritative($this->classMapAuthoritative);
-            $this->autoloadGenerator->setApcu($this->apcuAutoloader);
+            $this->autoloadGenerator->setApcu($this->apcuAutoloader, $this->apcuAutoloaderPrefix);
             $this->autoloadGenerator->setRunScripts($this->runScripts);
+            $this->autoloadGenerator->setIgnorePlatformRequirements($this->ignorePlatformReqs);
             $this->autoloadGenerator->dump($this->config, $localRepo, $this->package, $this->installationManager, 'composer', $this->optimizeAutoloader);
         }
 
-        if ($this->executeOperations) {
+        if ($this->install && $this->executeOperations) {
             // force binaries re-generation in case they are missing
             foreach ($localRepo->getPackages() as $package) {
                 $this->installationManager->ensureBinariesPresence($package);
@@ -346,305 +349,179 @@ class Installer
         return 0;
     }
 
-    /**
-     * @param  RepositoryInterface $localRepo
-     * @param  RepositoryInterface $installedRepo
-     * @param  PlatformRepository  $platformRepo
-     * @param  array               $aliases
-     * @return array               [int, PackageInterfaces[]|null] with the exit code and an array of dev packages on update, or null on install
-     */
-    protected function doInstall($localRepo, $installedRepo, $platformRepo, $aliases)
+    protected function doUpdate(InstalledRepositoryInterface $localRepo, $doInstall)
     {
-        // init vars
+        $platformRepo = $this->createPlatformRepo(true);
+        $aliases = $this->getRootAliases(true);
+
         $lockedRepository = null;
-        $repositories = null;
 
-        // initialize locked repo if we are installing from lock or in a partial update
-        // and a lock file is present as we need to force install non-allowed lock file
-        // packages in that case
-        if (!$this->update || (!empty($this->updateWhitelist) && $this->locker->isLocked())) {
-            try {
-                $lockedRepository = $this->locker->getLockedRepository($this->devMode);
-            } catch (\RuntimeException $e) {
-                // if there are dev requires, then we really can not install
-                if ($this->package->getDevRequires()) {
-                    throw $e;
-                }
-                // no require-dev in composer.json and the lock file was created with no dev info, so skip them
-                $lockedRepository = $this->locker->getLockedRepository();
+        try {
+            if ($this->locker->isLocked()) {
+                $lockedRepository = $this->locker->getLockedRepository(true);
+            }
+        } catch (\Seld\JsonLint\ParsingException $e) {
+            if ($this->updateAllowList || $this->updateMirrors) {
+                // in case we are doing a partial update or updating mirrors, the lock file is needed so we error
+                throw $e;
             }
+            // otherwise, ignoring parse errors as the lock file will be regenerated from scratch when
+            // doing a full update
         }
 
-        $this->allowListUpdateDependencies(
-            $lockedRepository ?: $localRepo,
-            $this->package->getRequires(),
-            $this->package->getDevRequires()
-        );
+        if (($this->updateAllowList || $this->updateMirrors) && !$lockedRepository) {
+            $this->io->writeError('<error>Cannot update ' . ($this->updateMirrors ? 'lock file information' : 'only a partial set of packages') . ' without a lock file present. Run `composer update` to generate a lock file.</error>', true, IOInterface::QUIET);
+
+            return 1;
+        }
 
         $this->io->writeError('<info>Loading composer repositories with package information</info>');
 
-        // creating repository pool
-        $policy = $this->createPolicy();
-        $pool = $this->createPool($this->update ? null : $lockedRepository);
-        $pool->addRepository($installedRepo, $aliases);
-        if ($this->update) {
-            $repositories = $this->repositoryManager->getRepositories();
-            foreach ($repositories as $repository) {
-                $pool->addRepository($repository, $aliases);
-            }
+        // creating repository set
+        $policy = $this->createPolicy(true);
+        $repositorySet = $this->createRepositorySet(true, $platformRepo, $aliases);
+        $repositories = $this->repositoryManager->getRepositories();
+        foreach ($repositories as $repository) {
+            $repositorySet->addRepository($repository);
         }
-        // Add the locked repository after the others in case we are doing a
-        // partial update so missing packages can be found there still.
-        // For installs from lock it's the only one added so it is first
         if ($lockedRepository) {
-            $pool->addRepository($lockedRepository, $aliases);
+            $repositorySet->addRepository($lockedRepository);
         }
 
-        // creating requirements request
-        $request = $this->createRequest($this->package, $platformRepo);
-
-        if ($this->update) {
-            // remove unstable packages from the localRepo if they don't match the current stability settings
-            $removedUnstablePackages = array();
-            foreach ($localRepo->getPackages() as $package) {
-                if (
-                    !$pool->isPackageAcceptable($package->getNames(), $package->getStability())
-                    && $this->installationManager->isPackageInstalled($localRepo, $package)
-                ) {
-                    $removedUnstablePackages[$package->getName()] = true;
-                    $request->remove($package->getName(), new Constraint('=', $package->getVersion()));
-                }
-            }
-
-            $this->io->writeError('<info>Updating dependencies'.($this->devMode ? ' (including require-dev)' : '').'</info>');
+        $request = $this->createRequest($this->fixedRootPackage, $platformRepo, $lockedRepository);
+        $this->requirePackagesForUpdate($request, $lockedRepository, true);
 
-            $request->updateAll();
-
-            $links = array_merge($this->package->getRequires(), $this->package->getDevRequires());
-
-            foreach ($links as $link) {
-                $request->install($link->getTarget(), $link->getConstraint());
-            }
-
-            // if the updateWhitelist is enabled, packages not in it are also fixed
-            // to the version specified in the lock, or their currently installed version
-            if ($this->updateWhitelist) {
-                $currentPackages = $this->getCurrentPackages($installedRepo);
-
-                // collect packages to fixate from root requirements as well as installed packages
-                $candidates = array();
-                foreach ($links as $link) {
-                    $candidates[$link->getTarget()] = true;
-                    $rootRequires[$link->getTarget()] = $link;
-                }
-                foreach ($currentPackages as $package) {
-                    $candidates[$package->getName()] = true;
-                }
-
-                // fix them to the version in lock (or currently installed) if they are not updateable
-                foreach ($candidates as $candidate => $dummy) {
-                    foreach ($currentPackages as $curPackage) {
-                        if ($curPackage->getName() === $candidate) {
-                            if (!$this->isUpdateable($curPackage) && !isset($removedUnstablePackages[$curPackage->getName()])) {
-                                $constraint = new Constraint('=', $curPackage->getVersion());
-                                $description = $this->locker->isLocked() ? '(locked at' : '(installed at';
-                                $requiredAt = isset($rootRequires[$candidate]) ? ', required as ' . $rootRequires[$candidate]->getPrettyConstraint() : '';
-                                $constraint->setPrettyString($description . ' ' . $curPackage->getPrettyVersion() . $requiredAt . ')');
-                                $request->install($curPackage->getName(), $constraint);
-                            }
-                            break;
-                        }
-                    }
-                }
-            }
-        } else {
-            $this->io->writeError('<info>Installing dependencies'.($this->devMode ? ' (including require-dev)' : '').' from lock file</info>');
-
-            if (!$this->locker->isFresh()) {
-                $this->io->writeError('<warning>Warning: The lock file is not up to date with the latest changes in composer.json. You may be getting outdated dependencies. It is recommended that you run `composer update` or `composer update <package name>`.</warning>', true, IOInterface::QUIET);
-            }
-
-            foreach ($lockedRepository->getPackages() as $package) {
-                $version = $package->getVersion();
-                if (isset($aliases[$package->getName()][$version])) {
-                    $version = $aliases[$package->getName()][$version]['alias_normalized'];
-                }
-                $constraint = new Constraint('=', $version);
-                $constraint->setPrettyString($package->getPrettyVersion());
-                $request->install($package->getName(), $constraint);
-            }
-
-            foreach ($this->locker->getPlatformRequirements($this->devMode) as $link) {
-                $request->install($link->getTarget(), $link->getConstraint());
-            }
+        // pass the allow list into the request, so the pool builder can apply it
+        if ($this->updateAllowList) {
+            $request->setUpdateAllowList($this->updateAllowList, $this->updateAllowTransitiveDependencies);
         }
 
-        // force dev packages to have the latest links if we update or install from a (potentially new) lock
-        $this->processDevPackages($localRepo, $pool, $policy, $repositories, $installedRepo, $lockedRepository, 'force-links');
+        $pool = $repositorySet->createPool($request, $this->io, $this->eventDispatcher);
+
+        $this->io->writeError('<info>Updating dependencies</info>');
 
         // solve dependencies
-        $this->eventDispatcher->dispatchInstallerEvent(InstallerEvents::PRE_DEPENDENCIES_SOLVING, $this->devMode, $policy, $pool, $installedRepo, $request);
-        $solver = new Solver($policy, $pool, $installedRepo, $this->io);
+        $solver = new Solver($policy, $pool, $this->io);
         try {
-            $operations = $solver->solve($request, $this->ignorePlatformReqs);
+            $lockTransaction = $solver->solve($request, $this->ignorePlatformReqs);
             $ruleSetSize = $solver->getRuleSetSize();
             $solver = null;
         } catch (SolverProblemsException $e) {
-            $this->io->writeError('<error>Your requirements could not be resolved to an installable set of packages.</error>', true, IOInterface::QUIET);
-            $this->io->writeError($e->getMessage());
-            if ($this->update && !$this->devMode) {
+            $err = 'Your requirements could not be resolved to an installable set of packages.';
+            $prettyProblem = $e->getPrettyString($repositorySet, $request, $pool, $this->io->isVerbose());
+
+            $this->io->writeError('<error>'. $err .'</error>', true, IOInterface::QUIET);
+            $this->io->writeError($prettyProblem);
+            if (!$this->devMode) {
                 $this->io->writeError('<warning>Running update with --no-dev does not mean require-dev is ignored, it just means the packages will not be installed. If dev requirements are blocking the update you have to resolve those problems.</warning>', true, IOInterface::QUIET);
             }
 
-            return array(max(1, $e->getCode()), array());
-        }
+            $ghe = new GithubActionError($this->io);
+            $ghe->emit($err."\n".$prettyProblem);
 
-        // force dev packages to be updated if we update or install from a (potentially new) lock
-        $operations = $this->processDevPackages($localRepo, $pool, $policy, $repositories, $installedRepo, $lockedRepository, 'force-updates', $operations);
-
-        $this->eventDispatcher->dispatchInstallerEvent(InstallerEvents::POST_DEPENDENCIES_SOLVING, $this->devMode, $policy, $pool, $installedRepo, $request, $operations);
+            return max(1, $e->getCode());
+        }
 
         $this->io->writeError("Analyzed ".count($pool)." packages to resolve dependencies", true, IOInterface::VERBOSE);
         $this->io->writeError("Analyzed ".$ruleSetSize." rules to resolve dependencies", true, IOInterface::VERBOSE);
 
-        // execute operations
-        if (!$operations) {
-            $this->io->writeError('Nothing to install or update');
+        if (!$lockTransaction->getOperations()) {
+            $this->io->writeError('Nothing to modify in lock file');
         }
 
-        $operations = $this->movePluginsToFront($operations);
-        $operations = $this->moveUninstallsToFront($operations);
-
-        // extract dev packages and mark them to be skipped if it's a --no-dev install or update
-        // we also force them to be uninstalled if they are present in the local repo
-        if ($this->update) {
-            $devPackages = $this->extractDevPackages($operations, $localRepo, $platformRepo, $aliases);
-            if (!$this->devMode) {
-                $operations = $this->filterDevPackageOperations($devPackages, $operations, $localRepo);
-            }
-        } else {
-            $devPackages = null;
+        $exitCode = $this->extractDevPackages($lockTransaction, $platformRepo, $aliases, $policy, $lockedRepository);
+        if ($exitCode !== 0) {
+            return $exitCode;
         }
 
-        if ($operations) {
-            $installs = $updates = $uninstalls = array();
-            foreach ($operations as $operation) {
+        // write lock
+        $platformReqs = $this->extractPlatformRequirements($this->package->getRequires());
+        $platformDevReqs = $this->extractPlatformRequirements($this->package->getDevRequires());
+
+        $installsUpdates = $uninstalls = array();
+        if ($lockTransaction->getOperations()) {
+            $installNames = $updateNames = $uninstallNames = array();
+            foreach ($lockTransaction->getOperations() as $operation) {
                 if ($operation instanceof InstallOperation) {
-                    $installs[] = $operation->getPackage()->getPrettyName().':'.$operation->getPackage()->getFullPrettyVersion();
+                    $installsUpdates[] = $operation;
+                    $installNames[] = $operation->getPackage()->getPrettyName().':'.$operation->getPackage()->getFullPrettyVersion();
                 } elseif ($operation instanceof UpdateOperation) {
-                    $updates[] = $operation->getTargetPackage()->getPrettyName().':'.$operation->getTargetPackage()->getFullPrettyVersion();
+                    $installsUpdates[] = $operation;
+                    $updateNames[] = $operation->getTargetPackage()->getPrettyName().':'.$operation->getTargetPackage()->getFullPrettyVersion();
                 } elseif ($operation instanceof UninstallOperation) {
-                    $uninstalls[] = $operation->getPackage()->getPrettyName();
+                    $uninstalls[] = $operation;
+                    $uninstallNames[] = $operation->getPackage()->getPrettyName();
                 }
             }
 
             $this->io->writeError(sprintf(
-                "<info>Package operations: %d install%s, %d update%s, %d removal%s</info>",
-                count($installs),
-                1 === count($installs) ? '' : 's',
-                count($updates),
-                1 === count($updates) ? '' : 's',
+                "<info>Lock file operations: %d install%s, %d update%s, %d removal%s</info>",
+                count($installNames),
+                1 === count($installNames) ? '' : 's',
+                count($updateNames),
+                1 === count($updateNames) ? '' : 's',
                 count($uninstalls),
                 1 === count($uninstalls) ? '' : 's'
             ));
-            if ($installs) {
-                $this->io->writeError("Installs: ".implode(', ', $installs), true, IOInterface::VERBOSE);
+            if ($installNames) {
+                $this->io->writeError("Installs: ".implode(', ', $installNames), true, IOInterface::VERBOSE);
             }
-            if ($updates) {
-                $this->io->writeError("Updates: ".implode(', ', $updates), true, IOInterface::VERBOSE);
+            if ($updateNames) {
+                $this->io->writeError("Updates: ".implode(', ', $updateNames), true, IOInterface::VERBOSE);
             }
             if ($uninstalls) {
-                $this->io->writeError("Removals: ".implode(', ', $uninstalls), true, IOInterface::VERBOSE);
+                $this->io->writeError("Removals: ".implode(', ', $uninstallNames), true, IOInterface::VERBOSE);
             }
         }
 
-        foreach ($operations as $operation) {
-            // collect suggestions
-            $jobType = $operation->getJobType();
-            if ('install' === $jobType) {
-                $this->suggestedPackagesReporter->addSuggestionsFromPackage($operation->getPackage());
+        $sortByName = function ($a, $b) {
+            if ($a instanceof UpdateOperation) {
+                $a = $a->getTargetPackage()->getName();
+            } else {
+                $a = $a->getPackage()->getName();
             }
-
-            // updating, force dev packages' references if they're in root package refs
-            if ($this->update) {
-                $package = null;
-                if ('update' === $jobType) {
-                    $package = $operation->getTargetPackage();
-                } elseif ('install' === $jobType) {
-                    $package = $operation->getPackage();
-                }
-                if ($package && $package->isDev()) {
-                    $references = $this->package->getReferences();
-                    if (isset($references[$package->getName()])) {
-                        $this->updateInstallReferences($package, $references[$package->getName()]);
-                    }
-                }
-                if ('update' === $jobType) {
-                    $targetPackage = $operation->getTargetPackage();
-                    if ($targetPackage->isDev()) {
-                        $initialPackage = $operation->getInitialPackage();
-                        if ($targetPackage->getVersion() === $initialPackage->getVersion()
-                            && (!$targetPackage->getSourceReference() || $targetPackage->getSourceReference() === $initialPackage->getSourceReference())
-                            && (!$targetPackage->getDistReference() || $targetPackage->getDistReference() === $initialPackage->getDistReference())
-                        ) {
-                            $this->io->writeError('  - Skipping update of ' . $targetPackage->getPrettyName() . ' to the same reference-locked version', true, IOInterface::DEBUG);
-                            $this->io->writeError('', true, IOInterface::DEBUG);
-
-                            continue;
-                        }
-                    }
-                }
+            if ($b instanceof UpdateOperation) {
+                $b = $b->getTargetPackage()->getName();
+            } else {
+                $b = $b->getPackage()->getName();
             }
 
-            $event = 'Composer\Installer\PackageEvents::PRE_PACKAGE_'.strtoupper($jobType);
-            if (defined($event) && $this->runScripts) {
-                $this->eventDispatcher->dispatchPackageEvent(constant($event), $this->devMode, $policy, $pool, $installedRepo, $request, $operations, $operation);
-            }
-
-            // output non-alias ops when not executing operations (i.e. dry run), output alias ops in debug verbosity
-            if (!$this->executeOperations && false === strpos($operation->getJobType(), 'Alias')) {
-                $this->io->writeError('  - ' . $operation);
-            } elseif ($this->io->isDebug() && false !== strpos($operation->getJobType(), 'Alias')) {
-                $this->io->writeError('  - ' . $operation);
-            }
-
-            $this->installationManager->execute($localRepo, $operation);
-
-            // output reasons why the operation was ran, only for install/update operations
-            if ($this->verbose && $this->io->isVeryVerbose() && in_array($jobType, array('install', 'update'))) {
-                $reason = $operation->getReason();
-                if ($reason instanceof Rule) {
-                    switch ($reason->getReason()) {
-                        case Rule::RULE_JOB_INSTALL:
-                            $this->io->writeError('    REASON: Required by the root package: '.$reason->getPrettyString($pool));
-                            $this->io->writeError('');
-                            break;
-                        case Rule::RULE_PACKAGE_REQUIRES:
-                            $this->io->writeError('    REASON: '.$reason->getPrettyString($pool));
-                            $this->io->writeError('');
-                            break;
-                    }
-                }
-            }
+            return strcmp($a, $b);
+        };
+        usort($uninstalls, $sortByName);
+        usort($installsUpdates, $sortByName);
 
-            if ($this->executeOperations || $this->writeLock) {
-                $localRepo->write();
+        foreach (array_merge($uninstalls, $installsUpdates) as $operation) {
+            // collect suggestions
+            if ($operation instanceof InstallOperation) {
+                $this->suggestedPackagesReporter->addSuggestionsFromPackage($operation->getPackage());
             }
 
-            $event = 'Composer\Installer\PackageEvents::POST_PACKAGE_'.strtoupper($jobType);
-            if (defined($event) && $this->runScripts) {
-                $this->eventDispatcher->dispatchPackageEvent(constant($event), $this->devMode, $policy, $pool, $installedRepo, $request, $operations, $operation);
+            // output op, but alias op only in debug verbosity
+            if (false === strpos($operation->getOperationType(), 'Alias') || $this->io->isDebug()) {
+                $this->io->writeError('  - ' . $operation->show(true));
             }
         }
 
-        if ($this->executeOperations) {
-            // force source/dist urls to be updated for all packages
-            $this->processPackageUrls($pool, $policy, $localRepo, $repositories);
-            $localRepo->write();
+        $updatedLock = $this->locker->setLockData(
+            $lockTransaction->getNewLockPackages(false, $this->updateMirrors),
+            $lockTransaction->getNewLockPackages(true, $this->updateMirrors),
+            $platformReqs,
+            $platformDevReqs,
+            $lockTransaction->getAliases($aliases),
+            $this->package->getMinimumStability(),
+            $this->package->getStabilityFlags(),
+            $this->preferStable || $this->package->getPreferStable(),
+            $this->preferLowest,
+            $this->config->get('platform') ?: array(),
+            $this->writeLock && $this->executeOperations
+        );
+        if ($updatedLock && $this->writeLock && $this->executeOperations) {
+            $this->io->writeError('<info>Writing lock file</info>');
         }
 
         // see https://github.com/composer/composer/issues/2764
-        if ($operations) {
+        if ($this->executeOperations && count($lockTransaction->getOperations()) > 0) {
             $vendorDir = $this->config->get('vendor-dir');
             if (is_dir($vendorDir)) {
                 // suppress errors as this fails sometimes on OSX for no apparent reason
@@ -653,231 +530,205 @@ class Installer
             }
         }
 
-        return array(0, $devPackages);
+        if ($doInstall) {
+            // TODO ensure lock is used from locker as-is, since it may not have been written to disk in case of executeOperations == false
+            return $this->doInstall($localRepo, true);
+        }
+
+        return 0;
     }
 
     /**
-     * Extracts the dev packages out of the localRepo
-     *
-     * This works by faking the operations so we can see what the dev packages
-     * would be at the end of the operation execution. This lets us then remove
-     * the dev packages from the list of operations accordingly if we are in a
-     * --no-dev install or update.
-     *
-     * @return array
+     * Run the solver a second time on top of the existing update result with only the current result set in the pool
+     * and see what packages would get removed if we only had the non-dev packages in the solver request
      */
-    private function extractDevPackages(array $operations, RepositoryInterface $localRepo, PlatformRepository $platformRepo, array $aliases)
+    protected function extractDevPackages(LockTransaction $lockTransaction, PlatformRepository $platformRepo, array $aliases, PolicyInterface $policy, LockArrayRepository $lockedRepository = null)
     {
         if (!$this->package->getDevRequires()) {
-            return array();
-        }
-
-        // fake-apply all operations to this clone of the local repo so we see the complete set of package we would end up with
-        $tempLocalRepo = clone $localRepo;
-        foreach ($operations as $operation) {
-            switch ($operation->getJobType()) {
-                case 'install':
-                case 'markAliasInstalled':
-                    if (!$tempLocalRepo->hasPackage($operation->getPackage())) {
-                        $tempLocalRepo->addPackage(clone $operation->getPackage());
-                    }
-                    break;
-
-                case 'uninstall':
-                case 'markAliasUninstalled':
-                    $tempLocalRepo->removePackage($operation->getPackage());
-                    break;
-
-                case 'update':
-                    $tempLocalRepo->removePackage($operation->getInitialPackage());
-                    if (!$tempLocalRepo->hasPackage($operation->getTargetPackage())) {
-                        $tempLocalRepo->addPackage(clone $operation->getTargetPackage());
-                    }
-                    break;
-
-                default:
-                    throw new \LogicException('Unknown type: '.$operation->getJobType());
-            }
+            return 0;
         }
 
-        // we have to reload the local repo to handle aliases properly
-        // but as it is not persisted on disk we use a loader/dumper
-        // to reload it in memory
-        $localRepo = new InstalledArrayRepository(array());
+        $resultRepo = new ArrayRepository(array());
         $loader = new ArrayLoader(null, true);
         $dumper = new ArrayDumper();
-        foreach ($tempLocalRepo->getCanonicalPackages() as $pkg) {
-            $localRepo->addPackage($loader->load($dumper->dump($pkg)));
+        foreach ($lockTransaction->getNewLockPackages(false) as $pkg) {
+            $resultRepo->addPackage($loader->load($dumper->dump($pkg)));
         }
-        unset($tempLocalRepo, $loader, $dumper);
 
-        $policy = $this->createPolicy();
-        $pool = $this->createPool();
-        $installedRepo = $this->createInstalledRepo($localRepo, $platformRepo);
-        $pool->addRepository($installedRepo, $aliases);
+        $repositorySet = $this->createRepositorySet(true, $platformRepo, $aliases);
+        $repositorySet->addRepository($resultRepo);
 
-        // creating requirements request without dev requirements
-        $request = $this->createRequest($this->package, $platformRepo);
-        $request->updateAll();
-        foreach ($this->package->getRequires() as $link) {
-            $request->install($link->getTarget(), $link->getConstraint());
-        }
+        $request = $this->createRequest($this->fixedRootPackage, $platformRepo);
+        $this->requirePackagesForUpdate($request, $lockedRepository, false);
 
-        // solve deps to see which get removed
-        $this->eventDispatcher->dispatchInstallerEvent(InstallerEvents::PRE_DEPENDENCIES_SOLVING, false, $policy, $pool, $installedRepo, $request);
-        $solver = new Solver($policy, $pool, $installedRepo, $this->io);
-        $ops = $solver->solve($request, $this->ignorePlatformReqs);
-        $this->eventDispatcher->dispatchInstallerEvent(InstallerEvents::POST_DEPENDENCIES_SOLVING, false, $policy, $pool, $installedRepo, $request, $ops);
+        $pool = $repositorySet->createPoolWithAllPackages();
 
-        $devPackages = array();
-        foreach ($ops as $op) {
-            if ($op->getJobType() === 'uninstall') {
-                $devPackages[] = $op->getPackage();
-            }
+        $solver = new Solver($policy, $pool, $this->io);
+        try {
+            $nonDevLockTransaction = $solver->solve($request, $this->ignorePlatformReqs);
+            $solver = null;
+        } catch (SolverProblemsException $e) {
+            $err = 'Unable to find a compatible set of packages based on your non-dev requirements alone.';
+            $prettyProblem = $e->getPrettyString($repositorySet, $request, $pool, $this->io->isVerbose(), true);
+
+            $this->io->writeError('<error>'. $err .'</error>', true, IOInterface::QUIET);
+            $this->io->writeError('Your requirements can be resolved successfully when require-dev packages are present.');
+            $this->io->writeError('You may need to move packages from require-dev or some of their dependencies to require.');
+            $this->io->writeError($prettyProblem);
+
+            $ghe = new GithubActionError($this->io);
+            $ghe->emit($err."\n".$prettyProblem);
+
+            return max(1, $e->getCode());
         }
 
-        return $devPackages;
+        $lockTransaction->setNonDevPackages($nonDevLockTransaction);
+
+        return 0;
     }
 
     /**
-     * @return OperationInterface[] filtered operations, dev packages are uninstalled and all operations on them ignored
-     */
-    private function filterDevPackageOperations(array $devPackages, array $operations, RepositoryInterface $localRepo)
-    {
-        $finalOps = array();
-        $packagesToSkip = array();
-        foreach ($devPackages as $pkg) {
-            $packagesToSkip[$pkg->getName()] = true;
-            if ($installedDevPkg = $localRepo->findPackage($pkg->getName(), '*')) {
-                if ($installedDevPkg instanceof AliasPackage) {
-                    $finalOps[] = new MarkAliasUninstalledOperation($installedDevPkg, 'non-dev install removing it');
-                    $installedDevPkg = $installedDevPkg->getAliasOf();
-                }
-                $finalOps[] = new UninstallOperation($installedDevPkg, 'non-dev install removing it');
+     * @param  InstalledRepositoryInterface $localRepo
+     * @param  bool                         $alreadySolved Whether the function is called as part of an update command or independently
+     * @return int                          exit code
+     */
+    protected function doInstall(InstalledRepositoryInterface $localRepo, $alreadySolved = false)
+    {
+        $this->io->writeError('<info>Installing dependencies from lock file'.($this->devMode ? ' (including require-dev)' : '').'</info>');
+
+        $lockedRepository = $this->locker->getLockedRepository($this->devMode);
+
+        // verify that the lock file works with the current platform repository
+        // we can skip this part if we're doing this as the second step after an update
+        if (!$alreadySolved) {
+            $this->io->writeError('<info>Verifying lock file contents can be installed on current platform.</info>');
+
+            $platformRepo = $this->createPlatformRepo(false);
+            // creating repository set
+            $policy = $this->createPolicy(false);
+            // use aliases from lock file only, so empty root aliases here
+            $repositorySet = $this->createRepositorySet(false, $platformRepo, array(), $lockedRepository);
+            $repositorySet->addRepository($lockedRepository);
+
+            // creating requirements request
+            $request = $this->createRequest($this->fixedRootPackage, $platformRepo, $lockedRepository);
+
+            if (!$this->locker->isFresh()) {
+                $this->io->writeError('<warning>Warning: The lock file is not up to date with the latest changes in composer.json. You may be getting outdated dependencies. It is recommended that you run `composer update` or `composer update <package name>`.</warning>', true, IOInterface::QUIET);
             }
-        }
 
-        // skip operations applied on dev packages
-        foreach ($operations as $op) {
-            $package = $op->getJobType() === 'update' ? $op->getTargetPackage() : $op->getPackage();
-            if (isset($packagesToSkip[$package->getName()])) {
-                continue;
+            foreach ($lockedRepository->getPackages() as $package) {
+                $request->fixLockedPackage($package);
             }
 
-            $finalOps[] = $op;
-        }
+            foreach ($this->locker->getPlatformRequirements($this->devMode) as $link) {
+                $request->requireName($link->getTarget(), $link->getConstraint());
+            }
 
-        return $finalOps;
-    }
+            $pool = $repositorySet->createPool($request, $this->io, $this->eventDispatcher);
 
-    /**
-     * Workaround: if your packages depend on plugins, we must be sure
-     * that those are installed / updated first; else it would lead to packages
-     * being installed multiple times in different folders, when running Composer
-     * twice.
-     *
-     * While this does not fix the root-causes of https://github.com/composer/composer/issues/1147,
-     * it at least fixes the symptoms and makes usage of composer possible (again)
-     * in such scenarios.
-     *
-     * @param  OperationInterface[] $operations
-     * @return OperationInterface[] reordered operation list
-     */
-    private function movePluginsToFront(array $operations)
-    {
-        $pluginsNoDeps = array();
-        $pluginsWithDeps = array();
-        $pluginRequires = array();
+            // solve dependencies
+            $solver = new Solver($policy, $pool, $this->io);
+            try {
+                $lockTransaction = $solver->solve($request, $this->ignorePlatformReqs);
+                $solver = null;
 
-        foreach (array_reverse($operations, true) as $idx => $op) {
-            if ($op instanceof InstallOperation) {
-                $package = $op->getPackage();
-            } elseif ($op instanceof UpdateOperation) {
-                $package = $op->getTargetPackage();
-            } else {
-                continue;
+                // installing the locked packages on this platform resulted in lock modifying operations, there wasn't a conflict, but the lock file as-is seems to not work on this system
+                if (0 !== count($lockTransaction->getOperations())) {
+                    $this->io->writeError('<error>Your lock file cannot be installed on this system without changes. Please run composer update.</error>', true, IOInterface::QUIET);
+
+                    return 1;
+                }
+            } catch (SolverProblemsException $e) {
+                $err = 'Your lock file does not contain a compatible set of packages. Please run composer update.';
+                $prettyProblem = $e->getPrettyString($repositorySet, $request, $pool, $this->io->isVerbose());
+
+                $this->io->writeError('<error>'. $err .'</error>', true, IOInterface::QUIET);
+                $this->io->writeError($prettyProblem);
+
+                $ghe = new GithubActionError($this->io);
+                $ghe->emit($err."\n".$prettyProblem);
+
+                return max(1, $e->getCode());
             }
+        }
+
+        // TODO in how far do we need to do anything here to ensure dev packages being updated to latest in lock without version change are treated correctly?
+        $localRepoTransaction = new LocalRepoTransaction($lockedRepository, $localRepo);
+        $this->eventDispatcher->dispatchInstallerEvent(InstallerEvents::PRE_OPERATIONS_EXEC, $this->devMode, $this->executeOperations, $localRepoTransaction);
 
-            // is this package a plugin?
-            $isPlugin = $package->getType() === 'composer-plugin' || $package->getType() === 'composer-installer';
+        if (!$localRepoTransaction->getOperations()) {
+            $this->io->writeError('Nothing to install, update or remove');
+        }
 
-            // is this a plugin or a dependency of a plugin?
-            if ($isPlugin || count(array_intersect($package->getNames(), $pluginRequires))) {
-                // get the package's requires, but filter out any platform requirements or 'composer-plugin-api'
-                $requires = array_filter(array_keys($package->getRequires()), function ($req) {
-                    return $req !== 'composer-plugin-api' && !preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $req);
-                });
-
-                // is this a plugin with no meaningful dependencies?
-                if ($isPlugin && !count($requires)) {
-                    // plugins with no dependencies go to the very front
-                    array_unshift($pluginsNoDeps, $op);
-                } else {
-                    // capture the requirements for this package so those packages will be moved up as well
-                    $pluginRequires = array_merge($pluginRequires, $requires);
-                    // move the operation to the front
-                    array_unshift($pluginsWithDeps, $op);
+        if ($localRepoTransaction->getOperations()) {
+            $installs = $updates = $uninstalls = array();
+            foreach ($localRepoTransaction->getOperations() as $operation) {
+                if ($operation instanceof InstallOperation) {
+                    $installs[] = $operation->getPackage()->getPrettyName().':'.$operation->getPackage()->getFullPrettyVersion();
+                } elseif ($operation instanceof UpdateOperation) {
+                    $updates[] = $operation->getTargetPackage()->getPrettyName().':'.$operation->getTargetPackage()->getFullPrettyVersion();
+                } elseif ($operation instanceof UninstallOperation) {
+                    $uninstalls[] = $operation->getPackage()->getPrettyName();
                 }
+            }
 
-                unset($operations[$idx]);
+            $this->io->writeError(sprintf(
+                "<info>Package operations: %d install%s, %d update%s, %d removal%s</info>",
+                count($installs),
+                1 === count($installs) ? '' : 's',
+                count($updates),
+                1 === count($updates) ? '' : 's',
+                count($uninstalls),
+                1 === count($uninstalls) ? '' : 's'
+            ));
+            if ($installs) {
+                $this->io->writeError("Installs: ".implode(', ', $installs), true, IOInterface::VERBOSE);
+            }
+            if ($updates) {
+                $this->io->writeError("Updates: ".implode(', ', $updates), true, IOInterface::VERBOSE);
+            }
+            if ($uninstalls) {
+                $this->io->writeError("Removals: ".implode(', ', $uninstalls), true, IOInterface::VERBOSE);
             }
         }
 
-        return array_merge($pluginsNoDeps, $pluginsWithDeps, $operations);
-    }
-
-    /**
-     * Removals of packages should be executed before installations in
-     * case two packages resolve to the same path (due to custom installers)
-     *
-     * @param  OperationInterface[] $operations
-     * @return OperationInterface[] reordered operation list
-     */
-    private function moveUninstallsToFront(array $operations)
-    {
-        $uninstOps = array();
-        foreach ($operations as $idx => $op) {
-            if ($op instanceof UninstallOperation) {
-                $uninstOps[] = $op;
-                unset($operations[$idx]);
+        if ($this->executeOperations) {
+            $localRepo->setDevPackageNames($this->locker->getDevPackageNames());
+            $this->installationManager->execute($localRepo, $localRepoTransaction->getOperations(), $this->devMode, $this->runScripts);
+        } else {
+            foreach ($localRepoTransaction->getOperations() as $operation) {
+                // output op, but alias op only in debug verbosity
+                if (false === strpos($operation->getOperationType(), 'Alias') || $this->io->isDebug()) {
+                    $this->io->writeError('  - ' . $operation->show(false));
+                }
             }
         }
 
-        return array_merge($uninstOps, $operations);
+        return 0;
     }
 
-    /**
-     * @return RepositoryInterface
-     */
-    private function createInstalledRepo(RepositoryInterface $localRepo, PlatformRepository $platformRepo)
+    private function createPlatformRepo($forUpdate)
     {
-        // clone root package to have one in the installed repo that does not require anything
-        // we don't want it to be uninstallable, but its requirements should not conflict
-        // with the lock file for example
-        $installedRootPackage = clone $this->package;
-        $installedRootPackage->setRequires(array());
-        $installedRootPackage->setDevRequires(array());
-
-        $repos = array(
-            $localRepo,
-            new InstalledArrayRepository(array($installedRootPackage)),
-            $platformRepo,
-        );
-        $installedRepo = new CompositeRepository($repos);
-        if ($this->additionalInstalledRepository) {
-            $installedRepo->addRepository($this->additionalInstalledRepository);
+        if ($forUpdate) {
+            $platformOverrides = $this->config->get('platform') ?: array();
+        } else {
+            $platformOverrides = $this->locker->getPlatformOverrides();
         }
 
-        return $installedRepo;
+        return new PlatformRepository(array(), $platformOverrides);
     }
 
     /**
+     * @param  bool                     $forUpdate
+     * @param  PlatformRepository       $platformRepo
+     * @param  array                    $rootAliases
      * @param  RepositoryInterface|null $lockedRepository
-     * @return Pool
+     * @return RepositorySet
      */
-    private function createPool(RepositoryInterface $lockedRepository = null)
+    private function createRepositorySet($forUpdate, PlatformRepository $platformRepo, array $rootAliases = array(), $lockedRepository = null)
     {
-        if ($this->update) {
+        if ($forUpdate) {
             $minimumStability = $this->package->getMinimumStability();
             $stabilityFlags = $this->package->getStabilityFlags();
 
@@ -894,30 +745,58 @@ class Installer
             }
         }
 
-        $rootConstraints = array();
+        $rootRequires = array();
         foreach ($requires as $req => $constraint) {
             // skip platform requirements from the root package to avoid filtering out existing platform packages
-            if ($this->ignorePlatformReqs && preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $req)) {
+            if ((true === $this->ignorePlatformReqs || (is_array($this->ignorePlatformReqs) && in_array($req, $this->ignorePlatformReqs, true))) && PlatformRepository::isPlatformPackage($req)) {
                 continue;
             }
             if ($constraint instanceof Link) {
-                $rootConstraints[$req] = $constraint->getConstraint();
+                $rootRequires[$req] = $constraint->getConstraint();
             } else {
-                $rootConstraints[$req] = $constraint;
+                $rootRequires[$req] = $constraint;
             }
         }
 
-        return new Pool($minimumStability, $stabilityFlags, $rootConstraints);
+        $this->fixedRootPackage = clone $this->package;
+        $this->fixedRootPackage->setRequires(array());
+        $this->fixedRootPackage->setDevRequires(array());
+
+        $stabilityFlags[$this->package->getName()] = BasePackage::$stabilities[VersionParser::parseStability($this->package->getVersion())];
+
+        $repositorySet = new RepositorySet($minimumStability, $stabilityFlags, $rootAliases, $this->package->getReferences(), $rootRequires);
+        $repositorySet->addRepository(new RootPackageRepository($this->fixedRootPackage));
+        $repositorySet->addRepository($platformRepo);
+        if ($this->additionalFixedRepository) {
+            // allow using installed repos if needed to avoid warnings about installed repositories being used in the RepositorySet
+            // see https://github.com/composer/composer/pull/9574
+            $additionalFixedRepositories = $this->additionalFixedRepository;
+            if ($additionalFixedRepositories instanceof CompositeRepository) {
+                $additionalFixedRepositories = $additionalFixedRepositories->getRepositories();
+            } else {
+                $additionalFixedRepositories = array($additionalFixedRepositories);
+            }
+            foreach ($additionalFixedRepositories as $additionalFixedRepository) {
+                if ($additionalFixedRepository instanceof InstalledRepository || $additionalFixedRepository instanceof InstalledRepositoryInterface) {
+                    $repositorySet->allowInstalledRepositories();
+                    break;
+                }
+            }
+
+            $repositorySet->addRepository($this->additionalFixedRepository);
+        }
+
+        return $repositorySet;
     }
 
     /**
      * @return DefaultPolicy
      */
-    private function createPolicy()
+    private function createPolicy($forUpdate)
     {
         $preferStable = null;
         $preferLowest = null;
-        if (!$this->update) {
+        if (!$forUpdate) {
             $preferStable = $this->locker->getPreferStable();
             $preferLowest = $this->locker->getPreferLowest();
         }
@@ -934,374 +813,90 @@ class Installer
     }
 
     /**
-     * @param  RootPackageInterface $rootPackage
-     * @param  PlatformRepository   $platformRepo
      * @return Request
      */
-    private function createRequest(RootPackageInterface $rootPackage, PlatformRepository $platformRepo)
+    private function createRequest(RootPackageInterface $rootPackage, PlatformRepository $platformRepo, LockArrayRepository $lockedRepository = null)
     {
-        $request = new Request();
+        $request = new Request($lockedRepository);
 
-        $constraint = new Constraint('=', $rootPackage->getVersion());
-        $constraint->setPrettyString($rootPackage->getPrettyVersion());
-        $request->install($rootPackage->getName(), $constraint);
+        $request->fixPackage($rootPackage);
+        if ($rootPackage instanceof RootAliasPackage) {
+            $request->fixPackage($rootPackage->getAliasOf());
+        }
 
         $fixedPackages = $platformRepo->getPackages();
-        if ($this->additionalInstalledRepository) {
-            $additionalFixedPackages = $this->additionalInstalledRepository->getPackages();
-            $fixedPackages = array_merge($fixedPackages, $additionalFixedPackages);
+        if ($this->additionalFixedRepository) {
+            $fixedPackages = array_merge($fixedPackages, $this->additionalFixedRepository->getPackages());
         }
 
         // fix the version of all platform packages + additionally installed packages
         // to prevent the solver trying to remove or update those
+        // TODO why not replaces?
         $provided = $rootPackage->getProvides();
         foreach ($fixedPackages as $package) {
-            $constraint = new Constraint('=', $package->getVersion());
-            $constraint->setPrettyString($package->getPrettyVersion());
-
             // skip platform packages that are provided by the root package
             if ($package->getRepository() !== $platformRepo
                 || !isset($provided[$package->getName()])
-                || !$provided[$package->getName()]->getConstraint()->matches($constraint)
+                || !$provided[$package->getName()]->getConstraint()->matches(new Constraint('=', $package->getVersion()))
             ) {
-                $request->fix($package->getName(), $constraint);
+                $request->fixPackage($package);
             }
         }
 
         return $request;
     }
 
-    /**
-     * @param  WritableRepositoryInterface $localRepo
-     * @param  Pool                        $pool
-     * @param  PolicyInterface             $policy
-     * @param  array                       $repositories
-     * @param  RepositoryInterface         $installedRepo
-     * @param  RepositoryInterface         $lockedRepository
-     * @param  string                      $task
-     * @param  array|null                  $operations
-     * @return array
-     */
-    private function processDevPackages($localRepo, $pool, $policy, $repositories, $installedRepo, $lockedRepository, $task, array $operations = null)
+    private function requirePackagesForUpdate(Request $request, LockArrayRepository $lockedRepository = null, $includeDevRequires = true)
     {
-        if ($task === 'force-updates' && null === $operations) {
-            throw new \InvalidArgumentException('Missing operations argument');
-        }
-        if ($task === 'force-links') {
-            $operations = array();
-        }
-
-        if ($this->update && $this->updateWhitelist) {
-            $currentPackages = $this->getCurrentPackages($installedRepo);
-        }
-
-        foreach ($localRepo->getCanonicalPackages() as $package) {
-            // skip non-dev packages
-            if (!$package->isDev()) {
-                continue;
+        // if we're updating mirrors we want to keep exactly the same versions installed which are in the lock file, but we want current remote metadata
+        if ($this->updateMirrors) {
+            $excludedPackages = array();
+            if (!$includeDevRequires) {
+                $excludedPackages = array_flip($this->locker->getDevPackageNames());
             }
 
-            // skip packages that will be updated/uninstalled
-            foreach ($operations as $operation) {
-                if (('update' === $operation->getJobType() && $operation->getInitialPackage()->equals($package))
-                    || ('uninstall' === $operation->getJobType() && $operation->getPackage()->equals($package))
-                ) {
-                    continue 2;
+            foreach ($lockedRepository->getPackages() as $lockedPackage) {
+                // exclude alias packages here as for root aliases, both alias and aliased are
+                // present in the lock repo and we only want to require the aliased version
+                if (!$lockedPackage instanceof AliasPackage && !isset($excludedPackages[$lockedPackage->getName()])) {
+                    $request->requireName($lockedPackage->getName(), new Constraint('==', $lockedPackage->getVersion()));
                 }
             }
-
-            if ($this->update) {
-                // skip package if the allow list is enabled and it is not in it
-                if ($this->updateWhitelist && !$this->isUpdateable($package)) {
-                    // check if non-updateable packages are out of date compared to the lock file to ensure we don't corrupt it
-                    foreach ($currentPackages as $curPackage) {
-                        if ($curPackage->isDev() && $curPackage->getName() === $package->getName() && $curPackage->getVersion() === $package->getVersion()) {
-                            if ($task === 'force-links') {
-                                $package->setRequires($curPackage->getRequires());
-                                $package->setConflicts($curPackage->getConflicts());
-                                $package->setProvides($curPackage->getProvides());
-                                $package->setReplaces($curPackage->getReplaces());
-                            } elseif ($task === 'force-updates') {
-                                if (($curPackage->getSourceReference() && $curPackage->getSourceReference() !== $package->getSourceReference())
-                                    || ($curPackage->getDistReference() && $curPackage->getDistReference() !== $package->getDistReference())
-                                ) {
-                                    $operations[] = new UpdateOperation($package, $curPackage);
-                                }
-                            }
-
-                            break;
-                        }
-                    }
-
-                    continue;
-                }
-
-                // find similar packages (name/version) in all repositories
-                $matches = $pool->whatProvides($package->getName(), new Constraint('=', $package->getVersion()));
-                foreach ($matches as $index => $match) {
-                    // skip local packages
-                    if (!in_array($match->getRepository(), $repositories, true)) {
-                        unset($matches[$index]);
-                        continue;
-                    }
-
-                    // skip providers/replacers
-                    if ($match->getName() !== $package->getName()) {
-                        unset($matches[$index]);
-                        continue;
-                    }
-
-                    $matches[$index] = $match->getId();
-                }
-
-                // select preferred package according to policy rules
-                if ($matches && $matches = $policy->selectPreferredPackages($pool, array(), $matches)) {
-                    $newPackage = $pool->literalToPackage($matches[0]);
-
-                    if ($task === 'force-links' && $newPackage) {
-                        $package->setRequires($newPackage->getRequires());
-                        $package->setConflicts($newPackage->getConflicts());
-                        $package->setProvides($newPackage->getProvides());
-                        $package->setReplaces($newPackage->getReplaces());
-                    }
-
-                    if (
-                        $task === 'force-updates'
-                        && $newPackage
-                        && (
-                            ($newPackage->getSourceReference() && $newPackage->getSourceReference() !== $package->getSourceReference())
-                            || ($newPackage->getDistReference() && $newPackage->getDistReference() !== $package->getDistReference())
-                        )
-                    ) {
-                        $operations[] = new UpdateOperation($package, $newPackage);
-
-                        continue;
-                    }
-                }
-
-                if ($task === 'force-updates') {
-                    // force installed package to update to referenced version in root package if it does not match the installed version
-                    $references = $this->package->getReferences();
-
-                    if (isset($references[$package->getName()]) && $references[$package->getName()] !== $package->getSourceReference()) {
-                        // changing the source ref to update to will be handled in the operations loop
-                        $operations[] = new UpdateOperation($package, clone $package);
-                    }
-                }
-            } else {
-                // force update to locked version if it does not match the installed version
-                foreach ($lockedRepository->findPackages($package->getName()) as $lockedPackage) {
-                    if ($lockedPackage->isDev() && $lockedPackage->getVersion() === $package->getVersion()) {
-                        if ($task === 'force-links') {
-                            $package->setRequires($lockedPackage->getRequires());
-                            $package->setConflicts($lockedPackage->getConflicts());
-                            $package->setProvides($lockedPackage->getProvides());
-                            $package->setReplaces($lockedPackage->getReplaces());
-                        } elseif ($task === 'force-updates') {
-                            if (($lockedPackage->getSourceReference() && $lockedPackage->getSourceReference() !== $package->getSourceReference())
-                                || ($lockedPackage->getDistReference() && $lockedPackage->getDistReference() !== $package->getDistReference())
-                            ) {
-                                $operations[] = new UpdateOperation($package, $lockedPackage);
-                            }
-                        }
-
-                        break;
-                    }
-                }
+        } else {
+            $links = $this->package->getRequires();
+            if ($includeDevRequires) {
+                $links = array_merge($links, $this->package->getDevRequires());
             }
-        }
-
-        return $operations;
-    }
-
-    /**
-     * Loads the most "current" list of packages that are installed meaning from lock ideally or from installed repo as fallback
-     * @param  RepositoryInterface $installedRepo
-     * @return array
-     */
-    private function getCurrentPackages($installedRepo)
-    {
-        if ($this->locker->isLocked()) {
-            try {
-                return $this->locker->getLockedRepository(true)->getPackages();
-            } catch (\RuntimeException $e) {
-                // fetch only non-dev packages from lock if doing a dev update fails due to a previously incomplete lock file
-                return $this->locker->getLockedRepository()->getPackages();
+            foreach ($links as $link) {
+                $request->requireName($link->getTarget(), $link->getConstraint());
             }
         }
-
-        return $installedRepo->getPackages();
     }
 
     /**
+     * @param  bool  $forUpdate
      * @return array
      */
-    private function getRootAliases()
+    private function getRootAliases($forUpdate)
     {
-        if ($this->update) {
+        if ($forUpdate) {
             $aliases = $this->package->getAliases();
         } else {
             $aliases = $this->locker->getAliases();
         }
 
-        $normalizedAliases = array();
-
-        foreach ($aliases as $alias) {
-            $normalizedAliases[$alias['package']][$alias['version']] = array(
-                'alias' => $alias['alias'],
-                'alias_normalized' => $alias['alias_normalized'],
-            );
-        }
-
-        return $normalizedAliases;
-    }
-
-    /**
-     * @param Pool                        $pool
-     * @param PolicyInterface             $policy
-     * @param WritableRepositoryInterface $localRepo
-     * @param array                       $repositories
-     */
-    private function processPackageUrls($pool, $policy, $localRepo, $repositories)
-    {
-        if (!$this->update) {
-            return;
-        }
-
-        $rootRefs = $this->package->getReferences();
-
-        foreach ($localRepo->getCanonicalPackages() as $package) {
-            // find similar packages (name/version) in all repositories
-            $matches = $pool->whatProvides($package->getName(), new Constraint('=', $package->getVersion()));
-            foreach ($matches as $index => $match) {
-                // skip local packages
-                if (!in_array($match->getRepository(), $repositories, true)) {
-                    unset($matches[$index]);
-                    continue;
-                }
-
-                // skip providers/replacers
-                if ($match->getName() !== $package->getName()) {
-                    unset($matches[$index]);
-                    continue;
-                }
-
-                $matches[$index] = $match->getId();
-            }
-
-            // select preferred package according to policy rules
-            if ($matches && $matches = $policy->selectPreferredPackages($pool, array(), $matches)) {
-                $newPackage = $pool->literalToPackage($matches[0]);
-
-                // update the dist and source URLs
-                $sourceUrl = $package->getSourceUrl();
-                $newSourceUrl = $newPackage->getSourceUrl();
-                $newReference = $newPackage->getSourceReference();
-
-                if ($package->isDev() && isset($rootRefs[$package->getName()]) && $package->getSourceReference() === $rootRefs[$package->getName()]) {
-                    $newReference = $rootRefs[$package->getName()];
-                }
-
-                $this->updatePackageUrl($package, $newSourceUrl, $newPackage->getSourceType(), $newReference, $newPackage->getDistUrl(), $newPackage->getDistType(), $newPackage->getDistSha1Checksum());
-
-                if ($package instanceof CompletePackage && $newPackage instanceof CompletePackage) {
-                    $package->setAbandoned($newPackage->getReplacementPackage() ?: $newPackage->isAbandoned());
-                }
-
-                $package->setDistMirrors($newPackage->getDistMirrors());
-                $package->setSourceMirrors($newPackage->getSourceMirrors());
-                $package->setTransportOptions($newPackage->getTransportOptions());
-            }
-        }
-    }
-
-    private function updatePackageUrl(PackageInterface $package, $sourceUrl, $sourceType, $sourceReference, $distUrl, $distType, $distShaSum)
-    {
-        $oldSourceRef = $package->getSourceReference();
-
-        if ($package->getSourceUrl() !== $sourceUrl) {
-            $package->setSourceType($sourceType);
-            $package->setSourceUrl($sourceUrl);
-            $package->setSourceReference($sourceReference);
-        }
-
-        // only update dist url for github/bitbucket/gitlab dists as they use a combination of dist url + dist reference to install
-        // but for other urls this is ambiguous and could result in bad outcomes
-        if (preg_match('{^https?://(?:(?:www\.)?bitbucket\.org|(api\.)?github\.com|(?:www\.)?gitlab\.com)/}i', $distUrl)) {
-            $package->setDistUrl($distUrl);
-            $package->setDistType($distType);
-            $package->setDistSha1Checksum($distShaSum);
-            $this->updateInstallReferences($package, $sourceReference);
-        }
-
-        if ($this->updateWhitelist && !$this->isUpdateable($package)) {
-            $this->updateInstallReferences($package, $oldSourceRef);
-        }
-    }
-
-    private function updateInstallReferences(PackageInterface $package, $reference)
-    {
-        if (!$reference) {
-            return;
-        }
-
-        $package->setSourceReference($reference);
-
-        if (preg_match('{^https?://(?:(?:www\.)?bitbucket\.org|(api\.)?github\.com|(?:www\.)?gitlab\.com)/}i', $package->getDistUrl())) {
-            $package->setDistReference($reference);
-            $package->setDistUrl(preg_replace('{(?<=/|sha=)[a-f0-9]{40}(?=/|$)}i', $reference, $package->getDistUrl()));
-        } elseif ($package->getDistReference()) { // update the dist reference if there was one, but if none was provided ignore it
-            $package->setDistReference($reference);
-        }
-    }
-
-    /**
-     * @param PlatformRepository $platformRepo
-     * @param array              $aliases
-     */
-    private function aliasPlatformPackages(PlatformRepository $platformRepo, $aliases)
-    {
-        foreach ($aliases as $package => $versions) {
-            foreach ($versions as $version => $alias) {
-                $packages = $platformRepo->findPackages($package, $version);
-                foreach ($packages as $package) {
-                    $aliasPackage = new AliasPackage($package, $alias['alias_normalized'], $alias['alias']);
-                    $aliasPackage->setRootPackageAlias(true);
-                    $platformRepo->addPackage($aliasPackage);
-                }
-            }
-        }
-    }
-
-    /**
-     * @param  PackageInterface $package
-     * @return bool
-     */
-    private function isUpdateable(PackageInterface $package)
-    {
-        if (!$this->updateWhitelist) {
-            throw new \LogicException('isUpdateable should only be called when an allow list is present');
-        }
-
-        foreach ($this->updateWhitelist as $pattern => $void) {
-            $patternRegexp = BasePackage::packageNameToRegexp($pattern);
-            if (preg_match($patternRegexp, $package->getName())) {
-                return true;
-            }
-        }
-
-        return false;
+        return $aliases;
     }
 
     /**
      * @param  array $links
      * @return array
      */
-    private function extractPlatformRequirements($links)
+    private function extractPlatformRequirements(array $links)
     {
         $platformReqs = array();
         foreach ($links as $link) {
-            if (preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $link->getTarget())) {
+            if (PlatformRepository::isPlatformPackage($link->getTarget())) {
                 $platformReqs[$link->getTarget()] = $link->getPrettyConstraint();
             }
         }
@@ -1310,112 +905,6 @@ class Installer
     }
 
     /**
-     * Adds all dependencies of the update allow list to the allow list, too.
-     *
-     * Packages which are listed as requirements in the root package will be
-     * skipped including their dependencies, unless they are listed in the
-     * update allow list themselves or $whitelistAllDependencies is true.
-     *
-     * @param RepositoryInterface $localOrLockRepo Use the locked repo if available, otherwise installed repo will do
-     *                                             As we want the most accurate package list to work with, and installed
-     *                                             repo might be empty but locked repo will always be current.
-     * @param array               $rootRequires    An array of links to packages in require of the root package
-     * @param array               $rootDevRequires An array of links to packages in require-dev of the root package
-     */
-    private function allowListUpdateDependencies($localOrLockRepo, array $rootRequires, array $rootDevRequires)
-    {
-        if (!$this->updateWhitelist) {
-            return;
-        }
-
-        $rootRequires = array_merge($rootRequires, $rootDevRequires);
-
-        $skipPackages = array();
-        if (!$this->whitelistAllDependencies) {
-            foreach ($rootRequires as $require) {
-                $skipPackages[$require->getTarget()] = true;
-            }
-        }
-
-        $pool = new Pool('dev');
-        $pool->addRepository($localOrLockRepo);
-
-        $seen = array();
-
-        $rootRequiredPackageNames = array_keys($rootRequires);
-
-        foreach ($this->updateWhitelist as $packageName => $void) {
-            $packageQueue = new \SplQueue;
-            $nameMatchesRequiredPackage = false;
-
-            $depPackages = $pool->whatProvides($packageName);
-            $matchesByPattern = array();
-            // check if the name is a glob pattern that did not match directly
-            if (empty($depPackages)) {
-                // add any installed package matching the allow listed name/pattern
-                $allowListPatternSearchRegexp = BasePackage::packageNameToRegexp($packageName, '^%s$');
-                foreach ($localOrLockRepo->search($allowListPatternSearchRegexp) as $installedPackage) {
-                    $matchesByPattern[] = $pool->whatProvides($installedPackage['name']);
-                }
-
-                // add root requirements which match the allow listed name/pattern
-                $allowListPatternRegexp = BasePackage::packageNameToRegexp($packageName);
-                foreach ($rootRequiredPackageNames as $rootRequiredPackageName) {
-                    if (preg_match($allowListPatternRegexp, $rootRequiredPackageName)) {
-                        $nameMatchesRequiredPackage = true;
-                        break;
-                    }
-                }
-            }
-
-            if (!empty($matchesByPattern)) {
-                $depPackages = array_merge($depPackages, call_user_func_array('array_merge', $matchesByPattern));
-            }
-
-            if (count($depPackages) == 0 && !$nameMatchesRequiredPackage && !in_array($packageName, array('nothing', 'lock', 'mirrors'))) {
-                $this->io->writeError('<warning>Package "' . $packageName . '" listed for update is not installed. Ignoring.</warning>');
-            }
-
-            foreach ($depPackages as $depPackage) {
-                $packageQueue->enqueue($depPackage);
-            }
-
-            while (!$packageQueue->isEmpty()) {
-                $package = $packageQueue->dequeue();
-                if (isset($seen[$package->getId()])) {
-                    continue;
-                }
-
-                $seen[$package->getId()] = true;
-                $this->updateWhitelist[$package->getName()] = true;
-
-                if (!$this->whitelistDependencies && !$this->whitelistAllDependencies) {
-                    continue;
-                }
-
-                $requires = $package->getRequires();
-
-                foreach ($requires as $require) {
-                    $requirePackages = $pool->whatProvides($require->getTarget());
-
-                    foreach ($requirePackages as $requirePackage) {
-                        if (isset($this->updateWhitelist[$requirePackage->getName()])) {
-                            continue;
-                        }
-
-                        if (isset($skipPackages[$requirePackage->getName()]) && !preg_match(BasePackage::packageNameToRegexp($packageName), $requirePackage->getName())) {
-                            $this->io->writeError('<warning>Dependency "' . $requirePackage->getName() . '" is also a root requirement, but is not explicitly allowed. Ignoring.</warning>');
-                            continue;
-                        }
-
-                        $packageQueue->enqueue($requirePackage);
-                    }
-                }
-            }
-        }
-    }
-
-    /**
      * Replace local repositories with InstalledArrayRepository instances
      *
      * This is to prevent any accidental modification of the existing repos on disk
@@ -1462,12 +951,12 @@ class Installer
     }
 
     /**
-     * @param  RepositoryInterface $additionalInstalledRepository
+     * @param  RepositoryInterface $additionalFixedRepository
      * @return $this
      */
-    public function setAdditionalInstalledRepository(RepositoryInterface $additionalInstalledRepository)
+    public function setAdditionalFixedRepository(RepositoryInterface $additionalFixedRepository)
     {
-        $this->additionalInstalledRepository = $additionalInstalledRepository;
+        $this->additionalFixedRepository = $additionalFixedRepository;
 
         return $this;
     }
@@ -1527,7 +1016,7 @@ class Installer
      * @param  bool      $optimizeAutoloader
      * @return Installer
      */
-    public function setOptimizeAutoloader($optimizeAutoloader = false)
+    public function setOptimizeAutoloader($optimizeAutoloader)
     {
         $this->optimizeAutoloader = (bool) $optimizeAutoloader;
         if (!$this->optimizeAutoloader) {
@@ -1546,7 +1035,7 @@ class Installer
      * @param  bool      $classMapAuthoritative
      * @return Installer
      */
-    public function setClassMapAuthoritative($classMapAuthoritative = false)
+    public function setClassMapAuthoritative($classMapAuthoritative)
     {
         $this->classMapAuthoritative = (bool) $classMapAuthoritative;
         if ($this->classMapAuthoritative) {
@@ -1560,12 +1049,14 @@ class Installer
     /**
      * Whether or not generated autoloader considers APCu caching.
      *
-     * @param  bool      $apcuAutoloader
+     * @param  bool        $apcuAutoloader
+     * @param  string|null $apcuAutoloaderPrefix
      * @return Installer
      */
-    public function setApcuAutoloader($apcuAutoloader = false)
+    public function setApcuAutoloader($apcuAutoloader, $apcuAutoloaderPrefix = null)
     {
-        $this->apcuAutoloader = (bool) $apcuAutoloader;
+        $this->apcuAutoloader = $apcuAutoloader;
+        $this->apcuAutoloaderPrefix = $apcuAutoloaderPrefix;
 
         return $this;
     }
@@ -1576,7 +1067,7 @@ class Installer
      * @param  bool      $update
      * @return Installer
      */
-    public function setUpdate($update = true)
+    public function setUpdate($update)
     {
         $this->update = (bool) $update;
 
@@ -1584,6 +1075,19 @@ class Installer
     }
 
     /**
+     * Allows disabling the install step after an update
+     *
+     * @param  bool      $install
+     * @return Installer
+     */
+    public function setInstall($install)
+    {
+        $this->install = (bool) $install;
+
+        return $this;
+    }
+
+    /**
      * enables dev packages
      *
      * @param  bool      $devMode
@@ -1665,28 +1169,35 @@ class Installer
     /**
      * set ignore Platform Package requirements
      *
-     * @param  bool      $ignorePlatformReqs
+     * If this is set to true, all platform requirements are ignored
+     * If this is set to false, no platform requirements are ignored
+     * If this is set to string[], those packages will be ignored
+     *
+     * @param  bool|array $ignorePlatformReqs
      * @return Installer
      */
-    public function setIgnorePlatformRequirements($ignorePlatformReqs = false)
+    public function setIgnorePlatformRequirements($ignorePlatformReqs)
     {
-        $this->ignorePlatformReqs = (bool) $ignorePlatformReqs;
+        if (is_array($ignorePlatformReqs)) {
+            $this->ignorePlatformReqs = array_filter($ignorePlatformReqs, function ($req) {
+                return PlatformRepository::isPlatformPackage($req);
+            });
+        } else {
+            $this->ignorePlatformReqs = (bool) $ignorePlatformReqs;
+        }
 
         return $this;
     }
 
     /**
-     * restrict the update operation to a few packages, all other packages
-     * that are already installed will be kept at their current version
+     * Update the lock file to the exact same versions and references but use current remote metadata like URLs and mirror info
      *
-     * @deprecated use setUpdateAllowList instead
-     *
-     * @param  array     $packages
+     * @param  bool      $updateMirrors
      * @return Installer
      */
-    public function setUpdateWhitelist(array $packages)
+    public function setUpdateMirrors($updateMirrors)
     {
-        $this->updateWhitelist = array_flip(array_map('strtolower', $packages));
+        $this->updateMirrors = $updateMirrors;
 
         return $this;
     }
@@ -1700,85 +1211,32 @@ class Installer
      */
     public function setUpdateAllowList(array $packages)
     {
-        // call original method for BC
-        return $this->setUpdateWhitelist($packages);
-    }
-
-    /**
-     * @deprecated use setAllowListTransitiveDependencies instead
-     */
-    public function setWhitelistDependencies($updateDependencies = true)
-    {
-        return $this->setWhitelistTransitiveDependencies($updateDependencies);
-    }
-
-    /**
-     * Should dependencies of allowed packages (but not direct dependencies) be updated?
-     *
-     * This will NOT allow list any dependencies that are also directly defined
-     * in the root package.
-     *
-     * @deprecated use setAllowListTransitiveDependencies instead
-     *
-     * @param  bool      $updateTransitiveDependencies
-     * @return Installer
-     */
-    public function setWhitelistTransitiveDependencies($updateTransitiveDependencies = true)
-    {
-        $this->whitelistDependencies = (bool) $updateTransitiveDependencies;
+        $this->updateAllowList = array_flip(array_map('strtolower', $packages));
 
         return $this;
     }
 
     /**
-     * Should dependencies of allowed packages (but not direct dependencies) be updated?
+     * Should dependencies of packages marked for update be updated?
      *
-     * This will NOT allow list any dependencies that are also directly defined
-     * in the root package.
+     * Depending on the chosen constant this will either only update the directly named packages, all transitive
+     * dependencies which are not root requirement or all transitive dependencies including root requirements
      *
-     * @param  bool      $updateTransitiveDependencies
+     * @param  int       $updateAllowTransitiveDependencies One of the UPDATE_ constants on the Request class
      * @return Installer
      */
-    public function setAllowListTransitiveDependencies($updateTransitiveDependencies = true)
+    public function setUpdateAllowTransitiveDependencies($updateAllowTransitiveDependencies)
     {
-        // call original method for BC
-        return $this->setWhitelistTransitiveDependencies($updateTransitiveDependencies);
-    }
+        if (!in_array($updateAllowTransitiveDependencies, array(Request::UPDATE_ONLY_LISTED, Request::UPDATE_LISTED_WITH_TRANSITIVE_DEPS_NO_ROOT_REQUIRE, Request::UPDATE_LISTED_WITH_TRANSITIVE_DEPS), true)) {
+            throw new \RuntimeException("Invalid value for updateAllowTransitiveDependencies supplied");
+        }
 
-    /**
-     * Should all dependencies of allowed packages be updated recursively?
-     *
-     * This will allow list any dependencies of the allow listed packages, including
-     * those defined in the root package.
-     *
-     * @deprecated use setAllowListAllDependencies instead
-     *
-     * @param  bool      $updateAllDependencies
-     * @return Installer
-     */
-    public function setWhitelistAllDependencies($updateAllDependencies = true)
-    {
-        $this->whitelistAllDependencies = (bool) $updateAllDependencies;
+        $this->updateAllowTransitiveDependencies = $updateAllowTransitiveDependencies;
 
         return $this;
     }
 
     /**
-     * Should all dependencies of allowed packages be updated recursively?
-     *
-     * This will allow list any dependencies of the allow listed packages, including
-     * those defined in the root package.
-     *
-     * @param  bool      $updateAllDependencies
-     * @return Installer
-     */
-    public function setAllowListAllDependencies($updateAllDependencies = true)
-    {
-        // call original method for BC
-        return $this->setWhitelistAllDependencies($updateAllDependencies);
-    }
-
-    /**
      * Should packages be preferred in a stable version when updating?
      *
      * @param  bool      $preferStable
@@ -1833,19 +1291,6 @@ class Installer
 
         return $this;
     }
-
-    /**
-     * Should suggestions be skipped?
-     *
-     * @param  bool      $skipSuggest
-     * @return Installer
-     */
-    public function setSkipSuggest($skipSuggest = true)
-    {
-        $this->skipSuggest = (bool) $skipSuggest;
-
-        return $this;
-    }
 
     /**
      * Disables plugins.
diff -pruN 1.10.19-1/src/Composer/IO/BaseIO.php 2.0.9-1/src/Composer/IO/BaseIO.php
--- 1.10.19-1/src/Composer/IO/BaseIO.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/IO/BaseIO.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,10 +14,9 @@ namespace Composer\IO;
 
 use Composer\Config;
 use Composer\Util\ProcessExecutor;
-use Psr\Log\LoggerInterface;
 use Psr\Log\LogLevel;
 
-abstract class BaseIO implements IOInterface, LoggerInterface
+abstract class BaseIO implements IOInterface
 {
     protected $authentications = array();
 
@@ -136,7 +135,9 @@ abstract class BaseIO implements IOInter
         }
 
         foreach ($gitlabToken as $domain => $token) {
-            $this->checkAndSetAuthentication($domain, $token, 'private-token');
+            $username = is_array($token) && array_key_exists("username", $token) ? $token["username"] : $token;
+            $password = is_array($token) && array_key_exists("token", $token) ? $token["token"] : 'private-token';
+            $this->checkAndSetAuthentication($domain, $username, $password);
         }
 
         // reload http basic credentials from config if available
@@ -270,9 +271,9 @@ abstract class BaseIO implements IOInter
     public function log($level, $message, array $context = array())
     {
         if (in_array($level, array(LogLevel::EMERGENCY, LogLevel::ALERT, LogLevel::CRITICAL, LogLevel::ERROR))) {
-            $this->writeError('<error>'.$message.'</error>', true, self::NORMAL);
+            $this->writeError('<error>'.$message.'</error>');
         } elseif ($level === LogLevel::WARNING) {
-            $this->writeError('<warning>'.$message.'</warning>', true, self::NORMAL);
+            $this->writeError('<warning>'.$message.'</warning>');
         } elseif ($level === LogLevel::NOTICE) {
             $this->writeError('<info>'.$message.'</info>', true, self::VERBOSE);
         } elseif ($level === LogLevel::INFO) {
diff -pruN 1.10.19-1/src/Composer/IO/BufferIO.php 2.0.9-1/src/Composer/IO/BufferIO.php
--- 1.10.19-1/src/Composer/IO/BufferIO.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/IO/BufferIO.php	2021-01-27 15:09:27.000000000 +0000
@@ -73,7 +73,7 @@ class BufferIO extends ConsoleIO
 
     private function createStream(array $inputs)
     {
-        $stream = fopen('php://memory', 'r+', false);
+        $stream = fopen('php://memory', 'r+');
 
         foreach ($inputs as $input) {
             fwrite($stream, $input.PHP_EOL);
diff -pruN 1.10.19-1/src/Composer/IO/ConsoleIO.php 2.0.9-1/src/Composer/IO/ConsoleIO.php
--- 1.10.19-1/src/Composer/IO/ConsoleIO.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/IO/ConsoleIO.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,6 +14,7 @@ namespace Composer\IO;
 
 use Composer\Question\StrictConfirmationQuestion;
 use Symfony\Component\Console\Helper\HelperSet;
+use Symfony\Component\Console\Helper\ProgressBar;
 use Symfony\Component\Console\Input\InputInterface;
 use Symfony\Component\Console\Output\ConsoleOutputInterface;
 use Symfony\Component\Console\Output\OutputInterface;
@@ -254,6 +255,15 @@ class ConsoleIO extends BaseIO
     }
 
     /**
+     * @param  int         $max
+     * @return ProgressBar
+     */
+    public function getProgressBar($max = 0)
+    {
+        return new ProgressBar($this->getErrorOutput(), $max);
+    }
+
+    /**
      * {@inheritDoc}
      */
     public function ask($question, $default = null)
diff -pruN 1.10.19-1/src/Composer/IO/IOInterface.php 2.0.9-1/src/Composer/IO/IOInterface.php
--- 1.10.19-1/src/Composer/IO/IOInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/IO/IOInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,13 +13,14 @@
 namespace Composer\IO;
 
 use Composer\Config;
+use Psr\Log\LoggerInterface;
 
 /**
  * The Input/Output helper interface.
  *
  * @author François Pluchino <francois.pluchino@opendisplay.com>
  */
-interface IOInterface
+interface IOInterface extends LoggerInterface
 {
     const QUIET = 1;
     const NORMAL = 2;
@@ -81,6 +82,24 @@ interface IOInterface
     public function writeError($messages, $newline = true, $verbosity = self::NORMAL);
 
     /**
+     * Writes a message to the output, without formatting it.
+     *
+     * @param string|array $messages  The message as an array of lines or a single string
+     * @param bool         $newline   Whether to add a newline or not
+     * @param int          $verbosity Verbosity level from the VERBOSITY_* constants
+     */
+    public function writeRaw($messages, $newline = true, $verbosity = self::NORMAL);
+
+    /**
+     * Writes a message to the error output, without formatting it.
+     *
+     * @param string|array $messages  The message as an array of lines or a single string
+     * @param bool         $newline   Whether to add a newline or not
+     * @param int          $verbosity Verbosity level from the VERBOSITY_* constants
+     */
+    public function writeErrorRaw($messages, $newline = true, $verbosity = self::NORMAL);
+
+    /**
      * Overwrites a previous message to the output.
      *
      * @param string|array $messages  The message as an array of lines or a single string
@@ -107,7 +126,7 @@ interface IOInterface
      * @param string $default  The default answer if none is given by the user
      *
      * @throws \RuntimeException If there is no data to read in the input stream
-     * @return string            The user answer
+     * @return string|null       The user answer
      */
     public function ask($question, $default = null);
 
@@ -145,7 +164,7 @@ interface IOInterface
      *
      * @param string $question The question to ask
      *
-     * @return string The answer
+     * @return string|null The answer
      */
     public function askAndHideAnswer($question);
 
@@ -160,7 +179,7 @@ interface IOInterface
      * @param bool        $multiselect  Select more than one value separated by comma
      *
      * @throws \InvalidArgumentException
-     * @return int|string|array          The selected value or values (the key of the choices array)
+     * @return int|string|array|bool     The selected value or values (the key of the choices array)
      */
     public function select($question, $choices, $default, $attempts = false, $errorMessage = 'Value "%s" is invalid', $multiselect = false);
 
diff -pruN 1.10.19-1/src/Composer/Json/JsonFile.php 2.0.9-1/src/Composer/Json/JsonFile.php
--- 1.10.19-1/src/Composer/Json/JsonFile.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Json/JsonFile.php	2021-01-27 15:09:27.000000000 +0000
@@ -15,7 +15,7 @@ namespace Composer\Json;
 use JsonSchema\Validator;
 use Seld\JsonLint\JsonParser;
 use Seld\JsonLint\ParsingException;
-use Composer\Util\RemoteFilesystem;
+use Composer\Util\HttpDownloader;
 use Composer\IO\IOInterface;
 use Composer\Downloader\TransportException;
 
@@ -37,25 +37,25 @@ class JsonFile
     const COMPOSER_SCHEMA_PATH = '/../../../res/composer-schema.json';
 
     private $path;
-    private $rfs;
+    private $httpDownloader;
     private $io;
 
     /**
      * Initializes json file reader/parser.
      *
-     * @param  string                    $path path to a lockfile
-     * @param  RemoteFilesystem          $rfs  required for loading http/https json files
+     * @param  string                    $path           path to a lockfile
+     * @param  HttpDownloader            $httpDownloader required for loading http/https json files
      * @param  IOInterface               $io
      * @throws \InvalidArgumentException
      */
-    public function __construct($path, RemoteFilesystem $rfs = null, IOInterface $io = null)
+    public function __construct($path, HttpDownloader $httpDownloader = null, IOInterface $io = null)
     {
         $this->path = $path;
 
-        if (null === $rfs && preg_match('{^https?://}i', $path)) {
-            throw new \InvalidArgumentException('http urls require a RemoteFilesystem instance to be passed');
+        if (null === $httpDownloader && preg_match('{^https?://}i', $path)) {
+            throw new \InvalidArgumentException('http urls require a HttpDownloader instance to be passed');
         }
-        $this->rfs = $rfs;
+        $this->httpDownloader = $httpDownloader;
         $this->io = $io;
     }
 
@@ -86,11 +86,16 @@ class JsonFile
     public function read()
     {
         try {
-            if ($this->rfs) {
-                $json = $this->rfs->getContents($this->path, $this->path, false);
+            if ($this->httpDownloader) {
+                $json = $this->httpDownloader->get($this->path)->getBody();
             } else {
                 if ($this->io && $this->io->isDebug()) {
-                    $this->io->writeError('Reading ' . $this->path);
+                    $realpathInfo = '';
+                    $realpath = realpath($this->path);
+                    if (false !== $realpath && $realpath !== $this->path) {
+                         $realpathInfo = ' (' . $realpath . ')';
+                    }
+                    $this->io->writeError('Reading ' . $this->path . $realpathInfo);
                 }
                 $json = file_get_contents($this->path);
             }
@@ -112,11 +117,17 @@ class JsonFile
      */
     public function write(array $hash, $options = 448)
     {
+        if ($this->path === 'php://memory') {
+            file_put_contents($this->path, static::encode($hash, $options));
+
+            return;
+        }
+
         $dir = dirname($this->path);
         if (!is_dir($dir)) {
             if (file_exists($dir)) {
                 throw new \UnexpectedValueException(
-                    $dir.' exists and is not a directory.'
+                    realpath($dir).' exists and is not a directory.'
                 );
             }
             if (!@mkdir($dir, 0777, true)) {
@@ -158,7 +169,7 @@ class JsonFile
     /**
      * Validates the schema of the current json file according to composer-schema.json rules
      *
-     * @param  int                     $schema a JsonFile::*_SCHEMA constant
+     * @param  int                     $schema     a JsonFile::*_SCHEMA constant
      * @param  string|null             $schemaFile a path to the schema file
      * @throws JsonValidationException
      * @return bool                    true on success
diff -pruN 1.10.19-1/src/Composer/Json/JsonFormatter.php 2.0.9-1/src/Composer/Json/JsonFormatter.php
--- 1.10.19-1/src/Composer/Json/JsonFormatter.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Json/JsonFormatter.php	2021-01-27 15:09:27.000000000 +0000
@@ -58,7 +58,8 @@ class JsonFormatter
                 $buffer .= $char;
                 $noescape = '\\' === $char ? !$noescape : true;
                 continue;
-            } elseif ('' !== $buffer) {
+            }
+            if ('' !== $buffer) {
                 if ($unescapeSlashes) {
                     $buffer = str_replace('\\/', '/', $buffer);
                 }
diff -pruN 1.10.19-1/src/Composer/Json/JsonManipulator.php 2.0.9-1/src/Composer/Json/JsonManipulator.php
--- 1.10.19-1/src/Composer/Json/JsonManipulator.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Json/JsonManipulator.php	2021-01-27 15:09:27.000000000 +0000
@@ -20,13 +20,13 @@ use Composer\Repository\PlatformReposito
 class JsonManipulator
 {
     private static $DEFINES = '(?(DEFINE)
-       (?<number>   -? (?= [1-9]|0(?!\d) ) \d+ (\.\d+)? ([eE] [+-]? \d+)? )
+       (?<number>    -? (?= [1-9]|0(?!\d) ) \d++ (\.\d++)? ([eE] [+-]?+ \d++)? )
        (?<boolean>   true | false | null )
-       (?<string>    " ([^"\\\\]* | \\\\ ["\\\\bfnrt\/] | \\\\ u [0-9A-Fa-f]{4} )* " )
-       (?<array>     \[  (?:  (?&json) \s* (?: , (?&json) \s* )*  )?  \s* \] )
-       (?<pair>      \s* (?&string) \s* : (?&json) \s* )
-       (?<object>    \{  (?:  (?&pair)  (?: , (?&pair)  )*  )?  \s* \} )
-       (?<json>   \s* (?: (?&number) | (?&boolean) | (?&string) | (?&array) | (?&object) ) )
+       (?<string>    " ([^"\\\\]*+ | \\\\ ["\\\\bfnrt\/] | \\\\ u [0-9A-Fa-f]{4} )* " )
+       (?<array>     \[  (?:  (?&json) \s*+ (?: , (?&json) \s*+ )*+  )?+  \s*+ \] )
+       (?<pair>      \s*+ (?&string) \s*+ : (?&json) \s*+ )
+       (?<object>    \{  (?:  (?&pair)  (?: , (?&pair)  )*+  )?+  \s*+ \} )
+       (?<json>      \s*+ (?: (?&number) | (?&boolean) | (?&string) | (?&array) | (?&object) ) )
     )';
 
     private $contents;
@@ -117,7 +117,7 @@ class JsonManipulator
     private function sortPackages(array &$packages = array())
     {
         $prefix = function ($requirement) {
-            if (preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $requirement)) {
+            if (PlatformRepository::isPlatformPackage($requirement)) {
                 return preg_replace(
                     array(
                         '/^php/',
@@ -145,9 +145,9 @@ class JsonManipulator
         });
     }
 
-    public function addRepository($name, $config)
+    public function addRepository($name, $config, $append = true)
     {
-        return $this->addSubNode('repositories', $name, $config);
+        return $this->addSubNode('repositories', $name, $config, $append);
     }
 
     public function removeRepository($name)
@@ -167,15 +167,15 @@ class JsonManipulator
 
     public function addProperty($name, $value)
     {
-        if (substr($name, 0, 8) === 'suggest.') {
+        if (strpos($name, 'suggest.') === 0) {
             return $this->addSubNode('suggest', substr($name, 8), $value);
         }
 
-        if (substr($name, 0, 6) === 'extra.') {
+        if (strpos($name, 'extra.') === 0) {
             return $this->addSubNode('extra', substr($name, 6), $value);
         }
 
-        if (substr($name, 0, 8) === 'scripts.') {
+        if (strpos($name, 'scripts.') === 0) {
             return $this->addSubNode('scripts', substr($name, 8), $value);
         }
 
@@ -184,22 +184,22 @@ class JsonManipulator
 
     public function removeProperty($name)
     {
-        if (substr($name, 0, 8) === 'suggest.') {
+        if (strpos($name, 'suggest.') === 0) {
             return $this->removeSubNode('suggest', substr($name, 8));
         }
 
-        if (substr($name, 0, 6) === 'extra.') {
+        if (strpos($name, 'extra.') === 0) {
             return $this->removeSubNode('extra', substr($name, 6));
         }
 
-        if (substr($name, 0, 8) === 'scripts.') {
+        if (strpos($name, 'scripts.') === 0) {
             return $this->removeSubNode('scripts', substr($name, 8));
         }
 
         return $this->removeMainKey($name);
     }
 
-    public function addSubNode($mainNode, $name, $value)
+    public function addSubNode($mainNode, $name, $value, $append = true)
     {
         $decoded = JsonFile::parseJson($this->contents);
 
@@ -258,7 +258,7 @@ class JsonManipulator
                 return $matches['start'] . $that->format($value, 1) . $matches['end'];
             }, $children);
         } else {
-            $this->pregMatch('#^{ \s*? (?P<content>\S+.*?)? (?P<trailingspace>\s*) }$#sx', $children, $match);
+            $this->pregMatch('#^{ (?P<leadingspace>\s*?) (?P<content>\S+.*?)? (?P<trailingspace>\s*) }$#sx', $children, $match);
 
             $whitespace = '';
             if (!empty($match['trailingspace'])) {
@@ -271,11 +271,24 @@ class JsonManipulator
                 }
 
                 // child missing but non empty children
-                $children = preg_replace(
-                    '#'.$whitespace.'}$#',
-                    addcslashes(',' . $this->newline . $this->indent . $this->indent . JsonFile::encode($name).': '.$this->format($value, 1) . $whitespace . '}', '\\$'),
-                    $children
-                );
+                if ($append) {
+                    $children = preg_replace(
+                        '#'.$whitespace.'}$#',
+                        addcslashes(',' . $this->newline . $this->indent . $this->indent . JsonFile::encode($name).': '.$this->format($value, 1) . $whitespace . '}', '\\$'),
+                        $children
+                    );
+                } else {
+                    $whitespace = '';
+                    if (!empty($match['leadingspace'])) {
+                        $whitespace = $match['leadingspace'];
+                    }
+
+                    $children = preg_replace(
+                        '#^{'.$whitespace.'#',
+                        addcslashes('{' . $whitespace . JsonFile::encode($name).': '.$this->format($value, 1) . ',' . $this->newline . $this->indent . $this->indent, '\\$'),
+                        $children
+                    );
+                }
             } else {
                 if ($subName !== null) {
                     $value = array($subName => $value);
@@ -356,6 +369,10 @@ class JsonManipulator
             $childrenClean = $children;
         }
 
+        if (!isset($childrenClean)) {
+            throw new \InvalidArgumentException("JsonManipulator: \$childrenClean is not defined. Please report at https://github.com/composer/composer/issues/new.");
+        }
+
         // no child data left, $name was the only key in
         $this->pregMatch('#^{ \s*? (?P<content>\S+.*?)? (?P<trailingspace>\s*) }$#sx', $childrenClean, $match);
         if (empty($match['content'])) {
@@ -381,7 +398,7 @@ class JsonManipulator
             if ($subName !== null) {
                 $curVal = json_decode($matches['content'], true);
                 unset($curVal[$name][$subName]);
-                $childrenClean = $that->format($curVal, 0);
+                $childrenClean = $that->format($curVal);
             }
 
             return $matches['start'] . $childrenClean . $matches['end'];
@@ -463,6 +480,21 @@ class JsonManipulator
         return false;
     }
 
+    public function removeMainKeyIfEmpty($key)
+    {
+        $decoded = JsonFile::parseJson($this->contents);
+
+        if (!array_key_exists($key, $decoded)) {
+            return true;
+        }
+
+        if (is_array($decoded[$key]) && count($decoded[$key]) === 0) {
+            return $this->removeMainKey($key);
+        }
+
+        return true;
+    }
+
     public function format($data, $depth = 0)
     {
         if (is_array($data)) {
diff -pruN 1.10.19-1/src/Composer/Package/AliasPackage.php 2.0.9-1/src/Composer/Package/AliasPackage.php
--- 1.10.19-1/src/Composer/Package/AliasPackage.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/AliasPackage.php	2021-01-27 15:09:27.000000000 +0000
@@ -25,6 +25,7 @@ class AliasPackage extends BasePackage i
     protected $dev;
     protected $rootPackageAlias = false;
     protected $stability;
+    protected $hasSelfVersionRequires = false;
 
     /** @var PackageInterface */
     protected $aliasOf;
@@ -56,7 +57,7 @@ class AliasPackage extends BasePackage i
         $this->stability = VersionParser::parseStability($version);
         $this->dev = $this->stability === 'dev';
 
-        foreach (array('requires', 'devRequires', 'conflicts', 'provides', 'replaces') as $type) {
+        foreach (Link::$TYPES as $type) {
             $links = $aliasOf->{'get' . ucfirst($type)}();
             $this->$type = $this->replaceSelfVersionDependencies($links, $type);
         }
@@ -173,19 +174,30 @@ class AliasPackage extends BasePackage i
      */
     protected function replaceSelfVersionDependencies(array $links, $linkType)
     {
-        if (in_array($linkType, array('conflicts', 'provides', 'replaces'), true)) {
+        // for self.version requirements, we use the original package's branch name instead, to avoid leaking the magic dev-master-alias to users
+        $prettyVersion = $this->prettyVersion;
+        if ($prettyVersion === VersionParser::DEFAULT_BRANCH_ALIAS) {
+            $prettyVersion = $this->aliasOf->getPrettyVersion();
+        }
+
+        if (\in_array($linkType, array(Link::TYPE_CONFLICT, Link::TYPE_PROVIDE, Link::TYPE_REPLACE), true)) {
             $newLinks = array();
             foreach ($links as $link) {
                 // link is self.version, but must be replacing also the replaced version
                 if ('self.version' === $link->getPrettyConstraint()) {
-                    $newLinks[] = new Link($link->getSource(), $link->getTarget(), new Constraint('=', $this->version), $linkType, $this->prettyVersion);
+                    $newLinks[] = new Link($link->getSource(), $link->getTarget(), $constraint = new Constraint('=', $this->version), $linkType, $prettyVersion);
+                    $constraint->setPrettyString($prettyVersion);
                 }
             }
             $links = array_merge($links, $newLinks);
         } else {
             foreach ($links as $index => $link) {
                 if ('self.version' === $link->getPrettyConstraint()) {
-                    $links[$index] = new Link($link->getSource(), $link->getTarget(), new Constraint('=', $this->version), $linkType, $this->prettyVersion);
+                    if ($linkType === Link::TYPE_REQUIRE) {
+                        $this->hasSelfVersionRequires = true;
+                    }
+                    $links[$index] = new Link($link->getSource(), $link->getTarget(), $constraint = new Constraint('=', $this->version), $linkType, $prettyVersion);
+                    $constraint->setPrettyString($prettyVersion);
                 }
             }
         }
@@ -193,6 +205,11 @@ class AliasPackage extends BasePackage i
         return $links;
     }
 
+    public function hasSelfVersionRequires()
+    {
+        return $this->hasSelfVersionRequires;
+    }
+
     /***************************************
      * Wrappers around the aliased package *
      ***************************************/
@@ -387,11 +404,21 @@ class AliasPackage extends BasePackage i
         return $this->aliasOf->getNotificationUrl();
     }
 
+    public function getArchiveName()
+    {
+        return $this->aliasOf->getArchiveName();
+    }
+
     public function getArchiveExcludes()
     {
         return $this->aliasOf->getArchiveExcludes();
     }
 
+    public function isDefaultBranch()
+    {
+        return $this->aliasOf->isDefaultBranch();
+    }
+
     public function isAbandoned()
     {
         return $this->aliasOf->isAbandoned();
@@ -404,7 +431,7 @@ class AliasPackage extends BasePackage i
 
     public function __toString()
     {
-        return parent::__toString().' (alias of '.$this->aliasOf->getVersion().')';
+        return parent::__toString().' ('.($this->rootPackageAlias ? 'root ' : ''). 'alias of '.$this->aliasOf->getVersion().')';
     }
 
     public function setDistUrl($url)
@@ -416,4 +443,9 @@ class AliasPackage extends BasePackage i
     {
         return $this->aliasOf->setDistType($type);
     }
+
+    public function setSourceDistReferences($reference)
+    {
+        return $this->aliasOf->setSourceDistReferences($reference);
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Package/Archiver/ArchiveManager.php 2.0.9-1/src/Composer/Package/Archiver/ArchiveManager.php
--- 1.10.19-1/src/Composer/Package/Archiver/ArchiveManager.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Archiver/ArchiveManager.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,6 +16,7 @@ use Composer\Downloader\DownloadManager;
 use Composer\Package\PackageInterface;
 use Composer\Package\RootPackageInterface;
 use Composer\Util\Filesystem;
+use Composer\Util\Loop;
 use Composer\Json\JsonFile;
 
 /**
@@ -24,8 +25,14 @@ use Composer\Json\JsonFile;
  */
 class ArchiveManager
 {
+    /** @var DownloadManager */
     protected $downloadManager;
+    /** @var Loop */
+    protected $loop;
 
+    /**
+     * @var ArchiverInterface[]
+     */
     protected $archivers = array();
 
     /**
@@ -36,9 +43,10 @@ class ArchiveManager
     /**
      * @param DownloadManager $downloadManager A manager used to download package sources
      */
-    public function __construct(DownloadManager $downloadManager)
+    public function __construct(DownloadManager $downloadManager, Loop $loop)
     {
         $this->downloadManager = $downloadManager;
+        $this->loop = $loop;
     }
 
     /**
@@ -72,7 +80,12 @@ class ArchiveManager
      */
     public function getPackageFilename(PackageInterface $package)
     {
-        $nameParts = array(preg_replace('#[^a-z0-9-_]#i', '-', $package->getName()));
+        if ($package->getArchiveName()) {
+            $baseName = $package->getArchiveName();
+        } else {
+            $baseName = preg_replace('#[^a-z0-9-_]#i', '-', $package->getName());
+        }
+        $nameParts = array($baseName);
 
         if (preg_match('{^[a-f0-9]{40}$}', $package->getDistReference())) {
             array_push($nameParts, $package->getDistReference(), $package->getDistType());
@@ -125,20 +138,6 @@ class ArchiveManager
         }
 
         $filesystem = new Filesystem();
-        if (null === $fileName) {
-            $packageName = $this->getPackageFilename($package);
-        } else {
-            $packageName = $fileName;
-        }
-
-        // Archive filename
-        $filesystem->ensureDirectoryExists($targetDir);
-        $target = realpath($targetDir).'/'.$packageName.'.'.$format;
-        $filesystem->ensureDirectoryExists(dirname($target));
-
-        if (!$this->overwriteFiles && file_exists($target)) {
-            return $target;
-        }
 
         if ($package instanceof RootPackageInterface) {
             $sourcePath = realpath('.');
@@ -149,7 +148,9 @@ class ArchiveManager
 
             try {
                 // Download sources
-                $this->downloadManager->download($package, $sourcePath);
+                $promise = $this->downloadManager->download($package, $sourcePath);
+                $this->loop->wait(array($promise));
+                $this->downloadManager->install($package, $sourcePath);
             } catch (\Exception $e) {
                 $filesystem->removeDirectory($sourcePath);
                 throw  $e;
@@ -159,12 +160,30 @@ class ArchiveManager
             if (file_exists($composerJsonPath = $sourcePath.'/composer.json')) {
                 $jsonFile = new JsonFile($composerJsonPath);
                 $jsonData = $jsonFile->read();
+                if (!empty($jsonData['archive']['name'])) {
+                    $package->setArchiveName($jsonData['archive']['name']);
+                }
                 if (!empty($jsonData['archive']['exclude'])) {
                     $package->setArchiveExcludes($jsonData['archive']['exclude']);
                 }
             }
         }
 
+        if (null === $fileName) {
+            $packageName = $this->getPackageFilename($package);
+        } else {
+            $packageName = $fileName;
+        }
+
+        // Archive filename
+        $filesystem->ensureDirectoryExists($targetDir);
+        $target = realpath($targetDir).'/'.$packageName.'.'.$format;
+        $filesystem->ensureDirectoryExists(dirname($target));
+
+        if (!$this->overwriteFiles && file_exists($target)) {
+            return $target;
+        }
+
         // Create the archive
         $tempTarget = sys_get_temp_dir().'/composer_archive'.uniqid().'.'.$format;
         $filesystem->ensureDirectoryExists(dirname($tempTarget));
diff -pruN 1.10.19-1/src/Composer/Package/Archiver/BaseExcludeFilter.php 2.0.9-1/src/Composer/Package/Archiver/BaseExcludeFilter.php
--- 1.10.19-1/src/Composer/Package/Archiver/BaseExcludeFilter.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Archiver/BaseExcludeFilter.php	2021-01-27 15:09:27.000000000 +0000
@@ -123,26 +123,25 @@ abstract class BaseExcludeFilter
     protected function generatePattern($rule)
     {
         $negate = false;
-        $pattern = '{';
+        $pattern = '';
 
-        if (strlen($rule) && $rule[0] === '!') {
+        if ($rule !== '' && $rule[0] === '!') {
             $negate = true;
-            $rule = substr($rule, 1);
+            $rule = ltrim($rule, '!');
         }
 
-        if (strlen($rule) && $rule[0] === '/') {
-            $pattern .= '^/';
-            $rule = substr($rule, 1);
-        } elseif (strlen($rule) - 1 === strpos($rule, '/')) {
-            $pattern .= '/';
-            $rule = substr($rule, 0, -1);
-        } elseif (false === strpos($rule, '/')) {
-            $pattern .= '/';
+        $firstSlashPosition = strpos($rule, '/');
+        if (0 === $firstSlashPosition) {
+            $pattern = '^/';
+        } elseif (false === $firstSlashPosition || strlen($rule) - 1 === $firstSlashPosition) {
+            $pattern = '/';
         }
 
+        $rule = trim($rule, '/');
+        
         // remove delimiters as well as caret (^) and dollar sign ($) from the regex
-        $pattern .= substr(Finder\Glob::toRegex($rule), 2, -2) . '(?=$|/)';
+        $rule = substr(Finder\Glob::toRegex($rule), 2, -2);
 
-        return array($pattern . '}', $negate, false);
+        return array('{'.$pattern.$rule.'(?=$|/)}', $negate, false);
     }
 }
diff -pruN 1.10.19-1/src/Composer/Package/Archiver/ZipArchiver.php 2.0.9-1/src/Composer/Package/Archiver/ZipArchiver.php
--- 1.10.19-1/src/Composer/Package/Archiver/ZipArchiver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Archiver/ZipArchiver.php	2021-01-27 15:09:27.000000000 +0000
@@ -39,7 +39,10 @@ class ZipArchiver implements ArchiverInt
             foreach ($files as $file) {
                 /** @var \SplFileInfo $file */
                 $filepath = strtr($file->getPath()."/".$file->getFilename(), '\\', '/');
-                $localname = str_replace($sources.'/', '', $filepath);
+                $localname = $filepath;
+                if (strpos($localname, $sources . '/') === 0) {
+                    $localname = substr($localname, strlen($sources . '/'));
+                }
                 if ($file->isDir()) {
                     $zip->addEmptyDir($localname);
                 } else {
diff -pruN 1.10.19-1/src/Composer/Package/BasePackage.php 2.0.9-1/src/Composer/Package/BasePackage.php
--- 1.10.19-1/src/Composer/Package/BasePackage.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/BasePackage.php	2021-01-27 15:09:27.000000000 +0000
@@ -22,12 +22,15 @@ use Composer\Repository\PlatformReposito
  */
 abstract class BasePackage implements PackageInterface
 {
+    /**
+     * @phpstan-var array<string, array{description: string, method: Link::TYPE_*}>
+     */
     public static $supportedLinkTypes = array(
-        'require' => array('description' => 'requires', 'method' => 'requires'),
-        'conflict' => array('description' => 'conflicts', 'method' => 'conflicts'),
-        'provide' => array('description' => 'provides', 'method' => 'provides'),
-        'replace' => array('description' => 'replaces', 'method' => 'replaces'),
-        'require-dev' => array('description' => 'requires (for development)', 'method' => 'devRequires'),
+        'require' => array('description' => 'requires', 'method' => Link::TYPE_REQUIRE),
+        'conflict' => array('description' => 'conflicts', 'method' => Link::TYPE_CONFLICT),
+        'provide' => array('description' => 'provides', 'method' => Link::TYPE_PROVIDE),
+        'replace' => array('description' => 'replaces', 'method' => Link::TYPE_REPLACE),
+        'require-dev' => array('description' => 'requires (for development)', 'method' => Link::TYPE_DEV_REQUIRE),
     );
 
     const STABILITY_STABLE = 0;
@@ -89,14 +92,16 @@ abstract class BasePackage implements Pa
     /**
      * {@inheritDoc}
      */
-    public function getNames()
+    public function getNames($provides = true)
     {
         $names = array(
             $this->getName() => true,
         );
 
-        foreach ($this->getProvides() as $link) {
-            $names[$link->getTarget()] = true;
+        if ($provides) {
+            foreach ($this->getProvides() as $link) {
+                $names[$link->getTarget()] = true;
+            }
         }
 
         foreach ($this->getReplaces() as $link) {
@@ -210,18 +215,32 @@ abstract class BasePackage implements Pa
     /**
      * {@inheritDoc}
      */
-    public function getFullPrettyVersion($truncate = true)
+    public function getFullPrettyVersion($truncate = true, $displayMode = PackageInterface::DISPLAY_SOURCE_REF_IF_DEV)
     {
-        if (!$this->isDev() || !in_array($this->getSourceType(), array('hg', 'git'))) {
+        if ($displayMode === PackageInterface::DISPLAY_SOURCE_REF_IF_DEV &&
+            (!$this->isDev() || !\in_array($this->getSourceType(), array('hg', 'git')))
+        ) {
             return $this->getPrettyVersion();
         }
 
+        switch ($displayMode) {
+            case PackageInterface::DISPLAY_SOURCE_REF_IF_DEV:
+            case PackageInterface::DISPLAY_SOURCE_REF:
+                $reference = $this->getSourceReference();
+                break;
+            case PackageInterface::DISPLAY_DIST_REF:
+                $reference = $this->getDistReference();
+                break;
+            default:
+                throw new \UnexpectedValueException('Display mode '.$displayMode.' is not supported');
+        }
+
         // if source reference is a sha1 hash -- truncate
-        if ($truncate && strlen($this->getSourceReference()) === 40) {
-            return $this->getPrettyVersion() . ' ' . substr($this->getSourceReference(), 0, 7);
+        if ($truncate && \strlen($reference) === 40 && $this->getSourceType() !== 'svn') {
+            return $this->getPrettyVersion() . ' ' . substr($reference, 0, 7);
         }
 
-        return $this->getPrettyVersion() . ' ' . $this->getSourceReference();
+        return $this->getPrettyVersion() . ' ' . $reference;
     }
 
     public function getStabilityPriority()
@@ -238,14 +257,14 @@ abstract class BasePackage implements Pa
     /**
      * Build a regexp from a package name, expanding * globs as required
      *
-     * @param  string $allowListPattern
-     * @param  string $wrap Wrap the cleaned string by the given string
+     * @param  string $allowPattern
+     * @param  string $wrap         Wrap the cleaned string by the given string
      * @return string
      */
-    public static function packageNameToRegexp($allowListPattern, $wrap = '{^%s$}i')
+    public static function packageNameToRegexp($allowPattern, $wrap = '{^%s$}i')
     {
-        $cleanedAllowListPattern = str_replace('\\*', '.*', preg_quote($allowListPattern));
+        $cleanedAllowPattern = str_replace('\\*', '.*', preg_quote($allowPattern));
 
-        return sprintf($wrap, $cleanedAllowListPattern);
+        return sprintf($wrap, $cleanedAllowPattern);
     }
 }
diff -pruN 1.10.19-1/src/Composer/Package/Comparer/Comparer.php 2.0.9-1/src/Composer/Package/Comparer/Comparer.php
--- 1.10.19-1/src/Composer/Package/Comparer/Comparer.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Comparer/Comparer.php	2021-01-27 15:09:27.000000000 +0000
@@ -112,7 +112,6 @@ class Comparer
                             return false;
                         }
                     } elseif (is_file($dir.'/'.$file) && filesize($dir.'/'.$file)) {
-                        set_time_limit(30);
                         $array[$dir][$file] = md5_file($dir.'/'.$file);
                     }
                 }
diff -pruN 1.10.19-1/src/Composer/Package/CompletePackageInterface.php 2.0.9-1/src/Composer/Package/CompletePackageInterface.php
--- 1.10.19-1/src/Composer/Package/CompletePackageInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/CompletePackageInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -22,30 +22,30 @@ interface CompletePackageInterface exten
     /**
      * Returns the scripts of this package
      *
-     * @return array array('script name' => array('listeners'))
+     * @return array[] array('script name' => array('listeners'))
+     * @psalm-return array<string, string[]>
      */
     public function getScripts();
 
     /**
      * Returns an array of repositories
      *
-     * {"<type>": {<config key/values>}}
-     *
-     * @return array Repositories
+     * @return array[] Repositories
+     * @psalm-return array<array{type: string, url?: string}>
      */
     public function getRepositories();
 
     /**
      * Returns the package license, e.g. MIT, BSD, GPL
      *
-     * @return array The package licenses
+     * @return string[] The package licenses
      */
     public function getLicense();
 
     /**
      * Returns an array of keywords relating to the package
      *
-     * @return array
+     * @return string[]
      */
     public function getKeywords();
 
@@ -68,7 +68,8 @@ interface CompletePackageInterface exten
      *
      * Each item can contain name/homepage/email keys
      *
-     * @return array
+     * @return array[]
+     * @psalm-return array<array{?name: string, homepage?: string, email?: string, role?: string}>
      */
     public function getAuthors();
 
@@ -76,6 +77,7 @@ interface CompletePackageInterface exten
      * Returns the support information
      *
      * @return array
+     * @psalm-return array<string, string>
      */
     public function getSupport();
 
@@ -84,7 +86,8 @@ interface CompletePackageInterface exten
      *
      * Each item will contain type and url keys
      *
-     * @return array
+     * @return array[]
+     * @psalm-return array<array{type: string, url: string}>
      */
     public function getFunding();
 
diff -pruN 1.10.19-1/src/Composer/Package/CompletePackage.php 2.0.9-1/src/Composer/Package/CompletePackage.php
--- 1.10.19-1/src/Composer/Package/CompletePackage.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/CompletePackage.php	2021-01-27 15:09:27.000000000 +0000
@@ -213,6 +213,6 @@ class CompletePackage extends Package im
      */
     public function getReplacementPackage()
     {
-        return is_string($this->abandoned) ? $this->abandoned : null;
+        return \is_string($this->abandoned) ? $this->abandoned : null;
     }
 }
diff -pruN 1.10.19-1/src/Composer/Package/Dumper/ArrayDumper.php 2.0.9-1/src/Composer/Package/Dumper/ArrayDumper.php
--- 1.10.19-1/src/Composer/Package/Dumper/ArrayDumper.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Dumper/ArrayDumper.php	2021-01-27 15:09:27.000000000 +0000
@@ -70,6 +70,9 @@ class ArrayDumper
             }
         }
 
+        if ($package->getArchiveName()) {
+            $data['archive']['name'] = $package->getArchiveName();
+        }
         if ($package->getArchiveExcludes()) {
             $data['archive']['exclude'] = $package->getArchiveExcludes();
         }
@@ -92,6 +95,10 @@ class ArrayDumper
             $data['time'] = $package->getReleaseDate()->format(DATE_RFC3339);
         }
 
+        if ($package->isDefaultBranch()) {
+            $data['default-branch'] = true;
+        }
+
         $data = $this->dumpValues($package, $keys, $data);
 
         if ($package instanceof CompletePackageInterface) {
@@ -109,7 +116,7 @@ class ArrayDumper
 
             $data = $this->dumpValues($package, $keys, $data);
 
-            if (isset($data['keywords']) && is_array($data['keywords'])) {
+            if (isset($data['keywords']) && \is_array($data['keywords'])) {
                 sort($data['keywords']);
             }
 
@@ -125,7 +132,7 @@ class ArrayDumper
             }
         }
 
-        if (count($package->getTransportOptions()) > 0) {
+        if (\count($package->getTransportOptions()) > 0) {
             $data['transport-options'] = $package->getTransportOptions();
         }
 
@@ -142,7 +149,7 @@ class ArrayDumper
             $getter = 'get'.ucfirst($method);
             $value = $package->$getter();
 
-            if (null !== $value && !(is_array($value) && 0 === count($value))) {
+            if (null !== $value && !(\is_array($value) && 0 === \count($value))) {
                 $data[$key] = $value;
             }
         }
diff -pruN 1.10.19-1/src/Composer/Package/LinkConstraint/EmptyConstraint.php 2.0.9-1/src/Composer/Package/LinkConstraint/EmptyConstraint.php
--- 1.10.19-1/src/Composer/Package/LinkConstraint/EmptyConstraint.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/LinkConstraint/EmptyConstraint.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,24 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Package\LinkConstraint;
-
-use Composer\Semver\Constraint\EmptyConstraint as SemverEmptyConstraint;
-
-trigger_error('The ' . __NAMESPACE__ . '\EmptyConstraint class is deprecated, use Composer\Semver\Constraint\EmptyConstraint instead.', E_USER_DEPRECATED);
-
-/**
- * @deprecated use Composer\Semver\Constraint\EmptyConstraint instead
- */
-class EmptyConstraint extends SemverEmptyConstraint implements LinkConstraintInterface
-{
-}
diff -pruN 1.10.19-1/src/Composer/Package/LinkConstraint/LinkConstraintInterface.php 2.0.9-1/src/Composer/Package/LinkConstraint/LinkConstraintInterface.php
--- 1.10.19-1/src/Composer/Package/LinkConstraint/LinkConstraintInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/LinkConstraint/LinkConstraintInterface.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,24 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Package\LinkConstraint;
-
-use Composer\Semver\Constraint\ConstraintInterface;
-
-trigger_error('The ' . __NAMESPACE__ . '\LinkConstraintInterface interface is deprecated, use Composer\Semver\Constraint\ConstraintInterface instead.', E_USER_DEPRECATED);
-
-/**
- * @deprecated use Composer\Semver\Constraint\ConstraintInterface instead
- */
-interface LinkConstraintInterface extends ConstraintInterface
-{
-}
diff -pruN 1.10.19-1/src/Composer/Package/LinkConstraint/MultiConstraint.php 2.0.9-1/src/Composer/Package/LinkConstraint/MultiConstraint.php
--- 1.10.19-1/src/Composer/Package/LinkConstraint/MultiConstraint.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/LinkConstraint/MultiConstraint.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,24 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Package\LinkConstraint;
-
-use Composer\Semver\Constraint\MultiConstraint as SemverMultiConstraint;
-
-trigger_error('The ' . __NAMESPACE__ . '\MultiConstraint class is deprecated, use Composer\Semver\Constraint\MultiConstraint instead.', E_USER_DEPRECATED);
-
-/**
- * @deprecated use Composer\Semver\Constraint\MultiConstraint instead
- */
-class MultiConstraint extends SemverMultiConstraint implements LinkConstraintInterface
-{
-}
diff -pruN 1.10.19-1/src/Composer/Package/LinkConstraint/SpecificConstraint.php 2.0.9-1/src/Composer/Package/LinkConstraint/SpecificConstraint.php
--- 1.10.19-1/src/Composer/Package/LinkConstraint/SpecificConstraint.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/LinkConstraint/SpecificConstraint.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,24 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Package\LinkConstraint;
-
-use Composer\Semver\Constraint\AbstractConstraint;
-
-trigger_error('The ' . __NAMESPACE__ . '\SpecificConstraint abstract class is deprecated, there is no replacement for it.', E_USER_DEPRECATED);
-
-/**
- * @deprecated use Composer\Semver\Constraint\AbstractConstraint instead
- */
-abstract class SpecificConstraint extends AbstractConstraint implements LinkConstraintInterface
-{
-}
diff -pruN 1.10.19-1/src/Composer/Package/LinkConstraint/VersionConstraint.php 2.0.9-1/src/Composer/Package/LinkConstraint/VersionConstraint.php
--- 1.10.19-1/src/Composer/Package/LinkConstraint/VersionConstraint.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/LinkConstraint/VersionConstraint.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,24 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Package\LinkConstraint;
-
-use Composer\Semver\Constraint\Constraint;
-
-trigger_error('The ' . __NAMESPACE__ . '\VersionConstraint class is deprecated, use Composer\Semver\Constraint\Constraint instead.', E_USER_DEPRECATED);
-
-/**
- * @deprecated use Composer\Semver\Constraint\Constraint instead
- */
-class VersionConstraint extends Constraint implements LinkConstraintInterface
-{
-}
diff -pruN 1.10.19-1/src/Composer/Package/Link.php 2.0.9-1/src/Composer/Package/Link.php
--- 1.10.19-1/src/Composer/Package/Link.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Link.php	2021-01-27 15:09:27.000000000 +0000
@@ -21,6 +21,26 @@ use Composer\Semver\Constraint\Constrain
  */
 class Link
 {
+    const TYPE_REQUIRE = 'requires';
+    const TYPE_DEV_REQUIRE = 'devRequires';
+    const TYPE_PROVIDE = 'provides';
+    const TYPE_CONFLICT = 'conflicts';
+    const TYPE_REPLACE = 'replaces';
+
+    /**
+     * Will be converted into a constant once the min PHP version allows this
+     *
+     * @internal
+     * @var string[]
+     */
+    public static $TYPES = array(
+        self::TYPE_REQUIRE,
+        self::TYPE_DEV_REQUIRE,
+        self::TYPE_PROVIDE,
+        self::TYPE_CONFLICT,
+        self::TYPE_REPLACE,
+    );
+
     /**
      * @var string
      */
@@ -32,12 +52,13 @@ class Link
     protected $target;
 
     /**
-     * @var ConstraintInterface|null
+     * @var ConstraintInterface
      */
     protected $constraint;
 
     /**
      * @var string
+     * @phpstan-var self::TYPE_* $description
      */
     protected $description;
 
@@ -49,14 +70,20 @@ class Link
     /**
      * Creates a new package link.
      *
-     * @param string                   $source
-     * @param string                   $target
-     * @param ConstraintInterface|null $constraint       Constraint applying to the target of this link
-     * @param string                   $description      Used to create a descriptive string representation
-     * @param string|null              $prettyConstraint
-     */
-    public function __construct($source, $target, ConstraintInterface $constraint = null, $description = 'relates to', $prettyConstraint = null)
-    {
+     * @param string              $source
+     * @param string              $target
+     * @param ConstraintInterface $constraint  Constraint applying to the target of this link
+     * @param string              $description Used to create a descriptive string representation
+     * @phpstan-param self::TYPE_* $description
+     * @param string|null $prettyConstraint
+     */
+    public function __construct(
+        $source,
+        $target,
+        ConstraintInterface $constraint,
+        $description = 'relates to',
+        $prettyConstraint = null
+    ) {
         $this->source = strtolower($source);
         $this->target = strtolower($target);
         $this->constraint = $constraint;
@@ -89,7 +116,7 @@ class Link
     }
 
     /**
-     * @return ConstraintInterface|null
+     * @return ConstraintInterface
      */
     public function getConstraint()
     {
@@ -123,6 +150,6 @@ class Link
      */
     public function getPrettyString(PackageInterface $sourcePackage)
     {
-        return $sourcePackage->getPrettyString().' '.$this->description.' '.$this->target.' '.$this->constraint->getPrettyString().'';
+        return $sourcePackage->getPrettyString().' '.$this->description.' '.$this->target.($this->constraint ? ' '.$this->constraint->getPrettyString() : '');
     }
 }
diff -pruN 1.10.19-1/src/Composer/Package/Loader/ArrayLoader.php 2.0.9-1/src/Composer/Package/Loader/ArrayLoader.php
--- 1.10.19-1/src/Composer/Package/Loader/ArrayLoader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Loader/ArrayLoader.php	2021-01-27 15:09:27.000000000 +0000
@@ -18,7 +18,6 @@ use Composer\Package\Link;
 use Composer\Package\RootAliasPackage;
 use Composer\Package\RootPackageInterface;
 use Composer\Package\Version\VersionParser;
-use Composer\Semver\VersionParser as SemverVersionParser;
 
 /**
  * @author Konstantin Kudryashiv <ever.zet@gmail.com>
@@ -29,7 +28,7 @@ class ArrayLoader implements LoaderInter
     protected $versionParser;
     protected $loadOptions;
 
-    public function __construct(SemverVersionParser $parser = null, $loadOptions = false)
+    public function __construct(VersionParser $parser = null, $loadOptions = false)
     {
         if (!$parser) {
             $parser = new VersionParser;
@@ -40,6 +39,46 @@ class ArrayLoader implements LoaderInter
 
     public function load(array $config, $class = 'Composer\Package\CompletePackage')
     {
+        $package = $this->createObject($config, $class);
+
+        foreach (Package\BasePackage::$supportedLinkTypes as $type => $opts) {
+            if (isset($config[$type])) {
+                $method = 'set'.ucfirst($opts['method']);
+                $package->{$method}(
+                    $this->parseLinks(
+                        $package->getName(),
+                        $package->getPrettyVersion(),
+                        $opts['description'],
+                        $config[$type]
+                    )
+                );
+            }
+        }
+
+        $package = $this->configureObject($package, $config);
+
+        return $package;
+    }
+
+    public function loadPackages(array $versions, $class)
+    {
+        $packages = array();
+        $linkCache = array();
+
+        foreach ($versions as $version) {
+            $package = $this->createObject($version, $class);
+
+            $this->configureCachedLinks($linkCache, $package, $version);
+            $package = $this->configureObject($package, $version);
+
+            $packages[] = $package;
+        }
+
+        return $packages;
+    }
+
+    private function createObject(array $config, $class)
+    {
         if (!isset($config['name'])) {
             throw new \UnexpectedValueException('Unknown package has no name defined ('.json_encode($config).').');
         }
@@ -50,17 +89,27 @@ class ArrayLoader implements LoaderInter
         // handle already normalized versions
         if (isset($config['version_normalized'])) {
             $version = $config['version_normalized'];
+
+            // handling of existing repos which need to remain composer v1 compatible, in case the version_normalized contained VersionParser::DEFAULT_BRANCH_ALIAS, we renormalize it
+            if ($version === VersionParser::DEFAULT_BRANCH_ALIAS) {
+                $version = $this->versionParser->normalize($config['version']);
+            }
         } else {
             $version = $this->versionParser->normalize($config['version']);
         }
-        $package = new $class($config['name'], $version, $config['version']);
+
+        return new $class($config['name'], $version, $config['version']);
+    }
+
+    private function configureObject($package, array $config)
+    {
         $package->setType(isset($config['type']) ? strtolower($config['type']) : 'library');
 
         if (isset($config['target-dir'])) {
             $package->setTargetDir($config['target-dir']);
         }
 
-        if (isset($config['extra']) && is_array($config['extra'])) {
+        if (isset($config['extra']) && \is_array($config['extra'])) {
             $package->setExtra($config['extra']);
         }
 
@@ -78,8 +127,12 @@ class ArrayLoader implements LoaderInter
             $package->setInstallationSource($config['installation-source']);
         }
 
+        if (isset($config['default-branch']) && $config['default-branch'] === true) {
+            $package->setIsDefaultBranch(true);
+        }
+
         if (isset($config['source'])) {
-            if (!isset($config['source']['type']) || !isset($config['source']['url']) || !isset($config['source']['reference'])) {
+            if (!isset($config['source']['type'], $config['source']['url'], $config['source']['reference'])) {
                 throw new \UnexpectedValueException(sprintf(
                     "Package %s's source key should be specified as {\"type\": ..., \"url\": ..., \"reference\": ...},\n%s given.",
                     $config['name'],
@@ -95,8 +148,7 @@ class ArrayLoader implements LoaderInter
         }
 
         if (isset($config['dist'])) {
-            if (!isset($config['dist']['type'])
-             || !isset($config['dist']['url'])) {
+            if (!isset($config['dist']['type'], $config['dist']['url'])) {
                 throw new \UnexpectedValueException(sprintf(
                     "Package %s's dist key should be specified as ".
                     "{\"type\": ..., \"url\": ..., \"reference\": ..., \"shasum\": ...},\n%s given.",
@@ -113,21 +165,7 @@ class ArrayLoader implements LoaderInter
             }
         }
 
-        foreach (Package\BasePackage::$supportedLinkTypes as $type => $opts) {
-            if (isset($config[$type])) {
-                $method = 'set'.ucfirst($opts['method']);
-                $package->{$method}(
-                    $this->parseLinks(
-                        $package->getName(),
-                        $package->getPrettyVersion(),
-                        $opts['description'],
-                        $config[$type]
-                    )
-                );
-            }
-        }
-
-        if (isset($config['suggest']) && is_array($config['suggest'])) {
+        if (isset($config['suggest']) && \is_array($config['suggest'])) {
             foreach ($config['suggest'] as $target => $reason) {
                 if ('self.version' === trim($reason)) {
                     $config['suggest'][$target] = $package->getPrettyVersion();
@@ -162,12 +200,15 @@ class ArrayLoader implements LoaderInter
             $package->setNotificationUrl($config['notification-url']);
         }
 
+        if (!empty($config['archive']['name'])) {
+            $package->setArchiveName($config['archive']['name']);
+        }
         if (!empty($config['archive']['exclude'])) {
             $package->setArchiveExcludes($config['archive']['exclude']);
         }
 
         if ($package instanceof Package\CompletePackageInterface) {
-            if (isset($config['scripts']) && is_array($config['scripts'])) {
+            if (isset($config['scripts']) && \is_array($config['scripts'])) {
                 foreach ($config['scripts'] as $event => $listeners) {
                     $config['scripts'][$event] = (array) $listeners;
                 }
@@ -177,23 +218,23 @@ class ArrayLoader implements LoaderInter
                 $package->setScripts($config['scripts']);
             }
 
-            if (!empty($config['description']) && is_string($config['description'])) {
+            if (!empty($config['description']) && \is_string($config['description'])) {
                 $package->setDescription($config['description']);
             }
 
-            if (!empty($config['homepage']) && is_string($config['homepage'])) {
+            if (!empty($config['homepage']) && \is_string($config['homepage'])) {
                 $package->setHomepage($config['homepage']);
             }
 
-            if (!empty($config['keywords']) && is_array($config['keywords'])) {
+            if (!empty($config['keywords']) && \is_array($config['keywords'])) {
                 $package->setKeywords($config['keywords']);
             }
 
             if (!empty($config['license'])) {
-                $package->setLicense(is_array($config['license']) ? $config['license'] : array($config['license']));
+                $package->setLicense(\is_array($config['license']) ? $config['license'] : array($config['license']));
             }
 
-            if (!empty($config['authors']) && is_array($config['authors'])) {
+            if (!empty($config['authors']) && \is_array($config['authors'])) {
                 $package->setAuthors($config['authors']);
             }
 
@@ -201,7 +242,7 @@ class ArrayLoader implements LoaderInter
                 $package->setSupport($config['support']);
             }
 
-            if (!empty($config['funding']) && is_array($config['funding'])) {
+            if (!empty($config['funding']) && \is_array($config['funding'])) {
                 $package->setFunding($config['funding']);
             }
 
@@ -210,47 +251,84 @@ class ArrayLoader implements LoaderInter
             }
         }
 
+        if ($this->loadOptions && isset($config['transport-options'])) {
+            $package->setTransportOptions($config['transport-options']);
+        }
+
         if ($aliasNormalized = $this->getBranchAlias($config)) {
+            $prettyAlias = preg_replace('{(\.9{7})+}', '.x', $aliasNormalized);
+
             if ($package instanceof RootPackageInterface) {
-                $package = new RootAliasPackage($package, $aliasNormalized, preg_replace('{(\.9{7})+}', '.x', $aliasNormalized));
-            } else {
-                $package = new AliasPackage($package, $aliasNormalized, preg_replace('{(\.9{7})+}', '.x', $aliasNormalized));
+                return new RootAliasPackage($package, $aliasNormalized, $prettyAlias);
             }
-        }
 
-        if ($this->loadOptions && isset($config['transport-options'])) {
-            $package->setTransportOptions($config['transport-options']);
+            return new AliasPackage($package, $aliasNormalized, $prettyAlias);
         }
 
         return $package;
     }
 
+    private function configureCachedLinks(&$linkCache, $package, array $config)
+    {
+        $name = $package->getName();
+        $prettyVersion = $package->getPrettyVersion();
+
+        foreach (Package\BasePackage::$supportedLinkTypes as $type => $opts) {
+            if (isset($config[$type])) {
+                $method = 'set'.ucfirst($opts['method']);
+
+                $links = array();
+                foreach ($config[$type] as $prettyTarget => $constraint) {
+                    $target = strtolower($prettyTarget);
+                    if ($constraint === 'self.version') {
+                        $links[$target] = $this->createLink($name, $prettyVersion, $opts['description'], $target, $constraint);
+                    } else {
+                        if (!isset($linkCache[$name][$type][$target][$constraint])) {
+                            $linkCache[$name][$type][$target][$constraint] = array($target, $this->createLink($name, $prettyVersion, $opts['description'], $target, $constraint));
+                        }
+
+                        list($target, $link) = $linkCache[$name][$type][$target][$constraint];
+                        $links[$target] = $link;
+                    }
+                }
+
+                $package->{$method}($links);
+            }
+        }
+    }
+
     /**
-     * @param  string $source        source package name
-     * @param  string $sourceVersion source package version (pretty version ideally)
-     * @param  string $description   link description (e.g. requires, replaces, ..)
-     * @param  array  $links         array of package name => constraint mappings
+     * @param string $source        source package name
+     * @param string $sourceVersion source package version (pretty version ideally)
+     * @param string $description   link description (e.g. requires, replaces, ..)
+     * @phpstan-param Link::TYPE_* $description
+     * @param  array  $links array of package name => constraint mappings
      * @return Link[]
      */
     public function parseLinks($source, $sourceVersion, $description, $links)
     {
         $res = array();
         foreach ($links as $target => $constraint) {
-            if (!is_string($constraint)) {
-                throw new \UnexpectedValueException('Link constraint in '.$source.' '.$description.' > '.$target.' should be a string, got '.gettype($constraint) . ' (' . var_export($constraint, true) . ')');
-            }
-            if ('self.version' === $constraint) {
-                $parsedConstraint = $this->versionParser->parseConstraints($sourceVersion);
-            } else {
-                $parsedConstraint = $this->versionParser->parseConstraints($constraint);
-            }
-
-            $res[strtolower($target)] = new Link($source, $target, $parsedConstraint, $description, $constraint);
+            $res[strtolower($target)] = $this->createLink($source, $sourceVersion, $description, $target, $constraint);
         }
 
         return $res;
     }
 
+    private function createLink($source, $sourceVersion, $description, $target, $prettyConstraint)
+    {
+        if (!\is_string($prettyConstraint)) {
+            throw new \UnexpectedValueException('Link constraint in '.$source.' '.$description.' > '.$target.' should be a string, got '.\gettype($prettyConstraint) . ' (' . var_export($prettyConstraint, true) . ')');
+        }
+        if ('self.version' === $prettyConstraint) {
+            $parsedConstraint = $this->versionParser->parseConstraints($sourceVersion);
+        } else {
+            $parsedConstraint = $this->versionParser->parseConstraints($prettyConstraint);
+        }
+
+        return new Link($source, $target, $parsedConstraint, $description, $prettyConstraint);
+    }
+
     /**
      * Retrieves a branch alias (dev-master => 1.0.x-dev for example) if it exists
      *
@@ -259,39 +337,46 @@ class ArrayLoader implements LoaderInter
      */
     public function getBranchAlias(array $config)
     {
-        if (('dev-' !== substr($config['version'], 0, 4) && '-dev' !== substr($config['version'], -4))
-            || !isset($config['extra']['branch-alias'])
-            || !is_array($config['extra']['branch-alias'])
-        ) {
+        if (strpos($config['version'], 'dev-') !== 0 && '-dev' !== substr($config['version'], -4)) {
             return;
         }
 
-        foreach ($config['extra']['branch-alias'] as $sourceBranch => $targetBranch) {
-            // ensure it is an alias to a -dev package
-            if ('-dev' !== substr($targetBranch, -4)) {
-                continue;
-            }
+        if (isset($config['extra']['branch-alias']) && \is_array($config['extra']['branch-alias'])) {
+            foreach ($config['extra']['branch-alias'] as $sourceBranch => $targetBranch) {
+                // ensure it is an alias to a -dev package
+                if ('-dev' !== substr($targetBranch, -4)) {
+                    continue;
+                }
 
-            // normalize without -dev and ensure it's a numeric branch that is parseable
-            $validatedTargetBranch = $this->versionParser->normalizeBranch(substr($targetBranch, 0, -4));
-            if ('-dev' !== substr($validatedTargetBranch, -4)) {
-                continue;
-            }
+                // normalize without -dev and ensure it's a numeric branch that is parseable
+                if ($targetBranch === VersionParser::DEFAULT_BRANCH_ALIAS) {
+                    $validatedTargetBranch = VersionParser::DEFAULT_BRANCH_ALIAS;
+                } else {
+                    $validatedTargetBranch = $this->versionParser->normalizeBranch(substr($targetBranch, 0, -4));
+                }
+                if ('-dev' !== substr($validatedTargetBranch, -4)) {
+                    continue;
+                }
 
-            // ensure that it is the current branch aliasing itself
-            if (strtolower($config['version']) !== strtolower($sourceBranch)) {
-                continue;
-            }
+                // ensure that it is the current branch aliasing itself
+                if (strtolower($config['version']) !== strtolower($sourceBranch)) {
+                    continue;
+                }
 
-            // If using numeric aliases ensure the alias is a valid subversion
-            if (($sourcePrefix = $this->versionParser->parseNumericAliasPrefix($sourceBranch))
-                && ($targetPrefix = $this->versionParser->parseNumericAliasPrefix($targetBranch))
-                && (stripos($targetPrefix, $sourcePrefix) !== 0)
-            ) {
-                continue;
+                // If using numeric aliases ensure the alias is a valid subversion
+                if (($sourcePrefix = $this->versionParser->parseNumericAliasPrefix($sourceBranch))
+                    && ($targetPrefix = $this->versionParser->parseNumericAliasPrefix($targetBranch))
+                    && (stripos($targetPrefix, $sourcePrefix) !== 0)
+                ) {
+                    continue;
+                }
+
+                return $validatedTargetBranch;
             }
+        }
 
-            return $validatedTargetBranch;
+        if (isset($config['default-branch']) && $config['default-branch'] === true) {
+            return VersionParser::DEFAULT_BRANCH_ALIAS;
         }
     }
 }
diff -pruN 1.10.19-1/src/Composer/Package/Loader/JsonLoader.php 2.0.9-1/src/Composer/Package/Loader/JsonLoader.php
--- 1.10.19-1/src/Composer/Package/Loader/JsonLoader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Loader/JsonLoader.php	2021-01-27 15:09:27.000000000 +0000
@@ -38,6 +38,11 @@ class JsonLoader
             $config = JsonFile::parseJson(file_get_contents($json), $json);
         } elseif (is_string($json)) {
             $config = JsonFile::parseJson($json);
+        } else {
+            throw new \InvalidArgumentException(sprintf(
+                "JsonLoader: Unknown \$json parameter %s. Please report at https://github.com/composer/composer/issues/new.",
+                gettype($json)
+            ));
         }
 
         return $this->loader->load($config);
diff -pruN 1.10.19-1/src/Composer/Package/Loader/RootPackageLoader.php 2.0.9-1/src/Composer/Package/Loader/RootPackageLoader.php
--- 1.10.19-1/src/Composer/Package/Loader/RootPackageLoader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Loader/RootPackageLoader.php	2021-01-27 15:09:27.000000000 +0000
@@ -20,6 +20,7 @@ use Composer\Package\RootPackageInterfac
 use Composer\Repository\RepositoryFactory;
 use Composer\Package\Version\VersionGuesser;
 use Composer\Package\Version\VersionParser;
+use Composer\Package\RootPackage;
 use Composer\Repository\RepositoryManager;
 use Composer\Util\ProcessExecutor;
 
@@ -47,19 +48,13 @@ class RootPackageLoader extends ArrayLoa
      */
     private $versionGuesser;
 
-    /**
-     * @var IOInterface
-     */
-    private $io;
-
     public function __construct(RepositoryManager $manager, Config $config, VersionParser $parser = null, VersionGuesser $versionGuesser = null, IOInterface $io = null)
     {
         parent::__construct($parser);
 
         $this->manager = $manager;
         $this->config = $config;
-        $this->versionGuesser = $versionGuesser ?: new VersionGuesser($config, new ProcessExecutor(), $this->versionParser);
-        $this->io = $io;
+        $this->versionGuesser = $versionGuesser ?: new VersionGuesser($config, new ProcessExecutor($io), $this->versionParser);
     }
 
     /**
@@ -72,19 +67,15 @@ class RootPackageLoader extends ArrayLoa
     {
         if (!isset($config['name'])) {
             $config['name'] = '__root__';
-        } elseif ($this->io) {
-            if ($err = ValidatingArrayLoader::hasPackageNamingError($config['name'])) {
-                $this->io->writeError('<warning>Deprecation warning: Your package name '.$err.' Make sure you fix this as Composer 2.0 will error.</warning>');
-            }
+        } elseif ($err = ValidatingArrayLoader::hasPackageNamingError($config['name'])) {
+            throw new \RuntimeException('Your package name '.$err);
         }
         $autoVersioned = false;
         if (!isset($config['version'])) {
             $commit = null;
 
-            if (isset($config['extra']['branch-version'])) {
-                $config['version'] = preg_replace('{(\.x)?(-dev)?$}', '', $config['extra']['branch-version']).'.x-dev';
-            } elseif (getenv('COMPOSER_ROOT_VERSION')) {
-                // override with env var if available
+            // override with env var if available
+            if (getenv('COMPOSER_ROOT_VERSION')) {
                 $config['version'] = getenv('COMPOSER_ROOT_VERSION');
             } else {
                 $versionData = $this->versionGuesser->guessVersion($config, $cwd ?: getcwd());
@@ -120,7 +111,7 @@ class RootPackageLoader extends ArrayLoa
         }
 
         if ($autoVersioned) {
-            $realPackage->replaceVersion($realPackage->getVersion(), 'No version set (parsed as 1.0.0)');
+            $realPackage->replaceVersion($realPackage->getVersion(), RootPackage::DEFAULT_PRETTY_VERSION);
         }
 
         if (isset($config['minimum-stability'])) {
@@ -149,13 +140,11 @@ class RootPackageLoader extends ArrayLoa
             }
         }
 
-        if ($this->io) {
-            foreach (array_keys(BasePackage::$supportedLinkTypes) as $linkType) {
-                if (isset($config[$linkType])) {
-                    foreach ($config[$linkType] as $linkName => $constraint) {
-                        if ($err = ValidatingArrayLoader::hasPackageNamingError($linkName, true)) {
-                            $this->io->writeError('<warning>Deprecation warning: '.$linkType.'.'.$err.' Make sure you fix this as Composer 2.0 will error.</warning>');
-                        }
+        foreach (array_keys(BasePackage::$supportedLinkTypes) as $linkType) {
+            if (isset($config[$linkType])) {
+                foreach ($config[$linkType] as $linkName => $constraint) {
+                    if ($err = ValidatingArrayLoader::hasPackageNamingError($linkName, true)) {
+                        throw new \RuntimeException($linkType.'.'.$err);
                     }
                 }
             }
diff -pruN 1.10.19-1/src/Composer/Package/Loader/ValidatingArrayLoader.php 2.0.9-1/src/Composer/Package/Loader/ValidatingArrayLoader.php
--- 1.10.19-1/src/Composer/Package/Loader/ValidatingArrayLoader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Loader/ValidatingArrayLoader.php	2021-01-27 15:09:27.000000000 +0000
@@ -221,7 +221,7 @@ class ValidatingArrayLoader implements L
             }
         }
 
-        $unboundConstraint = new Constraint('=', $this->versionParser->normalize('dev-master'));
+        $unboundConstraint = new Constraint('=', '10000000-dev');
         $stableConstraint = new Constraint('=', '1.0.0');
 
         foreach (array_keys(BasePackage::$supportedLinkTypes) as $linkType) {
@@ -249,14 +249,14 @@ class ValidatingArrayLoader implements L
                             ($this->flags & self::CHECK_UNBOUND_CONSTRAINTS)
                             && 'require' === $linkType
                             && $linkConstraint->matches($unboundConstraint)
-                            && !preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $package)
+                            && !PlatformRepository::isPlatformPackage($package)
                         ) {
                             $this->warnings[] = $linkType.'.'.$package.' : unbound version constraints ('.$constraint.') should be avoided';
                         } elseif (
                             // check requires for exact constraints
                             ($this->flags & self::CHECK_STRICT_CONSTRAINTS)
                             && 'require' === $linkType
-                            && substr($linkConstraint, 0, 1) === '='
+                            && strpos($linkConstraint, '=') === 0
                             && $stableConstraint->versionCompare($stableConstraint, $linkConstraint, '<=')
                         ) {
                             $this->warnings[] = $linkType.'.'.$package.' : exact version constraints ('.$constraint.') should be avoided if the package follows semantic versioning';
@@ -372,7 +372,7 @@ class ValidatingArrayLoader implements L
 
     public static function hasPackageNamingError($name, $isLink = false)
     {
-        if (preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $name)) {
+        if (PlatformRepository::isPlatformPackage($name)) {
             return;
         }
 
diff -pruN 1.10.19-1/src/Composer/Package/Locker.php 2.0.9-1/src/Composer/Package/Locker.php
--- 1.10.19-1/src/Composer/Package/Locker.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Locker.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,11 +14,11 @@ namespace Composer\Package;
 
 use Composer\Json\JsonFile;
 use Composer\Installer\InstallationManager;
-use Composer\Repository\RepositoryManager;
+use Composer\Repository\LockArrayRepository;
 use Composer\Util\ProcessExecutor;
-use Composer\Repository\ArrayRepository;
 use Composer\Package\Dumper\ArrayDumper;
 use Composer\Package\Loader\ArrayLoader;
+use Composer\Package\Version\VersionParser;
 use Composer\Plugin\PluginInterface;
 use Composer\Util\Git as GitUtil;
 use Composer\IO\IOInterface;
@@ -32,35 +32,40 @@ use Seld\JsonLint\ParsingException;
  */
 class Locker
 {
+    /** @var JsonFile */
     private $lockFile;
-    private $repositoryManager;
+    /** @var InstallationManager */
     private $installationManager;
+    /** @var string */
     private $hash;
+    /** @var string */
     private $contentHash;
+    /** @var ArrayLoader */
     private $loader;
+    /** @var ArrayDumper */
     private $dumper;
+    /** @var ProcessExecutor */
     private $process;
     private $lockDataCache;
+    private $virtualFileWritten;
 
     /**
      * Initializes packages locker.
      *
      * @param IOInterface         $io
      * @param JsonFile            $lockFile             lockfile loader
-     * @param RepositoryManager   $repositoryManager    repository manager instance
      * @param InstallationManager $installationManager  installation manager instance
      * @param string              $composerFileContents The contents of the composer file
      */
-    public function __construct(IOInterface $io, JsonFile $lockFile, RepositoryManager $repositoryManager, InstallationManager $installationManager, $composerFileContents)
+    public function __construct(IOInterface $io, JsonFile $lockFile, InstallationManager $installationManager, $composerFileContents, ProcessExecutor $process = null)
     {
         $this->lockFile = $lockFile;
-        $this->repositoryManager = $repositoryManager;
         $this->installationManager = $installationManager;
         $this->hash = md5($composerFileContents);
         $this->contentHash = self::getContentHash($composerFileContents);
         $this->loader = new ArrayLoader(null, true);
         $this->dumper = new ArrayDumper();
-        $this->process = new ProcessExecutor($io);
+        $this->process = $process ?: new ProcessExecutor($io);
     }
 
     /**
@@ -109,7 +114,7 @@ class Locker
      */
     public function isLocked()
     {
-        if (!$this->lockFile->exists()) {
+        if (!$this->virtualFileWritten && !$this->lockFile->exists()) {
             return false;
         }
 
@@ -146,19 +151,19 @@ class Locker
      *
      * @param  bool                                     $withDevReqs true to retrieve the locked dev packages
      * @throws \RuntimeException
-     * @return \Composer\Repository\RepositoryInterface
+     * @return \Composer\Repository\LockArrayRepository
      */
     public function getLockedRepository($withDevReqs = false)
     {
         $lockData = $this->getLockData();
-        $packages = new ArrayRepository();
+        $packages = new LockArrayRepository();
 
         $lockedPackages = $lockData['packages'];
         if ($withDevReqs) {
             if (isset($lockData['packages-dev'])) {
                 $lockedPackages = array_merge($lockedPackages, $lockData['packages-dev']);
             } else {
-                throw new \RuntimeException('The lock file does not contain require-dev information, run install with the --no-dev option or run update to install those packages.');
+                throw new \RuntimeException('The lock file does not contain require-dev information, run install with the --no-dev option or delete it and run composer update to generate a new lock file.');
             }
         }
 
@@ -167,14 +172,47 @@ class Locker
         }
 
         if (isset($lockedPackages[0]['name'])) {
+            $packageByName = array();
             foreach ($lockedPackages as $info) {
-                $packages->addPackage($this->loader->load($info));
+                $package = $this->loader->load($info);
+                $packages->addPackage($package);
+                $packageByName[$package->getName()] = $package;
+
+                if ($package instanceof AliasPackage) {
+                    $packageByName[$package->getAliasOf()->getName()] = $package->getAliasOf();
+                }
+            }
+
+            if (isset($lockData['aliases'])) {
+                foreach ($lockData['aliases'] as $alias) {
+                    if (isset($packageByName[$alias['package']])) {
+                        $aliasPkg = new AliasPackage($packageByName[$alias['package']], $alias['alias_normalized'], $alias['alias']);
+                        $aliasPkg->setRootPackageAlias(true);
+                        $packages->addPackage($aliasPkg);
+                    }
+                }
             }
 
             return $packages;
         }
 
-        throw new \RuntimeException('Your composer.lock was created before 2012-09-15, and is not supported anymore. Run "composer update" to generate a new one.');
+        throw new \RuntimeException('Your composer.lock is invalid. Run "composer update" to generate a new one.');
+    }
+
+    /**
+     * @return string[] Names of dependencies installed through require-dev
+     */
+    public function getDevPackageNames()
+    {
+        $names = array();
+        $lockData = $this->getLockData();
+        if (isset($lockData['packages-dev'])) {
+            foreach ($lockData['packages-dev'] as $package) {
+                $names[] = strtolower($package['name']);
+            }
+        }
+
+        return $names;
     }
 
     /**
@@ -190,18 +228,18 @@ class Locker
 
         if (!empty($lockData['platform'])) {
             $requirements = $this->loader->parseLinks(
-                '__ROOT__',
+                '__root__',
                 '1.0.0',
-                'requires',
+                Link::TYPE_REQUIRE,
                 isset($lockData['platform']) ? $lockData['platform'] : array()
             );
         }
 
         if ($withDevReqs && !empty($lockData['platform-dev'])) {
             $devRequirements = $this->loader->parseLinks(
-                '__ROOT__',
+                '__root__',
                 '1.0.0',
-                'requires',
+                Link::TYPE_REQUIRE,
                 isset($lockData['platform-dev']) ? $lockData['platform-dev'] : array()
             );
 
@@ -254,19 +292,7 @@ class Locker
     {
         $lockData = $this->getLockData();
 
-        if (!isset($lockData['aliases'])) {
-            return array();
-        }
-
-        // forward compatibility with Composer 2 lock files created
-        // before https://github.com/composer/composer/issues/9337 was fixed
-        foreach ($lockData['aliases'] as $index => $alias) {
-            if (in_array($alias['version'], array('dev-master', 'dev-default', 'dev-trunk'), true)) {
-                $lockData['aliases'][$index]['version'] = '9999999-dev';
-            }
-        }
-
-        return $lockData['aliases'];
+        return isset($lockData['aliases']) ? $lockData['aliases'] : array();
     }
 
     public function getLockData()
@@ -295,11 +321,22 @@ class Locker
      * @param bool   $preferStable
      * @param bool   $preferLowest
      * @param array  $platformOverrides
+     * @param bool   $write             Whether to actually write data to disk, useful in tests and for --dry-run
      *
      * @return bool
      */
-    public function setLockData(array $packages, $devPackages, array $platformReqs, $platformDevReqs, array $aliases, $minimumStability, array $stabilityFlags, $preferStable, $preferLowest, array $platformOverrides)
+    public function setLockData(array $packages, $devPackages, array $platformReqs, $platformDevReqs, array $aliases, $minimumStability, array $stabilityFlags, $preferStable, $preferLowest, array $platformOverrides, $write = true)
     {
+        // keep old default branch names normalized to DEFAULT_BRANCH_ALIAS for BC as that is how Composer 1 outputs the lock file
+        // when loading the lock file the version is anyway ignored in Composer 2, so it has no adverse effect
+        $aliases = array_map(function ($alias) {
+            if (in_array($alias['version'], array('dev-master', 'dev-trunk', 'dev-default'), true)) {
+                $alias['version'] = VersionParser::DEFAULT_BRANCH_ALIAS;
+            }
+
+            return $alias;
+        }, $aliases);
+
         $lock = array(
             '_readme' => array('This file locks the dependencies of your project to a known state',
                                'Read more about it at https://getcomposer.org/doc/01-basic-usage.md#installing-dependencies',
@@ -307,24 +344,13 @@ class Locker
             'content-hash' => $this->contentHash,
             'packages' => null,
             'packages-dev' => null,
-            'aliases' => array(),
+            'aliases' => $aliases,
             'minimum-stability' => $minimumStability,
             'stability-flags' => $stabilityFlags,
             'prefer-stable' => $preferStable,
             'prefer-lowest' => $preferLowest,
         );
 
-        foreach ($aliases as $package => $versions) {
-            foreach ($versions as $version => $alias) {
-                $lock['aliases'][] = array(
-                    'alias' => $alias['alias'],
-                    'alias_normalized' => $alias['alias_normalized'],
-                    'version' => $version,
-                    'package' => $package,
-                );
-            }
-        }
-
         $lock['packages'] = $this->lockPackages($packages);
         if (null !== $devPackages) {
             $lock['packages-dev'] = $this->lockPackages($devPackages);
@@ -337,22 +363,20 @@ class Locker
         }
         $lock['plugin-api-version'] = PluginInterface::PLUGIN_API_VERSION;
 
-        if (empty($lock['packages']) && empty($lock['packages-dev']) && empty($lock['platform']) && empty($lock['platform-dev'])) {
-            if ($this->lockFile->exists()) {
-                unlink($this->lockFile->getPath());
-            }
-
-            return false;
-        }
-
         try {
             $isLocked = $this->isLocked();
         } catch (ParsingException $e) {
             $isLocked = false;
         }
         if (!$isLocked || $lock !== $this->getLockData()) {
-            $this->lockFile->write($lock);
-            $this->lockDataCache = null;
+            if ($write) {
+                $this->lockFile->write($lock);
+                $this->lockDataCache = null;
+                $this->virtualFileWritten = false;
+            } else {
+                $this->virtualFileWritten = true;
+                $this->lockDataCache = JsonFile::parseJson(JsonFile::encode($lock, 448 & JsonFile::JSON_PRETTY_PRINT));
+            }
 
             return true;
         }
diff -pruN 1.10.19-1/src/Composer/Package/PackageInterface.php 2.0.9-1/src/Composer/Package/PackageInterface.php
--- 1.10.19-1/src/Composer/Package/PackageInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/PackageInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -21,6 +21,10 @@ use Composer\Repository\RepositoryInterf
  */
 interface PackageInterface
 {
+    const DISPLAY_SOURCE_REF_IF_DEV = 0;
+    const DISPLAY_SOURCE_REF = 1;
+    const DISPLAY_DIST_REF = 2;
+
     /**
      * Returns the package's name without version info, thus not a unique identifier
      *
@@ -41,9 +45,11 @@ interface PackageInterface
      * No version or release type information should be included in any of the
      * names. Provided or replaced package names need to be returned as well.
      *
-     * @return array An array of strings referring to this package
+     * @param bool $provides Whether provided names should be included
+     *
+     * @return string[] An array of strings referring to this package
      */
-    public function getNames();
+    public function getNames($provides = true);
 
     /**
      * Allows the solver to set an id for this package to refer to it.
@@ -76,7 +82,7 @@ interface PackageInterface
     /**
      * Returns the package targetDir property
      *
-     * @return string The package targetDir
+     * @return string|null The package targetDir
      */
     public function getTargetDir();
 
@@ -118,7 +124,7 @@ interface PackageInterface
     /**
      * Returns the repository urls of this package including mirrors, e.g. git://github.com/naderman/composer.git
      *
-     * @return array
+     * @return string[]
      */
     public function getSourceUrls();
 
@@ -153,7 +159,7 @@ interface PackageInterface
     /**
      * Returns the urls of the distribution archive of this version, including mirrors
      *
-     * @return array
+     * @return string[]
      */
     public function getDistUrls();
 
@@ -197,10 +203,13 @@ interface PackageInterface
      *
      * @see getPrettyVersion
      *
-     * @param  bool   $truncate If the source reference is a sha1 hash, truncate it
+     * @param  bool   $truncate    If the source reference is a sha1 hash, truncate it
+     * @param  int    $displayMode One of the DISPLAY_ constants on this interface determining display of references
      * @return string version
+     *
+     * @psalm-param self::DISPLAY_SOURCE_REF_IF_DEV|self::DISPLAY_SOURCE_REF|self::DISPLAY_DIST_REF $displayMode
      */
-    public function getFullPrettyVersion($truncate = true);
+    public function getFullPrettyVersion($truncate = true, $displayMode = self::DISPLAY_SOURCE_REF_IF_DEV);
 
     /**
      * Returns the release date of the package
@@ -261,6 +270,7 @@ interface PackageInterface
      * combination with this package.
      *
      * @return array An array of package suggestions with descriptions
+     * @psalm-return array<string, string>
      */
     public function getSuggests();
 
@@ -273,6 +283,7 @@ interface PackageInterface
      * directories for autoloading using the type specified.
      *
      * @return array Mapping of autoloading rules
+     * @psalm-return array{psr-0?: array<string, string>, psr-4?: array<string, string>, classmap?: list<string>, files?: list<string>}
      */
     public function getAutoload();
 
@@ -285,6 +296,7 @@ interface PackageInterface
      * directories for autoloading using the type specified.
      *
      * @return array Mapping of dev autoloading rules
+     * @psalm-return array{psr-0?: array<string, string>, psr-4?: array<string, string>, classmap?: list<string>, files?: list<string>}
      */
     public function getDevAutoload();
 
@@ -292,7 +304,7 @@ interface PackageInterface
      * Returns a list of directories which should get added to PHP's
      * include path.
      *
-     * @return array
+     * @return string[]
      */
     public function getIncludePaths();
 
@@ -313,7 +325,7 @@ interface PackageInterface
     /**
      * Returns the package binaries
      *
-     * @return array
+     * @return string[]
      */
     public function getBinaries();
 
@@ -346,6 +358,13 @@ interface PackageInterface
     public function getPrettyString();
 
     /**
+     * Returns default base filename for archive
+     *
+     * @return array
+     */
+    public function getArchiveName();
+
+    /**
      * Returns a list of patterns to exclude from package archives
      *
      * @return array
@@ -353,6 +372,11 @@ interface PackageInterface
     public function getArchiveExcludes();
 
     /**
+     * @return bool
+     */
+    public function isDefaultBranch();
+
+    /**
      * Returns a list of options to download package dist files
      *
      * @return array
@@ -386,4 +410,13 @@ interface PackageInterface
      * @return void
      */
     public function setDistReference($reference);
+
+    /**
+     * Set dist and source references and update dist URL for ones that contain a reference
+     *
+     * @param string $reference
+     *
+     * @return void
+     */
+    public function setSourceDistReferences($reference);
 }
diff -pruN 1.10.19-1/src/Composer/Package/Package.php 2.0.9-1/src/Composer/Package/Package.php
--- 1.10.19-1/src/Composer/Package/Package.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Package.php	2021-01-27 15:09:27.000000000 +0000
@@ -57,7 +57,9 @@ class Package extends BasePackage
     protected $autoload = array();
     protected $devAutoload = array();
     protected $includePaths = array();
+    protected $archiveName;
     protected $archiveExcludes = array();
+    protected $isDefaultBranch = false;
 
     /**
      * Creates a new in memory package.
@@ -552,6 +554,24 @@ class Package extends BasePackage
     }
 
     /**
+     * Sets default base filename for archive
+     *
+     * @param string $name
+     */
+    public function setArchiveName($name)
+    {
+        $this->archiveName = $name;
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function getArchiveName()
+    {
+        return $this->archiveName;
+    }
+
+    /**
      * Sets a list of patterns to be excluded from archives
      *
      * @param array $excludes
@@ -570,6 +590,39 @@ class Package extends BasePackage
     }
 
     /**
+     * @param bool $defaultBranch
+     */
+    public function setIsDefaultBranch($defaultBranch)
+    {
+        $this->isDefaultBranch = $defaultBranch;
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function isDefaultBranch()
+    {
+        return $this->isDefaultBranch;
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function setSourceDistReferences($reference)
+    {
+        $this->setSourceReference($reference);
+
+        // only bitbucket, github and gitlab have auto generated dist URLs that easily allow replacing the reference in the dist URL
+        // TODO generalize this a bit for self-managed/on-prem versions? Some kind of replace token in dist urls which allow this?
+        if (preg_match('{^https?://(?:(?:www\.)?bitbucket\.org|(api\.)?github\.com|(?:www\.)?gitlab\.com)/}i', $this->getDistUrl())) {
+            $this->setDistReference($reference);
+            $this->setDistUrl(preg_replace('{(?<=/|sha=)[a-f0-9]{40}(?=/|$)}i', $reference, $this->getDistUrl()));
+        } elseif ($this->getDistReference()) { // update the dist reference if there was one, but if none was provided ignore it
+            $this->setDistReference($reference);
+        }
+    }
+
+    /**
      * Replaces current version and pretty version with passed values.
      * It also sets stability.
      *
@@ -599,8 +652,10 @@ class Package extends BasePackage
                     $mirrorUrl = ComposerMirror::processGitUrl($mirror['url'], $this->name, $url, $type);
                 } elseif ($urlType === 'source' && $type === 'hg') {
                     $mirrorUrl = ComposerMirror::processHgUrl($mirror['url'], $this->name, $url, $type);
+                } else {
+                    continue;
                 }
-                if (!in_array($mirrorUrl, $urls)) {
+                if (!\in_array($mirrorUrl, $urls)) {
                     $func = $mirror['preferred'] ? 'array_unshift' : 'array_push';
                     $func($urls, $mirrorUrl);
                 }
diff -pruN 1.10.19-1/src/Composer/Package/RootAliasPackage.php 2.0.9-1/src/Composer/Package/RootAliasPackage.php
--- 1.10.19-1/src/Composer/Package/RootAliasPackage.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/RootAliasPackage.php	2021-01-27 15:09:27.000000000 +0000
@@ -75,7 +75,7 @@ class RootAliasPackage extends AliasPack
      */
     public function setRequires(array $require)
     {
-        $this->requires = $this->replaceSelfVersionDependencies($require, 'requires');
+        $this->requires = $this->replaceSelfVersionDependencies($require, Link::TYPE_REQUIRE);
 
         $this->aliasOf->setRequires($require);
     }
@@ -85,7 +85,7 @@ class RootAliasPackage extends AliasPack
      */
     public function setDevRequires(array $devRequire)
     {
-        $this->devRequires = $this->replaceSelfVersionDependencies($devRequire, 'devRequires');
+        $this->devRequires = $this->replaceSelfVersionDependencies($devRequire, Link::TYPE_DEV_REQUIRE);
 
         $this->aliasOf->setDevRequires($devRequire);
     }
@@ -95,7 +95,7 @@ class RootAliasPackage extends AliasPack
      */
     public function setConflicts(array $conflicts)
     {
-        $this->conflicts = $this->replaceSelfVersionDependencies($conflicts, 'conflicts');
+        $this->conflicts = $this->replaceSelfVersionDependencies($conflicts, Link::TYPE_CONFLICT);
         $this->aliasOf->setConflicts($conflicts);
     }
 
@@ -104,7 +104,7 @@ class RootAliasPackage extends AliasPack
      */
     public function setProvides(array $provides)
     {
-        $this->provides = $this->replaceSelfVersionDependencies($provides, 'provides');
+        $this->provides = $this->replaceSelfVersionDependencies($provides, Link::TYPE_PROVIDE);
         $this->aliasOf->setProvides($provides);
     }
 
@@ -113,7 +113,7 @@ class RootAliasPackage extends AliasPack
      */
     public function setReplaces(array $replaces)
     {
-        $this->replaces = $this->replaceSelfVersionDependencies($replaces, 'replaces');
+        $this->replaces = $this->replaceSelfVersionDependencies($replaces, Link::TYPE_REPLACE);
         $this->aliasOf->setReplaces($replaces);
     }
 
diff -pruN 1.10.19-1/src/Composer/Package/RootPackage.php 2.0.9-1/src/Composer/Package/RootPackage.php
--- 1.10.19-1/src/Composer/Package/RootPackage.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/RootPackage.php	2021-01-27 15:09:27.000000000 +0000
@@ -19,6 +19,8 @@ namespace Composer\Package;
  */
 class RootPackage extends CompletePackage implements RootPackageInterface
 {
+    const DEFAULT_PRETTY_VERSION = '1.0.0+no-version-set';
+
     protected $minimumStability = 'stable';
     protected $preferStable = false;
     protected $stabilityFlags = array();
diff -pruN 1.10.19-1/src/Composer/Package/Version/StabilityFilter.php 2.0.9-1/src/Composer/Package/Version/StabilityFilter.php
--- 1.10.19-1/src/Composer/Package/Version/StabilityFilter.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Version/StabilityFilter.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,49 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Package\Version;
+
+use Composer\Package\BasePackage;
+
+/**
+ * @author Jordi Boggiano <j.boggiano@seld.be>
+ */
+class StabilityFilter
+{
+    /**
+     * Checks if any of the provided package names in the given stability match the configured acceptable stability and flags
+     *
+     * @param int[] $acceptableStabilities array of stability => BasePackage::STABILITY_* value
+     * @psalm-param array<string, BasePackage::STABILITY_*> $acceptableStabilities
+     * @param int[] $stabilityFlags an array of package name => BasePackage::STABILITY_* value
+     * @psalm-param array<string, BasePackage::STABILITY_*> $stabilityFlags
+     * @param  string[] $names     The package name(s) to check for stability flags
+     * @param  string   $stability one of 'stable', 'RC', 'beta', 'alpha' or 'dev'
+     * @return bool     true if any package name is acceptable
+     */
+    public static function isPackageAcceptable(array $acceptableStabilities, array $stabilityFlags, $names, $stability)
+    {
+        foreach ($names as $name) {
+            // allow if package matches the package-specific stability flag
+            if (isset($stabilityFlags[$name])) {
+                if (BasePackage::$stabilities[$stability] <= $stabilityFlags[$name]) {
+                    return true;
+                }
+            } elseif (isset($acceptableStabilities[$stability])) {
+                // allow if package matches the global stability requirement and has no exception
+                return true;
+            }
+        }
+
+        return false;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Package/Version/VersionGuesser.php 2.0.9-1/src/Composer/Package/Version/VersionGuesser.php
--- 1.10.19-1/src/Composer/Package/Version/VersionGuesser.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Version/VersionGuesser.php	2021-01-27 15:09:27.000000000 +0000
@@ -17,6 +17,7 @@ use Composer\Repository\Vcs\HgDriver;
 use Composer\IO\NullIO;
 use Composer\Semver\VersionParser as SemverVersionParser;
 use Composer\Util\Git as GitUtil;
+use Composer\Util\HttpDownloader;
 use Composer\Util\ProcessExecutor;
 use Composer\Util\Svn as SvnUtil;
 
@@ -77,7 +78,7 @@ class VersionGuesser
             return $this->postprocess($versionData);
         }
 
-        $versionData = $this->guessFossilVersion($packageConfig, $path);
+        $versionData = $this->guessFossilVersion($path);
         if (null !== $versionData && null !== $versionData['version']) {
             return $this->postprocess($versionData);
         }
@@ -92,7 +93,7 @@ class VersionGuesser
 
     private function postprocess(array $versionData)
     {
-        if (!empty($versionData['feature_version']) && $versionData['feature_version'] === $versionData['version'] && $versionData['feature_pretty_version'] === $versionData['feature_pretty_version']) {
+        if (!empty($versionData['feature_version']) && $versionData['feature_version'] === $versionData['version'] && $versionData['feature_pretty_version'] === $versionData['pretty_version']) {
             unset($versionData['feature_version'], $versionData['feature_pretty_version']);
         }
 
@@ -125,7 +126,11 @@ class VersionGuesser
             // find current branch and collect all branch names
             foreach ($this->process->splitLines($output) as $branch) {
                 if ($branch && preg_match('{^(?:\* ) *(\(no branch\)|\(detached from \S+\)|\(HEAD detached at \S+\)|\S+) *([a-f0-9]+) .*$}', $branch, $match)) {
-                    if ($match[1] === '(no branch)' || substr($match[1], 0, 10) === '(detached ' || substr($match[1], 0, 17) === '(HEAD detached at') {
+                    if (
+                        $match[1] === '(no branch)'
+                        || strpos($match[1], '(detached ') === 0
+                        || strpos($match[1], '(HEAD detached at') === 0
+                    ) {
                         $version = 'dev-' . $match[2];
                         $prettyVersion = $version;
                         $isFeatureBranch = true;
@@ -133,7 +138,7 @@ class VersionGuesser
                     } else {
                         $version = $this->versionParser->normalizeBranch($match[1]);
                         $prettyVersion = 'dev-' . $match[1];
-                        $isFeatureBranch = 0 === strpos($version, 'dev-');
+                        $isFeatureBranch = $this->isFeatureBranch($packageConfig, $match[1]);
                     }
 
                     if ($match[2]) {
@@ -151,6 +156,7 @@ class VersionGuesser
             if ($isFeatureBranch) {
                 $featureVersion = $version;
                 $featurePrettyVersion = $prettyVersion;
+
                 // try to find the best (nearest) version branch to assume this feature's version
                 $result = $this->guessFeatureVersion($packageConfig, $version, $branches, 'git rev-list %candidate%..%branch%', $path);
                 $version = $result['version'];
@@ -205,7 +211,7 @@ class VersionGuesser
             $version = $this->versionParser->normalizeBranch($branch);
             $isFeatureBranch = 0 === strpos($version, 'dev-');
 
-            if ('9999999-dev' === $version) {
+            if (VersionParser::DEFAULT_BRANCH_ALIAS === $version) {
                 return array('version' => $version, 'commit' => null, 'pretty_version' => 'dev-'.$branch);
             }
 
@@ -214,7 +220,8 @@ class VersionGuesser
             }
 
             // re-use the HgDriver to fetch branches (this properly includes bookmarks)
-            $driver = new HgDriver(array('url' => $path), new NullIO(), $this->config, $this->process);
+            $io = new NullIO();
+            $driver = new HgDriver(array('url' => $path), $io, $this->config, new HttpDownloader($io, $this->config), $this->process);
             $branches = array_keys($driver->getBranches());
 
             // try to find the best (nearest) version branch to assume this feature's version
@@ -233,19 +240,14 @@ class VersionGuesser
 
         // ignore feature branches if they have no branch-alias or self.version is used
         // and find the branch they came from to use as a version instead
-        if ((isset($packageConfig['extra']['branch-alias']) && !isset($packageConfig['extra']['branch-alias'][$version]))
+        if (!isset($packageConfig['extra']['branch-alias'][$version])
             || strpos(json_encode($packageConfig), '"self.version"')
         ) {
             $branch = preg_replace('{^dev-}', '', $version);
             $length = PHP_INT_MAX;
 
-            $nonFeatureBranches = '';
-            if (!empty($packageConfig['non-feature-branches'])) {
-                $nonFeatureBranches = implode('|', $packageConfig['non-feature-branches']);
-            }
-
             // return directly, if branch is configured to be non-feature branch
-            if (preg_match('{^(' . $nonFeatureBranches . ')$}', $branch) && in_array($branch, $branches, true)) {
+            if (!$this->isFeatureBranch($packageConfig, $branch)) {
                 return array('version' => $version, 'pretty_version' => $prettyVersion);
             }
 
@@ -267,7 +269,7 @@ class VersionGuesser
                 $candidateVersion = preg_replace('{^remotes/\S+/}', '', $candidate);
 
                 // do not compare against itself or other feature branches
-                if ($candidate === $branch || !preg_match('{^(' . $nonFeatureBranches . '|master|trunk|default|develop|\d+\..+)$}', $candidateVersion, $match)) {
+                if ($candidate === $branch || $this->isFeatureBranch($packageConfig, $candidateVersion)) {
                     continue;
                 }
 
@@ -290,7 +292,17 @@ class VersionGuesser
         return array('version' => $version, 'pretty_version' => $prettyVersion);
     }
 
-    private function guessFossilVersion(array $packageConfig, $path)
+    private function isFeatureBranch(array $packageConfig, $branchName)
+    {
+        $nonFeatureBranches = '';
+        if (!empty($packageConfig['non-feature-branches'])) {
+            $nonFeatureBranches = implode('|', $packageConfig['non-feature-branches']);
+        }
+
+        return !preg_match('{^(' . $nonFeatureBranches . '|master|main|latest|next|current|support|tip|trunk|default|develop|\d+\..+)$}', $branchName, $match);
+    }
+
+    private function guessFossilVersion($path)
     {
         $version = null;
         $prettyVersion = null;
@@ -336,7 +348,11 @@ class VersionGuesser
                 }
 
                 $prettyVersion = trim($matches[1]);
-                $version = $this->versionParser->normalize($prettyVersion);
+                if ($prettyVersion === 'trunk') {
+                    $version = 'dev-trunk';
+                } else {
+                    $version = $this->versionParser->normalize($prettyVersion);
+                }
 
                 return array('version' => $version, 'commit' => '', 'pretty_version' => $prettyVersion);
             }
diff -pruN 1.10.19-1/src/Composer/Package/Version/VersionParser.php 2.0.9-1/src/Composer/Package/Version/VersionParser.php
--- 1.10.19-1/src/Composer/Package/Version/VersionParser.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Version/VersionParser.php	2021-01-27 15:09:27.000000000 +0000
@@ -18,6 +18,8 @@ use Composer\Semver\Semver;
 
 class VersionParser extends SemverVersionParser
 {
+    const DEFAULT_BRANCH_ALIAS = '9999999-dev';
+
     private static $constraints = array();
 
     /**
@@ -49,7 +51,7 @@ class VersionParser extends SemverVersio
 
         for ($i = 0, $count = count($pairs); $i < $count; $i++) {
             $pair = preg_replace('{^([^=: ]+)[=: ](.*)$}', '$1 $2', trim($pairs[$i]));
-            if (false === strpos($pair, ' ') && isset($pairs[$i + 1]) && false === strpos($pairs[$i + 1], '/') && !preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $pairs[$i + 1])) {
+            if (false === strpos($pair, ' ') && isset($pairs[$i + 1]) && false === strpos($pairs[$i + 1], '/') && !PlatformRepository::isPlatformPackage($pairs[$i + 1])) {
                 $pair .= ' '.$pairs[$i + 1];
                 $i++;
             }
@@ -70,7 +72,14 @@ class VersionParser extends SemverVersio
      */
     public static function isUpgrade($normalizedFrom, $normalizedTo)
     {
-        if (substr($normalizedFrom, 0, 4) === 'dev-' || substr($normalizedTo, 0, 4) === 'dev-') {
+        if ($normalizedFrom === $normalizedTo) {
+            return true;
+        }
+
+        $normalizedFrom = str_replace(array('dev-master', 'dev-trunk', 'dev-default'), VersionParser::DEFAULT_BRANCH_ALIAS, $normalizedFrom);
+        $normalizedTo = str_replace(array('dev-master', 'dev-trunk', 'dev-default'), VersionParser::DEFAULT_BRANCH_ALIAS, $normalizedTo);
+
+        if (strpos($normalizedFrom, 'dev-') === 0 || strpos($normalizedTo, 'dev-') === 0) {
             return true;
         }
 
diff -pruN 1.10.19-1/src/Composer/Package/Version/VersionSelector.php 2.0.9-1/src/Composer/Package/Version/VersionSelector.php
--- 1.10.19-1/src/Composer/Package/Version/VersionSelector.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Package/Version/VersionSelector.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,13 +12,14 @@
 
 namespace Composer\Package\Version;
 
-use Composer\DependencyResolver\Pool;
 use Composer\Package\BasePackage;
+use Composer\Package\AliasPackage;
 use Composer\Package\PackageInterface;
-use Composer\Plugin\PluginInterface;
 use Composer\Composer;
 use Composer\Package\Loader\ArrayLoader;
 use Composer\Package\Dumper\ArrayDumper;
+use Composer\Repository\RepositorySet;
+use Composer\Repository\PlatformRepository;
 use Composer\Semver\Constraint\Constraint;
 
 /**
@@ -29,40 +30,64 @@ use Composer\Semver\Constraint\Constrain
  */
 class VersionSelector
 {
-    private $pool;
+    private $repositorySet;
+
+    private $platformConstraints = array();
 
     private $parser;
 
-    public function __construct(Pool $pool)
+    /**
+     * @param PlatformRepository $platformRepo If passed in, the versions found will be filtered against their requirements to eliminate any not matching the current platform packages
+     */
+    public function __construct(RepositorySet $repositorySet, PlatformRepository $platformRepo = null)
     {
-        $this->pool = $pool;
+        $this->repositorySet = $repositorySet;
+        if ($platformRepo) {
+            foreach ($platformRepo->getPackages() as $package) {
+                $this->platformConstraints[$package->getName()][] = new Constraint('==', $package->getVersion());
+            }
+        }
     }
 
     /**
      * Given a package name and optional version, returns the latest PackageInterface
      * that matches.
      *
-     * @param  string                $packageName
-     * @param  string                $targetPackageVersion
-     * @param  string                $targetPhpVersion
-     * @param  string                $preferredStability
-     * @return PackageInterface|bool
+     * @param  string                 $packageName
+     * @param  string                 $targetPackageVersion
+     * @param  string                 $preferredStability
+     * @param  bool|array             $ignorePlatformReqs
+     * @return PackageInterface|false
      */
-    public function findBestCandidate($packageName, $targetPackageVersion = null, $targetPhpVersion = null, $preferredStability = 'stable')
+    public function findBestCandidate($packageName, $targetPackageVersion = null, $preferredStability = 'stable', $ignorePlatformReqs = false, $repoSetFlags = 0)
     {
+        if (!isset(BasePackage::$stabilities[$preferredStability])) {
+            // If you get this, maybe you are still relying on the Composer 1.x signature where the 3rd arg was the php version
+            throw new \UnexpectedValueException('Expected a valid stability name as 3rd argument, got '.$preferredStability);
+        }
+
         $constraint = $targetPackageVersion ? $this->getParser()->parseConstraints($targetPackageVersion) : null;
-        $candidates = $this->pool->whatProvides(strtolower($packageName), $constraint, true);
+        $candidates = $this->repositorySet->findPackages(strtolower($packageName), $constraint, $repoSetFlags);
 
-        if ($targetPhpVersion) {
-            $phpConstraint = new Constraint('==', $this->getParser()->normalize($targetPhpVersion));
-            $composerRuntimeConstraint = new Constraint('==', $this->getParser()->normalize(Composer::RUNTIME_API_VERSION));
-            $composerPluginConstraint = new Constraint('==', $this->getParser()->normalize(PluginInterface::PLUGIN_API_VERSION));
-            $candidates = array_filter($candidates, function ($pkg) use ($phpConstraint, $composerPluginConstraint, $composerRuntimeConstraint) {
+        if ($this->platformConstraints && true !== $ignorePlatformReqs) {
+            $platformConstraints = $this->platformConstraints;
+            $ignorePlatformReqs = $ignorePlatformReqs ?: array();
+            $candidates = array_filter($candidates, function ($pkg) use ($platformConstraints, $ignorePlatformReqs) {
                 $reqs = $pkg->getRequires();
 
-                return (!isset($reqs['php']) || $reqs['php']->getConstraint()->matches($phpConstraint))
-                    && (!isset($reqs['composer-plugin-api']) || $reqs['composer-plugin-api']->getConstraint()->matches($composerPluginConstraint))
-                    && (!isset($reqs['composer-runtime-api']) || $reqs['composer-runtime-api']->getConstraint()->matches($composerRuntimeConstraint));
+                foreach ($reqs as $name => $link) {
+                    if (!in_array($name, $ignorePlatformReqs, true) && isset($platformConstraints[$name])) {
+                        foreach ($platformConstraints[$name] as $constraint) {
+                            if ($link->getConstraint()->matches($constraint)) {
+                                continue 2;
+                            }
+                        }
+
+                        return false;
+                    }
+                }
+
+                return true;
             });
         }
 
@@ -103,11 +128,16 @@ class VersionSelector
             }
         }
 
+        // if we end up with 9999999-dev as selected package, make sure we use the original version instead of the alias
+        if ($package instanceof AliasPackage && $package->getVersion() === VersionParser::DEFAULT_BRANCH_ALIAS) {
+            $package = $package->getAliasOf();
+        }
+
         return $package;
     }
 
     /**
-     * Given a concrete version, this returns a ~ constraint (when possible)
+     * Given a concrete version, this returns a ^ constraint (when possible)
      * that should be used, for example, in composer.json.
      *
      * For example:
@@ -131,7 +161,7 @@ class VersionSelector
         $loader = new ArrayLoader($this->getParser());
         $dumper = new ArrayDumper();
         $extra = $loader->getBranchAlias($dumper->dump($package));
-        if ($extra) {
+        if ($extra && $extra !== VersionParser::DEFAULT_BRANCH_ALIAS) {
             $extra = preg_replace('{^(\d+\.\d+\.\d+)(\.9999999)-dev$}', '$1.0', $extra, -1, $count);
             if ($count) {
                 $extra = str_replace('.9999999', '.0', $extra);
diff -pruN 1.10.19-1/src/Composer/Platform/HhvmDetector.php 2.0.9-1/src/Composer/Platform/HhvmDetector.php
--- 1.10.19-1/src/Composer/Platform/HhvmDetector.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Platform/HhvmDetector.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,62 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Platform;
+
+use Composer\Util\Platform;
+use Composer\Util\ProcessExecutor;
+use Symfony\Component\Process\ExecutableFinder;
+
+class HhvmDetector
+{
+    private static $hhvmVersion;
+    private $executableFinder;
+    private $processExecutor;
+
+    public function __construct(ExecutableFinder  $executableFinder = null, ProcessExecutor $processExecutor = null)
+    {
+        $this->executableFinder = $executableFinder;
+        $this->processExecutor = $processExecutor;
+    }
+
+    public function reset()
+    {
+        self::$hhvmVersion = null;
+    }
+
+    public function getVersion()
+    {
+        if (null !== self::$hhvmVersion) {
+            return self::$hhvmVersion ?: null;
+        }
+
+        self::$hhvmVersion = defined('HHVM_VERSION') ? HHVM_VERSION : null;
+        if (self::$hhvmVersion === null && !Platform::isWindows()) {
+            self::$hhvmVersion = false;
+            $this->executableFinder = $this->executableFinder ?: new ExecutableFinder();
+            $hhvmPath = $this->executableFinder->find('hhvm');
+            if ($hhvmPath !== null) {
+                $this->processExecutor = $this->processExecutor ?: new ProcessExecutor();
+                $exitCode = $this->processExecutor->execute(
+                    ProcessExecutor::escape($hhvmPath).
+                    ' --php -d hhvm.jit=0 -r "echo HHVM_VERSION;" 2>/dev/null',
+                    self::$hhvmVersion
+                );
+                if ($exitCode !== 0) {
+                    self::$hhvmVersion = false;
+                }
+            }
+        }
+
+        return self::$hhvmVersion;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Platform/Runtime.php 2.0.9-1/src/Composer/Platform/Runtime.php
--- 1.10.19-1/src/Composer/Platform/Runtime.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Platform/Runtime.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,109 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Platform;
+
+class Runtime
+{
+    /**
+     * @param  string       $constant
+     * @param  class-string $class
+     * @return bool
+     */
+    public function hasConstant($constant, $class = null)
+    {
+        return defined(ltrim($class.'::'.$constant, ':'));
+    }
+
+    /**
+     * @param  bool         $constant
+     * @param  class-string $class
+     * @return mixed
+     */
+    public function getConstant($constant, $class = null)
+    {
+        return constant(ltrim($class.'::'.$constant, ':'));
+    }
+
+    /**
+     * @param  string $fn
+     * @return bool
+     */
+    public function hasFunction($fn)
+    {
+        return function_exists($fn);
+    }
+
+    /**
+     * @param  callable $callable
+     * @param  array    $arguments
+     * @return mixed
+     */
+    public function invoke($callable, array $arguments = array())
+    {
+        return call_user_func_array($callable, $arguments);
+    }
+
+    /**
+     * @param  class-string $class
+     * @return bool
+     */
+    public function hasClass($class)
+    {
+        return class_exists($class, false);
+    }
+
+    /**
+     * @param  class-string $class
+     * @param  array        $arguments
+     * @return object
+     */
+    public function construct($class, array $arguments = array())
+    {
+        if (empty($arguments)) {
+            return new $class;
+        }
+
+        $refl = new \ReflectionClass($class);
+
+        return $refl->newInstanceArgs($arguments);
+    }
+
+    /** @return string[] */
+    public function getExtensions()
+    {
+        return get_loaded_extensions();
+    }
+
+    /**
+     * @param  string $extension
+     * @return string
+     */
+    public function getExtensionVersion($extension)
+    {
+        return phpversion($extension);
+    }
+
+    /**
+     * @param  string $extension
+     * @return string
+     */
+    public function getExtensionInfo($extension)
+    {
+        $reflector = new \ReflectionExtension($extension);
+
+        ob_start();
+        $reflector->info();
+
+        return ob_get_clean();
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Platform/Version.php 2.0.9-1/src/Composer/Platform/Version.php
--- 1.10.19-1/src/Composer/Platform/Version.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Platform/Version.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,104 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Platform;
+
+/**
+ * @author Lars Strojny <lars@strojny.net>
+ */
+class Version
+{
+    /**
+     * @param  string      $opensslVersion
+     * @param  bool        $isFips
+     * @return string|null
+     */
+    public static function parseOpenssl($opensslVersion, &$isFips)
+    {
+        $isFips = false;
+
+        if (!preg_match('/^(?<version>[0-9.]+)(?<patch>[a-z]{0,2})?(?<suffix>(?:-?(?:dev|pre|alpha|beta|rc|fips)[\d]*)*)?$/', $opensslVersion, $matches)) {
+            return null;
+        }
+
+        $isFips = strpos($matches['suffix'], 'fips') !== false;
+        $suffix = strtr('-'.ltrim($matches['suffix'], '-'), array('-fips' => '', '-pre' => '-alpha'));
+        $patch = self::convertAlphaVersionToIntVersion($matches['patch']);
+
+        return rtrim($matches['version'].'.'.$patch.$suffix, '-');
+    }
+
+    /**
+     * @param  string      $libjpegVersion
+     * @return string|null
+     */
+    public static function parseLibjpeg($libjpegVersion)
+    {
+        if (!preg_match('/^(?<major>\d+)(?<minor>[a-z]*)$/', $libjpegVersion, $matches)) {
+            return null;
+        }
+
+        return $matches['major'].'.'.self::convertAlphaVersionToIntVersion($matches['minor']);
+    }
+
+    /**
+     * @param  string      $zoneinfoVersion
+     * @return string|null
+     */
+    public static function parseZoneinfoVersion($zoneinfoVersion)
+    {
+        if (!preg_match('/^(?<year>\d{4})(?<revision>[a-z]*)$/', $zoneinfoVersion, $matches)) {
+            return null;
+        }
+
+        return $matches['year'].'.'.self::convertAlphaVersionToIntVersion($matches['revision']);
+    }
+
+    /**
+     * "" => 0, "a" => 1, "zg" => 33
+     *
+     * @param  string $alpha
+     * @return int
+     */
+    private static function convertAlphaVersionToIntVersion($alpha)
+    {
+        return strlen($alpha) * (-ord('a') + 1) + array_sum(array_map('ord', str_split($alpha)));
+    }
+
+    /**
+     * @param  int    $versionId
+     * @return string
+     */
+    public static function convertLibxpmVersionId($versionId)
+    {
+        return self::convertVersionId($versionId, 100);
+    }
+
+    /**
+     * @param  int    $versionId
+     * @return string
+     */
+    public static function convertOpenldapVersionId($versionId)
+    {
+        return self::convertVersionId($versionId, 100);
+    }
+
+    private static function convertVersionId($versionId, $base)
+    {
+        return sprintf(
+            '%d.%d.%d',
+            $versionId / ($base * $base),
+            ($versionId / $base) % $base,
+            $versionId % $base
+        );
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Plugin/PluginEvents.php 2.0.9-1/src/Composer/Plugin/PluginEvents.php
--- 1.10.19-1/src/Composer/Plugin/PluginEvents.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Plugin/PluginEvents.php	2021-01-27 15:09:27.000000000 +0000
@@ -50,6 +50,16 @@ class PluginEvents
     const PRE_FILE_DOWNLOAD = 'pre-file-download';
 
     /**
+     * The POST_FILE_DOWNLOAD event occurs after downloading a package dist file
+     *
+     * The event listener method receives a
+     * Composer\Plugin\PostFileDownloadEvent instance.
+     *
+     * @var string
+     */
+    const POST_FILE_DOWNLOAD = 'post-file-download';
+
+    /**
      * The PRE_COMMAND_RUN event occurs before a command is executed and lets you modify the input arguments/options
      *
      * The event listener method receives a
@@ -58,4 +68,15 @@ class PluginEvents
      * @var string
      */
     const PRE_COMMAND_RUN = 'pre-command-run';
+
+    /**
+     * The PRE_POOL_CREATE event occurs before the Pool of packages is created, and lets
+     * you filter the list of packages which is going to enter the Solver
+     *
+     * The event listener method receives a
+     * Composer\Plugin\PrePoolCreateEvent instance.
+     *
+     * @var string
+     */
+    const PRE_POOL_CREATE = 'pre-pool-create';
 }
diff -pruN 1.10.19-1/src/Composer/Plugin/PluginInterface.php 2.0.9-1/src/Composer/Plugin/PluginInterface.php
--- 1.10.19-1/src/Composer/Plugin/PluginInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Plugin/PluginInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -25,9 +25,14 @@ interface PluginInterface
     /**
      * Version number of the internal composer-plugin-api package
      *
+     * This is used to denote the API version of Plugin specific
+     * features, but is also bumped to a new major if Composer
+     * includes a major break in internal APIs which are susceptible
+     * to be used by plugins.
+     *
      * @var string
      */
-    const PLUGIN_API_VERSION = '1.1.0';
+    const PLUGIN_API_VERSION = '2.0.0';
 
     /**
      * Apply plugin modifications to Composer
@@ -36,4 +41,26 @@ interface PluginInterface
      * @param IOInterface $io
      */
     public function activate(Composer $composer, IOInterface $io);
+
+    /**
+     * Remove any hooks from Composer
+     *
+     * This will be called when a plugin is deactivated before being
+     * uninstalled, but also before it gets upgraded to a new version
+     * so the old one can be deactivated and the new one activated.
+     *
+     * @param Composer    $composer
+     * @param IOInterface $io
+     */
+    public function deactivate(Composer $composer, IOInterface $io);
+
+    /**
+     * Prepare the plugin to be uninstalled
+     *
+     * This will be called after deactivate.
+     *
+     * @param Composer    $composer
+     * @param IOInterface $io
+     */
+    public function uninstall(Composer $composer, IOInterface $io);
 }
diff -pruN 1.10.19-1/src/Composer/Plugin/PluginManager.php 2.0.9-1/src/Composer/Plugin/PluginManager.php
--- 1.10.19-1/src/Composer/Plugin/PluginManager.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Plugin/PluginManager.php	2021-01-27 15:09:27.000000000 +0000
@@ -17,12 +17,14 @@ use Composer\EventDispatcher\EventSubscr
 use Composer\IO\IOInterface;
 use Composer\Package\CompletePackage;
 use Composer\Package\Package;
+use Composer\Package\RootPackage;
 use Composer\Package\Version\VersionParser;
 use Composer\Repository\RepositoryInterface;
+use Composer\Repository\InstalledRepository;
+use Composer\Repository\RootPackageRepository;
 use Composer\Package\PackageInterface;
 use Composer\Package\Link;
 use Composer\Semver\Constraint\Constraint;
-use Composer\DependencyResolver\Pool;
 use Composer\Plugin\Capability\Capability;
 use Composer\Util\PackageSorter;
 
@@ -34,15 +36,23 @@ use Composer\Util\PackageSorter;
  */
 class PluginManager
 {
+    /** @var Composer */
     protected $composer;
+    /** @var IOInterface */
     protected $io;
+    /** @var Composer */
     protected $globalComposer;
+    /** @var VersionParser */
     protected $versionParser;
+    /** @var bool */
     protected $disablePlugins = false;
 
+    /** @var array<PluginInterface> */
     protected $plugins = array();
+    /** @var array<string, PluginInterface> */
     protected $registeredPlugins = array();
 
+    /** @var int */
     private static $classCounter = 0;
 
     /**
@@ -74,10 +84,10 @@ class PluginManager
         $repo = $this->composer->getRepositoryManager()->getLocalRepository();
         $globalRepo = $this->globalComposer ? $this->globalComposer->getRepositoryManager()->getLocalRepository() : null;
         if ($repo) {
-            $this->loadRepository($repo);
+            $this->loadRepository($repo, false);
         }
         if ($globalRepo) {
-            $this->loadRepository($globalRepo);
+            $this->loadRepository($globalRepo, true);
         }
     }
 
@@ -109,10 +119,11 @@ class PluginManager
      *
      * @param PackageInterface $package
      * @param bool             $failOnMissingClasses By default this silently skips plugins that can not be found, but if set to true it fails with an exception
+     * @param bool             $isGlobalPlugin       Set to true to denote plugins which are installed in the global Composer directory
      *
      * @throws \UnexpectedValueException
      */
-    public function registerPackage(PackageInterface $package, $failOnMissingClasses = false)
+    public function registerPackage(PackageInterface $package, $failOnMissingClasses = false, $isGlobalPlugin = false)
     {
         if ($this->disablePlugins) {
             return;
@@ -134,10 +145,16 @@ class PluginManager
             $currentPluginApiVersion = $this->getPluginApiVersion();
             $currentPluginApiConstraint = new Constraint('==', $this->versionParser->normalize($currentPluginApiVersion));
 
-            if ($requiresComposer->getPrettyString() === '1.0.0' && $this->getPluginApiVersion() === '1.0.0') {
-                $this->io->writeError('<warning>The "' . $package->getName() . '" plugin requires composer-plugin-api 1.0.0, this *WILL* break in the future and it should be fixed ASAP (require ^1.0 for example).</warning>');
+            if ($requiresComposer->getPrettyString() === $this->getPluginApiVersion()) {
+                $this->io->writeError('<warning>The "' . $package->getName() . '" plugin requires composer-plugin-api '.$this->getPluginApiVersion().', this *WILL* break in the future and it should be fixed ASAP (require ^'.$this->getPluginApiVersion().' instead for example).</warning>');
             } elseif (!$requiresComposer->matches($currentPluginApiConstraint)) {
-                $this->io->writeError('<warning>The "' . $package->getName() . '" plugin was skipped because it requires a Plugin API version ("' . $requiresComposer->getPrettyString() . '") that does not match your Composer installation ("' . $currentPluginApiVersion . '"). You may need to run composer update with the "--no-plugins" option.</warning>');
+                $this->io->writeError('<warning>The "' . $package->getName() . '" plugin '.($isGlobalPlugin ? '(installed globally) ' : '').'was skipped because it requires a Plugin API version ("' . $requiresComposer->getPrettyString() . '") that does not match your Composer installation ("' . $currentPluginApiVersion . '"). You may need to run composer update with the "--no-plugins" option.</warning>');
+
+                return;
+            }
+
+            if ($package->getName() === 'symfony/flex' && preg_match('{^[0-9.]+$}', $package->getVersion()) && version_compare($package->getVersion(), '1.9.8', '<')) {
+                $this->io->writeError('<warning>The "' . $package->getName() . '" plugin '.($isGlobalPlugin ? '(installed globally) ' : '').'was skipped because it is not compatible with Composer 2+. Make sure to update it to version 1.9.8 or greater.</warning>');
 
                 return;
             }
@@ -145,7 +162,7 @@ class PluginManager
 
         $oldInstallerPlugin = ($package->getType() === 'composer-installer');
 
-        if (in_array($package->getName(), $this->registeredPlugins)) {
+        if (isset($this->registeredPlugins[$package->getName()])) {
             return;
         }
 
@@ -158,23 +175,28 @@ class PluginManager
         $localRepo = $this->composer->getRepositoryManager()->getLocalRepository();
         $globalRepo = $this->globalComposer ? $this->globalComposer->getRepositoryManager()->getLocalRepository() : null;
 
-        $pool = new Pool('dev');
-        $pool->addRepository($localRepo);
+        $rootPackage = clone $this->composer->getPackage();
+        $rootPackageRepo = new RootPackageRepository($rootPackage);
+        $installedRepo = new InstalledRepository(array($localRepo, $rootPackageRepo));
         if ($globalRepo) {
-            $pool->addRepository($globalRepo);
+            $installedRepo->addRepository($globalRepo);
         }
 
         $autoloadPackages = array($package->getName() => $package);
-        $autoloadPackages = $this->collectDependencies($pool, $autoloadPackages, $package);
+        $autoloadPackages = $this->collectDependencies($installedRepo, $autoloadPackages, $package);
 
         $generator = $this->composer->getAutoloadGenerator();
-        $autoloads = array();
+        $autoloads = array(array($rootPackage, ''));
         foreach ($autoloadPackages as $autoloadPackage) {
+            if ($autoloadPackage === $rootPackage) {
+                continue;
+            }
+
             $downloadPath = $this->getInstallPath($autoloadPackage, $globalRepo && $globalRepo->hasPackage($autoloadPackage));
             $autoloads[] = array($autoloadPackage, $downloadPath);
         }
 
-        $map = $generator->parseAutoloads($autoloads, new Package('dummy', '1.0.0.0', '1.0.0'));
+        $map = $generator->parseAutoloads($autoloads, $rootPackage);
         $classLoader = $generator->createLoader($map);
         $classLoader->register();
 
@@ -189,9 +211,11 @@ class PluginManager
                     $className = substr($class, $separatorPos + 1);
                 }
                 $code = preg_replace('{^((?:final\s+)?(?:\s*))class\s+('.preg_quote($className).')}mi', '$1class $2_composer_tmp'.self::$classCounter, $code, 1);
-                $code = str_replace('__FILE__', var_export($path, true), $code);
-                $code = str_replace('__DIR__', var_export(dirname($path), true), $code);
-                $code = str_replace('__CLASS__', var_export($class, true), $code);
+                $code = strtr($code, array(
+                    '__FILE__' => var_export($path, true),
+                    '__DIR__' => var_export(dirname($path), true),
+                    '__CLASS__' => var_export($class, true),
+                ));
                 $code = preg_replace('/^\s*<\?(php)?/i', '', $code, 1);
                 eval($code);
                 $class .= '_composer_tmp'.self::$classCounter;
@@ -201,10 +225,11 @@ class PluginManager
             if ($oldInstallerPlugin) {
                 $installer = new $class($this->io, $this->composer);
                 $this->composer->getInstallationManager()->addInstaller($installer);
+                $this->registeredPlugins[$package->getName()] = $installer;
             } elseif (class_exists($class)) {
                 $plugin = new $class();
-                $this->addPlugin($plugin);
-                $this->registeredPlugins[] = $package->getName();
+                $this->addPlugin($plugin, $isGlobalPlugin);
+                $this->registeredPlugins[$package->getName()] = $plugin;
             } elseif ($failOnMissingClasses) {
                 throw new \UnexpectedValueException('Plugin '.$package->getName().' could not be initialized, class not found: '.$class);
             }
@@ -212,6 +237,71 @@ class PluginManager
     }
 
     /**
+     * Deactivates a plugin package
+     *
+     * If it's of type composer-installer it is unregistered from the installers
+     * instead for BC
+     *
+     * @param PackageInterface $package
+     *
+     * @throws \UnexpectedValueException
+     */
+    public function deactivatePackage(PackageInterface $package)
+    {
+        if ($this->disablePlugins) {
+            return;
+        }
+
+        $oldInstallerPlugin = ($package->getType() === 'composer-installer');
+
+        if (!isset($this->registeredPlugins[$package->getName()])) {
+            return;
+        }
+
+        if ($oldInstallerPlugin) {
+            $installer = $this->registeredPlugins[$package->getName()];
+            unset($this->registeredPlugins[$package->getName()]);
+            $this->composer->getInstallationManager()->removeInstaller($installer);
+        } else {
+            $plugin = $this->registeredPlugins[$package->getName()];
+            unset($this->registeredPlugins[$package->getName()]);
+            $this->removePlugin($plugin);
+        }
+    }
+
+    /**
+     * Uninstall a plugin package
+     *
+     * If it's of type composer-installer it is unregistered from the installers
+     * instead for BC
+     *
+     * @param PackageInterface $package
+     *
+     * @throws \UnexpectedValueException
+     */
+    public function uninstallPackage(PackageInterface $package)
+    {
+        if ($this->disablePlugins) {
+            return;
+        }
+
+        $oldInstallerPlugin = ($package->getType() === 'composer-installer');
+
+        if (!isset($this->registeredPlugins[$package->getName()])) {
+            return;
+        }
+
+        if ($oldInstallerPlugin) {
+            $this->deactivatePackage($package);
+        } else {
+            $plugin = $this->registeredPlugins[$package->getName()];
+            unset($this->registeredPlugins[$package->getName()]);
+            $this->removePlugin($plugin);
+            $this->uninstallPlugin($plugin);
+        }
+    }
+
+    /**
      * Returns the version of the internal composer-plugin-api package.
      *
      * @return string
@@ -230,9 +320,9 @@ class PluginManager
      *
      * @param PluginInterface $plugin plugin instance
      */
-    public function addPlugin(PluginInterface $plugin)
+    public function addPlugin(PluginInterface $plugin, $isGlobalPlugin = false)
     {
-        $this->io->writeError('Loading plugin '.get_class($plugin), true, IOInterface::DEBUG);
+        $this->io->writeError('Loading plugin '.get_class($plugin).($isGlobalPlugin ? ' (installed globally)' : ''), true, IOInterface::DEBUG);
         $this->plugins[] = $plugin;
         $plugin->activate($this->composer, $this->io);
 
@@ -242,8 +332,48 @@ class PluginManager
     }
 
     /**
+     * Removes a plugin, deactivates it and removes any listener the plugin has set on the plugin instance
+     *
+     * Ideally plugin packages should be deactivated via deactivatePackage, but if you use Composer
+     * programmatically and want to deregister a plugin class directly this is a valid way
+     * to do it.
+     *
+     * @param PluginInterface $plugin plugin instance
+     */
+    public function removePlugin(PluginInterface $plugin)
+    {
+        $index = array_search($plugin, $this->plugins, true);
+        if ($index === false) {
+            return;
+        }
+
+        $this->io->writeError('Unloading plugin '.get_class($plugin), true, IOInterface::DEBUG);
+        unset($this->plugins[$index]);
+        $plugin->deactivate($this->composer, $this->io);
+
+        $this->composer->getEventDispatcher()->removeListener($plugin);
+    }
+
+    /**
+     * Notifies a plugin it is being uninstalled and should clean up
+     *
+     * Ideally plugin packages should be uninstalled via uninstallPackage, but if you use Composer
+     * programmatically and want to deregister a plugin class directly this is a valid way
+     * to do it.
+     *
+     * @param PluginInterface $plugin plugin instance
+     */
+    public function uninstallPlugin(PluginInterface $plugin)
+    {
+        $this->io->writeError('Uninstalling plugin '.get_class($plugin), true, IOInterface::DEBUG);
+        $plugin->uninstall($this->composer, $this->io);
+    }
+
+    /**
      * Load all plugins and installers from a repository
      *
+     * If a plugin requires another plugin, the required one will be loaded first
+     *
      * Note that plugins in the specified repository that rely on events that
      * have fired prior to loading will be missed. This means you likely want to
      * call this method as early as possible.
@@ -252,19 +382,19 @@ class PluginManager
      *
      * @throws \RuntimeException
      */
-    private function loadRepository(RepositoryInterface $repo)
+    private function loadRepository(RepositoryInterface $repo, $isGlobalRepo)
     {
         $packages = $repo->getPackages();
-        $sortedPackages = array_reverse(PackageSorter::sortPackages($packages));
+        $sortedPackages = PackageSorter::sortPackages($packages);
         foreach ($sortedPackages as $package) {
             if (!($package instanceof CompletePackage)) {
                 continue;
             }
             if ('composer-plugin' === $package->getType()) {
-                $this->registerPackage($package);
+                $this->registerPackage($package, false, $isGlobalRepo);
             // Backward compatibility
             } elseif ('composer-installer' === $package->getType()) {
-                $this->registerPackage($package);
+                $this->registerPackage($package, false, $isGlobalRepo);
             }
         }
     }
@@ -272,13 +402,13 @@ class PluginManager
     /**
      * Recursively generates a map of package names to packages for all deps
      *
-     * @param Pool             $pool      Package pool of installed packages
-     * @param array            $collected Current state of the map for recursion
-     * @param PackageInterface $package   The package to analyze
+     * @param InstalledRepository $installedRepo Set of local repos
+     * @param array               $collected     Current state of the map for recursion
+     * @param PackageInterface    $package       The package to analyze
      *
      * @return array Map of package names to packages
      */
-    private function collectDependencies(Pool $pool, array $collected, PackageInterface $package)
+    private function collectDependencies(InstalledRepository $installedRepo, array $collected, PackageInterface $package)
     {
         $requires = array_merge(
             $package->getRequires(),
@@ -286,10 +416,11 @@ class PluginManager
         );
 
         foreach ($requires as $requireLink) {
-            $requiredPackage = $this->lookupInstalledPackage($pool, $requireLink);
-            if ($requiredPackage && !isset($collected[$requiredPackage->getName()])) {
-                $collected[$requiredPackage->getName()] = $requiredPackage;
-                $collected = $this->collectDependencies($pool, $collected, $requiredPackage);
+            foreach ($installedRepo->findPackagesWithReplacersAndProviders($requireLink->getTarget()) as $requiredPackage) {
+                if (!isset($collected[$requiredPackage->getName()])) {
+                    $collected[$requiredPackage->getName()] = $requiredPackage;
+                    $collected = $this->collectDependencies($installedRepo, $collected, $requiredPackage);
+                }
             }
         }
 
@@ -297,23 +428,6 @@ class PluginManager
     }
 
     /**
-     * Resolves a package link to a package in the installed pool
-     *
-     * Since dependencies are already installed this should always find one.
-     *
-     * @param Pool $pool Pool of installed packages only
-     * @param Link $link Package link to look up
-     *
-     * @return PackageInterface|null The found package
-     */
-    private function lookupInstalledPackage(Pool $pool, Link $link)
-    {
-        $packages = $pool->whatProvides($link->getTarget(), $link->getConstraint());
-
-        return !empty($packages) ? $packages[0] : null;
-    }
-
-    /**
      * Retrieves the path a package is installed to.
      *
      * @param PackageInterface $package
diff -pruN 1.10.19-1/src/Composer/Plugin/PostFileDownloadEvent.php 2.0.9-1/src/Composer/Plugin/PostFileDownloadEvent.php
--- 1.10.19-1/src/Composer/Plugin/PostFileDownloadEvent.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Plugin/PostFileDownloadEvent.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,102 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Plugin;
+
+use Composer\EventDispatcher\Event;
+use Composer\Package\PackageInterface;
+
+/**
+ * The post file download event.
+ *
+ * @author Nils Adermann <naderman@naderman.de>
+ */
+class PostFileDownloadEvent extends Event
+{
+    /**
+     * @var string
+     */
+    private $fileName;
+
+    /**
+     * @var string|null
+     */
+    private $checksum;
+
+    /**
+     * @var string
+     */
+    private $url;
+
+    /**
+     * @var \Composer\Package\PackageInterface
+     */
+    private $package;
+
+    /**
+     * Constructor.
+     *
+     * @param string           $name     The event name
+     * @param string           $fileName The file name
+     * @param string|null      $checksum The checksum
+     * @param string           $url      The processed url
+     * @param PackageInterface $package  The package.
+     */
+    public function __construct($name, $fileName, $checksum, $url, PackageInterface $package)
+    {
+        parent::__construct($name);
+        $this->fileName = $fileName;
+        $this->checksum = $checksum;
+        $this->url = $url;
+        $this->package = $package;
+    }
+
+    /**
+     * Retrieves the target file name location.
+     *
+     * @return string
+     */
+    public function getFileName()
+    {
+        return $this->fileName;
+    }
+
+    /**
+     * Gets the checksum.
+     *
+     * @return string|null
+     */
+    public function getChecksum()
+    {
+        return $this->checksum;
+    }
+
+    /**
+     * Gets the processed URL.
+     *
+     * @return string
+     */
+    public function getUrl()
+    {
+        return $this->url;
+    }
+
+    /**
+     * Get the package.
+     *
+     * @return \Composer\Package\PackageInterface The package.
+     */
+    public function getPackage()
+    {
+        return $this->package;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Plugin/PreFileDownloadEvent.php 2.0.9-1/src/Composer/Plugin/PreFileDownloadEvent.php
--- 1.10.19-1/src/Composer/Plugin/PreFileDownloadEvent.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Plugin/PreFileDownloadEvent.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,7 +13,7 @@
 namespace Composer\Plugin;
 
 use Composer\EventDispatcher\Event;
-use Composer\Util\RemoteFilesystem;
+use Composer\Util\HttpDownloader;
 
 /**
  * The pre file download event.
@@ -23,9 +23,9 @@ use Composer\Util\RemoteFilesystem;
 class PreFileDownloadEvent extends Event
 {
     /**
-     * @var RemoteFilesystem
+     * @var HttpDownloader
      */
-    private $rfs;
+    private $httpDownloader;
 
     /**
      * @var string
@@ -33,46 +33,105 @@ class PreFileDownloadEvent extends Event
     private $processedUrl;
 
     /**
+     * @var string|null
+     */
+    private $customCacheKey;
+
+    /**
+     * @var string
+     */
+    private $type;
+
+    /**
+     * @var mixed
+     */
+    private $context;
+
+    /**
      * Constructor.
      *
-     * @param string           $name         The event name
-     * @param RemoteFilesystem $rfs
-     * @param string           $processedUrl
+     * @param string         $name           The event name
+     * @param HttpDownloader $httpDownloader
+     * @param string         $processedUrl
+     * @param string         $type
+     * @param mixed          $context
      */
-    public function __construct($name, RemoteFilesystem $rfs, $processedUrl)
+    public function __construct($name, HttpDownloader $httpDownloader, $processedUrl, $type, $context = null)
     {
         parent::__construct($name);
-        $this->rfs = $rfs;
+        $this->httpDownloader = $httpDownloader;
+        $this->processedUrl = $processedUrl;
+        $this->type = $type;
+        $this->context = $context;
+    }
+
+    /**
+     * @return HttpDownloader
+     */
+    public function getHttpDownloader()
+    {
+        return $this->httpDownloader;
+    }
+
+    /**
+     * Retrieves the processed URL that will be downloaded.
+     *
+     * @return string
+     */
+    public function getProcessedUrl()
+    {
+        return $this->processedUrl;
+    }
+
+    /**
+     * Sets the processed URL that will be downloaded.
+     *
+     * @param string $processedUrl New processed URL
+     */
+    public function setProcessedUrl($processedUrl)
+    {
         $this->processedUrl = $processedUrl;
     }
 
     /**
-     * Returns the remote filesystem
+     * Retrieves a custom package cache key for this download.
      *
-     * @return RemoteFilesystem
+     * @return string|null
      */
-    public function getRemoteFilesystem()
+    public function getCustomCacheKey()
     {
-        return $this->rfs;
+        return $this->customCacheKey;
     }
 
     /**
-     * Sets the remote filesystem
+     * Sets a custom package cache key for this download.
      *
-     * @param RemoteFilesystem $rfs
+     * @param string|null $customCacheKey New cache key
      */
-    public function setRemoteFilesystem(RemoteFilesystem $rfs)
+    public function setCustomCacheKey($customCacheKey)
     {
-        $this->rfs = $rfs;
+        $this->customCacheKey = $customCacheKey;
     }
 
     /**
-     * Retrieves the processed URL this remote filesystem will be used for
+     * Returns the type of this download (package, metadata).
      *
      * @return string
      */
-    public function getProcessedUrl()
+    public function getType()
     {
-        return $this->processedUrl;
+        return $this->type;
+    }
+
+    /**
+     * Returns the context of this download, if any.
+     *
+     * If this download is of type package, the package object is returned.
+     *
+     * @return mixed
+     */
+    public function getContext()
+    {
+        return $this->context;
     }
 }
diff -pruN 1.10.19-1/src/Composer/Plugin/PrePoolCreateEvent.php 2.0.9-1/src/Composer/Plugin/PrePoolCreateEvent.php
--- 1.10.19-1/src/Composer/Plugin/PrePoolCreateEvent.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Plugin/PrePoolCreateEvent.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,158 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Plugin;
+
+use Composer\EventDispatcher\Event;
+use Composer\Repository\RepositoryInterface;
+use Composer\DependencyResolver\Request;
+use Composer\Package\PackageInterface;
+
+/**
+ * The pre command run event.
+ *
+ * @author Jordi Boggiano <j.boggiano@seld.be>
+ */
+class PrePoolCreateEvent extends Event
+{
+    /**
+     * @var RepositoryInterface[]
+     */
+    private $repositories;
+    /**
+     * @var Request
+     */
+    private $request;
+    /**
+     * @var array
+     */
+    private $acceptableStabilities;
+    /**
+     * @var array
+     */
+    private $stabilityFlags;
+    /**
+     * @var array
+     */
+    private $rootAliases;
+    /**
+     * @var array
+     */
+    private $rootReferences;
+    /**
+     * @var PackageInterface[]
+     */
+    private $packages;
+    /**
+     * @var PackageInterface[]
+     */
+    private $unacceptableFixedPackages;
+
+    /**
+     * @param string                $name         The event name
+     * @param RepositoryInterface[] $repositories
+     */
+    public function __construct($name, array $repositories, Request $request, array $acceptableStabilities, array $stabilityFlags, array $rootAliases, array $rootReferences, array $packages, array $unacceptableFixedPackages)
+    {
+        parent::__construct($name);
+
+        $this->repositories = $repositories;
+        $this->request = $request;
+        $this->acceptableStabilities = $acceptableStabilities;
+        $this->stabilityFlags = $stabilityFlags;
+        $this->rootAliases = $rootAliases;
+        $this->rootReferences = $rootReferences;
+        $this->packages = $packages;
+        $this->unacceptableFixedPackages = $unacceptableFixedPackages;
+    }
+
+    /**
+     * @return RepositoryInterface[]
+     */
+    public function getRepositories()
+    {
+        return $this->repositories;
+    }
+
+    /**
+     * @return Request
+     */
+    public function getRequest()
+    {
+        return $this->request;
+    }
+
+    /**
+     * @return array
+     */
+    public function getAcceptableStabilities()
+    {
+        return $this->acceptableStabilities;
+    }
+
+    /**
+     * @return array
+     */
+    public function getStabilityFlags()
+    {
+        return $this->stabilityFlags;
+    }
+
+    /**
+     * @return array[] of package => version => [alias, alias_normalized]
+     * @psalm-return array<string, array<string, array{alias: string, alias_normalized: string}>>
+     */
+    public function getRootAliases()
+    {
+        return $this->rootAliases;
+    }
+
+    /**
+     * @return array
+     */
+    public function getRootReferences()
+    {
+        return $this->rootReferences;
+    }
+
+    /**
+     * @return PackageInterface[]
+     */
+    public function getPackages()
+    {
+        return $this->packages;
+    }
+
+    /**
+     * @return PackageInterface[]
+     */
+    public function getUnacceptableFixedPackages()
+    {
+        return $this->unacceptableFixedPackages;
+    }
+
+    /**
+     * @param PackageInterface[] $packages
+     */
+    public function setPackages(array $packages)
+    {
+        $this->packages = $packages;
+    }
+
+    /**
+     * @param PackageInterface[] $packages
+     */
+    public function setUnacceptableFixedPackages(array $packages)
+    {
+        $this->unacceptableFixedPackages = $packages;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Repository/ArrayRepository.php 2.0.9-1/src/Composer/Repository/ArrayRepository.php
--- 1.10.19-1/src/Composer/Repository/ArrayRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/ArrayRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,6 +16,7 @@ use Composer\Package\AliasPackage;
 use Composer\Package\PackageInterface;
 use Composer\Package\CompletePackageInterface;
 use Composer\Package\Version\VersionParser;
+use Composer\Package\Version\StabilityFilter;
 use Composer\Semver\Constraint\ConstraintInterface;
 use Composer\Semver\Constraint\Constraint;
 
@@ -24,14 +25,14 @@ use Composer\Semver\Constraint\Constrain
  *
  * @author Nils Adermann <naderman@naderman.de>
  */
-class ArrayRepository extends BaseRepository
+class ArrayRepository implements RepositoryInterface
 {
     /** @var PackageInterface[] */
     protected $packages;
-    
-    /** 
-      * @var PackageInterface[] indexed by package unique name and used to cache hasPackage calls
-      */
+
+    /**
+     * @var PackageInterface[] indexed by package unique name and used to cache hasPackage calls
+     */
     protected $packageMap;
 
     public function __construct(array $packages = array())
@@ -41,6 +42,51 @@ class ArrayRepository extends BaseReposi
         }
     }
 
+    public function getRepoName()
+    {
+        return 'array repo (defining '.$this->count().' package'.($this->count() > 1 ? 's' : '').')';
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function loadPackages(array $packageMap, array $acceptableStabilities, array $stabilityFlags, array $alreadyLoaded = array())
+    {
+        $packages = $this->getPackages();
+
+        $result = array();
+        $namesFound = array();
+        foreach ($packages as $package) {
+            if (array_key_exists($package->getName(), $packageMap)) {
+                if (
+                    (!$packageMap[$package->getName()] || $packageMap[$package->getName()]->matches(new Constraint('==', $package->getVersion())))
+                    && StabilityFilter::isPackageAcceptable($acceptableStabilities, $stabilityFlags, $package->getNames(), $package->getStability())
+                    && !isset($alreadyLoaded[$package->getName()][$package->getVersion()])
+                ) {
+                    // add selected packages which match stability requirements
+                    $result[spl_object_hash($package)] = $package;
+                    // add the aliased package for packages where the alias matches
+                    if ($package instanceof AliasPackage && !isset($result[spl_object_hash($package->getAliasOf())])) {
+                        $result[spl_object_hash($package->getAliasOf())] = $package->getAliasOf();
+                    }
+                }
+
+                $namesFound[$package->getName()] = true;
+            }
+        }
+
+        // add aliases of packages that were selected, even if the aliases did not match
+        foreach ($packages as $package) {
+            if ($package instanceof AliasPackage) {
+                if (isset($result[spl_object_hash($package->getAliasOf())])) {
+                    $result[spl_object_hash($package)] = $package;
+                }
+            }
+        }
+
+        return array('namesFound' => array_keys($namesFound), 'packages' => $result);
+    }
+
     /**
      * {@inheritDoc}
      */
@@ -81,8 +127,7 @@ class ArrayRepository extends BaseReposi
 
         foreach ($this->getPackages() as $package) {
             if ($name === $package->getName()) {
-                $pkgConstraint = new Constraint('==', $package->getVersion());
-                if (null === $constraint || $constraint->matches($pkgConstraint)) {
+                if (null === $constraint || $constraint->matches(new Constraint('==', $package->getVersion()))) {
                     $packages[] = $package;
                 }
             }
@@ -160,6 +205,32 @@ class ArrayRepository extends BaseReposi
         $this->packageMap = null;
     }
 
+    /**
+     * {@inheritDoc}
+     */
+    public function getProviders($packageName)
+    {
+        $result = array();
+
+        foreach ($this->getPackages() as $candidate) {
+            if (isset($result[$candidate->getName()])) {
+                continue;
+            }
+            foreach ($candidate->getProvides() as $link) {
+                if ($packageName === $link->getTarget()) {
+                    $result[$candidate->getName()] = array(
+                        'name' => $candidate->getName(),
+                        'description' => $candidate->getDescription(),
+                        'type' => $candidate->getType(),
+                    );
+                    continue 2;
+                }
+            }
+        }
+
+        return $result;
+    }
+
     protected function createAliasPackage(PackageInterface $package, $alias, $prettyAlias)
     {
         return new AliasPackage($package instanceof AliasPackage ? $package->getAliasOf() : $package, $alias, $prettyAlias);
@@ -205,6 +276,10 @@ class ArrayRepository extends BaseReposi
      */
     public function count()
     {
+        if (null === $this->packages) {
+            $this->initialize();
+        }
+
         return count($this->packages);
     }
 
diff -pruN 1.10.19-1/src/Composer/Repository/ArtifactRepository.php 2.0.9-1/src/Composer/Repository/ArtifactRepository.php
--- 1.10.19-1/src/Composer/Repository/ArtifactRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/ArtifactRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,6 +16,7 @@ use Composer\IO\IOInterface;
 use Composer\Json\JsonFile;
 use Composer\Package\Loader\ArrayLoader;
 use Composer\Package\Loader\LoaderInterface;
+use Composer\Util\Tar;
 use Composer\Util\Zip;
 
 /**
@@ -43,6 +44,11 @@ class ArtifactRepository extends ArrayRe
         $this->repoConfig = $repoConfig;
     }
 
+    public function getRepoName()
+    {
+        return 'artifact repo ('.$this->lookup.')';
+    }
+
     public function getRepoConfig()
     {
         return $this->repoConfig;
@@ -61,7 +67,7 @@ class ArtifactRepository extends ArrayRe
 
         $directory = new \RecursiveDirectoryIterator($path, \RecursiveDirectoryIterator::FOLLOW_SYMLINKS);
         $iterator = new \RecursiveIteratorIterator($directory);
-        $regex = new \RegexIterator($iterator, '/^.+\.(zip|phar)$/i');
+        $regex = new \RegexIterator($iterator, '/^.+\.(zip|phar|tar|gz|tgz)$/i');
         foreach ($regex as $file) {
             /* @var $file \SplFileInfo */
             if (!$file->isFile()) {
@@ -83,7 +89,26 @@ class ArtifactRepository extends ArrayRe
 
     private function getComposerInformation(\SplFileInfo $file)
     {
-        $json = Zip::getComposerJson($file->getPathname());
+        $json = null;
+        $fileType = null;
+        $fileExtension = pathinfo($file->getPathname(), PATHINFO_EXTENSION);
+        if (in_array($fileExtension, array('gz', 'tar', 'tgz'), true)) {
+            $fileType = 'tar';
+        } elseif ($fileExtension === 'zip') {
+            $fileType = 'zip';
+        } else {
+            throw new \RuntimeException('Files with "'.$fileExtension.'" extensions aren\'t supported. Only ZIP and TAR/TAR.GZ/TGZ archives are supported.');
+        }
+
+        try {
+            if ($fileType === 'tar') {
+                $json = Tar::getComposerJson($file->getPathname());
+            } else {
+                $json = Zip::getComposerJson($file->getPathname());
+            }
+        } catch (\Exception $exception) {
+            $this->io->write('Failed loading package '.$file->getPathname().': '.$exception->getMessage(), false, IOInterface::VERBOSE);
+        }
 
         if (null === $json) {
             return false;
@@ -91,7 +116,7 @@ class ArtifactRepository extends ArrayRe
 
         $package = JsonFile::parseJson($json, $file->getPathname().'#composer.json');
         $package['dist'] = array(
-            'type' => 'zip',
+            'type' => $fileType,
             'url' => strtr($file->getPathname(), '\\', '/'),
             'shasum' => sha1_file($file->getRealPath()),
         );
diff -pruN 1.10.19-1/src/Composer/Repository/BaseRepository.php 2.0.9-1/src/Composer/Repository/BaseRepository.php
--- 1.10.19-1/src/Composer/Repository/BaseRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/BaseRepository.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,189 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Repository;
-
-use Composer\Package\RootPackageInterface;
-use Composer\Semver\Constraint\ConstraintInterface;
-use Composer\Semver\Constraint\Constraint;
-use Composer\Package\Link;
-
-/**
- * Common ancestor class for generic repository functionality.
- *
- * @author Niels Keurentjes <niels.keurentjes@omines.com>
- */
-abstract class BaseRepository implements RepositoryInterface
-{
-    /**
-     * Returns a list of links causing the requested needle packages to be installed, as an associative array with the
-     * dependent's name as key, and an array containing in order the PackageInterface and Link describing the relationship
-     * as values. If recursive lookup was requested a third value is returned containing an identically formed array up
-     * to the root package. That third value will be false in case a circular recursion was detected.
-     *
-     * @param  string|string[]          $needle        The package name(s) to inspect.
-     * @param  ConstraintInterface|null $constraint    Optional constraint to filter by.
-     * @param  bool                     $invert        Whether to invert matches to discover reasons for the package *NOT* to be installed.
-     * @param  bool                     $recurse       Whether to recursively expand the requirement tree up to the root package.
-     * @param  string[]                 $packagesFound Used internally when recurring
-     * @return array                    An associative array of arrays as described above.
-     */
-    public function getDependents($needle, $constraint = null, $invert = false, $recurse = true, $packagesFound = null)
-    {
-        $needles = array_map('strtolower', (array) $needle);
-        $results = array();
-
-        // initialize the array with the needles before any recursion occurs
-        if (null === $packagesFound) {
-            $packagesFound = $needles;
-        }
-
-        // locate root package for use below
-        $rootPackage = null;
-        foreach ($this->getPackages() as $package) {
-            if ($package instanceof RootPackageInterface) {
-                $rootPackage = $package;
-                break;
-            }
-        }
-
-        // Loop over all currently installed packages.
-        foreach ($this->getPackages() as $package) {
-            $links = $package->getRequires();
-
-            // each loop needs its own "tree" as we want to show the complete dependent set of every needle
-            // without warning all the time about finding circular deps
-            $packagesInTree = $packagesFound;
-
-            // Replacements are considered valid reasons for a package to be installed during forward resolution
-            if (!$invert) {
-                $links += $package->getReplaces();
-
-                // On forward search, check if any replaced package was required and add the replaced
-                // packages to the list of needles. Contrary to the cross-reference link check below,
-                // replaced packages are the target of links.
-                foreach ($package->getReplaces() as $link) {
-                    foreach ($needles as $needle) {
-                        if ($link->getSource() === $needle) {
-                            if ($constraint === null || ($link->getConstraint()->matches($constraint) === !$invert)) {
-                                // already displayed this node's dependencies, cutting short
-                                if (in_array($link->getTarget(), $packagesInTree)) {
-                                    $results[] = array($package, $link, false);
-                                    continue;
-                                }
-                                $packagesInTree[] = $link->getTarget();
-                                $dependents = $recurse ? $this->getDependents($link->getTarget(), null, false, true, $packagesInTree) : array();
-                                $results[] = array($package, $link, $dependents);
-                                $needles[] = $link->getTarget();
-                            }
-                        }
-                    }
-                }
-            }
-
-            // Require-dev is only relevant for the root package
-            if ($package instanceof RootPackageInterface) {
-                $links += $package->getDevRequires();
-            }
-
-            // Cross-reference all discovered links to the needles
-            foreach ($links as $link) {
-                foreach ($needles as $needle) {
-                    if ($link->getTarget() === $needle) {
-                        if ($constraint === null || ($link->getConstraint()->matches($constraint) === !$invert)) {
-                            // already displayed this node's dependencies, cutting short
-                            if (in_array($link->getSource(), $packagesInTree)) {
-                                $results[] = array($package, $link, false);
-                                continue;
-                            }
-                            $packagesInTree[] = $link->getSource();
-                            $dependents = $recurse ? $this->getDependents($link->getSource(), null, false, true, $packagesInTree) : array();
-                            $results[] = array($package, $link, $dependents);
-                        }
-                    }
-                }
-            }
-
-            // When inverting, we need to check for conflicts of the needles against installed packages
-            if ($invert && in_array($package->getName(), $needles)) {
-                foreach ($package->getConflicts() as $link) {
-                    foreach ($this->findPackages($link->getTarget()) as $pkg) {
-                        $version = new Constraint('=', $pkg->getVersion());
-                        if ($link->getConstraint()->matches($version) === $invert) {
-                            $results[] = array($package, $link, false);
-                        }
-                    }
-                }
-            }
-
-            // When inverting, we need to check for conflicts of the needles' requirements against installed packages
-            if ($invert && $constraint && in_array($package->getName(), $needles) && $constraint->matches(new Constraint('=', $package->getVersion()))) {
-                foreach ($package->getRequires() as $link) {
-                    if (preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $link->getTarget())) {
-                        if ($this->findPackage($link->getTarget(), $link->getConstraint())) {
-                            continue;
-                        }
-
-                        $platformPkg = $this->findPackage($link->getTarget(), '*');
-                        $description = $platformPkg ? 'but '.$platformPkg->getPrettyVersion().' is installed' : 'but it is missing';
-                        $results[] = array($package, new Link($package->getName(), $link->getTarget(), null, 'requires', $link->getPrettyConstraint().' '.$description), false);
-
-                        continue;
-                    }
-
-                    foreach ($this->getPackages() as $pkg) {
-                        if (!in_array($link->getTarget(), $pkg->getNames())) {
-                            continue;
-                        }
-
-                        $version = new Constraint('=', $pkg->getVersion());
-
-                        if ($link->getTarget() !== $pkg->getName()) {
-                            foreach (array_merge($pkg->getReplaces(), $pkg->getProvides()) as $prov) {
-                                if ($link->getTarget() === $prov->getTarget()) {
-                                    $version = $prov->getConstraint();
-                                    break;
-                                }
-                            }
-                        }
-
-                        if (!$link->getConstraint()->matches($version)) {
-                            // if we have a root package (we should but can not guarantee..) we show
-                            // the root requires as well to perhaps allow to find an issue there
-                            if ($rootPackage) {
-                                foreach (array_merge($rootPackage->getRequires(), $rootPackage->getDevRequires()) as $rootReq) {
-                                    if (in_array($rootReq->getTarget(), $pkg->getNames()) && !$rootReq->getConstraint()->matches($link->getConstraint())) {
-                                        $results[] = array($package, $link, false);
-                                        $results[] = array($rootPackage, $rootReq, false);
-                                        continue 3;
-                                    }
-                                }
-
-                                $results[] = array($package, $link, false);
-                                $results[] = array($rootPackage, new Link($rootPackage->getName(), $link->getTarget(), null, 'does not require', 'but ' . $pkg->getPrettyVersion() . ' is installed'), false);
-                            } else {
-                                // no root so let's just print whatever we found
-                                $results[] = array($package, $link, false);
-                            }
-                        }
-
-                        continue 2;
-                    }
-                }
-            }
-        }
-
-        ksort($results);
-
-        return $results;
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Repository/ComposerRepository.php 2.0.9-1/src/Composer/Repository/ComposerRepository.php
--- 1.10.19-1/src/Composer/Repository/ComposerRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/ComposerRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,58 +12,88 @@
 
 namespace Composer\Repository;
 
+use Composer\Package\BasePackage;
 use Composer\Package\Loader\ArrayLoader;
 use Composer\Package\PackageInterface;
 use Composer\Package\AliasPackage;
 use Composer\Package\Version\VersionParser;
-use Composer\DependencyResolver\Pool;
+use Composer\Package\Version\StabilityFilter;
 use Composer\Json\JsonFile;
 use Composer\Cache;
 use Composer\Config;
-use Composer\Composer;
-use Composer\Factory;
 use Composer\IO\IOInterface;
-use Composer\Util\RemoteFilesystem;
+use Composer\Semver\CompilingMatcher;
+use Composer\Util\HttpDownloader;
+use Composer\Util\Loop;
 use Composer\Plugin\PluginEvents;
 use Composer\Plugin\PreFileDownloadEvent;
 use Composer\EventDispatcher\EventDispatcher;
 use Composer\Downloader\TransportException;
 use Composer\Semver\Constraint\ConstraintInterface;
 use Composer\Semver\Constraint\Constraint;
+use Composer\Semver\Constraint\MatchAllConstraint;
+use Composer\Util\Http\Response;
+use Composer\Util\MetadataMinifier;
+use Composer\Util\Url;
 
 /**
  * @author Jordi Boggiano <j.boggiano@seld.be>
  */
 class ComposerRepository extends ArrayRepository implements ConfigurableRepositoryInterface
 {
-    protected $config;
-    protected $repoConfig;
-    protected $options;
-    protected $url;
-    protected $baseUrl;
-    protected $io;
-    protected $rfs;
+    private $repoConfig;
+    private $options;
+    private $url;
+    private $baseUrl;
+    private $io;
+    private $httpDownloader;
+    private $loop;
     protected $cache;
     protected $notifyUrl;
     protected $searchUrl;
+    /** @var string|null a URL containing %package% which can be queried to get providers of a given name */
+    protected $providersApiUrl;
     protected $hasProviders = false;
     protected $providersUrl;
+    protected $listUrl;
+    /** @var bool Indicates whether a comprehensive list of packages this repository might provide is expressed in the repository root. **/
+    protected $hasAvailablePackageList = false;
+    protected $availablePackages;
+    protected $availablePackagePatterns;
     protected $lazyProvidersUrl;
     protected $providerListing;
-    protected $providers = array();
-    protected $providersByUid = array();
     protected $loader;
-    protected $rootAliases;
-    protected $allowSslDowngrade = false;
-    protected $eventDispatcher;
-    protected $sourceMirrors;
-    protected $distMirrors;
+    private $allowSslDowngrade = false;
+    private $eventDispatcher;
+    private $sourceMirrors;
+    private $distMirrors;
     private $degradedMode = false;
     private $rootData;
     private $hasPartialPackages;
     private $partialPackagesByName;
 
-    public function __construct(array $repoConfig, IOInterface $io, Config $config, EventDispatcher $eventDispatcher = null, RemoteFilesystem $rfs = null)
+    /**
+     * TODO v3 should make this private once we can drop PHP 5.3 support
+     * @private
+     * @var array list of package names which are fresh and can be loaded from the cache directly in case loadPackage is called several times
+     *            useful for v2 metadata repositories with lazy providers
+     */
+    public $freshMetadataUrls = array();
+
+    /**
+     * TODO v3 should make this private once we can drop PHP 5.3 support
+     * @private
+     * @var array list of package names which returned a 404 and should not be re-fetched in case loadPackage is called several times
+     *            useful for v2 metadata repositories with lazy providers
+     */
+    public $packagesNotFoundCache = array();
+    /**
+     * TODO v3 should make this private once we can drop PHP 5.3 support
+     * @private
+     */
+    public $versionParser;
+
+    public function __construct(array $repoConfig, IOInterface $io, Config $config, HttpDownloader $httpDownloader, EventDispatcher $eventDispatcher = null)
     {
         parent::__construct();
         if (!preg_match('{^[\w.]+\??://}', $repoConfig['url'])) {
@@ -72,7 +102,7 @@ class ComposerRepository extends ArrayRe
         }
         $repoConfig['url'] = rtrim($repoConfig['url'], '/');
 
-        if ('https?' === substr($repoConfig['url'], 0, 6)) {
+        if (strpos($repoConfig['url'], 'https?') === 0) {
             $repoConfig['url'] = (extension_loaded('openssl') ? 'https' : 'http') . substr($repoConfig['url'], 6);
         }
 
@@ -88,7 +118,6 @@ class ComposerRepository extends ArrayRe
             $this->allowSslDowngrade = true;
         }
 
-        $this->config = $config;
         $this->options = $repoConfig['options'];
         $this->url = $repoConfig['url'];
 
@@ -99,25 +128,24 @@ class ComposerRepository extends ArrayRe
 
         $this->baseUrl = rtrim(preg_replace('{(?:/[^/\\\\]+\.json)?(?:[?#].*)?$}', '', $this->url), '/');
         $this->io = $io;
-        $this->cache = new Cache($io, $config->get('cache-repo-dir').'/'.preg_replace('{[^a-z0-9.]}i', '-', $this->url), 'a-z0-9.$');
-        $this->loader = new ArrayLoader();
-        if ($rfs && $this->options) {
-            $rfs = clone $rfs;
-            $rfs->setOptions($this->options);
-        }
-        $this->rfs = $rfs ?: Factory::createRemoteFilesystem($this->io, $this->config, $this->options);
+        $this->cache = new Cache($io, $config->get('cache-repo-dir').'/'.preg_replace('{[^a-z0-9.]}i', '-', Url::sanitize($this->url)), 'a-z0-9.$~');
+        $this->cache->setReadOnly($config->get('cache-read-only'));
+        $this->versionParser = new VersionParser();
+        $this->loader = new ArrayLoader($this->versionParser);
+        $this->httpDownloader = $httpDownloader;
         $this->eventDispatcher = $eventDispatcher;
         $this->repoConfig = $repoConfig;
+        $this->loop = new Loop($this->httpDownloader);
     }
 
-    public function getRepoConfig()
+    public function getRepoName()
     {
-        return $this->repoConfig;
+        return 'composer repo ('.Url::sanitize($this->url).')';
     }
 
-    public function setRootAliases(array $rootAliases)
+    public function getRepoConfig()
     {
-        $this->rootAliases = $rootAliases;
+        return $this->repoConfig;
     }
 
     /**
@@ -125,30 +153,39 @@ class ComposerRepository extends ArrayRe
      */
     public function findPackage($name, $constraint)
     {
-        if (!$this->hasProviders()) {
-            return parent::findPackage($name, $constraint);
-        }
+        // this call initializes loadRootServerFile which is needed for the rest below to work
+        $hasProviders = $this->hasProviders();
 
         $name = strtolower($name);
         if (!$constraint instanceof ConstraintInterface) {
-            $versionParser = new VersionParser();
-            $constraint = $versionParser->parseConstraints($constraint);
+            $constraint = $this->versionParser->parseConstraints($constraint);
         }
 
-        foreach ($this->getProviderNames() as $providerName) {
-            if ($name === $providerName) {
-                $packages = $this->whatProvides(new Pool('dev'), $providerName);
-                foreach ($packages as $package) {
-                    if ($name === $package->getName()) {
-                        $pkgConstraint = new Constraint('==', $package->getVersion());
-                        if ($constraint->matches($pkgConstraint)) {
-                            return $package;
-                        }
-                    }
+        if ($this->lazyProvidersUrl) {
+            if ($this->hasPartialPackages() && isset($this->partialPackagesByName[$name])) {
+                return $this->filterPackages($this->whatProvides($name), $constraint, true);
+            }
+
+            if ($this->hasAvailablePackageList && !$this->lazyProvidersRepoContains($name)) {
+                return;
+            }
+
+            $packages = $this->loadAsyncPackages(array($name => $constraint));
+
+            return reset($packages['packages']);
+        }
+
+        if ($hasProviders) {
+            foreach ($this->getProviderNames() as $providerName) {
+                if ($name === $providerName) {
+                    return $this->filterPackages($this->whatProvides($providerName), $constraint, true);
                 }
-                break;
             }
+
+            return;
         }
+
+        return parent::findPackage($name, $constraint);
     }
 
     /**
@@ -156,46 +193,221 @@ class ComposerRepository extends ArrayRe
      */
     public function findPackages($name, $constraint = null)
     {
-        if (!$this->hasProviders()) {
-            return parent::findPackages($name, $constraint);
-        }
-        // normalize name
-        $name = strtolower($name);
+        // this call initializes loadRootServerFile which is needed for the rest below to work
+        $hasProviders = $this->hasProviders();
 
+        $name = strtolower($name);
         if (null !== $constraint && !$constraint instanceof ConstraintInterface) {
-            $versionParser = new VersionParser();
-            $constraint = $versionParser->parseConstraints($constraint);
+            $constraint = $this->versionParser->parseConstraints($constraint);
         }
 
-        $packages = array();
+        if ($this->lazyProvidersUrl) {
+            if ($this->hasPartialPackages() && isset($this->partialPackagesByName[$name])) {
+                return $this->filterPackages($this->whatProvides($name), $constraint);
+            }
 
-        foreach ($this->getProviderNames() as $providerName) {
-            if ($name === $providerName) {
-                $candidates = $this->whatProvides(new Pool('dev'), $providerName);
-                foreach ($candidates as $package) {
-                    if ($name === $package->getName()) {
-                        $pkgConstraint = new Constraint('==', $package->getVersion());
-                        if (null === $constraint || $constraint->matches($pkgConstraint)) {
-                            $packages[] = $package;
-                        }
-                    }
+            if ($this->hasAvailablePackageList && !$this->lazyProvidersRepoContains($name)) {
+                return array();
+            }
+
+            $result = $this->loadAsyncPackages(array($name => $constraint));
+
+            return $result['packages'];
+        }
+
+        if ($hasProviders) {
+            foreach ($this->getProviderNames() as $providerName) {
+                if ($name === $providerName) {
+                    return $this->filterPackages($this->whatProvides($providerName), $constraint);
                 }
-                break;
             }
+
+            return array();
         }
 
-        return $packages;
+        return parent::findPackages($name, $constraint);
+    }
+
+    private function filterPackages(array $packages, $constraint = null, $returnFirstMatch = false)
+    {
+        if (null === $constraint) {
+            if ($returnFirstMatch) {
+                return reset($packages);
+            }
+
+            return $packages;
+        }
+
+        $filteredPackages = array();
+
+        foreach ($packages as $package) {
+            $pkgConstraint = new Constraint('==', $package->getVersion());
+
+            if ($constraint->matches($pkgConstraint)) {
+                if ($returnFirstMatch) {
+                    return $package;
+                }
+
+                $filteredPackages[] = $package;
+            }
+        }
+
+        if ($returnFirstMatch) {
+            return null;
+        }
+
+        return $filteredPackages;
     }
 
     public function getPackages()
     {
-        if ($this->hasProviders()) {
-            throw new \LogicException('Composer repositories that have providers can not load the complete list of packages, use getProviderNames instead.');
+        $hasProviders = $this->hasProviders();
+
+        if ($this->lazyProvidersUrl) {
+            if (is_array($this->availablePackages) && !$this->availablePackagePatterns) {
+                $packageMap = array();
+                foreach ($this->availablePackages as $name) {
+                    $packageMap[$name] = new MatchAllConstraint();
+                }
+
+                $result = $this->loadAsyncPackages($packageMap);
+
+                return array_values($result['packages']);
+            }
+
+            if ($this->hasPartialPackages()) {
+                return array_values($this->partialPackagesByName);
+            }
+
+            throw new \LogicException('Composer repositories that have lazy providers and no available-packages list can not load the complete list of packages, use getPackageNames instead.');
+        }
+
+        if ($hasProviders) {
+            throw new \LogicException('Composer repositories that have providers can not load the complete list of packages, use getPackageNames instead.');
         }
 
         return parent::getPackages();
     }
 
+    public function getPackageNames($packageFilter = null)
+    {
+        $hasProviders = $this->hasProviders();
+
+        $packageFilterCb = function ($name) {
+            return true;
+        };
+        if (null !== $packageFilter) {
+            $packageFilterRegex = '{^'.str_replace('\\*', '.*?', preg_quote($packageFilter)).'$}i';
+            $packageFilterCb = function ($name) use ($packageFilterRegex) {
+                return (bool) preg_match($packageFilterRegex, $name);
+            };
+        }
+
+        if ($this->lazyProvidersUrl) {
+            if (is_array($this->availablePackages)) {
+                return array_filter(array_keys($this->availablePackages), $packageFilterCb);
+            }
+
+            if ($this->listUrl) {
+                $url = $this->listUrl;
+                if ($packageFilter) {
+                    $url .= '?filter='.urlencode($packageFilter);
+                }
+
+                $result = $this->httpDownloader->get($url, $this->options)->decodeJson();
+
+                return $result['packageNames'];
+            }
+
+            if ($this->hasPartialPackages()) {
+                return array_filter(array_keys($this->partialPackagesByName), $packageFilterCb);
+            }
+
+            return array();
+        }
+
+        if ($hasProviders) {
+            return array_filter($this->getProviderNames(), $packageFilterCb);
+        }
+
+        $names = array();
+        foreach ($this->getPackages() as $package) {
+            if ($packageFilterCb($package->getName())) {
+                $names[] = $package->getPrettyName();
+            }
+        }
+
+        return $names;
+    }
+
+    public function loadPackages(array $packageNameMap, array $acceptableStabilities, array $stabilityFlags, array $alreadyLoaded = array())
+    {
+        // this call initializes loadRootServerFile which is needed for the rest below to work
+        $hasProviders = $this->hasProviders();
+
+        if (!$hasProviders && !$this->hasPartialPackages() && !$this->lazyProvidersUrl) {
+            return parent::loadPackages($packageNameMap, $acceptableStabilities, $stabilityFlags, $alreadyLoaded);
+        }
+
+        $packages = array();
+        $namesFound = array();
+
+        if ($hasProviders || $this->hasPartialPackages()) {
+            foreach ($packageNameMap as $name => $constraint) {
+                $matches = array();
+
+                // if a repo has no providers but only partial packages and the partial packages are missing
+                // then we don't want to call whatProvides as it would try to load from the providers and fail
+                if (!$hasProviders && !isset($this->partialPackagesByName[$name])) {
+                    continue;
+                }
+
+                $candidates = $this->whatProvides($name, $acceptableStabilities, $stabilityFlags, $alreadyLoaded);
+                foreach ($candidates as $candidate) {
+                    if ($candidate->getName() !== $name) {
+                        throw new \LogicException('whatProvides should never return a package with a different name than the requested one');
+                    }
+                    $namesFound[$name] = true;
+
+                    if (!$constraint || $constraint->matches(new Constraint('==', $candidate->getVersion()))) {
+                        $matches[spl_object_hash($candidate)] = $candidate;
+                        if ($candidate instanceof AliasPackage && !isset($matches[spl_object_hash($candidate->getAliasOf())])) {
+                            $matches[spl_object_hash($candidate->getAliasOf())] = $candidate->getAliasOf();
+                        }
+                    }
+                }
+
+                // add aliases of matched packages even if they did not match the constraint
+                foreach ($candidates as $candidate) {
+                    if ($candidate instanceof AliasPackage) {
+                        if (isset($matches[spl_object_hash($candidate->getAliasOf())])) {
+                            $matches[spl_object_hash($candidate)] = $candidate;
+                        }
+                    }
+                }
+                $packages = array_merge($packages, $matches);
+
+                unset($packageNameMap[$name]);
+            }
+        }
+
+        if ($this->lazyProvidersUrl && count($packageNameMap)) {
+            if ($this->hasAvailablePackageList) {
+                foreach ($packageNameMap as $name => $constraint) {
+                    if (!$this->lazyProvidersRepoContains(strtolower($name))) {
+                        unset($packageNameMap[$name]);
+                    }
+                }
+            }
+
+            $result = $this->loadAsyncPackages($packageNameMap, $acceptableStabilities, $stabilityFlags, $alreadyLoaded);
+            $packages = array_merge($packages, $result['packages']);
+            $namesFound = array_merge($namesFound, $result['namesFound']);
+        }
+
+        return array('namesFound' => array_keys($namesFound), 'packages' => $packages);
+    }
+
     /**
      * {@inheritDoc}
      */
@@ -206,9 +418,7 @@ class ComposerRepository extends ArrayRe
         if ($this->searchUrl && $mode === self::SEARCH_FULLTEXT) {
             $url = str_replace(array('%query%', '%type%'), array($query, $type), $this->searchUrl);
 
-            $origin = RemoteFilesystem::getOrigin($url);
-            $json = $this->rfs->getContents($origin, $url, false);
-            $search = JsonFile::parseJson($json, $url);
+            $search = $this->httpDownloader->get($url, $this->options)->decodeJson();
 
             if (empty($search['results'])) {
                 return array();
@@ -225,11 +435,11 @@ class ComposerRepository extends ArrayRe
             return $results;
         }
 
-        if ($this->hasProviders()) {
+        if ($this->hasProviders() || $this->lazyProvidersUrl) {
             $results = array();
             $regex = '{(?:'.implode('|', preg_split('{\s+}', $query)).')}i';
 
-            foreach ($this->getProviderNames() as $name) {
+            foreach ($this->getPackageNames() as $name) {
                 if (preg_match($regex, $name)) {
                     $results[] = array('name' => $name);
                 }
@@ -241,20 +451,49 @@ class ComposerRepository extends ArrayRe
         return parent::search($query, $mode);
     }
 
-    public function getProviderNames()
+    public function getProviders($packageName)
     {
         $this->loadRootServerFile();
+        $result = array();
 
-        if (null === $this->providerListing) {
-            $this->loadProviderListings($this->loadRootServerFile());
+        if ($this->providersApiUrl) {
+            $apiResult = $this->httpDownloader->get(str_replace('%package%', $packageName, $this->providersApiUrl), $this->options)->decodeJson();
+
+            foreach ($apiResult['providers'] as $provider) {
+                $result[$provider['name']] = $provider;
+            }
+
+            return $result;
         }
 
-        if ($this->hasPartialPackages) {
-            if (null === $this->partialPackagesByName) {
-                $this->initializePartialPackages();
+        if ($this->hasPartialPackages()) {
+            foreach ($this->partialPackagesByName as $versions) {
+                foreach ($versions as $candidate) {
+                    if (isset($result[$candidate['name']]) || !isset($candidate['provide'][$packageName])) {
+                        continue;
+                    }
+                    $result[$candidate['name']] = array(
+                        'name' => $candidate['name'],
+                        'description' => isset($candidate['description']) ? $candidate['description'] : '',
+                        'type' => isset($candidate['type']) ? $candidate['type'] : '',
+                    );
+                }
             }
+        }
+
+        if ($this->packages) {
+            $result = array_merge($result, parent::getProviders($packageName));
+        }
+
+        return $result;
+    }
 
-            return array_keys($this->partialPackagesByName);
+    private function getProviderNames()
+    {
+        $this->loadRootServerFile();
+
+        if (null === $this->providerListing) {
+            $this->loadProviderListings($this->loadRootServerFile());
         }
 
         if ($this->lazyProvidersUrl) {
@@ -269,7 +508,7 @@ class ComposerRepository extends ArrayRe
         return array();
     }
 
-    protected function configurePackageTransportOptions(PackageInterface $package)
+    private function configurePackageTransportOptions(PackageInterface $package)
     {
         foreach ($package->getDistUrls() as $url) {
             if (strpos($url, $this->baseUrl) === 0) {
@@ -280,42 +519,22 @@ class ComposerRepository extends ArrayRe
         }
     }
 
-    public function hasProviders()
+    private function hasProviders()
     {
         $this->loadRootServerFile();
 
         return $this->hasProviders;
     }
 
-    public function resetPackageIds()
-    {
-        foreach ($this->providersByUid as $package) {
-            if ($package instanceof AliasPackage) {
-                $package->getAliasOf()->setId(-1);
-            }
-            $package->setId(-1);
-        }
-    }
-
     /**
-     * @param  Pool        $pool
-     * @param  string      $name          package name
-     * @param  bool        $bypassFilters If set to true, this bypasses the stability filtering, and forces a recompute without cache
+     * @param  string      $name package name
      * @return array|mixed
      */
-    public function whatProvides(Pool $pool, $name, $bypassFilters = false)
+    private function whatProvides($name, array $acceptableStabilities = null, array $stabilityFlags = null, array $alreadyLoaded = array())
     {
-        if (isset($this->providers[$name]) && !$bypassFilters) {
-            return $this->providers[$name];
-        }
-
-        if ($this->hasPartialPackages && null === $this->partialPackagesByName) {
-            $this->initializePartialPackages();
-        }
-
-        if (!$this->hasPartialPackages || !isset($this->partialPackagesByName[$name])) {
+        if (!$this->hasPartialPackages() || !isset($this->partialPackagesByName[$name])) {
             // skip platform packages, root package and composer-plugin-api
-            if (preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $name) || '__root__' === $name || 'composer-plugin-api' === $name) {
+            if (PlatformRepository::isPlatformPackage($name) || '__root__' === $name) {
                 return array();
             }
 
@@ -349,13 +568,12 @@ class ComposerRepository extends ArrayRe
                 } elseif ($useLastModifiedCheck) {
                     if ($contents = $this->cache->read($cacheKey)) {
                         $contents = json_decode($contents, true);
-                        if (isset($contents['last-modified'])) {
+                        // we already loaded some packages from this file, so assume it is fresh and avoid fetching it again
+                        if (isset($alreadyLoaded[$name])) {
+                            $packages = $contents;
+                        } elseif (isset($contents['last-modified'])) {
                             $response = $this->fetchFileIfLastModified($url, $cacheKey, $contents['last-modified']);
-                            if (true === $response) {
-                                $packages = $contents;
-                            } elseif ($response) {
-                                $packages = $response;
-                            }
+                            $packages = true === $response ? $contents : $response;
                         }
                     }
                 }
@@ -366,8 +584,11 @@ class ComposerRepository extends ArrayRe
                     $packages = $this->fetchFile($url, $cacheKey, $hash, $useLastModifiedCheck);
                 } catch (TransportException $e) {
                     // 404s are acceptable for lazy provider repos
-                    if ($e->getStatusCode() === 404 && $this->lazyProvidersUrl) {
+                    if ($this->lazyProvidersUrl && in_array($e->getStatusCode(), array(404, 499), true)) {
                         $packages = array('packages' => array());
+                        if ($e->getStatusCode() === 499) {
+                            $this->io->error('<warning>' . $e->getMessage() . '</warning>');
+                        }
                     } else {
                         throw $e;
                     }
@@ -380,81 +601,58 @@ class ComposerRepository extends ArrayRe
             $loadingPartialPackage = true;
         }
 
-        $this->providers[$name] = array();
+        $result = array();
+        $versionsToLoad = array();
         foreach ($packages['packages'] as $versions) {
             foreach ($versions as $version) {
-                if (!$loadingPartialPackage && $this->hasPartialPackages && isset($this->partialPackagesByName[$version['name']])) {
+                $normalizedName = strtolower($version['name']);
+
+                // only load the actual named package, not other packages that might find themselves in the same file
+                if ($normalizedName !== $name) {
                     continue;
                 }
 
-                // avoid loading the same objects twice
-                if (isset($this->providersByUid[$version['uid']])) {
-                    // skip if already assigned
-                    if (!isset($this->providers[$name][$version['uid']])) {
-                        // expand alias in two packages
-                        if ($this->providersByUid[$version['uid']] instanceof AliasPackage) {
-                            $this->providers[$name][$version['uid']] = $this->providersByUid[$version['uid']]->getAliasOf();
-                            $this->providers[$name][$version['uid'].'-alias'] = $this->providersByUid[$version['uid']];
-                        } else {
-                            $this->providers[$name][$version['uid']] = $this->providersByUid[$version['uid']];
-                        }
-                        // check for root aliases
-                        if (isset($this->providersByUid[$version['uid'].'-root'])) {
-                            $this->providers[$name][$version['uid'].'-root'] = $this->providersByUid[$version['uid'].'-root'];
-                        }
-                    }
-                } else {
-                    if (!$bypassFilters && !$pool->isPackageAcceptable(strtolower($version['name']), VersionParser::parseStability($version['version']))) {
-                        continue;
-                    }
-
-                    // load acceptable packages in the providers
-                    $package = $this->createPackage($version, 'Composer\Package\CompletePackage');
-                    $package->setRepository($this);
-
-                    if ($package instanceof AliasPackage) {
-                        $aliased = $package->getAliasOf();
-                        $aliased->setRepository($this);
-
-                        $this->providers[$name][$version['uid']] = $aliased;
-                        $this->providers[$name][$version['uid'].'-alias'] = $package;
+                if (!$loadingPartialPackage && $this->hasPartialPackages() && isset($this->partialPackagesByName[$normalizedName])) {
+                    continue;
+                }
 
-                        // override provider with its alias so it can be expanded in the if block above
-                        $this->providersByUid[$version['uid']] = $package;
-                    } else {
-                        $this->providers[$name][$version['uid']] = $package;
-                        $this->providersByUid[$version['uid']] = $package;
+                if (!isset($versionsToLoad[$version['uid']])) {
+                    if (!isset($version['version_normalized'])) {
+                        $version['version_normalized'] = $this->versionParser->normalize($version['version']);
+                    } elseif ($version['version_normalized'] === VersionParser::DEFAULT_BRANCH_ALIAS) {
+                        // handling of existing repos which need to remain composer v1 compatible, in case the version_normalized contained VersionParser::DEFAULT_BRANCH_ALIAS, we renormalize it
+                        $version['version_normalized'] = $this->versionParser->normalize($version['version']);
                     }
 
-                    // handle root package aliases
-                    unset($rootAliasData);
-
-                    if (isset($this->rootAliases[$package->getName()][$package->getVersion()])) {
-                        $rootAliasData = $this->rootAliases[$package->getName()][$package->getVersion()];
-                    } elseif ($package instanceof AliasPackage && isset($this->rootAliases[$package->getName()][$package->getAliasOf()->getVersion()])) {
-                        $rootAliasData = $this->rootAliases[$package->getName()][$package->getAliasOf()->getVersion()];
+                    // avoid loading packages which have already been loaded
+                    if (isset($alreadyLoaded[$name][$version['version_normalized']])) {
+                        continue;
                     }
 
-                    if (isset($rootAliasData)) {
-                        $alias = $this->createAliasPackage($package, $rootAliasData['alias_normalized'], $rootAliasData['alias']);
-                        $alias->setRepository($this);
-
-                        $this->providers[$name][$version['uid'].'-root'] = $alias;
-                        $this->providersByUid[$version['uid'].'-root'] = $alias;
+                    if ($this->isVersionAcceptable(null, $normalizedName, $version, $acceptableStabilities, $stabilityFlags)) {
+                        $versionsToLoad[$version['uid']] = $version;
                     }
                 }
             }
         }
 
-        $result = $this->providers[$name];
+        // load acceptable packages in the providers
+        $loadedPackages = $this->createPackages($versionsToLoad);
+        $uids = array_keys($versionsToLoad);
+
+        foreach ($loadedPackages as $index => $package) {
+            $package->setRepository($this);
+            $uid = $uids[$index];
 
-        // clean up the cache because otherwise using this puts the repo in an inconsistent state with a polluted unfiltered cache
-        // which is likely not an issue but might cause hard to track behaviors depending on how the repo is used
-        if ($bypassFilters) {
-            foreach ($this->providers[$name] as $uid => $provider) {
-                unset($this->providersByUid[$uid]);
+            if ($package instanceof AliasPackage) {
+                $aliased = $package->getAliasOf();
+                $aliased->setRepository($this);
+
+                $result[$uid] = $aliased;
+                $result[$uid.'-alias'] = $package;
+            } else {
+                $result[$uid] = $package;
             }
-            unset($this->providers[$name]);
         }
 
         return $result;
@@ -469,8 +667,8 @@ class ComposerRepository extends ArrayRe
 
         $repoData = $this->loadDataFromServer();
 
-        foreach ($repoData as $package) {
-            $this->addPackage($this->createPackage($package, 'Composer\Package\CompletePackage'));
+        foreach ($this->createPackages($repoData) as $package) {
+            $this->addPackage($package);
         }
     }
 
@@ -485,13 +683,142 @@ class ComposerRepository extends ArrayRe
         $this->configurePackageTransportOptions($package);
     }
 
+    /**
+     * @param array $packageNames array of package name => ConstraintInterface|null - if a constraint is provided, only packages matching it will be loaded
+     */
+    private function loadAsyncPackages(array $packageNames, array $acceptableStabilities = null, array $stabilityFlags = null, array $alreadyLoaded = array())
+    {
+        $this->loadRootServerFile();
+
+        $packages = array();
+        $namesFound = array();
+        $promises = array();
+        $repo = $this;
+
+        if (!$this->lazyProvidersUrl) {
+            throw new \LogicException('loadAsyncPackages only supports v2 protocol composer repos with a metadata-url');
+        }
+
+        // load ~dev versions of the packages as well if needed
+        foreach ($packageNames as $name => $constraint) {
+            if ($acceptableStabilities === null || $stabilityFlags === null || StabilityFilter::isPackageAcceptable($acceptableStabilities, $stabilityFlags, array($name), 'dev')) {
+                $packageNames[$name.'~dev'] = $constraint;
+            }
+            // if only dev stability is requested, we skip loading the non dev file
+            if (isset($acceptableStabilities['dev']) && count($acceptableStabilities) === 1 && count($stabilityFlags) === 0) {
+                unset($packageNames[$name]);
+            }
+        }
+
+        foreach ($packageNames as $name => $constraint) {
+            $name = strtolower($name);
+
+            $realName = preg_replace('{~dev$}', '', $name);
+            // skip platform packages, root package and composer-plugin-api
+            if (PlatformRepository::isPlatformPackage($realName) || '__root__' === $realName) {
+                continue;
+            }
+
+            $url = str_replace('%package%', $name, $this->lazyProvidersUrl);
+            $cacheKey = 'provider-'.strtr($name, '/', '~').'.json';
+
+            $lastModified = null;
+            if ($contents = $this->cache->read($cacheKey)) {
+                $contents = json_decode($contents, true);
+                $lastModified = isset($contents['last-modified']) ? $contents['last-modified'] : null;
+            }
+
+            $promises[] = $this->asyncFetchFile($url, $cacheKey, $lastModified)
+                ->then(function ($response) use (&$packages, &$namesFound, $contents, $realName, $constraint, $repo, $acceptableStabilities, $stabilityFlags, $alreadyLoaded) {
+                    if (true === $response) {
+                        $response = $contents;
+                    }
+
+                    if (!isset($response['packages'][$realName])) {
+                        return;
+                    }
+
+                    $versions = $response['packages'][$realName];
+
+                    if (isset($response['minified']) && $response['minified'] === 'composer/2.0') {
+                        $versions = MetadataMinifier::expand($versions);
+                    }
+
+                    $namesFound[$realName] = true;
+                    $versionsToLoad = array();
+                    foreach ($versions as $version) {
+                        if (!isset($version['version_normalized'])) {
+                            $version['version_normalized'] = $repo->versionParser->normalize($version['version']);
+                        } elseif ($version['version_normalized'] === VersionParser::DEFAULT_BRANCH_ALIAS) {
+                            // handling of existing repos which need to remain composer v1 compatible, in case the version_normalized contained VersionParser::DEFAULT_BRANCH_ALIAS, we renormalize it
+                            $version['version_normalized'] = $repo->versionParser->normalize($version['version']);
+                        }
+
+                        // avoid loading packages which have already been loaded
+                        if (isset($alreadyLoaded[$realName][$version['version_normalized']])) {
+                            continue;
+                        }
+
+                        if ($repo->isVersionAcceptable($constraint, $realName, $version, $acceptableStabilities, $stabilityFlags)) {
+                            $versionsToLoad[] = $version;
+                        }
+                    }
+
+                    $loadedPackages = $repo->createPackages($versionsToLoad);
+                    foreach ($loadedPackages as $package) {
+                        $package->setRepository($repo);
+                        $packages[spl_object_hash($package)] = $package;
+
+                        if ($package instanceof AliasPackage && !isset($packages[spl_object_hash($package->getAliasOf())])) {
+                            $package->getAliasOf()->setRepository($repo);
+                            $packages[spl_object_hash($package->getAliasOf())] = $package->getAliasOf();
+                        }
+                    }
+                });
+        }
+
+        $this->loop->wait($promises);
+
+        return array('namesFound' => $namesFound, 'packages' => $packages);
+        // RepositorySet should call loadMetadata, getMetadata when all promises resolved, then metadataComplete when done so we can GC the loaded json and whatnot then as needed
+    }
+
+    /**
+     * TODO v3 should make this private once we can drop PHP 5.3 support
+     *
+     * @param string $name package name (must be lowercased already)
+     * @private
+     */
+    public function isVersionAcceptable($constraint, $name, $versionData, array $acceptableStabilities = null, array $stabilityFlags = null)
+    {
+        $versions = array($versionData['version_normalized']);
+
+        if ($alias = $this->loader->getBranchAlias($versionData)) {
+            $versions[] = $alias;
+        }
+
+        foreach ($versions as $version) {
+            if (null !== $acceptableStabilities && null !== $stabilityFlags && !StabilityFilter::isPackageAcceptable($acceptableStabilities, $stabilityFlags, array($name), VersionParser::parseStability($version))) {
+                continue;
+            }
+
+            if ($constraint && !CompilingMatcher::match($constraint, Constraint::OP_EQ, $version)) {
+                continue;
+            }
+
+            return true;
+        }
+
+        return false;
+    }
+
     protected function loadRootServerFile()
     {
         if (null !== $this->rootData) {
             return $this->rootData;
         }
 
-        if (!extension_loaded('openssl') && 'https' === substr($this->url, 0, 5)) {
+        if (!extension_loaded('openssl') && strpos($this->url, 'https') === 0) {
             throw new \RuntimeException('You must enable the openssl extension in your php.ini to load information from '.$this->url);
         }
 
@@ -539,6 +866,46 @@ class ComposerRepository extends ArrayRe
             $this->hasPartialPackages = !empty($data['packages']) && is_array($data['packages']);
         }
 
+        // Horrible hack to workaround https://github.com/composer/composer/issues/9297 and bad mirrors, should be disabled if possible once they fix things
+        if (!empty($data['metadata-url']) && !empty($data['list']) && $data['metadata-url'] === '/p/%package%.json' && $data['list'] === 'https://packagist.org/packages/list.json') {
+            $this->io->writeError('<warning>Composer 2 repository support for '.$this->url.' has been disabled due to what seems like a misconfiguration. If this is a packagist.org mirror we recommend removing it as Composer 2 handles network operations much faster and should work fine without.</warning>');
+            unset($data['metadata-url']);
+        }
+
+        // metadata-url indicates V2 repo protocol so it takes over from all the V1 types
+        // V2 only has lazyProviders and possibly partial packages, but no ability to process anything else,
+        // V2 also supports async loading
+        if (!empty($data['metadata-url'])) {
+            $this->lazyProvidersUrl = $this->canonicalizeUrl($data['metadata-url']);
+            $this->providersUrl = null;
+            $this->hasProviders = false;
+            $this->hasPartialPackages = !empty($data['packages']) && is_array($data['packages']);
+            $this->allowSslDowngrade = false;
+
+            // provides a list of package names that are available in this repo
+            // this disables lazy-provider behavior in the sense that if a list is available we assume it is finite and won't search for other packages in that repo
+            // while if no list is there lazyProvidersUrl is used when looking for any package name to see if the repo knows it
+            if (!empty($data['available-packages'])) {
+                $availPackages = array_map('strtolower', $data['available-packages']);
+                $this->availablePackages = array_combine($availPackages, $availPackages);
+                $this->hasAvailablePackageList = true;
+            }
+
+            // Provides a list of package name patterns (using * wildcards to match any substring, e.g. "vendor/*") that are available in this repo
+            // Disables lazy-provider behavior as with available-packages, but may allow much more compact expression of packages covered by this repository.
+            // Over-specifying covered packages is safe, but may result in increased traffic to your repository.
+            if (!empty($data['available-package-patterns'])) {
+                $this->availablePackagePatterns = array_map(function ($pattern) {
+                    return BasePackage::packageNameToRegexp($pattern);
+                }, $data['available-package-patterns']);
+                $this->hasAvailablePackageList = true;
+            }
+
+            // Remove legacy keys as most repos need to be compatible with Composer v1
+            // as well but we are not interested in the old format anymore at this point
+            unset($data['providers-url'], $data['providers'], $data['providers-includes']);
+        }
+
         if ($this->allowSslDowngrade) {
             $this->url = str_replace('https://', 'http://', $this->url);
             $this->baseUrl = str_replace('https://', 'http://', $this->baseUrl);
@@ -549,25 +916,22 @@ class ComposerRepository extends ArrayRe
             $this->hasProviders = true;
         }
 
+        if (!empty($data['list'])) {
+            $this->listUrl = $this->canonicalizeUrl($data['list']);
+        }
+
         if (!empty($data['providers']) || !empty($data['providers-includes'])) {
             $this->hasProviders = true;
         }
 
-        // force values for packagist
-        if (preg_match('{^https?://repo\.packagist\.org/?$}i', $this->url) && !empty($this->repoConfig['force-lazy-providers'])) {
-            $this->url = 'https://repo.packagist.org';
-            $this->baseUrl = 'https://repo.packagist.org';
-            $this->lazyProvidersUrl = $this->canonicalizeUrl('https://repo.packagist.org/p/%package%.json');
-            $this->providersUrl = null;
-        } elseif (!empty($this->repoConfig['force-lazy-providers'])) {
-            $this->lazyProvidersUrl = $this->canonicalizeUrl('/p/%package%.json');
-            $this->providersUrl = null;
+        if (!empty($data['providers-api'])) {
+            $this->providersApiUrl = $this->canonicalizeUrl($data['providers-api']);
         }
 
         return $this->rootData = $data;
     }
 
-    protected function canonicalizeUrl($url)
+    private function canonicalizeUrl($url)
     {
         if ('/' === $url[0]) {
             if (preg_match('{^[^:]++://[^/]*+}', $this->url, $matches)) {
@@ -580,14 +944,23 @@ class ComposerRepository extends ArrayRe
         return $url;
     }
 
-    protected function loadDataFromServer()
+    private function loadDataFromServer()
     {
         $data = $this->loadRootServerFile();
 
         return $this->loadIncludes($data);
     }
 
-    protected function loadProviderListings($data)
+    private function hasPartialPackages()
+    {
+        if ($this->hasPartialPackages && null === $this->partialPackagesByName) {
+            $this->initializePartialPackages();
+        }
+
+        return $this->hasPartialPackages;
+    }
+
+    private function loadProviderListings($data)
     {
         if (isset($data['providers'])) {
             if (!is_array($this->providerListing)) {
@@ -612,7 +985,7 @@ class ComposerRepository extends ArrayRe
         }
     }
 
-    protected function loadIncludes($data)
+    private function loadIncludes($data)
     {
         $packages = array();
 
@@ -649,23 +1022,37 @@ class ComposerRepository extends ArrayRe
         return $packages;
     }
 
-    protected function createPackage(array $data, $class = 'Composer\Package\CompletePackage')
+    /**
+     * TODO v3 should make this private once we can drop PHP 5.3 support
+     *
+     * @private
+     */
+    public function createPackages(array $packages, $class = 'Composer\Package\CompletePackage')
     {
+        if (!$packages) {
+            return array();
+        }
+
         try {
-            if (!isset($data['notification-url'])) {
-                $data['notification-url'] = $this->notifyUrl;
+            foreach ($packages as &$data) {
+                if (!isset($data['notification-url'])) {
+                    $data['notification-url'] = $this->notifyUrl;
+                }
             }
 
-            $package = $this->loader->load($data, $class);
-            if (isset($this->sourceMirrors[$package->getSourceType()])) {
-                $package->setSourceMirrors($this->sourceMirrors[$package->getSourceType()]);
+            $packages = $this->loader->loadPackages($packages, $class);
+
+            foreach ($packages as $package) {
+                if (isset($this->sourceMirrors[$package->getSourceType()])) {
+                    $package->setSourceMirrors($this->sourceMirrors[$package->getSourceType()]);
+                }
+                $package->setDistMirrors($this->distMirrors);
+                $this->configurePackageTransportOptions($package);
             }
-            $package->setDistMirrors($this->distMirrors);
-            $this->configurePackageTransportOptions($package);
 
-            return $package;
+            return $packages;
         } catch (\Exception $e) {
-            throw new \RuntimeException('Could not load package '.(isset($data['name']) ? $data['name'] : json_encode($data)).' in '.$this->url.': ['.get_class($e).'] '.$e->getMessage(), 0, $e);
+            throw new \RuntimeException('Could not load packages '.(isset($packages[0]['name']) ? $packages[0]['name'] : json_encode($packages)).' in '.$this->url.': ['.get_class($e).'] '.$e->getMessage(), 0, $e);
         }
     }
 
@@ -677,22 +1064,21 @@ class ComposerRepository extends ArrayRe
         }
 
         // url-encode $ signs in URLs as bad proxies choke on them
-        if (($pos = strpos($filename, '$')) && preg_match('{^https?://.*}i', $filename)) {
+        if (($pos = strpos($filename, '$')) && preg_match('{^https?://}i', $filename)) {
             $filename = substr($filename, 0, $pos) . '%24' . substr($filename, $pos + 1);
         }
 
         $retries = 3;
         while ($retries--) {
             try {
-                $preFileDownloadEvent = new PreFileDownloadEvent(PluginEvents::PRE_FILE_DOWNLOAD, $this->rfs, $filename);
                 if ($this->eventDispatcher) {
+                    $preFileDownloadEvent = new PreFileDownloadEvent(PluginEvents::PRE_FILE_DOWNLOAD, $this->httpDownloader, $filename, 'metadata');
                     $this->eventDispatcher->dispatch($preFileDownloadEvent->getName(), $preFileDownloadEvent);
+                    $filename = $preFileDownloadEvent->getProcessedUrl();
                 }
 
-                $origin = RemoteFilesystem::getOrigin($filename);
-                $rfs = $preFileDownloadEvent->getRemoteFilesystem();
-
-                $json = $rfs->getContents($origin, $filename, false);
+                $response = $this->httpDownloader->get($filename, $this->options);
+                $json = $response->getBody();
                 if ($sha256 && $sha256 !== hash('sha256', $json)) {
                     // undo downgrade before trying again if http seems to be hijacked or modifying content somehow
                     if ($this->allowSslDowngrade) {
@@ -711,12 +1097,12 @@ class ComposerRepository extends ArrayRe
                     throw new RepositorySecurityException('The contents of '.$filename.' do not match its signature. This could indicate a man-in-the-middle attack or e.g. antivirus software corrupting files. Try running composer again and report this if you think it is a mistake.');
                 }
 
-                $data = JsonFile::parseJson($json, $filename);
-                RemoteFilesystem::outputWarnings($this->io, $this->url, $data);
+                $data = $response->decodeJson();
+                HttpDownloader::outputWarnings($this->io, $this->url, $data);
 
-                if ($cacheKey) {
+                if ($cacheKey && !$this->cache->isReadOnly()) {
                     if ($storeLastModifiedTime) {
-                        $lastModifiedDate = $rfs->findHeaderValue($rfs->getLastHeaders(), 'last-modified');
+                        $lastModifiedDate = $response->getHeader('last-modified');
                         if ($lastModifiedDate) {
                             $data['last-modified'] = $lastModifiedDate;
                             $json = json_encode($data);
@@ -725,8 +1111,14 @@ class ComposerRepository extends ArrayRe
                     $this->cache->write($cacheKey, $json);
                 }
 
+                $response->collect();
+
                 break;
             } catch (\Exception $e) {
+                if ($e instanceof \LogicException) {
+                    throw $e;
+                }
+
                 if ($e instanceof TransportException && $e->getStatusCode() === 404) {
                     throw $e;
                 }
@@ -742,8 +1134,7 @@ class ComposerRepository extends ArrayRe
 
                 if ($cacheKey && ($contents = $this->cache->read($cacheKey))) {
                     if (!$this->degradedMode) {
-                        $this->io->writeError('<warning>'.$e->getMessage().'</warning>');
-                        $this->io->writeError('<warning>'.$this->url.' could not be fully loaded, package information was loaded from the local cache and may be out of date</warning>');
+                        $this->io->writeError('<warning>'.$this->url.' could not be fully loaded ('.$e->getMessage().'), package information was loaded from the local cache and may be out of date</warning>');
                     }
                     $this->degradedMode = true;
                     $data = JsonFile::parseJson($contents, $this->cache->getRoot().$cacheKey);
@@ -755,39 +1146,54 @@ class ComposerRepository extends ArrayRe
             }
         }
 
+        if (!isset($data)) {
+            throw new \LogicException("ComposerRepository: Undefined \$data. Please report at https://github.com/composer/composer/issues/new.");
+        }
+
         return $data;
     }
 
-    protected function fetchFileIfLastModified($filename, $cacheKey, $lastModifiedTime)
+    private function fetchFileIfLastModified($filename, $cacheKey, $lastModifiedTime)
     {
         $retries = 3;
         while ($retries--) {
             try {
-                $preFileDownloadEvent = new PreFileDownloadEvent(PluginEvents::PRE_FILE_DOWNLOAD, $this->rfs, $filename);
                 if ($this->eventDispatcher) {
+                    $preFileDownloadEvent = new PreFileDownloadEvent(PluginEvents::PRE_FILE_DOWNLOAD, $this->httpDownloader, $filename, 'metadata');
                     $this->eventDispatcher->dispatch($preFileDownloadEvent->getName(), $preFileDownloadEvent);
+                    $filename = $preFileDownloadEvent->getProcessedUrl();
                 }
 
-                $origin = RemoteFilesystem::getOrigin($filename);
-                $rfs = $preFileDownloadEvent->getRemoteFilesystem();
-                $options = array('http' => array('header' => array('If-Modified-Since: '.$lastModifiedTime)));
-                $json = $rfs->getContents($origin, $filename, false, $options);
-                if ($json === '' && $rfs->findStatusCode($rfs->getLastHeaders()) === 304) {
+                $options = $this->options;
+                if (isset($options['http']['header'])) {
+                    $options['http']['header'] = (array) $options['http']['header'];
+                }
+                $options['http']['header'][] = 'If-Modified-Since: '.$lastModifiedTime;
+                $response = $this->httpDownloader->get($filename, $options);
+                $json = $response->getBody();
+                if ($json === '' && $response->getStatusCode() === 304) {
                     return true;
                 }
 
-                $data = JsonFile::parseJson($json, $filename);
-                RemoteFilesystem::outputWarnings($this->io, $this->url, $data);
+                $data = $response->decodeJson();
+                HttpDownloader::outputWarnings($this->io, $this->url, $data);
 
-                $lastModifiedDate = $rfs->findHeaderValue($rfs->getLastHeaders(), 'last-modified');
+                $lastModifiedDate = $response->getHeader('last-modified');
+                $response->collect();
                 if ($lastModifiedDate) {
                     $data['last-modified'] = $lastModifiedDate;
                     $json = json_encode($data);
                 }
-                $this->cache->write($cacheKey, $json);
+                if (!$this->cache->isReadOnly()) {
+                    $this->cache->write($cacheKey, $json);
+                }
 
                 return $data;
             } catch (\Exception $e) {
+                if ($e instanceof \LogicException) {
+                    throw $e;
+                }
+
                 if ($e instanceof TransportException && $e->getStatusCode() === 404) {
                     throw $e;
                 }
@@ -798,8 +1204,7 @@ class ComposerRepository extends ArrayRe
                 }
 
                 if (!$this->degradedMode) {
-                    $this->io->writeError('<warning>'.$e->getMessage().'</warning>');
-                    $this->io->writeError('<warning>'.$this->url.' could not be fully loaded, package information was loaded from the local cache and may be out of date</warning>');
+                    $this->io->writeError('<warning>'.$this->url.' could not be fully loaded ('.$e->getMessage().'), package information was loaded from the local cache and may be out of date</warning>');
                 }
                 $this->degradedMode = true;
 
@@ -808,6 +1213,106 @@ class ComposerRepository extends ArrayRe
         }
     }
 
+    private function asyncFetchFile($filename, $cacheKey, $lastModifiedTime = null)
+    {
+        $retries = 3;
+
+        if (isset($this->packagesNotFoundCache[$filename])) {
+            return \React\Promise\resolve(array('packages' => array()));
+        }
+
+        if (isset($this->freshMetadataUrls[$filename]) && $lastModifiedTime) {
+            // make it look like we got a 304 response
+            return \React\Promise\resolve(true);
+        }
+
+        $httpDownloader = $this->httpDownloader;
+        if ($this->eventDispatcher) {
+            $preFileDownloadEvent = new PreFileDownloadEvent(PluginEvents::PRE_FILE_DOWNLOAD, $this->httpDownloader, $filename, 'metadata');
+            $this->eventDispatcher->dispatch($preFileDownloadEvent->getName(), $preFileDownloadEvent);
+            $filename = $preFileDownloadEvent->getProcessedUrl();
+        }
+
+        $options = $this->options;
+        if ($lastModifiedTime) {
+            if (isset($options['http']['header'])) {
+                $options['http']['header'] = (array) $options['http']['header'];
+            }
+            $options['http']['header'][] = 'If-Modified-Since: '.$lastModifiedTime;
+        }
+
+        $io = $this->io;
+        $url = $this->url;
+        $cache = $this->cache;
+        $degradedMode = &$this->degradedMode;
+        $repo = $this;
+
+        $accept = function ($response) use ($io, $url, $filename, $cache, $cacheKey, $repo) {
+            // package not found is acceptable for a v2 protocol repository
+            if ($response->getStatusCode() === 404) {
+                $repo->packagesNotFoundCache[$filename] = true;
+
+                return array('packages' => array());
+            }
+
+            $json = $response->getBody();
+            if ($json === '' && $response->getStatusCode() === 304) {
+                $repo->freshMetadataUrls[$filename] = true;
+
+                return true;
+            }
+
+            $data = $response->decodeJson();
+            HttpDownloader::outputWarnings($io, $url, $data);
+
+            $lastModifiedDate = $response->getHeader('last-modified');
+            $response->collect();
+            if ($lastModifiedDate) {
+                $data['last-modified'] = $lastModifiedDate;
+                $json = JsonFile::encode($data, JsonFile::JSON_UNESCAPED_SLASHES | JsonFile::JSON_UNESCAPED_UNICODE);
+            }
+            if (!$cache->isReadOnly()) {
+                $cache->write($cacheKey, $json);
+            }
+            $repo->freshMetadataUrls[$filename] = true;
+
+            return $data;
+        };
+
+        $reject = function ($e) use (&$retries, $httpDownloader, $filename, $options, &$reject, $accept, $io, $url, &$degradedMode, $repo) {
+            if ($e instanceof TransportException && $e->getStatusCode() === 404) {
+                $repo->packagesNotFoundCache[$filename] = true;
+
+                return false;
+            }
+
+            // special error code returned when network is being artificially disabled
+            if ($e instanceof TransportException && $e->getStatusCode() === 499) {
+                $retries = 0;
+            }
+
+            if (--$retries > 0) {
+                usleep(100000);
+
+                return $httpDownloader->add($filename, $options)->then($accept, $reject);
+            }
+
+            if (!$degradedMode) {
+                $io->writeError('<warning>'.$url.' could not be fully loaded ('.$e->getMessage().'), package information was loaded from the local cache and may be out of date</warning>');
+            }
+            $degradedMode = true;
+
+            // special error code returned when network is being artificially disabled
+            if ($e instanceof TransportException && $e->getStatusCode() === 499) {
+                return $accept(new Response(array('url' => $url), 404, array(), ''));
+            }
+
+            throw $e;
+        };
+
+        return $httpDownloader->add($filename, $options)->then($accept, $reject);
+    }
+
     /**
      * This initializes the packages key of a partial packages.json that contain some packages inlined + a providers-lazy-url
      *
@@ -819,23 +1324,39 @@ class ComposerRepository extends ArrayRe
 
         $this->partialPackagesByName = array();
         foreach ($rootData['packages'] as $package => $versions) {
-            $package = strtolower($package);
             foreach ($versions as $version) {
-                $this->partialPackagesByName[$package][] = $version;
-                if (!empty($version['provide']) && is_array($version['provide'])) {
-                    foreach ($version['provide'] as $provided => $providedVersion) {
-                        $this->partialPackagesByName[strtolower($provided)][] = $version;
-                    }
-                }
-                if (!empty($version['replace']) && is_array($version['replace'])) {
-                    foreach ($version['replace'] as $provided => $providedVersion) {
-                        $this->partialPackagesByName[strtolower($provided)][] = $version;
-                    }
-                }
+                $this->partialPackagesByName[strtolower($version['name'])][] = $version;
             }
         }
 
         // wipe rootData as it is fully consumed at this point and this saves some memory
         $this->rootData = true;
     }
+
+    /**
+     * Checks if the package name is present in this lazy providers repo
+     *
+     * @param  string $name
+     * @return bool   true if the package name is present in availablePackages or matched by availablePackagePatterns
+     */
+    protected function lazyProvidersRepoContains($name)
+    {
+        if (!$this->hasAvailablePackageList) {
+            throw new \LogicException('lazyProvidersRepoContains should not be called unless hasAvailablePackageList is true');
+        }
+
+        if (is_array($this->availablePackages) && isset($this->availablePackages[$name])) {
+            return true;
+        }
+
+        if (is_array($this->availablePackagePatterns)) {
+            foreach ($this->availablePackagePatterns as $providerRegex) {
+                if (preg_match($providerRegex, $name)) {
+                    return true;
+                }
+            }
+        }
+
+        return false;
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Repository/CompositeRepository.php 2.0.9-1/src/Composer/Repository/CompositeRepository.php
--- 1.10.19-1/src/Composer/Repository/CompositeRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/CompositeRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -19,7 +19,7 @@ use Composer\Package\PackageInterface;
  *
  * @author Beau Simensen <beau@dflydev.com>
  */
-class CompositeRepository extends BaseRepository
+class CompositeRepository implements RepositoryInterface
 {
     /**
      * List of repositories
@@ -39,6 +39,13 @@ class CompositeRepository extends BaseRe
         }
     }
 
+    public function getRepoName()
+    {
+        return 'composite repo ('.implode(', ', array_map(function ($repo) {
+            return $repo->getRepoName();
+        }, $this->repositories)).')';
+    }
+
     /**
      * Returns all the wrapped repositories
      *
@@ -95,6 +102,26 @@ class CompositeRepository extends BaseRe
     }
 
     /**
+     * {@inheritDoc}
+     */
+    public function loadPackages(array $packageMap, array $acceptableStabilities, array $stabilityFlags, array $alreadyLoaded = array())
+    {
+        $packages = array();
+        $namesFound = array();
+        foreach ($this->repositories as $repository) {
+            /* @var $repository RepositoryInterface */
+            $result = $repository->loadPackages($packageMap, $acceptableStabilities, $stabilityFlags, $alreadyLoaded);
+            $packages[] = $result['packages'];
+            $namesFound[] = $result['namesFound'];
+        }
+
+        return array(
+            'packages' => $packages ? call_user_func_array('array_merge', $packages) : array(),
+            'namesFound' => $namesFound ? array_unique(call_user_func_array('array_merge', $namesFound)) : array(),
+        );
+    }
+
+    /**
      * {@inheritdoc}
      */
     public function search($query, $mode = 0, $type = null)
@@ -123,6 +150,20 @@ class CompositeRepository extends BaseRe
     }
 
     /**
+     * {@inheritdoc}
+     */
+    public function getProviders($packageName)
+    {
+        $results = array();
+        foreach ($this->repositories as $repository) {
+            /* @var $repository RepositoryInterface */
+            $results[] = $repository->getProviders($packageName);
+        }
+
+        return $results ? call_user_func_array('array_merge', $results) : array();
+    }
+
+    /**
      * {@inheritdoc}
      */
     public function removePackage(PackageInterface $package)
diff -pruN 1.10.19-1/src/Composer/Repository/FilesystemRepository.php 2.0.9-1/src/Composer/Repository/FilesystemRepository.php
--- 1.10.19-1/src/Composer/Repository/FilesystemRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/FilesystemRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,7 +14,11 @@ namespace Composer\Repository;
 
 use Composer\Json\JsonFile;
 use Composer\Package\Loader\ArrayLoader;
+use Composer\Package\RootPackageInterface;
+use Composer\Package\AliasPackage;
 use Composer\Package\Dumper\ArrayDumper;
+use Composer\Installer\InstallationManager;
+use Composer\Util\Filesystem;
 
 /**
  * Filesystem repository.
@@ -24,17 +28,26 @@ use Composer\Package\Dumper\ArrayDumper;
  */
 class FilesystemRepository extends WritableArrayRepository
 {
-    private $file;
+    protected $file;
+    private $dumpVersions;
+    private $rootPackage;
 
     /**
      * Initializes filesystem repository.
      *
-     * @param JsonFile $repositoryFile repository json file
+     * @param JsonFile              $repositoryFile repository json file
+     * @param bool                  $dumpVersions
+     * @param ?RootPackageInterface $rootPackage    Must be provided if $dumpVersions is true
      */
-    public function __construct(JsonFile $repositoryFile)
+    public function __construct(JsonFile $repositoryFile, $dumpVersions = false, RootPackageInterface $rootPackage = null)
     {
         parent::__construct();
         $this->file = $repositoryFile;
+        $this->dumpVersions = $dumpVersions;
+        $this->rootPackage = $rootPackage;
+        if ($dumpVersions && !$rootPackage) {
+            throw new \InvalidArgumentException('Expected a root package instance if $dumpVersions is true');
+        }
     }
 
     /**
@@ -49,11 +62,15 @@ class FilesystemRepository extends Writa
         }
 
         try {
-            $packages = $this->file->read();
+            $data = $this->file->read();
+            if (isset($data['packages'])) {
+                $packages = $data['packages'];
+            } else {
+                $packages = $data;
+            }
 
-            // forward compatibility for composer v2 installed.json
-            if (isset($packages['packages'])) {
-                $packages = $packages['packages'];
+            if (isset($data['dev-package-names'])) {
+                $this->setDevPackageNames($data['dev-package-names']);
             }
 
             if (!is_array($packages)) {
@@ -79,19 +96,127 @@ class FilesystemRepository extends Writa
     /**
      * Writes writable repository.
      */
-    public function write()
+    public function write($devMode, InstallationManager $installationManager)
     {
-        $data = array();
+        $data = array('packages' => array(), 'dev' => $devMode, 'dev-package-names' => array());
         $dumper = new ArrayDumper();
+        $fs = new Filesystem();
+        $repoDir = dirname($fs->normalizePath($this->file->getPath()));
 
         foreach ($this->getCanonicalPackages() as $package) {
-            $data[] = $dumper->dump($package);
+            $pkgArray = $dumper->dump($package);
+            $path = $installationManager->getInstallPath($package);
+            $pkgArray['install-path'] = ('' !== $path && null !== $path) ? $fs->findShortestPath($repoDir, $fs->isAbsolutePath($path) ? $path : getcwd() . '/' . $path, true) : null;
+            $data['packages'][] = $pkgArray;
+
+            // only write to the files the names which are really installed, as we receive the full list
+            // of dev package names before they get installed during composer install
+            if (in_array($package->getName(), $this->devPackageNames, true)) {
+                $data['dev-package-names'][] = $package->getName();
+            }
         }
 
-        usort($data, function ($a, $b) {
+        sort($data['dev-package-names']);
+        usort($data['packages'], function ($a, $b) {
             return strcmp($a['name'], $b['name']);
         });
 
         $this->file->write($data);
+
+        if ($this->dumpVersions) {
+            $versions = array('versions' => array());
+            $packages = $this->getPackages();
+            $packages[] = $rootPackage = $this->rootPackage;
+            while ($rootPackage instanceof AliasPackage) {
+                $rootPackage = $rootPackage->getAliasOf();
+                $packages[] = $rootPackage;
+            }
+
+            // add real installed packages
+            foreach ($packages as $package) {
+                if ($package instanceof AliasPackage) {
+                    continue;
+                }
+
+                $reference = null;
+                if ($package->getInstallationSource()) {
+                    $reference = $package->getInstallationSource() === 'source' ? $package->getSourceReference() : $package->getDistReference();
+                }
+                if (null === $reference) {
+                    $reference = ($package->getSourceReference() ?: $package->getDistReference()) ?: null;
+                }
+
+                $versions['versions'][$package->getName()] = array(
+                    'pretty_version' => $package->getPrettyVersion(),
+                    'version' => $package->getVersion(),
+                    'aliases' => array(),
+                    'reference' => $reference,
+                );
+                if ($package instanceof RootPackageInterface) {
+                    $versions['root'] = $versions['versions'][$package->getName()];
+                    $versions['root']['name'] = $package->getName();
+                }
+            }
+
+            // add provided/replaced packages
+            foreach ($packages as $package) {
+                foreach ($package->getReplaces() as $replace) {
+                    // exclude platform replaces as when they are really there we can not check for their presence
+                    if (PlatformRepository::isPlatformPackage($replace->getTarget())) {
+                        continue;
+                    }
+                    $replaced = $replace->getPrettyConstraint();
+                    if ($replaced === 'self.version') {
+                        $replaced = $package->getPrettyVersion();
+                    }
+                    if (!isset($versions['versions'][$replace->getTarget()]['replaced']) || !in_array($replaced, $versions['versions'][$replace->getTarget()]['replaced'], true)) {
+                        $versions['versions'][$replace->getTarget()]['replaced'][] = $replaced;
+                    }
+                }
+                foreach ($package->getProvides() as $provide) {
+                    // exclude platform provides as when they are really there we can not check for their presence
+                    if (PlatformRepository::isPlatformPackage($provide->getTarget())) {
+                        continue;
+                    }
+                    $provided = $provide->getPrettyConstraint();
+                    if ($provided === 'self.version') {
+                        $provided = $package->getPrettyVersion();
+                    }
+                    if (!isset($versions['versions'][$provide->getTarget()]['provided']) || !in_array($provided, $versions['versions'][$provide->getTarget()]['provided'], true)) {
+                        $versions['versions'][$provide->getTarget()]['provided'][] = $provided;
+                    }
+                }
+            }
+
+            // add aliases
+            foreach ($packages as $package) {
+                if (!$package instanceof AliasPackage) {
+                    continue;
+                }
+                $versions['versions'][$package->getName()]['aliases'][] = $package->getPrettyVersion();
+                if ($package instanceof RootPackageInterface) {
+                    $versions['root']['aliases'][] = $package->getPrettyVersion();
+                }
+            }
+
+            ksort($versions['versions']);
+            ksort($versions);
+
+            $fs->filePutContentsIfModified($repoDir.'/installed.php', '<?php return '.var_export($versions, true).';'."\n");
+            $installedVersionsClass = file_get_contents(__DIR__.'/../InstalledVersions.php');
+            // while not strictly needed since https://github.com/composer/composer/pull/9635 - we keep this for BC
+            // and overall broader compatibility with people that may not use Composer's ClassLoader. They can
+            // simply include InstalledVersions.php manually and have it working in a basic way.
+            $installedVersionsClass = str_replace('private static $installed;', 'private static $installed = '.var_export($versions, true).';', $installedVersionsClass);
+            $fs->filePutContentsIfModified($repoDir.'/InstalledVersions.php', $installedVersionsClass);
+
+            // make sure the InstalledVersions class is loaded and has the latest state
+            // not using the autoloader here to avoid loading the one from Composer's vendor dir
+            if (!class_exists('Composer\InstalledVersions', false)) {
+                include $repoDir.'/InstalledVersions.php';
+            } else {
+                \Composer\InstalledVersions::reload($versions);
+            }
+        }
     }
 }
diff -pruN 1.10.19-1/src/Composer/Repository/FilterRepository.php 2.0.9-1/src/Composer/Repository/FilterRepository.php
--- 1.10.19-1/src/Composer/Repository/FilterRepository.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/FilterRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,209 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Repository;
+
+use Composer\Package\PackageInterface;
+use Composer\Package\BasePackage;
+
+/**
+ * Filters which packages are seen as canonical on this repo by loadPackages
+ *
+ * @author Jordi Boggiano <j.boggiano@seld.be>
+ */
+class FilterRepository implements RepositoryInterface
+{
+    private $only = array();
+    private $exclude = array();
+    private $canonical = true;
+    private $repo;
+
+    public function __construct(RepositoryInterface $repo, array $options)
+    {
+        if (isset($options['only'])) {
+            if (!is_array($options['only'])) {
+                throw new \InvalidArgumentException('"only" key for repository '.$repo->getRepoName().' should be an array');
+            }
+            $this->only = '{^'.implode('|', array_map(function ($val) {
+                return BasePackage::packageNameToRegexp($val, '%s');
+            }, $options['only'])) .'$}iD';
+        }
+        if (isset($options['exclude'])) {
+            if (!is_array($options['exclude'])) {
+                throw new \InvalidArgumentException('"exclude" key for repository '.$repo->getRepoName().' should be an array');
+            }
+            $this->exclude = '{^'.implode('|', array_map(function ($val) {
+                return BasePackage::packageNameToRegexp($val, '%s');
+            }, $options['exclude'])) .'$}iD';
+        }
+        if ($this->exclude && $this->only) {
+            throw new \InvalidArgumentException('Only one of "only" and "exclude" can be specified for repository '.$repo->getRepoName());
+        }
+        if (isset($options['canonical'])) {
+            if (!is_bool($options['canonical'])) {
+                throw new \InvalidArgumentException('"canonical" key for repository '.$repo->getRepoName().' should be a boolean');
+            }
+            $this->canonical = $options['canonical'];
+        }
+
+        $this->repo = $repo;
+    }
+
+    public function getRepoName()
+    {
+        return $this->repo->getRepoName();
+    }
+
+    /**
+     * Returns the wrapped repositories
+     *
+     * @return RepositoryInterface
+     */
+    public function getRepository()
+    {
+        return $this->repo;
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function hasPackage(PackageInterface $package)
+    {
+        return $this->repo->hasPackage($package);
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function findPackage($name, $constraint)
+    {
+        if (!$this->isAllowed($name)) {
+            return null;
+        }
+
+        return $this->repo->findPackage($name, $constraint);
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function findPackages($name, $constraint = null)
+    {
+        if (!$this->isAllowed($name)) {
+            return array();
+        }
+
+        return $this->repo->findPackages($name, $constraint);
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function loadPackages(array $packageMap, array $acceptableStabilities, array $stabilityFlags, array $alreadyLoaded = array())
+    {
+        foreach ($packageMap as $name => $constraint) {
+            if (!$this->isAllowed($name)) {
+                unset($packageMap[$name]);
+            }
+        }
+
+        if (!$packageMap) {
+            return array('namesFound' => array(), 'packages' => array());
+        }
+
+        $result = $this->repo->loadPackages($packageMap, $acceptableStabilities, $stabilityFlags, $alreadyLoaded);
+        if (!$this->canonical) {
+            $result['namesFound'] = array();
+        }
+
+        return $result;
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function search($query, $mode = 0, $type = null)
+    {
+        $result = array();
+
+        foreach ($this->repo->search($query, $mode, $type) as $package) {
+            if ($this->isAllowed($package['name'])) {
+                $result[] = $package;
+            }
+        }
+
+        return $result;
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function getPackages()
+    {
+        $result = array();
+        foreach ($this->repo->getPackages() as $package) {
+            if ($this->isAllowed($package->getName())) {
+                $result[] = $package;
+            }
+        }
+
+        return $result;
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function getProviders($packageName)
+    {
+        $result = array();
+        foreach ($this->repo->getProviders($packageName) as $provider) {
+            if ($this->isAllowed($provider['name'])) {
+                $result[] = $provider;
+            }
+        }
+
+        return $result;
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function removePackage(PackageInterface $package)
+    {
+        return $this->repo->removePackage($package);
+    }
+
+    /**
+     * {@inheritdoc}
+     */
+    public function count()
+    {
+        if ($this->repo->count() > 0) {
+            return count($this->getPackages());
+        }
+
+        return 0;
+    }
+
+    private function isAllowed($name)
+    {
+        if (!$this->only && !$this->exclude) {
+            return true;
+        }
+
+        if ($this->only) {
+            return (bool) preg_match($this->only, $name);
+        }
+
+        return !preg_match($this->exclude, $name);
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Repository/InstalledArrayRepository.php 2.0.9-1/src/Composer/Repository/InstalledArrayRepository.php
--- 1.10.19-1/src/Composer/Repository/InstalledArrayRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/InstalledArrayRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -15,10 +15,24 @@ namespace Composer\Repository;
 /**
  * Installed array repository.
  *
- * This is used for serving the RootPackage inside an in-memory InstalledRepository
+ * This is used as an in-memory InstalledRepository mostly for testing purposes
  *
  * @author Jordi Boggiano <j.boggiano@seld.be>
  */
 class InstalledArrayRepository extends WritableArrayRepository implements InstalledRepositoryInterface
 {
+    public function getRepoName()
+    {
+        return 'installed '.parent::getRepoName();
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function isFresh()
+    {
+        // this is not a completely correct implementation but there is no way to
+        // distinguish an empty repo and a newly created one given this is all in-memory
+        return $this->count() === 0;
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Repository/InstalledFilesystemRepository.php 2.0.9-1/src/Composer/Repository/InstalledFilesystemRepository.php
--- 1.10.19-1/src/Composer/Repository/InstalledFilesystemRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/InstalledFilesystemRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -19,4 +19,16 @@ namespace Composer\Repository;
  */
 class InstalledFilesystemRepository extends FilesystemRepository implements InstalledRepositoryInterface
 {
+    public function getRepoName()
+    {
+        return 'installed '.parent::getRepoName();
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function isFresh()
+    {
+        return !$this->file->exists();
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Repository/InstalledRepositoryInterface.php 2.0.9-1/src/Composer/Repository/InstalledRepositoryInterface.php
--- 1.10.19-1/src/Composer/Repository/InstalledRepositoryInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/InstalledRepositoryInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -21,4 +21,8 @@ namespace Composer\Repository;
  */
 interface InstalledRepositoryInterface extends WritableRepositoryInterface
 {
+    /**
+     * @return bool true if packages were never installed in this repository
+     */
+    public function isFresh();
 }
diff -pruN 1.10.19-1/src/Composer/Repository/InstalledRepository.php 2.0.9-1/src/Composer/Repository/InstalledRepository.php
--- 1.10.19-1/src/Composer/Repository/InstalledRepository.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/InstalledRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,254 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Repository;
+
+use Composer\Package\Version\VersionParser;
+use Composer\Semver\Constraint\ConstraintInterface;
+use Composer\Semver\Constraint\Constraint;
+use Composer\Semver\Constraint\MatchAllConstraint;
+use Composer\Package\RootPackageInterface;
+use Composer\Package\Link;
+
+/**
+ * Installed repository is a composite of all installed repo types.
+ *
+ * The main use case is tagging a repo as an "installed" repository, and offering a way to get providers/replacers easily.
+ *
+ * Installed repos are LockArrayRepository, InstalledRepositoryInterface, RootPackageRepository and PlatformRepository
+ *
+ * @author Jordi Boggiano <j.boggiano@seld.be>
+ */
+class InstalledRepository extends CompositeRepository
+{
+    public function findPackagesWithReplacersAndProviders($name, $constraint = null)
+    {
+        $name = strtolower($name);
+
+        if (null !== $constraint && !$constraint instanceof ConstraintInterface) {
+            $versionParser = new VersionParser();
+            $constraint = $versionParser->parseConstraints($constraint);
+        }
+
+        $matches = array();
+        foreach ($this->getRepositories() as $repo) {
+            foreach ($repo->getPackages() as $candidate) {
+                if ($name === $candidate->getName()) {
+                    if (null === $constraint || $constraint->matches(new Constraint('==', $candidate->getVersion()))) {
+                        $matches[] = $candidate;
+                    }
+                    continue;
+                }
+
+                foreach (array_merge($candidate->getProvides(), $candidate->getReplaces()) as $link) {
+                    if (
+                        $name === $link->getTarget()
+                        && ($constraint === null || $link->getConstraint() === null || $constraint->matches($link->getConstraint()))
+                    ) {
+                        $matches[] = $candidate;
+                        continue 2;
+                    }
+                }
+            }
+        }
+
+        return $matches;
+    }
+
+    /**
+     * Returns a list of links causing the requested needle packages to be installed, as an associative array with the
+     * dependent's name as key, and an array containing in order the PackageInterface and Link describing the relationship
+     * as values. If recursive lookup was requested a third value is returned containing an identically formed array up
+     * to the root package. That third value will be false in case a circular recursion was detected.
+     *
+     * @param  string|string[]          $needle        The package name(s) to inspect.
+     * @param  ConstraintInterface|null $constraint    Optional constraint to filter by.
+     * @param  bool                     $invert        Whether to invert matches to discover reasons for the package *NOT* to be installed.
+     * @param  bool                     $recurse       Whether to recursively expand the requirement tree up to the root package.
+     * @param  string[]                 $packagesFound Used internally when recurring
+     * @return array                    An associative array of arrays as described above.
+     */
+    public function getDependents($needle, $constraint = null, $invert = false, $recurse = true, $packagesFound = null)
+    {
+        $needles = array_map('strtolower', (array) $needle);
+        $results = array();
+
+        // initialize the array with the needles before any recursion occurs
+        if (null === $packagesFound) {
+            $packagesFound = $needles;
+        }
+
+        // locate root package for use below
+        $rootPackage = null;
+        foreach ($this->getPackages() as $package) {
+            if ($package instanceof RootPackageInterface) {
+                $rootPackage = $package;
+                break;
+            }
+        }
+
+        // Loop over all currently installed packages.
+        foreach ($this->getPackages() as $package) {
+            $links = $package->getRequires();
+
+            // each loop needs its own "tree" as we want to show the complete dependent set of every needle
+            // without warning all the time about finding circular deps
+            $packagesInTree = $packagesFound;
+
+            // Replacements are considered valid reasons for a package to be installed during forward resolution
+            if (!$invert) {
+                $links += $package->getReplaces();
+
+                // On forward search, check if any replaced package was required and add the replaced
+                // packages to the list of needles. Contrary to the cross-reference link check below,
+                // replaced packages are the target of links.
+                foreach ($package->getReplaces() as $link) {
+                    foreach ($needles as $needle) {
+                        if ($link->getSource() === $needle) {
+                            if ($constraint === null || ($link->getConstraint()->matches($constraint) === !$invert)) {
+                                // already displayed this node's dependencies, cutting short
+                                if (in_array($link->getTarget(), $packagesInTree)) {
+                                    $results[] = array($package, $link, false);
+                                    continue;
+                                }
+                                $packagesInTree[] = $link->getTarget();
+                                $dependents = $recurse ? $this->getDependents($link->getTarget(), null, false, true, $packagesInTree) : array();
+                                $results[] = array($package, $link, $dependents);
+                                $needles[] = $link->getTarget();
+                            }
+                        }
+                    }
+                }
+            }
+
+            // Require-dev is only relevant for the root package
+            if ($package instanceof RootPackageInterface) {
+                $links += $package->getDevRequires();
+            }
+
+            // Cross-reference all discovered links to the needles
+            foreach ($links as $link) {
+                foreach ($needles as $needle) {
+                    if ($link->getTarget() === $needle) {
+                        if ($constraint === null || ($link->getConstraint()->matches($constraint) === !$invert)) {
+                            // already displayed this node's dependencies, cutting short
+                            if (in_array($link->getSource(), $packagesInTree)) {
+                                $results[] = array($package, $link, false);
+                                continue;
+                            }
+                            $packagesInTree[] = $link->getSource();
+                            $dependents = $recurse ? $this->getDependents($link->getSource(), null, false, true, $packagesInTree) : array();
+                            $results[] = array($package, $link, $dependents);
+                        }
+                    }
+                }
+            }
+
+            // When inverting, we need to check for conflicts of the needles against installed packages
+            if ($invert && in_array($package->getName(), $needles)) {
+                foreach ($package->getConflicts() as $link) {
+                    foreach ($this->findPackages($link->getTarget()) as $pkg) {
+                        $version = new Constraint('=', $pkg->getVersion());
+                        if ($link->getConstraint()->matches($version) === $invert) {
+                            $results[] = array($package, $link, false);
+                        }
+                    }
+                }
+            }
+
+            // When inverting, we need to check for conflicts of the needles' requirements against installed packages
+            if ($invert && $constraint && in_array($package->getName(), $needles) && $constraint->matches(new Constraint('=', $package->getVersion()))) {
+                foreach ($package->getRequires() as $link) {
+                    if (PlatformRepository::isPlatformPackage($link->getTarget())) {
+                        if ($this->findPackage($link->getTarget(), $link->getConstraint())) {
+                            continue;
+                        }
+
+                        $platformPkg = $this->findPackage($link->getTarget(), '*');
+                        $description = $platformPkg ? 'but '.$platformPkg->getPrettyVersion().' is installed' : 'but it is missing';
+                        $results[] = array($package, new Link($package->getName(), $link->getTarget(), new MatchAllConstraint, Link::TYPE_REQUIRE, $link->getPrettyConstraint().' '.$description), false);
+
+                        continue;
+                    }
+
+                    foreach ($this->getPackages() as $pkg) {
+                        if (!in_array($link->getTarget(), $pkg->getNames())) {
+                            continue;
+                        }
+
+                        $version = new Constraint('=', $pkg->getVersion());
+
+                        if ($link->getTarget() !== $pkg->getName()) {
+                            foreach (array_merge($pkg->getReplaces(), $pkg->getProvides()) as $prov) {
+                                if ($link->getTarget() === $prov->getTarget()) {
+                                    $version = $prov->getConstraint();
+                                    break;
+                                }
+                            }
+                        }
+
+                        if (!$link->getConstraint()->matches($version)) {
+                            // if we have a root package (we should but can not guarantee..) we show
+                            // the root requires as well to perhaps allow to find an issue there
+                            if ($rootPackage) {
+                                foreach (array_merge($rootPackage->getRequires(), $rootPackage->getDevRequires()) as $rootReq) {
+                                    if (in_array($rootReq->getTarget(), $pkg->getNames()) && !$rootReq->getConstraint()->matches($link->getConstraint())) {
+                                        $results[] = array($package, $link, false);
+                                        $results[] = array($rootPackage, $rootReq, false);
+                                        continue 3;
+                                    }
+                                }
+
+                                $results[] = array($package, $link, false);
+                                $results[] = array($rootPackage, new Link($rootPackage->getName(), $link->getTarget(), new MatchAllConstraint, 'does not require', 'but ' . $pkg->getPrettyVersion() . ' is installed'), false);
+                            } else {
+                                // no root so let's just print whatever we found
+                                $results[] = array($package, $link, false);
+                            }
+                        }
+
+                        continue 2;
+                    }
+                }
+            }
+        }
+
+        ksort($results);
+
+        return $results;
+    }
+
+    public function getRepoName()
+    {
+        return 'installed repo ('.implode(', ', array_map(function ($repo) {
+            return $repo->getRepoName();
+        }, $this->getRepositories())).')';
+    }
+
+    /**
+     * Add a repository.
+     * @param RepositoryInterface $repository
+     */
+    public function addRepository(RepositoryInterface $repository)
+    {
+        if (
+            $repository instanceof LockArrayRepository
+            || $repository instanceof InstalledRepositoryInterface
+            || $repository instanceof RootPackageRepository
+            || $repository instanceof PlatformRepository
+        ) {
+            return parent::addRepository($repository);
+        }
+
+        throw new \LogicException('An InstalledRepository can not contain a repository of type '.get_class($repository).' ('.$repository->getRepoName().')');
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Repository/LockArrayRepository.php 2.0.9-1/src/Composer/Repository/LockArrayRepository.php
--- 1.10.19-1/src/Composer/Repository/LockArrayRepository.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/LockArrayRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,28 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Repository;
+
+/**
+ * Lock array repository.
+ *
+ * Regular array repository, only uses a different type to identify the lock file as the source of info
+ *
+ * @author Nils Adermann <naderman@naderman.de>
+ */
+class LockArrayRepository extends ArrayRepository
+{
+    public function getRepoName()
+    {
+        return 'lock repo';
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Repository/PackageRepository.php 2.0.9-1/src/Composer/Repository/PackageRepository.php
--- 1.10.19-1/src/Composer/Repository/PackageRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/PackageRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -58,4 +58,9 @@ class PackageRepository extends ArrayRep
             $this->addPackage($package);
         }
     }
+
+    public function getRepoName()
+    {
+        return preg_replace('{^array }', 'package ', parent::getRepoName());
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Repository/PathRepository.php 2.0.9-1/src/Composer/Repository/PathRepository.php
--- 1.10.19-1/src/Composer/Repository/PathRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/PathRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -21,6 +21,7 @@ use Composer\Package\Version\VersionPars
 use Composer\Util\Platform;
 use Composer\Util\ProcessExecutor;
 use Composer\Util\Filesystem;
+use Composer\Util\Url;
 use Composer\Util\Git as GitUtil;
 
 /**
@@ -117,6 +118,11 @@ class PathRepository extends ArrayReposi
         parent::__construct();
     }
 
+    public function getRepoName()
+    {
+        return 'path repo ('.Url::sanitize($this->repoConfig['url']).')';
+    }
+
     public function getRepoConfig()
     {
         return $this->repoConfig;
@@ -164,10 +170,11 @@ class PathRepository extends ArrayReposi
                 'reference' => sha1($json . serialize($this->options)),
             );
             $package['transport-options'] = $this->options;
+            unset($package['transport-options']['versions']);
 
-            // use the branch-version as the package version if available
-            if (!isset($package['version']) && isset($package['extra']['branch-version'])) {
-                $package['version'] = preg_replace('{(\.x)?(-dev)?$}', '', $package['extra']['branch-version']).'.x-dev';
+            // use the version provided as option if available
+            if (isset($package['name'], $this->options['versions'][$package['name']])) {
+                $package['version'] = $this->options['versions'][$package['name']];
             }
 
             // carry over the root package version if this path repo is in the same git repository as root package
diff -pruN 1.10.19-1/src/Composer/Repository/Pear/BaseChannelReader.php 2.0.9-1/src/Composer/Repository/Pear/BaseChannelReader.php
--- 1.10.19-1/src/Composer/Repository/Pear/BaseChannelReader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Pear/BaseChannelReader.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,82 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Repository\Pear;
-
-use Composer\Util\RemoteFilesystem;
-
-/**
- * Base PEAR Channel reader.
- *
- * Provides xml namespaces and red
- *
- * @author Alexey Prilipko <palex@farpost.com>
- */
-abstract class BaseChannelReader
-{
-    /**
-     * PEAR REST Interface namespaces
-     */
-    const CHANNEL_NS = 'http://pear.php.net/channel-1.0';
-    const ALL_CATEGORIES_NS = 'http://pear.php.net/dtd/rest.allcategories';
-    const CATEGORY_PACKAGES_INFO_NS = 'http://pear.php.net/dtd/rest.categorypackageinfo';
-    const ALL_PACKAGES_NS = 'http://pear.php.net/dtd/rest.allpackages';
-    const ALL_RELEASES_NS = 'http://pear.php.net/dtd/rest.allreleases';
-    const PACKAGE_INFO_NS = 'http://pear.php.net/dtd/rest.package';
-
-    /** @var RemoteFilesystem */
-    private $rfs;
-
-    protected function __construct(RemoteFilesystem $rfs)
-    {
-        $this->rfs = $rfs;
-    }
-
-    /**
-     * Read content from remote filesystem.
-     *
-     * @param string $origin server
-     * @param string $path   relative path to content
-     * @throws \UnexpectedValueException
-     * @return \SimpleXMLElement
-     */
-    protected function requestContent($origin, $path)
-    {
-        $url = rtrim($origin, '/') . '/' . ltrim($path, '/');
-        $content = $this->rfs->getContents($origin, $url, false);
-        if (!$content) {
-            throw new \UnexpectedValueException('The PEAR channel at ' . $url . ' did not respond.');
-        }
-
-        return str_replace('http://pear.php.net/rest/', 'https://pear.php.net/rest/', $content);
-    }
-
-    /**
-     * Read xml content from remote filesystem
-     *
-     * @param string $origin server
-     * @param string $path   relative path to content
-     * @throws \UnexpectedValueException
-     * @return \SimpleXMLElement
-     */
-    protected function requestXml($origin, $path)
-    {
-        // http://components.ez.no/p/packages.xml is malformed. to read it we must ignore parsing errors.
-        $xml = simplexml_load_string($this->requestContent($origin, $path), "SimpleXMLElement", LIBXML_NOERROR);
-
-        if (false === $xml) {
-            throw new \UnexpectedValueException(sprintf('The PEAR channel at ' . $origin . ' is broken. (Invalid XML at file `%s`)', $path));
-        }
-
-        return $xml;
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Repository/Pear/ChannelInfo.php 2.0.9-1/src/Composer/Repository/Pear/ChannelInfo.php
--- 1.10.19-1/src/Composer/Repository/Pear/ChannelInfo.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Pear/ChannelInfo.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,67 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Repository\Pear;
-
-/**
- * PEAR channel info
- *
- * @author Alexey Prilipko <palex@farpost.com>
- */
-class ChannelInfo
-{
-    private $name;
-    private $alias;
-    private $packages;
-
-    /**
-     * @param string        $name
-     * @param string        $alias
-     * @param PackageInfo[] $packages
-     */
-    public function __construct($name, $alias, array $packages)
-    {
-        $this->name = $name;
-        $this->alias = $alias;
-        $this->packages = $packages;
-    }
-
-    /**
-     * Name of the channel
-     *
-     * @return string
-     */
-    public function getName()
-    {
-        return $this->name;
-    }
-
-    /**
-     * Alias of the channel
-     *
-     * @return string
-     */
-    public function getAlias()
-    {
-        return $this->alias;
-    }
-
-    /**
-     * List of channel packages
-     *
-     * @return PackageInfo[]
-     */
-    public function getPackages()
-    {
-        return $this->packages;
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Repository/Pear/ChannelReader.php 2.0.9-1/src/Composer/Repository/Pear/ChannelReader.php
--- 1.10.19-1/src/Composer/Repository/Pear/ChannelReader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Pear/ChannelReader.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,101 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Repository\Pear;
-
-use Composer\Util\RemoteFilesystem;
-
-/**
- * PEAR Channel package reader.
- *
- * Reads channel packages info from and builds Package's
- *
- * @author Alexey Prilipko <palex@farpost.com>
- */
-class ChannelReader extends BaseChannelReader
-{
-    /** @var array of ('xpath test' => 'rest implementation') */
-    private $readerMap;
-
-    public function __construct(RemoteFilesystem $rfs)
-    {
-        parent::__construct($rfs);
-
-        $rest10reader = new ChannelRest10Reader($rfs);
-        $rest11reader = new ChannelRest11Reader($rfs);
-
-        $this->readerMap = array(
-            'REST1.3' => $rest11reader,
-            'REST1.2' => $rest11reader,
-            'REST1.1' => $rest11reader,
-            'REST1.0' => $rest10reader,
-        );
-    }
-
-    /**
-     * Reads PEAR channel through REST interface and builds list of packages
-     *
-     * @param string $url PEAR Channel url
-     * @throws \UnexpectedValueException
-     * @return ChannelInfo
-     */
-    public function read($url)
-    {
-        $xml = $this->requestXml($url, "/channel.xml");
-
-        $channelName = (string) $xml->name;
-        $channelAlias = (string) $xml->suggestedalias;
-
-        $supportedVersions = array_keys($this->readerMap);
-        $selectedRestVersion = $this->selectRestVersion($xml, $supportedVersions);
-        if (!$selectedRestVersion) {
-            throw new \UnexpectedValueException(sprintf('PEAR repository %s does not supports any of %s protocols.', $url, implode(', ', $supportedVersions)));
-        }
-
-        $reader = $this->readerMap[$selectedRestVersion['version']];
-        $packageDefinitions = $reader->read($selectedRestVersion['baseUrl']);
-
-        return new ChannelInfo($channelName, $channelAlias, $packageDefinitions);
-    }
-
-    /**
-     * Reads channel supported REST interfaces and selects one of them
-     *
-     * @param \SimpleXMLElement $channelXml
-     * @param string[] $supportedVersions supported PEAR REST protocols
-     * @return array|null hash with selected version and baseUrl
-     */
-    private function selectRestVersion($channelXml, $supportedVersions)
-    {
-        $channelXml->registerXPathNamespace('ns', self::CHANNEL_NS);
-
-        foreach ($supportedVersions as $version) {
-            $xpathTest = "ns:servers/ns:*/ns:rest/ns:baseurl[@type='{$version}']";
-            $testResult = $channelXml->xpath($xpathTest);
-
-            foreach ($testResult as $result) {
-                // Choose first https:// option.
-                $result = (string) $result;
-                if (preg_match('{^https://}i', $result)) {
-                    return array('version' => $version, 'baseUrl' => $result);
-                }
-            }
-
-            // Fallback to non-https if it does not exist.
-            if (count($testResult) > 0) {
-                return array('version' => $version, 'baseUrl' => (string) $testResult[0]);
-            }
-        }
-
-        return null;
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Repository/Pear/ChannelRest10Reader.php 2.0.9-1/src/Composer/Repository/Pear/ChannelRest10Reader.php
--- 1.10.19-1/src/Composer/Repository/Pear/ChannelRest10Reader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Pear/ChannelRest10Reader.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,164 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Repository\Pear;
-
-use Composer\Downloader\TransportException;
-
-/**
- * Read PEAR packages using REST 1.0 interface
- *
- * At version 1.0 package descriptions read from:
- *  {baseUrl}/p/packages.xml
- *  {baseUrl}/p/{package}/info.xml
- *  {baseUrl}/p/{package}/allreleases.xml
- *  {baseUrl}/p/{package}/deps.{version}.txt
- *
- * @author Alexey Prilipko <palex@farpost.com>
- */
-class ChannelRest10Reader extends BaseChannelReader
-{
-    private $dependencyReader;
-
-    public function __construct($rfs)
-    {
-        parent::__construct($rfs);
-
-        $this->dependencyReader = new PackageDependencyParser();
-    }
-
-    /**
-     * Reads package descriptions using PEAR Rest 1.0 interface
-     *
-     * @param string $baseUrl base Url interface
-     *
-     * @return PackageInfo[]
-     */
-    public function read($baseUrl)
-    {
-        return $this->readPackages($baseUrl);
-    }
-
-    /**
-     * Read list of packages from
-     *  {baseUrl}/p/packages.xml
-     *
-     * @param string $baseUrl
-     * @return PackageInfo[]
-     */
-    private function readPackages($baseUrl)
-    {
-        $result = array();
-
-        $xmlPath = '/p/packages.xml';
-        $xml = $this->requestXml($baseUrl, $xmlPath);
-        $xml->registerXPathNamespace('ns', self::ALL_PACKAGES_NS);
-        foreach ($xml->xpath('ns:p') as $node) {
-            $packageName = (string) $node;
-            $packageInfo = $this->readPackage($baseUrl, $packageName);
-            $result[] = $packageInfo;
-        }
-
-        return $result;
-    }
-
-    /**
-     * Read package info from
-     *  {baseUrl}/p/{package}/info.xml
-     *
-     * @param string $baseUrl
-     * @param string $packageName
-     * @return PackageInfo
-     */
-    private function readPackage($baseUrl, $packageName)
-    {
-        $xmlPath = '/p/' . strtolower($packageName) . '/info.xml';
-        $xml = $this->requestXml($baseUrl, $xmlPath);
-        $xml->registerXPathNamespace('ns', self::PACKAGE_INFO_NS);
-
-        $channelName = (string) $xml->c;
-        $packageName = (string) $xml->n;
-        $license = (string) $xml->l;
-        $shortDescription = (string) $xml->s;
-        $description = (string) $xml->d;
-
-        return new PackageInfo(
-            $channelName,
-            $packageName,
-            $license,
-            $shortDescription,
-            $description,
-            $this->readPackageReleases($baseUrl, $packageName)
-        );
-    }
-
-    /**
-     * Read package releases from
-     *  {baseUrl}/p/{package}/allreleases.xml
-     *
-     * @param string $baseUrl
-     * @param string $packageName
-     * @throws \Composer\Downloader\TransportException|\Exception
-     * @return ReleaseInfo[]                                      hash array with keys as version numbers
-     */
-    private function readPackageReleases($baseUrl, $packageName)
-    {
-        $result = array();
-
-        try {
-            $xmlPath = '/r/' . strtolower($packageName) . '/allreleases.xml';
-            $xml = $this->requestXml($baseUrl, $xmlPath);
-            $xml->registerXPathNamespace('ns', self::ALL_RELEASES_NS);
-            foreach ($xml->xpath('ns:r') as $node) {
-                $releaseVersion = (string) $node->v;
-                $releaseStability = (string) $node->s;
-
-                try {
-                    $result[$releaseVersion] = new ReleaseInfo(
-                        $releaseStability,
-                        $this->readPackageReleaseDependencies($baseUrl, $packageName, $releaseVersion)
-                    );
-                } catch (TransportException $exception) {
-                    if ($exception->getCode() != 404) {
-                        throw $exception;
-                    }
-                }
-            }
-        } catch (TransportException $exception) {
-            if ($exception->getCode() != 404) {
-                throw $exception;
-            }
-        }
-
-        return $result;
-    }
-
-    /**
-     * Read package dependencies from
-     *  {baseUrl}/p/{package}/deps.{version}.txt
-     *
-     * @param string $baseUrl
-     * @param string $packageName
-     * @param string $version
-     * @return DependencyInfo[]
-     */
-    private function readPackageReleaseDependencies($baseUrl, $packageName, $version)
-    {
-        $dependencyReader = new PackageDependencyParser();
-
-        $depthPath = '/r/' . strtolower($packageName) . '/deps.' . $version . '.txt';
-        $content = $this->requestContent($baseUrl, $depthPath);
-        $dependencyArray = unserialize($content);
-
-        return $dependencyReader->buildDependencyInfo($dependencyArray);
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Repository/Pear/ChannelRest11Reader.php 2.0.9-1/src/Composer/Repository/Pear/ChannelRest11Reader.php
--- 1.10.19-1/src/Composer/Repository/Pear/ChannelRest11Reader.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Pear/ChannelRest11Reader.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,139 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Repository\Pear;
-
-/**
- * Read PEAR packages using REST 1.1 interface
- *
- * At version 1.1 package descriptions read from:
- *  {baseUrl}/c/categories.xml
- *  {baseUrl}/c/{category}/packagesinfo.xml
- *
- * @author Alexey Prilipko <palex@farpost.com>
- */
-class ChannelRest11Reader extends BaseChannelReader
-{
-    private $dependencyReader;
-
-    public function __construct($rfs)
-    {
-        parent::__construct($rfs);
-
-        $this->dependencyReader = new PackageDependencyParser();
-    }
-
-    /**
-     * Reads package descriptions using PEAR Rest 1.1 interface
-     *
-     * @param string $baseUrl base Url interface
-     *
-     * @return PackageInfo[]
-     */
-    public function read($baseUrl)
-    {
-        return $this->readChannelPackages($baseUrl);
-    }
-
-    /**
-     * Read list of channel categories from
-     *  {baseUrl}/c/categories.xml
-     *
-     * @param string $baseUrl
-     * @return PackageInfo[]
-     */
-    private function readChannelPackages($baseUrl)
-    {
-        $result = array();
-
-        $xml = $this->requestXml($baseUrl, "/c/categories.xml");
-        $xml->registerXPathNamespace('ns', self::ALL_CATEGORIES_NS);
-        foreach ($xml->xpath('ns:c') as $node) {
-            $categoryName = (string) $node;
-            $categoryPackages = $this->readCategoryPackages($baseUrl, $categoryName);
-            $result = array_merge($result, $categoryPackages);
-        }
-
-        return $result;
-    }
-
-    /**
-     * Read packages from
-     *  {baseUrl}/c/{category}/packagesinfo.xml
-     *
-     * @param string $baseUrl
-     * @param string $categoryName
-     * @return PackageInfo[]
-     */
-    private function readCategoryPackages($baseUrl, $categoryName)
-    {
-        $result = array();
-
-        $categoryPath = '/c/'.urlencode($categoryName).'/packagesinfo.xml';
-        $xml = $this->requestXml($baseUrl, $categoryPath);
-        $xml->registerXPathNamespace('ns', self::CATEGORY_PACKAGES_INFO_NS);
-        foreach ($xml->xpath('ns:pi') as $node) {
-            $packageInfo = $this->parsePackage($node);
-            $result[] = $packageInfo;
-        }
-
-        return $result;
-    }
-
-    /**
-     * Parses package node.
-     *
-     * @param \SimpleXMLElement $packageInfo  xml element describing package
-     * @return PackageInfo
-     */
-    private function parsePackage($packageInfo)
-    {
-        $packageInfo->registerXPathNamespace('ns', self::CATEGORY_PACKAGES_INFO_NS);
-        $channelName = (string) $packageInfo->p->c;
-        $packageName = (string) $packageInfo->p->n;
-        $license = (string) $packageInfo->p->l;
-        $shortDescription = (string) $packageInfo->p->s;
-        $description = (string) $packageInfo->p->d;
-
-        $dependencies = array();
-        foreach ($packageInfo->xpath('ns:deps') as $node) {
-            $dependencyVersion = (string) $node->v;
-            $dependencyArray = unserialize((string) $node->d);
-
-            $dependencyInfo = $this->dependencyReader->buildDependencyInfo($dependencyArray);
-
-            $dependencies[$dependencyVersion] = $dependencyInfo;
-        }
-
-        $releases = array();
-        $releasesInfo = $packageInfo->xpath('ns:a/ns:r');
-        if ($releasesInfo) {
-            foreach ($releasesInfo as $node) {
-                $releaseVersion = (string) $node->v;
-                $releaseStability = (string) $node->s;
-                $releases[$releaseVersion] = new ReleaseInfo(
-                    $releaseStability,
-                    isset($dependencies[$releaseVersion]) ? $dependencies[$releaseVersion] : new DependencyInfo(array(), array())
-                );
-            }
-        }
-
-        return new PackageInfo(
-            $channelName,
-            $packageName,
-            $license,
-            $shortDescription,
-            $description,
-            $releases
-        );
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Repository/Pear/DependencyConstraint.php 2.0.9-1/src/Composer/Repository/Pear/DependencyConstraint.php
--- 1.10.19-1/src/Composer/Repository/Pear/DependencyConstraint.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Pear/DependencyConstraint.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,60 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Repository\Pear;
-
-/**
- * PEAR package release dependency info
- *
- * @author Alexey Prilipko <palex@farpost.com>
- */
-class DependencyConstraint
-{
-    private $type;
-    private $constraint;
-    private $channelName;
-    private $packageName;
-
-    /**
-     * @param string $type
-     * @param string $constraint
-     * @param string $channelName
-     * @param string $packageName
-     */
-    public function __construct($type, $constraint, $channelName, $packageName)
-    {
-        $this->type = $type;
-        $this->constraint = $constraint;
-        $this->channelName = $channelName;
-        $this->packageName = $packageName;
-    }
-
-    public function getChannelName()
-    {
-        return $this->channelName;
-    }
-
-    public function getConstraint()
-    {
-        return $this->constraint;
-    }
-
-    public function getPackageName()
-    {
-        return $this->packageName;
-    }
-
-    public function getType()
-    {
-        return $this->type;
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Repository/Pear/DependencyInfo.php 2.0.9-1/src/Composer/Repository/Pear/DependencyInfo.php
--- 1.10.19-1/src/Composer/Repository/Pear/DependencyInfo.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Pear/DependencyInfo.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,50 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Repository\Pear;
-
-/**
- * PEAR package release dependency info
- *
- * @author Alexey Prilipko <palex@farpost.com>
- */
-class DependencyInfo
-{
-    private $requires;
-    private $optionals;
-
-    /**
-     * @param DependencyConstraint[] $requires  list of requires/conflicts/replaces
-     * @param array                  $optionals [groupName => DependencyConstraint[]] list of optional groups
-     */
-    public function __construct($requires, $optionals)
-    {
-        $this->requires = $requires;
-        $this->optionals = $optionals;
-    }
-
-    /**
-     * @return DependencyConstraint[] list of requires/conflicts/replaces
-     */
-    public function getRequires()
-    {
-        return $this->requires;
-    }
-
-    /**
-     * @return array [groupName => DependencyConstraint[]] list of optional groups
-     */
-    public function getOptionals()
-    {
-        return $this->optionals;
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Repository/Pear/PackageDependencyParser.php 2.0.9-1/src/Composer/Repository/Pear/PackageDependencyParser.php
--- 1.10.19-1/src/Composer/Repository/Pear/PackageDependencyParser.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Pear/PackageDependencyParser.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,317 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Repository\Pear;
-
-/**
- * Read PEAR packages using REST 1.0 interface
- *
- * @author Alexey Prilipko <palex@farpost.com>
- */
-class PackageDependencyParser
-{
-    /**
-     * Builds dependency information. It detects used package.xml format.
-     *
-     * @param array $depArray
-     * @return DependencyInfo
-     */
-    public function buildDependencyInfo($depArray)
-    {
-        if (!is_array($depArray)) {
-            return new DependencyInfo(array(), array());
-        }
-        if (!$this->isHash($depArray)) {
-            return new DependencyInfo($this->buildDependency10Info($depArray), array());
-        }
-
-        return $this->buildDependency20Info($depArray);
-    }
-
-    /**
-     * Builds dependency information from package.xml 1.0 format
-     *
-     * https://pear.php.net/manual/en/guide.developers.package2.dependencies.php
-     *
-     * package.xml 1.0 format consists of array of
-     * { type="php|os|sapi|ext|pkg" rel="has|not|eq|ge|gt|le|lt" optional="yes"
-     *   channel="channelName" name="extName|packageName" }
-     *
-     * @param array $depArray Dependency data in package.xml 1.0 format
-     * @return DependencyConstraint[]
-     */
-    private function buildDependency10Info($depArray)
-    {
-        static $dep10toOperatorMap = array('has' => '==', 'eq' => '==', 'ge' => '>=', 'gt' => '>', 'le' => '<=', 'lt' => '<', 'not' => '!=');
-
-        $result = array();
-
-        foreach ($depArray as $depItem) {
-            if (empty($depItem['rel']) || !array_key_exists($depItem['rel'], $dep10toOperatorMap)) {
-                // 'unknown rel type:' . $depItem['rel'];
-                continue;
-            }
-
-            $depType = !empty($depItem['optional']) && 'yes' == $depItem['optional']
-                ? 'optional'
-                : 'required';
-            $depType = 'not' == $depItem['rel']
-                ? 'conflicts'
-                : $depType;
-
-            $depVersion = !empty($depItem['version']) ? $this->parseVersion($depItem['version']) : '*';
-
-            // has & not are special operators that does not requires version
-            $depVersionConstraint = ('has' == $depItem['rel'] || 'not' == $depItem['rel']) && '*' == $depVersion
-                ? '*'
-                : $dep10toOperatorMap[$depItem['rel']] . $depVersion;
-
-            switch ($depItem['type']) {
-                case 'php':
-                    $depChannelName = 'php';
-                    $depPackageName = '';
-                    break;
-                case 'pkg':
-                    $depChannelName = !empty($depItem['channel']) ? $depItem['channel'] : 'pear.php.net';
-                    $depPackageName = $depItem['name'];
-                    break;
-                case 'ext':
-                    $depChannelName = 'ext';
-                    $depPackageName = $depItem['name'];
-                    break;
-                case 'os':
-                case 'sapi':
-                    $depChannelName = '';
-                    $depPackageName = '';
-                break;
-                default:
-                    $depChannelName = '';
-                    $depPackageName = '';
-                    break;
-            }
-
-            if ('' != $depChannelName) {
-                $result[] = new DependencyConstraint(
-                    $depType,
-                    $depVersionConstraint,
-                    $depChannelName,
-                    $depPackageName
-                );
-            }
-        }
-
-        return $result;
-    }
-
-    /**
-     * Builds dependency information from package.xml 2.0 format
-     *
-     * @param array $depArray Dependency data in package.xml 1.0 format
-     * @return DependencyInfo
-     */
-    private function buildDependency20Info($depArray)
-    {
-        $result = array();
-        $optionals = array();
-        $defaultOptionals = array();
-        foreach ($depArray as $depType => $depTypeGroup) {
-            if (!is_array($depTypeGroup)) {
-                continue;
-            }
-            if ('required' == $depType || 'optional' == $depType) {
-                foreach ($depTypeGroup as $depItemType => $depItem) {
-                    switch ($depItemType) {
-                        case 'php':
-                            $result[] = new DependencyConstraint(
-                                $depType,
-                                $this->parse20VersionConstraint($depItem),
-                                'php',
-                                ''
-                            );
-                            break;
-                        case 'package':
-                            $deps = $this->buildDepPackageConstraints($depItem, $depType);
-                            $result = array_merge($result, $deps);
-                            break;
-                        case 'extension':
-                            $deps = $this->buildDepExtensionConstraints($depItem, $depType);
-                            $result = array_merge($result, $deps);
-                            break;
-                        case 'subpackage':
-                            $deps = $this->buildDepPackageConstraints($depItem, 'replaces');
-                            $defaultOptionals += $deps;
-                            break;
-                        case 'os':
-                        case 'pearinstaller':
-                            break;
-                        default:
-                            break;
-                    }
-                }
-            } elseif ('group' == $depType) {
-                if ($this->isHash($depTypeGroup)) {
-                    $depTypeGroup = array($depTypeGroup);
-                }
-
-                foreach ($depTypeGroup as $depItem) {
-                    $groupName = $depItem['attribs']['name'];
-                    if (!isset($optionals[$groupName])) {
-                        $optionals[$groupName] = array();
-                    }
-
-                    if (isset($depItem['subpackage'])) {
-                        $optionals[$groupName] += $this->buildDepPackageConstraints($depItem['subpackage'], 'replaces');
-                    } else {
-                        $result += $this->buildDepPackageConstraints($depItem['package'], 'optional');
-                    }
-                }
-            }
-        }
-
-        if (count($defaultOptionals) > 0) {
-            $optionals['*'] = $defaultOptionals;
-        }
-
-        return new DependencyInfo($result, $optionals);
-    }
-
-    /**
-     * Builds dependency constraint of 'extension' type
-     *
-     * @param array $depItem dependency constraint or array of dependency constraints
-     * @param string $depType target type of building constraint.
-     * @return DependencyConstraint[]
-     */
-    private function buildDepExtensionConstraints($depItem, $depType)
-    {
-        if ($this->isHash($depItem)) {
-            $depItem = array($depItem);
-        }
-
-        $result = array();
-        foreach ($depItem as $subDepItem) {
-            $depChannelName = 'ext';
-            $depPackageName = $subDepItem['name'];
-            $depVersionConstraint = $this->parse20VersionConstraint($subDepItem);
-
-            $result[] = new DependencyConstraint(
-                $depType,
-                $depVersionConstraint,
-                $depChannelName,
-                $depPackageName
-            );
-        }
-
-        return $result;
-    }
-
-    /**
-     * Builds dependency constraint of 'package' type
-     *
-     * @param array $depItem dependency constraint or array of dependency constraints
-     * @param string $depType target type of building constraint.
-     * @return DependencyConstraint[]
-     */
-    private function buildDepPackageConstraints($depItem, $depType)
-    {
-        if ($this->isHash($depItem)) {
-            $depItem = array($depItem);
-        }
-
-        $result = array();
-        foreach ($depItem as $subDepItem) {
-            if (!array_key_exists('channel', $subDepItem)) {
-                $subDepItem['channel'] = $subDepItem['uri'];
-            }
-            $depChannelName = $subDepItem['channel'];
-            $depPackageName = $subDepItem['name'];
-            $depVersionConstraint = $this->parse20VersionConstraint($subDepItem);
-            if (isset($subDepItem['conflicts'])) {
-                $depType = 'conflicts';
-            }
-
-            $result[] = new DependencyConstraint(
-                $depType,
-                $depVersionConstraint,
-                $depChannelName,
-                $depPackageName
-            );
-        }
-
-        return $result;
-    }
-
-    /**
-     * Parses version constraint
-     *
-     * @param  array  $data array containing several 'min', 'max', 'has', 'exclude' and other keys.
-     * @return string
-     */
-    private function parse20VersionConstraint(array $data)
-    {
-        static $dep20toOperatorMap = array('has' => '==', 'min' => '>=', 'max' => '<=', 'exclude' => '!=');
-
-        $versions = array();
-        $values = array_intersect_key($data, $dep20toOperatorMap);
-        if (0 == count($values)) {
-            return '*';
-        }
-        if (isset($values['min']) && isset($values['exclude']) && $data['min'] == $data['exclude']) {
-            $versions[] = '>' . $this->parseVersion($values['min']);
-        } elseif (isset($values['max']) && isset($values['exclude']) && $data['max'] == $data['exclude']) {
-            $versions[] = '<' . $this->parseVersion($values['max']);
-        } else {
-            foreach ($values as $op => $version) {
-                if ('exclude' == $op && is_array($version)) {
-                    foreach ($version as $versionPart) {
-                        $versions[] = $dep20toOperatorMap[$op] . $this->parseVersion($versionPart);
-                    }
-                } else {
-                    $versions[] = $dep20toOperatorMap[$op] . $this->parseVersion($version);
-                }
-            }
-        }
-
-        return implode(',', $versions);
-    }
-
-    /**
-     * Softened version parser
-     *
-     * @param string $version
-     * @return null|string
-     */
-    private function parseVersion($version)
-    {
-        if (preg_match('{^v?(\d{1,3})(\.\d+)?(\.\d+)?(\.\d+)?}i', $version, $matches)) {
-            $version = $matches[1]
-                .(!empty($matches[2]) ? $matches[2] : '.0')
-                .(!empty($matches[3]) ? $matches[3] : '.0')
-                .(!empty($matches[4]) ? $matches[4] : '.0');
-
-            return $version;
-        }
-
-        return null;
-    }
-
-    /**
-     * Test if array is associative or hash type
-     *
-     * @param  array $array
-     * @return bool
-     */
-    private function isHash(array $array)
-    {
-        return !array_key_exists(1, $array) && !array_key_exists(0, $array);
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Repository/Pear/PackageInfo.php 2.0.9-1/src/Composer/Repository/Pear/PackageInfo.php
--- 1.10.19-1/src/Composer/Repository/Pear/PackageInfo.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Pear/PackageInfo.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,94 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Repository\Pear;
-
-/**
- * PEAR Package info
- *
- * @author Alexey Prilipko <palex@farpost.com>
- */
-class PackageInfo
-{
-    private $channelName;
-    private $packageName;
-    private $license;
-    private $shortDescription;
-    private $description;
-    private $releases;
-
-    /**
-     * @param string        $channelName
-     * @param string        $packageName
-     * @param string        $license
-     * @param string        $shortDescription
-     * @param string        $description
-     * @param ReleaseInfo[] $releases         associative array maps release version to release info
-     */
-    public function __construct($channelName, $packageName, $license, $shortDescription, $description, $releases)
-    {
-        $this->channelName = $channelName;
-        $this->packageName = $packageName;
-        $this->license = $license;
-        $this->shortDescription = $shortDescription;
-        $this->description = $description;
-        $this->releases = $releases;
-    }
-
-    /**
-     * @return string the package channel name
-     */
-    public function getChannelName()
-    {
-        return $this->channelName;
-    }
-
-    /**
-     * @return string the package name
-     */
-    public function getPackageName()
-    {
-        return $this->packageName;
-    }
-
-    /**
-     * @return string the package description
-     */
-    public function getDescription()
-    {
-        return $this->description;
-    }
-
-    /**
-     * @return string the package short description
-     */
-    public function getShortDescription()
-    {
-        return $this->shortDescription;
-    }
-
-    /**
-     * @return string the package license
-     */
-    public function getLicense()
-    {
-        return $this->license;
-    }
-
-    /**
-     * @return ReleaseInfo[]
-     */
-    public function getReleases()
-    {
-        return $this->releases;
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Repository/Pear/ReleaseInfo.php 2.0.9-1/src/Composer/Repository/Pear/ReleaseInfo.php
--- 1.10.19-1/src/Composer/Repository/Pear/ReleaseInfo.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Pear/ReleaseInfo.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,50 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Repository\Pear;
-
-/**
- * PEAR package release info
- *
- * @author Alexey Prilipko <palex@farpost.com>
- */
-class ReleaseInfo
-{
-    private $stability;
-    private $dependencyInfo;
-
-    /**
-     * @param string         $stability
-     * @param DependencyInfo $dependencyInfo
-     */
-    public function __construct($stability, $dependencyInfo)
-    {
-        $this->stability = $stability;
-        $this->dependencyInfo = $dependencyInfo;
-    }
-
-    /**
-     * @return DependencyInfo release dependencies
-     */
-    public function getDependencyInfo()
-    {
-        return $this->dependencyInfo;
-    }
-
-    /**
-     * @return string release stability
-     */
-    public function getStability()
-    {
-        return $this->stability;
-    }
-}
diff -pruN 1.10.19-1/src/Composer/Repository/PearRepository.php 2.0.9-1/src/Composer/Repository/PearRepository.php
--- 1.10.19-1/src/Composer/Repository/PearRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/PearRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,19 +12,6 @@
 
 namespace Composer\Repository;
 
-use Composer\IO\IOInterface;
-use Composer\Semver\VersionParser as SemverVersionParser;
-use Composer\Package\Version\VersionParser;
-use Composer\Repository\Pear\ChannelReader;
-use Composer\Package\CompletePackage;
-use Composer\Repository\Pear\ChannelInfo;
-use Composer\EventDispatcher\EventDispatcher;
-use Composer\Package\Link;
-use Composer\Semver\Constraint\Constraint;
-use Composer\Util\RemoteFilesystem;
-use Composer\Config;
-use Composer\Factory;
-
 /**
  * Builds list of package from PEAR channel.
  *
@@ -33,166 +20,13 @@ use Composer\Factory;
  *
  * @author Benjamin Eberlei <kontakt@beberlei.de>
  * @author Jordi Boggiano <j.boggiano@seld.be>
+ * @deprecated
+ * @private
  */
-class PearRepository extends ArrayRepository implements ConfigurableRepositoryInterface
+class PearRepository extends ArrayRepository
 {
-    private $url;
-    private $io;
-    private $rfs;
-    private $versionParser;
-    private $repoConfig;
-
-    /** @var string vendor makes additional alias for each channel as {prefix}/{packagename}. It allows smoother
-     * package transition to composer-like repositories.
-     */
-    private $vendorAlias;
-
-    public function __construct(array $repoConfig, IOInterface $io, Config $config, EventDispatcher $dispatcher = null, RemoteFilesystem $rfs = null)
-    {
-        parent::__construct();
-        if (!preg_match('{^https?://}', $repoConfig['url'])) {
-            $repoConfig['url'] = 'http://'.$repoConfig['url'];
-        }
-
-        $urlBits = parse_url($repoConfig['url']);
-        if (empty($urlBits['scheme']) || empty($urlBits['host'])) {
-            throw new \UnexpectedValueException('Invalid url given for PEAR repository: '.$repoConfig['url']);
-        }
-
-        $this->url = rtrim($repoConfig['url'], '/');
-        $this->io = $io;
-        $this->rfs = $rfs ?: Factory::createRemoteFilesystem($this->io, $config);
-        $this->vendorAlias = isset($repoConfig['vendor-alias']) ? $repoConfig['vendor-alias'] : null;
-        $this->versionParser = new VersionParser();
-        $this->repoConfig = $repoConfig;
-    }
-
-    public function getRepoConfig()
-    {
-        return $this->repoConfig;
-    }
-
-    protected function initialize()
-    {
-        parent::initialize();
-
-        $this->io->writeError('Initializing PEAR repository '.$this->url);
-
-        $reader = new ChannelReader($this->rfs);
-        try {
-            $channelInfo = $reader->read($this->url);
-        } catch (\Exception $e) {
-            $this->io->writeError('<warning>PEAR repository from '.$this->url.' could not be loaded. '.$e->getMessage().'</warning>');
-
-            return;
-        }
-        $packages = $this->buildComposerPackages($channelInfo, $this->versionParser);
-        foreach ($packages as $package) {
-            $this->addPackage($package);
-        }
-    }
-
-    /**
-     * Builds CompletePackages from PEAR package definition data.
-     *
-     * @param  ChannelInfo         $channelInfo
-     * @param  SemverVersionParser $versionParser
-     * @return CompletePackage
-     */
-    private function buildComposerPackages(ChannelInfo $channelInfo, SemverVersionParser $versionParser)
+    public function __construct()
     {
-        $result = array();
-        foreach ($channelInfo->getPackages() as $packageDefinition) {
-            foreach ($packageDefinition->getReleases() as $version => $releaseInfo) {
-                try {
-                    $normalizedVersion = $versionParser->normalize($version);
-                } catch (\UnexpectedValueException $e) {
-                    $this->io->writeError('Could not load '.$packageDefinition->getPackageName().' '.$version.': '.$e->getMessage(), true, IOInterface::VERBOSE);
-                    continue;
-                }
-
-                $composerPackageName = $this->buildComposerPackageName($packageDefinition->getChannelName(), $packageDefinition->getPackageName());
-
-                // distribution url must be read from /r/{packageName}/{version}.xml::/r/g:text()
-                // but this location is 'de-facto' standard
-                $urlBits = parse_url($this->url);
-                $scheme = (isset($urlBits['scheme']) && 'https' === $urlBits['scheme'] && extension_loaded('openssl')) ? 'https' : 'http';
-                $distUrl = "{$scheme}://{$packageDefinition->getChannelName()}/get/{$packageDefinition->getPackageName()}-{$version}.tgz";
-
-                $requires = array();
-                $suggests = array();
-                $conflicts = array();
-                $replaces = array();
-
-                // alias package only when its channel matches repository channel,
-                // cause we've know only repository channel alias
-                if ($channelInfo->getName() == $packageDefinition->getChannelName()) {
-                    $composerPackageAlias = $this->buildComposerPackageName($channelInfo->getAlias(), $packageDefinition->getPackageName());
-                    $aliasConstraint = new Constraint('==', $normalizedVersion);
-                    $replaces[] = new Link($composerPackageName, $composerPackageAlias, $aliasConstraint, 'replaces', (string) $aliasConstraint);
-                }
-
-                // alias package with user-specified prefix. it makes private pear channels looks like composer's.
-                if (!empty($this->vendorAlias)
-                    && ($this->vendorAlias != 'pear-'.$channelInfo->getAlias() || $channelInfo->getName() != $packageDefinition->getChannelName())
-                ) {
-                    $composerPackageAlias = "{$this->vendorAlias}/{$packageDefinition->getPackageName()}";
-                    $aliasConstraint = new Constraint('==', $normalizedVersion);
-                    $replaces[] = new Link($composerPackageName, $composerPackageAlias, $aliasConstraint, 'replaces', (string) $aliasConstraint);
-                }
-
-                foreach ($releaseInfo->getDependencyInfo()->getRequires() as $dependencyConstraint) {
-                    $dependencyPackageName = $this->buildComposerPackageName($dependencyConstraint->getChannelName(), $dependencyConstraint->getPackageName());
-                    $constraint = $versionParser->parseConstraints($dependencyConstraint->getConstraint());
-                    $link = new Link($composerPackageName, $dependencyPackageName, $constraint, $dependencyConstraint->getType(), $dependencyConstraint->getConstraint());
-                    switch ($dependencyConstraint->getType()) {
-                        case 'required':
-                            $requires[] = $link;
-                            break;
-                        case 'conflicts':
-                            $conflicts[] = $link;
-                            break;
-                        case 'replaces':
-                            $replaces[] = $link;
-                            break;
-                    }
-                }
-
-                foreach ($releaseInfo->getDependencyInfo()->getOptionals() as $group => $dependencyConstraints) {
-                    foreach ($dependencyConstraints as $dependencyConstraint) {
-                        $dependencyPackageName = $this->buildComposerPackageName($dependencyConstraint->getChannelName(), $dependencyConstraint->getPackageName());
-                        $suggests[$group.'-'.$dependencyPackageName] = $dependencyConstraint->getConstraint();
-                    }
-                }
-
-                $package = new CompletePackage($composerPackageName, $normalizedVersion, $version);
-                $package->setType('pear-library');
-                $package->setDescription($packageDefinition->getDescription());
-                $package->setLicense(array($packageDefinition->getLicense()));
-                $package->setDistType('file');
-                $package->setDistUrl($distUrl);
-                $package->setAutoload(array('classmap' => array('')));
-                $package->setIncludePaths(array('/'));
-                $package->setRequires($requires);
-                $package->setConflicts($conflicts);
-                $package->setSuggests($suggests);
-                $package->setReplaces($replaces);
-                $result[] = $package;
-            }
-        }
-
-        return $result;
-    }
-
-    private function buildComposerPackageName($channelName, $packageName)
-    {
-        if ('php' === $channelName) {
-            return "php";
-        }
-        if ('ext' === $channelName) {
-            return "ext-{$packageName}";
-        }
-
-        return "pear-{$channelName}/{$packageName}";
+        throw new \RuntimeException('The PEAR repository has been removed from Composer 2.0');
     }
 }
diff -pruN 1.10.19-1/src/Composer/Repository/PlatformRepository.php 2.0.9-1/src/Composer/Repository/PlatformRepository.php
--- 1.10.19-1/src/Composer/Repository/PlatformRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/PlatformRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,14 +14,16 @@ namespace Composer\Repository;
 
 use Composer\Composer;
 use Composer\Package\CompletePackage;
+use Composer\Package\Link;
 use Composer\Package\PackageInterface;
 use Composer\Package\Version\VersionParser;
+use Composer\Platform\HhvmDetector;
+use Composer\Platform\Runtime;
+use Composer\Platform\Version;
 use Composer\Plugin\PluginInterface;
-use Composer\Util\ProcessExecutor;
+use Composer\Semver\Constraint\Constraint;
 use Composer\Util\Silencer;
-use Composer\Util\Platform;
 use Composer\XdebugHandler\XdebugHandler;
-use Symfony\Component\Process\ExecutableFinder;
 
 /**
  * @author Jordi Boggiano <j.boggiano@seld.be>
@@ -30,6 +32,9 @@ class PlatformRepository extends ArrayRe
 {
     const PLATFORM_PACKAGE_REGEX = '{^(?:php(?:-64bit|-ipv6|-zts|-debug)?|hhvm|(?:ext|lib)-[a-z0-9](?:[_.-]?[a-z0-9]+)*|composer-(?:plugin|runtime)-api)$}iD';
 
+    /**
+     * @var VersionParser
+     */
     private $versionParser;
 
     /**
@@ -41,17 +46,24 @@ class PlatformRepository extends ArrayRe
      */
     private $overrides = array();
 
-    private $process;
+    private $runtime;
+    private $hhvmDetector;
 
-    public function __construct(array $packages = array(), array $overrides = array(), ProcessExecutor $process = null)
+    public function __construct(array $packages = array(), array $overrides = array(), Runtime $runtime = null, HhvmDetector $hhvmDetector = null)
     {
-        $this->process = $process === null ? (new ProcessExecutor()) : $process;
+        $this->runtime = $runtime ?: new Runtime();
+        $this->hhvmDetector = $hhvmDetector ?: new HhvmDetector();
         foreach ($overrides as $name => $version) {
             $this->overrides[strtolower($name)] = array('name' => $name, 'version' => $version);
         }
         parent::__construct($packages);
     }
 
+    public function getRepoName()
+    {
+        return 'platform repo';
+    }
+
     protected function initialize()
     {
         parent::initialize();
@@ -62,7 +74,7 @@ class PlatformRepository extends ArrayRe
         // Later we might even replace the extensions instead.
         foreach ($this->overrides as $override) {
             // Check that it's a platform package.
-            if (!preg_match(self::PLATFORM_PACKAGE_REGEX, $override['name'])) {
+            if (!self::isPlatformPackage($override['name'])) {
                 throw new \InvalidArgumentException('Invalid platform package name in config.platform: '.$override['name']);
             }
 
@@ -82,10 +94,10 @@ class PlatformRepository extends ArrayRe
         $this->addPackage($composerRuntimeApi);
 
         try {
-            $prettyVersion = PHP_VERSION;
+            $prettyVersion = $this->runtime->getConstant('PHP_VERSION');
             $version = $this->versionParser->normalize($prettyVersion);
         } catch (\UnexpectedValueException $e) {
-            $prettyVersion = preg_replace('#^([^~+-]+).*$#', '$1', PHP_VERSION);
+            $prettyVersion = preg_replace('#^([^~+-]+).*$#', '$1', $this->runtime->getConstant('PHP_VERSION'));
             $version = $this->versionParser->normalize($prettyVersion);
         }
 
@@ -93,19 +105,19 @@ class PlatformRepository extends ArrayRe
         $php->setDescription('The PHP interpreter');
         $this->addPackage($php);
 
-        if (PHP_DEBUG) {
+        if ($this->runtime->getConstant('PHP_DEBUG')) {
             $phpdebug = new CompletePackage('php-debug', $version, $prettyVersion);
             $phpdebug->setDescription('The PHP interpreter, with debugging symbols');
             $this->addPackage($phpdebug);
         }
 
-        if (defined('PHP_ZTS') && PHP_ZTS) {
+        if ($this->runtime->hasConstant('PHP_ZTS') && $this->runtime->getConstant('PHP_ZTS')) {
             $phpzts = new CompletePackage('php-zts', $version, $prettyVersion);
             $phpzts->setDescription('The PHP interpreter, with Zend Thread Safety');
             $this->addPackage($phpzts);
         }
 
-        if (PHP_INT_SIZE === 8) {
+        if ($this->runtime->getConstant('PHP_INT_SIZE') === 8) {
             $php64 = new CompletePackage('php-64bit', $version, $prettyVersion);
             $php64->setDescription('The PHP interpreter, 64bit');
             $this->addPackage($php64);
@@ -113,13 +125,13 @@ class PlatformRepository extends ArrayRe
 
         // The AF_INET6 constant is only defined if ext-sockets is available but
         // IPv6 support might still be available.
-        if (defined('AF_INET6') || Silencer::call('inet_pton', '::') !== false) {
+        if ($this->runtime->hasConstant('AF_INET6') || Silencer::call(array($this->runtime, 'invoke'), 'inet_pton', array('::')) !== false) {
             $phpIpv6 = new CompletePackage('php-ipv6', $version, $prettyVersion);
             $phpIpv6->setDescription('The PHP interpreter, with IPv6 support');
             $this->addPackage($phpIpv6);
         }
 
-        $loadedExtensions = get_loaded_extensions();
+        $loadedExtensions = $this->runtime->getExtensions();
 
         // Extensions scanning
         foreach ($loadedExtensions as $name) {
@@ -127,9 +139,7 @@ class PlatformRepository extends ArrayRe
                 continue;
             }
 
-            $reflExt = new \ReflectionExtension($name);
-            $prettyVersion = $reflExt->getVersion();
-            $this->addExtension($name, $prettyVersion);
+            $this->addExtension($name, $this->runtime->getExtensionVersion($name));
         }
 
         // Check for Xdebug in a restarted process
@@ -141,119 +151,316 @@ class PlatformRepository extends ArrayRe
         // Doing it this way to know that functions or constants exist before
         // relying on them.
         foreach ($loadedExtensions as $name) {
-            $prettyVersion = null;
-            $description = 'The '.$name.' PHP library';
             switch ($name) {
+                case 'amqp':
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    // librabbitmq version => 0.9.0
+                    if (preg_match('/^librabbitmq version => (?<version>.+)$/im', $info, $librabbitmqMatches)) {
+                        $this->addLibrary($name.'-librabbitmq', $librabbitmqMatches['version'], 'AMQP librabbitmq version');
+                    }
+
+                    // AMQP protocol version => 0-9-1
+                    if (preg_match('/^AMQP protocol version => (?<version>.+)$/im', $info, $protocolMatches)) {
+                        $this->addLibrary($name.'-protocol', str_replace('-', '.', $protocolMatches['version']), 'AMQP protocol version');
+                    }
+                    break;
+
+                case 'bz2':
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    // BZip2 Version => 1.0.6, 6-Sept-2010
+                    if (preg_match('/^BZip2 Version => (?<version>.*),/im', $info, $matches)) {
+                        $this->addLibrary($name, $matches['version']);
+                    }
+                    break;
+
                 case 'curl':
-                    $curlVersion = curl_version();
-                    $prettyVersion = $curlVersion['version'];
+                    $curlVersion = $this->runtime->invoke('curl_version');
+                    $this->addLibrary($name, $curlVersion['version']);
+
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    // SSL Version => OpenSSL/1.0.1t
+                    if (preg_match('{^SSL Version => (?<library>[^/]+)/(?<version>.+)$}im', $info, $sslMatches)) {
+                        $library = strtolower($sslMatches['library']);
+                        if ($library === 'openssl') {
+                            $parsedVersion = Version::parseOpenssl($sslMatches['version'], $isFips);
+                            $this->addLibrary($name.'-openssl'.($isFips ? '-fips' : ''), $parsedVersion, 'curl OpenSSL version ('.$parsedVersion.')', array(), $isFips ? array('curl-openssl') : array());
+                        } else {
+                            $this->addLibrary($name.'-'.$library, $sslMatches['version'], 'curl '.$library.' version ('.$sslMatches['version'].')', array('curl-openssl'));
+                        }
+                    }
+
+                    // libSSH Version => libssh2/1.4.3
+                    if (preg_match('{^libSSH Version => (?<library>[^/]+)/(?<version>.+?)(?:/.*)?$}im', $info, $sshMatches)) {
+                        $this->addLibrary($name.'-'.strtolower($sshMatches['library']), $sshMatches['version'], 'curl '.$sshMatches['library'].' version');
+                    }
+
+                    // ZLib Version => 1.2.8
+                    if (preg_match('{^ZLib Version => (?<version>.+)$}im', $info, $zlibMatches)) {
+                        $this->addLibrary($name.'-zlib', $zlibMatches['version'], 'curl zlib version');
+                    }
+                    break;
+
+                case 'date':
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    // timelib version => 2018.03
+                    if (preg_match('/^timelib version => (?<version>.+)$/im', $info, $timelibMatches)) {
+                        $this->addLibrary($name.'-timelib', $timelibMatches['version'], 'date timelib version');
+                    }
+
+                    // Timezone Database => internal
+                    if (preg_match('/^Timezone Database => (?<source>internal|external)$/im', $info, $zoneinfoSourceMatches)) {
+                        $external = $zoneinfoSourceMatches['source'] === 'external';
+                        if (preg_match('/^"Olson" Timezone Database Version => (?<version>.+?)(\.system)?$/im', $info, $zoneinfoMatches)) {
+                            // If the timezonedb is provided by ext/timezonedb, register that version as a replacement
+                            if ($external && in_array('timezonedb', $loadedExtensions, true)) {
+                                $this->addLibrary('timezonedb-zoneinfo', $zoneinfoMatches['version'], 'zoneinfo ("Olson") database for date (replaced by timezonedb)', array($name.'-zoneinfo'));
+                            } else {
+                                $this->addLibrary($name.'-zoneinfo', $zoneinfoMatches['version'], 'zoneinfo ("Olson") database for date');
+                            }
+                        }
+                    }
+                    break;
+
+                case 'fileinfo':
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    // libmagic => 537
+                    if (preg_match('/^libmagic => (?<version>.+)$/im', $info, $magicMatches)) {
+                        $this->addLibrary($name.'-libmagic', $magicMatches['version'], 'fileinfo libmagic version');
+                    }
+                    break;
+
+                case 'gd':
+                    $this->addLibrary($name, $this->runtime->getConstant('GD_VERSION'));
+
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    if (preg_match('/^libJPEG Version => (?<version>.+?)(?: compatible)?$/im', $info, $libjpegMatches)) {
+                        $this->addLibrary($name.'-libjpeg', Version::parseLibjpeg($libjpegMatches['version']), 'libjpeg version for gd');
+                    }
+
+                    if (preg_match('/^libPNG Version => (?<version>.+)$/im', $info, $libpngMatches)) {
+                        $this->addLibrary($name.'-libpng', $libpngMatches['version'], 'libpng version for gd');
+                    }
+
+                    if (preg_match('/^FreeType Version => (?<version>.+)$/im', $info, $freetypeMatches)) {
+                        $this->addLibrary($name.'-freetype', $freetypeMatches['version'], 'freetype version for gd');
+                    }
+
+                    if (preg_match('/^libXpm Version => (?<versionId>\d+)$/im', $info, $libxpmMatches)) {
+                        $this->addLibrary($name.'-libxpm', Version::convertLibxpmVersionId($libxpmMatches['versionId']), 'libxpm version for gd');
+                    }
+
+                    break;
+
+                case 'gmp':
+                    $this->addLibrary($name, $this->runtime->getConstant('GMP_VERSION'));
                     break;
 
                 case 'iconv':
-                    $prettyVersion = ICONV_VERSION;
+                    $this->addLibrary($name, $this->runtime->getConstant('ICONV_VERSION'));
                     break;
 
                 case 'intl':
-                    $name = 'ICU';
-                    if (defined('INTL_ICU_VERSION')) {
-                        $prettyVersion = INTL_ICU_VERSION;
-                    } else {
-                        $reflector = new \ReflectionExtension('intl');
-
-                        ob_start();
-                        $reflector->info();
-                        $output = ob_get_clean();
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    $description = 'The ICU unicode and globalization support library';
+                    // Truthy check is for testing only so we can make the condition fail
+                    if ($this->runtime->hasConstant('INTL_ICU_VERSION')) {
+                        $this->addLibrary('icu', $this->runtime->getConstant('INTL_ICU_VERSION'), $description);
+                    } elseif (preg_match('/^ICU version => (?<version>.+)$/im', $info, $matches)) {
+                        $this->addLibrary('icu', $matches['version'], $description);
+                    }
+
+                    // ICU TZData version => 2019c
+                    if (preg_match('/^ICU TZData version => (?<version>.*)$/im', $info, $zoneinfoMatches)) {
+                        $this->addLibrary('icu-zoneinfo', Version::parseZoneinfoVersion($zoneinfoMatches['version']), 'zoneinfo ("Olson") database for icu');
+                    }
 
-                        preg_match('/^ICU version => (.*)$/m', $output, $matches);
-                        $prettyVersion = $matches[1];
+                    // Add a separate version for the CLDR library version
+                    if ($this->runtime->hasClass('ResourceBundle')) {
+                        $cldrVersion = $this->runtime->invoke(array('ResourceBundle', 'create'), array('root', 'ICUDATA', false))->get('Version');
+                        $this->addLibrary('icu-cldr', $cldrVersion, 'ICU CLDR project version');
                     }
 
+                    if ($this->runtime->hasClass('IntlChar')) {
+                        $this->addLibrary('icu-unicode', implode('.', array_slice($this->runtime->invoke(array('IntlChar', 'getUnicodeVersion')), 0, 3)), 'ICU unicode version');
+                    }
                     break;
 
                 case 'imagick':
-                    $imagick = new \Imagick();
-                    $imageMagickVersion = $imagick->getVersion();
+                    $imageMagickVersion = $this->runtime->construct('Imagick')->getVersion();
                     // 6.x: ImageMagick 6.2.9 08/24/06 Q16 http://www.imagemagick.org
                     // 7.x: ImageMagick 7.0.8-34 Q16 x86_64 2019-03-23 https://imagemagick.org
-                    preg_match('/^ImageMagick ([\d.]+)(?:-(\d+))?/', $imageMagickVersion['versionString'], $matches);
-                    if (isset($matches[2])) {
-                        $prettyVersion = "{$matches[1]}.{$matches[2]}";
-                    } else {
-                        $prettyVersion = $matches[1];
+                    preg_match('/^ImageMagick (?<version>[\d.]+)(?:-(?<patch>\d+))?/', $imageMagickVersion['versionString'], $matches);
+                    $version = $matches['version'];
+                    if (isset($matches['patch'])) {
+                        $version .= '.'.$matches['patch'];
+                    }
+
+                    $this->addLibrary($name.'-imagemagick', $version, null, array('imagick'));
+                    break;
+
+                case 'ldap':
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    if (preg_match('/^Vendor Version => (?<versionId>\d+)$/im', $info, $matches) && preg_match('/^Vendor Name => (?<vendor>.+)$/im', $info, $vendorMatches)) {
+                        $this->addLibrary($name.'-'.strtolower($vendorMatches['vendor']), Version::convertOpenldapVersionId($matches['versionId']), $vendorMatches['vendor'].' version of ldap');
                     }
                     break;
 
                 case 'libxml':
-                    $prettyVersion = LIBXML_DOTTED_VERSION;
+                    // ext/dom, ext/simplexml, ext/xmlreader and ext/xmlwriter use the same libxml as the ext/libxml
+                    $libxmlProvides = array_map(function ($extension) {
+                        return $extension . '-libxml';
+                    }, array_intersect($loadedExtensions, array('dom', 'simplexml', 'xml', 'xmlreader', 'xmlwriter')));
+                    $this->addLibrary($name, $this->runtime->getConstant('LIBXML_DOTTED_VERSION'), 'libxml library version', array(), $libxmlProvides);
+
                     break;
 
-                case 'openssl':
-                    $prettyVersion = preg_replace_callback('{^(?:OpenSSL|LibreSSL)?\s*([0-9.]+)([a-z]*).*}i', function ($match) {
-                        if (empty($match[2])) {
-                            return $match[1];
-                        }
+                case 'mbstring':
+                    $info = $this->runtime->getExtensionInfo($name);
 
-                        // OpenSSL versions add another letter when they reach Z.
-                        // e.g. OpenSSL 0.9.8zh 3 Dec 2015
+                    // libmbfl version => 1.3.2
+                    if (preg_match('/^libmbfl version => (?<version>.+)$/im', $info, $libmbflMatches)) {
+                        $this->addLibrary($name.'-libmbfl', $libmbflMatches['version'], 'mbstring libmbfl version');
+                    }
 
-                        if (!preg_match('{^z*[a-z]$}', $match[2])) {
-                            // 0.9.8abc is garbage
-                            return 0;
-                        }
+                    if ($this->runtime->hasConstant('MB_ONIGURUMA_VERSION')) {
+                        $this->addLibrary($name.'-oniguruma', $this->runtime->getConstant('MB_ONIGURUMA_VERSION'), 'mbstring oniguruma version');
+
+                    // Multibyte regex (oniguruma) version => 5.9.5
+                    // oniguruma version => 6.9.0
+                    } elseif (preg_match('/^(?:oniguruma|Multibyte regex \(oniguruma\)) version => (?<version>.+)$/im', $info, $onigurumaMatches)) {
+                        $this->addLibrary($name.'-oniguruma', $onigurumaMatches['version'], 'mbstring oniguruma version');
+                    }
 
-                        $len = strlen($match[2]);
-                        $patchVersion = ($len - 1) * 26; // All Z
-                        $patchVersion += ord($match[2][$len - 1]) - 96;
+                    break;
 
-                        return $match[1].'.'.$patchVersion;
-                    }, OPENSSL_VERSION_TEXT);
+                case 'memcached':
+                    $info = $this->runtime->getExtensionInfo($name);
 
-                    $description = OPENSSL_VERSION_TEXT;
+                    // libmemcached version => 1.0.18
+                    if (preg_match('/^libmemcached version => (?<version>.+)$/im', $info, $matches)) {
+                        $this->addLibrary($name.'-libmemcached', $matches['version'], 'libmemcached version');
+                    }
+                    break;
+
+                case 'openssl':
+                    // OpenSSL 1.1.1g  21 Apr 2020
+                    if (preg_match('{^(?:OpenSSL|LibreSSL)?\s*(?<version>\S+)}i', $this->runtime->getConstant('OPENSSL_VERSION_TEXT'), $matches)) {
+                        $parsedVersion = Version::parseOpenssl($matches['version'], $isFips);
+                        $this->addLibrary($name.($isFips ? '-fips' : ''), $parsedVersion, $this->runtime->getConstant('OPENSSL_VERSION_TEXT'), array(), $isFips ? array($name) : array());
+                    }
                     break;
 
                 case 'pcre':
-                    $prettyVersion = preg_replace('{^(\S+).*}', '$1', PCRE_VERSION);
+                    $this->addLibrary($name, preg_replace('{^(\S+).*}', '$1', $this->runtime->getConstant('PCRE_VERSION')));
+
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    // PCRE Unicode Version => 12.1.0
+                    if (preg_match('/^PCRE Unicode Version => (?<version>.+)$/im', $info, $pcreUnicodeMatches)) {
+                        $this->addLibrary($name.'-unicode', $pcreUnicodeMatches['version'], 'PCRE Unicode version support');
+                    }
+
+                    break;
+
+                case 'mysqlnd':
+                case 'pdo_mysql':
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    if (preg_match('/^(?:Client API version|Version) => mysqlnd (?<version>.+?) /mi', $info, $matches)) {
+                        $this->addLibrary($name.'-mysqlnd', $matches['version'], 'mysqlnd library version for '.$name);
+                    }
                     break;
 
-                case 'uuid':
-                    $prettyVersion = phpversion('uuid');
+                case 'mongodb':
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    if (preg_match('/^libmongoc bundled version => (?<version>.+)$/im', $info, $libmongocMatches)) {
+                        $this->addLibrary($name.'-libmongoc', $libmongocMatches['version'], 'libmongoc version of mongodb');
+                    }
+
+                    if (preg_match('/^libbson bundled version => (?<version>.+)$/im', $info, $libbsonMatches)) {
+                        $this->addLibrary($name.'-libbson', $libbsonMatches['version'], 'libbson version of mongodb');
+                    }
+                    break;
+
+                case 'pgsql':
+                case 'pdo_pgsql':
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    if (preg_match('/^PostgreSQL\(libpq\) Version => (?<version>.*)$/im', $info, $matches)) {
+                        $this->addLibrary($name.'-libpq', $matches['version'], 'libpq for '.$name);
+                    }
+                    break;
+
+                case 'libsodium':
+                case 'sodium':
+                    $this->addLibrary('libsodium', $this->runtime->getConstant('SODIUM_LIBRARY_VERSION'));
+                    break;
+
+                case 'sqlite3':
+                case 'pdo_sqlite':
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    if (preg_match('/^SQLite Library => (?<version>.+)$/im', $info, $matches)) {
+                        $this->addLibrary($name.'-sqlite', $matches['version']);
+                    }
+                    break;
+
+                case 'ssh2':
+                    $info = $this->runtime->getExtensionInfo($name);
+
+                    if (preg_match('/^libssh2 version => (?<version>.+)$/im', $info, $matches)) {
+                        $this->addLibrary($name.'-libssh2', $matches['version']);
+                    }
                     break;
 
                 case 'xsl':
-                    $prettyVersion = LIBXSLT_DOTTED_VERSION;
+                    $this->addLibrary('libxslt', $this->runtime->getConstant('LIBXSLT_DOTTED_VERSION'), null, array('xsl'));
+
+                    $info = $this->runtime->getExtensionInfo('xsl');
+                    if (preg_match('/^libxslt compiled against libxml Version => (?<version>.+)$/im', $info, $matches)) {
+                        $this->addLibrary('libxslt-libxml', $matches['version'], 'libxml version libxslt is compiled against');
+                    }
                     break;
 
-                default:
-                    // None handled extensions have no special cases, skip
-                    continue 2;
-            }
+                case 'yaml':
+                    $info = $this->runtime->getExtensionInfo('yaml');
 
-            try {
-                $version = $this->versionParser->normalize($prettyVersion);
-            } catch (\UnexpectedValueException $e) {
-                continue;
-            }
+                    if (preg_match('/^LibYAML Version => (?<version>.+)$/im', $info, $matches)) {
+                        $this->addLibrary($name.'-libyaml', $matches['version'], 'libyaml version of yaml');
+                    }
+                    break;
+
+                case 'zip':
+                    if ($this->runtime->hasConstant('LIBZIP_VERSION', 'ZipArchive')) {
+                        $this->addLibrary($name.'-libzip', $this->runtime->getConstant('LIBZIP_VERSION', 'ZipArchive'), null, array('zip'));
+                    }
+                    break;
 
-            $lib = new CompletePackage('lib-'.$name, $version, $prettyVersion);
-            $lib->setDescription($description);
-            $this->addPackage($lib);
-        }
-
-        $hhvmVersion = defined('HHVM_VERSION') ? HHVM_VERSION : null;
-        if ($hhvmVersion === null && !Platform::isWindows()) {
-            $finder = new ExecutableFinder();
-            $hhvm = $finder->find('hhvm');
-            if ($hhvm !== null) {
-                $exitCode = $this->process->execute(
-                    ProcessExecutor::escape($hhvm).
-                    ' --php -d hhvm.jit=0 -r "echo HHVM_VERSION;" 2>/dev/null',
-                    $hhvmVersion
-                );
-                if ($exitCode !== 0) {
-                    $hhvmVersion = null;
-                }
+                case 'zlib':
+                    if ($this->runtime->hasConstant('ZLIB_VERSION')) {
+                        $this->addLibrary($name, $this->runtime->getConstant('ZLIB_VERSION'));
+
+                    // Linked Version => 1.2.8
+                    } elseif (preg_match('/^Linked Version => (?<version>.+)$/im', $this->runtime->getExtensionInfo($name), $matches)) {
+                        $this->addLibrary($name, $matches['version']);
+                    }
+                    break;
+
+                default:
+                    break;
             }
         }
+
+        $hhvmVersion = $this->hhvmDetector->getVersion();
         if ($hhvmVersion) {
             try {
                 $prettyVersion = $hhvmVersion;
@@ -282,7 +489,7 @@ class PlatformRepository extends ArrayRe
             } else {
                 $actualText = 'actual: '.$package->getPrettyVersion();
             }
-            $overrider->setDescription($overrider->getDescription().' ('.$actualText.')');
+            $overrider->setDescription($overrider->getDescription().', '.$actualText);
 
             return;
         }
@@ -295,7 +502,7 @@ class PlatformRepository extends ArrayRe
             } else {
                 $actualText = 'actual: '.$package->getPrettyVersion();
             }
-            $overrider->setDescription($overrider->getDescription().' ('.$actualText.')');
+            $overrider->setDescription($overrider->getDescription().', '.$actualText);
 
             return;
         }
@@ -339,11 +546,70 @@ class PlatformRepository extends ArrayRe
         $packageName = $this->buildPackageName($name);
         $ext = new CompletePackage($packageName, $version, $prettyVersion);
         $ext->setDescription('The '.$name.' PHP extension'.$extraDescription);
+
+        if ($name === 'uuid') {
+            $ext->setReplaces(array(
+                new Link('ext-uuid', 'lib-uuid', new Constraint('=', $version), Link::TYPE_REPLACE, $ext->getPrettyVersion()),
+            ));
+        }
+
         $this->addPackage($ext);
     }
 
+    /**
+     * @param  string $name
+     * @return string
+     */
     private function buildPackageName($name)
     {
-        return 'ext-' . str_replace(' ', '-', $name);
+        return 'ext-' . str_replace(' ', '-', strtolower($name));
+    }
+
+    /**
+     * @param string      $name
+     * @param string      $prettyVersion
+     * @param string|null $description
+     * @param string[]    $replaces
+     * @param string[]    $provides
+     */
+    private function addLibrary($name, $prettyVersion, $description = null, array $replaces = array(), array $provides = array())
+    {
+        try {
+            $version = $this->versionParser->normalize($prettyVersion);
+        } catch (\UnexpectedValueException $e) {
+            return;
+        }
+
+        if ($description === null) {
+            $description = 'The '.$name.' library';
+        }
+
+        $lib = new CompletePackage('lib-'.$name, $version, $prettyVersion);
+        $lib->setDescription($description);
+
+        $links = function ($alias) use ($name, $version, $lib) {
+            return new Link('lib-'.$name, 'lib-'.$alias, new Constraint('=', $version), Link::TYPE_REPLACE, $lib->getPrettyVersion());
+        };
+        $lib->setReplaces(array_map($links, $replaces));
+        $lib->setProvides(array_map($links, $provides));
+
+        $this->addPackage($lib);
+    }
+
+    /**
+     * Check if a package name is a platform package.
+     *
+     * @param  string $name
+     * @return bool
+     */
+    public static function isPlatformPackage($name)
+    {
+        static $cache = array();
+
+        if (isset($cache[$name])) {
+            return $cache[$name];
+        }
+
+        return $cache[$name] = (bool) preg_match(PlatformRepository::PLATFORM_PACKAGE_REGEX, $name);
     }
 }
diff -pruN 1.10.19-1/src/Composer/Repository/RepositoryFactory.php 2.0.9-1/src/Composer/Repository/RepositoryFactory.php
--- 1.10.19-1/src/Composer/Repository/RepositoryFactory.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/RepositoryFactory.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,7 +16,8 @@ use Composer\Factory;
 use Composer\IO\IOInterface;
 use Composer\Config;
 use Composer\EventDispatcher\EventDispatcher;
-use Composer\Util\RemoteFilesystem;
+use Composer\Util\HttpDownloader;
+use Composer\Util\ProcessExecutor;
 use Composer\Json\JsonFile;
 
 /**
@@ -36,7 +37,7 @@ class RepositoryFactory
         if (0 === strpos($repository, 'http')) {
             $repoConfig = array('type' => 'composer', 'url' => $repository);
         } elseif ("json" === pathinfo($repository, PATHINFO_EXTENSION)) {
-            $json = new JsonFile($repository, Factory::createRemoteFilesystem($io, $config));
+            $json = new JsonFile($repository, Factory::createHttpDownloader($io, $config));
             $data = $json->read();
             if (!empty($data['packages']) || !empty($data['includes']) || !empty($data['provider-includes'])) {
                 $repoConfig = array('type' => 'composer', 'url' => 'file://' . strtr(realpath($repository), '\\', '/'));
@@ -45,7 +46,7 @@ class RepositoryFactory
             } else {
                 throw new \InvalidArgumentException("Invalid repository URL ($repository) given. This file does not contain a valid composer repository.");
             }
-        } elseif ('{' === substr($repository, 0, 1)) {
+        } elseif (strpos($repository, '{') === 0) {
             // assume it is a json object that makes a repo config
             $repoConfig = JsonFile::parseJson($repository);
         } else {
@@ -78,7 +79,7 @@ class RepositoryFactory
     public static function createRepo(IOInterface $io, Config $config, array $repoConfig, RepositoryManager $rm = null)
     {
         if (!$rm) {
-            $rm = static::manager($io, $config, null, Factory::createRemoteFilesystem($io, $config));
+            $rm = static::manager($io, $config, Factory::createHttpDownloader($io, $config));
         }
         $repos = static::createRepos($rm, array($repoConfig));
 
@@ -103,7 +104,7 @@ class RepositoryFactory
             if (!$io) {
                 throw new \InvalidArgumentException('This function requires either an IOInterface or a RepositoryManager');
             }
-            $rm = static::manager($io, $config, null, Factory::createRemoteFilesystem($io, $config));
+            $rm = static::manager($io, $config, Factory::createHttpDownloader($io, $config));
         }
 
         return static::createRepos($rm, $config->getRepositories());
@@ -113,12 +114,12 @@ class RepositoryFactory
      * @param  IOInterface       $io
      * @param  Config            $config
      * @param  EventDispatcher   $eventDispatcher
-     * @param  RemoteFilesystem  $rfs
+     * @param  HttpDownloader    $httpDownloader
      * @return RepositoryManager
      */
-    public static function manager(IOInterface $io, Config $config, EventDispatcher $eventDispatcher = null, RemoteFilesystem $rfs = null)
+    public static function manager(IOInterface $io, Config $config, HttpDownloader $httpDownloader, EventDispatcher $eventDispatcher = null, ProcessExecutor $process = null)
     {
-        $rm = new RepositoryManager($io, $config, $eventDispatcher, $rfs);
+        $rm = new RepositoryManager($io, $config, $httpDownloader, $eventDispatcher, $process);
         $rm->setRepositoryClass('composer', 'Composer\Repository\ComposerRepository');
         $rm->setRepositoryClass('vcs', 'Composer\Repository\VcsRepository');
         $rm->setRepositoryClass('package', 'Composer\Repository\PackageRepository');
diff -pruN 1.10.19-1/src/Composer/Repository/RepositoryInterface.php 2.0.9-1/src/Composer/Repository/RepositoryInterface.php
--- 1.10.19-1/src/Composer/Repository/RepositoryInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/RepositoryInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,8 @@
 namespace Composer\Repository;
 
 use Composer\Package\PackageInterface;
+use Composer\Package\BasePackage;
+use Composer\Semver\Constraint\ConstraintInterface;
 
 /**
  * Repository interface.
@@ -38,8 +40,8 @@ interface RepositoryInterface extends \C
     /**
      * Searches for the first match of a package by name and version.
      *
-     * @param string                                                 $name       package name
-     * @param string|\Composer\Semver\Constraint\ConstraintInterface $constraint package version or version constraint to match against
+     * @param string                     $name       package name
+     * @param string|ConstraintInterface $constraint package version or version constraint to match against
      *
      * @return PackageInterface|null
      */
@@ -48,8 +50,8 @@ interface RepositoryInterface extends \C
     /**
      * Searches for all packages matching a name and optionally a version.
      *
-     * @param string                                                 $name       package name
-     * @param string|\Composer\Semver\Constraint\ConstraintInterface $constraint package version or version constraint to match against
+     * @param string                     $name       package name
+     * @param string|ConstraintInterface $constraint package version or version constraint to match against
      *
      * @return PackageInterface[]
      */
@@ -63,12 +65,54 @@ interface RepositoryInterface extends \C
     public function getPackages();
 
     /**
+     * Returns list of registered packages with the supplied name
+     *
+     * - The packages returned are the packages found which match the constraints, acceptable stability and stability flags provided
+     * - The namesFound returned are names which should be considered as canonically found in this repository, that should not be looked up in any further lower priority repositories
+     *
+     * @param ConstraintInterface[] $packageNameMap        package names pointing to constraints
+     * @param int[]                 $acceptableStabilities array of stability => BasePackage::STABILITY_* value
+     * @psalm-param array<string, BasePackage::STABILITY_*> $acceptableStabilities
+     * @param int[] $stabilityFlags an array of package name => BasePackage::STABILITY_* value
+     * @psalm-param array<string, BasePackage::STABILITY_*> $stabilityFlags
+     * @param array[] $alreadyLoaded an array of package name => package version => package
+     * @psalm-param array<string, array<string, PackageInterface>> $alreadyLoaded
+     *
+     * @return array [namesFound => string[], packages => PackageInterface[]]
+     * @psalm-return array{namesFound: string[], packages: PackageInterface[]}
+     */
+    public function loadPackages(array $packageNameMap, array $acceptableStabilities, array $stabilityFlags, array $alreadyLoaded = array());
+
+    /**
      * Searches the repository for packages containing the query
      *
      * @param string $query search query
      * @param int    $mode  a set of SEARCH_* constants to search on, implementations should do a best effort only
+     * @param string $type  The type of package to search for. Defaults to all types of packages
      *
      * @return array[] an array of array('name' => '...', 'description' => '...')
+     * @psalm-return list<array{name: string, description: string}>
+     */
+    public function search($query, $mode = 0, $type = null);
+
+    /**
+     * Returns a list of packages providing a given package name
+     *
+     * Packages which have the same name as $packageName should not be returned, only those that have a "provide" on it.
+     *
+     * @param string $packageName package name which must be provided
+     *
+     * @return array[] an array with the provider name as key and value of array('name' => '...', 'description' => '...', 'type' => '...')
+     * @psalm-return array<string, array{name: string, description: string, type: string}>
+     */
+    public function getProviders($packageName);
+
+    /**
+     * Returns a name representing this repository to the user
+     *
+     * This is best effort and definitely can not always be very precise
+     *
+     * @return string
      */
-    public function search($query, $mode = 0);
+    public function getRepoName();
 }
diff -pruN 1.10.19-1/src/Composer/Repository/RepositoryManager.php 2.0.9-1/src/Composer/Repository/RepositoryManager.php
--- 1.10.19-1/src/Composer/Repository/RepositoryManager.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/RepositoryManager.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,7 +16,8 @@ use Composer\IO\IOInterface;
 use Composer\Config;
 use Composer\EventDispatcher\EventDispatcher;
 use Composer\Package\PackageInterface;
-use Composer\Util\RemoteFilesystem;
+use Composer\Util\HttpDownloader;
+use Composer\Util\ProcessExecutor;
 
 /**
  * Repositories manager.
@@ -27,20 +28,30 @@ use Composer\Util\RemoteFilesystem;
  */
 class RepositoryManager
 {
+    /** @var InstalledRepositoryInterface */
     private $localRepository;
+    /** @var list<RepositoryInterface> */
     private $repositories = array();
+    /** @var array<string, string> */
     private $repositoryClasses = array();
+    /** @var IOInterface */
     private $io;
+    /** @var Config */
     private $config;
+    /** @var HttpDownloader */
+    private $httpDownloader;
+    /** @var ?EventDispatcher */
     private $eventDispatcher;
-    private $rfs;
+    /** @var ProcessExecutor */
+    private $process;
 
-    public function __construct(IOInterface $io, Config $config, EventDispatcher $eventDispatcher = null, RemoteFilesystem $rfs = null)
+    public function __construct(IOInterface $io, Config $config, HttpDownloader $httpDownloader, EventDispatcher $eventDispatcher = null, ProcessExecutor $process = null)
     {
         $this->io = $io;
         $this->config = $config;
+        $this->httpDownloader = $httpDownloader;
         $this->eventDispatcher = $eventDispatcher;
-        $this->rfs = $rfs;
+        $this->process = $process ?: new ProcessExecutor($io);
     }
 
     /**
@@ -125,25 +136,18 @@ class RepositoryManager
 
         $class = $this->repositoryClasses[$type];
 
-        $reflMethod = new \ReflectionMethod($class, '__construct');
-        $params = $reflMethod->getParameters();
-        if (isset($params[4])) {
-            $paramType = null;
-            if (\PHP_VERSION_ID >= 70000) {
-                $reflectionType = $params[4]->getType();
-                if ($reflectionType) {
-                    $paramType = $reflectionType instanceof \ReflectionNamedType ? $reflectionType->getName() : (string)$reflectionType;
-                }
-            } else {
-                $paramType = $params[4]->getClass() ? $params[4]->getClass()->getName() : null;
-            }
+        if (isset($config['only']) || isset($config['exclude']) || isset($config['canonical'])) {
+            $filterConfig = $config;
+            unset($config['only'], $config['exclude'], $config['canonical']);
+        }
 
-            if ($paramType  === 'Composer\Util\RemoteFilesystem') {
-                return new $class($config, $this->io, $this->config, $this->eventDispatcher, $this->rfs);
-            }
+        $repository = new $class($config, $this->io, $this->config, $this->httpDownloader, $this->eventDispatcher, $this->process);
+
+        if (isset($filterConfig)) {
+            $repository = new FilterRepository($repository, $filterConfig);
         }
 
-        return new $class($config, $this->io, $this->config, $this->eventDispatcher);
+        return $repository;
     }
 
     /**
@@ -170,9 +174,9 @@ class RepositoryManager
     /**
      * Sets local repository for the project.
      *
-     * @param WritableRepositoryInterface $repository repository instance
+     * @param InstalledRepositoryInterface $repository repository instance
      */
-    public function setLocalRepository(WritableRepositoryInterface $repository)
+    public function setLocalRepository(InstalledRepositoryInterface $repository)
     {
         $this->localRepository = $repository;
     }
@@ -180,7 +184,7 @@ class RepositoryManager
     /**
      * Returns local repository for the project.
      *
-     * @return WritableRepositoryInterface
+     * @return InstalledRepositoryInterface
      */
     public function getLocalRepository()
     {
diff -pruN 1.10.19-1/src/Composer/Repository/RepositorySet.php 2.0.9-1/src/Composer/Repository/RepositorySet.php
--- 1.10.19-1/src/Composer/Repository/RepositorySet.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/RepositorySet.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,299 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Repository;
+
+use Composer\DependencyResolver\Pool;
+use Composer\DependencyResolver\PoolBuilder;
+use Composer\DependencyResolver\Request;
+use Composer\EventDispatcher\EventDispatcher;
+use Composer\IO\IOInterface;
+use Composer\IO\NullIO;
+use Composer\Package\BasePackage;
+use Composer\Package\AliasPackage;
+use Composer\Semver\Constraint\ConstraintInterface;
+use Composer\Package\Version\StabilityFilter;
+
+/**
+ * @author Nils Adermann <naderman@naderman.de>
+ */
+class RepositorySet
+{
+    /**
+     * Packages are returned even though their stability does not match the required stability
+     */
+    const ALLOW_UNACCEPTABLE_STABILITIES = 1;
+    /**
+     * Packages will be looked up in all repositories, even after they have been found in a higher prio one
+     */
+    const ALLOW_SHADOWED_REPOSITORIES = 2;
+
+    /**
+     * @var array[]
+     * @psalm-var array<string, array<string, array{alias: string, alias_normalized: string}>>
+     */
+    private $rootAliases;
+
+    /**
+     * @var string[]
+     * @psalm-var array<string, string>
+     */
+    private $rootReferences;
+
+    /** @var RepositoryInterface[] */
+    private $repositories = array();
+
+    /**
+     * @var int[] array of stability => BasePackage::STABILITY_* value
+     * @psalm-var array<string, int>
+     */
+    private $acceptableStabilities;
+
+    /**
+     * @var int[] array of package name => BasePackage::STABILITY_* value
+     * @psalm-var array<string, int>
+     */
+    private $stabilityFlags;
+
+    private $rootRequires;
+
+    /** @var bool */
+    private $locked = false;
+    /** @var bool */
+    private $allowInstalledRepositories = false;
+
+    /**
+     * In most cases if you are looking to use this class as a way to find packages from repositories
+     * passing minimumStability is all you need to worry about. The rest is for advanced pool creation including
+     * aliases, pinned references and other special cases.
+     *
+     * @param string $minimumStability
+     * @param int[]  $stabilityFlags   an array of package name => BasePackage::STABILITY_* value
+     * @psalm-param array<string, int> $stabilityFlags
+     * @param array[] $rootAliases
+     * @psalm-param list<array{package: string, version: string, alias: string, alias_normalized: string}> $rootAliases
+     * @param string[] $rootReferences an array of package name => source reference
+     * @psalm-param array<string, string> $rootReferences
+     */
+    public function __construct($minimumStability = 'stable', array $stabilityFlags = array(), array $rootAliases = array(), array $rootReferences = array(), array $rootRequires = array())
+    {
+        $this->rootAliases = self::getRootAliasesPerPackage($rootAliases);
+        $this->rootReferences = $rootReferences;
+
+        $this->acceptableStabilities = array();
+        foreach (BasePackage::$stabilities as $stability => $value) {
+            if ($value <= BasePackage::$stabilities[$minimumStability]) {
+                $this->acceptableStabilities[$stability] = $value;
+            }
+        }
+        $this->stabilityFlags = $stabilityFlags;
+        $this->rootRequires = $rootRequires;
+        foreach ($rootRequires as $name => $constraint) {
+            if (PlatformRepository::isPlatformPackage($name)) {
+                unset($this->rootRequires[$name]);
+            }
+        }
+    }
+
+    public function allowInstalledRepositories($allow = true)
+    {
+        $this->allowInstalledRepositories = $allow;
+    }
+
+    public function getRootRequires()
+    {
+        return $this->rootRequires;
+    }
+
+    /**
+     * Adds a repository to this repository set
+     *
+     * The first repos added have a higher priority. As soon as a package is found in any
+     * repository the search for that package ends, and following repos will not be consulted.
+     *
+     * @param RepositoryInterface $repo A package repository
+     */
+    public function addRepository(RepositoryInterface $repo)
+    {
+        if ($this->locked) {
+            throw new \RuntimeException("Pool has already been created from this repository set, it cannot be modified anymore.");
+        }
+
+        if ($repo instanceof CompositeRepository) {
+            $repos = $repo->getRepositories();
+        } else {
+            $repos = array($repo);
+        }
+
+        foreach ($repos as $repo) {
+            $this->repositories[] = $repo;
+        }
+    }
+
+    /**
+     * Find packages providing or matching a name and optionally meeting a constraint in all repositories
+     *
+     * Returned in the order of repositories, matching priority
+     *
+     * @param  string                   $name
+     * @param  ConstraintInterface|null $constraint
+     * @param  int                      $flags      any of the ALLOW_* constants from this class to tweak what is returned
+     * @return array
+     */
+    public function findPackages($name, ConstraintInterface $constraint = null, $flags = 0)
+    {
+        $ignoreStability = ($flags & self::ALLOW_UNACCEPTABLE_STABILITIES) !== 0;
+        $loadFromAllRepos = ($flags & self::ALLOW_SHADOWED_REPOSITORIES) !== 0;
+
+        $packages = array();
+        if ($loadFromAllRepos) {
+            foreach ($this->repositories as $repository) {
+                $packages[] = $repository->findPackages($name, $constraint) ?: array();
+            }
+        } else {
+            foreach ($this->repositories as $repository) {
+                $result = $repository->loadPackages(array($name => $constraint), $ignoreStability ? BasePackage::$stabilities : $this->acceptableStabilities, $ignoreStability ? array() : $this->stabilityFlags);
+
+                $packages[] = $result['packages'];
+                foreach ($result['namesFound'] as $nameFound) {
+                    // avoid loading the same package again from other repositories once it has been found
+                    if ($name === $nameFound) {
+                        break 2;
+                    }
+                }
+            }
+        }
+
+        $candidates = $packages ? call_user_func_array('array_merge', $packages) : array();
+
+        // when using loadPackages above (!$loadFromAllRepos) the repos already filter for stability so no need to do it again
+        if ($ignoreStability || !$loadFromAllRepos) {
+            return $candidates;
+        }
+
+        $result = array();
+        foreach ($candidates as $candidate) {
+            if ($this->isPackageAcceptable($candidate->getNames(), $candidate->getStability())) {
+                $result[] = $candidate;
+            }
+        }
+
+        return $result;
+    }
+
+    public function getProviders($packageName)
+    {
+        $providers = array();
+        foreach ($this->repositories as $repository) {
+            if ($repoProviders = $repository->getProviders($packageName)) {
+                $providers = array_merge($providers, $repoProviders);
+            }
+        }
+
+        return $providers;
+    }
+
+    public function isPackageAcceptable($names, $stability)
+    {
+        return StabilityFilter::isPackageAcceptable($this->acceptableStabilities, $this->stabilityFlags, $names, $stability);
+    }
+
+    /**
+     * Create a pool for dependency resolution from the packages in this repository set.
+     *
+     * @return Pool
+     */
+    public function createPool(Request $request, IOInterface $io, EventDispatcher $eventDispatcher = null)
+    {
+        $poolBuilder = new PoolBuilder($this->acceptableStabilities, $this->stabilityFlags, $this->rootAliases, $this->rootReferences, $io, $eventDispatcher);
+
+        foreach ($this->repositories as $repo) {
+            if (($repo instanceof InstalledRepositoryInterface || $repo instanceof InstalledRepository) && !$this->allowInstalledRepositories) {
+                throw new \LogicException('The pool can not accept packages from an installed repository');
+            }
+        }
+
+        $this->locked = true;
+
+        return $poolBuilder->buildPool($this->repositories, $request);
+    }
+
+    /**
+     * Create a pool for dependency resolution from the packages in this repository set.
+     *
+     * @return Pool
+     */
+    public function createPoolWithAllPackages()
+    {
+        foreach ($this->repositories as $repo) {
+            if (($repo instanceof InstalledRepositoryInterface || $repo instanceof InstalledRepository) && !$this->allowInstalledRepositories) {
+                throw new \LogicException('The pool can not accept packages from an installed repository');
+            }
+        }
+
+        $this->locked = true;
+
+        $packages = array();
+        foreach ($this->repositories as $repository) {
+            foreach ($repository->getPackages() as $package) {
+                $packages[] = $package;
+
+                if (isset($this->rootAliases[$package->getName()][$package->getVersion()])) {
+                    $alias = $this->rootAliases[$package->getName()][$package->getVersion()];
+                    while ($package instanceof AliasPackage) {
+                        $package = $package->getAliasOf();
+                    }
+                    $aliasPackage = new AliasPackage($package, $alias['alias_normalized'], $alias['alias']);
+                    $aliasPackage->setRootPackageAlias(true);
+                    $packages[] = $aliasPackage;
+                }
+            }
+        }
+
+        return new Pool($packages);
+    }
+
+    // TODO unify this with above in some simpler version without "request"?
+    public function createPoolForPackage($packageName, LockArrayRepository $lockedRepo = null)
+    {
+        return $this->createPoolForPackages(array($packageName), $lockedRepo);
+    }
+
+    public function createPoolForPackages($packageNames, LockArrayRepository $lockedRepo = null)
+    {
+        $request = new Request($lockedRepo);
+
+        foreach ($packageNames as $packageName) {
+            if (PlatformRepository::isPlatformPackage($packageName)) {
+                throw new \LogicException('createPoolForPackage(s) can not be used for platform packages, as they are never loaded by the PoolBuilder which expects them to be fixed. Use createPoolWithAllPackages or pass in a proper request with the platform packages you need fixed in it.');
+            }
+
+            $request->requireName($packageName);
+        }
+
+        return $this->createPool($request, new NullIO());
+    }
+
+    private static function getRootAliasesPerPackage(array $aliases)
+    {
+        $normalizedAliases = array();
+
+        foreach ($aliases as $alias) {
+            $normalizedAliases[$alias['package']][$alias['version']] = array(
+                'alias' => $alias['alias'],
+                'alias_normalized' => $alias['alias_normalized'],
+            );
+        }
+
+        return $normalizedAliases;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Repository/RootPackageRepository.php 2.0.9-1/src/Composer/Repository/RootPackageRepository.php
--- 1.10.19-1/src/Composer/Repository/RootPackageRepository.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/RootPackageRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,35 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Repository;
+
+use Composer\Package\RootPackageInterface;
+
+/**
+ * Root package repository.
+ *
+ * This is used for serving the RootPackage inside an in-memory InstalledRepository
+ *
+ * @author Jordi Boggiano <j.boggiano@seld.be>
+ */
+class RootPackageRepository extends ArrayRepository
+{
+    public function __construct(RootPackageInterface $package)
+    {
+        parent::__construct(array($package));
+    }
+
+    public function getRepoName()
+    {
+        return 'root package repo';
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Repository/Vcs/BitbucketDriver.php 2.0.9-1/src/Composer/Repository/Vcs/BitbucketDriver.php
--- 1.10.19-1/src/Composer/Repository/Vcs/BitbucketDriver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Vcs/BitbucketDriver.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,18 +16,16 @@ use Composer\Cache;
 use Composer\Downloader\TransportException;
 use Composer\Json\JsonFile;
 use Composer\Util\Bitbucket;
+use Composer\Util\Http\Response;
 
 abstract class BitbucketDriver extends VcsDriver
 {
-    /** @var Cache */
-    protected $cache;
     protected $owner;
     protected $repository;
     protected $hasIssues;
     protected $rootIdentifier;
     protected $tags;
     protected $branches;
-    protected $infoCache = array();
     protected $branchesUrl = '';
     protected $tagsUrl = '';
     protected $homeUrl = '';
@@ -59,6 +57,7 @@ abstract class BitbucketDriver extends V
                 $this->repository,
             ))
         );
+        $this->cache->setReadOnly($this->config->get('cache-read-only'));
     }
 
     /**
@@ -92,7 +91,7 @@ abstract class BitbucketDriver extends V
             )
         );
 
-        $repoData = JsonFile::parseJson($this->getContentsWithOAuthCredentials($resource, true), $resource);
+        $repoData = $this->fetchWithOAuthCredentials($resource, true)->decodeJson();
         if ($this->fallbackDriver) {
             return false;
         }
@@ -145,7 +144,7 @@ abstract class BitbucketDriver extends V
                         $hash = $branches[$label];
                     }
 
-                    if (! isset($hash)) {
+                    if (!isset($hash)) {
                         $composer['support']['source'] = sprintf(
                             'https://%s/%s/%s/src',
                             $this->originUrl,
@@ -206,7 +205,7 @@ abstract class BitbucketDriver extends V
             $file
         );
 
-        return $this->getContentsWithOAuthCredentials($resource);
+        return $this->fetchWithOAuthCredentials($resource)->getBody();
     }
 
     /**
@@ -231,7 +230,7 @@ abstract class BitbucketDriver extends V
             $this->repository,
             $identifier
         );
-        $commit = JsonFile::parseJson($this->getContentsWithOAuthCredentials($resource), $resource);
+        $commit = $this->fetchWithOAuthCredentials($resource)->decodeJson();
 
         return new \DateTime($commit['date']);
     }
@@ -293,7 +292,7 @@ abstract class BitbucketDriver extends V
             );
             $hasNext = true;
             while ($hasNext) {
-                $tagsData = JsonFile::parseJson($this->getContentsWithOAuthCredentials($resource), $resource);
+                $tagsData = $this->fetchWithOAuthCredentials($resource)->decodeJson();
                 foreach ($tagsData['values'] as $data) {
                     $this->tags[$data['name']] = $data['target']['hash'];
                 }
@@ -337,7 +336,7 @@ abstract class BitbucketDriver extends V
             );
             $hasNext = true;
             while ($hasNext) {
-                $branchData = JsonFile::parseJson($this->getContentsWithOAuthCredentials($resource), $resource);
+                $branchData = $this->fetchWithOAuthCredentials($resource)->decodeJson();
                 foreach ($branchData['values'] as $data) {
                     // skip headless branches which seem to be deleted branches that bitbucket nevertheless returns in the API
                     if ($this->vcsType === 'hg' && empty($data['heads'])) {
@@ -363,14 +362,14 @@ abstract class BitbucketDriver extends V
      * @param string $url              The URL of content
      * @param bool   $fetchingRepoData
      *
-     * @return mixed The result
+     * @return Response The result
      */
-    protected function getContentsWithOAuthCredentials($url, $fetchingRepoData = false)
+    protected function fetchWithOAuthCredentials($url, $fetchingRepoData = false)
     {
         try {
             return parent::getContents($url);
         } catch (TransportException $e) {
-            $bitbucketUtil = new Bitbucket($this->io, $this->config, $this->process, $this->remoteFilesystem);
+            $bitbucketUtil = new Bitbucket($this->io, $this->config, $this->process, $this->httpDownloader);
 
             if (403 === $e->getCode() || (401 === $e->getCode() && strpos($e->getMessage(), 'Could not authenticate against') === 0)) {
                 if (!$this->io->hasAuthentication($this->originUrl)
@@ -380,7 +379,9 @@ abstract class BitbucketDriver extends V
                 }
 
                 if (!$this->io->isInteractive() && $fetchingRepoData) {
-                    return $this->attemptCloneFallback();
+                    if ($this->attemptCloneFallback()) {
+                        return new Response(array('url' => 'dummy'), 200, array(), 'null');
+                    }
                 }
             }
 
@@ -399,6 +400,8 @@ abstract class BitbucketDriver extends V
     {
         try {
             $this->setupFallbackDriver($this->generateSshUrl());
+
+            return true;
         } catch (\RuntimeException $e) {
             $this->fallbackDriver = null;
 
@@ -442,7 +445,7 @@ abstract class BitbucketDriver extends V
             $this->repository
         );
 
-        $data = JsonFile::parseJson($this->getContentsWithOAuthCredentials($resource), $resource);
+        $data = $this->fetchWithOAuthCredentials($resource)->decodeJson();
         if (isset($data['mainbranch'])) {
             return $data['mainbranch'];
         }
diff -pruN 1.10.19-1/src/Composer/Repository/Vcs/FossilDriver.php 2.0.9-1/src/Composer/Repository/Vcs/FossilDriver.php
--- 1.10.19-1/src/Composer/Repository/Vcs/FossilDriver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Vcs/FossilDriver.php	2021-01-27 15:09:27.000000000 +0000
@@ -28,7 +28,6 @@ class FossilDriver extends VcsDriver
     protected $rootIdentifier;
     protected $repoFile;
     protected $checkoutDir;
-    protected $infoCache = array();
 
     /**
      * {@inheritDoc}
@@ -166,7 +165,7 @@ class FossilDriver extends VcsDriver
     public function getChangeDate($identifier)
     {
         $this->process->execute('fossil finfo -b -n 1 composer.json', $output, $this->checkoutDir);
-        list($ckout, $date, $message) = explode(' ', trim($output), 3);
+        list(, $date) = explode(' ', trim($output), 3);
 
         return new \DateTime($date, new \DateTimeZone('UTC'));
     }
@@ -197,7 +196,6 @@ class FossilDriver extends VcsDriver
     {
         if (null === $this->branches) {
             $branches = array();
-            $bookmarks = array();
 
             $this->process->execute('fossil branch list', $output, $this->checkoutDir);
             foreach ($this->process->splitLines($output) as $branch) {
diff -pruN 1.10.19-1/src/Composer/Repository/Vcs/GitBitbucketDriver.php 2.0.9-1/src/Composer/Repository/Vcs/GitBitbucketDriver.php
--- 1.10.19-1/src/Composer/Repository/Vcs/GitBitbucketDriver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Vcs/GitBitbucketDriver.php	2021-01-27 15:09:27.000000000 +0000
@@ -30,7 +30,7 @@ class GitBitbucketDriver extends Bitbuck
         }
 
         if (null === $this->rootIdentifier) {
-            if (! $this->getRepoData()) {
+            if (!$this->getRepoData()) {
                 return $this->fallbackDriver->getRootIdentifier();
             }
 
@@ -75,8 +75,8 @@ class GitBitbucketDriver extends Bitbuck
             array('url' => $url),
             $this->io,
             $this->config,
-            $this->process,
-            $this->remoteFilesystem
+            $this->httpDownloader,
+            $this->process
         );
         $this->fallbackDriver->initialize();
     }
diff -pruN 1.10.19-1/src/Composer/Repository/Vcs/GitDriver.php 2.0.9-1/src/Composer/Repository/Vcs/GitDriver.php
--- 1.10.19-1/src/Composer/Repository/Vcs/GitDriver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Vcs/GitDriver.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,6 +14,7 @@ namespace Composer\Repository\Vcs;
 
 use Composer\Util\ProcessExecutor;
 use Composer\Util\Filesystem;
+use Composer\Util\Url;
 use Composer\Util\Git as GitUtil;
 use Composer\IO\IOInterface;
 use Composer\Cache;
@@ -24,12 +25,10 @@ use Composer\Config;
  */
 class GitDriver extends VcsDriver
 {
-    protected $cache;
     protected $tags;
     protected $branches;
     protected $rootIdentifier;
     protected $repoDir;
-    protected $infoCache = array();
 
     /**
      * {@inheritDoc}
@@ -62,6 +61,9 @@ class GitDriver extends VcsDriver
 
             $gitUtil = new GitUtil($this->io, $this->config, $this->process, $fs);
             if (!$gitUtil->syncMirror($this->url, $this->repoDir)) {
+                if (!is_dir($this->repoDir)) {
+                    throw new \RuntimeException('Failed to clone '.$this->url.' to read package information from it');
+                }
                 $this->io->writeError('<error>Failed to update '.$this->url.', package information from this repository may be outdated</error>');
             }
 
@@ -71,7 +73,8 @@ class GitDriver extends VcsDriver
         $this->getTags();
         $this->getBranches();
 
-        $this->cache = new Cache($this->io, $this->config->get('cache-repo-dir').'/'.preg_replace('{[^a-z0-9.]}i', '-', $cacheUrl));
+        $this->cache = new Cache($this->io, $this->config->get('cache-repo-dir').'/'.preg_replace('{[^a-z0-9.]}i', '-', Url::sanitize($cacheUrl)));
+        $this->cache->setReadOnly($this->config->get('cache-read-only'));
     }
 
     /**
diff -pruN 1.10.19-1/src/Composer/Repository/Vcs/GitHubDriver.php 2.0.9-1/src/Composer/Repository/Vcs/GitHubDriver.php
--- 1.10.19-1/src/Composer/Repository/Vcs/GitHubDriver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Vcs/GitHubDriver.php	2021-01-27 15:09:27.000000000 +0000
@@ -18,13 +18,13 @@ use Composer\Json\JsonFile;
 use Composer\Cache;
 use Composer\IO\IOInterface;
 use Composer\Util\GitHub;
+use Composer\Util\Http\Response;
 
 /**
  * @author Jordi Boggiano <j.boggiano@seld.be>
  */
 class GitHubDriver extends VcsDriver
 {
-    protected $cache;
     protected $owner;
     protected $repository;
     protected $tags;
@@ -32,7 +32,6 @@ class GitHubDriver extends VcsDriver
     protected $rootIdentifier;
     protected $repoData;
     protected $hasIssues;
-    protected $infoCache = array();
     protected $isPrivate = false;
     private $isArchived = false;
     private $fundingInfo;
@@ -57,8 +56,9 @@ class GitHubDriver extends VcsDriver
             $this->originUrl = 'github.com';
         }
         $this->cache = new Cache($this->io, $this->config->get('cache-repo-dir').'/'.$this->originUrl.'/'.$this->owner.'/'.$this->repository);
+        $this->cache->setReadOnly($this->config->get('cache-read-only'));
 
-        if ( $this->config->get('use-github-api') === false || (isset($this->repoConfig['no-api']) && $this->repoConfig['no-api'] ) ){
+        if ($this->config->get('use-github-api') === false || (isset($this->repoConfig['no-api']) && $this->repoConfig['no-api'])) {
             $this->setupGitDriver($this->url);
 
             return;
@@ -150,7 +150,7 @@ class GitHubDriver extends VcsDriver
 
         if (!isset($this->infoCache[$identifier])) {
             if ($this->shouldCache($identifier) && $res = $this->cache->read($identifier)) {
-                $composer =  JsonFile::parseJson($res);
+                $composer = JsonFile::parseJson($res);
             } else {
                 $composer = $this->getBaseComposerInformation($identifier);
 
@@ -193,12 +193,10 @@ class GitHubDriver extends VcsDriver
         }
 
         foreach (array($this->getApiUrl() . '/repos/'.$this->owner.'/'.$this->repository.'/contents/.github/FUNDING.yml', $this->getApiUrl() . '/repos/'.$this->owner.'/.github/contents/FUNDING.yml') as $file) {
-
             try {
-                $result = $this->remoteFilesystem->getContents($this->originUrl, $file, false, array(
+                $response = $this->httpDownloader->get($file, array(
                     'retry-auth-failure' => false,
-                ));
-                $response = json_decode($result, true);
+                ))->decodeJson();
             } catch (TransportException $e) {
                 continue;
             }
@@ -276,7 +274,7 @@ class GitHubDriver extends VcsDriver
         }
 
         $resource = $this->getApiUrl() . '/repos/'.$this->owner.'/'.$this->repository.'/contents/' . $file . '?ref='.urlencode($identifier);
-        $resource = JsonFile::parseJson($this->getContents($resource));
+        $resource = $this->getContents($resource)->decodeJson();
         if (empty($resource['content']) || $resource['encoding'] !== 'base64' || !($content = base64_decode($resource['content']))) {
             throw new \RuntimeException('Could not retrieve ' . $file . ' for '.$identifier);
         }
@@ -294,7 +292,7 @@ class GitHubDriver extends VcsDriver
         }
 
         $resource = $this->getApiUrl() . '/repos/'.$this->owner.'/'.$this->repository.'/commits/'.urlencode($identifier);
-        $commit = JsonFile::parseJson($this->getContents($resource), $resource);
+        $commit = $this->getContents($resource)->decodeJson();
 
         return new \DateTime($commit['commit']['committer']['date']);
     }
@@ -312,12 +310,13 @@ class GitHubDriver extends VcsDriver
             $resource = $this->getApiUrl() . '/repos/'.$this->owner.'/'.$this->repository.'/tags?per_page=100';
 
             do {
-                $tagsData = JsonFile::parseJson($this->getContents($resource), $resource);
+                $response = $this->getContents($resource);
+                $tagsData = $response->decodeJson();
                 foreach ($tagsData as $tag) {
                     $this->tags[$tag['name']] = $tag['commit']['sha'];
                 }
 
-                $resource = $this->getNextPage();
+                $resource = $this->getNextPage($response);
             } while ($resource);
         }
 
@@ -337,7 +336,8 @@ class GitHubDriver extends VcsDriver
             $resource = $this->getApiUrl() . '/repos/'.$this->owner.'/'.$this->repository.'/git/refs/heads?per_page=100';
 
             do {
-                $branchData = JsonFile::parseJson($this->getContents($resource), $resource);
+                $response = $this->getContents($resource);
+                $branchData = $response->decodeJson();
                 foreach ($branchData as $branch) {
                     $name = substr($branch['ref'], 11);
                     if ($name !== 'gh-pages') {
@@ -345,7 +345,7 @@ class GitHubDriver extends VcsDriver
                     }
                 }
 
-                $resource = $this->getNextPage();
+                $resource = $this->getNextPage($response);
             } while ($resource);
         }
 
@@ -409,7 +409,7 @@ class GitHubDriver extends VcsDriver
         try {
             return parent::getContents($url);
         } catch (TransportException $e) {
-            $gitHubUtil = new GitHub($this->io, $this->config, $this->process, $this->remoteFilesystem);
+            $gitHubUtil = new GitHub($this->io, $this->config, $this->process, $this->httpDownloader);
 
             switch ($e->getCode()) {
                 case 401:
@@ -424,16 +424,18 @@ class GitHubDriver extends VcsDriver
                     }
 
                     if (!$this->io->isInteractive()) {
-                        return $this->attemptCloneFallback();
+                        if ($this->attemptCloneFallback()) {
+                            return new Response(array('url' => 'dummy'), 200, array(), 'null');
+                        }
                     }
 
                     $scopesIssued = array();
                     $scopesNeeded = array();
                     if ($headers = $e->getHeaders()) {
-                        if ($scopes = $this->remoteFilesystem->findHeaderValue($headers, 'X-OAuth-Scopes')) {
+                        if ($scopes = Response::findHeaderValue($headers, 'X-OAuth-Scopes')) {
                             $scopesIssued = explode(' ', $scopes);
                         }
-                        if ($scopes = $this->remoteFilesystem->findHeaderValue($headers, 'X-Accepted-OAuth-Scopes')) {
+                        if ($scopes = Response::findHeaderValue($headers, 'X-Accepted-OAuth-Scopes')) {
                             $scopesNeeded = explode(' ', $scopes);
                         }
                     }
@@ -452,7 +454,9 @@ class GitHubDriver extends VcsDriver
                     }
 
                     if (!$this->io->isInteractive() && $fetchingRepoData) {
-                        return $this->attemptCloneFallback();
+                        if ($this->attemptCloneFallback()) {
+                            return new Response(array('url' => 'dummy'), 200, array(), 'null');
+                        }
                     }
 
                     $rateLimited = $gitHubUtil->isRateLimited($e->getHeaders());
@@ -498,7 +502,15 @@ class GitHubDriver extends VcsDriver
 
         $repoDataUrl = $this->getApiUrl() . '/repos/'.$this->owner.'/'.$this->repository;
 
-        $this->repoData = JsonFile::parseJson($this->getContents($repoDataUrl, true), $repoDataUrl);
+        try {
+            $this->repoData = $this->getContents($repoDataUrl, true)->decodeJson();
+        } catch (TransportException $e) {
+            if ($e->getCode() === 499) {
+                $this->attemptCloneFallback();
+            } else {
+                throw $e;
+            }
+        }
         if (null === $this->repoData && null !== $this->gitDriver) {
             return;
         }
@@ -529,7 +541,7 @@ class GitHubDriver extends VcsDriver
             // are not interactive) then we fallback to GitDriver.
             $this->setupGitDriver($this->generateSshUrl());
 
-            return;
+            return true;
         } catch (\RuntimeException $e) {
             $this->gitDriver = null;
 
@@ -544,23 +556,20 @@ class GitHubDriver extends VcsDriver
             array('url' => $url),
             $this->io,
             $this->config,
-            $this->process,
-            $this->remoteFilesystem
+            $this->httpDownloader,
+            $this->process
         );
         $this->gitDriver->initialize();
     }
 
-    protected function getNextPage()
+    protected function getNextPage(Response $response)
     {
-        $headers = $this->remoteFilesystem->getLastHeaders();
-        foreach ($headers as $header) {
-            if (preg_match('{^link:\s*(.+?)\s*$}i', $header, $match)) {
-                $links = explode(',', $match[1]);
-                foreach ($links as $link) {
-                    if (preg_match('{<(.+?)>; *rel="next"}', $link, $match)) {
-                        return $match[1];
-                    }
-                }
+        $header = $response->getHeader('link');
+
+        $links = explode(',', $header);
+        foreach ($links as $link) {
+            if (preg_match('{<(.+?)>; *rel="next"}', $link, $match)) {
+                return $match[1];
             }
         }
     }
diff -pruN 1.10.19-1/src/Composer/Repository/Vcs/GitLabDriver.php 2.0.9-1/src/Composer/Repository/Vcs/GitLabDriver.php
--- 1.10.19-1/src/Composer/Repository/Vcs/GitLabDriver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Vcs/GitLabDriver.php	2021-01-27 15:09:27.000000000 +0000
@@ -17,8 +17,9 @@ use Composer\Cache;
 use Composer\IO\IOInterface;
 use Composer\Json\JsonFile;
 use Composer\Downloader\TransportException;
-use Composer\Util\RemoteFilesystem;
+use Composer\Util\HttpDownloader;
 use Composer\Util\GitLab;
+use Composer\Util\Http\Response;
 
 /**
  * Driver for GitLab API, use the Git driver for local checkouts.
@@ -94,7 +95,7 @@ class GitLabDriver extends VcsDriver
             ? $match['scheme']
             : (isset($this->repoConfig['secure-http']) && $this->repoConfig['secure-http'] === false ? 'http' : 'https')
         ;
-        $this->originUrl = $this->determineOrigin($configuredDomains, $guessedDomain, $urlParts, $match['port']);
+        $this->originUrl = self::determineOrigin($configuredDomains, $guessedDomain, $urlParts, $match['port']);
 
         if (false !== strpos($this->originUrl, ':') || false !== strpos($this->originUrl, '/')) {
             $this->hasNonstandardOrigin = true;
@@ -104,19 +105,20 @@ class GitLabDriver extends VcsDriver
         $this->repository = preg_replace('#(\.git)$#', '', $match['repo']);
 
         $this->cache = new Cache($this->io, $this->config->get('cache-repo-dir').'/'.$this->originUrl.'/'.$this->namespace.'/'.$this->repository);
+        $this->cache->setReadOnly($this->config->get('cache-read-only'));
 
         $this->fetchProject();
     }
 
     /**
-     * Updates the RemoteFilesystem instance.
+     * Updates the HttpDownloader instance.
      * Mainly useful for tests.
      *
      * @internal
      */
-    public function setRemoteFilesystem(RemoteFilesystem $remoteFilesystem)
+    public function setHttpDownloader(HttpDownloader $httpDownloader)
     {
-        $this->remoteFilesystem = $remoteFilesystem;
+        $this->httpDownloader = $httpDownloader;
     }
 
     /**
@@ -130,7 +132,7 @@ class GitLabDriver extends VcsDriver
 
         if (!isset($this->infoCache[$identifier])) {
             if ($this->shouldCache($identifier) && $res = $this->cache->read($identifier)) {
-                $composer =  JsonFile::parseJson($res);
+                $composer = JsonFile::parseJson($res);
             } else {
                 $composer = $this->getBaseComposerInformation($identifier);
 
@@ -175,7 +177,7 @@ class GitLabDriver extends VcsDriver
         $resource = $this->getApiUrl().'/repository/files/'.$this->urlEncodeAll($file).'/raw?ref='.$identifier;
 
         try {
-            $content = $this->getContents($resource);
+            $content = $this->getContents($resource)->getBody();
         } catch (TransportException $e) {
             if ($e->getCode() !== 404) {
                 throw $e;
@@ -329,7 +331,8 @@ class GitLabDriver extends VcsDriver
 
         $references = array();
         do {
-            $data = JsonFile::parseJson($this->getContents($resource), $resource);
+            $response = $this->getContents($resource);
+            $data = $response->decodeJson();
 
             foreach ($data as $datum) {
                 $references[$datum['name']] = $datum['commit']['id'];
@@ -340,7 +343,7 @@ class GitLabDriver extends VcsDriver
             }
 
             if (count($data) >= $perPage) {
-                $resource = $this->getNextPage();
+                $resource = $this->getNextPage($response);
             } else {
                 $resource = false;
             }
@@ -353,7 +356,7 @@ class GitLabDriver extends VcsDriver
     {
         // we need to fetch the default branch from the api
         $resource = $this->getApiUrl();
-        $this->project = JsonFile::parseJson($this->getContents($resource, true), $resource);
+        $this->project = $this->getContents($resource, true)->decodeJson();
         if (isset($this->project['visibility'])) {
             $this->isPrivate = $this->project['visibility'] !== 'public';
         } else {
@@ -364,19 +367,19 @@ class GitLabDriver extends VcsDriver
 
     protected function attemptCloneFallback()
     {
-        try {
-            if ($this->isPrivate === false) {
-                $url = $this->generatePublicUrl();
-            } else {
-                $url = $this->generateSshUrl();
-            }
+        if ($this->isPrivate === false) {
+            $url = $this->generatePublicUrl();
+        } else {
+            $url = $this->generateSshUrl();
+        }
 
+        try {
             // If this repository may be private and we
             // cannot ask for authentication credentials (because we
             // are not interactive) then we fallback to GitDriver.
             $this->setupGitDriver($url);
 
-            return;
+            return true;
         } catch (\RuntimeException $e) {
             $this->gitDriver = null;
 
@@ -410,8 +413,8 @@ class GitLabDriver extends VcsDriver
             array('url' => $url),
             $this->io,
             $this->config,
-            $this->process,
-            $this->remoteFilesystem
+            $this->httpDownloader,
+            $this->process
         );
         $this->gitDriver->initialize();
     }
@@ -422,10 +425,10 @@ class GitLabDriver extends VcsDriver
     protected function getContents($url, $fetchingRepoData = false)
     {
         try {
-            $res = parent::getContents($url);
+            $response = parent::getContents($url);
 
             if ($fetchingRepoData) {
-                $json = JsonFile::parseJson($res, $url);
+                $json = $response->decodeJson();
 
                 // Accessing the API with a token with Guest (10) access will return
                 // more data than unauthenticated access but no default_branch data
@@ -460,9 +463,9 @@ class GitLabDriver extends VcsDriver
                 }
             }
 
-            return $res;
+            return $response;
         } catch (TransportException $e) {
-            $gitLabUtil = new GitLab($this->io, $this->config, $this->process, $this->remoteFilesystem);
+            $gitLabUtil = new GitLab($this->io, $this->config, $this->process, $this->httpDownloader);
 
             switch ($e->getCode()) {
                 case 401:
@@ -477,7 +480,9 @@ class GitLabDriver extends VcsDriver
                     }
 
                     if (!$this->io->isInteractive()) {
-                        return $this->attemptCloneFallback();
+                        if ($this->attemptCloneFallback()) {
+                            return new Response(array('url' => 'dummy'), 200, array(), 'null');
+                        }
                     }
                     $this->io->writeError('<warning>Failed to download ' . $this->namespace . '/' . $this->repository . ':' . $e->getMessage() . '</warning>');
                     $gitLabUtil->authorizeOAuthInteractively($this->scheme, $this->originUrl, 'Your credentials are required to fetch private repository metadata (<info>'.$this->url.'</info>)');
@@ -490,7 +495,9 @@ class GitLabDriver extends VcsDriver
                     }
 
                     if (!$this->io->isInteractive() && $fetchingRepoData) {
-                        return $this->attemptCloneFallback();
+                        if ($this->attemptCloneFallback()) {
+                            return new Response(array('url' => 'dummy'), 200, array(), 'null');
+                        }
                     }
 
                     throw $e;
@@ -530,17 +537,14 @@ class GitLabDriver extends VcsDriver
         return true;
     }
 
-    private function getNextPage()
+    protected function getNextPage(Response $response)
     {
-        $headers = $this->remoteFilesystem->getLastHeaders();
-        foreach ($headers as $header) {
-            if (preg_match('{^link:\s*(.+?)\s*$}i', $header, $match)) {
-                $links = explode(',', $match[1]);
-                foreach ($links as $link) {
-                    if (preg_match('{<(.+?)>; *rel="next"}', $link, $match)) {
-                        return $match[1];
-                    }
-                }
+        $header = $response->getHeader('link');
+
+        $links = explode(',', $header);
+        foreach ($links as $link) {
+            if (preg_match('{<(.+?)>; *rel="next"}', $link, $match)) {
+                return $match[1];
             }
         }
     }
@@ -559,6 +563,7 @@ class GitLabDriver extends VcsDriver
             if ($portNumber) {
                 return $guessedDomain.':'.$portNumber;
             }
+
             return $guessedDomain;
         }
 
diff -pruN 1.10.19-1/src/Composer/Repository/Vcs/HgBitbucketDriver.php 2.0.9-1/src/Composer/Repository/Vcs/HgBitbucketDriver.php
--- 1.10.19-1/src/Composer/Repository/Vcs/HgBitbucketDriver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Vcs/HgBitbucketDriver.php	2021-01-27 15:09:27.000000000 +0000
@@ -30,7 +30,7 @@ class HgBitbucketDriver extends Bitbucke
         }
 
         if (null === $this->rootIdentifier) {
-            if (! $this->getRepoData()) {
+            if (!$this->getRepoData()) {
                 return $this->fallbackDriver->getRootIdentifier();
             }
 
@@ -75,8 +75,8 @@ class HgBitbucketDriver extends Bitbucke
             array('url' => $url),
             $this->io,
             $this->config,
-            $this->process,
-            $this->remoteFilesystem
+            $this->httpDownloader,
+            $this->process
         );
         $this->fallbackDriver->initialize();
     }
diff -pruN 1.10.19-1/src/Composer/Repository/Vcs/HgDriver.php 2.0.9-1/src/Composer/Repository/Vcs/HgDriver.php
--- 1.10.19-1/src/Composer/Repository/Vcs/HgDriver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Vcs/HgDriver.php	2021-01-27 15:09:27.000000000 +0000
@@ -28,7 +28,6 @@ class HgDriver extends VcsDriver
     protected $branches;
     protected $rootIdentifier;
     protected $repoDir;
-    protected $infoCache = array();
 
     /**
      * {@inheritDoc}
@@ -228,8 +227,8 @@ class HgDriver extends VcsDriver
             return false;
         }
 
-        $processExecutor = new ProcessExecutor($io);
-        $exit = $processExecutor->execute(sprintf('hg identify %s', ProcessExecutor::escape($url)), $ignored);
+        $process = new ProcessExecutor($io);
+        $exit = $process->execute(sprintf('hg identify %s', ProcessExecutor::escape($url)), $ignored);
 
         return $exit === 0;
     }
diff -pruN 1.10.19-1/src/Composer/Repository/Vcs/PerforceDriver.php 2.0.9-1/src/Composer/Repository/Vcs/PerforceDriver.php
--- 1.10.19-1/src/Composer/Repository/Vcs/PerforceDriver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Vcs/PerforceDriver.php	2021-01-27 15:09:27.000000000 +0000
@@ -116,14 +116,12 @@ class PerforceDriver extends VcsDriver
      */
     public function getSource($identifier)
     {
-        $source = array(
+        return array(
             'type' => 'perforce',
             'url' => $this->repoConfig['url'],
             'reference' => $identifier,
             'p4user' => $this->perforce->getUser(),
         );
-
-        return $source;
     }
 
     /**
@@ -140,7 +138,6 @@ class PerforceDriver extends VcsDriver
     public function hasComposerFile($identifier)
     {
         $composerInfo = $this->perforce->getComposerInformation('//' . $this->depot . '/' . $identifier);
-        $composerInfoIdentifier = $identifier;
 
         return !empty($composerInfo);
     }
diff -pruN 1.10.19-1/src/Composer/Repository/Vcs/SvnDriver.php 2.0.9-1/src/Composer/Repository/Vcs/SvnDriver.php
--- 1.10.19-1/src/Composer/Repository/Vcs/SvnDriver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Vcs/SvnDriver.php	2021-01-27 15:09:27.000000000 +0000
@@ -17,6 +17,7 @@ use Composer\Config;
 use Composer\Json\JsonFile;
 use Composer\Util\ProcessExecutor;
 use Composer\Util\Filesystem;
+use Composer\Util\Url;
 use Composer\Util\Svn as SvnUtil;
 use Composer\IO\IOInterface;
 use Composer\Downloader\TransportException;
@@ -27,15 +28,10 @@ use Composer\Downloader\TransportExcepti
  */
 class SvnDriver extends VcsDriver
 {
-    /**
-     * @var Cache
-     */
-    protected $cache;
     protected $baseUrl;
     protected $tags;
     protected $branches;
     protected $rootIdentifier;
-    protected $infoCache = array();
 
     protected $trunkPath = 'trunk';
     protected $branchesPath = 'branches';
@@ -77,7 +73,8 @@ class SvnDriver extends VcsDriver
             $this->baseUrl = substr($this->url, 0, $pos);
         }
 
-        $this->cache = new Cache($this->io, $this->config->get('cache-repo-dir').'/'.preg_replace('{[^a-z0-9.]}i', '-', $this->baseUrl));
+        $this->cache = new Cache($this->io, $this->config->get('cache-repo-dir').'/'.preg_replace('{[^a-z0-9.]}i', '-', Url::sanitize($this->baseUrl)));
+        $this->cache->setReadOnly($this->config->get('cache-read-only'));
 
         $this->getBranches();
         $this->getTags();
@@ -224,7 +221,7 @@ class SvnDriver extends VcsDriver
                     foreach ($this->process->splitLines($output) as $line) {
                         $line = trim($line);
                         if ($line && preg_match('{^\s*(\S+).*?(\S+)\s*$}', $line, $match)) {
-                            if (isset($match[1]) && isset($match[2]) && $match[2] !== './') {
+                            if (isset($match[1], $match[2]) && $match[2] !== './') {
                                 $this->tags[rtrim($match[2], '/')] = $this->buildIdentifier(
                                     '/' . $this->tagsPath . '/' . $match[2],
                                     $match[1]
@@ -258,7 +255,7 @@ class SvnDriver extends VcsDriver
                 foreach ($this->process->splitLines($output) as $line) {
                     $line = trim($line);
                     if ($line && preg_match('{^\s*(\S+).*?(\S+)\s*$}', $line, $match)) {
-                        if (isset($match[1]) && isset($match[2]) && $match[2] === './') {
+                        if (isset($match[1], $match[2]) && $match[2] === './') {
                             $this->branches['trunk'] = $this->buildIdentifier(
                                 '/' . $this->trunkPath,
                                 $match[1]
@@ -277,7 +274,7 @@ class SvnDriver extends VcsDriver
                     foreach ($this->process->splitLines(trim($output)) as $line) {
                         $line = trim($line);
                         if ($line && preg_match('{^\s*(\S+).*?(\S+)\s*$}', $line, $match)) {
-                            if (isset($match[1]) && isset($match[2]) && $match[2] !== './') {
+                            if (isset($match[1], $match[2]) && $match[2] !== './') {
                                 $this->branches[rtrim($match[2], '/')] = $this->buildIdentifier(
                                     '/' . $this->branchesPath . '/' . $match[2],
                                     $match[1]
@@ -307,9 +304,8 @@ class SvnDriver extends VcsDriver
             return false;
         }
 
-        $processExecutor = new ProcessExecutor($io);
-
-        $exit = $processExecutor->execute(
+        $process = new ProcessExecutor($io);
+        $exit = $process->execute(
             "svn info --non-interactive ".ProcessExecutor::escape($url),
             $ignoredOutput
         );
@@ -320,14 +316,14 @@ class SvnDriver extends VcsDriver
         }
 
         // Subversion client 1.7 and older
-        if (false !== stripos($processExecutor->getErrorOutput(), 'authorization failed:')) {
+        if (false !== stripos($process->getErrorOutput(), 'authorization failed:')) {
             // This is likely a remote Subversion repository that requires
             // authentication. We will handle actual authentication later.
             return true;
         }
 
         // Subversion client 1.8 and newer
-        if (false !== stripos($processExecutor->getErrorOutput(), 'Authentication failed')) {
+        if (false !== stripos($process->getErrorOutput(), 'Authentication failed')) {
             // This is likely a remote Subversion or newer repository that requires
             // authentication. We will handle actual authentication later.
             return true;
diff -pruN 1.10.19-1/src/Composer/Repository/Vcs/VcsDriverInterface.php 2.0.9-1/src/Composer/Repository/Vcs/VcsDriverInterface.php
--- 1.10.19-1/src/Composer/Repository/Vcs/VcsDriverInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Vcs/VcsDriverInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -36,17 +36,17 @@ interface VcsDriverInterface
     /**
      * Return the content of $file or null if the file does not exist.
      *
-     * @param  string $file
-     * @param  string $identifier
-     * @return string
+     * @param  string      $file
+     * @param  string      $identifier
+     * @return string|null
      */
     public function getFileContent($file, $identifier);
 
     /**
      * Get the changedate for $identifier.
      *
-     * @param  string    $identifier
-     * @return \DateTime
+     * @param  string         $identifier
+     * @return \DateTime|null
      */
     public function getChangeDate($identifier);
 
@@ -72,8 +72,8 @@ interface VcsDriverInterface
     public function getTags();
 
     /**
-     * @param  string $identifier Any identifier to a specific branch/tag/commit
-     * @return array  With type, url reference and shasum keys.
+     * @param  string     $identifier Any identifier to a specific branch/tag/commit
+     * @return array|null With type, url reference and shasum keys.
      */
     public function getDist($identifier);
 
diff -pruN 1.10.19-1/src/Composer/Repository/Vcs/VcsDriver.php 2.0.9-1/src/Composer/Repository/Vcs/VcsDriver.php
--- 1.10.19-1/src/Composer/Repository/Vcs/VcsDriver.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/Vcs/VcsDriver.php	2021-01-27 15:09:27.000000000 +0000
@@ -15,12 +15,12 @@ namespace Composer\Repository\Vcs;
 use Composer\Cache;
 use Composer\Downloader\TransportException;
 use Composer\Config;
-use Composer\Factory;
 use Composer\IO\IOInterface;
 use Composer\Json\JsonFile;
 use Composer\Util\ProcessExecutor;
-use Composer\Util\RemoteFilesystem;
+use Composer\Util\HttpDownloader;
 use Composer\Util\Filesystem;
+use Composer\Util\Http\Response;
 
 /**
  * A driver implementation for driver with authentication interaction.
@@ -41,8 +41,8 @@ abstract class VcsDriver implements VcsD
     protected $config;
     /** @var ProcessExecutor */
     protected $process;
-    /** @var RemoteFilesystem */
-    protected $remoteFilesystem;
+    /** @var HttpDownloader */
+    protected $httpDownloader;
     /** @var array */
     protected $infoCache = array();
     /** @var Cache */
@@ -51,13 +51,13 @@ abstract class VcsDriver implements VcsD
     /**
      * Constructor.
      *
-     * @param array            $repoConfig       The repository configuration
-     * @param IOInterface      $io               The IO instance
-     * @param Config           $config           The composer configuration
-     * @param ProcessExecutor  $process          Process instance, injectable for mocking
-     * @param RemoteFilesystem $remoteFilesystem Remote Filesystem, injectable for mocking
+     * @param array           $repoConfig     The repository configuration
+     * @param IOInterface     $io             The IO instance
+     * @param Config          $config         The composer configuration
+     * @param HttpDownloader  $httpDownloader Remote Filesystem, injectable for mocking
+     * @param ProcessExecutor $process        Process instance, injectable for mocking
      */
-    final public function __construct(array $repoConfig, IOInterface $io, Config $config, ProcessExecutor $process = null, RemoteFilesystem $remoteFilesystem = null)
+    final public function __construct(array $repoConfig, IOInterface $io, Config $config, HttpDownloader $httpDownloader, ProcessExecutor $process)
     {
         if (Filesystem::isLocalPath($repoConfig['url'])) {
             $repoConfig['url'] = Filesystem::getPlatformPath($repoConfig['url']);
@@ -68,8 +68,8 @@ abstract class VcsDriver implements VcsD
         $this->repoConfig = $repoConfig;
         $this->io = $io;
         $this->config = $config;
-        $this->process = $process ?: new ProcessExecutor($io);
-        $this->remoteFilesystem = $remoteFilesystem ?: Factory::createRemoteFilesystem($this->io, $config);
+        $this->httpDownloader = $httpDownloader;
+        $this->process = $process;
     }
 
     /**
@@ -80,7 +80,7 @@ abstract class VcsDriver implements VcsD
      */
     protected function shouldCache($identifier)
     {
-        return $this->cache && preg_match('{[a-f0-9]{40}}i', $identifier);
+        return $this->cache && preg_match('{^[a-f0-9]{40}$}iD', $identifier);
     }
 
     /**
@@ -156,13 +156,13 @@ abstract class VcsDriver implements VcsD
      *
      * @param string $url The URL of content
      *
-     * @return mixed The result
+     * @return Response
      */
     protected function getContents($url)
     {
         $options = isset($this->repoConfig['options']) ? $this->repoConfig['options'] : array();
 
-        return $this->remoteFilesystem->getContents($this->originUrl, $url, false, $options);
+        return $this->httpDownloader->get($url, $options);
     }
 
     /**
diff -pruN 1.10.19-1/src/Composer/Repository/VcsRepository.php 2.0.9-1/src/Composer/Repository/VcsRepository.php
--- 1.10.19-1/src/Composer/Repository/VcsRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/VcsRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -20,6 +20,9 @@ use Composer\Package\Loader\ValidatingAr
 use Composer\Package\Loader\InvalidPackageException;
 use Composer\Package\Loader\LoaderInterface;
 use Composer\EventDispatcher\EventDispatcher;
+use Composer\Util\ProcessExecutor;
+use Composer\Util\HttpDownloader;
+use Composer\Util\Url;
 use Composer\Semver\Constraint\Constraint;
 use Composer\IO\IOInterface;
 use Composer\Config;
@@ -39,6 +42,8 @@ class VcsRepository extends ArrayReposit
     protected $type;
     protected $loader;
     protected $repoConfig;
+    protected $httpDownloader;
+    protected $processExecutor;
     protected $branchErrorOccurred = false;
     private $drivers;
     /** @var VcsDriverInterface */
@@ -48,7 +53,7 @@ class VcsRepository extends ArrayReposit
     private $emptyReferences = array();
     private $versionTransportExceptions = array();
 
-    public function __construct(array $repoConfig, IOInterface $io, Config $config, EventDispatcher $dispatcher = null, array $drivers = null, VersionCacheInterface $versionCache = null)
+    public function __construct(array $repoConfig, IOInterface $io, Config $config, HttpDownloader $httpDownloader, EventDispatcher $dispatcher = null, ProcessExecutor $process = null, array $drivers = null, VersionCacheInterface $versionCache = null)
     {
         parent::__construct();
         $this->drivers = $drivers ?: array(
@@ -72,6 +77,19 @@ class VcsRepository extends ArrayReposit
         $this->config = $config;
         $this->repoConfig = $repoConfig;
         $this->versionCache = $versionCache;
+        $this->httpDownloader = $httpDownloader;
+        $this->processExecutor = $process ?: new ProcessExecutor($io);
+    }
+
+    public function getRepoName()
+    {
+        $driverClass = get_class($this->getDriver());
+        $driverType = array_search($driverClass, $this->drivers);
+        if (!$driverType) {
+            $driverType = $driverClass;
+        }
+
+        return 'vcs repo ('.$driverType.' '.Url::sanitize($this->url).')';
     }
 
     public function getRepoConfig()
@@ -92,7 +110,7 @@ class VcsRepository extends ArrayReposit
 
         if (isset($this->drivers[$this->type])) {
             $class = $this->drivers[$this->type];
-            $this->driver = new $class($this->repoConfig, $this->io, $this->config);
+            $this->driver = new $class($this->repoConfig, $this->io, $this->config, $this->httpDownloader, $this->processExecutor);
             $this->driver->initialize();
 
             return $this->driver;
@@ -100,7 +118,7 @@ class VcsRepository extends ArrayReposit
 
         foreach ($this->drivers as $driver) {
             if ($driver::supports($this->io, $this->config, $this->url)) {
-                $this->driver = new $driver($this->repoConfig, $this->io, $this->config);
+                $this->driver = new $driver($this->repoConfig, $this->io, $this->config, $this->httpDownloader, $this->processExecutor);
                 $this->driver->initialize();
 
                 return $this->driver;
@@ -109,7 +127,7 @@ class VcsRepository extends ArrayReposit
 
         foreach ($this->drivers as $driver) {
             if ($driver::supports($this->io, $this->config, $this->url, true)) {
-                $this->driver = new $driver($this->repoConfig, $this->io, $this->config);
+                $this->driver = new $driver($this->repoConfig, $this->io, $this->config, $this->httpDownloader, $this->processExecutor);
                 $this->driver->initialize();
 
                 return $this->driver;
@@ -149,8 +167,10 @@ class VcsRepository extends ArrayReposit
             $this->loader = new ArrayLoader($this->versionParser);
         }
 
+        $hasRootIdentifierComposerJson = false;
         try {
-            if ($driver->hasComposerFile($driver->getRootIdentifier())) {
+            $hasRootIdentifierComposerJson = $driver->hasComposerFile($driver->getRootIdentifier());
+            if ($hasRootIdentifierComposerJson) {
                 $data = $driver->getComposerInformation($driver->getRootIdentifier());
                 $this->packageName = !empty($data['name']) ? $data['name'] : null;
             }
@@ -176,7 +196,8 @@ class VcsRepository extends ArrayReposit
                 $this->addPackage($cachedPackage);
 
                 continue;
-            } elseif ($cachedPackage === false) {
+            }
+            if ($cachedPackage === false) {
                 $this->emptyReferences[] = $identifier;
 
                 continue;
@@ -211,6 +232,9 @@ class VcsRepository extends ArrayReposit
                 $data['version'] = preg_replace('{[.-]?dev$}i', '', $data['version']);
                 $data['version_normalized'] = preg_replace('{(^dev-|[.-]?dev$)}i', '', $data['version_normalized']);
 
+                // make sure tag do not contain the default-branch marker
+                unset($data['default-branch']);
+
                 // broken package, version doesn't match tag
                 if ($data['version_normalized'] !== $parsedTag) {
                     if ($isVeryVerbose) {
@@ -242,6 +266,9 @@ class VcsRepository extends ArrayReposit
                     if ($e->getCode() === 404) {
                         $this->emptyReferences[] = $identifier;
                     }
+                    if ($e->getCode() === 401 || $e->getCode() === 403) {
+                        throw $e;
+                    }
                 }
                 if ($isVeryVerbose) {
                     $this->io->writeError('<warning>Skipped tag '.$tag.', '.($e instanceof TransportException ? 'no composer file was found (' . $e->getCode() . ' HTTP status code)' : $e->getMessage()).'</warning>');
@@ -255,6 +282,11 @@ class VcsRepository extends ArrayReposit
         }
 
         $branches = $driver->getBranches();
+        // make sure the root identifier branch gets loaded first
+        if ($hasRootIdentifierComposerJson && isset($branches[$driver->getRootIdentifier()])) {
+            $branches = array($driver->getRootIdentifier() => $branches[$driver->getRootIdentifier()]) + $branches;
+        }
+
         foreach ($branches as $branch => $identifier) {
             $msg = 'Reading composer.json of <info>' . ($this->packageName ?: $this->url) . '</info> (<comment>' . $branch . '</comment>)';
             if ($isVeryVerbose) {
@@ -263,13 +295,6 @@ class VcsRepository extends ArrayReposit
                 $this->io->overwriteError($msg, false);
             }
 
-            if ($branch === 'trunk' && isset($branches['master'])) {
-                if ($isVeryVerbose) {
-                    $this->io->writeError('<warning>Skipped branch '.$branch.', can not parse both master and trunk branches as they both resolve to 9999999-dev internally</warning>');
-                }
-                continue;
-            }
-
             if (!$parsedBranch = $this->validateBranch($branch)) {
                 if ($isVeryVerbose) {
                     $this->io->writeError('<warning>Skipped branch '.$branch.', invalid name</warning>');
@@ -278,19 +303,20 @@ class VcsRepository extends ArrayReposit
             }
 
             // make sure branch packages have a dev flag
-            if ('dev-' === substr($parsedBranch, 0, 4) || '9999999-dev' === $parsedBranch) {
+            if (strpos($parsedBranch, 'dev-') === 0 || VersionParser::DEFAULT_BRANCH_ALIAS === $parsedBranch) {
                 $version = 'dev-' . $branch;
             } else {
-                $prefix = substr($branch, 0, 1) === 'v' ? 'v' : '';
+                $prefix = strpos($branch, 'v') === 0 ? 'v' : '';
                 $version = $prefix . preg_replace('{(\.9{7})+}', '.x', $parsedBranch);
             }
 
-            $cachedPackage = $this->getCachedPackageVersion($version, $identifier, $isVerbose, $isVeryVerbose);
+            $cachedPackage = $this->getCachedPackageVersion($version, $identifier, $isVerbose, $isVeryVerbose, $driver->getRootIdentifier() === $branch);
             if ($cachedPackage) {
                 $this->addPackage($cachedPackage);
 
                 continue;
-            } elseif ($cachedPackage === false) {
+            }
+            if ($cachedPackage === false) {
                 $this->emptyReferences[] = $identifier;
 
                 continue;
@@ -309,6 +335,11 @@ class VcsRepository extends ArrayReposit
                 $data['version'] = $version;
                 $data['version_normalized'] = $parsedBranch;
 
+                unset($data['default-branch']);
+                if ($driver->getRootIdentifier() === $branch) {
+                    $data['default-branch'] = true;
+                }
+
                 if ($isVeryVerbose) {
                     $this->io->writeError('Importing branch '.$branch.' ('.$data['version'].')');
                 }
@@ -324,6 +355,9 @@ class VcsRepository extends ArrayReposit
                 if ($e->getCode() === 404) {
                     $this->emptyReferences[] = $identifier;
                 }
+                if ($e->getCode() === 401 || $e->getCode() === 403) {
+                    throw $e;
+                }
                 if ($isVeryVerbose) {
                     $this->io->writeError('<warning>Skipped branch '.$branch.', no composer file was found (' . $e->getCode() . ' HTTP status code)</warning>');
                 }
@@ -390,7 +424,7 @@ class VcsRepository extends ArrayReposit
         return false;
     }
 
-    private function getCachedPackageVersion($version, $identifier, $isVerbose, $isVeryVerbose)
+    private function getCachedPackageVersion($version, $identifier, $isVerbose, $isVeryVerbose, $isDefaultBranch = false)
     {
         if (!$this->versionCache) {
             return;
@@ -413,6 +447,11 @@ class VcsRepository extends ArrayReposit
                 $this->io->overwriteError($msg, false);
             }
 
+            unset($cachedPackage['default-branch']);
+            if ($isDefaultBranch) {
+                $cachedPackage['default-branch'] = true;
+            }
+
             if ($existingPackage = $this->findPackage($cachedPackage['name'], new Constraint('=', $cachedPackage['version_normalized']))) {
                 if ($isVeryVerbose) {
                     $this->io->writeError('<warning>Skipped cached version '.$version.', it conflicts with an another tag ('.$existingPackage->getPrettyVersion().') as both resolve to '.$cachedPackage['version_normalized'].' internally</warning>');
diff -pruN 1.10.19-1/src/Composer/Repository/VersionCacheInterface.php 2.0.9-1/src/Composer/Repository/VersionCacheInterface.php
--- 1.10.19-1/src/Composer/Repository/VersionCacheInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/VersionCacheInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -15,8 +15,8 @@ namespace Composer\Repository;
 interface VersionCacheInterface
 {
     /**
-     * @param string $version
-     * @param string $identifier
+     * @param  string           $version
+     * @param  string           $identifier
      * @return array|null|false Package version data if found, false to indicate the identifier is known but has no package, null for an unknown identifier
      */
     public function getVersionPackage($version, $identifier);
diff -pruN 1.10.19-1/src/Composer/Repository/WritableArrayRepository.php 2.0.9-1/src/Composer/Repository/WritableArrayRepository.php
--- 1.10.19-1/src/Composer/Repository/WritableArrayRepository.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/WritableArrayRepository.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,7 @@
 namespace Composer\Repository;
 
 use Composer\Package\AliasPackage;
+use Composer\Installer\InstallationManager;
 
 /**
  * Writable array repository.
@@ -22,9 +23,30 @@ use Composer\Package\AliasPackage;
 class WritableArrayRepository extends ArrayRepository implements WritableRepositoryInterface
 {
     /**
+     * @var string[]
+     */
+    protected $devPackageNames = array();
+
+    /**
+     * {@inheritDoc}
+     */
+    public function setDevPackageNames(array $devPackageNames)
+    {
+        $this->devPackageNames = $devPackageNames;
+    }
+
+    /**
+     * {@inheritDoc}
+     */
+    public function getDevPackageNames()
+    {
+        return $this->devPackageNames;
+    }
+
+    /**
      * {@inheritDoc}
      */
-    public function write()
+    public function write($devMode, InstallationManager $installationManager)
     {
     }
 
diff -pruN 1.10.19-1/src/Composer/Repository/WritableRepositoryInterface.php 2.0.9-1/src/Composer/Repository/WritableRepositoryInterface.php
--- 1.10.19-1/src/Composer/Repository/WritableRepositoryInterface.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Repository/WritableRepositoryInterface.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,7 @@
 namespace Composer\Repository;
 
 use Composer\Package\PackageInterface;
+use Composer\Installer\InstallationManager;
 
 /**
  * Writable repository interface.
@@ -23,8 +24,10 @@ interface WritableRepositoryInterface ex
 {
     /**
      * Writes repository (f.e. to the disc).
+     *
+     * @param bool $devMode Whether dev requirements were included or not in this installation
      */
-    public function write();
+    public function write($devMode, InstallationManager $installationManager);
 
     /**
      * Adds package to the repository.
@@ -51,4 +54,14 @@ interface WritableRepositoryInterface ex
      * Forces a reload of all packages.
      */
     public function reload();
+
+    /**
+     * @param string[] $devPackageNames
+     */
+    public function setDevPackageNames(array $devPackageNames);
+
+    /**
+     * @return string[] Names of dependencies installed through require-dev
+     */
+    public function getDevPackageNames();
 }
diff -pruN 1.10.19-1/src/Composer/Script/CommandEvent.php 2.0.9-1/src/Composer/Script/CommandEvent.php
--- 1.10.19-1/src/Composer/Script/CommandEvent.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Script/CommandEvent.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,22 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Script;
-
-/**
- * The Command Event.
- *
- * @deprecated use Composer\Script\Event instead
- */
-class CommandEvent extends Event
-{
-}
diff -pruN 1.10.19-1/src/Composer/Script/Event.php 2.0.9-1/src/Composer/Script/Event.php
--- 1.10.19-1/src/Composer/Script/Event.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Script/Event.php	2021-01-27 15:09:27.000000000 +0000
@@ -60,7 +60,6 @@ class Event extends BaseEvent
         $this->composer = $composer;
         $this->io = $io;
         $this->devMode = $devMode;
-        $this->originatingEvent = null;
     }
 
     /**
@@ -106,7 +105,7 @@ class Event extends BaseEvent
     /**
      * Set the originating event.
      *
-     * @param \Composer\EventDispatcher\Event $event
+     * @param  \Composer\EventDispatcher\Event $event
      * @return $this
      */
     public function setOriginatingEvent(BaseEvent $event)
@@ -119,7 +118,7 @@ class Event extends BaseEvent
     /**
      * Returns the upper-most event in chain.
      *
-     * @param \Composer\EventDispatcher\Event $event
+     * @param  \Composer\EventDispatcher\Event $event
      * @return \Composer\EventDispatcher\Event
      */
     private function calculateOriginatingEvent(BaseEvent $event)
diff -pruN 1.10.19-1/src/Composer/Script/PackageEvent.php 2.0.9-1/src/Composer/Script/PackageEvent.php
--- 1.10.19-1/src/Composer/Script/PackageEvent.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Script/PackageEvent.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,24 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Script;
-
-use Composer\Installer\PackageEvent as BasePackageEvent;
-
-/**
- * The Package Event.
- *
- * @deprecated Use Composer\Installer\PackageEvent instead
- */
-class PackageEvent extends BasePackageEvent
-{
-}
diff -pruN 1.10.19-1/src/Composer/Script/ScriptEvents.php 2.0.9-1/src/Composer/Script/ScriptEvents.php
--- 1.10.19-1/src/Composer/Script/ScriptEvents.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Script/ScriptEvents.php	2021-01-27 15:09:27.000000000 +0000
@@ -128,66 +128,4 @@ class ScriptEvents
      * @var string
      */
     const POST_ARCHIVE_CMD = 'post-archive-cmd';
-
-    /** Deprecated constants below */
-
-    /**
-     * The PRE_PACKAGE_INSTALL event occurs before a package is installed.
-     *
-     * The event listener method receives a Composer\Installer\PackageEvent instance.
-     *
-     * @deprecated Use Composer\Installer\PackageEvents::PRE_PACKAGE_INSTALL instead.
-     * @var string
-     */
-    const PRE_PACKAGE_INSTALL = 'pre-package-install';
-
-    /**
-     * The POST_PACKAGE_INSTALL event occurs after a package is installed.
-     *
-     * The event listener method receives a Composer\Installer\PackageEvent instance.
-     *
-     * @deprecated Use Composer\Installer\PackageEvents::POST_PACKAGE_INSTALL instead.
-     * @var string
-     */
-    const POST_PACKAGE_INSTALL = 'post-package-install';
-
-    /**
-     * The PRE_PACKAGE_UPDATE event occurs before a package is updated.
-     *
-     * The event listener method receives a Composer\Installer\PackageEvent instance.
-     *
-     * @deprecated Use Composer\Installer\PackageEvents::PRE_PACKAGE_UPDATE instead.
-     * @var string
-     */
-    const PRE_PACKAGE_UPDATE = 'pre-package-update';
-
-    /**
-     * The POST_PACKAGE_UPDATE event occurs after a package is updated.
-     *
-     * The event listener method receives a Composer\Installer\PackageEvent instance.
-     *
-     * @deprecated Use Composer\Installer\PackageEvents::POST_PACKAGE_UPDATE instead.
-     * @var string
-     */
-    const POST_PACKAGE_UPDATE = 'post-package-update';
-
-    /**
-     * The PRE_PACKAGE_UNINSTALL event occurs before a package has been uninstalled.
-     *
-     * The event listener method receives a Composer\Installer\PackageEvent instance.
-     *
-     * @deprecated Use Composer\Installer\PackageEvents::PRE_PACKAGE_UNINSTALL instead.
-     * @var string
-     */
-    const PRE_PACKAGE_UNINSTALL = 'pre-package-uninstall';
-
-    /**
-     * The POST_PACKAGE_UNINSTALL event occurs after a package has been uninstalled.
-     *
-     * The event listener method receives a Composer\Installer\PackageEvent instance.
-     *
-     * @deprecated Use Composer\Installer\PackageEvents::POST_PACKAGE_UNINSTALL instead.
-     * @var string
-     */
-    const POST_PACKAGE_UNINSTALL = 'post-package-uninstall';
 }
diff -pruN 1.10.19-1/src/Composer/SelfUpdate/Versions.php 2.0.9-1/src/Composer/SelfUpdate/Versions.php
--- 1.10.19-1/src/Composer/SelfUpdate/Versions.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/SelfUpdate/Versions.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,9 +12,8 @@
 
 namespace Composer\SelfUpdate;
 
-use Composer\Util\RemoteFilesystem;
+use Composer\Util\HttpDownloader;
 use Composer\Config;
-use Composer\Json\JsonFile;
 
 /**
  * @author Jordi Boggiano <j.boggiano@seld.be>
@@ -23,14 +22,14 @@ class Versions
 {
     public static $channels = array('stable', 'preview', 'snapshot', '1', '2');
 
-    private $rfs;
+    private $httpDownloader;
     private $config;
     private $channel;
     private $versionsData;
 
-    public function __construct(Config $config, RemoteFilesystem $rfs)
+    public function __construct(Config $config, HttpDownloader $httpDownloader)
     {
-        $this->rfs = $rfs;
+        $this->httpDownloader = $httpDownloader;
         $this->config = $config;
     }
 
@@ -84,7 +83,7 @@ class Versions
                 $protocol = 'https';
             }
 
-            $this->versionsData = JsonFile::parseJson($this->rfs->getContents('getcomposer.org', $protocol . '://getcomposer.org/versions', false));
+            $this->versionsData = $this->httpDownloader->get($protocol . '://getcomposer.org/versions')->decodeJson();
         }
 
         return $this->versionsData;
diff -pruN 1.10.19-1/src/Composer/Util/AuthHelper.php 2.0.9-1/src/Composer/Util/AuthHelper.php
--- 1.10.19-1/src/Composer/Util/AuthHelper.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/AuthHelper.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,6 +14,7 @@ namespace Composer\Util;
 
 use Composer\Config;
 use Composer\IO\IOInterface;
+use Composer\Downloader\TransportException;
 
 /**
  * @author Jordi Boggiano <j.boggiano@seld.be>
@@ -22,6 +23,7 @@ class AuthHelper
 {
     protected $io;
     protected $config;
+    private $displayedOriginAuthentications = array();
 
     public function __construct(IOInterface $io, Config $config)
     {
@@ -29,7 +31,11 @@ class AuthHelper
         $this->config = $config;
     }
 
-    public function storeAuth($originUrl, $storeAuth)
+    /**
+     * @param string      $origin
+     * @param string|bool $storeAuth
+     */
+    public function storeAuth($origin, $storeAuth)
     {
         $store = false;
         $configSource = $this->config->getAuthConfigSource();
@@ -37,7 +43,7 @@ class AuthHelper
             $store = $configSource;
         } elseif ($storeAuth === 'prompt') {
             $answer = $this->io->askAndValidate(
-                'Do you want to store credentials for '.$originUrl.' in '.$configSource->getName().' ? [Yn] ',
+                'Do you want to store credentials for '.$origin.' in '.$configSource->getName().' ? [Yn] ',
                 function ($value) {
                     $input = strtolower(substr(trim($value), 0, 1));
                     if (in_array($input, array('y','n'))) {
@@ -55,9 +61,207 @@ class AuthHelper
         }
         if ($store) {
             $store->addConfigSetting(
-                'http-basic.'.$originUrl,
-                $this->io->getAuthentication($originUrl)
+                'http-basic.'.$origin,
+                $this->io->getAuthentication($origin)
             );
         }
     }
+
+    /**
+     * @param  string      $url
+     * @param  string      $origin
+     * @param  int         $statusCode HTTP status code that triggered this call
+     * @param  string|null $reason     a message/description explaining why this was called
+     * @param  string[]    $headers
+     * @return array|null  containing retry (bool) and storeAuth (string|bool) keys, if retry is true the request should be
+     *                                retried, if storeAuth is true then on a successful retry the authentication should be persisted to auth.json
+     */
+    public function promptAuthIfNeeded($url, $origin, $statusCode, $reason = null, $headers = array())
+    {
+        $storeAuth = false;
+
+        if (in_array($origin, $this->config->get('github-domains'), true)) {
+            $gitHubUtil = new GitHub($this->io, $this->config, null);
+            $message = "\n";
+
+            $rateLimited = $gitHubUtil->isRateLimited($headers);
+            if ($rateLimited) {
+                $rateLimit = $gitHubUtil->getRateLimit($headers);
+                if ($this->io->hasAuthentication($origin)) {
+                    $message = 'Review your configured GitHub OAuth token or enter a new one to go over the API rate limit.';
+                } else {
+                    $message = 'Create a GitHub OAuth token to go over the API rate limit.';
+                }
+
+                $message = sprintf(
+                    'GitHub API limit (%d calls/hr) is exhausted, could not fetch '.$url.'. '.$message.' You can also wait until %s for the rate limit to reset.',
+                    $rateLimit['limit'],
+                    $rateLimit['reset']
+                )."\n";
+            } else {
+                $message .= 'Could not fetch '.$url.', please ';
+                if ($this->io->hasAuthentication($origin)) {
+                    $message .= 'review your configured GitHub OAuth token or enter a new one to access private repos';
+                } else {
+                    $message .= 'create a GitHub OAuth token to access private repos';
+                }
+            }
+
+            if (!$gitHubUtil->authorizeOAuth($origin)
+                && (!$this->io->isInteractive() || !$gitHubUtil->authorizeOAuthInteractively($origin, $message))
+            ) {
+                throw new TransportException('Could not authenticate against '.$origin, 401);
+            }
+        } elseif (in_array($origin, $this->config->get('gitlab-domains'), true)) {
+            $message = "\n".'Could not fetch '.$url.', enter your ' . $origin . ' credentials ' .($statusCode === 401 ? 'to access private repos' : 'to go over the API rate limit');
+            $gitLabUtil = new GitLab($this->io, $this->config, null);
+
+            if ($this->io->hasAuthentication($origin) && ($auth = $this->io->getAuthentication($origin)) && in_array($auth['password'], array('gitlab-ci-token', 'private-token', 'oauth2'), true)) {
+                throw new TransportException("Invalid credentials for '" . $url . "', aborting.", $statusCode);
+            }
+
+            if (!$gitLabUtil->authorizeOAuth($origin)
+                && (!$this->io->isInteractive() || !$gitLabUtil->authorizeOAuthInteractively(parse_url($url, PHP_URL_SCHEME), $origin, $message))
+            ) {
+                throw new TransportException('Could not authenticate against '.$origin, 401);
+            }
+        } elseif ($origin === 'bitbucket.org' || $origin === 'api.bitbucket.org') {
+            $askForOAuthToken = true;
+            $origin = 'bitbucket.org';
+            if ($this->io->hasAuthentication($origin)) {
+                $auth = $this->io->getAuthentication($origin);
+                if ($auth['username'] !== 'x-token-auth') {
+                    $bitbucketUtil = new Bitbucket($this->io, $this->config);
+                    $accessToken = $bitbucketUtil->requestToken($origin, $auth['username'], $auth['password']);
+                    if (!empty($accessToken)) {
+                        $this->io->setAuthentication($origin, 'x-token-auth', $accessToken);
+                        $askForOAuthToken = false;
+                    }
+                } else {
+                    throw new TransportException('Could not authenticate against ' . $origin, 401);
+                }
+            }
+
+            if ($askForOAuthToken) {
+                $message = "\n".'Could not fetch ' . $url . ', please create a bitbucket OAuth token to ' . (($statusCode === 401 || $statusCode === 403) ? 'access private repos' : 'go over the API rate limit');
+                $bitBucketUtil = new Bitbucket($this->io, $this->config);
+                if (!$bitBucketUtil->authorizeOAuth($origin)
+                    && (!$this->io->isInteractive() || !$bitBucketUtil->authorizeOAuthInteractively($origin, $message))
+                ) {
+                    throw new TransportException('Could not authenticate against ' . $origin, 401);
+                }
+            }
+        } else {
+            // 404s are only handled for github
+            if ($statusCode === 404) {
+                return;
+            }
+
+            // fail if the console is not interactive
+            if (!$this->io->isInteractive()) {
+                if ($statusCode === 401) {
+                    $message = "The '" . $url . "' URL required authentication.\nYou must be using the interactive console to authenticate";
+                } elseif ($statusCode === 403) {
+                    $message = "The '" . $url . "' URL could not be accessed: " . $reason;
+                } else {
+                    $message = "Unknown error code '" . $statusCode . "', reason: " . $reason;
+                }
+
+                throw new TransportException($message, $statusCode);
+            }
+            // fail if we already have auth
+            if ($this->io->hasAuthentication($origin)) {
+                throw new TransportException("Invalid credentials for '" . $url . "', aborting.", $statusCode);
+            }
+
+            $this->io->writeError('    Authentication required (<info>'.$origin.'</info>):');
+            $username = $this->io->ask('      Username: ');
+            $password = $this->io->askAndHideAnswer('      Password: ');
+            $this->io->setAuthentication($origin, $username, $password);
+            $storeAuth = $this->config->get('store-auths');
+        }
+
+        return array('retry' => true, 'storeAuth' => $storeAuth);
+    }
+
+    /**
+     * @param  array  $headers
+     * @param  string $origin
+     * @param  string $url
+     * @return array  updated headers array
+     */
+    public function addAuthenticationHeader(array $headers, $origin, $url)
+    {
+        if ($this->io->hasAuthentication($origin)) {
+            $authenticationDisplayMessage = null;
+            $auth = $this->io->getAuthentication($origin);
+            if ($auth['password'] === 'bearer') {
+                $headers[] = 'Authorization: Bearer '.$auth['username'];
+            } elseif ('github.com' === $origin && 'x-oauth-basic' === $auth['password']) {
+                // only add the access_token if it is actually a github API URL
+                if (preg_match('{^https?://api\.github\.com/}', $url)) {
+                    $headers[] = 'Authorization: token '.$auth['username'];
+                    $authenticationDisplayMessage = 'Using GitHub token authentication';
+                }
+            } elseif (
+                in_array($origin, $this->config->get('gitlab-domains'), true)
+                && in_array($auth['password'], array('oauth2', 'private-token', 'gitlab-ci-token'), true)
+            ) {
+                if ($auth['password'] === 'oauth2') {
+                    $headers[] = 'Authorization: Bearer '.$auth['username'];
+                    $authenticationDisplayMessage = 'Using GitLab OAuth token authentication';
+                } elseif ($auth['password'] === 'private-token' || $auth['password'] === 'gitlab-ci-token') {
+                    $headers[] = 'PRIVATE-TOKEN: '.$auth['username'];
+                    $authenticationDisplayMessage = 'Using GitLab private token authentication';
+                }
+            } elseif (
+                'bitbucket.org' === $origin
+                && $url !== Bitbucket::OAUTH2_ACCESS_TOKEN_URL
+                && 'x-token-auth' === $auth['username']
+            ) {
+                if (!$this->isPublicBitBucketDownload($url)) {
+                    $headers[] = 'Authorization: Bearer ' . $auth['password'];
+                    $authenticationDisplayMessage = 'Using Bitbucket OAuth token authentication';
+                }
+            } else {
+                $authStr = base64_encode($auth['username'] . ':' . $auth['password']);
+                $headers[] = 'Authorization: Basic '.$authStr;
+                $authenticationDisplayMessage = 'Using HTTP basic authentication with username "' . $auth['username'] . '"';
+            }
+
+            if ($authenticationDisplayMessage && (!isset($this->displayedOriginAuthentications[$origin]) || $this->displayedOriginAuthentications[$origin] !== $authenticationDisplayMessage)) {
+                $this->io->writeError($authenticationDisplayMessage, true, IOInterface::DEBUG);
+                $this->displayedOriginAuthentications[$origin] = $authenticationDisplayMessage;
+            }
+        } elseif (in_array($origin, array('api.bitbucket.org', 'api.github.com'), true)) {
+            return $this->addAuthenticationHeader($headers, str_replace('api.', '', $origin), $url);
+        }
+
+        return $headers;
+    }
+
+    /**
+     * @link https://github.com/composer/composer/issues/5584
+     *
+     * @param string $urlToBitBucketFile URL to a file at bitbucket.org.
+     *
+     * @return bool Whether the given URL is a public BitBucket download which requires no authentication.
+     */
+    public function isPublicBitBucketDownload($urlToBitBucketFile)
+    {
+        $domain = parse_url($urlToBitBucketFile, PHP_URL_HOST);
+        if (strpos($domain, 'bitbucket.org') === false) {
+            // Bitbucket downloads are hosted on amazonaws.
+            // We do not need to authenticate there at all
+            return true;
+        }
+
+        $path = parse_url($urlToBitBucketFile, PHP_URL_PATH);
+
+        // Path for a public download follows this pattern /{user}/{repo}/downloads/{whatever}
+        // {@link https://blog.bitbucket.org/2009/04/12/new-feature-downloads/}
+        $pathParts = explode('/', $path);
+
+        return count($pathParts) >= 4 && $pathParts[3] == 'downloads';
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Util/Bitbucket.php 2.0.9-1/src/Composer/Util/Bitbucket.php
--- 1.10.19-1/src/Composer/Util/Bitbucket.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Bitbucket.php	2021-01-27 15:09:27.000000000 +0000
@@ -22,11 +22,17 @@ use Composer\Downloader\TransportExcepti
  */
 class Bitbucket
 {
+    /** @var IOInterface */
     private $io;
+    /** @var Config */
     private $config;
+    /** @var ProcessExecutor */
     private $process;
-    private $remoteFilesystem;
+    /** @var HttpDownloader */
+    private $httpDownloader;
+    /** @var array */
     private $token = array();
+    /** @var int|null */
     private $time;
 
     const OAUTH2_ACCESS_TOKEN_URL = 'https://bitbucket.org/site/oauth2/access_token';
@@ -34,18 +40,18 @@ class Bitbucket
     /**
      * Constructor.
      *
-     * @param IOInterface      $io               The IO instance
-     * @param Config           $config           The composer configuration
-     * @param ProcessExecutor  $process          Process instance, injectable for mocking
-     * @param RemoteFilesystem $remoteFilesystem Remote Filesystem, injectable for mocking
-     * @param int              $time             Timestamp, injectable for mocking
+     * @param IOInterface     $io             The IO instance
+     * @param Config          $config         The composer configuration
+     * @param ProcessExecutor $process        Process instance, injectable for mocking
+     * @param HttpDownloader  $httpDownloader Remote Filesystem, injectable for mocking
+     * @param int             $time           Timestamp, injectable for mocking
      */
-    public function __construct(IOInterface $io, Config $config, ProcessExecutor $process = null, RemoteFilesystem $remoteFilesystem = null, $time = null)
+    public function __construct(IOInterface $io, Config $config, ProcessExecutor $process = null, HttpDownloader $httpDownloader = null, $time = null)
     {
         $this->io = $io;
         $this->config = $config;
         $this->process = $process ?: new ProcessExecutor($io);
-        $this->remoteFilesystem = $remoteFilesystem ?: Factory::createRemoteFilesystem($this->io, $config);
+        $this->httpDownloader = $httpDownloader ?: Factory::createHttpDownloader($this->io, $config);
         $this->time = $time;
     }
 
@@ -84,13 +90,12 @@ class Bitbucket
     }
 
     /**
-     * @param  string $originUrl
      * @return bool
      */
-    private function requestAccessToken($originUrl)
+    private function requestAccessToken()
     {
         try {
-            $json = $this->remoteFilesystem->getContents($originUrl, self::OAUTH2_ACCESS_TOKEN_URL, false, array(
+            $response = $this->httpDownloader->get(self::OAUTH2_ACCESS_TOKEN_URL, array(
                 'retry-auth-failure' => false,
                 'http' => array(
                     'method' => 'POST',
@@ -98,7 +103,7 @@ class Bitbucket
                 ),
             ));
 
-            $this->token = json_decode($json, true);
+            $this->token = $response->decodeJson();
         } catch (TransportException $e) {
             if ($e->getCode() === 400) {
                 $this->io->writeError('<error>Invalid OAuth consumer provided.</error>');
@@ -107,7 +112,8 @@ class Bitbucket
                 $this->io->writeError('2. You are using an OAuth consumer, but didn\'t configure a (dummy) callback url');
 
                 return false;
-            } elseif (in_array($e->getCode(), array(403, 401))) {
+            }
+            if (in_array($e->getCode(), array(403, 401))) {
                 $this->io->writeError('<error>Invalid OAuth consumer provided.</error>');
                 $this->io->writeError('You can also add it manually later by using "composer config --global --auth bitbucket-oauth.bitbucket.org <consumer-key> <consumer-secret>"');
 
@@ -160,7 +166,7 @@ class Bitbucket
 
         $this->io->setAuthentication($originUrl, $consumerKey, $consumerSecret);
 
-        if (!$this->requestAccessToken($originUrl)) {
+        if (!$this->requestAccessToken()) {
             return false;
         }
 
@@ -190,7 +196,7 @@ class Bitbucket
         }
 
         $this->io->setAuthentication($originUrl, $consumerKey, $consumerSecret);
-        if (!$this->requestAccessToken($originUrl)) {
+        if (!$this->requestAccessToken()) {
             return '';
         }
 
@@ -229,8 +235,7 @@ class Bitbucket
         $authConfig = $this->config->get('bitbucket-oauth');
 
         if (
-            !isset($authConfig[$originUrl]['access-token'])
-            || !isset($authConfig[$originUrl]['access-token-expiration'])
+            !isset($authConfig[$originUrl]['access-token'], $authConfig[$originUrl]['access-token-expiration'])
             || time() > $authConfig[$originUrl]['access-token-expiration']
         ) {
             return false;
diff -pruN 1.10.19-1/src/Composer/Util/ConfigValidator.php 2.0.9-1/src/Composer/Util/ConfigValidator.php
--- 1.10.19-1/src/Composer/Util/ConfigValidator.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/ConfigValidator.php	2021-01-27 15:09:27.000000000 +0000
@@ -28,6 +28,8 @@ use Composer\Spdx\SpdxLicenses;
  */
 class ConfigValidator
 {
+    const CHECK_VERSION = 1;
+
     private $io;
 
     public function __construct(IOInterface $io)
@@ -40,10 +42,11 @@ class ConfigValidator
      *
      * @param string $file                       The path to the file
      * @param int    $arrayLoaderValidationFlags Flags for ArrayLoader validation
+     * @param int    $flags                      Flags for validation
      *
      * @return array a triple containing the errors, publishable errors, and warnings
      */
-    public function validate($file, $arrayLoaderValidationFlags = ValidatingArrayLoader::CHECK_ALL)
+    public function validate($file, $arrayLoaderValidationFlags = ValidatingArrayLoader::CHECK_ALL, $flags = self::CHECK_VERSION)
     {
         $errors = array();
         $publishErrors = array();
@@ -109,7 +112,7 @@ class ConfigValidator
             }
         }
 
-        if (isset($manifest['version'])) {
+        if (($flags & self::CHECK_VERSION) && isset($manifest['version'])) {
             $warnings[] = 'The version field is present, it is recommended to leave it out if the package is published on Packagist.';
         }
 
@@ -129,7 +132,7 @@ class ConfigValidator
         }
 
         // check for require-dev overrides
-        if (isset($manifest['require']) && isset($manifest['require-dev'])) {
+        if (isset($manifest['require'], $manifest['require-dev'])) {
             $requireOverrides = array_intersect_key($manifest['require'], $manifest['require-dev']);
 
             if (!empty($requireOverrides)) {
@@ -138,7 +141,6 @@ class ConfigValidator
             }
         }
 
-
         // check for meaningless provide/replace satisfying requirements
         foreach (array('provide', 'replace') as $linkType) {
             if (isset($manifest[$linkType])) {
@@ -187,8 +189,8 @@ class ConfigValidator
             $warnings[] = "Defining autoload.psr-4 with an empty namespace prefix is a bad idea for performance";
         }
 
+        $loader = new ValidatingArrayLoader(new ArrayLoader(), true, null, $arrayLoaderValidationFlags);
         try {
-            $loader = new ValidatingArrayLoader(new ArrayLoader(), true, null, $arrayLoaderValidationFlags);
             if (!isset($manifest['version'])) {
                 $manifest['version'] = '1.0.0';
             }
diff -pruN 1.10.19-1/src/Composer/Util/Filesystem.php 2.0.9-1/src/Composer/Util/Filesystem.php
--- 1.10.19-1/src/Composer/Util/Filesystem.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Filesystem.php	2021-01-27 15:09:27.000000000 +0000
@@ -23,11 +23,12 @@ use Symfony\Component\Finder\Finder;
  */
 class Filesystem
 {
+    /** @var ProcessExecutor */
     private $processExecutor;
 
     public function __construct(ProcessExecutor $executor = null)
     {
-        $this->processExecutor = $executor ?: new ProcessExecutor();
+        $this->processExecutor = $executor;
     }
 
     public function remove($file)
@@ -57,12 +58,12 @@ class Filesystem
             ->depth(0)
             ->in($dir);
 
-        return count($finder) === 0;
+        return \count($finder) === 0;
     }
 
     public function emptyDirectory($dir, $ensureDirectoryExists = true)
     {
-        if (file_exists($dir) && is_link($dir)) {
+        if (is_link($dir) && file_exists($dir)) {
             $this->unlink($dir);
         }
 
@@ -107,7 +108,7 @@ class Filesystem
             return unlink($directory);
         }
 
-        if (!file_exists($directory) || !is_dir($directory)) {
+        if (!is_dir($directory) || !file_exists($directory)) {
             return true;
         }
 
@@ -115,7 +116,7 @@ class Filesystem
             throw new \RuntimeException('Aborting an attempted deletion of '.$directory.', this was probably not intended, if it is a real use case please report it.');
         }
 
-        if (!function_exists('proc_open')) {
+        if (!\function_exists('proc_open')) {
             return $this->removeDirectoryPhp($directory);
         }
 
@@ -130,7 +131,7 @@ class Filesystem
         // clear stat cache because external processes aren't tracked by the php stat cache
         clearstatcache();
 
-        if ($result && !file_exists($directory)) {
+        if ($result && !is_dir($directory)) {
             return true;
         }
 
@@ -276,8 +277,8 @@ class Filesystem
     /**
      * Copies a file or directory from $source to $target.
      *
-     * @param string $source
-     * @param string $target
+     * @param  string $source
+     * @param  string $target
      * @return bool
      */
     public function copy($source, $target)
@@ -291,8 +292,9 @@ class Filesystem
         $this->ensureDirectoryExists($target);
 
         $result = true;
+        /** @var RecursiveDirectoryIterator $ri */
         foreach ($ri as $file) {
-            $targetPath = $target . DIRECTORY_SEPARATOR . $ri->getSubPathName();
+            $targetPath = $target . DIRECTORY_SEPARATOR . $ri->getSubPathname();
             if ($file->isDir()) {
                 $this->ensureDirectoryExists($targetPath);
             } else {
@@ -309,16 +311,16 @@ class Filesystem
             return;
         }
 
-        if (!function_exists('proc_open')) {
+        if (!\function_exists('proc_open')) {
             $this->copyThenRemove($source, $target);
-            
+
             return;
         }
 
         if (Platform::isWindows()) {
             // Try to copy & delete - this is a workaround for random "Access denied" errors.
             $command = sprintf('xcopy %s %s /E /I /Q /Y', ProcessExecutor::escape($source), ProcessExecutor::escape($target));
-            $result = $this->processExecutor->execute($command, $output);
+            $result = $this->getProcess()->execute($command, $output);
 
             // clear stat cache because external processes aren't tracked by the php stat cache
             clearstatcache();
@@ -332,7 +334,7 @@ class Filesystem
             // We do not use PHP's "rename" function here since it does not support
             // the case where $source, and $target are located on different partitions.
             $command = sprintf('mv %s %s', ProcessExecutor::escape($source), ProcessExecutor::escape($target));
-            $result = $this->processExecutor->execute($command, $output);
+            $result = $this->getProcess()->execute($command, $output);
 
             // clear stat cache because external processes aren't tracked by the php stat cache
             clearstatcache();
@@ -367,13 +369,13 @@ class Filesystem
             $from = rtrim($from, '/') . '/dummy_file';
         }
 
-        if (dirname($from) === dirname($to)) {
+        if (\dirname($from) === \dirname($to)) {
             return './'.basename($to);
         }
 
         $commonPath = $to;
         while (strpos($from.'/', $commonPath.'/') !== 0 && '/' !== $commonPath && !preg_match('{^[a-z]:/?$}i', $commonPath)) {
-            $commonPath = strtr(dirname($commonPath), '\\', '/');
+            $commonPath = strtr(\dirname($commonPath), '\\', '/');
         }
 
         if (0 !== strpos($from, $commonPath) || '/' === $commonPath) {
@@ -381,10 +383,10 @@ class Filesystem
         }
 
         $commonPath = rtrim($commonPath, '/') . '/';
-        $sourcePathDepth = substr_count(substr($from, strlen($commonPath)), '/');
+        $sourcePathDepth = substr_count(substr($from, \strlen($commonPath)), '/');
         $commonPathCode = str_repeat('../', $sourcePathDepth);
 
-        return ($commonPathCode . substr($to, strlen($commonPath))) ?: './';
+        return ($commonPathCode . substr($to, \strlen($commonPath))) ?: './';
     }
 
     /**
@@ -412,7 +414,7 @@ class Filesystem
 
         $commonPath = $to;
         while (strpos($from.'/', $commonPath.'/') !== 0 && '/' !== $commonPath && !preg_match('{^[a-z]:/?$}i', $commonPath) && '.' !== $commonPath) {
-            $commonPath = strtr(dirname($commonPath), '\\', '/');
+            $commonPath = strtr(\dirname($commonPath), '\\', '/');
         }
 
         if (0 !== strpos($from, $commonPath) || '/' === $commonPath || '.' === $commonPath) {
@@ -421,17 +423,17 @@ class Filesystem
 
         $commonPath = rtrim($commonPath, '/') . '/';
         if (strpos($to, $from.'/') === 0) {
-            return '__DIR__ . '.var_export(substr($to, strlen($from)), true);
+            return '__DIR__ . '.var_export(substr($to, \strlen($from)), true);
         }
-        $sourcePathDepth = substr_count(substr($from, strlen($commonPath)), '/') + $directories;
+        $sourcePathDepth = substr_count(substr($from, \strlen($commonPath)), '/') + $directories;
         if ($staticCode) {
             $commonPathCode = "__DIR__ . '".str_repeat('/..', $sourcePathDepth)."'";
         } else {
             $commonPathCode = str_repeat('dirname(', $sourcePathDepth).'__DIR__'.str_repeat(')', $sourcePathDepth);
         }
-        $relTarget = substr($to, strlen($commonPath));
+        $relTarget = substr($to, \strlen($commonPath));
 
-        return $commonPathCode . (strlen($relTarget) ? '.' . var_export('/' . $relTarget, true) : '');
+        return $commonPathCode . (\strlen($relTarget) ? '.' . var_export('/' . $relTarget, true) : '');
     }
 
     /**
@@ -442,7 +444,7 @@ class Filesystem
      */
     public function isAbsolutePath($path)
     {
-        return substr($path, 0, 1) === '/' || substr($path, 1, 1) === ':' || substr($path, 0, 2) === '\\\\';
+        return strpos($path, '/') === 0 || substr($path, 1, 1) === ':' || strpos($path, '\\\\') === 0;
     }
 
     /**
@@ -482,10 +484,10 @@ class Filesystem
         // extract a prefix being a protocol://, protocol:, protocol://drive: or simply drive:
         if (preg_match('{^( [0-9a-z]{2,}+: (?: // (?: [a-z]: )? )? | [a-z]: )}ix', $path, $match)) {
             $prefix = $match[1];
-            $path = substr($path, strlen($prefix));
+            $path = substr($path, \strlen($prefix));
         }
 
-        if (substr($path, 0, 1) === '/') {
+        if (strpos($path, '/') === 0) {
             $absolute = true;
             $path = substr($path, 1);
         }
@@ -505,6 +507,23 @@ class Filesystem
     }
 
     /**
+     * Remove trailing slashes if present to avoid issues with symlinks
+     *
+     * And other possible unforeseen disasters, see https://github.com/composer/composer/pull/9422
+     *
+     * @param  string $path
+     * @return bool
+     */
+    public static function trimTrailingSlash($path)
+    {
+        if (!preg_match('{^[/\\\\]+$}', $path)) {
+            $path = rtrim($path, '/\\');
+        }
+
+        return $path;
+    }
+
+    /**
      * Return if the given path is local
      *
      * @param  string $path
@@ -539,8 +558,15 @@ class Filesystem
         return $size;
     }
 
+    /**
+     * @return ProcessExecutor
+     */
     protected function getProcess()
     {
+        if (!$this->processExecutor) {
+            $this->processExecutor = new ProcessExecutor();
+        }
+
         return $this->processExecutor;
     }
 
@@ -571,10 +597,14 @@ class Filesystem
      */
     public function relativeSymlink($target, $link)
     {
+        if (!function_exists('symlink')) {
+            return false;
+        }
+
         $cwd = getcwd();
 
         $relativePath = $this->findShortestPath($link, $target);
-        chdir(dirname($link));
+        chdir(\dirname($link));
         $result = @symlink($relativePath, $link);
 
         chdir($cwd);
@@ -627,7 +657,7 @@ class Filesystem
 
         $resolved = rtrim($pathname, '/');
 
-        if (!strlen($resolved)) {
+        if (!\strlen($resolved)) {
             return $pathname;
         }
 
@@ -716,4 +746,61 @@ class Filesystem
 
         return $this->rmdir($junction);
     }
+
+    public function filePutContentsIfModified($path, $content)
+    {
+        $currentContent = @file_get_contents($path);
+        if (!$currentContent || ($currentContent != $content)) {
+            return file_put_contents($path, $content);
+        }
+
+        return 0;
+    }
+
+    /**
+     * Copy file using stream_copy_to_stream to work around https://bugs.php.net/bug.php?id=6463
+     *
+     * @param string $source
+     * @param string $target
+     */
+    public function safeCopy($source, $target)
+    {
+        if (!file_exists($target) || !file_exists($source) || !$this->filesAreEqual($source, $target)) {
+            $source = fopen($source, 'r');
+            $target = fopen($target, 'w+');
+
+            stream_copy_to_stream($source, $target);
+            fclose($source);
+            fclose($target);
+        }
+    }
+
+    /**
+     * compare 2 files
+     * https://stackoverflow.com/questions/3060125/can-i-use-file-get-contents-to-compare-two-files
+     */
+    private function filesAreEqual($a, $b)
+    {
+        // Check if filesize is different
+        if (filesize($a) !== filesize($b)) {
+            return false;
+        }
+
+        // Check if content is different
+        $ah = fopen($a, 'rb');
+        $bh = fopen($b, 'rb');
+
+        $result = true;
+        while (!feof($ah)) {
+            if (fread($ah, 8192) != fread($bh, 8192)) {
+                $result = false;
+                break;
+            }
+        }
+
+        fclose($ah);
+        fclose($bh);
+
+        return $result;
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Util/GitHub.php 2.0.9-1/src/Composer/Util/GitHub.php
--- 1.10.19-1/src/Composer/Util/GitHub.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/GitHub.php	2021-01-27 15:09:27.000000000 +0000
@@ -22,25 +22,29 @@ use Composer\Downloader\TransportExcepti
  */
 class GitHub
 {
+    /** @var IOInterface */
     protected $io;
+    /** @var Config */
     protected $config;
+    /** @var ProcessExecutor */
     protected $process;
-    protected $remoteFilesystem;
+    /** @var HttpDownloader */
+    protected $httpDownloader;
 
     /**
      * Constructor.
      *
-     * @param IOInterface      $io               The IO instance
-     * @param Config           $config           The composer configuration
-     * @param ProcessExecutor  $process          Process instance, injectable for mocking
-     * @param RemoteFilesystem $remoteFilesystem Remote Filesystem, injectable for mocking
+     * @param IOInterface     $io             The IO instance
+     * @param Config          $config         The composer configuration
+     * @param ProcessExecutor $process        Process instance, injectable for mocking
+     * @param HttpDownloader  $httpDownloader Remote Filesystem, injectable for mocking
      */
-    public function __construct(IOInterface $io, Config $config, ProcessExecutor $process = null, RemoteFilesystem $remoteFilesystem = null)
+    public function __construct(IOInterface $io, Config $config, ProcessExecutor $process = null, HttpDownloader $httpDownloader = null)
     {
         $this->io = $io;
         $this->config = $config;
         $this->process = $process ?: new ProcessExecutor($io);
-        $this->remoteFilesystem = $remoteFilesystem ?: Factory::createRemoteFilesystem($this->io, $config);
+        $this->httpDownloader = $httpDownloader ?: Factory::createHttpDownloader($this->io, $config);
     }
 
     /**
@@ -104,7 +108,7 @@ class GitHub
         try {
             $apiUrl = ('github.com' === $originUrl) ? 'api.github.com/' : $originUrl . '/api/v3/';
 
-            $this->remoteFilesystem->getContents($originUrl, 'https://'. $apiUrl, false, array(
+            $this->httpDownloader->get('https://'. $apiUrl, array(
                 'retry-auth-failure' => false,
             ));
         } catch (TransportException $e) {
diff -pruN 1.10.19-1/src/Composer/Util/GitLab.php 2.0.9-1/src/Composer/Util/GitLab.php
--- 1.10.19-1/src/Composer/Util/GitLab.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/GitLab.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,32 +16,35 @@ use Composer\IO\IOInterface;
 use Composer\Config;
 use Composer\Factory;
 use Composer\Downloader\TransportException;
-use Composer\Json\JsonFile;
 
 /**
  * @author Roshan Gautam <roshan.gautam@hotmail.com>
  */
 class GitLab
 {
+    /** @var IOInterface */
     protected $io;
+    /** @var Config */
     protected $config;
+    /** @var ProcessExecutor */
     protected $process;
-    protected $remoteFilesystem;
+    /** @var HttpDownloader */
+    protected $httpDownloader;
 
     /**
      * Constructor.
      *
-     * @param IOInterface      $io               The IO instance
-     * @param Config           $config           The composer configuration
-     * @param ProcessExecutor  $process          Process instance, injectable for mocking
-     * @param RemoteFilesystem $remoteFilesystem Remote Filesystem, injectable for mocking
+     * @param IOInterface     $io             The IO instance
+     * @param Config          $config         The composer configuration
+     * @param ProcessExecutor $process        Process instance, injectable for mocking
+     * @param HttpDownloader  $httpDownloader Remote Filesystem, injectable for mocking
      */
-    public function __construct(IOInterface $io, Config $config, ProcessExecutor $process = null, RemoteFilesystem $remoteFilesystem = null)
+    public function __construct(IOInterface $io, Config $config, ProcessExecutor $process = null, HttpDownloader $httpDownloader = null)
     {
         $this->io = $io;
         $this->config = $config;
         $this->process = $process ?: new ProcessExecutor($io);
-        $this->remoteFilesystem = $remoteFilesystem ?: Factory::createRemoteFilesystem($this->io, $config);
+        $this->httpDownloader = $httpDownloader ?: Factory::createHttpDownloader($this->io, $config);
     }
 
     /**
@@ -67,17 +70,28 @@ class GitLab
             return true;
         }
 
+        // if available use deploy token from git config
+        if (0 === $this->process->execute('git config gitlab.deploytoken.user', $tokenUser) && 0 === $this->process->execute('git config gitlab.deploytoken.token', $tokenPassword)) {
+            $this->io->setAuthentication($originUrl, trim($tokenUser), trim($tokenPassword));
+
+            return true;
+        }
+
         // if available use token from composer config
         $authTokens = $this->config->get('gitlab-token');
 
         if (isset($authTokens[$originUrl])) {
-            $this->io->setAuthentication($originUrl, $authTokens[$originUrl], 'private-token');
-
-            return true;
+            $token = $authTokens[$originUrl];
         }
 
         if (isset($authTokens[$bcOriginUrl])) {
-            $this->io->setAuthentication($originUrl, $authTokens[$bcOriginUrl], 'private-token');
+            $token = $authTokens[$bcOriginUrl];
+        }
+
+        if (isset($token)) {
+            $username = is_array($token) && array_key_exists("username", $token) ? $token["username"] : $token;
+            $password = is_array($token) && array_key_exists("token", $token) ? $token["token"] : 'private-token';
+            $this->io->setAuthentication($originUrl, $username, $password);
 
             return true;
         }
@@ -168,10 +182,10 @@ class GitLab
             ),
         );
 
-        $json = $this->remoteFilesystem->getContents($originUrl, $scheme.'://'.$apiUrl.'/oauth/token', false, $options);
+        $token = $this->httpDownloader->get($scheme.'://'.$apiUrl.'/oauth/token', $options)->decodeJson();
 
         $this->io->writeError('Token successfully created');
 
-        return JsonFile::parseJson($json);
+        return $token;
     }
 }
diff -pruN 1.10.19-1/src/Composer/Util/Git.php 2.0.9-1/src/Composer/Util/Git.php
--- 1.10.19-1/src/Composer/Util/Git.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Git.php	2021-01-27 15:09:27.000000000 +0000
@@ -79,7 +79,8 @@ class Git
                     return;
                 }
                 $messages[] = '- ' . $protoUrl . "\n" . preg_replace('#^#m', '  ', $this->process->getErrorOutput());
-                if ($initialClone) {
+
+                if ($initialClone && isset($origCwd)) {
                     $this->filesystem->removeDirectory($origCwd);
                 }
             }
@@ -100,7 +101,7 @@ class Git
             $errorMsg = $this->process->getErrorOutput();
             // private github repository without ssh key access, try https with auth
             if (preg_match('{^git@' . self::getGitHubDomainsRegex($this->config) . ':(.+?)\.git$}i', $url, $match)
-                || preg_match('{^https?://' . self::getGitHubDomainsRegex($this->config) . '/(.*)}', $url, $match)
+                || preg_match('{^https?://' . self::getGitHubDomainsRegex($this->config) . '/(.*?)(?:\.git)?$}', $url, $match)
             ) {
                 if (!$this->io->hasAuthentication($match[1])) {
                     $gitHubUtil = new GitHub($this->io, $this->config, $this->process);
@@ -121,7 +122,7 @@ class Git
 
                     $errorMsg = $this->process->getErrorOutput();
                 }
-            } elseif (preg_match('{^https://(bitbucket\.org)/(.*)(\.git)?$}U', $url, $match)) { //bitbucket oauth
+            } elseif (preg_match('{^https://(bitbucket\.org)/(.*?)(?:\.git)?$}U', $url, $match)) { //bitbucket oauth
                 $bitbucketUtil = new Bitbucket($this->io, $this->config, $this->process);
 
                 if (!$this->io->hasAuthentication($match[1])) {
@@ -138,7 +139,7 @@ class Git
                     //We already have an access_token from a previous request.
                     if ($auth['username'] !== 'x-token-auth') {
                         $accessToken = $bitbucketUtil->requestToken($match[1], $auth['username'], $auth['password']);
-                        if (! empty($accessToken)) {
+                        if (!empty($accessToken)) {
                             $this->io->setAuthentication($match[1], 'x-token-auth', $accessToken);
                         }
                     }
@@ -238,7 +239,7 @@ class Git
                 }
             }
 
-            if ($initialClone) {
+            if ($initialClone && isset($origCwd)) {
                 $this->filesystem->removeDirectory($origCwd);
             }
 
@@ -248,13 +249,19 @@ class Git
 
     public function syncMirror($url, $dir)
     {
+        if (getenv('COMPOSER_DISABLE_NETWORK') && getenv('COMPOSER_DISABLE_NETWORK') !== 'prime') {
+            $this->io->writeError('<warning>Aborting git mirror sync of '.$url.' as network is disabled</warning>');
+
+            return false;
+        }
+
         // update the repo if it is a valid git repository
         if (is_dir($dir) && 0 === $this->process->execute('git rev-parse --git-dir', $output, $dir) && trim($output) === '.') {
             try {
                 $commandCallable = function ($url) {
                     $sanitizedUrl = preg_replace('{://([^@]+?):(.+?)@}', '://', $url);
 
-                    return sprintf('git remote set-url origin %s && git remote update --prune origin && git remote set-url origin %s', ProcessExecutor::escape($url), ProcessExecutor::escape($sanitizedUrl));
+                    return sprintf('git remote set-url origin %s && git remote update --prune origin && git remote set-url origin %s && git gc --auto', ProcessExecutor::escape($url), ProcessExecutor::escape($sanitizedUrl));
                 };
                 $this->runCommand($commandCallable, $url, $dir);
             } catch (\Exception $e) {
@@ -280,12 +287,12 @@ class Git
 
     public function fetchRefOrSyncMirror($url, $dir, $ref)
     {
-        if ($this->checkRefIsInMirror($url, $dir, $ref)) {
+        if ($this->checkRefIsInMirror($dir, $ref)) {
             return true;
         }
 
         if ($this->syncMirror($url, $dir)) {
-            return $this->checkRefIsInMirror($url, $dir, $ref);
+            return $this->checkRefIsInMirror($dir, $ref);
         }
 
         return false;
@@ -301,7 +308,7 @@ class Git
         return '';
     }
 
-    private function checkRefIsInMirror($url, $dir, $ref)
+    private function checkRefIsInMirror($dir, $ref)
     {
         if (is_dir($dir) && 0 === $this->process->execute('git rev-parse --git-dir', $output, $dir) && trim($output) === '.') {
             $escapedRef = ProcessExecutor::escape($ref.'^{commit}');
@@ -347,7 +354,7 @@ class Git
         // added in git 1.7.1, prevents prompting the user for username/password
         if (getenv('GIT_ASKPASS') !== 'echo') {
             putenv('GIT_ASKPASS=echo');
-            unset($_SERVER['GIT_ASKPASS']);
+            $_SERVER['GIT_ASKPASS'] = 'echo';
         }
 
         // clean up rogue git env vars in case this is running in a git hook
@@ -363,6 +370,7 @@ class Git
         // Run processes with predictable LANGUAGE
         if (getenv('LANGUAGE') !== 'C') {
             putenv('LANGUAGE=C');
+            $_SERVER['LANGUAGE'] = 'C';
         }
 
         // clean up env for OSX, see https://github.com/composer/composer/issues/2146#issuecomment-35478940
@@ -380,27 +388,16 @@ class Git
         return '(' . implode('|', array_map('preg_quote', $config->get('gitlab-domains'))) . ')';
     }
 
-    public static function sanitizeUrl($message)
-    {
-        return preg_replace_callback('{://(?P<user>[^@]+?):(?P<password>.+?)@}', function ($m) {
-            if (preg_match('{^[a-f0-9]{12,}$}', $m[1])) {
-                return '://***:***@';
-            }
-
-            return '://' . $m[1] . ':***@';
-        }, $message);
-    }
-
     private function throwException($message, $url)
     {
         // git might delete a directory when it fails and php will not know
         clearstatcache();
 
         if (0 !== $this->process->execute('git --version', $ignoredOutput)) {
-            throw new \RuntimeException(self::sanitizeUrl('Failed to clone ' . $url . ', git was not found, check that it is installed and in your PATH env.' . "\n\n" . $this->process->getErrorOutput()));
+            throw new \RuntimeException(Url::sanitize('Failed to clone ' . $url . ', git was not found, check that it is installed and in your PATH env.' . "\n\n" . $this->process->getErrorOutput()));
         }
 
-        throw new \RuntimeException(self::sanitizeUrl($message));
+        throw new \RuntimeException(Url::sanitize($message));
     }
 
     /**
@@ -408,7 +405,7 @@ class Git
      *
      * @return string|null The git version number.
      */
-    public static function getVersion(ProcessExecutor $process = null)
+    public static function getVersion(ProcessExecutor $process)
     {
         if (false === self::$version) {
             self::$version = null;
diff -pruN 1.10.19-1/src/Composer/Util/Hg.php 2.0.9-1/src/Composer/Util/Hg.php
--- 1.10.19-1/src/Composer/Util/Hg.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Hg.php	2021-01-27 15:09:27.000000000 +0000
@@ -72,23 +72,12 @@ class Hg
         $this->throwException('Failed to clone ' . $url . ', ' . "\n\n" . $error, $url);
     }
 
-    public static function sanitizeUrl($message)
-    {
-        return preg_replace_callback('{://(?P<user>[^@]+?):(?P<password>.+?)@}', function ($m) {
-            if (preg_match('{^[a-f0-9]{12,}$}', $m[1])) {
-                return '://***:***@';
-            }
-
-            return '://' . $m[1] . ':***@';
-        }, $message);
-    }
-
     private function throwException($message, $url)
     {
         if (0 !== $this->process->execute('hg --version', $ignoredOutput)) {
-            throw new \RuntimeException(self::sanitizeUrl('Failed to clone ' . $url . ', hg was not found, check that it is installed and in your PATH env.' . "\n\n" . $this->process->getErrorOutput()));
+            throw new \RuntimeException(Url::sanitize('Failed to clone ' . $url . ', hg was not found, check that it is installed and in your PATH env.' . "\n\n" . $this->process->getErrorOutput()));
         }
 
-        throw new \RuntimeException(self::sanitizeUrl($message));
+        throw new \RuntimeException(Url::sanitize($message));
     }
 }
diff -pruN 1.10.19-1/src/Composer/Util/Http/CurlDownloader.php 2.0.9-1/src/Composer/Util/Http/CurlDownloader.php
--- 1.10.19-1/src/Composer/Util/Http/CurlDownloader.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Http/CurlDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,535 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Util\Http;
+
+use Composer\Config;
+use Composer\Downloader\MaxFileSizeExceededException;
+use Composer\IO\IOInterface;
+use Composer\Downloader\TransportException;
+use Composer\Util\StreamContextFactory;
+use Composer\Util\AuthHelper;
+use Composer\Util\Url;
+use Composer\Util\HttpDownloader;
+use React\Promise\Promise;
+
+/**
+ * @internal
+ * @author Jordi Boggiano <j.boggiano@seld.be>
+ * @author Nicolas Grekas <p@tchwork.com>
+ */
+class CurlDownloader
+{
+    private $multiHandle;
+    private $shareHandle;
+    private $jobs = array();
+    /** @var IOInterface */
+    private $io;
+    /** @var Config */
+    private $config;
+    /** @var AuthHelper */
+    private $authHelper;
+    private $selectTimeout = 5.0;
+    private $maxRedirects = 20;
+    /** @var ProxyManager */
+    private $proxyManager;
+    private $supportsSecureProxy;
+    protected $multiErrors = array(
+        CURLM_BAD_HANDLE => array('CURLM_BAD_HANDLE', 'The passed-in handle is not a valid CURLM handle.'),
+        CURLM_BAD_EASY_HANDLE => array('CURLM_BAD_EASY_HANDLE', "An easy handle was not good/valid. It could mean that it isn't an easy handle at all, or possibly that the handle already is in used by this or another multi handle."),
+        CURLM_OUT_OF_MEMORY => array('CURLM_OUT_OF_MEMORY', 'You are doomed.'),
+        CURLM_INTERNAL_ERROR => array('CURLM_INTERNAL_ERROR', 'This can only be returned if libcurl bugs. Please report it to us!'),
+    );
+
+    private static $options = array(
+        'http' => array(
+            'method' => CURLOPT_CUSTOMREQUEST,
+            'content' => CURLOPT_POSTFIELDS,
+            'header' => CURLOPT_HTTPHEADER,
+            'timeout' => CURLOPT_TIMEOUT,
+        ),
+        'ssl' => array(
+            'cafile' => CURLOPT_CAINFO,
+            'capath' => CURLOPT_CAPATH,
+            'verify_peer' => CURLOPT_SSL_VERIFYPEER,
+            'verify_peer_name' => CURLOPT_SSL_VERIFYHOST,
+            'local_cert' => CURLOPT_SSLCERT,
+            'local_pk' => CURLOPT_SSLKEY,
+            'passphrase' => CURLOPT_SSLKEYPASSWD,
+        ),
+    );
+
+    private static $timeInfo = array(
+        'total_time' => true,
+        'namelookup_time' => true,
+        'connect_time' => true,
+        'pretransfer_time' => true,
+        'starttransfer_time' => true,
+        'redirect_time' => true,
+    );
+
+    public function __construct(IOInterface $io, Config $config, array $options = array(), $disableTls = false)
+    {
+        $this->io = $io;
+        $this->config = $config;
+
+        $this->multiHandle = $mh = curl_multi_init();
+        if (function_exists('curl_multi_setopt')) {
+            curl_multi_setopt($mh, CURLMOPT_PIPELINING, PHP_VERSION_ID >= 70400 ? /* CURLPIPE_MULTIPLEX */ 2 : /*CURLPIPE_HTTP1 | CURLPIPE_MULTIPLEX*/ 3);
+            if (defined('CURLMOPT_MAX_HOST_CONNECTIONS') && !defined('HHVM_VERSION')) {
+                curl_multi_setopt($mh, CURLMOPT_MAX_HOST_CONNECTIONS, 8);
+            }
+        }
+
+        if (function_exists('curl_share_init')) {
+            $this->shareHandle = $sh = curl_share_init();
+            curl_share_setopt($sh, CURLSHOPT_SHARE, CURL_LOCK_DATA_COOKIE);
+            curl_share_setopt($sh, CURLSHOPT_SHARE, CURL_LOCK_DATA_DNS);
+            curl_share_setopt($sh, CURLSHOPT_SHARE, CURL_LOCK_DATA_SSL_SESSION);
+        }
+
+        $this->authHelper = new AuthHelper($io, $config);
+        $this->proxyManager = ProxyManager::getInstance();
+
+        $version = curl_version();
+        $features = $version['features'];
+        $this->supportsSecureProxy = defined('CURL_VERSION_HTTPS_PROXY') && ($features & CURL_VERSION_HTTPS_PROXY);
+    }
+
+    /**
+     * @return int internal job id
+     */
+    public function download($resolve, $reject, $origin, $url, $options, $copyTo = null)
+    {
+        $attributes = array();
+        if (isset($options['retry-auth-failure'])) {
+            $attributes['retryAuthFailure'] = $options['retry-auth-failure'];
+            unset($options['retry-auth-failure']);
+        }
+
+        return $this->initDownload($resolve, $reject, $origin, $url, $options, $copyTo, $attributes);
+    }
+
+    /**
+     * @return int internal job id
+     */
+    private function initDownload($resolve, $reject, $origin, $url, $options, $copyTo = null, array $attributes = array())
+    {
+        $attributes = array_merge(array(
+            'retryAuthFailure' => true,
+            'redirects' => 0,
+            'storeAuth' => false,
+        ), $attributes);
+
+        $originalOptions = $options;
+
+        // check URL can be accessed (i.e. is not insecure), but allow insecure Packagist calls to $hashed providers as file integrity is verified with sha256
+        if (!preg_match('{^http://(repo\.)?packagist\.org/p/}', $url) || (false === strpos($url, '$') && false === strpos($url, '%24'))) {
+            $this->config->prohibitUrlByConfig($url, $this->io);
+        }
+
+        $curlHandle = curl_init();
+        $headerHandle = fopen('php://temp/maxmemory:32768', 'w+b');
+
+        if ($copyTo) {
+            $errorMessage = '';
+            set_error_handler(function ($code, $msg) use (&$errorMessage) {
+                if ($errorMessage) {
+                    $errorMessage .= "\n";
+                }
+                $errorMessage .= preg_replace('{^fopen\(.*?\): }', '', $msg);
+            });
+            $bodyHandle = fopen($copyTo.'~', 'w+b');
+            restore_error_handler();
+            if (!$bodyHandle) {
+                throw new TransportException('The "'.$url.'" file could not be written to '.$copyTo.': '.$errorMessage);
+            }
+        } else {
+            $bodyHandle = @fopen('php://temp/maxmemory:524288', 'w+b');
+        }
+
+        curl_setopt($curlHandle, CURLOPT_URL, $url);
+        curl_setopt($curlHandle, CURLOPT_FOLLOWLOCATION, false);
+        curl_setopt($curlHandle, CURLOPT_CONNECTTIMEOUT, 10);
+        curl_setopt($curlHandle, CURLOPT_TIMEOUT, 300);
+        curl_setopt($curlHandle, CURLOPT_WRITEHEADER, $headerHandle);
+        curl_setopt($curlHandle, CURLOPT_FILE, $bodyHandle);
+        curl_setopt($curlHandle, CURLOPT_ENCODING, "gzip");
+        curl_setopt($curlHandle, CURLOPT_PROTOCOLS, CURLPROTO_HTTP | CURLPROTO_HTTPS);
+        if (function_exists('curl_share_init')) {
+            curl_setopt($curlHandle, CURLOPT_SHARE, $this->shareHandle);
+        }
+
+        if (!isset($options['http']['header'])) {
+            $options['http']['header'] = array();
+        }
+
+        $options['http']['header'] = array_diff($options['http']['header'], array('Connection: close'));
+        $options['http']['header'][] = 'Connection: keep-alive';
+
+        $version = curl_version();
+        $features = $version['features'];
+        if (0 === strpos($url, 'https://') && \defined('CURL_VERSION_HTTP2') && \defined('CURL_HTTP_VERSION_2_0') && (CURL_VERSION_HTTP2 & $features)) {
+            curl_setopt($curlHandle, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_2_0);
+        }
+
+        $options['http']['header'] = $this->authHelper->addAuthenticationHeader($options['http']['header'], $origin, $url);
+        // Merge in headers - we don't get any proxy values
+        $options = StreamContextFactory::initOptions($url, $options, true);
+
+        foreach (self::$options as $type => $curlOptions) {
+            foreach ($curlOptions as $name => $curlOption) {
+                if (isset($options[$type][$name])) {
+                    if ($type === 'ssl' && $name === 'verify_peer_name') {
+                        curl_setopt($curlHandle, $curlOption, $options[$type][$name] === true ? 2 : $options[$type][$name]);
+                    } else {
+                        curl_setopt($curlHandle, $curlOption, $options[$type][$name]);
+                    }
+                }
+            }
+        }
+
+        // Always set CURLOPT_PROXY to enable/disable proxy handling
+        // Any proxy authorization is included in the proxy url
+        $proxy = $this->proxyManager->getProxyForRequest($url);
+        curl_setopt($curlHandle, CURLOPT_PROXY, $proxy->getUrl());
+
+        // Curl needs certificate locations for secure proxies.
+        // CURLOPT_PROXY_SSL_VERIFY_PEER/HOST are enabled by default
+        if ($proxy->isSecure()) {
+            if (!$this->supportsSecureProxy) {
+                throw new TransportException('Connecting to a secure proxy using curl is not supported on PHP versions below 7.3.0.');
+            }
+            if (!empty($options['ssl']['cafile'])) {
+                curl_setopt($curlHandle, CURLOPT_PROXY_CAINFO, $options['ssl']['cafile']);
+            }
+            if (!empty($options['ssl']['capath'])) {
+                curl_setopt($curlHandle, CURLOPT_PROXY_CAPATH, $options['ssl']['capath']);
+            }
+        }
+
+        $progress = array_diff_key(curl_getinfo($curlHandle), self::$timeInfo);
+
+        $this->jobs[(int) $curlHandle] = array(
+            'url' => $url,
+            'origin' => $origin,
+            'attributes' => $attributes,
+            'options' => $originalOptions,
+            'progress' => $progress,
+            'curlHandle' => $curlHandle,
+            'filename' => $copyTo,
+            'headerHandle' => $headerHandle,
+            'bodyHandle' => $bodyHandle,
+            'resolve' => $resolve,
+            'reject' => $reject,
+        );
+
+        $usingProxy = $proxy->getFormattedUrl(' using proxy (%s)');
+        $ifModified = false !== stripos(implode(',', $options['http']['header']), 'if-modified-since:') ? ' if modified' : '';
+        if ($attributes['redirects'] === 0) {
+            $this->io->writeError('Downloading ' . Url::sanitize($url) . $usingProxy . $ifModified, true, IOInterface::DEBUG);
+        }
+
+        $this->checkCurlResult(curl_multi_add_handle($this->multiHandle, $curlHandle));
+        // TODO progress
+
+        return (int) $curlHandle;
+    }
+
+    public function abortRequest($id)
+    {
+        if (isset($this->jobs[$id], $this->jobs[$id]['handle'])) {
+            $job = $this->jobs[$id];
+            curl_multi_remove_handle($this->multiHandle, $job['handle']);
+            curl_close($job['handle']);
+            if (is_resource($job['headerHandle'])) {
+                fclose($job['headerHandle']);
+            }
+            if (is_resource($job['bodyHandle'])) {
+                fclose($job['bodyHandle']);
+            }
+            if ($job['filename']) {
+                @unlink($job['filename'].'~');
+            }
+            unset($this->jobs[$id]);
+        }
+    }
+
+    public function tick()
+    {
+        if (!$this->jobs) {
+            return;
+        }
+
+        $active = true;
+        $this->checkCurlResult(curl_multi_exec($this->multiHandle, $active));
+        if (-1 === curl_multi_select($this->multiHandle, $this->selectTimeout)) {
+            // sleep in case select returns -1 as it can happen on old php versions or some platforms where curl does not manage to do the select
+            usleep(150);
+        }
+
+        while ($progress = curl_multi_info_read($this->multiHandle)) {
+            $curlHandle = $progress['handle'];
+            $result = $progress['result'];
+            $i = (int) $curlHandle;
+            if (!isset($this->jobs[$i])) {
+                continue;
+            }
+
+            $progress = curl_getinfo($curlHandle);
+            $job = $this->jobs[$i];
+            unset($this->jobs[$i]);
+            $error = curl_error($curlHandle);
+            $errno = curl_errno($curlHandle);
+            curl_multi_remove_handle($this->multiHandle, $curlHandle);
+            curl_close($curlHandle);
+
+            $headers = null;
+            $statusCode = null;
+            $response = null;
+            try {
+                // TODO progress
+                if (CURLE_OK !== $errno || $error || $result !== CURLE_OK) {
+                    $errno = $errno ?: $result;
+                    if (!$error && function_exists('curl_strerror')) {
+                        $error = curl_strerror($errno);
+                    }
+                    throw new TransportException('curl error '.$errno.' while downloading '.Url::sanitize($progress['url']).': '.$error);
+                }
+                $statusCode = $progress['http_code'];
+                rewind($job['headerHandle']);
+                $headers = explode("\r\n", rtrim(stream_get_contents($job['headerHandle'])));
+                fclose($job['headerHandle']);
+
+                if ($statusCode === 0) {
+                    throw new \LogicException('Received unexpected http status code 0 without error for '.Url::sanitize($progress['url']).': headers '.var_export($headers, true).' curl info '.var_export($progress, true));
+                }
+
+                // prepare response object
+                if ($job['filename']) {
+                    $contents = $job['filename'].'~';
+                    if ($statusCode >= 300) {
+                        rewind($job['bodyHandle']);
+                        $contents = stream_get_contents($job['bodyHandle']);
+                    }
+                    $response = new CurlResponse(array('url' => $progress['url']), $statusCode, $headers, $contents, $progress);
+                    $this->io->writeError('['.$statusCode.'] '.Url::sanitize($progress['url']), true, IOInterface::DEBUG);
+                } else {
+                    rewind($job['bodyHandle']);
+                    $contents = stream_get_contents($job['bodyHandle']);
+                    $response = new CurlResponse(array('url' => $progress['url']), $statusCode, $headers, $contents, $progress);
+                    $this->io->writeError('['.$statusCode.'] '.Url::sanitize($progress['url']), true, IOInterface::DEBUG);
+                }
+                fclose($job['bodyHandle']);
+
+                if ($response->getStatusCode() >= 400 && $response->getHeader('content-type') === 'application/json') {
+                    HttpDownloader::outputWarnings($this->io, $job['origin'], json_decode($response->getBody(), true));
+                }
+
+                $result = $this->isAuthenticatedRetryNeeded($job, $response);
+                if ($result['retry']) {
+                    $this->restartJob($job, $job['url'], array('storeAuth' => $result['storeAuth']));
+                    continue;
+                }
+
+                // handle 3xx redirects, 304 Not Modified is excluded
+                if ($statusCode >= 300 && $statusCode <= 399 && $statusCode !== 304 && $job['attributes']['redirects'] < $this->maxRedirects) {
+                    $location = $this->handleRedirect($job, $response);
+                    if ($location) {
+                        $this->restartJob($job, $location, array('redirects' => $job['attributes']['redirects'] + 1));
+                        continue;
+                    }
+                }
+
+                // fail 4xx and 5xx responses and capture the response
+                if ($statusCode >= 400 && $statusCode <= 599) {
+                    throw $this->failResponse($job, $response, $response->getStatusMessage());
+                }
+
+                if ($job['attributes']['storeAuth']) {
+                    $this->authHelper->storeAuth($job['origin'], $job['attributes']['storeAuth']);
+                }
+
+                // resolve promise
+                if ($job['filename']) {
+                    rename($job['filename'].'~', $job['filename']);
+                    call_user_func($job['resolve'], $response);
+                } else {
+                    call_user_func($job['resolve'], $response);
+                }
+            } catch (\Exception $e) {
+                if ($e instanceof TransportException && $headers) {
+                    $e->setHeaders($headers);
+                    $e->setStatusCode($statusCode);
+                }
+                if ($e instanceof TransportException && $response) {
+                    $e->setResponse($response->getBody());
+                }
+                if ($e instanceof TransportException && $progress) {
+                    $e->setResponseInfo($progress);
+                }
+
+                if (is_resource($job['headerHandle'])) {
+                    fclose($job['headerHandle']);
+                }
+                if (is_resource($job['bodyHandle'])) {
+                    fclose($job['bodyHandle']);
+                }
+                if ($job['filename']) {
+                    @unlink($job['filename'].'~');
+                }
+                call_user_func($job['reject'], $e);
+            }
+        }
+
+        foreach ($this->jobs as $i => $curlHandle) {
+            if (!isset($this->jobs[$i])) {
+                continue;
+            }
+            $curlHandle = $this->jobs[$i]['curlHandle'];
+            $progress = array_diff_key(curl_getinfo($curlHandle), self::$timeInfo);
+
+            if ($this->jobs[$i]['progress'] !== $progress) {
+                $this->jobs[$i]['progress'] = $progress;
+
+                if (isset($this->jobs[$i]['options']['max_file_size'])) {
+                    // Compare max_file_size with the content-length header this value will be -1 until the header is parsed
+                    if ($this->jobs[$i]['options']['max_file_size'] < $progress['download_content_length']) {
+                        throw new MaxFileSizeExceededException('Maximum allowed download size reached. Content-length header indicates ' . $progress['download_content_length'] . ' bytes. Allowed ' .  $this->jobs[$i]['options']['max_file_size'] . ' bytes');
+                    }
+
+                    // Compare max_file_size with the download size in bytes
+                    if ($this->jobs[$i]['options']['max_file_size'] < $progress['size_download']) {
+                        throw new MaxFileSizeExceededException('Maximum allowed download size reached. Downloaded ' . $progress['size_download'] . ' of allowed ' .  $this->jobs[$i]['options']['max_file_size'] . ' bytes');
+                    }
+                }
+
+                // TODO progress
+            }
+        }
+    }
+
+    private function handleRedirect(array $job, Response $response)
+    {
+        if ($locationHeader = $response->getHeader('location')) {
+            if (parse_url($locationHeader, PHP_URL_SCHEME)) {
+                // Absolute URL; e.g. https://example.com/composer
+                $targetUrl = $locationHeader;
+            } elseif (parse_url($locationHeader, PHP_URL_HOST)) {
+                // Scheme relative; e.g. //example.com/foo
+                $targetUrl = parse_url($job['url'], PHP_URL_SCHEME).':'.$locationHeader;
+            } elseif ('/' === $locationHeader[0]) {
+                // Absolute path; e.g. /foo
+                $urlHost = parse_url($job['url'], PHP_URL_HOST);
+
+                // Replace path using hostname as an anchor.
+                $targetUrl = preg_replace('{^(.+(?://|@)'.preg_quote($urlHost).'(?::\d+)?)(?:[/\?].*)?$}', '\1'.$locationHeader, $job['url']);
+            } else {
+                // Relative path; e.g. foo
+                // This actually differs from PHP which seems to add duplicate slashes.
+                $targetUrl = preg_replace('{^(.+/)[^/?]*(?:\?.*)?$}', '\1'.$locationHeader, $job['url']);
+            }
+        }
+
+        if (!empty($targetUrl)) {
+            $this->io->writeError(sprintf('Following redirect (%u) %s', $job['attributes']['redirects'] + 1, Url::sanitize($targetUrl)), true, IOInterface::DEBUG);
+
+            return $targetUrl;
+        }
+
+        throw new TransportException('The "'.$job['url'].'" file could not be downloaded, got redirect without Location ('.$response->getStatusMessage().')');
+    }
+
+    private function isAuthenticatedRetryNeeded(array $job, Response $response)
+    {
+        if (in_array($response->getStatusCode(), array(401, 403)) && $job['attributes']['retryAuthFailure']) {
+            $result = $this->authHelper->promptAuthIfNeeded($job['url'], $job['origin'], $response->getStatusCode(), $response->getStatusMessage(), $response->getHeaders());
+
+            if ($result['retry']) {
+                return $result;
+            }
+        }
+
+        $locationHeader = $response->getHeader('location');
+        $needsAuthRetry = false;
+
+        // check for bitbucket login page asking to authenticate
+        if (
+            $job['origin'] === 'bitbucket.org'
+            && !$this->authHelper->isPublicBitBucketDownload($job['url'])
+            && substr($job['url'], -4) === '.zip'
+            && (!$locationHeader || substr($locationHeader, -4) !== '.zip')
+            && preg_match('{^text/html\b}i', $response->getHeader('content-type'))
+        ) {
+            $needsAuthRetry = 'Bitbucket requires authentication and it was not provided';
+        }
+
+        // check for gitlab 404 when downloading archives
+        if (
+            $response->getStatusCode() === 404
+            && $this->config && in_array($job['origin'], $this->config->get('gitlab-domains'), true)
+            && false !== strpos($job['url'], 'archive.zip')
+        ) {
+            $needsAuthRetry = 'GitLab requires authentication and it was not provided';
+        }
+
+        if ($needsAuthRetry) {
+            if ($job['attributes']['retryAuthFailure']) {
+                $result = $this->authHelper->promptAuthIfNeeded($job['url'], $job['origin'], 401);
+                if ($result['retry']) {
+                    return $result;
+                }
+            }
+
+            throw $this->failResponse($job, $response, $needsAuthRetry);
+        }
+
+        return array('retry' => false, 'storeAuth' => false);
+    }
+
+    private function restartJob(array $job, $url, array $attributes = array())
+    {
+        if ($job['filename']) {
+            @unlink($job['filename'].'~');
+        }
+
+        $attributes = array_merge($job['attributes'], $attributes);
+        $origin = Url::getOrigin($this->config, $url);
+
+        $this->initDownload($job['resolve'], $job['reject'], $origin, $url, $job['options'], $job['filename'], $attributes);
+    }
+
+    private function failResponse(array $job, Response $response, $errorMessage)
+    {
+        if ($job['filename']) {
+            @unlink($job['filename'].'~');
+        }
+
+        $details = '';
+        if ($response->getHeader('content-type') === 'application/json') {
+            $details = ':'.PHP_EOL.substr($response->getBody(), 0, 200).(strlen($response->getBody()) > 200 ? '...' : '');
+        }
+
+        return new TransportException('The "'.$job['url'].'" file could not be downloaded ('.$errorMessage.')' . $details, $response->getStatusCode());
+    }
+
+    private function checkCurlResult($code)
+    {
+        if ($code != CURLM_OK && $code != CURLM_CALL_MULTI_PERFORM) {
+            throw new \RuntimeException(
+                isset($this->multiErrors[$code])
+                ? "cURL error: {$code} ({$this->multiErrors[$code][0]}): cURL message: {$this->multiErrors[$code][1]}"
+                : 'Unexpected cURL error: ' . $code
+            );
+        }
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Util/Http/CurlResponse.php 2.0.9-1/src/Composer/Util/Http/CurlResponse.php
--- 1.10.19-1/src/Composer/Util/Http/CurlResponse.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Http/CurlResponse.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,32 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Util\Http;
+
+class CurlResponse extends Response
+{
+    private $curlInfo;
+
+    public function __construct(array $request, $code, array $headers, $body, array $curlInfo)
+    {
+        parent::__construct($request, $code, $headers, $body);
+        $this->curlInfo = $curlInfo;
+    }
+
+    /**
+     * @return array
+     */
+    public function getCurlInfo()
+    {
+        return $this->curlInfo;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Util/Http/ProxyHelper.php 2.0.9-1/src/Composer/Util/Http/ProxyHelper.php
--- 1.10.19-1/src/Composer/Util/Http/ProxyHelper.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Http/ProxyHelper.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,179 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Util\Http;
+
+/**
+ * Proxy discovery and helper class
+ *
+ * @internal
+ * @author John Stevenson <john-stevenson@blueyonder.co.uk>
+ */
+class ProxyHelper
+{
+    /**
+     * Returns proxy environment values
+     *
+     * @throws \RuntimeException on malformed url
+     * @return array             httpProxy, httpsProxy, noProxy values
+     */
+    public static function getProxyData()
+    {
+        $httpProxy = null;
+        $httpsProxy = null;
+
+        // Handle http_proxy/HTTP_PROXY on CLI only for security reasons
+        if (PHP_SAPI === 'cli' || PHP_SAPI === 'phpdbg') {
+            if ($env = self::getProxyEnv(array('http_proxy', 'HTTP_PROXY'), $name)) {
+                $httpProxy = self::checkProxy($env, $name);
+            }
+        }
+
+        // Prefer CGI_HTTP_PROXY if available
+        if ($env = self::getProxyEnv(array('CGI_HTTP_PROXY'), $name)) {
+            $httpProxy = self::checkProxy($env, $name);
+        }
+
+        // Handle https_proxy/HTTPS_PROXY
+        if ($env = self::getProxyEnv(array('https_proxy', 'HTTPS_PROXY'), $name)) {
+            $httpsProxy = self::checkProxy($env, $name);
+        } else {
+            $httpsProxy = $httpProxy;
+        }
+
+        // Handle no_proxy
+        $noProxy = self::getProxyEnv(array('no_proxy', 'NO_PROXY'), $name);
+
+        return array($httpProxy, $httpsProxy, $noProxy);
+    }
+
+    /**
+     * Returns http context options for the proxy url
+     *
+     * @param  string $proxyUrl
+     * @return array
+     */
+    public static function getContextOptions($proxyUrl)
+    {
+        $proxy = parse_url($proxyUrl);
+
+        // Remove any authorization
+        $proxyUrl = self::formatParsedUrl($proxy, false);
+        $proxyUrl = str_replace(array('http://', 'https://'), array('tcp://', 'ssl://'), $proxyUrl);
+
+        $options['http']['proxy'] = $proxyUrl;
+
+        // Handle any authorization
+        if (isset($proxy['user'])) {
+            $auth = rawurldecode($proxy['user']);
+
+            if (isset($proxy['pass'])) {
+                $auth .= ':' . rawurldecode($proxy['pass']);
+            }
+            $auth = base64_encode($auth);
+            // Set header as a string
+            $options['http']['header'] = "Proxy-Authorization: Basic {$auth}";
+        }
+
+        return $options;
+    }
+
+    /**
+     * Sets/unsets request_fulluri value in http context options array
+     *
+     * @param string $requestUrl
+     * @param array  $options    Set by method
+     */
+    public static function setRequestFullUri($requestUrl, array &$options)
+    {
+        if ('http' === parse_url($requestUrl, PHP_URL_SCHEME)) {
+            $options['http']['request_fulluri'] = true;
+        } else {
+            unset($options['http']['request_fulluri']);
+        }
+    }
+
+    /**
+     * Searches $_SERVER for case-sensitive values
+     *
+     * @param  array       $names Names to search for
+     * @param  mixed       $name  Name of any found value
+     * @return string|null The found value
+     */
+    private static function getProxyEnv(array $names, &$name)
+    {
+        foreach ($names as $name) {
+            if (!empty($_SERVER[$name])) {
+                return $_SERVER[$name];
+            }
+        }
+    }
+
+    /**
+     * Checks and formats a proxy url from the environment
+     *
+     * @param  string            $proxyUrl
+     * @param  string            $envName
+     * @throws \RuntimeException on malformed url
+     * @return string            The formatted proxy url
+     */
+    private static function checkProxy($proxyUrl, $envName)
+    {
+        $error = sprintf('malformed %s url', $envName);
+        $proxy = parse_url($proxyUrl);
+
+        if (!isset($proxy['host'])) {
+            throw new \RuntimeException($error);
+        }
+
+        $proxyUrl = self::formatParsedUrl($proxy, true);
+
+        if (!parse_url($proxyUrl, PHP_URL_PORT)) {
+            throw new \RuntimeException($error);
+        }
+
+        return $proxyUrl;
+    }
+
+    /**
+     * Formats a url from its component parts
+     *
+     * @param  array  $proxy       Values from parse_url
+     * @param  bool   $includeAuth Whether to include authorization values
+     * @return string The formatted value
+     */
+    private static function formatParsedUrl(array $proxy, $includeAuth)
+    {
+        $proxyUrl = isset($proxy['scheme']) ? strtolower($proxy['scheme']) . '://' : '';
+
+        if ($includeAuth && isset($proxy['user'])) {
+            $proxyUrl .= $proxy['user'];
+
+            if (isset($proxy['pass'])) {
+                $proxyUrl .= ':' . $proxy['pass'];
+            }
+            $proxyUrl .= '@';
+        }
+
+        $proxyUrl .= $proxy['host'];
+
+        if (isset($proxy['port'])) {
+            $proxyUrl .= ':' . $proxy['port'];
+        } elseif (strpos($proxyUrl, 'http://') === 0) {
+            $proxyUrl .= ':80';
+        } elseif (strpos($proxyUrl, 'https://') === 0) {
+            $proxyUrl .= ':443';
+        }
+
+        return $proxyUrl;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Util/Http/ProxyManager.php 2.0.9-1/src/Composer/Util/Http/ProxyManager.php
--- 1.10.19-1/src/Composer/Util/Http/ProxyManager.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Http/ProxyManager.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,188 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Util\Http;
+
+use Composer\Downloader\TransportException;
+use Composer\Util\NoProxyPattern;
+use Composer\Util\Url;
+
+/**
+ * @internal
+ * @author John Stevenson <john-stevenson@blueyonder.co.uk>
+ */
+class ProxyManager
+{
+    private $error;
+    private $fullProxy;
+    private $safeProxy;
+    private $streams;
+    private $hasProxy;
+    private $info;
+    private $lastProxy;
+    /** @var NoProxyPattern */
+    private $noProxyHandler;
+
+    /** @var ProxyManager */
+    private static $instance;
+
+    private function __construct()
+    {
+        $this->fullProxy = $this->safeProxy = array(
+            'http' => null,
+            'https' => null,
+        );
+
+        $this->streams['http'] = $this->streams['https'] = array(
+            'options' => null,
+        );
+
+        $this->hasProxy = false;
+        $this->initProxyData();
+    }
+
+    /**
+     * @return ProxyManager
+     */
+    public static function getInstance()
+    {
+        if (!self::$instance) {
+            self::$instance = new self();
+        }
+
+        return self::$instance;
+    }
+
+    /**
+     * Clears the persistent instance
+     */
+    public static function reset()
+    {
+        self::$instance = null;
+    }
+
+    /**
+     * Returns a RequestProxy instance for the request url
+     *
+     * @param  string       $requestUrl
+     * @return RequestProxy
+     */
+    public function getProxyForRequest($requestUrl)
+    {
+        if ($this->error) {
+            throw new TransportException('Unable to use a proxy: '.$this->error);
+        }
+
+        $scheme = parse_url($requestUrl, PHP_URL_SCHEME) ?: 'http';
+        $proxyUrl = '';
+        $options = array();
+        $formattedProxyUrl = '';
+
+        if ($this->hasProxy && $this->fullProxy[$scheme]) {
+            if ($this->noProxy($requestUrl)) {
+                $formattedProxyUrl = 'excluded by no_proxy';
+            } else {
+                $proxyUrl = $this->fullProxy[$scheme];
+                $options = $this->streams[$scheme]['options'];
+                ProxyHelper::setRequestFullUri($requestUrl, $options);
+                $formattedProxyUrl = $this->safeProxy[$scheme];
+            }
+        }
+
+        return new RequestProxy($proxyUrl, $options, $formattedProxyUrl);
+    }
+
+    /**
+     * Returns true if a proxy is being used
+     *
+     * @return bool If false any error will be in $message
+     */
+    public function isProxying()
+    {
+        return $this->hasProxy;
+    }
+
+    /**
+     * Returns proxy configuration info which can be shown to the user
+     *
+     * @return string|null Safe proxy URL or an error message if setting up proxy failed or null if no proxy was configured
+     */
+    public function getFormattedProxy()
+    {
+        return $this->hasProxy ? $this->info : $this->error;
+    }
+
+    /**
+     * Initializes proxy values from the environment
+     */
+    private function initProxyData()
+    {
+        try {
+            list($httpProxy, $httpsProxy, $noProxy) = ProxyHelper::getProxyData();
+        } catch (\RuntimeException $e) {
+            $this->error = $e->getMessage();
+
+            return;
+        }
+
+        $info = array();
+
+        if ($httpProxy) {
+            $info[] = $this->setData($httpProxy, 'http');
+        }
+        if ($httpsProxy) {
+            $info[] = $this->setData($httpsProxy, 'https');
+        }
+        if ($this->hasProxy) {
+            $this->info = implode(', ', $info);
+            if ($noProxy) {
+                $this->noProxyHandler = array(new NoProxyPattern($noProxy), 'test');
+            }
+        }
+    }
+
+    /**
+     * Sets initial data
+     *
+     * @param string $url    Proxy url
+     * @param string $scheme Environment variable scheme
+     */
+    private function setData($url, $scheme)
+    {
+        $safeProxy = Url::sanitize($url);
+        $this->fullProxy[$scheme] = $url;
+        $this->safeProxy[$scheme] = $safeProxy;
+        $this->streams[$scheme]['options'] = ProxyHelper::getContextOptions($url);
+        $this->hasProxy = true;
+
+        return sprintf('%s=%s', $scheme, $safeProxy);
+    }
+
+    /**
+     * Returns true if a url matches no_proxy value
+     *
+     * @param  string $requestUrl
+     * @return bool
+     */
+    private function noProxy($requestUrl)
+    {
+        if ($this->noProxyHandler) {
+            if (call_user_func($this->noProxyHandler, $requestUrl)) {
+                $this->lastProxy = 'excluded by no_proxy';
+
+                return true;
+            }
+        }
+
+        return false;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Util/Http/RequestProxy.php 2.0.9-1/src/Composer/Util/Http/RequestProxy.php
--- 1.10.19-1/src/Composer/Util/Http/RequestProxy.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Http/RequestProxy.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,87 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Util\Http;
+
+use Composer\Util\Url;
+
+/**
+ * @internal
+ * @author John Stevenson <john-stevenson@blueyonder.co.uk>
+ */
+class RequestProxy
+{
+    private $contextOptions;
+    private $isSecure;
+    private $formattedUrl;
+    private $url;
+
+    /**
+     * @param string $url
+     * @param array  $contextOptions
+     * @param string $formattedUrl
+     */
+    public function __construct($url, array $contextOptions, $formattedUrl)
+    {
+        $this->url = $url;
+        $this->contextOptions = $contextOptions;
+        $this->formattedUrl = $formattedUrl;
+        $this->isSecure = 0 === strpos($url, 'https://');
+    }
+
+    /**
+     * Returns an array of context options
+     *
+     * @return array
+     */
+    public function getContextOptions()
+    {
+        return $this->contextOptions;
+    }
+
+    /**
+     * Returns the safe proxy url from the last request
+     *
+     * @param  string|null $format Output format specifier
+     * @return string      Safe proxy, no proxy or empty
+     */
+    public function getFormattedUrl($format = '')
+    {
+        $result = '';
+        if ($this->formattedUrl) {
+            $format = $format ?: '%s';
+            $result = sprintf($format, $this->formattedUrl);
+        }
+
+        return $result;
+    }
+
+    /**
+     * Returns the proxy url
+     *
+     * @return string Proxy url or empty
+     */
+    public function getUrl()
+    {
+        return $this->url;
+    }
+
+    /**
+     * Returns true if this is a secure-proxy
+     *
+     * @return bool False if not secure or there is no proxy
+     */
+    public function isSecure()
+    {
+        return $this->isSecure;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Util/Http/Response.php 2.0.9-1/src/Composer/Util/Http/Response.php
--- 1.10.19-1/src/Composer/Util/Http/Response.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Http/Response.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,98 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Util\Http;
+
+use Composer\Json\JsonFile;
+
+class Response
+{
+    private $request;
+    private $code;
+    private $headers;
+    private $body;
+
+    public function __construct(array $request, $code, array $headers, $body)
+    {
+        if (!isset($request['url'])) {
+            throw new \LogicException('url key missing from request array');
+        }
+        $this->request = $request;
+        $this->code = (int) $code;
+        $this->headers = $headers;
+        $this->body = $body;
+    }
+
+    public function getStatusCode()
+    {
+        return $this->code;
+    }
+
+    /**
+     * @return string|null
+     */
+    public function getStatusMessage()
+    {
+        $value = null;
+        foreach ($this->headers as $header) {
+            if (preg_match('{^HTTP/\S+ \d+}i', $header)) {
+                // In case of redirects, headers contain the headers of all responses
+                // so we can not return directly and need to keep iterating
+                $value = $header;
+            }
+        }
+
+        return $value;
+    }
+
+    public function getHeaders()
+    {
+        return $this->headers;
+    }
+
+    public function getHeader($name)
+    {
+        return self::findHeaderValue($this->headers, $name);
+    }
+
+    public function getBody()
+    {
+        return $this->body;
+    }
+
+    public function decodeJson()
+    {
+        return JsonFile::parseJson($this->body, $this->request['url']);
+    }
+
+    public function collect()
+    {
+        $this->request = $this->code = $this->headers = $this->body = null;
+    }
+
+    /**
+     * @param  array       $headers array of returned headers like from getLastHeaders()
+     * @param  string      $name    header name (case insensitive)
+     * @return string|null
+     */
+    public static function findHeaderValue(array $headers, $name)
+    {
+        $value = null;
+        foreach ($headers as $header) {
+            if (preg_match('{^'.preg_quote($name).':\s*(.+?)\s*$}i', $header, $match)) {
+                $value = $match[1];
+            }
+        }
+
+        return $value;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Util/HttpDownloader.php 2.0.9-1/src/Composer/Util/HttpDownloader.php
--- 1.10.19-1/src/Composer/Util/HttpDownloader.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/HttpDownloader.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,487 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Util;
+
+use Composer\Config;
+use Composer\IO\IOInterface;
+use Composer\Downloader\TransportException;
+use Composer\Util\Http\Response;
+use Composer\Composer;
+use Composer\Package\Version\VersionParser;
+use Composer\Semver\Constraint\Constraint;
+use React\Promise\Promise;
+
+/**
+ * @author Jordi Boggiano <j.boggiano@seld.be>
+ */
+class HttpDownloader
+{
+    const STATUS_QUEUED = 1;
+    const STATUS_STARTED = 2;
+    const STATUS_COMPLETED = 3;
+    const STATUS_FAILED = 4;
+    const STATUS_ABORTED = 5;
+
+    private $io;
+    private $config;
+    private $jobs = array();
+    private $options = array();
+    private $runningJobs = 0;
+    private $maxJobs = 10;
+    private $curl;
+    private $rfs;
+    private $idGen = 0;
+    private $disabled;
+    private $allowAsync = false;
+
+    /**
+     * @param IOInterface $io         The IO instance
+     * @param Config      $config     The config
+     * @param array       $options    The options
+     * @param bool        $disableTls
+     */
+    public function __construct(IOInterface $io, Config $config, array $options = array(), $disableTls = false)
+    {
+        $this->io = $io;
+
+        $this->disabled = (bool) getenv('COMPOSER_DISABLE_NETWORK');
+
+        // Setup TLS options
+        // The cafile option can be set via config.json
+        if ($disableTls === false) {
+            $this->options = StreamContextFactory::getTlsDefaults($options, $io);
+        }
+
+        // handle the other externally set options normally.
+        $this->options = array_replace_recursive($this->options, $options);
+        $this->config = $config;
+
+        if (self::isCurlEnabled()) {
+            $this->curl = new Http\CurlDownloader($io, $config, $options, $disableTls);
+        }
+
+        $this->rfs = new RemoteFilesystem($io, $config, $options, $disableTls);
+    }
+
+    /**
+     * Download a file synchronously
+     *
+     * @param  string   $url     URL to download
+     * @param  array    $options Stream context options e.g. https://www.php.net/manual/en/context.http.php
+     *                           although not all options are supported when using the default curl downloader
+     * @return Response
+     *
+     * @throws TransportException
+     */
+    public function get($url, $options = array())
+    {
+        list($job) = $this->addJob(array('url' => $url, 'options' => $options, 'copyTo' => false), true);
+        $this->wait($job['id']);
+
+        $response = $this->getResponse($job['id']);
+
+        // check for failed curl response (empty body but successful looking response)
+        if (
+            $this->curl
+            && PHP_VERSION_ID < 70000
+            && $response->getBody() === null
+            && $response->getStatusCode() === 200
+            && $response->getHeader('content-length') !== '0'
+        ) {
+            $this->io->writeError('<warning>cURL downloader failed to return a response, disabling it and proceeding in slow mode.</warning>');
+
+            $this->curl = null;
+
+            list($job) = $this->addJob(array('url' => $url, 'options' => $options, 'copyTo' => false), true);
+            $this->wait($job['id']);
+
+            $response = $this->getResponse($job['id']);
+        }
+
+        return $response;
+    }
+
+    /**
+     * Create an async download operation
+     *
+     * @param  string   $url     URL to download
+     * @param  array    $options Stream context options e.g. https://www.php.net/manual/en/context.http.php
+     *                           although not all options are supported when using the default curl downloader
+     * @return Promise
+     *
+     * @throws TransportException
+     */
+    public function add($url, $options = array())
+    {
+        list(, $promise) = $this->addJob(array('url' => $url, 'options' => $options, 'copyTo' => false));
+
+        return $promise;
+    }
+
+    /**
+     * Copy a file synchronously
+     *
+     * @param  string   $url     URL to download
+     * @param  string   $to      Path to copy to
+     * @param  array    $options Stream context options e.g. https://www.php.net/manual/en/context.http.php
+     *                           although not all options are supported when using the default curl downloader
+     * @return Response
+     *
+     * @throws TransportException
+     */
+    public function copy($url, $to, $options = array())
+    {
+        list($job) = $this->addJob(array('url' => $url, 'options' => $options, 'copyTo' => $to), true);
+        $this->wait($job['id']);
+
+        return $this->getResponse($job['id']);
+    }
+
+    /**
+     * Create an async copy operation
+     *
+     * @param  string   $url     URL to download
+     * @param  string   $to      Path to copy to
+     * @param  array    $options Stream context options e.g. https://www.php.net/manual/en/context.http.php
+     *                           although not all options are supported when using the default curl downloader
+     * @return Promise
+     *
+     * @throws TransportException
+     */
+    public function addCopy($url, $to, $options = array())
+    {
+        list(, $promise) = $this->addJob(array('url' => $url, 'options' => $options, 'copyTo' => $to));
+
+        return $promise;
+    }
+
+    /**
+     * Retrieve the options set in the constructor
+     *
+     * @return array Options
+     */
+    public function getOptions()
+    {
+        return $this->options;
+    }
+
+    /**
+     * Merges new options
+     *
+     * @return void
+     */
+    public function setOptions(array $options)
+    {
+        $this->options = array_replace_recursive($this->options, $options);
+    }
+
+    private function addJob($request, $sync = false)
+    {
+        $request['options'] = array_replace_recursive($this->options, $request['options']);
+
+        $job = array(
+            'id' => $this->idGen++,
+            'status' => self::STATUS_QUEUED,
+            'request' => $request,
+            'sync' => $sync,
+            'origin' => Url::getOrigin($this->config, $request['url']),
+        );
+
+        if (!$sync && !$this->allowAsync) {
+            throw new \LogicException('You must use the HttpDownloader instance which is part of a Composer\Loop instance to be able to run async http requests');
+        }
+
+        // capture username/password from URL if there is one
+        if (preg_match('{^https?://([^:/]+):([^@/]+)@([^/]+)}i', $request['url'], $match)) {
+            $this->io->setAuthentication($job['origin'], rawurldecode($match[1]), rawurldecode($match[2]));
+        }
+
+        $rfs = $this->rfs;
+
+        if ($this->canUseCurl($job)) {
+            $resolver = function ($resolve, $reject) use (&$job) {
+                $job['status'] = HttpDownloader::STATUS_QUEUED;
+                $job['resolve'] = $resolve;
+                $job['reject'] = $reject;
+            };
+        } else {
+            $resolver = function ($resolve, $reject) use (&$job, $rfs) {
+                // start job
+                $url = $job['request']['url'];
+                $options = $job['request']['options'];
+
+                $job['status'] = HttpDownloader::STATUS_STARTED;
+
+                if ($job['request']['copyTo']) {
+                    $rfs->copy($job['origin'], $url, $job['request']['copyTo'], false /* TODO progress */, $options);
+
+                    $headers = $rfs->getLastHeaders();
+                    $response = new Http\Response($job['request'], $rfs->findStatusCode($headers), $headers, $job['request']['copyTo'].'~');
+
+                    $resolve($response);
+                } else {
+                    $body = $rfs->getContents($job['origin'], $url, false /* TODO progress */, $options);
+                    $headers = $rfs->getLastHeaders();
+                    $response = new Http\Response($job['request'], $rfs->findStatusCode($headers), $headers, $body);
+
+                    $resolve($response);
+                }
+            };
+        }
+
+        $downloader = $this;
+        $curl = $this->curl;
+
+        $canceler = function () use (&$job, $curl) {
+            if ($job['status'] === HttpDownloader::STATUS_QUEUED) {
+                $job['status'] = HttpDownloader::STATUS_ABORTED;
+            }
+            if ($job['status'] !== HttpDownloader::STATUS_STARTED) {
+                return;
+            }
+            $job['status'] = HttpDownloader::STATUS_ABORTED;
+            if (isset($job['curl_id'])) {
+                $curl->abortRequest($job['curl_id']);
+            }
+        };
+
+        $promise = new Promise($resolver, $canceler);
+        $promise->then(function ($response) use (&$job, $downloader) {
+            $job['status'] = HttpDownloader::STATUS_COMPLETED;
+            $job['response'] = $response;
+
+            // TODO 3.0 this should be done directly on $this when PHP 5.3 is dropped
+            $downloader->markJobDone();
+
+            return $response;
+        }, function ($e) use (&$job, $downloader) {
+            $job['status'] = HttpDownloader::STATUS_FAILED;
+            $job['exception'] = $e;
+
+            $downloader->markJobDone();
+
+            throw $e;
+        });
+        $this->jobs[$job['id']] = &$job;
+
+        if ($this->runningJobs < $this->maxJobs) {
+            $this->startJob($job['id']);
+        }
+
+        return array($job, $promise);
+    }
+
+    private function startJob($id)
+    {
+        $job = &$this->jobs[$id];
+        if ($job['status'] !== self::STATUS_QUEUED) {
+            return;
+        }
+
+        // start job
+        $job['status'] = self::STATUS_STARTED;
+        $this->runningJobs++;
+
+        $resolve = $job['resolve'];
+        $reject = $job['reject'];
+        $url = $job['request']['url'];
+        $options = $job['request']['options'];
+        $origin = $job['origin'];
+
+        if ($this->disabled) {
+            if (isset($job['request']['options']['http']['header']) && false !== stripos(implode('', $job['request']['options']['http']['header']), 'if-modified-since')) {
+                $resolve(new Response(array('url' => $url), 304, array(), ''));
+            } else {
+                $e = new TransportException('Network disabled, request canceled: '.$url, 499);
+                $e->setStatusCode(499);
+                $reject($e);
+            }
+
+            return;
+        }
+
+        try {
+            if ($job['request']['copyTo']) {
+                $job['curl_id'] = $this->curl->download($resolve, $reject, $origin, $url, $options, $job['request']['copyTo']);
+            } else {
+                $job['curl_id'] = $this->curl->download($resolve, $reject, $origin, $url, $options);
+            }
+        } catch (\Exception $exception) {
+            $reject($exception);
+        }
+    }
+
+    /**
+     * @private
+     */
+    public function markJobDone()
+    {
+        $this->runningJobs--;
+    }
+
+    /**
+     * Wait for current async download jobs to complete
+     *
+     * @param int|null $index For internal use only, the job id
+     */
+    public function wait($index = null)
+    {
+        do {
+            $jobCount = $this->countActiveJobs($index);
+        } while ($jobCount);
+    }
+
+    /**
+     * @internal
+     */
+    public function enableAsync()
+    {
+        $this->allowAsync = true;
+    }
+
+    /**
+     * @internal
+     *
+     * @param  int|null $index For internal use only, the job id
+     * @return int      number of active (queued or started) jobs
+     */
+    public function countActiveJobs($index = null)
+    {
+        if ($this->runningJobs < $this->maxJobs) {
+            foreach ($this->jobs as $job) {
+                if ($job['status'] === self::STATUS_QUEUED && $this->runningJobs < $this->maxJobs) {
+                    $this->startJob($job['id']);
+                }
+            }
+        }
+
+        if ($this->curl) {
+            $this->curl->tick();
+        }
+
+        if (null !== $index) {
+            return $this->jobs[$index]['status'] < self::STATUS_COMPLETED ? 1 : 0;
+        }
+
+        $active = 0;
+        foreach ($this->jobs as $job) {
+            if ($job['status'] < self::STATUS_COMPLETED) {
+                $active++;
+            } elseif (!$job['sync']) {
+                unset($this->jobs[$job['id']]);
+            }
+        }
+
+        return $active;
+    }
+
+    private function getResponse($index)
+    {
+        if (!isset($this->jobs[$index])) {
+            throw new \LogicException('Invalid request id');
+        }
+
+        if ($this->jobs[$index]['status'] === self::STATUS_FAILED) {
+            throw $this->jobs[$index]['exception'];
+        }
+
+        if (!isset($this->jobs[$index]['response'])) {
+            throw new \LogicException('Response not available yet, call wait() first');
+        }
+
+        $resp = $this->jobs[$index]['response'];
+
+        unset($this->jobs[$index]);
+
+        return $resp;
+    }
+
+    /**
+     * @internal
+     */
+    public static function outputWarnings(IOInterface $io, $url, $data)
+    {
+        foreach (array('warning', 'info') as $type) {
+            if (empty($data[$type])) {
+                continue;
+            }
+
+            if (!empty($data[$type . '-versions'])) {
+                $versionParser = new VersionParser();
+                $constraint = $versionParser->parseConstraints($data[$type . '-versions']);
+                $composer = new Constraint('==', $versionParser->normalize(Composer::getVersion()));
+                if (!$constraint->matches($composer)) {
+                    continue;
+                }
+            }
+
+            $io->writeError('<'.$type.'>'.ucfirst($type).' from '.$url.': '.$data[$type].'</'.$type.'>');
+        }
+    }
+
+    /**
+     * @internal
+     */
+    public static function getExceptionHints(\Exception $e)
+    {
+        if (!$e instanceof TransportException) {
+            return;
+        }
+
+        if (
+            false !== strpos($e->getMessage(), 'Resolving timed out')
+            || false !== strpos($e->getMessage(), 'Could not resolve host')
+        ) {
+            Silencer::suppress();
+            $testConnectivity = file_get_contents('https://8.8.8.8', false, stream_context_create(array(
+                'ssl' => array('verify_peer' => false),
+                'http' => array('follow_location' => false, 'ignore_errors' => true),
+            )));
+            Silencer::restore();
+            if (false !== $testConnectivity) {
+                return array(
+                    '<error>The following exception probably indicates you have misconfigured DNS resolver(s)</error>',
+                );
+            }
+
+            return array(
+                '<error>The following exception probably indicates you are offline or have misconfigured DNS resolver(s)</error>',
+            );
+        }
+    }
+
+    private function canUseCurl(array $job)
+    {
+        if (!$this->curl) {
+            return false;
+        }
+
+        if (!preg_match('{^https?://}i', $job['request']['url'])) {
+            return false;
+        }
+
+        if (!empty($job['request']['options']['ssl']['allow_self_signed'])) {
+            return false;
+        }
+
+        return true;
+    }
+
+    /**
+     * @internal
+     */
+    public static function isCurlEnabled()
+    {
+        return \extension_loaded('curl') && \function_exists('curl_multi_exec') && \function_exists('curl_multi_init');
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Util/Loop.php 2.0.9-1/src/Composer/Util/Loop.php
--- 1.10.19-1/src/Composer/Util/Loop.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Loop.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,128 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Util;
+
+use React\Promise\Promise;
+use Symfony\Component\Console\Helper\ProgressBar;
+
+/**
+ * @author Jordi Boggiano <j.boggiano@seld.be>
+ */
+class Loop
+{
+    /** @var HttpDownloader */
+    private $httpDownloader;
+    /** @var ProcessExecutor|null */
+    private $processExecutor;
+    /** @var Promise[][] */
+    private $currentPromises = array();
+    /** @var int */
+    private $waitIndex = 0;
+
+    public function __construct(HttpDownloader $httpDownloader, ProcessExecutor $processExecutor = null)
+    {
+        $this->httpDownloader = $httpDownloader;
+        $this->httpDownloader->enableAsync();
+
+        $this->processExecutor = $processExecutor;
+        if ($this->processExecutor) {
+            $this->processExecutor->enableAsync();
+        }
+    }
+
+    /**
+     * @return HttpDownloader
+     */
+    public function getHttpDownloader()
+    {
+        return $this->httpDownloader;
+    }
+
+    /**
+     * @return ProcessExecutor|null
+     */
+    public function getProcessExecutor()
+    {
+        return $this->processExecutor;
+    }
+
+    public function wait(array $promises, ProgressBar $progress = null)
+    {
+        /** @var \Exception|null */
+        $uncaught = null;
+
+        \React\Promise\all($promises)->then(
+            function () {
+            },
+            function ($e) use (&$uncaught) {
+                $uncaught = $e;
+            }
+        );
+
+        // keep track of every group of promises that is waited on, so abortJobs can
+        // cancel them all, even if wait() was called within a wait()
+        $waitIndex = $this->waitIndex++;
+        $this->currentPromises[$waitIndex] = $promises;
+
+        if ($progress) {
+            $totalJobs = 0;
+            if ($this->httpDownloader) {
+                $totalJobs += $this->httpDownloader->countActiveJobs();
+            }
+            if ($this->processExecutor) {
+                $totalJobs += $this->processExecutor->countActiveJobs();
+            }
+            $progress->start($totalJobs);
+        }
+
+        $lastUpdate = 0;
+        while (true) {
+            $activeJobs = 0;
+
+            if ($this->httpDownloader) {
+                $activeJobs += $this->httpDownloader->countActiveJobs();
+            }
+            if ($this->processExecutor) {
+                $activeJobs += $this->processExecutor->countActiveJobs();
+            }
+
+            if ($progress && microtime(true) - $lastUpdate > 0.1) {
+                $lastUpdate = microtime(true);
+                $progress->setProgress($progress->getMaxSteps() - $activeJobs);
+            }
+
+            if (!$activeJobs) {
+                break;
+            }
+        }
+
+        // as we skip progress updates if they are too quick, make sure we do one last one here at 100%
+        if ($progress) {
+            $progress->setProgress($progress->getMaxSteps());
+        }
+
+        unset($this->currentPromises[$waitIndex]);
+        if ($uncaught) {
+            throw $uncaught;
+        }
+    }
+
+    public function abortJobs()
+    {
+        foreach ($this->currentPromises as $promiseGroup) {
+            foreach ($promiseGroup as $promise) {
+                $promise->cancel();
+            }
+        }
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Util/MetadataMinifier.php 2.0.9-1/src/Composer/Util/MetadataMinifier.php
--- 1.10.19-1/src/Composer/Util/MetadataMinifier.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/MetadataMinifier.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,78 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Util;
+
+class MetadataMinifier
+{
+    public static function expand(array $versions)
+    {
+        $expanded = array();
+        $expandedVersion = null;
+        foreach ($versions as $versionData) {
+            if (!$expandedVersion) {
+                $expandedVersion = $versionData;
+                $expanded[] = $expandedVersion;
+                continue;
+            }
+
+            // add any changes from the previous version to the expanded one
+            foreach ($versionData as $key => $val) {
+                if ($val === '__unset') {
+                    unset($expandedVersion[$key]);
+                } else {
+                    $expandedVersion[$key] = $val;
+                }
+            }
+
+            $expanded[] = $expandedVersion;
+        }
+
+        return $expanded;
+    }
+
+    public static function minify(array $versions)
+    {
+        $minifiedVersions = array();
+
+        $lastKnownVersionData = null;
+        foreach ($versions as $version) {
+            if (!$lastKnownVersionData) {
+                $lastKnownVersionData = $version;
+                $minifiedVersions[] = $version;
+                continue;
+            }
+
+            $minifiedVersion = array();
+
+            // add any changes from the previous version
+            foreach ($version as $key => $val) {
+                if (!isset($lastKnownVersionData[$key]) || $lastKnownVersionData[$key] !== $val) {
+                    $minifiedVersion[$key] = $val;
+                    $lastKnownVersionData[$key] = $val;
+                }
+            }
+
+            // store any deletions from the previous version for keys missing in current one
+            foreach ($lastKnownVersionData as $key => $val) {
+                if (!isset($version[$key])) {
+                    $minifiedVersion[$key] = "__unset";
+                    unset($lastKnownVersionData[$key]);
+                }
+            }
+
+            $minifiedVersions[] = $minifiedVersion;
+        }
+
+        return $minifiedVersions;
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Util/NoProxyPattern.php 2.0.9-1/src/Composer/Util/NoProxyPattern.php
--- 1.10.19-1/src/Composer/Util/NoProxyPattern.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/NoProxyPattern.php	2021-01-27 15:09:27.000000000 +0000
@@ -108,7 +108,7 @@ class NoProxyPattern
     /**
      * Returns true if the url is matched by a rule
      *
-     * @param int $index
+     * @param int    $index
      * @param string $hostName
      * @param string $url
      *
@@ -134,7 +134,7 @@ class NoProxyPattern
             $match = $rule->ipdata->ip === $url->ipdata->ip;
         } else {
             // Match host and port
-            $haystack = substr($url->name, - strlen($rule->name));
+            $haystack = substr($url->name, -strlen($rule->name));
             $match = stripos($haystack, $rule->name) === 0;
         }
 
@@ -171,10 +171,10 @@ class NoProxyPattern
     /**
      * Finds or creates rule data for a hostname
      *
-     * @param int $index
+     * @param int    $index
      * @param string $hostName
      *
-     * @return {null|stdClass} Null if the hostname is invalid
+     * @return null|stdClass Null if the hostname is invalid
      */
     private function getRule($index, $hostName)
     {
@@ -197,9 +197,9 @@ class NoProxyPattern
     /**
      * Creates an object containing IP data if the host is an IP address
      *
-     * @param string $host
-     * @param null|stdclass $ipdata Set by method if IP address found
-     * @param bool $allowPrefix Whether a CIDR prefix-length is expected
+     * @param string        $host
+     * @param null|stdclass $ipdata      Set by method if IP address found
+     * @param bool          $allowPrefix Whether a CIDR prefix-length is expected
      *
      * @return bool False if the host contains invalid data
      */
@@ -265,7 +265,7 @@ class NoProxyPattern
      * Returns the binary network mask mapped to IPv6
      *
      * @param string $prefix CIDR prefix-length
-     * @param int $size Byte size of in_addr
+     * @param int    $size   Byte size of in_addr
      *
      * @return string
      */
@@ -290,8 +290,8 @@ class NoProxyPattern
      * Calculates and returns the network and mask
      *
      * @param string $rangeIp IP in_addr
-     * @param int $size Byte size of in_addr
-     * @param string $prefix CIDR prefix-length
+     * @param int    $size    Byte size of in_addr
+     * @param string $prefix  CIDR prefix-length
      *
      * @return string[] network in_addr, binary mask
      */
@@ -315,7 +315,7 @@ class NoProxyPattern
      * Maps an IPv4 address to IPv6
      *
      * @param string $binary in_addr
-     * @param int $size Byte size of in_addr
+     * @param int    $size   Byte size of in_addr
      *
      * @return string Mapped or existing in_addr
      */
@@ -332,8 +332,8 @@ class NoProxyPattern
     /**
      * Creates a rule data object
      *
-     * @param string $host
-     * @param int $port
+     * @param string        $host
+     * @param int           $port
      * @param null|stdclass $ipdata
      *
      * @return stdclass
@@ -351,8 +351,8 @@ class NoProxyPattern
     /**
      * Creates an ip data object
      *
-     * @param string $ip in_addr
-     * @param int $size Byte size of in_addr
+     * @param string      $ip      in_addr
+     * @param int         $size    Byte size of in_addr
      * @param null|string $netmask Network mask
      *
      * @return stdclass
@@ -392,8 +392,7 @@ class NoProxyPattern
             $ip6 = substr($hostName, 1, $index - 1);
             $hostName = substr($hostName, $index + 1);
 
-            if (strpbrk($hostName, '[]') !== false
-                || substr_count($hostName, ':') > 1) {
+            if (strpbrk($hostName, '[]') !== false || substr_count($hostName, ':') > 1) {
                 return $error;
             }
         }
@@ -419,15 +418,16 @@ class NoProxyPattern
      * Wrapper around filter_var FILTER_VALIDATE_INT
      *
      * @param string $int
-     * @param int $min
-     * @param int $max
+     * @param int    $min
+     * @param int    $max
      */
     private function validateInt($int, $min, $max)
     {
         $options = array(
             'options' => array(
                 'min_range' => $min,
-                'max_range' => $max)
+                'max_range' => $max,
+            ),
         );
 
         return false !== filter_var($int, FILTER_VALIDATE_INT, $options);
diff -pruN 1.10.19-1/src/Composer/Util/PackageSorter.php 2.0.9-1/src/Composer/Util/PackageSorter.php
--- 1.10.19-1/src/Composer/Util/PackageSorter.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/PackageSorter.php	2021-01-27 15:09:27.000000000 +0000
@@ -1,5 +1,14 @@
 <?php
 
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
 
 namespace Composer\Util;
 
@@ -16,7 +25,8 @@ class PackageSorter
      * @param  array $packages
      * @return array
      */
-    public static function sortPackages(array $packages) {
+    public static function sortPackages(array $packages)
+    {
         $usageList = array();
 
         foreach ($packages as $package) { /** @var PackageInterface $package */
@@ -55,9 +65,9 @@ class PackageSorter
 
         $weightList = array();
 
-        foreach ($packages as $name => $package) {
-            $weight = $computeImportance($name);
-            $weightList[$name] = $weight;
+        foreach ($packages as $index => $package) {
+            $weight = $computeImportance($package->getName());
+            $weightList[$index] = $weight;
         }
 
         $stable_sort = function (&$array) {
@@ -84,9 +94,10 @@ class PackageSorter
 
         $sortedPackages = array();
 
-        foreach (array_keys($weightList) as $name) {
-            $sortedPackages[] = $packages[$name];
+        foreach (array_keys($weightList) as $index) {
+            $sortedPackages[] = $packages[$index];
         }
+
         return $sortedPackages;
     }
 }
diff -pruN 1.10.19-1/src/Composer/Util/Perforce.php 2.0.9-1/src/Composer/Util/Perforce.php
--- 1.10.19-1/src/Composer/Util/Perforce.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Perforce.php	2021-01-27 15:09:27.000000000 +0000
@@ -273,7 +273,7 @@ class Perforce
         if ($useClient) {
             $p4Command .= '-c ' . $this->getClient() . ' ';
         }
-        $p4Command = $p4Command . '-p ' . $this->getPort() . ' ' . $command;
+        $p4Command .= '-p ' . $this->getPort() . ' ' . $command;
 
         return $p4Command;
     }
@@ -389,7 +389,6 @@ class Perforce
             } else {
                 $command = 'echo ' . ProcessExecutor::escape($password)  . ' | ' . $this->generateP4Command(' login -a', false);
                 $exitCode = $this->executeCommand($command);
-                $result = trim($this->commandResult);
                 if ($exitCode) {
                     throw new \Exception("Error logging in:" . $this->process->getErrorOutput());
                 }
@@ -427,9 +426,7 @@ class Perforce
     {
         $index = strpos($identifier, '@');
         if ($index === false) {
-            $path = $identifier. '/' . $file;
-
-            return $path;
+            return $identifier. '/' . $file;
         }
 
         $path = substr($identifier, 0, $index) . '/' . $file . substr($identifier, $index);
@@ -476,9 +473,7 @@ class Perforce
         $lastCommitArr = explode(' ', $lastCommit);
         $lastCommitNum = $lastCommitArr[1];
 
-        $branches = array('master' => $possibleBranches[$this->p4Branch] . '@'. $lastCommitNum);
-
-        return $branches;
+        return array('master' => $possibleBranches[$this->p4Branch] . '@'. $lastCommitNum);
     }
 
     public function getTags()
@@ -519,7 +514,7 @@ class Perforce
     }
 
     /**
-     * @param string $reference
+     * @param  string     $reference
      * @return mixed|null
      */
     protected function getChangeList($reference)
@@ -541,8 +536,8 @@ class Perforce
     }
 
     /**
-     * @param string $fromReference
-     * @param string $toReference
+     * @param  string     $fromReference
+     * @param  string     $toReference
      * @return mixed|null
      */
     public function getCommitLogs($fromReference, $toReference)
diff -pruN 1.10.19-1/src/Composer/Util/Platform.php 2.0.9-1/src/Composer/Util/Platform.php
--- 1.10.19-1/src/Composer/Util/Platform.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Platform.php	2021-01-27 15:09:27.000000000 +0000
@@ -55,7 +55,7 @@ class Platform
             return $home;
         }
 
-        if (function_exists('posix_getuid') && function_exists('posix_getpwuid')) {
+        if (\function_exists('posix_getuid') && \function_exists('posix_getpwuid')) {
             $info = posix_getpwuid(posix_getuid());
 
             return $info['dir'];
@@ -69,7 +69,7 @@ class Platform
      */
     public static function isWindows()
     {
-        return defined('PHP_WINDOWS_VERSION_BUILD');
+        return \defined('PHP_WINDOWS_VERSION_BUILD');
     }
 
     /**
@@ -80,13 +80,35 @@ class Platform
     {
         static $useMbString = null;
         if (null === $useMbString) {
-            $useMbString = function_exists('mb_strlen') && ini_get('mbstring.func_overload');
+            $useMbString = \function_exists('mb_strlen') && ini_get('mbstring.func_overload');
         }
 
         if ($useMbString) {
             return mb_strlen($str, '8bit');
         }
 
-        return strlen($str);
+        return \strlen($str);
+    }
+
+    public static function isTty($fd = null)
+    {
+        if ($fd === null) {
+            $fd = defined('STDOUT') ? STDOUT : fopen('php://stdout', 'w');
+        }
+
+        // modern cross-platform function, includes the fstat
+        // fallback so if it is present we trust it
+        if (function_exists('stream_isatty')) {
+            return stream_isatty($fd);
+        }
+
+        // only trusting this if it is positive, otherwise prefer fstat fallback
+        if (function_exists('posix_isatty') && posix_isatty($fd)) {
+            return true;
+        }
+
+        $stat = @fstat($fd);
+        // Check if formatted mode is S_IFCHR
+        return $stat ? 0020000 === ($stat['mode'] & 0170000) : false;
     }
 }
diff -pruN 1.10.19-1/src/Composer/Util/ProcessExecutor.php 2.0.9-1/src/Composer/Util/ProcessExecutor.php
--- 1.10.19-1/src/Composer/Util/ProcessExecutor.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/ProcessExecutor.php	2021-01-27 15:09:27.000000000 +0000
@@ -15,18 +15,36 @@ namespace Composer\Util;
 use Composer\IO\IOInterface;
 use Symfony\Component\Process\Process;
 use Symfony\Component\Process\ProcessUtils;
+use Symfony\Component\Process\Exception\RuntimeException;
+use React\Promise\Promise;
 
 /**
  * @author Robert Schönthal <seroscho@googlemail.com>
+ * @author Jordi Boggiano <j.boggiano@seld.be>
  */
 class ProcessExecutor
 {
+    const STATUS_QUEUED = 1;
+    const STATUS_STARTED = 2;
+    const STATUS_COMPLETED = 3;
+    const STATUS_FAILED = 4;
+    const STATUS_ABORTED = 5;
+
     protected static $timeout = 300;
 
     protected $captureOutput;
     protected $errorOutput;
     protected $io;
 
+    /**
+     * @psalm-var array<int, array<string, mixed>>
+     */
+    private $jobs = array();
+    private $runningJobs = 0;
+    private $maxJobs = 10;
+    private $idGen = 0;
+    private $allowAsync = false;
+
     public function __construct(IOInterface $io = null)
     {
         $this->io = $io;
@@ -43,6 +61,31 @@ class ProcessExecutor
      */
     public function execute($command, &$output = null, $cwd = null)
     {
+        if (func_num_args() > 1) {
+            return $this->doExecute($command, $cwd, false, $output);
+        }
+
+        return $this->doExecute($command, $cwd, false);
+    }
+
+    /**
+     * runs a process on the commandline in TTY mode
+     *
+     * @param  string $command the command to execute
+     * @param  string $cwd     the working directory
+     * @return int    statuscode
+     */
+    public function executeTty($command, $cwd = null)
+    {
+        if (Platform::isTty()) {
+            return $this->doExecute($command, $cwd, true);
+        }
+
+        return $this->doExecute($command, $cwd, false);
+    }
+
+    private function doExecute($command, $cwd, $tty, &$output = null)
+    {
         if ($this->io && $this->io->isDebug()) {
             $safeCommand = preg_replace_callback('{://(?P<user>[^:/\s]+):(?P<password>[^@\s/]+)@}i', function ($m) {
                 if (preg_match('{^[a-f0-9]{12,}$}', $m['user'])) {
@@ -61,7 +104,7 @@ class ProcessExecutor
             $cwd = realpath(getcwd());
         }
 
-        $this->captureOutput = func_num_args() > 1;
+        $this->captureOutput = func_num_args() > 3;
         $this->errorOutput = null;
 
         // TODO in v3, commands should be passed in as arrays of cmd + args
@@ -70,6 +113,13 @@ class ProcessExecutor
         } else {
             $process = new Process($command, $cwd, null, null, static::getTimeout());
         }
+        if (!Platform::isWindows() && $tty) {
+            try {
+                $process->setTty(true);
+            } catch (RuntimeException $e) {
+                // ignore TTY enabling errors
+            }
+        }
 
         $callback = is_callable($output) ? $output : array($this, 'outputHandler');
         $process->run($callback);
@@ -83,6 +133,192 @@ class ProcessExecutor
         return $process->getExitCode();
     }
 
+    /**
+     * starts a process on the commandline in async mode
+     *
+     * @param  string  $command the command to execute
+     * @param  string  $cwd     the working directory
+     * @return Promise
+     */
+    public function executeAsync($command, $cwd = null)
+    {
+        if (!$this->allowAsync) {
+            throw new \LogicException('You must use the ProcessExecutor instance which is part of a Composer\Loop instance to be able to run async processes');
+        }
+
+        $job = array(
+            'id' => $this->idGen++,
+            'status' => self::STATUS_QUEUED,
+            'command' => $command,
+            'cwd' => $cwd,
+        );
+
+        $resolver = function ($resolve, $reject) use (&$job) {
+            $job['status'] = ProcessExecutor::STATUS_QUEUED;
+            $job['resolve'] = $resolve;
+            $job['reject'] = $reject;
+        };
+
+        $self = $this;
+
+        $canceler = function () use (&$job) {
+            if ($job['status'] === ProcessExecutor::STATUS_QUEUED) {
+                $job['status'] = ProcessExecutor::STATUS_ABORTED;
+            }
+            if ($job['status'] !== ProcessExecutor::STATUS_STARTED) {
+                return;
+            }
+            $job['status'] = ProcessExecutor::STATUS_ABORTED;
+            try {
+                if (defined('SIGINT')) {
+                    $job['process']->signal(SIGINT);
+                }
+            } catch (\Exception $e) {
+                // signal can throw in various conditions, but we don't care if it fails
+            }
+            $job['process']->stop(1);
+        };
+
+        $promise = new Promise($resolver, $canceler);
+        $promise = $promise->then(function () use (&$job, $self) {
+            if ($job['process']->isSuccessful()) {
+                $job['status'] = ProcessExecutor::STATUS_COMPLETED;
+            } else {
+                $job['status'] = ProcessExecutor::STATUS_FAILED;
+            }
+
+            // TODO 3.0 this should be done directly on $this when PHP 5.3 is dropped
+            $self->markJobDone();
+
+            return $job['process'];
+        }, function ($e) use (&$job, $self) {
+            $job['status'] = ProcessExecutor::STATUS_FAILED;
+
+            $self->markJobDone();
+
+            throw $e;
+        });
+        $this->jobs[$job['id']] = &$job;
+
+        if ($this->runningJobs < $this->maxJobs) {
+            $this->startJob($job['id']);
+        }
+
+        return $promise;
+    }
+
+    private function startJob($id)
+    {
+        $job = &$this->jobs[$id];
+        if ($job['status'] !== self::STATUS_QUEUED) {
+            return;
+        }
+
+        // start job
+        $job['status'] = self::STATUS_STARTED;
+        $this->runningJobs++;
+
+        $command = $job['command'];
+        $cwd = $job['cwd'];
+
+        if ($this->io && $this->io->isDebug()) {
+            $safeCommand = preg_replace_callback('{://(?P<user>[^:/\s]+):(?P<password>[^@\s/]+)@}i', function ($m) {
+                if (preg_match('{^[a-f0-9]{12,}$}', $m['user'])) {
+                    return '://***:***@';
+                }
+
+                return '://'.$m['user'].':***@';
+            }, $command);
+            $safeCommand = preg_replace("{--password (.*[^\\\\]\') }", '--password \'***\' ', $safeCommand);
+            $this->io->writeError('Executing async command ('.($cwd ?: 'CWD').'): '.$safeCommand);
+        }
+
+        // make sure that null translate to the proper directory in case the dir is a symlink
+        // and we call a git command, because msysgit does not handle symlinks properly
+        if (null === $cwd && Platform::isWindows() && false !== strpos($command, 'git') && getcwd()) {
+            $cwd = realpath(getcwd());
+        }
+
+        // TODO in v3, commands should be passed in as arrays of cmd + args
+        if (method_exists('Symfony\Component\Process\Process', 'fromShellCommandline')) {
+            $process = Process::fromShellCommandline($command, $cwd, null, null, static::getTimeout());
+        } else {
+            $process = new Process($command, $cwd, null, null, static::getTimeout());
+        }
+
+        $job['process'] = $process;
+
+        $process->start();
+    }
+
+    public function wait($index = null)
+    {
+        while (true) {
+            if (!$this->countActiveJobs($index)) {
+                return;
+            }
+
+            usleep(1000);
+        }
+    }
+
+    /**
+     * @internal
+     */
+    public function enableAsync()
+    {
+        $this->allowAsync = true;
+    }
+
+    /**
+     * @internal
+     *
+     * @return int number of active (queued or started) jobs
+     */
+    public function countActiveJobs($index = null)
+    {
+        // tick
+        foreach ($this->jobs as $job) {
+            if ($job['status'] === self::STATUS_STARTED) {
+                if (!$job['process']->isRunning()) {
+                    call_user_func($job['resolve'], $job['process']);
+                }
+            }
+
+            if ($this->runningJobs < $this->maxJobs) {
+                if ($job['status'] === self::STATUS_QUEUED) {
+                    $this->startJob($job['id']);
+                }
+            }
+        }
+
+        if (null !== $index) {
+            return $this->jobs[$index]['status'] < self::STATUS_COMPLETED ? 1 : 0;
+        }
+
+        $active = 0;
+        foreach ($this->jobs as $job) {
+            if ($job['status'] < self::STATUS_COMPLETED) {
+                $active++;
+            } else {
+                unset($this->jobs[$job['id']]);
+            }
+        }
+
+        return $active;
+    }
+
+    /**
+     * @private
+     */
+    public function markJobDone()
+    {
+        $this->runningJobs--;
+    }
+
+    /**
+     * @return string[]
+     */
     public function splitLines($output)
     {
         $output = trim($output);
@@ -112,18 +348,10 @@ class ProcessExecutor
             return;
         }
 
-        if (method_exists($this->io, 'writeRaw')) {
-            if (Process::ERR === $type) {
-                $this->io->writeErrorRaw($buffer, false);
-            } else {
-                $this->io->writeRaw($buffer, false);
-            }
+        if (Process::ERR === $type) {
+            $this->io->writeErrorRaw($buffer, false);
         } else {
-            if (Process::ERR === $type) {
-                $this->io->writeError($buffer, false);
-            } else {
-                $this->io->write($buffer, false);
-            }
+            $this->io->writeRaw($buffer, false);
         }
     }
 
diff -pruN 1.10.19-1/src/Composer/Util/RemoteFilesystem.php 2.0.9-1/src/Composer/Util/RemoteFilesystem.php
--- 1.10.19-1/src/Composer/Util/RemoteFilesystem.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/RemoteFilesystem.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,15 +13,15 @@
 namespace Composer\Util;
 
 use Composer\Config;
-use Composer\Composer;
-use Composer\Semver\Constraint\Constraint;
-use Composer\Package\Version\VersionParser;
+use Composer\Downloader\MaxFileSizeExceededException;
 use Composer\IO\IOInterface;
 use Composer\Downloader\TransportException;
 use Composer\CaBundle\CaBundle;
-use Psr\Log\LoggerInterface;
+use Composer\Util\Http\Response;
+use Composer\Util\Http\ProxyManager;
 
 /**
+ * @internal
  * @author François Pluchino <francois.pluchino@opendisplay.com>
  * @author Jordi Boggiano <j.boggiano@seld.be>
  * @author Nils Adermann <naderman@naderman.de>
@@ -41,13 +41,13 @@ class RemoteFilesystem
     private $options = array();
     private $peerCertificateMap = array();
     private $disableTls = false;
-    private $retryAuthFailure;
     private $lastHeaders;
     private $storeAuth;
+    private $authHelper;
     private $degradedMode = false;
     private $redirects;
     private $maxRedirects = 20;
-    private $displayedOriginAuthentications = array();
+    private $proxyManager;
 
     /**
      * Constructor.
@@ -56,15 +56,16 @@ class RemoteFilesystem
      * @param Config      $config     The config
      * @param array       $options    The options
      * @param bool        $disableTls
+     * @param AuthHelper  $authHelper
      */
-    public function __construct(IOInterface $io, Config $config = null, array $options = array(), $disableTls = false)
+    public function __construct(IOInterface $io, Config $config, array $options = array(), $disableTls = false, AuthHelper $authHelper = null)
     {
         $this->io = $io;
 
         // Setup TLS options
         // The cafile option can be set via config.json
         if ($disableTls === false) {
-            $this->options = $this->getTlsDefaults($options);
+            $this->options = StreamContextFactory::getTlsDefaults($options, $io);
         } else {
             $this->disableTls = true;
         }
@@ -72,6 +73,8 @@ class RemoteFilesystem
         // handle the other externally set options normally.
         $this->options = array_replace_recursive($this->options, $options);
         $this->config = $config;
+        $this->authHelper = isset($authHelper) ? $authHelper : new AuthHelper($io, $config);
+        $this->proxyManager = ProxyManager::getInstance();
     }
 
     /**
@@ -146,31 +149,10 @@ class RemoteFilesystem
     }
 
     /**
-     * @param  array       $headers array of returned headers like from getLastHeaders()
-     * @param  string      $name    header name (case insensitive)
-     * @return string|null
-     */
-    public function findHeaderValue(array $headers, $name)
-    {
-        $value = null;
-        foreach ($headers as $header) {
-            if (preg_match('{^'.$name.':\s*(.+?)\s*$}i', $header, $match)) {
-                $value = $match[1];
-            } elseif (preg_match('{^HTTP/}i', $header)) {
-                // In case of redirects, http_response_headers contains the headers of all responses
-                // so we reset the flag when a new response is being parsed as we are only interested in the last response
-                $value = null;
-            }
-        }
-
-        return $value;
-    }
-
-    /**
      * @param  array    $headers array of returned headers like from getLastHeaders()
      * @return int|null
      */
-    public function findStatusCode(array $headers)
+    public static function findStatusCode(array $headers)
     {
         $value = null;
         foreach ($headers as $header) {
@@ -218,27 +200,6 @@ class RemoteFilesystem
      */
     protected function get($originUrl, $fileUrl, $additionalOptions = array(), $fileName = null, $progress = true)
     {
-        if (strpos($originUrl, '.github.com') === (strlen($originUrl) - 11)) {
-            $originUrl = 'github.com';
-        }
-
-        // Gitlab can be installed in a non-root context (i.e. gitlab.com/foo). When downloading archives the originUrl
-        // is the host without the path, so we look for the registered gitlab-domains matching the host here
-        if (
-            $this->config
-            && is_array($this->config->get('gitlab-domains'))
-            && false === strpos($originUrl, '/')
-            && !in_array($originUrl, $this->config->get('gitlab-domains'))
-        ) {
-            foreach ($this->config->get('gitlab-domains') as $gitlabDomain) {
-                if (0 === strpos($gitlabDomain, $originUrl)) {
-                    $originUrl = $gitlabDomain;
-                    break;
-                }
-            }
-            unset($gitlabDomain);
-        }
-
         $this->scheme = parse_url($fileUrl, PHP_URL_SCHEME);
         $this->bytesMax = 0;
         $this->originUrl = $originUrl;
@@ -246,18 +207,13 @@ class RemoteFilesystem
         $this->fileName = $fileName;
         $this->progress = $progress;
         $this->lastProgress = null;
-        $this->retryAuthFailure = true;
+        $retryAuthFailure = true;
         $this->lastHeaders = array();
         $this->redirects = 1; // The first request counts.
 
-        // capture username/password from URL if there is one
-        if (preg_match('{^https?://([^:/]+):([^@/]+)@([^/]+)}i', $fileUrl, $match)) {
-            $this->io->setAuthentication($originUrl, rawurldecode($match[1]), rawurldecode($match[2]));
-        }
-
         $tempAdditionalOptions = $additionalOptions;
         if (isset($tempAdditionalOptions['retry-auth-failure'])) {
-            $this->retryAuthFailure = (bool) $tempAdditionalOptions['retry-auth-failure'];
+            $retryAuthFailure = (bool) $tempAdditionalOptions['retry-auth-failure'];
 
             unset($tempAdditionalOptions['retry-auth-failure']);
         }
@@ -275,14 +231,6 @@ class RemoteFilesystem
 
         $origFileUrl = $fileUrl;
 
-        if (isset($options['github-token'])) {
-            // only add the access_token if it is actually a github URL (in case we were redirected to S3)
-            if (preg_match('{^https?://api\.github\.com/}', $fileUrl)) {
-                $options['http']['header'][] = 'Authorization: token '.$options['github-token'];
-            }
-            unset($options['github-token']);
-        }
-
         if (isset($options['gitlab-token'])) {
             $fileUrl .= (false === strpos($fileUrl, '?') ? '?' : '&') . 'access_token='.$options['gitlab-token'];
             unset($options['gitlab-token']);
@@ -292,18 +240,24 @@ class RemoteFilesystem
             $options['http']['ignore_errors'] = true;
         }
 
-        if ($this->degradedMode && substr($fileUrl, 0, 26) === 'http://repo.packagist.org/') {
+        if ($this->degradedMode && strpos($fileUrl, 'http://repo.packagist.org/') === 0) {
             // access packagist using the resolved IPv4 instead of the hostname to force IPv4 protocol
             $fileUrl = 'http://' . gethostbyname('repo.packagist.org') . substr($fileUrl, 20);
             $degradedPackagist = true;
         }
 
+        $maxFileSize = null;
+        if (isset($options['max_file_size'])) {
+            $maxFileSize = $options['max_file_size'];
+            unset($options['max_file_size']);
+        }
+
         $ctx = StreamContextFactory::getContext($fileUrl, $options, array('notification' => array($this, 'callbackGet')));
 
-        $actualContextOptions = stream_context_get_options($ctx);
-        $usingProxy = !empty($actualContextOptions['http']['proxy']) ? ' using proxy ' . $actualContextOptions['http']['proxy'] : '';
-        $this->io->writeError((substr($origFileUrl, 0, 4) === 'http' ? 'Downloading ' : 'Reading ') . $this->stripCredentialsFromUrl($origFileUrl) . $usingProxy, true, IOInterface::DEBUG);
-        unset($origFileUrl, $actualContextOptions);
+        $proxy = ProxyManager::getInstance()->getProxyForRequest($fileUrl);
+        $usingProxy = $proxy->getFormattedUrl(' using proxy (%s)');
+        $this->io->writeError((strpos($origFileUrl, 'http') === 0 ? 'Downloading ' : 'Reading ') . Url::sanitize($origFileUrl) . $usingProxy, true, IOInterface::DEBUG);
+        unset($origFileUrl, $proxy, $usingProxy);
 
         // Check for secure HTTP, but allow insecure Packagist calls to $hashed providers as file integrity is verified with sha256
         if ((!preg_match('{^http://(repo\.)?packagist\.org/p/}', $fileUrl) || (false === strpos($fileUrl, '$') && false === strpos($fileUrl, '%24'))) && empty($degradedPackagist) && $this->config) {
@@ -325,27 +279,33 @@ class RemoteFilesystem
 
             return true;
         });
+        $http_response_header = array();
         try {
-            $result = $this->getRemoteContents($originUrl, $fileUrl, $ctx, $http_response_header);
+            $result = $this->getRemoteContents($originUrl, $fileUrl, $ctx, $http_response_header, $maxFileSize);
 
             if (!empty($http_response_header[0])) {
-                $statusCode = $this->findStatusCode($http_response_header);
-                if ($statusCode >= 400 && $this->findHeaderValue($http_response_header, 'content-type') === 'application/json') {
-                    self::outputWarnings($this->io, $originUrl, json_decode($result, true));
+                $statusCode = self::findStatusCode($http_response_header);
+                if ($statusCode >= 400 && Response::findHeaderValue($http_response_header, 'content-type') === 'application/json') {
+                    HttpDownloader::outputWarnings($this->io, $originUrl, json_decode($result, true));
                 }
 
-                if (in_array($statusCode, array(401, 403)) && $this->retryAuthFailure) {
-                    $this->promptAuthAndRetry($statusCode, $this->findStatusMessage($http_response_header), null, $http_response_header);
+                if (in_array($statusCode, array(401, 403)) && $retryAuthFailure) {
+                    $this->promptAuthAndRetry($statusCode, $this->findStatusMessage($http_response_header), $http_response_header);
                 }
             }
 
-            $contentLength = !empty($http_response_header[0]) ? $this->findHeaderValue($http_response_header, 'content-length') : null;
+            $contentLength = !empty($http_response_header[0]) ? Response::findHeaderValue($http_response_header, 'content-length') : null;
             if ($contentLength && Platform::strlen($result) < $contentLength) {
                 // alas, this is not possible via the stream callback because STREAM_NOTIFY_COMPLETED is documented, but not implemented anywhere in PHP
                 $e = new TransportException('Content-Length mismatch, received '.Platform::strlen($result).' bytes out of the expected '.$contentLength);
                 $e->setHeaders($http_response_header);
-                $e->setStatusCode($this->findStatusCode($http_response_header));
-                $e->setResponse($result);
+                $e->setStatusCode(self::findStatusCode($http_response_header));
+                try {
+                    $e->setResponse($this->decodeResult($result, $http_response_header));
+                } catch (\Exception $e) {
+                    $e->setResponse($result);
+                }
+
                 $this->io->writeError('Content-Length mismatch, received '.Platform::strlen($result).' out of '.$contentLength.' bytes: (' . base64_encode($result).')', true, IOInterface::DEBUG);
 
                 throw $e;
@@ -365,10 +325,10 @@ class RemoteFilesystem
         } catch (\Exception $e) {
             if ($e instanceof TransportException && !empty($http_response_header[0])) {
                 $e->setHeaders($http_response_header);
-                $e->setStatusCode($this->findStatusCode($http_response_header));
+                $e->setStatusCode(self::findStatusCode($http_response_header));
             }
             if ($e instanceof TransportException && $result !== false) {
-                $e->setResponse($result);
+                $e->setResponse($this->decodeResult($result, $http_response_header));
             }
             $result = false;
         }
@@ -395,20 +355,20 @@ class RemoteFilesystem
         $contentType = null;
         $locationHeader = null;
         if (!empty($http_response_header[0])) {
-            $statusCode = $this->findStatusCode($http_response_header);
-            $contentType = $this->findHeaderValue($http_response_header, 'content-type');
-            $locationHeader = $this->findHeaderValue($http_response_header, 'location');
+            $statusCode = self::findStatusCode($http_response_header);
+            $contentType = Response::findHeaderValue($http_response_header, 'content-type');
+            $locationHeader = Response::findHeaderValue($http_response_header, 'location');
         }
 
         // check for bitbucket login page asking to authenticate
         if ($originUrl === 'bitbucket.org'
-            && !$this->isPublicBitBucketDownload($fileUrl)
+            && !$this->authHelper->isPublicBitBucketDownload($fileUrl)
             && substr($fileUrl, -4) === '.zip'
             && (!$locationHeader || substr(parse_url($locationHeader, PHP_URL_PATH), -4) !== '.zip')
             && $contentType && preg_match('{^text/html\b}i', $contentType)
         ) {
             $result = false;
-            if ($this->retryAuthFailure) {
+            if ($retryAuthFailure) {
                 $this->promptAuthAndRetry(401);
             }
         }
@@ -419,7 +379,7 @@ class RemoteFilesystem
             && false !== strpos($fileUrl, 'archive.zip')
         ) {
             $result = false;
-            if ($this->retryAuthFailure) {
+            if ($retryAuthFailure) {
                 $this->promptAuthAndRetry(401);
             }
         }
@@ -434,13 +394,13 @@ class RemoteFilesystem
         // fail 4xx and 5xx responses and capture the response
         if ($statusCode && $statusCode >= 400 && $statusCode <= 599) {
             if (!$this->retry) {
-                if ($this->progress && !$this->retry && !$isRedirect) {
+                if ($this->progress && !$isRedirect) {
                     $this->io->overwriteError("Downloading (<error>failed</error>)", false);
                 }
 
                 $e = new TransportException('The "'.$this->fileUrl.'" file could not be downloaded ('.$http_response_header[0].')', $statusCode);
                 $e->setHeaders($http_response_header);
-                $e->setResponse($result);
+                $e->setResponse($this->decodeResult($result, $http_response_header));
                 $e->setStatusCode($statusCode);
                 throw $e;
             }
@@ -452,36 +412,22 @@ class RemoteFilesystem
         }
 
         // decode gzip
-        if ($result && extension_loaded('zlib') && substr($fileUrl, 0, 4) === 'http' && !$hasFollowedRedirect) {
-            $contentEncoding = $this->findHeaderValue($http_response_header, 'content-encoding');
-            $decode = $contentEncoding && 'gzip' === strtolower($contentEncoding);
-
-            if ($decode) {
-                try {
-                    if (PHP_VERSION_ID >= 50400) {
-                        $result = zlib_decode($result);
-                    } else {
-                        // work around issue with gzuncompress & co that do not work with all gzip checksums
-                        $result = file_get_contents('compress.zlib://data:application/octet-stream;base64,'.base64_encode($result));
-                    }
-
-                    if (!$result) {
-                        throw new TransportException('Failed to decode zlib stream');
-                    }
-                } catch (\Exception $e) {
-                    if ($this->degradedMode) {
-                        throw $e;
-                    }
+        if ($result && extension_loaded('zlib') && strpos($fileUrl, 'http') === 0 && !$hasFollowedRedirect) {
+            try {
+                $result = $this->decodeResult($result, $http_response_header);
+            } catch (\Exception $e) {
+                if ($this->degradedMode) {
+                    throw $e;
+                }
 
-                    $this->degradedMode = true;
-                    $this->io->writeError(array(
-                        '',
-                        '<error>Failed to decode response: '.$e->getMessage().'</error>',
-                        '<error>Retrying with degraded mode, check https://getcomposer.org/doc/articles/troubleshooting.md#degraded-mode for more info</error>',
-                    ));
+                $this->degradedMode = true;
+                $this->io->writeError(array(
+                    '',
+                    '<error>Failed to decode response: '.$e->getMessage().'</error>',
+                    '<error>Retrying with degraded mode, check https://getcomposer.org/doc/articles/troubleshooting.md#degraded-mode for more info</error>',
+                ));
 
-                    return $this->get($this->originUrl, $this->fileUrl, $additionalOptions, $this->fileName, $this->progress);
-                }
+                return $this->get($this->originUrl, $this->fileUrl, $additionalOptions, $this->fileName, $this->progress);
             }
         }
 
@@ -548,8 +494,7 @@ class RemoteFilesystem
             $result = $this->get($this->originUrl, $this->fileUrl, $additionalOptions, $this->fileName, $this->progress);
 
             if ($this->storeAuth && $this->config) {
-                $authHelper = new AuthHelper($this->io, $this->config);
-                $authHelper->storeAuth($this->originUrl, $this->storeAuth);
+                $this->authHelper->storeAuth($this->originUrl, $this->storeAuth);
                 $this->storeAuth = false;
             }
 
@@ -586,21 +531,34 @@ class RemoteFilesystem
     /**
      * Get contents of remote URL.
      *
-     * @param string   $originUrl The origin URL
-     * @param string   $fileUrl   The file URL
-     * @param resource $context   The stream context
+     * @param string   $originUrl   The origin URL
+     * @param string   $fileUrl     The file URL
+     * @param resource $context     The stream context
+     * @param int      $maxFileSize The maximum allowed file size
      *
      * @return string|false The response contents or false on failure
      */
-    protected function getRemoteContents($originUrl, $fileUrl, $context, array &$responseHeaders = null)
+    protected function getRemoteContents($originUrl, $fileUrl, $context, array &$responseHeaders = null, $maxFileSize = null)
     {
+        $result = false;
+
         try {
             $e = null;
-            $result = file_get_contents($fileUrl, false, $context);
+            if ($maxFileSize !== null) {
+                $result = file_get_contents($fileUrl, false, $context, 0, $maxFileSize);
+            } else {
+                // passing `null` to file_get_contents will convert `null` to `0` and return 0 bytes
+                $result = file_get_contents($fileUrl, false, $context);
+            }
         } catch (\Throwable $e) {
         } catch (\Exception $e) {
         }
 
+        if ($maxFileSize !== null && Platform::strlen($result) >= $maxFileSize) {
+            throw new MaxFileSizeExceededException('Maximum allowed download size reached. Downloaded ' . Platform::strlen($result) . ' of allowed ' .  $maxFileSize . ' bytes');
+        }
+
+        // https://www.php.net/manual/en/reserved.variables.httpresponseheader.php
         $responseHeaders = isset($http_response_header) ? $http_response_header : array();
 
         if (null !== $e) {
@@ -652,111 +610,16 @@ class RemoteFilesystem
         }
     }
 
-    protected function promptAuthAndRetry($httpStatus, $reason = null, $warning = null, $headers = array())
+    protected function promptAuthAndRetry($httpStatus, $reason = null, $headers = array())
     {
-        if ($this->config && in_array($this->originUrl, $this->config->get('github-domains'), true)) {
-            $gitHubUtil = new GitHub($this->io, $this->config, null);
-            $message = "\n";
-
-            $rateLimited = $gitHubUtil->isRateLimited($headers);
-            if ($rateLimited) {
-                $rateLimit = $gitHubUtil->getRateLimit($headers);
-                if ($this->io->hasAuthentication($this->originUrl)) {
-                    $message = 'Review your configured GitHub OAuth token or enter a new one to go over the API rate limit.';
-                } else {
-                    $message = 'Create a GitHub OAuth token to go over the API rate limit.';
-                }
-
-                $message = sprintf(
-                    'GitHub API limit (%d calls/hr) is exhausted, could not fetch '.$this->fileUrl.'. '.$message.' You can also wait until %s for the rate limit to reset.',
-                    $rateLimit['limit'],
-                    $rateLimit['reset']
-                )."\n";
-            } else {
-                $message .= 'Could not fetch '.$this->fileUrl.', please ';
-                if ($this->io->hasAuthentication($this->originUrl)) {
-                    $message .= 'review your configured GitHub OAuth token or enter a new one to access private repos';
-                } else {
-                    $message .= 'create a GitHub OAuth token to access private repos';
-                }
-            }
-
-            if (!$gitHubUtil->authorizeOAuth($this->originUrl)
-                && (!$this->io->isInteractive() || !$gitHubUtil->authorizeOAuthInteractively($this->originUrl, $message))
-            ) {
-                throw new TransportException('Could not authenticate against '.$this->originUrl, 401);
-            }
-        } elseif ($this->config && in_array($this->originUrl, $this->config->get('gitlab-domains'), true)) {
-            $message = "\n".'Could not fetch '.$this->fileUrl.', enter your ' . $this->originUrl . ' credentials ' .($httpStatus === 401 ? 'to access private repos' : 'to go over the API rate limit');
-            $gitLabUtil = new GitLab($this->io, $this->config, null);
-
-            if ($this->io->hasAuthentication($this->originUrl) && ($auth = $this->io->getAuthentication($this->originUrl)) && in_array($auth['password'], array('gitlab-ci-token', 'private-token', 'oauth2'), true)) {
-                throw new TransportException("Invalid credentials for '" . $this->fileUrl . "', aborting.", $httpStatus);
-            }
-
-            if (!$gitLabUtil->authorizeOAuth($this->originUrl)
-                && (!$this->io->isInteractive() || !$gitLabUtil->authorizeOAuthInteractively($this->scheme, $this->originUrl, $message))
-            ) {
-                throw new TransportException('Could not authenticate against '.$this->originUrl, 401);
-            }
-        } elseif ($this->config && ($this->originUrl === 'bitbucket.org' || $this->originUrl === 'api.bitbucket.org')) {
-            $askForOAuthToken = true;
-            $this->originUrl = 'bitbucket.org';
-
-            if ($this->io->hasAuthentication($this->originUrl)) {
-                $auth = $this->io->getAuthentication($this->originUrl);
-                if ($auth['username'] !== 'x-token-auth') {
-                    $bitbucketUtil = new Bitbucket($this->io, $this->config);
-                    $accessToken = $bitbucketUtil->requestToken($this->originUrl, $auth['username'], $auth['password']);
-                    if (!empty($accessToken)) {
-                        $this->io->setAuthentication($this->originUrl, 'x-token-auth', $accessToken);
-                        $askForOAuthToken = false;
-                    }
-                } else {
-                    throw new TransportException('Could not authenticate against ' . $this->originUrl, 401);
-                }
-            }
-
-            if ($askForOAuthToken) {
-                $message = "\n".'Could not fetch ' . $this->fileUrl . ', please create a bitbucket OAuth token to ' . (($httpStatus === 401 || $httpStatus === 403) ? 'access private repos' : 'go over the API rate limit');
-                $bitBucketUtil = new Bitbucket($this->io, $this->config);
-                if (! $bitBucketUtil->authorizeOAuth($this->originUrl)
-                    && (! $this->io->isInteractive() || !$bitBucketUtil->authorizeOAuthInteractively($this->originUrl, $message))
-                ) {
-                    throw new TransportException('Could not authenticate against ' . $this->originUrl, 401);
-                }
-            }
-        } else {
-            // 404s are only handled for github
-            if ($httpStatus === 404) {
-                return;
-            }
+        $result = $this->authHelper->promptAuthIfNeeded($this->fileUrl, $this->originUrl, $httpStatus, $reason, $headers);
 
-            // fail if the console is not interactive
-            if (!$this->io->isInteractive()) {
-                if ($httpStatus === 401) {
-                    $message = "The '" . $this->fileUrl . "' URL required authentication.\nYou must be using the interactive console to authenticate";
-                }
-                if ($httpStatus === 403) {
-                    $message = "The '" . $this->fileUrl . "' URL could not be accessed: " . $reason;
-                }
+        $this->storeAuth = $result['storeAuth'];
+        $this->retry = $result['retry'];
 
-                throw new TransportException($message, $httpStatus);
-            }
-            // fail if we already have auth
-            if ($this->io->hasAuthentication($this->originUrl)) {
-                throw new TransportException("Invalid credentials for '" . $this->fileUrl . "', aborting.", $httpStatus);
-            }
-
-            $this->io->writeError('    Authentication required (<info>'.$this->originUrl.'</info>):');
-            $username = $this->io->ask('      Username: ');
-            $password = $this->io->askAndHideAnswer('      Password: ');
-            $this->io->setAuthentication($this->originUrl, $username, $password);
-            $this->storeAuth = $this->config->get('store-auths');
+        if ($this->retry) {
+            throw new TransportException('RETRY');
         }
-
-        $this->retry = true;
-        throw new TransportException('RETRY');
     }
 
     protected function getOptionsForUrl($originUrl, $additionalOptions)
@@ -816,40 +679,7 @@ class RemoteFilesystem
             $headers[] = 'Connection: close';
         }
 
-        if ($this->io->hasAuthentication($originUrl)) {
-            $authenticationDisplayMessage = null;
-            $auth = $this->io->getAuthentication($originUrl);
-            if ($auth['password'] === 'bearer') {
-                $headers[] = 'Authorization: Bearer '.$auth['username'];
-            } elseif ('github.com' === $originUrl && 'x-oauth-basic' === $auth['password']) {
-                $options['github-token'] = $auth['username'];
-                $authenticationDisplayMessage = 'Using GitHub token authentication';
-            } elseif ($this->config && in_array($originUrl, $this->config->get('gitlab-domains'), true)) {
-                if ($auth['password'] === 'oauth2') {
-                    $headers[] = 'Authorization: Bearer '.$auth['username'];
-                    $authenticationDisplayMessage = 'Using GitLab OAuth token authentication';
-                } elseif ($auth['password'] === 'private-token' || $auth['password'] === 'gitlab-ci-token') {
-                    $headers[] = 'PRIVATE-TOKEN: '.$auth['username'];
-                    $authenticationDisplayMessage = 'Using GitLab private token authentication';
-                }
-            } elseif ('bitbucket.org' === $originUrl
-                && $this->fileUrl !== Bitbucket::OAUTH2_ACCESS_TOKEN_URL && 'x-token-auth' === $auth['username']
-            ) {
-                if (!$this->isPublicBitBucketDownload($this->fileUrl)) {
-                    $headers[] = 'Authorization: Bearer ' . $auth['password'];
-                    $authenticationDisplayMessage = 'Using Bitbucket OAuth token authentication';
-                }
-            } else {
-                $authStr = base64_encode($auth['username'] . ':' . $auth['password']);
-                $headers[] = 'Authorization: Basic '.$authStr;
-                $authenticationDisplayMessage = 'Using HTTP basic authentication with username "' . $auth['username'] . '"';
-            }
-
-            if ($authenticationDisplayMessage && !in_array($originUrl, $this->displayedOriginAuthentications, true)) {
-                $this->io->writeError($authenticationDisplayMessage, true, IOInterface::DEBUG);
-                $this->displayedOriginAuthentications[] = $originUrl;
-            }
-        }
+        $headers = $this->authHelper->addAuthenticationHeader($headers, $originUrl, $this->fileUrl);
 
         $options['http']['follow_location'] = 0;
 
@@ -865,7 +695,7 @@ class RemoteFilesystem
 
     private function handleRedirect(array $http_response_header, array $additionalOptions, $result)
     {
-        if ($locationHeader = $this->findHeaderValue($http_response_header, 'location')) {
+        if ($locationHeader = Response::findHeaderValue($http_response_header, 'location')) {
             if (parse_url($locationHeader, PHP_URL_SCHEME)) {
                 // Absolute URL; e.g. https://example.com/composer
                 $targetUrl = $locationHeader;
@@ -889,7 +719,7 @@ class RemoteFilesystem
             $this->redirects++;
 
             $this->io->writeError('', true, IOInterface::DEBUG);
-            $this->io->writeError(sprintf('Following redirect (%u) %s', $this->redirects, $this->stripCredentialsFromUrl($targetUrl)), true, IOInterface::DEBUG);
+            $this->io->writeError(sprintf('Following redirect (%u) %s', $this->redirects, Url::sanitize($targetUrl)), true, IOInterface::DEBUG);
 
             $additionalOptions['redirects'] = $this->redirects;
 
@@ -899,7 +729,7 @@ class RemoteFilesystem
         if (!$this->retry) {
             $e = new TransportException('The "'.$this->fileUrl.'" file could not be downloaded, got redirect without Location ('.$http_response_header[0].')');
             $e->setHeaders($http_response_header);
-            $e->setResponse($result);
+            $e->setResponse($this->decodeResult($result, $http_response_header));
 
             throw $e;
         }
@@ -908,111 +738,6 @@ class RemoteFilesystem
     }
 
     /**
-     * @param array $options
-     *
-     * @return array
-     */
-    private function getTlsDefaults(array $options)
-    {
-        $ciphers = implode(':', array(
-            'ECDHE-RSA-AES128-GCM-SHA256',
-            'ECDHE-ECDSA-AES128-GCM-SHA256',
-            'ECDHE-RSA-AES256-GCM-SHA384',
-            'ECDHE-ECDSA-AES256-GCM-SHA384',
-            'DHE-RSA-AES128-GCM-SHA256',
-            'DHE-DSS-AES128-GCM-SHA256',
-            'kEDH+AESGCM',
-            'ECDHE-RSA-AES128-SHA256',
-            'ECDHE-ECDSA-AES128-SHA256',
-            'ECDHE-RSA-AES128-SHA',
-            'ECDHE-ECDSA-AES128-SHA',
-            'ECDHE-RSA-AES256-SHA384',
-            'ECDHE-ECDSA-AES256-SHA384',
-            'ECDHE-RSA-AES256-SHA',
-            'ECDHE-ECDSA-AES256-SHA',
-            'DHE-RSA-AES128-SHA256',
-            'DHE-RSA-AES128-SHA',
-            'DHE-DSS-AES128-SHA256',
-            'DHE-RSA-AES256-SHA256',
-            'DHE-DSS-AES256-SHA',
-            'DHE-RSA-AES256-SHA',
-            'AES128-GCM-SHA256',
-            'AES256-GCM-SHA384',
-            'AES128-SHA256',
-            'AES256-SHA256',
-            'AES128-SHA',
-            'AES256-SHA',
-            'AES',
-            'CAMELLIA',
-            'DES-CBC3-SHA',
-            '!aNULL',
-            '!eNULL',
-            '!EXPORT',
-            '!DES',
-            '!RC4',
-            '!MD5',
-            '!PSK',
-            '!aECDH',
-            '!EDH-DSS-DES-CBC3-SHA',
-            '!EDH-RSA-DES-CBC3-SHA',
-            '!KRB5-DES-CBC3-SHA',
-        ));
-
-        /**
-         * CN_match and SNI_server_name are only known once a URL is passed.
-         * They will be set in the getOptionsForUrl() method which receives a URL.
-         *
-         * cafile or capath can be overridden by passing in those options to constructor.
-         */
-        $defaults = array(
-            'ssl' => array(
-                'ciphers' => $ciphers,
-                'verify_peer' => true,
-                'verify_depth' => 7,
-                'SNI_enabled' => true,
-                'capture_peer_cert' => true,
-            ),
-        );
-
-        if (isset($options['ssl'])) {
-            $defaults['ssl'] = array_replace_recursive($defaults['ssl'], $options['ssl']);
-        }
-
-        $caBundleLogger = $this->io instanceof LoggerInterface ? $this->io : null;
-
-        /**
-         * Attempt to find a local cafile or throw an exception if none pre-set
-         * The user may go download one if this occurs.
-         */
-        if (!isset($defaults['ssl']['cafile']) && !isset($defaults['ssl']['capath'])) {
-            $result = CaBundle::getSystemCaRootBundlePath($caBundleLogger);
-
-            if (is_dir($result)) {
-                $defaults['ssl']['capath'] = $result;
-            } else {
-                $defaults['ssl']['cafile'] = $result;
-            }
-        }
-
-        if (isset($defaults['ssl']['cafile']) && (!is_readable($defaults['ssl']['cafile']) || !CaBundle::validateCaFile($defaults['ssl']['cafile'], $caBundleLogger))) {
-            throw new TransportException('The configured cafile was not valid or could not be read.');
-        }
-
-        if (isset($defaults['ssl']['capath']) && (!is_dir($defaults['ssl']['capath']) || !is_readable($defaults['ssl']['capath']))) {
-            throw new TransportException('The configured capath was not valid or could not be read.');
-        }
-
-        /**
-         * Disable TLS compression to prevent CRIME attacks where supported.
-         */
-        if (PHP_VERSION_ID >= 50413) {
-            $defaults['ssl']['disable_compression'] = true;
-        }
-
-        return $defaults;
-    }
-
-    /**
      * Fetch certificate common name and fingerprint for validation of SAN.
      *
      * @todo Remove when PHP 5.6 is minimum supported version.
@@ -1082,68 +807,27 @@ class RemoteFilesystem
         return parse_url($url, PHP_URL_HOST).':'.$port;
     }
 
-    /**
-     * @link https://github.com/composer/composer/issues/5584
-     *
-     * @param string $urlToBitBucketFile URL to a file at bitbucket.org.
-     *
-     * @return bool Whether the given URL is a public BitBucket download which requires no authentication.
-     */
-    private function isPublicBitBucketDownload($urlToBitBucketFile)
+    private function decodeResult($result, $http_response_header)
     {
-        $domain = parse_url($urlToBitBucketFile, PHP_URL_HOST);
-        if (strpos($domain, 'bitbucket.org') === false) {
-            // Bitbucket downloads are hosted on amazonaws.
-            // We do not need to authenticate there at all
-            return true;
-        }
-
-        $path = parse_url($urlToBitBucketFile, PHP_URL_PATH);
-
-        // Path for a public download follows this pattern /{user}/{repo}/downloads/{whatever}
-        // {@link https://blog.bitbucket.org/2009/04/12/new-feature-downloads/}
-        $pathParts = explode('/', $path);
-
-        return count($pathParts) >= 4 && $pathParts[3] == 'downloads';
-    }
+        // decode gzip
+        if ($result && extension_loaded('zlib')) {
+            $contentEncoding = Response::findHeaderValue($http_response_header, 'content-encoding');
+            $decode = $contentEncoding && 'gzip' === strtolower($contentEncoding);
 
-    public static function outputWarnings(IOInterface $io, $url, $data)
-    {
-        foreach (array('warning', 'info') as $type) {
-            if (empty($data[$type])) {
-                continue;
-            }
+            if ($decode) {
+                if (PHP_VERSION_ID >= 50400) {
+                    $result = zlib_decode($result);
+                } else {
+                    // work around issue with gzuncompress & co that do not work with all gzip checksums
+                    $result = file_get_contents('compress.zlib://data:application/octet-stream;base64,'.base64_encode($result));
+                }
 
-            if (!empty($data[$type . '-versions'])) {
-                $versionParser = new VersionParser();
-                $constraint = $versionParser->parseConstraints($data[$type . '-versions']);
-                $composer = new Constraint('==', $versionParser->normalize(Composer::getVersion()));
-                if (!$constraint->matches($composer)) {
-                    continue;
+                if ($result === false) {
+                    throw new TransportException('Failed to decode zlib stream');
                 }
             }
-
-            $io->writeError('<'.$type.'>'.ucfirst($type).' from '.$url.': '.$data[$type].'</'.$type.'>');
         }
-    }
 
-    public static function getOrigin($urlOrPath)
-    {
-        $hostPort = parse_url($urlOrPath, PHP_URL_HOST);
-        if (!$hostPort) {
-            return $urlOrPath;
-        }
-        if (parse_url($urlOrPath, PHP_URL_PORT)) {
-            $hostPort .= ':'.parse_url($urlOrPath, PHP_URL_PORT);
-        }
-
-        return $hostPort;
-    }
-
-    private function stripCredentialsFromUrl($url)
-    {
-        // GitHub repository rename result in redirect locations containing the access_token as GET parameter
-        // e.g. https://api.github.com/repositories/9999999999?access_token=github_token
-        return preg_replace('{([&?]access_token=)[^&]+}', '$1***', $url);
+        return $result;
     }
 }
diff -pruN 1.10.19-1/src/Composer/Util/SpdxLicense.php 2.0.9-1/src/Composer/Util/SpdxLicense.php
--- 1.10.19-1/src/Composer/Util/SpdxLicense.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/SpdxLicense.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,24 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Util;
-
-use Composer\Spdx\SpdxLicenses;
-
-trigger_error('The ' . __NAMESPACE__ . '\SpdxLicense class is deprecated, use Composer\Spdx\SpdxLicenses instead.', E_USER_DEPRECATED);
-
-/**
- * @deprecated use Composer\Spdx\SpdxLicenses instead
- */
-class SpdxLicense extends SpdxLicenses
-{
-}
diff -pruN 1.10.19-1/src/Composer/Util/StreamContextFactory.php 2.0.9-1/src/Composer/Util/StreamContextFactory.php
--- 1.10.19-1/src/Composer/Util/StreamContextFactory.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/StreamContextFactory.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,10 @@
 namespace Composer\Util;
 
 use Composer\Composer;
+use Composer\CaBundle\CaBundle;
+use Composer\Downloader\TransportException;
+use Composer\Util\Http\ProxyManager;
+use Psr\Log\LoggerInterface;
 
 /**
  * Allows the creation of a basic context supporting http proxy
@@ -25,7 +29,8 @@ final class StreamContextFactory
     /**
      * Creates a context supporting HTTP proxies
      *
-     * @param  string            $url            URL the context is to be used for
+     * @param string $url URL the context is to be used for
+     * @psalm-param array{http: array{follow_location?: int, max_redirects?: int, header?: string|array<string, string|int>}} $defaultOptions
      * @param  array             $defaultOptions Options to merge with the default
      * @param  array             $defaultParams  Parameters to specify on the context
      * @throws \RuntimeException if https proxy required and OpenSSL uninstalled
@@ -39,118 +44,189 @@ final class StreamContextFactory
             'max_redirects' => 20,
         ));
 
-        // Handle HTTP_PROXY/http_proxy on CLI only for security reasons
-        if ((PHP_SAPI === 'cli' || PHP_SAPI === 'phpdbg') && (!empty($_SERVER['HTTP_PROXY']) || !empty($_SERVER['http_proxy']))) {
-            $proxy = parse_url(!empty($_SERVER['http_proxy']) ? $_SERVER['http_proxy'] : $_SERVER['HTTP_PROXY']);
-        }
-
-        // Prefer CGI_HTTP_PROXY if available
-        if (!empty($_SERVER['CGI_HTTP_PROXY'])) {
-            $proxy = parse_url($_SERVER['CGI_HTTP_PROXY']);
-        }
-
-        // Override with HTTPS proxy if present and URL is https
-        if (preg_match('{^https://}i', $url) && (!empty($_SERVER['HTTPS_PROXY']) || !empty($_SERVER['https_proxy']))) {
-            $proxy = parse_url(!empty($_SERVER['https_proxy']) ? $_SERVER['https_proxy'] : $_SERVER['HTTPS_PROXY']);
-        }
+        $options = array_replace_recursive($options, self::initOptions($url, $defaultOptions));
+        unset($defaultOptions['http']['header']);
+        $options = array_replace_recursive($options, $defaultOptions);
 
-        // Remove proxy if URL matches no_proxy directive
-        if (!empty($_SERVER['NO_PROXY']) || !empty($_SERVER['no_proxy']) && parse_url($url, PHP_URL_HOST)) {
-            $pattern = new NoProxyPattern(!empty($_SERVER['no_proxy']) ? $_SERVER['no_proxy'] : $_SERVER['NO_PROXY']);
-            if ($pattern->test($url)) {
-                unset($proxy);
-            }
+        if (isset($options['http']['header'])) {
+            $options['http']['header'] = self::fixHttpHeaderField($options['http']['header']);
         }
 
-        if (!empty($proxy)) {
-            $proxyURL = isset($proxy['scheme']) ? $proxy['scheme'] . '://' : '';
-            $proxyURL .= isset($proxy['host']) ? $proxy['host'] : '';
-
-            if (isset($proxy['port'])) {
-                $proxyURL .= ":" . $proxy['port'];
-            } elseif ('http://' == substr($proxyURL, 0, 7)) {
-                $proxyURL .= ":80";
-            } elseif ('https://' == substr($proxyURL, 0, 8)) {
-                $proxyURL .= ":443";
-            }
-
-            // http(s):// is not supported in proxy
-            $proxyURL = str_replace(array('http://', 'https://'), array('tcp://', 'ssl://'), $proxyURL);
-
-            if (0 === strpos($proxyURL, 'ssl:') && !extension_loaded('openssl')) {
-                throw new \RuntimeException('You must enable the openssl extension to use a proxy over https');
-            }
-
-            $options['http']['proxy'] = $proxyURL;
+        return stream_context_create($options, $defaultParams);
+    }
 
-            // enabled request_fulluri unless it is explicitly disabled
-            switch (parse_url($url, PHP_URL_SCHEME)) {
-                case 'http': // default request_fulluri to true
-                    $reqFullUriEnv = getenv('HTTP_PROXY_REQUEST_FULLURI');
-                    if ($reqFullUriEnv === false || $reqFullUriEnv === '' || (strtolower($reqFullUriEnv) !== 'false' && (bool) $reqFullUriEnv)) {
-                        $options['http']['request_fulluri'] = true;
+    /**
+     * @param string $url
+     * @param array  $options
+     * @param bool   $forCurl When true, will not add proxy values as these are handled separately
+     * @psalm-return array{http:{header: string[], proxy?: string, request_fulluri: bool}, ssl: array}
+     * @return array formatted as a stream context array
+     */
+    public static function initOptions($url, array $options, $forCurl = false)
+    {
+        // Make sure the headers are in an array form
+        if (!isset($options['http']['header'])) {
+            $options['http']['header'] = array();
+        }
+        if (is_string($options['http']['header'])) {
+            $options['http']['header'] = explode("\r\n", $options['http']['header']);
+        }
+
+        // Add stream proxy options if there is a proxy
+        if (!$forCurl) {
+            $proxy = ProxyManager::getInstance()->getProxyForRequest($url);
+            if ($proxyOptions = $proxy->getContextOptions()) {
+                $isHttpsRequest = 0 === strpos($url, 'https://');
+
+                if ($proxy->isSecure()) {
+                    if (!extension_loaded('openssl')) {
+                        throw new TransportException('You must enable the openssl extension to use a secure proxy.');
                     }
-                    break;
-                case 'https': // default request_fulluri to true
-                    $reqFullUriEnv = getenv('HTTPS_PROXY_REQUEST_FULLURI');
-                    if ($reqFullUriEnv === false || $reqFullUriEnv === '' || (strtolower($reqFullUriEnv) !== 'false' && (bool) $reqFullUriEnv)) {
-                        $options['http']['request_fulluri'] = true;
+                    if ($isHttpsRequest) {
+                        throw new TransportException('You must enable the curl extension to make https requests through a secure proxy.');
                     }
-                    break;
-            }
-
-            // add SNI opts for https URLs
-            if ('https' === parse_url($url, PHP_URL_SCHEME)) {
-                $options['ssl']['SNI_enabled'] = true;
-                if (PHP_VERSION_ID < 50600) {
-                    $options['ssl']['SNI_server_name'] = parse_url($url, PHP_URL_HOST);
-                }
-            }
-
-            // handle proxy auth if present
-            if (isset($proxy['user'])) {
-                $auth = rawurldecode($proxy['user']);
-                if (isset($proxy['pass'])) {
-                    $auth .= ':' . rawurldecode($proxy['pass']);
+                } elseif ($isHttpsRequest && !extension_loaded('openssl')) {
+                    throw new TransportException('You must enable the openssl extension to make https requests through a proxy.');
                 }
-                $auth = base64_encode($auth);
 
-                // Preserve headers if already set in default options
-                if (isset($defaultOptions['http']['header'])) {
-                    if (is_string($defaultOptions['http']['header'])) {
-                        $defaultOptions['http']['header'] = array($defaultOptions['http']['header']);
-                    }
-                    $defaultOptions['http']['header'][] = "Proxy-Authorization: Basic {$auth}";
-                } else {
-                    $options['http']['header'] = array("Proxy-Authorization: Basic {$auth}");
+                // Header will be a Proxy-Authorization string or not set
+                if (isset($proxyOptions['http']['header'])) {
+                    $options['http']['header'][] = $proxyOptions['http']['header'];
+                    unset($proxyOptions['http']['header']);
                 }
+                $options = array_replace_recursive($options, $proxyOptions);
             }
         }
 
-        $options = array_replace_recursive($options, $defaultOptions);
-
-        if (isset($options['http']['header'])) {
-            $options['http']['header'] = self::fixHttpHeaderField($options['http']['header']);
-        }
-
         if (defined('HHVM_VERSION')) {
             $phpVersion = 'HHVM ' . HHVM_VERSION;
         } else {
             $phpVersion = 'PHP ' . PHP_MAJOR_VERSION . '.' . PHP_MINOR_VERSION . '.' . PHP_RELEASE_VERSION;
         }
 
+        if ($forCurl) {
+            $curl = curl_version();
+            $httpVersion = 'cURL '.$curl['version'];
+        } else {
+            $httpVersion = 'streams';
+        }
+
         if (!isset($options['http']['header']) || false === stripos(implode('', $options['http']['header']), 'user-agent')) {
             $options['http']['header'][] = sprintf(
-                'User-Agent: Composer/%s (%s; %s; %s%s)',
+                'User-Agent: Composer/%s (%s; %s; %s; %s%s)',
                 Composer::getVersion(),
                 function_exists('php_uname') ? php_uname('s') : 'Unknown',
                 function_exists('php_uname') ? php_uname('r') : 'Unknown',
                 $phpVersion,
+                $httpVersion,
                 getenv('CI') ? '; CI' : ''
             );
         }
 
-        return stream_context_create($options, $defaultParams);
+        return $options;
+    }
+
+    /**
+     * @param array $options
+     *
+     * @return array
+     */
+    public static function getTlsDefaults(array $options, LoggerInterface $logger = null)
+    {
+        $ciphers = implode(':', array(
+            'ECDHE-RSA-AES128-GCM-SHA256',
+            'ECDHE-ECDSA-AES128-GCM-SHA256',
+            'ECDHE-RSA-AES256-GCM-SHA384',
+            'ECDHE-ECDSA-AES256-GCM-SHA384',
+            'DHE-RSA-AES128-GCM-SHA256',
+            'DHE-DSS-AES128-GCM-SHA256',
+            'kEDH+AESGCM',
+            'ECDHE-RSA-AES128-SHA256',
+            'ECDHE-ECDSA-AES128-SHA256',
+            'ECDHE-RSA-AES128-SHA',
+            'ECDHE-ECDSA-AES128-SHA',
+            'ECDHE-RSA-AES256-SHA384',
+            'ECDHE-ECDSA-AES256-SHA384',
+            'ECDHE-RSA-AES256-SHA',
+            'ECDHE-ECDSA-AES256-SHA',
+            'DHE-RSA-AES128-SHA256',
+            'DHE-RSA-AES128-SHA',
+            'DHE-DSS-AES128-SHA256',
+            'DHE-RSA-AES256-SHA256',
+            'DHE-DSS-AES256-SHA',
+            'DHE-RSA-AES256-SHA',
+            'AES128-GCM-SHA256',
+            'AES256-GCM-SHA384',
+            'AES128-SHA256',
+            'AES256-SHA256',
+            'AES128-SHA',
+            'AES256-SHA',
+            'AES',
+            'CAMELLIA',
+            'DES-CBC3-SHA',
+            '!aNULL',
+            '!eNULL',
+            '!EXPORT',
+            '!DES',
+            '!RC4',
+            '!MD5',
+            '!PSK',
+            '!aECDH',
+            '!EDH-DSS-DES-CBC3-SHA',
+            '!EDH-RSA-DES-CBC3-SHA',
+            '!KRB5-DES-CBC3-SHA',
+        ));
+
+        /**
+         * CN_match and SNI_server_name are only known once a URL is passed.
+         * They will be set in the getOptionsForUrl() method which receives a URL.
+         *
+         * cafile or capath can be overridden by passing in those options to constructor.
+         */
+        $defaults = array(
+            'ssl' => array(
+                'ciphers' => $ciphers,
+                'verify_peer' => true,
+                'verify_depth' => 7,
+                'SNI_enabled' => true,
+                'capture_peer_cert' => true,
+            ),
+        );
+
+        if (isset($options['ssl'])) {
+            $defaults['ssl'] = array_replace_recursive($defaults['ssl'], $options['ssl']);
+        }
+
+        /**
+         * Attempt to find a local cafile or throw an exception if none pre-set
+         * The user may go download one if this occurs.
+         */
+        if (!isset($defaults['ssl']['cafile']) && !isset($defaults['ssl']['capath'])) {
+            $result = CaBundle::getSystemCaRootBundlePath($logger);
+
+            if (is_dir($result)) {
+                $defaults['ssl']['capath'] = $result;
+            } else {
+                $defaults['ssl']['cafile'] = $result;
+            }
+        }
+
+        if (isset($defaults['ssl']['cafile']) && (!is_readable($defaults['ssl']['cafile']) || !CaBundle::validateCaFile($defaults['ssl']['cafile'], $logger))) {
+            throw new TransportException('The configured cafile was not valid or could not be read.');
+        }
+
+        if (isset($defaults['ssl']['capath']) && (!is_dir($defaults['ssl']['capath']) || !is_readable($defaults['ssl']['capath']))) {
+            throw new TransportException('The configured capath was not valid or could not be read.');
+        }
+
+        /**
+         * Disable TLS compression to prevent CRIME attacks where supported.
+         */
+        if (PHP_VERSION_ID >= 50413) {
+            $defaults['ssl']['disable_compression'] = true;
+        }
+
+        return $defaults;
     }
 
     /**
@@ -160,7 +236,7 @@ final class StreamContextFactory
      * This method fixes the array by moving the content-type header to the end
      *
      * @link https://bugs.php.net/bug.php?id=61548
-     * @param string|array $header
+     * @param  string|array $header
      * @return array
      */
     private static function fixHttpHeaderField($header)
diff -pruN 1.10.19-1/src/Composer/Util/Svn.php 2.0.9-1/src/Composer/Util/Svn.php
--- 1.10.19-1/src/Composer/Util/Svn.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Svn.php	2021-01-27 15:09:27.000000000 +0000
@@ -139,7 +139,7 @@ class Svn
             if ($type !== 'out') {
                 return;
             }
-            if ('Redirecting to URL ' === substr($buffer, 0, 19)) {
+            if (strpos($buffer, 'Redirecting to URL ') === 0) {
                 return;
             }
             $output .= $buffer;
@@ -207,7 +207,7 @@ class Svn
         $this->credentials['username'] = $this->io->ask("Username: ");
         $this->credentials['password'] = $this->io->askAndHideAnswer("Password: ");
 
-        $this->cacheCredentials = $this->io->askConfirmation("Should Subversion cache these credentials? (yes/no) ", true);
+        $this->cacheCredentials = $this->io->askConfirmation("Should Subversion cache these credentials? (yes/no) ");
 
         return $this;
     }
@@ -304,7 +304,7 @@ class Svn
             $this->createAuthFromUrl();
         }
 
-        return $this->hasAuth;
+        return (bool) $this->hasAuth;
     }
 
     /**
diff -pruN 1.10.19-1/src/Composer/Util/SyncHelper.php 2.0.9-1/src/Composer/Util/SyncHelper.php
--- 1.10.19-1/src/Composer/Util/SyncHelper.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/SyncHelper.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,66 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Util;
+
+use Composer\Downloader\DownloaderInterface;
+use Composer\Package\PackageInterface;
+use React\Promise\PromiseInterface;
+
+class SyncHelper
+{
+    /**
+     * Helps you download + install a single package in a synchronous way
+     *
+     * This executes all the required steps and waits for promises to complete
+     *
+     * @param Loop                  $loop        Loop instance which you can get from $composer->getLoop()
+     * @param DownloaderInterface   $downloader  Downloader instance you can get from $composer->getDownloadManager()->getDownloader('zip') for example
+     * @param string                $path        the installation path for the package
+     * @param PackageInterface      $package     the package to install
+     * @param PackageInterface|null $prevPackage the previous package if this is an update and not an initial installation
+     */
+    public static function downloadAndInstallPackageSync(Loop $loop, DownloaderInterface $downloader, $path, PackageInterface $package, PackageInterface $prevPackage = null)
+    {
+        $type = $prevPackage ? 'update' : 'install';
+
+        try {
+            self::await($loop, $downloader->download($package, $path, $prevPackage));
+
+            self::await($loop, $downloader->prepare($type, $package, $path, $prevPackage));
+
+            if ($type === 'update') {
+                self::await($loop, $downloader->update($package, $path, $prevPackage));
+            } else {
+                self::await($loop, $downloader->install($package, $path, $prevPackage));
+            }
+        } catch (\Exception $e) {
+            self::await($loop, $downloader->cleanup($type, $package, $path, $prevPackage));
+            throw $e;
+        }
+
+        self::await($loop, $downloader->cleanup($type, $package, $path, $prevPackage));
+    }
+
+    /**
+     * Waits for a promise to resolve
+     *
+     * @param Loop                  $loop    Loop instance which you can get from $composer->getLoop()
+     * @param PromiseInterface|null $promise
+     */
+    public static function await(Loop $loop, PromiseInterface $promise = null)
+    {
+        if ($promise) {
+            $loop->wait(array($promise));
+        }
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Util/Tar.php 2.0.9-1/src/Composer/Util/Tar.php
--- 1.10.19-1/src/Composer/Util/Tar.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Tar.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,68 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Util;
+
+/**
+ * @author Wissem Riahi <wissemr@gmail.com>
+ */
+class Tar
+{
+    /**
+     * @param string $pathToArchive
+     *
+     * @return string|null
+     */
+    public static function getComposerJson($pathToArchive)
+    {
+        $phar = new \PharData($pathToArchive);
+
+        if (!$phar->valid()) {
+            return null;
+        }
+
+        return self::extractComposerJsonFromFolder($phar);
+    }
+
+    /**
+     * @param \PharData $phar
+     *
+     * @throws \RuntimeException
+     *
+     * @return string
+     */
+    private static function extractComposerJsonFromFolder(\PharData $phar)
+    {
+        if (isset($phar['composer.json'])) {
+            return $phar['composer.json']->getContent();
+        }
+
+        $topLevelPaths = array();
+        foreach ($phar as $folderFile) {
+            $name = $folderFile->getBasename();
+
+            if ($folderFile->isDir()) {
+                $topLevelPaths[$name] = true;
+                if (\count($topLevelPaths) > 1) {
+                    throw new \RuntimeException('Archive has more than one top level directories, and no composer.json was found on the top level, so it\'s an invalid archive. Top level paths found were: '.implode(',', array_keys($topLevelPaths)));
+                }
+            }
+        }
+
+        $composerJsonPath = key($topLevelPaths).'/composer.json';
+        if ($topLevelPaths && isset($phar[$composerJsonPath])) {
+            return $phar[$composerJsonPath]->getContent();
+        }
+
+        throw new \RuntimeException('No composer.json found either at the top level or within the topmost directory');
+    }
+}
diff -pruN 1.10.19-1/src/Composer/Util/TlsHelper.php 2.0.9-1/src/Composer/Util/TlsHelper.php
--- 1.10.19-1/src/Composer/Util/TlsHelper.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/TlsHelper.php	2021-01-27 15:09:27.000000000 +0000
@@ -98,7 +98,7 @@ final class TlsHelper
      * By Kevin McArthur of StormTide Digital Studios Inc.
      * @KevinSMcArthur / https://github.com/StormTide
      *
-     * See http://tools.ietf.org/html/draft-ietf-websec-key-pinning-02
+     * See https://tools.ietf.org/html/draft-ietf-websec-key-pinning-02
      *
      * This method was adapted from Sslurp.
      * https://github.com/EvanDotPro/Sslurp
diff -pruN 1.10.19-1/src/Composer/Util/Url.php 2.0.9-1/src/Composer/Util/Url.php
--- 1.10.19-1/src/Composer/Util/Url.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Url.php	2021-01-27 15:09:27.000000000 +0000
@@ -19,6 +19,12 @@ use Composer\Config;
  */
 class Url
 {
+    /**
+     * @param  Config $config
+     * @param  string $url
+     * @param  string $ref
+     * @return string the updated URL
+     */
     public static function updateDistReference(Config $config, $url, $ref)
     {
         $host = parse_url($url, PHP_URL_HOST);
@@ -52,4 +58,65 @@ class Url
 
         return $url;
     }
+
+    /**
+     * @param  string $url
+     * @return string
+     */
+    public static function getOrigin(Config $config, $url)
+    {
+        if (0 === strpos($url, 'file://')) {
+            return $url;
+        }
+
+        $origin = (string) parse_url($url, PHP_URL_HOST);
+        if ($port = parse_url($url, PHP_URL_PORT)) {
+            $origin .= ':'.$port;
+        }
+
+        if (strpos($origin, '.github.com') === (strlen($origin) - 11)) {
+            return 'github.com';
+        }
+
+        if ($origin === 'repo.packagist.org') {
+            return 'packagist.org';
+        }
+
+        if ($origin === '') {
+            $origin = $url;
+        }
+
+        // Gitlab can be installed in a non-root context (i.e. gitlab.com/foo). When downloading archives the originUrl
+        // is the host without the path, so we look for the registered gitlab-domains matching the host here
+        if (
+            is_array($config->get('gitlab-domains'))
+            && false === strpos($origin, '/')
+            && !in_array($origin, $config->get('gitlab-domains'))
+        ) {
+            foreach ($config->get('gitlab-domains') as $gitlabDomain) {
+                if (0 === strpos($gitlabDomain, $origin)) {
+                    return $gitlabDomain;
+                }
+            }
+        }
+
+        return $origin;
+    }
+
+    public static function sanitize($url)
+    {
+        // GitHub repository rename result in redirect locations containing the access_token as GET parameter
+        // e.g. https://api.github.com/repositories/9999999999?access_token=github_token
+        $url = preg_replace('{([&?]access_token=)[^&]+}', '$1***', $url);
+
+        $url = preg_replace_callback('{(?P<prefix>://|^)(?P<user>[^:/\s@]+):(?P<password>[^@\s/]+)@}i', function ($m) {
+            if (preg_match('{^[a-f0-9]{12,}$}', $m['user'])) {
+                return $m['prefix'].'***:***@';
+            }
+
+            return $m['prefix'].$m['user'].':***@';
+        }, $url);
+
+        return $url;
+    }
 }
diff -pruN 1.10.19-1/src/Composer/Util/Zip.php 2.0.9-1/src/Composer/Util/Zip.php
--- 1.10.19-1/src/Composer/Util/Zip.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/Util/Zip.php	2021-01-27 15:09:27.000000000 +0000
@@ -64,44 +64,51 @@ class Zip
     /**
      * Find a file by name, returning the one that has the shortest path.
      *
-     * @param \ZipArchive $zip
-     * @param string      $filename
+     * @param  \ZipArchive       $zip
+     * @param  string            $filename
+     * @throws \RuntimeException
      *
-     * @return bool|int
+     * @return int
      */
     private static function locateFile(\ZipArchive $zip, $filename)
     {
-        $indexOfShortestMatch = false;
-        $lengthOfShortestMatch = -1;
+        // return root composer.json if it is there and is a file
+        if (false !== ($index = $zip->locateName($filename)) && $zip->getFromIndex($index) !== false) {
+            return $index;
+        }
 
+        $topLevelPaths = array();
         for ($i = 0; $i < $zip->numFiles; $i++) {
-            $stat = $zip->statIndex($i);
-            if (strcmp(basename($stat['name']), $filename) === 0) {
-                $directoryName = dirname($stat['name']);
-                if ($directoryName === '.') {
-                    //if composer.json is in root directory
-                    //it has to be the one to use.
-                    return $i;
-                }
+            $name = $zip->getNameIndex($i);
+            $dirname = dirname($name);
+
+            // ignore OSX specific resource fork folder
+            if (strpos($name, '__MACOSX') !== false) {
+                continue;
+            }
 
-                if (strpos($directoryName, '\\') !== false ||
-                    strpos($directoryName, '/') !== false) {
-                    //composer.json files below first directory are rejected
-                    continue;
+            // handle archives with proper TOC
+            if ($dirname === '.') {
+                $topLevelPaths[$name] = true;
+                if (\count($topLevelPaths) > 1) {
+                    throw new \RuntimeException('Archive has more than one top level directories, and no composer.json was found on the top level, so it\'s an invalid archive. Top level paths found were: '.implode(',', array_keys($topLevelPaths)));
                 }
+                continue;
+            }
 
-                $length = strlen($stat['name']);
-                if ($indexOfShortestMatch === false || $length < $lengthOfShortestMatch) {
-                    //Check it's not a directory.
-                    $contents = $zip->getFromIndex($i);
-                    if ($contents !== false) {
-                        $indexOfShortestMatch = $i;
-                        $lengthOfShortestMatch = $length;
-                    }
+            // handle archives which do not have a TOC record for the directory itself
+            if (false === strpos($dirname, '\\') && false === strpos($dirname, '/')) {
+                $topLevelPaths[$dirname.'/'] = true;
+                if (\count($topLevelPaths) > 1) {
+                    throw new \RuntimeException('Archive has more than one top level directories, and no composer.json was found on the top level, so it\'s an invalid archive. Top level paths found were: '.implode(',', array_keys($topLevelPaths)));
                 }
             }
         }
 
-        return $indexOfShortestMatch;
+        if ($topLevelPaths && false !== ($index = $zip->locateName(key($topLevelPaths).$filename)) && $zip->getFromIndex($index) !== false) {
+            return $index;
+        }
+
+        throw new \RuntimeException('No composer.json found either at the top level or within the topmost directory');
     }
 }
diff -pruN 1.10.19-1/src/Composer/XdebugHandler.php 2.0.9-1/src/Composer/XdebugHandler.php
--- 1.10.19-1/src/Composer/XdebugHandler.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/src/Composer/XdebugHandler.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,31 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer;
-
-use Symfony\Component\Console\Output\OutputInterface;
-
-trigger_error('The ' . __NAMESPACE__ . '\XdebugHandler class is deprecated, use Composer\XdebugHandler\XdebugHandler instead,', E_USER_DEPRECATED);
-
-/**
- * @deprecated use Composer\XdebugHandler\XdebugHandler instead
- */
-class XdebugHandler extends XdebugHandler\XdebugHandler
-{
-    const ENV_ALLOW = 'COMPOSER_ALLOW_XDEBUG';
-    const ENV_VERSION = 'COMPOSER_XDEBUG_VERSION';
-
-    public function __construct(OutputInterface $output)
-    {
-        parent::__construct('composer', '--ansi');
-    }
-}
diff -pruN 1.10.19-1/tests/complete.phpunit.xml 2.0.9-1/tests/complete.phpunit.xml
--- 1.10.19-1/tests/complete.phpunit.xml	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/complete.phpunit.xml	2021-01-27 15:09:27.000000000 +0000
@@ -1,16 +1,22 @@
 <?xml version="1.0" encoding="UTF-8"?>
 
-<phpunit backupGlobals="false"
+<phpunit xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+         xsi:noNamespaceSchemaLocation="https://schema.phpunit.de/5.7/phpunit.xsd"
+         backupGlobals="false"
          backupStaticAttributes="false"
+         beStrictAboutTestsThatDoNotTestAnything="true"
          colors="true"
          convertErrorsToExceptions="true"
          convertNoticesToExceptions="true"
          convertWarningsToExceptions="true"
+         failOnRisky="true"
          processIsolation="false"
          stopOnFailure="false"
-         syntaxCheck="false"
          bootstrap="./bootstrap.php"
 >
+    <php>
+        <env name="SYMFONY_DEPRECATIONS_HELPER" value="weak"/>
+    </php>
     <testsuites>
         <testsuite name="Full Composer Test Suite">
             <directory>./Composer/</directory>
diff -pruN 1.10.19-1/tests/Composer/Test/AllFunctionalTest.php 2.0.9-1/tests/Composer/Test/AllFunctionalTest.php
--- 1.10.19-1/tests/Composer/Test/AllFunctionalTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/AllFunctionalTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,7 +12,6 @@
 
 namespace Composer\Test;
 
-use Composer\Test\TestCase;
 use Composer\Util\Filesystem;
 use Symfony\Component\Finder\Finder;
 use Symfony\Component\Process\Process;
@@ -100,7 +99,7 @@ class AllFunctionalTest extends TestCase
      * @dataProvider getTestFiles
      * @depends testBuildPhar
      */
-    public function testIntegration(\SplFileInfo $testFile)
+    public function testIntegration($testFile)
     {
         $testData = $this->parseTestFile($testFile);
 
@@ -133,15 +132,15 @@ class AllFunctionalTest extends TestCase
     {
         $tests = array();
         foreach (Finder::create()->in(__DIR__.'/Fixtures/functional')->name('*.test')->files() as $file) {
-            $tests[] = array($file);
+            $tests[] = array($file->getRealPath());
         }
 
         return $tests;
     }
 
-    private function parseTestFile(\SplFileInfo $file)
+    private function parseTestFile($file)
     {
-        $tokens = preg_split('#(?:^|\n*)--([A-Z-]+)--\n#', file_get_contents($file->getRealPath()), null, PREG_SPLIT_DELIM_CAPTURE);
+        $tokens = preg_split('#(?:^|\n*)--([A-Z-]+)--\n#', file_get_contents($file), null, PREG_SPLIT_DELIM_CAPTURE);
         $data = array();
         $section = null;
 
@@ -196,8 +195,8 @@ class AllFunctionalTest extends TestCase
                     throw new \RuntimeException(sprintf(
                         'Unknown section "%s". Allowed sections: "RUN", "EXPECT", "EXPECT-ERROR", "EXPECT-EXIT-CODE", "EXPECT-REGEX", "EXPECT-ERROR-REGEX". '
                        .'Section headers must be written as "--HEADER_NAME--".',
-                       $section
-                   ));
+                        $section
+                    ));
             }
 
             $data[$section] = $sectionData;
diff -pruN 1.10.19-1/tests/Composer/Test/ApplicationTest.php 2.0.9-1/tests/Composer/Test/ApplicationTest.php
--- 1.10.19-1/tests/Composer/Test/ApplicationTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/ApplicationTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,7 +13,6 @@
 namespace Composer\Test;
 
 use Composer\Console\Application;
-use Composer\Test\TestCase;
 use Symfony\Component\Console\Output\OutputInterface;
 
 class ApplicationTest extends TestCase
@@ -62,7 +61,7 @@ class ApplicationTest extends TestCase
 
             $outputMock->expects($this->at($index++))
                 ->method("write")
-                ->with($this->equalTo('<warning>You are running composer with Xdebug enabled. This has a major impact on runtime performance. See https://getcomposer.org/xdebug</warning>'));
+                ->with($this->equalTo('<warning>Composer is operating slower than normal because you have Xdebug enabled. See https://getcomposer.org/xdebug</warning>'));
         }
 
         $outputMock->expects($this->at($index++))
@@ -71,7 +70,7 @@ class ApplicationTest extends TestCase
 
         $outputMock->expects($this->at($index++))
             ->method("write")
-            ->with($this->equalTo(sprintf('<warning>Warning: This development build of composer is over 60 days old. It is recommended to update it by running "%s self-update" to get the latest version.</warning>', $_SERVER['PHP_SELF'])));
+            ->with($this->equalTo(sprintf('<warning>Warning: This development build of Composer is over 60 days old. It is recommended to update it by running "%s self-update" to get the latest version.</warning>', $_SERVER['PHP_SELF'])));
 
         if (!defined('COMPOSER_DEV_WARNING_TIME')) {
             define('COMPOSER_DEV_WARNING_TIME', time() - 1);
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/AutoloadGeneratorTest.php 2.0.9-1/tests/Composer/Test/Autoload/AutoloadGeneratorTest.php
--- 1.10.19-1/tests/Composer/Test/Autoload/AutoloadGeneratorTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/AutoloadGeneratorTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,10 +14,13 @@ namespace Composer\Test\Autoload;
 
 use Composer\Autoload\AutoloadGenerator;
 use Composer\Package\Link;
+use Composer\Package\Version\VersionParser;
 use Composer\Semver\Constraint\Constraint;
+use Composer\Semver\Constraint\MatchAllConstraint;
 use Composer\Util\Filesystem;
 use Composer\Package\AliasPackage;
 use Composer\Package\Package;
+use Composer\Package\RootPackage;
 use Composer\Test\TestCase;
 use Composer\Script\ScriptEvents;
 use Composer\Repository\InstalledRepositoryInterface;
@@ -100,6 +103,9 @@ class AutoloadGeneratorTest extends Test
             'vendor-dir' => function () use ($that) {
                 return $that->vendorDir;
             },
+            'platform-check' => function () {
+                return true;
+            },
         );
 
         $this->config->expects($this->atLeastOnce())
@@ -130,6 +136,9 @@ class AutoloadGeneratorTest extends Test
                 return $that->vendorDir.'/'.$package->getName() . ($targetDir ? '/'.$targetDir : '');
             }));
         $this->repository = $this->getMockBuilder('Composer\Repository\InstalledRepositoryInterface')->getMock();
+        $this->repository->expects($this->any())
+            ->method('getDevPackageNames')
+            ->willReturn(array());
 
         $this->eventDispatcher = $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')
             ->disableOriginalConstructor()
@@ -151,9 +160,9 @@ class AutoloadGeneratorTest extends Test
         }
     }
 
-    public function testMainPackageAutoloading()
+    public function testRootPackageAutoloading()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array(
             'psr-0' => array(
                 'Main' => 'src/',
@@ -196,9 +205,9 @@ class AutoloadGeneratorTest extends Test
         $this->assertAutoloadFiles('classmap', $this->vendorDir.'/composer', 'classmap');
     }
 
-    public function testMainPackageDevAutoloading()
+    public function testRootPackageDevAutoloading()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array(
             'psr-0' => array(
                 'Main' => 'src/',
@@ -234,9 +243,9 @@ class AutoloadGeneratorTest extends Test
         $this->assertAutoloadFiles('files2', $this->vendorDir.'/composer', 'files');
     }
 
-    public function testMainPackageDevAutoloadingDisabledByDefault()
+    public function testRootPackageDevAutoloadingDisabledByDefault()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array(
             'psr-0' => array(
                 'Main' => 'src/',
@@ -271,7 +280,7 @@ class AutoloadGeneratorTest extends Test
     {
         $this->vendorDir = $this->workingDir;
 
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array(
             'psr-0' => array('Main' => 'src/', 'Lala' => 'src/'),
             'psr-4' => array(
@@ -298,9 +307,9 @@ class AutoloadGeneratorTest extends Test
         $this->assertAutoloadFiles('classmap3', $this->vendorDir.'/composer', 'classmap');
     }
 
-    public function testMainPackageAutoloadingAlternativeVendorDir()
+    public function testRootPackageAutoloadingAlternativeVendorDir()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array(
             'psr-0' => array('Main' => 'src/', 'Lala' => 'src/'),
             'psr-4' => array(
@@ -327,9 +336,9 @@ class AutoloadGeneratorTest extends Test
         $this->assertAutoloadFiles('classmap2', $this->vendorDir.'/composer', 'classmap');
     }
 
-    public function testMainPackageAutoloadingWithTargetDir()
+    public function testRootPackageAutoloadingWithTargetDir()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array(
             'psr-0' => array('Main\\Foo' => '', 'Main\\Bar' => ''),
             'classmap' => array('Main/Foo/src', 'lib'),
@@ -360,10 +369,10 @@ class AutoloadGeneratorTest extends Test
 
     public function testVendorsAutoloading()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setRequires(array(
-            new Link('a', 'a/a'),
-            new Link('a', 'b/b'),
+            new Link('a', 'a/a', new MatchAllConstraint()),
+            new Link('a', 'b/b', new MatchAllConstraint()),
         ));
 
         $packages = array();
@@ -389,9 +398,9 @@ class AutoloadGeneratorTest extends Test
 
     public function testNonDevAutoloadExclusionWithRecursion()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setRequires(array(
-            new Link('a', 'a/a'),
+            new Link('a', 'a/a', new MatchAllConstraint()),
         ));
 
         $packages = array();
@@ -399,11 +408,11 @@ class AutoloadGeneratorTest extends Test
         $packages[] = $b = new Package('b/b', '1.0', '1.0');
         $a->setAutoload(array('psr-0' => array('A' => 'src/', 'A\\B' => 'lib/')));
         $a->setRequires(array(
-            new Link('a/a', 'b/b'),
+            new Link('a/a', 'b/b', new MatchAllConstraint()),
         ));
         $b->setAutoload(array('psr-0' => array('B\\Sub\\Name' => 'src/')));
         $b->setRequires(array(
-            new Link('b/b', 'a/a'),
+            new Link('b/b', 'a/a', new MatchAllConstraint()),
         ));
 
         $this->repository->expects($this->once())
@@ -422,18 +431,18 @@ class AutoloadGeneratorTest extends Test
 
     public function testNonDevAutoloadShouldIncludeReplacedPackages()
     {
-        $package = new Package('a', '1.0', '1.0');
-        $package->setRequires(array(new Link('a', 'a/a')));
+        $package = new RootPackage('root/a', '1.0', '1.0');
+        $package->setRequires(array(new Link('a', 'a/a', new MatchAllConstraint())));
 
         $packages = array();
         $packages[] = $a = new Package('a/a', '1.0', '1.0');
         $packages[] = $b = new Package('b/b', '1.0', '1.0');
 
-        $a->setRequires(array(new Link('a/a', 'b/c')));
+        $a->setRequires(array(new Link('a/a', 'b/c', new MatchAllConstraint())));
 
         $b->setAutoload(array('psr-4' => array('B\\' => 'src/')));
         $b->setReplaces(
-            array(new Link('b/b', 'b/c', new Constraint('==', '1.0'), 'replaces'))
+            array(new Link('b/b', 'b/c', new Constraint('==', '1.0'), Link::TYPE_REPLACE))
         );
 
         $this->repository->expects($this->once())
@@ -448,6 +457,7 @@ class AutoloadGeneratorTest extends Test
         $this->assertEquals(
             array(
                 'B\\C\\C' => $this->vendorDir.'/b/b/src/C/C.php',
+                'Composer\\InstalledVersions' => $this->vendorDir . '/composer/InstalledVersions.php',
             ),
             include $this->vendorDir.'/composer/autoload_classmap.php'
         );
@@ -455,9 +465,9 @@ class AutoloadGeneratorTest extends Test
 
     public function testNonDevAutoloadExclusionWithRecursionReplace()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setRequires(array(
-            new Link('a', 'a/a'),
+            new Link('a', 'a/a', new MatchAllConstraint()),
         ));
 
         $packages = array();
@@ -465,11 +475,11 @@ class AutoloadGeneratorTest extends Test
         $packages[] = $b = new Package('b/b', '1.0', '1.0');
         $a->setAutoload(array('psr-0' => array('A' => 'src/', 'A\\B' => 'lib/')));
         $a->setRequires(array(
-            new Link('a/a', 'c/c'),
+            new Link('a/a', 'c/c', new MatchAllConstraint()),
         ));
         $b->setAutoload(array('psr-0' => array('B\\Sub\\Name' => 'src/')));
         $b->setReplaces(array(
-            new Link('b/b', 'c/c'),
+            new Link('b/b', 'c/c', new MatchAllConstraint()),
         ));
 
         $this->repository->expects($this->once())
@@ -488,9 +498,9 @@ class AutoloadGeneratorTest extends Test
 
     public function testNonDevAutoloadReplacesNestedRequirements()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setRequires(array(
-            new Link('a', 'a/a')
+            new Link('a', 'a/a', new MatchAllConstraint()),
         ));
 
         $packages = array();
@@ -501,18 +511,18 @@ class AutoloadGeneratorTest extends Test
         $packages[] = $e = new Package('e/e', '1.0', '1.0');
         $a->setAutoload(array('classmap' => array('src/A.php')));
         $a->setRequires(array(
-            new Link('a/a', 'b/b')
+            new Link('a/a', 'b/b', new MatchAllConstraint()),
         ));
         $b->setAutoload(array('classmap' => array('src/B.php')));
         $b->setRequires(array(
-            new Link('b/b', 'e/e')
+            new Link('b/b', 'e/e', new MatchAllConstraint()),
         ));
         $c->setAutoload(array('classmap' => array('src/C.php')));
         $c->setReplaces(array(
-            new Link('c/c', 'b/b')
+            new Link('c/c', 'b/b', new MatchAllConstraint()),
         ));
         $c->setRequires(array(
-            new Link('c/c', 'd/d')
+            new Link('c/c', 'd/d', new MatchAllConstraint()),
         ));
         $d->setAutoload(array('classmap' => array('src/D.php')));
         $e->setAutoload(array('classmap' => array('src/E.php')));
@@ -540,9 +550,9 @@ class AutoloadGeneratorTest extends Test
 
     public function testPharAutoload()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setRequires(array(
-            new Link('a', 'a/a'),
+            new Link('a', 'a/a', new MatchAllConstraint()),
         ));
 
         $package->setAutoload(array(
@@ -581,7 +591,7 @@ class AutoloadGeneratorTest extends Test
 
     public function testPSRToClassMapIgnoresNonExistingDir()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
 
         $package->setAutoload(array(
             'psr-0' => array('Prefix' => 'foo/bar/non/existing/'),
@@ -595,16 +605,16 @@ class AutoloadGeneratorTest extends Test
         $this->generator->dump($this->config, $this->repository, $package, $this->im, 'composer', true, '_8');
         $this->assertFileExists($this->vendorDir.'/composer/autoload_classmap.php', "ClassMap file needs to be generated.");
         $this->assertEquals(
-            array(),
+            array(
+                'Composer\\InstalledVersions' => $this->vendorDir.'/composer/InstalledVersions.php',
+            ),
             include $this->vendorDir.'/composer/autoload_classmap.php'
         );
     }
 
     public function testPSRToClassMapIgnoresNonPSRClasses()
     {
-        $package = new Package('a', '1.0', '1.0');
-
-        $this->markTestSkipped('Skipped until ClassMapGenerator ignoring of invalid PSR-x classes is enabled');
+        $package = new RootPackage('root/a', '1.0', '1.0');
 
         $package->setAutoload(array(
             'psr-0' => array('psr0_' => 'psr0/'),
@@ -634,6 +644,7 @@ class AutoloadGeneratorTest extends Test
 \$baseDir = dirname(\$vendorDir);
 
 return array(
+    'Composer\\\\InstalledVersions' => \$vendorDir . '/composer/InstalledVersions.php',
     'psr0_match' => \$baseDir . '/psr0/psr0/match.php',
     'psr4\\\\match' => \$baseDir . '/psr4/match.php',
 );
@@ -644,10 +655,10 @@ EOF;
 
     public function testVendorsClassMapAutoloading()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setRequires(array(
-            new Link('a', 'a/a'),
-            new Link('a', 'b/b'),
+            new Link('a', 'a/a', new MatchAllConstraint()),
+            new Link('a', 'b/b', new MatchAllConstraint()),
         ));
 
         $packages = array();
@@ -675,6 +686,7 @@ EOF;
                 'ClassMapBar' => $this->vendorDir.'/b/b/src/b.php',
                 'ClassMapBaz' => $this->vendorDir.'/b/b/lib/c.php',
                 'ClassMapFoo' => $this->vendorDir.'/a/a/src/a.php',
+                'Composer\\InstalledVersions' => $this->vendorDir.'/composer/InstalledVersions.php',
             ),
             include $this->vendorDir.'/composer/autoload_classmap.php'
         );
@@ -683,10 +695,10 @@ EOF;
 
     public function testVendorsClassMapAutoloadingWithTargetDir()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setRequires(array(
-            new Link('a', 'a/a'),
-            new Link('a', 'b/b'),
+            new Link('a', 'a/a', new MatchAllConstraint()),
+            new Link('a', 'b/b', new MatchAllConstraint()),
         ));
 
         $packages = array();
@@ -715,6 +727,7 @@ EOF;
                 'ClassMapBar' => $this->vendorDir.'/a/a/target/lib/b.php',
                 'ClassMapBaz' => $this->vendorDir.'/b/b/src/c.php',
                 'ClassMapFoo' => $this->vendorDir.'/a/a/target/src/a.php',
+                'Composer\\InstalledVersions' => $this->vendorDir.'/composer/InstalledVersions.php',
             ),
             include $this->vendorDir.'/composer/autoload_classmap.php'
         );
@@ -722,11 +735,11 @@ EOF;
 
     public function testClassMapAutoloadingEmptyDirAndExactFile()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setRequires(array(
-            new Link('a', 'a/a'),
-            new Link('a', 'b/b'),
-            new Link('a', 'c/c'),
+            new Link('a', 'a/a', new MatchAllConstraint()),
+            new Link('a', 'b/b', new MatchAllConstraint()),
+            new Link('a', 'c/c', new MatchAllConstraint()),
         ));
 
         $packages = array();
@@ -756,21 +769,22 @@ EOF;
                 'ClassMapBar' => $this->vendorDir.'/b/b/test.php',
                 'ClassMapBaz' => $this->vendorDir.'/c/c/foo/test.php',
                 'ClassMapFoo' => $this->vendorDir.'/a/a/src/a.php',
+                'Composer\\InstalledVersions' => $this->vendorDir.'/composer/InstalledVersions.php',
             ),
             include $this->vendorDir.'/composer/autoload_classmap.php'
         );
         $this->assertAutoloadFiles('classmap5', $this->vendorDir.'/composer', 'classmap');
-        $this->assertNotContains('$loader->setClassMapAuthoritative(true);', file_get_contents($this->vendorDir.'/composer/autoload_real.php'));
-        $this->assertNotContains('$loader->setApcuPrefix(', file_get_contents($this->vendorDir.'/composer/autoload_real.php'));
+        $this->assertStringNotContainsString('$loader->setClassMapAuthoritative(true);', file_get_contents($this->vendorDir.'/composer/autoload_real.php'));
+        $this->assertStringNotContainsString('$loader->setApcuPrefix(', file_get_contents($this->vendorDir.'/composer/autoload_real.php'));
     }
 
     public function testClassMapAutoloadingAuthoritativeAndApcu()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setRequires(array(
-            new Link('a', 'a/a'),
-            new Link('a', 'b/b'),
-            new Link('a', 'c/c'),
+            new Link('a', 'a/a', new MatchAllConstraint()),
+            new Link('a', 'b/b', new MatchAllConstraint()),
+            new Link('a', 'c/c', new MatchAllConstraint()),
         ));
 
         $packages = array();
@@ -803,23 +817,73 @@ EOF;
                 'ClassMapBar' => $this->vendorDir.'/b/b/ClassMapBar.php',
                 'ClassMapBaz' => $this->vendorDir.'/c/c/foo/ClassMapBaz.php',
                 'ClassMapFoo' => $this->vendorDir.'/a/a/src/ClassMapFoo.php',
+                'Composer\\InstalledVersions' => $this->vendorDir.'/composer/InstalledVersions.php',
             ),
             include $this->vendorDir.'/composer/autoload_classmap.php'
         );
         $this->assertAutoloadFiles('classmap8', $this->vendorDir.'/composer', 'classmap');
 
-        $this->assertContains('$loader->setClassMapAuthoritative(true);', file_get_contents($this->vendorDir.'/composer/autoload_real.php'));
-        $this->assertContains('$loader->setApcuPrefix(', file_get_contents($this->vendorDir.'/composer/autoload_real.php'));
+        $this->assertStringContainsString('$loader->setClassMapAuthoritative(true);', file_get_contents($this->vendorDir.'/composer/autoload_real.php'));
+        $this->assertStringContainsString('$loader->setApcuPrefix(', file_get_contents($this->vendorDir.'/composer/autoload_real.php'));
+    }
+
+    public function testClassMapAutoloadingAuthoritativeAndApcuPrefix()
+    {
+        $package = new RootPackage('root/a', '1.0', '1.0');
+        $package->setRequires(array(
+            new Link('a', 'a/a', new MatchAllConstraint()),
+            new Link('a', 'b/b', new MatchAllConstraint()),
+            new Link('a', 'c/c', new MatchAllConstraint()),
+        ));
+
+        $packages = array();
+        $packages[] = $a = new Package('a/a', '1.0', '1.0');
+        $packages[] = $b = new Package('b/b', '1.0', '1.0');
+        $packages[] = $c = new Package('c/c', '1.0', '1.0');
+        $a->setAutoload(array('psr-4' => array('' => 'src/')));
+        $b->setAutoload(array('psr-4' => array('' => './')));
+        $c->setAutoload(array('psr-4' => array('' => 'foo/')));
+
+        $this->repository->expects($this->once())
+            ->method('getCanonicalPackages')
+            ->will($this->returnValue($packages));
+
+        $this->fs->ensureDirectoryExists($this->vendorDir.'/composer');
+        $this->fs->ensureDirectoryExists($this->vendorDir.'/a/a/src');
+        $this->fs->ensureDirectoryExists($this->vendorDir.'/b/b');
+        $this->fs->ensureDirectoryExists($this->vendorDir.'/c/c/foo');
+        file_put_contents($this->vendorDir.'/a/a/src/ClassMapFoo.php', '<?php class ClassMapFoo {}');
+        file_put_contents($this->vendorDir.'/b/b/ClassMapBar.php', '<?php class ClassMapBar {}');
+        file_put_contents($this->vendorDir.'/c/c/foo/ClassMapBaz.php', '<?php class ClassMapBaz {}');
+
+        $this->generator->setClassMapAuthoritative(true);
+        $this->generator->setApcu(true, 'custom\'Prefix');
+        $this->generator->dump($this->config, $this->repository, $package, $this->im, 'composer', false, '_7');
+
+        $this->assertFileExists($this->vendorDir.'/composer/autoload_classmap.php', "ClassMap file needs to be generated.");
+        $this->assertEquals(
+            array(
+                'ClassMapBar' => $this->vendorDir.'/b/b/ClassMapBar.php',
+                'ClassMapBaz' => $this->vendorDir.'/c/c/foo/ClassMapBaz.php',
+                'ClassMapFoo' => $this->vendorDir.'/a/a/src/ClassMapFoo.php',
+                'Composer\\InstalledVersions' => $this->vendorDir.'/composer/InstalledVersions.php',
+            ),
+            include $this->vendorDir.'/composer/autoload_classmap.php'
+        );
+        $this->assertAutoloadFiles('classmap8', $this->vendorDir.'/composer', 'classmap');
+
+        $this->assertStringContainsString('$loader->setClassMapAuthoritative(true);', file_get_contents($this->vendorDir.'/composer/autoload_real.php'));
+        $this->assertStringContainsString('$loader->setApcuPrefix(\'custom\\\'Prefix\');', file_get_contents($this->vendorDir.'/composer/autoload_real.php'));
     }
 
     public function testFilesAutoloadGeneration()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array('files' => array('root.php')));
         $package->setRequires(array(
-            new Link('a', 'a/a'),
-            new Link('a', 'b/b'),
-            new Link('a', 'c/c'),
+            new Link('a', 'a/a', new MatchAllConstraint()),
+            new Link('a', 'b/b', new MatchAllConstraint()),
+            new Link('a', 'c/c', new MatchAllConstraint()),
         ));
 
         $packages = array();
@@ -850,7 +914,8 @@ EOF;
         $this->assertFileContentEquals(__DIR__.'/Fixtures/autoload_static_functions.php', $this->vendorDir.'/composer/autoload_static.php');
         $this->assertFileContentEquals(__DIR__.'/Fixtures/autoload_files_functions.php', $this->vendorDir.'/composer/autoload_files.php');
 
-        include $this->vendorDir . '/autoload.php';
+        $loader = require $this->vendorDir . '/autoload.php';
+        $loader->unregister();
         $this->assertTrue(function_exists('testFilesAutoloadGeneration1'));
         $this->assertTrue(function_exists('testFilesAutoloadGeneration2'));
         $this->assertTrue(function_exists('testFilesAutoloadGeneration3'));
@@ -860,16 +925,16 @@ EOF;
 
     public function testFilesAutoloadGenerationRemoveExtraEntitiesFromAutoloadFiles()
     {
-        $autoloadPackage = new Package('a', '1.0', '1.0');
+        $autoloadPackage = new RootPackage('root/a', '1.0', '1.0');
         $autoloadPackage->setAutoload(array('files' => array('root.php')));
         $autoloadPackage->setIncludePaths(array('/lib', '/src'));
 
-        $notAutoloadPackage = new Package('a', '1.0', '1.0');
+        $notAutoloadPackage = new RootPackage('root/a', '1.0', '1.0');
 
         $requires = array(
-            new Link('a', 'a/a'),
-            new Link('a', 'b/b'),
-            new Link('a', 'c/c'),
+            new Link('a', 'a/a', new MatchAllConstraint()),
+            new Link('a', 'b/b', new MatchAllConstraint()),
+            new Link('a', 'c/c', new MatchAllConstraint()),
         );
         $autoloadPackage->setRequires($requires);
         $notAutoloadPackage->setRequires($requires);
@@ -891,15 +956,15 @@ EOF;
         $notAutoloadPackages[] = $b = new Package('b/b', '1.0', '1.0');
         $notAutoloadPackages[] = $c = new Package('c/c', '1.0', '1.0');
 
-        $this->repository->expects($this->at(0))
+        $this->repository->expects($this->at(1))
             ->method('getCanonicalPackages')
             ->will($this->returnValue($autoloadPackages));
 
-        $this->repository->expects($this->at(1))
+        $this->repository->expects($this->at(3))
             ->method('getCanonicalPackages')
             ->will($this->returnValue($notAutoloadPackages));
 
-        $this->repository->expects($this->at(2))
+        $this->repository->expects($this->at(5))
             ->method('getCanonicalPackages')
             ->will($this->returnValue($notAutoloadPackages));
 
@@ -929,19 +994,19 @@ EOF;
         $this->assertFileContentEquals(__DIR__.'/Fixtures/autoload_functions.php', $this->vendorDir.'/autoload.php');
         $this->assertFileContentEquals(__DIR__.'/Fixtures/autoload_real_functions_with_removed_include_paths_and_autolad_files.php', $this->vendorDir.'/composer/autoload_real.php');
         $this->assertFileContentEquals(__DIR__.'/Fixtures/autoload_static_functions_with_removed_include_paths_and_autolad_files.php', $this->vendorDir.'/composer/autoload_static.php');
-        $this->assertFileNotExists($this->vendorDir.'/composer/autoload_files.php');
-        $this->assertFileNotExists($this->vendorDir.'/composer/include_paths.php');
+        $this->assertFileDoesNotExist($this->vendorDir.'/composer/autoload_files.php');
+        $this->assertFileDoesNotExist($this->vendorDir.'/composer/include_paths.php');
     }
 
     public function testFilesAutoloadOrderByDependencies()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array('files' => array('root2.php')));
         $package->setRequires(array(
-            new Link('a', 'z/foo'),
-            new Link('a', 'b/bar'),
-            new Link('a', 'd/d'),
-            new Link('a', 'e/e'),
+            new Link('a', 'z/foo', new MatchAllConstraint()),
+            new Link('a', 'b/bar', new MatchAllConstraint()),
+            new Link('a', 'd/d', new MatchAllConstraint()),
+            new Link('a', 'e/e', new MatchAllConstraint()),
         ));
 
         $packages = array();
@@ -952,18 +1017,18 @@ EOF;
         $packages[] = $e = new Package('e/e', '1.0', '1.0');
 
         $z->setAutoload(array('files' => array('testA.php')));
-        $z->setRequires(array(new Link('z/foo', 'c/lorem')));
+        $z->setRequires(array(new Link('z/foo', 'c/lorem', new MatchAllConstraint())));
 
         $b->setAutoload(array('files' => array('testB.php')));
-        $b->setRequires(array(new Link('b/bar', 'c/lorem'), new Link('b/bar', 'd/d')));
+        $b->setRequires(array(new Link('b/bar', 'c/lorem', new MatchAllConstraint()), new Link('b/bar', 'd/d', new MatchAllConstraint())));
 
         $c->setAutoload(array('files' => array('testC.php')));
 
         $d->setAutoload(array('files' => array('testD.php')));
-        $d->setRequires(array(new Link('d/d', 'c/lorem')));
+        $d->setRequires(array(new Link('d/d', 'c/lorem', new MatchAllConstraint())));
 
         $e->setAutoload(array('files' => array('testE.php')));
-        $e->setRequires(array(new Link('e/e', 'c/lorem')));
+        $e->setRequires(array(new Link('e/e', 'c/lorem', new MatchAllConstraint())));
 
         $this->repository->expects($this->once())
             ->method('getCanonicalPackages')
@@ -986,7 +1051,8 @@ EOF;
         $this->assertFileContentEquals(__DIR__ . '/Fixtures/autoload_real_files_by_dependency.php', $this->vendorDir . '/composer/autoload_real.php');
         $this->assertFileContentEquals(__DIR__ . '/Fixtures/autoload_static_files_by_dependency.php', $this->vendorDir . '/composer/autoload_static.php');
 
-        require $this->vendorDir . '/autoload.php';
+        $loader = require $this->vendorDir . '/autoload.php';
+        $loader->unregister();
 
         $this->assertTrue(function_exists('testFilesAutoloadOrderByDependency1'));
         $this->assertTrue(function_exists('testFilesAutoloadOrderByDependency2'));
@@ -1004,14 +1070,14 @@ EOF;
      */
     public function testOverrideVendorsAutoloading()
     {
-        $mainPackage = new Package('z', '1.0', '1.0');
-        $mainPackage->setAutoload(array(
+        $rootPackage = new RootPackage('root/z', '1.0', '1.0');
+        $rootPackage->setAutoload(array(
             'psr-0' => array('A\\B' => $this->workingDir.'/lib'),
             'classmap' => array($this->workingDir.'/src'),
         ));
-        $mainPackage->setRequires(array(
-            new Link('z', 'a/a'),
-            new Link('z', 'b/b'),
+        $rootPackage->setRequires(array(
+            new Link('z', 'a/a', new MatchAllConstraint()),
+            new Link('z', 'b/b', new MatchAllConstraint()),
         ));
 
         $packages = array();
@@ -1085,12 +1151,13 @@ EOF;
 
 return array(
     'A\\\\B\\\\C' => \$baseDir . '/lib/A/B/C.php',
+    'Composer\\\\InstalledVersions' => \$vendorDir . '/composer/InstalledVersions.php',
     'Foo\\\\Bar' => \$baseDir . '/src/classes.php',
 );
 
 EOF;
 
-        $this->generator->dump($this->config, $this->repository, $mainPackage, $this->im, 'composer', true, '_9');
+        $this->generator->dump($this->config, $this->repository, $rootPackage, $this->im, 'composer', true, '_9');
         $this->assertStringEqualsFile($this->vendorDir.'/composer/autoload_namespaces.php', $expectedNamespace);
         $this->assertStringEqualsFile($this->vendorDir.'/composer/autoload_psr4.php', $expectedPsr4);
         $this->assertStringEqualsFile($this->vendorDir.'/composer/autoload_classmap.php', $expectedClassmap);
@@ -1098,7 +1165,7 @@ EOF;
 
     public function testIncludePathFileGeneration()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $packages = array();
 
         $a = new Package("a/a", "1.0", "1.0");
@@ -1135,7 +1202,7 @@ EOF;
 
     public function testIncludePathsArePrependedInAutoloadFile()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $packages = array();
 
         $a = new Package("a/a", "1.0", "1.0");
@@ -1153,7 +1220,8 @@ EOF;
 
         $oldIncludePath = get_include_path();
 
-        require $this->vendorDir."/autoload.php";
+        $loader = require $this->vendorDir."/autoload.php";
+        $loader->unregister();
 
         $this->assertEquals(
             $this->vendorDir."/a/a/lib".PATH_SEPARATOR.$oldIncludePath,
@@ -1163,9 +1231,9 @@ EOF;
         set_include_path($oldIncludePath);
     }
 
-    public function testIncludePathsInMainPackage()
+    public function testIncludePathsInRootPackage()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setIncludePaths(array('/lib', '/src'));
 
         $packages = array($a = new Package("a/a", "1.0", "1.0"));
@@ -1181,7 +1249,8 @@ EOF;
 
         $oldIncludePath = get_include_path();
 
-        require $this->vendorDir."/autoload.php";
+        $loader = require $this->vendorDir."/autoload.php";
+        $loader->unregister();
 
         $this->assertEquals(
             $this->workingDir."/lib".PATH_SEPARATOR.$this->workingDir."/src".PATH_SEPARATOR.$this->vendorDir."/a/a/lib".PATH_SEPARATOR.$oldIncludePath,
@@ -1193,7 +1262,7 @@ EOF;
 
     public function testIncludePathFileWithoutPathsIsSkipped()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $packages = array();
 
         $a = new Package("a/a", "1.0", "1.0");
@@ -1207,7 +1276,7 @@ EOF;
 
         $this->generator->dump($this->config, $this->repository, $package, $this->im, "composer", false, '_12');
 
-        $this->assertFileNotExists($this->vendorDir."/composer/include_paths.php");
+        $this->assertFileDoesNotExist($this->vendorDir."/composer/include_paths.php");
     }
 
     public function testPreAndPostEventsAreDispatchedDuringAutoloadDump()
@@ -1222,7 +1291,7 @@ EOF;
             ->method('dispatchScript')
             ->with(ScriptEvents::POST_AUTOLOAD_DUMP, false);
 
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array('psr-0' => array('foo/bar/non/existing/')));
 
         $this->repository->expects($this->once())
@@ -1235,7 +1304,7 @@ EOF;
 
     public function testUseGlobalIncludePath()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array(
             'psr-0' => array('Main\\Foo' => '', 'Main\\Bar' => ''),
         ));
@@ -1262,7 +1331,7 @@ EOF;
         $this->fs->ensureDirectoryExists($workingDir);
         chdir($workingDir);
 
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array(
             'psr-0' => array('Foo' => 'src'),
             'psr-4' => array('Acme\Foo\\' => 'src-psr4'),
@@ -1270,7 +1339,7 @@ EOF;
             'files' => array('test.php'),
         ));
         $package->setRequires(array(
-            new Link('a', 'b/b'),
+            new Link('a', 'b/b', new MatchAllConstraint()),
         ));
 
         $vendorPackage = new Package('b/b', '1.0', '1.0');
@@ -1354,6 +1423,7 @@ $baseDir = dirname($vendorDir).'/working
 return array(
     'Bar\\Bar' => $vendorDir . '/b/b/classmaps/classes.php',
     'Bar\\Foo' => $vendorDir . '/b/b/lib/Bar/Foo.php',
+    'Composer\\InstalledVersions' => $vendorDir . '/composer/InstalledVersions.php',
     'Foo\\Bar' => $baseDir . '/src/Foo/Bar.php',
     'Foo\\Foo' => $baseDir . '/classmap/classes.php',
 );
@@ -1363,8 +1433,8 @@ EOF;
         $this->assertStringEqualsFile($vendorDir.'/composer/autoload_namespaces.php', $expectedNamespace);
         $this->assertStringEqualsFile($vendorDir.'/composer/autoload_psr4.php', $expectedPsr4);
         $this->assertStringEqualsFile($vendorDir.'/composer/autoload_classmap.php', $expectedClassmap);
-        $this->assertContains("\$vendorDir . '/b/b/bootstrap.php',\n", file_get_contents($vendorDir.'/composer/autoload_files.php'));
-        $this->assertContains("\$baseDir . '/test.php',\n", file_get_contents($vendorDir.'/composer/autoload_files.php'));
+        $this->assertStringContainsString("\$vendorDir . '/b/b/bootstrap.php',\n", file_get_contents($vendorDir.'/composer/autoload_files.php'));
+        $this->assertStringContainsString("\$baseDir . '/test.php',\n", file_get_contents($vendorDir.'/composer/autoload_files.php'));
     }
 
     public function testUpLevelRelativePaths()
@@ -1373,13 +1443,13 @@ EOF;
         mkdir($workingDir, 0777, true);
         chdir($workingDir);
 
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array(
             'psr-0' => array('Foo' => '../path/../src'),
             'psr-4' => array('Acme\Foo\\' => '../path/../src-psr4'),
-            'classmap' => array('../classmap'),
+            'classmap' => array('../classmap', '../classmap2/subdir', 'classmap3', 'classmap4'),
             'files' => array('../test.php'),
-            'exclude-from-classmap' => array('./../classmap/excluded'),
+            'exclude-from-classmap' => array('./../classmap/excluded', '../classmap2', 'classmap3/classes.php', 'classmap4/*/classes.php'),
         ));
 
         $this->repository->expects($this->once())
@@ -1388,9 +1458,15 @@ EOF;
 
         $this->fs->ensureDirectoryExists($this->workingDir.'/src/Foo');
         $this->fs->ensureDirectoryExists($this->workingDir.'/classmap/excluded');
+        $this->fs->ensureDirectoryExists($this->workingDir.'/classmap2/subdir');
+        $this->fs->ensureDirectoryExists($this->workingDir.'/working-dir/classmap3');
+        $this->fs->ensureDirectoryExists($this->workingDir.'/working-dir/classmap4/foo/');
         file_put_contents($this->workingDir.'/src/Foo/Bar.php', '<?php namespace Foo; class Bar {}');
         file_put_contents($this->workingDir.'/classmap/classes.php', '<?php namespace Foo; class Foo {}');
         file_put_contents($this->workingDir.'/classmap/excluded/classes.php', '<?php namespace Foo; class Boo {}');
+        file_put_contents($this->workingDir.'/classmap2/subdir/classes.php', '<?php namespace Foo; class Boo2 {}');
+        file_put_contents($this->workingDir.'/working-dir/classmap3/classes.php', '<?php namespace Foo; class Boo3 {}');
+        file_put_contents($this->workingDir.'/working-dir/classmap4/foo/classes.php', '<?php namespace Foo; class Boo4 {}');
         file_put_contents($this->workingDir.'/test.php', '<?php class Foo {}');
 
         $this->generator->dump($this->config, $this->repository, $package, $this->im, 'composer', true, '_14');
@@ -1432,6 +1508,7 @@ $vendorDir = dirname(dirname(__FILE__));
 $baseDir = dirname($vendorDir).'/working-dir';
 
 return array(
+    'Composer\\InstalledVersions' => $vendorDir . '/composer/InstalledVersions.php',
     'Foo\\Bar' => $baseDir . '/../src/Foo/Bar.php',
     'Foo\\Foo' => $baseDir . '/../classmap/classes.php',
 );
@@ -1441,12 +1518,12 @@ EOF;
         $this->assertStringEqualsFile($this->vendorDir.'/composer/autoload_namespaces.php', $expectedNamespace);
         $this->assertStringEqualsFile($this->vendorDir.'/composer/autoload_psr4.php', $expectedPsr4);
         $this->assertStringEqualsFile($this->vendorDir.'/composer/autoload_classmap.php', $expectedClassmap);
-        $this->assertContains("\$baseDir . '/../test.php',\n", file_get_contents($this->vendorDir.'/composer/autoload_files.php'));
+        $this->assertStringContainsString("\$baseDir . '/../test.php',\n", file_get_contents($this->vendorDir.'/composer/autoload_files.php'));
     }
 
     public function testEmptyPaths()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array(
             'psr-0' => array('Foo' => ''),
             'psr-4' => array('Acme\Foo\\' => ''),
@@ -1501,6 +1578,7 @@ $baseDir = dirname($vendorDir);
 
 return array(
     'Classmap\\Foo' => $baseDir . '/class.php',
+    'Composer\\InstalledVersions' => $vendorDir . '/composer/InstalledVersions.php',
     'Foo\\Bar' => $baseDir . '/Foo/Bar.php',
 );
 
@@ -1513,7 +1591,7 @@ EOF;
 
     public function testVendorSubstringPath()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array(
             'psr-0' => array('Foo' => 'composer-test-autoload-src/src'),
             'psr-4' => array('Acme\Foo\\' => 'composer-test-autoload-src/src-psr4'),
@@ -1560,7 +1638,7 @@ EOF;
 
     public function testExcludeFromClassmap()
     {
-        $package = new Package('a', '1.0', '1.0');
+        $package = new RootPackage('root/a', '1.0', '1.0');
         $package->setAutoload(array(
             'psr-0' => array(
                 'Main' => 'src/',
@@ -1627,6 +1705,126 @@ EOF;
         $this->assertAutoloadFiles('classmap', $this->vendorDir.'/composer', 'classmap');
     }
 
+    /**
+     * @dataProvider platformCheckProvider
+     */
+    public function testGeneratesPlatformCheck(array $requires, $expectedFixture, array $provides = array(), array $replaces = array(), $ignorePlatformReqs = false)
+    {
+        $package = new RootPackage('root/a', '1.0', '1.0');
+        $package->setRequires($requires);
+
+        if ($provides) {
+            $package->setProvides($provides);
+        }
+
+        if ($replaces) {
+            $package->setReplaces($replaces);
+        }
+
+        $this->repository->expects($this->once())
+            ->method('getCanonicalPackages')
+            ->will($this->returnValue(array()));
+
+        $this->generator->setIgnorePlatformRequirements($ignorePlatformReqs);
+        $this->generator->dump($this->config, $this->repository, $package, $this->im, 'composer', true, '_1');
+
+        if (null === $expectedFixture) {
+            $this->assertFalse(file_exists($this->vendorDir . '/composer/platform_check.php'));
+            $this->assertStringNotContainsString("require __DIR__ . '/platform_check.php';", file_get_contents($this->vendorDir.'/composer/autoload_real.php'));
+        } else {
+            $this->assertFileContentEquals(__DIR__ . '/Fixtures/platform/' . $expectedFixture . '.php', $this->vendorDir . '/composer/platform_check.php');
+            $this->assertStringContainsString("require __DIR__ . '/platform_check.php';", file_get_contents($this->vendorDir.'/composer/autoload_real.php'));
+        }
+    }
+
+    public function platformCheckProvider()
+    {
+        $versionParser = new VersionParser();
+
+        return array(
+            'Typical project requirements' => array(
+                array(
+                    new Link('a', 'php', $versionParser->parseConstraints('^7.2')),
+                    new Link('a', 'ext-xml', $versionParser->parseConstraints('*')),
+                    new Link('a', 'ext-json', $versionParser->parseConstraints('*')),
+                ),
+                'typical',
+            ),
+            'No PHP lower bound' => array(
+                array(
+                    new Link('a', 'php', $versionParser->parseConstraints('< 8')),
+                ),
+                null,
+            ),
+            'No PHP upper bound' => array(
+                array(
+                    new Link('a', 'php', $versionParser->parseConstraints('>= 7.2')),
+                ),
+                'no_php_upper_bound',
+            ),
+            'Specific PHP release version' => array(
+                array(
+                    new Link('a', 'php', $versionParser->parseConstraints('^7.2.8')),
+                ),
+                'specific_php_release',
+            ),
+            'No PHP required' => array(
+                array(
+                    new Link('a', 'ext-xml', $versionParser->parseConstraints('*')),
+                    new Link('a', 'ext-json', $versionParser->parseConstraints('*')),
+                ),
+                'no_php_required',
+            ),
+            'Ignoring all platform requirements skips check completely' => array(
+                array(
+                    new Link('a', 'php', $versionParser->parseConstraints('^7.2')),
+                    new Link('a', 'ext-xml', $versionParser->parseConstraints('*')),
+                    new Link('a', 'ext-json', $versionParser->parseConstraints('*')),
+                ),
+                null,
+                array(),
+                array(),
+                true,
+            ),
+            'Ignored platform requirements are not checked for' => array(
+                array(
+                    new Link('a', 'php', $versionParser->parseConstraints('^7.2.8')),
+                    new Link('a', 'ext-xml', $versionParser->parseConstraints('*')),
+                    new Link('a', 'ext-json', $versionParser->parseConstraints('*')),
+                    new Link('a', 'ext-pdo', $versionParser->parseConstraints('*')),
+                ),
+                'no_php_required',
+                array(),
+                array(),
+                array('php', 'ext-pdo'),
+            ),
+            'No extensions required' => array(
+                array(
+                    new Link('a', 'php', $versionParser->parseConstraints('^7.2')),
+                ),
+                'no_extensions_required',
+            ),
+            'Replaced/provided extensions are not checked for + checking case insensitivity' => array(
+                array(
+                    new Link('a', 'ext-xml', $versionParser->parseConstraints('^7.2')),
+                    new Link('a', 'ext-Pdo', $versionParser->parseConstraints('^7.2')),
+                    new Link('a', 'ext-bcMath', $versionParser->parseConstraints('^7.2')),
+                ),
+                'replaced_provided_exts',
+                array(
+                    // constraint does not satisfy all the ^7.2 requirement so we do not accept it as being replaced
+                    new Link('a', 'ext-PDO', $versionParser->parseConstraints('7.1.*')),
+                    // valid replace of bcmath so no need to check for it
+                    new Link('a', 'ext-BCMath', $versionParser->parseConstraints('^7.1')),
+                ),
+                array(
+                    // valid provide of ext-xml so no need to check for it
+                    new Link('a', 'ext-XML', $versionParser->parseConstraints('*')),
+                ),
+            ),
+        );
+    }
+
     private function assertAutoloadFiles($name, $dir, $type = 'namespaces')
     {
         $a = __DIR__.'/Fixtures/autoload_'.$name.'.php';
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/ClassMapGeneratorTest.php 2.0.9-1/tests/Composer/Test/Autoload/ClassMapGeneratorTest.php
--- 1.10.19-1/tests/Composer/Test/Autoload/ClassMapGeneratorTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/ClassMapGeneratorTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -120,16 +120,13 @@ class ClassMapGeneratorTest extends Test
         ), ClassMapGenerator::createMap($finder));
     }
 
-    /**
-     * @expectedException \RuntimeException
-     * @expectedExceptionMessage does not exist
-     */
     public function testFindClassesThrowsWhenFileDoesNotExist()
     {
         $r = new \ReflectionClass('Composer\\Autoload\\ClassMapGenerator');
         $find = $r->getMethod('findClasses');
         $find->setAccessible(true);
 
+        $this->setExpectedException('RuntimeException', 'does not exist');
         $find->invoke(null, __DIR__ . '/no-file');
     }
 
@@ -213,12 +210,9 @@ class ClassMapGeneratorTest extends Test
         $fs->removeDirectory($tempDir);
     }
 
-    /**
-     * @expectedException \RuntimeException
-     * @expectedExceptionMessage Could not scan for classes inside
-     */
     public function testCreateMapThrowsWhenDirectoryDoesNotExist()
     {
+        $this->setExpectedException('RuntimeException', 'Could not scan for classes inside');
         ClassMapGenerator::createMap(__DIR__ . '/no-file.no-foler');
     }
 
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap2.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap2.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap2.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap2.php	2021-01-27 15:09:27.000000000 +0000
@@ -7,4 +7,5 @@ $baseDir = dirname(dirname($vendorDir));
 
 return array(
     'ClassMapFoo' => $baseDir . '/composersrc/foo.php',
+    'Composer\\InstalledVersions' => $vendorDir . '/composer/InstalledVersions.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap3.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap3.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap3.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap3.php	2021-01-27 15:09:27.000000000 +0000
@@ -7,5 +7,6 @@ $baseDir = $vendorDir;
 
 return array(
     'ClassMapFoo' => $vendorDir . '/composersrc/foo.php',
+    'Composer\\InstalledVersions' => $vendorDir . '/composer/InstalledVersions.php',
     'Main\\Foo' => $vendorDir . '/src/Main/Foo.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap4.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap4.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap4.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap4.php	2021-01-27 15:09:27.000000000 +0000
@@ -9,4 +9,5 @@ return array(
     'ClassMapBar' => $vendorDir . '/b/b/src/b.php',
     'ClassMapBaz' => $vendorDir . '/b/b/lib/c.php',
     'ClassMapFoo' => $vendorDir . '/a/a/src/a.php',
+    'Composer\\InstalledVersions' => $vendorDir . '/composer/InstalledVersions.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap5.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap5.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap5.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap5.php	2021-01-27 15:09:27.000000000 +0000
@@ -9,4 +9,5 @@ return array(
     'ClassMapBar' => $vendorDir . '/b/b/test.php',
     'ClassMapBaz' => $vendorDir . '/c/c/foo/test.php',
     'ClassMapFoo' => $vendorDir . '/a/a/src/a.php',
+    'Composer\\InstalledVersions' => $vendorDir . '/composer/InstalledVersions.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap6.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap6.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap6.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap6.php	2021-01-27 15:09:27.000000000 +0000
@@ -8,4 +8,5 @@ $baseDir = dirname($vendorDir);
 return array(
     'ClassMapBar' => $baseDir . '/lib/rootbar.php',
     'ClassMapFoo' => $baseDir . '/src/rootfoo.php',
+    'Composer\\InstalledVersions' => $vendorDir . '/composer/InstalledVersions.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap7.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap7.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap7.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap7.php	2021-01-27 15:09:27.000000000 +0000
@@ -6,5 +6,6 @@ $vendorDir = dirname(dirname(__FILE__));
 $baseDir = dirname($vendorDir);
 
 return array(
+    'Composer\\InstalledVersions' => $vendorDir . '/composer/InstalledVersions.php',
     'Main\\ClassMain' => $baseDir . '/src/Main/ClassMain.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap8.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap8.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap8.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap8.php	2021-01-27 15:09:27.000000000 +0000
@@ -9,4 +9,5 @@ return array(
     'ClassMapBar' => $vendorDir . '/b/b/ClassMapBar.php',
     'ClassMapBaz' => $vendorDir . '/c/c/foo/ClassMapBaz.php',
     'ClassMapFoo' => $vendorDir . '/a/a/src/ClassMapFoo.php',
+    'Composer\\InstalledVersions' => $vendorDir . '/composer/InstalledVersions.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap9.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap9.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap9.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap9.php	2021-01-27 15:09:27.000000000 +0000
@@ -8,5 +8,6 @@ $baseDir = dirname($vendorDir);
 return array(
     'A' => $vendorDir . '/a/a/src/A.php',
     'C' => $vendorDir . '/c/c/src/C.php',
+    'Composer\\InstalledVersions' => $vendorDir . '/composer/InstalledVersions.php',
     'D' => $vendorDir . '/d/d/src/D.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_classmap.php	2021-01-27 15:09:27.000000000 +0000
@@ -8,6 +8,7 @@ $baseDir = dirname($vendorDir);
 return array(
     'Acme\\Cake\\ClassMapBar' => $baseDir . '/src-cake/ClassMapBar.php',
     'ClassMapFoo' => $baseDir . '/composersrc/foo.php',
+    'Composer\\InstalledVersions' => $vendorDir . '/composer/InstalledVersions.php',
     'Lala\\ClassMapMain' => $baseDir . '/src/Lala/ClassMapMain.php',
     'Lala\\Test\\ClassMapMainTest' => $baseDir . '/src/Lala/Test/ClassMapMainTest.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_files2.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_files2.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_files2.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_files2.php	2021-01-27 15:09:27.000000000 +0000
@@ -6,5 +6,5 @@ $vendorDir = dirname(dirname(__FILE__));
 $baseDir = dirname($vendorDir);
 
 return array(
-    'e5e597abc575cc420a44914c612bb1b3' => $baseDir . '/devfiles/foo.php',
+    'fd1502a3b53705310b21799d025f0dee' => $baseDir . '/devfiles/foo.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_files_functions.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_files_functions.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_files_functions.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_files_functions.php	2021-01-27 15:09:27.000000000 +0000
@@ -10,5 +10,5 @@ return array(
     'e56cac94f86c787e1efd645809df361d' => $vendorDir . '/b/b/test2.php',
     'df8470dfa2ebd6b31da05b60fb4ec29a' => $vendorDir . '/c/c/foo/bar/test3.php',
     '68f1e24e6cd39de885cb5a47678e6518' => $vendorDir . '/c/c/foo/bar/test4.php',
-    '61b776fd0ee84fb7d7d958ae46118ded' => $baseDir . '/root.php',
+    '5e70d6595c54512c151823ca0663ab51' => $baseDir . '/root.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_files_functions_with_removed_extra.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_files_functions_with_removed_extra.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_files_functions_with_removed_extra.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_files_functions_with_removed_extra.php	2021-01-27 15:09:27.000000000 +0000
@@ -6,5 +6,5 @@ $vendorDir = dirname(dirname(__FILE__));
 $baseDir = dirname($vendorDir);
 
 return array(
-    '61b776fd0ee84fb7d7d958ae46118ded' => $baseDir . '/root.php',
+    '5e70d6595c54512c151823ca0663ab51' => $baseDir . '/root.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_files_target_dir.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_files_target_dir.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_files_target_dir.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_files_target_dir.php	2021-01-27 15:09:27.000000000 +0000
@@ -6,6 +6,6 @@ $vendorDir = dirname(dirname(__FILE__));
 $baseDir = dirname($vendorDir);
 
 return array(
-    'b419c11b924de79ffa740afc29a3dc16' => $baseDir . '/foo.php',
-    'f558c96fbd0535aaa98981fa59ff7594' => $baseDir . '/bar.php',
+    'b4b4f2eb2151c57cadbd5714a7aba8b7' => $baseDir . '/foo.php',
+    '99b24fc198db06c1d2d8118a8a5475eb' => $baseDir . '/bar.php',
 );
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_phar_static.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_phar_static.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_phar_static.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_phar_static.php	2021-01-27 15:09:27.000000000 +0000
@@ -75,12 +75,17 @@ class ComposerStaticInitPhar
         ),
     );
 
+    public static $classMap = array (
+        'Composer\\InstalledVersions' => __DIR__ . '/..' . '/composer/InstalledVersions.php',
+    );
+
     public static function getInitializer(ClassLoader $loader)
     {
         return \Closure::bind(function () use ($loader) {
             $loader->prefixLengthsPsr4 = ComposerStaticInitPhar::$prefixLengthsPsr4;
             $loader->prefixDirsPsr4 = ComposerStaticInitPhar::$prefixDirsPsr4;
             $loader->prefixesPsr0 = ComposerStaticInitPhar::$prefixesPsr0;
+            $loader->classMap = ComposerStaticInitPhar::$classMap;
 
         }, null, ClassLoader::class);
     }
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_files_by_dependency.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_files_by_dependency.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_files_by_dependency.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_files_by_dependency.php	2021-01-27 15:09:27.000000000 +0000
@@ -23,12 +23,12 @@ class ComposerAutoloaderInitFilesAutoloa
         }
 
         spl_autoload_register(array('ComposerAutoloaderInitFilesAutoloadOrder', 'loadClassLoader'), true, true);
-        self::$loader = $loader = new \Composer\Autoload\ClassLoader();
+        self::$loader = $loader = new \Composer\Autoload\ClassLoader(\dirname(\dirname(__FILE__)));
         spl_autoload_unregister(array('ComposerAutoloaderInitFilesAutoloadOrder', 'loadClassLoader'));
 
         $useStaticLoader = PHP_VERSION_ID >= 50600 && !defined('HHVM_VERSION') && (!function_exists('zend_loader_file_encoded') || !zend_loader_file_encoded());
         if ($useStaticLoader) {
-            require_once __DIR__ . '/autoload_static.php';
+            require __DIR__ . '/autoload_static.php';
 
             call_user_func(\Composer\Autoload\ComposerStaticInitFilesAutoloadOrder::getInitializer($loader));
         } else {
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_functions.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_functions.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_functions.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_functions.php	2021-01-27 15:09:27.000000000 +0000
@@ -23,12 +23,12 @@ class ComposerAutoloaderInitFilesAutoloa
         }
 
         spl_autoload_register(array('ComposerAutoloaderInitFilesAutoload', 'loadClassLoader'), true, true);
-        self::$loader = $loader = new \Composer\Autoload\ClassLoader();
+        self::$loader = $loader = new \Composer\Autoload\ClassLoader(\dirname(\dirname(__FILE__)));
         spl_autoload_unregister(array('ComposerAutoloaderInitFilesAutoload', 'loadClassLoader'));
 
         $useStaticLoader = PHP_VERSION_ID >= 50600 && !defined('HHVM_VERSION') && (!function_exists('zend_loader_file_encoded') || !zend_loader_file_encoded());
         if ($useStaticLoader) {
-            require_once __DIR__ . '/autoload_static.php';
+            require __DIR__ . '/autoload_static.php';
 
             call_user_func(\Composer\Autoload\ComposerStaticInitFilesAutoload::getInitializer($loader));
         } else {
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_functions_with_include_paths.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_functions_with_include_paths.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_functions_with_include_paths.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_functions_with_include_paths.php	2021-01-27 15:09:27.000000000 +0000
@@ -23,7 +23,7 @@ class ComposerAutoloaderInitFilesAutoloa
         }
 
         spl_autoload_register(array('ComposerAutoloaderInitFilesAutoload', 'loadClassLoader'), true, true);
-        self::$loader = $loader = new \Composer\Autoload\ClassLoader();
+        self::$loader = $loader = new \Composer\Autoload\ClassLoader(\dirname(\dirname(__FILE__)));
         spl_autoload_unregister(array('ComposerAutoloaderInitFilesAutoload', 'loadClassLoader'));
 
         $includePaths = require __DIR__ . '/include_paths.php';
@@ -32,7 +32,7 @@ class ComposerAutoloaderInitFilesAutoloa
 
         $useStaticLoader = PHP_VERSION_ID >= 50600 && !defined('HHVM_VERSION') && (!function_exists('zend_loader_file_encoded') || !zend_loader_file_encoded());
         if ($useStaticLoader) {
-            require_once __DIR__ . '/autoload_static.php';
+            require __DIR__ . '/autoload_static.php';
 
             call_user_func(\Composer\Autoload\ComposerStaticInitFilesAutoload::getInitializer($loader));
         } else {
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_functions_with_removed_include_paths_and_autolad_files.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_functions_with_removed_include_paths_and_autolad_files.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_functions_with_removed_include_paths_and_autolad_files.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_functions_with_removed_include_paths_and_autolad_files.php	2021-01-27 15:09:27.000000000 +0000
@@ -23,12 +23,12 @@ class ComposerAutoloaderInitFilesAutoloa
         }
 
         spl_autoload_register(array('ComposerAutoloaderInitFilesAutoload', 'loadClassLoader'), true, true);
-        self::$loader = $loader = new \Composer\Autoload\ClassLoader();
+        self::$loader = $loader = new \Composer\Autoload\ClassLoader(\dirname(\dirname(__FILE__)));
         spl_autoload_unregister(array('ComposerAutoloaderInitFilesAutoload', 'loadClassLoader'));
 
         $useStaticLoader = PHP_VERSION_ID >= 50600 && !defined('HHVM_VERSION') && (!function_exists('zend_loader_file_encoded') || !zend_loader_file_encoded());
         if ($useStaticLoader) {
-            require_once __DIR__ . '/autoload_static.php';
+            require __DIR__ . '/autoload_static.php';
 
             call_user_func(\Composer\Autoload\ComposerStaticInitFilesAutoload::getInitializer($loader));
         } else {
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_include_path.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_include_path.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_include_path.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_include_path.php	2021-01-27 15:09:27.000000000 +0000
@@ -23,12 +23,12 @@ class ComposerAutoloaderInitIncludePath
         }
 
         spl_autoload_register(array('ComposerAutoloaderInitIncludePath', 'loadClassLoader'), true, true);
-        self::$loader = $loader = new \Composer\Autoload\ClassLoader();
+        self::$loader = $loader = new \Composer\Autoload\ClassLoader(\dirname(\dirname(__FILE__)));
         spl_autoload_unregister(array('ComposerAutoloaderInitIncludePath', 'loadClassLoader'));
 
         $useStaticLoader = PHP_VERSION_ID >= 50600 && !defined('HHVM_VERSION') && (!function_exists('zend_loader_file_encoded') || !zend_loader_file_encoded());
         if ($useStaticLoader) {
-            require_once __DIR__ . '/autoload_static.php';
+            require __DIR__ . '/autoload_static.php';
 
             call_user_func(\Composer\Autoload\ComposerStaticInitIncludePath::getInitializer($loader));
         } else {
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_target_dir.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_target_dir.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_target_dir.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_real_target_dir.php	2021-01-27 15:09:27.000000000 +0000
@@ -23,12 +23,12 @@ class ComposerAutoloaderInitTargetDir
         }
 
         spl_autoload_register(array('ComposerAutoloaderInitTargetDir', 'loadClassLoader'), true, true);
-        self::$loader = $loader = new \Composer\Autoload\ClassLoader();
+        self::$loader = $loader = new \Composer\Autoload\ClassLoader(\dirname(\dirname(__FILE__)));
         spl_autoload_unregister(array('ComposerAutoloaderInitTargetDir', 'loadClassLoader'));
 
         $useStaticLoader = PHP_VERSION_ID >= 50600 && !defined('HHVM_VERSION') && (!function_exists('zend_loader_file_encoded') || !zend_loader_file_encoded());
         if ($useStaticLoader) {
-            require_once __DIR__ . '/autoload_static.php';
+            require __DIR__ . '/autoload_static.php';
 
             call_user_func(\Composer\Autoload\ComposerStaticInitTargetDir::getInitializer($loader));
         } else {
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_files_by_dependency.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_files_by_dependency.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_files_by_dependency.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_files_by_dependency.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,12 +12,17 @@ class ComposerStaticInitFilesAutoloadOrd
         '8bceec6fdc149a1a6acbf7ad3cfed51c' => __DIR__ . '/..' . '/z/foo/testA.php',
         'c5466e580c6c2403f225c43b6a21a96f' => __DIR__ . '/..' . '/b/bar/testB.php',
         '69dfc37c40a853a7cbac6c9d2367c5f4' => __DIR__ . '/..' . '/e/e/testE.php',
-        '334307692417e52db5a08c3271700a7e' => __DIR__ . '/../..' . '/root2.php',
+        'ab280164f4754f5dfdb0721de84d737f' => __DIR__ . '/../..' . '/root2.php',
+    );
+
+    public static $classMap = array (
+        'Composer\\InstalledVersions' => __DIR__ . '/..' . '/composer/InstalledVersions.php',
     );
 
     public static function getInitializer(ClassLoader $loader)
     {
         return \Closure::bind(function () use ($loader) {
+            $loader->classMap = ComposerStaticInitFilesAutoloadOrder::$classMap;
 
         }, null, ClassLoader::class);
     }
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_functions.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_functions.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_functions.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_functions.php	2021-01-27 15:09:27.000000000 +0000
@@ -11,12 +11,17 @@ class ComposerStaticInitFilesAutoload
         'e56cac94f86c787e1efd645809df361d' => __DIR__ . '/..' . '/b/b/test2.php',
         'df8470dfa2ebd6b31da05b60fb4ec29a' => __DIR__ . '/..' . '/c/c/foo/bar/test3.php',
         '68f1e24e6cd39de885cb5a47678e6518' => __DIR__ . '/..' . '/c/c/foo/bar/test4.php',
-        '61b776fd0ee84fb7d7d958ae46118ded' => __DIR__ . '/../..' . '/root.php',
+        '5e70d6595c54512c151823ca0663ab51' => __DIR__ . '/../..' . '/root.php',
+    );
+
+    public static $classMap = array (
+        'Composer\\InstalledVersions' => __DIR__ . '/..' . '/composer/InstalledVersions.php',
     );
 
     public static function getInitializer(ClassLoader $loader)
     {
         return \Closure::bind(function () use ($loader) {
+            $loader->classMap = ComposerStaticInitFilesAutoload::$classMap;
 
         }, null, ClassLoader::class);
     }
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_functions_with_include_paths.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_functions_with_include_paths.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_functions_with_include_paths.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_functions_with_include_paths.php	2021-01-27 15:09:27.000000000 +0000
@@ -11,12 +11,17 @@ class ComposerStaticInitFilesAutoload
         'e56cac94f86c787e1efd645809df361d' => __DIR__ . '/..' . '/b/b/test2.php',
         'df8470dfa2ebd6b31da05b60fb4ec29a' => __DIR__ . '/..' . '/c/c/foo/bar/test3.php',
         '68f1e24e6cd39de885cb5a47678e6518' => __DIR__ . '/..' . '/c/c/foo/bar/test4.php',
-        '61b776fd0ee84fb7d7d958ae46118ded' => __DIR__ . '/../..' . '/root.php',
+        '5e70d6595c54512c151823ca0663ab51' => __DIR__ . '/../..' . '/root.php',
+    );
+
+    public static $classMap = array (
+        'Composer\\InstalledVersions' => __DIR__ . '/..' . '/composer/InstalledVersions.php',
     );
 
     public static function getInitializer(ClassLoader $loader)
     {
         return \Closure::bind(function () use ($loader) {
+            $loader->classMap = ComposerStaticInitFilesAutoload::$classMap;
 
         }, null, ClassLoader::class);
     }
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_functions_with_removed_include_paths_and_autolad_files.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_functions_with_removed_include_paths_and_autolad_files.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_functions_with_removed_include_paths_and_autolad_files.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_functions_with_removed_include_paths_and_autolad_files.php	2021-01-27 15:09:27.000000000 +0000
@@ -6,9 +6,14 @@ namespace Composer\Autoload;
 
 class ComposerStaticInitFilesAutoload
 {
+    public static $classMap = array (
+        'Composer\\InstalledVersions' => __DIR__ . '/..' . '/composer/InstalledVersions.php',
+    );
+
     public static function getInitializer(ClassLoader $loader)
     {
         return \Closure::bind(function () use ($loader) {
+            $loader->classMap = ComposerStaticInitFilesAutoload::$classMap;
 
         }, null, ClassLoader::class);
     }
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_include_path.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_include_path.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_include_path.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_include_path.php	2021-01-27 15:09:27.000000000 +0000
@@ -20,10 +20,15 @@ class ComposerStaticInitIncludePath
         ),
     );
 
+    public static $classMap = array (
+        'Composer\\InstalledVersions' => __DIR__ . '/..' . '/composer/InstalledVersions.php',
+    );
+
     public static function getInitializer(ClassLoader $loader)
     {
         return \Closure::bind(function () use ($loader) {
             $loader->prefixesPsr0 = ComposerStaticInitIncludePath::$prefixesPsr0;
+            $loader->classMap = ComposerStaticInitIncludePath::$classMap;
 
         }, null, ClassLoader::class);
     }
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_target_dir.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_target_dir.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_target_dir.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/autoload_static_target_dir.php	2021-01-27 15:09:27.000000000 +0000
@@ -7,8 +7,8 @@ namespace Composer\Autoload;
 class ComposerStaticInitTargetDir
 {
     public static $files = array (
-        'b419c11b924de79ffa740afc29a3dc16' => __DIR__ . '/../..' . '/foo.php',
-        'f558c96fbd0535aaa98981fa59ff7594' => __DIR__ . '/../..' . '/bar.php',
+        'b4b4f2eb2151c57cadbd5714a7aba8b7' => __DIR__ . '/../..' . '/foo.php',
+        '99b24fc198db06c1d2d8118a8a5475eb' => __DIR__ . '/../..' . '/bar.php',
     );
 
     public static $prefixesPsr0 = array (
@@ -28,6 +28,7 @@ class ComposerStaticInitTargetDir
     public static $classMap = array (
         'ClassMapBar' => __DIR__ . '/../..' . '/lib/rootbar.php',
         'ClassMapFoo' => __DIR__ . '/../..' . '/src/rootfoo.php',
+        'Composer\\InstalledVersions' => __DIR__ . '/..' . '/composer/InstalledVersions.php',
     );
 
     public static function getInitializer(ClassLoader $loader)
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/classmap/BackslashLineEndingString.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/classmap/BackslashLineEndingString.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/classmap/BackslashLineEndingString.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/classmap/BackslashLineEndingString.php	2021-01-27 15:09:27.000000000 +0000
@@ -3,14 +3,14 @@
 namespace Foo;
 
 class SlashedA {
-    function foo() {
+    public function foo() {
         return sprintf("foo\
                         bar");
     }
 }
 
 class SlashedB {
-    function bar() {
+    public function bar() {
         print "baz";
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/platform/no_extensions_required.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/platform/no_extensions_required.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/platform/no_extensions_required.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/platform/no_extensions_required.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,26 @@
+<?php
+
+// platform_check.php @generated by Composer
+
+$issues = array();
+
+if (!(PHP_VERSION_ID >= 70200)) {
+    $issues[] = 'Your Composer dependencies require a PHP version ">= 7.2.0". You are running ' . PHP_VERSION . '.';
+}
+
+if ($issues) {
+    if (!headers_sent()) {
+        header('HTTP/1.1 500 Internal Server Error');
+    }
+    if (!ini_get('display_errors')) {
+        if (PHP_SAPI === 'cli' || PHP_SAPI === 'phpdbg') {
+            fwrite(STDERR, 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . implode(PHP_EOL, $issues) . PHP_EOL.PHP_EOL);
+        } elseif (!headers_sent()) {
+            echo 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . str_replace('You are running '.PHP_VERSION.'.', '', implode(PHP_EOL, $issues)) . PHP_EOL.PHP_EOL;
+        }
+    }
+    trigger_error(
+        'Composer detected issues in your platform: ' . implode(' ', $issues),
+        E_USER_ERROR
+    );
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/platform/no_php_required.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/platform/no_php_required.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/platform/no_php_required.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/platform/no_php_required.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,30 @@
+<?php
+
+// platform_check.php @generated by Composer
+
+$issues = array();
+
+$missingExtensions = array();
+extension_loaded('json') || $missingExtensions[] = 'json';
+extension_loaded('xml') || $missingExtensions[] = 'xml';
+
+if ($missingExtensions) {
+    $issues[] = 'Your Composer dependencies require the following PHP extensions to be installed: ' . implode(', ', $missingExtensions) . '.';
+}
+
+if ($issues) {
+    if (!headers_sent()) {
+        header('HTTP/1.1 500 Internal Server Error');
+    }
+    if (!ini_get('display_errors')) {
+        if (PHP_SAPI === 'cli' || PHP_SAPI === 'phpdbg') {
+            fwrite(STDERR, 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . implode(PHP_EOL, $issues) . PHP_EOL.PHP_EOL);
+        } elseif (!headers_sent()) {
+            echo 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . str_replace('You are running '.PHP_VERSION.'.', '', implode(PHP_EOL, $issues)) . PHP_EOL.PHP_EOL;
+        }
+    }
+    trigger_error(
+        'Composer detected issues in your platform: ' . implode(' ', $issues),
+        E_USER_ERROR
+    );
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/platform/no_php_upper_bound.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/platform/no_php_upper_bound.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/platform/no_php_upper_bound.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/platform/no_php_upper_bound.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,26 @@
+<?php
+
+// platform_check.php @generated by Composer
+
+$issues = array();
+
+if (!(PHP_VERSION_ID >= 70200)) {
+    $issues[] = 'Your Composer dependencies require a PHP version ">= 7.2.0". You are running ' . PHP_VERSION . '.';
+}
+
+if ($issues) {
+    if (!headers_sent()) {
+        header('HTTP/1.1 500 Internal Server Error');
+    }
+    if (!ini_get('display_errors')) {
+        if (PHP_SAPI === 'cli' || PHP_SAPI === 'phpdbg') {
+            fwrite(STDERR, 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . implode(PHP_EOL, $issues) . PHP_EOL.PHP_EOL);
+        } elseif (!headers_sent()) {
+            echo 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . str_replace('You are running '.PHP_VERSION.'.', '', implode(PHP_EOL, $issues)) . PHP_EOL.PHP_EOL;
+        }
+    }
+    trigger_error(
+        'Composer detected issues in your platform: ' . implode(' ', $issues),
+        E_USER_ERROR
+    );
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/platform/replaced_provided_exts.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/platform/replaced_provided_exts.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/platform/replaced_provided_exts.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/platform/replaced_provided_exts.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,29 @@
+<?php
+
+// platform_check.php @generated by Composer
+
+$issues = array();
+
+$missingExtensions = array();
+extension_loaded('pdo') || $missingExtensions[] = 'pdo';
+
+if ($missingExtensions) {
+    $issues[] = 'Your Composer dependencies require the following PHP extensions to be installed: ' . implode(', ', $missingExtensions) . '.';
+}
+
+if ($issues) {
+    if (!headers_sent()) {
+        header('HTTP/1.1 500 Internal Server Error');
+    }
+    if (!ini_get('display_errors')) {
+        if (PHP_SAPI === 'cli' || PHP_SAPI === 'phpdbg') {
+            fwrite(STDERR, 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . implode(PHP_EOL, $issues) . PHP_EOL.PHP_EOL);
+        } elseif (!headers_sent()) {
+            echo 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . str_replace('You are running '.PHP_VERSION.'.', '', implode(PHP_EOL, $issues)) . PHP_EOL.PHP_EOL;
+        }
+    }
+    trigger_error(
+        'Composer detected issues in your platform: ' . implode(' ', $issues),
+        E_USER_ERROR
+    );
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/platform/specific_php_release.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/platform/specific_php_release.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/platform/specific_php_release.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/platform/specific_php_release.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,26 @@
+<?php
+
+// platform_check.php @generated by Composer
+
+$issues = array();
+
+if (!(PHP_VERSION_ID >= 70208)) {
+    $issues[] = 'Your Composer dependencies require a PHP version ">= 7.2.8". You are running ' . PHP_VERSION . '.';
+}
+
+if ($issues) {
+    if (!headers_sent()) {
+        header('HTTP/1.1 500 Internal Server Error');
+    }
+    if (!ini_get('display_errors')) {
+        if (PHP_SAPI === 'cli' || PHP_SAPI === 'phpdbg') {
+            fwrite(STDERR, 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . implode(PHP_EOL, $issues) . PHP_EOL.PHP_EOL);
+        } elseif (!headers_sent()) {
+            echo 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . str_replace('You are running '.PHP_VERSION.'.', '', implode(PHP_EOL, $issues)) . PHP_EOL.PHP_EOL;
+        }
+    }
+    trigger_error(
+        'Composer detected issues in your platform: ' . implode(' ', $issues),
+        E_USER_ERROR
+    );
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/platform/typical.php 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/platform/typical.php
--- 1.10.19-1/tests/Composer/Test/Autoload/Fixtures/platform/typical.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Autoload/Fixtures/platform/typical.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,34 @@
+<?php
+
+// platform_check.php @generated by Composer
+
+$issues = array();
+
+if (!(PHP_VERSION_ID >= 70200)) {
+    $issues[] = 'Your Composer dependencies require a PHP version ">= 7.2.0". You are running ' . PHP_VERSION . '.';
+}
+
+$missingExtensions = array();
+extension_loaded('json') || $missingExtensions[] = 'json';
+extension_loaded('xml') || $missingExtensions[] = 'xml';
+
+if ($missingExtensions) {
+    $issues[] = 'Your Composer dependencies require the following PHP extensions to be installed: ' . implode(', ', $missingExtensions) . '.';
+}
+
+if ($issues) {
+    if (!headers_sent()) {
+        header('HTTP/1.1 500 Internal Server Error');
+    }
+    if (!ini_get('display_errors')) {
+        if (PHP_SAPI === 'cli' || PHP_SAPI === 'phpdbg') {
+            fwrite(STDERR, 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . implode(PHP_EOL, $issues) . PHP_EOL.PHP_EOL);
+        } elseif (!headers_sent()) {
+            echo 'Composer detected issues in your platform:' . PHP_EOL.PHP_EOL . str_replace('You are running '.PHP_VERSION.'.', '', implode(PHP_EOL, $issues)) . PHP_EOL.PHP_EOL;
+        }
+    }
+    trigger_error(
+        'Composer detected issues in your platform: ' . implode(' ', $issues),
+        E_USER_ERROR
+    );
+}
diff -pruN 1.10.19-1/tests/Composer/Test/CacheTest.php 2.0.9-1/tests/Composer/Test/CacheTest.php
--- 1.10.19-1/tests/Composer/Test/CacheTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/CacheTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,7 +12,7 @@
 
 namespace Composer\Test;
 
-use Composer\Test\TestCase;
+use Composer\Cache;
 use Composer\Util\Filesystem;
 
 class CacheTest extends TestCase
@@ -20,6 +20,7 @@ class CacheTest extends TestCase
     private $files;
     private $root;
     private $finder;
+    private $filesystem;
     private $cache;
 
     public function setUp()
@@ -34,6 +35,7 @@ class CacheTest extends TestCase
         }
 
         $this->finder = $this->getMockBuilder('Symfony\Component\Finder\Finder')->disableOriginalConstructor()->getMock();
+        $this->filesystem = $this->getMockBuilder('Composer\Util\Filesystem')->getMock();
 
         $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
         $this->cache = $this->getMockBuilder('Composer\Cache')
@@ -69,7 +71,7 @@ class CacheTest extends TestCase
         $this->cache->gc(600, 1024 * 1024 * 1024);
 
         for ($i = 1; $i < 4; $i++) {
-            $this->assertFileNotExists("{$this->root}/cached.file{$i}.zip");
+            $this->assertFileDoesNotExist("{$this->root}/cached.file{$i}.zip");
         }
         $this->assertFileExists("{$this->root}/cached.file0.zip");
     }
@@ -98,17 +100,15 @@ class CacheTest extends TestCase
         $this->cache->gc(600, 1500);
 
         for ($i = 0; $i < 3; $i++) {
-            $this->assertFileNotExists("{$this->root}/cached.file{$i}.zip");
+            $this->assertFileDoesNotExist("{$this->root}/cached.file{$i}.zip");
         }
         $this->assertFileExists("{$this->root}/cached.file3.zip");
     }
 
     public function testClearCache()
     {
+        $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
+        $this->cache = new Cache($io, $this->root, 'a-z0-9.', $this->filesystem);
         $this->assertTrue($this->cache->clear());
-
-        for ($i = 0; $i < 3; $i++) {
-            $this->assertFileNotExists("{$this->root}/cached.file{$i}.zip");
-        }
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Command/ArchiveCommandTest.php 2.0.9-1/tests/Composer/Test/Command/ArchiveCommandTest.php
--- 1.10.19-1/tests/Composer/Test/Command/ArchiveCommandTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Command/ArchiveCommandTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -95,9 +95,9 @@ class ArchiveCommandTest extends TestCas
                 null,
                 false,
                 null
-            );
+            )->willReturn(0);
         $command->method('isInteractive')->willReturn(false);
 
-        $command->run($input, $output);
+        $this->assertEquals(0, $command->run($input, $output));
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Command/InitCommandTest.php 2.0.9-1/tests/Composer/Test/Command/InitCommandTest.php
--- 1.10.19-1/tests/Composer/Test/Command/InitCommandTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Command/InitCommandTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -59,7 +59,7 @@ class InitCommandTest extends TestCase
     {
         $command = new InitCommand;
         $author = $command->parseAuthorString(
-                'Johnathon "Johnny" Smith <john@example.com>'
+            'Johnathon "Johnny" Smith <john@example.com>'
         );
         $this->assertEquals('Johnathon "Johnny" Smith', $author['name']);
         $this->assertEquals('john@example.com', $author['email']);
@@ -73,7 +73,7 @@ class InitCommandTest extends TestCase
     {
         $command = new InitCommand;
         $author = $command->parseAuthorString(
-                'Johnathon (Johnny) Smith <john@example.com>'
+            'Johnathon (Johnny) Smith <john@example.com>'
         );
         $this->assertEquals('Johnathon (Johnny) Smith', $author['name']);
         $this->assertEquals('john@example.com', $author['email']);
diff -pruN 1.10.19-1/tests/Composer/Test/Command/RunScriptCommandTest.php 2.0.9-1/tests/Composer/Test/Command/RunScriptCommandTest.php
--- 1.10.19-1/tests/Composer/Test/Command/RunScriptCommandTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Command/RunScriptCommandTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -66,7 +66,8 @@ class RunScriptCommandTest extends TestC
 
         $ed->expects($this->once())
             ->method('dispatchScript')
-            ->with($scriptName, $expectedDevMode, array());
+            ->with($scriptName, $expectedDevMode, array())
+            ->willReturn(0);
 
         $composer = $this->createComposerInstance();
         $composer->setEventDispatcher($ed);
diff -pruN 1.10.19-1/tests/Composer/Test/ComposerTest.php 2.0.9-1/tests/Composer/Test/ComposerTest.php
--- 1.10.19-1/tests/Composer/Test/ComposerTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/ComposerTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,7 +13,6 @@
 namespace Composer\Test;
 
 use Composer\Composer;
-use Composer\Test\TestCase;
 
 class ComposerTest extends TestCase
 {
@@ -57,7 +56,7 @@ class ComposerTest extends TestCase
     public function testSetGetInstallationManager()
     {
         $composer = new Composer();
-        $manager = $this->getMockBuilder('Composer\Installer\InstallationManager')->getMock();
+        $manager = $this->getMockBuilder('Composer\Installer\InstallationManager')->disableOriginalConstructor()->getMock();
         $composer->setInstallationManager($manager);
 
         $this->assertSame($manager, $composer->getInstallationManager());
diff -pruN 1.10.19-1/tests/Composer/Test/Config/Fixtures/removeLink/conflict-to-empty-after.json 2.0.9-1/tests/Composer/Test/Config/Fixtures/removeLink/conflict-to-empty-after.json
--- 1.10.19-1/tests/Composer/Test/Config/Fixtures/removeLink/conflict-to-empty-after.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Config/Fixtures/removeLink/conflict-to-empty-after.json	2021-01-27 15:09:27.000000000 +0000
@@ -1,6 +1,4 @@
 {
     "name": "my-vend/my-app",
-    "license": "MIT",
-    "conflict": {
-    }
+    "license": "MIT"
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Config/Fixtures/removeLink/provide-to-empty-after.json 2.0.9-1/tests/Composer/Test/Config/Fixtures/removeLink/provide-to-empty-after.json
--- 1.10.19-1/tests/Composer/Test/Config/Fixtures/removeLink/provide-to-empty-after.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Config/Fixtures/removeLink/provide-to-empty-after.json	2021-01-27 15:09:27.000000000 +0000
@@ -1,6 +1,4 @@
 {
     "name": "my-vend/my-app",
-    "license": "MIT",
-    "provide": {
-    }
+    "license": "MIT"
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Config/Fixtures/removeLink/replace-to-empty-after.json 2.0.9-1/tests/Composer/Test/Config/Fixtures/removeLink/replace-to-empty-after.json
--- 1.10.19-1/tests/Composer/Test/Config/Fixtures/removeLink/replace-to-empty-after.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Config/Fixtures/removeLink/replace-to-empty-after.json	2021-01-27 15:09:27.000000000 +0000
@@ -1,6 +1,4 @@
 {
     "name": "my-vend/my-app",
-    "license": "MIT",
-    "replace": {
-    }
+    "license": "MIT"
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Config/Fixtures/removeLink/require-dev-to-empty-after.json 2.0.9-1/tests/Composer/Test/Config/Fixtures/removeLink/require-dev-to-empty-after.json
--- 1.10.19-1/tests/Composer/Test/Config/Fixtures/removeLink/require-dev-to-empty-after.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Config/Fixtures/removeLink/require-dev-to-empty-after.json	2021-01-27 15:09:27.000000000 +0000
@@ -1,6 +1,4 @@
 {
     "name": "my-vend/my-app",
-    "license": "MIT",
-    "require-dev": {
-    }
+    "license": "MIT"
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Config/Fixtures/removeLink/require-to-empty-after.json 2.0.9-1/tests/Composer/Test/Config/Fixtures/removeLink/require-to-empty-after.json
--- 1.10.19-1/tests/Composer/Test/Config/Fixtures/removeLink/require-to-empty-after.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Config/Fixtures/removeLink/require-to-empty-after.json	2021-01-27 15:09:27.000000000 +0000
@@ -1,6 +1,4 @@
 {
     "name": "my-vend/my-app",
-    "license": "MIT",
-    "require": {
-    }
+    "license": "MIT"
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Config/Fixtures/removeLink/suggest-to-empty-after.json 2.0.9-1/tests/Composer/Test/Config/Fixtures/removeLink/suggest-to-empty-after.json
--- 1.10.19-1/tests/Composer/Test/Config/Fixtures/removeLink/suggest-to-empty-after.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Config/Fixtures/removeLink/suggest-to-empty-after.json	2021-01-27 15:09:27.000000000 +0000
@@ -1,6 +1,4 @@
 {
     "name": "my-vend/my-app",
-    "license": "MIT",
-    "suggest": {
-    }
+    "license": "MIT"
 }
diff -pruN 1.10.19-1/tests/Composer/Test/ConfigTest.php 2.0.9-1/tests/Composer/Test/ConfigTest.php
--- 1.10.19-1/tests/Composer/Test/ConfigTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/ConfigTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,7 +13,6 @@
 namespace Composer\Test;
 
 use Composer\Config;
-use Composer\Test\TestCase;
 
 class ConfigTest extends TestCase
 {
diff -pruN 1.10.19-1/tests/Composer/Test/Console/HtmlOutputFormatterTest.php 2.0.9-1/tests/Composer/Test/Console/HtmlOutputFormatterTest.php
--- 1.10.19-1/tests/Composer/Test/Console/HtmlOutputFormatterTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Console/HtmlOutputFormatterTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -24,7 +24,7 @@ class HtmlOutputFormatterTest extends Te
             'warning' => new OutputFormatterStyle('black', 'yellow'),
         ));
 
-        return $this->assertEquals(
+        $this->assertEquals(
             'text <span style="color:green;">green</span> <span style="color:yellow;">yellow</span> <span style="color:black;background-color:yellow;">black w/ yello bg</span>',
             $formatter->format('text <info>green</info> <comment>yellow</comment> <warning>black w/ yello bg</warning>')
         );
diff -pruN 1.10.19-1/tests/Composer/Test/DefaultConfigTest.php 2.0.9-1/tests/Composer/Test/DefaultConfigTest.php
--- 1.10.19-1/tests/Composer/Test/DefaultConfigTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DefaultConfigTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,7 +13,6 @@
 namespace Composer\Test;
 
 use Composer\Config;
-use Composer\Test\TestCase;
 
 class DefaultConfigTest extends TestCase
 {
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/DefaultPolicyTest.php 2.0.9-1/tests/Composer/Test/DependencyResolver/DefaultPolicyTest.php
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/DefaultPolicyTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/DefaultPolicyTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,30 +13,30 @@
 namespace Composer\Test\DependencyResolver;
 
 use Composer\Repository\ArrayRepository;
-use Composer\Repository\RepositoryInterface;
+use Composer\Repository\LockArrayRepository;
 use Composer\DependencyResolver\DefaultPolicy;
-use Composer\DependencyResolver\Pool;
 use Composer\Package\Link;
 use Composer\Package\AliasPackage;
+use Composer\Repository\RepositorySet;
 use Composer\Semver\Constraint\Constraint;
 use Composer\Test\TestCase;
 
 class DefaultPolicyTest extends TestCase
 {
-    /** @var Pool */
-    protected $pool;
+    /** @var RepositorySet */
+    protected $repositorySet;
     /** @var ArrayRepository */
     protected $repo;
-    /** @var ArrayRepository */
-    protected $repoInstalled;
+    /** @var LockArrayRepository */
+    protected $repoLocked;
     /** @var DefaultPolicy */
     protected $policy;
 
     public function setUp()
     {
-        $this->pool = new Pool('dev');
+        $this->repositorySet = new RepositorySet('dev');
         $this->repo = new ArrayRepository;
-        $this->repoInstalled = new ArrayRepository;
+        $this->repoLocked = new LockArrayRepository;
 
         $this->policy = new DefaultPolicy;
     }
@@ -44,12 +44,14 @@ class DefaultPolicyTest extends TestCase
     public function testSelectSingle()
     {
         $this->repo->addPackage($packageA = $this->getPackage('A', '1.0'));
-        $this->pool->addRepository($this->repo);
+        $this->repositorySet->addRepository($this->repo);
+
+        $pool = $this->repositorySet->createPoolForPackage('A', $this->repoLocked);
 
         $literals = array($packageA->getId());
         $expected = array($packageA->getId());
 
-        $selected = $this->policy->selectPreferredPackages($this->pool, array(), $literals);
+        $selected = $this->policy->selectPreferredPackages($pool, $literals);
 
         $this->assertSame($expected, $selected);
     }
@@ -58,12 +60,14 @@ class DefaultPolicyTest extends TestCase
     {
         $this->repo->addPackage($packageA1 = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($packageA2 = $this->getPackage('A', '2.0'));
-        $this->pool->addRepository($this->repo);
+        $this->repositorySet->addRepository($this->repo);
+
+        $pool = $this->repositorySet->createPoolForPackage('A', $this->repoLocked);
 
         $literals = array($packageA1->getId(), $packageA2->getId());
         $expected = array($packageA2->getId());
 
-        $selected = $this->policy->selectPreferredPackages($this->pool, array(), $literals);
+        $selected = $this->policy->selectPreferredPackages($pool, $literals);
 
         $this->assertSame($expected, $selected);
     }
@@ -72,12 +76,14 @@ class DefaultPolicyTest extends TestCase
     {
         $this->repo->addPackage($packageA1 = $this->getPackage('A', '1.0.0'));
         $this->repo->addPackage($packageA2 = $this->getPackage('A', '1.0.1-alpha'));
-        $this->pool->addRepository($this->repo);
+        $this->repositorySet->addRepository($this->repo);
+
+        $pool = $this->repositorySet->createPoolForPackage('A', $this->repoLocked);
 
         $literals = array($packageA1->getId(), $packageA2->getId());
         $expected = array($packageA2->getId());
 
-        $selected = $this->policy->selectPreferredPackages($this->pool, array(), $literals);
+        $selected = $this->policy->selectPreferredPackages($pool, $literals);
 
         $this->assertSame($expected, $selected);
     }
@@ -86,13 +92,15 @@ class DefaultPolicyTest extends TestCase
     {
         $this->repo->addPackage($packageA1 = $this->getPackage('A', '1.0.0'));
         $this->repo->addPackage($packageA2 = $this->getPackage('A', '1.0.1-alpha'));
-        $this->pool->addRepository($this->repo);
+        $this->repositorySet->addRepository($this->repo);
+
+        $pool = $this->repositorySet->createPoolForPackage('A', $this->repoLocked);
 
         $literals = array($packageA1->getId(), $packageA2->getId());
         $expected = array($packageA1->getId());
 
         $policy = new DefaultPolicy(true);
-        $selected = $policy->selectPreferredPackages($this->pool, array(), $literals);
+        $selected = $policy->selectPreferredPackages($pool, $literals);
 
         $this->assertSame($expected, $selected);
     }
@@ -101,46 +109,14 @@ class DefaultPolicyTest extends TestCase
     {
         $this->repo->addPackage($packageA1 = $this->getPackage('A', 'dev-foo'));
         $this->repo->addPackage($packageA2 = $this->getPackage('A', '1.0.0'));
-        $this->pool->addRepository($this->repo);
+        $this->repositorySet->addRepository($this->repo);
+
+        $pool = $this->repositorySet->createPoolForPackage('A', $this->repoLocked);
 
         $literals = array($packageA1->getId(), $packageA2->getId());
         $expected = array($packageA2->getId());
 
-        $selected = $this->policy->selectPreferredPackages($this->pool, array(), $literals);
-
-        $this->assertSame($expected, $selected);
-    }
-
-    public function testSelectNewestOverInstalled()
-    {
-        $this->repo->addPackage($packageA = $this->getPackage('A', '2.0'));
-        $this->repoInstalled->addPackage($packageAInstalled = $this->getPackage('A', '1.0'));
-        $this->pool->addRepository($this->repoInstalled);
-        $this->pool->addRepository($this->repo);
-
-        $literals = array($packageA->getId(), $packageAInstalled->getId());
-        $expected = array($packageA->getId());
-
-        $selected = $this->policy->selectPreferredPackages($this->pool, $this->mapFromRepo($this->repoInstalled), $literals);
-
-        $this->assertSame($expected, $selected);
-    }
-
-    public function testSelectFirstRepo()
-    {
-        $otherRepository = new ArrayRepository;
-
-        $this->repo->addPackage($packageA = $this->getPackage('A', '1.0'));
-        $otherRepository->addPackage($packageAImportant = $this->getPackage('A', '1.0'));
-
-        $this->pool->addRepository($this->repoInstalled);
-        $this->pool->addRepository($otherRepository);
-        $this->pool->addRepository($this->repo);
-
-        $literals = array($packageA->getId(), $packageAImportant->getId());
-        $expected = array($packageAImportant->getId());
-
-        $selected = $this->policy->selectPreferredPackages($this->pool, array(), $literals);
+        $selected = $this->policy->selectPreferredPackages($pool, $literals);
 
         $this->assertSame($expected, $selected);
     }
@@ -155,21 +131,25 @@ class DefaultPolicyTest extends TestCase
         $repo2->addPackage($package3 = $this->getPackage('A', '1.1'));
         $repo2->addPackage($package4 = $this->getPackage('A', '1.2'));
 
-        $this->pool->addRepository($repo1);
-        $this->pool->addRepository($repo2);
+        $this->repositorySet->addRepository($repo1);
+        $this->repositorySet->addRepository($repo2);
+
+        $pool = $this->repositorySet->createPoolForPackage('A', $this->repoLocked);
 
         $literals = array($package1->getId(), $package2->getId(), $package3->getId(), $package4->getId());
         $expected = array($package2->getId());
-        $selected = $this->policy->selectPreferredPackages($this->pool, array(), $literals);
+        $selected = $this->policy->selectPreferredPackages($pool, $literals);
 
         $this->assertSame($expected, $selected);
 
-        $this->pool = new Pool('dev');
-        $this->pool->addRepository($repo2);
-        $this->pool->addRepository($repo1);
+        $this->repositorySet = new RepositorySet('dev');
+        $this->repositorySet->addRepository($repo2);
+        $this->repositorySet->addRepository($repo1);
+
+        $pool = $this->repositorySet->createPoolForPackage('A', $this->repoLocked);
 
         $expected = array($package4->getId());
-        $selected = $this->policy->selectPreferredPackages($this->pool, array(), $literals);
+        $selected = $this->policy->selectPreferredPackages($pool, $literals);
 
         $this->assertSame($expected, $selected);
     }
@@ -186,11 +166,13 @@ class DefaultPolicyTest extends TestCase
         $repoImportant->addPackage($packageA2AliasImportant = new AliasPackage($packageA2Important, '2.1.9999999.9999999-dev', '2.1.x-dev'));
         $packageAAliasImportant->setRootPackageAlias(true);
 
-        $this->pool->addRepository($this->repoInstalled);
-        $this->pool->addRepository($repoImportant);
-        $this->pool->addRepository($this->repo);
+        $this->repositorySet->addRepository($repoImportant);
+        $this->repositorySet->addRepository($this->repo);
+        $this->repositorySet->addRepository($this->repoLocked);
 
-        $packages = $this->pool->whatProvides('a', new Constraint('=', '2.1.9999999.9999999-dev'));
+        $pool = $this->repositorySet->createPoolForPackage('A', $this->repoLocked);
+
+        $packages = $pool->whatProvides('a', new Constraint('=', '2.1.9999999.9999999-dev'));
         $literals = array();
         foreach ($packages as $package) {
             $literals[] = $package->getId();
@@ -198,7 +180,7 @@ class DefaultPolicyTest extends TestCase
 
         $expected = array($packageAAliasImportant->getId());
 
-        $selected = $this->policy->selectPreferredPackages($this->pool, array(), $literals);
+        $selected = $this->policy->selectPreferredPackages($pool, $literals);
 
         $this->assertSame($expected, $selected);
     }
@@ -208,15 +190,17 @@ class DefaultPolicyTest extends TestCase
         $this->repo->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($packageB = $this->getPackage('B', '2.0'));
 
-        $packageA->setProvides(array(new Link('A', 'X', new Constraint('==', '1.0'), 'provides')));
-        $packageB->setProvides(array(new Link('B', 'X', new Constraint('==', '1.0'), 'provides')));
+        $packageA->setProvides(array(new Link('A', 'X', new Constraint('==', '1.0'), Link::TYPE_PROVIDE)));
+        $packageB->setProvides(array(new Link('B', 'X', new Constraint('==', '1.0'), Link::TYPE_PROVIDE)));
+
+        $this->repositorySet->addRepository($this->repo);
 
-        $this->pool->addRepository($this->repo);
+        $pool = $this->repositorySet->createPoolForPackages(array('A', 'B'), $this->repoLocked);
 
         $literals = array($packageA->getId(), $packageB->getId());
         $expected = $literals;
 
-        $selected = $this->policy->selectPreferredPackages($this->pool, array(), $literals);
+        $selected = $this->policy->selectPreferredPackages($pool, $literals);
 
         $this->assertSame($expected, $selected);
     }
@@ -226,14 +210,16 @@ class DefaultPolicyTest extends TestCase
         $this->repo->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($packageB = $this->getPackage('B', '2.0'));
 
-        $packageB->setReplaces(array(new Link('B', 'A', new Constraint('==', '1.0'), 'replaces')));
+        $packageB->setReplaces(array(new Link('B', 'A', new Constraint('==', '1.0'), Link::TYPE_REPLACE)));
 
-        $this->pool->addRepository($this->repo);
+        $this->repositorySet->addRepository($this->repo);
+
+        $pool = $this->repositorySet->createPoolForPackages(array('A', 'B'), $this->repoLocked);
 
         $literals = array($packageA->getId(), $packageB->getId());
         $expected = $literals;
 
-        $selected = $this->policy->selectPreferredPackages($this->pool, array(), $literals);
+        $selected = $this->policy->selectPreferredPackages($pool, $literals);
 
         $this->assertSame($expected, $selected);
     }
@@ -244,15 +230,17 @@ class DefaultPolicyTest extends TestCase
         $this->repo->addPackage($packageB = $this->getPackage('vendor-b/replacer', '1.0'));
         $this->repo->addPackage($packageA = $this->getPackage('vendor-a/replacer', '1.0'));
 
-        $packageA->setReplaces(array(new Link('vendor-a/replacer', 'vendor-a/package', new Constraint('==', '1.0'), 'replaces')));
-        $packageB->setReplaces(array(new Link('vendor-b/replacer', 'vendor-a/package', new Constraint('==', '1.0'), 'replaces')));
+        $packageA->setReplaces(array(new Link('vendor-a/replacer', 'vendor-a/package', new Constraint('==', '1.0'), Link::TYPE_REPLACE)));
+        $packageB->setReplaces(array(new Link('vendor-b/replacer', 'vendor-a/package', new Constraint('==', '1.0'), Link::TYPE_REPLACE)));
+
+        $this->repositorySet->addRepository($this->repo);
 
-        $this->pool->addRepository($this->repo);
+        $pool = $this->repositorySet->createPoolForPackages(array('vendor-a/replacer', 'vendor-b/replacer'), $this->repoLocked);
 
         $literals = array($packageA->getId(), $packageB->getId());
         $expected = $literals;
 
-        $selected = $this->policy->selectPreferredPackages($this->pool, array(), $literals, 'vendor-a/package');
+        $selected = $this->policy->selectPreferredPackages($pool, $literals, 'vendor-a/package');
         $this->assertEquals($expected, $selected);
 
         // test with reversed order in repo
@@ -260,38 +248,32 @@ class DefaultPolicyTest extends TestCase
         $repo->addPackage($packageA = clone $packageA);
         $repo->addPackage($packageB = clone $packageB);
 
-        $pool = new Pool('dev');
-        $pool->addRepository($this->repo);
+        $repositorySet = new RepositorySet('dev');
+        $repositorySet->addRepository($this->repo);
+
+        $pool = $this->repositorySet->createPoolForPackages(array('vendor-a/replacer', 'vendor-b/replacer'), $this->repoLocked);
 
         $literals = array($packageA->getId(), $packageB->getId());
         $expected = $literals;
 
-        $selected = $this->policy->selectPreferredPackages($this->pool, array(), $literals, 'vendor-a/package');
+        $selected = $this->policy->selectPreferredPackages($pool, $literals, 'vendor-a/package');
         $this->assertSame($expected, $selected);
     }
 
-    protected function mapFromRepo(RepositoryInterface $repo)
-    {
-        $map = array();
-        foreach ($repo->getPackages() as $package) {
-            $map[$package->getId()] = true;
-        }
-
-        return $map;
-    }
-
     public function testSelectLowest()
     {
         $policy = new DefaultPolicy(false, true);
 
         $this->repo->addPackage($packageA1 = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($packageA2 = $this->getPackage('A', '2.0'));
-        $this->pool->addRepository($this->repo);
+        $this->repositorySet->addRepository($this->repo);
+
+        $pool = $this->repositorySet->createPoolForPackage('A', $this->repoLocked);
 
         $literals = array($packageA1->getId(), $packageA2->getId());
         $expected = array($packageA1->getId());
 
-        $selected = $policy->selectPreferredPackages($this->pool, array(), $literals);
+        $selected = $policy->selectPreferredPackages($pool, $literals);
 
         $this->assertSame($expected, $selected);
     }
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/alias-priority-conflicting.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/alias-priority-conflicting.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/alias-priority-conflicting.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/alias-priority-conflicting.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,62 @@
+--TEST--
+Check root aliases are loaded
+
+--ROOT--
+{
+    "minimum-stability": "dev",
+    "aliases": [
+        {
+            "package": "req/pkg",
+            "version": "dev-feature-foo",
+            "alias": "dev-master"
+        }
+    ]
+}
+
+
+--REQUEST--
+{
+    "require": {
+        "package/a": "dev-master",
+        "req/pkg": "dev-feature-foo"
+    }
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {
+            "name": "req/pkg", "version": "dev-feature-foo",
+            "source": { "reference": "feat.f", "type": "git", "url": "" }
+        },
+        {
+            "name": "req/pkg", "version": "dev-master",
+            "extra": { "branch-alias": { "dev-master": "1.0.x-dev" } },
+            "source": { "reference": "forked", "type": "git", "url": "" },
+            "default-branch": true
+        },
+        {
+            "name": "req/pkg", "version": "dev-master",
+            "extra": { "branch-alias": { "dev-master": "1.0.x-dev" } },
+            "source": { "reference": "master", "type": "git", "url": "" },
+            "default-branch": true
+        },
+        {
+            "name": "package/a", "version": "dev-master",
+            "require": { "req/pkg": "dev-master" },
+            "default-branch": true
+        }
+    ]
+]
+
+--EXPECT--
+[
+    "req/pkg-dev-feature-foo#feat.f",
+    "req/pkg-dev-master#feat.f (alias of dev-feature-foo)",
+    "package/a-dev-master",
+    "package/a-9999999-dev (alias of dev-master)"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/alias-with-reference.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/alias-with-reference.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/alias-with-reference.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/alias-with-reference.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,59 @@
+--TEST--
+Check root aliases get selected correctly
+
+--ROOT--
+{
+    "stability-flags": {
+        "a/aliased": "dev"
+    },
+    "aliases": [
+        {
+            "package": "a/aliased",
+            "version": "dev-master",
+            "alias": "1.0.0"
+        }
+    ],
+    "references": {
+        "a/aliased": "abcd"
+    }
+}
+
+
+--REQUEST--
+{
+    "require": {
+        "a/aliased": "dev-master",
+        "b/requirer": "*"
+    }
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {
+            "name": "a/aliased", "version": "dev-master",
+            "source": { "reference": "orig", "type": "git", "url": "" },
+            "default-branch": true
+        },
+        {
+            "name": "a/aliased", "version": "1.0"
+        },
+        {
+            "name": "b/requirer", "version": "1.0.0",
+            "require": { "a/aliased": "1.0.0" },
+            "source": { "reference": "1.0.0", "type": "git", "url": "" }
+        }
+    ]
+]
+
+--EXPECT--
+[
+    "a/aliased-dev-master#abcd",
+    "a/aliased-1.0.0.0#abcd (alias of dev-master)",
+    "b/requirer-1.0.0.0#1.0.0",
+    "a/aliased-9999999-dev#abcd (alias of dev-master)"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/constraint-expansion-works-with-exact-versions.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/constraint-expansion-works-with-exact-versions.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/constraint-expansion-works-with-exact-versions.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/constraint-expansion-works-with-exact-versions.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,31 @@
+--TEST--
+Tests if version constraint is expanded. If not, dep/dep 3.0.0 would not be loaded here.
+
+--REQUEST--
+{
+    "require": {
+        "root/req": "*"
+    }
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "root/req", "version": "1.0.0", "require": {"dep/dep": "2.3.4"}},
+        {"name": "dep/dep", "version": "2.3.4", "require": {"dep/dep2": "2.*"}},
+        {"name": "dep/dep", "version": "2.3.5"},
+        {"name": "dep/dep2", "version": "2.3.4", "require": {"dep/dep": "2.*"}}
+    ]
+]
+
+--EXPECT--
+[
+    "root/req-1.0.0.0",
+    "dep/dep-2.3.4.0",
+    "dep/dep2-2.3.4.0",
+    "dep/dep-2.3.5.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/fixed-packages-do-not-load-from-repos.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/fixed-packages-do-not-load-from-repos.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/fixed-packages-do-not-load-from-repos.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/fixed-packages-do-not-load-from-repos.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,36 @@
+--TEST--
+Fixed packages do not get loaded from the repos
+
+--REQUEST--
+{
+    "require": {
+        "some/pkg": "*",
+        "root/req": "*"
+    }
+}
+
+--FIXED--
+[
+    {"name": "some/pkg", "version": "1.0.3", "id": 1},
+    {"name": "dep/dep", "version": "2.1.5", "id": 2}
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "some/pkg", "version": "1.0.0"},
+        {"name": "some/pkg", "version": "1.1.0"},
+        {"name": "root/req", "version": "1.0.0", "require": {"dep/dep": "2.*"}},
+        {"name": "root/req", "version": "2.0.0", "require": {"dep/dep": "3.*"}},
+        {"name": "dep/dep", "version": "2.3.4"},
+        {"name": "dep/dep", "version": "3.0.1"}
+    ]
+]
+
+--EXPECT--
+[
+    1,
+    2,
+    "root/req-1.0.0.0",
+    "root/req-2.0.0.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/fixed-packages-replaced-do-not-load-from-repos.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/fixed-packages-replaced-do-not-load-from-repos.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/fixed-packages-replaced-do-not-load-from-repos.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/fixed-packages-replaced-do-not-load-from-repos.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,33 @@
+--TEST--
+Packages replaced by fixed packages do not get loaded from the repos
+
+--REQUEST--
+{
+    "require": {
+        "some/pkg": "*",
+        "root/req": "*"
+    }
+}
+
+--FIXED--
+[
+    {"name": "some/pkg", "version": "1.0.3", "replace": {"dep/dep": "2.1.0"}, "id": 1}
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "some/pkg", "version": "1.0.0"},
+        {"name": "root/req", "version": "1.0.0", "require": {"dep/dep": "2.*"}},
+        {"name": "root/req", "version": "2.0.0", "require": {"dep/dep": "3.*"}},
+        {"name": "dep/dep", "version": "2.3.4"},
+        {"name": "dep/dep", "version": "3.0.1"}
+    ]
+]
+
+--EXPECT--
+[
+    1,
+    "root/req-1.0.0.0",
+    "root/req-2.0.0.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/multi-repo-replace-partial-update.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/multi-repo-replace-partial-update.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/multi-repo-replace-partial-update.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/multi-repo-replace-partial-update.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,107 @@
+--TEST--
+Check that replacers from additional repositories are loaded when doing a partial update
+
+--REQUEST--
+{
+    "require": {
+        "base/package": "^1.0",
+        "indirect/replacer": "^1.0"
+    },
+    "locked": [
+        {"name": "shared/dep", "version": "1.2.0", "id": 1},
+        {"name": "indirect/replacer", "version": "1.2.0", "require": {"replacer/package": "^1.2"}, "id": 2},
+        {"name": "replacer/package", "version": "1.2.0", "require": {"shared/dep": "^1.1"}, "replace": {"base/package": "1.2.0"}, "id": 3}
+    ],
+    "allowList": [
+        "indirect/replacer"
+    ],
+    "allowTransitiveDepsNoRootRequire": true
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {
+            "name": "base/package",
+            "version": "1.0.0",
+            "require": {
+                "shared/dep": "^1.2"
+            }
+        },
+        {
+            "name": "shared/dep",
+            "version": "1.0.0"
+        },
+        {
+            "name": "shared/dep",
+            "version": "1.2.0"
+        }
+    ],
+    [
+        {
+            "name": "base/package",
+            "version": "1.1.0"
+        },
+        {
+            "name": "shared/dep",
+            "version": "1.3.0"
+        }
+    ],
+    {
+        "canonical": false,
+        "packages": [
+            {
+                "name": "indirect/replacer",
+                "version": "1.2.0",
+                "require": {
+                    "replacer/package": "^1.2"
+                }
+            },
+            {
+                "name": "replacer/package",
+                "version": "1.2.0",
+                "require": {
+                    "shared/dep": "^1.1"
+                }
+            },
+            {
+                "name": "shared/dep",
+                "version": "1.1.0"
+            }
+        ]
+    },
+    [
+        {
+            "name": "replacer/package",
+            "version": "1.0.0",
+            "require": {
+                "shared/dep": "^1.0"
+            },
+            "replace": {
+                "base/package": "1.0.0"
+            }
+        },
+        {
+            "name": "indirect/replacer",
+            "version": "1.0.0",
+            "require": {
+                "replacer/package": "^1.0"
+            }
+        }
+    ]
+]
+
+--EXPECT--
+[
+    "indirect/replacer-1.2.0.0",
+    "indirect/replacer-1.0.0.0",
+    "replacer/package-1.2.0.0",
+    "replacer/package-1.0.0.0",
+    "base/package-1.0.0.0",
+    "shared/dep-1.0.0.0",
+    "shared/dep-1.2.0.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/multi-repo-replace.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/multi-repo-replace.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/multi-repo-replace.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/multi-repo-replace.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,98 @@
+--TEST--
+Check that replacers from additional repositories are loaded
+
+--REQUEST--
+{
+    "require": {
+        "base/package": "^1.0",
+        "indirect/replacer": "^1.0"
+    }
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {
+            "name": "base/package",
+            "version": "1.0.0",
+            "require": {
+                "shared/dep": "^1.2"
+            }
+        },
+        {
+            "name": "shared/dep",
+            "version": "1.0.0"
+        },
+        {
+            "name": "shared/dep",
+            "version": "1.2.0"
+        }
+    ],
+    [
+        {
+            "name": "base/package",
+            "version": "1.1.0"
+        },
+        {
+            "name": "shared/dep",
+            "version": "1.3.0"
+        }
+    ],
+    {
+        "canonical": false,
+        "packages": [
+            {
+                "name": "indirect/replacer",
+                "version": "1.2.0",
+                "require": {
+                    "replacer/package": "^1.2"
+                }
+            },
+            {
+                "name": "replacer/package",
+                "version": "1.2.0",
+                "require": {
+                    "shared/dep": "^1.1"
+                }
+            },
+            {
+                "name": "shared/dep",
+                "version": "1.1.0"
+            }
+        ]
+    },
+    [
+        {
+            "name": "replacer/package",
+            "version": "1.0.0",
+            "require": {
+                "shared/dep": "^1.0"
+            },
+            "replace": {
+                "base/package": "1.2.0"
+            }
+        },
+        {
+            "name": "indirect/replacer",
+            "version": "1.0.0",
+            "require": {
+                "replacer/package": "^1.0"
+            }
+        }
+    ]
+]
+
+--EXPECT--
+[
+    "base/package-1.0.0.0",
+    "indirect/replacer-1.2.0.0",
+    "indirect/replacer-1.0.0.0",
+    "shared/dep-1.2.0.0",
+    "replacer/package-1.2.0.0",
+    "replacer/package-1.0.0.0",
+    "shared/dep-1.0.0.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/must-expand-root-reqs.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/must-expand-root-reqs.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/must-expand-root-reqs.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/must-expand-root-reqs.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,36 @@
+--TEST--
+Fixed packages do not get loaded from the repos
+
+--REQUEST--
+{
+    "require": {
+        "some/pkg": "*",
+        "root/req": "*"
+    }
+}
+
+--FIXED--
+[
+    {"name": "some/pkg", "version": "1.0.3", "id": 1},
+    {"name": "dep/dep", "version": "2.1.5", "id": 2}
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "some/pkg", "version": "1.0.0"},
+        {"name": "some/pkg", "version": "1.1.0"},
+        {"name": "root/req", "version": "1.0.0", "require": {"dep/dep": "2.*"}},
+        {"name": "root/req", "version": "2.0.0", "require": {"dep/dep": "3.*"}},
+        {"name": "dep/dep", "version": "2.3.4"},
+        {"name": "dep/dep", "version": "3.0.1"}
+    ]
+]
+
+--EXPECT--
+[
+    1,
+    2,
+    "root/req-1.0.0.0",
+    "root/req-2.0.0.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/packages-that-do-not-exist.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/packages-that-do-not-exist.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/packages-that-do-not-exist.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/packages-that-do-not-exist.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,27 @@
+--TEST--
+Test package is not found
+
+--REQUEST--
+{
+    "require": {
+        "root/req": "*"
+    }
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "root/req", "version": "1.0.0", "require": {"dep/dep": "2.*"}},
+        {"name": "dep/dep", "version": "2.3.4", "require": {"dep/dep3": "2.*"}}
+    ]
+]
+
+--EXPECT--
+[
+    "root/req-1.0.0.0",
+    "dep/dep-2.3.4.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/package-versions-are-not-loaded-if-not-required-expansion.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/package-versions-are-not-loaded-if-not-required-expansion.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/package-versions-are-not-loaded-if-not-required-expansion.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/package-versions-are-not-loaded-if-not-required-expansion.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,34 @@
+--TEST--
+Tests if version constraint is expanded. If not, dep/dep 3.0.0 would not be loaded here.
+
+--REQUEST--
+{
+    "require": {
+        "root/req": "*"
+    }
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "root/req", "version": "1.0.0", "require": {"dep/dep": "2.*"}},
+        {"name": "dep/dep", "version": "2.3.4", "require": {"dep/dep2": "2.*"}},
+        {"name": "dep/dep", "version": "2.3.5"},
+        {"name": "dep/dep", "version": "3.0.0"},
+        {"name": "dep/dep", "version": "4.0.0"},
+        {"name": "dep/dep2", "version": "2.3.4", "require": {"dep/dep": "3.*"}}
+    ]
+]
+
+--EXPECT--
+[
+    "root/req-1.0.0.0",
+    "dep/dep-2.3.4.0",
+    "dep/dep-2.3.5.0",
+    "dep/dep2-2.3.4.0",
+    "dep/dep-3.0.0.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/package-versions-are-not-loaded-if-not-required-recursive.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/package-versions-are-not-loaded-if-not-required-recursive.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/package-versions-are-not-loaded-if-not-required-recursive.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/package-versions-are-not-loaded-if-not-required-recursive.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,31 @@
+--TEST--
+Test irrelevant package versions are not loaded recursively
+
+--REQUEST--
+{
+    "require": {
+        "root/req": "*"
+    }
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "root/req", "version": "1.0.0", "require": {"dep/dep": "2.*"}},
+        {"name": "dep/dep", "version": "2.3.4", "require": {"dep/dep2": "2.*"}},
+        {"name": "dep/dep", "version": "3.0.1"},
+        {"name": "dep/dep2", "version": "2.3.4"},
+        {"name": "dep/dep2", "version": "3.0.1"}
+    ]
+]
+
+--EXPECT--
+[
+    "root/req-1.0.0.0",
+    "dep/dep-2.3.4.0",
+    "dep/dep2-2.3.4.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,39 @@
+--TEST--
+Partially updating a root requirement without deps, still selects a new dependency if the update results in a replacement missing for another locked package.
+
+--REQUEST--
+{
+    "require": {
+        "some/pkg": "*",
+        "root/req": "*"
+    },
+    "locked": [
+        {"name": "some/pkg", "version": "1.0.3", "replace": {"dep/dep": "2.1.0"}, "id": 1},
+        {"name": "root/req", "version": "1.0.0", "require": {"dep/dep": "2.*"}, "id": 2}
+    ],
+    "allowList": [
+        "some/pkg"
+    ]
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "some/pkg", "version": "1.0.4"},
+        {"name": "root/req", "version": "1.0.0", "require": {"dep/dep": "2.*"}},
+        {"name": "root/req", "version": "2.0.0", "require": {"dep/dep": "3.*"}},
+        {"name": "dep/dep", "version": "2.3.4"},
+        {"name": "dep/dep", "version": "3.0.1"}
+    ]
+]
+
+--EXPECT--
+[
+    2,
+   "some/pkg-1.0.4.0",
+   "dep/dep-2.3.4.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-transitive-deps-no-root-unfix.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-transitive-deps-no-root-unfix.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-transitive-deps-no-root-unfix.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-transitive-deps-no-root-unfix.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,49 @@
+--TEST--
+Partially updating one root requirement with transitive deps without root requirements keeps the other root requirement fixed.
+
+--REQUEST--
+{
+    "require": {
+        "root/update": "*",
+        "root/fix": "*"
+    },
+    "locked": [
+        {"name": "root/update", "version": "1.0.1", "require": {"dep/dep": "1.*", "dep2/dep2": "1.*"}, "id": 1},
+        {"name": "dep/dep", "version": "1.0.2", "require": {"root/fix": "1.*"}, "id": 2},
+        {"name": "dep2/dep2", "version": "1.0.2", "require": {"dep/dep": "1.*"}, "id": 3},
+        {"name": "root/fix", "version": "1.0.3", "id": 4}
+    ],
+    "allowList": [
+        "root/update"
+    ],
+    "allowTransitiveDepsNoRootRequire": true
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "root/update", "version": "1.0.4", "require": {"dep/dep": "1.*", "dep2/dep2": "1.*"}},
+        {"name": "root/update", "version": "1.0.5", "require": {"dep/dep": "2.*", "dep2/dep2": "2.*"}},
+        {"name": "root/fix", "version": "1.0.6"},
+        {"name": "root/fix", "version": "2.0.7"},
+        {"name": "dep/dep", "version": "1.0.8", "require": {"root/fix": "1.*"}},
+        {"name": "dep/dep", "version": "2.0.9", "require": {"root/fix": "2.*"}},
+        {"name": "dep2/dep2", "version": "1.0.8", "require": {"dep/dep": "1.*"}},
+        {"name": "dep2/dep2", "version": "2.0.9", "require": {"dep/dep": "2.*"}}
+    ]
+]
+
+--EXPECT--
+[
+    4,
+   "root/update-1.0.4.0",
+   "root/update-1.0.5.0",
+   "dep/dep-1.0.8.0",
+   "dep/dep-2.0.9.0",
+   "dep2/dep2-1.0.8.0",
+   "dep2/dep2-2.0.9.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-transitive-deps-unfix.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-transitive-deps-unfix.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-transitive-deps-unfix.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-transitive-deps-unfix.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,50 @@
+--TEST--
+Partially updating one root requirement with transitive deps fully updates another one too.
+
+--REQUEST--
+{
+    "require": {
+        "root/update": "*",
+        "root/dep": "1.0.*",
+        "root/dep2": "*"
+    },
+    "locked": [
+        {"name": "root/update", "version": "1.0.1", "require": {"dep/dep": "1.*"}},
+        {"name": "dep/dep", "version": "1.0.2", "require": {"root/dep": "1.*", "root/dep2": "1.*"}},
+        {"name": "root/dep", "version": "1.0.3"},
+        {"name": "root/dep2", "version": "1.0.3"}
+    ],
+    "allowList": [
+        "root/update"
+    ],
+    "allowTransitiveDeps": true
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "root/update", "version": "1.0.4", "require": {"dep/dep": "1.*"}},
+        {"name": "root/update", "version": "1.0.5", "require": {"dep/dep": "2.*"}},
+        {"name": "root/dep", "version": "1.0.6"},
+        {"name": "root/dep", "version": "2.0.7"},
+        {"name": "root/dep2", "version": "1.0.6"},
+        {"name": "root/dep2", "version": "2.0.7"},
+        {"name": "dep/dep", "version": "1.0.8", "require": {"root/dep": "1.*", "root/dep2": "1.*"}},
+        {"name": "dep/dep", "version": "2.0.9", "require": {"root/dep": "2.*", "root/dep2": "2.*"}}
+    ]
+]
+
+--EXPECT--
+[
+   "root/update-1.0.4.0",
+   "root/update-1.0.5.0",
+   "dep/dep-1.0.8.0",
+   "dep/dep-2.0.9.0",
+   "root/dep-1.0.6.0",
+   "root/dep2-1.0.6.0",
+   "root/dep2-2.0.7.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-unfixing-locked-deps.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-unfixing-locked-deps.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-unfixing-locked-deps.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-unfixing-locked-deps.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,50 @@
+--TEST--
+Unlocking a package also unlocks its dependencies when transitive deps are true. But version constraints from other
+locked packages still need to be taking into account for loading all necessary versions of these transitive deps.
+
+--REQUEST--
+{
+    "require": {
+        "root/req1": "*",
+        "root/req2": "*"
+    },
+    "locked": [
+        {"name": "root/req1", "version": "1.0.0", "require": {"dep/pkg1": "1.*"}},
+        {"name": "root/req2", "version": "1.0.0", "require": {"dep/pkg2": "1.*"}},
+        {"name": "dep/pkg1", "version": "1.0.0", "author": "old"},
+        {"name": "dep/pkg2", "version": "1.0.0"}
+    ],
+    "allowList": [
+        "dep/pkg2"
+    ],
+    "allowTransitiveDeps": true
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "root/req1", "version": "1.0.0", "require": {"dep/pkg1": "1.*"}},
+        {"name": "root/req2", "version": "1.0.0", "require": {"dep/pkg2": "1.*"}},
+        {"name": "dep/pkg1", "version": "1.0.0", "author": "new"},
+        {"name": "dep/pkg1", "version": "1.0.1"},
+        {"name": "dep/pkg1", "version": "2.0.0"},
+        {"name": "dep/pkg1", "version": "3.0.0"},
+        {"name": "dep/pkg2", "version": "1.0.0"},
+        {"name": "dep/pkg2", "version": "1.2.0", "require": {"dep/pkg1": "2.*"}}
+    ]
+]
+
+--EXPECT--
+[
+    "root/req1-1.0.0.0 (locked)",
+    "root/req2-1.0.0.0 (locked)",
+    "dep/pkg2-1.0.0.0",
+    "dep/pkg2-1.2.0.0",
+    "dep/pkg1-1.0.0.0",
+    "dep/pkg1-1.0.1.0",
+    "dep/pkg1-2.0.0.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-unfixing-with-replacers.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-unfixing-with-replacers.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-unfixing-with-replacers.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/partial-update-unfixing-with-replacers.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,52 @@
+--TEST--
+Fixed packages and replacers get unfixed correctly (refs https://github.com/composer/composer/pull/8942)
+
+--REQUEST--
+{
+    "require": {
+        "root/req1": "*",
+        "root/req3": "*"
+    },
+    "locked": [
+        {"name": "root/req1", "version": "1.0.0", "require": {"replacer/pkg": "1.*"}},
+        {"name": "root/req3", "version": "1.0.0", "require": {"replaced/pkg": "1.*", "dep/dep": "2.*"}},
+        {"name": "replacer/pkg", "version": "1.0.0", "replace": {"replaced/pkg": "*"}},
+        {"name": "dep/dep", "version": "2.3.5"}
+    ],
+    "allowList": [
+        "root/req1"
+    ],
+    "allowTransitiveDeps": true
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "root/req1", "version": "1.0.0", "require": {"replacer/pkg": "1.*"}},
+        {"name": "root/req1", "version": "1.1.0", "require": {"replacer/pkg": "1.*"}},
+        {"name": "root/req3", "version": "1.0.0", "require": {"replaced/pkg": "1.*"}},
+        {"name": "root/req3", "version": "1.1.0", "require": {"replaced/pkg": "1.*"}},
+        {"name": "replacer/pkg", "version": "1.0.0", "replace": {"replaced/pkg": "*"}},
+        {"name": "replacer/pkg", "version": "1.1.0", "replace": {"replaced/pkg": "*"}},
+        {"name": "replaced/pkg", "version": "1.2.3"},
+        {"name": "replaced/pkg", "version": "1.2.4"},
+        {"name": "dep/dep", "version": "2.3.5"},
+        {"name": "dep/dep", "version": "2.3.6"}
+    ]
+]
+
+--EXPECT--
+[
+    "root/req3-1.0.0.0 (locked)",
+    "dep/dep-2.3.5.0 (locked)",
+    "root/req1-1.0.0.0",
+    "root/req1-1.1.0.0",
+    "replacer/pkg-1.0.0.0",
+    "replacer/pkg-1.1.0.0",
+    "replaced/pkg-1.2.3.0",
+    "replaced/pkg-1.2.4.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/root-requirements-avoid-loading-further-versions.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/root-requirements-avoid-loading-further-versions.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/root-requirements-avoid-loading-further-versions.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/root-requirements-avoid-loading-further-versions.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,30 @@
+--TEST--
+Root requirements avoid loading of further versions
+
+--REQUEST--
+{
+    "require": {
+        "foo/bar": "1.0.0",
+        "foo/requirer": "*"
+    }
+}
+
+--FIXED--
+[
+]
+
+--PACKAGE-REPOS--
+[
+    [
+        { "name": "foo/bar", "version": "1.0.0" },
+        { "name": "foo/bar", "version": "2.0.0" },
+        { "name": "foo/bar", "version": "3.0.0" },
+        { "name": "foo/requirer", "version": "1.0.0", "require": { "foo/bar": "*" } }
+    ]
+]
+
+--EXPECT--
+[
+    "foo/bar-1.0.0.0",
+    "foo/requirer-1.0.0.0"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/stability-flags-take-over-minimum-stability-and-filter-packages.test 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/stability-flags-take-over-minimum-stability-and-filter-packages.test
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/stability-flags-take-over-minimum-stability-and-filter-packages.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/Fixtures/poolbuilder/stability-flags-take-over-minimum-stability-and-filter-packages.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,48 @@
+--TEST--
+Stability flags apply
+
+--ROOT--
+{
+    "stability-flags": {
+        "flagged/pkg": "alpha"
+    },
+    "minimum-stability": "RC",
+    "aliases": [
+        {
+            "package": "default/pkg",
+            "version": "1.0.0-RC",
+            "alias": "1.2.0"
+        }
+    ]
+}
+
+--REQUEST--
+{
+    "require": {
+        "flagged/pkg": "*",
+        "default/pkg": "*"
+    }
+}
+
+--PACKAGE-REPOS--
+[
+    [
+        {"name": "flagged/pkg", "version": "1.0.0", "id": 1},
+        {"name": "flagged/pkg", "version": "1.0.0-beta", "id": 2},
+        {"name": "flagged/pkg", "version": "1.0.0-dev", "id": 3},
+        {"name": "flagged/pkg", "version": "1.0.0-RC", "id": 4},
+        {"name": "default/pkg", "version": "1.0.0", "id": 5},
+        {"name": "default/pkg", "version": "1.0.0-RC", "id": 6},
+        {"name": "default/pkg", "version": "1.0.0-alpha", "id": 7}
+    ]
+]
+
+--EXPECT--
+[
+    1,
+    2,
+    4,
+    5,
+    6,
+    "default/pkg-1.2.0.0 (alias of 6)"
+]
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/PoolBuilderTest.php 2.0.9-1/tests/Composer/Test/DependencyResolver/PoolBuilderTest.php
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/PoolBuilderTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/PoolBuilderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,226 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\DependencyResolver;
+
+use Composer\IO\NullIO;
+use Composer\Repository\ArrayRepository;
+use Composer\Repository\FilterRepository;
+use Composer\Repository\LockArrayRepository;
+use Composer\DependencyResolver\Request;
+use Composer\Package\BasePackage;
+use Composer\Package\AliasPackage;
+use Composer\Json\JsonFile;
+use Composer\Package\Loader\ArrayLoader;
+use Composer\Package\Version\VersionParser;
+use Composer\Repository\RepositorySet;
+use Composer\Test\TestCase;
+
+class PoolBuilderTest extends TestCase
+{
+    /**
+     * @dataProvider getIntegrationTests
+     */
+    public function testPoolBuilder($file, $message, $expect, $root, $requestData, $packageRepos, $fixed)
+    {
+        $rootAliases = !empty($root['aliases']) ? $root['aliases'] : array();
+        $minimumStability = !empty($root['minimum-stability']) ? $root['minimum-stability'] : 'stable';
+        $stabilityFlags = !empty($root['stability-flags']) ? $root['stability-flags'] : array();
+        $rootReferences = !empty($root['references']) ? $root['references'] : array();
+        $stabilityFlags = array_map(function ($stability) {
+            return BasePackage::$stabilities[$stability];
+        }, $stabilityFlags);
+
+        $parser = new VersionParser();
+        foreach ($rootAliases as $index => $alias) {
+            $rootAliases[$index]['version'] = $parser->normalize($alias['version']);
+            $rootAliases[$index]['alias_normalized'] = $parser->normalize($alias['alias']);
+        }
+
+        $loader = new ArrayLoader();
+        $packageIds = array();
+        $loadPackage = function ($data) use ($loader, &$packageIds) {
+            if (!empty($data['id'])) {
+                $id = $data['id'];
+                unset($data['id']);
+            }
+
+            $pkg = $loader->load($data);
+
+            if (!empty($id)) {
+                if (!empty($packageIds[$id])) {
+                    throw new \LogicException('Duplicate package id '.$id.' defined');
+                }
+                $packageIds[$id] = $pkg;
+            }
+
+            return $pkg;
+        };
+
+        $repositorySet = new RepositorySet($minimumStability, $stabilityFlags, $rootAliases, $rootReferences);
+        foreach ($packageRepos as $packages) {
+            $repo = new ArrayRepository();
+            if (isset($packages['canonical']) || isset($packages['only']) || isset($packages['exclude'])) {
+                $options = $packages;
+                $packages = $options['packages'];
+                unset($options['packages']);
+                $repositorySet->addRepository(new FilterRepository($repo, $options));
+            } else {
+                $repositorySet->addRepository($repo);
+            }
+            foreach ($packages as $package) {
+                $repo->addPackage($loadPackage($package));
+            }
+        }
+        $repositorySet->addRepository($lockedRepo = new LockArrayRepository());
+
+        if (isset($requestData['locked'])) {
+            foreach ($requestData['locked'] as $package) {
+                $lockedRepo->addPackage($loadPackage($package));
+            }
+        }
+        $request = new Request($lockedRepo);
+        foreach ($requestData['require'] as $package => $constraint) {
+            $request->requireName($package, $parser->parseConstraints($constraint));
+        }
+        if (isset($requestData['allowList'])) {
+            $transitiveDeps = Request::UPDATE_ONLY_LISTED;
+            if (isset($requestData['allowTransitiveDepsNoRootRequire']) && $requestData['allowTransitiveDepsNoRootRequire']) {
+                $transitiveDeps = Request::UPDATE_LISTED_WITH_TRANSITIVE_DEPS_NO_ROOT_REQUIRE;
+            }
+            if (isset($requestData['allowTransitiveDeps']) && $requestData['allowTransitiveDeps']) {
+                $transitiveDeps = Request::UPDATE_LISTED_WITH_TRANSITIVE_DEPS;
+            }
+            $request->setUpdateAllowList(array_flip($requestData['allowList']), $transitiveDeps);
+        }
+
+        foreach ($fixed as $fixedPackage) {
+            $request->fixPackage($loadPackage($fixedPackage));
+        }
+
+        $pool = $repositorySet->createPool($request, new NullIO());
+        $result = array();
+        for ($i = 1, $count = count($pool); $i <= $count; $i++) {
+            $result[] = $pool->packageById($i);
+        }
+
+        $result = array_map(function ($package) use ($packageIds) {
+            if ($id = array_search($package, $packageIds, true)) {
+                return $id;
+            }
+
+            $suffix = '';
+            if ($package->getSourceReference()) {
+                $suffix = '#'.$package->getSourceReference();
+            }
+            if ($package->getRepository() instanceof LockArrayRepository) {
+                $suffix .= ' (locked)';
+            }
+
+            if ($package instanceof AliasPackage) {
+                if ($id = array_search($package->getAliasOf(), $packageIds, true)) {
+                    return (string) $package->getName().'-'.$package->getVersion() . $suffix . ' (alias of '.$id . ')';
+                }
+
+                return (string) $package->getName().'-'.$package->getVersion() . $suffix . ' (alias of '.$package->getAliasOf()->getVersion().')';
+            }
+
+            return (string) $package->getName().'-'.$package->getVersion() . $suffix;
+        }, $result);
+
+        $this->assertSame($expect, $result);
+    }
+
+    public function getIntegrationTests()
+    {
+        $fixturesDir = realpath(__DIR__.'/Fixtures/poolbuilder/');
+        $tests = array();
+        foreach (new \RecursiveIteratorIterator(new \RecursiveDirectoryIterator($fixturesDir), \RecursiveIteratorIterator::LEAVES_ONLY) as $file) {
+            if (!preg_match('/\.test$/', $file)) {
+                continue;
+            }
+
+            try {
+                $testData = $this->readTestFile($file, $fixturesDir);
+
+                $message = $testData['TEST'];
+
+                $request = JsonFile::parseJson($testData['REQUEST']);
+                $root = !empty($testData['ROOT']) ? JsonFile::parseJson($testData['ROOT']) : array();
+
+                $packageRepos = JsonFile::parseJson($testData['PACKAGE-REPOS']);
+                $fixed = array();
+                if (!empty($testData['FIXED'])) {
+                    $fixed = JsonFile::parseJson($testData['FIXED']);
+                }
+                $expect = JsonFile::parseJson($testData['EXPECT']);
+            } catch (\Exception $e) {
+                die(sprintf('Test "%s" is not valid: '.$e->getMessage(), str_replace($fixturesDir.'/', '', $file)));
+            }
+
+            $tests[basename($file)] = array(str_replace($fixturesDir.'/', '', $file), $message, $expect, $root, $request, $packageRepos, $fixed);
+        }
+
+        return $tests;
+    }
+
+    protected function readTestFile(\SplFileInfo $file, $fixturesDir)
+    {
+        $tokens = preg_split('#(?:^|\n*)--([A-Z-]+)--\n#', file_get_contents($file->getRealPath()), null, PREG_SPLIT_DELIM_CAPTURE);
+
+        $sectionInfo = array(
+            'TEST' => true,
+            'ROOT' => false,
+            'REQUEST' => true,
+            'FIXED' => false,
+            'PACKAGE-REPOS' => true,
+            'EXPECT' => true,
+        );
+
+        $section = null;
+        $data = array();
+        foreach ($tokens as $i => $token) {
+            if (null === $section && empty($token)) {
+                continue; // skip leading blank
+            }
+
+            if (null === $section) {
+                if (!isset($sectionInfo[$token])) {
+                    throw new \RuntimeException(sprintf(
+                        'The test file "%s" must not contain a section named "%s".',
+                        str_replace($fixturesDir.'/', '', $file),
+                        $token
+                    ));
+                }
+                $section = $token;
+                continue;
+            }
+
+            $sectionData = $token;
+
+            $data[$section] = $sectionData;
+            $section = $sectionData = null;
+        }
+
+        foreach ($sectionInfo as $section => $required) {
+            if ($required && !isset($data[$section])) {
+                throw new \RuntimeException(sprintf(
+                    'The test file "%s" must have a section named "%s".',
+                    str_replace($fixturesDir.'/', '', $file),
+                    $section
+                ));
+            }
+        }
+
+        return $data;
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/PoolTest.php 2.0.9-1/tests/Composer/Test/DependencyResolver/PoolTest.php
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/PoolTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/PoolTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,99 +13,29 @@
 namespace Composer\Test\DependencyResolver;
 
 use Composer\DependencyResolver\Pool;
-use Composer\Repository\ArrayRepository;
-use Composer\Package\BasePackage;
 use Composer\Test\TestCase;
 
 class PoolTest extends TestCase
 {
     public function testPool()
     {
-        $pool = new Pool;
-        $repo = new ArrayRepository;
         $package = $this->getPackage('foo', '1');
 
-        $repo->addPackage($package);
-        $pool->addRepository($repo);
+        $pool = $this->createPool(array($package));
 
         $this->assertEquals(array($package), $pool->whatProvides('foo'));
         $this->assertEquals(array($package), $pool->whatProvides('foo'));
     }
 
-    public function testPoolIgnoresIrrelevantPackages()
-    {
-        $pool = new Pool('stable', array('bar' => BasePackage::STABILITY_BETA));
-        $repo = new ArrayRepository;
-        $repo->addPackage($package = $this->getPackage('bar', '1'));
-        $repo->addPackage($betaPackage = $this->getPackage('bar', '1-beta'));
-        $repo->addPackage($alphaPackage = $this->getPackage('bar', '1-alpha'));
-        $repo->addPackage($package2 = $this->getPackage('foo', '1'));
-        $repo->addPackage($rcPackage2 = $this->getPackage('foo', '1rc'));
-
-        $pool->addRepository($repo);
-
-        $this->assertEquals(array($package, $betaPackage), $pool->whatProvides('bar'));
-        $this->assertEquals(array($package2), $pool->whatProvides('foo'));
-    }
-
-    /**
-     * @expectedException \RuntimeException
-     */
-    public function testGetPriorityForNotRegisteredRepository()
-    {
-        $pool = new Pool;
-        $repository = new ArrayRepository;
-
-        $pool->getPriority($repository);
-    }
-
-    public function testGetPriorityWhenRepositoryIsRegistered()
-    {
-        $pool = new Pool;
-        $firstRepository = new ArrayRepository;
-        $pool->addRepository($firstRepository);
-        $secondRepository = new ArrayRepository;
-        $pool->addRepository($secondRepository);
-
-        $firstPriority = $pool->getPriority($firstRepository);
-        $secondPriority = $pool->getPriority($secondRepository);
-
-        $this->assertEquals(0, $firstPriority);
-        $this->assertEquals(-1, $secondPriority);
-    }
-
-    public function testWhatProvidesSamePackageForDifferentRepositories()
-    {
-        $pool = new Pool;
-        $firstRepository = new ArrayRepository;
-        $secondRepository = new ArrayRepository;
-
-        $firstPackage = $this->getPackage('foo', '1');
-        $secondPackage = $this->getPackage('foo', '1');
-        $thirdPackage = $this->getPackage('foo', '2');
-
-        $firstRepository->addPackage($firstPackage);
-        $secondRepository->addPackage($secondPackage);
-        $secondRepository->addPackage($thirdPackage);
-
-        $pool->addRepository($firstRepository);
-        $pool->addRepository($secondRepository);
-
-        $this->assertEquals(array($firstPackage, $secondPackage, $thirdPackage), $pool->whatProvides('foo'));
-    }
-
     public function testWhatProvidesPackageWithConstraint()
     {
-        $pool = new Pool;
-        $repository = new ArrayRepository;
-
         $firstPackage = $this->getPackage('foo', '1');
         $secondPackage = $this->getPackage('foo', '2');
 
-        $repository->addPackage($firstPackage);
-        $repository->addPackage($secondPackage);
-
-        $pool->addRepository($repository);
+        $pool = $this->createPool(array(
+            $firstPackage,
+            $secondPackage,
+        ));
 
         $this->assertEquals(array($firstPackage, $secondPackage), $pool->whatProvides('foo'));
         $this->assertEquals(array($secondPackage), $pool->whatProvides('foo', $this->getVersionConstraint('==', '2')));
@@ -113,20 +43,22 @@ class PoolTest extends TestCase
 
     public function testPackageById()
     {
-        $pool = new Pool;
-        $repository = new ArrayRepository;
         $package = $this->getPackage('foo', '1');
 
-        $repository->addPackage($package);
-        $pool->addRepository($repository);
+        $pool = $this->createPool(array($package));
 
         $this->assertSame($package, $pool->packageById(1));
     }
 
     public function testWhatProvidesWhenPackageCannotBeFound()
     {
-        $pool = new Pool;
+        $pool = $this->createPool();
 
         $this->assertEquals(array(), $pool->whatProvides('foo'));
     }
+
+    protected function createPool(array $packages = array())
+    {
+        return new Pool($packages);
+    }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/RequestTest.php 2.0.9-1/tests/Composer/Test/DependencyResolver/RequestTest.php
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/RequestTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/RequestTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,11 +14,12 @@ namespace Composer\Test\DependencyResolv
 
 use Composer\DependencyResolver\Request;
 use Composer\Repository\ArrayRepository;
+use Composer\Semver\Constraint\MatchAllConstraint;
 use Composer\Test\TestCase;
 
 class RequestTest extends TestCase
 {
-    public function testRequestInstallAndRemove()
+    public function testRequestInstall()
     {
         $repo = new ArrayRepository;
         $foo = $this->getPackage('foo', '1');
@@ -30,17 +31,13 @@ class RequestTest extends TestCase
         $repo->addPackage($foobar);
 
         $request = new Request();
-        $request->install('foo');
-        $request->fix('bar');
-        $request->remove('foobar');
+        $request->requireName('foo');
 
         $this->assertEquals(
             array(
-                array('cmd' => 'install', 'packageName' => 'foo', 'constraint' => null, 'fixed' => false),
-                array('cmd' => 'install', 'packageName' => 'bar', 'constraint' => null, 'fixed' => true),
-                array('cmd' => 'remove', 'packageName' => 'foobar', 'constraint' => null, 'fixed' => false),
+                'foo' => new MatchAllConstraint(),
             ),
-            $request->getJobs()
+            $request->getRequires()
         );
     }
 
@@ -56,25 +53,13 @@ class RequestTest extends TestCase
         $repo2->addPackage($foo2);
 
         $request = new Request();
-        $request->install('foo', $constraint = $this->getVersionConstraint('=', '1'));
+        $request->requireName('foo', $constraint = $this->getVersionConstraint('=', '1'));
 
         $this->assertEquals(
             array(
-                    array('cmd' => 'install', 'packageName' => 'foo', 'constraint' => $constraint, 'fixed' => false),
+                'foo' => $constraint,
             ),
-            $request->getJobs()
-        );
-    }
-
-    public function testUpdateAll()
-    {
-        $request = new Request();
-
-        $request->updateAll();
-
-        $this->assertEquals(
-            array(array('cmd' => 'update-all')),
-            $request->getJobs()
+            $request->getRequires()
         );
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/RuleSetIteratorTest.php 2.0.9-1/tests/Composer/Test/DependencyResolver/RuleSetIteratorTest.php
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/RuleSetIteratorTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/RuleSetIteratorTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -26,15 +26,15 @@ class RuleSetIteratorTest extends TestCa
 
     protected function setUp()
     {
-        $this->pool = new Pool;
+        $this->pool = new Pool();
 
         $this->rules = array(
-            RuleSet::TYPE_JOB => array(
-                new GenericRule(array(), Rule::RULE_JOB_INSTALL, null),
-                new GenericRule(array(), Rule::RULE_JOB_INSTALL, null),
+            RuleSet::TYPE_REQUEST => array(
+                new GenericRule(array(), Rule::RULE_ROOT_REQUIRE, null),
+                new GenericRule(array(), Rule::RULE_ROOT_REQUIRE, null),
             ),
             RuleSet::TYPE_LEARNED => array(
-                new GenericRule(array(), Rule::RULE_INTERNAL_ALLOW_UPDATE, null),
+                new GenericRule(array(), Rule::RULE_LEARNED, null),
             ),
             RuleSet::TYPE_PACKAGE => array(),
         );
@@ -50,8 +50,8 @@ class RuleSetIteratorTest extends TestCa
         }
 
         $expected = array(
-            $this->rules[RuleSet::TYPE_JOB][0],
-            $this->rules[RuleSet::TYPE_JOB][1],
+            $this->rules[RuleSet::TYPE_REQUEST][0],
+            $this->rules[RuleSet::TYPE_REQUEST][1],
             $this->rules[RuleSet::TYPE_LEARNED][0],
         );
 
@@ -68,8 +68,8 @@ class RuleSetIteratorTest extends TestCa
         }
 
         $expected = array(
-            RuleSet::TYPE_JOB,
-            RuleSet::TYPE_JOB,
+            RuleSet::TYPE_REQUEST,
+            RuleSet::TYPE_REQUEST,
             RuleSet::TYPE_LEARNED,
         );
 
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/RuleSetTest.php 2.0.9-1/tests/Composer/Test/DependencyResolver/RuleSetTest.php
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/RuleSetTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/RuleSetTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,36 +16,28 @@ use Composer\DependencyResolver\GenericR
 use Composer\DependencyResolver\Rule;
 use Composer\DependencyResolver\RuleSet;
 use Composer\DependencyResolver\Pool;
-use Composer\Repository\ArrayRepository;
 use Composer\Test\TestCase;
 
 class RuleSetTest extends TestCase
 {
-    protected $pool;
-
-    public function setUp()
-    {
-        $this->pool = new Pool;
-    }
-
     public function testAdd()
     {
         $rules = array(
             RuleSet::TYPE_PACKAGE => array(),
-            RuleSet::TYPE_JOB => array(
-                new GenericRule(array(1), Rule::RULE_JOB_INSTALL, null),
-                new GenericRule(array(2), Rule::RULE_JOB_INSTALL, null),
+            RuleSet::TYPE_REQUEST => array(
+                new GenericRule(array(1), Rule::RULE_ROOT_REQUIRE, null),
+                new GenericRule(array(2), Rule::RULE_ROOT_REQUIRE, null),
             ),
             RuleSet::TYPE_LEARNED => array(
-                new GenericRule(array(), Rule::RULE_INTERNAL_ALLOW_UPDATE, null),
+                new GenericRule(array(), Rule::RULE_LEARNED, null),
             ),
         );
 
         $ruleSet = new RuleSet;
 
-        $ruleSet->add($rules[RuleSet::TYPE_JOB][0], RuleSet::TYPE_JOB);
+        $ruleSet->add($rules[RuleSet::TYPE_REQUEST][0], RuleSet::TYPE_REQUEST);
         $ruleSet->add($rules[RuleSet::TYPE_LEARNED][0], RuleSet::TYPE_LEARNED);
-        $ruleSet->add($rules[RuleSet::TYPE_JOB][1], RuleSet::TYPE_JOB);
+        $ruleSet->add($rules[RuleSet::TYPE_REQUEST][1], RuleSet::TYPE_REQUEST);
 
         $this->assertEquals($rules, $ruleSet->getRules());
     }
@@ -53,38 +45,36 @@ class RuleSetTest extends TestCase
     public function testAddIgnoresDuplicates()
     {
         $rules = array(
-            RuleSet::TYPE_JOB => array(
-                new GenericRule(array(), Rule::RULE_JOB_INSTALL, null),
-                new GenericRule(array(), Rule::RULE_JOB_INSTALL, null),
-                new GenericRule(array(), Rule::RULE_JOB_INSTALL, null),
+            RuleSet::TYPE_REQUEST => array(
+                new GenericRule(array(), Rule::RULE_ROOT_REQUIRE, null),
+                new GenericRule(array(), Rule::RULE_ROOT_REQUIRE, null),
+                new GenericRule(array(), Rule::RULE_ROOT_REQUIRE, null),
             ),
         );
 
         $ruleSet = new RuleSet;
 
-        $ruleSet->add($rules[RuleSet::TYPE_JOB][0], RuleSet::TYPE_JOB);
-        $ruleSet->add($rules[RuleSet::TYPE_JOB][1], RuleSet::TYPE_JOB);
-        $ruleSet->add($rules[RuleSet::TYPE_JOB][2], RuleSet::TYPE_JOB);
+        $ruleSet->add($rules[RuleSet::TYPE_REQUEST][0], RuleSet::TYPE_REQUEST);
+        $ruleSet->add($rules[RuleSet::TYPE_REQUEST][1], RuleSet::TYPE_REQUEST);
+        $ruleSet->add($rules[RuleSet::TYPE_REQUEST][2], RuleSet::TYPE_REQUEST);
 
-        $this->assertCount(1, $ruleSet->getIteratorFor(array(RuleSet::TYPE_JOB)));
+        $this->assertCount(1, $ruleSet->getIteratorFor(array(RuleSet::TYPE_REQUEST)));
     }
 
-    /**
-     * @expectedException \OutOfBoundsException
-     */
     public function testAddWhenTypeIsNotRecognized()
     {
         $ruleSet = new RuleSet;
 
-        $ruleSet->add(new GenericRule(array(), Rule::RULE_JOB_INSTALL, null), 7);
+        $this->setExpectedException('OutOfBoundsException');
+        $ruleSet->add(new GenericRule(array(), Rule::RULE_ROOT_REQUIRE, null), 7);
     }
 
     public function testCount()
     {
         $ruleSet = new RuleSet;
 
-        $ruleSet->add(new GenericRule(array(1), Rule::RULE_JOB_INSTALL, null), RuleSet::TYPE_JOB);
-        $ruleSet->add(new GenericRule(array(2), Rule::RULE_JOB_INSTALL, null), RuleSet::TYPE_JOB);
+        $ruleSet->add(new GenericRule(array(1), Rule::RULE_ROOT_REQUIRE, null), RuleSet::TYPE_REQUEST);
+        $ruleSet->add(new GenericRule(array(2), Rule::RULE_ROOT_REQUIRE, null), RuleSet::TYPE_REQUEST);
 
         $this->assertEquals(2, $ruleSet->count());
     }
@@ -93,8 +83,8 @@ class RuleSetTest extends TestCase
     {
         $ruleSet = new RuleSet;
 
-        $rule = new GenericRule(array(), Rule::RULE_JOB_INSTALL, null);
-        $ruleSet->add($rule, RuleSet::TYPE_JOB);
+        $rule = new GenericRule(array(), Rule::RULE_ROOT_REQUIRE, null);
+        $ruleSet->add($rule, RuleSet::TYPE_REQUEST);
 
         $this->assertSame($rule, $ruleSet->ruleById[0]);
     }
@@ -103,9 +93,9 @@ class RuleSetTest extends TestCase
     {
         $ruleSet = new RuleSet;
 
-        $rule1 = new GenericRule(array(1), Rule::RULE_JOB_INSTALL, null);
-        $rule2 = new GenericRule(array(2), Rule::RULE_JOB_INSTALL, null);
-        $ruleSet->add($rule1, RuleSet::TYPE_JOB);
+        $rule1 = new GenericRule(array(1), Rule::RULE_ROOT_REQUIRE, null);
+        $rule2 = new GenericRule(array(2), Rule::RULE_ROOT_REQUIRE, null);
+        $ruleSet->add($rule1, RuleSet::TYPE_REQUEST);
         $ruleSet->add($rule2, RuleSet::TYPE_LEARNED);
 
         $iterator = $ruleSet->getIterator();
@@ -118,10 +108,10 @@ class RuleSetTest extends TestCase
     public function testGetIteratorFor()
     {
         $ruleSet = new RuleSet;
-        $rule1 = new GenericRule(array(1), Rule::RULE_JOB_INSTALL, null);
-        $rule2 = new GenericRule(array(2), Rule::RULE_JOB_INSTALL, null);
+        $rule1 = new GenericRule(array(1), Rule::RULE_ROOT_REQUIRE, null);
+        $rule2 = new GenericRule(array(2), Rule::RULE_ROOT_REQUIRE, null);
 
-        $ruleSet->add($rule1, RuleSet::TYPE_JOB);
+        $ruleSet->add($rule1, RuleSet::TYPE_REQUEST);
         $ruleSet->add($rule2, RuleSet::TYPE_LEARNED);
 
         $iterator = $ruleSet->getIteratorFor(RuleSet::TYPE_LEARNED);
@@ -132,29 +122,32 @@ class RuleSetTest extends TestCase
     public function testGetIteratorWithout()
     {
         $ruleSet = new RuleSet;
-        $rule1 = new GenericRule(array(1), Rule::RULE_JOB_INSTALL, null);
-        $rule2 = new GenericRule(array(2), Rule::RULE_JOB_INSTALL, null);
+        $rule1 = new GenericRule(array(1), Rule::RULE_ROOT_REQUIRE, null);
+        $rule2 = new GenericRule(array(2), Rule::RULE_ROOT_REQUIRE, null);
 
-        $ruleSet->add($rule1, RuleSet::TYPE_JOB);
+        $ruleSet->add($rule1, RuleSet::TYPE_REQUEST);
         $ruleSet->add($rule2, RuleSet::TYPE_LEARNED);
 
-        $iterator = $ruleSet->getIteratorWithout(RuleSet::TYPE_JOB);
+        $iterator = $ruleSet->getIteratorWithout(RuleSet::TYPE_REQUEST);
 
         $this->assertSame($rule2, $iterator->current());
     }
 
     public function testPrettyString()
     {
-        $repo = new ArrayRepository;
-        $repo->addPackage($p = $this->getPackage('foo', '2.1'));
-        $this->pool->addRepository($repo);
+        $pool = new Pool(array(
+            $p = $this->getPackage('foo', '2.1'),
+        ));
+
+        $repositorySetMock = $this->getMockBuilder('Composer\Repository\RepositorySet')->disableOriginalConstructor()->getMock();
+        $requestMock = $this->getMockBuilder('Composer\DependencyResolver\Request')->disableOriginalConstructor()->getMock();
 
         $ruleSet = new RuleSet;
         $literal = $p->getId();
-        $rule = new GenericRule(array($literal), Rule::RULE_JOB_INSTALL, null);
+        $rule = new GenericRule(array($literal), Rule::RULE_ROOT_REQUIRE, array('packageName' => 'foo/bar', 'constraint' => null));
 
-        $ruleSet->add($rule, RuleSet::TYPE_JOB);
+        $ruleSet->add($rule, RuleSet::TYPE_REQUEST);
 
-        $this->assertContains('JOB     : Install command rule (install foo 2.1)', $ruleSet->getPrettyString($this->pool));
+        $this->assertStringContainsString('REQUEST : No package found to satisfy root composer.json require foo/bar', $ruleSet->getPrettyString($repositorySetMock, $requestMock, $pool));
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/RuleTest.php 2.0.9-1/tests/Composer/Test/DependencyResolver/RuleTest.php
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/RuleTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/RuleTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,21 +16,15 @@ use Composer\DependencyResolver\GenericR
 use Composer\DependencyResolver\Rule;
 use Composer\DependencyResolver\RuleSet;
 use Composer\DependencyResolver\Pool;
-use Composer\Repository\ArrayRepository;
+use Composer\Package\Link;
+use Composer\Semver\Constraint\MatchAllConstraint;
 use Composer\Test\TestCase;
 
 class RuleTest extends TestCase
 {
-    protected $pool;
-
-    public function setUp()
-    {
-        $this->pool = new Pool;
-    }
-
     public function testGetHash()
     {
-        $rule = new GenericRule(array(123), Rule::RULE_JOB_INSTALL, null);
+        $rule = new GenericRule(array(123), Rule::RULE_ROOT_REQUIRE, null);
 
         $hash = unpack('ihash', md5('123', true));
         $this->assertEquals($hash['hash'], $rule->getHash());
@@ -38,39 +32,39 @@ class RuleTest extends TestCase
 
     public function testEqualsForRulesWithDifferentHashes()
     {
-        $rule = new GenericRule(array(1, 2), Rule::RULE_JOB_INSTALL, null);
-        $rule2 = new GenericRule(array(1, 3), Rule::RULE_JOB_INSTALL, null);
+        $rule = new GenericRule(array(1, 2), Rule::RULE_ROOT_REQUIRE, null);
+        $rule2 = new GenericRule(array(1, 3), Rule::RULE_ROOT_REQUIRE, null);
 
         $this->assertFalse($rule->equals($rule2));
     }
 
     public function testEqualsForRulesWithDifferLiteralsQuantity()
     {
-        $rule = new GenericRule(array(1, 12), Rule::RULE_JOB_INSTALL, null);
-        $rule2 = new GenericRule(array(1), Rule::RULE_JOB_INSTALL, null);
+        $rule = new GenericRule(array(1, 12), Rule::RULE_ROOT_REQUIRE, null);
+        $rule2 = new GenericRule(array(1), Rule::RULE_ROOT_REQUIRE, null);
 
         $this->assertFalse($rule->equals($rule2));
     }
 
     public function testEqualsForRulesWithSameLiterals()
     {
-        $rule = new GenericRule(array(1, 12), Rule::RULE_JOB_INSTALL, null);
-        $rule2 = new GenericRule(array(1, 12), Rule::RULE_JOB_INSTALL, null);
+        $rule = new GenericRule(array(1, 12), Rule::RULE_ROOT_REQUIRE, null);
+        $rule2 = new GenericRule(array(1, 12), Rule::RULE_ROOT_REQUIRE, null);
 
         $this->assertTrue($rule->equals($rule2));
     }
 
     public function testSetAndGetType()
     {
-        $rule = new GenericRule(array(), Rule::RULE_JOB_INSTALL, null);
-        $rule->setType(RuleSet::TYPE_JOB);
+        $rule = new GenericRule(array(), Rule::RULE_ROOT_REQUIRE, null);
+        $rule->setType(RuleSet::TYPE_REQUEST);
 
-        $this->assertEquals(RuleSet::TYPE_JOB, $rule->getType());
+        $this->assertEquals(RuleSet::TYPE_REQUEST, $rule->getType());
     }
 
     public function testEnable()
     {
-        $rule = new GenericRule(array(), Rule::RULE_JOB_INSTALL, null);
+        $rule = new GenericRule(array(), Rule::RULE_ROOT_REQUIRE, null);
         $rule->disable();
         $rule->enable();
 
@@ -80,7 +74,7 @@ class RuleTest extends TestCase
 
     public function testDisable()
     {
-        $rule = new GenericRule(array(), Rule::RULE_JOB_INSTALL, null);
+        $rule = new GenericRule(array(), Rule::RULE_ROOT_REQUIRE, null);
         $rule->enable();
         $rule->disable();
 
@@ -90,8 +84,8 @@ class RuleTest extends TestCase
 
     public function testIsAssertions()
     {
-        $rule = new GenericRule(array(1, 12), Rule::RULE_JOB_INSTALL, null);
-        $rule2 = new GenericRule(array(1), Rule::RULE_JOB_INSTALL, null);
+        $rule = new GenericRule(array(1, 12), Rule::RULE_ROOT_REQUIRE, null);
+        $rule2 = new GenericRule(array(1), Rule::RULE_ROOT_REQUIRE, null);
 
         $this->assertFalse($rule->isAssertion());
         $this->assertTrue($rule2->isAssertion());
@@ -99,13 +93,19 @@ class RuleTest extends TestCase
 
     public function testPrettyString()
     {
-        $repo = new ArrayRepository;
-        $repo->addPackage($p1 = $this->getPackage('foo', '2.1'));
-        $repo->addPackage($p2 = $this->getPackage('baz', '1.1'));
-        $this->pool->addRepository($repo);
+        $pool = new Pool(array(
+            $p1 = $this->getPackage('foo', '2.1'),
+            $p2 = $this->getPackage('baz', '1.1'),
+        ));
+
+        $repositorySetMock = $this->getMockBuilder('Composer\Repository\RepositorySet')->disableOriginalConstructor()->getMock();
+        $requestMock = $this->getMockBuilder('Composer\DependencyResolver\Request')->disableOriginalConstructor()->getMock();
+
+        $emptyConstraint = new MatchAllConstraint();
+        $emptyConstraint->setPrettyString('*');
 
-        $rule = new GenericRule(array($p1->getId(), -$p2->getId()), Rule::RULE_JOB_INSTALL, null);
+        $rule = new GenericRule(array($p1->getId(), -$p2->getId()), Rule::RULE_PACKAGE_REQUIRES, new Link('baz', 'foo', $emptyConstraint));
 
-        $this->assertEquals('Install command rule (don\'t install baz 1.1|install foo 2.1)', $rule->getPrettyString($this->pool));
+        $this->assertEquals('baz 1.1 relates to foo * -> satisfiable by foo[2.1].', $rule->getPrettyString($repositorySetMock, $requestMock, $pool, false));
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/SolverTest.php 2.0.9-1/tests/Composer/Test/DependencyResolver/SolverTest.php
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/SolverTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/SolverTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,33 +14,35 @@ namespace Composer\Test\DependencyResolv
 
 use Composer\IO\NullIO;
 use Composer\Repository\ArrayRepository;
+use Composer\Repository\LockArrayRepository;
 use Composer\DependencyResolver\DefaultPolicy;
-use Composer\DependencyResolver\Pool;
 use Composer\DependencyResolver\Request;
 use Composer\DependencyResolver\Solver;
 use Composer\DependencyResolver\SolverProblemsException;
 use Composer\Package\Link;
+use Composer\Repository\RepositorySet;
 use Composer\Test\TestCase;
 use Composer\Semver\Constraint\MultiConstraint;
+use Composer\Semver\Constraint\MatchAllConstraint;
 
 class SolverTest extends TestCase
 {
-    protected $pool;
+    protected $repoSet;
     protected $repo;
-    protected $repoInstalled;
+    protected $repoLocked;
     protected $request;
     protected $policy;
     protected $solver;
+    protected $pool;
 
     public function setUp()
     {
-        $this->pool = new Pool;
+        $this->repoSet = new RepositorySet();
         $this->repo = new ArrayRepository;
-        $this->repoInstalled = new ArrayRepository;
+        $this->repoLocked = new LockArrayRepository;
 
-        $this->request = new Request();
+        $this->request = new Request($this->repoLocked);
         $this->policy = new DefaultPolicy;
-        $this->solver = new Solver($this->policy, $this->pool, $this->repoInstalled, new NullIO());
     }
 
     public function testSolverInstallSingle()
@@ -48,16 +50,16 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->reposComplete();
 
-        $this->request->install('A');
+        $this->request->requireName('A');
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $packageA),
         ));
     }
 
-    public function testSolverRemoveIfNotInstalled()
+    public function testSolverRemoveIfNotRequested()
     {
-        $this->repoInstalled->addPackage($packageA = $this->getPackage('A', '1.0'));
+        $this->repoLocked->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->reposComplete();
 
         $this->checkSolverResult(array(
@@ -70,8 +72,9 @@ class SolverTest extends TestCase
         $this->repo->addPackage($this->getPackage('A', '1.0'));
         $this->reposComplete();
 
-        $this->request->install('B', $this->getVersionConstraint('==', '1'));
+        $this->request->requireName('B', $this->getVersionConstraint('==', '1'));
 
+        $this->createSolver();
         try {
             $transaction = $this->solver->solve($this->request);
             $this->fail('Unsolvable conflict did not result in exception.');
@@ -79,7 +82,7 @@ class SolverTest extends TestCase
             $problems = $e->getProblems();
             $this->assertCount(1, $problems);
             $this->assertEquals(2, $e->getCode());
-            $this->assertEquals("\n    - The requested package b could not be found in any version, there may be a typo in the package name.", $problems[0]->getPrettyString());
+            $this->assertEquals("\n    - Root composer.json requires b, it could not be found in any version, there may be a typo in the package name.", $problems[0]->getPrettyString($this->repoSet, $this->request, $this->pool, false));
         }
     }
 
@@ -91,11 +94,10 @@ class SolverTest extends TestCase
         $repo1->addPackage($foo1 = $this->getPackage('foo', '1'));
         $repo2->addPackage($foo2 = $this->getPackage('foo', '1'));
 
-        $this->pool->addRepository($this->repoInstalled);
-        $this->pool->addRepository($repo1);
-        $this->pool->addRepository($repo2);
+        $this->repoSet->addRepository($repo1);
+        $this->repoSet->addRepository($repo2);
 
-        $this->request->install('foo');
+        $this->request->requireName('foo');
 
         $this->checkSolverResult(array(
                 array('job' => 'install', 'package' => $foo1),
@@ -108,11 +110,11 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageB = $this->getPackage('B', '1.0'));
         $this->repo->addPackage($newPackageB = $this->getPackage('B', '1.1'));
 
-        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('<', '1.1'), 'requires')));
+        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('<', '1.1'), Link::TYPE_REQUIRE)));
 
         $this->reposComplete();
 
-        $this->request->install('A');
+        $this->request->requireName('A');
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $packageB),
@@ -133,12 +135,12 @@ class SolverTest extends TestCase
                 $this->getVersionConstraint('<=', '1.3'),
                 $this->getVersionConstraint('<>', '1.3'),
                 $this->getVersionConstraint('!=', '1.2'),
-            )), 'requires'),
+            )), Link::TYPE_REQUIRE),
         ));
 
         $this->reposComplete();
 
-        $this->request->install('A');
+        $this->request->requireName('A');
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $newPackageB11),
@@ -153,18 +155,18 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageC = $this->getPackage('C', '1.0'));
 
         $packageB->setRequires(array(
-            'a' => new Link('B', 'A', $this->getVersionConstraint('>=', '1.0'), 'requires'),
-            'c' => new Link('B', 'C', $this->getVersionConstraint('>=', '1.0'), 'requires'),
+            'a' => new Link('B', 'A', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE),
+            'c' => new Link('B', 'C', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE),
         ));
         $packageC->setRequires(array(
-            'a' => new Link('C', 'A', $this->getVersionConstraint('>=', '1.0'), 'requires'),
+            'a' => new Link('C', 'A', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE),
         ));
 
         $this->reposComplete();
 
-        $this->request->install('A');
-        $this->request->install('B');
-        $this->request->install('C');
+        $this->request->requireName('A');
+        $this->request->requireName('B');
+        $this->request->requireName('C');
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $packageA),
@@ -173,62 +175,38 @@ class SolverTest extends TestCase
         ));
     }
 
-    public function testSolverInstallInstalled()
+    public function testSolverFixLocked()
     {
-        $this->repoInstalled->addPackage($this->getPackage('A', '1.0'));
+        $this->repoLocked->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->reposComplete();
 
-        $this->request->install('A');
+        $this->request->fixPackage($packageA);
 
         $this->checkSolverResult(array());
     }
 
-    public function testSolverInstallInstalledWithAlternative()
+    public function testSolverFixLockedWithAlternative()
     {
         $this->repo->addPackage($this->getPackage('A', '1.0'));
-        $this->repoInstalled->addPackage($this->getPackage('A', '1.0'));
+        $this->repoLocked->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->reposComplete();
 
-        $this->request->install('A');
-
-        $this->checkSolverResult(array());
-    }
-
-    public function testSolverRemoveSingle()
-    {
-        $this->repoInstalled->addPackage($packageA = $this->getPackage('A', '1.0'));
-        $this->reposComplete();
-
-        $this->request->remove('A');
-
-        $this->checkSolverResult(array(
-            array('job' => 'remove', 'package' => $packageA),
-        ));
-    }
-
-    public function testSolverRemoveUninstalled()
-    {
-        $this->repo->addPackage($this->getPackage('A', '1.0'));
-        $this->reposComplete();
-
-        $this->request->remove('A');
+        $this->request->fixPackage($packageA);
 
         $this->checkSolverResult(array());
     }
 
     public function testSolverUpdateDoesOnlyUpdate()
     {
-        $this->repoInstalled->addPackage($packageA = $this->getPackage('A', '1.0'));
-        $this->repoInstalled->addPackage($packageB = $this->getPackage('B', '1.0'));
+        $this->repoLocked->addPackage($packageA = $this->getPackage('A', '1.0'));
+        $this->repoLocked->addPackage($packageB = $this->getPackage('B', '1.0'));
         $this->repo->addPackage($newPackageB = $this->getPackage('B', '1.1'));
         $this->reposComplete();
 
-        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0.0.0'), 'requires')));
+        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0.0.0'), Link::TYPE_REQUIRE)));
 
-        $this->request->install('A', $this->getVersionConstraint('=', '1.0.0.0'));
-        $this->request->install('B', $this->getVersionConstraint('=', '1.1.0.0'));
-        $this->request->update('A', $this->getVersionConstraint('=', '1.0.0.0'));
-        $this->request->update('B', $this->getVersionConstraint('=', '1.0.0.0'));
+        $this->request->fixPackage($packageA);
+        $this->request->requireName('B', $this->getVersionConstraint('=', '1.1.0.0'));
 
         $this->checkSolverResult(array(
             array('job' => 'update', 'from' => $packageB, 'to' => $newPackageB),
@@ -237,12 +215,11 @@ class SolverTest extends TestCase
 
     public function testSolverUpdateSingle()
     {
-        $this->repoInstalled->addPackage($packageA = $this->getPackage('A', '1.0'));
+        $this->repoLocked->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($newPackageA = $this->getPackage('A', '1.1'));
         $this->reposComplete();
 
-        $this->request->install('A');
-        $this->request->update('A');
+        $this->request->requireName('A');
 
         $this->checkSolverResult(array(
             array('job' => 'update', 'from' => $packageA, 'to' => $newPackageA),
@@ -251,18 +228,17 @@ class SolverTest extends TestCase
 
     public function testSolverUpdateAll()
     {
-        $this->repoInstalled->addPackage($packageA = $this->getPackage('A', '1.0'));
-        $this->repoInstalled->addPackage($packageB = $this->getPackage('B', '1.0'));
+        $this->repoLocked->addPackage($packageA = $this->getPackage('A', '1.0'));
+        $this->repoLocked->addPackage($packageB = $this->getPackage('B', '1.0'));
         $this->repo->addPackage($newPackageA = $this->getPackage('A', '1.1'));
         $this->repo->addPackage($newPackageB = $this->getPackage('B', '1.1'));
 
-        $packageA->setRequires(array('b' => new Link('A', 'B', null, 'requires')));
-        $newPackageA->setRequires(array('b' => new Link('A', 'B', null, 'requires')));
+        $packageA->setRequires(array('b' => new Link('A', 'B', new MatchAllConstraint(), Link::TYPE_REQUIRE)));
+        $newPackageA->setRequires(array('b' => new Link('A', 'B', new MatchAllConstraint(), Link::TYPE_REQUIRE)));
 
         $this->reposComplete();
 
-        $this->request->install('A');
-        $this->request->updateAll();
+        $this->request->requireName('A');
 
         $this->checkSolverResult(array(
             array('job' => 'update', 'from' => $packageB, 'to' => $newPackageB),
@@ -272,28 +248,26 @@ class SolverTest extends TestCase
 
     public function testSolverUpdateCurrent()
     {
-        $this->repoInstalled->addPackage($this->getPackage('A', '1.0'));
+        $this->repoLocked->addPackage($this->getPackage('A', '1.0'));
         $this->repo->addPackage($this->getPackage('A', '1.0'));
         $this->reposComplete();
 
-        $this->request->install('A');
-        $this->request->update('A');
+        $this->request->requireName('A');
 
         $this->checkSolverResult(array());
     }
 
     public function testSolverUpdateOnlyUpdatesSelectedPackage()
     {
-        $this->repoInstalled->addPackage($packageA = $this->getPackage('A', '1.0'));
-        $this->repoInstalled->addPackage($packageB = $this->getPackage('B', '1.0'));
+        $this->repoLocked->addPackage($packageA = $this->getPackage('A', '1.0'));
+        $this->repoLocked->addPackage($packageB = $this->getPackage('B', '1.0'));
         $this->repo->addPackage($packageAnewer = $this->getPackage('A', '1.1'));
         $this->repo->addPackage($packageBnewer = $this->getPackage('B', '1.1'));
 
         $this->reposComplete();
 
-        $this->request->install('A');
-        $this->request->install('B');
-        $this->request->update('A');
+        $this->request->requireName('A');
+        $this->request->fixPackage($packageB);
 
         $this->checkSolverResult(array(
             array('job' => 'update', 'from' => $packageA, 'to' => $packageAnewer),
@@ -302,13 +276,12 @@ class SolverTest extends TestCase
 
     public function testSolverUpdateConstrained()
     {
-        $this->repoInstalled->addPackage($packageA = $this->getPackage('A', '1.0'));
+        $this->repoLocked->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($newPackageA = $this->getPackage('A', '1.2'));
         $this->repo->addPackage($this->getPackage('A', '2.0'));
         $this->reposComplete();
 
-        $this->request->install('A', $this->getVersionConstraint('<', '2.0.0.0'));
-        $this->request->update('A');
+        $this->request->requireName('A', $this->getVersionConstraint('<', '2.0.0.0'));
 
         $this->checkSolverResult(array(array(
             'job' => 'update',
@@ -319,13 +292,12 @@ class SolverTest extends TestCase
 
     public function testSolverUpdateFullyConstrained()
     {
-        $this->repoInstalled->addPackage($packageA = $this->getPackage('A', '1.0'));
+        $this->repoLocked->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($newPackageA = $this->getPackage('A', '1.2'));
         $this->repo->addPackage($this->getPackage('A', '2.0'));
         $this->reposComplete();
 
-        $this->request->install('A', $this->getVersionConstraint('<', '2.0.0.0'));
-        $this->request->update('A', $this->getVersionConstraint('=', '1.0.0.0'));
+        $this->request->requireName('A', $this->getVersionConstraint('<', '2.0.0.0'));
 
         $this->checkSolverResult(array(array(
             'job' => 'update',
@@ -336,52 +308,49 @@ class SolverTest extends TestCase
 
     public function testSolverUpdateFullyConstrainedPrunesInstalledPackages()
     {
-        $this->repoInstalled->addPackage($packageA = $this->getPackage('A', '1.0'));
-        $this->repoInstalled->addPackage($packageB = $this->getPackage('B', '1.0'));
+        $this->repoLocked->addPackage($packageA = $this->getPackage('A', '1.0'));
+        $this->repoLocked->addPackage($packageB = $this->getPackage('B', '1.0'));
         $this->repo->addPackage($newPackageA = $this->getPackage('A', '1.2'));
         $this->repo->addPackage($this->getPackage('A', '2.0'));
         $this->reposComplete();
 
-        $this->request->install('A', $this->getVersionConstraint('<', '2.0.0.0'));
-        $this->request->update('A', $this->getVersionConstraint('=', '1.0.0.0'));
+        $this->request->requireName('A', $this->getVersionConstraint('<', '2.0.0.0'));
 
         $this->checkSolverResult(array(
             array(
+                'job' => 'remove',
+                'package' => $packageB,
+            ),
+            array(
                 'job' => 'update',
                 'from' => $packageA,
                 'to' => $newPackageA,
             ),
-            array(
-                'job' => 'remove',
-                'package' => $packageB,
-            ),
         ));
     }
 
     public function testSolverAllJobs()
     {
-        $this->repoInstalled->addPackage($packageD = $this->getPackage('D', '1.0'));
-        $this->repoInstalled->addPackage($oldPackageC = $this->getPackage('C', '1.0'));
+        $this->repoLocked->addPackage($packageD = $this->getPackage('D', '1.0'));
+        $this->repoLocked->addPackage($oldPackageC = $this->getPackage('C', '1.0'));
 
         $this->repo->addPackage($packageA = $this->getPackage('A', '2.0'));
         $this->repo->addPackage($packageB = $this->getPackage('B', '1.0'));
         $this->repo->addPackage($newPackageB = $this->getPackage('B', '1.1'));
         $this->repo->addPackage($packageC = $this->getPackage('C', '1.1'));
         $this->repo->addPackage($this->getPackage('D', '1.0'));
-        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('<', '1.1'), 'requires')));
+        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('<', '1.1'), Link::TYPE_REQUIRE)));
 
         $this->reposComplete();
 
-        $this->request->install('A');
-        $this->request->install('C');
-        $this->request->update('C');
-        $this->request->remove('D');
+        $this->request->requireName('A');
+        $this->request->requireName('C');
 
         $this->checkSolverResult(array(
-            array('job' => 'update',  'from' => $oldPackageC, 'to' => $packageC),
+            array('job' => 'remove',  'package' => $packageD),
             array('job' => 'install', 'package' => $packageB),
             array('job' => 'install', 'package' => $packageA),
-            array('job' => 'remove',  'package' => $packageD),
+            array('job' => 'update',  'from' => $oldPackageC, 'to' => $packageC),
         ));
     }
 
@@ -391,12 +360,12 @@ class SolverTest extends TestCase
         $this->repo->addPackage($middlePackageB = $this->getPackage('B', '1.0'));
         $this->repo->addPackage($newPackageB = $this->getPackage('B', '1.1'));
         $this->repo->addPackage($oldPackageB = $this->getPackage('B', '0.9'));
-        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('<', '1.1'), 'requires')));
-        $packageA->setConflicts(array('b' => new Link('A', 'B', $this->getVersionConstraint('<', '1.0'), 'conflicts')));
+        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('<', '1.1'), Link::TYPE_REQUIRE)));
+        $packageA->setConflicts(array('b' => new Link('A', 'B', $this->getVersionConstraint('<', '1.0'), Link::TYPE_CONFLICT)));
 
         $this->reposComplete();
 
-        $this->request->install('A');
+        $this->request->requireName('A');
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $middlePackageB),
@@ -406,16 +375,17 @@ class SolverTest extends TestCase
 
     public function testSolverObsolete()
     {
-        $this->repoInstalled->addPackage($packageA = $this->getPackage('A', '1.0'));
+        $this->repoLocked->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($packageB = $this->getPackage('B', '1.0'));
-        $packageB->setReplaces(array('a' => new Link('B', 'A', new MultiConstraint(array()))));
+        $packageB->setReplaces(array('a' => new Link('B', 'A', new MatchAllConstraint())));
 
         $this->reposComplete();
 
-        $this->request->install('B');
+        $this->request->requireName('B');
 
         $this->checkSolverResult(array(
-            array('job' => 'update', 'from' => $packageA, 'to' => $packageB),
+            array('job' => 'remove', 'package' => $packageA),
+            array('job' => 'install', 'package' => $packageB),
         ));
     }
 
@@ -426,7 +396,7 @@ class SolverTest extends TestCase
 
         $this->reposComplete();
 
-        $this->request->install('A');
+        $this->request->requireName('A');
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $packageA),
@@ -437,15 +407,16 @@ class SolverTest extends TestCase
     {
         $this->repo->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($packageQ = $this->getPackage('Q', '1.0'));
-        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), 'requires')));
-        $packageQ->setProvides(array('b' => new Link('Q', 'B', $this->getVersionConstraint('=', '1.0'), 'provides')));
+        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE)));
+        $packageQ->setProvides(array('b' => new Link('Q', 'B', $this->getVersionConstraint('=', '1.0'), Link::TYPE_PROVIDE)));
 
         $this->reposComplete();
 
-        $this->request->install('A');
+        $this->request->requireName('A');
 
         // must explicitly pick the provider, so error in this case
         $this->setExpectedException('Composer\DependencyResolver\SolverProblemsException');
+        $this->createSolver();
         $this->solver->solve($this->request);
     }
 
@@ -454,12 +425,12 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($packageQ = $this->getPackage('Q', '1.0'));
         $this->repo->addPackage($packageB = $this->getPackage('B', '1.0'));
-        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), 'requires')));
-        $packageQ->setReplaces(array('b' => new Link('Q', 'B', $this->getVersionConstraint('>=', '1.0'), 'replaces')));
+        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE)));
+        $packageQ->setReplaces(array('b' => new Link('Q', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REPLACE)));
 
         $this->reposComplete();
 
-        $this->request->install('A');
+        $this->request->requireName('A');
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $packageB),
@@ -471,14 +442,15 @@ class SolverTest extends TestCase
     {
         $this->repo->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($packageQ = $this->getPackage('Q', '1.0'));
-        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), 'requires')));
-        $packageQ->setReplaces(array('b' => new Link('Q', 'B', $this->getVersionConstraint('>=', '1.0'), 'replaces')));
+        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE)));
+        $packageQ->setReplaces(array('b' => new Link('Q', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REPLACE)));
 
         $this->reposComplete();
 
-        $this->request->install('A');
+        $this->request->requireName('A');
 
         $this->setExpectedException('Composer\DependencyResolver\SolverProblemsException');
+        $this->createSolver();
         $this->solver->solve($this->request);
     }
 
@@ -487,13 +459,13 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($packageQ = $this->getPackage('Q', '1.0'));
         $this->repo->addPackage($packageB = $this->getPackage('B', '1.0'));
-        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), 'requires')));
-        $packageQ->setReplaces(array('b' => new Link('Q', 'B', $this->getVersionConstraint('>=', '1.0'), 'replaces')));
+        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE)));
+        $packageQ->setReplaces(array('b' => new Link('Q', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REPLACE)));
 
         $this->reposComplete();
 
-        $this->request->install('A');
-        $this->request->install('Q');
+        $this->request->requireName('A');
+        $this->request->requireName('Q');
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $packageQ),
@@ -505,32 +477,32 @@ class SolverTest extends TestCase
     {
         $this->repo->addPackage($packageX = $this->getPackage('X', '1.0'));
         $packageX->setRequires(array(
-            'a' => new Link('X', 'A', $this->getVersionConstraint('>=', '2.0.0.0'), 'requires'),
-            'b' => new Link('X', 'B', $this->getVersionConstraint('>=', '2.0.0.0'), 'requires'),
+            'a' => new Link('X', 'A', $this->getVersionConstraint('>=', '2.0.0.0'), Link::TYPE_REQUIRE),
+            'b' => new Link('X', 'B', $this->getVersionConstraint('>=', '2.0.0.0'), Link::TYPE_REQUIRE),
         ));
 
         $this->repo->addPackage($packageA = $this->getPackage('A', '2.0.0'));
         $this->repo->addPackage($newPackageA = $this->getPackage('A', '2.1.0'));
         $this->repo->addPackage($newPackageB = $this->getPackage('B', '2.1.0'));
 
-        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '2.0.0.0'), 'requires')));
+        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '2.0.0.0'), Link::TYPE_REQUIRE)));
 
         // new package A depends on version of package B that does not exist
         // => new package A is not installable
-        $newPackageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '2.2.0.0'), 'requires')));
+        $newPackageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '2.2.0.0'), Link::TYPE_REQUIRE)));
 
         // add a package S replacing both A and B, so that S and B or S and A cannot be simultaneously installed
         // but an alternative option for A and B both exists
         // this creates a more difficult so solve conflict
         $this->repo->addPackage($packageS = $this->getPackage('S', '2.0.0'));
         $packageS->setReplaces(array(
-            'a' => new Link('S', 'A', $this->getVersionConstraint('>=', '2.0.0.0'), 'replaces'),
-            'b' => new Link('S', 'B', $this->getVersionConstraint('>=', '2.0.0.0'), 'replaces'),
+            'a' => new Link('S', 'A', $this->getVersionConstraint('>=', '2.0.0.0'), Link::TYPE_REPLACE),
+            'b' => new Link('S', 'B', $this->getVersionConstraint('>=', '2.0.0.0'), Link::TYPE_REPLACE),
         ));
 
         $this->reposComplete();
 
-        $this->request->install('X');
+        $this->request->requireName('X');
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $newPackageB),
@@ -544,12 +516,12 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($packageB1 = $this->getPackage('B', '0.9'));
         $this->repo->addPackage($packageB2 = $this->getPackage('B', '1.1'));
-        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), 'requires')));
-        $packageB2->setRequires(array('a' => new Link('B', 'A', $this->getVersionConstraint('>=', '1.0'), 'requires')));
+        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE)));
+        $packageB2->setRequires(array('a' => new Link('B', 'A', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE)));
 
         $this->reposComplete();
 
-        $this->request->install('A');
+        $this->request->requireName('A');
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $packageB2),
@@ -563,23 +535,23 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageB = $this->getPackage('B', '1.0'));
         $this->repo->addPackage($packageC = $this->getPackage('C', '1.0'));
         $this->repo->addPackage($packageD = $this->getPackage('D', '1.0'));
-        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), 'requires')));
-        $packageB->setRequires(array('virtual' => new Link('B', 'Virtual', $this->getVersionConstraint('>=', '1.0'), 'requires')));
-        $packageC->setProvides(array('virtual' => new Link('C', 'Virtual', $this->getVersionConstraint('==', '1.0'), 'provides')));
-        $packageD->setProvides(array('virtual' => new Link('D', 'Virtual', $this->getVersionConstraint('==', '1.0'), 'provides')));
+        $packageA->setRequires(array('b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE)));
+        $packageB->setRequires(array('virtual' => new Link('B', 'Virtual', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE)));
+        $packageC->setProvides(array('virtual' => new Link('C', 'Virtual', $this->getVersionConstraint('==', '1.0'), Link::TYPE_PROVIDE)));
+        $packageD->setProvides(array('virtual' => new Link('D', 'Virtual', $this->getVersionConstraint('==', '1.0'), Link::TYPE_PROVIDE)));
 
-        $packageC->setRequires(array('a' => new Link('C', 'A', $this->getVersionConstraint('==', '1.0'), 'requires')));
-        $packageD->setRequires(array('a' => new Link('D', 'A', $this->getVersionConstraint('==', '1.0'), 'requires')));
+        $packageC->setRequires(array('a' => new Link('C', 'A', $this->getVersionConstraint('==', '1.0'), Link::TYPE_REQUIRE)));
+        $packageD->setRequires(array('a' => new Link('D', 'A', $this->getVersionConstraint('==', '1.0'), Link::TYPE_REQUIRE)));
 
         $this->reposComplete();
 
-        $this->request->install('A');
-        $this->request->install('C');
+        $this->request->requireName('A');
+        $this->request->requireName('C');
 
         $this->checkSolverResult(array(
+            array('job' => 'install', 'package' => $packageB),
             array('job' => 'install', 'package' => $packageA),
             array('job' => 'install', 'package' => $packageC),
-            array('job' => 'install', 'package' => $packageB),
         ));
     }
 
@@ -595,24 +567,24 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageD2 = $this->getPackage('D', '1.1'));
 
         $packageA->setRequires(array(
-            'b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), 'requires'),
-            'c' => new Link('A', 'C', $this->getVersionConstraint('>=', '1.0'), 'requires'),
+            'b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE),
+            'c' => new Link('A', 'C', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE),
         ));
 
         $packageD->setReplaces(array(
-            'b' => new Link('D', 'B', $this->getVersionConstraint('>=', '1.0'), 'replaces'),
-            'c' => new Link('D', 'C', $this->getVersionConstraint('>=', '1.0'), 'replaces'),
+            'b' => new Link('D', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REPLACE),
+            'c' => new Link('D', 'C', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REPLACE),
         ));
 
         $packageD2->setReplaces(array(
-            'b' => new Link('D', 'B', $this->getVersionConstraint('>=', '1.0'), 'replaces'),
-            'c' => new Link('D', 'C', $this->getVersionConstraint('>=', '1.0'), 'replaces'),
+            'b' => new Link('D', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REPLACE),
+            'c' => new Link('D', 'C', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REPLACE),
         ));
 
         $this->reposComplete();
 
-        $this->request->install('A');
-        $this->request->install('D');
+        $this->request->requireName('A');
+        $this->request->requireName('D');
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $packageD2),
@@ -631,26 +603,27 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageD = $this->getPackage('D', '2.0.9'));
 
         $packageC->setRequires(array(
-            'a' => new Link('C', 'A', $this->getVersionConstraint('>=', '2.0'), 'requires'),
-            'd' => new Link('C', 'D', $this->getVersionConstraint('>=', '2.0'), 'requires'),
+            'a' => new Link('C', 'A', $this->getVersionConstraint('>=', '2.0'), Link::TYPE_REQUIRE),
+            'd' => new Link('C', 'D', $this->getVersionConstraint('>=', '2.0'), Link::TYPE_REQUIRE),
         ));
 
         $packageD->setRequires(array(
-            'a' => new Link('D', 'A', $this->getVersionConstraint('>=', '2.1'), 'requires'),
-            'b' => new Link('D', 'B', $this->getVersionConstraint('>=', '2.0-dev'), 'requires'),
+            'a' => new Link('D', 'A', $this->getVersionConstraint('>=', '2.1'), Link::TYPE_REQUIRE),
+            'b' => new Link('D', 'B', $this->getVersionConstraint('>=', '2.0-dev'), Link::TYPE_REQUIRE),
         ));
 
-        $packageB1->setRequires(array('a' => new Link('B', 'A', $this->getVersionConstraint('==', '2.1.0.0-dev'), 'requires')));
-        $packageB2->setRequires(array('a' => new Link('B', 'A', $this->getVersionConstraint('==', '2.1.0.0-dev'), 'requires')));
+        $packageB1->setRequires(array('a' => new Link('B', 'A', $this->getVersionConstraint('==', '2.1.0.0-dev'), Link::TYPE_REQUIRE)));
+        $packageB2->setRequires(array('a' => new Link('B', 'A', $this->getVersionConstraint('==', '2.1.0.0-dev'), Link::TYPE_REQUIRE)));
 
-        $packageB2->setReplaces(array('d' => new Link('B', 'D', $this->getVersionConstraint('==', '2.0.9.0'), 'replaces')));
+        $packageB2->setReplaces(array('d' => new Link('B', 'D', $this->getVersionConstraint('==', '2.0.9.0'), Link::TYPE_REPLACE)));
 
         $this->reposComplete();
 
-        $this->request->install('C', $this->getVersionConstraint('==', '2.0.0.0-dev'));
+        $this->request->requireName('C', $this->getVersionConstraint('==', '2.0.0.0-dev'));
 
         $this->setExpectedException('Composer\DependencyResolver\SolverProblemsException');
 
+        $this->createSolver();
         $this->solver->solve($this->request);
     }
 
@@ -659,14 +632,18 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($packageB = $this->getPackage('B', '1.0'));
         $packageA->setConflicts(array(
-            'b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), 'conflicts'),
+            'b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_CONFLICT),
         ));
 
         $this->reposComplete();
 
-        $this->request->install('A');
-        $this->request->install('B');
+        $emptyConstraint = new MatchAllConstraint();
+        $emptyConstraint->setPrettyString('*');
 
+        $this->request->requireName('A', $emptyConstraint);
+        $this->request->requireName('B', $emptyConstraint);
+
+        $this->createSolver();
         try {
             $transaction = $this->solver->solve($this->request);
             $this->fail('Unsolvable conflict did not result in exception.');
@@ -676,10 +653,10 @@ class SolverTest extends TestCase
 
             $msg = "\n";
             $msg .= "  Problem 1\n";
-            $msg .= "    - Installation request for a -> satisfiable by A[1.0].\n";
-            $msg .= "    - B 1.0 conflicts with A[1.0].\n";
-            $msg .= "    - Installation request for b -> satisfiable by B[1.0].\n";
-            $this->assertEquals($msg, $e->getMessage());
+            $msg .= "    - Root composer.json requires a * -> satisfiable by A[1.0].\n";
+            $msg .= "    - A 1.0 conflicts with B 1.0.\n";
+            $msg .= "    - Root composer.json requires b * -> satisfiable by B[1.0].\n";
+            $this->assertEquals($msg, $e->getPrettyString($this->repoSet, $this->request, $this->pool, false));
         }
     }
 
@@ -689,13 +666,14 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageB = $this->getPackage('B', '1.0'));
 
         $packageA->setRequires(array(
-            'b' => new Link('A', 'B', $this->getVersionConstraint('>=', '2.0'), 'requires'),
+            'b' => new Link('A', 'B', $this->getVersionConstraint('>=', '2.0'), Link::TYPE_REQUIRE),
         ));
 
         $this->reposComplete();
 
-        $this->request->install('A');
+        $this->request->requireName('A');
 
+        $this->createSolver();
         try {
             $transaction = $this->solver->solve($this->request);
             $this->fail('Unsolvable conflict did not result in exception.');
@@ -706,15 +684,9 @@ class SolverTest extends TestCase
 
             $msg = "\n";
             $msg .= "  Problem 1\n";
-            $msg .= "    - Installation request for a -> satisfiable by A[1.0].\n";
-            $msg .= "    - A 1.0 requires b >= 2.0 -> no matching package found.\n\n";
-            $msg .= "Potential causes:\n";
-            $msg .= " - A typo in the package name\n";
-            $msg .= " - The package is not available in a stable-enough version according to your minimum-stability setting\n";
-            $msg .= "   see <https://getcomposer.org/doc/04-schema.md#minimum-stability> for more details.\n";
-            $msg .= " - It's a private package and you forgot to add a custom repository to find it\n\n";
-            $msg .= "Read <https://getcomposer.org/doc/articles/troubleshooting.md> for further common problems.";
-            $this->assertEquals($msg, $e->getMessage());
+            $msg .= "    - Root composer.json requires a * -> satisfiable by A[1.0].\n";
+            $msg .= "    - A 1.0 requires b >= 2.0 -> found B[1.0] but it does not match the constraint.\n";
+            $this->assertEquals($msg, $e->getPrettyString($this->repoSet, $this->request, $this->pool, false));
         }
     }
 
@@ -727,22 +699,26 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageD = $this->getPackage('D', '1.0'));
 
         $packageA->setRequires(array(
-            'b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), 'requires'),
+            'b' => new Link('A', 'B', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE),
         ));
         $packageB->setRequires(array(
-            'c' => new Link('B', 'C', $this->getVersionConstraint('>=', '1.0'), 'requires'),
+            'c' => new Link('B', 'C', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE),
         ));
         $packageC->setRequires(array(
-            'd' => new Link('C', 'D', $this->getVersionConstraint('>=', '1.0'), 'requires'),
+            'd' => new Link('C', 'D', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE),
         ));
         $packageD->setRequires(array(
-            'b' => new Link('D', 'B', $this->getVersionConstraint('<', '1.0'), 'requires'),
+            'b' => new Link('D', 'B', $this->getVersionConstraint('<', '1.0'), Link::TYPE_REQUIRE),
         ));
 
         $this->reposComplete();
 
-        $this->request->install('A');
+        $emptyConstraint = new MatchAllConstraint();
+        $emptyConstraint->setPrettyString('*');
+
+        $this->request->requireName('A', $emptyConstraint);
 
+        $this->createSolver();
         try {
             $transaction = $this->solver->solve($this->request);
             $this->fail('Unsolvable conflict did not result in exception.');
@@ -755,10 +731,10 @@ class SolverTest extends TestCase
             $msg .= "    - C 1.0 requires d >= 1.0 -> satisfiable by D[1.0].\n";
             $msg .= "    - D 1.0 requires b < 1.0 -> satisfiable by B[0.9].\n";
             $msg .= "    - B 1.0 requires c >= 1.0 -> satisfiable by C[1.0].\n";
-            $msg .= "    - Can only install one of: B[0.9, 1.0].\n";
+            $msg .= "    - You can only install one version of a package, so only one of these can be installed: B[0.9, 1.0].\n";
             $msg .= "    - A 1.0 requires b >= 1.0 -> satisfiable by B[1.0].\n";
-            $msg .= "    - Installation request for a -> satisfiable by A[1.0].\n";
-            $this->assertEquals($msg, $e->getMessage());
+            $msg .= "    - Root composer.json requires a * -> satisfiable by A[1.0].\n";
+            $this->assertEquals($msg, $e->getPrettyString($this->repoSet, $this->request, $this->pool, false));
         }
     }
 
@@ -771,17 +747,17 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageTwigBridge = $this->getPackage('symfony/twig-bridge', '2.0'));
 
         $packageTwigBridge->setRequires(array(
-            'twig/twig' => new Link('symfony/twig-bridge', 'twig/twig', $this->getVersionConstraint('<', '2.0'), 'requires'),
+            'twig/twig' => new Link('symfony/twig-bridge', 'twig/twig', $this->getVersionConstraint('<', '2.0'), Link::TYPE_REQUIRE),
         ));
 
         $packageSymfony->setReplaces(array(
-            'symfony/twig-bridge' => new Link('symfony/symfony', 'symfony/twig-bridge', $this->getVersionConstraint('==', '2.0'), 'replaces'),
+            'symfony/twig-bridge' => new Link('symfony/symfony', 'symfony/twig-bridge', $this->getVersionConstraint('==', '2.0'), Link::TYPE_REPLACE),
         ));
 
         $this->reposComplete();
 
-        $this->request->install('symfony/twig-bridge');
-        $this->request->install('twig/twig');
+        $this->request->requireName('symfony/twig-bridge');
+        $this->request->requireName('twig/twig');
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $packageTwig16),
@@ -796,22 +772,22 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageA2 = $this->getPackage('A', '2.0'));
 
         $packageA2->setRequires(array(
-            'b' => new Link('A', 'B', $this->getVersionConstraint('==', '2.0'), 'requires', '== 2.0'),
+            'b' => new Link('A', 'B', $this->getVersionConstraint('==', '2.0'), Link::TYPE_REQUIRE, '== 2.0'),
         ));
         $packageB->setRequires(array(
-            'a' => new Link('B', 'A', $this->getVersionConstraint('>=', '2.0'), 'requires'),
+            'a' => new Link('B', 'A', $this->getVersionConstraint('>=', '2.0'), Link::TYPE_REQUIRE),
         ));
 
         $this->repo->addPackage($packageA2Alias = $this->getAliasPackage($packageA2, '1.1'));
 
         $this->reposComplete();
 
-        $this->request->install('A', $this->getVersionConstraint('==', '1.1.0.0'));
+        $this->request->requireName('A', $this->getVersionConstraint('==', '1.1.0.0'));
 
         $this->checkSolverResult(array(
-            array('job' => 'install', 'package' => $packageA2),
             array('job' => 'install', 'package' => $packageB),
-            array('job' => 'install', 'package' => $packageA2Alias),
+            array('job' => 'install', 'package' => $packageA2),
+            array('job' => 'markAliasInstalled', 'package' => $packageA2Alias),
         ));
     }
 
@@ -821,20 +797,50 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageB = $this->getPackage('B', '1.0'));
 
         $packageB->setRequires(array(
-            'a' => new Link('B', 'A', $this->getVersionConstraint('<', '2.0'), 'requires'),
+            'a' => new Link('B', 'A', $this->getVersionConstraint('<', '2.0'), Link::TYPE_REQUIRE),
+        ));
+
+        $this->repo->addPackage($packageAAlias = $this->getAliasPackage($packageA, '1.1'));
+
+        $this->reposComplete();
+
+        $this->request->requireName('A', $this->getVersionConstraint('==', '2.0'));
+        $this->request->requireName('B');
+
+        $this->checkSolverResult(array(
+            array('job' => 'install', 'package' => $packageA),
+            array('job' => 'markAliasInstalled', 'package' => $packageAAlias),
+            array('job' => 'install', 'package' => $packageB),
         ));
+    }
 
+    public function testInstallRootAliasesIfAliasOfIsInstalled()
+    {
+        // root aliased, required
+        $this->repo->addPackage($packageA = $this->getPackage('A', '1.0'));
         $this->repo->addPackage($packageAAlias = $this->getAliasPackage($packageA, '1.1'));
+        $packageAAlias->setRootPackageAlias(true);
+        // root aliased, not required, should still be installed as it is root alias
+        $this->repo->addPackage($packageB = $this->getPackage('B', '1.0'));
+        $this->repo->addPackage($packageBAlias = $this->getAliasPackage($packageB, '1.1'));
+        $packageBAlias->setRootPackageAlias(true);
+        // regular alias, not required, alias should not be installed
+        $this->repo->addPackage($packageC = $this->getPackage('C', '1.0'));
+        $this->repo->addPackage($packageCAlias = $this->getAliasPackage($packageC, '1.1'));
 
         $this->reposComplete();
 
-        $this->request->install('A', $this->getVersionConstraint('==', '2.0'));
-        $this->request->install('B');
+        $this->request->requireName('A', $this->getVersionConstraint('==', '1.1'));
+        $this->request->requireName('B', $this->getVersionConstraint('==', '1.0'));
+        $this->request->requireName('C', $this->getVersionConstraint('==', '1.0'));
 
         $this->checkSolverResult(array(
             array('job' => 'install', 'package' => $packageA),
-            array('job' => 'install', 'package' => $packageAAlias),
+            array('job' => 'markAliasInstalled', 'package' => $packageAAlias),
             array('job' => 'install', 'package' => $packageB),
+            array('job' => 'markAliasInstalled', 'package' => $packageBAlias),
+            array('job' => 'install', 'package' => $packageC),
+            array('job' => 'markAliasInstalled', 'package' => $packageCAlias),
         ));
     }
 
@@ -862,34 +868,36 @@ class SolverTest extends TestCase
         $this->repo->addPackage($packageG3 = $this->getPackage('G', '3.0'));
 
         $packageA->setRequires(array(
-            'b' => new Link('A', 'B', $this->getVersionConstraint('==', '1.0'), 'requires'),
-            'c' => new Link('A', 'C', $this->getVersionConstraint('>=', '1.0'), 'requires'),
-            'd' => new Link('A', 'D', $this->getVersionConstraint('==', '1.0'), 'requires'),
+            'b' => new Link('A', 'B', $this->getVersionConstraint('==', '1.0'), Link::TYPE_REQUIRE),
+            'c' => new Link('A', 'C', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE),
+            'd' => new Link('A', 'D', $this->getVersionConstraint('==', '1.0'), Link::TYPE_REQUIRE),
         ));
 
         $packageB->setRequires(array(
-            'e' => new Link('B', 'E', $this->getVersionConstraint('==', '1.0'), 'requires'),
+            'e' => new Link('B', 'E', $this->getVersionConstraint('==', '1.0'), Link::TYPE_REQUIRE),
         ));
 
         $packageC1->setRequires(array(
-            'f' => new Link('C', 'F', $this->getVersionConstraint('==', '1.0'), 'requires'),
+            'f' => new Link('C', 'F', $this->getVersionConstraint('==', '1.0'), Link::TYPE_REQUIRE),
         ));
         $packageC2->setRequires(array(
-            'f' => new Link('C', 'F', $this->getVersionConstraint('==', '1.0'), 'requires'),
-            'g' => new Link('C', 'G', $this->getVersionConstraint('>=', '1.0'), 'requires'),
+            'f' => new Link('C', 'F', $this->getVersionConstraint('==', '1.0'), Link::TYPE_REQUIRE),
+            'g' => new Link('C', 'G', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE),
         ));
 
         $packageD->setRequires(array(
-            'f' => new Link('D', 'F', $this->getVersionConstraint('>=', '1.0'), 'requires'),
+            'f' => new Link('D', 'F', $this->getVersionConstraint('>=', '1.0'), Link::TYPE_REQUIRE),
         ));
 
         $packageE->setRequires(array(
-            'g' => new Link('E', 'G', $this->getVersionConstraint('<=', '2.0'), 'requires'),
+            'g' => new Link('E', 'G', $this->getVersionConstraint('<=', '2.0'), Link::TYPE_REQUIRE),
         ));
 
         $this->reposComplete();
 
-        $this->request->install('A');
+        $this->request->requireName('A');
+
+        $this->createSolver();
 
         // check correct setup for assertion later
         $this->assertFalse($this->solver->testFlagLearnedPositiveLiteral);
@@ -911,24 +919,37 @@ class SolverTest extends TestCase
 
     protected function reposComplete()
     {
-        $this->pool->addRepository($this->repoInstalled);
-        $this->pool->addRepository($this->repo);
+        $this->repoSet->addRepository($this->repo);
+        $this->repoSet->addRepository($this->repoLocked);
+    }
+
+    protected function createSolver()
+    {
+        $io = new NullIO();
+        $this->pool = $this->repoSet->createPool($this->request, $io);
+        $this->solver = new Solver($this->policy, $this->pool, $io);
     }
 
     protected function checkSolverResult(array $expected)
     {
+        $this->createSolver();
         $transaction = $this->solver->solve($this->request);
 
         $result = array();
-        foreach ($transaction as $operation) {
-            if ('update' === $operation->getJobType()) {
+        foreach ($transaction->getOperations() as $operation) {
+            if ('update' === $operation->getOperationType()) {
                 $result[] = array(
                     'job' => 'update',
                     'from' => $operation->getInitialPackage(),
                     'to' => $operation->getTargetPackage(),
                 );
+            } elseif (in_array($operation->getOperationType(), array('markAliasInstalled', 'markAliasUninstalled'))) {
+                $result[] = array(
+                    'job' => $operation->getOperationType(),
+                    'package' => $operation->getPackage(),
+                );
             } else {
-                $job = ('uninstall' === $operation->getJobType() ? 'remove' : 'install');
+                $job = ('uninstall' === $operation->getOperationType() ? 'remove' : 'install');
                 $result[] = array(
                     'job' => $job,
                     'package' => $operation->getPackage(),
@@ -936,6 +957,16 @@ class SolverTest extends TestCase
             }
         }
 
+        $expectedReadable = array();
+        foreach ($expected as $op) {
+            $expectedReadable[] = array_map('strval', $op);
+        }
+        $resultReadable = array();
+        foreach ($result as $op) {
+            $resultReadable[] = array_map('strval', $op);
+        }
+
+        $this->assertEquals($expectedReadable, $resultReadable);
         $this->assertEquals($expected, $result);
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/DependencyResolver/TransactionTest.php 2.0.9-1/tests/Composer/Test/DependencyResolver/TransactionTest.php
--- 1.10.19-1/tests/Composer/Test/DependencyResolver/TransactionTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/DependencyResolver/TransactionTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,116 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\DependencyResolver;
+
+use Composer\DependencyResolver\Transaction;
+use Composer\Package\Link;
+use Composer\Test\TestCase;
+
+class TransactionTest extends TestCase
+{
+    public function setUp()
+    {
+    }
+
+    public function testTransactionGenerationAndSorting()
+    {
+        $presentPackages = array(
+            $packageA = $this->getPackage('a/a', 'dev-master'),
+            $packageAalias = $this->getAliasPackage($packageA, '1.0.x-dev'),
+            $packageB = $this->getPackage('b/b', '1.0.0'),
+            $packageE = $this->getPackage('e/e', 'dev-foo'),
+            $packageEalias = $this->getAliasPackage($packageE, '1.0.x-dev'),
+            $packageC = $this->getPackage('c/c', '1.0.0'),
+        );
+        $resultPackages = array(
+            $packageA,
+            $packageAalias,
+            $packageBnew = $this->getPackage('b/b', '2.1.3'),
+            $packageD = $this->getPackage('d/d', '1.2.3'),
+            $packageF = $this->getPackage('f/f', '1.0.0'),
+            $packageFalias1 = $this->getAliasPackage($packageF, 'dev-foo'),
+            $packageG = $this->getPackage('g/g', '1.0.0'),
+            $packageA0first = $this->getPackage('a0/first', '1.2.3'),
+            $packageFalias2 = $this->getAliasPackage($packageF, 'dev-bar'),
+            $plugin = $this->getPackage('x/plugin', '1.0.0'),
+            $plugin2Dep = $this->getPackage('x/plugin2-dep', '1.0.0'),
+            $plugin2 = $this->getPackage('x/plugin2', '1.0.0'),
+            $dlModifyingPlugin = $this->getPackage('x/downloads-modifying', '1.0.0'),
+            $dlModifyingPlugin2Dep = $this->getPackage('x/downloads-modifying2-dep', '1.0.0'),
+            $dlModifyingPlugin2 = $this->getPackage('x/downloads-modifying2', '1.0.0'),
+        );
+
+        $plugin->setType('composer-installer');
+        foreach (array($plugin2, $dlModifyingPlugin, $dlModifyingPlugin2) as $pluginPackage) {
+            $pluginPackage->setType('composer-plugin');
+        }
+
+        $plugin2->setRequires(array(
+            'x/plugin2-dep' => new Link('x/plugin2', 'x/plugin2-dep', $this->getVersionConstraint('=', '1.0.0'), Link::TYPE_REQUIRE),
+        ));
+        $dlModifyingPlugin2->setRequires(array(
+            'x/downloads-modifying2-dep' => new Link('x/downloads-modifying2', 'x/downloads-modifying2-dep', $this->getVersionConstraint('=', '1.0.0'), Link::TYPE_REQUIRE),
+        ));
+        $dlModifyingPlugin->setExtra(array('plugin-modifies-downloads' => true));
+        $dlModifyingPlugin2->setExtra(array('plugin-modifies-downloads' => true));
+
+        $packageD->setRequires(array(
+            'f/f' => new Link('d/d', 'f/f', $this->getVersionConstraint('>', '0.2'), Link::TYPE_REQUIRE),
+            'g/provider' => new Link('d/d', 'g/provider', $this->getVersionConstraint('>', '0.2'), Link::TYPE_REQUIRE),
+        ));
+        $packageG->setProvides(array('g/provider' => new Link('g/g', 'g/provider', $this->getVersionConstraint('==', '1.0.0'), Link::TYPE_PROVIDE)));
+
+        $expectedOperations = array(
+            array('job' => 'uninstall', 'package' => $packageC),
+            array('job' => 'uninstall', 'package' => $packageE),
+            array('job' => 'markAliasUninstalled', 'package' => $packageEalias),
+            array('job' => 'install', 'package' => $dlModifyingPlugin),
+            array('job' => 'install', 'package' => $dlModifyingPlugin2Dep),
+            array('job' => 'install', 'package' => $dlModifyingPlugin2),
+            array('job' => 'install', 'package' => $plugin),
+            array('job' => 'install', 'package' => $plugin2Dep),
+            array('job' => 'install', 'package' => $plugin2),
+            array('job' => 'install', 'package' => $packageA0first),
+            array('job' => 'update', 'from' => $packageB, 'to' => $packageBnew),
+            array('job' => 'install', 'package' => $packageG),
+            array('job' => 'install', 'package' => $packageF),
+            array('job' => 'markAliasInstalled', 'package' => $packageFalias2),
+            array('job' => 'markAliasInstalled', 'package' => $packageFalias1),
+            array('job' => 'install', 'package' => $packageD),
+        );
+
+        $transaction = new Transaction($presentPackages, $resultPackages);
+        $this->checkTransactionOperations($transaction, $expectedOperations);
+    }
+
+    protected function checkTransactionOperations(Transaction $transaction, array $expected)
+    {
+        $result = array();
+        foreach ($transaction->getOperations() as $operation) {
+            if ('update' === $operation->getOperationType()) {
+                $result[] = array(
+                    'job' => 'update',
+                    'from' => $operation->getInitialPackage(),
+                    'to' => $operation->getTargetPackage(),
+                );
+            } else {
+                $result[] = array(
+                    'job' => $operation->getOperationType(),
+                    'package' => $operation->getPackage(),
+                );
+            }
+        }
+
+        $this->assertEquals($expected, $result);
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Downloader/ArchiveDownloaderTest.php 2.0.9-1/tests/Composer/Test/Downloader/ArchiveDownloaderTest.php
--- 1.10.19-1/tests/Composer/Test/Downloader/ArchiveDownloaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Downloader/ArchiveDownloaderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,6 +16,8 @@ use Composer\Test\TestCase;
 
 class ArchiveDownloaderTest extends TestCase
 {
+    protected $config;
+
     public function testGetFileName()
     {
         $packageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
@@ -28,8 +30,13 @@ class ArchiveDownloaderTest extends Test
         $method = new \ReflectionMethod($downloader, 'getFileName');
         $method->setAccessible(true);
 
+        $this->config->expects($this->any())
+            ->method('get')
+            ->with('vendor-dir')
+            ->will($this->returnValue('/vendor'));
+
         $first = $method->invoke($downloader, $packageMock, '/path');
-        $this->assertRegExp('#/path/[a-z0-9]+\.js#', $first);
+        $this->assertMatchesRegularExpression('#/vendor/composer/tmp-[a-z0-9]+\.js#', $first);
         $this->assertSame($first, $method->invoke($downloader, $packageMock, '/path'));
     }
 
@@ -156,7 +163,11 @@ class ArchiveDownloaderTest extends Test
     {
         return $this->getMockForAbstractClass(
             'Composer\Downloader\ArchiveDownloader',
-            array($this->getMockBuilder('Composer\IO\IOInterface')->getMock(), $this->getMockBuilder('Composer\Config')->getMock())
+            array(
+                $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock(),
+                $this->config = $this->getMockBuilder('Composer\Config')->getMock(),
+                new \Composer\Util\HttpDownloader($io, $this->config),
+            )
         );
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Downloader/DownloadManagerTest.php 2.0.9-1/tests/Composer/Test/Downloader/DownloadManagerTest.php
--- 1.10.19-1/tests/Composer/Test/Downloader/DownloadManagerTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Downloader/DownloadManagerTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -50,7 +50,7 @@ class DownloadManagerTest extends TestCa
 
         $this->setExpectedException('InvalidArgumentException');
 
-        $manager->getDownloaderForInstalledPackage($package);
+        $manager->getDownloaderForPackage($package);
     }
 
     public function testGetDownloaderForCorrectlyInstalledDistPackage()
@@ -82,7 +82,7 @@ class DownloadManagerTest extends TestCa
             ->with('pear')
             ->will($this->returnValue($downloader));
 
-        $this->assertSame($downloader, $manager->getDownloaderForInstalledPackage($package));
+        $this->assertSame($downloader, $manager->getDownloaderForPackage($package));
     }
 
     public function testGetDownloaderForIncorrectlyInstalledDistPackage()
@@ -116,7 +116,7 @@ class DownloadManagerTest extends TestCa
 
         $this->setExpectedException('LogicException');
 
-        $manager->getDownloaderForInstalledPackage($package);
+        $manager->getDownloaderForPackage($package);
     }
 
     public function testGetDownloaderForCorrectlyInstalledSourcePackage()
@@ -148,7 +148,7 @@ class DownloadManagerTest extends TestCa
             ->with('git')
             ->will($this->returnValue($downloader));
 
-        $this->assertSame($downloader, $manager->getDownloaderForInstalledPackage($package));
+        $this->assertSame($downloader, $manager->getDownloaderForPackage($package));
     }
 
     public function testGetDownloaderForIncorrectlyInstalledSourcePackage()
@@ -182,7 +182,7 @@ class DownloadManagerTest extends TestCa
 
         $this->setExpectedException('LogicException');
 
-        $manager->getDownloaderForInstalledPackage($package);
+        $manager->getDownloaderForPackage($package);
     }
 
     public function testGetDownloaderForMetapackage()
@@ -195,7 +195,7 @@ class DownloadManagerTest extends TestCa
 
         $manager = new DownloadManager($this->io, false, $this->filesystem);
 
-        $this->assertNull($manager->getDownloaderForInstalledPackage($package));
+        $this->assertNull($manager->getDownloaderForPackage($package));
     }
 
     public function testFullPackageDownload()
@@ -223,11 +223,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
 
@@ -274,16 +274,16 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->at(0))
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloaderFail));
         $manager
             ->expects($this->at(1))
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloaderSuccess));
 
@@ -333,11 +333,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
 
@@ -369,11 +369,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
 
@@ -399,11 +399,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
           ->setConstructorArgs(array($this->io, false, $this->filesystem))
-          ->setMethods(array('getDownloaderForInstalledPackage'))
+          ->setMethods(array('getDownloaderForPackage'))
           ->getMock();
         $manager
           ->expects($this->once())
-          ->method('getDownloaderForInstalledPackage')
+          ->method('getDownloaderForPackage')
           ->with($package)
           ->will($this->returnValue(null)); // There is no downloader for Metapackages.
 
@@ -435,11 +435,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
 
@@ -472,11 +472,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
 
@@ -509,11 +509,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
 
@@ -550,33 +550,30 @@ class DownloadManagerTest extends TestCa
         $initial
             ->expects($this->once())
             ->method('getDistType')
-            ->will($this->returnValue('pear'));
+            ->will($this->returnValue('zip'));
 
         $target = $this->createPackageMock();
         $target
             ->expects($this->once())
-            ->method('getDistType')
-            ->will($this->returnValue('pear'));
+            ->method('getInstallationSource')
+            ->will($this->returnValue('dist'));
         $target
             ->expects($this->once())
-            ->method('setInstallationSource')
-            ->with('dist');
+            ->method('getDistType')
+            ->will($this->returnValue('zip'));
 
-        $pearDownloader = $this->createDownloaderMock();
-        $pearDownloader
+        $zipDownloader = $this->createDownloaderMock();
+        $zipDownloader
             ->expects($this->once())
             ->method('update')
             ->with($initial, $target, 'vendor/bundles/FOS/UserBundle');
+        $zipDownloader
+            ->expects($this->any())
+            ->method('getInstallationSource')
+            ->will($this->returnValue('dist'));
 
-        $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
-            ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
-            ->getMock();
-        $manager
-            ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
-            ->with($initial)
-            ->will($this->returnValue($pearDownloader));
+        $manager = new DownloadManager($this->io, false, $this->filesystem);
+        $manager->setDownloader('zip', $zipDownloader);
 
         $manager->update($initial, $target, 'vendor/bundles/FOS/UserBundle');
     }
@@ -591,113 +588,89 @@ class DownloadManagerTest extends TestCa
         $initial
             ->expects($this->once())
             ->method('getDistType')
-            ->will($this->returnValue('pear'));
+            ->will($this->returnValue('xz'));
 
         $target = $this->createPackageMock();
         $target
-            ->expects($this->once())
+            ->expects($this->any())
+            ->method('getInstallationSource')
+            ->will($this->returnValue('dist'));
+        $target
+            ->expects($this->any())
             ->method('getDistType')
-            ->will($this->returnValue('composer'));
+            ->will($this->returnValue('zip'));
 
-        $pearDownloader = $this->createDownloaderMock();
-        $pearDownloader
+        $xzDownloader = $this->createDownloaderMock();
+        $xzDownloader
             ->expects($this->once())
             ->method('remove')
             ->with($initial, 'vendor/bundles/FOS/UserBundle');
-
-        $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
-            ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage', 'download'))
-            ->getMock();
-        $manager
-            ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
-            ->with($initial)
-            ->will($this->returnValue($pearDownloader));
-        $manager
-            ->expects($this->once())
-            ->method('download')
-            ->with($target, 'vendor/bundles/FOS/UserBundle', false);
-
-        $manager->update($initial, $target, 'vendor/bundles/FOS/UserBundle');
-    }
-
-    public function testUpdateSourceWithEqualTypes()
-    {
-        $initial = $this->createPackageMock();
-        $initial
-            ->expects($this->once())
+        $xzDownloader
+            ->expects($this->any())
             ->method('getInstallationSource')
-            ->will($this->returnValue('source'));
-        $initial
-            ->expects($this->once())
-            ->method('getSourceType')
-            ->will($this->returnValue('svn'));
-
-        $target = $this->createPackageMock();
-        $target
-            ->expects($this->once())
-            ->method('getSourceType')
-            ->will($this->returnValue('svn'));
+            ->will($this->returnValue('dist'));
 
-        $svnDownloader = $this->createDownloaderMock();
-        $svnDownloader
+        $zipDownloader = $this->createDownloaderMock();
+        $zipDownloader
             ->expects($this->once())
-            ->method('update')
-            ->with($initial, $target, 'vendor/pkg');
+            ->method('install')
+            ->with($target, 'vendor/bundles/FOS/UserBundle');
+        $zipDownloader
+            ->expects($this->any())
+            ->method('getInstallationSource')
+            ->will($this->returnValue('dist'));
 
-        $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
-            ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage', 'download'))
-            ->getMock();
-        $manager
-            ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
-            ->with($initial)
-            ->will($this->returnValue($svnDownloader));
+        $manager = new DownloadManager($this->io, false, $this->filesystem);
+        $manager->setDownloader('xz', $xzDownloader);
+        $manager->setDownloader('zip', $zipDownloader);
 
-        $manager->update($initial, $target, 'vendor/pkg');
+        $manager->update($initial, $target, 'vendor/bundles/FOS/UserBundle');
     }
 
-    public function testUpdateSourceWithNotEqualTypes()
+    /**
+     * @dataProvider updatesProvider
+     */
+    public function testGetAvailableSourcesUpdateSticksToSameSource($prevPkgSource, $prevPkgIsDev, $targetAvailable, $targetIsDev, $expected)
     {
-        $initial = $this->createPackageMock();
-        $initial
-            ->expects($this->once())
-            ->method('getInstallationSource')
-            ->will($this->returnValue('source'));
-        $initial
-            ->expects($this->once())
-            ->method('getSourceType')
-            ->will($this->returnValue('svn'));
-
-        $target = $this->createPackageMock();
-        $target
-            ->expects($this->once())
-            ->method('getSourceType')
-            ->will($this->returnValue('git'));
-
-        $svnDownloader = $this->createDownloaderMock();
-        $svnDownloader
-            ->expects($this->once())
-            ->method('remove')
-            ->with($initial, 'vendor/pkg');
+        $initial = null;
+        if ($prevPkgSource) {
+            $initial = $this->prophesize('Composer\Package\PackageInterface');
+            $initial->getInstallationSource()->willReturn($prevPkgSource);
+            $initial->isDev()->willReturn($prevPkgIsDev);
+        }
+
+        $target = $this->prophesize('Composer\Package\PackageInterface');
+        $target->getSourceType()->willReturn(in_array('source', $targetAvailable, true) ? 'git' : null);
+        $target->getDistType()->willReturn(in_array('dist', $targetAvailable, true) ? 'zip' : null);
+        $target->isDev()->willReturn($targetIsDev);
 
-        $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
-            ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage', 'download'))
-            ->getMock();
-        $manager
-            ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
-            ->with($initial)
-            ->will($this->returnValue($svnDownloader));
-        $manager
-            ->expects($this->once())
-            ->method('download')
-            ->with($target, 'vendor/pkg', true);
-
-        $manager->update($initial, $target, 'vendor/pkg');
+        $manager = new DownloadManager($this->io, false, $this->filesystem);
+        $method = new \ReflectionMethod($manager, 'getAvailableSources');
+        $method->setAccessible(true);
+        $this->assertEquals($expected, $method->invoke($manager, $target->reveal(), $initial ? $initial->reveal() : null));
+    }
+
+    public static function updatesProvider()
+    {
+        return array(
+            //    prevPkg source,  prevPkg isDev, pkg available,           pkg isDev,  expected
+            // updates keep previous source as preference
+            array('source',        false,         array('source', 'dist'), false,      array('source', 'dist')),
+            array('dist',          false,         array('source', 'dist'), false,      array('dist', 'source')),
+            // updates do not keep previous source if target package does not have it
+            array('source',        false,         array('dist'),           false,      array('dist')),
+            array('dist',          false,         array('source'),         false,      array('source')),
+            // updates do not keep previous source if target is dev and prev wasn't dev and installed from dist
+            array('source',        false,         array('source', 'dist'), true,       array('source', 'dist')),
+            array('dist',          false,         array('source', 'dist'), true,       array('source', 'dist')),
+            // install picks the right default
+            array(null,            null,          array('source', 'dist'), true,       array('source', 'dist')),
+            array(null,            null,          array('dist'),           true,       array('dist')),
+            array(null,            null,          array('source'),         true,       array('source')),
+            array(null,            null,          array('source', 'dist'), false,      array('dist', 'source')),
+            array(null,            null,          array('dist'),           false,      array('dist')),
+            array(null,            null,          array('source'),         false,      array('source')),
+        );
     }
 
     public function testUpdateMetapackage()
@@ -707,11 +680,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
           ->setConstructorArgs(array($this->io, false, $this->filesystem))
-          ->setMethods(array('getDownloaderForInstalledPackage'))
+          ->setMethods(array('getDownloaderForPackage'))
           ->getMock();
         $manager
-          ->expects($this->once())
-          ->method('getDownloaderForInstalledPackage')
+          ->expects($this->exactly(2))
+          ->method('getDownloaderForPackage')
           ->with($initial)
           ->will($this->returnValue(null)); // There is no downloader for metapackages.
 
@@ -730,11 +703,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($pearDownloader));
 
@@ -747,11 +720,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
           ->setConstructorArgs(array($this->io, false, $this->filesystem))
-          ->setMethods(array('getDownloaderForInstalledPackage'))
+          ->setMethods(array('getDownloaderForPackage'))
           ->getMock();
         $manager
           ->expects($this->once())
-          ->method('getDownloaderForInstalledPackage')
+          ->method('getDownloaderForPackage')
           ->with($package)
           ->will($this->returnValue(null)); // There is no downloader for metapackages.
 
@@ -790,11 +763,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
 
@@ -833,11 +806,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
 
@@ -879,11 +852,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
         $manager->setPreferences(array('foo/*' => 'source'));
@@ -926,11 +899,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
         $manager->setPreferences(array('foo/*' => 'source'));
@@ -973,11 +946,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
         $manager->setPreferences(array('foo/*' => 'auto'));
@@ -1020,11 +993,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
         $manager->setPreferences(array('foo/*' => 'auto'));
@@ -1063,11 +1036,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
         $manager->setPreferences(array('foo/*' => 'source'));
@@ -1106,11 +1079,11 @@ class DownloadManagerTest extends TestCa
 
         $manager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($this->io, false, $this->filesystem))
-            ->setMethods(array('getDownloaderForInstalledPackage'))
+            ->setMethods(array('getDownloaderForPackage'))
             ->getMock();
         $manager
             ->expects($this->once())
-            ->method('getDownloaderForInstalledPackage')
+            ->method('getDownloaderForPackage')
             ->with($package)
             ->will($this->returnValue($downloader));
         $manager->setPreferences(array('foo/*' => 'dist'));
diff -pruN 1.10.19-1/tests/Composer/Test/Downloader/FileDownloaderTest.php 2.0.9-1/tests/Composer/Test/Downloader/FileDownloaderTest.php
--- 1.10.19-1/tests/Composer/Test/Downloader/FileDownloaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Downloader/FileDownloaderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,24 +12,35 @@
 
 namespace Composer\Test\Downloader;
 
+use Composer\Config;
 use Composer\Downloader\FileDownloader;
+use Composer\EventDispatcher\EventDispatcher;
+use Composer\Plugin\PluginEvents;
+use Composer\Plugin\PreFileDownloadEvent;
 use Composer\Test\TestCase;
 use Composer\Util\Filesystem;
+use Composer\Util\Http\Response;
+use Composer\Util\Loop;
 
 class FileDownloaderTest extends TestCase
 {
-    protected function getDownloader($io = null, $config = null, $eventDispatcher = null, $cache = null, $rfs = null, $filesystem = null)
+    private $httpDownloader;
+    private $config;
+
+    protected function getDownloader($io = null, $config = null, $eventDispatcher = null, $cache = null, $httpDownloader = null, $filesystem = null)
     {
         $io = $io ?: $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
-        $config = $config ?: $this->getMockBuilder('Composer\Config')->getMock();
-        $rfs = $rfs ?: $this->getMockBuilder('Composer\Util\RemoteFilesystem')->disableOriginalConstructor()->getMock();
+        $this->config = $config ?: $this->getMockBuilder('Composer\Config')->getMock();
+        $httpDownloader = $httpDownloader ?: $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock();
+        $httpDownloader
+            ->expects($this->any())
+            ->method('addCopy')
+            ->will($this->returnValue(\React\Promise\resolve(new Response(array('url' => 'http://example.org/'), 200, array(), 'file~'))));
+        $this->httpDownloader = $httpDownloader;
 
-        return new FileDownloader($io, $config, $eventDispatcher, $cache, $rfs, $filesystem);
+        return new FileDownloader($io, $this->config, $httpDownloader, $eventDispatcher, $cache, $filesystem);
     }
 
-    /**
-     * @expectedException \InvalidArgumentException
-     */
     public function testDownloadForPackageWithoutDistReference()
     {
         $packageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
@@ -38,6 +49,8 @@ class FileDownloaderTest extends TestCas
             ->will($this->returnValue(null))
         ;
 
+        $this->setExpectedException('InvalidArgumentException');
+
         $downloader = $this->getDownloader();
         $downloader->download($packageMock, '/path');
     }
@@ -45,11 +58,11 @@ class FileDownloaderTest extends TestCas
     public function testDownloadToExistingFile()
     {
         $packageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
-        $packageMock->expects($this->once())
+        $packageMock->expects($this->any())
             ->method('getDistUrl')
             ->will($this->returnValue('url'))
         ;
-        $packageMock->expects($this->once())
+        $packageMock->expects($this->any())
             ->method('getDistUrls')
             ->will($this->returnValue(array('url')))
         ;
@@ -68,7 +81,7 @@ class FileDownloaderTest extends TestCas
                 unlink($path);
             }
             $this->assertInstanceOf('RuntimeException', $e);
-            $this->assertContains('exists and is not a directory', $e->getMessage());
+            $this->assertStringContainsString('exists and is not a directory', $e->getMessage());
         }
     }
 
@@ -84,7 +97,12 @@ class FileDownloaderTest extends TestCas
         $method = new \ReflectionMethod($downloader, 'getFileName');
         $method->setAccessible(true);
 
-        $this->assertEquals('/path/script.js', $method->invoke($downloader, $packageMock, '/path'));
+        $this->config->expects($this->once())
+            ->method('get')
+            ->with('vendor-dir')
+            ->will($this->returnValue('/vendor'));
+
+        $this->assertMatchesRegularExpression('#/vendor/composer/tmp-[a-z0-9]+\.js#', $method->invoke($downloader, $packageMock, '/path'));
     }
 
     public function testDownloadButFileIsUnsaved()
@@ -117,9 +135,205 @@ class FileDownloaderTest extends TestCas
         ;
 
         $downloader = $this->getDownloader($ioMock);
+
+        $this->config->expects($this->once())
+            ->method('get')
+            ->with('vendor-dir')
+            ->will($this->returnValue($path.'/vendor'));
+
         try {
-            $downloader->download($packageMock, $path);
-            $this->fail();
+            $loop = new Loop($this->httpDownloader);
+            $promise = $downloader->download($packageMock, $path);
+            $loop->wait(array($promise));
+
+            $this->fail('Download was expected to throw');
+        } catch (\Exception $e) {
+            if (is_dir($path)) {
+                $fs = new Filesystem();
+                $fs->removeDirectory($path);
+            } elseif (is_file($path)) {
+                unlink($path);
+            }
+
+            $this->assertInstanceOf('UnexpectedValueException', $e, $e->getMessage());
+            $this->assertStringContainsString('could not be saved to', $e->getMessage());
+        }
+    }
+
+    public function testDownloadWithCustomProcessedUrl()
+    {
+        $self = $this;
+
+        $path = $this->getUniqueTmpDirectory();
+        $config = new Config(false, $path);
+
+        $packageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
+        $packageMock->expects($this->any())
+            ->method('getDistUrl')
+            ->will($this->returnValue('url'));
+        $packageMock->expects($this->any())
+            ->method('getDistUrls')
+            ->will($this->returnValue(array('url')));
+
+        $rootPackageMock = $this->getMockBuilder('Composer\Package\RootPackageInterface')->getMock();
+        $rootPackageMock->expects($this->any())
+            ->method('getScripts')
+            ->will($this->returnValue(array()));
+
+        $composerMock = $this->getMockBuilder('Composer\Composer')->getMock();
+        $composerMock->expects($this->any())
+            ->method('getPackage')
+            ->will($this->returnValue($rootPackageMock));
+        $composerMock->expects($this->any())
+            ->method('getConfig')
+            ->will($this->returnValue($config));
+
+        $expectedUrl = 'foobar';
+        $expectedCacheKey = '/'.sha1($expectedUrl).'.';
+
+        $dispatcher = new EventDispatcher(
+            $composerMock,
+            $this->getMockBuilder('Composer\IO\IOInterface')->getMock(),
+            $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock()
+        );
+        $dispatcher->addListener(PluginEvents::PRE_FILE_DOWNLOAD, function (PreFileDownloadEvent $event) use ($expectedUrl) {
+            $event->setProcessedUrl($expectedUrl);
+        });
+
+        $cacheMock = $this->getMockBuilder('Composer\Cache')
+            ->disableOriginalConstructor()
+            ->getMock();
+        $cacheMock
+            ->expects($this->any())
+            ->method('copyTo')
+            ->will($this->returnCallback(function ($cacheKey) use ($self, $expectedCacheKey) {
+                $self->assertEquals($expectedCacheKey, $cacheKey, 'Failed assertion on $cacheKey argument of Cache::copyTo method:');
+
+                return false;
+            }));
+        $cacheMock
+            ->expects($this->any())
+            ->method('copyFrom')
+            ->will($this->returnCallback(function ($cacheKey) use ($self, $expectedCacheKey) {
+                $self->assertEquals($expectedCacheKey, $cacheKey, 'Failed assertion on $cacheKey argument of Cache::copyFrom method:');
+
+                return false;
+            }));
+
+        $httpDownloaderMock = $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock();
+        $httpDownloaderMock
+            ->expects($this->any())
+            ->method('addCopy')
+            ->will($this->returnCallback(function ($url) use ($self, $expectedUrl) {
+                $self->assertEquals($expectedUrl, $url, 'Failed assertion on $url argument of HttpDownloader::addCopy method:');
+
+                return \React\Promise\resolve(
+                    new Response(array('url' => 'http://example.org/'), 200, array(), 'file~')
+                );
+            }));
+
+        $downloader = $this->getDownloader(null, $config, $dispatcher, $cacheMock, $httpDownloaderMock);
+
+        try {
+            $loop = new Loop($this->httpDownloader);
+            $promise = $downloader->download($packageMock, $path);
+            $loop->wait(array($promise));
+
+            $this->fail('Download was expected to throw');
+        } catch (\Exception $e) {
+            if (is_dir($path)) {
+                $fs = new Filesystem();
+                $fs->removeDirectory($path);
+            } elseif (is_file($path)) {
+                unlink($path);
+            }
+
+            $this->assertInstanceOf('UnexpectedValueException', $e, $e->getMessage());
+            $this->assertStringContainsString('could not be saved to', $e->getMessage());
+        }
+    }
+
+    public function testDownloadWithCustomCacheKey()
+    {
+        $self = $this;
+
+        $path = $this->getUniqueTmpDirectory();
+        $config = new Config(false, $path);
+
+        $packageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
+        $packageMock->expects($this->any())
+            ->method('getDistUrl')
+            ->will($this->returnValue('url'));
+        $packageMock->expects($this->any())
+            ->method('getDistUrls')
+            ->will($this->returnValue(array('url')));
+
+        $rootPackageMock = $this->getMockBuilder('Composer\Package\RootPackageInterface')->getMock();
+        $rootPackageMock->expects($this->any())
+            ->method('getScripts')
+            ->will($this->returnValue(array()));
+
+        $composerMock = $this->getMockBuilder('Composer\Composer')->getMock();
+        $composerMock->expects($this->any())
+            ->method('getPackage')
+            ->will($this->returnValue($rootPackageMock));
+        $composerMock->expects($this->any())
+            ->method('getConfig')
+            ->will($this->returnValue($config));
+
+        $expectedUrl = 'url';
+        $customCacheKey = 'xyzzy';
+        $expectedCacheKey = '/'.sha1($customCacheKey).'.';
+
+        $dispatcher = new EventDispatcher(
+            $composerMock,
+            $this->getMockBuilder('Composer\IO\IOInterface')->getMock(),
+            $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock()
+        );
+        $dispatcher->addListener(PluginEvents::PRE_FILE_DOWNLOAD, function (PreFileDownloadEvent $event) use ($customCacheKey) {
+            $event->setCustomCacheKey($customCacheKey);
+        });
+
+        $cacheMock = $this->getMockBuilder('Composer\Cache')
+            ->disableOriginalConstructor()
+            ->getMock();
+        $cacheMock
+            ->expects($this->any())
+            ->method('copyTo')
+            ->will($this->returnCallback(function ($cacheKey) use ($self, $expectedCacheKey) {
+                $self->assertEquals($expectedCacheKey, $cacheKey, 'Failed assertion on $cacheKey argument of Cache::copyTo method:');
+
+                return false;
+            }));
+        $cacheMock
+            ->expects($this->any())
+            ->method('copyFrom')
+            ->will($this->returnCallback(function ($cacheKey) use ($self, $expectedCacheKey) {
+                $self->assertEquals($expectedCacheKey, $cacheKey, 'Failed assertion on $cacheKey argument of Cache::copyFrom method:');
+
+                return false;
+            }));
+
+        $httpDownloaderMock = $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock();
+        $httpDownloaderMock
+            ->expects($this->any())
+            ->method('addCopy')
+            ->will($this->returnCallback(function ($url) use ($self, $expectedUrl) {
+                $self->assertEquals($expectedUrl, $url, 'Failed assertion on $url argument of HttpDownloader::addCopy method:');
+
+                return \React\Promise\resolve(
+                    new Response(array('url' => 'http://example.org/'), 200, array(), 'file~')
+                );
+            }));
+
+        $downloader = $this->getDownloader(null, $config, $dispatcher, $cacheMock, $httpDownloaderMock);
+
+        try {
+            $loop = new Loop($this->httpDownloader);
+            $promise = $downloader->download($packageMock, $path);
+            $loop->wait(array($promise));
+
+            $this->fail('Download was expected to throw');
         } catch (\Exception $e) {
             if (is_dir($path)) {
                 $fs = new Filesystem();
@@ -128,8 +342,8 @@ class FileDownloaderTest extends TestCas
                 unlink($path);
             }
 
-            $this->assertInstanceOf('UnexpectedValueException', $e);
-            $this->assertContains('could not be saved to', $e->getMessage());
+            $this->assertInstanceOf('UnexpectedValueException', $e, $e->getMessage());
+            $this->assertStringContainsString('could not be saved to', $e->getMessage());
         }
     }
 
@@ -187,12 +401,25 @@ class FileDownloaderTest extends TestCas
 
         $path = $this->getUniqueTmpDirectory();
         $downloader = $this->getDownloader(null, null, null, null, null, $filesystem);
+
         // make sure the file expected to be downloaded is on disk already
-        touch($path.'/script.js');
+        $this->config->expects($this->any())
+            ->method('get')
+            ->with('vendor-dir')
+            ->will($this->returnValue($path.'/vendor'));
+
+        $method = new \ReflectionMethod($downloader, 'getFileName');
+        $method->setAccessible(true);
+        $dlFile = $method->invoke($downloader, $packageMock, $path);
+        mkdir(dirname($dlFile), 0777, true);
+        touch($dlFile);
 
         try {
-            $downloader->download($packageMock, $path);
-            $this->fail();
+            $loop = new Loop($this->httpDownloader);
+            $promise = $downloader->download($packageMock, $path);
+            $loop->wait(array($promise));
+
+            $this->fail('Download was expected to throw');
         } catch (\Exception $e) {
             if (is_dir($path)) {
                 $fs = new Filesystem();
@@ -201,8 +428,8 @@ class FileDownloaderTest extends TestCas
                 unlink($path);
             }
 
-            $this->assertInstanceOf('UnexpectedValueException', $e);
-            $this->assertContains('checksum verification', $e->getMessage());
+            $this->assertInstanceOf('UnexpectedValueException', $e, $e->getMessage());
+            $this->assertStringContainsString('checksum verification', $e->getMessage());
         }
     }
 
@@ -217,7 +444,7 @@ class FileDownloaderTest extends TestCas
             ->will($this->returnValue('1.2.0.0'));
 
         $newPackage = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
-        $newPackage->expects($this->once())
+        $newPackage->expects($this->any())
             ->method('getFullPrettyVersion')
             ->will($this->returnValue('1.0.0'));
         $newPackage->expects($this->once())
@@ -233,16 +460,36 @@ class FileDownloaderTest extends TestCas
         $ioMock = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
         $ioMock->expects($this->at(0))
             ->method('writeError')
+            ->with($this->stringContains('Downloading'));
+
+        $ioMock->expects($this->at(1))
+            ->method('writeError')
             ->with($this->stringContains('Downgrading'));
 
         $path = $this->getUniqueTmpDirectory();
-        touch($path.'/script.js');
         $filesystem = $this->getMockBuilder('Composer\Util\Filesystem')->getMock();
         $filesystem->expects($this->once())
             ->method('removeDirectory')
             ->will($this->returnValue(true));
 
         $downloader = $this->getDownloader($ioMock, null, null, null, null, $filesystem);
+
+        // make sure the file expected to be downloaded is on disk already
+        $this->config->expects($this->any())
+            ->method('get')
+            ->with('vendor-dir')
+            ->will($this->returnValue($path.'/vendor'));
+
+        $method = new \ReflectionMethod($downloader, 'getFileName');
+        $method->setAccessible(true);
+        $dlFile = $method->invoke($downloader, $newPackage, $path);
+        mkdir(dirname($dlFile), 0777, true);
+        touch($dlFile);
+
+        $loop = new Loop($this->httpDownloader);
+        $promise = $downloader->download($newPackage, $path, $oldPackage);
+        $loop->wait(array($promise));
+
         $downloader->update($oldPackage, $newPackage, $path);
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Downloader/FossilDownloaderTest.php 2.0.9-1/tests/Composer/Test/Downloader/FossilDownloaderTest.php
--- 1.10.19-1/tests/Composer/Test/Downloader/FossilDownloaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Downloader/FossilDownloaderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -45,21 +45,20 @@ class FossilDownloaderTest extends TestC
         return new FossilDownloader($io, $config, $executor, $filesystem);
     }
 
-    /**
-     * @expectedException \InvalidArgumentException
-     */
-    public function testDownloadForPackageWithoutSourceReference()
+    public function testInstallForPackageWithoutSourceReference()
     {
         $packageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
         $packageMock->expects($this->once())
             ->method('getSourceReference')
             ->will($this->returnValue(null));
 
+        $this->setExpectedException('InvalidArgumentException');
+
         $downloader = $this->getDownloaderMock();
-        $downloader->download($packageMock, '/path');
+        $downloader->install($packageMock, '/path');
     }
 
-    public function testDownload()
+    public function testInstall()
     {
         $packageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
         $packageMock->expects($this->any())
@@ -89,12 +88,9 @@ class FossilDownloaderTest extends TestC
             ->will($this->returnValue(0));
 
         $downloader = $this->getDownloaderMock(null, null, $processExecutor);
-        $downloader->download($packageMock, 'repo');
+        $downloader->install($packageMock, 'repo');
     }
 
-    /**
-     * @expectedException \InvalidArgumentException
-     */
     public function testUpdateforPackageWithoutSourceReference()
     {
         $initialPackageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
@@ -103,8 +99,12 @@ class FossilDownloaderTest extends TestC
             ->method('getSourceReference')
             ->will($this->returnValue(null));
 
+        $this->setExpectedException('InvalidArgumentException');
+
         $downloader = $this->getDownloaderMock();
+        $downloader->prepare('update', $sourcePackageMock, '/path', $initialPackageMock);
         $downloader->update($initialPackageMock, $sourcePackageMock, '/path');
+        $downloader->cleanup('update', $sourcePackageMock, '/path', $initialPackageMock);
     }
 
     public function testUpdate()
@@ -140,7 +140,9 @@ class FossilDownloaderTest extends TestC
             ->will($this->returnValue(0));
 
         $downloader = $this->getDownloaderMock(null, null, $processExecutor);
+        $downloader->prepare('update', $packageMock, $this->workingDir, $packageMock);
         $downloader->update($packageMock, $packageMock, $this->workingDir);
+        $downloader->cleanup('update', $packageMock, $this->workingDir, $packageMock);
     }
 
     public function testRemove()
diff -pruN 1.10.19-1/tests/Composer/Test/Downloader/GitDownloaderTest.php 2.0.9-1/tests/Composer/Test/Downloader/GitDownloaderTest.php
--- 1.10.19-1/tests/Composer/Test/Downloader/GitDownloaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Downloader/GitDownloaderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -17,8 +17,7 @@ use Composer\Config;
 use Composer\Test\TestCase;
 use Composer\Util\Filesystem;
 use Composer\Util\Platform;
-use Composer\Util\ProcessExecutor;
-use Composer\Util\Git as GitUtil;
+use Prophecy\Argument;
 
 class GitDownloaderTest extends TestCase
 {
@@ -77,9 +76,6 @@ class GitDownloaderTest extends TestCase
         return new GitDownloader($io, $config, $executor, $filesystem);
     }
 
-    /**
-     * @expectedException \InvalidArgumentException
-     */
     public function testDownloadForPackageWithoutSourceReference()
     {
         $packageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
@@ -87,8 +83,13 @@ class GitDownloaderTest extends TestCase
             ->method('getSourceReference')
             ->will($this->returnValue(null));
 
+        $this->setExpectedException('InvalidArgumentException');
+
         $downloader = $this->getDownloaderMock();
         $downloader->download($packageMock, '/path');
+        $downloader->prepare('install', $packageMock, '/path');
+        $downloader->install($packageMock, '/path');
+        $downloader->cleanup('install', $packageMock, '/path');
     }
 
     public function testDownload()
@@ -121,16 +122,14 @@ class GitDownloaderTest extends TestCase
 
         $processExecutor->expects($this->at(2))
             ->method('execute')
-            ->with($this->equalTo($this->winCompat("git checkout 'master' --")), $this->equalTo(null), $this->equalTo($this->winCompat('composerPath')))
-            ->will($this->returnValue(0));
-
-        $processExecutor->expects($this->at(3))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git reset --hard '1234567890123456789012345678901234567890' --")), $this->equalTo(null), $this->equalTo($this->winCompat('composerPath')))
+            ->with($this->equalTo($this->winCompat("(git checkout 'master' -- || git checkout -B 'master' 'composer/master' --) && git reset --hard '1234567890123456789012345678901234567890' --")), $this->equalTo(null), $this->equalTo($this->winCompat('composerPath')))
             ->will($this->returnValue(0));
 
         $downloader = $this->getDownloaderMock(null, null, $processExecutor);
         $downloader->download($packageMock, 'composerPath');
+        $downloader->prepare('install', $packageMock, 'composerPath');
+        $downloader->install($packageMock, 'composerPath');
+        $downloader->cleanup('install', $packageMock, 'composerPath');
     }
 
     public function testDownloadWithCache()
@@ -194,16 +193,14 @@ class GitDownloaderTest extends TestCase
 
         $processExecutor->expects($this->at(5))
             ->method('execute')
-            ->with($this->equalTo($this->winCompat("git checkout 'master' --")), $this->equalTo(null), $this->equalTo($this->winCompat('composerPath')))
-            ->will($this->returnValue(0));
-
-        $processExecutor->expects($this->at(6))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git reset --hard '1234567890123456789012345678901234567890' --")), $this->equalTo(null), $this->equalTo($this->winCompat('composerPath')))
+            ->with($this->equalTo($this->winCompat("(git checkout 'master' -- || git checkout -B 'master' 'composer/master' --) && git reset --hard '1234567890123456789012345678901234567890' --")), $this->equalTo(null), $this->equalTo($this->winCompat('composerPath')))
             ->will($this->returnValue(0));
 
         $downloader = $this->getDownloaderMock(null, $config, $processExecutor);
         $downloader->download($packageMock, 'composerPath');
+        $downloader->prepare('install', $packageMock, 'composerPath');
+        $downloader->install($packageMock, 'composerPath');
+        $downloader->cleanup('install', $packageMock, 'composerPath');
         @rmdir($cachePath);
     }
 
@@ -265,6 +262,9 @@ class GitDownloaderTest extends TestCase
 
         $downloader = $this->getDownloaderMock(null, new Config(), $processExecutor);
         $downloader->download($packageMock, 'composerPath');
+        $downloader->prepare('install', $packageMock, 'composerPath');
+        $downloader->install($packageMock, 'composerPath');
+        $downloader->cleanup('install', $packageMock, 'composerPath');
     }
 
     public function pushUrlProvider()
@@ -320,11 +320,11 @@ class GitDownloaderTest extends TestCase
 
         $downloader = $this->getDownloaderMock(null, $config, $processExecutor);
         $downloader->download($packageMock, 'composerPath');
+        $downloader->prepare('install', $packageMock, 'composerPath');
+        $downloader->install($packageMock, 'composerPath');
+        $downloader->cleanup('install', $packageMock, 'composerPath');
     }
 
-    /**
-     * @expectedException \RuntimeException
-     */
     public function testDownloadThrowsRuntimeExceptionIfGitCommandFails()
     {
         $expectedGitCommand = $this->winCompat("git clone --no-checkout 'https://example.com/composer/composer' 'composerPath' && cd 'composerPath' && git remote add composer 'https://example.com/composer/composer' && git fetch composer && git remote set-url origin 'https://example.com/composer/composer' && git remote set-url composer 'https://example.com/composer/composer'");
@@ -341,13 +341,22 @@ class GitDownloaderTest extends TestCase
             ->with($this->equalTo($expectedGitCommand))
             ->will($this->returnValue(1));
 
-        $downloader = $this->getDownloaderMock(null, null, $processExecutor);
-        $downloader->download($packageMock, 'composerPath');
+        // not using PHPUnit's expected exception because Prophecy exceptions extend from RuntimeException too so it is not safe
+        try {
+            $downloader = $this->getDownloaderMock(null, null, $processExecutor);
+            $downloader->download($packageMock, 'composerPath');
+            $downloader->prepare('install', $packageMock, 'composerPath');
+            $downloader->install($packageMock, 'composerPath');
+            $downloader->cleanup('install', $packageMock, 'composerPath');
+            $this->fail('This test should throw');
+        } catch (\RuntimeException $e) {
+            if ('RuntimeException' !== get_class($e)) {
+                throw $e;
+            }
+            $this->assertEquals('RuntimeException', get_class($e));
+        }
     }
 
-    /**
-     * @expectedException \InvalidArgumentException
-     */
     public function testUpdateforPackageWithoutSourceReference()
     {
         $initialPackageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
@@ -356,8 +365,13 @@ class GitDownloaderTest extends TestCase
             ->method('getSourceReference')
             ->will($this->returnValue(null));
 
+        $this->setExpectedException('InvalidArgumentException');
+
         $downloader = $this->getDownloaderMock();
+        $downloader->download($sourcePackageMock, '/path', $initialPackageMock);
+        $downloader->prepare('update', $sourcePackageMock, '/path', $initialPackageMock);
         $downloader->update($initialPackageMock, $sourcePackageMock, '/path');
+        $downloader->cleanup('update', $sourcePackageMock, '/path', $initialPackageMock);
     }
 
     public function testUpdate()
@@ -374,39 +388,21 @@ class GitDownloaderTest extends TestCase
         $packageMock->expects($this->any())
             ->method('getVersion')
             ->will($this->returnValue('1.0.0.0'));
-        $processExecutor = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
-        $processExecutor->expects($this->at(0))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git show-ref --head -d")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(1))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git status --porcelain --untracked-files=no")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(2))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git remote -v")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(3))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git remote -v")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(4))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat($expectedGitUpdateCommand)), $this->equalTo(null), $this->equalTo($this->winCompat($this->workingDir)))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(5))
-            ->method('execute')
-            ->with($this->equalTo('git branch -r'))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(6))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git checkout 'ref' -- && git reset --hard 'ref' --")), $this->equalTo(null), $this->equalTo($this->winCompat($this->workingDir)))
-            ->will($this->returnValue(0));
+
+        $process = $this->prophesize('Composer\Util\ProcessExecutor');
+        $process->execute($this->winCompat('git show-ref --head -d'), Argument::cetera())->willReturn(0);
+        $process->execute($this->winCompat('git status --porcelain --untracked-files=no'), Argument::cetera())->willReturn(0);
+        $process->execute($this->winCompat('git remote -v'), Argument::cetera())->willReturn(0);
+        $process->execute($this->winCompat('git branch -r'), Argument::cetera())->willReturn(0);
+        $process->execute($expectedGitUpdateCommand, null, $this->winCompat($this->workingDir))->willReturn(0)->shouldBeCalled();
+        $process->execute($this->winCompat("git checkout 'ref' -- && git reset --hard 'ref' --"), null, $this->winCompat($this->workingDir))->willReturn(0)->shouldBeCalled();
 
         $this->fs->ensureDirectoryExists($this->workingDir.'/.git');
-        $downloader = $this->getDownloaderMock(null, new Config(), $processExecutor);
+        $downloader = $this->getDownloaderMock(null, new Config(), $process->reveal());
+        $downloader->download($packageMock, $this->workingDir, $packageMock);
+        $downloader->prepare('update', $packageMock, $this->workingDir, $packageMock);
         $downloader->update($packageMock, $packageMock, $this->workingDir);
+        $downloader->cleanup('update', $packageMock, $this->workingDir, $packageMock);
     }
 
     public function testUpdateWithNewRepoUrl()
@@ -426,6 +422,7 @@ class GitDownloaderTest extends TestCase
         $packageMock->expects($this->any())
             ->method('getVersion')
             ->will($this->returnValue('1.0.0.0'));
+
         $processExecutor = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
         $processExecutor->expects($this->at(0))
             ->method('execute')
@@ -438,31 +435,31 @@ class GitDownloaderTest extends TestCase
         $processExecutor->expects($this->at(2))
             ->method('execute')
             ->with($this->equalTo($this->winCompat("git remote -v")))
-            ->will($this->returnCallback(function ($cmd, &$output, $cwd) {
-                $output = 'origin https://github.com/old/url (fetch)
-origin https://github.com/old/url (push)
-composer https://github.com/old/url (fetch)
-composer https://github.com/old/url (push)
-';
-
-                return 0;
-            }));
+            ->will($this->returnValue(0));
         $processExecutor->expects($this->at(3))
             ->method('execute')
-            ->with($this->equalTo($this->winCompat("git remote -v")))
+            ->with($this->equalTo($this->winCompat($expectedGitUpdateCommand)), $this->equalTo(null), $this->equalTo($this->winCompat($this->workingDir)))
             ->will($this->returnValue(0));
         $processExecutor->expects($this->at(4))
             ->method('execute')
-            ->with($this->equalTo($this->winCompat($expectedGitUpdateCommand)), $this->equalTo(null), $this->equalTo($this->winCompat($this->workingDir)))
+            ->with($this->equalTo('git branch -r'))
             ->will($this->returnValue(0));
         $processExecutor->expects($this->at(5))
             ->method('execute')
-            ->with($this->equalTo('git branch -r'))
+            ->with($this->equalTo($this->winCompat("git checkout 'ref' -- && git reset --hard 'ref' --")), $this->equalTo(null), $this->equalTo($this->winCompat($this->workingDir)))
             ->will($this->returnValue(0));
         $processExecutor->expects($this->at(6))
             ->method('execute')
-            ->with($this->equalTo($this->winCompat("git checkout 'ref' -- && git reset --hard 'ref' --")), $this->equalTo(null), $this->equalTo($this->winCompat($this->workingDir)))
-            ->will($this->returnValue(0));
+            ->with($this->equalTo($this->winCompat("git remote -v")))
+            ->will($this->returnCallback(function ($cmd, &$output, $cwd) {
+                $output = 'origin https://github.com/old/url (fetch)
+origin https://github.com/old/url (push)
+composer https://github.com/old/url (fetch)
+composer https://github.com/old/url (push)
+';
+
+                return 0;
+            }));
         $processExecutor->expects($this->at(7))
             ->method('execute')
             ->with($this->equalTo($this->winCompat("git remote set-url origin 'https://github.com/composer/composer'")), $this->equalTo(null), $this->equalTo($this->winCompat($this->workingDir)))
@@ -474,16 +471,19 @@ composer https://github.com/old/url (pus
 
         $this->fs->ensureDirectoryExists($this->workingDir.'/.git');
         $downloader = $this->getDownloaderMock(null, new Config(), $processExecutor);
+        $downloader->download($packageMock, $this->workingDir, $packageMock);
+        $downloader->prepare('update', $packageMock, $this->workingDir, $packageMock);
         $downloader->update($packageMock, $packageMock, $this->workingDir);
+        $downloader->cleanup('update', $packageMock, $this->workingDir, $packageMock);
     }
 
     /**
      * @group failing
-     * @expectedException \RuntimeException
      */
     public function testUpdateThrowsRuntimeExceptionIfGitCommandFails()
     {
         $expectedGitUpdateCommand = $this->winCompat("(git remote set-url composer 'https://github.com/composer/composer' && git rev-parse --quiet --verify 'ref^{commit}' || (git fetch composer && git fetch --tags composer)) && git remote set-url composer 'https://github.com/composer/composer'");
+        $expectedGitUpdateCommand2 = $this->winCompat("(git remote set-url composer 'git@github.com:composer/composer' && git rev-parse --quiet --verify 'ref^{commit}' || (git fetch composer && git fetch --tags composer)) && git remote set-url composer 'git@github.com:composer/composer'");
 
         $packageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
         $packageMock->expects($this->any())
@@ -495,36 +495,38 @@ composer https://github.com/old/url (pus
         $packageMock->expects($this->any())
             ->method('getVersion')
             ->will($this->returnValue('1.0.0.0'));
-        $processExecutor = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
-        $processExecutor->expects($this->at(0))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git show-ref --head -d")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(1))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git status --porcelain --untracked-files=no")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(2))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git remote -v")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(3))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git remote -v")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(4))
-            ->method('execute')
-            ->with($this->equalTo($expectedGitUpdateCommand))
-            ->will($this->returnValue(1));
+
+        $process = $this->prophesize('Composer\Util\ProcessExecutor');
+        $process->execute($this->winCompat('git --version'), Argument::cetera())->willReturn(0);
+        $process->execute($this->winCompat('git show-ref --head -d'), Argument::cetera())->willReturn(0);
+        $process->execute($this->winCompat('git status --porcelain --untracked-files=no'), Argument::cetera())->willReturn(0);
+        $process->execute($this->winCompat('git remote -v'), Argument::cetera())->willReturn(0);
+        $process->execute($this->winCompat('git branch -r'), Argument::cetera())->willReturn(0);
+        $process->execute($expectedGitUpdateCommand, null, $this->winCompat($this->workingDir))->willReturn(1)->shouldBeCalled();
+        $process->execute($expectedGitUpdateCommand2, null, $this->winCompat($this->workingDir))->willReturn(1)->shouldBeCalled();
+        $process->getErrorOutput()->willReturn('');
 
         $this->fs->ensureDirectoryExists($this->workingDir.'/.git');
-        $downloader = $this->getDownloaderMock(null, new Config(), $processExecutor);
-        $downloader->update($packageMock, $packageMock, $this->workingDir);
+
+        // not using PHPUnit's expected exception because Prophecy exceptions extend from RuntimeException too so it is not safe
+        try {
+            $downloader = $this->getDownloaderMock(null, new Config(), $process->reveal());
+            $downloader->download($packageMock, $this->workingDir, $packageMock);
+            $downloader->prepare('update', $packageMock, $this->workingDir, $packageMock);
+            $downloader->update($packageMock, $packageMock, $this->workingDir);
+            $downloader->cleanup('update', $packageMock, $this->workingDir, $packageMock);
+            $this->fail('This test should throw');
+        } catch (\RuntimeException $e) {
+            if ('RuntimeException' !== get_class($e)) {
+                throw $e;
+            }
+            $this->assertEquals('RuntimeException', get_class($e));
+        }
     }
 
     public function testUpdateDoesntThrowsRuntimeExceptionIfGitCommandFailsAtFirstButIsAbleToRecover()
     {
-        $expectedFirstGitUpdateCommand = $this->winCompat("(git remote set-url composer '' && git rev-parse --quiet --verify 'ref^{commit}' || (git fetch composer && git fetch --tags composer)) && git remote set-url composer ''");
+        $expectedFirstGitUpdateCommand = $this->winCompat("(git remote set-url composer '".(Platform::isWindows() ? 'C:\\\\' : '/')."' && git rev-parse --quiet --verify 'ref^{commit}' || (git fetch composer && git fetch --tags composer)) && git remote set-url composer '".(Platform::isWindows() ? 'C:\\\\' : '/')."'");
         $expectedSecondGitUpdateCommand = $this->winCompat("(git remote set-url composer 'https://github.com/composer/composer' && git rev-parse --quiet --verify 'ref^{commit}' || (git fetch composer && git fetch --tags composer)) && git remote set-url composer 'https://github.com/composer/composer'");
 
         $packageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
@@ -536,52 +538,25 @@ composer https://github.com/old/url (pus
             ->will($this->returnValue('1.0.0.0'));
         $packageMock->expects($this->any())
             ->method('getSourceUrls')
-            ->will($this->returnValue(array('/foo/bar', 'https://github.com/composer/composer')));
-        $processExecutor = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
-        $processExecutor->expects($this->at(0))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git show-ref --head -d")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(1))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git status --porcelain --untracked-files=no")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(2))
-           ->method('execute')
-            ->with($this->equalTo($this->winCompat("git remote -v")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(3))
-           ->method('execute')
-            ->with($this->equalTo($this->winCompat("git remote -v")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(4))
-            ->method('execute')
-            ->with($this->equalTo($expectedFirstGitUpdateCommand))
-            ->will($this->returnValue(1));
-        $processExecutor->expects($this->at(6))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git --version")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(7))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git remote -v")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(8))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git remote -v")))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(9))
-            ->method('execute')
-            ->with($this->equalTo($expectedSecondGitUpdateCommand))
-            ->will($this->returnValue(0));
-        $processExecutor->expects($this->at(11))
-            ->method('execute')
-            ->with($this->equalTo($this->winCompat("git checkout 'ref' -- && git reset --hard 'ref' --")), $this->equalTo(null), $this->equalTo($this->winCompat($this->workingDir)))
-            ->will($this->returnValue(0));
+            ->will($this->returnValue(array(Platform::isWindows() ? 'C:\\' : '/', 'https://github.com/composer/composer')));
+
+        $process = $this->prophesize('Composer\Util\ProcessExecutor');
+        $process->execute($this->winCompat('git --version'), Argument::cetera())->willReturn(0);
+        $process->execute($this->winCompat('git show-ref --head -d'), Argument::cetera())->willReturn(0);
+        $process->execute($this->winCompat('git status --porcelain --untracked-files=no'), Argument::cetera())->willReturn(0);
+        $process->execute($this->winCompat('git remote -v'), Argument::cetera())->willReturn(0);
+        $process->execute($this->winCompat('git branch -r'), Argument::cetera())->willReturn(0);
+        $process->execute($expectedFirstGitUpdateCommand, Argument::cetera())->willReturn(1)->shouldBeCalled();
+        $process->execute($expectedSecondGitUpdateCommand, Argument::cetera())->willReturn(0)->shouldBeCalled();
+        $process->execute($this->winCompat("git checkout 'ref' -- && git reset --hard 'ref' --"), null, $this->winCompat($this->workingDir))->willReturn(0)->shouldBeCalled();
+        $process->getErrorOutput()->willReturn('');
 
         $this->fs->ensureDirectoryExists($this->workingDir.'/.git');
-        $downloader = $this->getDownloaderMock(null, new Config(), $processExecutor);
+        $downloader = $this->getDownloaderMock(null, new Config(), $process->reveal());
+        $downloader->download($packageMock, $this->workingDir, $packageMock);
+        $downloader->prepare('update', $packageMock, $this->workingDir, $packageMock);
         $downloader->update($packageMock, $packageMock, $this->workingDir);
+        $downloader->cleanup('update', $packageMock, $this->workingDir, $packageMock);
     }
 
     public function testDowngradeShowsAppropriateMessage()
@@ -626,7 +601,10 @@ composer https://github.com/old/url (pus
 
         $this->fs->ensureDirectoryExists($this->workingDir.'/.git');
         $downloader = $this->getDownloaderMock($ioMock, null, $processExecutor);
+        $downloader->download($newPackage, $this->workingDir, $oldPackage);
+        $downloader->prepare('update', $newPackage, $this->workingDir, $oldPackage);
         $downloader->update($oldPackage, $newPackage, $this->workingDir);
+        $downloader->cleanup('update', $newPackage, $this->workingDir, $oldPackage);
     }
 
     public function testNotUsingDowngradingWithReferences()
@@ -661,11 +639,14 @@ composer https://github.com/old/url (pus
         $ioMock = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
         $ioMock->expects($this->at(0))
             ->method('writeError')
-            ->with($this->stringContains('updating'));
+            ->with($this->stringContains('Upgrading'));
 
         $this->fs->ensureDirectoryExists($this->workingDir.'/.git');
         $downloader = $this->getDownloaderMock($ioMock, null, $processExecutor);
+        $downloader->download($newPackage, $this->workingDir, $oldPackage);
+        $downloader->prepare('update', $newPackage, $this->workingDir, $oldPackage);
         $downloader->update($oldPackage, $newPackage, $this->workingDir);
+        $downloader->cleanup('update', $newPackage, $this->workingDir, $oldPackage);
     }
 
     public function testRemove()
@@ -685,7 +666,9 @@ composer https://github.com/old/url (pus
             ->will($this->returnValue(true));
 
         $downloader = $this->getDownloaderMock(null, null, $processExecutor, $filesystem);
+        $downloader->prepare('uninstall', $packageMock, 'composerPath');
         $downloader->remove($packageMock, 'composerPath');
+        $downloader->cleanup('uninstall', $packageMock, 'composerPath');
     }
 
     public function testGetInstallationSource()
diff -pruN 1.10.19-1/tests/Composer/Test/Downloader/HgDownloaderTest.php 2.0.9-1/tests/Composer/Test/Downloader/HgDownloaderTest.php
--- 1.10.19-1/tests/Composer/Test/Downloader/HgDownloaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Downloader/HgDownloaderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -45,9 +45,6 @@ class HgDownloaderTest extends TestCase
         return new HgDownloader($io, $config, $executor, $filesystem);
     }
 
-    /**
-     * @expectedException \InvalidArgumentException
-     */
     public function testDownloadForPackageWithoutSourceReference()
     {
         $packageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
@@ -55,8 +52,10 @@ class HgDownloaderTest extends TestCase
             ->method('getSourceReference')
             ->will($this->returnValue(null));
 
+        $this->setExpectedException('InvalidArgumentException');
+
         $downloader = $this->getDownloaderMock();
-        $downloader->download($packageMock, '/path');
+        $downloader->install($packageMock, '/path');
     }
 
     public function testDownload()
@@ -83,12 +82,9 @@ class HgDownloaderTest extends TestCase
             ->will($this->returnValue(0));
 
         $downloader = $this->getDownloaderMock(null, null, $processExecutor);
-        $downloader->download($packageMock, 'composerPath');
+        $downloader->install($packageMock, 'composerPath');
     }
 
-    /**
-     * @expectedException \InvalidArgumentException
-     */
     public function testUpdateforPackageWithoutSourceReference()
     {
         $initialPackageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
@@ -97,8 +93,12 @@ class HgDownloaderTest extends TestCase
             ->method('getSourceReference')
             ->will($this->returnValue(null));
 
+        $this->setExpectedException('InvalidArgumentException');
+
         $downloader = $this->getDownloaderMock();
+        $downloader->prepare('update', $sourcePackageMock, '/path', $initialPackageMock);
         $downloader->update($initialPackageMock, $sourcePackageMock, '/path');
+        $downloader->cleanup('update', $sourcePackageMock, '/path', $initialPackageMock);
     }
 
     public function testUpdate()
@@ -129,7 +129,9 @@ class HgDownloaderTest extends TestCase
             ->will($this->returnValue(0));
 
         $downloader = $this->getDownloaderMock(null, null, $processExecutor);
+        $downloader->prepare('update', $packageMock, $this->workingDir, $packageMock);
         $downloader->update($packageMock, $packageMock, $this->workingDir);
+        $downloader->cleanup('update', $packageMock, $this->workingDir, $packageMock);
     }
 
     public function testRemove()
@@ -148,7 +150,9 @@ class HgDownloaderTest extends TestCase
             ->will($this->returnValue(true));
 
         $downloader = $this->getDownloaderMock(null, null, $processExecutor, $filesystem);
+        $downloader->prepare('uninstall', $packageMock, 'composerPath');
         $downloader->remove($packageMock, 'composerPath');
+        $downloader->cleanup('uninstall', $packageMock, 'composerPath');
     }
 
     public function testGetInstallationSource()
diff -pruN 1.10.19-1/tests/Composer/Test/Downloader/PearPackageExtractorTest.php 2.0.9-1/tests/Composer/Test/Downloader/PearPackageExtractorTest.php
--- 1.10.19-1/tests/Composer/Test/Downloader/PearPackageExtractorTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Downloader/PearPackageExtractorTest.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,146 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Test\Downloader;
-
-use Composer\Downloader\PearPackageExtractor;
-use Composer\Test\TestCase;
-
-class PearPackageExtractorTest extends TestCase
-{
-    public function testShouldExtractPackage_1_0()
-    {
-        $state = libxml_disable_entity_loader(true);
-
-        $extractor = $this->getMockForAbstractClass('Composer\Downloader\PearPackageExtractor', array(), '', false);
-        $method = new \ReflectionMethod($extractor, 'buildCopyActions');
-        $method->setAccessible(true);
-
-        $fileActions = $method->invoke($extractor, __DIR__ . '/Fixtures/Package_v1.0', array('php' => '/'), array());
-
-        libxml_disable_entity_loader($state);
-
-        $expectedFileActions = array(
-            'Gtk.php' => array(
-                'from' => 'PEAR_Frontend_Gtk-0.4.0/Gtk.php',
-                'to' => 'PEAR/Frontend/Gtk.php',
-                'role' => 'php',
-                'tasks' => array(),
-            ),
-            'Gtk/Config.php' => array(
-                'from' => 'PEAR_Frontend_Gtk-0.4.0/Gtk/Config.php',
-                'to' => 'PEAR/Frontend/Gtk/Config.php',
-                'role' => 'php',
-                'tasks' => array(),
-            ),
-            'Gtk/xpm/black_close_icon.xpm' => array(
-                'from' => 'PEAR_Frontend_Gtk-0.4.0/Gtk/xpm/black_close_icon.xpm',
-                'to' => 'PEAR/Frontend/Gtk/xpm/black_close_icon.xpm',
-                'role' => 'php',
-                'tasks' => array(),
-            ),
-        );
-        $this->assertSame($expectedFileActions, $fileActions);
-    }
-
-    public function testShouldExtractPackage_2_0()
-    {
-        $state = libxml_disable_entity_loader(true);
-
-        $extractor = $this->getMockForAbstractClass('Composer\Downloader\PearPackageExtractor', array(), '', false);
-        $method = new \ReflectionMethod($extractor, 'buildCopyActions');
-        $method->setAccessible(true);
-
-        $fileActions = $method->invoke($extractor, __DIR__ . '/Fixtures/Package_v2.0', array('php' => '/'), array());
-
-        libxml_disable_entity_loader($state);
-
-        $expectedFileActions = array(
-            'URL.php' => array(
-                'from' => 'Net_URL-1.0.15/URL.php',
-                'to' => 'Net/URL.php',
-                'role' => 'php',
-                'tasks' => array(),
-            ),
-        );
-        $this->assertSame($expectedFileActions, $fileActions);
-    }
-
-    public function testShouldExtractPackage_2_1()
-    {
-        $state = libxml_disable_entity_loader(true);
-
-        $extractor = $this->getMockForAbstractClass('Composer\Downloader\PearPackageExtractor', array(), '', false);
-        $method = new \ReflectionMethod($extractor, 'buildCopyActions');
-        $method->setAccessible(true);
-
-        $fileActions = $method->invoke($extractor, __DIR__ . '/Fixtures/Package_v2.1', array('php' => '/', 'script' => '/bin'), array());
-
-        libxml_disable_entity_loader($state);
-
-        $expectedFileActions = array(
-            'php/Zend/Authentication/Storage/StorageInterface.php' => array(
-                'from' => 'Zend_Authentication-2.0.0beta4/php/Zend/Authentication/Storage/StorageInterface.php',
-                'to' => '/php/Zend/Authentication/Storage/StorageInterface.php',
-                'role' => 'php',
-                'tasks' => array(),
-            ),
-            'php/Zend/Authentication/Result.php' => array(
-                'from' => 'Zend_Authentication-2.0.0beta4/php/Zend/Authentication/Result.php',
-                'to' => '/php/Zend/Authentication/Result.php',
-                'role' => 'php',
-                'tasks' => array(),
-            ),
-            'php/Test.php' => array(
-                'from' => 'Zend_Authentication-2.0.0beta4/php/Test.php',
-                'to' => '/php/Test.php',
-                'role' => 'script',
-                'tasks' => array(
-                    array(
-                        'from' => '@version@',
-                        'to' => 'version',
-                    ),
-                ),
-            ),
-            'renamedFile.php' => array(
-                'from' => 'Zend_Authentication-2.0.0beta4/renamedFile.php',
-                'to' => 'correctFile.php',
-                'role' => 'php',
-                'tasks' => array(),
-            ),
-        );
-        $this->assertSame($expectedFileActions, $fileActions);
-    }
-
-    public function testShouldPerformReplacements()
-    {
-        $from = tempnam($this->getUniqueTmpDirectory(), 'pear-extract');
-        $to = $from.'-to';
-
-        $original = 'replaced: @placeholder@; not replaced: @another@; replaced again: @placeholder@';
-        $expected = 'replaced: value; not replaced: @another@; replaced again: value';
-
-        file_put_contents($from, $original);
-
-        $extractor = new PearPackageExtractor($from);
-        $method = new \ReflectionMethod($extractor, 'copyFile');
-        $method->setAccessible(true);
-
-        $method->invoke($extractor, $from, $to, array(array('from' => '@placeholder@', 'to' => 'variable')), array('variable' => 'value'));
-        $result = file_get_contents($to);
-
-        unlink($to);
-        unlink($from);
-
-        $this->assertEquals($expected, $result);
-    }
-}
diff -pruN 1.10.19-1/tests/Composer/Test/Downloader/PerforceDownloaderTest.php 2.0.9-1/tests/Composer/Test/Downloader/PerforceDownloaderTest.php
--- 1.10.19-1/tests/Composer/Test/Downloader/PerforceDownloaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Downloader/PerforceDownloaderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -17,6 +17,7 @@ use Composer\Config;
 use Composer\Repository\VcsRepository;
 use Composer\IO\IOInterface;
 use Composer\Test\TestCase;
+use Composer\Factory;
 use Composer\Util\Filesystem;
 
 /**
@@ -96,7 +97,7 @@ class PerforceDownloaderTest extends Tes
     {
         $repository = $this->getMockBuilder('Composer\Repository\VcsRepository')
             ->setMethods(array('getRepoConfig'))
-            ->setConstructorArgs(array($repoConfig, $io, $config))
+            ->setConstructorArgs(array($repoConfig, $io, $config, Factory::createHttpDownloader($io, $config)))
             ->getMock();
         $repository->expects($this->any())->method('getRepoConfig')->will($this->returnValue($repoConfig));
 
@@ -123,7 +124,7 @@ class PerforceDownloaderTest extends Tes
      * @depends testInitPerforceInstantiatesANewPerforceObject
      * @depends testInitPerforceDoesNothingIfPerforceAlreadySet
      */
-    public function testDoDownloadWithTag()
+    public function testDoInstallWithTag()
     {
         //I really don't like this test but the logic of each Perforce method is tested in the Perforce class.  Really I am just enforcing workflow.
         $ref = 'SOURCE_REF@123';
@@ -131,7 +132,7 @@ class PerforceDownloaderTest extends Tes
         $this->package->expects($this->once())->method('getSourceReference')->will($this->returnValue($ref));
         $this->io->expects($this->once())->method('writeError')->with($this->stringContains('Cloning '.$ref));
         $perforceMethods = array('setStream', 'p4Login', 'writeP4ClientSpec', 'connectClient', 'syncCodeBase', 'cleanupClientSpec');
-        $perforce = $this->getMockBuilder('Composer\Util\Perforce', $perforceMethods)->disableOriginalConstructor()->getMock();
+        $perforce = $this->getMockBuilder('Composer\Util\Perforce')->disableOriginalConstructor()->getMock();
         $perforce->expects($this->at(0))->method('initializePath')->with($this->equalTo($this->testPath));
         $perforce->expects($this->at(1))->method('setStream')->with($this->equalTo($ref));
         $perforce->expects($this->at(2))->method('p4Login');
@@ -140,21 +141,21 @@ class PerforceDownloaderTest extends Tes
         $perforce->expects($this->at(5))->method('syncCodeBase')->with($label);
         $perforce->expects($this->at(6))->method('cleanupClientSpec');
         $this->downloader->setPerforce($perforce);
-        $this->downloader->doDownload($this->package, $this->testPath, 'url');
+        $this->downloader->doInstall($this->package, $this->testPath, 'url');
     }
 
     /**
      * @depends testInitPerforceInstantiatesANewPerforceObject
      * @depends testInitPerforceDoesNothingIfPerforceAlreadySet
      */
-    public function testDoDownloadWithNoTag()
+    public function testDoInstallWithNoTag()
     {
         $ref = 'SOURCE_REF';
         $label = null;
         $this->package->expects($this->once())->method('getSourceReference')->will($this->returnValue($ref));
         $this->io->expects($this->once())->method('writeError')->with($this->stringContains('Cloning '.$ref));
         $perforceMethods = array('setStream', 'p4Login', 'writeP4ClientSpec', 'connectClient', 'syncCodeBase', 'cleanupClientSpec');
-        $perforce = $this->getMockBuilder('Composer\Util\Perforce', $perforceMethods)->disableOriginalConstructor()->getMock();
+        $perforce = $this->getMockBuilder('Composer\Util\Perforce')->disableOriginalConstructor()->getMock();
         $perforce->expects($this->at(0))->method('initializePath')->with($this->equalTo($this->testPath));
         $perforce->expects($this->at(1))->method('setStream')->with($this->equalTo($ref));
         $perforce->expects($this->at(2))->method('p4Login');
@@ -163,6 +164,6 @@ class PerforceDownloaderTest extends Tes
         $perforce->expects($this->at(5))->method('syncCodeBase')->with($label);
         $perforce->expects($this->at(6))->method('cleanupClientSpec');
         $this->downloader->setPerforce($perforce);
-        $this->downloader->doDownload($this->package, $this->testPath, 'url');
+        $this->downloader->doInstall($this->package, $this->testPath, 'url');
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Downloader/XzDownloaderTest.php 2.0.9-1/tests/Composer/Test/Downloader/XzDownloaderTest.php
--- 1.10.19-1/tests/Composer/Test/Downloader/XzDownloaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Downloader/XzDownloaderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,7 +16,8 @@ use Composer\Downloader\XzDownloader;
 use Composer\Test\TestCase;
 use Composer\Util\Filesystem;
 use Composer\Util\Platform;
-use Composer\Util\RemoteFilesystem;
+use Composer\Util\Loop;
+use Composer\Util\HttpDownloader;
 
 class XzDownloaderTest extends TestCase
 {
@@ -66,13 +67,17 @@ class XzDownloaderTest extends TestCase
             ->method('get')
             ->with('vendor-dir')
             ->will($this->returnValue($this->testDir));
-        $downloader = new XzDownloader($io, $config, null, null, null, new RemoteFilesystem($io));
+        $downloader = new XzDownloader($io, $config, $httpDownloader = new HttpDownloader($io, $this->getMockBuilder('Composer\Config')->getMock()), null, null, null);
 
         try {
-            $downloader->download($packageMock, $this->getUniqueTmpDirectory());
+            $loop = new Loop($httpDownloader);
+            $promise = $downloader->download($packageMock, $this->testDir.'/install-path');
+            $loop->wait(array($promise));
+            $downloader->install($packageMock, $this->testDir.'/install-path');
+
             $this->fail('Download of invalid tarball should throw an exception');
         } catch (\RuntimeException $e) {
-            $this->assertRegexp('/(File format not recognized|Unrecognized archive format)/i', $e->getMessage());
+            $this->assertMatchesRegularExpression('/(File format not recognized|Unrecognized archive format)/i', $e->getMessage());
         }
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Downloader/ZipDownloaderTest.php 2.0.9-1/tests/Composer/Test/Downloader/ZipDownloaderTest.php
--- 1.10.19-1/tests/Composer/Test/Downloader/ZipDownloaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Downloader/ZipDownloaderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,6 +16,8 @@ use Composer\Downloader\ZipDownloader;
 use Composer\Package\PackageInterface;
 use Composer\Test\TestCase;
 use Composer\Util\Filesystem;
+use Composer\Util\HttpDownloader;
+use Composer\Util\Loop;
 
 class ZipDownloaderTest extends TestCase
 {
@@ -23,14 +25,19 @@ class ZipDownloaderTest extends TestCase
      * @var string
      */
     private $testDir;
+    private $httpDownloader;
     private $io;
     private $config;
+    private $package;
 
     public function setUp()
     {
         $this->testDir = $this->getUniqueTmpDirectory();
         $this->io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
         $this->config = $this->getMockBuilder('Composer\Config')->getMock();
+        $dlConfig = $this->getMockBuilder('Composer\Config')->getMock();
+        $this->httpDownloader = new HttpDownloader($this->io, $dlConfig);
+        $this->package = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
     }
 
     public function tearDown()
@@ -53,72 +60,56 @@ class ZipDownloaderTest extends TestCase
         }
     }
 
-    /**
-     * @group only
-     */
     public function testErrorMessages()
     {
         if (!class_exists('ZipArchive')) {
             $this->markTestSkipped('zip extension missing');
         }
 
-        $this->config->expects($this->at(0))
-            ->method('get')
-            ->with('disable-tls')
-            ->will($this->returnValue(false));
-        $this->config->expects($this->at(1))
-            ->method('get')
-            ->with('cafile')
-            ->will($this->returnValue(null));
-        $this->config->expects($this->at(2))
-            ->method('get')
-            ->with('capath')
-            ->will($this->returnValue(null));
-        $this->config->expects($this->at(3))
+        $this->config->expects($this->any())
             ->method('get')
             ->with('vendor-dir')
             ->will($this->returnValue($this->testDir));
 
-        $packageMock = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
-        $packageMock->expects($this->any())
+        $this->package->expects($this->any())
             ->method('getDistUrl')
             ->will($this->returnValue($distUrl = 'file://'.__FILE__))
         ;
-        $packageMock->expects($this->any())
+        $this->package->expects($this->any())
             ->method('getDistUrls')
             ->will($this->returnValue(array($distUrl)))
         ;
-        $packageMock->expects($this->atLeastOnce())
+        $this->package->expects($this->atLeastOnce())
             ->method('getTransportOptions')
             ->will($this->returnValue(array()))
         ;
 
-        $downloader = new ZipDownloader($this->io, $this->config);
+        $downloader = new ZipDownloader($this->io, $this->config, $this->httpDownloader);
 
         $this->setPrivateProperty('hasSystemUnzip', false);
 
         try {
-            $downloader->download($packageMock, sys_get_temp_dir().'/composer-zip-test');
+            $loop = new Loop($this->httpDownloader);
+            $promise = $downloader->download($this->package, $path = sys_get_temp_dir().'/composer-zip-test');
+            $loop->wait(array($promise));
+            $downloader->install($this->package, $path);
+
             $this->fail('Download of invalid zip files should throw an exception');
         } catch (\Exception $e) {
-            $this->assertContains('is not a zip archive', $e->getMessage());
+            $this->assertStringContainsString('is not a zip archive', $e->getMessage());
         }
     }
 
-    /**
-     * @expectedException \RuntimeException
-     * @expectedExceptionMessage There was an error extracting the ZIP file
-     */
     public function testZipArchiveOnlyFailed()
     {
+        $this->setExpectedException('RuntimeException', 'There was an error extracting the ZIP file');
         if (!class_exists('ZipArchive')) {
             $this->markTestSkipped('zip extension missing');
         }
 
         $this->setPrivateProperty('hasSystemUnzip', false);
         $this->setPrivateProperty('hasZipArchive', true);
-        $downloader = new MockedZipDownloader($this->io, $this->config);
-
+        $downloader = new MockedZipDownloader($this->io, $this->config, $this->httpDownloader);
         $zipArchive = $this->getMockBuilder('ZipArchive')->getMock();
         $zipArchive->expects($this->at(0))
             ->method('open')
@@ -128,23 +119,20 @@ class ZipDownloaderTest extends TestCase
             ->will($this->returnValue(false));
 
         $this->setPrivateProperty('zipArchiveObject', $zipArchive, $downloader);
-        $downloader->extract('testfile.zip', 'vendor/dir');
+        $promise = $downloader->extract($this->package, 'testfile.zip', 'vendor/dir');
+        $this->wait($promise);
     }
 
-    /**
-     * @expectedException \RuntimeException
-     * @expectedExceptionMessage The archive may contain identical file names with different capitalization (which fails on case insensitive filesystems): Not a directory
-     */
     public function testZipArchiveExtractOnlyFailed()
     {
+        $this->setExpectedException('RuntimeException', 'The archive may contain identical file names with different capitalization (which fails on case insensitive filesystems): Not a directory');
         if (!class_exists('ZipArchive')) {
             $this->markTestSkipped('zip extension missing');
         }
 
         $this->setPrivateProperty('hasSystemUnzip', false);
         $this->setPrivateProperty('hasZipArchive', true);
-        $downloader = new MockedZipDownloader($this->io, $this->config);
-
+        $downloader = new MockedZipDownloader($this->io, $this->config, $this->httpDownloader);
         $zipArchive = $this->getMockBuilder('ZipArchive')->getMock();
         $zipArchive->expects($this->at(0))
             ->method('open')
@@ -154,12 +142,10 @@ class ZipDownloaderTest extends TestCase
             ->will($this->throwException(new \ErrorException('Not a directory')));
 
         $this->setPrivateProperty('zipArchiveObject', $zipArchive, $downloader);
-        $downloader->extract('testfile.zip', 'vendor/dir');
+        $promise = $downloader->extract($this->package, 'testfile.zip', 'vendor/dir');
+        $this->wait($promise);
     }
 
-    /**
-     * @group only
-     */
     public function testZipArchiveOnlyGood()
     {
         if (!class_exists('ZipArchive')) {
@@ -168,8 +154,7 @@ class ZipDownloaderTest extends TestCase
 
         $this->setPrivateProperty('hasSystemUnzip', false);
         $this->setPrivateProperty('hasZipArchive', true);
-        $downloader = new MockedZipDownloader($this->io, $this->config);
-
+        $downloader = new MockedZipDownloader($this->io, $this->config, $this->httpDownloader);
         $zipArchive = $this->getMockBuilder('ZipArchive')->getMock();
         $zipArchive->expects($this->at(0))
             ->method('open')
@@ -179,45 +164,63 @@ class ZipDownloaderTest extends TestCase
             ->will($this->returnValue(true));
 
         $this->setPrivateProperty('zipArchiveObject', $zipArchive, $downloader);
-        $downloader->extract('testfile.zip', 'vendor/dir');
+        $promise = $downloader->extract($this->package, 'testfile.zip', 'vendor/dir');
+        $this->wait($promise);
     }
 
-    /**
-     * @expectedException \Exception
-     * @expectedExceptionMessage Failed to execute (1) unzip
-     */
     public function testSystemUnzipOnlyFailed()
     {
-        if (!class_exists('ZipArchive')) {
-            $this->markTestSkipped('zip extension missing');
-        }
-
+        $this->setExpectedException('Exception', 'Failed to extract : (1) unzip');
+        $this->setPrivateProperty('isWindows', false);
         $this->setPrivateProperty('hasSystemUnzip', true);
         $this->setPrivateProperty('hasZipArchive', false);
+
+        $procMock = $this->getMockBuilder('Symfony\Component\Process\Process')->disableOriginalConstructor()->getMock();
+        $procMock->expects($this->any())
+            ->method('getExitCode')
+            ->will($this->returnValue(1));
+        $procMock->expects($this->any())
+            ->method('isSuccessful')
+            ->will($this->returnValue(false));
+        $procMock->expects($this->any())
+            ->method('getErrorOutput')
+            ->will($this->returnValue('output'));
+
         $processExecutor = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
         $processExecutor->expects($this->at(0))
-            ->method('execute')
-            ->will($this->returnValue(1));
+            ->method('executeAsync')
+            ->will($this->returnValue(\React\Promise\resolve($procMock)));
 
-        $downloader = new MockedZipDownloader($this->io, $this->config, null, null, $processExecutor);
-        $downloader->extract('testfile.zip', 'vendor/dir');
+        $downloader = new MockedZipDownloader($this->io, $this->config, $this->httpDownloader, null, null, null, $processExecutor);
+        $promise = $downloader->extract($this->package, 'testfile.zip', 'vendor/dir');
+        $this->wait($promise);
     }
 
     public function testSystemUnzipOnlyGood()
     {
-        if (!class_exists('ZipArchive')) {
-            $this->markTestSkipped('zip extension missing');
-        }
-
+        $this->setPrivateProperty('isWindows', false);
         $this->setPrivateProperty('hasSystemUnzip', true);
         $this->setPrivateProperty('hasZipArchive', false);
+
+        $procMock = $this->getMockBuilder('Symfony\Component\Process\Process')->disableOriginalConstructor()->getMock();
+        $procMock->expects($this->any())
+            ->method('getExitCode')
+            ->will($this->returnValue(0));
+        $procMock->expects($this->any())
+            ->method('isSuccessful')
+            ->will($this->returnValue(true));
+        $procMock->expects($this->any())
+            ->method('getErrorOutput')
+            ->will($this->returnValue('output'));
+
         $processExecutor = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
         $processExecutor->expects($this->at(0))
-            ->method('execute')
-            ->will($this->returnValue(0));
+            ->method('executeAsync')
+            ->will($this->returnValue(\React\Promise\resolve($procMock)));
 
-        $downloader = new MockedZipDownloader($this->io, $this->config, null, null, $processExecutor);
-        $downloader->extract('testfile.zip', 'vendor/dir');
+        $downloader = new MockedZipDownloader($this->io, $this->config, $this->httpDownloader, null, null, null, $processExecutor);
+        $promise = $downloader->extract($this->package, 'testfile.zip', 'vendor/dir');
+        $this->wait($promise);
     }
 
     public function testNonWindowsFallbackGood()
@@ -230,10 +233,21 @@ class ZipDownloaderTest extends TestCase
         $this->setPrivateProperty('hasSystemUnzip', true);
         $this->setPrivateProperty('hasZipArchive', true);
 
+        $procMock = $this->getMockBuilder('Symfony\Component\Process\Process')->disableOriginalConstructor()->getMock();
+        $procMock->expects($this->any())
+            ->method('getExitCode')
+            ->will($this->returnValue(1));
+        $procMock->expects($this->any())
+            ->method('isSuccessful')
+            ->will($this->returnValue(false));
+        $procMock->expects($this->any())
+            ->method('getErrorOutput')
+            ->will($this->returnValue('output'));
+
         $processExecutor = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
         $processExecutor->expects($this->at(0))
-            ->method('execute')
-            ->will($this->returnValue(1));
+            ->method('executeAsync')
+            ->will($this->returnValue(\React\Promise\resolve($procMock)));
 
         $zipArchive = $this->getMockBuilder('ZipArchive')->getMock();
         $zipArchive->expects($this->at(0))
@@ -243,17 +257,15 @@ class ZipDownloaderTest extends TestCase
             ->method('extractTo')
             ->will($this->returnValue(true));
 
-        $downloader = new MockedZipDownloader($this->io, $this->config, null, null, $processExecutor);
+        $downloader = new MockedZipDownloader($this->io, $this->config, $this->httpDownloader, null, null, null, $processExecutor);
         $this->setPrivateProperty('zipArchiveObject', $zipArchive, $downloader);
-        $downloader->extract('testfile.zip', 'vendor/dir');
+        $promise = $downloader->extract($this->package, 'testfile.zip', 'vendor/dir');
+        $this->wait($promise);
     }
 
-    /**
-     * @expectedException \Exception
-     * @expectedExceptionMessage There was an error extracting the ZIP file
-     */
     public function testNonWindowsFallbackFailed()
     {
+        $this->setExpectedException('Exception', 'There was an error extracting the ZIP file');
         if (!class_exists('ZipArchive')) {
             $this->markTestSkipped('zip extension missing');
         }
@@ -262,10 +274,21 @@ class ZipDownloaderTest extends TestCase
         $this->setPrivateProperty('hasSystemUnzip', true);
         $this->setPrivateProperty('hasZipArchive', true);
 
+        $procMock = $this->getMockBuilder('Symfony\Component\Process\Process')->disableOriginalConstructor()->getMock();
+        $procMock->expects($this->any())
+            ->method('getExitCode')
+            ->will($this->returnValue(1));
+        $procMock->expects($this->any())
+            ->method('isSuccessful')
+            ->will($this->returnValue(false));
+        $procMock->expects($this->any())
+            ->method('getErrorOutput')
+            ->will($this->returnValue('output'));
+
         $processExecutor = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
         $processExecutor->expects($this->at(0))
-          ->method('execute')
-          ->will($this->returnValue(1));
+          ->method('executeAsync')
+          ->will($this->returnValue(\React\Promise\resolve($procMock)));
 
         $zipArchive = $this->getMockBuilder('ZipArchive')->getMock();
         $zipArchive->expects($this->at(0))
@@ -275,9 +298,10 @@ class ZipDownloaderTest extends TestCase
           ->method('extractTo')
           ->will($this->returnValue(false));
 
-        $downloader = new MockedZipDownloader($this->io, $this->config, null, null, $processExecutor);
+        $downloader = new MockedZipDownloader($this->io, $this->config, $this->httpDownloader, null, null, null, $processExecutor);
         $this->setPrivateProperty('zipArchiveObject', $zipArchive, $downloader);
-        $downloader->extract('testfile.zip', 'vendor/dir');
+        $promise = $downloader->extract($this->package, 'testfile.zip', 'vendor/dir');
+        $this->wait($promise);
     }
 
     public function testWindowsFallbackGood()
@@ -303,17 +327,15 @@ class ZipDownloaderTest extends TestCase
             ->method('extractTo')
             ->will($this->returnValue(false));
 
-        $downloader = new MockedZipDownloader($this->io, $this->config, null, null, $processExecutor);
+        $downloader = new MockedZipDownloader($this->io, $this->config, $this->httpDownloader, null, null, null, $processExecutor);
         $this->setPrivateProperty('zipArchiveObject', $zipArchive, $downloader);
-        $downloader->extract('testfile.zip', 'vendor/dir');
+        $promise = $downloader->extract($this->package, 'testfile.zip', 'vendor/dir');
+        $this->wait($promise);
     }
 
-    /**
-     * @expectedException \Exception
-     * @expectedExceptionMessage Failed to execute (1) unzip
-     */
     public function testWindowsFallbackFailed()
     {
+        $this->setExpectedException('Exception', 'Failed to execute (1) unzip');
         if (!class_exists('ZipArchive')) {
             $this->markTestSkipped('zip extension missing');
         }
@@ -335,21 +357,45 @@ class ZipDownloaderTest extends TestCase
           ->method('extractTo')
           ->will($this->returnValue(false));
 
-        $downloader = new MockedZipDownloader($this->io, $this->config, null, null, $processExecutor);
+        $downloader = new MockedZipDownloader($this->io, $this->config, $this->httpDownloader, null, null, null, $processExecutor);
         $this->setPrivateProperty('zipArchiveObject', $zipArchive, $downloader);
-        $downloader->extract('testfile.zip', 'vendor/dir');
+        $promise = $downloader->extract($this->package, 'testfile.zip', 'vendor/dir');
+        $this->wait($promise);
+    }
+
+    private function wait($promise)
+    {
+        if (null === $promise) {
+            return;
+        }
+
+        $e = null;
+        $promise->then(function () {
+            // noop
+        }, function ($ex) use (&$e) {
+            $e = $ex;
+        });
+
+        if ($e) {
+            throw $e;
+        }
     }
 }
 
 class MockedZipDownloader extends ZipDownloader
 {
-    public function download(PackageInterface $package, $path, $output = true)
+    public function download(PackageInterface $package, $path, PackageInterface $prevPackage = null, $output = true)
+    {
+        return;
+    }
+
+    public function install(PackageInterface $package, $path, $output = true)
     {
         return;
     }
 
-    public function extract($file, $path)
+    public function extract(PackageInterface $package, $file, $path)
     {
-        parent::extract($file, $path);
+        return parent::extract($package, $file, $path);
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/EventDispatcher/EventDispatcherTest.php 2.0.9-1/tests/Composer/Test/EventDispatcher/EventDispatcherTest.php
--- 1.10.19-1/tests/Composer/Test/EventDispatcher/EventDispatcherTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/EventDispatcher/EventDispatcherTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,24 +14,22 @@ namespace Composer\Test\EventDispatcher;
 
 use Composer\EventDispatcher\Event;
 use Composer\EventDispatcher\EventDispatcher;
-use Composer\EventDispatcher\ScriptExecutionException;
 use Composer\Installer\InstallerEvents;
 use Composer\Config;
 use Composer\Composer;
 use Composer\Test\TestCase;
 use Composer\IO\BufferIO;
 use Composer\Script\ScriptEvents;
-use Composer\Script\CommandEvent;
+use Composer\Script\Event as ScriptEvent;
 use Composer\Util\ProcessExecutor;
 use Symfony\Component\Console\Output\OutputInterface;
 
 class EventDispatcherTest extends TestCase
 {
-    /**
-     * @expectedException RuntimeException
-     */
     public function testListenerExceptionsAreCaught()
     {
+        $this->setExpectedException('RuntimeException');
+
         $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
         $dispatcher = $this->getDispatcherStubForListenersTest(array(
             'Composer\Test\EventDispatcher\EventDispatcherTest::call',
@@ -53,30 +51,6 @@ class EventDispatcherTest extends TestCa
     }
 
     /**
-     * @group legacy
-     */
-    public function testDispatcherCanConvertScriptEventToCommandEventForListener()
-    {
-        $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
-        $dispatcher = $this->getDispatcherStubForListenersTest(array(
-            'Composer\Test\EventDispatcher\EventDispatcherTest::expectsCommandEvent',
-        ), $io);
-
-        $this->setExpectedException('PHPUnit\Framework\Error\Deprecated');
-        $this->assertEquals(1, $dispatcher->dispatchScript(ScriptEvents::POST_INSTALL_CMD, false));
-    }
-
-    public function testDispatcherDoesNotAttemptConversionForListenerWithoutTypehint()
-    {
-        $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
-        $dispatcher = $this->getDispatcherStubForListenersTest(array(
-            'Composer\Test\EventDispatcher\EventDispatcherTest::expectsVariableEvent',
-        ), $io);
-
-        $this->assertEquals(1, $dispatcher->dispatchScript(ScriptEvents::POST_INSTALL_CMD, false));
-    }
-
-    /**
      * @dataProvider getValidCommands
      * @param string $command
      */
@@ -125,7 +99,7 @@ class EventDispatcherTest extends TestCa
         $composer->setPackage($package);
 
         $composer->setRepositoryManager($this->getRepositoryManagerMockForDevModePassingTest());
-        $composer->setInstallationManager($this->getMockBuilder('Composer\Installer\InstallationManager')->getMock());
+        $composer->setInstallationManager($this->getMockBuilder('Composer\Installer\InstallationManager')->disableOriginalConstructor()->getMock());
 
         $dispatcher = new EventDispatcher(
             $composer,
@@ -195,6 +169,49 @@ class EventDispatcherTest extends TestCa
         return $rm;
     }
 
+    public function testDispatcherRemoveListener()
+    {
+        $composer = $this->createComposerInstance();
+
+        $composer->setRepositoryManager($this->getRepositoryManagerMockForDevModePassingTest());
+        $composer->setInstallationManager($this->getMockBuilder('Composer\Installer\InstallationManager')->disableOriginalConstructor()->getMock());
+
+        $dispatcher = new EventDispatcher(
+            $composer,
+            $io = new BufferIO('', OutputInterface::VERBOSITY_VERBOSE),
+            $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock()
+        );
+
+        $listener = array($this, 'someMethod');
+        $listener2 = array($this, 'someMethod2');
+        $listener3 = 'Composer\\Test\\EventDispatcher\\EventDispatcherTest::someMethod';
+
+        $dispatcher->addListener('ev1', $listener, 0);
+        $dispatcher->addListener('ev1', $listener, 1);
+        $dispatcher->addListener('ev1', $listener2, 1);
+        $dispatcher->addListener('ev1', $listener3);
+        $dispatcher->addListener('ev2', $listener3);
+        $dispatcher->addListener('ev2', $listener);
+        $dispatcher->dispatch('ev1');
+        $dispatcher->dispatch('ev2');
+
+        $expected = '> ev1: Composer\Test\EventDispatcher\EventDispatcherTest->someMethod'.PHP_EOL
+            .'> ev1: Composer\Test\EventDispatcher\EventDispatcherTest->someMethod2'.PHP_EOL
+            .'> ev1: Composer\Test\EventDispatcher\EventDispatcherTest->someMethod'.PHP_EOL
+            .'> ev1: Composer\Test\EventDispatcher\EventDispatcherTest::someMethod'.PHP_EOL
+            .'> ev2: Composer\Test\EventDispatcher\EventDispatcherTest::someMethod'.PHP_EOL
+            .'> ev2: Composer\Test\EventDispatcher\EventDispatcherTest->someMethod'.PHP_EOL;
+        $this->assertEquals($expected, $io->getOutput());
+
+        $dispatcher->removeListener($this);
+        $dispatcher->dispatch('ev1');
+        $dispatcher->dispatch('ev2');
+
+        $expected .= '> ev1: Composer\Test\EventDispatcher\EventDispatcherTest::someMethod'.PHP_EOL
+            .'> ev2: Composer\Test\EventDispatcher\EventDispatcherTest::someMethod'.PHP_EOL;
+        $this->assertEquals($expected, $io->getOutput());
+    }
+
     public function testDispatcherCanExecuteCliAndPhpInSameEventScriptStack()
     {
         $process = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
@@ -264,11 +281,11 @@ class EventDispatcherTest extends TestCa
     public function testDispatcherAppendsDirBinOnPathForEveryListener()
     {
         $currentDirectoryBkp = getcwd();
-        $composerBinDirBkp   = getenv('COMPOSER_BIN_DIR');
+        $composerBinDirBkp = getenv('COMPOSER_BIN_DIR');
         chdir(__DIR__);
         putenv('COMPOSER_BIN_DIR=' . __DIR__ . sprintf('%svendor%sbin', DIRECTORY_SEPARATOR, DIRECTORY_SEPARATOR));
 
-        $process    = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
+        $process = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
         $dispatcher = $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')->setConstructorArgs(array(
                 $this->createComposerInstance(),
                 $io = new BufferIO('', OutputInterface::VERBOSITY_VERBOSE),
@@ -292,7 +309,7 @@ class EventDispatcherTest extends TestCa
         putenv('COMPOSER_BIN_DIR' . ($composerBinDirBkp === false ? '' : '=' . $composerBinDirBkp));
     }
 
-    static public function createsVendorBinFolderChecksEnvDoesNotContainsBin()
+    public static function createsVendorBinFolderChecksEnvDoesNotContainsBin()
     {
         mkdir(__DIR__ . sprintf('%svendor%sbin', DIRECTORY_SEPARATOR, DIRECTORY_SEPARATOR), 0700, true);
         $val = getenv('PATH');
@@ -304,7 +321,7 @@ class EventDispatcherTest extends TestCa
         self::assertFalse(strpos($val, __DIR__ . sprintf('%svendor%sbin', DIRECTORY_SEPARATOR, DIRECTORY_SEPARATOR)));
     }
 
-    static public function createsVendorBinFolderChecksEnvContainsBin()
+    public static function createsVendorBinFolderChecksEnvContainsBin()
     {
         $val = getenv('PATH');
 
@@ -315,7 +332,8 @@ class EventDispatcherTest extends TestCa
         self::assertNotFalse(strpos($val, __DIR__ . sprintf('%svendor%sbin', DIRECTORY_SEPARATOR, DIRECTORY_SEPARATOR)));
     }
 
-    static public function getTestEnv() {
+    public static function getTestEnv()
+    {
         $val = getenv('ABC');
         if ($val !== '123') {
             throw new \Exception('getenv() did not return the expected value. expected 123 got '. var_export($val, true));
@@ -358,7 +376,7 @@ class EventDispatcherTest extends TestCa
                 return array();
             }));
 
-        $dispatcher->dispatch('root', new CommandEvent('root', $composer, $io));
+        $dispatcher->dispatch('root', new ScriptEvent('root', $composer, $io));
         $expected = '> root: @group'.PHP_EOL.
             '> group: echo -n foo'.PHP_EOL.
             '> group: @subgroup'.PHP_EOL.
@@ -374,10 +392,10 @@ class EventDispatcherTest extends TestCa
             ->setConstructorArgs(array(
                 $composer = $this->createComposerInstance(),
                 $io = new BufferIO('', OutputInterface::VERBOSITY_VERBOSE),
-                $process
+                $process,
             ))
             ->setMethods(array(
-                'getListeners'
+                'getListeners',
             ))
             ->getMock();
 
@@ -388,29 +406,28 @@ class EventDispatcherTest extends TestCa
         $dispatcher->expects($this->atLeastOnce())
             ->method('getListeners')
             ->will($this->returnCallback(function (Event $event) {
-                if($event->getName() === 'hello') {
+                if ($event->getName() === 'hello') {
                     return array('echo Hello');
                 }
 
-                if($event->getName() === 'helloWorld') {
+                if ($event->getName() === 'helloWorld') {
                     return array('@hello World');
                 }
 
                 return array();
             }));
 
-        $dispatcher->dispatch('helloWorld', new CommandEvent('helloWorld', $composer, $io));
+        $dispatcher->dispatch('helloWorld', new ScriptEvent('helloWorld', $composer, $io));
         $expected = "> helloWorld: @hello World".PHP_EOL.
             "> hello: echo Hello " .escapeshellarg('World').PHP_EOL;
 
         $this->assertEquals($expected, $io->getOutput());
     }
 
-    /**
-     * @expectedException RuntimeException
-     */
     public function testDispatcherDetectInfiniteRecursion()
     {
+        $this->setExpectedException('RuntimeException');
+
         $process = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
         $dispatcher = $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')
         ->setConstructorArgs(array(
@@ -437,7 +454,7 @@ class EventDispatcherTest extends TestCa
                 return array();
             }));
 
-        $dispatcher->dispatch('root', new CommandEvent('root', $composer, $io));
+        $dispatcher->dispatch('root', new ScriptEvent('root', $composer, $io));
     }
 
     private function getDispatcherStubForListenersTest($listeners, $io)
@@ -487,7 +504,7 @@ class EventDispatcherTest extends TestCa
             ->with($this->equalTo('> echo foo'));
 
         $io->expects($this->once())
-            ->method('write')
+            ->method('writeRaw')
             ->with($this->equalTo('foo'.PHP_EOL), false);
 
         $dispatcher->dispatchScript(ScriptEvents::POST_INSTALL_CMD, false);
@@ -519,6 +536,10 @@ class EventDispatcherTest extends TestCa
             ->willReturn('> exit 1');
 
         $io->expects($this->at(2))
+            ->method('isInteractive')
+            ->willReturn(1);
+
+        $io->expects($this->at(3))
             ->method('writeError')
             ->with($this->equalTo('<error>Script '.$code.' handling the post-install-cmd event returned with error code 1</error>'));
 
@@ -542,13 +563,9 @@ class EventDispatcherTest extends TestCa
             ->method('getListeners')
             ->will($this->returnValue(array()));
 
-        $policy = $this->getMockBuilder('Composer\DependencyResolver\PolicyInterface')->getMock();
-        $pool = $this->getMockBuilder('Composer\DependencyResolver\Pool')->disableOriginalConstructor()->getMock();
-        $installedRepo = $this->getMockBuilder('Composer\Repository\CompositeRepository')->disableOriginalConstructor()->getMock();
-        $request = $this->getMockBuilder('Composer\DependencyResolver\Request')->disableOriginalConstructor()->getMock();
+        $transaction = $this->getMockBuilder('Composer\DependencyResolver\LockTransaction')->disableOriginalConstructor()->getMock();
 
-        $dispatcher->dispatchInstallerEvent(InstallerEvents::PRE_DEPENDENCIES_SOLVING, true, $policy, $pool, $installedRepo, $request);
-        $dispatcher->dispatchInstallerEvent(InstallerEvents::POST_DEPENDENCIES_SOLVING, true, $policy, $pool, $installedRepo, $request, array());
+        $dispatcher->dispatchInstallerEvent(InstallerEvents::PRE_OPERATIONS_EXEC, true, true, $transaction);
     }
 
     public static function call()
@@ -556,17 +573,12 @@ class EventDispatcherTest extends TestCa
         throw new \RuntimeException();
     }
 
-    public static function expectsCommandEvent(CommandEvent $event)
-    {
-        return false;
-    }
-
-    public static function expectsVariableEvent($event)
+    public static function someMethod()
     {
-        return false;
+        return true;
     }
 
-    public static function someMethod()
+    public static function someMethod2()
     {
         return true;
     }
diff -pruN 1.10.19-1/tests/Composer/Test/FactoryTest.php 2.0.9-1/tests/Composer/Test/FactoryTest.php
--- 1.10.19-1/tests/Composer/Test/FactoryTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/FactoryTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -35,6 +35,6 @@ class FactoryTest extends TestCase
             ->with($this->equalTo('disable-tls'))
             ->will($this->returnValue(true));
 
-        Factory::createRemoteFilesystem($ioMock, $config);
+        Factory::createHttpDownloader($ioMock, $config);
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/functional/packages.json 2.0.9-1/tests/Composer/Test/Fixtures/functional/packages.json
--- 1.10.19-1/tests/Composer/Test/Fixtures/functional/packages.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/functional/packages.json	2021-01-27 15:09:27.000000000 +0000
@@ -18,7 +18,7 @@
             {
                 "name": "Jordi Boggiano",
                 "email": "j.boggiano@seld.be",
-                "homepage": "http://seld.be",
+                "homepage": "https://seld.be",
                 "role": "Developer"
             }
         ],
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/abandoned-listed.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/abandoned-listed.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/abandoned-listed.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/abandoned-listed.test	2021-01-27 15:09:27.000000000 +0000
@@ -22,14 +22,18 @@ Abandoned packages are flagged
     }
 }
 --RUN--
-install
+update
 --EXPECT-OUTPUT--
 Loading composer repositories with package information
-Updating dependencies (including require-dev)
+Updating dependencies
+Lock file operations: 2 installs, 0 updates, 0 removals
+  - Locking a/a (1.0.0)
+  - Locking c/c (1.0.0)
+Writing lock file
+Installing dependencies from lock file (including require-dev)
 Package operations: 2 installs, 0 updates, 0 removals
 <warning>Package a/a is abandoned, you should avoid using it. No replacement was suggested.</warning>
 <warning>Package c/c is abandoned, you should avoid using it. Use b/b instead.</warning>
-Writing lock file
 Generating autoload files
 
 --EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/aliased-priority-conflicting.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/aliased-priority-conflicting.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/aliased-priority-conflicting.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/aliased-priority-conflicting.test	2021-01-27 15:09:27.000000000 +0000
@@ -13,25 +13,24 @@ Aliases take precedence over default pac
                 {
                     "name": "a/req", "version": "dev-master",
                     "extra": { "branch-alias": { "dev-master": "1.0.x-dev" } },
-                    "source": { "reference": "forked", "type": "git", "url": "" }
-                }
-            ]
-        },
-        {
-            "type": "package",
-            "package": [
+                    "source": { "reference": "forked", "type": "git", "url": "" },
+                    "default-branch": true
+                },
                 {
-                    "name": "a/a", "version": "dev-master",
-                    "require": { "a/req": "dev-master" }
+                    "name": "a/req", "version": "dev-master",
+                    "extra": { "branch-alias": { "dev-master": "1.0.x-dev" } },
+                    "source": { "reference": "master", "type": "git", "url": "" },
+                    "default-branch": true
                 },
                 {
-                    "name": "a/b", "version": "dev-master",
-                    "require": { "a/req": "dev-master" }
+                    "name": "a/a", "version": "dev-master",
+                    "require": { "a/req": "dev-master" },
+                    "default-branch": true
                 },
                 {
-                    "name": "a/req", "version": "dev-master",
-                    "extra": { "branch-alias": { "dev-master": "1.0.x-dev" } },
-                    "source": { "reference": "master", "type": "git", "url": "" }
+                    "name": "a/b", "version": "dev-master",
+                    "require": { "a/req": "dev-master" },
+                    "default-branch": true
                 }
             ]
         }
@@ -43,10 +42,53 @@ Aliases take precedence over default pac
     },
     "minimum-stability": "dev"
 }
+--EXPECT-LOCK--
+{
+    "packages": [
+        {
+            "name": "a/a", "version": "dev-master",
+            "require": { "a/req": "dev-master" },
+            "type": "library",
+            "default-branch": true
+        },
+        {
+            "name": "a/b", "version": "dev-master",
+            "require": { "a/req": "dev-master" },
+            "type": "library",
+            "default-branch": true
+        },
+        {
+            "name": "a/req", "version": "dev-feature-foo",
+            "source": { "reference": "feat.f", "type": "git", "url": "" },
+            "type": "library"
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [
+        {
+            "alias": "dev-master",
+            "alias_normalized": "dev-master",
+            "version": "dev-feature-foo",
+            "package": "a/req"
+        }
+    ],
+    "minimum-stability": "dev",
+    "stability-flags": {
+        "a/a": 20,
+        "a/b": 20,
+        "a/req": 20
+    },
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
 --RUN--
 install
 --EXPECT--
 Installing a/req (dev-feature-foo feat.f)
 Marking a/req (dev-master feat.f) as installed, alias of a/req (dev-feature-foo feat.f)
 Installing a/a (dev-master)
+Marking a/a (9999999-dev) as installed, alias of a/a (dev-master)
 Installing a/b (dev-master)
+Marking a/b (9999999-dev) as installed, alias of a/b (dev-master)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/aliased-priority.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/aliased-priority.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/aliased-priority.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/aliased-priority.test	2021-01-27 15:09:27.000000000 +0000
@@ -51,6 +51,6 @@ install
 Installing a/c (dev-feature-foo feat.f)
 Marking a/c (dev-master feat.f) as installed, alias of a/c (dev-feature-foo feat.f)
 Installing a/b (dev-master forked)
+Marking a/b (1.0.x-dev forked) as installed, alias of a/b (dev-master forked)
 Installing a/a (dev-master master)
 Marking a/a (1.0.x-dev master) as installed, alias of a/a (dev-master master)
-Marking a/b (1.0.x-dev forked) as installed, alias of a/b (dev-master forked)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/aliases-with-require-dev.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/aliases-with-require-dev.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/aliases-with-require-dev.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/aliases-with-require-dev.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,90 @@
+--TEST--
+Aliases are loaded when splitting require-dev from require (https://github.com/composer/composer/issues/8954)
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "a/aliased", "version": "dev-next", "replace": { "a/aliased-replaced": "self.version" }
+                },
+                {
+                    "name": "b/requirer", "version": "2.3.0",
+                    "require": { "a/aliased-replaced": "^4.0" }
+                },
+                {
+                    "name": "a/aliased2", "version": "dev-next", "replace": { "a/aliased-replaced2": "self.version" }
+                },
+                {
+                    "name": "b/requirer2", "version": "2.3.0",
+                    "require": { "a/aliased-replaced": "^4.0", "a/aliased-replaced2": "^4.0" }
+                }
+            ]
+        }
+    ],
+    "require": {
+        "a/aliased": "dev-next as 4.1.0-RC2",
+        "b/requirer": "2.3.0"
+    },
+    "require-dev": {
+        "a/aliased2": "dev-next as 4.1.0-RC2",
+        "b/requirer2": "2.3.0"
+    }
+}
+--RUN--
+update
+--EXPECT-LOCK--
+{
+    "packages": [
+        {
+            "name": "a/aliased", "version": "dev-next",
+            "type": "library",
+            "replace": { "a/aliased-replaced": "self.version" }
+        },
+        {
+            "name": "b/requirer", "version": "2.3.0",
+            "require": { "a/aliased-replaced": "^4.0" },
+            "type": "library"
+        }
+    ],
+    "packages-dev": [
+        {
+            "name": "a/aliased2", "version": "dev-next",
+            "type": "library",
+            "replace": { "a/aliased-replaced2": "self.version" }
+        },
+        {
+            "name": "b/requirer2", "version": "2.3.0",
+            "require": { "a/aliased-replaced": "^4.0", "a/aliased-replaced2": "^4.0" },
+            "type": "library"
+        }
+    ],
+    "aliases": [{
+        "package": "a/aliased",
+        "version": "dev-next",
+        "alias": "4.1.0-RC2",
+        "alias_normalized": "4.1.0.0-RC2"
+    }, {
+        "package": "a/aliased2",
+        "version": "dev-next",
+        "alias": "4.1.0-RC2",
+        "alias_normalized": "4.1.0.0-RC2"
+    }],
+    "minimum-stability": "stable",
+    "stability-flags": {
+        "a/aliased": 20,
+        "a/aliased2": 20
+    },
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT--
+Installing a/aliased (dev-next)
+Marking a/aliased (4.1.0-RC2) as installed, alias of a/aliased (dev-next)
+Installing b/requirer (2.3.0)
+Installing a/aliased2 (dev-next)
+Marking a/aliased2 (4.1.0-RC2) as installed, alias of a/aliased2 (dev-next)
+Installing b/requirer2 (2.3.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/alias-in-lock2.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/alias-in-lock2.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/alias-in-lock2.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/alias-in-lock2.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,75 @@
+--TEST--
+Newly defined root aliases end up in lock file only if the package is updated
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "a/aliased", "version": "3.0.2"
+                },
+                {
+                    "name": "a/aliased2", "version": "3.0.2"
+                }
+            ]
+        }
+    ],
+    "require": {
+        "a/aliased": "3.0.2 as 3.0.3",
+        "a/aliased2": "3.0.2 as 3.0.3"
+    }
+}
+--LOCK--
+{
+    "packages": [
+        {
+            "name": "a/aliased", "version": "3.0.2",
+            "type": "library"
+        },
+        {
+            "name": "a/aliased2", "version": "3.0.2",
+            "type": "library"
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update a/aliased
+--EXPECT-LOCK--
+{
+    "packages": [
+        {
+            "name": "a/aliased", "version": "3.0.2",
+            "type": "library"
+        },
+        {
+            "name": "a/aliased2", "version": "3.0.2",
+            "type": "library"
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [{
+        "package": "a/aliased",
+        "version": "3.0.2.0",
+        "alias": "3.0.3",
+        "alias_normalized": "3.0.3.0"
+    }],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT--
+Installing a/aliased (3.0.2)
+Marking a/aliased (3.0.3) as installed, alias of a/aliased (3.0.2)
+Installing a/aliased2 (3.0.2)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/alias-in-lock.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/alias-in-lock.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/alias-in-lock.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/alias-in-lock.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,71 @@
+--TEST--
+Root-defined aliases end up in lock file always on full update
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "a/aliased", "version": "3.0.2"
+                },
+                {
+                    "name": "a/aliased2", "version": "3.0.2"
+                },
+                {
+                    "name": "b/requirer", "version": "1.0.0",
+                    "require": { "a/aliased": "^3.0.3", "a/aliased2": "^3.0.0" }
+                }
+            ]
+        }
+    ],
+    "require": {
+        "a/aliased": "3.0.2 as 3.0.3",
+        "a/aliased2": "3.0.2 as 3.0.3",
+        "b/requirer": "*"
+    }
+}
+--RUN--
+update
+--EXPECT-LOCK--
+{
+    "packages": [
+        {
+            "name": "a/aliased", "version": "3.0.2",
+            "type": "library"
+        },
+        {
+            "name": "a/aliased2", "version": "3.0.2",
+            "type": "library"
+        },
+        {
+            "name": "b/requirer", "version": "1.0.0",
+            "require": { "a/aliased": "^3.0.3", "a/aliased2": "^3.0.0" },
+            "type": "library"
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [{
+        "package": "a/aliased",
+        "version": "3.0.2.0",
+        "alias": "3.0.3",
+        "alias_normalized": "3.0.3.0"
+    },{
+        "package": "a/aliased2",
+        "version": "3.0.2.0",
+        "alias": "3.0.3",
+        "alias_normalized": "3.0.3.0"
+    }],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT--
+Installing a/aliased2 (3.0.2)
+Marking a/aliased2 (3.0.3) as installed, alias of a/aliased2 (3.0.2)
+Installing a/aliased (3.0.2)
+Marking a/aliased (3.0.3) as installed, alias of a/aliased (3.0.2)
+Installing b/requirer (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/alias-on-unloadable-package.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/alias-on-unloadable-package.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/alias-on-unloadable-package.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/alias-on-unloadable-package.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,30 @@
+--TEST--
+A root alias for a package which cannot be found in an acceptable version does not lead to different error.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "a/aliased", "version": "1.2.3" }
+            ]
+        }
+    ],
+    "require": {
+        "a/aliased": "3.0.2 as 3.0.3"
+    }
+}
+--RUN--
+update
+--EXPECT-EXIT-CODE--
+2
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires a/aliased 3.0.2 as 3.0.3, found a/aliased[1.2.3] but it does not match the constraint.
+
+--EXPECT--
+
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/alias-solver-problems2.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/alias-solver-problems2.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/alias-solver-problems2.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/alias-solver-problems2.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,51 @@
+--TEST--
+Test the error output of solver problems with dev-master aliases.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "locked/pkg", "version": "dev-master", "require": {"locked/dependency": "1.0.0"}, "default-branch": true }
+            ]
+        }
+    ],
+    "require": {
+        "locked/pkg": "*@dev"
+    }
+}
+
+--LOCK--
+{
+    "packages": [
+        { "name": "locked/pkg", "version": "dev-master", "require": {"locked/dependency": "1.0.0"}, "default-branch": true },
+        { "name": "locked/dependency", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+
+--RUN--
+update locked/dependency
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - locked/pkg dev-master requires locked/dependency 1.0.0 -> found locked/dependency[1.0.0] in lock file but not in remote repositories, make sure you avoid updating this package to keep the one from lock file.
+    - locked/pkg is locked to version dev-master and an update of this package was not requested.
+
+Use the option --with-all-dependencies (-W) to allow upgrades, downgrades and removals for packages currently locked to specific versions.
+--EXPECT--
+
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/alias-solver-problems.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/alias-solver-problems.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/alias-solver-problems.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/alias-solver-problems.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,56 @@
+--TEST--
+Test the error output of solver problems with dev-master aliases.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {"name": "a/a", "version": "dev-master", "require": {"d/d": "1.0.0"}, "default-branch": true},
+                {"name": "b/b", "version": "dev-master", "require": {"d/d": "2.0.0"}, "default-branch": true},
+                {"name": "d/d", "version": "1.0.0"},
+                {"name": "d/d", "version": "2.0.0"}
+            ]
+        }
+    ],
+    "require": {
+        "a/a": "*@dev",
+        "b/b": "*@dev"
+    }
+}
+
+--LOCK--
+{
+    "packages": [
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+
+--RUN--
+update a/a b/b
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires b/b *@dev -> satisfiable by b/b[dev-master].
+    - a/a dev-master requires d/d 1.0.0 -> satisfiable by d/d[1.0.0].
+    - You can only install one version of a package, so only one of these can be installed: d/d[1.0.0, 2.0.0].
+    - b/b dev-master requires d/d 2.0.0 -> satisfiable by d/d[2.0.0].
+    - Conclusion: install b/b dev-master (conflict analysis result)
+    - Root composer.json requires a/a *@dev -> satisfiable by a/a[dev-master].
+
+--EXPECT--
+
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/alias-with-reference.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/alias-with-reference.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/alias-with-reference.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/alias-with-reference.test	2021-01-27 15:09:27.000000000 +0000
@@ -8,7 +8,8 @@ Aliases of referenced packages work
             "package": [
                 {
                     "name": "a/aliased", "version": "dev-master",
-                    "source": { "reference": "orig", "type": "git", "url": "" }
+                    "source": { "reference": "orig", "type": "git", "url": "" },
+                    "default-branch": true
                 },
                 {
                     "name": "b/requirer", "version": "1.0.0",
@@ -24,8 +25,41 @@ Aliases of referenced packages work
     }
 }
 --RUN--
-install
+update
+--EXPECT-LOCK--
+{
+    "packages": [
+        {
+            "name": "a/aliased", "version": "dev-master",
+            "source": { "reference": "abcd", "type": "git", "url": "" },
+            "type": "library",
+            "default-branch": true
+        },
+        {
+            "name": "b/requirer", "version": "1.0.0",
+            "require": { "a/aliased": "1.0.0" },
+            "source": { "reference": "1.0.0", "type": "git", "url": "" },
+            "type": "library"
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [{
+        "package": "a/aliased",
+        "version": "9999999-dev",
+        "alias": "1.0.0",
+        "alias_normalized": "1.0.0.0"
+    }],
+    "minimum-stability": "stable",
+    "stability-flags": {
+        "a/aliased": 20
+    },
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
 --EXPECT--
 Installing a/aliased (dev-master abcd)
 Marking a/aliased (1.0.0) as installed, alias of a/aliased (dev-master abcd)
+Marking a/aliased (9999999-dev abcd) as installed, alias of a/aliased (dev-master abcd)
 Installing b/requirer (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/broken-deps-do-not-replace.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/broken-deps-do-not-replace.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/broken-deps-do-not-replace.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/broken-deps-do-not-replace.test	2021-01-27 15:09:27.000000000 +0000
@@ -19,16 +19,16 @@ Broken dependencies should not lead to a
     }
 }
 --RUN--
-install
+update
 --EXPECT-OUTPUT--
 Loading composer repositories with package information
-Updating dependencies (including require-dev)
+Updating dependencies
 Your requirements could not be resolved to an installable set of packages.
 
   Problem 1
-    - c/c 1.0.0 requires x/x 1.0 -> no matching package found.
+    - c/c 1.0.0 requires x/x 1.0 -> could not be found in any version, there may be a typo in the package name.
     - b/b 1.0.0 requires c/c 1.* -> satisfiable by c/c[1.0.0].
-    - Installation request for b/b 1.* -> satisfiable by b/b[1.0.0].
+    - Root composer.json requires b/b 1.* -> satisfiable by b/b[1.0.0].
 
 Potential causes:
  - A typo in the package name
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/circular-dependency2.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/circular-dependency2.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/circular-dependency2.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/circular-dependency2.test	2021-01-27 15:09:27.000000000 +0000
@@ -2,7 +2,7 @@
 Circular dependencies are possible between packages
 --COMPOSER--
 {
-    "name": "root",
+    "name": "root/pkg",
     "version": "dev-master",
     "require": {
         "require/itself": "1.0.0",
@@ -32,5 +32,5 @@ Circular dependencies are possible betwe
 --RUN--
 update -v
 --EXPECT--
-Installing require/itself (1.0.0)
 Installing regular/pkg (1.0.0)
+Installing require/itself (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/conflict-between-dependents.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/conflict-between-dependents.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/conflict-between-dependents.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/conflict-between-dependents.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,38 @@
+--TEST--
+Test the error output of solver problems for conflicts between two dependents
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "conflicter/pkg", "version": "1.0.0", "conflict": { "victim/pkg": "1.0.0"} },
+                { "name": "victim/pkg", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "conflicter/pkg": "1.0.0",
+        "victim/pkg": "1.0.0"
+    }
+}
+
+
+--RUN--
+update
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires conflicter/pkg 1.0.0 -> satisfiable by conflicter/pkg[1.0.0].
+    - conflicter/pkg 1.0.0 conflicts with victim/pkg 1.0.0.
+    - Root composer.json requires victim/pkg 1.0.0 -> satisfiable by victim/pkg[1.0.0].
+
+--EXPECT--
+
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/conflict-between-root-and-dependent.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/conflict-between-root-and-dependent.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/conflict-between-root-and-dependent.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/conflict-between-root-and-dependent.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,40 @@
+--TEST--
+Test conflicts between a dependency's requirements and the root requirements
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "requirer/pkg", "version": "1.0.0", "require": {
+                    "dependency/pkg": "1.0.0",
+                    "dependency/unstable-pkg": "1.0.0-dev"
+                } },
+                { "name": "dependency/pkg", "version": "2.0.0" },
+                { "name": "dependency/pkg", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "requirer/pkg": "1.*",
+        "dependency/pkg": "2.*"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires requirer/pkg 1.* -> satisfiable by requirer/pkg[1.0.0].
+    - requirer/pkg 1.0.0 requires dependency/pkg 1.0.0 -> found dependency/pkg[1.0.0] but it conflicts with your root composer.json require (2.*).
+
+--EXPECT--
+
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/conflict-on-root-with-alias-prevents-update-if-not-required.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/conflict-on-root-with-alias-prevents-update-if-not-required.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/conflict-on-root-with-alias-prevents-update-if-not-required.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/conflict-on-root-with-alias-prevents-update-if-not-required.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,38 @@
+--TEST--
+Test that a root package conflict with a branch alias leads to an error, even if the branch alias isn't required.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "some/dep", "version": "1.0.0" },
+                { "name": "some/dep", "version": "1.1.0" },
+                { "name": "some/dep", "version": "1.2.0" },
+                { "name": "some/dep", "version": "dev-main", "extra": {"branch-alias": {"dev-main": "1.3.x-dev"} } },
+                { "name": "some/dep", "version": "1.2.x-dev" }
+            ]
+        }
+    ],
+    "require": {
+        "some/dep": "dev-main"
+    },
+    "conflict": {
+        "some/dep": ">=1.3"
+    }
+}
+--RUN--
+update
+--EXPECT-EXIT-CODE--
+2
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - __root__ is present at version 1.0.0+no-version-set and cannot be modified by Composer
+    - some/dep 1.3.x-dev is an alias of some/dep dev-main and must be installed with it.
+    - __root__ 1.0.0+no-version-set conflicts with some/dep 1.3.x-dev.
+    - Root composer.json requires some/dep dev-main -> satisfiable by some/dep[dev-main].
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/conflict-with-alias-in-lock-does-prevents-install.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/conflict-with-alias-in-lock-does-prevents-install.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/conflict-with-alias-in-lock-does-prevents-install.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/conflict-with-alias-in-lock-does-prevents-install.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,54 @@
+--TEST--
+Test that conflict with a branch alias in the lock file leads to an error on install from lock, even if the branch alias was removed on the remote end.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "some/dep", "version": "1.0.0" },
+                { "name": "some/dep", "version": "1.1.0" },
+                { "name": "some/dep", "version": "1.2.0" },
+                { "name": "some/dep", "version": "dev-main" },
+                { "name": "some/dep", "version": "1.2.x-dev" },
+                { "name": "conflictor/foo", "version": "1.0.0", "conflict": { "some/dep": ">=1.3" } }
+            ]
+        }
+    ],
+    "require": {
+        "some/dep": "dev-main",
+        "conflictor/foo": "1.0.0"
+    }
+}
+--LOCK--
+{
+    "packages": [
+        { "name": "conflictor/foo", "version": "1.0.0", "conflict": { "some/dep": ">=1.3" }, "type": "library" },
+        { "name": "some/dep", "version": "dev-main", "extra": {"branch-alias": {"dev-main": "1.3.x-dev"} }, "type": "library" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": {
+        "some/dep": 20
+    },
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+install
+--EXPECT-EXIT-CODE--
+2
+--EXPECT-OUTPUT--
+Installing dependencies from lock file (including require-dev)
+Verifying lock file contents can be installed on current platform.
+Your lock file does not contain a compatible set of packages. Please run composer update.
+
+  Problem 1
+    - conflictor/foo is locked to version 1.0.0 and an update of this package was not requested.
+    - conflictor/foo 1.0.0 conflicts with some/dep 1.3.x-dev.
+    - some/dep is locked to version 1.3.x-dev and an update of this package was not requested.
+
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/conflict-with-alias-prevents-update-if-not-required.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/conflict-with-alias-prevents-update-if-not-required.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/conflict-with-alias-prevents-update-if-not-required.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/conflict-with-alias-prevents-update-if-not-required.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,38 @@
+--TEST--
+Test that conflict of a dependency with a branch alias of another dependency is not ignored, even if the alias is not required for installation.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "some/dep", "version": "1.0.0" },
+                { "name": "some/dep", "version": "1.1.0" },
+                { "name": "some/dep", "version": "1.2.0" },
+                { "name": "some/dep", "version": "dev-main", "extra": {"branch-alias": {"dev-main": "1.3.x-dev"} } },
+                { "name": "some/dep", "version": "1.2.x-dev" },
+                { "name": "conflictor/foo", "version": "1.0.0", "conflict": { "some/dep": ">=1.3" } }
+            ]
+        }
+    ],
+    "require": {
+        "some/dep": "dev-main",
+        "conflictor/foo": "1.0.0"
+    }
+}
+--RUN--
+update
+--EXPECT-EXIT-CODE--
+2
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires some/dep dev-main -> satisfiable by some/dep[dev-main].
+    - conflictor/foo 1.0.0 conflicts with some/dep 1.3.x-dev.
+    - some/dep 1.3.x-dev is an alias of some/dep dev-main and must be installed with it.
+    - Root composer.json requires conflictor/foo 1.0.0 -> satisfiable by conflictor/foo[1.0.0].
+
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/conflict-with-alias-prevents-update.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/conflict-with-alias-prevents-update.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/conflict-with-alias-prevents-update.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/conflict-with-alias-prevents-update.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,43 @@
+--TEST--
+Test that conflict on a branch alias is respected
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "some/dep", "version": "1.0.0" },
+                { "name": "some/dep", "version": "1.1.0" },
+                { "name": "some/dep", "version": "1.2.0" },
+                { "name": "some/dep", "version": "dev-main", "extra": {"branch-alias": {"dev-main": "1.3.x-dev"} } },
+                { "name": "some/dep", "version": "1.2.x-dev" }
+            ]
+        }
+    ],
+    "require": {
+        "some/dep": "^1.0@dev"
+    },
+    "conflict": {
+        "some/dep": ">=1.3"
+    }
+}
+--RUN--
+update
+--EXPECT-LOCK--
+{
+    "packages": [
+        { "name": "some/dep", "version": "1.2.x-dev", "type": "library" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": {
+        "some/dep": 20
+    },
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT--
+Installing some/dep (1.2.x-dev)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/deduplicate-solver-problems.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/deduplicate-solver-problems.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/deduplicate-solver-problems.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/deduplicate-solver-problems.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,48 @@
+--TEST--
+Test the error output of solver problems is deduplicated.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "package/a", "version": "2.0.0", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.0.1", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.0.2", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.0.3", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.1.0", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.2.0", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.3.1", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.3.2", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.3.3", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.3.4", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.3.5", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.4.0", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.5.0", "require": { "missing/dep": "^1.0" } },
+                { "name": "package/a", "version": "2.6.0", "require": { "missing/dep": "^1.0" } },
+                { "name": "missing/dep", "version": "2.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "package/a": "*"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - package/a[2.0.0, ..., 2.6.0] require missing/dep ^1.0 -> found missing/dep[2.0.0] but it does not match the constraint.
+    - Root composer.json requires package/a * -> satisfiable by package/a[2.0.0, ..., 2.6.0].
+
+--EXPECT--
+
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/disjunctive-multi-constraints.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/disjunctive-multi-constraints.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/disjunctive-multi-constraints.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/disjunctive-multi-constraints.test	2021-01-27 15:09:27.000000000 +0000
@@ -6,19 +6,19 @@ Disjunctive multi constraints work
         {
             "type": "package",
             "package": [
-                { "name": "foo", "version": "1.1.0" },
-                { "name": "foo", "version": "1.0.0" },
-                { "name": "bar", "version": "1.1.0", "require": { "foo": "1.0.*" } }
+                { "name": "foo/pkg", "version": "1.1.0" },
+                { "name": "foo/pkg", "version": "1.0.0" },
+                { "name": "bar/pkg", "version": "1.1.0", "require": { "foo/pkg": "1.0.*" } }
             ]
         }
     ],
     "require": {
-        "bar": "1.*",
-        "foo": "1.0.*|1.1.*"
+        "bar/pkg": "1.*",
+        "foo/pkg": "1.0.*|1.1.*"
     }
 }
 --RUN--
 install
 --EXPECT--
-Installing foo (1.0.0)
-Installing bar (1.1.0)
+Installing foo/pkg (1.0.0)
+Installing bar/pkg (1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-4319.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-4319.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-4319.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-4319.test	2021-01-27 15:09:27.000000000 +0000
@@ -28,16 +28,16 @@ Present a clear error message when confi
 }
 
 --RUN--
-install
+update
 
 --EXPECT-OUTPUT--
 Loading composer repositories with package information
-Updating dependencies (including require-dev)
+Updating dependencies
 Your requirements could not be resolved to an installable set of packages.
 
   Problem 1
-    - Installation request for a/a ~1.0 -> satisfiable by a/a[1.0.0].
-    - a/a 1.0.0 requires php 5.5 -> your PHP version (%s) overridden by "config.platform.php" version (5.3) does not satisfy that requirement.
+    - Root composer.json requires a/a ~1.0 -> satisfiable by a/a[1.0.0].
+    - a/a 1.0.0 requires php 5.5 -> your php version (5.3; overridden via config.platform, actual: %s) does not satisfy that requirement.
 
 --EXPECT--
 
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-4795-2.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-4795-2.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-4795-2.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-4795-2.test	2021-01-27 15:09:27.000000000 +0000
@@ -29,17 +29,39 @@ that are also a root package, when that
     { "name": "a/a", "version": "1.0.0" },
     { "name": "b/b", "version": "1.0.0", "require": { "a/a": "~1.0" } }
 ]
-
+--LOCK--
+{
+    "packages": [
+        {
+            "name": "a/a", "version": "1.0.0"
+        },
+        {
+            "name": "b/b", "version": "1.0.0", "require": { "a/a": "~1.0" }
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": {},
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
 --RUN--
 update a/a b/b --with-dependencies
 
 --EXPECT-OUTPUT--
 Loading composer repositories with package information
-Updating dependencies (including require-dev)
-Package operations: 0 installs, 2 updates, 0 removals
+Updating dependencies
+Lock file operations: 0 installs, 2 updates, 0 removals
+  - Upgrading a/a (1.0.0 => 1.1.0)
+  - Upgrading b/b (1.0.0 => 1.1.0)
 Writing lock file
+Installing dependencies from lock file (including require-dev)
+Package operations: 0 installs, 2 updates, 0 removals
 Generating autoload files
 
 --EXPECT--
-Updating a/a (1.0.0) to a/a (1.1.0)
-Updating b/b (1.0.0) to b/b (1.1.0)
+Upgrading a/a (1.0.0 => 1.1.0)
+Upgrading b/b (1.0.0 => 1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-4795.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-4795.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-4795.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-4795.test	2021-01-27 15:09:27.000000000 +0000
@@ -14,7 +14,7 @@ dependency of one the requirements that
                 { "name": "a/a", "version": "1.0.0" },
                 { "name": "a/a", "version": "1.1.0" },
                 { "name": "b/b", "version": "1.0.0", "require": { "a/a": "~1.0" } },
-                { "name": "b/b", "version": "1.1.0", "require": { "a/b": "~1.1" } }
+                { "name": "b/b", "version": "1.1.0", "require": { "a/a": "~1.1" } }
             ]
         }
     ],
@@ -30,15 +30,32 @@ dependency of one the requirements that
     { "name": "b/b", "version": "1.0.0", "require": { "a/a": "~1.0" } }
 ]
 
+--LOCK--
+{
+    "packages": [
+        { "name": "a/a", "version": "1.0.0" },
+        { "name": "b/b", "version": "1.0.0", "require": { "a/a": "~1.0" } }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
 --RUN--
 update b/b --with-dependencies
 
 --EXPECT-OUTPUT--
-<warning>Dependency "a/a" is also a root requirement, but is not explicitly allowed. Ignoring.</warning>
 Loading composer repositories with package information
-Updating dependencies (including require-dev)
-Nothing to install or update
+<warning>Dependency "a/a" is also a root requirement. Package has not been listed as an update argument, so keeping locked at old version. Use --with-all-dependencies (-W) to include root dependencies.</warning>
+Updating dependencies
+Nothing to modify in lock file
 Writing lock file
+Installing dependencies from lock file (including require-dev)
+Nothing to install, update or remove
 Generating autoload files
 
 --EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-7051.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-7051.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-7051.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-7051.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,135 @@
+--TEST--
+Solver Bug Exception caused by analyze on mutli conflict rule reported in GitHub issue 7051 https://github.com/composer/composer/issues/7051
+--COMPOSER--
+{
+    "require": {
+        "illuminate/queue": "*",
+        "friendsofphp/php-cs-fixer": "*"
+    },
+    "repositories": {
+        "illuminate/queue": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "illuminate/queue",
+                    "version": "v5.2.0",
+                    "require": {
+                        "illuminate/console": "5.2.*"
+                    }
+                }
+            ]
+        },
+        "friendsofphp/php-cs-fixer": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.10.5",
+                    "type": "application",
+                    "require": {
+                        "symfony/console": "^3.2 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.10.4",
+                    "type": "application",
+                    "require": {
+                        "symfony/console": "^3.2 || ^4.0"
+                    }
+                }
+            ]
+        },
+        "illuminate/console": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "illuminate/console",
+                    "version": "v5.2.26",
+                    "require": {
+                        "symfony/console": "2.8.*"
+                    }
+                },
+                {
+                    "name": "illuminate/console",
+                    "version": "v5.2.25",
+                    "require": {
+                        "symfony/console": "3.1.*"
+                    }
+                }
+            ]
+        },
+        "symfony/console": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "symfony/console",
+                    "version": "v3.4.29"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v3.4.28"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v3.3.18"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v3.3.17"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v3.2.14"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v3.2.13"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v3.1.10"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v3.1.9"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v2.8.8"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v2.8.7"
+                }
+            ]
+        }
+    }
+}
+--RUN--
+update
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.10.5 (conflict analysis result)
+    - Root composer.json requires friendsofphp/php-cs-fixer * -> satisfiable by friendsofphp/php-cs-fixer[v2.10.4, v2.10.5].
+    - illuminate/queue v5.2.0 requires illuminate/console 5.2.* -> satisfiable by illuminate/console[v5.2.25, v5.2.26].
+    - illuminate/console v5.2.26 requires symfony/console 2.8.* -> satisfiable by symfony/console[v2.8.7, v2.8.8].
+    - Conclusion: don't install symfony/console v2.8.7 (conflict analysis result)
+    - Conclusion: don't install symfony/console v3.4.28 (conflict analysis result)
+    - Conclusion: don't install symfony/console v2.8.8 (conflict analysis result)
+    - Conclusion: don't install symfony/console v3.4.29 (conflict analysis result)
+    - Root composer.json requires illuminate/queue * -> satisfiable by illuminate/queue[v5.2.0].
+    - friendsofphp/php-cs-fixer v2.10.4 requires symfony/console ^3.2 || ^4.0 -> satisfiable by symfony/console[v3.2.13, ..., v3.4.29].
+    - You can only install one version of a package, so only one of these can be installed: symfony/console[v2.8.7, v2.8.8, v3.1.9, ..., v3.4.29].
+    - illuminate/console v5.2.25 requires symfony/console 3.1.* -> satisfiable by symfony/console[v3.1.9, v3.1.10].
+    - Conclusion: don't install symfony/console v3.1.10 (conflict analysis result)
+--EXPECT--
+
+--EXPECT-EXIT-CODE--
+2
+
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-8902.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-8902.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-8902.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-8902.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,46 @@
+--TEST--
+
+See Github issue #8902 ( https://github.com/composer/composer/issues/8902 ).
+
+Avoid installing packages twice if they are required in different versions and one is matched by a dev package.
+
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "beyondcode/laravel-dump-server", "version": "1.4.0", "require": { "symfony/var-dumper": "^5.0" } },
+                { "name": "laravel/framework", "version": "6.8.14", "require": { "symfony/var-dumper": "^4.3.4" } },
+                { "name": "symfony/var-dumper", "version": "4.4.0" },
+                { "name": "symfony/var-dumper", "version": "dev-master", "extra": { "branch-alias": {"dev-master": "5.2-dev"} } }
+            ]
+        }
+    ],
+    "require": {
+        "beyondcode/laravel-dump-server": "^1.3",
+        "laravel/framework": "^6.8"
+    },
+    "minimum-stability": "dev"
+}
+
+--RUN--
+update
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires beyondcode/laravel-dump-server ^1.3 -> satisfiable by beyondcode/laravel-dump-server[1.4.0].
+    - You can only install one version of a package, so only one of these can be installed: symfony/var-dumper[dev-master, 4.4.0].
+    - symfony/var-dumper 5.2.x-dev is an alias of symfony/var-dumper dev-master and thus requires it to be installed too.
+    - laravel/framework 6.8.14 requires symfony/var-dumper ^4.3.4 -> satisfiable by symfony/var-dumper[4.4.0].
+    - beyondcode/laravel-dump-server 1.4.0 requires symfony/var-dumper ^5.0 -> satisfiable by symfony/var-dumper[5.2.x-dev (alias of dev-master)].
+    - Root composer.json requires laravel/framework ^6.8 -> satisfiable by laravel/framework[6.8.14].
+
+--EXPECT--
+
+--EXPECT-EXIT-CODE--
+2
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-8903.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-8903.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-8903.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-8903.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,216 @@
+--TEST--
+
+See Github issue #8903 ( https://github.com/composer/composer/issues/8903 ).
+
+Recursive output of learnt rules can lead to infinite loop.
+
+--COMPOSER--
+{
+    "name": "nomorehours/knowmore-api",
+    "description": "Reported at https://github.com/composer/composer/issues/8903 (OP)",
+    "require": {
+        "laravel/lumen-framework": "^7.0",
+        "irazasyed/telegram-bot-sdk": "^2.0"
+    },
+    "repositories": {
+        "laravel/lumen-framework": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "laravel/lumen-framework",
+                    "version": "v7.0.0",
+                    "type": "library",
+                    "require": {
+                        "illuminate/support": "^7.0"
+                    }
+                }
+            ]
+        },
+        "irazasyed/telegram-bot-sdk": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "irazasyed/telegram-bot-sdk",
+                    "version": "v2.1.0",
+                    "type": "library",
+                    "require": {
+                        "illuminate/support": "5.0.*|5.1.*|5.2.*"
+                    }
+                },
+                {
+                    "name": "irazasyed/telegram-bot-sdk",
+                    "version": "v2.0.0",
+                    "type": "library",
+                    "require": {
+                        "illuminate/support": "5.0.*|5.1.*|5.2.*"
+                    }
+                }
+            ]
+        },
+        "illuminate/support": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.14.0",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.2.2",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.2.1",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.1.0",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.0.8",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.0.7",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.0.6",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.0.5",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.0.4",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.0.3",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.0.2",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.0.1",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v7.0.0",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.3.23",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.3.16",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.3.4",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.3.0",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.2.45",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.2.43",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.2.37",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.2.32",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.2.31",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.2.28",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.2.27",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.2.26",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.2.25",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.2.24",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.2.0",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.1.41",
+                    "type": "library"
+                },
+                {
+                    "name": "illuminate/support",
+                    "version": "v5.0.0",
+                    "type": "library"
+                }
+            ]
+        }
+    }
+}
+
+--RUN--
+update
+
+--EXPECT--
+
+--EXPECT-OUTPUT--
+
+--EXPECT-EXIT-CODE--
+2
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-9012.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-9012.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-9012.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-9012.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,325 @@
+--TEST--
+
+See Github issue #9012 ( https://github.com/composer/composer/issues/9012 and https://gist.github.com/Seldaek/4e2dbc2cea4b4fd7a8207bb310ec8e34).
+
+Recursive analysis of the same learnt rules can lead to infinite recursion in solver.
+
+--COMPOSER--
+{
+    "require": {
+        "php": ">=7.1.7",
+        "laravel/framework": "^6.0",
+        "nunomaduro/collision": "^4.0"
+    },
+    "config": {
+        "preferred-install": "dist",
+        "sort-packages": true,
+        "optimize-autoloader": true,
+        "process-timeout": 0
+    },
+    "repositories": {
+        "laravel/framework": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "laravel/framework",
+                    "version": "v6.0.0",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "6.x-dev"
+                        }
+                    },
+                    "require": {
+                        "symfony/console": "^4.3.4"
+                    }
+                }
+            ]
+        },
+        "nunomaduro/collision": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "nunomaduro/collision",
+                    "version": "v4.2.0",
+                    "type": "library",
+                    "extra": {
+                        "laravel": {
+                            "providers": [
+                                "NunoMaduro\\Collision\\Adapters\\Laravel\\CollisionServiceProvider"
+                            ]
+                        }
+                    },
+                    "require": {
+                        "symfony/console": "^5.0"
+                    }
+                }
+            ]
+        },
+        "symfony/console": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "symfony/console",
+                    "version": "v5.1.7",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.1.6",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.1.5",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.1.4",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.1.3",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.1.2",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.1.1",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.1.0",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.1.0-RC2",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.1.0-RC1",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.1.0-BETA1",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.0.11",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.0.10",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.0.9",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.0.8",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.0.7",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.0.6",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.0.5",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.0.4",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.0.3",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.0.2",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.0.1",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v5.0.0",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.15",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.14",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.13",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.12",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.11",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.10",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.9",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.8",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.7",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.6",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.5",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.4",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.3",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.2",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.1",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.0",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.0-RC1",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.0-BETA2",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.4.0-BETA1",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.3.11",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.3.10",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.3.9",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.3.8",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.3.7",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.3.6",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.3.5",
+                    "type": "library"
+                },
+                {
+                    "name": "symfony/console",
+                    "version": "v4.3.4",
+                    "type": "library"
+                }
+            ]
+        }
+    }
+}
+
+--RUN--
+update
+
+--EXPECT--
+
+--EXPECT-OUTPUT--
+
+--EXPECT-EXIT-CODE--
+2
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-9290.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-9290.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/github-issues-9290.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/github-issues-9290.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,96 @@
+--TEST--
+
+See Github issue #9290 ( https://github.com/composer/composer/issues/9290 ).
+MultiConflictRule with a level 1 decision needs to exit correctly.
+
+--COMPOSER--
+{
+    "require": {
+        "mailgun/mailgun-php": "^2.8"
+    },
+    "minimum-stability": "dev",
+    "repositories": {
+        "mailgun/mailgun-php": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "mailgun/mailgun-php",
+                    "version": "2.x-dev",
+                    "type": "library",
+                    "require": {
+                        "php-http/httplug": "^1.0 || ^2.0",
+                        "php-http/client-common": "^1.1"
+                    }
+                }
+            ]
+        },
+        "php-http/client-common": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "php-http/client-common",
+                    "version": "1.10.0",
+                    "type": "library",
+                    "require": {
+                        "php-http/httplug": "^1.1",
+                        "symfony/options-resolver": "^5.0"
+                    }
+                },
+                {
+                    "name": "php-http/client-common",
+                    "version": "1.x-dev",
+                    "type": "library",
+                    "require": {
+                        "php-http/httplug": "^1.1",
+                        "symfony/options-resolver": "^5.0"
+                    }
+                }
+            ]
+        },
+        "php-http/httplug": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "php-http/httplug",
+                    "version": "v2.0.0",
+                    "type": "library"
+                },
+                {
+                    "name": "php-http/httplug",
+                    "version": "v1.1.0",
+                    "type": "library"
+                },
+                {
+                    "name": "php-http/httplug",
+                    "version": "dev-master",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.x-dev"
+                        }
+                    },
+                    "default-branch": true
+                }
+            ]
+        },
+        "symfony/options-resolver": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "symfony/options-resolver",
+                    "version": "v5.2.0-BETA1",
+                    "type": "library"
+                }
+            ]
+        }
+    }
+}
+
+--RUN--
+update
+
+--EXPECT--
+Installing php-http/httplug (v1.1.0)
+Installing symfony/options-resolver (v5.2.0-BETA1)
+Installing php-http/client-common (1.x-dev)
+Installing mailgun/mailgun-php (2.x-dev)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-aliased-alias.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-aliased-alias.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-aliased-alias.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-aliased-alias.test	2021-01-27 15:09:27.000000000 +0000
@@ -11,7 +11,8 @@ Installing double aliased package
                     "dist": { "type": "file", "url": "" },
                     "require": {
                         "b/b": "dev-master"
-                    }
+                    },
+                    "default-branch": true
                 },
                 {
                     "name": "b/b", "version": "dev-foo",
@@ -31,6 +32,7 @@ Installing double aliased package
 install
 --EXPECT--
 Installing b/b (dev-foo)
+Marking b/b (1.0.x-dev) as installed, alias of b/b (dev-foo)
 Marking b/b (dev-master) as installed, alias of b/b (dev-foo)
 Installing a/a (dev-master)
-Marking b/b (1.0.x-dev) as installed, alias of b/b (dev-foo)
+Marking a/a (9999999-dev) as installed, alias of a/a (dev-master)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-dev-using-dist.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-dev-using-dist.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-dev-using-dist.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-dev-using-dist.test	2021-01-27 15:09:27.000000000 +0000
@@ -14,7 +14,8 @@ Installs a dev package from lock using d
                         "type": "zip",
                         "url": "http://www.example.com/dist.zip",
                         "reference": "459720ff3b74ee0c0d159277c6f2f5df89d8a4f6"
-                    }
+                    },
+                    "default-branch": true
                 }
             ]
         }
@@ -25,7 +26,7 @@ Installs a dev package from lock using d
     "minimum-stability": "dev"
 }
 --RUN--
-install --prefer-dist
+install
 --EXPECT-LOCK--
 {
     "packages": [
@@ -37,7 +38,8 @@ install --prefer-dist
                 "url": "http://www.example.com/dist.zip",
                 "reference": "459720ff3b74ee0c0d159277c6f2f5df89d8a4f6"
             },
-            "type": "library"
+            "type": "library",
+            "default-branch": true
         }
     ],
     "packages-dev": [],
@@ -53,3 +55,4 @@ install --prefer-dist
 }
 --EXPECT--
 Installing a/a (dev-master)
+Marking a/a (9999999-dev) as installed, alias of a/a (dev-master)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-from-empty-lock.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-from-empty-lock.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-from-empty-lock.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-from-empty-lock.test	2021-01-27 15:09:27.000000000 +0000
@@ -6,22 +6,22 @@ Requirements from the composer file are
         {
             "type": "package",
             "package": [
-                { "name": "required", "version": "1.0.0" },
-                { "name": "newly-required", "version": "1.0.0" }
+                { "name": "required/pkg", "version": "1.0.0" },
+                { "name": "newly-required/pkg", "version": "1.0.0" }
             ]
         }
     ],
     "require": {
-        "required": "1.0.0",
-        "newly-required": "1.0.0"
+        "required/pkg": "1.0.0",
+        "newly-required/pkg": "1.0.0"
     }
 }
 --LOCK--
 {
     "packages": [
-        { "name": "required", "version": "1.0.0" }
+        { "name": "required/pkg", "version": "1.0.0" }
     ],
-    "packages-dev": null,
+    "packages-dev": [],
     "aliases": [],
     "minimum-stability": "stable",
     "stability-flags": [],
@@ -31,4 +31,4 @@ Requirements from the composer file are
 --RUN--
 install
 --EXPECT--
-Installing required (1.0.0)
\ No newline at end of file
+Installing required/pkg (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-from-lock-removes-package.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-from-lock-removes-package.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-from-lock-removes-package.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-from-lock-removes-package.test	2021-01-27 15:09:27.000000000 +0000
@@ -6,26 +6,26 @@ Install from a lock file that deleted a
         {
             "type": "package",
             "package": [
-                { "name": "allowed", "version": "1.1.0" },
-                { "name": "allowed", "version": "1.0.0", "require": { "fixed-dependency": "1.0.0", "old-dependency": "1.0.0" } },
-                { "name": "fixed-dependency", "version": "1.1.0" },
-                { "name": "fixed-dependency", "version": "1.0.0" },
-                { "name": "old-dependency", "version": "1.0.0" }
+                { "name": "allowed/pkg", "version": "1.1.0" },
+                { "name": "allowed/pkg", "version": "1.0.0", "require": { "fixed/dependency": "1.0.0", "old/dependency": "1.0.0" } },
+                { "name": "fixed/dependency", "version": "1.1.0" },
+                { "name": "fixed/dependency", "version": "1.0.0" },
+                { "name": "old/dependency", "version": "1.0.0" }
             ]
         }
     ],
     "require": {
-        "allowed": "1.*",
-        "fixed-dependency": "1.*"
+        "allowed/pkg": "1.*",
+        "fixed/dependency": "1.*"
     }
 }
 --LOCK--
 {
     "packages": [
-        { "name": "allowed", "version": "1.1.0" },
-        { "name": "fixed-dependency", "version": "1.0.0" }
+        { "name": "allowed/pkg", "version": "1.1.0" },
+        { "name": "fixed/dependency", "version": "1.0.0" }
     ],
-    "packages-dev": null,
+    "packages-dev": [],
     "aliases": [],
     "minimum-stability": "dev",
     "stability-flags": [],
@@ -33,12 +33,12 @@ Install from a lock file that deleted a
 }
 --INSTALLED--
 [
-    { "name": "allowed", "version": "1.0.0", "require": { "old-dependency": "1.0.0", "fixed-dependency": "1.0.0" } },
-    { "name": "fixed-dependency", "version": "1.0.0" },
-    { "name": "old-dependency", "version": "1.0.0" }
+    { "name": "allowed/pkg", "version": "1.0.0", "require": { "old/dependency": "1.0.0", "fixed/dependency": "1.0.0" } },
+    { "name": "fixed/dependency", "version": "1.0.0" },
+    { "name": "old/dependency", "version": "1.0.0" }
 ]
 --RUN--
 install
 --EXPECT--
-Uninstalling old-dependency (1.0.0)
-Updating allowed (1.0.0) to allowed (1.1.0)
+Removing old/dependency (1.0.0)
+Upgrading allowed/pkg (1.0.0 => 1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-funding-notice.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-funding-notice.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-funding-notice.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-funding-notice.test	2021-01-27 15:09:27.000000000 +0000
@@ -41,10 +41,16 @@ Installs a simple package with exact mat
 --RUN--
 install
 --EXPECT-OUTPUT--
+<warning>No lock file found. Updating dependencies instead of installing from lock file. Use composer update over composer install if you do not have a lock file.</warning>
 Loading composer repositories with package information
-Updating dependencies (including require-dev)
-Package operations: 3 installs, 0 updates, 0 removals
+Updating dependencies
+Lock file operations: 3 installs, 0 updates, 0 removals
+  - Locking a/a (1.0.0)
+  - Locking b/b (1.0.0)
+  - Locking d/d (1.0.0)
 Writing lock file
+Installing dependencies from lock file (including require-dev)
+Package operations: 3 installs, 0 updates, 0 removals
 Generating autoload files
 2 packages you are using are looking for funding.
 Use the `composer fund` command to find out more!
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-missing-alias-from-lock.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-missing-alias-from-lock.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-missing-alias-from-lock.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-missing-alias-from-lock.test	2021-01-27 15:09:27.000000000 +0000
@@ -29,7 +29,7 @@ Installing an old alias that doesn't exi
             "type": "library"
         }
     ],
-    "packages-dev": null,
+    "packages-dev": [],
     "aliases": [],
     "minimum-stability": "dev",
     "stability-flags": [],
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-reference.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-reference.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/install-reference.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/install-reference.test	2021-01-27 15:09:27.000000000 +0000
@@ -7,17 +7,19 @@ Installs a dev package forcing it's refe
             "type": "package",
             "package": [
                 {
-                    "name": "a/a", "version": "dev-master",
-                    "source": { "reference": "abc123", "url": "", "type": "git" }
+                    "name": "a/a", "version": "dev-main",
+                    "source": { "reference": "abc123", "url": "", "type": "git" },
+                    "default-branch": true
                 }
             ]
         }
     ],
     "require": {
-        "a/a": "dev-master#def000"
+        "a/a": "dev-main#def000"
     }
 }
 --RUN--
 install
 --EXPECT--
-Installing a/a (dev-master def000)
+Installing a/a (dev-main def000)
+Marking a/a (9999999-dev def000) as installed, alias of a/a (dev-main def000)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-downgrades-non-allow-listed-unstable.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-downgrades-non-allow-listed-unstable.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-downgrades-non-allow-listed-unstable.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-downgrades-non-allow-listed-unstable.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,64 @@
+--TEST--
+Partial update from lock file should apply lock file and if an unstable package is not allowed anymore by latest composer.json it should fail
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "a/old", "version": "1.0.0" },
+                { "name": "a/old", "version": "2.0.0" },
+                { "name": "b/unstable", "version": "1.0.0" },
+                { "name": "b/unstable", "version": "1.1.0-alpha" },
+                { "name": "c/uptodate", "version": "1.0.0" },
+                { "name": "d/removed", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "a/old": "*",
+        "b/unstable": "*",
+        "c/uptodate": "*"
+    }
+}
+--LOCK--
+{
+    "packages": [
+        { "name": "a/old", "version": "1.0.0" },
+        { "name": "b/unstable", "version": "1.1.0-alpha" },
+        { "name": "c/uptodate", "version": "1.0.0" },
+        { "name": "d/removed", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": {
+        "b/unstable": 15
+    },
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--INSTALLED--
+[
+    { "name": "a/old", "version": "0.9.0" },
+    { "name": "b/unstable", "version": "1.1.0-alpha" },
+    { "name": "c/uptodate", "version": "2.0.0" }
+]
+--RUN--
+update c/uptodate
+--EXPECT--
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - b/unstable is fixed to 1.1.0-alpha (lock file version) by a partial update but that version is rejected by your minimum-stability. Make sure you list it as an argument for the update command.
+
+Use the option --with-all-dependencies (-W) to allow upgrades, downgrades and removals for packages currently locked to specific versions.
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-downgrades-non-whitelisted-unstable.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-downgrades-non-whitelisted-unstable.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-downgrades-non-whitelisted-unstable.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-downgrades-non-whitelisted-unstable.test	1970-01-01 00:00:00.000000000 +0000
@@ -1,71 +0,0 @@
---TEST--
-Partial update from lock file should apply lock file and downgrade unstable packages even if not allowed
---COMPOSER--
-{
-    "repositories": [
-        {
-            "type": "package",
-            "package": [
-                { "name": "a/old", "version": "1.0.0" },
-                { "name": "a/old", "version": "2.0.0" },
-                { "name": "b/unstable", "version": "1.0.0" },
-                { "name": "b/unstable", "version": "1.1.0-alpha" },
-                { "name": "c/uptodate", "version": "1.0.0" },
-                { "name": "d/removed", "version": "1.0.0" }
-            ]
-        }
-    ],
-    "require": {
-        "a/old": "*",
-        "b/unstable": "*",
-        "c/uptodate": "*"
-    }
-}
---LOCK--
-{
-    "packages": [
-        { "name": "a/old", "version": "1.0.0" },
-        { "name": "b/unstable", "version": "1.1.0-alpha" },
-        { "name": "c/uptodate", "version": "1.0.0" },
-        { "name": "d/removed", "version": "1.0.0" }
-    ],
-    "packages-dev": [],
-    "aliases": [],
-    "minimum-stability": "stable",
-    "stability-flags": {
-        "b/unstable": 15
-    },
-    "prefer-stable": false,
-    "prefer-lowest": false,
-    "platform": [],
-    "platform-dev": []
-}
---INSTALLED--
-[
-    { "name": "a/old", "version": "0.9.0" },
-    { "name": "b/unstable", "version": "1.1.0-alpha" },
-    { "name": "c/uptodate", "version": "2.0.0" }
-]
---RUN--
-update c/uptodate
---EXPECT-LOCK--
-{
-    "packages": [
-        { "name": "a/old", "version": "1.0.0", "type": "library" },
-        { "name": "b/unstable", "version": "1.0.0", "type": "library" },
-        { "name": "c/uptodate", "version": "2.0.0", "type": "library" },
-        { "name": "d/removed", "version": "1.0.0", "type": "library" }
-    ],
-    "packages-dev": [],
-    "aliases": [],
-    "minimum-stability": "stable",
-    "stability-flags": [],
-    "prefer-stable": false,
-    "prefer-lowest": false,
-    "platform": [],
-    "platform-dev": []
-}
---EXPECT--
-Downgrading b/unstable (1.1.0-alpha) to b/unstable (1.0.0)
-Updating a/old (0.9.0) to a/old (1.0.0)
-Installing d/removed (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-forces-dev-reference-from-lock-for-non-updated-packages.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-forces-dev-reference-from-lock-for-non-updated-packages.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-forces-dev-reference-from-lock-for-non-updated-packages.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-forces-dev-reference-from-lock-for-non-updated-packages.test	2021-01-27 15:09:27.000000000 +0000
@@ -93,5 +93,5 @@ update b/b
     "platform-dev": []
 }
 --EXPECT--
-Updating a/a (dev-master oldmaster-a) to a/a (dev-master newmaster-a)
-Updating b/b (dev-master oldmaster-b) to b/b (dev-master newmaster-b2)
+Upgrading a/a (dev-master oldmaster-a => dev-master newmaster-a)
+Upgrading b/b (dev-master oldmaster-b => dev-master newmaster-b2)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-from-lock.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-from-lock.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-from-lock.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-from-lock.test	2021-01-27 15:09:27.000000000 +0000
@@ -21,7 +21,8 @@ Partial update from lock file should upd
     "require": {
         "a/old": "*",
         "b/unstable": "*",
-        "c/uptodate": "*"
+        "c/uptodate": "*",
+        "e/newreq": "*"
     }
 }
 --LOCK--
@@ -60,7 +61,6 @@ update b/unstable
         { "name": "a/old", "version": "1.0.0", "type": "library" },
         { "name": "b/unstable", "version": "1.0.0", "type": "library", "require": {"f/dependency": "1.*"} },
         { "name": "c/uptodate", "version": "1.0.0", "type": "library" },
-        { "name": "d/removed", "version": "1.0.0", "type": "library" },
         { "name": "e/newreq", "version": "1.0.0", "type": "library" },
         { "name": "f/dependency", "version": "1.0.0", "type": "library" }
     ],
@@ -74,8 +74,7 @@ update b/unstable
     "platform-dev": []
 }
 --EXPECT--
-Downgrading b/unstable (1.1.0-alpha) to b/unstable (1.0.0)
-Updating a/old (0.9.0) to a/old (1.0.0)
-Downgrading c/uptodate (2.0.0) to c/uptodate (1.0.0)
-Installing d/removed (1.0.0)
+Upgrading a/old (0.9.0 => 1.0.0)
+Downgrading b/unstable (1.1.0-alpha => 1.0.0)
+Downgrading c/uptodate (2.0.0 => 1.0.0)
 Installing e/newreq (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-from-lock-with-root-alias.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-from-lock-with-root-alias.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-from-lock-with-root-alias.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-from-lock-with-root-alias.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,77 @@
+--TEST--
+Partial update from lock file with root aliases should work
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "a/dep", "version": "1.0.0", "require": { "c/aliased": "2.0.0" } },
+                { "name": "b/dep", "version": "1.0.0", "require": { "c/aliased": "1.0.0" } },
+                { "name": "c/aliased", "version": "1.0.0" },
+                { "name": "c/aliased", "version": "2.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "a/dep": "*",
+        "b/dep": "*",
+        "c/aliased": "1.0.0 as 2.0.0"
+    }
+}
+--LOCK--
+{
+    "packages": [
+        { "name": "a/dep", "version": "1.0.0", "require": { "c/aliased": "2.0.0" } },
+        { "name": "b/dep", "version": "1.0.0", "require": { "c/aliased": "1.0.0" } },
+        { "name": "c/aliased", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [
+        {
+            "package": "c/aliased",
+            "version": "1.0.0.0",
+            "alias": "2.0.0",
+            "alias_normalized": "2.0.0.0"
+        }
+    ],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--INSTALLED--
+[
+    { "name": "a/dep", "version": "1.0.0", "require": { "c/aliased": "2.0.0" } },
+    { "name": "b/dep", "version": "1.0.0", "require": { "c/aliased": "1.0.0" } },
+    { "name": "c/aliased", "version": "1.0.0" }
+]
+--RUN--
+update --lock
+--EXPECT-LOCK--
+{
+    "packages": [
+        { "name": "a/dep", "version": "1.0.0", "require": { "c/aliased": "2.0.0" }, "type": "library" },
+        { "name": "b/dep", "version": "1.0.0", "require": { "c/aliased": "1.0.0" }, "type": "library" },
+        { "name": "c/aliased", "version": "1.0.0", "type": "library" }
+    ],
+    "packages-dev": [],
+    "aliases": [
+        {
+            "package": "c/aliased",
+            "version": "1.0.0.0",
+            "alias": "2.0.0",
+            "alias_normalized": "2.0.0.0"
+        }
+    ],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT--
+Marking c/aliased (2.0.0) as installed, alias of c/aliased (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-installs-from-lock-even-missing.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-installs-from-lock-even-missing.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-installs-from-lock-even-missing.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-installs-from-lock-even-missing.test	2021-01-27 15:09:27.000000000 +0000
@@ -97,9 +97,9 @@ update b/b
     "platform-dev": []
 }
 --EXPECT--
-Updating a/a (dev-master oldmaster-a) to a/a (dev-master newmaster-a)
-Updating b/b (dev-master oldmaster-b) to b/b (dev-master newmaster-b2)
+Marking a/a (2.1.x-dev oldmaster-a) as uninstalled, alias of a/a (dev-master oldmaster-a)
+Marking b/b (2.1.x-dev oldmaster-b) as uninstalled, alias of b/b (dev-master oldmaster-b)
+Upgrading a/a (dev-master oldmaster-a => dev-master newmaster-a)
 Marking a/a (2.2.x-dev newmaster-a) as installed, alias of a/a (dev-master newmaster-a)
+Upgrading b/b (dev-master oldmaster-b => dev-master newmaster-b2)
 Marking b/b (2.3.x-dev newmaster-b2) as installed, alias of b/b (dev-master newmaster-b2)
-Marking b/b (2.1.x-dev oldmaster-b) as uninstalled, alias of b/b (dev-master oldmaster-b)
-Marking a/a (2.1.x-dev oldmaster-a) as uninstalled, alias of a/a (dev-master oldmaster-a)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-keeps-older-dep-if-still-required.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-keeps-older-dep-if-still-required.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-keeps-older-dep-if-still-required.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-keeps-older-dep-if-still-required.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,65 @@
+--TEST--
+Ensure that a partial update of a dependency does not conflict if the only way to proceed is using an old locked version.
+
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {"name": "root/req1", "version": "1.0.0", "require": {"dep/pkg1": "1.*"}},
+                {"name": "root/req2", "version": "1.0.0", "require": {"dep/pkg2": "1.*"}},
+                {"name": "dep/pkg1", "version": "1.0.0"},
+                {"name": "dep/pkg1", "version": "2.0.0"},
+                {"name": "dep/pkg2", "version": "1.0.0"},
+                {"name": "dep/pkg2", "version": "1.0.1"},
+                {"name": "dep/pkg2", "version": "1.2.0", "require": {"dep/pkg1": "2.*"}}
+            ]
+        }
+    ],
+    "require": {
+        "root/req1": "*",
+        "root/req2": "*"
+    }
+}
+--LOCK--
+{
+    "packages": [
+        {"name": "dep/pkg1", "version": "1.0.0", "type": "library"},
+        {"name": "dep/pkg2", "version": "1.0.1", "type": "library"},
+        {"name": "root/req1", "version": "1.0.0", "require": {"dep/pkg1": "1.*"}, "type": "library"},
+        {"name": "root/req2", "version": "1.0.0", "require": {"dep/pkg2": "1.*"}, "type": "library"}
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": {},
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update dep/pkg2 --with-dependencies
+--EXPECT-LOCK--
+{
+    "packages": [
+        {"name": "dep/pkg1", "version": "1.0.0", "type": "library"},
+        {"name": "dep/pkg2", "version": "1.0.1", "type": "library"},
+        {"name": "root/req1", "version": "1.0.0", "require": {"dep/pkg1": "1.*"}, "type": "library"},
+        {"name": "root/req2", "version": "1.0.0", "require": {"dep/pkg2": "1.*"}, "type": "library"}
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT--
+Installing dep/pkg1 (1.0.0)
+Installing root/req1 (1.0.0)
+Installing dep/pkg2 (1.0.1)
+Installing root/req2 (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-keeps-older-dep-if-still-required-with-provide.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-keeps-older-dep-if-still-required-with-provide.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-keeps-older-dep-if-still-required-with-provide.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-keeps-older-dep-if-still-required-with-provide.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,65 @@
+--TEST--
+Ensure that a partial update of a dependency does not conflict if the only way to proceed is using an old locked version.
+
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {"name": "root/req1", "version": "1.0.0", "require": {"virtual/pkg1": "1.*"}},
+                {"name": "root/req2", "version": "1.0.0", "require": {"dep/pkg2": "1.*", "dep/pkg1": "*"}},
+                {"name": "dep/pkg1", "version": "1.0.0", "provide": {"virtual/pkg1": "1.0.0"}},
+                {"name": "dep/pkg1", "version": "2.0.0"},
+                {"name": "dep/pkg2", "version": "1.0.0"},
+                {"name": "dep/pkg2", "version": "1.0.1"},
+                {"name": "dep/pkg2", "version": "1.2.0", "require": {"virtual/pkg1": "2.*"}}
+            ]
+        }
+    ],
+    "require": {
+        "root/req1": "*",
+        "root/req2": "*"
+    }
+}
+--LOCK--
+{
+    "packages": [
+        {"name": "dep/pkg1", "version": "1.0.0", "type": "library", "provide": {"virtual/pkg1": "1.0.0"}},
+        {"name": "dep/pkg2", "version": "1.0.0", "type": "library"},
+        {"name": "root/req1", "version": "1.0.0", "require": {"virtual/pkg1": "1.*"}, "type": "library"},
+        {"name": "root/req2", "version": "1.0.0", "require": {"dep/pkg2": "1.*", "dep/pkg1": "*"}, "type": "library"}
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": {},
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update dep/pkg2 --with-dependencies
+--EXPECT-LOCK--
+{
+    "packages": [
+        {"name": "dep/pkg1", "version": "1.0.0", "type": "library", "provide": {"virtual/pkg1": "1.0.0"}},
+        {"name": "dep/pkg2", "version": "1.0.1", "type": "library"},
+        {"name": "root/req1", "version": "1.0.0", "require": {"virtual/pkg1": "1.*"}, "type": "library"},
+        {"name": "root/req2", "version": "1.0.0", "require": {"dep/pkg2": "1.*", "dep/pkg1": "*"}, "type": "library"}
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT--
+Installing dep/pkg1 (1.0.0)
+Installing root/req1 (1.0.0)
+Installing dep/pkg2 (1.0.1)
+Installing root/req2 (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-without-lock.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-without-lock.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/partial-update-without-lock.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/partial-update-without-lock.test	2021-01-27 15:09:27.000000000 +0000
@@ -1,5 +1,5 @@
 --TEST--
-Partial update without lock file should update everything allowed, remove overly unstable packages
+Partial update without lock file should error
 --COMPOSER--
 {
     "repositories": [
@@ -30,22 +30,8 @@ Partial update without lock file should
 ]
 --RUN--
 update b/unstable
---EXPECT-LOCK--
-{
-    "packages": [
-        { "name": "a/old", "version": "1.0.0", "type": "library" },
-        { "name": "b/unstable", "version": "1.0.0", "type": "library" },
-        { "name": "c/uptodate", "version": "1.0.0", "type": "library" },
-        { "name": "d/removed", "version": "1.0.0", "type": "library" }
-    ],
-    "packages-dev": [],
-    "aliases": [],
-    "minimum-stability": "stable",
-    "stability-flags": [],
-    "prefer-stable": false,
-    "prefer-lowest": false,
-    "platform": [],
-    "platform-dev": []
-}
+--EXPECT-OUTPUT--
+Cannot update only a partial set of packages without a lock file present. Run `composer update` to generate a lock file.
+--EXPECT-EXIT-CODE--
+1
 --EXPECT--
-Downgrading b/unstable (1.1.0-alpha) to b/unstable (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/plugins-are-installed-first.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/plugins-are-installed-first.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/plugins-are-installed-first.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/plugins-are-installed-first.test	2021-01-27 15:09:27.000000000 +0000
@@ -6,26 +6,26 @@ Composer installers and their requiremen
         {
             "type": "package",
             "package": [
-                { "name": "pkg", "version": "1.0.0" },
-                { "name": "pkg2", "version": "1.0.0" },
-                { "name": "inst", "version": "1.0.0", "type": "composer-plugin" },
-                { "name": "inst-with-req", "version": "1.0.0", "type": "composer-plugin", "require": { "php": ">=5", "ext-json": "*", "composer-plugin-api": "*" } },
-                { "name": "inst-with-req2", "version": "1.0.0", "type": "composer-plugin", "require": { "pkg2": "*" } }
+                { "name": "pkg/1", "version": "1.0.0" },
+                { "name": "pkg/2", "version": "1.0.0" },
+                { "name": "inst/pkg", "version": "1.0.0", "type": "composer-plugin" },
+                { "name": "inst/with-req", "version": "1.0.0", "type": "composer-plugin", "require": { "php": ">=5", "ext-json": "*", "composer-plugin-api": "*" } },
+                { "name": "inst/with-req2", "version": "1.0.0", "type": "composer-plugin", "require": { "pkg/2": "*" } }
             ]
         }
     ],
     "require": {
-        "pkg": "1.0.0",
-        "inst": "1.0.0",
-        "inst-with-req2": "1.0.0",
-        "inst-with-req": "1.0.0"
+        "pkg/1": "1.0.0",
+        "inst/pkg": "1.0.0",
+        "inst/with-req2": "1.0.0",
+        "inst/with-req": "1.0.0"
     }
 }
 --RUN--
 install
 --EXPECT--
-Installing inst (1.0.0)
-Installing inst-with-req (1.0.0)
-Installing pkg2 (1.0.0)
-Installing inst-with-req2 (1.0.0)
-Installing pkg (1.0.0)
+Installing inst/pkg (1.0.0)
+Installing inst/with-req (1.0.0)
+Installing pkg/2 (1.0.0)
+Installing inst/with-req2 (1.0.0)
+Installing pkg/1 (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/prefer-lowest-branches.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/prefer-lowest-branches.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/prefer-lowest-branches.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/prefer-lowest-branches.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,29 @@
+--TEST--
+Assert that prefer-lowest can not pick the lowest version of all packages when two branches are valid but conflict with each other
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {"name": "req/pkg", "version": "1.0.0", "require": {"req/pkg2": "^1.2"}},
+                {"name": "req/pkg2", "version": "1.0.0", "require": {"req/pkg": "^1.2"}},
+                {"name": "req/pkg", "version": "1.2.0", "require": {"req/pkg2": "^1.0"}},
+                {"name": "req/pkg2", "version": "1.2.0", "require": {"req/pkg": "^1.0"}},
+                {"name": "req/pkg", "version": "1.4.0", "require": {"req/pkg2": "^1.0"}},
+                {"name": "req/pkg2", "version": "1.4.0", "require": {"req/pkg": "^1.0"}}
+            ]
+        }
+    ],
+    "require": {
+        "req/pkg": "*",
+        "req/pkg2": "*"
+    }
+}
+
+--RUN--
+update --prefer-lowest
+
+--EXPECT--
+Installing req/pkg2 (1.2.0)
+Installing req/pkg (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/problems-reduce-versions.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/problems-reduce-versions.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/problems-reduce-versions.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/problems-reduce-versions.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,118 @@
+--TEST--
+Test the error output minifies version lists
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {"name": "a/a", "version": "1.0.0", "require": {"b/b": "1.0.0"}},
+                {"name": "b/b", "version": "1.0.0"},
+                {"name": "b/b", "version": "1.0.1"},
+                {"name": "b/b", "version": "1.0.2"},
+                {"name": "b/b", "version": "1.0.3"},
+                {"name": "b/b", "version": "v1.1.4"},
+                {"name": "b/b", "version": "1.0.4"},
+                {"name": "b/b", "version": "1.0.5"},
+                {"name": "b/b", "version": "1.0.6"},
+                {"name": "b/b", "version": "1.0.7"},
+                {"name": "b/b", "version": "1.1.0"},
+                {"name": "b/b", "version": "2.0.5"},
+                {"name": "b/b", "version": "1.0.8"},
+                {"name": "b/b", "version": "1.0.9"},
+                {"name": "b/b", "version": "1.1.1"},
+                {"name": "b/b", "version": "1.1.2"},
+                {"name": "b/b", "version": "1.1.3"},
+                {"name": "b/b", "version": "1.1.5"},
+                {"name": "b/b", "version": "v1.1.6"},
+                {"name": "b/b", "version": "1.1.7-alpha"},
+                {"name": "b/b", "version": "1.1.8"},
+                {"name": "b/b", "version": "1.1.9"},
+                {"name": "b/b", "version": "1.2.0"},
+                {"name": "b/b", "version": "1.2.2"},
+                {"name": "b/b", "version": "1.2.3"},
+                {"name": "b/b", "version": "1.2.4"},
+                {"name": "b/b", "version": "1.2.5"},
+                {"name": "b/b", "version": "1.2.6"},
+                {"name": "b/b", "version": "1.2.1"},
+                {"name": "b/b", "version": "1.2.7"},
+                {"name": "b/b", "version": "1.2.8"},
+                {"name": "b/b", "version": "1.2.9"},
+                {"name": "b/b", "version": "2.0.0"},
+                {"name": "b/b", "version": "2.0.1"},
+                {"name": "b/b", "version": "2.0.2"},
+                {"name": "b/b", "version": "2.0.3"},
+                {"name": "b/b", "version": "2.0.4"},
+                {"name": "b/b", "version": "2.0.6"},
+                {"name": "b/b", "version": "2.0.7"},
+                {"name": "b/b", "version": "2.0.8"},
+                {"name": "b/b", "version": "2.0.9"},
+                {"name": "b/b", "version": "2.1.0"},
+                {"name": "b/b", "version": "2.1.1"},
+                {"name": "b/b", "version": "2.1.2"},
+                {"name": "b/b", "version": "2.1.3"},
+                {"name": "b/b", "version": "2.1.4"},
+                {"name": "b/b", "version": "2.1.5"},
+                {"name": "b/b", "version": "2.1.6"},
+                {"name": "b/b", "version": "2.1.7"},
+                {"name": "b/b", "version": "2.1.8"},
+                {"name": "b/b", "version": "2.1.9"},
+                {"name": "b/b", "version": "2.2.0"},
+                {"name": "b/b", "version": "2.2.1"},
+                {"name": "b/b", "version": "2.2.2"},
+                {"name": "b/b", "version": "2.2.3"},
+                {"name": "b/b", "version": "2.2.4"},
+                {"name": "b/b", "version": "2.2.5"},
+                {"name": "b/b", "version": "2.2.6"},
+                {"name": "b/b", "version": "2.2.7"},
+                {"name": "b/b", "version": "2.2.8"},
+                {"name": "b/b", "version": "2.2.9"},
+                {"name": "b/b", "version": "2.3.0-RC"},
+                {"name": "b/b", "version": "3.0.0"},
+                {"name": "b/b", "version": "3.0.1"},
+                {"name": "b/b", "version": "3.0.2"},
+                {"name": "b/b", "version": "3.0.3"},
+                {"name": "b/b", "version": "4.0.0"}
+            ]
+        }
+    ],
+    "require": {
+        "a/a": "*",
+        "b/b": "^1.1 || ^2.0 || ^3.0"
+    },
+    "minimum-stability": "dev"
+}
+
+--LOCK--
+{
+    "packages": [
+        {"name": "b/b", "version": "1.0.0"}
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+
+--RUN--
+update a/a
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires b/b ^1.1 || ^2.0 || ^3.0, found b/b[1.1.0, ..., 1.2.9, 2.0.0, ..., 2.3.0-RC, 3.0.0, 3.0.1, 3.0.2, 3.0.3] but the package is fixed to 1.0.0 (lock file version) by a partial update and that version does not match. Make sure you list it as an argument for the update command.
+
+Use the option --with-all-dependencies (-W) to allow upgrades, downgrades and removals for packages currently locked to specific versions.
+
+--EXPECT--
+
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-can-coexist-with-other-version-of-provided.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-can-coexist-with-other-version-of-provided.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-can-coexist-with-other-version-of-provided.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-can-coexist-with-other-version-of-provided.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,34 @@
+--TEST--
+Test that providers can coexist with a different version of the package they provide
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "foo/provider",
+                    "provide": {
+                        "foo/original": "3.0.0"
+                    },
+                    "version": "1.0.0"
+                },
+                {
+                    "name": "foo/original",
+                    "version": "1.0.0"
+                }
+            ]
+        }
+    ],
+    "require": {
+        "foo/original": "1.0.0",
+        "foo/provider": "1.0.0"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT--
+Installing foo/original (1.0.0)
+Installing foo/provider (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-conflicts2.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-conflicts2.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-conflicts2.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-conflicts2.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,33 @@
+--TEST--
+Providers of a replaced name should be installable
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "provider/pkg",
+                    "version": "1.0.0",
+                    "provide": { "third/pkg": "2.*" }
+                },
+                {
+                    "name": "replacer/pkg",
+                    "version": "1.0.0",
+                    "replace": { "third/pkg": "2.*" }
+                }
+            ]
+        }
+    ],
+    "require": {
+        "provider/pkg": "*",
+        "replacer/pkg": "*"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT--
+Installing provider/pkg (1.0.0)
+Installing replacer/pkg (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-conflicts3.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-conflicts3.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-conflicts3.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-conflicts3.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,48 @@
+--TEST--
+Test that a replacer can not be installed together with another version of the package it replaces
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {"name": "replacer/pkg", "version": "2.0.0", "replace": { "regular/pkg": "self.version" }},
+                {"name": "replacer/pkg", "version": "2.0.1", "replace": { "regular/pkg": "self.version" }},
+                {"name": "replacer/pkg", "version": "2.0.2", "replace": { "regular/pkg": "self.version" }},
+                {"name": "replacer/pkg", "version": "2.0.3", "replace": { "regular/pkg": "self.version" }},
+                {"name": "regular/pkg", "version": "1.0.0"},
+                {"name": "regular/pkg", "version": "1.0.1"},
+                {"name": "regular/pkg", "version": "1.0.2"},
+                {"name": "regular/pkg", "version": "1.0.3"},
+                {"name": "regular/pkg", "version": "2.0.0"},
+                {"name": "regular/pkg", "version": "2.0.1"}
+            ]
+        }
+    ],
+    "require": {
+        "regular/pkg": "1.*",
+        "replacer/pkg": "2.*"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Conclusion: don't install regular/pkg 1.0.1 (conflict analysis result)
+    - Conclusion: don't install regular/pkg 1.0.2 (conflict analysis result)
+    - Conclusion: don't install regular/pkg 1.0.3 (conflict analysis result)
+    - Only one of these can be installed: regular/pkg[1.0.0, 1.0.1, 1.0.2, 1.0.3], replacer/pkg[2.0.0, 2.0.1, 2.0.2, 2.0.3]. replacer/pkg replaces regular/pkg and thus cannot coexist with it.
+    - Root composer.json requires regular/pkg 1.* -> satisfiable by regular/pkg[1.0.0, 1.0.1, 1.0.2, 1.0.3].
+    - Root composer.json requires replacer/pkg 2.* -> satisfiable by replacer/pkg[2.0.0, 2.0.1, 2.0.2, 2.0.3].
+
+--EXPECT--
+
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-conflicts.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-conflicts.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-conflicts.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-conflicts.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,49 @@
+--TEST--
+Test that names provided by a dependent and root package cause a conflict only for replace
+--COMPOSER--
+{
+    "version": "1.2.3",
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "provider/pkg",
+                    "version": "1.0.0",
+                    "provide": { "root-provided/transitive-provided": "2.*", "root-replaced/transitive-provided": "2.*" },
+                    "replace": { "root-provided/transitive-replaced": "2.*", "root-replaced/transitive-replaced": "2.*" }
+                }
+            ]
+        }
+    ],
+    "require": {
+        "provider/pkg": "*"
+    },
+    "provide": {
+        "root-provided/transitive-replaced": "2.*",
+        "root-provided/transitive-provided": "2.*"
+    },
+    "replace": {
+        "root-replaced/transitive-replaced": "2.*",
+        "root-replaced/transitive-provided": "2.*"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - __root__ is present at version 1.2.3 and cannot be modified by Composer
+    - provider/pkg[1.0.0] cannot be installed as that would require removing __root__[1.2.3]. They both replace root-replaced/transitive-replaced and thus cannot coexist.
+    - Root composer.json requires provider/pkg * -> satisfiable by provider/pkg[1.0.0].
+
+--EXPECT--
+
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-dev-require-can-satisfy-require.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-dev-require-can-satisfy-require.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-dev-require-can-satisfy-require.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-dev-require-can-satisfy-require.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,52 @@
+--TEST--
+Test that a requirement can be satisfied by a providing package required in require-dev.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {"name": "provider/requirer", "version": "1.0.0", "type": "metapackage", "require": {"b/b": "1.0.0"}},
+                {"name": "b/b", "version": "1.0.0", "type": "metapackage", "provide": {"provided/pkg": "1.0.0"}}
+            ]
+        }
+    ],
+    "require": {
+        "provided/pkg": "1.0.0"
+    },
+    "require-dev": {
+        "provider/requirer": "1.0.0"
+    }
+}
+
+--RUN--
+update --no-dev
+
+--EXPECT-LOCK--
+{
+    "packages": [
+        {
+            "name": "b/b",
+            "version": "1.0.0",
+            "type": "metapackage",
+            "provide": {"provided/pkg": "1.0.0"}
+        }
+    ],
+    "packages-dev": [
+        {
+            "name": "provider/requirer",
+            "version": "1.0.0",
+            "type": "metapackage",
+            "require": {"b/b": "1.0.0"}
+        }
+    ],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT--
+Installing b/b (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-gets-picked-together-with-other-version-of-provided-conflict.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-gets-picked-together-with-other-version-of-provided-conflict.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-gets-picked-together-with-other-version-of-provided-conflict.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-gets-picked-together-with-other-version-of-provided-conflict.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,56 @@
+--TEST--
+A root requirement for a name exists as well as a dependency's requirement for the same name but in a different version.
+Since the root requirement does not allow the dependency's requirement to be installed, this conflicts.
+
+The difference between this test and the one which does not conflict is that here the root requirement could only be
+satisfied with the provided package but would conflict with the actual package by the given name.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "foo/provider",
+                    "provide": {
+                        "foo/original": "3.0.0"
+                    },
+                    "version": "1.0.0"
+                },
+                {
+                    "name": "foo/original",
+                    "version": "1.0.0"
+                },
+                {
+                    "name": "foo/requirer",
+                    "require": {
+                        "foo/original": "1.0.0"
+                    },
+                    "version": "1.0.0"
+                }
+            ]
+        }
+    ],
+    "require": {
+        "foo/original": "3.0.0",
+        "foo/provider": "1.0.0",
+        "foo/requirer": "1.0.0"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires foo/requirer 1.0.0 -> satisfiable by foo/requirer[1.0.0].
+    - foo/requirer 1.0.0 requires foo/original 1.0.0 -> found foo/original[1.0.0] but it conflicts with your root composer.json require (3.0.0).
+
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-gets-picked-together-with-other-version-of-provided-indirect.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-gets-picked-together-with-other-version-of-provided-indirect.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-gets-picked-together-with-other-version-of-provided-indirect.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-gets-picked-together-with-other-version-of-provided-indirect.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,54 @@
+--TEST--
+This is a variant of the test provider-gets-picked-together-with-other-version-of-provided-conflict.test which differs
+in so far as that the root requirements were all moved into a package which now allows the combination to succeed.
+
+Only root requirements strictly limit compatibility with versions if a package by a provided name also actually exists.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "foo/root",
+                    "require": {
+                        "foo/original": "3.0.0",
+                        "foo/provider": "1.0.0",
+                        "foo/requirer": "1.0.0"
+                    },
+                    "version": "1.0.0"
+                },
+                {
+                    "name": "foo/provider",
+                    "provide": {
+                        "foo/original": "3.0.0"
+                    },
+                    "version": "1.0.0"
+                },
+                {
+                    "name": "foo/original",
+                    "version": "1.0.0"
+                },
+                {
+                    "name": "foo/requirer",
+                    "require": {
+                        "foo/original": "1.0.0"
+                    },
+                    "version": "1.0.0"
+                }
+            ]
+        }
+    ],
+    "require": {
+        "foo/root": "1.0.0"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT--
+Installing foo/original (1.0.0)
+Installing foo/provider (1.0.0)
+Installing foo/requirer (1.0.0)
+Installing foo/root (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-gets-picked-together-with-other-version-of-provided.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-gets-picked-together-with-other-version-of-provided.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-gets-picked-together-with-other-version-of-provided.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-gets-picked-together-with-other-version-of-provided.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,46 @@
+--TEST--
+A root requirement for a name exists as well as a dependency's requirement for the same name but in a different version.
+The root requirement is satisfied by the actual package by that name in that version. The dependency's requirement can
+be satisfied by another package which provides the name in the other version. This will result in all packages being
+installed as the provider does not conflict with the actual package and all requirements can be met.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "foo/provider",
+                    "provide": {
+                        "foo/original": "3.0.0"
+                    },
+                    "version": "1.0.0"
+                },
+                {
+                    "name": "foo/original",
+                    "version": "1.0.0"
+                },
+                {
+                    "name": "foo/requirer",
+                    "require": {
+                        "foo/original": "3.0.0"
+                    },
+                    "version": "1.0.0"
+                }
+            ]
+        }
+    ],
+    "require": {
+        "foo/original": "1.0.0",
+        "foo/provider": "1.0.0",
+        "foo/requirer": "1.0.0"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT--
+Installing foo/original (1.0.0)
+Installing foo/provider (1.0.0)
+Installing foo/requirer (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-packages-can-be-installed-if-selected.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-packages-can-be-installed-if-selected.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-packages-can-be-installed-if-selected.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-packages-can-be-installed-if-selected.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,36 @@
+--TEST--
+Test that providers can be installed if they are selected and the package they provide is not installable
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "foo/polyfill",
+                    "provide": {
+                        "foo/standard": "1.0.0"
+                    },
+                    "version": "1.0.0"
+                },
+                {
+                    "name": "foo/standard",
+                    "require": {
+                        "foo/does-not-exist": "1.0.0"
+                    },
+                    "version": "1.0.0"
+                }
+            ]
+        }
+    ],
+    "require": {
+        "foo/standard": "1.0.0",
+        "foo/polyfill": "1.0.0"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT--
+Installing foo/polyfill (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-packages-can-be-installed-together-with-provided-if-both-installable.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-packages-can-be-installed-together-with-provided-if-both-installable.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-packages-can-be-installed-together-with-provided-if-both-installable.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-packages-can-be-installed-together-with-provided-if-both-installable.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,38 @@
+--TEST--
+Test that providers can be installed in conjunction with the package they provide if they are selected and the package they provide is also installable
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "foo/polyfill",
+                    "provide": {
+                        "foo/standard": "1.0.0"
+                    },
+                    "version": "1.0.0"
+                },
+                {
+                    "name": "foo/standard",
+                    "version": "1.0.0",
+                    "provide": {
+                        "foo/also-necessary": "1.0.0"
+                    }
+                }
+            ]
+        }
+    ],
+    "require": {
+        "foo/also-necessary": "1.0.0",
+        "foo/standard": "1.0.0",
+        "foo/polyfill": "1.0.0"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT--
+Installing foo/polyfill (1.0.0)
+Installing foo/standard (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-packages-can-not-be-installed-unless-selected.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-packages-can-not-be-installed-unless-selected.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-packages-can-not-be-installed-unless-selected.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-packages-can-not-be-installed-unless-selected.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,55 @@
+--TEST--
+Test that providers can not be installed if they are not selected
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "foo/polyfill",
+                    "provide": {
+                        "foo/standard": "1.0.0"
+                    },
+                    "version": "1.0.0"
+                },
+                {
+                    "name": "foo/standard",
+                    "require": {
+                        "foo/does-not-exist": "1.0.0"
+                    },
+                    "version": "1.0.0"
+                }
+            ]
+        }
+    ],
+    "require": {
+        "foo/standard": "1.0.0"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires foo/standard 1.0.0 -> satisfiable by foo/standard[1.0.0].
+    - foo/standard 1.0.0 requires foo/does-not-exist 1.0.0 -> could not be found in any version, there may be a typo in the package name.
+
+Potential causes:
+ - A typo in the package name
+ - The package is not available in a stable-enough version according to your minimum-stability setting
+   see <https://getcomposer.org/doc/04-schema.md#minimum-stability> for more details.
+ - It's a private package and you forgot to add a custom repository to find it
+
+Read <https://getcomposer.org/doc/articles/troubleshooting.md> for further common problems.
+
+--EXPECT--
+
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-satisfies-its-own-requirement.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-satisfies-its-own-requirement.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/provider-satisfies-its-own-requirement.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/provider-satisfies-its-own-requirement.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,25 @@
+--TEST--
+Test that a package requiring something it provides itself, satisfies itself even though a package exists.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": {
+                "name": "provided/pkg",
+                "version": "1.0.0"
+            }
+        }
+    ],
+    "require": {
+        "provided/pkg": "1.0.0"
+    },
+    "provide": {
+        "provided/pkg": "1.0.0"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/remove-deletes-unused-deps.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/remove-deletes-unused-deps.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/remove-deletes-unused-deps.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/remove-deletes-unused-deps.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,46 @@
+--TEST--
+Removing a package deletes unused dependencies and does not update other dependencies
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "root/a", "version": "1.0.0", "require": { "dep/c": "*", "dep/d": "*"} },
+                { "name": "remove/b", "version": "1.0.0", "require": { "dep/c": "*", "dep/e": "*"} },
+                { "name": "dep/c", "version": "1.0.0" },
+                { "name": "dep/c", "version": "1.2.0" },
+                { "name": "dep/d", "version": "1.0.0" },
+                { "name": "dep/d", "version": "1.2.0" },
+                { "name": "dep/e", "version": "1.0.0" },
+                { "name": "unrelated/f", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "root/a": "*"
+    }
+}
+--LOCK--
+{
+    "packages": [
+        { "name": "root/a", "version": "1.0.0", "require": { "dep/c": "*", "dep/d": "*"} },
+        { "name": "remove/b", "version": "1.0.0", "require": { "dep/c": "*", "dep/e": "*"} },
+        { "name": "dep/c", "version": "1.0.0" },
+        { "name": "dep/d", "version": "1.0.0" },
+        { "name": "dep/e", "version": "1.0.0" },
+        { "name": "unrelated/f", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false
+}
+--RUN--
+update remove/b
+--EXPECT--
+Installing dep/d (1.0.0)
+Installing dep/c (1.0.0)
+Installing root/a (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/remove-does-nothing-if-removal-requires-update-of-dep.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/remove-does-nothing-if-removal-requires-update-of-dep.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/remove-does-nothing-if-removal-requires-update-of-dep.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/remove-does-nothing-if-removal-requires-update-of-dep.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,39 @@
+--TEST--
+Removing a package has no effect if another package would require an update in order to find a correct set of dependencies without the removed package
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "root/a", "version": "1.0.0", "require": { "remove/b": "*", "dep/c": "*"} },
+                { "name": "remove/b", "version": "1.0.0", "require": { "dep/c": "*"} },
+                { "name": "dep/c", "version": "1.0.0" },
+                { "name": "dep/c", "version": "1.2.0", "replace": { "remove/b": "1.0.0"} }
+            ]
+        }
+    ],
+    "require": {
+        "root/a": "*"
+    }
+}
+--LOCK--
+{
+    "packages": [
+        { "name": "root/a", "version": "1.0.0", "require": { "remove/b": "*", "dep/c": "*"} },
+        { "name": "remove/b", "version": "1.0.0", "require": { "dep/c": "*"} },
+        { "name": "dep/c", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false
+}
+--RUN--
+update remove/b
+--EXPECT--
+Installing dep/c (1.0.0)
+Installing remove/b (1.0.0)
+Installing root/a (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/replace-priorities.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/replace-priorities.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/replace-priorities.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/replace-priorities.test	2021-01-27 15:09:27.000000000 +0000
@@ -6,28 +6,28 @@ Replace takes precedence only in higher
         {
             "type": "package",
             "package": [
-                { "name": "forked", "version": "1.1.0", "replace": { "package2": "1.1.0" } }
+                { "name": "forked/pkg", "version": "1.1.0", "replace": { "package/2": "1.1.0" } }
             ]
         },
         {
             "type": "package",
             "package": [
-                { "name": "package", "version": "1.0.0" },
-                { "name": "package2", "version": "1.0.0" },
-                { "name": "package3", "version": "1.0.0", "require": { "forked": "*" } },
-                { "name": "hijacker", "version": "1.1.0", "replace": { "package": "1.1.0" } }
+                { "name": "package/1", "version": "1.0.0" },
+                { "name": "package/2", "version": "1.0.0" },
+                { "name": "package/3", "version": "1.0.0", "require": { "forked/pkg": "*" } },
+                { "name": "hijacker/pkg", "version": "1.1.0", "replace": { "package/1": "1.1.0" } }
             ]
         }
     ],
     "require": {
-        "package": "1.*",
-        "package2": "1.*",
-        "package3": "1.*"
+        "package/1": "1.*",
+        "package/2": "1.*",
+        "package/3": "1.*"
     }
 }
 --RUN--
 install
 --EXPECT--
-Installing package (1.0.0)
-Installing forked (1.1.0)
-Installing package3 (1.0.0)
+Installing package/1 (1.0.0)
+Installing forked/pkg (1.1.0)
+Installing package/3 (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/replace-range-require-single-version.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/replace-range-require-single-version.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/replace-range-require-single-version.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/replace-range-require-single-version.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,30 @@
+--TEST--
+Verify replacing an unbound range and requiring a single version works as well as vice versa.
+
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "a/a", "version": "1.0.1", "replace": {"c/c": ">2.0" }},
+                { "name": "b/b", "version": "1.0.2", "require": {"c/c": "2.1.2" }},
+                { "name": "d/d", "version": "1.0.3", "replace": {"f/f": "2.1.2" }},
+                { "name": "e/e", "version": "1.0.4", "require": {"f/f": ">2.0" }}
+            ]
+        }
+    ],
+    "require": {
+        "a/a": "1.0.1",
+        "b/b": "1.0.2",
+        "d/d": "1.0.3",
+        "e/e": "1.0.4"
+    }
+}
+--RUN--
+update
+--EXPECT--
+Installing a/a (1.0.1)
+Installing b/b (1.0.2)
+Installing d/d (1.0.3)
+Installing e/e (1.0.4)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/replacer-satisfies-its-own-requirement.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/replacer-satisfies-its-own-requirement.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/replacer-satisfies-its-own-requirement.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/replacer-satisfies-its-own-requirement.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,25 @@
+--TEST--
+Test that a package requiring something it replaces itself, satisfies itself even though a package exists.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": {
+                "name": "replaced/pkg",
+                "version": "1.0.0"
+            }
+        }
+    ],
+    "require": {
+        "replaced/pkg": "1.0.0"
+    },
+    "replace": {
+        "replaced/pkg": "1.0.0"
+    }
+}
+
+--RUN--
+update
+
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/repositories-priorities2.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/repositories-priorities2.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/repositories-priorities2.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/repositories-priorities2.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,26 @@
+--TEST--
+Packages found in a higher priority repository take precedence
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "foo/a", "version": "1.0.0" }
+            ]
+        },
+        {
+            "type": "package",
+            "package": [
+                { "name": "foo/a", "version": "1.1.0" }
+            ]
+        }
+    ],
+    "require": {
+        "foo/a": "1.*"
+    }
+}
+--RUN--
+update
+--EXPECT--
+Installing foo/a (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/repositories-priorities3.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/repositories-priorities3.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/repositories-priorities3.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/repositories-priorities3.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,49 @@
+--TEST--
+Test that filter repositories apply correctly
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "foo/a", "version": "1.0.0" }
+            ],
+            "canonical": false
+        },
+        {
+            "type": "package",
+            "package": [
+                { "name": "foo/a", "version": "1.0.0" },
+                { "name": "foo/b", "version": "1.0.0" }
+            ],
+            "only": ["foo/b"]
+        },
+        {
+            "type": "package",
+            "package": [
+                { "name": "foo/a", "version": "1.2.0" },
+                { "name": "foo/c", "version": "1.2.0" }
+            ],
+            "exclude": ["foo/c"]
+        },
+        {
+            "type": "package",
+            "package": [
+                { "name": "foo/a", "version": "1.1.0" },
+                { "name": "foo/b", "version": "1.1.0" },
+                { "name": "foo/c", "version": "1.1.0" }
+            ]
+        }
+    ],
+    "require": {
+        "foo/a": "1.*",
+        "foo/b": "1.*",
+        "foo/c": "1.*"
+    }
+}
+--RUN--
+update
+--EXPECT--
+Installing foo/a (1.2.0)
+Installing foo/b (1.0.0)
+Installing foo/c (1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/repositories-priorities4.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/repositories-priorities4.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/repositories-priorities4.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/repositories-priorities4.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,59 @@
+--TEST--
+Packages found in a higher priority repository take precedence even if they are not found in the requested version case #2
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "ruflin/elastica",
+                    "version": "dev-outdated-branch"
+                }
+            ]
+        },
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "friendsofsymfony/elastica-bundle",
+                    "version": "dev-foobar-master",
+                    "require": {
+                        "ruflin/elastica": "2.*"
+                    }
+                }
+            ]
+        },
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "ruflin/elastica",
+                    "version": "2.0.0"
+                },
+                {
+                    "name": "ruflin/elastica",
+                    "version": "2.0.1"
+                }
+            ]
+        }
+    ],
+    "require": {
+        "friendsofsymfony/elastica-bundle": "dev-foobar-master"
+    }
+}
+
+--RUN--
+update
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires friendsofsymfony/elastica-bundle dev-foobar-master -> satisfiable by friendsofsymfony/elastica-bundle[dev-foobar-master].
+    - friendsofsymfony/elastica-bundle dev-foobar-master requires ruflin/elastica 2.* -> satisfiable by ruflin/elastica[2.0.0, 2.0.1] from package repo (defining 2 packages) but ruflin/elastica[dev-outdated-branch] from package repo (defining 1 package) has higher repository priority. The packages with higher priority do not match your constraint and are therefore not installable. See https://getcomposer.org/repoprio for details and assistance.
+
+--EXPECT--
+--EXPECT-EXIT-CODE--
+2
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/repositories-priorities5.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/repositories-priorities5.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/repositories-priorities5.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/repositories-priorities5.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,35 @@
+--TEST--
+Packages found in a higher priority repository take precedence even if they are not found in the requested version case #3
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "foo/a", "version": "2.0.0-dev" }
+            ]
+        },
+        {
+            "type": "package",
+            "package": [
+                { "name": "foo/a", "version": "2.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "foo/a": "2.*"
+    }
+}
+--RUN--
+update
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires foo/a 2.*, it is satisfiable by foo/a[2.0.0] from package repo (defining 1 package) but foo/a[2.0.0-dev] from package repo (defining 1 package) has higher repository priority. The packages with higher priority do not match your minimum-stability and are therefore not installable. See https://getcomposer.org/repoprio for details and assistance.
+
+--EXPECT--
+--EXPECT-EXIT-CODE--
+2
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/repositories-priorities.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/repositories-priorities.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/repositories-priorities.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/repositories-priorities.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,35 @@
+--TEST--
+Packages found in a higher priority repository take precedence even if they are not found in the requested version
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "foo/a", "version": "1.0.0" }
+            ]
+        },
+        {
+            "type": "package",
+            "package": [
+                { "name": "foo/a", "version": "2.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "foo/a": "2.*"
+    }
+}
+--RUN--
+update
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires foo/a 2.*, it is satisfiable by foo/a[2.0.0] from package repo (defining 1 package) but foo/a[1.0.0] from package repo (defining 1 package) has higher repository priority. The packages with higher priority do not match your constraint and are therefore not installable. See https://getcomposer.org/repoprio for details and assistance.
+
+--EXPECT--
+--EXPECT-EXIT-CODE--
+2
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/root-alias-change-with-circular-dep.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/root-alias-change-with-circular-dep.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/root-alias-change-with-circular-dep.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/root-alias-change-with-circular-dep.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,65 @@
+--TEST--
+Root alias changing after the lock file was created and invalidating it should show a decent error message
+This also checks that an implicit stabilityFlag is added for the root package, if it is a dev version
+--COMPOSER--
+{
+    "name": "root/pkg",
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "b/requirer", "version": "1.0.0",
+                    "require": { "root/pkg": "^1" }
+                }
+            ]
+        }
+    ],
+    "require": {
+        "b/requirer": "*"
+    },
+    "version": "2.x-dev"
+}
+
+--INSTALLED--
+[
+    {
+        "name": "b/requirer", "version": "1.0.0",
+        "require": { "root/pkg": "^1" }
+    }
+]
+
+--LOCK--
+{
+    "packages": [
+        {
+            "name": "b/requirer", "version": "1.0.0",
+            "require": { "root/pkg": "^1" },
+            "type": "library"
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+install
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Installing dependencies from lock file (including require-dev)
+Verifying lock file contents can be installed on current platform.
+Your lock file does not contain a compatible set of packages. Please run composer update.
+
+  Problem 1
+    - b/requirer is locked to version 1.0.0 and an update of this package was not requested.
+    - b/requirer 1.0.0 requires root/pkg ^1 -> found root/pkg[2.x-dev] but it does not match the constraint.
+
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/root-alias-gets-loaded-for-locked-pkgs.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/root-alias-gets-loaded-for-locked-pkgs.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/root-alias-gets-loaded-for-locked-pkgs.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/root-alias-gets-loaded-for-locked-pkgs.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,54 @@
+--TEST--
+Newly defined root alias does not get loaded if package is loaded from lock file
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "some/dep", "version": "dev-main" },
+                { "name": "foo/pkg", "version": "1.0.0", "require": {"some/dep": "^1"} }
+            ]
+        }
+    ],
+    "require": {
+        "some/dep": "dev-main as 1.0.0",
+        "foo/pkg": "^1.0"
+    }
+}
+--LOCK--
+{
+    "packages": [
+        { "name": "some/dep", "version": "dev-main" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--INSTALLED--
+[
+    { "name": "some/dep", "version": "dev-main" }
+]
+--RUN--
+update foo/pkg
+
+--EXPECT-EXIT-CODE--
+2
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Root composer.json requires foo/pkg ^1.0 -> satisfiable by foo/pkg[1.0.0].
+    - foo/pkg 1.0.0 requires some/dep ^1 -> found some/dep[dev-main] but it does not match the constraint.
+
+Use the option --with-all-dependencies (-W) to allow upgrades, downgrades and removals for packages currently locked to specific versions.
+
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/root-requirements-do-not-affect-locked-versions.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/root-requirements-do-not-affect-locked-versions.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/root-requirements-do-not-affect-locked-versions.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/root-requirements-do-not-affect-locked-versions.test	2021-01-27 15:09:27.000000000 +0000
@@ -23,7 +23,7 @@ The locked version will not get overwrit
         { "name": "foo/bar", "version": "1.0.0" },
         { "name": "foo/baz", "version": "2.0.0" }
     ],
-    "packages-dev": null,
+    "packages-dev": [],
     "aliases": [],
     "minimum-stability": "stable",
     "stability-flags": [],
@@ -38,4 +38,4 @@ The locked version will not get overwrit
 --RUN--
 install
 --EXPECT--
-Updating foo/baz (1.0.0) to foo/baz (2.0.0)
+Upgrading foo/baz (1.0.0 => 2.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/solver-problems.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/solver-problems.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/solver-problems.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/solver-problems.test	2021-01-27 15:09:27.000000000 +0000
@@ -6,50 +6,151 @@ Test the error output of solver problems
         {
             "type": "package",
             "package": [
+                { "name": "package/found", "version": "2.0.0", "require": {
+                    "unstable/package2": "2.*"
+                } },
+                { "name": "package/found2", "version": "2.0.0", "require": {
+                    "invalid/💩package": "*"
+                } },
+                { "name": "package/found3", "version": "2.0.0", "require": {
+                    "unstable/package2": "2.*"
+                } },
+                { "name": "package/found4", "version": "2.0.0", "require": {
+                    "non-existent/pkg2": "1.*"
+                } },
+                { "name": "package/found5", "version": "2.0.0", "require": {
+                    "requirer/pkg": "1.*"
+                } },
+                { "name": "package/found6", "version": "2.0.0", "require": {
+                    "stable-requiree-excluded/pkg2": "1.0.1"
+                } },
+                { "name": "package/found7", "version": "2.0.0", "require": {
+                    "php-64bit": "1.0.1"
+                } },
+                { "name": "conflict/requirer", "version": "2.0.0", "require": {
+                    "conflict/dep": "1.0.0"
+                } },
+                { "name": "conflict/requirer2", "version": "2.0.0", "require": {
+                    "conflict/dep": "2.0.0"
+                } },
+                { "name": "conflict/dep", "version": "1.0.0" },
+                { "name": "conflict/dep", "version": "2.0.0" },
                 { "name": "unstable/package", "version": "2.0.0-alpha" },
                 { "name": "unstable/package", "version": "1.0.0" },
-                { "name": "requirer/pkg", "version": "1.0.0", "require": {"dependency/pkg": "1.0.0" } },
+                { "name": "unstable/package2", "version": "2.0.0-alpha" },
+                { "name": "unstable/package2", "version": "1.0.0" },
+                { "name": "requirer/pkg", "version": "1.0.0", "require": {
+                    "dependency/pkg": "1.0.0",
+                    "dependency/unstable-pkg": "1.0.0-dev"
+                } },
                 { "name": "dependency/pkg", "version": "2.0.0" },
                 { "name": "dependency/pkg", "version": "1.0.0" },
+                { "name": "dependency/unstable-pkg", "version": "1.0.0-dev" },
                 { "name": "stable-requiree-excluded/pkg", "version": "1.0.1" },
-                { "name": "stable-requiree-excluded/pkg", "version": "1.0.0" }
+                { "name": "stable-requiree-excluded/pkg", "version": "1.0.0" },
+                { "name": "api/provider", "description": "Provides the missing API", "version": "1.0.0", "provide": { "missing/provided-api": "1.*" } }
             ]
         }
     ],
     "require": {
+        "package/found": "2.*",
+        "package/found2": "2.*",
+        "package/found3": "2.*",
+        "package/found4": "2.*",
+        "package/found5": "2.*",
+        "package/found6": "2.*",
+        "package/found7": "2.*",
+        "missing/provided-api": "2.*",
+        "conflict/requirer": "2.*",
+        "conflict/requirer2": "2.*",
         "unstable/package": "2.*",
-        "bogus/pkg": "1.*",
+        "non-existent/pkg": "1.*",
         "requirer/pkg": "1.*",
         "dependency/pkg": "2.*",
-        "stable-requiree-excluded/pkg": "1.0.1"
+        "stable-requiree-excluded/pkg": "1.0.1",
+        "lib-xml": "1002.*",
+        "lib-icu": "1001.*",
+        "ext-xml": "1002.*",
+        "php": "1"
     }
 }
 
 --INSTALLED--
 [
-    { "name": "stable-requiree-excluded/pkg", "version": "1.0.0" }
+    { "name": "stable-requiree-excluded/pkg", "version": "1.0.0" },
+    { "name": "stable-requiree-excluded/pkg2", "version": "1.0.0" }
 ]
 
+--LOCK--
+{
+    "packages": [
+        { "name": "stable-requiree-excluded/pkg", "version": "1.0.0" },
+        { "name": "stable-requiree-excluded/pkg2", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+
 --RUN--
-update unstable/package requirer/pkg dependency/pkg
+update unstable/package requirer/pkg dependency/pkg conflict/requirer
 
 --EXPECT-EXIT-CODE--
 2
 
 --EXPECT-OUTPUT--
 Loading composer repositories with package information
-Updating dependencies (including require-dev)
+Updating dependencies
 Your requirements could not be resolved to an installable set of packages.
 
   Problem 1
-    - The requested package unstable/package 2.* exists as unstable/package[1.0.0] but these are rejected by your constraint.
+    - Root composer.json requires missing/provided-api 2.*, it could not be found in any version, but the following packages provide it:
+      - api/provider Provides the missing API
+      Consider requiring one of these to satisfy the missing/provided-api requirement.
   Problem 2
-    - The requested package bogus/pkg could not be found in any version, there may be a typo in the package name.
+    - Root composer.json requires unstable/package 2.*, found unstable/package[2.0.0-alpha] but it does not match your minimum-stability.
   Problem 3
-    - The requested package stable-requiree-excluded/pkg (installed at 1.0.0, required as 1.0.1) is satisfiable by stable-requiree-excluded/pkg[1.0.0] but these conflict with your requirements or minimum-stability.
+    - Root composer.json requires non-existent/pkg, it could not be found in any version, there may be a typo in the package name.
   Problem 4
-    - Installation request for requirer/pkg 1.* -> satisfiable by requirer/pkg[1.0.0].
-    - requirer/pkg 1.0.0 requires dependency/pkg 1.0.0 -> satisfiable by dependency/pkg[1.0.0] but these conflict with your requirements or minimum-stability.
+    - Root composer.json requires stable-requiree-excluded/pkg 1.0.1, found stable-requiree-excluded/pkg[1.0.1] but the package is fixed to 1.0.0 (lock file version) by a partial update and that version does not match. Make sure you list it as an argument for the update command.
+  Problem 5
+    - Root composer.json requires linked library lib-xml 1002.* but it has the wrong version installed or is missing from your system, make sure to load the extension providing it.
+  Problem 6
+    - Root composer.json requires linked library lib-icu 1001.* but it has the wrong version installed, try upgrading the intl extension.
+  Problem 7
+    - Root composer.json requires PHP extension ext-xml 1002.* but it has the wrong version (%s) installed. Install or enable PHP's xml extension.
+  Problem 8
+    - Root composer.json requires php 1 but your php version (%s) does not satisfy that requirement.
+  Problem 9
+    - Root composer.json requires package/found 2.* -> satisfiable by package/found[2.0.0].
+    - package/found 2.0.0 requires unstable/package2 2.* -> found unstable/package2[2.0.0-alpha] but it does not match your minimum-stability.
+  Problem 10
+    - Root composer.json requires package/found2 2.* -> satisfiable by package/found2[2.0.0].
+    - package/found2 2.0.0 requires invalid/💩package * -> could not be found, it looks like its name is invalid, "💩" is not allowed in package names.
+  Problem 11
+    - Root composer.json requires package/found3 2.* -> satisfiable by package/found3[2.0.0].
+    - package/found3 2.0.0 requires unstable/package2 2.* -> found unstable/package2[2.0.0-alpha] but it does not match your minimum-stability.
+  Problem 12
+    - Root composer.json requires package/found4 2.* -> satisfiable by package/found4[2.0.0].
+    - package/found4 2.0.0 requires non-existent/pkg2 1.* -> could not be found in any version, there may be a typo in the package name.
+  Problem 13
+    - Root composer.json requires package/found6 2.* -> satisfiable by package/found6[2.0.0].
+    - package/found6 2.0.0 requires stable-requiree-excluded/pkg2 1.0.1 -> found stable-requiree-excluded/pkg2[1.0.0] but it does not match the constraint.
+  Problem 14
+    - Root composer.json requires package/found7 2.* -> satisfiable by package/found7[2.0.0].
+    - package/found7 2.0.0 requires php-64bit 1.0.1 -> your php-64bit version (%s) does not satisfy that requirement.
+  Problem 15
+    - Root composer.json requires requirer/pkg 1.* -> satisfiable by requirer/pkg[1.0.0].
+    - requirer/pkg 1.0.0 requires dependency/pkg 1.0.0 -> found dependency/pkg[1.0.0] but it conflicts with your root composer.json require (2.*).
+  Problem 16
+    - requirer/pkg 1.0.0 requires dependency/pkg 1.0.0 -> found dependency/pkg[1.0.0] but it conflicts with your root composer.json require (2.*).
+    - package/found5 2.0.0 requires requirer/pkg 1.* -> satisfiable by requirer/pkg[1.0.0].
+    - Root composer.json requires package/found5 2.* -> satisfiable by package/found5[2.0.0].
 
 Potential causes:
  - A typo in the package name
@@ -59,5 +160,11 @@ Potential causes:
 
 Read <https://getcomposer.org/doc/articles/troubleshooting.md> for further common problems.
 
+To enable extensions, verify that they are enabled in your .ini files:
+__inilist__
+You can also run `php --ini` inside terminal to see which files are used by PHP in CLI mode.
+
+Use the option --with-all-dependencies (-W) to allow upgrades, downgrades and removals for packages currently locked to specific versions.
+
 --EXPECT--
 
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/suggest-installed.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/suggest-installed.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/suggest-installed.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/suggest-installed.test	2021-01-27 15:09:27.000000000 +0000
@@ -17,12 +17,16 @@ Suggestions are not displayed for instal
     }
 }
 --RUN--
-install
+update
 --EXPECT-OUTPUT--
 Loading composer repositories with package information
-Updating dependencies (including require-dev)
-Package operations: 2 installs, 0 updates, 0 removals
+Updating dependencies
+Lock file operations: 2 installs, 0 updates, 0 removals
+  - Locking a/a (1.0.0)
+  - Locking b/b (1.0.0)
 Writing lock file
+Installing dependencies from lock file (including require-dev)
+Package operations: 2 installs, 0 updates, 0 removals
 Generating autoload files
 
 --EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/suggest-prod-nolock.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/suggest-prod-nolock.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/suggest-prod-nolock.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/suggest-prod-nolock.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,32 @@
+--TEST--
+Suggestions are displayed even in non-dev mode for new suggesters installed when updating the lock file
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "a/a", "version": "1.0.0", "suggest": { "b/b": "an obscure reason" } }
+            ]
+        }
+    ],
+    "require": {
+        "a/a": "1.0.0"
+    }
+}
+--RUN--
+install --no-dev
+--EXPECT-OUTPUT--
+<warning>No lock file found. Updating dependencies instead of installing from lock file. Use composer update over composer install if you do not have a lock file.</warning>
+Loading composer repositories with package information
+Updating dependencies
+Lock file operations: 1 install, 0 updates, 0 removals
+  - Locking a/a (1.0.0)
+Writing lock file
+Installing dependencies from lock file
+Package operations: 1 install, 0 updates, 0 removals
+1 package suggestions were added by new dependencies, use `composer suggest` to see details.
+Generating autoload files
+
+--EXPECT--
+Installing a/a (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/suggest-prod.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/suggest-prod.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/suggest-prod.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/suggest-prod.test	2021-01-27 15:09:27.000000000 +0000
@@ -1,5 +1,5 @@
 --TEST--
-Suggestions are not displayed in non-dev mode
+Suggestions are not displayed for when not updating the lock file
 --COMPOSER--
 {
     "repositories": [
@@ -14,13 +14,26 @@ Suggestions are not displayed in non-dev
         "a/a": "1.0.0"
     }
 }
+--LOCK--
+{
+    "packages": [
+        { "name": "a/a", "version": "1.0.0", "suggest": { "b/b": "an obscure reason" } }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
 --RUN--
-install --no-dev
+install
 --EXPECT-OUTPUT--
-Loading composer repositories with package information
-Updating dependencies
+Installing dependencies from lock file (including require-dev)
+Verifying lock file contents can be installed on current platform.
 Package operations: 1 install, 0 updates, 0 removals
-Writing lock file
 Generating autoload files
 
 --EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/suggest-replaced.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/suggest-replaced.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/suggest-replaced.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/suggest-replaced.test	2021-01-27 15:09:27.000000000 +0000
@@ -17,12 +17,16 @@ Suggestions are not displayed for packag
     }
 }
 --RUN--
-install
+update
 --EXPECT-OUTPUT--
 Loading composer repositories with package information
-Updating dependencies (including require-dev)
-Package operations: 2 installs, 0 updates, 0 removals
+Updating dependencies
+Lock file operations: 2 installs, 0 updates, 0 removals
+  - Locking a/a (1.0.0)
+  - Locking c/c (1.0.0)
 Writing lock file
+Installing dependencies from lock file (including require-dev)
+Package operations: 2 installs, 0 updates, 0 removals
 Generating autoload files
 
 --EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/suggest-uninstalled.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/suggest-uninstalled.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/suggest-uninstalled.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/suggest-uninstalled.test	2021-01-27 15:09:27.000000000 +0000
@@ -17,11 +17,15 @@ Suggestions are displayed
 --RUN--
 install
 --EXPECT-OUTPUT--
+<warning>No lock file found. Updating dependencies instead of installing from lock file. Use composer update over composer install if you do not have a lock file.</warning>
 Loading composer repositories with package information
-Updating dependencies (including require-dev)
-Package operations: 1 install, 0 updates, 0 removals
-a/a suggests installing b/b (an obscure reason)
+Updating dependencies
+Lock file operations: 1 install, 0 updates, 0 removals
+  - Locking a/a (1.0.0)
 Writing lock file
+Installing dependencies from lock file (including require-dev)
+Package operations: 1 install, 0 updates, 0 removals
+1 package suggestions were added by new dependencies, use `composer suggest` to see details.
 Generating autoload files
 
 --EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/unbounded-conflict-does-not-match-default-branch-with-branch-alias.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/unbounded-conflict-does-not-match-default-branch-with-branch-alias.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/unbounded-conflict-does-not-match-default-branch-with-branch-alias.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/unbounded-conflict-does-not-match-default-branch-with-branch-alias.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,31 @@
+--TEST--
+Test that a conflict against >=5 does not include the default branch if it has a branch alias defined.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "conflicter/pkg", "version": "1.0.0", "conflict": { "victim/pkg": ">=5", "victim/pkg2": ">=5" } },
+                { "name": "victim/pkg", "version": "dev-master", "default-branch": true, "extra": { "branch-alias": { "dev-master": "2.x-dev" } } },
+                { "name": "victim/pkg2", "version": "dev-foo" }
+            ]
+        }
+    ],
+    "require": {
+        "conflicter/pkg": "1.0.0",
+        "victim/pkg": "*",
+        "victim/pkg2": "*"
+    },
+    "minimum-stability": "dev"
+}
+
+
+--RUN--
+update
+
+--EXPECT--
+Installing conflicter/pkg (1.0.0)
+Installing victim/pkg (dev-master)
+Marking victim/pkg (2.x-dev) as installed, alias of victim/pkg (dev-master)
+Installing victim/pkg2 (dev-foo)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/unbounded-conflict-matches-default-branch.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/unbounded-conflict-matches-default-branch.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/unbounded-conflict-matches-default-branch.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/unbounded-conflict-matches-default-branch.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,39 @@
+--TEST--
+Test that a conflict against >=5 includes the default branch if it has no branch alias defined (and then uses the default 9999999-dev alias).
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "conflicter/pkg", "version": "1.0.0", "conflict": { "victim/pkg": ">=5", "victim/pkg2": ">=5" } },
+                { "name": "victim/pkg", "version": "dev-master", "default-branch": true },
+                { "name": "victim/pkg2", "version": "dev-foo" }
+            ]
+        }
+    ],
+    "require": {
+        "conflicter/pkg": "1.0.0",
+        "victim/pkg": "*",
+        "victim/pkg2": "*"
+    },
+    "minimum-stability": "dev"
+}
+
+
+--RUN--
+update
+
+--EXPECT-EXIT-CODE--
+2
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - conflicter/pkg 1.0.0 conflicts with victim/pkg dev-master.
+    - Root composer.json requires conflicter/pkg 1.0.0 -> satisfiable by conflicter/pkg[1.0.0].
+    - Root composer.json requires victim/pkg * -> satisfiable by victim/pkg[dev-master].
+
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-alias-lock2.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-alias-lock2.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-alias-lock2.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-alias-lock2.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,84 @@
+--TEST--
+Updating an aliased package where the old alias matches the new package should not fail
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "a/a", "version": "1.10.x-dev",
+                    "extra": { "branch-alias": { "dev-master": "1.10.x-dev" } },
+                    "source": { "type": "git", "url": "", "reference": "downgradedref" }
+                },
+                {
+                    "name": "a/a", "version": "dev-master",
+                    "extra": { "branch-alias": { "dev-master": "2.x-dev" } },
+                    "source": { "type": "git", "url": "", "reference": "newref" }
+                }
+            ]
+        }
+    ],
+    "require": {
+        "a/a": "^1.0"
+    },
+    "minimum-stability": "dev"
+}
+--LOCK--
+{
+    "_": "outdated lock file, should not have to be loaded in an update",
+    "packages": [
+        {
+            "name": "a/a", "version": "dev-master",
+            "extra": { "branch-alias": { "dev-master": "1.10.x-dev" } },
+            "source": { "type": "git", "url": "", "reference": "installedref" }
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false
+}
+--INSTALLED--
+[
+    {
+        "name": "a/a", "version": "dev-master",
+        "extra": { "branch-alias": { "dev-master": "1.10.x-dev" } },
+        "source": { "type": "git", "url": "", "reference": "installedref" }
+    }
+]
+--RUN--
+update
+--EXPECT-LOCK--
+{
+    "packages": [
+        {
+            "name": "a/a", "version": "1.10.x-dev",
+            "extra": { "branch-alias": { "dev-master": "1.10.x-dev" } },
+            "source": { "type": "git", "url": "", "reference": "downgradedref" },
+            "type": "library"
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT-INSTALLED--
+[
+    {
+        "name": "a/a", "version": "1.10.x-dev",
+        "source": { "type": "git", "url": "", "reference": "downgradedref" },
+        "type": "library",
+        "extra": { "branch-alias": { "dev-master": "1.10.x-dev" } }
+    }
+]
+--EXPECT--
+Marking a/a (1.10.x-dev installedref) as uninstalled, alias of a/a (dev-master installedref)
+Downgrading a/a (dev-master installedref => 1.10.x-dev downgradedref)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-alias-lock.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-alias-lock.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-alias-lock.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-alias-lock.test	2021-01-27 15:09:27.000000000 +0000
@@ -29,20 +29,6 @@ Update aliased package does not mess up
     },
     "minimum-stability": "dev"
 }
---LOCK--
-{
-    "_": "outdated lock file, should not have to be loaded in an update",
-    "packages": [
-        { "package": "a/a", "version": "dev-master", "source-reference": "1234" },
-        { "package": "a/a", "version": "dev-master", "alias-pretty-version": "1.0.x-dev", "alias-version": "1.0.9999999.9999999-dev" }
-    ],
-    "packages-dev": null,
-    "aliases": [],
-    "minimum-stability": "dev",
-    "stability-flags": [],
-    "prefer-stable": false,
-    "prefer-lowest": false
-}
 --INSTALLED--
 [
     {
@@ -73,4 +59,4 @@ update
     "platform-dev": []
 }
 --EXPECT--
-Updating a/a (dev-master 1234) to a/a (dev-master master)
+Upgrading a/a (dev-master 1234 => dev-master master)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-alias.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-alias.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-alias.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-alias.test	2021-01-27 15:09:27.000000000 +0000
@@ -33,5 +33,5 @@ Update aliased package to non-aliased ve
 --RUN--
 update
 --EXPECT--
-Updating a/a (dev-master master) to a/a (dev-foo foo)
-Marking a/a (1.0.x-dev master) as uninstalled, alias of a/a (dev-master master)
\ No newline at end of file
+Marking a/a (1.0.x-dev master) as uninstalled, alias of a/a (dev-master master)
+Upgrading a/a (dev-master master => dev-foo foo)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-all-dry-run.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-all-dry-run.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-all-dry-run.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-all-dry-run.test	2021-01-27 15:09:27.000000000 +0000
@@ -35,6 +35,15 @@ Updates updateable packages in dry-run m
 ]
 --RUN--
 update --dry-run
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Lock file operations: 3 installs, 0 updates, 0 removals
+  - Locking a/a (1.0.1)
+  - Locking a/b (2.0.0)
+  - Locking a/c (1.0.0)
+Installing dependencies from lock file (including require-dev)
+Package operations: 0 installs, 2 updates, 0 removals
+  - Upgrading a/a (1.0.0 => 1.0.1)
+  - Upgrading a/b (1.0.0 => 2.0.0)
 --EXPECT--
-Updating a/a (1.0.0) to a/a (1.0.1)
-Updating a/b (1.0.0) to a/b (2.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-locked-require.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-locked-require.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-locked-require.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-locked-require.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,53 @@
+--TEST--
+Update with a package allow list only updates those packages if they are not present in composer.json
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "allowed/pkg", "version": "1.1.0", "require": { "dependency/pkg": "1.1.0", "fixed/dependency": "1.*" } },
+                { "name": "allowed/pkg", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0", "fixed/dependency": "1.*" } },
+                { "name": "dependency/pkg", "version": "1.1.0" },
+                { "name": "dependency/pkg", "version": "1.0.0" },
+                { "name": "fixed/dependency", "version": "1.1.0", "require": { "fixed/sub-dependency": "1.*" } },
+                { "name": "fixed/dependency", "version": "1.0.0", "require": { "fixed/sub-dependency": "1.*" } },
+                { "name": "fixed/sub-dependency", "version": "1.1.0" },
+                { "name": "fixed/sub-dependency", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "allowed/pkg": "1.*",
+        "fixed/dependency": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "allowed/pkg", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0", "fixed/dependency": "1.*" } },
+    { "name": "dependency/pkg", "version": "1.0.0" },
+    { "name": "fixed/dependency", "version": "1.0.0", "require": { "fixed/sub-dependency": "1.*" } },
+    { "name": "fixed/sub-dependency", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "allowed/pkg", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0", "fixed/dependency": "1.*" } },
+        { "name": "dependency/pkg", "version": "1.0.0" },
+        { "name": "fixed/dependency", "version": "1.0.0", "require": { "fixed/sub-dependency": "1.*" } },
+        { "name": "fixed/sub-dependency", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update allowed/pkg dependency/pkg
+--EXPECT--
+Upgrading dependency/pkg (1.0.0 => 1.1.0)
+Upgrading allowed/pkg (1.0.0 => 1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,69 @@
+--TEST--
+Update with a package allow list only updates those corresponding to the pattern
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "vendor/test-package", "version": "2.0" },
+                { "name": "vendor/not-me", "version": "2.0" },
+                { "name": "exact/test-package", "version": "2.0" },
+                { "name": "notexact/testpackage", "version": "2.0" },
+                { "name": "all/package1", "version": "2.0" },
+                { "name": "all/package2", "version": "2.0" },
+                { "name": "another/another", "version": "2.0" },
+                { "name": "no/regexp", "version": "2.0" }
+            ]
+        }
+    ],
+    "require": {
+        "vendor/test-package": "*.*",
+        "vendor/not-me": "*.*",
+        "exact/test-package": "*.*",
+        "notexact/testpackage": "*.*",
+        "all/package1": "*.*",
+        "all/package2": "*.*",
+        "another/another": "*.*",
+        "no/regexp": "*.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "vendor/test-package", "version": "1.0" },
+    { "name": "vendor/not-me", "version": "1.0" },
+    { "name": "exact/test-package", "version": "1.0" },
+    { "name": "notexact/testpackage", "version": "1.0" },
+    { "name": "all/package1", "version": "1.0" },
+    { "name": "all/package2", "version": "1.0" },
+    { "name": "another/another", "version": "1.0" },
+    { "name": "no/regexp", "version": "1.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "vendor/test-package", "version": "1.0" },
+        { "name": "vendor/not-me", "version": "1.0" },
+        { "name": "exact/test-package", "version": "1.0" },
+        { "name": "notexact/testpackage", "version": "1.0" },
+        { "name": "all/package1", "version": "1.0" },
+        { "name": "all/package2", "version": "1.0" },
+        { "name": "another/another", "version": "1.0" },
+        { "name": "no/regexp", "version": "1.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update vendor/Test* exact/test-package notexact/Test all/* no/reg.?xp
+--EXPECT--
+Upgrading all/package1 (1.0 => 2.0)
+Upgrading all/package2 (1.0 => 2.0)
+Upgrading exact/test-package (1.0 => 2.0)
+Upgrading vendor/test-package (1.0 => 2.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-with-all-dependencies.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-with-all-dependencies.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-with-all-dependencies.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-with-all-dependencies.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,65 @@
+--TEST--
+Update with a package allow list pattern and all-dependencies flag updates packages and their dependencies, even if defined as root dependency, matching the pattern
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "fixed/pkg", "version": "1.1.0" },
+                { "name": "fixed/pkg", "version": "1.0.0" },
+                { "name": "allowed/pkg-component1", "version": "1.1.0" },
+                { "name": "allowed/pkg-component1", "version": "1.0.0" },
+                { "name": "allowed/pkg-component2", "version": "1.1.0", "require": { "dependency/pkg": "1.*" } },
+                { "name": "allowed/pkg-component2", "version": "1.0.0", "require": { "dependency/pkg": "1.*" } },
+                { "name": "dependency/pkg", "version": "1.1.0" },
+                { "name": "dependency/pkg", "version": "1.0.0" },
+                { "name": "unrelated/pkg", "version": "1.1.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg-dependency", "version": "1.1.0" },
+                { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "fixed/pkg": "1.*",
+        "allowed/pkg-component1": "1.*",
+        "allowed/pkg-component2": "1.*",
+        "dependency/pkg": "1.*",
+        "unrelated/pkg": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "fixed/pkg", "version": "1.0.0" },
+    { "name": "allowed/pkg-component1", "version": "1.0.0" },
+    { "name": "allowed/pkg-component2", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+    { "name": "dependency/pkg", "version": "1.0.0" },
+    { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+    { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "fixed/pkg", "version": "1.0.0" },
+        { "name": "allowed/pkg-component1", "version": "1.0.0" },
+        { "name": "allowed/pkg-component2", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+        { "name": "dependency/pkg", "version": "1.0.0" },
+        { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+        { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update allowed/pkg-* --with-all-dependencies
+--EXPECT--
+Upgrading allowed/pkg-component1 (1.0.0 => 1.1.0)
+Upgrading dependency/pkg (1.0.0 => 1.1.0)
+Upgrading allowed/pkg-component2 (1.0.0 => 1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-with-dependencies.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-with-dependencies.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-with-dependencies.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-with-dependencies.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,67 @@
+--TEST--
+Update with a package allow list only updates those packages and their dependencies matching the pattern but no dependencies defined as roo package
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "fixed/pkg", "version": "1.1.0" },
+                { "name": "fixed/pkg", "version": "1.0.0" },
+                { "name": "allowed/pkg-component1", "version": "1.1.0" },
+                { "name": "allowed/pkg-component1", "version": "1.0.0" },
+                { "name": "allowed/pkg-component2", "version": "1.1.0", "require": { "dependency/pkg": "1.*", "root/pkg-dependency": "1.*" } },
+                { "name": "allowed/pkg-component2", "version": "1.0.0", "require": { "dependency/pkg": "1.*", "root/pkg-dependency": "1.*" } },
+                { "name": "dependency/pkg", "version": "1.1.0" },
+                { "name": "dependency/pkg", "version": "1.0.0" },
+                { "name": "root/pkg-dependency", "version": "1.1.0" },
+                { "name": "root/pkg-dependency", "version": "1.0.0" },
+                { "name": "unrelated/pkg", "version": "1.1.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg-dependency", "version": "1.1.0" },
+                { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "fixed/pkg": "1.*",
+        "allowed/pkg-component1": "1.*",
+        "allowed/pkg-component2": "1.*",
+        "root/pkg-dependency": "1.*",
+        "unrelated/pkg": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "fixed/pkg", "version": "1.0.0" },
+    { "name": "allowed/pkg-component1", "version": "1.0.0" },
+    { "name": "allowed/pkg-component2", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+    { "name": "root/pkg-dependency", "version": "1.0.0" },
+    { "name": "dependency/pkg", "version": "1.0.0" },
+    { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+    { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "fixed/pkg", "version": "1.0.0" },
+        { "name": "allowed/pkg-component1", "version": "1.0.0" },
+        { "name": "allowed/pkg-component2", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+        { "name": "root/pkg-dependency", "version": "1.0.0" },
+        { "name": "dependency/pkg", "version": "1.0.0" },
+        { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+        { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": {"a/a":20},
+    "prefer-stable": false,
+    "prefer-lowest": false
+}
+--RUN--
+update allowed/pkg-* --with-dependencies
+--EXPECT--
+Upgrading allowed/pkg-component1 (1.0.0 => 1.1.0)
+Upgrading dependency/pkg (1.0.0 => 1.1.0)
+Upgrading allowed/pkg-component2 (1.0.0 => 1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-without-dependencies.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-without-dependencies.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-without-dependencies.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-without-dependencies.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,61 @@
+--TEST--
+Update with a package allow list only updates those packages matching the pattern
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "fixed/pkg", "version": "1.1.0" },
+                { "name": "fixed/pkg", "version": "1.0.0" },
+                { "name": "allowed/pkg-component1", "version": "1.1.0" },
+                { "name": "allowed/pkg-component1", "version": "1.0.0" },
+                { "name": "allowed/pkg-component2", "version": "1.1.0", "require": { "dependency/pkg": "1.*" } },
+                { "name": "allowed/pkg-component2", "version": "1.0.0", "require": { "dependency/pkg": "1.*" } },
+                { "name": "dependency/pkg", "version": "1.1.0" },
+                { "name": "dependency/pkg", "version": "1.0.0" },
+                { "name": "unrelated/pkg", "version": "1.1.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg-dependency", "version": "1.1.0" },
+                { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "fixed/pkg": "1.*",
+        "allowed/pkg-component1": "1.*",
+        "allowed/pkg-component2": "1.*",
+        "unrelated/pkg": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "fixed/pkg", "version": "1.0.0" },
+    { "name": "allowed/pkg-component1", "version": "1.0.0" },
+    { "name": "allowed/pkg-component2", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+    { "name": "dependency/pkg", "version": "1.0.0" },
+    { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+    { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "fixed/pkg", "version": "1.0.0" },
+        { "name": "allowed/pkg-component1", "version": "1.0.0" },
+        { "name": "allowed/pkg-component2", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+        { "name": "dependency/pkg", "version": "1.0.0" },
+        { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+        { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": {"a/a":20},
+    "prefer-stable": false,
+    "prefer-lowest": false
+}
+--RUN--
+update allowed/pkg-*
+--EXPECT--
+Upgrading allowed/pkg-component1 (1.0.0 => 1.1.0)
+Upgrading allowed/pkg-component2 (1.0.0 => 1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-with-root-dependencies.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-with-root-dependencies.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-with-root-dependencies.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-patterns-with-root-dependencies.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,77 @@
+--TEST--
+Update with a package allow list only updates those packages and their dependencies matching the pattern
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "fixed/pkg", "version": "1.1.0" },
+                { "name": "fixed/pkg", "version": "1.0.0" },
+                { "name": "allowed/pkg-component1", "version": "1.1.0", "require": { "allowed/pkg-component2": "1.1.0" } },
+                { "name": "allowed/pkg-component1", "version": "1.0.0", "require": { "allowed/pkg-component2": "1.0.0" } },
+                { "name": "allowed/pkg-component2", "version": "1.1.0", "require": { "dependency/pkg": "1.1.0", "allowed/pkg-component5": "1.0.0" } },
+                { "name": "allowed/pkg-component2", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+                { "name": "allowed/pkg-component3", "version": "1.1.0", "require": { "allowed/pkg-component4": "1.1.0" } },
+                { "name": "allowed/pkg-component3", "version": "1.0.0", "require": { "allowed/pkg-component4": "1.0.0" } },
+                { "name": "allowed/pkg-component4", "version": "1.1.0" },
+                { "name": "allowed/pkg-component4", "version": "1.0.0" },
+                { "name": "allowed/pkg-component5", "version": "1.1.0" },
+                { "name": "allowed/pkg-component5", "version": "1.0.0" },
+                { "name": "dependency/pkg", "version": "1.1.0" },
+                { "name": "dependency/pkg", "version": "1.0.0" },
+                { "name": "unrelated/pkg", "version": "1.1.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg-dependency", "version": "1.1.0" },
+                { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "fixed/pkg": "1.*",
+        "allowed/pkg-component1": "1.*",
+        "allowed/pkg-component2": "1.*",
+        "allowed/pkg-component3": "1.0.0",
+        "unrelated/pkg": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "fixed/pkg", "version": "1.0.0" },
+    { "name": "allowed/pkg-component1", "version": "1.0.0", "require": { "allowed/pkg-component2": "1.0.0" } },
+    { "name": "allowed/pkg-component2", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+    { "name": "allowed/pkg-component3", "version": "1.0.0", "require": { "allowed/pkg-component4": "1.0.0" } },
+    { "name": "allowed/pkg-component4", "version": "1.0.0" },
+    { "name": "allowed/pkg-component5", "version": "1.0.0" },
+    { "name": "dependency/pkg", "version": "1.0.0" },
+    { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+    { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "fixed/pkg", "version": "1.0.0" },
+        { "name": "allowed/pkg-component1", "version": "1.0.0", "require": { "allowed/pkg-component2": "1.0.0" } },
+        { "name": "allowed/pkg-component2", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+        { "name": "allowed/pkg-component3", "version": "1.0.0", "require": { "allowed/pkg-component4": "1.0.0" } },
+        { "name": "allowed/pkg-component4", "version": "1.0.0" },
+        { "name": "allowed/pkg-component5", "version": "1.0.0" },
+        { "name": "dependency/pkg", "version": "1.0.0" },
+        { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+        { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update allowed/pkg-* foobar --with-dependencies
+--EXPECT--
+Upgrading dependency/pkg (1.0.0 => 1.1.0)
+Upgrading allowed/pkg-component2 (1.0.0 => 1.1.0)
+Upgrading allowed/pkg-component1 (1.0.0 => 1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-reads-lock.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-reads-lock.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-reads-lock.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-reads-lock.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,48 @@
+--TEST--
+Limited update takes rules from lock if available, and not from the installed repo + composer.json
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "toupdate/installed", "version": "1.1.0" },
+                { "name": "toupdate/installed", "version": "1.0.0" },
+                { "name": "toupdate/notinstalled", "version": "1.1.0" },
+                { "name": "toupdate/notinstalled", "version": "1.0.0" },
+                { "name": "old/installed", "version": "0.9.0" },
+                { "name": "old/installed", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "toupdate/installed": "1.*",
+        "toupdate/notinstalled": "1.*",
+        "old/installed": "*"
+    }
+}
+--LOCK--
+{
+    "packages": [
+        { "name": "old/installed", "version": "1.0.0" },
+        { "name": "toupdate/installed", "version": "1.0.0" },
+        { "name": "toupdate/notinstalled", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false
+}
+--INSTALLED--
+[
+    { "name": "toupdate/installed", "version": "1.0.0" },
+    { "name": "old/installed", "version": "0.9.0" }
+]
+--RUN--
+update toupdate/installed
+--EXPECT--
+Upgrading old/installed (0.9.0 => 1.0.0)
+Upgrading toupdate/installed (1.0.0 => 1.1.0)
+Installing toupdate/notinstalled (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-removes-unused.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-removes-unused.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-removes-unused.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-removes-unused.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,48 @@
+--TEST--
+Update with a package allow list removes unused packages
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "allowed/pkg", "version": "1.1.0" },
+                { "name": "allowed/pkg", "version": "1.0.0", "require": { "fixed/dependency": "1.0.0", "old/dependency": "1.0.0" } },
+                { "name": "fixed/dependency", "version": "1.1.0" },
+                { "name": "fixed/dependency", "version": "1.0.0" },
+                { "name": "old/dependency", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "allowed/pkg": "1.*",
+        "fixed/dependency": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "allowed/pkg", "version": "1.0.0", "require": { "old/dependency": "1.0.0", "fixed/dependency": "1.0.0" } },
+    { "name": "fixed/dependency", "version": "1.0.0" },
+    { "name": "old/dependency", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "allowed/pkg", "version": "1.0.0", "require": { "old/dependency": "1.0.0", "fixed/dependency": "1.0.0" } },
+        { "name": "fixed/dependency", "version": "1.0.0" },
+        { "name": "old/dependency", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update --with-dependencies allowed/pkg
+--EXPECT--
+Removing old/dependency (1.0.0)
+Upgrading allowed/pkg (1.0.0 => 1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-require-new-replace.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-require-new-replace.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-require-new-replace.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-require-new-replace.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,44 @@
+--TEST--
+A partial update for a new package yet to be installed should remove another dependency it replaces if that allows installation.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "*" } },
+                { "name": "current/dep", "version": "1.0.0" },
+                { "name": "new/pkg", "version": "1.0.0", "replace": { "current/dep": "1.0.0" } }
+            ]
+        }
+    ],
+    "require": {
+        "current/pkg": "1.*",
+        "new/pkg": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "*" } },
+    { "name": "current/dep", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "*" } },
+        { "name": "current/dep", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update new/pkg
+--EXPECT--
+Removing current/dep (1.0.0)
+Installing new/pkg (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,57 @@
+--TEST--
+Update with a package allow list only updates those packages listed as command arguments
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "fixed/pkg", "version": "1.1.0" },
+                { "name": "fixed/pkg", "version": "1.0.0" },
+                { "name": "allowed/pkg", "version": "1.1.0", "require": { "dependency/pkg": "1.*" } },
+                { "name": "allowed/pkg", "version": "1.0.0", "require": { "dependency/pkg": "1.*" } },
+                { "name": "dependency/pkg", "version": "1.1.0" },
+                { "name": "dependency/pkg", "version": "1.0.0" },
+                { "name": "unrelated/pkg", "version": "1.1.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg-dependency", "version": "1.1.0" },
+                { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "fixed/pkg": "1.*",
+        "allowed/pkg": "1.*",
+        "unrelated/pkg": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "fixed/pkg", "version": "1.0.0" },
+    { "name": "allowed/pkg", "version": "1.0.0", "require": { "dependency": "1.*" } },
+    { "name": "dependency/pkg", "version": "1.0.0" },
+    { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" } },
+    { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "fixed/pkg", "version": "1.0.0" },
+        { "name": "allowed/pkg", "version": "1.0.0", "require": { "dependency/pkg": "1.*" } },
+        { "name": "dependency/pkg", "version": "1.0.0" },
+        { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+        { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update allowed/pkg
+--EXPECT--
+Upgrading allowed/pkg (1.0.0 => 1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-warns-non-existing-patterns.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-warns-non-existing-patterns.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-warns-non-existing-patterns.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-warns-non-existing-patterns.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,58 @@
+--TEST--
+Verify that partial updates warn about using patterns in the argument which have no matches
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "a/a", "version": "1.0.0" },
+                { "name": "b/b", "version": "1.0.0" },
+                { "name": "b/b", "version": "1.1.0" }
+            ]
+        }
+    ],
+    "require": {
+        "a/a": "~1.0",
+        "b/b": "~1.0"
+    }
+}
+
+--INSTALLED--
+[
+    { "name": "a/a", "version": "1.0.0" },
+    { "name": "b/b", "version": "1.0.0" }
+]
+
+--LOCK--
+{
+    "packages": [
+        { "name": "a/a", "version": "1.0.0" },
+        { "name": "b/b", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update b/b foo/bar baz/* --with-dependencies
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+<warning>Package "foo/bar" listed for update is not locked.</warning>
+<warning>Pattern "baz/*" listed for update does not match any locked packages.</warning>
+Updating dependencies
+Lock file operations: 0 installs, 1 update, 0 removals
+  - Upgrading b/b (1.0.0 => 1.1.0)
+Writing lock file
+Installing dependencies from lock file (including require-dev)
+Package operations: 0 installs, 1 update, 0 removals
+Generating autoload files
+
+--EXPECT--
+Upgrading b/b (1.0.0 => 1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-alias.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-alias.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-alias.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-alias.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,99 @@
+--TEST--
+Verify that a partial update with deps correctly keeps track of all aliases.
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "<1.2.0" } },
+                { "name": "current/dep", "version": "dev-master", "extra": {"branch-alias": {"dev-master": "1.0.x-dev"}}},
+                { "name": "current/dep", "version": "1.0.0" },
+                { "name": "current/dep", "version": "1.1.0", "require": {"current/dep2": "*"} },
+                { "name": "current/dep", "version": "1.2.0" },
+                { "name": "current/dep2", "version": "dev-foo", "extra": {"branch-alias": {"dev-foo": "1.0.x-dev"}}},
+                { "name": "current/dep2", "version": "dev-master", "extra": {"branch-alias": {"dev-master": "2.x-dev"}}},
+                { "name": "new/pkg", "version": "1.0.0", "require": { "current/dep": "^1.1", "current/dep2": "^1.1"} },
+                { "name": "new/pkg", "version": "1.1.0", "require": { "current/dep": "^1.2" } }
+            ]
+        }
+    ],
+    "require": {
+        "current/dep": "dev-master as 1.1.0",
+        "current/dep2": "dev-master as 1.1.2",
+        "current/pkg": "1.0.0 as 2.0.0",
+        "new/pkg": "1.*"
+    },
+    "minimum-stability": "dev"
+}
+--INSTALLED--
+[
+    { "name": "current/dep", "version": "dev-master", "extra": {"branch-alias": {"dev-master": "1.0.x-dev"}}},
+    { "name": "current/dep2", "version": "dev-foo", "extra": {"branch-alias": {"dev-foo": "1.0.x-dev"}}},
+    { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "<1.2.0" } }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "current/dep", "version": "dev-master", "extra": {"branch-alias": {"dev-master": "1.0.x-dev"}}, "type": "library"},
+        { "name": "current/dep2", "version": "dev-foo", "extra": {"branch-alias": {"dev-foo": "1.0.x-dev"}}, "type": "library"},
+        { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "<1.2.0" } }
+    ],
+    "packages-dev": [],
+    "aliases": [
+        {
+            "alias": "1.1.0",
+            "alias_normalized": "1.1.0.0",
+            "version": "9999999-dev",
+            "package": "current/dep"
+        }
+    ],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update new/pkg --with-all-dependencies
+--EXPECT-LOCK--
+{
+    "packages": [
+        { "name": "current/dep", "version": "dev-master", "extra": {"branch-alias": {"dev-master": "1.0.x-dev"}}, "type": "library"},
+        { "name": "current/dep2", "version": "dev-master", "extra": {"branch-alias": {"dev-master": "2.x-dev"}}, "type": "library"},
+        { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "<1.2.0" }, "type": "library"},
+        { "name": "new/pkg", "version": "1.0.0", "require": { "current/dep": "^1.1", "current/dep2": "^1.1"}, "type": "library"}
+    ],
+    "packages-dev": [],
+    "aliases": [
+        {
+            "alias": "1.1.0",
+            "alias_normalized": "1.1.0.0",
+            "version": "9999999-dev",
+            "package": "current/dep"
+        },
+        {
+            "alias": "1.1.2",
+            "alias_normalized": "1.1.2.0",
+            "version": "9999999-dev",
+            "package": "current/dep2"
+        }
+    ],
+    "minimum-stability": "dev",
+    "stability-flags": {
+        "current/dep": 20,
+        "current/dep2": 20
+    },
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT--
+Marking current/dep2 (1.0.x-dev) as uninstalled, alias of current/dep2 (dev-foo)
+Marking current/dep (1.1.0) as installed, alias of current/dep (dev-master)
+Upgrading current/dep2 (dev-foo => dev-master)
+Marking current/dep2 (1.1.2) as installed, alias of current/dep2 (dev-master)
+Marking current/dep2 (2.x-dev) as installed, alias of current/dep2 (dev-master)
+Installing new/pkg (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-new-requirement.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-new-requirement.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-new-requirement.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-new-requirement.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,49 @@
+--TEST--
+When partially updating a package to a newer version and the new version has a new requirement for a package we already have installed, mark it for update
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "root/pkg1", "version": "1.0.0", "require": { "current/dep": "^1.0" } },
+                { "name": "root/pkg1", "version": "1.2.0", "require": { "current/dep": "^1.0" } },
+                { "name": "current/dep", "version": "1.0.0" },
+                { "name": "current/dep", "version": "1.2.0" },
+                { "name": "root/pkg2", "version": "1.0.0" },
+                { "name": "root/pkg2", "version": "1.2.0", "require": { "current/dep": "^1.2" } }
+            ]
+        }
+    ],
+    "require": {
+        "root/pkg1": "1.*",
+        "root/pkg2": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "root/pkg1", "version": "1.0.0", "require": { "current/dep": "^1.0" } },
+    { "name": "current/dep", "version": "1.0.0" },
+    { "name": "root/pkg2", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "root/pkg1", "version": "1.0.0", "require": { "current/dep": "^1.0" } },
+        { "name": "current/dep", "version": "1.0.0" },
+        { "name": "root/pkg2", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update root/pkg2 --with-dependencies
+--EXPECT--
+Upgrading current/dep (1.0.0 => 1.2.0)
+Upgrading root/pkg2 (1.0.0 => 1.2.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-require-new-replace-mutual.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-require-new-replace-mutual.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-require-new-replace-mutual.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-require-new-replace-mutual.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,51 @@
+--TEST--
+Require a new package in the composer.json and updating with its name as an argument and with-dependencies should remove packages it replaces which are not root requirements
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "current/pkg", "version": "1.0.0", "require": { "mutual/target": "*", "mutual/target-provide": "*" } },
+                { "name": "current/dep", "version": "1.0.0", "replace": { "mutual/target": "1.0.0" } },
+                { "name": "new/pkg", "version": "1.0.0", "replace": { "mutual/target": "1.0.0" } },
+                { "name": "current/dep-provide", "version": "1.0.0", "provide": { "mutual/target-provide": "1.0.0" } },
+                { "name": "new/pkg-provide", "version": "1.0.0", "provide": { "mutual/target-provide": "1.0.0" } }
+            ]
+        }
+    ],
+    "require": {
+        "current/pkg": "1.*",
+        "new/pkg": "1.*",
+        "new/pkg-provide": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "current/pkg", "version": "1.0.0", "require": { "mutual/target": "*" } },
+    { "name": "current/dep", "version": "1.0.0", "replace": { "mutual/target": "1.0.0" } },
+    { "name": "current/dep-provide", "version": "1.0.0", "provide": { "mutual/target-provide": "1.0.0" } }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "current/pkg", "version": "1.0.0", "require": { "mutual/target": "*" } },
+        { "name": "current/dep", "version": "1.0.0", "replace": { "mutual/target": "1.0.0" } },
+        { "name": "current/dep-provide", "version": "1.0.0", "provide": { "mutual/target-provide": "1.0.0" } }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update new/pkg --with-dependencies
+--EXPECT--
+Removing current/dep-provide (1.0.0)
+Removing current/dep (1.0.0)
+Installing new/pkg (1.0.0)
+Installing new/pkg-provide (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-require-new-replace.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-require-new-replace.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-require-new-replace.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-require-new-replace.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,44 @@
+--TEST--
+Require a new package in the composer.json and updating with its name as an argument and with-dependencies should remove packages it replaces which are not root requirements
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "*" } },
+                { "name": "current/dep", "version": "1.0.0" },
+                { "name": "new/pkg", "version": "1.0.0", "replace": { "current/dep": "1.0.0" } }
+            ]
+        }
+    ],
+    "require": {
+        "current/pkg": "1.*",
+        "new/pkg": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "*" } },
+    { "name": "current/dep", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "*" } },
+        { "name": "current/dep", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update new/pkg --with-dependencies
+--EXPECT--
+Removing current/dep (1.0.0)
+Installing new/pkg (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-require-new.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-require-new.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-require-new.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies-require-new.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,48 @@
+--TEST--
+Require a new package in the composer.json and updating with its name as an argument and with-dependencies should update locked dependencies as far as possible
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "<1.2.0" } },
+                { "name": "current/pkg", "version": "1.1.0", "require": { "current/dep": "^1.0" } },
+                { "name": "current/dep", "version": "1.0.0" },
+                { "name": "current/dep", "version": "1.1.0" },
+                { "name": "current/dep", "version": "1.2.0" },
+                { "name": "new/pkg", "version": "1.0.0", "require": { "current/dep": "^1.1" } },
+                { "name": "new/pkg", "version": "1.1.0", "require": { "current/dep": "^1.2" } }
+            ]
+        }
+    ],
+    "require": {
+        "current/pkg": "1.*",
+        "new/pkg": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "<1.2.0" } },
+    { "name": "current/dep", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "current/pkg", "version": "1.0.0", "require": { "current/dep": "<1.2.0" } },
+        { "name": "current/dep", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update new/pkg --with-dependencies
+--EXPECT--
+Upgrading current/dep (1.0.0 => 1.1.0)
+Installing new/pkg (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependencies.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,56 @@
+--TEST--
+Update with a package allow list only updates those packages and their dependencies listed as command arguments
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "fixed/pkg", "version": "1.1.0" },
+                { "name": "fixed/pkg", "version": "1.0.0" },
+                { "name": "allowed/pkg", "version": "1.1.0", "require": { "dependency/pkg": "1.1.0" } },
+                { "name": "allowed/pkg", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+                { "name": "dependency/pkg", "version": "1.1.0" },
+                { "name": "dependency/pkg", "version": "1.0.0" },
+                { "name": "unrelated/pkg", "version": "1.1.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg-dependency", "version": "1.1.0" },
+                { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "fixed/pkg": "1.*",
+        "allowed/pkg": "1.*",
+        "unrelated/pkg": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "fixed/pkg", "version": "1.0.0" },
+    { "name": "allowed/pkg", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+    { "name": "dependency/pkg", "version": "1.0.0" },
+    { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+    { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "fixed/pkg", "version": "1.0.0" },
+        { "name": "allowed/pkg", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+        { "name": "dependency/pkg", "version": "1.0.0" },
+        { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+        { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": {"a/a":20},
+    "prefer-stable": false,
+    "prefer-lowest": false
+}
+--RUN--
+update allowed/pkg --with-dependencies
+--EXPECT--
+Upgrading dependency/pkg (1.0.0 => 1.1.0)
+Upgrading allowed/pkg (1.0.0 => 1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependency-conflict.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependency-conflict.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependency-conflict.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-allow-list-with-dependency-conflict.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,54 @@
+--TEST--
+Update with a package allow list only updates allowed packages if no dependency conflicts
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "fixed/pkg", "version": "1.1.0" },
+                { "name": "fixed/pkg", "version": "1.0.0" },
+                { "name": "allowed/pkg", "version": "1.1.0", "require": { "dependency/pkg": "1.1.0" } },
+                { "name": "allowed/pkg", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+                { "name": "dependency/pkg", "version": "1.1.0" },
+                { "name": "dependency/pkg", "version": "1.0.0" },
+                { "name": "unrelated/pkg", "version": "1.1.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" }  },
+                { "name": "unrelated/pkg-dependency", "version": "1.1.0" },
+                { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "fixed/pkg": "1.*",
+        "allowed/pkg": "1.*",
+        "unrelated/pkg": "1.*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "fixed/pkg", "version": "1.0.0" },
+    { "name": "allowed/pkg", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+    { "name": "dependency/pkg", "version": "1.0.0" },
+    { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+    { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+]
+--LOCK--
+{
+    "packages": [
+        { "name": "fixed/pkg", "version": "1.0.0" },
+        { "name": "allowed/pkg", "version": "1.0.0", "require": { "dependency/pkg": "1.0.0" } },
+        { "name": "dependency/pkg", "version": "1.0.0" },
+        { "name": "unrelated/pkg", "version": "1.0.0", "require": { "unrelated/pkg-dependency": "1.*" } },
+        { "name": "unrelated/pkg-dependency", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": {"a/a":20},
+    "prefer-stable": false,
+    "prefer-lowest": false
+}
+--RUN--
+update allowed/pkg
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-all.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-all.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-all.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-all.test	2021-01-27 15:09:27.000000000 +0000
@@ -36,5 +36,5 @@ Updates updateable packages
 --RUN--
 update
 --EXPECT--
-Updating a/a (1.0.0) to a/a (1.0.1)
-Updating a/b (1.0.0) to a/b (2.0.0)
+Upgrading a/a (1.0.0 => 1.0.1)
+Upgrading a/b (1.0.0 => 2.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-changes-url.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-changes-url.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-changes-url.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-changes-url.test	2021-01-27 15:09:27.000000000 +0000
@@ -3,10 +3,10 @@ Update updates URLs for updated packages
 
 a/a is dev and gets everything updated as it updates to a new ref
 b/b is a tag and gets everything updated by updating the package URL directly
-c/c is a tag and not allowed and gets the new URL but keeps its old ref
+c/c is a tag and not allowlisted and remains unchanged
 d/d is dev but with a #ref so it should get URL updated but not the reference
 e/e is dev and newly installed with a #ref so it should get the correct URL but with the #111 ref
-e/e is dev but not allowed and gets the new URL but keeps its old ref
+f/f is dev but not allowlisted and remains unchanged
 g/g is dev and installed in a different ref than the #ref, so it gets updated and gets the new URL but not the new ref
 --COMPOSER--
 {
@@ -17,7 +17,8 @@ g/g is dev and installed in a different
                 {
                     "name": "a/a", "version": "dev-master",
                     "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/a/newa", "type": "git" },
-                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/a/newa/tarball/2222222222222222222222222222222222222222", "type": "tar", "shasum": "newsum" }
+                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/a/newa/tarball/2222222222222222222222222222222222222222", "type": "tar", "shasum": "newsum" },
+                    "default-branch": true
                 },
                 {
                     "name": "b/b", "version": "2.0.3",
@@ -32,23 +33,27 @@ g/g is dev and installed in a different
                 {
                     "name": "d/d", "version": "dev-master",
                     "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/d/newd", "type": "git" },
-                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/d/newd/tarball/2222222222222222222222222222222222222222", "type": "tar", "shasum": "newsum" }
+                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/d/newd/tarball/2222222222222222222222222222222222222222", "type": "tar", "shasum": "newsum" },
+                    "default-branch": true
                 },
                 {
                     "name": "e/e", "version": "dev-master",
                     "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/e/newe", "type": "git" },
-                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/e/newe/tarball/2222222222222222222222222222222222222222", "type": "tar", "shasum": "newsum" }
+                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/e/newe/tarball/2222222222222222222222222222222222222222", "type": "tar", "shasum": "newsum" },
+                    "default-branch": true
                 },
                 {
                     "name": "f/f", "version": "dev-master",
                     "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/f/newf", "type": "git" },
                     "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/f/newf/tarball/2222222222222222222222222222222222222222", "type": "tar", "shasum": "newsum" },
-                    "transport-options": { "foo": "bar2" }
+                    "transport-options": { "foo": "bar2" },
+                    "default-branch": true
                 },
                 {
                     "name": "g/g", "version": "dev-master",
                     "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/g/newg", "type": "git" },
-                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/g/newg/tarball/2222222222222222222222222222222222222222", "type": "tar", "shasum": "newsum" }
+                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/g/newg/tarball/2222222222222222222222222222222222222222", "type": "tar", "shasum": "newsum" },
+                    "default-branch": true
                 }
             ]
         }
@@ -68,7 +73,8 @@ g/g is dev and installed in a different
     {
         "name": "a/a", "version": "dev-master",
         "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/a/a", "type": "git" },
-        "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/a/a/zipball/1111111111111111111111111111111111111111", "type": "zip", "shasum": "oldsum" }
+        "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/a/a/zipball/1111111111111111111111111111111111111111", "type": "zip", "shasum": "oldsum" },
+        "default-branch": true
     },
     {
         "name": "b/b", "version": "2.0.3",
@@ -83,21 +89,79 @@ g/g is dev and installed in a different
     {
         "name": "d/d", "version": "dev-master",
         "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/d/d", "type": "git" },
-        "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/d/d/zipball/1111111111111111111111111111111111111111", "type": "zip", "shasum": "oldsum" }
+        "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/d/d/zipball/1111111111111111111111111111111111111111", "type": "zip", "shasum": "oldsum" },
+        "default-branch": true
     },
     {
         "name": "f/f", "version": "dev-master",
         "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/f/f", "type": "git" },
         "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/f/f/zipball/1111111111111111111111111111111111111111", "type": "zip", "shasum": "oldsum" },
-        "transport-options": { "foo": "bar" }
+        "transport-options": { "foo": "bar" },
+        "default-branch": true
     },
     {
         "name": "g/g", "version": "dev-master",
         "source": { "reference": "0000000000000000000000000000000000000000", "url": "https://github.com/g/g", "type": "git" },
         "dist": { "reference": "0000000000000000000000000000000000000000", "url": "https://api.github.com/repos/g/g/zipball/0000000000000000000000000000000000000000", "type": "zip", "shasum": "oldsum" },
-        "transport-options": { "foo": "bar" }
+        "transport-options": { "foo": "bar" },
+        "default-branch": true
     }
 ]
+--LOCK--
+{
+    "packages": [
+        {
+            "name": "a/a", "version": "dev-master",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/a/a", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/a/a/zipball/1111111111111111111111111111111111111111", "type": "zip", "shasum": "oldsum" },
+            "type": "library",
+            "default-branch": true
+        },
+        {
+            "name": "b/b", "version": "2.0.3",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/b/b", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/b/b/zipball/1111111111111111111111111111111111111111", "type": "zip", "shasum": "oldsum" },
+            "type": "library"
+        },
+        {
+            "name": "c/c", "version": "1.0.0",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/c/c", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/c/c/zipball/1111111111111111111111111111111111111111", "type": "zip", "shasum": "oldsum" },
+            "type": "library"
+        },
+        {
+            "name": "d/d", "version": "dev-master",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/d/d", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/d/d/zipball/1111111111111111111111111111111111111111", "type": "zip", "shasum": "oldsum" },
+            "type": "library",
+            "default-branch": true
+        },
+        {
+            "name": "f/f", "version": "dev-master",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/f/f", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/f/f/zipball/1111111111111111111111111111111111111111", "type": "zip", "shasum": "oldsum" },
+            "type": "library",
+            "transport-options": { "foo": "bar" },
+            "default-branch": true
+        },
+        {
+            "name": "g/g", "version": "dev-master",
+            "source": { "reference": "0000000000000000000000000000000000000000", "url": "https://github.com/g/g", "type": "git" },
+            "dist": { "reference": "0000000000000000000000000000000000000000", "url": "https://api.github.com/repos/g/g/zipball/0000000000000000000000000000000000000000", "type": "zip", "shasum": "oldsum" },
+            "type": "library",
+            "transport-options": { "foo": "bar" },
+            "default-branch": true
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": {},
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
 --EXPECT-LOCK--
 {
     "packages": [
@@ -105,7 +169,8 @@ g/g is dev and installed in a different
             "name": "a/a", "version": "dev-master",
             "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/a/newa", "type": "git" },
             "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/a/newa/tarball/2222222222222222222222222222222222222222", "type": "tar", "shasum": "newsum" },
-            "type": "library"
+            "type": "library",
+            "default-branch": true
         },
         {
             "name": "b/b", "version": "2.0.3",
@@ -115,34 +180,38 @@ g/g is dev and installed in a different
         },
         {
             "name": "c/c", "version": "1.0.0",
-            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/c/newc", "type": "git" },
-            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/c/newc/tarball/1111111111111111111111111111111111111111", "type": "tar", "shasum": "newsum" },
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/c/c", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/c/c/zipball/1111111111111111111111111111111111111111", "type": "zip", "shasum": "oldsum" },
             "type": "library"
         },
         {
             "name": "d/d", "version": "dev-master",
             "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/d/newd", "type": "git" },
             "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/d/newd/tarball/1111111111111111111111111111111111111111", "type": "tar", "shasum": "newsum" },
-            "type": "library"
+            "type": "library",
+            "default-branch": true
         },
         {
             "name": "e/e", "version": "dev-master",
             "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/e/newe", "type": "git" },
             "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/e/newe/tarball/1111111111111111111111111111111111111111", "type": "tar", "shasum": "newsum" },
-            "type": "library"
+            "type": "library",
+            "default-branch": true
         },
         {
             "name": "f/f", "version": "dev-master",
-            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/f/newf", "type": "git" },
-            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/f/newf/tarball/1111111111111111111111111111111111111111", "type": "tar", "shasum": "newsum" },
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/f/f", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/f/f/zipball/1111111111111111111111111111111111111111", "type": "zip", "shasum": "oldsum" },
             "type": "library",
-            "transport-options": { "foo": "bar2" }
+            "transport-options": { "foo": "bar" },
+            "default-branch": true
         },
         {
             "name": "g/g", "version": "dev-master",
             "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/g/newg", "type": "git" },
             "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/g/newg/tarball/1111111111111111111111111111111111111111", "type": "tar", "shasum": "newsum" },
-            "type": "library"
+            "type": "library",
+            "default-branch": true
         }
     ],
     "packages-dev": [],
@@ -163,6 +232,8 @@ g/g is dev and installed in a different
 --RUN--
 update a/a b/b d/d g/g
 --EXPECT--
+Upgrading a/a (dev-master 1111111 => dev-master 2222222)
+Upgrading b/b (2.0.3 1111111 => 2.0.3 2222222)
 Installing e/e (dev-master 1111111)
-Updating a/a (dev-master 1111111) to a/a (dev-master 2222222)
-Updating g/g (dev-master 0000000) to g/g (dev-master 1111111)
+Marking e/e (9999999-dev 1111111) as installed, alias of e/e (dev-master 1111111)
+Upgrading g/g (dev-master 0000000 => dev-master 1111111)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-dev-ignores-providers.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-dev-ignores-providers.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-dev-ignores-providers.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-dev-ignores-providers.test	2021-01-27 15:09:27.000000000 +0000
@@ -35,4 +35,4 @@ Updating a dev package selects its newes
 --RUN--
 update
 --EXPECT--
-Updating a/installed (dev-master oldref) to a/installed (dev-master newref)
+Upgrading a/installed (dev-master oldref => dev-master newref)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-dev-packages-updates-repo-url.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-dev-packages-updates-repo-url.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-dev-packages-updates-repo-url.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-dev-packages-updates-repo-url.test	2021-01-27 15:09:27.000000000 +0000
@@ -93,4 +93,4 @@ update
     "platform-dev": []
 }
 --EXPECT--
-Updating a/a (dev-master oldmaster) to a/a (dev-master newmaster)
+Upgrading a/a (dev-master oldmaster => dev-master newmaster)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-dev-to-new-ref-picks-up-changes.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-dev-to-new-ref-picks-up-changes.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-dev-to-new-ref-picks-up-changes.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-dev-to-new-ref-picks-up-changes.test	2021-01-27 15:09:27.000000000 +0000
@@ -7,35 +7,39 @@ Updating a dev package to its latest ref
             "type": "package",
             "package": [
                 {
-                    "name": "a/devpackage", "version": "dev-master",
+                    "name": "a/devpackage", "version": "dev-main",
                     "source": { "reference": "newref", "url": "", "type": "git" },
                     "require": {
                         "a/dependency": "*"
-                    }
+                    },
+                    "default-branch": true
                 },
                 {
-                    "name": "a/dependency", "version": "dev-master",
+                    "name": "a/dependency", "version": "dev-main",
                     "source": { "reference": "ref", "url": "", "type": "git" },
-                    "require": {}
+                    "require": {},
+                    "default-branch": true
                 }
             ]
         }
     ],
     "require": {
-        "a/devpackage": "dev-master"
+        "a/devpackage": "dev-main"
     },
     "minimum-stability": "dev"
 }
 --INSTALLED--
 [
     {
-        "name": "a/devpackage", "version": "dev-master",
+        "name": "a/devpackage", "version": "dev-main",
         "source": { "reference": "oldref", "url": "", "type": "git" },
-        "require": {}
+        "require": {},
+        "default-branch": true
     }
 ]
 --RUN--
 update
 --EXPECT--
-Installing a/dependency (dev-master ref)
-Updating a/devpackage (dev-master oldref) to a/devpackage (dev-master newref)
+Installing a/dependency (dev-main ref)
+Marking a/dependency (9999999-dev ref) as installed, alias of a/dependency (dev-main ref)
+Upgrading a/devpackage (dev-main oldref => dev-main newref)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-downgrades-unstable-packages.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-downgrades-unstable-packages.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-downgrades-unstable-packages.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-downgrades-unstable-packages.test	2021-01-27 15:09:27.000000000 +0000
@@ -8,7 +8,8 @@ Downgrading from unstable to more stable
             "package": [
                 {
                     "name": "a/a", "version": "dev-master",
-                    "source": { "reference": "abcd", "url": "", "type": "git" }
+                    "source": { "reference": "abcd", "url": "", "type": "git" },
+                    "default-branch": true
                 },
                 {
                     "name": "a/a", "version": "1.0.0",
@@ -17,7 +18,8 @@ Downgrading from unstable to more stable
                 },
                 {
                     "name": "b/b", "version": "dev-master",
-                    "source": { "reference": "abcd", "url": "", "type": "git" }
+                    "source": { "reference": "abcd", "url": "", "type": "git" },
+                    "default-branch": true
                 },
                 {
                     "name": "b/b", "version": "1.0.0",
@@ -36,14 +38,17 @@ Downgrading from unstable to more stable
 [
     {
         "name": "a/a", "version": "dev-master",
-        "source": { "reference": "abcd", "url": "", "type": "git" }
+        "source": { "reference": "abcd", "url": "", "type": "git" },
+        "default-branch": true
     },
     {
         "name": "b/b", "version": "dev-master",
-        "source": { "reference": "abcd", "url": "", "type": "git" }
+        "source": { "reference": "abcd", "url": "", "type": "git" },
+        "default-branch": true
     }
 ]
 --RUN--
 update
 --EXPECT--
-Downgrading a/a (dev-master abcd) to a/a (1.0.0)
+Marking a/a (9999999-dev abcd) as uninstalled, alias of a/a (dev-master abcd)
+Downgrading a/a (dev-master abcd => 1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-ignore-platform-package-requirements.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-ignore-platform-package-requirements.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-ignore-platform-package-requirements.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-ignore-platform-package-requirements.test	2021-01-27 15:09:27.000000000 +0000
@@ -23,4 +23,4 @@ Update in ignore-platform-reqs mode
 --RUN--
 update --ignore-platform-reqs
 --EXPECT--
-Updating a/a (1.0.0) to a/a (1.0.1)
+Upgrading a/a (1.0.0 => 1.0.1)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-installed-reference.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-installed-reference.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-installed-reference.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-installed-reference.test	2021-01-27 15:09:27.000000000 +0000
@@ -28,3 +28,4 @@ Updating a dev package forcing it's refe
 --RUN--
 update
 --EXPECT--
+Upgrading a/a (dev-master def000 => dev-master )
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-mirrors-changes-url.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-mirrors-changes-url.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-mirrors-changes-url.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-mirrors-changes-url.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,204 @@
+--TEST--
+Update mirrors updates URLs for all packages if they have changed without updating versions
+
+a/a is dev and gets everything updated as it updates to a new ref
+b/b is a tag and gets everything updated by updating the package URL directly
+c/c is a tag and not allowlisted for update and gets the new URL but keeps its old ref
+d/d is dev but with a #ref so it should get URL updated but not the reference
+e/e is dev and newly installed with a #ref so it should get the correct URL but with the #111 ref
+e/e is dev but not allowlisted for update and gets the new URL but keeps its old ref
+g/g is dev and installed in a different ref than the #ref, so it gets updated and gets the new URL but not the new ref
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "a/a", "version": "dev-master",
+                    "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/a/newa", "type": "git" },
+                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/a/newa/zipball/2222222222222222222222222222222222222222", "type": "zip" }
+                },
+                {
+                    "name": "b/b", "version": "2.0.3",
+                    "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/b/newb", "type": "git" },
+                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/b/newb/zipball/2222222222222222222222222222222222222222", "type": "zip" }
+                },
+                {
+                    "name": "c/c", "version": "1.0.0",
+                    "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/c/newc", "type": "git" },
+                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/c/newc/zipball/2222222222222222222222222222222222222222", "type": "zip" }
+                },
+                {
+                    "name": "d/d", "version": "dev-master",
+                    "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/d/newd", "type": "git" },
+                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/d/newd/zipball/2222222222222222222222222222222222222222", "type": "zip" }
+                },
+                {
+                    "name": "e/e", "version": "dev-master",
+                    "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/e/newe", "type": "git" },
+                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/e/newe/zipball/2222222222222222222222222222222222222222", "type": "zip" }
+                },
+                {
+                    "name": "f/f", "version": "dev-master",
+                    "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/f/newf", "type": "git" },
+                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/f/newf/zipball/2222222222222222222222222222222222222222", "type": "zip" }
+                },
+                {
+                    "name": "g/g", "version": "dev-master",
+                    "source": { "reference": "2222222222222222222222222222222222222222", "url": "https://github.com/g/newg", "type": "git" },
+                    "dist": { "reference": "2222222222222222222222222222222222222222", "url": "https://api.github.com/repos/g/newg/zipball/2222222222222222222222222222222222222222", "type": "zip" }
+                }
+            ]
+        }
+    ],
+    "require": {
+        "a/a": "dev-master",
+        "b/b": "2.0.3",
+        "c/c": "1.0.0",
+        "d/d": "dev-master#1111111111111111111111111111111111111111",
+        "e/e": "dev-master#1111111111111111111111111111111111111111",
+        "f/f": "dev-master",
+        "g/g": "dev-master#1111111111111111111111111111111111111111"
+    }
+}
+--INSTALLED--
+[
+    {
+        "name": "a/a", "version": "dev-master",
+        "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/a/a", "type": "git" },
+        "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/a/a/zipball/1111111111111111111111111111111111111111", "type": "zip" }
+    },
+    {
+        "name": "b/b", "version": "2.0.3",
+        "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/b/b", "type": "git" },
+        "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/b/b/zipball/1111111111111111111111111111111111111111", "type": "zip" }
+    },
+    {
+        "name": "c/c", "version": "1.0.0",
+        "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/c/c", "type": "git" },
+        "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/c/c/zipball/1111111111111111111111111111111111111111", "type": "zip" }
+    },
+    {
+        "name": "d/d", "version": "dev-master",
+        "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/d/d", "type": "git" },
+        "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/d/d/zipball/1111111111111111111111111111111111111111", "type": "zip" }
+    },
+    {
+        "name": "f/f", "version": "dev-master",
+        "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/f/f", "type": "git" },
+        "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/f/f/zipball/1111111111111111111111111111111111111111", "type": "zip" }
+    },
+    {
+        "name": "g/g", "version": "dev-master",
+        "source": { "reference": "0000000000000000000000000000000000000000", "url": "https://github.com/g/g", "type": "git" },
+        "dist": { "reference": "0000000000000000000000000000000000000000", "url": "https://api.github.com/repos/g/g/zipball/0000000000000000000000000000000000000000", "type": "zip" }
+    }
+]
+--LOCK--
+{
+    "packages": [
+        {
+            "name": "a/a", "version": "dev-master",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/a/a", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/a/a/zipball/1111111111111111111111111111111111111111", "type": "zip" },
+            "type": "library"
+        },
+        {
+            "name": "b/b", "version": "2.0.3",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/b/b", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/b/b/zipball/1111111111111111111111111111111111111111", "type": "zip" },
+            "type": "library"
+        },
+        {
+            "name": "c/c", "version": "1.0.0",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/c/c", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/c/c/zipball/1111111111111111111111111111111111111111", "type": "zip" },
+            "type": "library"
+        },
+        {
+            "name": "d/d", "version": "dev-master",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/d/d", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/d/d/zipball/1111111111111111111111111111111111111111", "type": "zip" },
+            "type": "library"
+        },
+        {
+            "name": "f/f", "version": "dev-master",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/f/f", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/f/f/zipball/1111111111111111111111111111111111111111", "type": "zip" },
+            "type": "library"
+        },
+        {
+            "name": "g/g", "version": "dev-master",
+            "source": { "reference": "0000000000000000000000000000000000000000", "url": "https://github.com/g/g", "type": "git" },
+            "dist": { "reference": "0000000000000000000000000000000000000000", "url": "https://api.github.com/repos/g/g/zipball/0000000000000000000000000000000000000000", "type": "zip" },
+            "type": "library"
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": {},
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT-LOCK--
+{
+    "packages": [
+        {
+            "name": "a/a", "version": "dev-master",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/a/newa", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/a/newa/zipball/1111111111111111111111111111111111111111", "type": "zip" },
+            "type": "library"
+        },
+        {
+            "name": "b/b", "version": "2.0.3",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/b/newb", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/b/newb/zipball/1111111111111111111111111111111111111111", "type": "zip" },
+            "type": "library"
+        },
+        {
+            "name": "c/c", "version": "1.0.0",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/c/newc", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/c/newc/zipball/1111111111111111111111111111111111111111", "type": "zip" },
+            "type": "library"
+        },
+        {
+            "name": "d/d", "version": "dev-master",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/d/newd", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/d/newd/zipball/1111111111111111111111111111111111111111", "type": "zip" },
+            "type": "library"
+        },
+        {
+            "name": "f/f", "version": "dev-master",
+            "source": { "reference": "1111111111111111111111111111111111111111", "url": "https://github.com/f/newf", "type": "git" },
+            "dist": { "reference": "1111111111111111111111111111111111111111", "url": "https://api.github.com/repos/f/newf/zipball/1111111111111111111111111111111111111111", "type": "zip" },
+            "type": "library"
+        },
+        {
+            "name": "g/g", "version": "dev-master",
+            "source": { "reference": "0000000000000000000000000000000000000000", "url": "https://github.com/g/newg", "type": "git" },
+            "dist": { "reference": "0000000000000000000000000000000000000000", "url": "https://api.github.com/repos/g/newg/zipball/0000000000000000000000000000000000000000", "type": "zip" },
+            "type": "library"
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": {
+        "a/a": 20,
+        "d/d": 20,
+        "e/e": 20,
+        "f/f": 20,
+        "g/g": 20
+    },
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update mirrors
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-mirrors-fails-with-new-req.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-mirrors-fails-with-new-req.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-mirrors-fails-with-new-req.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-mirrors-fails-with-new-req.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,65 @@
+--TEST--
+Update mirrors with a new root require which is not yet in lock should simply ignore it
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {"name": "a/a", "version": "1.0.0"},
+                {"name": "a/a", "version": "1.1.0"},
+                {"name": "b/b", "version": "1.0.0"},
+                {"name": "b/b", "version": "1.1.0"},
+                {"name": "new/req", "version": "1.0.0"},
+                {"name": "new/req", "version": "1.1.0"}
+            ]
+        }
+    ],
+    "require": {
+        "a/a": "1.*",
+        "new/req": "1.*"
+    },
+    "require-dev": {
+        "b/b": "1.*"
+    }
+}
+--INSTALLED--
+[
+    {"name": "a/a", "version": "1.0.0"},
+    {"name": "b/b", "version": "1.0.0"}
+]
+--LOCK--
+{
+    "packages": [
+        {"name": "a/a", "version": "1.0.0", "type": "library"}
+    ],
+    "packages-dev": [
+        {"name": "b/b", "version": "1.0.0", "type": "library"}
+    ],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update mirrors
+--EXPECT-LOCK--
+{
+    "packages": [
+        {"name": "a/a", "version": "1.0.0", "type": "library"}
+    ],
+    "packages-dev": [
+        {"name": "b/b", "version": "1.0.0", "type": "library"}
+    ],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-no-dev-still-resolves-dev.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-no-dev-still-resolves-dev.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-no-dev-still-resolves-dev.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-no-dev-still-resolves-dev.test	2021-01-27 15:09:27.000000000 +0000
@@ -60,9 +60,9 @@ Updates with --no-dev but we still end u
 --RUN--
 update --no-dev
 --EXPECT--
-Uninstalling a/b (1.0.0)
-Updating a/a (1.0.0) to a/a (1.0.1)
-Updating dev/pkg (dev-master old) to dev/pkg (dev-master new)
+Removing a/b (1.0.0)
+Marking dev/pkg (1.0.x-dev old) as uninstalled, alias of dev/pkg (dev-master old)
+Upgrading a/a (1.0.0 => 1.0.1)
 Installing a/c (1.0.0)
+Upgrading dev/pkg (dev-master old => dev-master new)
 Marking dev/pkg (1.1.x-dev new) as installed, alias of dev/pkg (dev-master new)
-Marking dev/pkg (1.0.x-dev old) as uninstalled, alias of dev/pkg (dev-master old)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-no-install.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-no-install.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-no-install.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-no-install.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,64 @@
+--TEST--
+Updates without install updates the lock but not the installed state
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "a/a", "version": "1.0.0" },
+                { "name": "a/a", "version": "1.0.1" },
+                { "name": "a/a", "version": "1.1.0" },
+
+                { "name": "a/b", "version": "1.0.0" },
+                { "name": "a/b", "version": "1.0.1" },
+                { "name": "a/b", "version": "2.0.0" },
+
+                { "name": "a/c", "version": "1.0.0" },
+                { "name": "a/c", "version": "2.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "a/a": "1.0.*",
+        "a/c": "1.*"
+    },
+    "require-dev": {
+        "a/b": "*"
+    }
+}
+--INSTALLED--
+[
+    { "name": "a/a", "version": "1.0.0" },
+    { "name": "a/c", "version": "1.0.0" },
+    { "name": "a/b", "version": "1.0.0" }
+]
+--RUN--
+update --no-install
+
+--EXPECT-LOCK--
+{
+    "packages": [
+        { "name": "a/a", "version": "1.0.1", "type": "library" },
+        { "name": "a/c", "version": "1.0.0", "type": "library" }
+    ],
+    "packages-dev": [
+        { "name": "a/b", "version": "2.0.0", "type": "library" }
+    ],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+
+--EXPECT-INSTALLED--
+[
+    { "name": "a/a", "version": "1.0.0", "type": "library" },
+    { "name": "a/b", "version": "1.0.0", "type": "library" },
+    { "name": "a/c", "version": "1.0.0", "type": "library" }
+]
+
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-picks-up-change-of-vcs-type.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-picks-up-change-of-vcs-type.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-picks-up-change-of-vcs-type.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-picks-up-change-of-vcs-type.test	2021-01-27 15:09:27.000000000 +0000
@@ -31,10 +31,18 @@ Converting from one VCS type to another
             "name": "a/a", "version": "1.0.0",
             "source": { "reference": "old-hg-ref", "type": "hg", "url": "old-hg-url" }
         }
-    ]
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
 }
 --RUN--
-update
+update mirrors
 --EXPECT-LOCK--
 {
     "packages": [
@@ -54,4 +62,4 @@ update
     "platform-dev": []
 }
 --EXPECT--
-
+Upgrading a/a (1.0.0 old-hg-ref => 1.0.0 new-git-ref)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-prefer-lowest-stable.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-prefer-lowest-stable.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-prefer-lowest-stable.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-prefer-lowest-stable.test	2021-01-27 15:09:27.000000000 +0000
@@ -36,5 +36,5 @@ Updates packages to their lowest stable
 --RUN--
 update --prefer-lowest --prefer-stable
 --EXPECT--
-Updating a/a (1.0.0-rc1) to a/a (1.0.1)
-Downgrading a/b (1.0.1) to a/b (1.0.0)
+Upgrading a/a (1.0.0-rc1 => 1.0.1)
+Downgrading a/b (1.0.1 => 1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-reference-picks-latest.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-reference-picks-latest.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-reference-picks-latest.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-reference-picks-latest.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,31 @@
+--TEST--
+Updating a dev package should update to the latest available reference
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                {
+                    "name": "a/a", "version": "dev-master",
+                    "source": { "reference": "abc123", "url": "", "type": "git" }
+                }
+            ]
+        }
+    ],
+    "require": {
+        "a/a": "dev-master"
+    }
+}
+--INSTALLED--
+[
+    {
+        "name": "a/a", "version": "dev-master",
+        "source": { "reference": "def000", "url": "", "type": "git" },
+        "dist": { "reference": "def000", "url": "", "type": "zip", "shasum": "" }
+    }
+]
+--RUN--
+update
+--EXPECT--
+Upgrading a/a (dev-master def000 => dev-master abc123)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-reference.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-reference.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-reference.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-reference.test	2021-01-27 15:09:27.000000000 +0000
@@ -27,4 +27,4 @@ Updates a dev package forcing it's refer
 --RUN--
 install
 --EXPECT--
-Updating a/a (dev-master abc123) to a/a (dev-master def000)
+Upgrading a/a (dev-master abc123 => dev-master def000)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-removes-unused-locked-dep.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-removes-unused-locked-dep.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-removes-unused-locked-dep.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-removes-unused-locked-dep.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,67 @@
+--TEST--
+A composer update should remove unused locked dependencies from the lock file and remove unused installed deps from disk
+--COMPOSER--
+{
+    "repositories": [
+        {
+            "type": "package",
+            "package": [
+                { "name": "a/a", "version": "1.0.0" },
+                { "name": "b/b", "version": "1.0.0" }
+            ]
+        }
+    ],
+    "require": {
+        "a/a": "*"
+    }
+}
+--LOCK--
+{
+    "packages": [
+        { "name": "a/a", "version": "1.0.0" },
+        { "name": "b/b", "version": "1.0.0" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--INSTALLED--
+[
+    { "name": "a/a", "version": "1.0.0" },
+    { "name": "b/b", "version": "1.0.0" },
+    { "name": "c/c", "version": "1.0.0" }
+]
+--RUN--
+update
+--EXPECT-LOCK--
+{
+    "packages": [
+        { "name": "a/a", "version": "1.0.0", "type": "library" }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Lock file operations: 0 installs, 0 updates, 1 removal
+  - Removing b/b (1.0.0)
+Writing lock file
+Installing dependencies from lock file (including require-dev)
+Package operations: 0 installs, 0 updates, 2 removals
+Generating autoload files
+
+--EXPECT--
+Removing c/c (1.0.0)
+Removing b/b (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-to-empty-from-blank.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-to-empty-from-blank.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-to-empty-from-blank.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-to-empty-from-blank.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,20 @@
+--TEST--
+Update to a state without dependency works well from a blank slate
+--COMPOSER--
+{
+}
+--RUN--
+update
+--EXPECT-LOCK--
+{
+    "packages": [],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "stable",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-to-empty-from-locked.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-to-empty-from-locked.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-to-empty-from-locked.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-to-empty-from-locked.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,50 @@
+--TEST--
+Update to a state without dependency works well from locked with dependency
+--COMPOSER--
+{
+    "minimum-stability": "dev"
+}
+--INSTALLED--
+[
+    {
+        "name": "a/a", "version": "dev-master",
+        "source": { "reference": "1234", "type": "git", "url": "" },
+        "default-branch": true
+    }
+]
+--LOCK--
+{
+    "packages": [
+        {
+            "name": "a/a", "version": "dev-master",
+            "source": { "reference": "1234", "type": "git", "url": "" },
+            "type": "library",
+            "default-branch": true
+        }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--RUN--
+update
+--EXPECT-LOCK--
+{
+    "packages": [],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
+--EXPECT--
+Removing a/a (dev-master 1234)
+Marking a/a (9999999-dev 1234) as uninstalled, alias of a/a (dev-master 1234)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-locked-require.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-locked-require.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-locked-require.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-locked-require.test	1970-01-01 00:00:00.000000000 +0000
@@ -1,36 +0,0 @@
---TEST--
-Update with a package allowed list only updates those packages if they are not present in composer.json
---COMPOSER--
-{
-    "repositories": [
-        {
-            "type": "package",
-            "package": [
-                { "name": "allowed", "version": "1.1.0", "require": { "dependency": "1.1.0", "fixed-dependency": "1.*" } },
-                { "name": "allowed", "version": "1.0.0", "require": { "dependency": "1.0.0", "fixed-dependency": "1.*" } },
-                { "name": "dependency", "version": "1.1.0" },
-                { "name": "dependency", "version": "1.0.0" },
-                { "name": "fixed-dependency", "version": "1.1.0", "require": { "fixed-sub-dependency": "1.*" } },
-                { "name": "fixed-dependency", "version": "1.0.0", "require": { "fixed-sub-dependency": "1.*" } },
-                { "name": "fixed-sub-dependency", "version": "1.1.0" },
-                { "name": "fixed-sub-dependency", "version": "1.0.0" }
-            ]
-        }
-    ],
-    "require": {
-        "allowed": "1.*",
-        "fixed-dependency": "1.*"
-    }
-}
---INSTALLED--
-[
-    { "name": "allowed", "version": "1.0.0", "require": { "dependency": "1.0.0", "fixed-dependency": "1.*" } },
-    { "name": "dependency", "version": "1.0.0" },
-    { "name": "fixed-dependency", "version": "1.0.0", "require": { "fixed-sub-dependency": "1.*" } },
-    { "name": "fixed-sub-dependency", "version": "1.0.0" }
-]
---RUN--
-update allowed dependency
---EXPECT--
-Updating dependency (1.0.0) to dependency (1.1.0)
-Updating allowed (1.0.0) to allowed (1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns.test	1970-01-01 00:00:00.000000000 +0000
@@ -1,48 +0,0 @@
---TEST--
-Update with a package allowed list only updates those corresponding to the pattern
---COMPOSER--
-{
-    "repositories": [
-        {
-            "type": "package",
-            "package": [
-                { "name": "vendor/Test-Package", "version": "2.0" },
-                { "name": "vendor/NotMe", "version": "2.0" },
-                { "name": "exact/Test-Package", "version": "2.0" },
-                { "name": "notexact/TestPackage", "version": "2.0" },
-                { "name": "all/Package1", "version": "2.0" },
-                { "name": "all/Package2", "version": "2.0" },
-                { "name": "another/another", "version": "2.0" },
-                { "name": "no/regexp", "version": "2.0" }
-            ]
-        }
-    ],
-    "require": {
-        "vendor/Test-Package": "*.*",
-        "vendor/NotMe": "*.*",
-        "exact/Test-Package": "*.*",
-        "notexact/TestPackage": "*.*",
-        "all/Package1": "*.*",
-        "all/Package2": "*.*",
-        "another/another": "*.*",
-        "no/regexp": "*.*"
-    }
-}
---INSTALLED--
-[
-    { "name": "vendor/Test-Package", "version": "1.0" },
-    { "name": "vendor/NotMe", "version": "1.0" },
-    { "name": "exact/Test-Package", "version": "1.0" },
-    { "name": "notexact/TestPackage", "version": "1.0" },
-    { "name": "all/Package1", "version": "1.0" },
-    { "name": "all/Package2", "version": "1.0" },
-    { "name": "another/another", "version": "1.0" },
-    { "name": "no/regexp", "version": "1.0" }
-]
---RUN--
-update vendor/Test* exact/Test-Package notexact/Test all/* no/reg?xp
---EXPECT--
-Updating vendor/Test-Package (1.0) to vendor/Test-Package (2.0)
-Updating exact/Test-Package (1.0) to exact/Test-Package (2.0)
-Updating all/Package1 (1.0) to all/Package1 (2.0)
-Updating all/Package2 (1.0) to all/Package2 (2.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-with-all-dependencies.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-with-all-dependencies.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-with-all-dependencies.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-with-all-dependencies.test	1970-01-01 00:00:00.000000000 +0000
@@ -1,46 +0,0 @@
---TEST--
-Update with a package allowed list pattern and all-dependencies flag updates packages and their dependencies, even if defined as root dependency, matching the pattern
---COMPOSER--
-{
-    "repositories": [
-        {
-            "type": "package",
-            "package": [
-                { "name": "fixed", "version": "1.1.0" },
-                { "name": "fixed", "version": "1.0.0" },
-                { "name": "allowed-component1", "version": "1.1.0" },
-                { "name": "allowed-component1", "version": "1.0.0" },
-                { "name": "allowed-component2", "version": "1.1.0", "require": { "dependency": "1.*" } },
-                { "name": "allowed-component2", "version": "1.0.0", "require": { "dependency": "1.*" } },
-                { "name": "dependency", "version": "1.1.0" },
-                { "name": "dependency", "version": "1.0.0" },
-                { "name": "unrelated", "version": "1.1.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated-dependency", "version": "1.1.0" },
-                { "name": "unrelated-dependency", "version": "1.0.0" }
-            ]
-        }
-    ],
-    "require": {
-        "fixed": "1.*",
-        "allowed-component1": "1.*",
-        "allowed-component2": "1.*",
-        "dependency": "1.*",
-        "unrelated": "1.*"
-    }
-}
---INSTALLED--
-[
-    { "name": "fixed", "version": "1.0.0" },
-    { "name": "allowed-component1", "version": "1.0.0" },
-    { "name": "allowed-component2", "version": "1.0.0", "require": { "dependency": "1.0.0" } },
-    { "name": "dependency", "version": "1.0.0" },
-    { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" } },
-    { "name": "unrelated-dependency", "version": "1.0.0" }
-]
---RUN--
-update allowed-* --with-all-dependencies
---EXPECT--
-Updating allowed-component1 (1.0.0) to allowed-component1 (1.1.0)
-Updating dependency (1.0.0) to dependency (1.1.0)
-Updating allowed-component2 (1.0.0) to allowed-component2 (1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-with-dependencies.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-with-dependencies.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-with-dependencies.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-with-dependencies.test	1970-01-01 00:00:00.000000000 +0000
@@ -1,49 +0,0 @@
---TEST--
-Update with a package allowed list only updates those packages and their dependencies matching the pattern but no dependencies defined as roo package
---COMPOSER--
-{
-    "repositories": [
-        {
-            "type": "package",
-            "package": [
-                { "name": "fixed", "version": "1.1.0" },
-                { "name": "fixed", "version": "1.0.0" },
-                { "name": "allowed-component1", "version": "1.1.0" },
-                { "name": "allowed-component1", "version": "1.0.0" },
-                { "name": "allowed-component2", "version": "1.1.0", "require": { "dependency": "1.*", "root-dependency": "1.*" } },
-                { "name": "allowed-component2", "version": "1.0.0", "require": { "dependency": "1.*", "root-dependency": "1.*" } },
-                { "name": "dependency", "version": "1.1.0" },
-                { "name": "dependency", "version": "1.0.0" },
-                { "name": "root-dependency", "version": "1.1.0" },
-                { "name": "root-dependency", "version": "1.0.0" },
-                { "name": "unrelated", "version": "1.1.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated-dependency", "version": "1.1.0" },
-                { "name": "unrelated-dependency", "version": "1.0.0" }
-            ]
-        }
-    ],
-    "require": {
-        "fixed": "1.*",
-        "allowed-component1": "1.*",
-        "allowed-component2": "1.*",
-        "root-dependency": "1.*",
-        "unrelated": "1.*"
-    }
-}
---INSTALLED--
-[
-    { "name": "fixed", "version": "1.0.0" },
-    { "name": "allowed-component1", "version": "1.0.0" },
-    { "name": "allowed-component2", "version": "1.0.0", "require": { "dependency": "1.0.0" } },
-    { "name": "root-dependency", "version": "1.0.0" },
-    { "name": "dependency", "version": "1.0.0" },
-    { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" } },
-    { "name": "unrelated-dependency", "version": "1.0.0" }
-]
---RUN--
-update allowed-* --with-dependencies
---EXPECT--
-Updating allowed-component1 (1.0.0) to allowed-component1 (1.1.0)
-Updating dependency (1.0.0) to dependency (1.1.0)
-Updating allowed-component2 (1.0.0) to allowed-component2 (1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-without-dependencies.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-without-dependencies.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-without-dependencies.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-without-dependencies.test	1970-01-01 00:00:00.000000000 +0000
@@ -1,44 +0,0 @@
---TEST--
-Update with a package allowed list only updates those packages matching the pattern
---COMPOSER--
-{
-    "repositories": [
-        {
-            "type": "package",
-            "package": [
-                { "name": "fixed", "version": "1.1.0" },
-                { "name": "fixed", "version": "1.0.0" },
-                { "name": "allowed-component1", "version": "1.1.0" },
-                { "name": "allowed-component1", "version": "1.0.0" },
-                { "name": "allowed-component2", "version": "1.1.0", "require": { "dependency": "1.*" } },
-                { "name": "allowed-component2", "version": "1.0.0", "require": { "dependency": "1.*" } },
-                { "name": "dependency", "version": "1.1.0" },
-                { "name": "dependency", "version": "1.0.0" },
-                { "name": "unrelated", "version": "1.1.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated-dependency", "version": "1.1.0" },
-                { "name": "unrelated-dependency", "version": "1.0.0" }
-            ]
-        }
-    ],
-    "require": {
-        "fixed": "1.*",
-        "allowed-component1": "1.*",
-        "allowed-component2": "1.*",
-        "unrelated": "1.*"
-    }
-}
---INSTALLED--
-[
-    { "name": "fixed", "version": "1.0.0" },
-    { "name": "allowed-component1", "version": "1.0.0" },
-    { "name": "allowed-component2", "version": "1.0.0", "require": { "dependency": "1.0.0" } },
-    { "name": "dependency", "version": "1.0.0" },
-    { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" } },
-    { "name": "unrelated-dependency", "version": "1.0.0" }
-]
---RUN--
-update allowed-*
---EXPECT--
-Updating allowed-component1 (1.0.0) to allowed-component1 (1.1.0)
-Updating allowed-component2 (1.0.0) to allowed-component2 (1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-with-root-dependencies.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-with-root-dependencies.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-with-root-dependencies.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-patterns-with-root-dependencies.test	1970-01-01 00:00:00.000000000 +0000
@@ -1,55 +0,0 @@
---TEST--
-Update with a package allowed list only updates those packages and their dependencies matching the pattern
---COMPOSER--
-{
-    "repositories": [
-        {
-            "type": "package",
-            "package": [
-                { "name": "fixed", "version": "1.1.0" },
-                { "name": "fixed", "version": "1.0.0" },
-                { "name": "allowed-component1", "version": "1.1.0", "require": { "allowed-component2": "1.1.0" } },
-                { "name": "allowed-component1", "version": "1.0.0", "require": { "allowed-component2": "1.0.0" } },
-                { "name": "allowed-component2", "version": "1.1.0", "require": { "dependency": "1.1.0", "allowed-component5": "1.0.0" } },
-                { "name": "allowed-component2", "version": "1.0.0", "require": { "dependency": "1.0.0" } },
-                { "name": "allowed-component3", "version": "1.1.0", "require": { "allowed-component4": "1.1.0" } },
-                { "name": "allowed-component3", "version": "1.0.0", "require": { "allowed-component4": "1.0.0" } },
-                { "name": "allowed-component4", "version": "1.1.0" },
-                { "name": "allowed-component4", "version": "1.0.0" },
-                { "name": "allowed-component5", "version": "1.1.0" },
-                { "name": "allowed-component5", "version": "1.0.0" },
-                { "name": "dependency", "version": "1.1.0" },
-                { "name": "dependency", "version": "1.0.0" },
-                { "name": "unrelated", "version": "1.1.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated-dependency", "version": "1.1.0" },
-                { "name": "unrelated-dependency", "version": "1.0.0" }
-            ]
-        }
-    ],
-    "require": {
-        "fixed": "1.*",
-        "allowed-component1": "1.*",
-        "allowed-component2": "1.*",
-        "allowed-component3": "1.0.0",
-        "unrelated": "1.*"
-    }
-}
---INSTALLED--
-[
-    { "name": "fixed", "version": "1.0.0" },
-    { "name": "allowed-component1", "version": "1.0.0", "require": { "allowed-component2": "1.0.0" } },
-    { "name": "allowed-component2", "version": "1.0.0", "require": { "dependency": "1.0.0" } },
-    { "name": "allowed-component3", "version": "1.0.0", "require": { "allowed-component4": "1.0.0" } },
-    { "name": "allowed-component4", "version": "1.0.0" },
-    { "name": "allowed-component5", "version": "1.0.0" },
-    { "name": "dependency", "version": "1.0.0" },
-    { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" } },
-    { "name": "unrelated-dependency", "version": "1.0.0" }
-]
---RUN--
-update allowed-* --with-dependencies
---EXPECT--
-Updating dependency (1.0.0) to dependency (1.1.0)
-Updating allowed-component2 (1.0.0) to allowed-component2 (1.1.0)
-Updating allowed-component1 (1.0.0) to allowed-component1 (1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-reads-lock.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-reads-lock.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-reads-lock.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-reads-lock.test	1970-01-01 00:00:00.000000000 +0000
@@ -1,48 +0,0 @@
---TEST--
-Limited update takes rules from lock if available, and not from the installed repo + composer.json
---COMPOSER--
-{
-    "repositories": [
-        {
-            "type": "package",
-            "package": [
-                { "name": "toupdate/installed", "version": "1.1.0" },
-                { "name": "toupdate/installed", "version": "1.0.0" },
-                { "name": "toupdate/notinstalled", "version": "1.1.0" },
-                { "name": "toupdate/notinstalled", "version": "1.0.0" },
-                { "name": "old/installed", "version": "0.9.0" },
-                { "name": "old/installed", "version": "1.0.0" }
-            ]
-        }
-    ],
-    "require": {
-        "toupdate/installed": "1.*",
-        "toupdate/notinstalled": "1.*",
-        "old/installed": "*"
-    }
-}
---LOCK--
-{
-    "packages": [
-        { "name": "old/installed", "version": "1.0.0" },
-        { "name": "toupdate/installed", "version": "1.0.0" },
-        { "name": "toupdate/notinstalled", "version": "1.0.0" }
-    ],
-    "packages-dev": null,
-    "aliases": [],
-    "minimum-stability": "stable",
-    "stability-flags": [],
-    "prefer-stable": false,
-    "prefer-lowest": false
-}
---INSTALLED--
-[
-    { "name": "toupdate/installed", "version": "1.0.0" },
-    { "name": "old/installed", "version": "0.9.0" }
-]
---RUN--
-update toupdate/installed
---EXPECT--
-Updating toupdate/installed (1.0.0) to toupdate/installed (1.1.0)
-Updating old/installed (0.9.0) to old/installed (1.0.0)
-Installing toupdate/notinstalled (1.0.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-removes-unused.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-removes-unused.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-removes-unused.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-removes-unused.test	1970-01-01 00:00:00.000000000 +0000
@@ -1,32 +0,0 @@
---TEST--
-Update with a package allowed list removes unused packages
---COMPOSER--
-{
-    "repositories": [
-        {
-            "type": "package",
-            "package": [
-                { "name": "allowed", "version": "1.1.0" },
-                { "name": "allowed", "version": "1.0.0", "require": { "fixed-dependency": "1.0.0", "old-dependency": "1.0.0" } },
-                { "name": "fixed-dependency", "version": "1.1.0" },
-                { "name": "fixed-dependency", "version": "1.0.0" },
-                { "name": "old-dependency", "version": "1.0.0" }
-            ]
-        }
-    ],
-    "require": {
-        "allowed": "1.*",
-        "fixed-dependency": "1.*"
-    }
-}
---INSTALLED--
-[
-    { "name": "allowed", "version": "1.0.0", "require": { "old-dependency": "1.0.0", "fixed-dependency": "1.0.0" } },
-    { "name": "fixed-dependency", "version": "1.0.0" },
-    { "name": "old-dependency", "version": "1.0.0" }
-]
---RUN--
-update --with-dependencies allowed
---EXPECT--
-Uninstalling old-dependency (1.0.0)
-Updating allowed (1.0.0) to allowed (1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist.test	1970-01-01 00:00:00.000000000 +0000
@@ -1,39 +0,0 @@
---TEST--
-Update with a package allowed list only updates those packages listed as command arguments
---COMPOSER--
-{
-    "repositories": [
-        {
-            "type": "package",
-            "package": [
-                { "name": "fixed", "version": "1.1.0" },
-                { "name": "fixed", "version": "1.0.0" },
-                { "name": "allowed", "version": "1.1.0", "require": { "dependency": "1.*" } },
-                { "name": "allowed", "version": "1.0.0", "require": { "dependency": "1.*" } },
-                { "name": "dependency", "version": "1.1.0" },
-                { "name": "dependency", "version": "1.0.0" },
-                { "name": "unrelated", "version": "1.1.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated-dependency", "version": "1.1.0" },
-                { "name": "unrelated-dependency", "version": "1.0.0" }
-            ]
-        }
-    ],
-    "require": {
-        "fixed": "1.*",
-        "allowed": "1.*",
-        "unrelated": "1.*"
-    }
-}
---INSTALLED--
-[
-    { "name": "fixed", "version": "1.0.0" },
-    { "name": "allowed", "version": "1.0.0", "require": { "dependency": "1.*" } },
-    { "name": "dependency", "version": "1.0.0" },
-    { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" } },
-    { "name": "unrelated-dependency", "version": "1.0.0" }
-]
---RUN--
-update allowed
---EXPECT--
-Updating allowed (1.0.0) to allowed (1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-with-dependencies.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-with-dependencies.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-with-dependencies.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-with-dependencies.test	1970-01-01 00:00:00.000000000 +0000
@@ -1,40 +0,0 @@
---TEST--
-Update with a package allowed list only updates those packages and their dependencies listed as command arguments
---COMPOSER--
-{
-    "repositories": [
-        {
-            "type": "package",
-            "package": [
-                { "name": "fixed", "version": "1.1.0" },
-                { "name": "fixed", "version": "1.0.0" },
-                { "name": "allowed", "version": "1.1.0", "require": { "dependency": "1.1.0" } },
-                { "name": "allowed", "version": "1.0.0", "require": { "dependency": "1.0.0" } },
-                { "name": "dependency", "version": "1.1.0" },
-                { "name": "dependency", "version": "1.0.0" },
-                { "name": "unrelated", "version": "1.1.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated-dependency", "version": "1.1.0" },
-                { "name": "unrelated-dependency", "version": "1.0.0" }
-            ]
-        }
-    ],
-    "require": {
-        "fixed": "1.*",
-        "allowed": "1.*",
-        "unrelated": "1.*"
-    }
-}
---INSTALLED--
-[
-    { "name": "fixed", "version": "1.0.0" },
-    { "name": "allowed", "version": "1.0.0", "require": { "dependency": "1.0.0" } },
-    { "name": "dependency", "version": "1.0.0" },
-    { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" } },
-    { "name": "unrelated-dependency", "version": "1.0.0" }
-]
---RUN--
-update allowed --with-dependencies
---EXPECT--
-Updating dependency (1.0.0) to dependency (1.1.0)
-Updating allowed (1.0.0) to allowed (1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-with-dependency-conflict.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-with-dependency-conflict.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-whitelist-with-dependency-conflict.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-whitelist-with-dependency-conflict.test	1970-01-01 00:00:00.000000000 +0000
@@ -1,38 +0,0 @@
---TEST--
-Update with a package allowed list only updates allowed packages if no dependency conflicts
---COMPOSER--
-{
-    "repositories": [
-        {
-            "type": "package",
-            "package": [
-                { "name": "fixed", "version": "1.1.0" },
-                { "name": "fixed", "version": "1.0.0" },
-                { "name": "allowed", "version": "1.1.0", "require": { "dependency": "1.1.0" } },
-                { "name": "allowed", "version": "1.0.0", "require": { "dependency": "1.0.0" } },
-                { "name": "dependency", "version": "1.1.0" },
-                { "name": "dependency", "version": "1.0.0" },
-                { "name": "unrelated", "version": "1.1.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" }  },
-                { "name": "unrelated-dependency", "version": "1.1.0" },
-                { "name": "unrelated-dependency", "version": "1.0.0" }
-            ]
-        }
-    ],
-    "require": {
-        "fixed": "1.*",
-        "allowed": "1.*",
-        "unrelated": "1.*"
-    }
-}
---INSTALLED--
-[
-    { "name": "fixed", "version": "1.0.0" },
-    { "name": "allowed", "version": "1.0.0", "require": { "dependency": "1.0.0" } },
-    { "name": "dependency", "version": "1.0.0" },
-    { "name": "unrelated", "version": "1.0.0", "require": { "unrelated-dependency": "1.*" } },
-    { "name": "unrelated-dependency", "version": "1.0.0" }
-]
---RUN--
-update allowed
---EXPECT--
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-with-all-dependencies.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-with-all-dependencies.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/update-with-all-dependencies.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/update-with-all-dependencies.test	2021-01-27 15:09:27.000000000 +0000
@@ -2,7 +2,7 @@
 
 See Github issue #6661 ( github.com/composer/composer/issues/6661 ).
 
-When `--with-all-dependencies` is used, Composer\Installer::allowListUpdateDependencies should update the dependencies of all allowed packages, even if the dependency is a root requirement.
+When `--with-all-dependencies` is used, Composer should update the dependencies of all allowed packages, even if the dependency is a root requirement.
 
 --COMPOSER--
 {
@@ -28,17 +28,35 @@ When `--with-all-dependencies` is used,
     { "name": "a/a", "version": "1.0.0" },
     { "name": "b/b", "version": "1.0.0", "require": { "a/a": "~1.0" } }
 ]
-
+--LOCK--
+{
+    "packages": [
+        { "name": "a/a", "version": "1.0.0" },
+        { "name": "b/b", "version": "1.0.0", "require": { "a/a": "~1.0" } }
+    ],
+    "packages-dev": [],
+    "aliases": [],
+    "minimum-stability": "dev",
+    "stability-flags": [],
+    "prefer-stable": false,
+    "prefer-lowest": false,
+    "platform": [],
+    "platform-dev": []
+}
 --RUN--
 update b/b --with-all-dependencies
 
 --EXPECT-OUTPUT--
 Loading composer repositories with package information
-Updating dependencies (including require-dev)
-Package operations: 0 installs, 2 updates, 0 removals
+Updating dependencies
+Lock file operations: 0 installs, 2 updates, 0 removals
+  - Upgrading a/a (1.0.0 => 1.1.0)
+  - Upgrading b/b (1.0.0 => 1.1.0)
 Writing lock file
+Installing dependencies from lock file (including require-dev)
+Package operations: 0 installs, 2 updates, 0 removals
 Generating autoload files
 
 --EXPECT--
-Updating a/a (1.0.0) to a/a (1.1.0)
-Updating b/b (1.0.0) to b/b (1.1.0)
+Upgrading a/a (1.0.0 => 1.1.0)
+Upgrading b/b (1.0.0 => 1.1.0)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/updating-dev-from-lock-removes-old-deps.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/updating-dev-from-lock-removes-old-deps.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/updating-dev-from-lock-removes-old-deps.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/updating-dev-from-lock-removes-old-deps.test	2021-01-27 15:09:27.000000000 +0000
@@ -13,10 +13,11 @@ Installing locked dev packages should re
         {
             "name": "a/devpackage", "version": "dev-master",
             "source": { "reference": "newref", "url": "", "type": "git" },
-            "require": {}
+            "require": {},
+            "default-branch": true
         }
     ],
-    "packages-dev": null,
+    "packages-dev": [],
     "aliases": [],
     "minimum-stability": "dev",
     "stability-flags": [],
@@ -30,16 +31,19 @@ Installing locked dev packages should re
         "source": { "reference": "oldref", "url": "", "type": "git" },
         "require": {
             "a/dependency": "*"
-        }
+        },
+        "default-branch": true
     },
     {
         "name": "a/dependency", "version": "dev-master",
         "source": { "reference": "ref", "url": "", "type": "git" },
-        "require": {}
+        "require": {},
+        "default-branch": true
     }
 ]
 --RUN--
 install
 --EXPECT--
-Uninstalling a/dependency (dev-master ref)
-Updating a/devpackage (dev-master oldref) to a/devpackage (dev-master newref)
+Removing a/dependency (dev-master ref)
+Marking a/dependency (9999999-dev ref) as uninstalled, alias of a/dependency (dev-master ref)
+Upgrading a/devpackage (dev-master oldref => dev-master newref)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer/updating-dev-updates-url-and-reference.test 2.0.9-1/tests/Composer/Test/Fixtures/installer/updating-dev-updates-url-and-reference.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer/updating-dev-updates-url-and-reference.test	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer/updating-dev-updates-url-and-reference.test	2021-01-27 15:09:27.000000000 +0000
@@ -28,7 +28,7 @@ Updating a dev package for new reference
             "dist": { "reference": "oldref", "url": "oldurl", "type": "zip", "shasum": "" }
         }
     ],
-    "packages-dev": null,
+    "packages-dev": [],
     "aliases": [],
     "minimum-stability": "dev",
     "stability-flags": {"a/a":20},
@@ -65,4 +65,4 @@ update
     "platform-dev": []
 }
 --EXPECT--
-Updating a/a (dev-master oldref) to a/a (dev-master newref)
+Upgrading a/a (dev-master oldref => dev-master newref)
diff -pruN 1.10.19-1/tests/Composer/Test/Fixtures/installer-slow/github-issues-7665.test 2.0.9-1/tests/Composer/Test/Fixtures/installer-slow/github-issues-7665.test
--- 1.10.19-1/tests/Composer/Test/Fixtures/installer-slow/github-issues-7665.test	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Fixtures/installer-slow/github-issues-7665.test	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,3038 @@
+--TEST--
+Solver Bug Exception GitHub issue 7665 https://github.com/composer/composer/issues/7665
+--COMPOSER--
+{
+    "name": "smichaelsen/composer-test",
+    "require": {
+        "behat/behat": "~2.5",
+        "friendsofphp/php-cs-fixer": "^2.12"
+    },
+    "repositories": {
+        "behat/behat": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "behat/behat",
+                    "version": "v2.5.5",
+                    "type": "library",
+                    "require": {
+                        "symfony/finder": "~2.0"
+                    }
+                }
+            ]
+        },
+        "friendsofphp/php-cs-fixer": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v1.12.0",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^2.1 || ^3.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v1.12.1",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^2.1 || ^3.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v1.12.2",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^2.1 || ^3.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.12.0",
+                    "type": "application",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.12-dev"
+                        }
+                    },
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.12.1",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.12.2",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.12.3",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.12.4",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.12.5",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.12.6",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.12.7",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.12.8",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.13.0",
+                    "type": "application",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.13-dev"
+                        }
+                    },
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.13.1",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.13.2",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.13.3",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.14.0",
+                    "type": "application",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.14-dev"
+                        }
+                    },
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.14.1",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                },
+                {
+                    "name": "friendsofphp/php-cs-fixer",
+                    "version": "v2.14.2",
+                    "type": "application",
+                    "require": {
+                        "symfony/finder": "^3.0 || ^4.0"
+                    }
+                }
+            ]
+        },
+        "symfony/finder": {
+            "type": "package",
+            "package": [
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.0",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.0-BETA2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.10",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.11",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.12",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.13",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.5",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.6",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.7",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.8",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.6.9",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.6-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.0",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.0-BETA1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.0-BETA2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.10",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.11",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.12",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.13",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.14",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.15",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.16",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.17",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.18",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.19",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.20",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.21",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.22",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.23",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.24",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.25",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.26",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.27",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.28",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.29",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.30",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.31",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.32",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.33",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.34",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.35",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.36",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.37",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.38",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.39",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.40",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.41",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.42",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.43",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.44",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.45",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.46",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.47",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.48",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.49",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.5",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.50",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.6",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.7",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.8",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.7.9",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.7-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.0",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.0-BETA1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.10",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.11",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.12",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.13",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.14",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.15",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.16",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.17",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.18",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.19",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.20",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.21",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.22",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.23",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.24",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.25",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.26",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.27",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.28",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.29",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.30",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.31",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.32",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.33",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.34",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.35",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.36",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.37",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.38",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.39",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.40",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.41",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.42",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.43",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.44",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.45",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.46",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.47",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.48",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.49",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.5",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.6",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.7",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.8",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v2.8.9",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "2.8-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.0.0",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.0.0-BETA1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.0.1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.0.2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.0.3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.0.4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.0.5",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.0.6",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.0.7",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.0.8",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.0.9",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.0",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.0-BETA1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.0-RC1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.10",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.5",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.6",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.7",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.8",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.1.9",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.0",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.0-BETA1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.0-RC1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.0-RC2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.10",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.11",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.12",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.13",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.14",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.5",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.6",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.7",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.8",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.2.9",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.0",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.0-BETA1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.0-RC1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.10",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.11",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.12",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.13",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.14",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.15",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.16",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.17",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.18",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.5",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.6",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.7",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.8",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.3.9",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.3-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.0",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.0-BETA1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.0-BETA2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.0-BETA3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.0-BETA4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.0-RC1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.0-RC2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.10",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.11",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.12",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.13",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.14",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.15",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.16",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.17",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.18",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.19",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.20",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.21",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.22",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.23",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.24",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.5",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.6",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.7",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.8",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v3.4.9",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "3.4-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.0",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.0-BETA1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.0-BETA2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.0-BETA3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.0-BETA4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.0-RC1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.0-RC2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.10",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.11",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.12",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.13",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.14",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.15",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.5",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.6",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.7",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.8",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.0.9",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.0-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.0",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.0-BETA1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.0-BETA2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.0-BETA3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.10",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.11",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.5",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.6",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.7",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.8",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.1.9",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.1-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.2.0",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.2.0-BETA1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.2.0-BETA2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.2.0-RC1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.2.1",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.2.2",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.2.3",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.2.4",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.2-dev"
+                        }
+                    }
+                },
+                {
+                    "name": "symfony/finder",
+                    "version": "v4.2.5",
+                    "type": "library",
+                    "extra": {
+                        "branch-alias": {
+                            "dev-master": "4.2-dev"
+                        }
+                    }
+                }
+            ]
+        }
+    }
+}
+
+--RUN--
+update
+
+--EXPECT-OUTPUT--
+Loading composer repositories with package information
+Updating dependencies
+Your requirements could not be resolved to an installable set of packages.
+
+  Problem 1
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.12.1 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.12.2 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.12.3 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.12.4 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.12.5 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.12.6 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.12.7 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.12.8 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.13.0 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.13.1 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.13.2 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.13.3 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.14.0 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.14.1 (conflict analysis result)
+    - Conclusion: don't install friendsofphp/php-cs-fixer v2.14.2 (conflict analysis result)
+    - Root composer.json requires friendsofphp/php-cs-fixer ^2.12 -> satisfiable by friendsofphp/php-cs-fixer[v2.12.0, ..., v2.14.2].
+    - Conclusion: don't install symfony/finder v2.7.3 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.0.2 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.4 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.0.3 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.5 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.0.4 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.6 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.0.5 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.7 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.0.6 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.8 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.0.7 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.9 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.0.8 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.10 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.0.9 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.11 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.1.0 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.12 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.1.1 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.13 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.1.2 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.14 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.1.3 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.15 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.1.4 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.16 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.1.5 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.17 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.1.6 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.18 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.1.7 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.19 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.1.8 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.20 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.1.9 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.21 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.1.10 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.22 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.0 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.23 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.1 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.24 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.2 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.25 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.3 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.26 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.4 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.27 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.5 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.28 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.6 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.29 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.7 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.30 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.8 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.31 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.9 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.32 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.10 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.33 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.11 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.34 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.12 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.35 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.13 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.36 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.2.14 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.37 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.0 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.38 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.1 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.39 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.2 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.40 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.3 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.41 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.4 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.42 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.5 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.43 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.6 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.44 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.7 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.45 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.8 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.46 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.9 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.47 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.10 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.48 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.11 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.49 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.12 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.7.50 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.13 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.0 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.14 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.1 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.15 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.2 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.16 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.3 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.17 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.4 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.3.18 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.5 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.0 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.6 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.1 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.7 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.2 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.8 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.3 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.9 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.4 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.10 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.5 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.11 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.6 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.12 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.7 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.13 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.8 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.14 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.9 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.15 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.10 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.16 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.11 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.17 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.12 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.18 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.13 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.19 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.14 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.20 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.15 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.21 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.16 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.22 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.17 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.23 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.18 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.24 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.19 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.25 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.20 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.26 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.21 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.27 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.22 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.28 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.23 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.29 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v3.4.24 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.30 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.0 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.31 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.1 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.32 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.2 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.33 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.3 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.34 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.4 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.35 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.5 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.36 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.6 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.37 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.7 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.38 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.8 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.39 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.9 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.40 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.10 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.41 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.11 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.42 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.12 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.43 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.13 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.44 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.14 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.45 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.0.15 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.46 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.1.0 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.47 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.1.1 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.48 (conflict analysis result)
+    - Conclusion: don't install symfony/finder v4.1.2 (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.2.5] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.2.4] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.2.3] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.2.2] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.2.1] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.2.0] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.1.11] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.1.10] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.1.9] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.1.8] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.1.7] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.1.6] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.1.5] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.1.4] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder[v4.1.3] | install symfony/finder[v2.8.49] (conflict analysis result)
+    - Conclusion: don't install symfony/finder v2.8.49 (conflict analysis result)
+    - Root composer.json requires behat/behat ~2.5 -> satisfiable by behat/behat[v2.5.5].
+    - behat/behat v2.5.5 requires symfony/finder ~2.0 -> satisfiable by symfony/finder[v2.6.0, ..., v2.8.49].
+    - You can only install one version of a package, so only one of these can be installed: symfony/finder[v2.6.0, ..., v2.8.49, v3.0.0, ..., v3.4.24, v4.0.0, ..., v4.2.5].
+    - friendsofphp/php-cs-fixer v2.12.0 requires symfony/finder ^3.0 || ^4.0 -> satisfiable by symfony/finder[v3.0.0, ..., v3.4.24, v4.0.0, ..., v4.2.5].
+    - Conclusion: don't install symfony/finder v3.0.1 (conflict analysis result)
+
+--EXPECT--
+
+--EXPECT-EXIT-CODE--
+2
diff -pruN 1.10.19-1/tests/Composer/Test/InstalledVersionsTest.php 2.0.9-1/tests/Composer/Test/InstalledVersionsTest.php
--- 1.10.19-1/tests/Composer/Test/InstalledVersionsTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/InstalledVersionsTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,210 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test;
+
+use Composer\InstalledVersions;
+use Composer\Semver\VersionParser;
+
+class InstalledVersionsTest extends TestCase
+{
+    public function setUp()
+    {
+        InstalledVersions::reload(require __DIR__.'/Repository/Fixtures/installed.php');
+    }
+
+    public function testGetInstalledPackages()
+    {
+        $names = array(
+            '__root__',
+            'a/provider',
+            'a/provider2',
+            'b/replacer',
+            'c/c',
+            'foo/impl',
+            'foo/impl2',
+            'foo/replaced',
+        );
+        $this->assertSame($names, InstalledVersions::getInstalledPackages());
+    }
+
+    /**
+     * @dataProvider isInstalledProvider
+     */
+    public function testIsInstalled($expected, $name, $constraint = null)
+    {
+        $this->assertSame($expected, InstalledVersions::isInstalled($name));
+    }
+
+    public static function isInstalledProvider()
+    {
+        return array(
+            array(true,  'foo/impl'),
+            array(true,  'foo/replaced'),
+            array(true,  'c/c'),
+            array(true,  '__root__'),
+            array(true,  'b/replacer'),
+            array(false, 'not/there'),
+            array(false, 'not/there', '^1.0'),
+        );
+    }
+
+    /**
+     * @dataProvider satisfiesProvider
+     */
+    public function testSatisfies($expected, $name, $constraint)
+    {
+        $this->assertSame($expected, InstalledVersions::satisfies(new VersionParser, $name, $constraint));
+    }
+
+    public static function satisfiesProvider()
+    {
+        return array(
+            array(true,  'foo/impl', '1.5'),
+            array(true,  'foo/impl', '1.2'),
+            array(true,  'foo/impl', '^1.0'),
+            array(true,  'foo/impl', '^3 || ^2'),
+            array(false, 'foo/impl', '^3'),
+
+            array(true,  'foo/replaced', '3.5'),
+            array(true,  'foo/replaced', '^3.2'),
+            array(false,  'foo/replaced', '4.0'),
+
+            array(true,  'c/c', '3.0.0'),
+            array(true,  'c/c', '^3'),
+            array(false, 'c/c', '^3.1'),
+
+            array(true,  '__root__', 'dev-master'),
+            array(true,  '__root__', '^1.10'),
+            array(false, '__root__', '^2'),
+
+            array(true,  'b/replacer', '^2.1'),
+            array(false, 'b/replacer', '^2.3'),
+
+            array(true,  'a/provider2', '^1.2'),
+            array(true,  'a/provider2', '^1.4'),
+            array(false, 'a/provider2', '^1.5'),
+        );
+    }
+
+    /**
+     * @dataProvider getVersionRangesProvider
+     */
+    public function testGetVersionRanges($expected, $name)
+    {
+        $this->assertSame($expected, InstalledVersions::getVersionRanges($name));
+    }
+
+    public static function getVersionRangesProvider()
+    {
+        return array(
+            array('dev-master || 1.10.x-dev',   '__root__'),
+            array('^1.1 || 1.2 || 1.4 || 2.0',  'foo/impl'),
+            array('2.2 || 2.0',                 'foo/impl2'),
+            array('^3.0',                       'foo/replaced'),
+            array('1.1',                        'a/provider'),
+            array('1.2 || 1.4',                 'a/provider2'),
+            array('2.2',                        'b/replacer'),
+            array('3.0',                        'c/c'),
+        );
+    }
+
+    /**
+     * @dataProvider getVersionProvider
+     */
+    public function testGetVersion($expected, $name)
+    {
+        $this->assertSame($expected, InstalledVersions::getVersion($name));
+    }
+
+    public static function getVersionProvider()
+    {
+        return array(
+            array('dev-master',  '__root__'),
+            array(null, 'foo/impl'),
+            array(null, 'foo/impl2'),
+            array(null, 'foo/replaced'),
+            array('1.1.0.0', 'a/provider'),
+            array('1.2.0.0', 'a/provider2'),
+            array('2.2.0.0', 'b/replacer'),
+            array('3.0.0.0', 'c/c'),
+        );
+    }
+
+    /**
+     * @dataProvider getPrettyVersionProvider
+     */
+    public function testGetPrettyVersion($expected, $name)
+    {
+        $this->assertSame($expected, InstalledVersions::getPrettyVersion($name));
+    }
+
+    public static function getPrettyVersionProvider()
+    {
+        return array(
+            array('dev-master',  '__root__'),
+            array(null, 'foo/impl'),
+            array(null, 'foo/impl2'),
+            array(null, 'foo/replaced'),
+            array('1.1', 'a/provider'),
+            array('1.2', 'a/provider2'),
+            array('2.2', 'b/replacer'),
+            array('3.0', 'c/c'),
+        );
+    }
+
+    public function testGetVersionOutOfBounds()
+    {
+        $this->setExpectedException('OutOfBoundsException');
+        InstalledVersions::getVersion('not/installed');
+    }
+
+    public function testGetRootPackage()
+    {
+        $this->assertSame(array(
+            'pretty_version' => 'dev-master',
+            'version' => 'dev-master',
+            'aliases' => array(
+                '1.10.x-dev',
+            ),
+            'reference' => 'sourceref-by-default',
+            'name' => '__root__',
+        ), InstalledVersions::getRootPackage());
+    }
+
+    public function testGetRawData()
+    {
+        $this->assertSame(require __DIR__.'/Repository/Fixtures/installed.php', InstalledVersions::getRawData());
+    }
+
+    /**
+     * @dataProvider getReferenceProvider
+     */
+    public function testGetReference($expected, $name)
+    {
+        $this->assertSame($expected, InstalledVersions::getReference($name));
+    }
+
+    public static function getReferenceProvider()
+    {
+        return array(
+            array('sourceref-by-default',  '__root__'),
+            array(null, 'foo/impl'),
+            array(null, 'foo/impl2'),
+            array(null, 'foo/replaced'),
+            array('distref-as-no-source', 'a/provider'),
+            array('distref-as-installed-from-dist', 'a/provider2'),
+            array(null, 'b/replacer'),
+            array(null, 'c/c'),
+        );
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Installer/InstallationManagerTest.php 2.0.9-1/tests/Composer/Test/Installer/InstallationManagerTest.php
--- 1.10.19-1/tests/Composer/Test/Installer/InstallationManagerTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Installer/InstallationManagerTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,7 @@
 namespace Composer\Test\Installer;
 
 use Composer\Installer\InstallationManager;
+use Composer\Installer\NoopInstaller;
 use Composer\DependencyResolver\Operation\InstallOperation;
 use Composer\DependencyResolver\Operation\UpdateOperation;
 use Composer\DependencyResolver\Operation\UninstallOperation;
@@ -21,10 +22,14 @@ use Composer\Test\TestCase;
 class InstallationManagerTest extends TestCase
 {
     protected $repository;
+    protected $loop;
+    protected $io;
 
     public function setUp()
     {
+        $this->loop = $this->getMockBuilder('Composer\Util\Loop')->disableOriginalConstructor()->getMock();
         $this->repository = $this->getMockBuilder('Composer\Repository\InstalledRepositoryInterface')->getMock();
+        $this->io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
     }
 
     public function testAddGetInstaller()
@@ -38,7 +43,7 @@ class InstallationManagerTest extends Te
                 return $arg === 'vendor';
             }));
 
-        $manager = new InstallationManager();
+        $manager = new InstallationManager($this->loop, $this->io);
 
         $manager->addInstaller($installer);
         $this->assertSame($installer, $manager->getInstaller('vendor'));
@@ -67,7 +72,7 @@ class InstallationManagerTest extends Te
                 return $arg === 'vendor';
             }));
 
-        $manager = new InstallationManager();
+        $manager = new InstallationManager($this->loop, $this->io);
 
         $manager->addInstaller($installer);
         $this->assertSame($installer, $manager->getInstaller('vendor'));
@@ -80,16 +85,21 @@ class InstallationManagerTest extends Te
     public function testExecute()
     {
         $manager = $this->getMockBuilder('Composer\Installer\InstallationManager')
+            ->setConstructorArgs(array($this->loop, $this->io))
             ->setMethods(array('install', 'update', 'uninstall'))
             ->getMock();
 
-        $installOperation = new InstallOperation($this->createPackageMock());
-        $removeOperation = new UninstallOperation($this->createPackageMock());
+        $installOperation = new InstallOperation($package = $this->createPackageMock());
+        $removeOperation = new UninstallOperation($package);
         $updateOperation = new UpdateOperation(
-            $this->createPackageMock(),
-            $this->createPackageMock()
+            $package,
+            $package
         );
 
+        $package->expects($this->any())
+            ->method('getType')
+            ->will($this->returnValue('library'));
+
         $manager
             ->expects($this->once())
             ->method('install')
@@ -103,19 +113,18 @@ class InstallationManagerTest extends Te
             ->method('update')
             ->with($this->repository, $updateOperation);
 
-        $manager->execute($this->repository, $installOperation);
-        $manager->execute($this->repository, $removeOperation);
-        $manager->execute($this->repository, $updateOperation);
+        $manager->addInstaller(new NoopInstaller());
+        $manager->execute($this->repository, array($installOperation, $removeOperation, $updateOperation));
     }
 
     public function testInstall()
     {
         $installer = $this->createInstallerMock();
-        $manager = new InstallationManager();
+        $manager = new InstallationManager($this->loop, $this->io);
         $manager->addInstaller($installer);
 
         $package = $this->createPackageMock();
-        $operation = new InstallOperation($package, 'test');
+        $operation = new InstallOperation($package);
 
         $package
             ->expects($this->once())
@@ -139,12 +148,12 @@ class InstallationManagerTest extends Te
     public function testUpdateWithEqualTypes()
     {
         $installer = $this->createInstallerMock();
-        $manager = new InstallationManager();
+        $manager = new InstallationManager($this->loop, $this->io);
         $manager->addInstaller($installer);
 
         $initial = $this->createPackageMock();
         $target = $this->createPackageMock();
-        $operation = new UpdateOperation($initial, $target, 'test');
+        $operation = new UpdateOperation($initial, $target);
 
         $initial
             ->expects($this->once())
@@ -173,18 +182,17 @@ class InstallationManagerTest extends Te
     {
         $libInstaller = $this->createInstallerMock();
         $bundleInstaller = $this->createInstallerMock();
-        $manager = new InstallationManager();
+        $manager = new InstallationManager($this->loop, $this->io);
         $manager->addInstaller($libInstaller);
         $manager->addInstaller($bundleInstaller);
 
         $initial = $this->createPackageMock();
-        $target = $this->createPackageMock();
-        $operation = new UpdateOperation($initial, $target, 'test');
-
         $initial
             ->expects($this->once())
             ->method('getType')
             ->will($this->returnValue('library'));
+
+        $target = $this->createPackageMock();
         $target
             ->expects($this->once())
             ->method('getType')
@@ -213,17 +221,18 @@ class InstallationManagerTest extends Te
             ->method('install')
             ->with($this->repository, $target);
 
+        $operation = new UpdateOperation($initial, $target);
         $manager->update($this->repository, $operation);
     }
 
     public function testUninstall()
     {
         $installer = $this->createInstallerMock();
-        $manager = new InstallationManager();
+        $manager = new InstallationManager($this->loop, $this->io);
         $manager->addInstaller($installer);
 
         $package = $this->createPackageMock();
-        $operation = new UninstallOperation($package, 'test');
+        $operation = new UninstallOperation($package);
 
         $package
             ->expects($this->once())
@@ -249,7 +258,7 @@ class InstallationManagerTest extends Te
         $installer = $this->getMockBuilder('Composer\Installer\LibraryInstaller')
             ->disableOriginalConstructor()
             ->getMock();
-        $manager = new InstallationManager();
+        $manager = new InstallationManager($this->loop, $this->io);
         $manager->addInstaller($installer);
 
         $package = $this->createPackageMock();
@@ -281,7 +290,9 @@ class InstallationManagerTest extends Te
 
     private function createPackageMock()
     {
-        return $this->getMockBuilder('Composer\Package\PackageInterface')
+        $mock = $this->getMockBuilder('Composer\Package\PackageInterface')
             ->getMock();
+
+        return $mock;
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Installer/InstallerEventTest.php 2.0.9-1/tests/Composer/Test/Installer/InstallerEventTest.php
--- 1.10.19-1/tests/Composer/Test/Installer/InstallerEventTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Installer/InstallerEventTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -21,21 +21,14 @@ class InstallerEventTest extends TestCas
     {
         $composer = $this->getMockBuilder('Composer\Composer')->getMock();
         $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
-        $policy = $this->getMockBuilder('Composer\DependencyResolver\PolicyInterface')->getMock();
-        $pool = $this->getMockBuilder('Composer\DependencyResolver\Pool')->disableOriginalConstructor()->getMock();
-        $installedRepo = $this->getMockBuilder('Composer\Repository\CompositeRepository')->disableOriginalConstructor()->getMock();
-        $request = $this->getMockBuilder('Composer\DependencyResolver\Request')->disableOriginalConstructor()->getMock();
-        $operations = array($this->getMockBuilder('Composer\DependencyResolver\Operation\OperationInterface')->getMock());
-        $event = new InstallerEvent('EVENT_NAME', $composer, $io, true, $policy, $pool, $installedRepo, $request, $operations);
+        $transaction = $this->getMockBuilder('Composer\DependencyResolver\LockTransaction')->disableOriginalConstructor()->getMock();
+        $event = new InstallerEvent('EVENT_NAME', $composer, $io, true, true, $transaction);
 
         $this->assertSame('EVENT_NAME', $event->getName());
         $this->assertInstanceOf('Composer\Composer', $event->getComposer());
         $this->assertInstanceOf('Composer\IO\IOInterface', $event->getIO());
         $this->assertTrue($event->isDevMode());
-        $this->assertInstanceOf('Composer\DependencyResolver\PolicyInterface', $event->getPolicy());
-        $this->assertInstanceOf('Composer\DependencyResolver\Pool', $event->getPool());
-        $this->assertInstanceOf('Composer\Repository\CompositeRepository', $event->getInstalledRepo());
-        $this->assertInstanceOf('Composer\DependencyResolver\Request', $event->getRequest());
-        $this->assertCount(1, $event->getOperations());
+        $this->assertTrue($event->isExecutingOperations());
+        $this->assertInstanceOf('Composer\DependencyResolver\Transaction', $event->getTransaction());
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Installer/LibraryInstallerTest.php 2.0.9-1/tests/Composer/Test/Installer/LibraryInstallerTest.php
--- 1.10.19-1/tests/Composer/Test/Installer/LibraryInstallerTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Installer/LibraryInstallerTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -71,7 +71,7 @@ class LibraryInstallerTest extends TestC
         $this->fs->removeDirectory($this->vendorDir);
 
         new LibraryInstaller($this->io, $this->composer);
-        $this->assertFileNotExists($this->vendorDir);
+        $this->assertFileDoesNotExist($this->vendorDir);
     }
 
     public function testInstallerCreationShouldNotCreateBinDirectory()
@@ -79,7 +79,7 @@ class LibraryInstallerTest extends TestC
         $this->fs->removeDirectory($this->binDir);
 
         new LibraryInstaller($this->io, $this->composer);
-        $this->assertFileNotExists($this->binDir);
+        $this->assertFileDoesNotExist($this->binDir);
     }
 
     public function testIsInstalled()
@@ -113,7 +113,7 @@ class LibraryInstallerTest extends TestC
 
         $this->dm
             ->expects($this->once())
-            ->method('download')
+            ->method('install')
             ->with($package, $this->vendorDir.'/some/package');
 
         $this->repository
diff -pruN 1.10.19-1/tests/Composer/Test/Installer/SuggestedPackagesReporterTest.php 2.0.9-1/tests/Composer/Test/Installer/SuggestedPackagesReporterTest.php
--- 1.10.19-1/tests/Composer/Test/Installer/SuggestedPackagesReporterTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Installer/SuggestedPackagesReporterTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -33,14 +33,13 @@ class SuggestedPackagesReporterTest exte
     /**
      * @covers ::__construct
      */
-    public function testContrsuctor()
+    public function testConstructor()
     {
         $this->io->expects($this->once())
-            ->method('writeError');
+            ->method('write');
 
-        $suggestedPackagesReporter = new SuggestedPackagesReporter($this->io);
-        $suggestedPackagesReporter->addPackage('a', 'b', 'c');
-        $suggestedPackagesReporter->output();
+        $this->suggestedPackagesReporter->addPackage('a', 'b', 'c');
+        $this->suggestedPackagesReporter->output(SuggestedPackagesReporter::MODE_LIST);
     }
 
     /**
@@ -135,25 +134,33 @@ class SuggestedPackagesReporterTest exte
     {
         $this->suggestedPackagesReporter->addPackage('a', 'b', 'c');
 
-        $this->io->expects($this->once())
-            ->method('writeError')
-            ->with('a suggests installing b (c)');
+        $this->io->expects($this->at(0))
+            ->method('write')
+            ->with('<comment>a</comment> suggests:');
+
+        $this->io->expects($this->at(1))
+            ->method('write')
+            ->with(' - <info>b</info>: c');
 
-        $this->suggestedPackagesReporter->output();
+        $this->suggestedPackagesReporter->output(SuggestedPackagesReporter::MODE_BY_PACKAGE);
     }
 
     /**
      * @covers ::output
      */
-    public function testOutputWithNoSuggestedPackage()
+    public function testOutputWithNoSuggestionReason()
     {
         $this->suggestedPackagesReporter->addPackage('a', 'b', '');
 
-        $this->io->expects($this->once())
-            ->method('writeError')
-            ->with('a suggests installing b');
+        $this->io->expects($this->at(0))
+            ->method('write')
+            ->with('<comment>a</comment> suggests:');
 
-        $this->suggestedPackagesReporter->output();
+        $this->io->expects($this->at(1))
+            ->method('write')
+            ->with(' - <info>b</info>');
+
+        $this->suggestedPackagesReporter->output(SuggestedPackagesReporter::MODE_BY_PACKAGE);
     }
 
     /**
@@ -165,14 +172,18 @@ class SuggestedPackagesReporterTest exte
         $this->suggestedPackagesReporter->addPackage('source', 'target2', "<bg=green>Like us on Facebook</>");
 
         $this->io->expects($this->at(0))
-            ->method('writeError')
-            ->with("source suggests installing target1 ([1;37;42m Like us on Facebook [0m)");
+            ->method('write')
+            ->with('<comment>source</comment> suggests:');
 
         $this->io->expects($this->at(1))
-            ->method('writeError')
-            ->with('source suggests installing target2 (\\<bg=green>Like us on Facebook\\</>)');
+            ->method('write')
+            ->with(' - <info>target1</info>: [1;37;42m Like us on Facebook [0m');
+
+        $this->io->expects($this->at(2))
+            ->method('write')
+            ->with(' - <info>target2</info>: \\<bg=green>Like us on Facebook\\</>');
 
-        $this->suggestedPackagesReporter->output();
+        $this->suggestedPackagesReporter->output(SuggestedPackagesReporter::MODE_BY_PACKAGE);
     }
 
     /**
@@ -184,14 +195,26 @@ class SuggestedPackagesReporterTest exte
         $this->suggestedPackagesReporter->addPackage('source package', 'target', 'because reasons');
 
         $this->io->expects($this->at(0))
-            ->method('writeError')
-            ->with('a suggests installing b (c)');
+            ->method('write')
+            ->with('<comment>a</comment> suggests:');
 
         $this->io->expects($this->at(1))
-            ->method('writeError')
-            ->with('source package suggests installing target (because reasons)');
+            ->method('write')
+            ->with(' - <info>b</info>: c');
 
-        $this->suggestedPackagesReporter->output();
+        $this->io->expects($this->at(2))
+            ->method('write')
+            ->with('');
+
+        $this->io->expects($this->at(3))
+            ->method('write')
+            ->with('<comment>source package</comment> suggests:');
+
+        $this->io->expects($this->at(4))
+            ->method('write')
+            ->with(' - <info>target</info>: because reasons');
+
+        $this->suggestedPackagesReporter->output(SuggestedPackagesReporter::MODE_BY_PACKAGE);
     }
 
     /**
@@ -199,7 +222,7 @@ class SuggestedPackagesReporterTest exte
      */
     public function testOutputSkipInstalledPackages()
     {
-        $repository = $this->getMockBuilder('Composer\Repository\RepositoryInterface')->getMock();
+        $repository = $this->getMockBuilder('Composer\Repository\InstalledRepository')->disableOriginalConstructor()->getMock();
         $package1 = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
         $package2 = $this->getMockBuilder('Composer\Package\PackageInterface')->getMock();
 
@@ -221,11 +244,15 @@ class SuggestedPackagesReporterTest exte
         $this->suggestedPackagesReporter->addPackage('a', 'b', 'c');
         $this->suggestedPackagesReporter->addPackage('source package', 'target', 'because reasons');
 
-        $this->io->expects($this->once())
-            ->method('writeError')
-            ->with('source package suggests installing target (because reasons)');
+        $this->io->expects($this->at(0))
+            ->method('write')
+            ->with('<comment>source package</comment> suggests:');
+
+        $this->io->expects($this->at(1))
+            ->method('write')
+            ->with(' - <info>target</info>: because reasons');
 
-        $this->suggestedPackagesReporter->output($repository);
+        $this->suggestedPackagesReporter->output(SuggestedPackagesReporter::MODE_BY_PACKAGE, $repository);
     }
 
     /**
@@ -233,11 +260,11 @@ class SuggestedPackagesReporterTest exte
      */
     public function testOutputNotGettingInstalledPackagesWhenNoSuggestions()
     {
-        $repository = $this->getMockBuilder('Composer\Repository\RepositoryInterface')->getMock();
+        $repository = $this->getMockBuilder('Composer\Repository\InstalledRepository')->disableOriginalConstructor()->getMock();
         $repository->expects($this->exactly(0))
             ->method('getPackages');
 
-        $this->suggestedPackagesReporter->output($repository);
+        $this->suggestedPackagesReporter->output(SuggestedPackagesReporter::MODE_BY_PACKAGE, $repository);
     }
 
     private function getSuggestedPackageArray()
diff -pruN 1.10.19-1/tests/Composer/Test/InstallerTest.php 2.0.9-1/tests/Composer/Test/InstallerTest.php
--- 1.10.19-1/tests/Composer/Test/InstallerTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/InstallerTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,9 +12,15 @@
 
 namespace Composer\Test;
 
+use Composer\DependencyResolver\Request;
 use Composer\Installer;
-use Composer\Console\Application;
+use Symfony\Component\Console\Application;
+use Symfony\Component\Console\Command\Command;
+use Symfony\Component\Console\Input\InputArgument;
+use Symfony\Component\Console\Input\InputOption;
+use Composer\IO\BufferIO;
 use Composer\Json\JsonFile;
+use Composer\Package\Dumper\ArrayDumper;
 use Composer\Util\Filesystem;
 use Composer\Repository\ArrayRepository;
 use Composer\Repository\RepositoryManager;
@@ -29,8 +35,6 @@ use Symfony\Component\Console\Input\Stri
 use Symfony\Component\Console\Output\StreamOutput;
 use Symfony\Component\Console\Output\OutputInterface;
 use Symfony\Component\Console\Formatter\OutputFormatter;
-use Composer\Test\TestCase;
-use Composer\IO\BufferIO;
 
 class InstallerTest extends TestCase
 {
@@ -57,14 +61,16 @@ class InstallerTest extends TestCase
      */
     public function testInstaller(RootPackageInterface $rootPackage, $repositories, array $options)
     {
-        $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
+        $io = new BufferIO('', OutputInterface::VERBOSITY_NORMAL, new OutputFormatter(false));
 
         $downloadManager = $this->getMockBuilder('Composer\Downloader\DownloadManager')
             ->setConstructorArgs(array($io))
             ->getMock();
         $config = $this->getMockBuilder('Composer\Config')->getMock();
 
-        $repositoryManager = new RepositoryManager($io, $config);
+        $eventDispatcher = $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')->disableOriginalConstructor()->getMock();
+        $httpDownloader = $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock();
+        $repositoryManager = new RepositoryManager($io, $config, $httpDownloader, $eventDispatcher);
         $repositoryManager->setLocalRepository(new InstalledArrayRepository());
 
         if (!is_array($repositories)) {
@@ -73,23 +79,44 @@ class InstallerTest extends TestCase
         foreach ($repositories as $repository) {
             $repositoryManager->addRepository($repository);
         }
-
-        $locker = $this->getMockBuilder('Composer\Package\Locker')->disableOriginalConstructor()->getMock();
         $installationManager = new InstallationManagerMock();
 
-        $eventDispatcher = $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')->disableOriginalConstructor()->getMock();
+        // emulate a writable lock file
+        $lockData = null;
+        $lockJsonMock = $this->getMockBuilder('Composer\Json\JsonFile')->disableOriginalConstructor()->getMock();
+        $lockJsonMock->expects($this->any())
+            ->method('read')
+            ->will($this->returnCallback(function () use (&$lockData) {
+                return json_decode($lockData, true);
+            }));
+        $lockJsonMock->expects($this->any())
+            ->method('exists')
+            ->will($this->returnCallback(function () use (&$lockData) {
+                return $lockData !== null;
+            }));
+        $lockJsonMock->expects($this->any())
+            ->method('write')
+            ->will($this->returnCallback(function ($value, $options = 0) use (&$lockData) {
+                $lockData = json_encode($value, JsonFile::JSON_PRETTY_PRINT);
+            }));
+
+        $tempLockData = null;
+        $locker = new Locker($io, $lockJsonMock, $installationManager, '{}');
+
         $autoloadGenerator = $this->getMockBuilder('Composer\Autoload\AutoloadGenerator')->disableOriginalConstructor()->getMock();
 
         $installer = new Installer($io, $config, clone $rootPackage, $downloadManager, $repositoryManager, $locker, $installationManager, $eventDispatcher, $autoloadGenerator);
         $result = $installer->run();
-        $this->assertSame(0, $result);
+
+        $output = str_replace("\r", '', $io->getOutput());
+        $this->assertEquals(0, $result, $output);
 
         $expectedInstalled = isset($options['install']) ? $options['install'] : array();
         $expectedUpdated = isset($options['update']) ? $options['update'] : array();
         $expectedUninstalled = isset($options['uninstall']) ? $options['uninstall'] : array();
 
         $installed = $installationManager->getInstalledPackages();
-        $this->assertSame($expectedInstalled, $installed);
+        $this->assertEquals($this->makePackagesComparable($expectedInstalled), $this->makePackagesComparable($installed));
 
         $updated = $installationManager->getUpdatedPackages();
         $this->assertSame($expectedUpdated, $updated);
@@ -98,6 +125,18 @@ class InstallerTest extends TestCase
         $this->assertSame($expectedUninstalled, $uninstalled);
     }
 
+    protected function makePackagesComparable($packages)
+    {
+        $dumper = new ArrayDumper();
+
+        $comparable = array();
+        foreach ($packages as $package) {
+            $comparable[] = $dumper->dump($package);
+        }
+
+        return $comparable;
+    }
+
     public function provideInstaller()
     {
         $cases = array();
@@ -107,11 +146,11 @@ class InstallerTest extends TestCase
 
         $a = $this->getPackage('A', '1.0.0', 'Composer\Package\RootPackage');
         $a->setRequires(array(
-            new Link('A', 'B', $this->getVersionConstraint('=', '1.0.0')),
+            'b' => new Link('A', 'B', $v = $this->getVersionConstraint('=', '1.0.0'), Link::TYPE_REQUIRE, $v->getPrettyString()),
         ));
         $b = $this->getPackage('B', '1.0.0');
         $b->setRequires(array(
-            new Link('B', 'A', $this->getVersionConstraint('=', '1.0.0')),
+            'a' => new Link('B', 'A', $v = $this->getVersionConstraint('=', '1.0.0'), Link::TYPE_REQUIRE, $v->getPrettyString()),
         ));
 
         $cases[] = array(
@@ -127,11 +166,11 @@ class InstallerTest extends TestCase
 
         $a = $this->getPackage('A', '1.0.0', 'Composer\Package\RootPackage');
         $a->setRequires(array(
-            new Link('A', 'B', $this->getVersionConstraint('=', '1.0.0')),
+            'b' => new Link('A', 'B', $v = $this->getVersionConstraint('=', '1.0.0'), Link::TYPE_REQUIRE, $v->getPrettyString()),
         ));
         $b = $this->getPackage('B', '1.0.0');
         $b->setRequires(array(
-            new Link('B', 'A', $this->getVersionConstraint('=', '1.0.0')),
+            'a' => new Link('B', 'A', $v = $this->getVersionConstraint('=', '1.0.0'), Link::TYPE_REQUIRE, $v->getPrettyString()),
         ));
 
         $cases[] = array(
@@ -142,13 +181,23 @@ class InstallerTest extends TestCase
             ),
         );
 
+        // TODO why are there not more cases with uninstall/update?
         return $cases;
     }
 
     /**
+     * @group slow
+     * @dataProvider getSlowIntegrationTests
+     */
+    public function testSlowIntegration($file, $message, $condition, $composerConfig, $lock, $installed, $run, $expectLock, $expectInstalled, $expectOutput, $expect, $expectResult)
+    {
+        return $this->testIntegration($file, $message, $condition, $composerConfig, $lock, $installed, $run, $expectLock, $expectInstalled, $expectOutput, $expect, $expectResult);
+    }
+
+    /**
      * @dataProvider getIntegrationTests
      */
-    public function testIntegration($file, $message, $condition, $composerConfig, $lock, $installed, $run, $expectLock, $expectOutput, $expect, $expectResult)
+    public function testIntegration($file, $message, $condition, $composerConfig, $lock, $installed, $run, $expectLock, $expectInstalled, $expectOutput, $expect, $expectResult)
     {
         if ($condition) {
             eval('$res = '.$condition.';');
@@ -180,13 +229,24 @@ class InstallerTest extends TestCase
         $repositoryManager = $composer->getRepositoryManager();
         $repositoryManager->setLocalRepository(new InstalledFilesystemRepositoryMock($jsonMock));
 
+        // emulate a writable lock file
+        $lockData = $lock ? json_encode($lock, JsonFile::JSON_PRETTY_PRINT) : null;
         $lockJsonMock = $this->getMockBuilder('Composer\Json\JsonFile')->disableOriginalConstructor()->getMock();
         $lockJsonMock->expects($this->any())
             ->method('read')
-            ->will($this->returnValue($lock));
+            ->will($this->returnCallback(function () use (&$lockData) {
+                return json_decode($lockData, true);
+            }));
         $lockJsonMock->expects($this->any())
             ->method('exists')
-            ->will($this->returnValue(true));
+            ->will($this->returnCallback(function () use (&$lockData) {
+                return $lockData !== null;
+            }));
+        $lockJsonMock->expects($this->any())
+            ->method('write')
+            ->will($this->returnCallback(function ($value, $options = 0) use (&$lockData) {
+                $lockData = json_encode($value, JsonFile::JSON_PRETTY_PRINT);
+            }));
 
         if ($expectLock) {
             $actualLock = array();
@@ -203,7 +263,7 @@ class InstallerTest extends TestCase
         }
 
         $contents = json_encode($composerConfig);
-        $locker = new Locker($io, $lockJsonMock, $repositoryManager, $composer->getInstallationManager(), $contents);
+        $locker = new Locker($io, $lockJsonMock, $composer->getInstallationManager(), $contents);
         $composer->setLocker($locker);
 
         $eventDispatcher = $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')->disableOriginalConstructor()->getMock();
@@ -216,29 +276,67 @@ class InstallerTest extends TestCase
         $installer = Installer::create($io, $composer);
 
         $application = new Application;
-        $application->get('install')->setCode(function ($input, $output) use ($installer) {
+        $install = new Command('install');
+        $install->addOption('ignore-platform-reqs', null, InputOption::VALUE_NONE);
+        $install->addOption('ignore-platform-req', null, InputOption::VALUE_REQUIRED | InputOption::VALUE_IS_ARRAY);
+        $install->addOption('no-dev', null, InputOption::VALUE_NONE);
+        $install->addOption('dry-run', null, InputOption::VALUE_NONE);
+        $install->setCode(function ($input, $output) use ($installer) {
+            $ignorePlatformReqs = $input->getOption('ignore-platform-reqs') ?: ($input->getOption('ignore-platform-req') ?: false);
+
             $installer
                 ->setDevMode(!$input->getOption('no-dev'))
                 ->setDryRun($input->getOption('dry-run'))
-                ->setIgnorePlatformRequirements($input->getOption('ignore-platform-reqs'));
+                ->setIgnorePlatformRequirements($ignorePlatformReqs);
 
             return $installer->run();
         });
+        $application->add($install);
+
+        $update = new Command('update');
+        $update->addOption('ignore-platform-reqs', null, InputOption::VALUE_NONE);
+        $update->addOption('ignore-platform-req', null, InputOption::VALUE_REQUIRED | InputOption::VALUE_IS_ARRAY);
+        $update->addOption('no-dev', null, InputOption::VALUE_NONE);
+        $update->addOption('no-install', null, InputOption::VALUE_NONE);
+        $update->addOption('dry-run', null, InputOption::VALUE_NONE);
+        $update->addOption('lock', null, InputOption::VALUE_NONE);
+        $update->addOption('with-all-dependencies', null, InputOption::VALUE_NONE);
+        $update->addOption('with-dependencies', null, InputOption::VALUE_NONE);
+        $update->addOption('prefer-stable', null, InputOption::VALUE_NONE);
+        $update->addOption('prefer-lowest', null, InputOption::VALUE_NONE);
+        $update->addArgument('packages', InputArgument::IS_ARRAY | InputArgument::OPTIONAL);
+        $update->setCode(function ($input, $output) use ($installer) {
+            $packages = $input->getArgument('packages');
+            $filteredPackages = array_filter($packages, function ($package) {
+                return !in_array($package, array('lock', 'nothing', 'mirrors'), true);
+            });
+            $updateMirrors = $input->getOption('lock') || count($filteredPackages) != count($packages);
+            $packages = $filteredPackages;
+
+            $updateAllowTransitiveDependencies = Request::UPDATE_ONLY_LISTED;
+            if ($input->getOption('with-all-dependencies')) {
+                $updateAllowTransitiveDependencies = Request::UPDATE_LISTED_WITH_TRANSITIVE_DEPS;
+            } elseif ($input->getOption('with-dependencies')) {
+                $updateAllowTransitiveDependencies = Request::UPDATE_LISTED_WITH_TRANSITIVE_DEPS_NO_ROOT_REQUIRE;
+            }
+
+            $ignorePlatformReqs = $input->getOption('ignore-platform-reqs') ?: ($input->getOption('ignore-platform-req') ?: false);
 
-        $application->get('update')->setCode(function ($input, $output) use ($installer) {
             $installer
                 ->setDevMode(!$input->getOption('no-dev'))
                 ->setUpdate(true)
+                ->setInstall(!$input->getOption('no-install'))
                 ->setDryRun($input->getOption('dry-run'))
-                ->setUpdateAllowList($input->getArgument('packages'))
-                ->setAllowListTransitiveDependencies($input->getOption('with-dependencies'))
-                ->setAllowListAllDependencies($input->getOption('with-all-dependencies'))
+                ->setUpdateMirrors($updateMirrors)
+                ->setUpdateAllowList($packages)
+                ->setUpdateAllowTransitiveDependencies($updateAllowTransitiveDependencies)
                 ->setPreferStable($input->getOption('prefer-stable'))
                 ->setPreferLowest($input->getOption('prefer-lowest'))
-                ->setIgnorePlatformRequirements($input->getOption('ignore-platform-reqs'));
+                ->setIgnorePlatformRequirements($ignorePlatformReqs);
 
             return $installer->run();
         });
+        $application->add($update);
 
         if (!preg_match('{^(install|update)\b}', $run)) {
             throw new \UnexpectedValueException('The run command only supports install and update');
@@ -246,7 +344,7 @@ class InstallerTest extends TestCase
 
         $application->setAutoExit(false);
         $appOutput = fopen('php://memory', 'w+');
-        $input = new StringInput($run);
+        $input = new StringInput($run.' -vvv');
         $input->setInteractive(false);
         $result = $application->run($input, new StreamOutput($appOutput));
         fseek($appOutput, 0);
@@ -258,25 +356,52 @@ class InstallerTest extends TestCase
 
         $output = str_replace("\r", '', $io->getOutput());
         $this->assertEquals($expectResult, $result, $output . stream_get_contents($appOutput));
-        if ($expectLock) {
-            unset($actualLock['hash']);
-            unset($actualLock['content-hash']);
-            unset($actualLock['_readme']);
-            unset($actualLock['plugin-api-version']);
+        if ($expectLock && isset($actualLock)) {
+            unset($actualLock['hash'], $actualLock['content-hash'], $actualLock['_readme'], $actualLock['plugin-api-version']);
             $this->assertEquals($expectLock, $actualLock);
         }
 
+        if ($expectInstalled !== null) {
+            $actualInstalled = array();
+            $dumper = new ArrayDumper();
+
+            foreach ($repositoryManager->getLocalRepository()->getCanonicalPackages() as $package) {
+                $package = $dumper->dump($package);
+                unset($package['version_normalized']);
+                $actualInstalled[] = $package;
+            }
+
+            usort($actualInstalled, function ($a, $b) {
+                return strcmp($a['name'], $b['name']);
+            });
+
+            $this->assertSame($expectInstalled, $actualInstalled);
+        }
+
         $installationManager = $composer->getInstallationManager();
         $this->assertSame(rtrim($expect), implode("\n", $installationManager->getTrace()));
 
         if ($expectOutput) {
+            $output = preg_replace('{^    - .*?\.ini$}m', '__inilist__', $output);
+            $output = preg_replace('{(__inilist__\r?\n)+}', "__inilist__\n", $output);
+
             $this->assertStringMatchesFormat(rtrim($expectOutput), rtrim($output));
         }
     }
 
+    public function getSlowIntegrationTests()
+    {
+        return $this->loadIntegrationTests('installer-slow/');
+    }
+
     public function getIntegrationTests()
     {
-        $fixturesDir = realpath(__DIR__.'/Fixtures/installer/');
+        return $this->loadIntegrationTests('installer/');
+    }
+
+    public function loadIntegrationTests($path)
+    {
+        $fixturesDir = realpath(__DIR__.'/Fixtures/'.$path);
         $tests = array();
 
         foreach (new \RecursiveIteratorIterator(new \RecursiveDirectoryIterator($fixturesDir), \RecursiveIteratorIterator::LEAVES_ONLY) as $file) {
@@ -291,6 +416,7 @@ class InstallerTest extends TestCase
                 $installedDev = array();
                 $lock = array();
                 $expectLock = array();
+                $expectInstalled = null;
                 $expectResult = 0;
 
                 $message = $testData['TEST'];
@@ -329,6 +455,9 @@ class InstallerTest extends TestCase
                         $expectLock = JsonFile::parseJson($testData['EXPECT-LOCK']);
                     }
                 }
+                if (!empty($testData['EXPECT-INSTALLED'])) {
+                    $expectInstalled = JsonFile::parseJson($testData['EXPECT-INSTALLED']);
+                }
                 $expectOutput = isset($testData['EXPECT-OUTPUT']) ? $testData['EXPECT-OUTPUT'] : null;
                 $expect = $testData['EXPECT'];
                 if (!empty($testData['EXPECT-EXCEPTION'])) {
@@ -345,7 +474,7 @@ class InstallerTest extends TestCase
                 die(sprintf('Test "%s" is not valid: '.$e->getMessage(), str_replace($fixturesDir.'/', '', $file)));
             }
 
-            $tests[basename($file)] = array(str_replace($fixturesDir.'/', '', $file), $message, $condition, $composer, $lock, $installed, $run, $expectLock, $expectOutput, $expect, $expectResult);
+            $tests[basename($file)] = array(str_replace($fixturesDir.'/', '', $file), $message, $condition, $composer, $lock, $installed, $run, $expectLock, $expectInstalled, $expectOutput, $expect, $expectResult);
         }
 
         return $tests;
@@ -363,6 +492,7 @@ class InstallerTest extends TestCase
             'INSTALLED' => false,
             'RUN' => true,
             'EXPECT-LOCK' => false,
+            'EXPECT-INSTALLED' => false,
             'EXPECT-OUTPUT' => false,
             'EXPECT-EXIT-CODE' => false,
             'EXPECT-EXCEPTION' => false,
@@ -370,6 +500,7 @@ class InstallerTest extends TestCase
         );
 
         $section = null;
+        $data = array();
         foreach ($tokens as $i => $token) {
             if (null === $section && empty($token)) {
                 continue; // skip leading blank
diff -pruN 1.10.19-1/tests/Composer/Test/IO/ConsoleIOTest.php 2.0.9-1/tests/Composer/Test/IO/ConsoleIOTest.php
--- 1.10.19-1/tests/Composer/Test/IO/ConsoleIOTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/IO/ConsoleIOTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -84,7 +84,7 @@ class ConsoleIOTest extends TestCase
             ->with(
                 $this->callback(function ($messages) {
                     $result = preg_match("[(.*)/(.*) First line]", $messages[0]) > 0;
-                    $result &= preg_match("[(.*)/(.*) Second line]", $messages[1]) > 0;
+                    $result = $result && preg_match("[(.*)/(.*) Second line]", $messages[1]) > 0;
 
                     return $result;
                 }),
diff -pruN 1.10.19-1/tests/Composer/Test/IO/NullIOTest.php 2.0.9-1/tests/Composer/Test/IO/NullIOTest.php
--- 1.10.19-1/tests/Composer/Test/IO/NullIOTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/IO/NullIOTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -42,7 +42,7 @@ class NullIOTest extends TestCase
     {
         $io = new NullIO();
 
-        $this->assertInternalType('array', $io->getAuthentications());
+        $this->assertTrue(is_array($io->getAuthentications()));
         $this->assertEmpty($io->getAuthentications());
         $this->assertEquals(array('username' => null, 'password' => null), $io->getAuthentication('foo'));
     }
diff -pruN 1.10.19-1/tests/Composer/Test/Json/ComposerSchemaTest.php 2.0.9-1/tests/Composer/Test/Json/ComposerSchemaTest.php
--- 1.10.19-1/tests/Composer/Test/Json/ComposerSchemaTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Json/ComposerSchemaTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -20,13 +20,29 @@ use Composer\Test\TestCase;
  */
 class ComposerSchemaTest extends TestCase
 {
+    public function testNamePattern()
+    {
+        $expectedError = array(
+            array(
+                'property' => 'name',
+                'message' => 'Does not match the regex pattern ^[a-z0-9]([_.-]?[a-z0-9]+)*/[a-z0-9](([_.]?|-{0,2})[a-z0-9]+)*$',
+                'constraint' => 'pattern',
+                'pattern' => '^[a-z0-9]([_.-]?[a-z0-9]+)*/[a-z0-9](([_.]?|-{0,2})[a-z0-9]+)*$',
+            ),
+        );
+
+        $json = '{"name": "vendor/-pack__age", "description": "description"}';
+        $this->assertEquals($expectedError, $this->check($json));
+        $json = '{"name": "Vendor/Package", "description": "description"}';
+        $this->assertEquals($expectedError, $this->check($json));
+    }
+
     public function testRequiredProperties()
     {
         $json = '{ }';
-        $this->assertEquals(array(
-            array('property' => 'name', 'message' => 'The property name is required', 'constraint' => 'required'),
-            array('property' => 'description', 'message' => 'The property description is required', 'constraint' => 'required'),
-        ), $this->check($json));
+        $result = $this->check($json);
+        $this->assertContains(array('property' => 'name', 'message' => 'The property name is required', 'constraint' => 'required'), $result);
+        $this->assertContains(array('property' => 'description', 'message' => 'The property description is required', 'constraint' => 'required'), $result);
 
         $json = '{ "name": "vendor/package" }';
         $this->assertEquals(array(
@@ -41,13 +57,13 @@ class ComposerSchemaTest extends TestCas
 
     public function testOptionalAbandonedProperty()
     {
-        $json = '{"name": "name", "description": "description", "abandoned": true}';
+        $json = '{"name": "vendor/package", "description": "description", "abandoned": true}';
         $this->assertTrue($this->check($json));
     }
 
     public function testRequireTypes()
     {
-        $json = '{"name": "name", "description": "description", "require": {"a": ["b"]} }';
+        $json = '{"name": "vendor/package", "description": "description", "require": {"a": ["b"]} }';
         $this->assertEquals(array(
             array('property' => 'require.a', 'message' => 'Array value found, but a string is required', 'constraint' => 'type'),
         ), $this->check($json));
@@ -104,8 +120,7 @@ class ComposerSchemaTest extends TestCas
 
             // remove justinrainbow/json-schema 3.0/5.2 props so it works with all versions
             foreach ($errors as &$err) {
-                unset($err['pointer']);
-                unset($err['context']);
+                unset($err['pointer'], $err['context']);
             }
 
             return $errors;
diff -pruN 1.10.19-1/tests/Composer/Test/Json/Fixtures/composer.json 2.0.9-1/tests/Composer/Test/Json/Fixtures/composer.json
--- 1.10.19-1/tests/Composer/Test/Json/Fixtures/composer.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Json/Fixtures/composer.json	2021-01-27 15:09:27.000000000 +0000
@@ -9,12 +9,12 @@
         {
             "name": "Nils Adermann",
             "email": "naderman@naderman.de",
-            "homepage": "http://www.naderman.de"
+            "homepage": "https://www.naderman.de"
         },
         {
             "name": "Jordi Boggiano",
             "email": "j.boggiano@seld.be",
-            "homepage": "http://seld.be"
+            "homepage": "https://seld.be"
         }
     ],
     "support": {
diff -pruN 1.10.19-1/tests/Composer/Test/Json/JsonFileTest.php 2.0.9-1/tests/Composer/Test/Json/JsonFileTest.php
--- 1.10.19-1/tests/Composer/Test/Json/JsonFileTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Json/JsonFileTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -216,7 +216,7 @@ class JsonFileTest extends TestCase
             $result = JsonFile::parseJson($json);
             $this->fail(sprintf("Parsing should have failed but didn't.\nExpected:\n\"%s\"\nFor:\n\"%s\"\nGot:\n\"%s\"", $text, $json, var_export($result, true)));
         } catch (ParsingException $e) {
-            $this->assertContains($text, $e->getMessage());
+            $this->assertStringContainsString($text, $e->getMessage());
         }
     }
 
diff -pruN 1.10.19-1/tests/Composer/Test/Json/JsonManipulatorTest.php 2.0.9-1/tests/Composer/Test/Json/JsonManipulatorTest.php
--- 1.10.19-1/tests/Composer/Test/Json/JsonManipulatorTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Json/JsonManipulatorTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -1814,7 +1814,8 @@ class JsonManipulatorTest extends TestCa
 ', $manipulator->getContents());
     }
 
-    public function testAddConfigWithPackage() {
+    public function testAddConfigWithPackage()
+    {
         $manipulator = new JsonManipulator('{
     "repositories": [
         {
@@ -1935,7 +1936,7 @@ class JsonManipulatorTest extends TestCa
 ", $manipulator->getContents());
     }
 
-    public function testAddRepositoryCanAdd()
+    public function testAddRepositoryCanAppend()
     {
         $manipulator = new JsonManipulator('{
     "repositories": {
@@ -1946,7 +1947,7 @@ class JsonManipulatorTest extends TestCa
     }
 }');
 
-        $this->assertTrue($manipulator->addRepository('bar', array('type' => 'composer')));
+        $this->assertTrue($manipulator->addRepository('bar', array('type' => 'composer'), true));
         $this->assertEquals('{
     "repositories": {
         "foo": {
@@ -1961,6 +1962,32 @@ class JsonManipulatorTest extends TestCa
 ', $manipulator->getContents());
     }
 
+    public function testAddRepositoryCanPrepend()
+    {
+        $manipulator = new JsonManipulator('{
+    "repositories": {
+        "foo": {
+            "type": "vcs",
+            "url": "lala"
+        }
+    }
+}');
+
+        $this->assertTrue($manipulator->addRepository('bar', array('type' => 'composer'), false));
+        $this->assertEquals('{
+    "repositories": {
+        "bar": {
+            "type": "composer"
+        },
+        "foo": {
+            "type": "vcs",
+            "url": "lala"
+        }
+    }
+}
+', $manipulator->getContents());
+    }
+
     public function testAddRepositoryCanOverrideDeepRepos()
     {
         $manipulator = new JsonManipulator('{
@@ -2411,6 +2438,48 @@ class JsonManipulatorTest extends TestCa
 ', $manipulator->getContents());
     }
 
+    public function testRemoveMainKeyIfEmpty()
+    {
+        $manipulator = new JsonManipulator('{
+    "repositories": [
+    ],
+    "require": {
+        "package/a": "*",
+        "package/b": "*",
+        "package/c": "*"
+    },
+    "foo": "bar",
+    "require-dev": {
+    }
+}');
+
+        $this->assertTrue($manipulator->removeMainKeyIfEmpty('repositories'));
+        $this->assertEquals('{
+    "require": {
+        "package/a": "*",
+        "package/b": "*",
+        "package/c": "*"
+    },
+    "foo": "bar",
+    "require-dev": {
+    }
+}
+', $manipulator->getContents());
+
+        $this->assertTrue($manipulator->removeMainKeyIfEmpty('foo'));
+        $this->assertTrue($manipulator->removeMainKeyIfEmpty('require'));
+        $this->assertTrue($manipulator->removeMainKeyIfEmpty('require-dev'));
+        $this->assertEquals('{
+    "require": {
+        "package/a": "*",
+        "package/b": "*",
+        "package/c": "*"
+    },
+    "foo": "bar"
+}
+', $manipulator->getContents());
+    }
+
     public function testRemoveMainKeyRemovesKeyWhereValueIsNull()
     {
         $manipulator = new JsonManipulator(json_encode(array(
@@ -2497,4 +2566,1310 @@ class JsonManipulatorTest extends TestCa
 }
 ', $manipulator->getContents());
     }
+
+    public function testLargeFileDoesNotCauseBacktrackLimitErrorGithubIssue9595()
+    {
+        $manipulator = new JsonManipulator('{
+    "name": "leoloso/pop",
+    "require": {
+        "php": "^7.4|^8.0",
+        "ext-mbstring": "*",
+        "brain/cortex": "~1.0.0",
+        "composer/installers": "~1.0",
+        "composer/semver": "^1.5",
+        "erusev/parsedown": "^1.7",
+        "guzzlehttp/guzzle": "~6.3",
+        "jrfnl/php-cast-to-type": "^2.0",
+        "league/pipeline": "^1.0",
+        "lkwdwrd/wp-muplugin-loader": "dev-feature-composer-v2",
+        "obsidian/polyfill-hrtime": "^0.1",
+        "psr/cache": "^1.0",
+        "symfony/cache": "^5.1",
+        "symfony/config": "^5.1",
+        "symfony/dependency-injection": "^5.1",
+        "symfony/dotenv": "^5.1",
+        "symfony/expression-language": "^5.1",
+        "symfony/polyfill-php72": "^1.18",
+        "symfony/polyfill-php73": "^1.18",
+        "symfony/polyfill-php74": "^1.18",
+        "symfony/polyfill-php80": "^1.18",
+        "symfony/property-access": "^5.1",
+        "symfony/yaml": "^5.1"
+    },
+    "require-dev": {
+        "johnpbloch/wordpress": ">=5.5",
+        "phpstan/phpstan": "^0.12",
+        "phpunit/phpunit": ">=9.3",
+        "rector/rector": "^0.9",
+        "squizlabs/php_codesniffer": "^3.0",
+        "symfony/var-dumper": "^5.1",
+        "symplify/monorepo-builder": "^9.0",
+        "szepeviktor/phpstan-wordpress": "^0.6.2"
+    },
+    "autoload": {
+        "psr-4": {
+            "GraphQLAPI\\\\ConvertCaseDirectives\\\\": "layers/GraphQLAPIForWP/plugins/convert-case-directives/src",
+            "GraphQLAPI\\\\GraphQLAPI\\\\": "layers/GraphQLAPIForWP/plugins/graphql-api-for-wp/src",
+            "GraphQLAPI\\\\SchemaFeedback\\\\": "layers/GraphQLAPIForWP/plugins/schema-feedback/src",
+            "GraphQLByPoP\\\\GraphQLClientsForWP\\\\": "layers/GraphQLByPoP/packages/graphql-clients-for-wp/src",
+            "GraphQLByPoP\\\\GraphQLEndpointForWP\\\\": "layers/GraphQLByPoP/packages/graphql-endpoint-for-wp/src",
+            "GraphQLByPoP\\\\GraphQLParser\\\\": "layers/GraphQLByPoP/packages/graphql-parser/src",
+            "GraphQLByPoP\\\\GraphQLQuery\\\\": "layers/GraphQLByPoP/packages/graphql-query/src",
+            "GraphQLByPoP\\\\GraphQLRequest\\\\": "layers/GraphQLByPoP/packages/graphql-request/src",
+            "GraphQLByPoP\\\\GraphQLServer\\\\": "layers/GraphQLByPoP/packages/graphql-server/src",
+            "Leoloso\\\\ExamplesForPoP\\\\": "layers/Misc/packages/examples-for-pop/src",
+            "PoPSchema\\\\BasicDirectives\\\\": "layers/Schema/packages/basic-directives/src",
+            "PoPSchema\\\\BlockMetadataWP\\\\": "layers/Schema/packages/block-metadata-for-wp/src",
+            "PoPSchema\\\\CDNDirective\\\\": "layers/Schema/packages/cdn-directive/src",
+            "PoPSchema\\\\CategoriesWP\\\\": "layers/Schema/packages/categories-wp/src",
+            "PoPSchema\\\\Categories\\\\": "layers/Schema/packages/categories/src",
+            "PoPSchema\\\\CommentMetaWP\\\\": "layers/Schema/packages/commentmeta-wp/src",
+            "PoPSchema\\\\CommentMeta\\\\": "layers/Schema/packages/commentmeta/src",
+            "PoPSchema\\\\CommentMutationsWP\\\\": "layers/Schema/packages/comment-mutations-wp/src",
+            "PoPSchema\\\\CommentMutations\\\\": "layers/Schema/packages/comment-mutations/src",
+            "PoPSchema\\\\CommentsWP\\\\": "layers/Schema/packages/comments-wp/src",
+            "PoPSchema\\\\Comments\\\\": "layers/Schema/packages/comments/src",
+            "PoPSchema\\\\ConvertCaseDirectives\\\\": "layers/Schema/packages/convert-case-directives/src",
+            "PoPSchema\\\\CustomPostMediaMutationsWP\\\\": "layers/Schema/packages/custompostmedia-mutations-wp/src",
+            "PoPSchema\\\\CustomPostMediaMutations\\\\": "layers/Schema/packages/custompostmedia-mutations/src",
+            "PoPSchema\\\\CustomPostMediaWP\\\\": "layers/Schema/packages/custompostmedia-wp/src",
+            "PoPSchema\\\\CustomPostMedia\\\\": "layers/Schema/packages/custompostmedia/src",
+            "PoPSchema\\\\CustomPostMetaWP\\\\": "layers/Schema/packages/custompostmeta-wp/src",
+            "PoPSchema\\\\CustomPostMeta\\\\": "layers/Schema/packages/custompostmeta/src",
+            "PoPSchema\\\\CustomPostMutationsWP\\\\": "layers/Schema/packages/custompost-mutations-wp/src",
+            "PoPSchema\\\\CustomPostMutations\\\\": "layers/Schema/packages/custompost-mutations/src",
+            "PoPSchema\\\\CustomPostsWP\\\\": "layers/Schema/packages/customposts-wp/src",
+            "PoPSchema\\\\CustomPosts\\\\": "layers/Schema/packages/customposts/src",
+            "PoPSchema\\\\EventMutationsWPEM\\\\": "layers/Schema/packages/event-mutations-wp-em/src",
+            "PoPSchema\\\\EventMutations\\\\": "layers/Schema/packages/event-mutations/src",
+            "PoPSchema\\\\EventsWPEM\\\\": "layers/Schema/packages/events-wp-em/src",
+            "PoPSchema\\\\Events\\\\": "layers/Schema/packages/events/src",
+            "PoPSchema\\\\EverythingElseWP\\\\": "layers/Schema/packages/everythingelse-wp/src",
+            "PoPSchema\\\\EverythingElse\\\\": "layers/Schema/packages/everythingelse/src",
+            "PoPSchema\\\\GenericCustomPosts\\\\": "layers/Schema/packages/generic-customposts/src",
+            "PoPSchema\\\\GoogleTranslateDirectiveForCustomPosts\\\\": "layers/Schema/packages/google-translate-directive-for-customposts/src",
+            "PoPSchema\\\\GoogleTranslateDirective\\\\": "layers/Schema/packages/google-translate-directive/src",
+            "PoPSchema\\\\HighlightsWP\\\\": "layers/Schema/packages/highlights-wp/src",
+            "PoPSchema\\\\Highlights\\\\": "layers/Schema/packages/highlights/src",
+            "PoPSchema\\\\LocationPostsWP\\\\": "layers/Schema/packages/locationposts-wp/src",
+            "PoPSchema\\\\LocationPosts\\\\": "layers/Schema/packages/locationposts/src",
+            "PoPSchema\\\\LocationsWPEM\\\\": "layers/Schema/packages/locations-wp-em/src",
+            "PoPSchema\\\\Locations\\\\": "layers/Schema/packages/locations/src",
+            "PoPSchema\\\\MediaWP\\\\": "layers/Schema/packages/media-wp/src",
+            "PoPSchema\\\\Media\\\\": "layers/Schema/packages/media/src",
+            "PoPSchema\\\\MenusWP\\\\": "layers/Schema/packages/menus-wp/src",
+            "PoPSchema\\\\Menus\\\\": "layers/Schema/packages/menus/src",
+            "PoPSchema\\\\MetaQueryWP\\\\": "layers/Schema/packages/metaquery-wp/src",
+            "PoPSchema\\\\MetaQuery\\\\": "layers/Schema/packages/metaquery/src",
+            "PoPSchema\\\\Meta\\\\": "layers/Schema/packages/meta/src",
+            "PoPSchema\\\\NotificationsWP\\\\": "layers/Schema/packages/notifications-wp/src",
+            "PoPSchema\\\\Notifications\\\\": "layers/Schema/packages/notifications/src",
+            "PoPSchema\\\\PagesWP\\\\": "layers/Schema/packages/pages-wp/src",
+            "PoPSchema\\\\Pages\\\\": "layers/Schema/packages/pages/src",
+            "PoPSchema\\\\PostMutations\\\\": "layers/Schema/packages/post-mutations/src",
+            "PoPSchema\\\\PostTagsWP\\\\": "layers/Schema/packages/post-tags-wp/src",
+            "PoPSchema\\\\PostTags\\\\": "layers/Schema/packages/post-tags/src",
+            "PoPSchema\\\\PostsWP\\\\": "layers/Schema/packages/posts-wp/src",
+            "PoPSchema\\\\Posts\\\\": "layers/Schema/packages/posts/src",
+            "PoPSchema\\\\QueriedObjectWP\\\\": "layers/Schema/packages/queriedobject-wp/src",
+            "PoPSchema\\\\QueriedObject\\\\": "layers/Schema/packages/queriedobject/src",
+            "PoPSchema\\\\SchemaCommons\\\\": "layers/Schema/packages/schema-commons/src",
+            "PoPSchema\\\\StancesWP\\\\": "layers/Schema/packages/stances-wp/src",
+            "PoPSchema\\\\Stances\\\\": "layers/Schema/packages/stances/src",
+            "PoPSchema\\\\TagsWP\\\\": "layers/Schema/packages/tags-wp/src",
+            "PoPSchema\\\\Tags\\\\": "layers/Schema/packages/tags/src",
+            "PoPSchema\\\\TaxonomiesWP\\\\": "layers/Schema/packages/taxonomies-wp/src",
+            "PoPSchema\\\\Taxonomies\\\\": "layers/Schema/packages/taxonomies/src",
+            "PoPSchema\\\\TaxonomyMetaWP\\\\": "layers/Schema/packages/taxonomymeta-wp/src",
+            "PoPSchema\\\\TaxonomyMeta\\\\": "layers/Schema/packages/taxonomymeta/src",
+            "PoPSchema\\\\TaxonomyQueryWP\\\\": "layers/Schema/packages/taxonomyquery-wp/src",
+            "PoPSchema\\\\TaxonomyQuery\\\\": "layers/Schema/packages/taxonomyquery/src",
+            "PoPSchema\\\\TranslateDirectiveACL\\\\": "layers/Schema/packages/translate-directive-acl/src",
+            "PoPSchema\\\\TranslateDirective\\\\": "layers/Schema/packages/translate-directive/src",
+            "PoPSchema\\\\UserMetaWP\\\\": "layers/Schema/packages/usermeta-wp/src",
+            "PoPSchema\\\\UserMeta\\\\": "layers/Schema/packages/usermeta/src",
+            "PoPSchema\\\\UserRolesACL\\\\": "layers/Schema/packages/user-roles-acl/src",
+            "PoPSchema\\\\UserRolesAccessControl\\\\": "layers/Schema/packages/user-roles-access-control/src",
+            "PoPSchema\\\\UserRolesWP\\\\": "layers/Schema/packages/user-roles-wp/src",
+            "PoPSchema\\\\UserRoles\\\\": "layers/Schema/packages/user-roles/src",
+            "PoPSchema\\\\UserStateAccessControl\\\\": "layers/Schema/packages/user-state-access-control/src",
+            "PoPSchema\\\\UserStateMutationsWP\\\\": "layers/Schema/packages/user-state-mutations-wp/src",
+            "PoPSchema\\\\UserStateMutations\\\\": "layers/Schema/packages/user-state-mutations/src",
+            "PoPSchema\\\\UserStateWP\\\\": "layers/Schema/packages/user-state-wp/src",
+            "PoPSchema\\\\UserState\\\\": "layers/Schema/packages/user-state/src",
+            "PoPSchema\\\\UsersWP\\\\": "layers/Schema/packages/users-wp/src",
+            "PoPSchema\\\\Users\\\\": "layers/Schema/packages/users/src",
+            "PoPSitesWassup\\\\CommentMutations\\\\": "layers/Wassup/packages/comment-mutations/src",
+            "PoPSitesWassup\\\\ContactUsMutations\\\\": "layers/Wassup/packages/contactus-mutations/src",
+            "PoPSitesWassup\\\\ContactUserMutations\\\\": "layers/Wassup/packages/contactuser-mutations/src",
+            "PoPSitesWassup\\\\CustomPostLinkMutations\\\\": "layers/Wassup/packages/custompostlink-mutations/src",
+            "PoPSitesWassup\\\\CustomPostMutations\\\\": "layers/Wassup/packages/custompost-mutations/src",
+            "PoPSitesWassup\\\\EventLinkMutations\\\\": "layers/Wassup/packages/eventlink-mutations/src",
+            "PoPSitesWassup\\\\EventMutations\\\\": "layers/Wassup/packages/event-mutations/src",
+            "PoPSitesWassup\\\\EverythingElseMutations\\\\": "layers/Wassup/packages/everythingelse-mutations/src",
+            "PoPSitesWassup\\\\FlagMutations\\\\": "layers/Wassup/packages/flag-mutations/src",
+            "PoPSitesWassup\\\\FormMutations\\\\": "layers/Wassup/packages/form-mutations/src",
+            "PoPSitesWassup\\\\GravityFormsMutations\\\\": "layers/Wassup/packages/gravityforms-mutations/src",
+            "PoPSitesWassup\\\\HighlightMutations\\\\": "layers/Wassup/packages/highlight-mutations/src",
+            "PoPSitesWassup\\\\LocationMutations\\\\": "layers/Wassup/packages/location-mutations/src",
+            "PoPSitesWassup\\\\LocationPostLinkMutations\\\\": "layers/Wassup/packages/locationpostlink-mutations/src",
+            "PoPSitesWassup\\\\LocationPostMutations\\\\": "layers/Wassup/packages/locationpost-mutations/src",
+            "PoPSitesWassup\\\\NewsletterMutations\\\\": "layers/Wassup/packages/newsletter-mutations/src",
+            "PoPSitesWassup\\\\NotificationMutations\\\\": "layers/Wassup/packages/notification-mutations/src",
+            "PoPSitesWassup\\\\PostLinkMutations\\\\": "layers/Wassup/packages/postlink-mutations/src",
+            "PoPSitesWassup\\\\PostMutations\\\\": "layers/Wassup/packages/post-mutations/src",
+            "PoPSitesWassup\\\\ShareMutations\\\\": "layers/Wassup/packages/share-mutations/src",
+            "PoPSitesWassup\\\\SocialNetworkMutations\\\\": "layers/Wassup/packages/socialnetwork-mutations/src",
+            "PoPSitesWassup\\\\StanceMutations\\\\": "layers/Wassup/packages/stance-mutations/src",
+            "PoPSitesWassup\\\\SystemMutations\\\\": "layers/Wassup/packages/system-mutations/src",
+            "PoPSitesWassup\\\\UserStateMutations\\\\": "layers/Wassup/packages/user-state-mutations/src",
+            "PoPSitesWassup\\\\VolunteerMutations\\\\": "layers/Wassup/packages/volunteer-mutations/src",
+            "PoPSitesWassup\\\\Wassup\\\\": "layers/Wassup/packages/wassup/src",
+            "PoP\\\\APIClients\\\\": "layers/API/packages/api-clients/src",
+            "PoP\\\\APIEndpointsForWP\\\\": "layers/API/packages/api-endpoints-for-wp/src",
+            "PoP\\\\APIEndpoints\\\\": "layers/API/packages/api-endpoints/src",
+            "PoP\\\\APIMirrorQuery\\\\": "layers/API/packages/api-mirrorquery/src",
+            "PoP\\\\API\\\\": "layers/API/packages/api/src",
+            "PoP\\\\AccessControl\\\\": "layers/Engine/packages/access-control/src",
+            "PoP\\\\ApplicationWP\\\\": "layers/SiteBuilder/packages/application-wp/src",
+            "PoP\\\\Application\\\\": "layers/SiteBuilder/packages/application/src",
+            "PoP\\\\Base36Definitions\\\\": "layers/SiteBuilder/packages/definitions-base36/src",
+            "PoP\\\\CacheControl\\\\": "layers/Engine/packages/cache-control/src",
+            "PoP\\\\ComponentModel\\\\": "layers/Engine/packages/component-model/src",
+            "PoP\\\\ConfigurableSchemaFeedback\\\\": "layers/Engine/packages/configurable-schema-feedback/src",
+            "PoP\\\\ConfigurationComponentModel\\\\": "layers/SiteBuilder/packages/component-model-configuration/src",
+            "PoP\\\\DefinitionPersistence\\\\": "layers/SiteBuilder/packages/definitionpersistence/src",
+            "PoP\\\\Definitions\\\\": "layers/Engine/packages/definitions/src",
+            "PoP\\\\EmojiDefinitions\\\\": "layers/SiteBuilder/packages/definitions-emoji/src",
+            "PoP\\\\EngineWP\\\\": "layers/Engine/packages/engine-wp/src",
+            "PoP\\\\Engine\\\\": "layers/Engine/packages/engine/src",
+            "PoP\\\\FieldQuery\\\\": "layers/Engine/packages/field-query/src",
+            "PoP\\\\FileStore\\\\": "layers/Engine/packages/filestore/src",
+            "PoP\\\\FunctionFields\\\\": "layers/Engine/packages/function-fields/src",
+            "PoP\\\\GraphQLAPI\\\\": "layers/API/packages/api-graphql/src",
+            "PoP\\\\GuzzleHelpers\\\\": "layers/Engine/packages/guzzle-helpers/src",
+            "PoP\\\\HooksWP\\\\": "layers/Engine/packages/hooks-wp/src",
+            "PoP\\\\Hooks\\\\": "layers/Engine/packages/hooks/src",
+            "PoP\\\\LooseContracts\\\\": "layers/Engine/packages/loosecontracts/src",
+            "PoP\\\\MandatoryDirectivesByConfiguration\\\\": "layers/Engine/packages/mandatory-directives-by-configuration/src",
+            "PoP\\\\ModuleRouting\\\\": "layers/Engine/packages/modulerouting/src",
+            "PoP\\\\Multisite\\\\": "layers/SiteBuilder/packages/multisite/src",
+            "PoP\\\\PoP\\\\": "src",
+            "PoP\\\\QueryParsing\\\\": "layers/Engine/packages/query-parsing/src",
+            "PoP\\\\RESTAPI\\\\": "layers/API/packages/api-rest/src",
+            "PoP\\\\ResourceLoader\\\\": "layers/SiteBuilder/packages/resourceloader/src",
+            "PoP\\\\Resources\\\\": "layers/SiteBuilder/packages/resources/src",
+            "PoP\\\\Root\\\\": "layers/Engine/packages/root/src",
+            "PoP\\\\RoutingWP\\\\": "layers/Engine/packages/routing-wp/src",
+            "PoP\\\\Routing\\\\": "layers/Engine/packages/routing/src",
+            "PoP\\\\SPA\\\\": "layers/SiteBuilder/packages/spa/src",
+            "PoP\\\\SSG\\\\": "layers/SiteBuilder/packages/static-site-generator/src",
+            "PoP\\\\SiteWP\\\\": "layers/SiteBuilder/packages/site-wp/src",
+            "PoP\\\\Site\\\\": "layers/SiteBuilder/packages/site/src",
+            "PoP\\\\TraceTools\\\\": "layers/Engine/packages/trace-tools/src",
+            "PoP\\\\TranslationWP\\\\": "layers/Engine/packages/translation-wp/src",
+            "PoP\\\\Translation\\\\": "layers/Engine/packages/translation/src"
+        }
+    },
+    "autoload-dev": {
+        "psr-4": {
+            "GraphQLAPI\\\\ConvertCaseDirectives\\\\": "layers/GraphQLAPIForWP/plugins/convert-case-directives/tests",
+            "GraphQLAPI\\\\GraphQLAPI\\\\": "layers/GraphQLAPIForWP/plugins/graphql-api-for-wp/tests",
+            "GraphQLAPI\\\\SchemaFeedback\\\\": "layers/GraphQLAPIForWP/plugins/schema-feedback/tests",
+            "GraphQLByPoP\\\\GraphQLClientsForWP\\\\": "layers/GraphQLByPoP/packages/graphql-clients-for-wp/tests",
+            "GraphQLByPoP\\\\GraphQLEndpointForWP\\\\": "layers/GraphQLByPoP/packages/graphql-endpoint-for-wp/tests",
+            "GraphQLByPoP\\\\GraphQLParser\\\\": "layers/GraphQLByPoP/packages/graphql-parser/tests",
+            "GraphQLByPoP\\\\GraphQLQuery\\\\": "layers/GraphQLByPoP/packages/graphql-query/tests",
+            "GraphQLByPoP\\\\GraphQLRequest\\\\": "layers/GraphQLByPoP/packages/graphql-request/tests",
+            "GraphQLByPoP\\\\GraphQLServer\\\\": "layers/GraphQLByPoP/packages/graphql-server/tests",
+            "Leoloso\\\\ExamplesForPoP\\\\": "layers/Misc/packages/examples-for-pop/tests",
+            "PoPSchema\\\\BasicDirectives\\\\": "layers/Schema/packages/basic-directives/tests",
+            "PoPSchema\\\\BlockMetadataWP\\\\": "layers/Schema/packages/block-metadata-for-wp/tests",
+            "PoPSchema\\\\CDNDirective\\\\": "layers/Schema/packages/cdn-directive/tests",
+            "PoPSchema\\\\CategoriesWP\\\\": "layers/Schema/packages/categories-wp/tests",
+            "PoPSchema\\\\Categories\\\\": "layers/Schema/packages/categories/tests",
+            "PoPSchema\\\\CommentMetaWP\\\\": "layers/Schema/packages/commentmeta-wp/tests",
+            "PoPSchema\\\\CommentMeta\\\\": "layers/Schema/packages/commentmeta/tests",
+            "PoPSchema\\\\CommentMutationsWP\\\\": "layers/Schema/packages/comment-mutations-wp/tests",
+            "PoPSchema\\\\CommentMutations\\\\": "layers/Schema/packages/comment-mutations/tests",
+            "PoPSchema\\\\CommentsWP\\\\": "layers/Schema/packages/comments-wp/tests",
+            "PoPSchema\\\\Comments\\\\": "layers/Schema/packages/comments/tests",
+            "PoPSchema\\\\ConvertCaseDirectives\\\\": "layers/Schema/packages/convert-case-directives/tests",
+            "PoPSchema\\\\CustomPostMediaMutationsWP\\\\": "layers/Schema/packages/custompostmedia-mutations-wp/tests",
+            "PoPSchema\\\\CustomPostMediaMutations\\\\": "layers/Schema/packages/custompostmedia-mutations/tests",
+            "PoPSchema\\\\CustomPostMediaWP\\\\": "layers/Schema/packages/custompostmedia-wp/tests",
+            "PoPSchema\\\\CustomPostMedia\\\\": "layers/Schema/packages/custompostmedia/tests",
+            "PoPSchema\\\\CustomPostMetaWP\\\\": "layers/Schema/packages/custompostmeta-wp/tests",
+            "PoPSchema\\\\CustomPostMeta\\\\": "layers/Schema/packages/custompostmeta/tests",
+            "PoPSchema\\\\CustomPostMutationsWP\\\\": "layers/Schema/packages/custompost-mutations-wp/tests",
+            "PoPSchema\\\\CustomPostMutations\\\\": "layers/Schema/packages/custompost-mutations/tests",
+            "PoPSchema\\\\CustomPostsWP\\\\": "layers/Schema/packages/customposts-wp/tests",
+            "PoPSchema\\\\CustomPosts\\\\": "layers/Schema/packages/customposts/tests",
+            "PoPSchema\\\\EventMutationsWPEM\\\\": "layers/Schema/packages/event-mutations-wp-em/tests",
+            "PoPSchema\\\\EventMutations\\\\": "layers/Schema/packages/event-mutations/tests",
+            "PoPSchema\\\\EventsWPEM\\\\": "layers/Schema/packages/events-wp-em/tests",
+            "PoPSchema\\\\Events\\\\": "layers/Schema/packages/events/tests",
+            "PoPSchema\\\\EverythingElseWP\\\\": "layers/Schema/packages/everythingelse-wp/tests",
+            "PoPSchema\\\\EverythingElse\\\\": "layers/Schema/packages/everythingelse/tests",
+            "PoPSchema\\\\GenericCustomPosts\\\\": "layers/Schema/packages/generic-customposts/tests",
+            "PoPSchema\\\\GoogleTranslateDirectiveForCustomPosts\\\\": "layers/Schema/packages/google-translate-directive-for-customposts/tests",
+            "PoPSchema\\\\GoogleTranslateDirective\\\\": "layers/Schema/packages/google-translate-directive/tests",
+            "PoPSchema\\\\HighlightsWP\\\\": "layers/Schema/packages/highlights-wp/tests",
+            "PoPSchema\\\\Highlights\\\\": "layers/Schema/packages/highlights/tests",
+            "PoPSchema\\\\LocationPostsWP\\\\": "layers/Schema/packages/locationposts-wp/tests",
+            "PoPSchema\\\\LocationPosts\\\\": "layers/Schema/packages/locationposts/tests",
+            "PoPSchema\\\\LocationsWPEM\\\\": "layers/Schema/packages/locations-wp-em/tests",
+            "PoPSchema\\\\Locations\\\\": "layers/Schema/packages/locations/tests",
+            "PoPSchema\\\\MediaWP\\\\": "layers/Schema/packages/media-wp/tests",
+            "PoPSchema\\\\Media\\\\": "layers/Schema/packages/media/tests",
+            "PoPSchema\\\\MenusWP\\\\": "layers/Schema/packages/menus-wp/tests",
+            "PoPSchema\\\\Menus\\\\": "layers/Schema/packages/menus/tests",
+            "PoPSchema\\\\MetaQueryWP\\\\": "layers/Schema/packages/metaquery-wp/tests",
+            "PoPSchema\\\\MetaQuery\\\\": "layers/Schema/packages/metaquery/tests",
+            "PoPSchema\\\\Meta\\\\": "layers/Schema/packages/meta/tests",
+            "PoPSchema\\\\NotificationsWP\\\\": "layers/Schema/packages/notifications-wp/tests",
+            "PoPSchema\\\\Notifications\\\\": "layers/Schema/packages/notifications/tests",
+            "PoPSchema\\\\PagesWP\\\\": "layers/Schema/packages/pages-wp/tests",
+            "PoPSchema\\\\Pages\\\\": "layers/Schema/packages/pages/tests",
+            "PoPSchema\\\\PostMutations\\\\": "layers/Schema/packages/post-mutations/tests",
+            "PoPSchema\\\\PostTagsWP\\\\": "layers/Schema/packages/post-tags-wp/tests",
+            "PoPSchema\\\\PostTags\\\\": "layers/Schema/packages/post-tags/tests",
+            "PoPSchema\\\\PostsWP\\\\": "layers/Schema/packages/posts-wp/tests",
+            "PoPSchema\\\\Posts\\\\": "layers/Schema/packages/posts/tests",
+            "PoPSchema\\\\QueriedObjectWP\\\\": "layers/Schema/packages/queriedobject-wp/tests",
+            "PoPSchema\\\\QueriedObject\\\\": "layers/Schema/packages/queriedobject/tests",
+            "PoPSchema\\\\SchemaCommons\\\\": "layers/Schema/packages/schema-commons/tests",
+            "PoPSchema\\\\StancesWP\\\\": "layers/Schema/packages/stances-wp/tests",
+            "PoPSchema\\\\Stances\\\\": "layers/Schema/packages/stances/tests",
+            "PoPSchema\\\\TagsWP\\\\": "layers/Schema/packages/tags-wp/tests",
+            "PoPSchema\\\\Tags\\\\": "layers/Schema/packages/tags/tests",
+            "PoPSchema\\\\TaxonomiesWP\\\\": "layers/Schema/packages/taxonomies-wp/tests",
+            "PoPSchema\\\\Taxonomies\\\\": "layers/Schema/packages/taxonomies/tests",
+            "PoPSchema\\\\TaxonomyMetaWP\\\\": "layers/Schema/packages/taxonomymeta-wp/tests",
+            "PoPSchema\\\\TaxonomyMeta\\\\": "layers/Schema/packages/taxonomymeta/tests",
+            "PoPSchema\\\\TaxonomyQueryWP\\\\": "layers/Schema/packages/taxonomyquery-wp/tests",
+            "PoPSchema\\\\TaxonomyQuery\\\\": "layers/Schema/packages/taxonomyquery/tests",
+            "PoPSchema\\\\TranslateDirectiveACL\\\\": "layers/Schema/packages/translate-directive-acl/tests",
+            "PoPSchema\\\\TranslateDirective\\\\": "layers/Schema/packages/translate-directive/tests",
+            "PoPSchema\\\\UserMetaWP\\\\": "layers/Schema/packages/usermeta-wp/tests",
+            "PoPSchema\\\\UserMeta\\\\": "layers/Schema/packages/usermeta/tests",
+            "PoPSchema\\\\UserRolesACL\\\\": "layers/Schema/packages/user-roles-acl/tests",
+            "PoPSchema\\\\UserRolesAccessControl\\\\": "layers/Schema/packages/user-roles-access-control/tests",
+            "PoPSchema\\\\UserRolesWP\\\\": "layers/Schema/packages/user-roles-wp/tests",
+            "PoPSchema\\\\UserRoles\\\\": "layers/Schema/packages/user-roles/tests",
+            "PoPSchema\\\\UserStateAccessControl\\\\": "layers/Schema/packages/user-state-access-control/tests",
+            "PoPSchema\\\\UserStateMutationsWP\\\\": "layers/Schema/packages/user-state-mutations-wp/tests",
+            "PoPSchema\\\\UserStateMutations\\\\": "layers/Schema/packages/user-state-mutations/tests",
+            "PoPSchema\\\\UserStateWP\\\\": "layers/Schema/packages/user-state-wp/tests",
+            "PoPSchema\\\\UserState\\\\": "layers/Schema/packages/user-state/tests",
+            "PoPSchema\\\\UsersWP\\\\": "layers/Schema/packages/users-wp/tests",
+            "PoPSchema\\\\Users\\\\": "layers/Schema/packages/users/tests",
+            "PoPSitesWassup\\\\CommentMutations\\\\": "layers/Wassup/packages/comment-mutations/tests",
+            "PoPSitesWassup\\\\ContactUsMutations\\\\": "layers/Wassup/packages/contactus-mutations/tests",
+            "PoPSitesWassup\\\\ContactUserMutations\\\\": "layers/Wassup/packages/contactuser-mutations/tests",
+            "PoPSitesWassup\\\\CustomPostLinkMutations\\\\": "layers/Wassup/packages/custompostlink-mutations/tests",
+            "PoPSitesWassup\\\\CustomPostMutations\\\\": "layers/Wassup/packages/custompost-mutations/tests",
+            "PoPSitesWassup\\\\EventLinkMutations\\\\": "layers/Wassup/packages/eventlink-mutations/tests",
+            "PoPSitesWassup\\\\EventMutations\\\\": "layers/Wassup/packages/event-mutations/tests",
+            "PoPSitesWassup\\\\EverythingElseMutations\\\\": "layers/Wassup/packages/everythingelse-mutations/tests",
+            "PoPSitesWassup\\\\FlagMutations\\\\": "layers/Wassup/packages/flag-mutations/tests",
+            "PoPSitesWassup\\\\FormMutations\\\\": "layers/Wassup/packages/form-mutations/tests",
+            "PoPSitesWassup\\\\GravityFormsMutations\\\\": "layers/Wassup/packages/gravityforms-mutations/tests",
+            "PoPSitesWassup\\\\HighlightMutations\\\\": "layers/Wassup/packages/highlight-mutations/tests",
+            "PoPSitesWassup\\\\LocationMutations\\\\": "layers/Wassup/packages/location-mutations/tests",
+            "PoPSitesWassup\\\\LocationPostLinkMutations\\\\": "layers/Wassup/packages/locationpostlink-mutations/tests",
+            "PoPSitesWassup\\\\LocationPostMutations\\\\": "layers/Wassup/packages/locationpost-mutations/tests",
+            "PoPSitesWassup\\\\NewsletterMutations\\\\": "layers/Wassup/packages/newsletter-mutations/tests",
+            "PoPSitesWassup\\\\NotificationMutations\\\\": "layers/Wassup/packages/notification-mutations/tests",
+            "PoPSitesWassup\\\\PostLinkMutations\\\\": "layers/Wassup/packages/postlink-mutations/tests",
+            "PoPSitesWassup\\\\PostMutations\\\\": "layers/Wassup/packages/post-mutations/tests",
+            "PoPSitesWassup\\\\ShareMutations\\\\": "layers/Wassup/packages/share-mutations/tests",
+            "PoPSitesWassup\\\\SocialNetworkMutations\\\\": "layers/Wassup/packages/socialnetwork-mutations/tests",
+            "PoPSitesWassup\\\\StanceMutations\\\\": "layers/Wassup/packages/stance-mutations/tests",
+            "PoPSitesWassup\\\\SystemMutations\\\\": "layers/Wassup/packages/system-mutations/tests",
+            "PoPSitesWassup\\\\UserStateMutations\\\\": "layers/Wassup/packages/user-state-mutations/tests",
+            "PoPSitesWassup\\\\VolunteerMutations\\\\": "layers/Wassup/packages/volunteer-mutations/tests",
+            "PoPSitesWassup\\\\Wassup\\\\": "layers/Wassup/packages/wassup/tests",
+            "PoP\\\\APIClients\\\\": "layers/API/packages/api-clients/tests",
+            "PoP\\\\APIEndpointsForWP\\\\": "layers/API/packages/api-endpoints-for-wp/tests",
+            "PoP\\\\APIEndpoints\\\\": "layers/API/packages/api-endpoints/tests",
+            "PoP\\\\APIMirrorQuery\\\\": "layers/API/packages/api-mirrorquery/tests",
+            "PoP\\\\API\\\\": "layers/API/packages/api/tests",
+            "PoP\\\\AccessControl\\\\": "layers/Engine/packages/access-control/tests",
+            "PoP\\\\ApplicationWP\\\\": "layers/SiteBuilder/packages/application-wp/tests",
+            "PoP\\\\Application\\\\": "layers/SiteBuilder/packages/application/tests",
+            "PoP\\\\Base36Definitions\\\\": "layers/SiteBuilder/packages/definitions-base36/tests",
+            "PoP\\\\CacheControl\\\\": "layers/Engine/packages/cache-control/tests",
+            "PoP\\\\ComponentModel\\\\": "layers/Engine/packages/component-model/tests",
+            "PoP\\\\ConfigurableSchemaFeedback\\\\": "layers/Engine/packages/configurable-schema-feedback/tests",
+            "PoP\\\\ConfigurationComponentModel\\\\": "layers/SiteBuilder/packages/component-model-configuration/tests",
+            "PoP\\\\DefinitionPersistence\\\\": "layers/SiteBuilder/packages/definitionpersistence/tests",
+            "PoP\\\\Definitions\\\\": "layers/Engine/packages/definitions/tests",
+            "PoP\\\\EmojiDefinitions\\\\": "layers/SiteBuilder/packages/definitions-emoji/tests",
+            "PoP\\\\EngineWP\\\\": "layers/Engine/packages/engine-wp/tests",
+            "PoP\\\\Engine\\\\": "layers/Engine/packages/engine/tests",
+            "PoP\\\\FieldQuery\\\\": "layers/Engine/packages/field-query/tests",
+            "PoP\\\\FileStore\\\\": "layers/Engine/packages/filestore/tests",
+            "PoP\\\\FunctionFields\\\\": "layers/Engine/packages/function-fields/tests",
+            "PoP\\\\GraphQLAPI\\\\": "layers/API/packages/api-graphql/tests",
+            "PoP\\\\GuzzleHelpers\\\\": "layers/Engine/packages/guzzle-helpers/tests",
+            "PoP\\\\HooksWP\\\\": "layers/Engine/packages/hooks-wp/tests",
+            "PoP\\\\Hooks\\\\": "layers/Engine/packages/hooks/tests",
+            "PoP\\\\LooseContracts\\\\": "layers/Engine/packages/loosecontracts/tests",
+            "PoP\\\\MandatoryDirectivesByConfiguration\\\\": "layers/Engine/packages/mandatory-directives-by-configuration/tests",
+            "PoP\\\\ModuleRouting\\\\": "layers/Engine/packages/modulerouting/tests",
+            "PoP\\\\Multisite\\\\": "layers/SiteBuilder/packages/multisite/tests",
+            "PoP\\\\QueryParsing\\\\": "layers/Engine/packages/query-parsing/tests",
+            "PoP\\\\RESTAPI\\\\": "layers/API/packages/api-rest/tests",
+            "PoP\\\\ResourceLoader\\\\": "layers/SiteBuilder/packages/resourceloader/tests",
+            "PoP\\\\Resources\\\\": "layers/SiteBuilder/packages/resources/tests",
+            "PoP\\\\Root\\\\": "layers/Engine/packages/root/tests",
+            "PoP\\\\RoutingWP\\\\": "layers/Engine/packages/routing-wp/tests",
+            "PoP\\\\Routing\\\\": "layers/Engine/packages/routing/tests",
+            "PoP\\\\SPA\\\\": "layers/SiteBuilder/packages/spa/tests",
+            "PoP\\\\SSG\\\\": "layers/SiteBuilder/packages/static-site-generator/tests",
+            "PoP\\\\SiteWP\\\\": "layers/SiteBuilder/packages/site-wp/tests",
+            "PoP\\\\Site\\\\": "layers/SiteBuilder/packages/site/tests",
+            "PoP\\\\TraceTools\\\\": "layers/Engine/packages/trace-tools/tests",
+            "PoP\\\\TranslationWP\\\\": "layers/Engine/packages/translation-wp/tests",
+            "PoP\\\\Translation\\\\": "layers/Engine/packages/translation/tests"
+        }
+    },
+    "extra": {
+        "wordpress-install-dir": "vendor/wordpress/wordpress",
+        "merge-plugin": {
+            "include": [
+                "composer.local.json"
+            ],
+            "recurse": true,
+            "replace": false,
+            "ignore-duplicates": false,
+            "merge-dev": true,
+            "merge-extra": false,
+            "merge-extra-deep": false,
+            "merge-scripts": false
+        }
+    },
+    "replace": {
+        "getpop/access-control": "self.version",
+        "getpop/api": "self.version",
+        "getpop/api-clients": "self.version",
+        "getpop/api-endpoints": "self.version",
+        "getpop/api-endpoints-for-wp": "self.version",
+        "getpop/api-graphql": "self.version",
+        "getpop/api-mirrorquery": "self.version",
+        "getpop/api-rest": "self.version",
+        "getpop/application": "self.version",
+        "getpop/application-wp": "self.version",
+        "getpop/cache-control": "self.version",
+        "getpop/component-model": "self.version",
+        "getpop/component-model-configuration": "self.version",
+        "getpop/configurable-schema-feedback": "self.version",
+        "getpop/definitionpersistence": "self.version",
+        "getpop/definitions": "self.version",
+        "getpop/definitions-base36": "self.version",
+        "getpop/definitions-emoji": "self.version",
+        "getpop/engine": "self.version",
+        "getpop/engine-wp": "self.version",
+        "getpop/engine-wp-bootloader": "self.version",
+        "getpop/field-query": "self.version",
+        "getpop/filestore": "self.version",
+        "getpop/function-fields": "self.version",
+        "getpop/guzzle-helpers": "self.version",
+        "getpop/hooks": "self.version",
+        "getpop/hooks-wp": "self.version",
+        "getpop/loosecontracts": "self.version",
+        "getpop/mandatory-directives-by-configuration": "self.version",
+        "getpop/migrate-api": "self.version",
+        "getpop/migrate-api-graphql": "self.version",
+        "getpop/migrate-component-model": "self.version",
+        "getpop/migrate-component-model-configuration": "self.version",
+        "getpop/migrate-engine": "self.version",
+        "getpop/migrate-engine-wp": "self.version",
+        "getpop/migrate-static-site-generator": "self.version",
+        "getpop/modulerouting": "self.version",
+        "getpop/multisite": "self.version",
+        "getpop/query-parsing": "self.version",
+        "getpop/resourceloader": "self.version",
+        "getpop/resources": "self.version",
+        "getpop/root": "self.version",
+        "getpop/routing": "self.version",
+        "getpop/routing-wp": "self.version",
+        "getpop/site": "self.version",
+        "getpop/site-wp": "self.version",
+        "getpop/spa": "self.version",
+        "getpop/static-site-generator": "self.version",
+        "getpop/trace-tools": "self.version",
+        "getpop/translation": "self.version",
+        "getpop/translation-wp": "self.version",
+        "graphql-api/convert-case-directives": "self.version",
+        "graphql-api/graphql-api-for-wp": "self.version",
+        "graphql-api/schema-feedback": "self.version",
+        "graphql-by-pop/graphql-clients-for-wp": "self.version",
+        "graphql-by-pop/graphql-endpoint-for-wp": "self.version",
+        "graphql-by-pop/graphql-parser": "self.version",
+        "graphql-by-pop/graphql-query": "self.version",
+        "graphql-by-pop/graphql-request": "self.version",
+        "graphql-by-pop/graphql-server": "self.version",
+        "leoloso/examples-for-pop": "self.version",
+        "pop-migrate-everythingelse/cssconverter": "self.version",
+        "pop-migrate-everythingelse/ssr": "self.version",
+        "pop-schema/basic-directives": "self.version",
+        "pop-schema/block-metadata-for-wp": "self.version",
+        "pop-schema/categories": "self.version",
+        "pop-schema/categories-wp": "self.version",
+        "pop-schema/cdn-directive": "self.version",
+        "pop-schema/comment-mutations": "self.version",
+        "pop-schema/comment-mutations-wp": "self.version",
+        "pop-schema/commentmeta": "self.version",
+        "pop-schema/commentmeta-wp": "self.version",
+        "pop-schema/comments": "self.version",
+        "pop-schema/comments-wp": "self.version",
+        "pop-schema/convert-case-directives": "self.version",
+        "pop-schema/custompost-mutations": "self.version",
+        "pop-schema/custompost-mutations-wp": "self.version",
+        "pop-schema/custompostmedia": "self.version",
+        "pop-schema/custompostmedia-mutations": "self.version",
+        "pop-schema/custompostmedia-mutations-wp": "self.version",
+        "pop-schema/custompostmedia-wp": "self.version",
+        "pop-schema/custompostmeta": "self.version",
+        "pop-schema/custompostmeta-wp": "self.version",
+        "pop-schema/customposts": "self.version",
+        "pop-schema/customposts-wp": "self.version",
+        "pop-schema/event-mutations": "self.version",
+        "pop-schema/event-mutations-wp-em": "self.version",
+        "pop-schema/events": "self.version",
+        "pop-schema/events-wp-em": "self.version",
+        "pop-schema/everythingelse": "self.version",
+        "pop-schema/everythingelse-wp": "self.version",
+        "pop-schema/generic-customposts": "self.version",
+        "pop-schema/google-translate-directive": "self.version",
+        "pop-schema/google-translate-directive-for-customposts": "self.version",
+        "pop-schema/highlights": "self.version",
+        "pop-schema/highlights-wp": "self.version",
+        "pop-schema/locationposts": "self.version",
+        "pop-schema/locationposts-wp": "self.version",
+        "pop-schema/locations": "self.version",
+        "pop-schema/locations-wp-em": "self.version",
+        "pop-schema/media": "self.version",
+        "pop-schema/media-wp": "self.version",
+        "pop-schema/menus": "self.version",
+        "pop-schema/menus-wp": "self.version",
+        "pop-schema/meta": "self.version",
+        "pop-schema/metaquery": "self.version",
+        "pop-schema/metaquery-wp": "self.version",
+        "pop-schema/migrate-categories": "self.version",
+        "pop-schema/migrate-categories-wp": "self.version",
+        "pop-schema/migrate-commentmeta": "self.version",
+        "pop-schema/migrate-commentmeta-wp": "self.version",
+        "pop-schema/migrate-comments": "self.version",
+        "pop-schema/migrate-comments-wp": "self.version",
+        "pop-schema/migrate-custompostmedia": "self.version",
+        "pop-schema/migrate-custompostmedia-wp": "self.version",
+        "pop-schema/migrate-custompostmeta": "self.version",
+        "pop-schema/migrate-custompostmeta-wp": "self.version",
+        "pop-schema/migrate-customposts": "self.version",
+        "pop-schema/migrate-customposts-wp": "self.version",
+        "pop-schema/migrate-events": "self.version",
+        "pop-schema/migrate-events-wp-em": "self.version",
+        "pop-schema/migrate-everythingelse": "self.version",
+        "pop-schema/migrate-locations": "self.version",
+        "pop-schema/migrate-locations-wp-em": "self.version",
+        "pop-schema/migrate-media": "self.version",
+        "pop-schema/migrate-media-wp": "self.version",
+        "pop-schema/migrate-meta": "self.version",
+        "pop-schema/migrate-metaquery": "self.version",
+        "pop-schema/migrate-metaquery-wp": "self.version",
+        "pop-schema/migrate-pages": "self.version",
+        "pop-schema/migrate-pages-wp": "self.version",
+        "pop-schema/migrate-post-tags": "self.version",
+        "pop-schema/migrate-post-tags-wp": "self.version",
+        "pop-schema/migrate-posts": "self.version",
+        "pop-schema/migrate-posts-wp": "self.version",
+        "pop-schema/migrate-queriedobject": "self.version",
+        "pop-schema/migrate-queriedobject-wp": "self.version",
+        "pop-schema/migrate-tags": "self.version",
+        "pop-schema/migrate-tags-wp": "self.version",
+        "pop-schema/migrate-taxonomies": "self.version",
+        "pop-schema/migrate-taxonomies-wp": "self.version",
+        "pop-schema/migrate-taxonomymeta": "self.version",
+        "pop-schema/migrate-taxonomymeta-wp": "self.version",
+        "pop-schema/migrate-taxonomyquery": "self.version",
+        "pop-schema/migrate-taxonomyquery-wp": "self.version",
+        "pop-schema/migrate-usermeta": "self.version",
+        "pop-schema/migrate-usermeta-wp": "self.version",
+        "pop-schema/migrate-users": "self.version",
+        "pop-schema/migrate-users-wp": "self.version",
+        "pop-schema/notifications": "self.version",
+        "pop-schema/notifications-wp": "self.version",
+        "pop-schema/pages": "self.version",
+        "pop-schema/pages-wp": "self.version",
+        "pop-schema/post-mutations": "self.version",
+        "pop-schema/post-tags": "self.version",
+        "pop-schema/post-tags-wp": "self.version",
+        "pop-schema/posts": "self.version",
+        "pop-schema/posts-wp": "self.version",
+        "pop-schema/queriedobject": "self.version",
+        "pop-schema/queriedobject-wp": "self.version",
+        "pop-schema/schema-commons": "self.version",
+        "pop-schema/stances": "self.version",
+        "pop-schema/stances-wp": "self.version",
+        "pop-schema/tags": "self.version",
+        "pop-schema/tags-wp": "self.version",
+        "pop-schema/taxonomies": "self.version",
+        "pop-schema/taxonomies-wp": "self.version",
+        "pop-schema/taxonomymeta": "self.version",
+        "pop-schema/taxonomymeta-wp": "self.version",
+        "pop-schema/taxonomyquery": "self.version",
+        "pop-schema/taxonomyquery-wp": "self.version",
+        "pop-schema/translate-directive": "self.version",
+        "pop-schema/translate-directive-acl": "self.version",
+        "pop-schema/user-roles": "self.version",
+        "pop-schema/user-roles-access-control": "self.version",
+        "pop-schema/user-roles-acl": "self.version",
+        "pop-schema/user-roles-wp": "self.version",
+        "pop-schema/user-state": "self.version",
+        "pop-schema/user-state-access-control": "self.version",
+        "pop-schema/user-state-mutations": "self.version",
+        "pop-schema/user-state-mutations-wp": "self.version",
+        "pop-schema/user-state-wp": "self.version",
+        "pop-schema/usermeta": "self.version",
+        "pop-schema/usermeta-wp": "self.version",
+        "pop-schema/users": "self.version",
+        "pop-schema/users-wp": "self.version",
+        "pop-sites-wassup/comment-mutations": "self.version",
+        "pop-sites-wassup/contactus-mutations": "self.version",
+        "pop-sites-wassup/contactuser-mutations": "self.version",
+        "pop-sites-wassup/custompost-mutations": "self.version",
+        "pop-sites-wassup/custompostlink-mutations": "self.version",
+        "pop-sites-wassup/event-mutations": "self.version",
+        "pop-sites-wassup/eventlink-mutations": "self.version",
+        "pop-sites-wassup/everythingelse-mutations": "self.version",
+        "pop-sites-wassup/flag-mutations": "self.version",
+        "pop-sites-wassup/form-mutations": "self.version",
+        "pop-sites-wassup/gravityforms-mutations": "self.version",
+        "pop-sites-wassup/highlight-mutations": "self.version",
+        "pop-sites-wassup/location-mutations": "self.version",
+        "pop-sites-wassup/locationpost-mutations": "self.version",
+        "pop-sites-wassup/locationpostlink-mutations": "self.version",
+        "pop-sites-wassup/newsletter-mutations": "self.version",
+        "pop-sites-wassup/notification-mutations": "self.version",
+        "pop-sites-wassup/post-mutations": "self.version",
+        "pop-sites-wassup/postlink-mutations": "self.version",
+        "pop-sites-wassup/share-mutations": "self.version",
+        "pop-sites-wassup/socialnetwork-mutations": "self.version",
+        "pop-sites-wassup/stance-mutations": "self.version",
+        "pop-sites-wassup/system-mutations": "self.version",
+        "pop-sites-wassup/user-state-mutations": "self.version",
+        "pop-sites-wassup/volunteer-mutations": "self.version",
+        "pop-sites-wassup/wassup": "self.version"
+    },
+    "authors": [
+        {
+            "name": "Leonardo Losoviz",
+            "email": "leo@getpop.org",
+            "homepage": "https://getpop.org"
+        }
+    ],
+    "description": "Monorepo for all the PoP packages",
+    "license": "GPL-2.0-or-later",
+    "config": {
+        "sort-packages": true
+    },
+    "repositories": [
+        {
+            "type": "composer",
+            "url": "https://wpackagist.org"
+        },
+        {
+            "type": "vcs",
+            "url": "https://github.com/leoloso/wp-muplugin-loader.git"
+        },
+        {
+            "type": "vcs",
+            "url": "https://github.com/mcaskill/composer-merge-plugin.git"
+        }
+    ],
+    "scripts": {
+        "test": "phpunit",
+        "check-style": "phpcs -n src $(monorepo-builder source-packages --subfolder=src --subfolder=tests)",
+        "fix-style": "phpcbf -n src $(monorepo-builder source-packages --subfolder=src --subfolder=tests)",
+        "analyse": "ci/phpstan.sh \\". $(monorepo-builder source-packages --skip-unmigrated)\\"",
+        "preview-src-downgrade": "rector process $(monorepo-builder source-packages --subfolder=src) --config=rector-downgrade-code.php --ansi --dry-run || true",
+        "preview-vendor-downgrade": "layers/Engine/packages/root/ci/downgrade_code.sh 7.1 rector-downgrade-code.php --dry-run || true",
+        "preview-code-downgrade": [
+            "@preview-src-downgrade",
+            "@preview-vendor-downgrade"
+        ],
+        "build-server": [
+            "lando init --source remote --remote-url https://wordpress.org/latest.tar.gz --recipe wordpress --webroot wordpress --name graphql-api-dev",
+            "@start-server"
+        ],
+        "start-server": [
+            "cd layers/GraphQLAPIForWP/plugins/graphql-api-for-wp && composer install",
+            "lando start"
+        ],
+        "rebuild-server": "lando rebuild -y",
+        "merge-monorepo": "monorepo-builder merge --ansi",
+        "propagate-monorepo": "monorepo-builder propagate --ansi",
+        "validate-monorepo": "monorepo-builder validate --ansi",
+        "release": "monorepo-builder release patch --ansi"
+    },
+    "minimum-stability": "dev",
+    "prefer-stable": true
+}');
+
+        $this->assertTrue($manipulator->addSubNode('config', 'platform-check', false));
+        $this->assertEquals('{
+    "name": "leoloso/pop",
+    "require": {
+        "php": "^7.4|^8.0",
+        "ext-mbstring": "*",
+        "brain/cortex": "~1.0.0",
+        "composer/installers": "~1.0",
+        "composer/semver": "^1.5",
+        "erusev/parsedown": "^1.7",
+        "guzzlehttp/guzzle": "~6.3",
+        "jrfnl/php-cast-to-type": "^2.0",
+        "league/pipeline": "^1.0",
+        "lkwdwrd/wp-muplugin-loader": "dev-feature-composer-v2",
+        "obsidian/polyfill-hrtime": "^0.1",
+        "psr/cache": "^1.0",
+        "symfony/cache": "^5.1",
+        "symfony/config": "^5.1",
+        "symfony/dependency-injection": "^5.1",
+        "symfony/dotenv": "^5.1",
+        "symfony/expression-language": "^5.1",
+        "symfony/polyfill-php72": "^1.18",
+        "symfony/polyfill-php73": "^1.18",
+        "symfony/polyfill-php74": "^1.18",
+        "symfony/polyfill-php80": "^1.18",
+        "symfony/property-access": "^5.1",
+        "symfony/yaml": "^5.1"
+    },
+    "require-dev": {
+        "johnpbloch/wordpress": ">=5.5",
+        "phpstan/phpstan": "^0.12",
+        "phpunit/phpunit": ">=9.3",
+        "rector/rector": "^0.9",
+        "squizlabs/php_codesniffer": "^3.0",
+        "symfony/var-dumper": "^5.1",
+        "symplify/monorepo-builder": "^9.0",
+        "szepeviktor/phpstan-wordpress": "^0.6.2"
+    },
+    "autoload": {
+        "psr-4": {
+            "GraphQLAPI\\\\ConvertCaseDirectives\\\\": "layers/GraphQLAPIForWP/plugins/convert-case-directives/src",
+            "GraphQLAPI\\\\GraphQLAPI\\\\": "layers/GraphQLAPIForWP/plugins/graphql-api-for-wp/src",
+            "GraphQLAPI\\\\SchemaFeedback\\\\": "layers/GraphQLAPIForWP/plugins/schema-feedback/src",
+            "GraphQLByPoP\\\\GraphQLClientsForWP\\\\": "layers/GraphQLByPoP/packages/graphql-clients-for-wp/src",
+            "GraphQLByPoP\\\\GraphQLEndpointForWP\\\\": "layers/GraphQLByPoP/packages/graphql-endpoint-for-wp/src",
+            "GraphQLByPoP\\\\GraphQLParser\\\\": "layers/GraphQLByPoP/packages/graphql-parser/src",
+            "GraphQLByPoP\\\\GraphQLQuery\\\\": "layers/GraphQLByPoP/packages/graphql-query/src",
+            "GraphQLByPoP\\\\GraphQLRequest\\\\": "layers/GraphQLByPoP/packages/graphql-request/src",
+            "GraphQLByPoP\\\\GraphQLServer\\\\": "layers/GraphQLByPoP/packages/graphql-server/src",
+            "Leoloso\\\\ExamplesForPoP\\\\": "layers/Misc/packages/examples-for-pop/src",
+            "PoPSchema\\\\BasicDirectives\\\\": "layers/Schema/packages/basic-directives/src",
+            "PoPSchema\\\\BlockMetadataWP\\\\": "layers/Schema/packages/block-metadata-for-wp/src",
+            "PoPSchema\\\\CDNDirective\\\\": "layers/Schema/packages/cdn-directive/src",
+            "PoPSchema\\\\CategoriesWP\\\\": "layers/Schema/packages/categories-wp/src",
+            "PoPSchema\\\\Categories\\\\": "layers/Schema/packages/categories/src",
+            "PoPSchema\\\\CommentMetaWP\\\\": "layers/Schema/packages/commentmeta-wp/src",
+            "PoPSchema\\\\CommentMeta\\\\": "layers/Schema/packages/commentmeta/src",
+            "PoPSchema\\\\CommentMutationsWP\\\\": "layers/Schema/packages/comment-mutations-wp/src",
+            "PoPSchema\\\\CommentMutations\\\\": "layers/Schema/packages/comment-mutations/src",
+            "PoPSchema\\\\CommentsWP\\\\": "layers/Schema/packages/comments-wp/src",
+            "PoPSchema\\\\Comments\\\\": "layers/Schema/packages/comments/src",
+            "PoPSchema\\\\ConvertCaseDirectives\\\\": "layers/Schema/packages/convert-case-directives/src",
+            "PoPSchema\\\\CustomPostMediaMutationsWP\\\\": "layers/Schema/packages/custompostmedia-mutations-wp/src",
+            "PoPSchema\\\\CustomPostMediaMutations\\\\": "layers/Schema/packages/custompostmedia-mutations/src",
+            "PoPSchema\\\\CustomPostMediaWP\\\\": "layers/Schema/packages/custompostmedia-wp/src",
+            "PoPSchema\\\\CustomPostMedia\\\\": "layers/Schema/packages/custompostmedia/src",
+            "PoPSchema\\\\CustomPostMetaWP\\\\": "layers/Schema/packages/custompostmeta-wp/src",
+            "PoPSchema\\\\CustomPostMeta\\\\": "layers/Schema/packages/custompostmeta/src",
+            "PoPSchema\\\\CustomPostMutationsWP\\\\": "layers/Schema/packages/custompost-mutations-wp/src",
+            "PoPSchema\\\\CustomPostMutations\\\\": "layers/Schema/packages/custompost-mutations/src",
+            "PoPSchema\\\\CustomPostsWP\\\\": "layers/Schema/packages/customposts-wp/src",
+            "PoPSchema\\\\CustomPosts\\\\": "layers/Schema/packages/customposts/src",
+            "PoPSchema\\\\EventMutationsWPEM\\\\": "layers/Schema/packages/event-mutations-wp-em/src",
+            "PoPSchema\\\\EventMutations\\\\": "layers/Schema/packages/event-mutations/src",
+            "PoPSchema\\\\EventsWPEM\\\\": "layers/Schema/packages/events-wp-em/src",
+            "PoPSchema\\\\Events\\\\": "layers/Schema/packages/events/src",
+            "PoPSchema\\\\EverythingElseWP\\\\": "layers/Schema/packages/everythingelse-wp/src",
+            "PoPSchema\\\\EverythingElse\\\\": "layers/Schema/packages/everythingelse/src",
+            "PoPSchema\\\\GenericCustomPosts\\\\": "layers/Schema/packages/generic-customposts/src",
+            "PoPSchema\\\\GoogleTranslateDirectiveForCustomPosts\\\\": "layers/Schema/packages/google-translate-directive-for-customposts/src",
+            "PoPSchema\\\\GoogleTranslateDirective\\\\": "layers/Schema/packages/google-translate-directive/src",
+            "PoPSchema\\\\HighlightsWP\\\\": "layers/Schema/packages/highlights-wp/src",
+            "PoPSchema\\\\Highlights\\\\": "layers/Schema/packages/highlights/src",
+            "PoPSchema\\\\LocationPostsWP\\\\": "layers/Schema/packages/locationposts-wp/src",
+            "PoPSchema\\\\LocationPosts\\\\": "layers/Schema/packages/locationposts/src",
+            "PoPSchema\\\\LocationsWPEM\\\\": "layers/Schema/packages/locations-wp-em/src",
+            "PoPSchema\\\\Locations\\\\": "layers/Schema/packages/locations/src",
+            "PoPSchema\\\\MediaWP\\\\": "layers/Schema/packages/media-wp/src",
+            "PoPSchema\\\\Media\\\\": "layers/Schema/packages/media/src",
+            "PoPSchema\\\\MenusWP\\\\": "layers/Schema/packages/menus-wp/src",
+            "PoPSchema\\\\Menus\\\\": "layers/Schema/packages/menus/src",
+            "PoPSchema\\\\MetaQueryWP\\\\": "layers/Schema/packages/metaquery-wp/src",
+            "PoPSchema\\\\MetaQuery\\\\": "layers/Schema/packages/metaquery/src",
+            "PoPSchema\\\\Meta\\\\": "layers/Schema/packages/meta/src",
+            "PoPSchema\\\\NotificationsWP\\\\": "layers/Schema/packages/notifications-wp/src",
+            "PoPSchema\\\\Notifications\\\\": "layers/Schema/packages/notifications/src",
+            "PoPSchema\\\\PagesWP\\\\": "layers/Schema/packages/pages-wp/src",
+            "PoPSchema\\\\Pages\\\\": "layers/Schema/packages/pages/src",
+            "PoPSchema\\\\PostMutations\\\\": "layers/Schema/packages/post-mutations/src",
+            "PoPSchema\\\\PostTagsWP\\\\": "layers/Schema/packages/post-tags-wp/src",
+            "PoPSchema\\\\PostTags\\\\": "layers/Schema/packages/post-tags/src",
+            "PoPSchema\\\\PostsWP\\\\": "layers/Schema/packages/posts-wp/src",
+            "PoPSchema\\\\Posts\\\\": "layers/Schema/packages/posts/src",
+            "PoPSchema\\\\QueriedObjectWP\\\\": "layers/Schema/packages/queriedobject-wp/src",
+            "PoPSchema\\\\QueriedObject\\\\": "layers/Schema/packages/queriedobject/src",
+            "PoPSchema\\\\SchemaCommons\\\\": "layers/Schema/packages/schema-commons/src",
+            "PoPSchema\\\\StancesWP\\\\": "layers/Schema/packages/stances-wp/src",
+            "PoPSchema\\\\Stances\\\\": "layers/Schema/packages/stances/src",
+            "PoPSchema\\\\TagsWP\\\\": "layers/Schema/packages/tags-wp/src",
+            "PoPSchema\\\\Tags\\\\": "layers/Schema/packages/tags/src",
+            "PoPSchema\\\\TaxonomiesWP\\\\": "layers/Schema/packages/taxonomies-wp/src",
+            "PoPSchema\\\\Taxonomies\\\\": "layers/Schema/packages/taxonomies/src",
+            "PoPSchema\\\\TaxonomyMetaWP\\\\": "layers/Schema/packages/taxonomymeta-wp/src",
+            "PoPSchema\\\\TaxonomyMeta\\\\": "layers/Schema/packages/taxonomymeta/src",
+            "PoPSchema\\\\TaxonomyQueryWP\\\\": "layers/Schema/packages/taxonomyquery-wp/src",
+            "PoPSchema\\\\TaxonomyQuery\\\\": "layers/Schema/packages/taxonomyquery/src",
+            "PoPSchema\\\\TranslateDirectiveACL\\\\": "layers/Schema/packages/translate-directive-acl/src",
+            "PoPSchema\\\\TranslateDirective\\\\": "layers/Schema/packages/translate-directive/src",
+            "PoPSchema\\\\UserMetaWP\\\\": "layers/Schema/packages/usermeta-wp/src",
+            "PoPSchema\\\\UserMeta\\\\": "layers/Schema/packages/usermeta/src",
+            "PoPSchema\\\\UserRolesACL\\\\": "layers/Schema/packages/user-roles-acl/src",
+            "PoPSchema\\\\UserRolesAccessControl\\\\": "layers/Schema/packages/user-roles-access-control/src",
+            "PoPSchema\\\\UserRolesWP\\\\": "layers/Schema/packages/user-roles-wp/src",
+            "PoPSchema\\\\UserRoles\\\\": "layers/Schema/packages/user-roles/src",
+            "PoPSchema\\\\UserStateAccessControl\\\\": "layers/Schema/packages/user-state-access-control/src",
+            "PoPSchema\\\\UserStateMutationsWP\\\\": "layers/Schema/packages/user-state-mutations-wp/src",
+            "PoPSchema\\\\UserStateMutations\\\\": "layers/Schema/packages/user-state-mutations/src",
+            "PoPSchema\\\\UserStateWP\\\\": "layers/Schema/packages/user-state-wp/src",
+            "PoPSchema\\\\UserState\\\\": "layers/Schema/packages/user-state/src",
+            "PoPSchema\\\\UsersWP\\\\": "layers/Schema/packages/users-wp/src",
+            "PoPSchema\\\\Users\\\\": "layers/Schema/packages/users/src",
+            "PoPSitesWassup\\\\CommentMutations\\\\": "layers/Wassup/packages/comment-mutations/src",
+            "PoPSitesWassup\\\\ContactUsMutations\\\\": "layers/Wassup/packages/contactus-mutations/src",
+            "PoPSitesWassup\\\\ContactUserMutations\\\\": "layers/Wassup/packages/contactuser-mutations/src",
+            "PoPSitesWassup\\\\CustomPostLinkMutations\\\\": "layers/Wassup/packages/custompostlink-mutations/src",
+            "PoPSitesWassup\\\\CustomPostMutations\\\\": "layers/Wassup/packages/custompost-mutations/src",
+            "PoPSitesWassup\\\\EventLinkMutations\\\\": "layers/Wassup/packages/eventlink-mutations/src",
+            "PoPSitesWassup\\\\EventMutations\\\\": "layers/Wassup/packages/event-mutations/src",
+            "PoPSitesWassup\\\\EverythingElseMutations\\\\": "layers/Wassup/packages/everythingelse-mutations/src",
+            "PoPSitesWassup\\\\FlagMutations\\\\": "layers/Wassup/packages/flag-mutations/src",
+            "PoPSitesWassup\\\\FormMutations\\\\": "layers/Wassup/packages/form-mutations/src",
+            "PoPSitesWassup\\\\GravityFormsMutations\\\\": "layers/Wassup/packages/gravityforms-mutations/src",
+            "PoPSitesWassup\\\\HighlightMutations\\\\": "layers/Wassup/packages/highlight-mutations/src",
+            "PoPSitesWassup\\\\LocationMutations\\\\": "layers/Wassup/packages/location-mutations/src",
+            "PoPSitesWassup\\\\LocationPostLinkMutations\\\\": "layers/Wassup/packages/locationpostlink-mutations/src",
+            "PoPSitesWassup\\\\LocationPostMutations\\\\": "layers/Wassup/packages/locationpost-mutations/src",
+            "PoPSitesWassup\\\\NewsletterMutations\\\\": "layers/Wassup/packages/newsletter-mutations/src",
+            "PoPSitesWassup\\\\NotificationMutations\\\\": "layers/Wassup/packages/notification-mutations/src",
+            "PoPSitesWassup\\\\PostLinkMutations\\\\": "layers/Wassup/packages/postlink-mutations/src",
+            "PoPSitesWassup\\\\PostMutations\\\\": "layers/Wassup/packages/post-mutations/src",
+            "PoPSitesWassup\\\\ShareMutations\\\\": "layers/Wassup/packages/share-mutations/src",
+            "PoPSitesWassup\\\\SocialNetworkMutations\\\\": "layers/Wassup/packages/socialnetwork-mutations/src",
+            "PoPSitesWassup\\\\StanceMutations\\\\": "layers/Wassup/packages/stance-mutations/src",
+            "PoPSitesWassup\\\\SystemMutations\\\\": "layers/Wassup/packages/system-mutations/src",
+            "PoPSitesWassup\\\\UserStateMutations\\\\": "layers/Wassup/packages/user-state-mutations/src",
+            "PoPSitesWassup\\\\VolunteerMutations\\\\": "layers/Wassup/packages/volunteer-mutations/src",
+            "PoPSitesWassup\\\\Wassup\\\\": "layers/Wassup/packages/wassup/src",
+            "PoP\\\\APIClients\\\\": "layers/API/packages/api-clients/src",
+            "PoP\\\\APIEndpointsForWP\\\\": "layers/API/packages/api-endpoints-for-wp/src",
+            "PoP\\\\APIEndpoints\\\\": "layers/API/packages/api-endpoints/src",
+            "PoP\\\\APIMirrorQuery\\\\": "layers/API/packages/api-mirrorquery/src",
+            "PoP\\\\API\\\\": "layers/API/packages/api/src",
+            "PoP\\\\AccessControl\\\\": "layers/Engine/packages/access-control/src",
+            "PoP\\\\ApplicationWP\\\\": "layers/SiteBuilder/packages/application-wp/src",
+            "PoP\\\\Application\\\\": "layers/SiteBuilder/packages/application/src",
+            "PoP\\\\Base36Definitions\\\\": "layers/SiteBuilder/packages/definitions-base36/src",
+            "PoP\\\\CacheControl\\\\": "layers/Engine/packages/cache-control/src",
+            "PoP\\\\ComponentModel\\\\": "layers/Engine/packages/component-model/src",
+            "PoP\\\\ConfigurableSchemaFeedback\\\\": "layers/Engine/packages/configurable-schema-feedback/src",
+            "PoP\\\\ConfigurationComponentModel\\\\": "layers/SiteBuilder/packages/component-model-configuration/src",
+            "PoP\\\\DefinitionPersistence\\\\": "layers/SiteBuilder/packages/definitionpersistence/src",
+            "PoP\\\\Definitions\\\\": "layers/Engine/packages/definitions/src",
+            "PoP\\\\EmojiDefinitions\\\\": "layers/SiteBuilder/packages/definitions-emoji/src",
+            "PoP\\\\EngineWP\\\\": "layers/Engine/packages/engine-wp/src",
+            "PoP\\\\Engine\\\\": "layers/Engine/packages/engine/src",
+            "PoP\\\\FieldQuery\\\\": "layers/Engine/packages/field-query/src",
+            "PoP\\\\FileStore\\\\": "layers/Engine/packages/filestore/src",
+            "PoP\\\\FunctionFields\\\\": "layers/Engine/packages/function-fields/src",
+            "PoP\\\\GraphQLAPI\\\\": "layers/API/packages/api-graphql/src",
+            "PoP\\\\GuzzleHelpers\\\\": "layers/Engine/packages/guzzle-helpers/src",
+            "PoP\\\\HooksWP\\\\": "layers/Engine/packages/hooks-wp/src",
+            "PoP\\\\Hooks\\\\": "layers/Engine/packages/hooks/src",
+            "PoP\\\\LooseContracts\\\\": "layers/Engine/packages/loosecontracts/src",
+            "PoP\\\\MandatoryDirectivesByConfiguration\\\\": "layers/Engine/packages/mandatory-directives-by-configuration/src",
+            "PoP\\\\ModuleRouting\\\\": "layers/Engine/packages/modulerouting/src",
+            "PoP\\\\Multisite\\\\": "layers/SiteBuilder/packages/multisite/src",
+            "PoP\\\\PoP\\\\": "src",
+            "PoP\\\\QueryParsing\\\\": "layers/Engine/packages/query-parsing/src",
+            "PoP\\\\RESTAPI\\\\": "layers/API/packages/api-rest/src",
+            "PoP\\\\ResourceLoader\\\\": "layers/SiteBuilder/packages/resourceloader/src",
+            "PoP\\\\Resources\\\\": "layers/SiteBuilder/packages/resources/src",
+            "PoP\\\\Root\\\\": "layers/Engine/packages/root/src",
+            "PoP\\\\RoutingWP\\\\": "layers/Engine/packages/routing-wp/src",
+            "PoP\\\\Routing\\\\": "layers/Engine/packages/routing/src",
+            "PoP\\\\SPA\\\\": "layers/SiteBuilder/packages/spa/src",
+            "PoP\\\\SSG\\\\": "layers/SiteBuilder/packages/static-site-generator/src",
+            "PoP\\\\SiteWP\\\\": "layers/SiteBuilder/packages/site-wp/src",
+            "PoP\\\\Site\\\\": "layers/SiteBuilder/packages/site/src",
+            "PoP\\\\TraceTools\\\\": "layers/Engine/packages/trace-tools/src",
+            "PoP\\\\TranslationWP\\\\": "layers/Engine/packages/translation-wp/src",
+            "PoP\\\\Translation\\\\": "layers/Engine/packages/translation/src"
+        }
+    },
+    "autoload-dev": {
+        "psr-4": {
+            "GraphQLAPI\\\\ConvertCaseDirectives\\\\": "layers/GraphQLAPIForWP/plugins/convert-case-directives/tests",
+            "GraphQLAPI\\\\GraphQLAPI\\\\": "layers/GraphQLAPIForWP/plugins/graphql-api-for-wp/tests",
+            "GraphQLAPI\\\\SchemaFeedback\\\\": "layers/GraphQLAPIForWP/plugins/schema-feedback/tests",
+            "GraphQLByPoP\\\\GraphQLClientsForWP\\\\": "layers/GraphQLByPoP/packages/graphql-clients-for-wp/tests",
+            "GraphQLByPoP\\\\GraphQLEndpointForWP\\\\": "layers/GraphQLByPoP/packages/graphql-endpoint-for-wp/tests",
+            "GraphQLByPoP\\\\GraphQLParser\\\\": "layers/GraphQLByPoP/packages/graphql-parser/tests",
+            "GraphQLByPoP\\\\GraphQLQuery\\\\": "layers/GraphQLByPoP/packages/graphql-query/tests",
+            "GraphQLByPoP\\\\GraphQLRequest\\\\": "layers/GraphQLByPoP/packages/graphql-request/tests",
+            "GraphQLByPoP\\\\GraphQLServer\\\\": "layers/GraphQLByPoP/packages/graphql-server/tests",
+            "Leoloso\\\\ExamplesForPoP\\\\": "layers/Misc/packages/examples-for-pop/tests",
+            "PoPSchema\\\\BasicDirectives\\\\": "layers/Schema/packages/basic-directives/tests",
+            "PoPSchema\\\\BlockMetadataWP\\\\": "layers/Schema/packages/block-metadata-for-wp/tests",
+            "PoPSchema\\\\CDNDirective\\\\": "layers/Schema/packages/cdn-directive/tests",
+            "PoPSchema\\\\CategoriesWP\\\\": "layers/Schema/packages/categories-wp/tests",
+            "PoPSchema\\\\Categories\\\\": "layers/Schema/packages/categories/tests",
+            "PoPSchema\\\\CommentMetaWP\\\\": "layers/Schema/packages/commentmeta-wp/tests",
+            "PoPSchema\\\\CommentMeta\\\\": "layers/Schema/packages/commentmeta/tests",
+            "PoPSchema\\\\CommentMutationsWP\\\\": "layers/Schema/packages/comment-mutations-wp/tests",
+            "PoPSchema\\\\CommentMutations\\\\": "layers/Schema/packages/comment-mutations/tests",
+            "PoPSchema\\\\CommentsWP\\\\": "layers/Schema/packages/comments-wp/tests",
+            "PoPSchema\\\\Comments\\\\": "layers/Schema/packages/comments/tests",
+            "PoPSchema\\\\ConvertCaseDirectives\\\\": "layers/Schema/packages/convert-case-directives/tests",
+            "PoPSchema\\\\CustomPostMediaMutationsWP\\\\": "layers/Schema/packages/custompostmedia-mutations-wp/tests",
+            "PoPSchema\\\\CustomPostMediaMutations\\\\": "layers/Schema/packages/custompostmedia-mutations/tests",
+            "PoPSchema\\\\CustomPostMediaWP\\\\": "layers/Schema/packages/custompostmedia-wp/tests",
+            "PoPSchema\\\\CustomPostMedia\\\\": "layers/Schema/packages/custompostmedia/tests",
+            "PoPSchema\\\\CustomPostMetaWP\\\\": "layers/Schema/packages/custompostmeta-wp/tests",
+            "PoPSchema\\\\CustomPostMeta\\\\": "layers/Schema/packages/custompostmeta/tests",
+            "PoPSchema\\\\CustomPostMutationsWP\\\\": "layers/Schema/packages/custompost-mutations-wp/tests",
+            "PoPSchema\\\\CustomPostMutations\\\\": "layers/Schema/packages/custompost-mutations/tests",
+            "PoPSchema\\\\CustomPostsWP\\\\": "layers/Schema/packages/customposts-wp/tests",
+            "PoPSchema\\\\CustomPosts\\\\": "layers/Schema/packages/customposts/tests",
+            "PoPSchema\\\\EventMutationsWPEM\\\\": "layers/Schema/packages/event-mutations-wp-em/tests",
+            "PoPSchema\\\\EventMutations\\\\": "layers/Schema/packages/event-mutations/tests",
+            "PoPSchema\\\\EventsWPEM\\\\": "layers/Schema/packages/events-wp-em/tests",
+            "PoPSchema\\\\Events\\\\": "layers/Schema/packages/events/tests",
+            "PoPSchema\\\\EverythingElseWP\\\\": "layers/Schema/packages/everythingelse-wp/tests",
+            "PoPSchema\\\\EverythingElse\\\\": "layers/Schema/packages/everythingelse/tests",
+            "PoPSchema\\\\GenericCustomPosts\\\\": "layers/Schema/packages/generic-customposts/tests",
+            "PoPSchema\\\\GoogleTranslateDirectiveForCustomPosts\\\\": "layers/Schema/packages/google-translate-directive-for-customposts/tests",
+            "PoPSchema\\\\GoogleTranslateDirective\\\\": "layers/Schema/packages/google-translate-directive/tests",
+            "PoPSchema\\\\HighlightsWP\\\\": "layers/Schema/packages/highlights-wp/tests",
+            "PoPSchema\\\\Highlights\\\\": "layers/Schema/packages/highlights/tests",
+            "PoPSchema\\\\LocationPostsWP\\\\": "layers/Schema/packages/locationposts-wp/tests",
+            "PoPSchema\\\\LocationPosts\\\\": "layers/Schema/packages/locationposts/tests",
+            "PoPSchema\\\\LocationsWPEM\\\\": "layers/Schema/packages/locations-wp-em/tests",
+            "PoPSchema\\\\Locations\\\\": "layers/Schema/packages/locations/tests",
+            "PoPSchema\\\\MediaWP\\\\": "layers/Schema/packages/media-wp/tests",
+            "PoPSchema\\\\Media\\\\": "layers/Schema/packages/media/tests",
+            "PoPSchema\\\\MenusWP\\\\": "layers/Schema/packages/menus-wp/tests",
+            "PoPSchema\\\\Menus\\\\": "layers/Schema/packages/menus/tests",
+            "PoPSchema\\\\MetaQueryWP\\\\": "layers/Schema/packages/metaquery-wp/tests",
+            "PoPSchema\\\\MetaQuery\\\\": "layers/Schema/packages/metaquery/tests",
+            "PoPSchema\\\\Meta\\\\": "layers/Schema/packages/meta/tests",
+            "PoPSchema\\\\NotificationsWP\\\\": "layers/Schema/packages/notifications-wp/tests",
+            "PoPSchema\\\\Notifications\\\\": "layers/Schema/packages/notifications/tests",
+            "PoPSchema\\\\PagesWP\\\\": "layers/Schema/packages/pages-wp/tests",
+            "PoPSchema\\\\Pages\\\\": "layers/Schema/packages/pages/tests",
+            "PoPSchema\\\\PostMutations\\\\": "layers/Schema/packages/post-mutations/tests",
+            "PoPSchema\\\\PostTagsWP\\\\": "layers/Schema/packages/post-tags-wp/tests",
+            "PoPSchema\\\\PostTags\\\\": "layers/Schema/packages/post-tags/tests",
+            "PoPSchema\\\\PostsWP\\\\": "layers/Schema/packages/posts-wp/tests",
+            "PoPSchema\\\\Posts\\\\": "layers/Schema/packages/posts/tests",
+            "PoPSchema\\\\QueriedObjectWP\\\\": "layers/Schema/packages/queriedobject-wp/tests",
+            "PoPSchema\\\\QueriedObject\\\\": "layers/Schema/packages/queriedobject/tests",
+            "PoPSchema\\\\SchemaCommons\\\\": "layers/Schema/packages/schema-commons/tests",
+            "PoPSchema\\\\StancesWP\\\\": "layers/Schema/packages/stances-wp/tests",
+            "PoPSchema\\\\Stances\\\\": "layers/Schema/packages/stances/tests",
+            "PoPSchema\\\\TagsWP\\\\": "layers/Schema/packages/tags-wp/tests",
+            "PoPSchema\\\\Tags\\\\": "layers/Schema/packages/tags/tests",
+            "PoPSchema\\\\TaxonomiesWP\\\\": "layers/Schema/packages/taxonomies-wp/tests",
+            "PoPSchema\\\\Taxonomies\\\\": "layers/Schema/packages/taxonomies/tests",
+            "PoPSchema\\\\TaxonomyMetaWP\\\\": "layers/Schema/packages/taxonomymeta-wp/tests",
+            "PoPSchema\\\\TaxonomyMeta\\\\": "layers/Schema/packages/taxonomymeta/tests",
+            "PoPSchema\\\\TaxonomyQueryWP\\\\": "layers/Schema/packages/taxonomyquery-wp/tests",
+            "PoPSchema\\\\TaxonomyQuery\\\\": "layers/Schema/packages/taxonomyquery/tests",
+            "PoPSchema\\\\TranslateDirectiveACL\\\\": "layers/Schema/packages/translate-directive-acl/tests",
+            "PoPSchema\\\\TranslateDirective\\\\": "layers/Schema/packages/translate-directive/tests",
+            "PoPSchema\\\\UserMetaWP\\\\": "layers/Schema/packages/usermeta-wp/tests",
+            "PoPSchema\\\\UserMeta\\\\": "layers/Schema/packages/usermeta/tests",
+            "PoPSchema\\\\UserRolesACL\\\\": "layers/Schema/packages/user-roles-acl/tests",
+            "PoPSchema\\\\UserRolesAccessControl\\\\": "layers/Schema/packages/user-roles-access-control/tests",
+            "PoPSchema\\\\UserRolesWP\\\\": "layers/Schema/packages/user-roles-wp/tests",
+            "PoPSchema\\\\UserRoles\\\\": "layers/Schema/packages/user-roles/tests",
+            "PoPSchema\\\\UserStateAccessControl\\\\": "layers/Schema/packages/user-state-access-control/tests",
+            "PoPSchema\\\\UserStateMutationsWP\\\\": "layers/Schema/packages/user-state-mutations-wp/tests",
+            "PoPSchema\\\\UserStateMutations\\\\": "layers/Schema/packages/user-state-mutations/tests",
+            "PoPSchema\\\\UserStateWP\\\\": "layers/Schema/packages/user-state-wp/tests",
+            "PoPSchema\\\\UserState\\\\": "layers/Schema/packages/user-state/tests",
+            "PoPSchema\\\\UsersWP\\\\": "layers/Schema/packages/users-wp/tests",
+            "PoPSchema\\\\Users\\\\": "layers/Schema/packages/users/tests",
+            "PoPSitesWassup\\\\CommentMutations\\\\": "layers/Wassup/packages/comment-mutations/tests",
+            "PoPSitesWassup\\\\ContactUsMutations\\\\": "layers/Wassup/packages/contactus-mutations/tests",
+            "PoPSitesWassup\\\\ContactUserMutations\\\\": "layers/Wassup/packages/contactuser-mutations/tests",
+            "PoPSitesWassup\\\\CustomPostLinkMutations\\\\": "layers/Wassup/packages/custompostlink-mutations/tests",
+            "PoPSitesWassup\\\\CustomPostMutations\\\\": "layers/Wassup/packages/custompost-mutations/tests",
+            "PoPSitesWassup\\\\EventLinkMutations\\\\": "layers/Wassup/packages/eventlink-mutations/tests",
+            "PoPSitesWassup\\\\EventMutations\\\\": "layers/Wassup/packages/event-mutations/tests",
+            "PoPSitesWassup\\\\EverythingElseMutations\\\\": "layers/Wassup/packages/everythingelse-mutations/tests",
+            "PoPSitesWassup\\\\FlagMutations\\\\": "layers/Wassup/packages/flag-mutations/tests",
+            "PoPSitesWassup\\\\FormMutations\\\\": "layers/Wassup/packages/form-mutations/tests",
+            "PoPSitesWassup\\\\GravityFormsMutations\\\\": "layers/Wassup/packages/gravityforms-mutations/tests",
+            "PoPSitesWassup\\\\HighlightMutations\\\\": "layers/Wassup/packages/highlight-mutations/tests",
+            "PoPSitesWassup\\\\LocationMutations\\\\": "layers/Wassup/packages/location-mutations/tests",
+            "PoPSitesWassup\\\\LocationPostLinkMutations\\\\": "layers/Wassup/packages/locationpostlink-mutations/tests",
+            "PoPSitesWassup\\\\LocationPostMutations\\\\": "layers/Wassup/packages/locationpost-mutations/tests",
+            "PoPSitesWassup\\\\NewsletterMutations\\\\": "layers/Wassup/packages/newsletter-mutations/tests",
+            "PoPSitesWassup\\\\NotificationMutations\\\\": "layers/Wassup/packages/notification-mutations/tests",
+            "PoPSitesWassup\\\\PostLinkMutations\\\\": "layers/Wassup/packages/postlink-mutations/tests",
+            "PoPSitesWassup\\\\PostMutations\\\\": "layers/Wassup/packages/post-mutations/tests",
+            "PoPSitesWassup\\\\ShareMutations\\\\": "layers/Wassup/packages/share-mutations/tests",
+            "PoPSitesWassup\\\\SocialNetworkMutations\\\\": "layers/Wassup/packages/socialnetwork-mutations/tests",
+            "PoPSitesWassup\\\\StanceMutations\\\\": "layers/Wassup/packages/stance-mutations/tests",
+            "PoPSitesWassup\\\\SystemMutations\\\\": "layers/Wassup/packages/system-mutations/tests",
+            "PoPSitesWassup\\\\UserStateMutations\\\\": "layers/Wassup/packages/user-state-mutations/tests",
+            "PoPSitesWassup\\\\VolunteerMutations\\\\": "layers/Wassup/packages/volunteer-mutations/tests",
+            "PoPSitesWassup\\\\Wassup\\\\": "layers/Wassup/packages/wassup/tests",
+            "PoP\\\\APIClients\\\\": "layers/API/packages/api-clients/tests",
+            "PoP\\\\APIEndpointsForWP\\\\": "layers/API/packages/api-endpoints-for-wp/tests",
+            "PoP\\\\APIEndpoints\\\\": "layers/API/packages/api-endpoints/tests",
+            "PoP\\\\APIMirrorQuery\\\\": "layers/API/packages/api-mirrorquery/tests",
+            "PoP\\\\API\\\\": "layers/API/packages/api/tests",
+            "PoP\\\\AccessControl\\\\": "layers/Engine/packages/access-control/tests",
+            "PoP\\\\ApplicationWP\\\\": "layers/SiteBuilder/packages/application-wp/tests",
+            "PoP\\\\Application\\\\": "layers/SiteBuilder/packages/application/tests",
+            "PoP\\\\Base36Definitions\\\\": "layers/SiteBuilder/packages/definitions-base36/tests",
+            "PoP\\\\CacheControl\\\\": "layers/Engine/packages/cache-control/tests",
+            "PoP\\\\ComponentModel\\\\": "layers/Engine/packages/component-model/tests",
+            "PoP\\\\ConfigurableSchemaFeedback\\\\": "layers/Engine/packages/configurable-schema-feedback/tests",
+            "PoP\\\\ConfigurationComponentModel\\\\": "layers/SiteBuilder/packages/component-model-configuration/tests",
+            "PoP\\\\DefinitionPersistence\\\\": "layers/SiteBuilder/packages/definitionpersistence/tests",
+            "PoP\\\\Definitions\\\\": "layers/Engine/packages/definitions/tests",
+            "PoP\\\\EmojiDefinitions\\\\": "layers/SiteBuilder/packages/definitions-emoji/tests",
+            "PoP\\\\EngineWP\\\\": "layers/Engine/packages/engine-wp/tests",
+            "PoP\\\\Engine\\\\": "layers/Engine/packages/engine/tests",
+            "PoP\\\\FieldQuery\\\\": "layers/Engine/packages/field-query/tests",
+            "PoP\\\\FileStore\\\\": "layers/Engine/packages/filestore/tests",
+            "PoP\\\\FunctionFields\\\\": "layers/Engine/packages/function-fields/tests",
+            "PoP\\\\GraphQLAPI\\\\": "layers/API/packages/api-graphql/tests",
+            "PoP\\\\GuzzleHelpers\\\\": "layers/Engine/packages/guzzle-helpers/tests",
+            "PoP\\\\HooksWP\\\\": "layers/Engine/packages/hooks-wp/tests",
+            "PoP\\\\Hooks\\\\": "layers/Engine/packages/hooks/tests",
+            "PoP\\\\LooseContracts\\\\": "layers/Engine/packages/loosecontracts/tests",
+            "PoP\\\\MandatoryDirectivesByConfiguration\\\\": "layers/Engine/packages/mandatory-directives-by-configuration/tests",
+            "PoP\\\\ModuleRouting\\\\": "layers/Engine/packages/modulerouting/tests",
+            "PoP\\\\Multisite\\\\": "layers/SiteBuilder/packages/multisite/tests",
+            "PoP\\\\QueryParsing\\\\": "layers/Engine/packages/query-parsing/tests",
+            "PoP\\\\RESTAPI\\\\": "layers/API/packages/api-rest/tests",
+            "PoP\\\\ResourceLoader\\\\": "layers/SiteBuilder/packages/resourceloader/tests",
+            "PoP\\\\Resources\\\\": "layers/SiteBuilder/packages/resources/tests",
+            "PoP\\\\Root\\\\": "layers/Engine/packages/root/tests",
+            "PoP\\\\RoutingWP\\\\": "layers/Engine/packages/routing-wp/tests",
+            "PoP\\\\Routing\\\\": "layers/Engine/packages/routing/tests",
+            "PoP\\\\SPA\\\\": "layers/SiteBuilder/packages/spa/tests",
+            "PoP\\\\SSG\\\\": "layers/SiteBuilder/packages/static-site-generator/tests",
+            "PoP\\\\SiteWP\\\\": "layers/SiteBuilder/packages/site-wp/tests",
+            "PoP\\\\Site\\\\": "layers/SiteBuilder/packages/site/tests",
+            "PoP\\\\TraceTools\\\\": "layers/Engine/packages/trace-tools/tests",
+            "PoP\\\\TranslationWP\\\\": "layers/Engine/packages/translation-wp/tests",
+            "PoP\\\\Translation\\\\": "layers/Engine/packages/translation/tests"
+        }
+    },
+    "extra": {
+        "wordpress-install-dir": "vendor/wordpress/wordpress",
+        "merge-plugin": {
+            "include": [
+                "composer.local.json"
+            ],
+            "recurse": true,
+            "replace": false,
+            "ignore-duplicates": false,
+            "merge-dev": true,
+            "merge-extra": false,
+            "merge-extra-deep": false,
+            "merge-scripts": false
+        }
+    },
+    "replace": {
+        "getpop/access-control": "self.version",
+        "getpop/api": "self.version",
+        "getpop/api-clients": "self.version",
+        "getpop/api-endpoints": "self.version",
+        "getpop/api-endpoints-for-wp": "self.version",
+        "getpop/api-graphql": "self.version",
+        "getpop/api-mirrorquery": "self.version",
+        "getpop/api-rest": "self.version",
+        "getpop/application": "self.version",
+        "getpop/application-wp": "self.version",
+        "getpop/cache-control": "self.version",
+        "getpop/component-model": "self.version",
+        "getpop/component-model-configuration": "self.version",
+        "getpop/configurable-schema-feedback": "self.version",
+        "getpop/definitionpersistence": "self.version",
+        "getpop/definitions": "self.version",
+        "getpop/definitions-base36": "self.version",
+        "getpop/definitions-emoji": "self.version",
+        "getpop/engine": "self.version",
+        "getpop/engine-wp": "self.version",
+        "getpop/engine-wp-bootloader": "self.version",
+        "getpop/field-query": "self.version",
+        "getpop/filestore": "self.version",
+        "getpop/function-fields": "self.version",
+        "getpop/guzzle-helpers": "self.version",
+        "getpop/hooks": "self.version",
+        "getpop/hooks-wp": "self.version",
+        "getpop/loosecontracts": "self.version",
+        "getpop/mandatory-directives-by-configuration": "self.version",
+        "getpop/migrate-api": "self.version",
+        "getpop/migrate-api-graphql": "self.version",
+        "getpop/migrate-component-model": "self.version",
+        "getpop/migrate-component-model-configuration": "self.version",
+        "getpop/migrate-engine": "self.version",
+        "getpop/migrate-engine-wp": "self.version",
+        "getpop/migrate-static-site-generator": "self.version",
+        "getpop/modulerouting": "self.version",
+        "getpop/multisite": "self.version",
+        "getpop/query-parsing": "self.version",
+        "getpop/resourceloader": "self.version",
+        "getpop/resources": "self.version",
+        "getpop/root": "self.version",
+        "getpop/routing": "self.version",
+        "getpop/routing-wp": "self.version",
+        "getpop/site": "self.version",
+        "getpop/site-wp": "self.version",
+        "getpop/spa": "self.version",
+        "getpop/static-site-generator": "self.version",
+        "getpop/trace-tools": "self.version",
+        "getpop/translation": "self.version",
+        "getpop/translation-wp": "self.version",
+        "graphql-api/convert-case-directives": "self.version",
+        "graphql-api/graphql-api-for-wp": "self.version",
+        "graphql-api/schema-feedback": "self.version",
+        "graphql-by-pop/graphql-clients-for-wp": "self.version",
+        "graphql-by-pop/graphql-endpoint-for-wp": "self.version",
+        "graphql-by-pop/graphql-parser": "self.version",
+        "graphql-by-pop/graphql-query": "self.version",
+        "graphql-by-pop/graphql-request": "self.version",
+        "graphql-by-pop/graphql-server": "self.version",
+        "leoloso/examples-for-pop": "self.version",
+        "pop-migrate-everythingelse/cssconverter": "self.version",
+        "pop-migrate-everythingelse/ssr": "self.version",
+        "pop-schema/basic-directives": "self.version",
+        "pop-schema/block-metadata-for-wp": "self.version",
+        "pop-schema/categories": "self.version",
+        "pop-schema/categories-wp": "self.version",
+        "pop-schema/cdn-directive": "self.version",
+        "pop-schema/comment-mutations": "self.version",
+        "pop-schema/comment-mutations-wp": "self.version",
+        "pop-schema/commentmeta": "self.version",
+        "pop-schema/commentmeta-wp": "self.version",
+        "pop-schema/comments": "self.version",
+        "pop-schema/comments-wp": "self.version",
+        "pop-schema/convert-case-directives": "self.version",
+        "pop-schema/custompost-mutations": "self.version",
+        "pop-schema/custompost-mutations-wp": "self.version",
+        "pop-schema/custompostmedia": "self.version",
+        "pop-schema/custompostmedia-mutations": "self.version",
+        "pop-schema/custompostmedia-mutations-wp": "self.version",
+        "pop-schema/custompostmedia-wp": "self.version",
+        "pop-schema/custompostmeta": "self.version",
+        "pop-schema/custompostmeta-wp": "self.version",
+        "pop-schema/customposts": "self.version",
+        "pop-schema/customposts-wp": "self.version",
+        "pop-schema/event-mutations": "self.version",
+        "pop-schema/event-mutations-wp-em": "self.version",
+        "pop-schema/events": "self.version",
+        "pop-schema/events-wp-em": "self.version",
+        "pop-schema/everythingelse": "self.version",
+        "pop-schema/everythingelse-wp": "self.version",
+        "pop-schema/generic-customposts": "self.version",
+        "pop-schema/google-translate-directive": "self.version",
+        "pop-schema/google-translate-directive-for-customposts": "self.version",
+        "pop-schema/highlights": "self.version",
+        "pop-schema/highlights-wp": "self.version",
+        "pop-schema/locationposts": "self.version",
+        "pop-schema/locationposts-wp": "self.version",
+        "pop-schema/locations": "self.version",
+        "pop-schema/locations-wp-em": "self.version",
+        "pop-schema/media": "self.version",
+        "pop-schema/media-wp": "self.version",
+        "pop-schema/menus": "self.version",
+        "pop-schema/menus-wp": "self.version",
+        "pop-schema/meta": "self.version",
+        "pop-schema/metaquery": "self.version",
+        "pop-schema/metaquery-wp": "self.version",
+        "pop-schema/migrate-categories": "self.version",
+        "pop-schema/migrate-categories-wp": "self.version",
+        "pop-schema/migrate-commentmeta": "self.version",
+        "pop-schema/migrate-commentmeta-wp": "self.version",
+        "pop-schema/migrate-comments": "self.version",
+        "pop-schema/migrate-comments-wp": "self.version",
+        "pop-schema/migrate-custompostmedia": "self.version",
+        "pop-schema/migrate-custompostmedia-wp": "self.version",
+        "pop-schema/migrate-custompostmeta": "self.version",
+        "pop-schema/migrate-custompostmeta-wp": "self.version",
+        "pop-schema/migrate-customposts": "self.version",
+        "pop-schema/migrate-customposts-wp": "self.version",
+        "pop-schema/migrate-events": "self.version",
+        "pop-schema/migrate-events-wp-em": "self.version",
+        "pop-schema/migrate-everythingelse": "self.version",
+        "pop-schema/migrate-locations": "self.version",
+        "pop-schema/migrate-locations-wp-em": "self.version",
+        "pop-schema/migrate-media": "self.version",
+        "pop-schema/migrate-media-wp": "self.version",
+        "pop-schema/migrate-meta": "self.version",
+        "pop-schema/migrate-metaquery": "self.version",
+        "pop-schema/migrate-metaquery-wp": "self.version",
+        "pop-schema/migrate-pages": "self.version",
+        "pop-schema/migrate-pages-wp": "self.version",
+        "pop-schema/migrate-post-tags": "self.version",
+        "pop-schema/migrate-post-tags-wp": "self.version",
+        "pop-schema/migrate-posts": "self.version",
+        "pop-schema/migrate-posts-wp": "self.version",
+        "pop-schema/migrate-queriedobject": "self.version",
+        "pop-schema/migrate-queriedobject-wp": "self.version",
+        "pop-schema/migrate-tags": "self.version",
+        "pop-schema/migrate-tags-wp": "self.version",
+        "pop-schema/migrate-taxonomies": "self.version",
+        "pop-schema/migrate-taxonomies-wp": "self.version",
+        "pop-schema/migrate-taxonomymeta": "self.version",
+        "pop-schema/migrate-taxonomymeta-wp": "self.version",
+        "pop-schema/migrate-taxonomyquery": "self.version",
+        "pop-schema/migrate-taxonomyquery-wp": "self.version",
+        "pop-schema/migrate-usermeta": "self.version",
+        "pop-schema/migrate-usermeta-wp": "self.version",
+        "pop-schema/migrate-users": "self.version",
+        "pop-schema/migrate-users-wp": "self.version",
+        "pop-schema/notifications": "self.version",
+        "pop-schema/notifications-wp": "self.version",
+        "pop-schema/pages": "self.version",
+        "pop-schema/pages-wp": "self.version",
+        "pop-schema/post-mutations": "self.version",
+        "pop-schema/post-tags": "self.version",
+        "pop-schema/post-tags-wp": "self.version",
+        "pop-schema/posts": "self.version",
+        "pop-schema/posts-wp": "self.version",
+        "pop-schema/queriedobject": "self.version",
+        "pop-schema/queriedobject-wp": "self.version",
+        "pop-schema/schema-commons": "self.version",
+        "pop-schema/stances": "self.version",
+        "pop-schema/stances-wp": "self.version",
+        "pop-schema/tags": "self.version",
+        "pop-schema/tags-wp": "self.version",
+        "pop-schema/taxonomies": "self.version",
+        "pop-schema/taxonomies-wp": "self.version",
+        "pop-schema/taxonomymeta": "self.version",
+        "pop-schema/taxonomymeta-wp": "self.version",
+        "pop-schema/taxonomyquery": "self.version",
+        "pop-schema/taxonomyquery-wp": "self.version",
+        "pop-schema/translate-directive": "self.version",
+        "pop-schema/translate-directive-acl": "self.version",
+        "pop-schema/user-roles": "self.version",
+        "pop-schema/user-roles-access-control": "self.version",
+        "pop-schema/user-roles-acl": "self.version",
+        "pop-schema/user-roles-wp": "self.version",
+        "pop-schema/user-state": "self.version",
+        "pop-schema/user-state-access-control": "self.version",
+        "pop-schema/user-state-mutations": "self.version",
+        "pop-schema/user-state-mutations-wp": "self.version",
+        "pop-schema/user-state-wp": "self.version",
+        "pop-schema/usermeta": "self.version",
+        "pop-schema/usermeta-wp": "self.version",
+        "pop-schema/users": "self.version",
+        "pop-schema/users-wp": "self.version",
+        "pop-sites-wassup/comment-mutations": "self.version",
+        "pop-sites-wassup/contactus-mutations": "self.version",
+        "pop-sites-wassup/contactuser-mutations": "self.version",
+        "pop-sites-wassup/custompost-mutations": "self.version",
+        "pop-sites-wassup/custompostlink-mutations": "self.version",
+        "pop-sites-wassup/event-mutations": "self.version",
+        "pop-sites-wassup/eventlink-mutations": "self.version",
+        "pop-sites-wassup/everythingelse-mutations": "self.version",
+        "pop-sites-wassup/flag-mutations": "self.version",
+        "pop-sites-wassup/form-mutations": "self.version",
+        "pop-sites-wassup/gravityforms-mutations": "self.version",
+        "pop-sites-wassup/highlight-mutations": "self.version",
+        "pop-sites-wassup/location-mutations": "self.version",
+        "pop-sites-wassup/locationpost-mutations": "self.version",
+        "pop-sites-wassup/locationpostlink-mutations": "self.version",
+        "pop-sites-wassup/newsletter-mutations": "self.version",
+        "pop-sites-wassup/notification-mutations": "self.version",
+        "pop-sites-wassup/post-mutations": "self.version",
+        "pop-sites-wassup/postlink-mutations": "self.version",
+        "pop-sites-wassup/share-mutations": "self.version",
+        "pop-sites-wassup/socialnetwork-mutations": "self.version",
+        "pop-sites-wassup/stance-mutations": "self.version",
+        "pop-sites-wassup/system-mutations": "self.version",
+        "pop-sites-wassup/user-state-mutations": "self.version",
+        "pop-sites-wassup/volunteer-mutations": "self.version",
+        "pop-sites-wassup/wassup": "self.version"
+    },
+    "authors": [
+        {
+            "name": "Leonardo Losoviz",
+            "email": "leo@getpop.org",
+            "homepage": "https://getpop.org"
+        }
+    ],
+    "description": "Monorepo for all the PoP packages",
+    "license": "GPL-2.0-or-later",
+    "config": {
+        "sort-packages": true,
+        "platform-check": false
+    },
+    "repositories": [
+        {
+            "type": "composer",
+            "url": "https://wpackagist.org"
+        },
+        {
+            "type": "vcs",
+            "url": "https://github.com/leoloso/wp-muplugin-loader.git"
+        },
+        {
+            "type": "vcs",
+            "url": "https://github.com/mcaskill/composer-merge-plugin.git"
+        }
+    ],
+    "scripts": {
+        "test": "phpunit",
+        "check-style": "phpcs -n src $(monorepo-builder source-packages --subfolder=src --subfolder=tests)",
+        "fix-style": "phpcbf -n src $(monorepo-builder source-packages --subfolder=src --subfolder=tests)",
+        "analyse": "ci/phpstan.sh \\". $(monorepo-builder source-packages --skip-unmigrated)\\"",
+        "preview-src-downgrade": "rector process $(monorepo-builder source-packages --subfolder=src) --config=rector-downgrade-code.php --ansi --dry-run || true",
+        "preview-vendor-downgrade": "layers/Engine/packages/root/ci/downgrade_code.sh 7.1 rector-downgrade-code.php --dry-run || true",
+        "preview-code-downgrade": [
+            "@preview-src-downgrade",
+            "@preview-vendor-downgrade"
+        ],
+        "build-server": [
+            "lando init --source remote --remote-url https://wordpress.org/latest.tar.gz --recipe wordpress --webroot wordpress --name graphql-api-dev",
+            "@start-server"
+        ],
+        "start-server": [
+            "cd layers/GraphQLAPIForWP/plugins/graphql-api-for-wp && composer install",
+            "lando start"
+        ],
+        "rebuild-server": "lando rebuild -y",
+        "merge-monorepo": "monorepo-builder merge --ansi",
+        "propagate-monorepo": "monorepo-builder propagate --ansi",
+        "validate-monorepo": "monorepo-builder validate --ansi",
+        "release": "monorepo-builder release patch --ansi"
+    },
+    "minimum-stability": "dev",
+    "prefer-stable": true
+}
+', $manipulator->getContents());
+    }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Mock/FactoryMock.php 2.0.9-1/tests/Composer/Test/Mock/FactoryMock.php
--- 1.10.19-1/tests/Composer/Test/Mock/FactoryMock.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Mock/FactoryMock.php	2021-01-27 15:09:27.000000000 +0000
@@ -17,9 +17,15 @@ use Composer\Config;
 use Composer\Factory;
 use Composer\Repository\RepositoryManager;
 use Composer\Repository\WritableRepositoryInterface;
+use Composer\Package\Version\VersionGuesser;
+use Composer\Package\Version\VersionParser;
+use Composer\Package\RootPackageInterface;
 use Composer\Installer;
+use Composer\EventDispatcher\EventDispatcher;
 use Composer\IO\IOInterface;
 use Composer\Test\TestCase;
+use Composer\Util\Loop;
+use Composer\Util\ProcessExecutor;
 
 class FactoryMock extends Factory
 {
@@ -35,16 +41,21 @@ class FactoryMock extends Factory
         return $config;
     }
 
-    protected function addLocalRepository(IOInterface $io, RepositoryManager $rm, $vendorDir)
+    protected function loadRootPackage(RepositoryManager $rm, Config $config, VersionParser $parser, VersionGuesser $guesser, IOInterface $io)
     {
+        return new \Composer\Package\Loader\RootPackageLoader($rm, $config, $parser, new VersionGuesserMock(), $io);
     }
 
-    protected function createInstallationManager()
+    protected function addLocalRepository(IOInterface $io, RepositoryManager $rm, $vendorDir, RootPackageInterface $rootPackage)
     {
-        return new InstallationManagerMock;
     }
 
-    protected function createDefaultInstallers(Installer\InstallationManager $im, Composer $composer, IOInterface $io)
+    public function createInstallationManager(Loop $loop, IOInterface $io, EventDispatcher $dispatcher = null)
+    {
+        return new InstallationManagerMock();
+    }
+
+    protected function createDefaultInstallers(Installer\InstallationManager $im, Composer $composer, IOInterface $io, ProcessExecutor $process = null)
     {
     }
 
diff -pruN 1.10.19-1/tests/Composer/Test/Mock/HttpDownloaderMock.php 2.0.9-1/tests/Composer/Test/Mock/HttpDownloaderMock.php
--- 1.10.19-1/tests/Composer/Test/Mock/HttpDownloaderMock.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Mock/HttpDownloaderMock.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,39 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Mock;
+
+use Composer\Util\HttpDownloader;
+use Composer\Util\Http\Response;
+use Composer\Downloader\TransportException;
+
+class HttpDownloaderMock extends HttpDownloader
+{
+    protected $contentMap;
+
+    /**
+     * @param array $contentMap associative array of locations and content
+     */
+    public function __construct(array $contentMap)
+    {
+        $this->contentMap = $contentMap;
+    }
+
+    public function get($fileUrl, $options = array())
+    {
+        if (!empty($this->contentMap[$fileUrl])) {
+            return new Response(array('url' => $fileUrl), 200, array(), $this->contentMap[$fileUrl]);
+        }
+
+        throw new TransportException('The "'.$fileUrl.'" file could not be downloaded (NOT FOUND)', 404);
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Mock/InstallationManagerMock.php 2.0.9-1/tests/Composer/Test/Mock/InstallationManagerMock.php
--- 1.10.19-1/tests/Composer/Test/Mock/InstallationManagerMock.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Mock/InstallationManagerMock.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,6 +16,7 @@ use Composer\Installer\InstallationManag
 use Composer\Repository\RepositoryInterface;
 use Composer\Repository\InstalledRepositoryInterface;
 use Composer\Package\PackageInterface;
+use Composer\IO\IOInterface;
 use Composer\DependencyResolver\Operation\InstallOperation;
 use Composer\DependencyResolver\Operation\UpdateOperation;
 use Composer\DependencyResolver\Operation\UninstallOperation;
@@ -29,6 +30,19 @@ class InstallationManagerMock extends In
     private $uninstalled = array();
     private $trace = array();
 
+    public function __construct()
+    {
+    }
+
+    public function execute(RepositoryInterface $repo, array $operations, $devMode = true, $runScripts = true)
+    {
+        foreach ($operations as $operation) {
+            $method = $operation->getOperationType();
+            // skipping download() step here for tests
+            $this->$method($repo, $operation);
+        }
+    }
+
     public function getInstallPath(PackageInterface $package)
     {
         return '';
@@ -42,22 +56,24 @@ class InstallationManagerMock extends In
     public function install(RepositoryInterface $repo, InstallOperation $operation)
     {
         $this->installed[] = $operation->getPackage();
-        $this->trace[] = (string) $operation;
+        $this->trace[] = strip_tags((string) $operation);
         $repo->addPackage(clone $operation->getPackage());
     }
 
     public function update(RepositoryInterface $repo, UpdateOperation $operation)
     {
         $this->updated[] = array($operation->getInitialPackage(), $operation->getTargetPackage());
-        $this->trace[] = (string) $operation;
+        $this->trace[] = strip_tags((string) $operation);
         $repo->removePackage($operation->getInitialPackage());
-        $repo->addPackage(clone $operation->getTargetPackage());
+        if (!$repo->hasPackage($operation->getTargetPackage())) {
+            $repo->addPackage(clone $operation->getTargetPackage());
+        }
     }
 
     public function uninstall(RepositoryInterface $repo, UninstallOperation $operation)
     {
         $this->uninstalled[] = $operation->getPackage();
-        $this->trace[] = (string) $operation;
+        $this->trace[] = strip_tags((string) $operation);
         $repo->removePackage($operation->getPackage());
     }
 
@@ -66,7 +82,7 @@ class InstallationManagerMock extends In
         $package = $operation->getPackage();
 
         $this->installed[] = $package;
-        $this->trace[] = (string) $operation;
+        $this->trace[] = strip_tags((string) $operation);
 
         parent::markAliasInstalled($repo, $operation);
     }
@@ -74,7 +90,7 @@ class InstallationManagerMock extends In
     public function markAliasUninstalled(RepositoryInterface $repo, MarkAliasUninstalledOperation $operation)
     {
         $this->uninstalled[] = $operation->getPackage();
-        $this->trace[] = (string) $operation;
+        $this->trace[] = strip_tags((string) $operation);
 
         parent::markAliasUninstalled($repo, $operation);
     }
@@ -98,4 +114,9 @@ class InstallationManagerMock extends In
     {
         return $this->uninstalled;
     }
+
+    public function notifyInstalls(IOInterface $io)
+    {
+        // noop
+    }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Mock/InstalledFilesystemRepositoryMock.php 2.0.9-1/tests/Composer/Test/Mock/InstalledFilesystemRepositoryMock.php
--- 1.10.19-1/tests/Composer/Test/Mock/InstalledFilesystemRepositoryMock.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Mock/InstalledFilesystemRepositoryMock.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,7 @@
 namespace Composer\Test\Mock;
 
 use Composer\Repository\InstalledFilesystemRepository;
+use Composer\Installer\InstallationManager;
 
 class InstalledFilesystemRepositoryMock extends InstalledFilesystemRepository
 {
@@ -20,7 +21,7 @@ class InstalledFilesystemRepositoryMock
     {
     }
 
-    public function write()
+    public function write($devMode, InstallationManager $installationManager)
     {
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Mock/RemoteFilesystemMock.php 2.0.9-1/tests/Composer/Test/Mock/RemoteFilesystemMock.php
--- 1.10.19-1/tests/Composer/Test/Mock/RemoteFilesystemMock.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Mock/RemoteFilesystemMock.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,41 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Test\Mock;
-
-use Composer\Util\RemoteFilesystem;
-use Composer\Downloader\TransportException;
-
-/**
- * Remote filesystem mock
- */
-class RemoteFilesystemMock extends RemoteFilesystem
-{
-    protected $contentMap;
-
-    /**
-     * @param array $contentMap associative array of locations and content
-     */
-    public function __construct(array $contentMap)
-    {
-        $this->contentMap = $contentMap;
-    }
-
-    public function getContents($originUrl, $fileUrl, $progress = true, $options = array())
-    {
-        if (!empty($this->contentMap[$fileUrl])) {
-            return $this->contentMap[$fileUrl];
-        }
-
-        throw new TransportException('The "'.$fileUrl.'" file could not be downloaded (NOT FOUND)', 404);
-    }
-}
diff -pruN 1.10.19-1/tests/Composer/Test/Mock/VersionGuesserMock.php 2.0.9-1/tests/Composer/Test/Mock/VersionGuesserMock.php
--- 1.10.19-1/tests/Composer/Test/Mock/VersionGuesserMock.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Mock/VersionGuesserMock.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,27 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Mock;
+
+use Composer\Package\Version\VersionGuesser;
+
+class VersionGuesserMock extends VersionGuesser
+{
+    public function __construct()
+    {
+    }
+
+    public function guessVersion(array $packageConfig, $path)
+    {
+        return null;
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Package/Archiver/ArchivableFilesFinderTest.php 2.0.9-1/tests/Composer/Test/Package/Archiver/ArchivableFilesFinderTest.php
--- 1.10.19-1/tests/Composer/Test/Package/Archiver/ArchivableFilesFinderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Package/Archiver/ArchivableFilesFinderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -189,6 +189,7 @@ class ArchivableFilesFinderTest extends
             'git init && '.
             'git config user.email "you@example.com" && '.
             'git config user.name "Your Name" && '.
+            'git config commit.gpgsign false && '.
             'git add .git* && '.
             'git commit -m "ignore rules" && '.
             'git add . && '.
@@ -308,7 +309,11 @@ class ArchivableFilesFinderTest extends
 
     protected function getArchivedFiles($command)
     {
-        $process = new Process($command, $this->sources);
+        if (method_exists('Symfony\Component\Process\Process', 'fromShellCommandline')) {
+            $process = Process::fromShellCommandline($command, $this->sources);
+        } else {
+            $process = new Process($command, $this->sources);
+        }
         $process->run();
 
         $archive = new \PharData($this->sources.'/archive.zip');
diff -pruN 1.10.19-1/tests/Composer/Test/Package/Archiver/ArchiveManagerTest.php 2.0.9-1/tests/Composer/Test/Package/Archiver/ArchiveManagerTest.php
--- 1.10.19-1/tests/Composer/Test/Package/Archiver/ArchiveManagerTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Package/Archiver/ArchiveManagerTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,9 +12,13 @@
 
 namespace Composer\Test\Package\Archiver;
 
+use Composer\IO\NullIO;
 use Composer\Factory;
 use Composer\Package\Archiver\ArchiveManager;
 use Composer\Package\PackageInterface;
+use Composer\Util\Loop;
+use Composer\Test\Mock\FactoryMock;
+use Composer\Util\ProcessExecutor;
 
 class ArchiveManagerTest extends ArchiverTest
 {
@@ -30,7 +34,14 @@ class ArchiveManagerTest extends Archive
         parent::setUp();
 
         $factory = new Factory();
-        $this->manager = $factory->createArchiveManager($factory->createConfig());
+        $dm = $factory->createDownloadManager(
+            $io = new NullIO,
+            $config = FactoryMock::createConfig(),
+            $httpDownloader = $factory->createHttpDownloader($io, $config),
+            new ProcessExecutor($io)
+        );
+        $loop = new Loop($httpDownloader);
+        $this->manager = $factory->createArchiveManager($factory->createConfig(), $dm, $loop);
         $this->targetDir = $this->testDir.'/composer_archiver_tests';
     }
 
@@ -57,7 +68,7 @@ class ArchiveManagerTest extends Archive
         $this->assertFileExists($target);
 
         $tmppath = sys_get_temp_dir().'/composer_archiver/'.$this->manager->getPackageFilename($package);
-        $this->assertFileNotExists($tmppath);
+        $this->assertFileDoesNotExist($tmppath);
 
         unlink($target);
     }
@@ -79,7 +90,7 @@ class ArchiveManagerTest extends Archive
         $this->assertFileExists($target);
 
         $tmppath = sys_get_temp_dir().'/composer_archiver/'.$this->manager->getPackageFilename($package);
-        $this->assertFileNotExists($tmppath);
+        $this->assertFileDoesNotExist($tmppath);
 
         unlink($target);
     }
@@ -110,10 +121,22 @@ class ArchiveManagerTest extends Archive
             throw new \RuntimeException('Could not init: '.$this->process->getErrorOutput());
         }
 
+        $result = $this->process->execute('git checkout -b master', $output, $this->testDir);
+        if ($result > 0) {
+            chdir($currentWorkDir);
+            throw new \RuntimeException('Could not checkout master branch: '.$this->process->getErrorOutput());
+        }
+
         $result = $this->process->execute('git config user.email "you@example.com"', $output, $this->testDir);
         if ($result > 0) {
             chdir($currentWorkDir);
             throw new \RuntimeException('Could not config: '.$this->process->getErrorOutput());
+        }
+
+        $result = $this->process->execute('git config commit.gpgsign false', $output, $this->testDir);
+        if ($result > 0) {
+            chdir($currentWorkDir);
+            throw new \RuntimeException('Could not config: '.$this->process->getErrorOutput());
         }
 
         $result = $this->process->execute('git config user.name "Your Name"', $output, $this->testDir);
diff -pruN 1.10.19-1/tests/Composer/Test/Package/Archiver/ZipArchiverTest.php 2.0.9-1/tests/Composer/Test/Package/Archiver/ZipArchiverTest.php
--- 1.10.19-1/tests/Composer/Test/Package/Archiver/ZipArchiverTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Package/Archiver/ZipArchiverTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,42 +12,85 @@
 
 namespace Composer\Test\Package\Archiver;
 
+use Composer\Util\Platform;
+use ZipArchive;
 use Composer\Package\Archiver\ZipArchiver;
 
 class ZipArchiverTest extends ArchiverTest
 {
-    public function testZipArchive()
+    /**
+     * @param string $include
+     *
+     * @dataProvider provideGitignoreExcludeNegationTestCases
+     */
+    public function testGitignoreExcludeNegation($include)
+    {
+        $this->testZipArchive(array(
+            'docs/README.md' => '# The doc',
+            '.gitignore' => "/*\n.*\n!.git*\n$include",
+        ));
+    }
+
+    public function provideGitignoreExcludeNegationTestCases()
+    {
+        return array(
+            array('!/docs'),
+            array('!/docs/'),
+        );
+    }
+
+    public function testZipArchive(array $files = array())
     {
         if (!class_exists('ZipArchive')) {
             $this->markTestSkipped('Cannot run ZipArchiverTest, missing class "ZipArchive".');
         }
 
+        if (empty($files)) {
+            $files = array(
+                'file.txt' => NULL,
+                'foo/bar/baz' => NULL,
+                'x/baz' => NULL,
+                'x/includeme' => NULL,
+            );
+
+            if (!Platform::isWindows()) {
+                $files['foo' . getcwd() . '/file.txt'] = NULL;
+            }
+        }
         // Set up repository
-        $this->setupDummyRepo();
+        $this->setupDummyRepo($files);
         $package = $this->setupPackage();
         $target = sys_get_temp_dir().'/composer_archiver_test.zip';
 
         // Test archive
         $archiver = new ZipArchiver();
         $archiver->archive($package->getSourceUrl(), $target, 'zip');
-        $this->assertFileExists($target);
+        static::assertFileExists($target);
+        $zip = new ZipArchive();
+        $res = $zip->open($target);
+        static::assertTrue($res, 'Failed asserting that Zip file can be opened');
+        foreach ($files as $path => $content) {
+            static::assertSame($content, $zip->getFromName($path), 'Failed asserting that Zip contains ' . $path);
+        }
+        $zip->close();
 
         unlink($target);
     }
 
     /**
      * Create a local dummy repository to run tests against!
+     * @param array $files
      */
-    protected function setupDummyRepo()
+    protected function setupDummyRepo(array &$files)
     {
         $currentWorkDir = getcwd();
         chdir($this->testDir);
-
-        $this->writeFile('file.txt', 'content', $currentWorkDir);
-        $this->writeFile('foo/bar/baz', 'content', $currentWorkDir);
-        $this->writeFile('foo/bar/ignoreme', 'content', $currentWorkDir);
-        $this->writeFile('x/baz', 'content', $currentWorkDir);
-        $this->writeFile('x/includeme', 'content', $currentWorkDir);
+        foreach ($files as $path => $content) {
+            if ($files[$path] === NULL) {
+                $files[$path] = 'content';
+            }
+            $this->writeFile($path, $files[$path], $currentWorkDir);
+        }
 
         chdir($currentWorkDir);
     }
@@ -58,7 +101,7 @@ class ZipArchiverTest extends ArchiverTe
             mkdir(dirname($path), 0777, true);
         }
 
-        $result = file_put_contents($path, 'a');
+        $result = file_put_contents($path, $content);
         if (false === $result) {
             chdir($currentWorkDir);
             throw new \RuntimeException('Could not save file.');
diff -pruN 1.10.19-1/tests/Composer/Test/Package/BasePackageTest.php 2.0.9-1/tests/Composer/Test/Package/BasePackageTest.php
--- 1.10.19-1/tests/Composer/Test/Package/BasePackageTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Package/BasePackageTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -33,11 +33,10 @@ class BasePackageTest extends TestCase
         }
     }
 
-    /**
-     * @expectedException LogicException
-     */
     public function testSetAnotherRepository()
     {
+        $this->setExpectedException('LogicException');
+
         $package = $this->getMockForAbstractClass('Composer\Package\BasePackage', array('foo'));
 
         $package->setRepository($this->getMockBuilder('Composer\Repository\RepositoryInterface')->getMock());
@@ -81,7 +80,7 @@ class BasePackageTest extends TestCase
         $createPackage = function ($arr) use ($self) {
             $package = $self->getMockForAbstractClass('\Composer\Package\BasePackage', array(), '', false);
             $package->expects($self->once())->method('isDev')->will($self->returnValue(true));
-            $package->expects($self->once())->method('getSourceType')->will($self->returnValue('git'));
+            $package->expects($self->any())->method('getSourceType')->will($self->returnValue('git'));
             $package->expects($self->once())->method('getPrettyVersion')->will($self->returnValue('PrettyVersion'));
             $package->expects($self->any())->method('getSourceReference')->will($self->returnValue($arr['sourceReference']));
 
diff -pruN 1.10.19-1/tests/Composer/Test/Package/Dumper/ArrayDumperTest.php 2.0.9-1/tests/Composer/Test/Package/Dumper/ArrayDumperTest.php
--- 1.10.19-1/tests/Composer/Test/Package/Dumper/ArrayDumperTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Package/Dumper/ArrayDumperTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -172,7 +172,7 @@ class ArrayDumperTest extends TestCase
             ),
             array(
                 'require',
-                array(new Link('foo', 'foo/bar', new Constraint('=', '1.0.0.0'), 'requires', '1.0.0')),
+                array(new Link('foo', 'foo/bar', new Constraint('=', '1.0.0.0'), Link::TYPE_REQUIRE, '1.0.0')),
                 'requires',
                 array('foo/bar' => '1.0.0'),
             ),
@@ -197,13 +197,13 @@ class ArrayDumperTest extends TestCase
             ),
             array(
                 'require',
-                array(new Link('foo', 'foo/bar', new Constraint('=', '1.0.0.0'), 'requires', '1.0.0'), new Link('bar', 'bar/baz', new Constraint('=', '1.0.0.0'), 'requires', '1.0.0')),
+                array(new Link('foo', 'foo/bar', new Constraint('=', '1.0.0.0'), Link::TYPE_REQUIRE, '1.0.0'), new Link('bar', 'bar/baz', new Constraint('=', '1.0.0.0'), Link::TYPE_REQUIRE, '1.0.0')),
                 'requires',
                 array('bar/baz' => '1.0.0', 'foo/bar' => '1.0.0'),
             ),
             array(
                 'require-dev',
-                array(new Link('foo', 'foo/bar', new Constraint('=', '1.0.0.0'), 'requires', '1.0.0'), new Link('bar', 'bar/baz', new Constraint('=', '1.0.0.0'), 'requires', '1.0.0')),
+                array(new Link('foo', 'foo/bar', new Constraint('=', '1.0.0.0'), Link::TYPE_REQUIRE, '1.0.0'), new Link('bar', 'bar/baz', new Constraint('=', '1.0.0.0'), Link::TYPE_REQUIRE, '1.0.0')),
                 'devRequires',
                 array('bar/baz' => '1.0.0', 'foo/bar' => '1.0.0'),
             ),
@@ -215,19 +215,19 @@ class ArrayDumperTest extends TestCase
             ),
             array(
                 'provide',
-                array(new Link('foo', 'foo/bar', new Constraint('=', '1.0.0.0'), 'requires', '1.0.0'), new Link('bar', 'bar/baz', new Constraint('=', '1.0.0.0'), 'requires', '1.0.0')),
+                array(new Link('foo', 'foo/bar', new Constraint('=', '1.0.0.0'), Link::TYPE_REQUIRE, '1.0.0'), new Link('bar', 'bar/baz', new Constraint('=', '1.0.0.0'), Link::TYPE_REQUIRE, '1.0.0')),
                 'provides',
                 array('bar/baz' => '1.0.0', 'foo/bar' => '1.0.0'),
             ),
             array(
                 'replace',
-                array(new Link('foo', 'foo/bar', new Constraint('=', '1.0.0.0'), 'requires', '1.0.0'), new Link('bar', 'bar/baz', new Constraint('=', '1.0.0.0'), 'requires', '1.0.0')),
+                array(new Link('foo', 'foo/bar', new Constraint('=', '1.0.0.0'), Link::TYPE_REQUIRE, '1.0.0'), new Link('bar', 'bar/baz', new Constraint('=', '1.0.0.0'), Link::TYPE_REQUIRE, '1.0.0')),
                 'replaces',
                 array('bar/baz' => '1.0.0', 'foo/bar' => '1.0.0'),
             ),
             array(
                 'conflict',
-                array(new Link('foo', 'foo/bar', new Constraint('=', '1.0.0.0'), 'requires', '1.0.0'), new Link('bar', 'bar/baz', new Constraint('=', '1.0.0.0'), 'requires', '1.0.0')),
+                array(new Link('foo', 'foo/bar', new Constraint('=', '1.0.0.0'), Link::TYPE_REQUIRE, '1.0.0'), new Link('bar', 'bar/baz', new Constraint('=', '1.0.0.0'), Link::TYPE_REQUIRE, '1.0.0')),
                 'conflicts',
                 array('bar/baz' => '1.0.0', 'foo/bar' => '1.0.0'),
             ),
diff -pruN 1.10.19-1/tests/Composer/Test/Package/Loader/RootPackageLoaderTest.php 2.0.9-1/tests/Composer/Test/Package/Loader/RootPackageLoaderTest.php
--- 1.10.19-1/tests/Composer/Test/Package/Loader/RootPackageLoaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Package/Loader/RootPackageLoaderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -15,6 +15,7 @@ namespace Composer\Test\Package\Loader;
 use Composer\Config;
 use Composer\Package\Loader\RootPackageLoader;
 use Composer\Package\BasePackage;
+use Composer\Package\RootPackage;
 use Composer\Package\Version\VersionGuesser;
 use Composer\Semver\VersionParser;
 use Composer\Test\TestCase;
@@ -46,8 +47,8 @@ class RootPackageLoaderTest extends Test
                 'zux/complex' => '~1.0,>=1.0.2@dev',
                 'or/op' => '^2.0@dev || ^2.0@dev',
                 'multi/lowest-wins' => '^2.0@rc || >=3.0@dev , ~3.5@alpha',
-                'or/op/without-flags' => 'dev-master || 2.0 , ~3.5-alpha',
-                'or/op/without-flags2' => '3.0-beta || 2.0 , ~3.5-alpha',
+                'or/op-without-flags' => 'dev-master || 2.0 , ~3.5-alpha',
+                'or/op-without-flags2' => '3.0-beta || 2.0 , ~3.5-alpha',
             ),
             'minimum-stability' => 'alpha',
         ));
@@ -59,8 +60,8 @@ class RootPackageLoaderTest extends Test
             'zux/complex' => BasePackage::STABILITY_DEV,
             'or/op' => BasePackage::STABILITY_DEV,
             'multi/lowest-wins' => BasePackage::STABILITY_DEV,
-            'or/op/without-flags' => BasePackage::STABILITY_DEV,
-            'or/op/without-flags2' => BasePackage::STABILITY_ALPHA,
+            'or/op-without-flags' => BasePackage::STABILITY_DEV,
+            'or/op-without-flags2' => BasePackage::STABILITY_ALPHA,
         ), $package->getStabilityFlags());
     }
 
@@ -90,7 +91,7 @@ class RootPackageLoaderTest extends Test
         $package = $loader->load(array());
 
         $this->assertEquals("1.0.0.0", $package->getVersion());
-        $this->assertEquals("No version set (parsed as 1.0.0)", $package->getPrettyVersion());
+        $this->assertEquals(RootPackage::DEFAULT_PRETTY_VERSION, $package->getPrettyVersion());
     }
 
     public function testPrettyVersionForRootPackageInVersionBranch()
@@ -201,28 +202,4 @@ class RootPackageLoaderTest extends Test
 
         $this->assertEquals("dev-latest-production", $package->getPrettyVersion());
     }
-
-    /**
-     * @dataProvider provideExtraBranchVersion
-     */
-    public function testLoadExtraBranchVersion($branchVersion)
-    {
-        $package = $this->loadPackage(array(
-            'extra' => array(
-                'branch-version' => $branchVersion,
-            ),
-        ));
-
-        $this->assertEquals('1.2.x-dev', $package->getPrettyVersion());
-    }
-
-    public function provideExtraBranchVersion()
-    {
-        return array(
-            array('1.2'),
-            array('1.2.x'),
-            array('1.2-dev'),
-            array('1.2.x-dev'),
-        );
-    }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Package/Loader/ValidatingArrayLoaderTest.php 2.0.9-1/tests/Composer/Test/Package/Loader/ValidatingArrayLoaderTest.php
--- 1.10.19-1/tests/Composer/Test/Package/Loader/ValidatingArrayLoaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Package/Loader/ValidatingArrayLoaderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -76,10 +76,10 @@ class ValidatingArrayLoaderTest extends
                     'funding' => array(
                         array(
                             'type' => 'example',
-                            'url' => 'https://example.org/fund'
+                            'url' => 'https://example.org/fund',
                         ),
                         array(
-                            'url' => 'https://example.org/fund'
+                            'url' => 'https://example.org/fund',
                         ),
                     ),
                     'require' => array(
@@ -259,7 +259,7 @@ class ValidatingArrayLoaderTest extends
             'foo/-bar',
         );
         $invalidNaming = array();
-        foreach($invalidNames as $invalidName) {
+        foreach ($invalidNames as $invalidName) {
             $invalidNaming[] = array(
                 array(
                     'name' => $invalidName,
@@ -334,7 +334,7 @@ class ValidatingArrayLoaderTest extends
             'foo/bar---baz',
         );
         $invalidNaming = array();
-        foreach($invalidNames as $invalidName) {
+        foreach ($invalidNames as $invalidName) {
             $invalidNaming[] = array(
                 array(
                     'name' => $invalidName,
@@ -405,7 +405,6 @@ class ValidatingArrayLoaderTest extends
                     'require' => array(
                         'foo/baz' => '*',
                         'bar/baz' => '>=1.0',
-                        'bar/foo' => 'dev-master',
                         'bar/hacked' => '@stable',
                         'bar/woo' => '1.0.0',
                     ),
@@ -413,7 +412,6 @@ class ValidatingArrayLoaderTest extends
                 array(
                     'require.foo/baz : unbound version constraints (*) should be avoided',
                     'require.bar/baz : unbound version constraints (>=1.0) should be avoided',
-                    'require.bar/foo : unbound version constraints (dev-master) should be avoided',
                     'require.bar/hacked : unbound version constraints (@stable) should be avoided',
                     'require.bar/woo : exact version constraints (1.0.0) should be avoided if the package follows semantic versioning',
                 ),
diff -pruN 1.10.19-1/tests/Composer/Test/Package/LockerTest.php 2.0.9-1/tests/Composer/Test/Package/LockerTest.php
--- 1.10.19-1/tests/Composer/Test/Package/LockerTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Package/LockerTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -25,7 +25,6 @@ class LockerTest extends TestCase
         $locker = new Locker(
             new NullIO,
             $json,
-            $this->createRepositoryManagerMock(),
             $this->createInstallationManagerMock(),
             $this->getJsonContent()
         );
@@ -45,10 +44,9 @@ class LockerTest extends TestCase
     public function testGetNotLockedPackages()
     {
         $json = $this->createJsonFileMock();
-        $repo = $this->createRepositoryManagerMock();
         $inst = $this->createInstallationManagerMock();
 
-        $locker = new Locker(new NullIO, $json, $repo, $inst, $this->getJsonContent());
+        $locker = new Locker(new NullIO, $json, $inst, $this->getJsonContent());
 
         $json
             ->expects($this->once())
@@ -63,10 +61,9 @@ class LockerTest extends TestCase
     public function testGetLockedPackages()
     {
         $json = $this->createJsonFileMock();
-        $repo = $this->createRepositoryManagerMock();
         $inst = $this->createInstallationManagerMock();
 
-        $locker = new Locker(new NullIO, $json, $repo, $inst, $this->getJsonContent());
+        $locker = new Locker(new NullIO, $json, $inst, $this->getJsonContent());
 
         $json
             ->expects($this->once())
@@ -90,11 +87,10 @@ class LockerTest extends TestCase
     public function testSetLockData()
     {
         $json = $this->createJsonFileMock();
-        $repo = $this->createRepositoryManagerMock();
         $inst = $this->createInstallationManagerMock();
 
         $jsonContent = $this->getJsonContent() . '  ';
-        $locker = new Locker(new NullIO, $json, $repo, $inst, $jsonContent);
+        $locker = new Locker(new NullIO, $json, $inst, $jsonContent);
 
         $package1 = $this->createPackageMock();
         $package2 = $this->createPackageMock();
@@ -164,10 +160,9 @@ class LockerTest extends TestCase
     public function testLockBadPackages()
     {
         $json = $this->createJsonFileMock();
-        $repo = $this->createRepositoryManagerMock();
         $inst = $this->createInstallationManagerMock();
 
-        $locker = new Locker(new NullIO, $json, $repo, $inst, $this->getJsonContent());
+        $locker = new Locker(new NullIO, $json, $inst, $this->getJsonContent());
 
         $package1 = $this->createPackageMock();
         $package1
@@ -183,11 +178,10 @@ class LockerTest extends TestCase
     public function testIsFresh()
     {
         $json = $this->createJsonFileMock();
-        $repo = $this->createRepositoryManagerMock();
         $inst = $this->createInstallationManagerMock();
 
         $jsonContent = $this->getJsonContent();
-        $locker = new Locker(new NullIO, $json, $repo, $inst, $jsonContent);
+        $locker = new Locker(new NullIO, $json, $inst, $jsonContent);
 
         $json
             ->expects($this->once())
@@ -200,10 +194,9 @@ class LockerTest extends TestCase
     public function testIsFreshFalse()
     {
         $json = $this->createJsonFileMock();
-        $repo = $this->createRepositoryManagerMock();
         $inst = $this->createInstallationManagerMock();
 
-        $locker = new Locker(new NullIO, $json, $repo, $inst, $this->getJsonContent());
+        $locker = new Locker(new NullIO, $json, $inst, $this->getJsonContent());
 
         $json
             ->expects($this->once())
@@ -216,11 +209,10 @@ class LockerTest extends TestCase
     public function testIsFreshWithContentHash()
     {
         $json = $this->createJsonFileMock();
-        $repo = $this->createRepositoryManagerMock();
         $inst = $this->createInstallationManagerMock();
 
         $jsonContent = $this->getJsonContent();
-        $locker = new Locker(new NullIO, $json, $repo, $inst, $jsonContent);
+        $locker = new Locker(new NullIO, $json, $inst, $jsonContent);
 
         $json
             ->expects($this->once())
@@ -233,11 +225,10 @@ class LockerTest extends TestCase
     public function testIsFreshWithContentHashAndNoHash()
     {
         $json = $this->createJsonFileMock();
-        $repo = $this->createRepositoryManagerMock();
         $inst = $this->createInstallationManagerMock();
 
         $jsonContent = $this->getJsonContent();
-        $locker = new Locker(new NullIO, $json, $repo, $inst, $jsonContent);
+        $locker = new Locker(new NullIO, $json, $inst, $jsonContent);
 
         $json
             ->expects($this->once())
@@ -250,10 +241,9 @@ class LockerTest extends TestCase
     public function testIsFreshFalseWithContentHash()
     {
         $json = $this->createJsonFileMock();
-        $repo = $this->createRepositoryManagerMock();
         $inst = $this->createInstallationManagerMock();
 
-        $locker = new Locker(new NullIO, $json, $repo, $inst, $this->getJsonContent());
+        $locker = new Locker(new NullIO, $json, $inst, $this->getJsonContent());
 
         $differentHash = md5($this->getJsonContent(array('name' => 'test2')));
 
@@ -272,19 +262,6 @@ class LockerTest extends TestCase
             ->getMock();
     }
 
-    private function createRepositoryManagerMock()
-    {
-        $mock = $this->getMockBuilder('Composer\Repository\RepositoryManager')
-            ->disableOriginalConstructor()
-            ->getMock();
-
-        $mock->expects($this->any())
-            ->method('getLocalRepository')
-            ->will($this->returnValue($this->getMockBuilder('Composer\Repository\ArrayRepository')->getMock()));
-
-        return $mock;
-    }
-
     private function createInstallationManagerMock()
     {
         $mock = $this->getMockBuilder('Composer\Installer\InstallationManager')
diff -pruN 1.10.19-1/tests/Composer/Test/Package/RootAliasPackageTest.php 2.0.9-1/tests/Composer/Test/Package/RootAliasPackageTest.php
--- 1.10.19-1/tests/Composer/Test/Package/RootAliasPackageTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Package/RootAliasPackageTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,6 +14,7 @@ namespace Composer\Test\Package;
 
 use Composer\Package\Link;
 use Composer\Package\RootAliasPackage;
+use Composer\Semver\Constraint\MatchAllConstraint;
 use Composer\Test\TestCase;
 use Prophecy\Argument;
 
@@ -26,7 +27,7 @@ class RootAliasPackageTest extends TestC
 
         $alias = new RootAliasPackage($root->reveal(), '1.0', '1.0.0.0');
         $this->assertEmpty($alias->getRequires());
-        $links = array(new Link('a', 'b', null, 'foo', 'self.version'));
+        $links = array(new Link('a', 'b', new MatchAllConstraint(), 'foo', 'self.version'));
         $alias->setRequires($links);
         $this->assertNotEmpty($alias->getRequires());
     }
@@ -38,7 +39,7 @@ class RootAliasPackageTest extends TestC
 
         $alias = new RootAliasPackage($root->reveal(), '1.0', '1.0.0.0');
         $this->assertEmpty($alias->getDevRequires());
-        $links = array(new Link('a', 'b', null, 'foo', 'self.version'));
+        $links = array(new Link('a', 'b', new MatchAllConstraint(), 'foo', 'self.version'));
         $alias->setDevRequires($links);
         $this->assertNotEmpty($alias->getDevRequires());
     }
@@ -50,7 +51,7 @@ class RootAliasPackageTest extends TestC
 
         $alias = new RootAliasPackage($root->reveal(), '1.0', '1.0.0.0');
         $this->assertEmpty($alias->getConflicts());
-        $links = array(new Link('a', 'b', null, 'foo', 'self.version'));
+        $links = array(new Link('a', 'b', new MatchAllConstraint(), 'foo', 'self.version'));
         $alias->setConflicts($links);
         $this->assertNotEmpty($alias->getConflicts());
     }
@@ -62,7 +63,7 @@ class RootAliasPackageTest extends TestC
 
         $alias = new RootAliasPackage($root->reveal(), '1.0', '1.0.0.0');
         $this->assertEmpty($alias->getProvides());
-        $links = array(new Link('a', 'b', null, 'foo', 'self.version'));
+        $links = array(new Link('a', 'b', new MatchAllConstraint(), 'foo', 'self.version'));
         $alias->setProvides($links);
         $this->assertNotEmpty($alias->getProvides());
     }
@@ -74,7 +75,7 @@ class RootAliasPackageTest extends TestC
 
         $alias = new RootAliasPackage($root->reveal(), '1.0', '1.0.0.0');
         $this->assertEmpty($alias->getReplaces());
-        $links = array(new Link('a', 'b', null, 'foo', 'self.version'));
+        $links = array(new Link('a', 'b', new MatchAllConstraint(), 'foo', 'self.version'));
         $alias->setReplaces($links);
         $this->assertNotEmpty($alias->getReplaces());
     }
diff -pruN 1.10.19-1/tests/Composer/Test/Package/Version/VersionGuesserTest.php 2.0.9-1/tests/Composer/Test/Package/Version/VersionGuesserTest.php
--- 1.10.19-1/tests/Composer/Test/Package/Version/VersionGuesserTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Package/Version/VersionGuesserTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -93,7 +93,7 @@ class VersionGuesserTest extends TestCas
         $guesser = new VersionGuesser($config, $executor, new VersionParser());
         $versionArray = $guesser->guessVersion(array(), 'dummy/path');
 
-        $this->assertEquals("9999999-dev", $versionArray['version']);
+        $this->assertEquals("dev-".$branch, $versionArray['version']);
         $this->assertEquals("dev-".$branch, $versionArray['pretty_version']);
         $this->assertEmpty($versionArray['commit']);
     }
@@ -128,14 +128,14 @@ class VersionGuesserTest extends TestCas
         $guesser = new VersionGuesser($config, $executor, new VersionParser());
         $versionArray = $guesser->guessVersion(array(), 'dummy/path');
 
-        $this->assertEquals("9999999-dev", $versionArray['version']);
+        $this->assertEquals("dev-master", $versionArray['version']);
         $this->assertEquals("dev-master", $versionArray['pretty_version']);
         $this->assertArrayNotHasKey('feature_version', $versionArray);
         $this->assertArrayNotHasKey('feature_pretty_version', $versionArray);
         $this->assertEquals($commitHash, $versionArray['commit']);
     }
 
-    public function testGuessVersionReadsAndRespectsNonFeatureBranchesConfigurationForArbitraryNaming()
+    public function testGuessVersionDoesNotSeeCustomDefaultBranchAsNonFeatureBranch()
     {
         $commitHash = '03a15d220da53c52eddd5f32ffca64a7b3801bea';
         $anotherCommitHash = '13a15d220da53c52eddd5f32ffca64a7b3801bea';
@@ -149,6 +149,7 @@ class VersionGuesserTest extends TestCas
 
         $self = $this;
 
+        // Assumption here is that arbitrary would be the default branch
         $executor
             ->expects($this->at(0))
             ->method('execute')
@@ -160,11 +161,45 @@ class VersionGuesserTest extends TestCas
             })
         ;
 
+        $config = new Config;
+        $config->merge(array('repositories' => array('packagist' => false)));
+        $guesser = new VersionGuesser($config, $executor, new VersionParser());
+        $versionArray = $guesser->guessVersion(array('version' => 'self.version'), 'dummy/path');
+
+        $this->assertEquals("dev-current", $versionArray['version']);
+        $this->assertEquals($anotherCommitHash, $versionArray['commit']);
+    }
+
+    public function testGuessVersionReadsAndRespectsNonFeatureBranchesConfigurationForArbitraryNaming()
+    {
+        $commitHash = '03a15d220da53c52eddd5f32ffca64a7b3801bea';
+        $anotherCommitHash = '13a15d220da53c52eddd5f32ffca64a7b3801bea';
+
+        $executor = $this->getMockBuilder('\\Composer\\Util\\ProcessExecutor')
+            ->setMethods(array('execute'))
+            ->disableArgumentCloning()
+            ->disableOriginalConstructor()
+            ->getMock()
+        ;
+
+        $self = $this;
+
+        $executor
+            ->expects($this->at(0))
+            ->method('execute')
+            ->willReturnCallback(function ($command, &$output) use ($self, $commitHash, $anotherCommitHash) {
+                $self->assertEquals('git branch -a --no-color --no-abbrev -v', $command);
+                $output = "  arbitrary $commitHash Commit message\n* feature $anotherCommitHash Another message\n";
+
+                return 0;
+            })
+        ;
+
         $executor
             ->expects($this->at(1))
             ->method('execute')
             ->willReturnCallback(function ($command, &$output, $path) use ($self, $anotherCommitHash) {
-                $self->assertEquals('git rev-list arbitrary..current', $command);
+                $self->assertEquals('git rev-list arbitrary..feature', $command);
                 $output = "$anotherCommitHash\n";
 
                 return 0;
@@ -178,8 +213,8 @@ class VersionGuesserTest extends TestCas
 
         $this->assertEquals("dev-arbitrary", $versionArray['version']);
         $this->assertEquals($anotherCommitHash, $versionArray['commit']);
-        $this->assertEquals("dev-current", $versionArray['feature_version']);
-        $this->assertEquals("dev-current", $versionArray['feature_pretty_version']);
+        $this->assertEquals("dev-feature", $versionArray['feature_version']);
+        $this->assertEquals("dev-feature", $versionArray['feature_pretty_version']);
     }
 
     public function testGuessVersionReadsAndRespectsNonFeatureBranchesConfigurationForArbitraryNamingRegex()
@@ -201,17 +236,16 @@ class VersionGuesserTest extends TestCas
             ->method('execute')
             ->willReturnCallback(function ($command, &$output) use ($self, $commitHash, $anotherCommitHash) {
                 $self->assertEquals('git branch -a --no-color --no-abbrev -v', $command);
-                $output = "  latest-testing $commitHash Commit message\n* current $anotherCommitHash Another message\n";
+                $output = "  latest-testing $commitHash Commit message\n* feature $anotherCommitHash Another message\n";
 
                 return 0;
             })
         ;
-
         $executor
             ->expects($this->at(1))
             ->method('execute')
             ->willReturnCallback(function ($command, &$output, $path) use ($self, $anotherCommitHash) {
-                $self->assertEquals('git rev-list latest-testing..current', $command);
+                $self->assertEquals('git rev-list latest-testing..feature', $command);
                 $output = "$anotherCommitHash\n";
 
                 return 0;
@@ -225,8 +259,8 @@ class VersionGuesserTest extends TestCas
 
         $this->assertEquals("dev-latest-testing", $versionArray['version']);
         $this->assertEquals($anotherCommitHash, $versionArray['commit']);
-        $this->assertEquals("dev-current", $versionArray['feature_version']);
-        $this->assertEquals("dev-current", $versionArray['feature_pretty_version']);
+        $this->assertEquals("dev-feature", $versionArray['feature_version']);
+        $this->assertEquals("dev-feature", $versionArray['feature_pretty_version']);
     }
 
     public function testGuessVersionReadsAndRespectsNonFeatureBranchesConfigurationForArbitraryNamingWhenOnNonFeatureBranch()
@@ -378,7 +412,6 @@ class VersionGuesserTest extends TestCas
                 return 0;
             })
         ;
-
         $executor
             ->expects($this->at(1))
             ->method('execute')
@@ -419,7 +452,6 @@ class VersionGuesserTest extends TestCas
                 return 0;
             })
         ;
-
         $executor
             ->expects($this->at(1))
             ->method('execute')
diff -pruN 1.10.19-1/tests/Composer/Test/Package/Version/VersionParserTest.php 2.0.9-1/tests/Composer/Test/Package/Version/VersionParserTest.php
--- 1.10.19-1/tests/Composer/Test/Package/Version/VersionParserTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Package/Version/VersionParserTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -49,9 +49,9 @@ class VersionParserTest extends TestCase
         return array(
             array('0.9.0.0', '1.0.0.0', true),
             array('1.0.0.0', '0.9.0.0', false),
-            array('1.0.0.0', '9999999-dev', true),
-            array('9999999-dev', '9999999-dev', true),
-            array('9999999-dev', '1.0.0.0', false),
+            array('1.0.0.0', VersionParser::DEFAULT_BRANCH_ALIAS, true),
+            array(VersionParser::DEFAULT_BRANCH_ALIAS, VersionParser::DEFAULT_BRANCH_ALIAS, true),
+            array(VersionParser::DEFAULT_BRANCH_ALIAS, '1.0.0.0', false),
             array('1.0.0.0', 'dev-foo', true),
             array('dev-foo', 'dev-foo', true),
             array('dev-foo', '1.0.0.0', true),
diff -pruN 1.10.19-1/tests/Composer/Test/Package/Version/VersionSelectorTest.php 2.0.9-1/tests/Composer/Test/Package/Version/VersionSelectorTest.php
--- 1.10.19-1/tests/Composer/Test/Package/Version/VersionSelectorTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Package/Version/VersionSelectorTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -15,13 +15,15 @@ namespace Composer\Test\Package\Version;
 use Composer\Package\Version\VersionSelector;
 use Composer\Package\Package;
 use Composer\Package\Link;
-use Composer\Semver\VersionParser;
+use Composer\Package\AliasPackage;
+use Composer\Repository\PlatformRepository;
+use Composer\Package\Version\VersionParser;
 use Composer\Test\TestCase;
 
 class VersionSelectorTest extends TestCase
 {
     // A) multiple versions, get the latest one
-    // B) targetPackageVersion will pass to pool
+    // B) targetPackageVersion will pass to repo set
     // C) No results, throw exception
 
     public function testLatestVersionIsReturned()
@@ -33,40 +35,95 @@ class VersionSelectorTest extends TestCa
         $package3 = $this->createPackage('1.2.0');
         $packages = array($package1, $package2, $package3);
 
-        $pool = $this->createMockPool();
-        $pool->expects($this->once())
-            ->method('whatProvides')
-            ->with($packageName, null, true)
+        $repositorySet = $this->createMockRepositorySet();
+        $repositorySet->expects($this->once())
+            ->method('findPackages')
+            ->with($packageName, null)
             ->will($this->returnValue($packages));
 
-        $versionSelector = new VersionSelector($pool);
+        $versionSelector = new VersionSelector($repositorySet);
         $best = $versionSelector->findBestCandidate($packageName);
 
         // 1.2.2 should be returned because it's the latest of the returned versions
         $this->assertSame($package2, $best, 'Latest version should be 1.2.2');
     }
 
-    public function testLatestVersionIsReturnedThatMatchesPhpRequirement()
+    public function testLatestVersionIsReturnedThatMatchesPhpRequirements()
     {
         $packageName = 'foobar';
 
+        $platform = new PlatformRepository(array(), array('php' => '5.5.0'));
+        $repositorySet = $this->createMockRepositorySet();
+        $versionSelector = new VersionSelector($repositorySet, $platform);
+
         $parser = new VersionParser;
         $package1 = $this->createPackage('1.0.0');
+        $package1->setRequires(array('php' => new Link($packageName, 'php', $parser->parseConstraints('>=5.4'), Link::TYPE_REQUIRE, '>=5.4')));
         $package2 = $this->createPackage('2.0.0');
-        $package1->setRequires(array('php' => new Link($packageName, 'php', $parser->parseConstraints('>=5.4'), 'requires', '>=5.4')));
-        $package2->setRequires(array('php' => new Link($packageName, 'php', $parser->parseConstraints('>=5.6'), 'requires', '>=5.6')));
+        $package2->setRequires(array('php' => new Link($packageName, 'php', $parser->parseConstraints('>=5.6'), Link::TYPE_REQUIRE, '>=5.6')));
         $packages = array($package1, $package2);
 
-        $pool = $this->createMockPool();
-        $pool->expects($this->once())
-            ->method('whatProvides')
-            ->with($packageName, null, true)
+        $repositorySet->expects($this->any())
+            ->method('findPackages')
+            ->with($packageName, null)
             ->will($this->returnValue($packages));
 
-        $versionSelector = new VersionSelector($pool);
-        $best = $versionSelector->findBestCandidate($packageName, null, '5.5.0');
-
+        $best = $versionSelector->findBestCandidate($packageName);
         $this->assertSame($package1, $best, 'Latest version supporting php 5.5 should be returned (1.0.0)');
+        $best = $versionSelector->findBestCandidate($packageName, null, 'stable', true);
+        $this->assertSame($package2, $best, 'Latest version should be returned when ignoring platform reqs (2.0.0)');
+    }
+
+    public function testLatestVersionIsReturnedThatMatchesExtRequirements()
+    {
+        $packageName = 'foobar';
+
+        $platform = new PlatformRepository(array(), array('ext-zip' => '5.3.0'));
+        $repositorySet = $this->createMockRepositorySet();
+        $versionSelector = new VersionSelector($repositorySet, $platform);
+
+        $parser = new VersionParser;
+        $package1 = $this->createPackage('1.0.0');
+        $package1->setRequires(array('ext-zip' => new Link($packageName, 'ext-zip', $parser->parseConstraints('^5.2'), Link::TYPE_REQUIRE, '^5.2')));
+        $package2 = $this->createPackage('2.0.0');
+        $package2->setRequires(array('ext-zip' => new Link($packageName, 'ext-zip', $parser->parseConstraints('^5.4'), Link::TYPE_REQUIRE, '^5.4')));
+        $packages = array($package1, $package2);
+
+        $repositorySet->expects($this->any())
+            ->method('findPackages')
+            ->with($packageName, null)
+            ->will($this->returnValue($packages));
+
+        $best = $versionSelector->findBestCandidate($packageName);
+        $this->assertSame($package1, $best, 'Latest version supporting ext-zip 5.3.0 should be returned (1.0.0)');
+        $best = $versionSelector->findBestCandidate($packageName, null, 'stable', true);
+        $this->assertSame($package2, $best, 'Latest version should be returned when ignoring platform reqs (2.0.0)');
+    }
+
+    public function testLatestVersionIsReturnedThatMatchesComposerRequirements()
+    {
+        $packageName = 'foobar';
+
+        $platform = new PlatformRepository(array(), array('composer-runtime-api' => '1.0.0'));
+        $repositorySet = $this->createMockRepositorySet();
+        $versionSelector = new VersionSelector($repositorySet, $platform);
+
+        $parser = new VersionParser;
+        $package1 = $this->createPackage('1.0.0');
+        $package1->setRequires(array('composer-runtime-api' => new Link($packageName, 'composer-runtime-api', $parser->parseConstraints('^1.0'), Link::TYPE_REQUIRE, '^1.0')));
+        $package2 = $this->createPackage('1.1.0');
+        $package2->setRequires(array('composer-runtime-api' => new Link($packageName, 'composer-runtime-api', $parser->parseConstraints('^2.0'), Link::TYPE_REQUIRE, '^2.0')));
+        $packages = array($package1, $package2);
+
+        $repositorySet->expects($this->any())
+            ->method('findPackages')
+            ->with($packageName, null)
+            ->will($this->returnValue($packages));
+
+        $best = $versionSelector->findBestCandidate($packageName);
+        $this->assertSame($package1, $best, 'Latest version supporting composer 1 should be returned (1.0.0)');
+        $best = $versionSelector->findBestCandidate($packageName, null, 'stable', true);
+        $this->assertSame($package2, $best, 'Latest version should be returned when ignoring platform reqs (1.1.0)');
     }
 
     public function testMostStableVersionIsReturned()
@@ -77,13 +134,13 @@ class VersionSelectorTest extends TestCa
         $package2 = $this->createPackage('1.1.0-beta');
         $packages = array($package1, $package2);
 
-        $pool = $this->createMockPool();
-        $pool->expects($this->once())
-            ->method('whatProvides')
-            ->with($packageName, null, true)
+        $repositorySet = $this->createMockRepositorySet();
+        $repositorySet->expects($this->once())
+            ->method('findPackages')
+            ->with($packageName, null)
             ->will($this->returnValue($packages));
 
-        $versionSelector = new VersionSelector($pool);
+        $versionSelector = new VersionSelector($repositorySet);
         $best = $versionSelector->findBestCandidate($packageName);
 
         $this->assertSame($package1, $best, 'Latest most stable version should be returned (1.0.0)');
@@ -97,22 +154,22 @@ class VersionSelectorTest extends TestCa
         $package2 = $this->createPackage('2.0.0-beta3');
         $packages = array($package1, $package2);
 
-        $pool = $this->createMockPool();
-        $pool->expects($this->at(0))
-            ->method('whatProvides')
-            ->with($packageName, null, true)
+        $repositorySet = $this->createMockRepositorySet();
+        $repositorySet->expects($this->at(0))
+            ->method('findPackages')
+            ->with($packageName, null)
             ->will($this->returnValue($packages));
 
-        $pool->expects($this->at(1))
-            ->method('whatProvides')
-            ->with($packageName, null, true)
+        $repositorySet->expects($this->at(1))
+            ->method('findPackages')
+            ->with($packageName, null)
             ->will($this->returnValue(array_reverse($packages)));
 
-        $versionSelector = new VersionSelector($pool);
-        $best = $versionSelector->findBestCandidate($packageName, null, null);
+        $versionSelector = new VersionSelector($repositorySet);
+        $best = $versionSelector->findBestCandidate($packageName);
         $this->assertSame($package2, $best, 'Expecting 2.0.0-beta3, cause beta is more stable than dev');
 
-        $best = $versionSelector->findBestCandidate($packageName, null, null);
+        $best = $versionSelector->findBestCandidate($packageName);
         $this->assertSame($package2, $best, 'Expecting 2.0.0-beta3, cause beta is more stable than dev');
     }
 
@@ -124,14 +181,14 @@ class VersionSelectorTest extends TestCa
         $package2 = $this->createPackage('1.1.0-beta');
         $packages = array($package1, $package2);
 
-        $pool = $this->createMockPool();
-        $pool->expects($this->once())
-            ->method('whatProvides')
-            ->with($packageName, null, true)
+        $repositorySet = $this->createMockRepositorySet();
+        $repositorySet->expects($this->once())
+            ->method('findPackages')
+            ->with($packageName, null)
             ->will($this->returnValue($packages));
 
-        $versionSelector = new VersionSelector($pool);
-        $best = $versionSelector->findBestCandidate($packageName, null, null, 'dev');
+        $versionSelector = new VersionSelector($repositorySet);
+        $best = $versionSelector->findBestCandidate($packageName, null, 'dev');
 
         $this->assertSame($package2, $best, 'Latest version should be returned (1.1.0-beta)');
     }
@@ -145,14 +202,14 @@ class VersionSelectorTest extends TestCa
         $package3 = $this->createPackage('1.2.0-alpha');
         $packages = array($package1, $package2, $package3);
 
-        $pool = $this->createMockPool();
-        $pool->expects($this->once())
-            ->method('whatProvides')
-            ->with($packageName, null, true)
+        $repositorySet = $this->createMockRepositorySet();
+        $repositorySet->expects($this->once())
+            ->method('findPackages')
+            ->with($packageName, null)
             ->will($this->returnValue($packages));
 
-        $versionSelector = new VersionSelector($pool);
-        $best = $versionSelector->findBestCandidate($packageName, null, null, 'beta');
+        $versionSelector = new VersionSelector($repositorySet);
+        $best = $versionSelector->findBestCandidate($packageName, null, 'beta');
 
         $this->assertSame($package2, $best, 'Latest version should be returned (1.1.0-beta)');
     }
@@ -165,26 +222,47 @@ class VersionSelectorTest extends TestCa
         $package3 = $this->createPackage('1.2.0-alpha');
         $packages = array($package2, $package3);
 
-        $pool = $this->createMockPool();
-        $pool->expects($this->once())
-            ->method('whatProvides')
-            ->with($packageName, null, true)
+        $repositorySet = $this->createMockRepositorySet();
+        $repositorySet->expects($this->once())
+            ->method('findPackages')
+            ->with($packageName, null)
             ->will($this->returnValue($packages));
 
-        $versionSelector = new VersionSelector($pool);
-        $best = $versionSelector->findBestCandidate($packageName, null, null, 'stable');
+        $versionSelector = new VersionSelector($repositorySet);
+        $best = $versionSelector->findBestCandidate($packageName, null, 'stable');
 
         $this->assertSame($package2, $best, 'Latest version should be returned (1.1.0-beta)');
     }
 
+    public function testDefaultBranchAliasIsNeverReturned()
+    {
+        $packageName = 'foobar';
+
+        $package = $this->createPackage('1.1.0-beta');
+        $package2 = $this->createPackage('dev-main');
+        $package2Alias = new AliasPackage($package2, VersionParser::DEFAULT_BRANCH_ALIAS, VersionParser::DEFAULT_BRANCH_ALIAS);
+        $packages = array($package, $package2Alias);
+
+        $repositorySet = $this->createMockRepositorySet();
+        $repositorySet->expects($this->once())
+            ->method('findPackages')
+            ->with($packageName, null)
+            ->will($this->returnValue($packages));
+
+        $versionSelector = new VersionSelector($repositorySet);
+        $best = $versionSelector->findBestCandidate($packageName, null, 'dev');
+
+        $this->assertSame($package2, $best, 'Latest version should be returned (dev-main)');
+    }
+
     public function testFalseReturnedOnNoPackages()
     {
-        $pool = $this->createMockPool();
-        $pool->expects($this->once())
-            ->method('whatProvides')
+        $repositorySet = $this->createMockRepositorySet();
+        $repositorySet->expects($this->once())
+            ->method('findPackages')
             ->will($this->returnValue(array()));
 
-        $versionSelector = new VersionSelector($pool);
+        $versionSelector = new VersionSelector($repositorySet);
         $best = $versionSelector->findBestCandidate('foobaz');
         $this->assertFalse($best, 'No versions are available returns false');
     }
@@ -194,8 +272,8 @@ class VersionSelectorTest extends TestCa
      */
     public function testFindRecommendedRequireVersion($prettyVersion, $isDev, $stability, $expectedVersion, $branchAlias = null)
     {
-        $pool = $this->createMockPool();
-        $versionSelector = new VersionSelector($pool);
+        $repositorySet = $this->createMockRepositorySet();
+        $versionSelector = new VersionSelector($repositorySet);
         $versionParser = new VersionParser();
 
         $package = $this->getMockBuilder('\Composer\Package\PackageInterface')->getMock();
@@ -260,6 +338,7 @@ class VersionSelectorTest extends TestCa
             array('dev-master', true, 'dev', '^2.0@dev', '2.x-dev'),
             array('dev-master', true, 'dev', '^0.3.0@dev', '0.3.x-dev'),
             array('dev-master', true, 'dev', '^0.0.3@dev', '0.0.3.x-dev'),
+            array('dev-master', true, 'dev', 'dev-master', VersionParser::DEFAULT_BRANCH_ALIAS),
             // numeric alias
             array('3.x-dev', true, 'dev', '^3.0@dev', '3.0.x-dev'),
             array('3.x-dev', true, 'dev', '^3.0@dev', '3.0-dev'),
@@ -273,8 +352,10 @@ class VersionSelectorTest extends TestCa
         return new Package('foo', $parser->normalize($version), $version);
     }
 
-    private function createMockPool()
+    private function createMockRepositorySet()
     {
-        return $this->getMockBuilder('Composer\DependencyResolver\Pool')->getMock();
+        return $this->getMockBuilder('Composer\Repository\RepositorySet')
+            ->disableOriginalConstructor()
+            ->getMock();
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Platform/HhvmDetectorTest.php 2.0.9-1/tests/Composer/Test/Platform/HhvmDetectorTest.php
--- 1.10.19-1/tests/Composer/Test/Platform/HhvmDetectorTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Platform/HhvmDetectorTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,103 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Platform;
+
+use Composer\Platform\HhvmDetector;
+use Composer\Test\TestCase;
+use Composer\Util\Platform;
+use Composer\Util\ProcessExecutor;
+use Symfony\Component\Process\ExecutableFinder;
+
+class HhvmDetectorTest extends TestCase
+{
+    private $hhvmDetector;
+
+    protected function setUp()
+    {
+        $this->hhvmDetector = new HhvmDetector();
+        $this->hhvmDetector->reset();
+    }
+
+    public function testHHVMVersionWhenExecutingInHHVM()
+    {
+        if (!defined('HHVM_VERSION_ID')) {
+            self::markTestSkipped('Not running with HHVM');
+
+            return;
+        }
+        $version = $this->hhvmDetector->getVersion();
+        self::assertSame(self::versionIdToVersion(), $version);
+    }
+
+    public function testHHVMVersionWhenExecutingInPHP()
+    {
+        if (defined('HHVM_VERSION_ID')) {
+            self::markTestSkipped('Running with HHVM');
+
+            return;
+        }
+        if (PHP_VERSION_ID < 50400) {
+            self::markTestSkipped('Test only works on PHP 5.4+');
+
+            return;
+        }
+        if (Platform::isWindows()) {
+            self::markTestSkipped('Test does not run on Windows');
+
+            return;
+        }
+        $finder = new ExecutableFinder();
+        $hhvm = $finder->find('hhvm');
+        if ($hhvm === null) {
+            self::markTestSkipped('HHVM is not installed');
+        }
+
+        $detectedVersion = $this->hhvmDetector->getVersion();
+        self::assertNotNull($detectedVersion, 'Failed to detect HHVM version');
+
+        $process = new ProcessExecutor();
+        $exitCode = $process->execute(
+            ProcessExecutor::escape($hhvm).
+            ' --php -d hhvm.jit=0 -r "echo HHVM_VERSION;" 2>/dev/null',
+            $version
+        );
+        self::assertSame(0, $exitCode);
+
+        self::assertSame(self::getVersionParser()->normalize($version), self::getVersionParser()->normalize($detectedVersion));
+    }
+
+    /** @runInSeparateProcess */
+    public function testHHVMVersionWhenRunningInHHVMWithMockedConstant()
+    {
+        if (!defined('HHVM_VERSION_ID')) {
+            define('HHVM_VERSION', '2.2.1');
+            define('HHVM_VERSION_ID', 20201);
+        }
+        $version = $this->hhvmDetector->getVersion();
+        self::assertSame(self::getVersionParser()->normalize(self::versionIdToVersion()), self::getVersionParser()->normalize($version));
+    }
+
+    private static function versionIdToVersion()
+    {
+        if (!defined('HHVM_VERSION_ID')) {
+            return null;
+        }
+
+        return sprintf(
+            '%d.%d.%d',
+            HHVM_VERSION_ID / 10000,
+            (HHVM_VERSION_ID / 100) % 100,
+            HHVM_VERSION_ID % 100
+        );
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Platform/VersionTest.php 2.0.9-1/tests/Composer/Test/Platform/VersionTest.php
--- 1.10.19-1/tests/Composer/Test/Platform/VersionTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Platform/VersionTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,131 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Platform;
+
+use Composer\Platform\Version;
+use Composer\Test\TestCase;
+
+/**
+ * @author Lars Strojny <lars@strojny.net>
+ */
+class VersionTest extends TestCase
+{
+    /**
+     * Create normalized test data set
+     *
+     * 1) Clone OpenSSL repository
+     * 2) git log --pretty=%h --all -- crypto/opensslv.h include/openssl/opensslv.h | while read hash ; do (git show $hash:crypto/opensslv.h; git show $hash:include/openssl/opensslv.h)  | grep "define OPENSSL_VERSION_TEXT"  ; done > versions.txt
+     * 3) cat versions.txt | awk -F "OpenSSL " '{print $2}'  | awk -F " " '{print $1}' | sed -e "s:\([0-9]*\.[0-9]*\.[0-9]*\):1.2.3:g" -e "s:1\.2\.3[a-z]\(-.*\)\{0,1\}$:1.2.3a\1:g"  -e "s:1\.2\.3[a-z]\{2\}\(-.*\)\{0,1\}$:1.2.3zh\1:g"  -e "s:beta[0-9]:beta3:g"  -e "s:pre[0-9]*:pre2:g" | sort | uniq
+     */
+    public static function getOpenSslVersions()
+    {
+        return array(
+            // Generated
+            array('1.2.3', '1.2.3.0'),
+            array('1.2.3-beta3', '1.2.3.0-beta3'),
+            array('1.2.3-beta3-dev', '1.2.3.0-beta3-dev'),
+            array('1.2.3-beta3-fips', '1.2.3.0-beta3', true),
+            array('1.2.3-beta3-fips-dev', '1.2.3.0-beta3-dev', true),
+            array('1.2.3-dev', '1.2.3.0-dev'),
+            array('1.2.3-fips', '1.2.3.0', true),
+            array('1.2.3-fips-beta3', '1.2.3.0-beta3', true),
+            array('1.2.3-fips-beta3-dev', '1.2.3.0-beta3-dev', true),
+            array('1.2.3-fips-dev', '1.2.3.0-dev', true),
+            array('1.2.3-pre2', '1.2.3.0-alpha2'),
+            array('1.2.3-pre2-dev', '1.2.3.0-alpha2-dev'),
+            array('1.2.3-pre2-fips', '1.2.3.0-alpha2', true),
+            array('1.2.3-pre2-fips-dev', '1.2.3.0-alpha2-dev', true),
+            array('1.2.3a', '1.2.3.1'),
+            array('1.2.3a-beta3','1.2.3.1-beta3'),
+            array('1.2.3a-beta3-dev', '1.2.3.1-beta3-dev'),
+            array('1.2.3a-dev', '1.2.3.1-dev'),
+            array('1.2.3a-dev-fips', '1.2.3.1-dev', true),
+            array('1.2.3a-fips', '1.2.3.1', true),
+            array('1.2.3a-fips-beta3', '1.2.3.1-beta3', true),
+            array('1.2.3a-fips-dev', '1.2.3.1-dev', true),
+            array('1.2.3beta3', '1.2.3.0-beta3'),
+            array('1.2.3beta3-dev', '1.2.3.0-beta3-dev'),
+            array('1.2.3zh', '1.2.3.34'),
+            array('1.2.3zh-dev', '1.2.3.34-dev'),
+            array('1.2.3zh-fips', '1.2.3.34',true),
+            array('1.2.3zh-fips-dev', '1.2.3.34-dev', true),
+            // Additional cases
+            array('1.2.3zh-fips-rc3', '1.2.3.34-rc3', true, '1.2.3.34-RC3'),
+            array('1.2.3zh-alpha10-fips', '1.2.3.34-alpha10', true),
+            // Check that alphabetical patch levels overflow correctly
+            array('1.2.3', '1.2.3.0'),
+            array('1.2.3a', '1.2.3.1'),
+            array('1.2.3z', '1.2.3.26'),
+            array('1.2.3za', '1.2.3.27'),
+            array('1.2.3zy', '1.2.3.51'),
+            array('1.2.3zz', '1.2.3.52'),
+        );
+    }
+
+    /**
+     * @dataProvider getOpenSslVersions
+     * @param string      $input
+     * @param string      $parsedVersion
+     * @param bool        $fipsExpected
+     * @param string|null $normalizedVersion
+     */
+    public function testParseOpensslVersions($input, $parsedVersion, $fipsExpected = false, $normalizedVersion = null)
+    {
+        self::assertSame($parsedVersion, Version::parseOpenssl($input, $isFips));
+        self::assertSame($fipsExpected, $isFips);
+
+        $normalizedVersion = $normalizedVersion ? $normalizedVersion : $parsedVersion;
+        self::assertSame($normalizedVersion, $this->getVersionParser()->normalize($parsedVersion));
+    }
+
+    public function getLibJpegVersions()
+    {
+        return array(
+            array('9', '9.0'),
+            array('9a', '9.1'),
+            array('9b', '9.2'),
+            // Never seen in the wild, just for overflow correctness
+            array('9za', '9.27'),
+        );
+    }
+
+    /**
+     * @dataProvider getLibJpegVersions
+     * @param string $input
+     * @param string $parsedVersion
+     */
+    public function testParseLibjpegVersion($input, $parsedVersion)
+    {
+        self::assertSame($parsedVersion, Version::parseLibjpeg($input));
+    }
+
+    public function getZoneinfoVersions()
+    {
+        return array(
+            array('2019c', '2019.3'),
+            array('2020a', '2020.1'),
+            // Never happened so far but fixate overflow behavior
+            array('2020za', '2020.27'),
+        );
+    }
+
+    /**
+     * @dataProvider getZoneinfoVersions
+     * @param string $input
+     * @param string $parsedVersion
+     */
+    public function testParseZoneinfoVersion($input, $parsedVersion)
+    {
+        self::assertSame($parsedVersion, Version::parseZoneinfoVersion($input));
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v1/composer.json 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v1/composer.json
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v1/composer.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v1/composer.json	2021-01-27 15:09:27.000000000 +0000
@@ -7,6 +7,6 @@
         "class": "Installer\\Plugin"
     },
     "require": {
-        "composer-plugin-api": "^1.0"
+        "composer-plugin-api": "^2.0"
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v1/Installer/Plugin.php 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v1/Installer/Plugin.php
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v1/Installer/Plugin.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v1/Installer/Plugin.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,5 +12,16 @@ class Plugin implements PluginInterface
 
     public function activate(Composer $composer, IOInterface $io)
     {
+        $io->write('activate v1');
+    }
+
+    public function deactivate(Composer $composer, IOInterface $io)
+    {
+        $io->write('deactivate v1');
+    }
+
+    public function uninstall(Composer $composer, IOInterface $io)
+    {
+        $io->write('uninstall v1');
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v2/composer.json 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v2/composer.json
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v2/composer.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v2/composer.json	2021-01-27 15:09:27.000000000 +0000
@@ -7,6 +7,6 @@
         "class": "Installer\\Plugin2"
     },
     "require": {
-        "composer-plugin-api": "^1.0"
+        "composer-plugin-api": "^2.0"
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v2/Installer/Plugin2.php 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v2/Installer/Plugin2.php
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v2/Installer/Plugin2.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v2/Installer/Plugin2.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,5 +12,16 @@ class Plugin2 implements PluginInterface
 
     public function activate(Composer $composer, IOInterface $io)
     {
+        $io->write('activate v2');
+    }
+
+    public function deactivate(Composer $composer, IOInterface $io)
+    {
+        $io->write('deactivate v2');
+    }
+
+    public function uninstall(Composer $composer, IOInterface $io)
+    {
+        $io->write('uninstall v2');
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v3/composer.json 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v3/composer.json
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v3/composer.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v3/composer.json	2021-01-27 15:09:27.000000000 +0000
@@ -7,6 +7,6 @@
         "class": "Installer\\Plugin2"
     },
     "require": {
-        "composer-plugin-api": "^1.0"
+        "composer-plugin-api": "^2.0"
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v3/Installer/Plugin2.php 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v3/Installer/Plugin2.php
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v3/Installer/Plugin2.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v3/Installer/Plugin2.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,5 +12,16 @@ class Plugin2 implements PluginInterface
 
     public function activate(Composer $composer, IOInterface $io)
     {
+        $io->write('activate v3');
+    }
+
+    public function deactivate(Composer $composer, IOInterface $io)
+    {
+        $io->write('deactivate v3');
+    }
+
+    public function uninstall(Composer $composer, IOInterface $io)
+    {
+        $io->write('uninstall v3');
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v4/composer.json 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v4/composer.json
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v4/composer.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v4/composer.json	2021-01-27 15:09:27.000000000 +0000
@@ -10,6 +10,6 @@
         ]
     },
     "require": {
-        "composer-plugin-api": "^1.0"
+        "composer-plugin-api": "^2.0"
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v4/Installer/Plugin1.php 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v4/Installer/Plugin1.php
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v4/Installer/Plugin1.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v4/Installer/Plugin1.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,5 +13,16 @@ class Plugin1 implements PluginInterface
 
     public function activate(Composer $composer, IOInterface $io)
     {
+        $io->write('activate v4-plugin1');
+    }
+
+    public function deactivate(Composer $composer, IOInterface $io)
+    {
+        $io->write('deactivate v4-plugin1');
+    }
+
+    public function uninstall(Composer $composer, IOInterface $io)
+    {
+        $io->write('uninstall v4-plugin1');
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v4/Installer/Plugin2.php 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v4/Installer/Plugin2.php
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v4/Installer/Plugin2.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v4/Installer/Plugin2.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,5 +13,16 @@ class Plugin2 implements PluginInterface
 
     public function activate(Composer $composer, IOInterface $io)
     {
+        $io->write('activate v4-plugin2');
+    }
+
+    public function deactivate(Composer $composer, IOInterface $io)
+    {
+        $io->write('deactivate v4-plugin2');
+    }
+
+    public function uninstall(Composer $composer, IOInterface $io)
+    {
+        $io->write('uninstall v4-plugin2');
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v5/Installer/Plugin5.php 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v5/Installer/Plugin5.php
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v5/Installer/Plugin5.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v5/Installer/Plugin5.php	2021-01-27 15:09:27.000000000 +0000
@@ -10,5 +10,16 @@ class Plugin5 implements PluginInterface
 {
     public function activate(Composer $composer, IOInterface $io)
     {
+        $io->write('activate v5');
+    }
+
+    public function deactivate(Composer $composer, IOInterface $io)
+    {
+        $io->write('deactivate v5');
+    }
+
+    public function uninstall(Composer $composer, IOInterface $io)
+    {
+        $io->write('uninstall v5');
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v6/Installer/Plugin6.php 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v6/Installer/Plugin6.php
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v6/Installer/Plugin6.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v6/Installer/Plugin6.php	2021-01-27 15:09:27.000000000 +0000
@@ -10,5 +10,16 @@ class Plugin6 implements PluginInterface
 {
     public function activate(Composer $composer, IOInterface $io)
     {
+        $io->write('activate v6');
+    }
+
+    public function deactivate(Composer $composer, IOInterface $io)
+    {
+        $io->write('deactivate v6');
+    }
+
+    public function uninstall(Composer $composer, IOInterface $io)
+    {
+        $io->write('uninstall v6');
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v7/Installer/Plugin7.php 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v7/Installer/Plugin7.php
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v7/Installer/Plugin7.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v7/Installer/Plugin7.php	2021-01-27 15:09:27.000000000 +0000
@@ -10,5 +10,16 @@ class Plugin7 implements PluginInterface
 {
     public function activate(Composer $composer, IOInterface $io)
     {
+        $io->write('activate v7');
+    }
+
+    public function deactivate(Composer $composer, IOInterface $io)
+    {
+        $io->write('deactivate v7');
+    }
+
+    public function uninstall(Composer $composer, IOInterface $io)
+    {
+        $io->write('uninstall v7');
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v8/composer.json 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v8/composer.json
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v8/composer.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v8/composer.json	2021-01-27 15:09:27.000000000 +0000
@@ -9,6 +9,6 @@
         ]
     },
     "require": {
-        "composer-plugin-api": "1.1.0"
+        "composer-plugin-api": "2.0.0"
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v8/Installer/Plugin8.php 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v8/Installer/Plugin8.php
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v8/Installer/Plugin8.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v8/Installer/Plugin8.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,17 @@ class Plugin8 implements PluginInterface
 
     public function activate(Composer $composer, IOInterface $io)
     {
+        $io->write('activate v8');
+    }
+
+    public function deactivate(Composer $composer, IOInterface $io)
+    {
+        $io->write('deactivate v8');
+    }
+
+    public function uninstall(Composer $composer, IOInterface $io)
+    {
+        $io->write('uninstall v8');
     }
 
     public function getCapabilities()
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v9/composer.json 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v9/composer.json
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v9/composer.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v9/composer.json	2021-01-27 15:09:27.000000000 +0000
@@ -7,6 +7,6 @@
         "class": "Installer\\Plugin"
     },
     "require": {
-        "composer-plugin-api": "^1.0"
+        "composer-plugin-api": "^2.0"
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v9/Installer/Plugin.php 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v9/Installer/Plugin.php
--- 1.10.19-1/tests/Composer/Test/Plugin/Fixtures/plugin-v9/Installer/Plugin.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/Fixtures/plugin-v9/Installer/Plugin.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,5 +14,16 @@ class Plugin implements PluginInterface
 
     public function activate(Composer $composer, IOInterface $io)
     {
+        $io->write('activate v9');
+    }
+
+    public function deactivate(Composer $composer, IOInterface $io)
+    {
+        $io->write('deactivate v9');
+    }
+
+    public function uninstall(Composer $composer, IOInterface $io)
+    {
+        $io->write('uninstall v9');
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Plugin/PluginInstallerTest.php 2.0.9-1/tests/Composer/Test/Plugin/PluginInstallerTest.php
--- 1.10.19-1/tests/Composer/Test/Plugin/PluginInstallerTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Plugin/PluginInstallerTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -18,7 +18,10 @@ use Composer\Installer\PluginInstaller;
 use Composer\Package\CompletePackage;
 use Composer\Package\Loader\JsonLoader;
 use Composer\Package\Loader\ArrayLoader;
+use Composer\Package\RootPackage;
 use Composer\Plugin\PluginManager;
+use Composer\IO\BufferIO;
+use Composer\EventDispatcher\EventDispatcher;
 use Composer\Autoload\AutoloadGenerator;
 use Composer\Test\TestCase;
 use Composer\Util\Filesystem;
@@ -89,14 +92,14 @@ class PluginInstallerTest extends TestCa
             ->method('getLocalRepository')
             ->will($this->returnValue($this->repository));
 
-        $im = $this->getMockBuilder('Composer\Installer\InstallationManager')->getMock();
+        $im = $this->getMockBuilder('Composer\Installer\InstallationManager')->disableOriginalConstructor()->getMock();
         $im->expects($this->any())
             ->method('getInstallPath')
             ->will($this->returnCallback(function ($package) {
                 return __DIR__.'/Fixtures/'.$package->getPrettyName();
             }));
 
-        $this->io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
+        $this->io = new BufferIO();
 
         $dispatcher = $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')->disableOriginalConstructor()->getMock();
         $this->autoloadGenerator = new AutoloadGenerator($dispatcher);
@@ -108,6 +111,8 @@ class PluginInstallerTest extends TestCa
         $this->composer->setRepositoryManager($rm);
         $this->composer->setInstallationManager($im);
         $this->composer->setAutoloadGenerator($this->autoloadGenerator);
+        $this->composer->setEventDispatcher(new EventDispatcher($this->composer, $this->io));
+        $this->composer->setPackage(new RootPackage('dummy/root', '1.0.0.0', '1.0.0'));
 
         $this->pm = new PluginManager($this->io, $this->composer);
         $this->composer->setPluginManager($this->pm);
@@ -130,7 +135,7 @@ class PluginInstallerTest extends TestCa
     public function testInstallNewPlugin()
     {
         $this->repository
-            ->expects($this->exactly(2))
+            ->expects($this->any())
             ->method('getPackages')
             ->will($this->returnValue(array()));
         $installer = new PluginInstaller($this->io, $this->composer);
@@ -140,12 +145,13 @@ class PluginInstallerTest extends TestCa
 
         $plugins = $this->pm->getPlugins();
         $this->assertEquals('installer-v1', $plugins[0]->version);
+        $this->assertEquals('activate v1'.PHP_EOL, $this->io->getOutput());
     }
 
     public function testInstallMultiplePlugins()
     {
         $this->repository
-            ->expects($this->exactly(2))
+            ->expects($this->any())
             ->method('getPackages')
             ->will($this->returnValue(array($this->packages[3])));
         $installer = new PluginInstaller($this->io, $this->composer);
@@ -158,12 +164,13 @@ class PluginInstallerTest extends TestCa
         $this->assertEquals('installer-v4', $plugins[0]->version);
         $this->assertEquals('plugin2', $plugins[1]->name);
         $this->assertEquals('installer-v4', $plugins[1]->version);
+        $this->assertEquals('activate v4-plugin1'.PHP_EOL.'activate v4-plugin2'.PHP_EOL, $this->io->getOutput());
     }
 
     public function testUpgradeWithNewClassName()
     {
         $this->repository
-            ->expects($this->exactly(3))
+            ->expects($this->any())
             ->method('getPackages')
             ->will($this->returnValue(array($this->packages[0])));
         $this->repository
@@ -176,13 +183,35 @@ class PluginInstallerTest extends TestCa
         $installer->update($this->repository, $this->packages[0], $this->packages[1]);
 
         $plugins = $this->pm->getPlugins();
+        $this->assertCount(1, $plugins);
         $this->assertEquals('installer-v2', $plugins[1]->version);
+        $this->assertEquals('activate v1'.PHP_EOL.'deactivate v1'.PHP_EOL.'activate v2'.PHP_EOL, $this->io->getOutput());
+    }
+
+    public function testUninstall()
+    {
+        $this->repository
+            ->expects($this->any())
+            ->method('getPackages')
+            ->will($this->returnValue(array($this->packages[0])));
+        $this->repository
+            ->expects($this->exactly(1))
+            ->method('hasPackage')
+            ->will($this->onConsecutiveCalls(true, false));
+        $installer = new PluginInstaller($this->io, $this->composer);
+        $this->pm->loadInstalledPlugins();
+
+        $installer->uninstall($this->repository, $this->packages[0]);
+
+        $plugins = $this->pm->getPlugins();
+        $this->assertCount(0, $plugins);
+        $this->assertEquals('activate v1'.PHP_EOL.'deactivate v1'.PHP_EOL.'uninstall v1'.PHP_EOL, $this->io->getOutput());
     }
 
     public function testUpgradeWithSameClassName()
     {
         $this->repository
-            ->expects($this->exactly(3))
+            ->expects($this->any())
             ->method('getPackages')
             ->will($this->returnValue(array($this->packages[1])));
         $this->repository
@@ -196,12 +225,13 @@ class PluginInstallerTest extends TestCa
 
         $plugins = $this->pm->getPlugins();
         $this->assertEquals('installer-v3', $plugins[1]->version);
+        $this->assertEquals('activate v2'.PHP_EOL.'deactivate v2'.PHP_EOL.'activate v3'.PHP_EOL, $this->io->getOutput());
     }
 
     public function testRegisterPluginOnlyOneTime()
     {
         $this->repository
-            ->expects($this->exactly(2))
+            ->expects($this->any())
             ->method('getPackages')
             ->will($this->returnValue(array()));
         $installer = new PluginInstaller($this->io, $this->composer);
@@ -213,6 +243,7 @@ class PluginInstallerTest extends TestCa
         $plugins = $this->pm->getPlugins();
         $this->assertCount(1, $plugins);
         $this->assertEquals('installer-v1', $plugins[0]->version);
+        $this->assertEquals('activate v1'.PHP_EOL, $this->io->getOutput());
     }
 
     /**
@@ -240,11 +271,11 @@ class PluginInstallerTest extends TestCa
 
         // Add the plugins to the repo along with the internal Plugin package on which they all rely.
         $this->repository
-             ->expects($this->any())
-             ->method('getPackages')
-             ->will($this->returnCallback(function () use ($plugApiInternalPackage, $plugins) {
-                 return array_merge(array($plugApiInternalPackage), $plugins);
-             }));
+            ->expects($this->any())
+            ->method('getPackages')
+            ->will($this->returnCallback(function () use ($plugApiInternalPackage, $plugins) {
+                return array_merge(array($plugApiInternalPackage), $plugins);
+            }));
 
         $this->pm->loadInstalledPlugins();
     }
@@ -300,7 +331,7 @@ class PluginInstallerTest extends TestCa
     public function testCommandProviderCapability()
     {
         $this->repository
-            ->expects($this->exactly(2))
+            ->expects($this->any())
             ->method('getPackages')
             ->will($this->returnValue(array($this->packages[7])));
         $installer = new PluginInstaller($this->io, $this->composer);
@@ -368,10 +399,11 @@ class PluginInstallerTest extends TestCa
 
     /**
      * @dataProvider invalidImplementationClassNames
-     * @expectedException \UnexpectedValueException
      */
-    public function testQueryingWithInvalidCapabilityClassNameThrows($invalidImplementationClassNames)
+    public function testQueryingWithInvalidCapabilityClassNameThrows($invalidImplementationClassNames, $expect = 'UnexpectedValueException')
     {
+        $this->setExpectedException($expect);
+
         $capabilityApi = 'Composer\Plugin\Capability\Capability';
 
         $plugin = $this->getMockBuilder('Composer\Test\Plugin\Mock\CapablePluginInterface')
@@ -404,10 +436,9 @@ class PluginInstallerTest extends TestCa
 
     /**
      * @dataProvider nonExistingOrInvalidImplementationClassTypes
-     * @expectedException \RuntimeException
      */
     public function testQueryingWithNonExistingOrWrongCapabilityClassTypesThrows($wrongImplementationClassTypes)
     {
-        $this->testQueryingWithInvalidCapabilityClassNameThrows($wrongImplementationClassTypes);
+        $this->testQueryingWithInvalidCapabilityClassNameThrows($wrongImplementationClassTypes, 'RuntimeException');
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/PolyfillTestCase.php 2.0.9-1/tests/Composer/Test/PolyfillTestCase.php
--- 1.10.19-1/tests/Composer/Test/PolyfillTestCase.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/PolyfillTestCase.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,759 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test {
+    use PHPUnit\Framework\TestCase;
+    use PHPUnit\Framework\Constraint\LogicalNot;
+    use PHPUnit\Framework\Constraint\StringContains;
+
+    if (method_exists('PHPUnit\Framework\TestCase', 'assertStringContainsString')) {
+        abstract class PolyfillTestCase extends TestCase
+        {
+        }
+    } else {
+        abstract class PolyfillTestCase extends TestCase
+        {
+            // all the functions below are form https://github.com/symfony/phpunit-bridge/blob/bd341a45ef79b30918376e8b8e2279fac6894c3b/Legacy/PolyfillAssertTrait.php
+
+            /**
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertIsInt($actual, $message = '')
+            {
+                static::assertInternalType('int', $actual, $message);
+            }
+
+            /**
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertIsNumeric($actual, $message = '')
+            {
+                static::assertInternalType('numeric', $actual, $message);
+            }
+
+            /**
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertIsObject($actual, $message = '')
+            {
+                static::assertInternalType('object', $actual, $message);
+            }
+
+            /**
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertIsResource($actual, $message = '')
+            {
+                static::assertInternalType('resource', $actual, $message);
+            }
+
+            /**
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertIsString($actual, $message = '')
+            {
+                static::assertInternalType('string', $actual, $message);
+            }
+
+            /**
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertIsScalar($actual, $message = '')
+            {
+                static::assertInternalType('scalar', $actual, $message);
+            }
+
+            /**
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertIsCallable($actual, $message = '')
+            {
+                static::assertInternalType('callable', $actual, $message);
+            }
+
+            /**
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertIsIterable($actual, $message = '')
+            {
+                static::assertInternalType('iterable', $actual, $message);
+            }
+
+            /**
+             * @param string $needle
+             * @param string $haystack
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertStringContainsString($needle, $haystack, $message = '')
+            {
+                $constraint = new StringContains($needle, false);
+                static::assertThat($haystack, $constraint, $message);
+            }
+
+            /**
+             * @param string $needle
+             * @param string $haystack
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertStringContainsStringIgnoringCase($needle, $haystack, $message = '')
+            {
+                $constraint = new StringContains($needle, true);
+                static::assertThat($haystack, $constraint, $message);
+            }
+
+            /**
+             * @param string $needle
+             * @param string $haystack
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertStringNotContainsString($needle, $haystack, $message = '')
+            {
+                $constraint = new LogicalNot(new StringContains($needle, false));
+                static::assertThat($haystack, $constraint, $message);
+            }
+
+            /**
+             * @param string $needle
+             * @param string $haystack
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertStringNotContainsStringIgnoringCase($needle, $haystack, $message = '')
+            {
+                $constraint = new LogicalNot(new StringContains($needle, true));
+                static::assertThat($haystack, $constraint, $message);
+            }
+
+            /**
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertFinite($actual, $message = '')
+            {
+                static::assertInternalType('float', $actual, $message);
+                static::assertTrue(is_finite($actual), $message ? $message : "Failed asserting that $actual is finite.");
+            }
+
+            /**
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertInfinite($actual, $message = '')
+            {
+                static::assertInternalType('float', $actual, $message);
+                static::assertTrue(is_infinite($actual), $message ? $message : "Failed asserting that $actual is infinite.");
+            }
+
+            /**
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertNan($actual, $message = '')
+            {
+                static::assertInternalType('float', $actual, $message);
+                static::assertTrue(is_nan($actual), $message ? $message : "Failed asserting that $actual is nan.");
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertIsReadable($filename, $message = '')
+            {
+                static::assertInternalType('string', $filename, $message);
+                static::assertTrue(is_readable($filename), $message ? $message : "Failed asserting that $filename is readable.");
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertNotIsReadable($filename, $message = '')
+            {
+                static::assertInternalType('string', $filename, $message);
+                static::assertFalse(is_readable($filename), $message ? $message : "Failed asserting that $filename is not readable.");
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertIsNotReadable($filename, $message = '')
+            {
+                static::assertNotIsReadable($filename, $message);
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertIsWritable($filename, $message = '')
+            {
+                static::assertInternalType('string', $filename, $message);
+                static::assertTrue(is_writable($filename), $message ? $message : "Failed asserting that $filename is writable.");
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertNotIsWritable($filename, $message = '')
+            {
+                static::assertInternalType('string', $filename, $message);
+                static::assertFalse(is_writable($filename), $message ? $message : "Failed asserting that $filename is not writable.");
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertIsNotWritable($filename, $message = '')
+            {
+                static::assertNotIsWritable($filename, $message);
+            }
+
+            /**
+             * @param string $directory
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertDirectoryExists($directory, $message = '')
+            {
+                static::assertInternalType('string', $directory, $message);
+                static::assertTrue(is_dir($directory), $message ? $message : "Failed asserting that $directory exists.");
+            }
+
+            /**
+             * @param string $directory
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertDirectoryNotExists($directory, $message = '')
+            {
+                static::assertInternalType('string', $directory, $message);
+                static::assertFalse(is_dir($directory), $message ? $message : "Failed asserting that $directory does not exist.");
+            }
+
+            /**
+             * @param string $directory
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertDirectoryDoesNotExist($directory, $message = '')
+            {
+                static::assertDirectoryNotExists($directory, $message);
+            }
+
+            /**
+             * @param string $directory
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertDirectoryIsReadable($directory, $message = '')
+            {
+                static::assertDirectoryExists($directory, $message);
+                static::assertIsReadable($directory, $message);
+            }
+
+            /**
+             * @param string $directory
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertDirectoryNotIsReadable($directory, $message = '')
+            {
+                static::assertDirectoryExists($directory, $message);
+                static::assertNotIsReadable($directory, $message);
+            }
+
+            /**
+             * @param string $directory
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertDirectoryIsNotReadable($directory, $message = '')
+            {
+                static::assertDirectoryNotIsReadable($directory, $message);
+            }
+
+            /**
+             * @param string $directory
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertDirectoryIsWritable($directory, $message = '')
+            {
+                static::assertDirectoryExists($directory, $message);
+                static::assertIsWritable($directory, $message);
+            }
+
+            /**
+             * @param string $directory
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertDirectoryNotIsWritable($directory, $message = '')
+            {
+                static::assertDirectoryExists($directory, $message);
+                static::assertNotIsWritable($directory, $message);
+            }
+
+            /**
+             * @param string $directory
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertDirectoryIsNotWritable($directory, $message = '')
+            {
+                static::assertDirectoryNotIsWritable($directory, $message);
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertFileExists($filename, $message = '')
+            {
+                static::assertInternalType('string', $filename, $message);
+                static::assertTrue(file_exists($filename), $message ? $message : "Failed asserting that $filename exists.");
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertFileNotExists($filename, $message = '')
+            {
+                static::assertInternalType('string', $filename, $message);
+                static::assertFalse(file_exists($filename), $message ? $message : "Failed asserting that $filename does not exist.");
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertFileDoesNotExist($filename, $message = '')
+            {
+                static::assertFileNotExists($filename, $message);
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertFileIsReadable($filename, $message = '')
+            {
+                static::assertFileExists($filename, $message);
+                static::assertIsReadable($filename, $message);
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertFileNotIsReadable($filename, $message = '')
+            {
+                static::assertFileExists($filename, $message);
+                static::assertNotIsReadable($filename, $message);
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertFileIsNotReadable($filename, $message = '')
+            {
+                static::assertFileNotIsReadable($filename, $message);
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertFileIsWritable($filename, $message = '')
+            {
+                static::assertFileExists($filename, $message);
+                static::assertIsWritable($filename, $message);
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertFileNotIsWritable($filename, $message = '')
+            {
+                static::assertFileExists($filename, $message);
+                static::assertNotIsWritable($filename, $message);
+            }
+
+            /**
+             * @param string $filename
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertFileIsNotWritable($filename, $message = '')
+            {
+                static::assertFileNotIsWritable($filename, $message);
+            }
+
+            /**
+             * @param string $pattern
+             * @param string $string
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertMatchesRegularExpression($pattern, $string, $message = '')
+            {
+                static::assertRegExp($pattern, $string, $message);
+            }
+
+            /**
+             * @param string $pattern
+             * @param string $string
+             * @param string $message
+             *
+             * @return void
+             */
+            public static function assertDoesNotMatchRegularExpression($pattern, $string, $message = '')
+            {
+                static::assertNotRegExp($pattern, $string, $message);
+            }
+        }
+    }
+}
+
+namespace {
+    foreach (array(
+        'PHPUnit\Framework\Constraint\IsEqual',
+        'PHPUnit\Framework\Constraint\StringContains',
+        'PHPUnit\Framework\Constraint\TraversableContains',
+    ) as $class) {
+        if (!class_exists($class) && class_exists(str_replace('\\', '_', $class))) {
+            class_alias(str_replace('\\', '_', $class), $class);
+        }
+    }
+
+    foreach (array(
+        'PHPUnit\Framework\SelfDescribing',
+    ) as $interface) {
+        if (!interface_exists($interface) && interface_exists(str_replace('\\', '_', $interface))) {
+            class_alias(str_replace('\\', '_', $interface), $interface);
+        }
+    }
+
+    if (!class_exists('PHPUnit\Framework\Constraint\Constraint')) {
+        class_alias('PHPUnit_Framework_Constraint', 'PHPUnit\Framework\Constraint\Constraint');
+    }
+}
+
+// all the code below taken from various PHPUnit versions to make things work on PHPUnit 4.8 / PHP 5.3
+/*
+ * This file is part of PHPUnit.
+ *
+ * (c) Sebastian Bergmann <sebastian@phpunit.de>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace PHPUnit\Framework\Constraint {
+    use PHPUnit\Framework\ExpectationFailedException;
+
+    if (!class_exists('PHPUnit\Framework\Constraint\RegularExpression')) {
+        /**
+         * Constraint that asserts that the string it is evaluated for matches
+         * a regular expression.
+         *
+         * Checks a given value using the Perl Compatible Regular Expression extension
+         * in PHP. The pattern is matched by executing preg_match().
+         *
+         * The pattern string passed in the constructor.
+         */
+        class RegularExpression extends Constraint
+        {
+            /**
+             * @var string
+             */
+            protected $pattern;
+
+            /**
+             * @param string $pattern
+             */
+            public function __construct($pattern)
+            {
+                parent::__construct();
+                $this->pattern = $pattern;
+            }
+
+            /**
+             * Evaluates the constraint for parameter $other. Returns true if the
+             * constraint is met, false otherwise.
+             *
+             * @param mixed $other Value or object to evaluate.
+             *
+             * @return bool
+             */
+            protected function matches($other)
+            {
+                return \preg_match($this->pattern, $other) > 0;
+            }
+
+            /**
+             * Returns a string representation of the constraint.
+             *
+             * @return string
+             */
+            public function toString()
+            {
+                return \sprintf(
+                    'matches PCRE pattern "%s"',
+                    $this->pattern
+                );
+            }
+        }
+    }
+
+    if (!class_exists('PHPUnit\Framework\Constraint\LogicalNot')) {
+        /**
+         * Logical NOT.
+         */
+        class LogicalNot extends Constraint
+        {
+            /**
+             * @var Constraint
+             */
+            protected $constraint;
+
+            /**
+             * @param Constraint $constraint
+             */
+            public function __construct($constraint)
+            {
+                parent::__construct();
+
+                if (!($constraint instanceof Constraint)) {
+                    $constraint = new IsEqual($constraint);
+                }
+
+                $this->constraint = $constraint;
+            }
+
+            /**
+             * @param string $string
+             *
+             * @return string
+             */
+            public static function negate($string)
+            {
+                $positives = array(
+                    'contains ',
+                    'exists',
+                    'has ',
+                    'is ',
+                    'are ',
+                    'matches ',
+                    'starts with ',
+                    'ends with ',
+                    'reference ',
+                    'not not ',
+                );
+
+                $negatives = array(
+                    'does not contain ',
+                    'does not exist',
+                    'does not have ',
+                    'is not ',
+                    'are not ',
+                    'does not match ',
+                    'starts not with ',
+                    'ends not with ',
+                    'don\'t reference ',
+                    'not ',
+                );
+
+                \preg_match('/(\'[\w\W]*\')([\w\W]*)("[\w\W]*")/i', $string, $matches);
+
+                if (\count($matches) > 0) {
+                    $nonInput = $matches[2];
+
+                    $negatedString = \str_replace(
+                        $nonInput,
+                        \str_replace(
+                            $positives,
+                            $negatives,
+                            $nonInput
+                        ),
+                        $string
+                    );
+                } else {
+                    $negatedString = \str_replace(
+                        $positives,
+                        $negatives,
+                        $string
+                    );
+                }
+
+                return $negatedString;
+            }
+
+            /**
+             * Evaluates the constraint for parameter $other
+             *
+             * If $returnResult is set to false (the default), an exception is thrown
+             * in case of a failure. null is returned otherwise.
+             *
+             * If $returnResult is true, the result of the evaluation is returned as
+             * a boolean value instead: true in case of success, false in case of a
+             * failure.
+             *
+             * @param mixed  $other        Value or object to evaluate.
+             * @param string $description  Additional information about the test
+             * @param bool   $returnResult Whether to return a result or throw an exception
+             *
+             * @throws ExpectationFailedException
+             * @return mixed
+             */
+            public function evaluate($other, $description = '', $returnResult = false)
+            {
+                $success = !$this->constraint->evaluate($other, $description, true);
+
+                if ($returnResult) {
+                    return $success;
+                }
+
+                if (!$success) {
+                    $this->fail($other, $description);
+                }
+            }
+
+            /**
+             * Returns the description of the failure
+             *
+             * The beginning of failure messages is "Failed asserting that" in most
+             * cases. This method should return the second part of that sentence.
+             *
+             * @param mixed $other Evaluated value or object.
+             *
+             * @return string
+             */
+            protected function failureDescription($other)
+            {
+                switch (\get_class($this->constraint)) {
+                    case 'PHPUnit\Framework\Constraint\LogicalAnd':
+                    case 'PHPUnit\Framework\Constraint\LogicalNot':
+                    case 'PHPUnit\Framework\Constraint\LogicalOr':
+                        return 'not( ' . $this->constraint->failureDescription($other) . ' )';
+
+                    default:
+                        return self::negate(
+                            $this->constraint->failureDescription($other)
+                        );
+                }
+            }
+
+            /**
+             * Returns a string representation of the constraint.
+             *
+             * @return string
+             */
+            public function toString()
+            {
+                switch (\get_class($this->constraint)) {
+                    case 'PHPUnit\Framework\Constraint\LogicalAnd':
+                    case 'PHPUnit\Framework\Constraint\LogicalNot':
+                    case 'PHPUnit\Framework\Constraint\LogicalOr':
+                        return 'not( ' . $this->constraint->toString() . ' )';
+
+                    default:
+                        return self::negate(
+                            $this->constraint->toString()
+                        );
+                }
+            }
+
+            /**
+             * Counts the number of constraint elements.
+             *
+             * @return int
+             */
+            public function count()
+            {
+                return \count($this->constraint);
+            }
+        }
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Question/StrictConfirmationQuestionTest.php 2.0.9-1/tests/Composer/Test/Question/StrictConfirmationQuestionTest.php
--- 1.10.19-1/tests/Composer/Test/Question/StrictConfirmationQuestionTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Question/StrictConfirmationQuestionTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,7 +14,6 @@ namespace Composer\Test\Question;
 
 use Composer\Question\StrictConfirmationQuestion;
 use Composer\Test\TestCase;
-use Symfony\Component\Console\Exception\InvalidArgumentException;
 use Symfony\Component\Console\Helper\QuestionHelper;
 use Symfony\Component\Console\Input\ArrayInput;
 use Symfony\Component\Console\Input\StreamableInputInterface;
@@ -38,14 +37,14 @@ class StrictConfirmationQuestionTest ext
     }
 
     /**
-     * @expectedException InvalidArgumentException
-     * @expectedExceptionMessage Please answer yes, y, no, or n.
      * @dataProvider             getAskConfirmationBadData
      */
     public function testAskConfirmationBadAnswer($answer)
     {
         list($input, $dialog) = $this->createInput($answer."\n");
 
+        $this->setExpectedException('InvalidArgumentException', 'Please answer yes, y, no, or n.');
+
         $question = new StrictConfirmationQuestion('Do you like French fries?');
         $question->setMaxAttempts(1);
         $dialog->ask($input, $this->createOutputInterface(), $question);
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/ArtifactRepositoryTest.php 2.0.9-1/tests/Composer/Test/Repository/ArtifactRepositoryTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/ArtifactRepositoryTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/ArtifactRepositoryTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -15,7 +15,6 @@ namespace Composer\Test\Repository;
 use Composer\Repository\ArtifactRepository;
 use Composer\Test\TestCase;
 use Composer\IO\NullIO;
-use Composer\Config;
 use Composer\Package\BasePackage;
 
 class ArtifactRepositoryTest extends TestCase
@@ -36,6 +35,7 @@ class ArtifactRepositoryTest extends Tes
             'vendor1/package2-4.3.2',
             'vendor3/package1-5.4.3',
             'test/jsonInRoot-1.0.0',
+            'test/jsonInRootTarFile-1.0.0',
             'test/jsonInFirstLevel-1.0.0',
             //The files not-an-artifact.zip and jsonSecondLevel are not valid
             //artifacts and do not get detected.
@@ -52,6 +52,13 @@ class ArtifactRepositoryTest extends Tes
         sort($foundPackages);
 
         $this->assertSame($expectedPackages, $foundPackages);
+
+        $tarPackage = array_filter($repo->getPackages(), function (BasePackage $package) {
+            return $package->getPrettyName() === 'test/jsonInRootTarFile';
+        });
+        $this->assertCount(1, $tarPackage);
+        $tarPackage = array_pop($tarPackage);
+        $this->assertSame('tar', $tarPackage->getDistType());
     }
 
     public function testAbsoluteRepoUrlCreatesAbsoluteUrlPackages()
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/ComposerRepositoryTest.php 2.0.9-1/tests/Composer/Test/Repository/ComposerRepositoryTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/ComposerRepositoryTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/ComposerRepositoryTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -18,7 +18,7 @@ use Composer\Repository\RepositoryInterf
 use Composer\Test\Mock\FactoryMock;
 use Composer\Test\TestCase;
 use Composer\Package\Loader\ArrayLoader;
-use Composer\Semver\VersionParser;
+use Composer\Package\Version\VersionParser;
 
 class ComposerRepositoryTest extends TestCase
 {
@@ -32,11 +32,13 @@ class ComposerRepositoryTest extends Tes
         );
 
         $repository = $this->getMockBuilder('Composer\Repository\ComposerRepository')
-            ->setMethods(array('loadRootServerFile', 'createPackage'))
+            ->setMethods(array('loadRootServerFile', 'createPackages'))
             ->setConstructorArgs(array(
                 $repoConfig,
                 new NullIO,
                 FactoryMock::createConfig(),
+                $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock(),
+                $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')->disableOriginalConstructor()->getMock(),
             ))
             ->getMock();
 
@@ -45,16 +47,17 @@ class ComposerRepositoryTest extends Tes
             ->method('loadRootServerFile')
             ->will($this->returnValue($repoPackages));
 
+        $stubs = array();
         foreach ($expected as $at => $arg) {
-            $stubPackage = $this->getPackage('stub/stub', '1.0.0');
-
-            $repository
-                ->expects($this->at($at + 2))
-                ->method('createPackage')
-                ->with($this->identicalTo($arg), $this->equalTo('Composer\Package\CompletePackage'))
-                ->will($this->returnValue($stubPackage));
+            $stubs[] = $this->getPackage('stub/stub', '1.0.0');
         }
 
+        $repository
+            ->expects($this->at(2))
+            ->method('createPackages')
+            ->with($this->identicalTo($expected), $this->equalTo('Composer\Package\CompletePackage'))
+            ->will($this->returnValue($stubs));
+
         // Triggers initialization
         $packages = $repository->getPackages();
 
@@ -96,7 +99,13 @@ class ComposerRepositoryTest extends Tes
     public function testWhatProvides()
     {
         $repo = $this->getMockBuilder('Composer\Repository\ComposerRepository')
-            ->disableOriginalConstructor()
+            ->setConstructorArgs(array(
+                array('url' => 'https://dummy.test.link'),
+                new NullIO,
+                FactoryMock::createConfig(),
+                $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock(),
+                $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')->disableOriginalConstructor()->getMock(),
+            ))
             ->setMethods(array('fetchFile'))
             ->getMock();
 
@@ -142,28 +151,21 @@ class ComposerRepositoryTest extends Tes
                 ),
             )));
 
-        $pool = $this->getMockBuilder('Composer\DependencyResolver\Pool')->getMock();
-        $pool->expects($this->any())
-            ->method('isPackageAcceptable')
-            ->will($this->returnValue(true));
-
         $versionParser = new VersionParser();
-        $repo->setRootAliases(array(
-            'a' => array(
-                $versionParser->normalize('0.6') => array('alias' => 'dev-feature', 'alias_normalized' => $versionParser->normalize('dev-feature')),
-                $versionParser->normalize('1.1.x-dev') => array('alias' => '1.0', 'alias_normalized' => $versionParser->normalize('1.0')),
-            ),
-        ));
-
-        $packages = $repo->whatProvides($pool, 'a');
+        $reflMethod = new \ReflectionMethod($repo, 'whatProvides');
+        $reflMethod->setAccessible(true);
+        $packages = $reflMethod->invoke($repo, 'a');
 
-        $this->assertCount(7, $packages);
-        $this->assertEquals(array('1', '1-alias', '2', '2-alias', '2-root', '3', '3-root'), array_keys($packages));
-        $this->assertInstanceOf('Composer\Package\AliasPackage', $packages['2-root']);
-        $this->assertSame($packages['2'], $packages['2-root']->getAliasOf());
+        $this->assertCount(5, $packages);
+        $this->assertEquals(array('1', '1-alias', '2', '2-alias', '3'), array_keys($packages));
         $this->assertSame($packages['2'], $packages['2-alias']->getAliasOf());
     }
 
+    public function isPackageAcceptableReturnTrue()
+    {
+        return true;
+    }
+
     public function testSearchWithType()
     {
         $repoConfig = array(
@@ -179,21 +181,32 @@ class ComposerRepositoryTest extends Tes
             ),
         );
 
-        $rfs = $this->getMockBuilder('Composer\Util\RemoteFilesystem')
+        $httpDownloader = $this->getMockBuilder('Composer\Util\HttpDownloader')
+            ->disableOriginalConstructor()
+            ->getMock();
+        $eventDispatcher = $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')
             ->disableOriginalConstructor()
             ->getMock();
 
-        $rfs->expects($this->at(0))
-            ->method('getContents')
-            ->with('example.org', 'http://example.org/packages.json', false)
-            ->willReturn(json_encode(array('search' => '/search.json?q=%query%&type=%type%')));
-
-        $rfs->expects($this->at(1))
-            ->method('getContents')
-            ->with('example.org', 'http://example.org/search.json?q=foo&type=composer-plugin', false)
-            ->willReturn(json_encode($result));
+        $httpDownloader->expects($this->at(0))
+            ->method('enableAsync');
 
-        $repository = new ComposerRepository($repoConfig, new NullIO, FactoryMock::createConfig(), null, $rfs);
+        $httpDownloader->expects($this->at(1))
+            ->method('get')
+            ->with($url = 'http://example.org/packages.json')
+            ->willReturn(new \Composer\Util\Http\Response(array('url' => $url), 200, array(), json_encode(array('search' => '/search.json?q=%query%&type=%type%'))));
+
+        $httpDownloader->expects($this->at(2))
+            ->method('get')
+            ->with($url = 'http://example.org/search.json?q=foo&type=composer-plugin')
+            ->willReturn(new \Composer\Util\Http\Response(array('url' => $url), 200, array(), json_encode($result)));
+
+        $httpDownloader->expects($this->at(3))
+            ->method('get')
+            ->with($url = 'http://example.org/search.json?q=foo&type=library')
+            ->willReturn(new \Composer\Util\Http\Response(array('url' => $url), 200, array(), json_encode(array())));
+
+        $repository = new ComposerRepository($repoConfig, new NullIO, FactoryMock::createConfig(), $httpDownloader, $eventDispatcher);
 
         $this->assertSame(
             array(array('name' => 'foo', 'description' => null)),
@@ -217,7 +230,9 @@ class ComposerRepositoryTest extends Tes
         $repository = new ComposerRepository(
             array('url' => $repositoryUrl),
             new NullIO(),
-            FactoryMock::createConfig()
+            FactoryMock::createConfig(),
+            $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock(),
+            $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')->disableOriginalConstructor()->getMock()
         );
 
         $object = new \ReflectionObject($repository);
@@ -274,30 +289,31 @@ class ComposerRepositoryTest extends Tes
 
     public function testGetProviderNamesWillReturnPartialPackageNames()
     {
-        $rfs = $this->getMockBuilder('Composer\Util\RemoteFilesystem')
+        $httpDownloader = $this->getMockBuilder('Composer\Util\HttpDownloader')
             ->disableOriginalConstructor()
             ->getMock();
 
-        $rfs->expects($this->at(0))
-            ->method('getContents')
-            ->with('example.org', 'http://example.org/packages.json', false)
-            ->willReturn(json_encode(array(
+        $httpDownloader->expects($this->at(0))
+            ->method('enableAsync');
+
+        $httpDownloader->expects($this->at(1))
+            ->method('get')
+            ->with($url = 'http://example.org/packages.json')
+            ->willReturn(new \Composer\Util\Http\Response(array('url' => $url), 200, array(), json_encode(array(
                 'providers-lazy-url' => '/foo/p/%package%.json',
                 'packages' => array('foo/bar' => array(
-                    'dev-branch' => array(),
-                    'v1.0.0' => array(),
-                ))
-            )));
+                    'dev-branch' => array('name' => 'foo/bar'),
+                    'v1.0.0' => array('name' => 'foo/bar'),
+                )),
+            ))));
 
         $repository = new ComposerRepository(
             array('url' => 'http://example.org/packages.json'),
             new NullIO(),
             FactoryMock::createConfig(),
-            null,
-            $rfs
+            $httpDownloader
         );
 
-        $this->assertTrue($repository->hasProviders());
-        $this->assertEquals(array('foo/bar'), $repository->getProviderNames());
+        $this->assertEquals(array('foo/bar'), $repository->getPackageNames());
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/FilesystemRepositoryTest.php 2.0.9-1/tests/Composer/Test/Repository/FilesystemRepositoryTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/FilesystemRepositoryTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/FilesystemRepositoryTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,6 +14,7 @@ namespace Composer\Test\Repository;
 
 use Composer\Repository\FilesystemRepository;
 use Composer\Test\TestCase;
+use Composer\Json\JsonFile;
 
 class FilesystemRepositoryTest extends TestCase
 {
@@ -42,11 +43,9 @@ class FilesystemRepositoryTest extends T
         $this->assertSame('vendor', $packages[0]->getType());
     }
 
-    /**
-     * @expectedException \Composer\Repository\InvalidRepositoryException
-     */
     public function testCorruptedRepositoryFile()
     {
+        $this->setExpectedException('Composer\Repository\InvalidRepositoryException');
         $json = $this->createJsonFileMock();
 
         $repository = new FilesystemRepository($json);
@@ -82,6 +81,12 @@ class FilesystemRepositoryTest extends T
         $json = $this->createJsonFileMock();
 
         $repository = new FilesystemRepository($json);
+        $im = $this->getMockBuilder('Composer\Installer\InstallationManager')
+            ->disableOriginalConstructor()
+            ->getMock();
+        $im->expects($this->exactly(2))
+            ->method('getInstallPath')
+            ->will($this->returnValue('/foo/bar/vendor/woop/woop'));
 
         $json
             ->expects($this->once())
@@ -89,17 +94,72 @@ class FilesystemRepositoryTest extends T
             ->will($this->returnValue(array()));
         $json
             ->expects($this->once())
+            ->method('getPath')
+            ->will($this->returnValue('/foo/bar/vendor/composer/installed.json'));
+        $json
+            ->expects($this->once())
             ->method('exists')
             ->will($this->returnValue(true));
         $json
             ->expects($this->once())
             ->method('write')
             ->with(array(
-                array('name' => 'mypkg', 'type' => 'library', 'version' => '0.1.10', 'version_normalized' => '0.1.10.0'),
+                'packages' => array(
+                    array('name' => 'mypkg', 'type' => 'library', 'version' => '0.1.10', 'version_normalized' => '0.1.10.0', 'install-path' => '../woop/woop'),
+                    array('name' => 'mypkg2', 'type' => 'library', 'version' => '1.2.3', 'version_normalized' => '1.2.3.0', 'install-path' => '../woop/woop'),
+                ),
+                'dev' => true,
+                'dev-package-names' => array('mypkg2'),
             ));
 
+        $repository->setDevPackageNames(array('mypkg2'));
+        $repository->addPackage($this->getPackage('mypkg2', '1.2.3'));
         $repository->addPackage($this->getPackage('mypkg', '0.1.10'));
-        $repository->write();
+        $repository->write(true, $im);
+    }
+
+    public function testRepositoryWritesInstalledPhp()
+    {
+        $dir = $this->getUniqueTmpDirectory();
+        $json = new JsonFile($dir.'/installed.json');
+
+        $rootPackage = $this->getPackage('__root__', 'dev-master', 'Composer\Package\RootPackage');
+        $rootPackage->setSourceReference('sourceref-by-default');
+        $rootPackage->setDistReference('distref');
+        $this->configureLinks($rootPackage, array('provide' => array('foo/impl' => '2.0')));
+        $rootPackage = $this->getAliasPackage($rootPackage, '1.10.x-dev');
+
+        $repository = new FilesystemRepository($json, true, $rootPackage);
+        $pkg = $this->getPackage('a/provider', '1.1');
+        $this->configureLinks($pkg, array('provide' => array('foo/impl' => '^1.1', 'foo/impl2' => '2.0')));
+        $pkg->setDistReference('distref-as-no-source');
+        $repository->addPackage($pkg);
+
+        $pkg = $this->getPackage('a/provider2', '1.2');
+        $this->configureLinks($pkg, array('provide' => array('foo/impl' => 'self.version', 'foo/impl2' => '2.0')));
+        $pkg->setSourceReference('sourceref');
+        $pkg->setDistReference('distref-as-installed-from-dist');
+        $pkg->setInstallationSource('dist');
+        $repository->addPackage($pkg);
+
+        $repository->addPackage($this->getAliasPackage($pkg, '1.4'));
+
+        $pkg = $this->getPackage('b/replacer', '2.2');
+        $this->configureLinks($pkg, array('replace' => array('foo/impl2' => 'self.version', 'foo/replaced' => '^3.0')));
+        $repository->addPackage($pkg);
+
+        $pkg = $this->getPackage('c/c', '3.0');
+        $repository->addPackage($pkg);
+
+        $im = $this->getMockBuilder('Composer\Installer\InstallationManager')
+            ->disableOriginalConstructor()
+            ->getMock();
+        $im->expects($this->any())
+            ->method('getInstallPath')
+            ->will($this->returnValue('/foo/bar/vendor/woop/woop'));
+
+        $repository->write(true, $im);
+        $this->assertSame(require __DIR__.'/Fixtures/installed.php', require $dir.'/installed.php');
     }
 
     private function createJsonFileMock()
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/FilterRepositoryTest.php 2.0.9-1/tests/Composer/Test/Repository/FilterRepositoryTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/FilterRepositoryTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/FilterRepositoryTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,71 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Repository;
+
+use Composer\Test\TestCase;
+use Composer\Repository\FilterRepository;
+use Composer\Repository\ArrayRepository;
+use Composer\Semver\Constraint\MatchAllConstraint;
+use Composer\Package\BasePackage;
+
+class FilterRepositoryTest extends TestCase
+{
+    private $arrayRepo;
+
+    public function setUp()
+    {
+        $this->arrayRepo = new ArrayRepository();
+        $this->arrayRepo->addPackage($this->getPackage('foo/aaa', '1.0.0'));
+        $this->arrayRepo->addPackage($this->getPackage('foo/bbb', '1.0.0'));
+        $this->arrayRepo->addPackage($this->getPackage('bar/xxx', '1.0.0'));
+        $this->arrayRepo->addPackage($this->getPackage('baz/yyy', '1.0.0'));
+    }
+
+    /**
+     * @dataProvider repoMatchingTests
+     */
+    public function testRepoMatching($expected, $config)
+    {
+        $repo = new FilterRepository($this->arrayRepo, $config);
+        $packages = $repo->getPackages();
+
+        $this->assertSame($expected, array_map(function ($p) {
+            return $p->getName();
+        }, $packages));
+    }
+
+    public static function repoMatchingTests()
+    {
+        return array(
+            array(array('foo/aaa', 'foo/bbb'), array('only' => array('foo/*'))),
+            array(array('foo/aaa', 'baz/yyy'), array('only' => array('foo/aaa', 'baz/yyy'))),
+            array(array('bar/xxx'), array('exclude' => array('foo/*', 'baz/yyy'))),
+        );
+    }
+
+    public function testCanonicalDefaultTrue()
+    {
+        $repo = new FilterRepository($this->arrayRepo, array());
+        $result = $repo->loadPackages(array('foo/aaa' => new MatchAllConstraint), BasePackage::$stabilities, array());
+        $this->assertCount(1, $result['packages']);
+        $this->assertCount(1, $result['namesFound']);
+    }
+
+    public function testNonCanonical()
+    {
+        $repo = new FilterRepository($this->arrayRepo, array('canonical' => false));
+        $result = $repo->loadPackages(array('foo/aaa' => new MatchAllConstraint), BasePackage::$stabilities, array());
+        $this->assertCount(1, $result['packages']);
+        $this->assertCount(0, $result['namesFound']);
+    }
+}
Binary files 1.10.19-1/tests/Composer/Test/Repository/Fixtures/artifacts/composer-1.0.0-alpha6.zip and 2.0.9-1/tests/Composer/Test/Repository/Fixtures/artifacts/composer-1.0.0-alpha6.zip differ
Binary files 1.10.19-1/tests/Composer/Test/Repository/Fixtures/artifacts/jsonInFirstLevelWithExtraFirstLevel.zip and 2.0.9-1/tests/Composer/Test/Repository/Fixtures/artifacts/jsonInFirstLevelWithExtraFirstLevel.zip differ
Binary files 1.10.19-1/tests/Composer/Test/Repository/Fixtures/artifacts/jsonInFirstLevel.zip and 2.0.9-1/tests/Composer/Test/Repository/Fixtures/artifacts/jsonInFirstLevel.zip differ
Binary files 1.10.19-1/tests/Composer/Test/Repository/Fixtures/artifacts/jsonInRooTarFile.tar.gz and 2.0.9-1/tests/Composer/Test/Repository/Fixtures/artifacts/jsonInRooTarFile.tar.gz differ
Binary files 1.10.19-1/tests/Composer/Test/Repository/Fixtures/artifacts/not-an-artifact.zip and 2.0.9-1/tests/Composer/Test/Repository/Fixtures/artifacts/not-an-artifact.zip differ
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Fixtures/installed.php 2.0.9-1/tests/Composer/Test/Repository/Fixtures/installed.php
--- 1.10.19-1/tests/Composer/Test/Repository/Fixtures/installed.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Fixtures/installed.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,80 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+return array(
+    'root' => array(
+        'pretty_version' => 'dev-master',
+        'version' => 'dev-master',
+        'aliases' => array(
+            '1.10.x-dev',
+        ),
+        'reference' => 'sourceref-by-default',
+        'name' => '__root__',
+    ),
+    'versions' => array(
+        '__root__' => array(
+            'pretty_version' => 'dev-master',
+            'version' => 'dev-master',
+            'aliases' => array(
+                '1.10.x-dev',
+            ),
+            'reference' => 'sourceref-by-default',
+        ),
+        'a/provider' => array(
+            'pretty_version' => '1.1',
+            'version' => '1.1.0.0',
+            'aliases' => array(),
+            'reference' => 'distref-as-no-source',
+        ),
+        'a/provider2' => array(
+            'pretty_version' => '1.2',
+            'version' => '1.2.0.0',
+            'aliases' => array(
+              '1.4',
+            ),
+            'reference' => 'distref-as-installed-from-dist',
+        ),
+        'b/replacer' => array(
+            'pretty_version' => '2.2',
+            'version' => '2.2.0.0',
+            'aliases' => array(),
+            'reference' => null,
+        ),
+        'c/c' => array(
+            'pretty_version' => '3.0',
+            'version' => '3.0.0.0',
+            'aliases' => array(),
+            'reference' => null,
+        ),
+        'foo/impl' => array(
+            'provided' => array(
+                '^1.1',
+                '1.2',
+                '1.4',
+                '2.0',
+            ),
+        ),
+        'foo/impl2' => array(
+            'provided' => array(
+                '2.0',
+            ),
+            'replaced' => array(
+                '2.2',
+            ),
+        ),
+        'foo/replaced' => array(
+            'replaced' => array(
+                '^3.0',
+            ),
+        ),
+    ),
+);
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Fixtures/path/with-branch-version/composer.json 2.0.9-1/tests/Composer/Test/Repository/Fixtures/path/with-branch-version/composer.json
--- 1.10.19-1/tests/Composer/Test/Repository/Fixtures/path/with-branch-version/composer.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Fixtures/path/with-branch-version/composer.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,6 +0,0 @@
-{
-  "name": "test/path-branch-versioned",
-  "extra": {
-    "branch-version": "1.2"
-  }
-}
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/InstalledRepositoryTest.php 2.0.9-1/tests/Composer/Test/Repository/InstalledRepositoryTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/InstalledRepositoryTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/InstalledRepositoryTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,52 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Repository;
+
+use Composer\Repository\InstalledRepository;
+use Composer\Repository\ArrayRepository;
+use Composer\Repository\InstalledArrayRepository;
+use Composer\Package\Link;
+use Composer\Semver\Constraint\MatchAllConstraint;
+use Composer\Test\TestCase;
+
+class InstalledRepositoryTest extends TestCase
+{
+    public function testFindPackagesWithReplacersAndProviders()
+    {
+        $arrayRepoOne = new InstalledArrayRepository;
+        $arrayRepoOne->addPackage($foo = $this->getPackage('foo', '1'));
+        $arrayRepoOne->addPackage($foo2 = $this->getPackage('foo', '2'));
+
+        $arrayRepoTwo = new InstalledArrayRepository;
+        $arrayRepoTwo->addPackage($bar = $this->getPackage('bar', '1'));
+        $arrayRepoTwo->addPackage($bar2 = $this->getPackage('bar', '2'));
+
+        $foo->setReplaces(array(new Link('foo', 'provided', new MatchAllConstraint())));
+        $bar2->setProvides(array(new Link('bar', 'provided', new MatchAllConstraint())));
+
+        $repo = new InstalledRepository(array($arrayRepoOne, $arrayRepoTwo));
+
+        $this->assertEquals(array($foo2), $repo->findPackagesWithReplacersAndProviders('foo', '2'));
+        $this->assertEquals(array($bar), $repo->findPackagesWithReplacersAndProviders('bar', '1'));
+        $this->assertEquals(array($foo, $bar2), $repo->findPackagesWithReplacersAndProviders('provided'));
+    }
+
+    public function testAddRepository()
+    {
+        $arrayRepoOne = new ArrayRepository;
+
+        $this->setExpectedException('LogicException');
+
+        new InstalledRepository(array($arrayRepoOne));
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/PathRepositoryTest.php 2.0.9-1/tests/Composer/Test/Repository/PathRepositoryTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/PathRepositoryTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/PathRepositoryTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,19 +12,14 @@
 
 namespace Composer\Test\Repository;
 
-use Composer\Package\Loader\ArrayLoader;
 use Composer\Repository\PathRepository;
-use Composer\Semver\VersionParser;
 use Composer\Test\TestCase;
 
 class PathRepositoryTest extends TestCase
 {
-
-    /**
-     * @expectedException RuntimeException
-     */
     public function testLoadPackageFromFileSystemWithIncorrectPath()
     {
+        $this->setExpectedException('RuntimeException');
         $ioInterface = $this->getMockBuilder('Composer\IO\IOInterface')
             ->getMock();
 
@@ -47,7 +42,7 @@ class PathRepositoryTest extends TestCas
         $repository = new PathRepository(array('url' => $repositoryUrl), $ioInterface, $config);
         $repository->getPackages();
 
-        $this->assertEquals(1, $repository->count());
+        $this->assertSame(1, $repository->count());
         $this->assertTrue($repository->hasPackage($this->getPackage('test/path-versioned', '0.0.2')));
     }
 
@@ -63,16 +58,16 @@ class PathRepositoryTest extends TestCas
         $repository = new PathRepository(array('url' => $repositoryUrl), $ioInterface, $config);
         $packages = $repository->getPackages();
 
-        $this->assertEquals(1, $repository->count());
+        $this->assertGreaterThanOrEqual(1, $repository->count());
 
         $package = $packages[0];
-        $this->assertEquals('test/path-unversioned', $package->getName());
+        $this->assertSame('test/path-unversioned', $package->getName());
 
         $packageVersion = $package->getVersion();
         $this->assertNotEmpty($packageVersion);
     }
 
-    public function testLoadPackageFromFileSystemWithExtraBranchVersion()
+    public function testLoadPackageFromFileSystemWithWildcard()
     {
         $ioInterface = $this->getMockBuilder('Composer\IO\IOInterface')
             ->getMock();
@@ -80,16 +75,24 @@ class PathRepositoryTest extends TestCas
         $config = new \Composer\Config();
         $versionGuesser = null;
 
-        $repositoryUrl = implode(DIRECTORY_SEPARATOR, array(__DIR__, 'Fixtures', 'path', 'with-branch-version'));
+        $repositoryUrl = implode(DIRECTORY_SEPARATOR, array(__DIR__, 'Fixtures', 'path', '*'));
         $repository = new PathRepository(array('url' => $repositoryUrl), $ioInterface, $config);
         $packages = $repository->getPackages();
+        $names = array();
 
-        $this->assertEquals(1, $repository->count());
+        $this->assertEquals(2, $repository->count());
+
+        $package = $packages[0];
+        $names[] = $package->getName();
+
+        $package = $packages[1];
+        $names[] = $package->getName();
 
-        $this->assertTrue($repository->hasPackage($this->getPackage('test/path-branch-versioned', '1.2.x-dev')));
+        sort($names);
+        $this->assertEquals(array('test/path-unversioned', 'test/path-versioned'), $names);
     }
 
-    public function testLoadPackageFromFileSystemWithWildcard()
+    public function testLoadPackageWithExplicitVersions()
     {
         $ioInterface = $this->getMockBuilder('Composer\IO\IOInterface')
             ->getMock();
@@ -97,24 +100,28 @@ class PathRepositoryTest extends TestCas
         $config = new \Composer\Config();
         $versionGuesser = null;
 
+        $options = array(
+            'versions' => array(
+                'test/path-unversioned' => '4.3.2.1',
+                'test/path-versioned' => '3.2.1.0',
+            ),
+        );
         $repositoryUrl = implode(DIRECTORY_SEPARATOR, array(__DIR__, 'Fixtures', 'path', '*'));
-        $repository = new PathRepository(array('url' => $repositoryUrl), $ioInterface, $config);
+        $repository = new PathRepository(array('url' => $repositoryUrl, 'options' => $options), $ioInterface, $config);
         $packages = $repository->getPackages();
-        $names = array();
 
-        $this->assertEquals(3, $repository->count());
+        $versions = array();
+
+        $this->assertEquals(2, $repository->count());
 
         $package = $packages[0];
-        $names[] = $package->getName();
+        $versions[$package->getName()] = $package->getVersion();
 
         $package = $packages[1];
-        $names[] = $package->getName();
+        $versions[$package->getName()] = $package->getVersion();
 
-        $package = $packages[2];
-        $names[] = $package->getName();
-
-        sort($names);
-        $this->assertEquals(array('test/path-branch-versioned', 'test/path-unversioned', 'test/path-versioned'), $names);
+        ksort($versions);
+        $this->assertSame(array('test/path-unversioned' => '4.3.2.1', 'test/path-versioned' => '3.2.1.0'), $versions);
     }
 
     /**
@@ -138,13 +145,13 @@ class PathRepositoryTest extends TestCas
         $repository = new PathRepository(array('url' => $relativeUrl), $ioInterface, $config);
         $packages = $repository->getPackages();
 
-        $this->assertEquals(1, $repository->count());
+        $this->assertSame(1, $repository->count());
 
         $package = $packages[0];
-        $this->assertEquals('test/path-versioned', $package->getName());
+        $this->assertSame('test/path-versioned', $package->getName());
 
         // Convert platform specific separators back to generic URL slashes
         $relativeUrl = str_replace(DIRECTORY_SEPARATOR, '/', $relativeUrl);
-        $this->assertEquals($relativeUrl, $package->getDistUrl());
+        $this->assertSame($relativeUrl, $package->getDistUrl());
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/ChannelReaderTest.php 2.0.9-1/tests/Composer/Test/Repository/Pear/ChannelReaderTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/ChannelReaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/ChannelReaderTest.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,159 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Test\Repository\Pear;
-
-use Composer\Repository\Pear\ChannelInfo;
-use Composer\Repository\Pear\DependencyConstraint;
-use Composer\Repository\Pear\DependencyInfo;
-use Composer\Repository\Pear\PackageInfo;
-use Composer\Repository\Pear\ReleaseInfo;
-use Composer\Test\TestCase;
-use Composer\Semver\VersionParser;
-use Composer\Semver\Constraint\Constraint;
-use Composer\Package\Link;
-use Composer\Package\CompletePackage;
-use Composer\Test\Mock\RemoteFilesystemMock;
-
-class ChannelReaderTest extends TestCase
-{
-    public function testShouldBuildPackagesFromPearSchema()
-    {
-        $rfs = new RemoteFilesystemMock(array(
-            'http://pear.net/channel.xml' => file_get_contents(__DIR__ . '/Fixtures/channel.1.1.xml'),
-            'http://test.loc/rest11/c/categories.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.1/categories.xml'),
-            'http://test.loc/rest11/c/Default/packagesinfo.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.1/packagesinfo.xml'),
-        ));
-
-        $reader = new \Composer\Repository\Pear\ChannelReader($rfs);
-
-        $channelInfo = $reader->read('http://pear.net/');
-        $packages = $channelInfo->getPackages();
-
-        $this->assertCount(3, $packages);
-        $this->assertEquals('HTTP_Client', $packages[0]->getPackageName());
-        $this->assertEquals('HTTP_Request', $packages[1]->getPackageName());
-        $this->assertEquals('MDB2', $packages[2]->getPackageName());
-
-        $mdb2releases = $packages[2]->getReleases();
-        $this->assertCount(9, $mdb2releases['2.4.0']->getDependencyInfo()->getOptionals());
-    }
-
-    public function testShouldSelectCorrectReader()
-    {
-        $rfs = new RemoteFilesystemMock(array(
-            'http://pear.1.0.net/channel.xml' => file_get_contents(__DIR__ . '/Fixtures/channel.1.0.xml'),
-            'http://test.loc/rest10/p/packages.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.0/packages.xml'),
-            'http://test.loc/rest10/p/http_client/info.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.0/http_client_info.xml'),
-            'http://test.loc/rest10/p/http_request/info.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.0/http_request_info.xml'),
-            'http://pear.1.1.net/channel.xml' => file_get_contents(__DIR__ . '/Fixtures/channel.1.1.xml'),
-            'http://test.loc/rest11/c/categories.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.1/categories.xml'),
-            'http://test.loc/rest11/c/Default/packagesinfo.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.1/packagesinfo.xml'),
-        ));
-
-        $reader = new \Composer\Repository\Pear\ChannelReader($rfs);
-
-        $pear10 = $reader->read('http://pear.1.0.net/');
-        $this->assertCount(2, $pear10->getPackages());
-        $pear11 = $reader->read('http://pear.1.1.net/');
-        $this->assertCount(3, $pear11->getPackages());
-    }
-
-    public function testShouldCreatePackages()
-    {
-        $reader = $this->getMockBuilder('\Composer\Repository\PearRepository')
-            ->disableOriginalConstructor()
-            ->getMock();
-
-        $ref = new \ReflectionMethod($reader, 'buildComposerPackages');
-        $ref->setAccessible(true);
-
-        $channelInfo = new ChannelInfo(
-            'test.loc',
-            'test',
-            array(
-                new PackageInfo(
-                    'test.loc',
-                    'sample',
-                    'license',
-                    'shortDescription',
-                    'description',
-                    array(
-                        '1.0.0.1' => new ReleaseInfo(
-                            'stable',
-                            new DependencyInfo(
-                                array(
-                                    new DependencyConstraint(
-                                        'required',
-                                        '> 5.2.0.0',
-                                        'php',
-                                        ''
-                                    ),
-                                    new DependencyConstraint(
-                                        'conflicts',
-                                        '== 2.5.6.0',
-                                        'pear.php.net',
-                                        'broken'
-                                    ),
-                                ),
-                                array(
-                                    '*' => array(
-                                        new DependencyConstraint(
-                                            'optional',
-                                            '*',
-                                            'ext',
-                                            'xml'
-                                        ),
-                                    ),
-                                )
-                            )
-                        ),
-                    )
-                ),
-            )
-        );
-
-        $packages = $ref->invoke($reader, $channelInfo, new VersionParser());
-
-        $expectedPackage = new CompletePackage('pear-test.loc/sample', '1.0.0.1', '1.0.0.1');
-        $expectedPackage->setType('pear-library');
-        $expectedPackage->setDistType('file');
-        $expectedPackage->setDescription('description');
-        $expectedPackage->setLicense(array('license'));
-        $expectedPackage->setDistUrl("http://test.loc/get/sample-1.0.0.1.tgz");
-        $expectedPackage->setAutoload(array('classmap' => array('')));
-        $expectedPackage->setIncludePaths(array('/'));
-        $expectedPackage->setRequires(array(
-            new Link('pear-test.loc/sample', 'php', $this->createConstraint('>', '5.2.0.0'), 'required', '> 5.2.0.0'),
-        ));
-        $expectedPackage->setConflicts(array(
-            new Link('pear-test.loc/sample', 'pear-pear.php.net/broken', $this->createConstraint('==', '2.5.6.0'), 'conflicts', '== 2.5.6.0'),
-        ));
-        $expectedPackage->setSuggests(array(
-            '*-ext-xml' => '*',
-        ));
-        $expectedPackage->setReplaces(array(
-            new Link('pear-test.loc/sample', 'pear-test/sample', new Constraint('==', '1.0.0.1'), 'replaces', '== 1.0.0.1'),
-        ));
-
-        $this->assertCount(1, $packages);
-        $this->assertEquals($expectedPackage, $packages[0], 0, 1);
-    }
-
-    private function createConstraint($operator, $version)
-    {
-        $constraint = new Constraint($operator, $version);
-        $constraint->setPrettyString($operator.' '.$version);
-
-        return $constraint;
-    }
-}
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/ChannelRest10ReaderTest.php 2.0.9-1/tests/Composer/Test/Repository/Pear/ChannelRest10ReaderTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/ChannelRest10ReaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/ChannelRest10ReaderTest.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,41 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Test\Repository\Pear;
-
-use Composer\Test\TestCase;
-use Composer\Test\Mock\RemoteFilesystemMock;
-
-class ChannelRest10ReaderTest extends TestCase
-{
-    public function testShouldBuildPackagesFromPearSchema()
-    {
-        $rfs = new RemoteFilesystemMock(array(
-            'http://test.loc/rest10/p/packages.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.0/packages.xml'),
-            'http://test.loc/rest10/p/http_client/info.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.0/http_client_info.xml'),
-            'http://test.loc/rest10/r/http_client/allreleases.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.0/http_client_allreleases.xml'),
-            'http://test.loc/rest10/r/http_client/deps.1.2.1.txt' => file_get_contents(__DIR__ . '/Fixtures/Rest1.0/http_client_deps.1.2.1.txt'),
-            'http://test.loc/rest10/p/http_request/info.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.0/http_request_info.xml'),
-            'http://test.loc/rest10/r/http_request/allreleases.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.0/http_request_allreleases.xml'),
-            'http://test.loc/rest10/r/http_request/deps.1.4.0.txt' => file_get_contents(__DIR__ . '/Fixtures/Rest1.0/http_request_deps.1.4.0.txt'),
-        ));
-
-        $reader = new \Composer\Repository\Pear\ChannelRest10Reader($rfs);
-
-        /** @var \Composer\Package\PackageInterface[] $packages */
-        $packages = $reader->read('http://test.loc/rest10');
-
-        $this->assertCount(2, $packages);
-        $this->assertEquals('HTTP_Client', $packages[0]->getPackageName());
-        $this->assertEquals('HTTP_Request', $packages[1]->getPackageName());
-    }
-}
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/ChannelRest11ReaderTest.php 2.0.9-1/tests/Composer/Test/Repository/Pear/ChannelRest11ReaderTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/ChannelRest11ReaderTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/ChannelRest11ReaderTest.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,37 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Test\Repository\Pear;
-
-use Composer\Test\TestCase;
-use Composer\Test\Mock\RemoteFilesystemMock;
-
-class ChannelRest11ReaderTest extends TestCase
-{
-    public function testShouldBuildPackagesFromPearSchema()
-    {
-        $rfs = new RemoteFilesystemMock(array(
-            'http://pear.1.1.net/channel.xml' => file_get_contents(__DIR__ . '/Fixtures/channel.1.1.xml'),
-            'http://test.loc/rest11/c/categories.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.1/categories.xml'),
-            'http://test.loc/rest11/c/Default/packagesinfo.xml' => file_get_contents(__DIR__ . '/Fixtures/Rest1.1/packagesinfo.xml'),
-        ));
-
-        $reader = new \Composer\Repository\Pear\ChannelRest11Reader($rfs);
-
-        /** @var \Composer\Package\PackageInterface[] $packages */
-        $packages = $reader->read('http://test.loc/rest11');
-
-        $this->assertCount(3, $packages);
-        $this->assertEquals('HTTP_Client', $packages[0]->getPackageName());
-        $this->assertEquals('HTTP_Request', $packages[1]->getPackageName());
-    }
-}
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/channel.1.0.xml 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/channel.1.0.xml
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/channel.1.0.xml	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/channel.1.0.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-<channel xmlns="http://pear.php.net/channel-1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.0" xsi:schemaLocation="http://pear.php.net/channel-1.0 http://pear.php.net/dtd/channel-1.0.xsd">
-    <name>pear.net</name>
-    <summary>Test PEAR channel</summary>
-    <suggestedalias>test_alias</suggestedalias>
-    <servers>
-        <primary>
-            <rest>
-                <baseurl type="REST1.0">http://test.loc/rest10/</baseurl>
-            </rest>
-        </primary>
-    </servers>
-</channel>
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/channel.1.1.xml 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/channel.1.1.xml
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/channel.1.1.xml	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/channel.1.1.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-<channel xmlns="http://pear.php.net/channel-1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.0" xsi:schemaLocation="http://pear.php.net/channel-1.0 http://pear.php.net/dtd/channel-1.0.xsd">
-    <name>pear.net</name>
-    <summary>Test PEAR channel</summary>
-    <suggestedalias>test_alias</suggestedalias>
-    <servers>
-        <primary>
-            <rest>
-                <baseurl type="REST1.1">http://test.loc/rest11/</baseurl>
-            </rest>
-        </primary>
-    </servers>
-</channel>
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/DependencyParserTestData.json 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/DependencyParserTestData.json
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/DependencyParserTestData.json	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/DependencyParserTestData.json	1970-01-01 00:00:00.000000000 +0000
@@ -1,167 +0,0 @@
-[
-    {
-        "expected": [
-            {
-                "type" : "required",
-                "constraint" : "*",
-                "channel" : "pear.php.net",
-                "name" : "Foo"
-            }
-        ],
-        "1.0": [
-            { "type": "pkg", "rel": "has", "name": "Foo" }
-        ],
-        "2.0": {
-            "required": {
-                "package": {
-                    "name": "Foo",
-                    "channel": "pear.php.net"
-                }
-            }
-        }
-    },
-    {
-        "expected": [
-            {
-                "type" : "required",
-                "constraint" : ">1.0.0.0",
-                "channel" : "pear.php.net",
-                "name" : "Foo"
-            }
-        ],
-        "1.0": [
-            { "type": "pkg", "rel": "gt", "version": "1.0.0", "name": "Foo" }
-        ],
-        "2.0": {
-            "required": {
-                "package": {
-                    "name": "Foo",
-                    "channel": "pear.php.net",
-                    "min": "1.0.0",
-                    "exclude": "1.0.0"
-                }
-            }
-        }
-    },
-    {
-        "expected": [
-            {
-                "type" : "conflicts",
-                "constraint" : "*",
-                "channel" : "pear.php.net",
-                "name" : "Foo"
-            }
-        ],
-        "1.0": [
-            { "type": "pkg", "rel": "not", "name": "Foo" }
-        ],
-        "2.0": {
-            "required": {
-                "package": {
-                    "name": "Foo",
-                    "channel": "pear.php.net",
-                    "conflicts": true
-                }
-            }
-        }
-    },
-    {
-        "expected": [
-            {
-                "type" : "required",
-                "constraint" : ">=1.0.0.0",
-                "channel" : "pear.php.net",
-                "name" : "Foo"
-            },
-            {
-                "type" : "required",
-                "constraint" : "<2.0.0.0",
-                "channel" : "pear.php.net",
-                "name" : "Foo"
-            }
-        ],
-        "1.0": [
-            { "type": "pkg", "rel": "ge", "version": "1.0.0", "name": "Foo" },
-            { "type": "pkg", "rel": "lt", "version": "2.0.0", "name": "Foo" }
-        ],
-        "2.0": {
-            "required": {
-                "package": [
-                    {
-                        "name": "Foo",
-                        "channel": "pear.php.net",
-                        "min": "1.0.0"
-                    },
-                    {
-                        "name": "Foo",
-                        "channel": "pear.php.net",
-                        "max": "2.0.0",
-                        "exclude": "2.0.0"
-                    }
-                ]
-            }
-        }
-    },
-    {
-        "expected": [
-            {
-                "type" : "required",
-                "constraint" : ">=5.3.0.0",
-                "channel" : "php",
-                "name" : ""
-            }
-        ],
-        "1.0": [
-            { "type": "php", "rel": "ge", "version": "5.3"}
-        ],
-        "2.0": {
-            "required": {
-                "php": {
-                        "min": "5.3"
-                }
-            }
-        }
-    },
-    {
-        "expected": [
-            {
-                "type" : "required",
-                "constraint" : "*",
-                "channel" : "ext",
-                "name" : "xmllib"
-            }
-        ],
-        "1.0": [
-            { "type": "ext", "rel": "has", "name": "xmllib"}
-        ],
-        "2.0": {
-            "required": {
-                "extension": [
-                    {
-                        "name": "xmllib"
-                    }
-                ]
-            }
-        }
-    },
-    {
-        "expected": [
-            {
-                "type" : "optional",
-                "constraint" : "*",
-                "channel" : "ext",
-                "name" : "xmllib"
-            }
-        ],
-        "1.0": false,
-        "2.0": {
-            "optional": {
-                "extension": [
-                    {
-                        "name": "xmllib"
-                    }
-                ]
-            }
-        }
-    }
-]
\ No newline at end of file
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_client_allreleases.xml 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_client_allreleases.xml
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_client_allreleases.xml	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_client_allreleases.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,9 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<a xmlns="http://pear.php.net/dtd/rest.allreleases" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xlink="http://www.w3.org/1999/xlink" xsi:schemaLocation="http://pear.php.net/dtd/rest.allreleases http://pear.php.net/dtd/rest.allreleases.xsd">
-    <p>HTTP_Client</p>
-    <c>pear.net</c>
-    <r>
-        <v>1.2.1</v>
-        <s>stable</s>
-    </r>
-</a>
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_client_deps.1.2.1.txt 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_client_deps.1.2.1.txt
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_client_deps.1.2.1.txt	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_client_deps.1.2.1.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-a:1:{s:8:"required";a:3:{s:3:"php";a:1:{s:3:"min";s:5:"4.3.0";}s:13:"pearinstaller";a:1:{s:3:"min";s:5:"1.4.3";}s:7:"package";a:3:{s:4:"name";s:12:"HTTP_Request";s:7:"channel";s:8:"pear.net";s:3:"min";s:5:"1.4.0";}}}
\ No newline at end of file
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_client_info.xml 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_client_info.xml
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_client_info.xml	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_client_info.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,14 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<p xmlns="http://pear.php.net/dtd/rest.package" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xlink="http://www.w3.org/1999/xlink" xsi:schemaLocation="http://pear.php.net/dtd/rest.package http://pear.php.net/dtd/rest.package.xsd">
-    <n>HTTP_Client</n>
-    <c>pear.net</c>
-    <ca xlink:href="/rest/c/Default">Default</ca>
-    <l>BSD</l>
-    <s>
-        Easy way to perform multiple HTTP requests and process their results
-    </s>
-    <d>
-        The HTTP_Client class wraps around HTTP_Request and provides a higher level interface for performing multiple HTTP requests. Features: * Manages cookies and referrers between requests * Handles HTTP redirection * Has methods to set default headers and request parameters * Implements the Subject-Observer design pattern: the base class sends events to listeners that do the response processing.
-    </d>
-    <r xlink:href="/rest/r/http_client"/>
-</p>
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_request_allreleases.xml 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_request_allreleases.xml
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_request_allreleases.xml	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_request_allreleases.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,9 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<a xmlns="http://pear.php.net/dtd/rest.allreleases" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xlink="http://www.w3.org/1999/xlink" xsi:schemaLocation="http://pear.php.net/dtd/rest.allreleases http://pear.php.net/dtd/rest.allreleases.xsd">
-    <p>HTTP_Request</p>
-    <c>pear.net</c>
-    <r>
-        <v>1.4.0</v>
-        <s>stable</s>
-    </r>
-</a>
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_request_deps.1.4.0.txt 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_request_deps.1.4.0.txt
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_request_deps.1.4.0.txt	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_request_deps.1.4.0.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-a:1:{s:8:"required";a:3:{s:3:"php";a:1:{s:3:"min";s:5:"4.0.0";}s:13:"pearinstaller";a:1:{s:3:"min";s:7:"1.4.0b1";}s:7:"package";a:2:{i:0;a:3:{s:4:"name";s:7:"Net_URL";s:7:"channel";s:12:"pear.dev.loc";s:3:"min";s:6:"1.0.12";}i:1;a:3:{s:4:"name";s:10:"Net_Socket";s:7:"channel";s:8:"pear.net";s:3:"min";s:5:"1.0.2";}}}}
\ No newline at end of file
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_request_info.xml 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_request_info.xml
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_request_info.xml	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/http_request_info.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<p xmlns="http://pear.php.net/dtd/rest.package" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xlink="http://www.w3.org/1999/xlink" xsi:schemaLocation="http://pear.php.net/dtd/rest.package http://pear.php.net/dtd/rest.package.xsd">
-    <n>HTTP_Request</n>
-    <c>pear.net</c>
-    <ca xlink:href="/rest/c/Default">Default</ca>
-    <l>BSD</l>
-    <s>Provides an easy way to perform HTTP requests</s>
-    <d>
-        Supports GET/POST/HEAD/TRACE/PUT/DELETE, Basic authentication, Proxy, Proxy Authentication, SSL, file uploads etc.
-    </d>
-    <r xlink:href="/rest/r/http_request"/>
-</p>
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/packages.xml 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/packages.xml
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/packages.xml	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.0/packages.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,6 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<a xmlns="http://pear.php.net/dtd/rest.allpackages" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xlink="http://www.w3.org/1999/xlink" xsi:schemaLocation="http://pear.php.net/dtd/rest.allpackages http://pear.php.net/dtd/rest.allpackages.xsd">
-    <c>pear.net</c>
-    <p>HTTP_Client</p>
-    <p>HTTP_Request</p>
-</a>
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.1/categories.xml 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.1/categories.xml
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.1/categories.xml	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.1/categories.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<a xmlns="http://pear.php.net/dtd/rest.allcategories" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xlink="http://www.w3.org/1999/xlink" xsi:schemaLocation="http://pear.php.net/dtd/rest.allcategories http://pear.php.net/dtd/rest.allcategories.xsd">
-    <ch>pear.net</ch>
-    <c xlink:href="/rest/c/Default/info.xml">Default</c>
-</a>
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.1/packagesinfo.xml 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.1/packagesinfo.xml
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.1/packagesinfo.xml	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/Fixtures/Rest1.1/packagesinfo.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,97 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<f xmlns="http://pear.php.net/dtd/rest.categorypackageinfo" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xlink="http://www.w3.org/1999/xlink" xsi:schemaLocation="http://pear.php.net/dtd/rest.categorypackageinfo http://pear.php.net/dtd/rest.categorypackageinfo.xsd">
-    <pi>
-        <p>
-            <n>HTTP_Client</n>
-            <c>pear.net</c>
-            <ca xlink:href="/rest/c/Default">Default</ca>
-            <l>BSD</l>
-            <s>
-                Easy way to perform multiple HTTP requests and process their results
-            </s>
-            <d>
-                The HTTP_Client class wraps around HTTP_Request and provides a higher level interface for performing multiple HTTP requests. Features: * Manages cookies and referrers between requests * Handles HTTP redirection * Has methods to set default headers and request parameters * Implements the Subject-Observer design pattern: the base class sends events to listeners that do the response processing.
-            </d>
-            <r xlink:href="/rest/r/http_client"/>
-        </p>
-        <a>
-            <r>
-                <v>1.2.1</v>
-                <s>stable</s>
-            </r>
-        </a>
-        <deps>
-            <v>1.2.1</v>
-            <d>a:1:{s:8:"required";a:3:{s:3:"php";a:1:{s:3:"min";s:5:"4.3.0";}s:13:"pearinstaller";a:1:{s:3:"min";s:5:"1.4.3";}s:7:"package";a:3:{s:4:"name";s:12:"HTTP_Request";s:7:"channel";s:8:"pear.net";s:3:"min";s:5:"1.4.0";}}}</d>
-        </deps>
-    </pi>
-    <pi>
-        <p>
-            <n>HTTP_Request</n>
-            <c>pear.net</c>
-            <ca xlink:href="/rest/c/Default">Default</ca>
-            <l>BSD</l>
-            <s>Provides an easy way to perform HTTP requests</s>
-            <d>
-                Supports GET/POST/HEAD/TRACE/PUT/DELETE, Basic authentication, Proxy, Proxy Authentication, SSL, file uploads etc.
-            </d>
-            <r xlink:href="/rest/r/http_request"/>
-        </p>
-        <a>
-            <r>
-                <v>1.4.0</v>
-                <s>stable</s>
-            </r>
-        </a>
-        <deps>
-            <v>1.4.0</v>
-            <d>a:1:{s:8:&quot;required&quot;;a:3:{s:3:&quot;php&quot;;a:1:{s:3:&quot;min&quot;;s:5:&quot;4.0.0&quot;;}s:13:&quot;pearinstaller&quot;;a:1:{s:3:&quot;min&quot;;s:7:&quot;1.4.0b1&quot;;}s:7:&quot;package&quot;;a:2:{i:0;a:3:{s:4:&quot;name&quot;;s:7:&quot;Net_URL&quot;;s:7:&quot;channel&quot;;s:12:&quot;pear.php.net&quot;;s:3:&quot;min&quot;;s:6:&quot;1.0.12&quot;;}i:1;a:3:{s:4:&quot;name&quot;;s:10:&quot;Net_Socket&quot;;s:7:&quot;channel&quot;;s:12:&quot;pear.php.net&quot;;s:3:&quot;min&quot;;s:5:&quot;1.0.2&quot;;}}}}</d>
-        </deps>
-    </pi>
-    <pi>
-        <p><n>MDB2</n>
-            <c>pear.net</c>
-            <ca xlink:href="/rest/c/Database">Database</ca>
-            <l>BSD License</l>
-            <s>database abstraction layer</s>
-            <d>PEAR MDB2 is a merge of the PEAR DB and Metabase php database abstraction layers.
-
-                It provides a common API for all supported RDBMS. The main difference to most
-                other DB abstraction packages is that MDB2 goes much further to ensure
-                portability. MDB2 provides most of its many features optionally that
-                can be used to construct portable SQL statements:
-                * Object-Oriented API
-                * A DSN (data source name) or array format for specifying database servers
-                * Datatype abstraction and on demand datatype conversion
-                * Various optional fetch modes to fix portability issues
-                * Portable error codes
-                * Sequential and non sequential row fetching as well as bulk fetching
-                * Ability to make buffered and unbuffered queries
-                * Ordered array and associative array for the fetched rows
-                * Prepare/execute (bind) named and unnamed placeholder emulation
-                * Sequence/autoincrement emulation
-                * Replace emulation
-                * Limited sub select emulation
-                * Row limit emulation
-                * Transactions/savepoint support
-                * Large Object support
-                * Index/Unique Key/Primary Key support
-                * Pattern matching abstraction
-                * Module framework to load advanced functionality on demand
-                * Ability to read the information schema
-                * RDBMS management methods (creating, dropping, altering)
-                * Reverse engineering schemas from an existing database
-                * SQL function call abstraction
-                * Full integration into the PEAR Framework
-                * PHPDoc API documentation</d>
-            <r xlink:href="/rest/r/mdb2"/>
-        </p>
-        <a>
-            <r><v>2.4.0</v><s>stable</s></r>
-        </a>
-        <deps>
-            <v>2.4.0</v>
-            <d>a:2:{s:8:&quot;required&quot;;a:3:{s:3:&quot;php&quot;;a:1:{s:3:&quot;min&quot;;s:5:&quot;4.3.2&quot;;}s:13:&quot;pearinstaller&quot;;a:1:{s:3:&quot;min&quot;;s:7:&quot;1.4.0b1&quot;;}s:7:&quot;package&quot;;a:3:{s:4:&quot;name&quot;;s:4:&quot;PEAR&quot;;s:7:&quot;channel&quot;;s:12:&quot;pear.php.net&quot;;s:3:&quot;min&quot;;s:5:&quot;1.3.6&quot;;}}s:5:&quot;group&quot;;a:9:{i:0;a:2:{s:7:&quot;attribs&quot;;a:2:{s:4:&quot;hint&quot;;s:29:&quot;Frontbase SQL driver for MDB2&quot;;s:4:&quot;name&quot;;s:5:&quot;fbsql&quot;;}s:10:&quot;subpackage&quot;;a:3:{s:4:&quot;name&quot;;s:17:&quot;MDB2_Driver_fbsql&quot;;s:7:&quot;channel&quot;;s:12:&quot;pear.php.net&quot;;s:3:&quot;min&quot;;s:5:&quot;0.3.0&quot;;}}i:1;a:2:{s:7:&quot;attribs&quot;;a:2:{s:4:&quot;hint&quot;;s:34:&quot;Interbase/Firebird driver for MDB2&quot;;s:4:&quot;name&quot;;s:5:&quot;ibase&quot;;}s:10:&quot;subpackage&quot;;a:3:{s:4:&quot;name&quot;;s:17:&quot;MDB2_Driver_ibase&quot;;s:7:&quot;channel&quot;;s:12:&quot;pear.php.net&quot;;s:3:&quot;min&quot;;s:5:&quot;1.4.0&quot;;}}i:2;a:2:{s:7:&quot;attribs&quot;;a:2:{s:4:&quot;hint&quot;;s:21:&quot;MySQL driver for MDB2&quot;;s:4:&quot;name&quot;;s:5:&quot;mysql&quot;;}s:10:&quot;subpackage&quot;;a:3:{s:4:&quot;name&quot;;s:17:&quot;MDB2_Driver_mysql&quot;;s:7:&quot;channel&quot;;s:12:&quot;pear.php.net&quot;;s:3:&quot;min&quot;;s:5:&quot;1.4.0&quot;;}}i:3;a:2:{s:7:&quot;attribs&quot;;a:2:{s:4:&quot;hint&quot;;s:22:&quot;MySQLi driver for MDB2&quot;;s:4:&quot;name&quot;;s:6:&quot;mysqli&quot;;}s:10:&quot;subpackage&quot;;a:3:{s:4:&quot;name&quot;;s:18:&quot;MDB2_Driver_mysqli&quot;;s:7:&quot;channel&quot;;s:12:&quot;pear.php.net&quot;;s:3:&quot;min&quot;;s:5:&quot;1.4.0&quot;;}}i:4;a:2:{s:7:&quot;attribs&quot;;a:2:{s:4:&quot;hint&quot;;s:29:&quot;MS SQL Server driver for MDB2&quot;;s:4:&quot;name&quot;;s:5:&quot;mssql&quot;;}s:10:&quot;subpackage&quot;;a:3:{s:4:&quot;name&quot;;s:17:&quot;MDB2_Driver_mssql&quot;;s:7:&quot;channel&quot;;s:12:&quot;pear.php.net&quot;;s:3:&quot;min&quot;;s:5:&quot;1.2.0&quot;;}}i:5;a:2:{s:7:&quot;attribs&quot;;a:2:{s:4:&quot;hint&quot;;s:22:&quot;Oracle driver for MDB2&quot;;s:4:&quot;name&quot;;s:4:&quot;oci8&quot;;}s:10:&quot;subpackage&quot;;a:3:{s:4:&quot;name&quot;;s:16:&quot;MDB2_Driver_oci8&quot;;s:7:&quot;channel&quot;;s:12:&quot;pear.php.net&quot;;s:3:&quot;min&quot;;s:5:&quot;1.4.0&quot;;}}i:6;a:2:{s:7:&quot;attribs&quot;;a:2:{s:4:&quot;hint&quot;;s:26:&quot;PostgreSQL driver for MDB2&quot;;s:4:&quot;name&quot;;s:5:&quot;pgsql&quot;;}s:10:&quot;subpackage&quot;;a:3:{s:4:&quot;name&quot;;s:17:&quot;MDB2_Driver_pgsql&quot;;s:7:&quot;channel&quot;;s:12:&quot;pear.php.net&quot;;s:3:&quot;min&quot;;s:5:&quot;1.4.0&quot;;}}i:7;a:2:{s:7:&quot;attribs&quot;;a:2:{s:4:&quot;hint&quot;;s:24:&quot;Querysim driver for MDB2&quot;;s:4:&quot;name&quot;;s:8:&quot;querysim&quot;;}s:10:&quot;subpackage&quot;;a:3:{s:4:&quot;name&quot;;s:20:&quot;MDB2_Driver_querysim&quot;;s:7:&quot;channel&quot;;s:12:&quot;pear.php.net&quot;;s:3:&quot;min&quot;;s:5:&quot;0.6.0&quot;;}}i:8;a:2:{s:7:&quot;attribs&quot;;a:2:{s:4:&quot;hint&quot;;s:23:&quot;SQLite2 driver for MDB2&quot;;s:4:&quot;name&quot;;s:6:&quot;sqlite&quot;;}s:10:&quot;subpackage&quot;;a:3:{s:4:&quot;name&quot;;s:18:&quot;MDB2_Driver_sqlite&quot;;s:7:&quot;channel&quot;;s:12:&quot;pear.php.net&quot;;s:3:&quot;min&quot;;s:5:&quot;1.4.0&quot;;}}}}</d>
-        </deps>
-    </pi>
-</f>
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Pear/PackageDependencyParserTest.php 2.0.9-1/tests/Composer/Test/Repository/Pear/PackageDependencyParserTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/Pear/PackageDependencyParserTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Pear/PackageDependencyParserTest.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,61 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Test\Repository\Pear;
-
-use Composer\Repository\Pear\DependencyConstraint;
-use Composer\Repository\Pear\PackageDependencyParser;
-use Composer\Test\TestCase;
-
-class PackageDependencyParserTest extends TestCase
-{
-    /**
-     * @dataProvider dataProvider10
-     * @param $expected
-     * @param $data10
-     * @param $data20
-     */
-    public function testShouldParseDependencies($expected, $data10, $data20)
-    {
-        $expectedDependencies = array();
-        foreach ($expected as $expectedItem) {
-            $expectedDependencies[] = new DependencyConstraint(
-                $expectedItem['type'],
-                $expectedItem['constraint'],
-                $expectedItem['channel'],
-                $expectedItem['name']
-            );
-        }
-
-        $parser = new PackageDependencyParser();
-
-        if (false !== $data10) {
-            $result = $parser->buildDependencyInfo($data10);
-            $this->assertEquals($expectedDependencies, $result->getRequires() + $result->getOptionals(), "Failed for package.xml 1.0 format");
-        }
-
-        if (false !== $data20) {
-            $result = $parser->buildDependencyInfo($data20);
-            $this->assertEquals($expectedDependencies, $result->getRequires() + $result->getOptionals(), "Failed for package.xml 2.0 format");
-        }
-    }
-
-    public function dataProvider10()
-    {
-        $data = json_decode(file_get_contents(__DIR__.'/Fixtures/DependencyParserTestData.json'), true);
-        if (0 !== json_last_error()) {
-            throw new \PHPUnit_Framework_Exception('Invalid json file.');
-        }
-
-        return $data;
-    }
-}
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/PearRepositoryTest.php 2.0.9-1/tests/Composer/Test/Repository/PearRepositoryTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/PearRepositoryTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/PearRepositoryTest.php	1970-01-01 00:00:00.000000000 +0000
@@ -1,148 +0,0 @@
-<?php
-
-/*
- * This file is part of Composer.
- *
- * (c) Nils Adermann <naderman@naderman.de>
- *     Jordi Boggiano <j.boggiano@seld.be>
- *
- * For the full copyright and license information, please view the LICENSE
- * file that was distributed with this source code.
- */
-
-namespace Composer\Test\Repository;
-
-use Composer\Repository\PearRepository;
-use Composer\Test\TestCase;
-
-/**
- * @group legacy
- */
-class PearRepositoryTest extends TestCase
-{
-    /**
-     * @var PearRepository
-     */
-    private $repository;
-
-    /**
-     * @var \PHPUnit_Framework_MockObject_MockObject
-     */
-    private $remoteFilesystem;
-
-    public function testComposerShouldSetIncludePath()
-    {
-        $url = 'pear.phpmd.org';
-        if (!@file_get_contents('http://'.$url)) {
-            $this->markTestSkipped('Repository '.$url.' appears to be unreachable');
-        }
-        $expectedPackages = array(
-            array('name' => 'pear-pear.phpmd.org/PHP_PMD', 'version' => '1.3.3'),
-        );
-
-        $repoConfig = array(
-            'url' => $url,
-        );
-
-        $this->createRepository($repoConfig);
-
-        foreach ($expectedPackages as $expectedPackage) {
-            $package = $this->repository->findPackage($expectedPackage['name'], $expectedPackage['version']);
-            $this->assertInstanceOf(
-                'Composer\Package\PackageInterface',
-                $package,
-                'Expected package ' . $expectedPackage['name'] . ', version ' . $expectedPackage['version'] .
-                ' not found in pear channel ' . $url
-            );
-            $this->assertSame(array('/'), $package->getIncludePaths());
-        }
-    }
-
-    /**
-     * @dataProvider repositoryDataProvider
-     * @param string $url
-     * @param array  $expectedPackages
-     */
-    public function testRepositoryRead($url, array $expectedPackages)
-    {
-        $repoConfig = array(
-            'url' => $url,
-        );
-
-        if (!@file_get_contents('http://'.$url)) {
-            $this->markTestSkipped('Repository '.$url.' appears to be unreachable');
-        }
-
-        $this->createRepository($repoConfig);
-        foreach ($expectedPackages as $expectedPackage) {
-            $this->assertInstanceOf(
-                'Composer\Package\PackageInterface',
-                $this->repository->findPackage($expectedPackage['name'], $expectedPackage['version']),
-                'Expected package ' . $expectedPackage['name'] . ', version ' . $expectedPackage['version'] .
-                ' not found in pear channel ' . $url
-            );
-        }
-    }
-
-    public function repositoryDataProvider()
-    {
-        return array(
-            array(
-                'pear.php.net',
-                array(
-                    array('name' => 'pear-pear.php.net/PEAR', 'version' => '1.9.4'),
-                ),
-            ),
-            array(
-                'pear.pdepend.org',
-                array(
-                    array('name' => 'pear-pear.pdepend.org/PHP_Depend', 'version' => '1.0.5'),
-                ),
-            ),
-            array(
-                'pear.phpmd.org',
-                array(
-                    array('name' => 'pear-pear.phpmd.org/PHP_PMD', 'version' => '1.3.3'),
-                ),
-            ),
-            array(
-                'pear.doctrine-project.org',
-                array(
-                    array('name' => 'pear-pear.doctrine-project.org/DoctrineORM', 'version' => '2.2.2'),
-                ),
-            ),
-            array(
-                'pear.symfony-project.com',
-                array(
-                    array('name' => 'pear-pear.symfony-project.com/YAML', 'version' => '1.0.6'),
-                ),
-            ),
-            array(
-                'pear.pirum-project.org',
-                array(
-                    array('name' => 'pear-pear.pirum-project.org/Pirum', 'version' => '1.1.4'),
-                ),
-            ),
-        );
-    }
-
-    private function createRepository($repoConfig)
-    {
-        $ioInterface = $this->getMockBuilder('Composer\IO\IOInterface')
-            ->getMock();
-
-        $config = new \Composer\Config();
-
-        $this->remoteFilesystem = $this->getMockBuilder('Composer\Util\RemoteFilesystem')
-            ->disableOriginalConstructor()
-            ->getMock();
-
-        $this->repository = new PearRepository($repoConfig, $ioInterface, $config, null);
-    }
-
-    protected function tearDown()
-    {
-        $this->repository = null;
-        $this->remoteFilesystem = null;
-    }
-}
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/PlatformRepositoryTest.php 2.0.9-1/tests/Composer/Test/Repository/PlatformRepositoryTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/PlatformRepositoryTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/PlatformRepositoryTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -4,7 +4,7 @@
  * This file is part of Composer.
  *
  * (c) Nils Adermann <naderman@naderman.de>
- *         Jordi Boggiano <j.boggiano@seld.be>
+ *     Jordi Boggiano <j.boggiano@seld.be>
  *
  * For the full copyright and license information, please view the LICENSE
  * file that was distributed with this source code.
@@ -12,59 +12,1224 @@
 
 namespace Composer\Test\Repository;
 
+use Composer\Package\Package;
 use Composer\Repository\PlatformRepository;
 use Composer\Test\TestCase;
-use Composer\Util\Platform;
-use Symfony\Component\Process\ExecutableFinder;
+use PHPUnit\Framework\Assert;
 
-class PlatformRepositoryTest extends TestCase {
-    public function testHHVMVersionWhenExecutingInHHVM() {
-        if (!defined('HHVM_VERSION_ID')) {
-            $this->markTestSkipped('Not running with HHVM');
-            return;
-        }
-        $repository = new PlatformRepository();
-        $package = $repository->findPackage('hhvm', '*');
-        $this->assertNotNull($package, 'failed to find HHVM package');
-        $this->assertSame(
-            sprintf('%d.%d.%d',
-                HHVM_VERSION_ID / 10000,
-                (HHVM_VERSION_ID / 100) % 100,
-                HHVM_VERSION_ID % 100
+class PlatformRepositoryTest extends TestCase
+{
+    public function testHhvmPackage()
+    {
+        $hhvmDetector = $this->getMockBuilder('Composer\Platform\HhvmDetector')->getMock();
+        $platformRepository = new PlatformRepository(array(), array(), null, $hhvmDetector);
+
+        $hhvmDetector
+            ->method('getVersion')
+            ->willReturn('2.1.0');
+
+        $hhvm = $platformRepository->findPackage('hhvm', '*');
+        self::assertNotNull($hhvm, 'hhvm found');
+
+        self::assertSame('2.1.0', $hhvm->getPrettyVersion());
+    }
+
+    public function getPhpFlavorTestCases()
+    {
+        return array(
+            array(
+                array(
+                    'PHP_VERSION' => '7.1.33',
+                ),
+                array(
+                    'php' => '7.1.33',
+                ),
+            ),
+            array(
+                array(
+                    'PHP_VERSION' => '7.2.31-1+ubuntu16.04.1+deb.sury.org+1',
+                    'PHP_DEBUG' => true,
+                ),
+                array(
+                    'php' => '7.2.31',
+                    'php-debug' => '7.2.31',
+                ),
+            ),
+            array(
+                array(
+                    'PHP_VERSION' => '7.2.31-1+ubuntu16.04.1+deb.sury.org+1',
+                    'PHP_ZTS' => true,
+                ),
+                array(
+                    'php' => '7.2.31',
+                    'php-zts' => '7.2.31',
+                ),
+            ),
+            array(
+                array(
+                    'PHP_VERSION' => '7.2.31-1+ubuntu16.04.1+deb.sury.org+1',
+                    'PHP_INT_SIZE' => 8,
+                ),
+                array(
+                    'php' => '7.2.31',
+                    'php-64bit' => '7.2.31',
+                ),
+            ),
+            array(
+                array(
+                    'PHP_VERSION' => '7.2.31-1+ubuntu16.04.1+deb.sury.org+1',
+                    'AF_INET6' => 30,
+                ),
+                array(
+                    'php' => '7.2.31',
+                    'php-ipv6' => '7.2.31',
+                ),
+            ),
+            array(
+                array(
+                    'PHP_VERSION' => '7.2.31-1+ubuntu16.04.1+deb.sury.org+1',
+                ),
+                array(
+                    'php' => '7.2.31',
+                    'php-ipv6' => '7.2.31',
+                ),
+                array(
+                    array('inet_pton', array('::'), ''),
+                ),
+            ),
+            array(
+                array(
+                    'PHP_VERSION' => '7.2.31-1+ubuntu16.04.1+deb.sury.org+1',
+                ),
+                array(
+                    'php' => '7.2.31',
+                ),
+                array(
+                    array('inet_pton', array('::'), false),
+                ),
             ),
-            $package->getPrettyVersion()
         );
     }
 
-    public function testHHVMVersionWhenExecutingInPHP() {
-        if (defined('HHVM_VERSION_ID')) {
-            $this->markTestSkipped('Running with HHVM');
-            return;
-        }
-        if (PHP_VERSION_ID < 50400) {
-            $this->markTestSkipped('Test only works on PHP 5.4+');
-            return;
+    /** @dataProvider getPhpFlavorTestCases */
+    public function testPhpVersion(array $constants, array $packages, array $functions = array())
+    {
+        $runtime = $this->getMockBuilder('Composer\Platform\Runtime')->getMock();
+        $runtime
+            ->method('getExtensions')
+            ->willReturn(array());
+        $runtime
+            ->method('hasConstant')
+            ->willReturnMap(
+                array_map(function ($constant) {
+                    return array($constant, null, true);
+                }, array_keys($constants))
+            );
+        $runtime
+            ->method('getConstant')
+            ->willReturnMap(
+                array_map(function ($constant, $value) {
+                    return array($constant, null, $value);
+                }, array_keys($constants), array_values($constants))
+            );
+        $runtime
+            ->method('invoke')
+            ->willReturnMap($functions);
+
+        $repository = new PlatformRepository(array(), array(), $runtime);
+        foreach ($packages as $packageName => $version) {
+            $package = $repository->findPackage($packageName, '*');
+            self::assertNotNull($package, sprintf('Expected to find package "%s"', $packageName));
+            self::assertSame($version, $package->getPrettyVersion(), sprintf('Expected package "%s" version to be %s, got %s', $packageName, $version, $package->getPrettyVersion()));
         }
-        if (Platform::isWindows()) {
-            $this->markTestSkipped('Test does not run on Windows');
-            return;
+    }
+
+    public function testInetPtonRegression()
+    {
+        $runtime = $this->getMockBuilder('Composer\Platform\Runtime')->getMock();
+
+        $runtime
+            ->expects(self::once())
+            ->method('invoke')
+            ->with('inet_pton', array('::'))
+            ->willReturn(false);
+        $runtime
+            ->method('hasConstant')
+            ->willReturnMap(
+                array(
+                    array('PHP_ZTS', false),
+                    array('AF_INET6', false),
+                )
+            );
+        $runtime
+            ->method('getExtensions')
+            ->willReturn(array());
+        $runtime
+            ->method('getConstant')
+            ->willReturnMap(
+                array(
+                    array('PHP_VERSION', null, '7.0.0'),
+                    array('PHP_DEBUG', null, false),
+                )
+            );
+        $repository = new PlatformRepository(array(), array(), $runtime);
+        $package = $repository->findPackage('php-ipv6', '*');
+        self::assertNull($package);
+    }
+
+    public static function getLibraryTestCases()
+    {
+        return array(
+            'amqp' => array(
+                'amqp',
+                '
+
+amqp
+
+Version => 1.9.4
+Revision => release
+Compiled => Nov 19 2019 @ 08:44:26
+AMQP protocol version => 0-9-1
+librabbitmq version => 0.9.0
+Default max channels per connection => 256
+Default max frame size => 131072
+Default heartbeats interval => 0',
+                array(
+                    'lib-amqp-protocol' => '0.9.1',
+                    'lib-amqp-librabbitmq' => '0.9.0',
+                ),
+            ),
+            'bz2' => array(
+                'bz2',
+                '
+bz2
+
+BZip2 Support => Enabled
+Stream Wrapper support => compress.bzip2://
+Stream Filter support => bzip2.decompress, bzip2.compress
+BZip2 Version => 1.0.5, 6-Sept-2010',
+                array('lib-bz2' => '1.0.5'),
+            ),
+            'curl' => array(
+                'curl',
+                '
+curl
+
+cURL support => enabled
+cURL Information => 7.38.0
+Age => 3
+Features
+AsynchDNS => Yes
+CharConv => No
+Debug => No
+GSS-Negotiate => No
+IDN => Yes
+IPv6 => Yes
+krb4 => No
+Largefile => Yes
+libz => Yes
+NTLM => Yes
+NTLMWB => Yes
+SPNEGO => Yes
+SSL => Yes
+SSPI => No
+TLS-SRP => Yes
+HTTP2 => No
+GSSAPI => Yes
+Protocols => dict, file, ftp, ftps, gopher, http, https, imap, imaps, ldap, ldaps, pop3, pop3s, rtmp, rtsp, scp, sftp, smtp, smtps, telnet, tftp
+Host => x86_64-pc-linux-gnu
+SSL Version => OpenSSL/1.0.1t
+ZLib Version => 1.2.8
+libSSH Version => libssh2/1.4.3
+
+Directive => Local Value => Master Value
+curl.cainfo => no value => no value',
+                array(
+                    'lib-curl' => '2.0.0',
+                    'lib-curl-openssl' => '1.0.1.20',
+                    'lib-curl-zlib' => '1.2.8',
+                    'lib-curl-libssh2' => '1.4.3',
+                ),
+                array(array('curl_version', array(), array('version' => '2.0.0'))),
+            ),
+
+            'curl: OpenSSL fips version' => array(
+                'curl',
+                '
+curl
+
+cURL support => enabled
+cURL Information => 7.38.0
+Age => 3
+Features
+AsynchDNS => Yes
+CharConv => No
+Debug => No
+GSS-Negotiate => No
+IDN => Yes
+IPv6 => Yes
+krb4 => No
+Largefile => Yes
+libz => Yes
+NTLM => Yes
+NTLMWB => Yes
+SPNEGO => Yes
+SSL => Yes
+SSPI => No
+TLS-SRP => Yes
+HTTP2 => No
+GSSAPI => Yes
+Protocols => dict, file, ftp, ftps, gopher, http, https, imap, imaps, ldap, ldaps, pop3, pop3s, rtmp, rtsp, scp, sftp, smtp, smtps, telnet, tftp
+Host => x86_64-pc-linux-gnu
+SSL Version => OpenSSL/1.0.1t-fips
+ZLib Version => 1.2.8
+libSSH Version => libssh2/1.4.3
+
+Directive => Local Value => Master Value
+curl.cainfo => no value => no value',
+                array(
+                    'lib-curl' => '2.0.0',
+                    'lib-curl-openssl-fips' => array('1.0.1.20', array(), array('lib-curl-openssl')),
+                    'lib-curl-zlib' => '1.2.8',
+                    'lib-curl-libssh2' => '1.4.3',
+                ),
+                array(array('curl_version', array(), array('version' => '2.0.0'))),
+            ),
+            'curl: gnutls' => array(
+                'curl',
+                '
+curl
+
+cURL support => enabled
+cURL Information => 7.22.0
+Age => 3
+Features
+AsynchDNS => No
+CharConv => No
+Debug => No
+GSS-Negotiate => Yes
+IDN => Yes
+IPv6 => Yes
+krb4 => No
+Largefile => Yes
+libz => Yes
+NTLM => Yes
+NTLMWB => Yes
+SPNEGO => No
+SSL => Yes
+SSPI => No
+TLS-SRP => Yes
+Protocols => dict, file, ftp, ftps, gopher, http, https, imap, imaps, ldap, pop3, pop3s, rtmp, rtsp, smtp, smtps, telnet, tftp
+Host => x86_64-pc-linux-gnu
+SSL Version => GnuTLS/2.12.14
+ZLib Version => 1.2.3.4',
+                array(
+                    'lib-curl' => '7.22.0',
+                    'lib-curl-zlib' => '1.2.3.4',
+                    'lib-curl-gnutls' => array('2.12.14', array('lib-curl-openssl')),
+                ),
+                array(array('curl_version', array(), array('version' => '7.22.0'))),
+            ),
+            'curl: NSS' => array(
+                'curl',
+                '
+curl
+
+cURL support => enabled
+cURL Information => 7.24.0
+Age => 3
+Features
+AsynchDNS => Yes
+Debug => No
+GSS-Negotiate => Yes
+IDN => Yes
+IPv6 => Yes
+Largefile => Yes
+NTLM => Yes
+SPNEGO => No
+SSL => Yes
+SSPI => No
+krb4 => No
+libz => Yes
+CharConv => No
+Protocols => dict, file, ftp, ftps, gopher, http, https, imap, imaps, ldap, ldaps, pop3, pop3s, rtsp, scp, sftp, smtp, smtps, telnet, tftp
+Host => x86_64-redhat-linux-gnu
+SSL Version => NSS/3.13.3.0
+ZLib Version => 1.2.5
+libSSH Version => libssh2/1.4.1',
+                array(
+                    'lib-curl' => '7.24.0',
+                    'lib-curl-nss' => array('3.13.3.0', array('lib-curl-openssl')),
+                    'lib-curl-zlib' => '1.2.5',
+                    'lib-curl-libssh2' => '1.4.1',
+                ),
+                array(array('curl_version', array(), array('version' => '7.24.0'))),
+            ),
+            'curl: libssh not libssh2' => array(
+                'curl',
+                '
+
+curl
+
+cURL support => enabled
+cURL Information => 7.68.0
+Age => 5
+Features
+AsynchDNS => Yes
+CharConv => No
+Debug => No
+GSS-Negotiate => No
+IDN => Yes
+IPv6 => Yes
+krb4 => No
+Largefile => Yes
+libz => Yes
+NTLM => Yes
+NTLMWB => Yes
+SPNEGO => Yes
+SSL => Yes
+SSPI => No
+TLS-SRP => Yes
+HTTP2 => Yes
+GSSAPI => Yes
+KERBEROS5 => Yes
+UNIX_SOCKETS => Yes
+PSL => Yes
+HTTPS_PROXY => Yes
+MULTI_SSL => No
+BROTLI => Yes
+Protocols => dict, file, ftp, ftps, gopher, http, https, imap, imaps, ldap, ldaps, pop3, pop3s, rtmp, rtsp, scp, sftp, smb, smbs, smtp, smtps, telnet, tftp
+Host => x86_64-pc-linux-gnu
+SSL Version => OpenSSL/1.1.1g
+ZLib Version => 1.2.11
+libSSH Version => libssh/0.9.3/openssl/zlib',
+                array(
+                    'lib-curl' => '7.68.0',
+                    'lib-curl-openssl' => '1.1.1.7',
+                    'lib-curl-zlib' => '1.2.11',
+                    'lib-curl-libssh' => '0.9.3',
+                ),
+                array(array('curl_version', array(), array('version' => '7.68.0'))),
+            ),
+            'date' => array(
+                'date',
+                '
+date
+
+date/time support => enabled
+timelib version => 2018.03
+"Olson" Timezone Database Version => 2020.1
+Timezone Database => external
+Default timezone => Europe/Berlin',
+                array(
+                    'lib-date-timelib' => '2018.03',
+                    'lib-date-zoneinfo' => '2020.1',
+                ),
+            ),
+            'date: before timelib was extracted' => array(
+                'date',
+                '
+date
+
+date/time support => enabled
+"Olson" Timezone Database Version => 2013.2
+Timezone Database => internal
+Default timezone => Europe/Amsterdam',
+                array(
+                    'lib-date-zoneinfo' => '2013.2',
+                    'lib-date-timelib' => false,
+                ),
+            ),
+            'date: internal zoneinfo' => array(
+                array('date', 'timezonedb'),
+                '
+date
+
+date/time support => enabled
+"Olson" Timezone Database Version => 2020.1
+Timezone Database => internal
+Default timezone => UTC',
+                array('lib-date-zoneinfo' => '2020.1'),
+            ),
+            'date: external zoneinfo' => array(
+                array('date', 'timezonedb'),
+                '
+date
+
+date/time support => enabled
+"Olson" Timezone Database Version => 2020.1
+Timezone Database => external
+Default timezone => UTC',
+                array('lib-timezonedb-zoneinfo' => array('2020.1', array('lib-date-zoneinfo'))),
+            ),
+            'date: zoneinfo 0.system' => array(
+                'date',
+                '
+
+
+date/time support => enabled
+timelib version => 2018.03
+"Olson" Timezone Database Version => 0.system
+Timezone Database => internal
+Default timezone => Europe/Berlin
+
+Directive => Local Value => Master Value
+date.timezone => no value => no value
+date.default_latitude => 31.7667 => 31.7667
+date.default_longitude => 35.2333 => 35.2333
+date.sunset_zenith => 90.583333 => 90.583333
+date.sunrise_zenith => 90.583333 => 90.583333',
+                array(
+                    'lib-date-zoneinfo' => '0',
+                    'lib-date-timelib' => '2018.03',
+                ),
+            ),
+            'fileinfo' => array(
+                'fileinfo',
+                '
+fileinfo
+
+fileinfo support => enabled
+libmagic => 537',
+                array('lib-fileinfo-libmagic' => '537'),
+            ),
+            'gd' => array(
+                'gd',
+                '
+gd
+
+GD Support => enabled
+GD Version => bundled (2.1.0 compatible)
+FreeType Support => enabled
+FreeType Linkage => with freetype
+FreeType Version => 2.10.0
+GIF Read Support => enabled
+GIF Create Support => enabled
+JPEG Support => enabled
+libJPEG Version => 9 compatible
+PNG Support => enabled
+libPNG Version => 1.6.34
+WBMP Support => enabled
+XBM Support => enabled
+WebP Support => enabled
+
+Directive => Local Value => Master Value
+gd.jpeg_ignore_warning => 1 => 1',
+                array(
+                    'lib-gd' => '1.2.3',
+                    'lib-gd-freetype' => '2.10.0',
+                    'lib-gd-libjpeg' => '9.0',
+                    'lib-gd-libpng' => '1.6.34',
+                ),
+                array(),
+                array(array('GD_VERSION', null, '1.2.3')),
+            ),
+            'gd: libjpeg version variation' => array(
+                'gd',
+                '
+gd
+
+GD Support => enabled
+GD Version => bundled (2.1.0 compatible)
+FreeType Support => enabled
+FreeType Linkage => with freetype
+FreeType Version => 2.9.1
+GIF Read Support => enabled
+GIF Create Support => enabled
+JPEG Support => enabled
+libJPEG Version => 6b
+PNG Support => enabled
+libPNG Version => 1.6.35
+WBMP Support => enabled
+XBM Support => enabled
+WebP Support => enabled
+
+Directive => Local Value => Master Value
+gd.jpeg_ignore_warning => 1 => 1',
+                array(
+                    'lib-gd' => '1.2.3',
+                    'lib-gd-freetype' => '2.9.1',
+                    'lib-gd-libjpeg' => '6.2',
+                    'lib-gd-libpng' => '1.6.35',
+                ),
+                array(),
+                array(array('GD_VERSION', null, '1.2.3')),
+            ),
+            'gd: libxpm' => array(
+                'gd',
+                '
+gd
+
+GD Support => enabled
+GD headers Version => 2.2.5
+GD library Version => 2.2.5
+FreeType Support => enabled
+FreeType Linkage => with freetype
+FreeType Version => 2.6.3
+GIF Read Support => enabled
+GIF Create Support => enabled
+JPEG Support => enabled
+libJPEG Version => 6b
+PNG Support => enabled
+libPNG Version => 1.6.28
+WBMP Support => enabled
+XPM Support => enabled
+libXpm Version => 30411
+XBM Support => enabled
+WebP Support => enabled
+
+Directive => Local Value => Master Value
+gd.jpeg_ignore_warning => 1 => 1',
+                array(
+                    'lib-gd' => '2.2.5',
+                    'lib-gd-freetype' => '2.6.3',
+                    'lib-gd-libjpeg' => '6.2',
+                    'lib-gd-libpng' => '1.6.28',
+                    'lib-gd-libxpm' => '3.4.11',
+                ),
+                array(),
+                array(array('GD_VERSION', null, '2.2.5')),
+            ),
+            'iconv' => array(
+                'iconv',
+                null,
+                array('lib-iconv' => '1.2.4'),
+                array(),
+                array(array('ICONV_VERSION', null, '1.2.4')),
+            ),
+            'gmp' => array(
+                'gmp',
+                null,
+                array('lib-gmp' => '6.1.0'),
+                array(),
+                array(array('GMP_VERSION', null, '6.1.0')),
+            ),
+            'intl' => array(
+                'intl',
+                '
+intl
+
+Internationalization support => enabled
+ICU version => 57.1
+ICU Data version => 57.1
+ICU TZData version => 2016b
+ICU Unicode version => 8.0
+
+Directive => Local Value => Master Value
+intl.default_locale => no value => no value
+intl.error_level => 0 => 0
+intl.use_exceptions => 0 => 0',
+                array(
+                    'lib-icu' => '100',
+                    'lib-icu-cldr' => ResourceBundleStub::STUB_VERSION,
+                    'lib-icu-unicode' => '7.0.0',
+                    'lib-icu-zoneinfo' => '2016.2',
+                ),
+                array(
+                    array(array('ResourceBundle', 'create'), array('root', 'ICUDATA', false), new ResourceBundleStub()),
+                    array(array('IntlChar', 'getUnicodeVersion'), array(), array(7, 0, 0, 0)),
+                ),
+                array(array('INTL_ICU_VERSION', null, '100')),
+                array(
+                    array('ResourceBundle'),
+                    array('IntlChar'),
+                ),
+            ),
+            'intl: INTL_ICU_VERSION not defined' => array(
+                'intl',
+                '
+intl
+
+Internationalization support => enabled
+version => 1.1.0
+ICU version => 57.1
+ICU Data version => 57.1',
+                array('lib-icu' => '57.1'),
+            ),
+            'imagick: 6.x' => array(
+                'imagick',
+                null,
+                array('lib-imagick-imagemagick' => array('6.2.9', array('lib-imagick'))),
+                array(),
+                array(),
+                array(array('Imagick', array(), new ImagickStub('ImageMagick 6.2.9 Q16 x86_64 2018-05-18 http://www.imagemagick.org'))),
+            ),
+            'imagick: 7.x' => array(
+                'imagick',
+                null,
+                array('lib-imagick-imagemagick' => array('7.0.8.34', array('lib-imagick'))),
+                array(),
+                array(),
+                array(array('Imagick', array(), new ImagickStub('ImageMagick 7.0.8-34 Q16 x86_64 2019-03-23 https://imagemagick.org'))),
+            ),
+            'ldap' => array(
+                'ldap',
+                '
+ldap
+
+LDAP Support => enabled
+RCS Version => $Id: 5f1913de8e05a346da913956f81e0c0d8991c7cb $
+Total Links => 0/unlimited
+API Version => 3001
+Vendor Name => OpenLDAP
+Vendor Version => 20450
+SASL Support => Enabled
+
+Directive => Local Value => Master Value
+ldap.max_links => Unlimited => Unlimited',
+                array('lib-ldap-openldap' => '2.4.50'),
+            ),
+            'libxml' => array(
+                'libxml',
+                null,
+                array('lib-libxml' => '2.1.5'),
+                array(),
+                array(array('LIBXML_DOTTED_VERSION', null, '2.1.5')),
+            ),
+            'libxml: related extensions' => array(
+                array('libxml', 'dom', 'simplexml', 'xml', 'xmlreader', 'xmlwriter'),
+                null,
+                array('lib-libxml' => array('2.1.5', array(), array('lib-dom-libxml', 'lib-simplexml-libxml', 'lib-xml-libxml', 'lib-xmlreader-libxml', 'lib-xmlwriter-libxml'))),
+                array(),
+                array(array('LIBXML_DOTTED_VERSION', null, '2.1.5')),
+            ),
+            'mbstring' => array(
+                'mbstring',
+                '
+mbstring
+
+Multibyte Support => enabled
+Multibyte string engine => libmbfl
+HTTP input encoding translation => disabled
+libmbfl version => 1.3.2
+
+mbstring extension makes use of "streamable kanji code filter and converter", which is distributed under the GNU Lesser General Public License version 2.1.
+
+Multibyte (japanese) regex support => enabled
+Multibyte regex (oniguruma) version => 6.1.3',
+                array(
+                    'lib-mbstring-libmbfl' => '1.3.2',
+                    'lib-mbstring-oniguruma' => '7.0.0',
+                ),
+                array(),
+                array(array('MB_ONIGURUMA_VERSION', null, '7.0.0')),
+            ),
+            'mbstring: no MB_ONIGURUMA constant' => array(
+                'mbstring',
+                '
+mbstring
+
+Multibyte Support => enabled
+Multibyte string engine => libmbfl
+HTTP input encoding translation => disabled
+libmbfl version => 1.3.2
+
+mbstring extension makes use of "streamable kanji code filter and converter", which is distributed under the GNU Lesser General Public License version 2.1.
+
+Multibyte (japanese) regex support => enabled
+Multibyte regex (oniguruma) version => 6.1.3',
+                array(
+                    'lib-mbstring-libmbfl' => '1.3.2',
+                    'lib-mbstring-oniguruma' => '6.1.3',
+                ),
+            ),
+            'mbstring: no MB_ONIGURUMA constant <7.40' => array(
+                'mbstring',
+                '
+mbstring
+
+Multibyte Support => enabled
+Multibyte string engine => libmbfl
+HTTP input encoding translation => disabled
+libmbfl version => 1.3.2
+oniguruma version => 6.9.4
+
+mbstring extension makes use of "streamable kanji code filter and converter", which is distributed under the GNU Lesser General Public License version 2.1.
+
+Multibyte (japanese) regex support => enabled
+Multibyte regex (oniguruma) backtrack check => On',
+                array(
+                    'lib-mbstring-libmbfl' => '1.3.2',
+                    'lib-mbstring-oniguruma' => '6.9.4',
+                ),
+            ),
+            'memcached' => array(
+                'memcached',
+                '
+memcached
+
+memcached support => enabled
+Version => 3.1.5
+libmemcached version => 1.0.18
+SASL support => yes
+Session support => yes
+igbinary support => yes
+json support => yes
+msgpack support => yes',
+                array('lib-memcached-libmemcached' => '1.0.18'),
+            ),
+            'openssl' => array(
+                'openssl',
+                null,
+                array('lib-openssl' => '1.1.1.7'),
+                array(),
+                array(array('OPENSSL_VERSION_TEXT', null, 'OpenSSL 1.1.1g  21 Apr 2020')),
+            ),
+            'openssl: two letters suffix' => array(
+                'openssl',
+                null,
+                array('lib-openssl' => '0.9.8.33'),
+                array(),
+                array(array('OPENSSL_VERSION_TEXT', null, 'OpenSSL 0.9.8zg  21 Apr 2020')),
+            ),
+            'openssl: pre release is treated as alpha' => array(
+                'openssl',
+                null,
+                array('lib-openssl' => '1.1.1.7-alpha1'),
+                array(),
+                array(array('OPENSSL_VERSION_TEXT', null, 'OpenSSL 1.1.1g-pre1  21 Apr 2020')),
+            ),
+            'openssl: beta release' => array(
+                'openssl',
+                null,
+                array('lib-openssl' => '1.1.1.7-beta2'),
+                array(),
+                array(array('OPENSSL_VERSION_TEXT', null, 'OpenSSL 1.1.1g-beta2  21 Apr 2020')),
+            ),
+            'openssl: alpha release' => array(
+                'openssl',
+                null,
+                array('lib-openssl' => '1.1.1.7-alpha4'),
+                array(),
+                array(array('OPENSSL_VERSION_TEXT', null, 'OpenSSL 1.1.1g-alpha4  21 Apr 2020')),
+            ),
+            'openssl: rc release' => array(
+                'openssl',
+                null,
+                array('lib-openssl' => '1.1.1.7-rc2'),
+                array(),
+                array(array('OPENSSL_VERSION_TEXT', null, 'OpenSSL 1.1.1g-rc2  21 Apr 2020')),
+            ),
+            'openssl: fips' => array(
+                'openssl',
+                null,
+                array('lib-openssl-fips' => array('1.1.1.7', array(), array('lib-openssl'))),
+                array(),
+                array(array('OPENSSL_VERSION_TEXT', null, 'OpenSSL 1.1.1g-fips  21 Apr 2020')),
+            ),
+            'openssl: LibreSSL' => array(
+                'openssl',
+                null,
+                array('lib-openssl' => '2.0.1.0'),
+                array(),
+                array(array('OPENSSL_VERSION_TEXT', null, 'LibreSSL 2.0.1')),
+            ),
+            'mysqlnd' => array(
+                'mysqlnd',
+                '
+                mysqlnd
+
+mysqlnd => enabled
+Version => mysqlnd 5.0.11-dev - 20150407 - $Id: 38fea24f2847fa7519001be390c98ae0acafe387 $
+Compression => supported
+core SSL => supported
+extended SSL => supported
+Command buffer size => 4096
+Read buffer size => 32768
+Read timeout => 31536000
+Collecting statistics => Yes
+Collecting memory statistics => Yes
+Tracing => n/a
+Loaded plugins => mysqlnd,debug_trace,auth_plugin_mysql_native_password,auth_plugin_mysql_clear_password,auth_plugin_sha256_password
+API Extensions => pdo_mysql,mysqli',
+                array('lib-mysqlnd-mysqlnd' => '5.0.11-dev'),
+            ),
+            'pdo_mysql' => array(
+                'pdo_mysql',
+                '
+                pdo_mysql
+
+PDO Driver for MySQL => enabled
+Client API version => mysqlnd 5.0.10-dev - 20150407 - $Id: 38fea24f2847fa7519001be390c98ae0acafe387 $
+
+Directive => Local Value => Master Value
+pdo_mysql.default_socket => /tmp/mysql.sock => /tmp/mysql.sock',
+                array('lib-pdo_mysql-mysqlnd' => '5.0.10-dev'),
+            ),
+            'mongodb' => array(
+                'mongodb',
+                '
+                mongodb
+
+MongoDB support => enabled
+MongoDB extension version => 1.6.1
+MongoDB extension stability => stable
+libbson bundled version => 1.15.2
+libmongoc bundled version => 1.15.2
+libmongoc SSL => enabled
+libmongoc SSL library => OpenSSL
+libmongoc crypto => enabled
+libmongoc crypto library => libcrypto
+libmongoc crypto system profile => disabled
+libmongoc SASL => disabled
+libmongoc ICU => enabled
+libmongoc compression => enabled
+libmongoc compression snappy => disabled
+libmongoc compression zlib => enabled
+
+Directive => Local Value => Master Value
+mongodb.debug => no value => no value',
+                array(
+                    'lib-mongodb-libmongoc' => '1.15.2',
+                    'lib-mongodb-libbson' => '1.15.2',
+                ),
+            ),
+            'pcre' => array(
+                'pcre',
+                '
+pcre
+
+PCRE (Perl Compatible Regular Expressions) Support => enabled
+PCRE Library Version => 10.33 2019-04-16
+PCRE Unicode Version => 11.0.0
+PCRE JIT Support => enabled
+PCRE JIT Target => x86 64bit (little endian + unaligned)',
+                array(
+                    'lib-pcre' => '10.33',
+                    'lib-pcre-unicode' => '11.0.0',
+                ),
+                array(),
+                array(array('PCRE_VERSION', null, '10.33 2019-04-16')),
+            ),
+            'pcre: no unicode version included' => array(
+                'pcre',
+                '
+pcre
+
+PCRE (Perl Compatible Regular Expressions) Support => enabled
+PCRE Library Version => 8.38 2015-11-23
+
+Directive => Local Value => Master Value
+pcre.backtrack_limit => 1000000 => 1000000
+pcre.recursion_limit => 100000 => 100000
+                ',
+                array(
+                    'lib-pcre' => '8.38',
+                ),
+                array(),
+                array(array('PCRE_VERSION', null, '8.38 2015-11-23')),
+            ),
+            'pgsql' => array(
+                'pgsql',
+                '
+pgsql
+
+PostgreSQL Support => enabled
+PostgreSQL(libpq) Version => 12.2
+PostgreSQL(libpq)  => PostgreSQL 12.3 on x86_64-apple-darwin18.7.0, compiled by Apple clang version 11.0.0 (clang-1100.0.33.17), 64-bit
+Multibyte character support => enabled
+SSL support => enabled
+Active Persistent Links => 0
+Active Links => 0
+
+Directive => Local Value => Master Value
+pgsql.allow_persistent => On => On
+pgsql.max_persistent => Unlimited => Unlimited
+pgsql.max_links => Unlimited => Unlimited
+pgsql.auto_reset_persistent => Off => Off
+pgsql.ignore_notice => Off => Off
+pgsql.log_notice => Off => Off',
+                array('lib-pgsql-libpq' => '12.2'),
+            ),
+            'pdo_pgsql' => array(
+                'pdo_pgsql',
+                '
+                pdo_pgsql
+
+PDO Driver for PostgreSQL => enabled
+PostgreSQL(libpq) Version => 12.1
+Module version => 7.1.33
+Revision =>  $Id: 9c5f356c77143981d2e905e276e439501fe0f419 $',
+                array('lib-pdo_pgsql-libpq' => '12.1'),
+            ),
+            'libsodium' => array(
+                'libsodium',
+                null,
+                array('lib-libsodium' => '1.0.17'),
+                array(),
+                array(array('SODIUM_LIBRARY_VERSION', null, '1.0.17')),
+            ),
+            'libsodium: different extension name' => array(
+                'sodium',
+                null,
+                array('lib-libsodium' => '1.0.15'),
+                array(),
+                array(array('SODIUM_LIBRARY_VERSION', null, '1.0.15')),
+            ),
+            'pdo_sqlite' => array(
+                'pdo_sqlite',
+                '
+pdo_sqlite
+
+PDO Driver for SQLite 3.x => enabled
+SQLite Library => 3.32.3
+                ',
+                array('lib-pdo_sqlite-sqlite' => '3.32.3'),
+            ),
+            'sqlite3' => array(
+                'sqlite3',
+                '
+sqlite3
+
+SQLite3 support => enabled
+SQLite3 module version => 7.1.33
+SQLite Library => 3.31.0
+
+Directive => Local Value => Master Value
+sqlite3.extension_dir => no value => no value
+sqlite3.defensive => 1 => 1',
+                array('lib-sqlite3-sqlite' => '3.31.0'),
+            ),
+            'ssh2' => array(
+                'ssh2',
+                '
+ssh2
+
+SSH2 support => enabled
+extension version => 1.2
+libssh2 version => 1.8.0
+banner => SSH-2.0-libssh2_1.8.0',
+                array('lib-ssh2-libssh2' => '1.8.0'),
+            ),
+            'yaml' => array(
+                'yaml',
+                '
+                yaml
+
+LibYAML Support => enabled
+Module Version => 2.0.2
+LibYAML Version => 0.2.2
+
+Directive => Local Value => Master Value
+yaml.decode_binary => 0 => 0
+yaml.decode_timestamp => 0 => 0
+yaml.decode_php => 0 => 0
+yaml.output_canonical => 0 => 0
+yaml.output_indent => 2 => 2
+yaml.output_width => 80 => 80',
+                array('lib-yaml-libyaml' => '0.2.2'),
+            ),
+            'xsl' => array(
+                'xsl',
+                '
+xsl
+
+XSL => enabled
+libxslt Version => 1.1.33
+libxslt compiled against libxml Version => 2.9.8
+EXSLT => enabled
+libexslt Version => 1.1.29',
+                array(
+                    'lib-libxslt' => array('1.1.29', array('lib-xsl')),
+                    'lib-libxslt-libxml' => '2.9.8',
+                ),
+                array(),
+                array(array('LIBXSLT_DOTTED_VERSION', null, '1.1.29')),
+            ),
+            'zip' => array(
+                'zip',
+                null,
+                array('lib-zip-libzip' => array('1.5.0', array('lib-zip'))),
+                array(),
+                array(array('LIBZIP_VERSION', 'ZipArchive', '1.5.0')),
+            ),
+            'zlib' => array(
+                'zlib',
+                null,
+                array('lib-zlib' => '1.2.10'),
+                array(),
+                array(array('ZLIB_VERSION', null, '1.2.10')),
+            ),
+            'zlib: no constant present' => array(
+                'zlib',
+                '
+zlib
+
+ZLib Support => enabled
+Stream Wrapper => compress.zlib://
+Stream Filter => zlib.inflate, zlib.deflate
+Compiled Version => 1.2.8
+Linked Version => 1.2.11',
+                array('lib-zlib' => '1.2.11'),
+            ),
+        );
+    }
+
+    /**
+     * @dataProvider getLibraryTestCases
+     *
+     * @param string|string[]            $extensions
+     * @param string|null                $info
+     * @param array<string,string|false> $expectations
+     * @param array<string,mixed>        $functions
+     * @param array<string,mixed>        $constants
+     * @param array<string,class-string> $classDefinitions
+     */
+    public function testLibraryInformation(
+        $extensions,
+        $info,
+        array $expectations,
+        array $functions = array(),
+        array $constants = array(),
+        array $classDefinitions = array()
+    ) {
+        $extensions = (array) $extensions;
+
+        $extensionVersion = '100.200.300';
+
+        $runtime = $this->getMockBuilder('Composer\Platform\Runtime')->getMock();
+        $runtime
+            ->method('getExtensions')
+            ->willReturn($extensions);
+
+        $runtime
+            ->method('getExtensionVersion')
+            ->willReturnMap(
+                array_map(function ($extension) use ($extensionVersion) {
+                    return array($extension, $extensionVersion);
+                }, $extensions)
+            );
+
+        $runtime
+            ->method('getExtensionInfo')
+            ->willReturnMap(
+                array_map(function ($extension) use ($info) {
+                    return array($extension, $info);
+                }, $extensions)
+            );
+
+        $runtime
+            ->method('invoke')
+            ->willReturnMap($functions);
+
+        $constants[] = array('PHP_VERSION', null, '7.1.0');
+        $runtime
+            ->method('hasConstant')
+            ->willReturnMap(
+                array_map(
+                    function ($constantDefintion) {
+                        return array($constantDefintion[0], $constantDefintion[1], true);
+                    },
+                    $constants
+                )
+            );
+        $runtime
+            ->method('getConstant')
+            ->willReturnMap($constants);
+
+        $runtime
+            ->method('hasClass')
+            ->willReturnMap(
+                array_map(
+                    function ($classDefinition) {
+                        return array($classDefinition[0], true);
+                    },
+                    $classDefinitions
+                )
+            );
+        $runtime
+            ->method('construct')
+            ->willReturnMap($classDefinitions);
+
+        $platformRepository = new PlatformRepository(array(), array(), $runtime);
+
+        $expectations = array_map(function ($expectation) {
+            return array_replace(array(null, array(), array()), (array) $expectation);
+        }, $expectations);
+
+        $libraries = array_map(
+            function ($package) {
+                return $package['name'];
+            },
+            array_filter(
+                $platformRepository->search('lib', PlatformRepository::SEARCH_NAME),
+                function ($package) {
+                    return strpos($package['name'], 'lib-') === 0;
+                }
+            )
+        );
+        $expectedLibraries = array_merge(array_keys(array_filter($expectations, function ($expectation) {
+            return $expectation[0] !== false;
+        })));
+        self::assertCount(count(array_filter($expectedLibraries)), $libraries, sprintf('Expected: %s, got %s', var_export($expectedLibraries, true), var_export($libraries, true)));
+
+        $expectations = array_merge($expectations, array_combine(array_map(function ($extension) {
+            return 'ext-'.$extension;
+        }, $extensions), array_fill(0, count($extensions), array($extensionVersion, array(), array()))));
+
+        foreach ($expectations as $packageName => $expectation) {
+            list($expectedVersion, $expectedReplaces, $expectedProvides) = $expectation;
+
+            $package = $platformRepository->findPackage($packageName, '*');
+            if ($expectedVersion === false) {
+                self::assertNull($package, sprintf('Expected to not find package "%s"', $packageName));
+            } else {
+                self::assertNotNull($package, sprintf('Expected to find package "%s"', $packageName));
+                self::assertSame($expectedVersion, $package->getPrettyVersion(), sprintf('Expected version %s for %s', $expectedVersion, $packageName));
+                $this->assertPackageLinks('replaces', $expectedReplaces, $package, $package->getReplaces());
+                $this->assertPackageLinks('provides', $expectedProvides, $package, $package->getProvides());
+            }
         }
-        $finder = new ExecutableFinder();
-        $hhvm = $finder->find('hhvm');
-        if ($hhvm === null) {
-            $this->markTestSkipped('HHVM is not installed');
+    }
+
+    private function assertPackageLinks($context, array $expectedLinks, Package $sourcePackage, array $links)
+    {
+        self::assertCount(count($expectedLinks), $links, sprintf('%s: expected package count to match', $context));
+
+        foreach ($links as $link) {
+            self::assertSame($sourcePackage->getName(), $link->getSource());
+            self::assertContains($link->getTarget(), $expectedLinks, sprintf('%s: package %s not in %s', $context, $link->getTarget(), var_export($expectedLinks, true)));
+            self::assertTrue($link->getConstraint()->matches($this->getVersionConstraint('=', $sourcePackage->getVersion())));
         }
-        $process = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
-        $process->expects($this->once())->method('execute')->will($this->returnCallback(
-            function($command, &$out) {
-                $this->assertContains('HHVM_VERSION', $command);
-                $out = '4.0.1-dev';
-                return 0;
-            }
-        ));
-        $repository = new PlatformRepository(array(), array(), $process);
-        $package = $repository->findPackage('hhvm', '*');
-        $this->assertNotNull($package, 'failed to find HHVM package');
-        $this->assertSame('4.0.1.0-dev', $package->getVersion());
+    }
+}
+
+class ResourceBundleStub
+{
+    const STUB_VERSION = '32.0.1';
+
+    public static function create($locale, $bundleName, $fallback)
+    {
+        Assert::assertSame(3, func_num_args());
+        Assert::assertSame('root', $locale);
+        Assert::assertSame('ICUDATA', $bundleName);
+        Assert::assertFalse($fallback);
+
+        return new self();
+    }
+
+    public function get($field)
+    {
+        Assert::assertSame(1, func_num_args());
+        Assert::assertSame('Version', $field);
+
+        return self::STUB_VERSION;
+    }
+}
+
+class ImagickStub
+{
+    private $versionString;
+
+    public function __construct($versionString)
+    {
+        $this->versionString = $versionString;
+    }
+
+    public function getVersion()
+    {
+        Assert::assertSame(0, func_num_args());
+
+        return array('versionString' => $this->versionString);
     }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/RepositoryFactoryTest.php 2.0.9-1/tests/Composer/Test/Repository/RepositoryFactoryTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/RepositoryFactoryTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/RepositoryFactoryTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -21,7 +21,9 @@ class RepositoryFactoryTest extends Test
     {
         $manager = RepositoryFactory::manager(
             $this->getMockBuilder('Composer\IO\IOInterface')->getMock(),
-            $this->getMockBuilder('Composer\Config')->getMock()
+            $this->getMockBuilder('Composer\Config')->getMock(),
+            $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock(),
+            $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')->disableOriginalConstructor()->getMock()
         );
 
         $ref = new \ReflectionProperty($manager, 'repositoryClasses');
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/RepositoryManagerTest.php 2.0.9-1/tests/Composer/Test/Repository/RepositoryManagerTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/RepositoryManagerTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/RepositoryManagerTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -38,6 +38,7 @@ class RepositoryManagerTest extends Test
         $rm = new RepositoryManager(
             $this->getMockBuilder('Composer\IO\IOInterface')->getMock(),
             $this->getMockBuilder('Composer\Config')->getMock(),
+            $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock(),
             $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')->disableOriginalConstructor()->getMock()
         );
 
@@ -61,6 +62,7 @@ class RepositoryManagerTest extends Test
         $rm = new RepositoryManager(
             $this->getMockBuilder('Composer\IO\IOInterface')->getMock(),
             $config = $this->getMockBuilder('Composer\Config')->setMethods(array('get'))->getMock(),
+            $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock(),
             $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')->disableOriginalConstructor()->getMock()
         );
 
@@ -95,7 +97,7 @@ class RepositoryManagerTest extends Test
             array('git', array('url' => 'http://github.com/foo/bar')),
             array('git', array('url' => 'git@example.org:foo/bar.git')),
             array('svn', array('url' => 'svn://example.org/foo/bar')),
-            array('pear', array('url' => 'http://pear.example.org/foo')),
+            array('pear', array('url' => 'http://pear.example.org/foo'), 'RuntimeException'),
             array('package', array('package' => array())),
             array('invalid', array(), 'InvalidArgumentException'),
         );
@@ -106,4 +108,20 @@ class RepositoryManagerTest extends Test
 
         return $cases;
     }
+
+    public function testFilterRepoWrapping()
+    {
+        $rm = new RepositoryManager(
+            $this->getMockBuilder('Composer\IO\IOInterface')->getMock(),
+            $config = $this->getMockBuilder('Composer\Config')->setMethods(array('get'))->getMock(),
+            $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock(),
+            $this->getMockBuilder('Composer\EventDispatcher\EventDispatcher')->disableOriginalConstructor()->getMock()
+        );
+
+        $rm->setRepositoryClass('path', 'Composer\Repository\PathRepository');
+        $repo = $rm->createRepository('path', array('type' => 'path', 'url' => __DIR__, 'only' => array('foo/bar')));
+
+        $this->assertInstanceOf('Composer\Repository\FilterRepository', $repo);
+        $this->assertInstanceOf('Composer\Repository\PathRepository', $repo->getRepository());
+    }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Vcs/FossilDriverTest.php 2.0.9-1/tests/Composer/Test/Repository/Vcs/FossilDriverTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/Vcs/FossilDriverTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Vcs/FossilDriverTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,7 +16,6 @@ use Composer\Repository\Vcs\FossilDriver
 use Composer\Config;
 use Composer\Test\TestCase;
 use Composer\Util\Filesystem;
-use Composer\Util\Platform;
 
 class FossilDriverTest extends TestCase
 {
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php 2.0.9-1/tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Vcs/GitBitbucketDriverTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,6 +16,8 @@ use Composer\Config;
 use Composer\Repository\Vcs\GitBitbucketDriver;
 use Composer\Test\TestCase;
 use Composer\Util\Filesystem;
+use Composer\Util\ProcessExecutor;
+use Composer\Util\Http\Response;
 
 /**
  * @group bitbucket
@@ -26,8 +28,8 @@ class GitBitbucketDriverTest extends Tes
     private $io;
     /** @type \Composer\Config */
     private $config;
-    /** @type \Composer\Util\RemoteFilesystem|\PHPUnit_Framework_MockObject_MockObject */
-    private $rfs;
+    /** @type \Composer\Util\HttpDownloader|\PHPUnit_Framework_MockObject_MockObject */
+    private $httpDownloader;
     /** @type string */
     private $home;
     /** @type string */
@@ -46,7 +48,7 @@ class GitBitbucketDriverTest extends Tes
             ),
         ));
 
-        $this->rfs = $this->getMockBuilder('Composer\Util\RemoteFilesystem')
+        $this->httpDownloader = $this->getMockBuilder('Composer\Util\HttpDownloader')
             ->disableOriginalConstructor()
             ->getMock();
     }
@@ -67,8 +69,8 @@ class GitBitbucketDriverTest extends Tes
             $repoConfig,
             $this->io,
             $this->config,
-            null,
-            $this->rfs
+            $this->httpDownloader,
+            new ProcessExecutor($this->io)
         );
 
         $driver->initialize();
@@ -83,15 +85,14 @@ class GitBitbucketDriverTest extends Tes
             'https://bitbucket.org/user/repo.git does not appear to be a git repository, use https://bitbucket.org/user/repo if this is a mercurial bitbucket repository'
         );
 
-        $this->rfs->expects($this->once())
-            ->method('getContents')
+        $this->httpDownloader->expects($this->once())
+            ->method('get')
             ->with(
-                $this->originUrl,
-                'https://api.bitbucket.org/2.0/repositories/user/repo?fields=-project%2C-owner',
-                false
+                $url = 'https://api.bitbucket.org/2.0/repositories/user/repo?fields=-project%2C-owner',
+                array()
             )
             ->willReturn(
-                '{"scm":"hg","website":"","has_wiki":false,"name":"repo","links":{"branches":{"href":"https:\/\/api.bitbucket.org\/2.0\/repositories\/user\/repo\/refs\/branches"},"tags":{"href":"https:\/\/api.bitbucket.org\/2.0\/repositories\/user\/repo\/refs\/tags"},"clone":[{"href":"https:\/\/user@bitbucket.org\/user\/repo","name":"https"},{"href":"ssh:\/\/hg@bitbucket.org\/user\/repo","name":"ssh"}],"html":{"href":"https:\/\/bitbucket.org\/user\/repo"}},"language":"php","created_on":"2015-02-18T16:22:24.688+00:00","updated_on":"2016-05-17T13:20:21.993+00:00","is_private":true,"has_issues":false}'
+                new Response(array('url' => $url), 200, array(), '{"scm":"hg","website":"","has_wiki":false,"name":"repo","links":{"branches":{"href":"https:\/\/api.bitbucket.org\/2.0\/repositories\/user\/repo\/refs\/branches"},"tags":{"href":"https:\/\/api.bitbucket.org\/2.0\/repositories\/user\/repo\/refs\/tags"},"clone":[{"href":"https:\/\/user@bitbucket.org\/user\/repo","name":"https"},{"href":"ssh:\/\/hg@bitbucket.org\/user\/repo","name":"ssh"}],"html":{"href":"https:\/\/bitbucket.org\/user\/repo"}},"language":"php","created_on":"2015-02-18T16:22:24.688+00:00","updated_on":"2016-05-17T13:20:21.993+00:00","is_private":true,"has_issues":false}')
             );
 
         $driver = $this->getDriver(array('url' => 'https://bitbucket.org/user/repo.git'));
@@ -103,47 +104,43 @@ class GitBitbucketDriverTest extends Tes
     {
         $driver = $this->getDriver(array('url' => 'https://bitbucket.org/user/repo.git'));
 
-        $this->rfs->expects($this->any())
-            ->method('getContents')
+        $urls = array(
+            'https://api.bitbucket.org/2.0/repositories/user/repo?fields=-project%2C-owner',
+            'https://api.bitbucket.org/2.0/repositories/user/repo?fields=mainbranch',
+            'https://api.bitbucket.org/2.0/repositories/user/repo/refs/tags?pagelen=100&fields=values.name%2Cvalues.target.hash%2Cnext&sort=-target.date',
+            'https://api.bitbucket.org/2.0/repositories/user/repo/refs/branches?pagelen=100&fields=values.name%2Cvalues.target.hash%2Cvalues.heads%2Cnext&sort=-target.date',
+            'https://api.bitbucket.org/2.0/repositories/user/repo/src/master/composer.json',
+            'https://api.bitbucket.org/2.0/repositories/user/repo/commit/master?fields=date',
+        );
+        $this->httpDownloader->expects($this->any())
+            ->method('get')
             ->withConsecutive(
                 array(
-                    $this->originUrl,
-                    'https://api.bitbucket.org/2.0/repositories/user/repo?fields=-project%2C-owner',
-                    false,
+                    $urls[0], array(),
                 ),
                 array(
-                    $this->originUrl,
-                    'https://api.bitbucket.org/2.0/repositories/user/repo?fields=mainbranch',
-                    false,
+                    $urls[1], array(),
                 ),
                 array(
-                    $this->originUrl,
-                    'https://api.bitbucket.org/2.0/repositories/user/repo/refs/tags?pagelen=100&fields=values.name%2Cvalues.target.hash%2Cnext&sort=-target.date',
-                    false,
+                    $urls[2], array(),
                 ),
                 array(
-                    $this->originUrl,
-                    'https://api.bitbucket.org/2.0/repositories/user/repo/refs/branches?pagelen=100&fields=values.name%2Cvalues.target.hash%2Cvalues.heads%2Cnext&sort=-target.date',
-                    false,
+                    $urls[3], array(),
                 ),
                 array(
-                    $this->originUrl,
-                    'https://api.bitbucket.org/2.0/repositories/user/repo/src/master/composer.json',
-                    false,
+                    $urls[4], array(),
                 ),
                 array(
-                    $this->originUrl,
-                    'https://api.bitbucket.org/2.0/repositories/user/repo/commit/master?fields=date',
-                    false,
+                    $urls[5], array(),
                 )
             )
             ->willReturnOnConsecutiveCalls(
-                '{"scm":"git","website":"","has_wiki":false,"name":"repo","links":{"branches":{"href":"https:\/\/api.bitbucket.org\/2.0\/repositories\/user\/repo\/refs\/branches"},"tags":{"href":"https:\/\/api.bitbucket.org\/2.0\/repositories\/user\/repo\/refs\/tags"},"clone":[{"href":"https:\/\/user@bitbucket.org\/user\/repo.git","name":"https"},{"href":"ssh:\/\/git@bitbucket.org\/user\/repo.git","name":"ssh"}],"html":{"href":"https:\/\/bitbucket.org\/user\/repo"}},"language":"php","created_on":"2015-02-18T16:22:24.688+00:00","updated_on":"2016-05-17T13:20:21.993+00:00","is_private":true,"has_issues":false}',
-                '{"mainbranch": {"name": "master"}}',
-                '{"values":[{"name":"1.0.1","target":{"hash":"9b78a3932143497c519e49b8241083838c8ff8a1"}},{"name":"1.0.0","target":{"hash":"d3393d514318a9267d2f8ebbf463a9aaa389f8eb"}}]}',
-                '{"values":[{"name":"master","target":{"hash":"937992d19d72b5116c3e8c4a04f960e5fa270b22"}}]}',
-                '{"name": "user/repo","description": "test repo","license": "GPL","authors": [{"name": "Name","email": "local@domain.tld"}],"require": {"creator/package": "^1.0"},"require-dev": {"phpunit/phpunit": "~4.8"}}',
-                '{"date": "2016-05-17T13:19:52+00:00"}'
+                new Response(array('url' => $urls[0]), 200, array(), '{"scm":"git","website":"","has_wiki":false,"name":"repo","links":{"branches":{"href":"https:\/\/api.bitbucket.org\/2.0\/repositories\/user\/repo\/refs\/branches"},"tags":{"href":"https:\/\/api.bitbucket.org\/2.0\/repositories\/user\/repo\/refs\/tags"},"clone":[{"href":"https:\/\/user@bitbucket.org\/user\/repo.git","name":"https"},{"href":"ssh:\/\/git@bitbucket.org\/user\/repo.git","name":"ssh"}],"html":{"href":"https:\/\/bitbucket.org\/user\/repo"}},"language":"php","created_on":"2015-02-18T16:22:24.688+00:00","updated_on":"2016-05-17T13:20:21.993+00:00","is_private":true,"has_issues":false}'),
+                new Response(array('url' => $urls[1]), 200, array(), '{"mainbranch": {"name": "master"}}'),
+                new Response(array('url' => $urls[2]), 200, array(), '{"values":[{"name":"1.0.1","target":{"hash":"9b78a3932143497c519e49b8241083838c8ff8a1"}},{"name":"1.0.0","target":{"hash":"d3393d514318a9267d2f8ebbf463a9aaa389f8eb"}}]}'),
+                new Response(array('url' => $urls[3]), 200, array(), '{"values":[{"name":"master","target":{"hash":"937992d19d72b5116c3e8c4a04f960e5fa270b22"}}]}'),
+                new Response(array('url' => $urls[4]), 200, array(), '{"name": "user/repo","description": "test repo","license": "GPL","authors": [{"name": "Name","email": "local@domain.tld"}],"require": {"creator/package": "^1.0"},"require-dev": {"phpunit/phpunit": "~4.8"}}'),
+                new Response(array('url' => $urls[5]), 200, array(), '{"date": "2016-05-17T13:19:52+00:00"}')
             );
 
         $this->assertEquals(
@@ -227,6 +224,7 @@ class GitBitbucketDriverTest extends Tes
             GitBitbucketDriver::supports($this->io, $this->config, 'https://bitbucket.org/user/repo.git')
         );
 
+        // should not be changed, see https://github.com/composer/composer/issues/9400
         $this->assertFalse(
             GitBitbucketDriver::supports($this->io, $this->config, 'git@bitbucket.org:user/repo.git')
         );
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Vcs/GitHubDriverTest.php 2.0.9-1/tests/Composer/Test/Repository/Vcs/GitHubDriverTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/Vcs/GitHubDriverTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Vcs/GitHubDriverTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,6 +16,7 @@ use Composer\Downloader\TransportExcepti
 use Composer\Repository\Vcs\GitHubDriver;
 use Composer\Test\TestCase;
 use Composer\Util\Filesystem;
+use Composer\Util\Http\Response;
 use Composer\Config;
 
 class GitHubDriverTest extends TestCase
@@ -53,8 +54,8 @@ class GitHubDriverTest extends TestCase
             ->method('isInteractive')
             ->will($this->returnValue(true));
 
-        $remoteFilesystem = $this->getMockBuilder('Composer\Util\RemoteFilesystem')
-            ->setConstructorArgs(array($io))
+        $httpDownloader = $this->getMockBuilder('Composer\Util\HttpDownloader')
+            ->setConstructorArgs(array($io, $this->config))
             ->getMock();
 
         $process = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
@@ -62,9 +63,9 @@ class GitHubDriverTest extends TestCase
             ->method('execute')
             ->will($this->returnValue(1));
 
-        $remoteFilesystem->expects($this->at(0))
-            ->method('getContents')
-            ->with($this->equalTo('github.com'), $this->equalTo($repoApiUrl), $this->equalTo(false))
+        $httpDownloader->expects($this->at(0))
+            ->method('get')
+            ->with($this->equalTo($repoApiUrl))
             ->will($this->throwException(new TransportException('HTTP/1.1 404 Not Found', 404)));
 
         $io->expects($this->once())
@@ -76,15 +77,15 @@ class GitHubDriverTest extends TestCase
             ->method('setAuthentication')
             ->with($this->equalTo('github.com'), $this->matchesRegularExpression('{sometoken}'), $this->matchesRegularExpression('{x-oauth-basic}'));
 
-        $remoteFilesystem->expects($this->at(1))
-            ->method('getContents')
-            ->with($this->equalTo('github.com'), $this->equalTo('https://api.github.com/'), $this->equalTo(false))
-            ->will($this->returnValue('{}'));
-
-        $remoteFilesystem->expects($this->at(2))
-            ->method('getContents')
-            ->with($this->equalTo('github.com'), $this->equalTo($repoApiUrl), $this->equalTo(false))
-            ->will($this->returnValue('{"master_branch": "test_master", "private": true, "owner": {"login": "composer"}, "name": "packagist"}'));
+        $httpDownloader->expects($this->at(1))
+            ->method('get')
+            ->with($this->equalTo($url = 'https://api.github.com/'))
+            ->will($this->returnValue(new Response(array('url' => $url), 200, array(), '{}')));
+
+        $httpDownloader->expects($this->at(2))
+            ->method('get')
+            ->with($this->equalTo($url = $repoApiUrl))
+            ->will($this->returnValue(new Response(array('url' => $url), 200, array(), '{"master_branch": "test_master", "private": true, "owner": {"login": "composer"}, "name": "packagist"}')));
 
         $configSource = $this->getMockBuilder('Composer\Config\ConfigSourceInterface')->getMock();
         $authConfigSource = $this->getMockBuilder('Composer\Config\ConfigSourceInterface')->getMock();
@@ -95,7 +96,7 @@ class GitHubDriverTest extends TestCase
             'url' => $repoUrl,
         );
 
-        $gitHubDriver = new GitHubDriver($repoConfig, $io, $this->config, $process, $remoteFilesystem);
+        $gitHubDriver = new GitHubDriver($repoConfig, $io, $this->config, $httpDownloader, $process);
         $gitHubDriver->initialize();
         $this->setAttribute($gitHubDriver, 'tags', array($identifier => $sha));
 
@@ -124,21 +125,25 @@ class GitHubDriverTest extends TestCase
             ->method('isInteractive')
             ->will($this->returnValue(true));
 
-        $remoteFilesystem = $this->getMockBuilder('Composer\Util\RemoteFilesystem')
-            ->setConstructorArgs(array($io))
+        $httpDownloader = $this->getMockBuilder('Composer\Util\HttpDownloader')
+            ->setConstructorArgs(array($io, $this->config))
             ->getMock();
 
-        $remoteFilesystem->expects($this->at(0))
-            ->method('getContents')
-            ->with($this->equalTo('github.com'), $this->equalTo($repoApiUrl), $this->equalTo(false))
-            ->will($this->returnValue('{"master_branch": "test_master", "owner": {"login": "composer"}, "name": "packagist"}'));
+        $httpDownloader->expects($this->at(0))
+            ->method('get')
+            ->with($this->equalTo($repoApiUrl))
+            ->will($this->returnValue(new Response(array('url' => $repoApiUrl), 200, array(), '{"master_branch": "test_master", "owner": {"login": "composer"}, "name": "packagist"}')));
 
         $repoConfig = array(
             'url' => $repoUrl,
         );
         $repoUrl = 'https://github.com/composer/packagist.git';
 
-        $gitHubDriver = new GitHubDriver($repoConfig, $io, $this->config, null, $remoteFilesystem);
+        $process = $this->getMockBuilder('Composer\Util\ProcessExecutor')
+            ->disableOriginalConstructor()
+            ->getMock();
+
+        $gitHubDriver = new GitHubDriver($repoConfig, $io, $this->config, $httpDownloader, $process);
         $gitHubDriver->initialize();
         $this->setAttribute($gitHubDriver, 'tags', array($identifier => $sha));
 
@@ -167,31 +172,40 @@ class GitHubDriverTest extends TestCase
             ->method('isInteractive')
             ->will($this->returnValue(true));
 
-        $remoteFilesystem = $this->getMockBuilder('Composer\Util\RemoteFilesystem')
-            ->setConstructorArgs(array($io))
+        $httpDownloader = $this->getMockBuilder('Composer\Util\HttpDownloader')
+            ->setConstructorArgs(array($io, $this->config))
             ->getMock();
 
-        $remoteFilesystem->expects($this->at(0))
-            ->method('getContents')
-            ->with($this->equalTo('github.com'), $this->equalTo($repoApiUrl), $this->equalTo(false))
-            ->will($this->returnValue('{"master_branch": "test_master", "owner": {"login": "composer"}, "name": "packagist"}'));
-
-        $remoteFilesystem->expects($this->at(1))
-            ->method('getContents')
-            ->with($this->equalTo('github.com'), $this->equalTo('https://api.github.com/repos/composer/packagist/contents/composer.json?ref=feature%2F3.2-foo'), $this->equalTo(false))
-            ->will($this->returnValue('{"encoding":"base64","content":"'.base64_encode('{"support": {"source": "'.$repoUrl.'" }}').'"}'));
-
-        $remoteFilesystem->expects($this->at(2))
-            ->method('getContents')
-            ->with($this->equalTo('github.com'), $this->equalTo('https://api.github.com/repos/composer/packagist/commits/feature%2F3.2-foo'), $this->equalTo(false))
-            ->will($this->returnValue('{"commit": {"committer":{ "date": "2012-09-10"}}}'));
+        $httpDownloader->expects($this->at(0))
+            ->method('get')
+            ->with($this->equalTo($url = $repoApiUrl))
+            ->will($this->returnValue(new Response(array('url' => $url), 200, array(), '{"master_branch": "test_master", "owner": {"login": "composer"}, "name": "packagist"}')));
+
+        $httpDownloader->expects($this->at(1))
+            ->method('get')
+            ->with($this->equalTo($url = 'https://api.github.com/repos/composer/packagist/contents/composer.json?ref=feature%2F3.2-foo'))
+            ->will($this->returnValue(new Response(array('url' => $url), 200, array(), '{"encoding":"base64","content":"'.base64_encode('{"support": {"source": "'.$repoUrl.'" }}').'"}')));
+
+        $httpDownloader->expects($this->at(2))
+            ->method('get')
+            ->with($this->equalTo($url = 'https://api.github.com/repos/composer/packagist/commits/feature%2F3.2-foo'))
+            ->will($this->returnValue(new Response(array('url' => $url), 200, array(), '{"commit": {"committer":{ "date": "2012-09-10"}}}')));
+
+        $httpDownloader->expects($this->at(3))
+            ->method('get')
+            ->with($this->equalTo($url = 'https://api.github.com/repos/composer/packagist/contents/.github/FUNDING.yml'))
+            ->will($this->returnValue(new Response(array('url' => $url), 200, array(), '{"encoding": "base64", "content": "'.base64_encode("custom: https://example.com").'"}')));
 
         $repoConfig = array(
             'url' => $repoUrl,
         );
         $repoUrl = 'https://github.com/composer/packagist.git';
 
-        $gitHubDriver = new GitHubDriver($repoConfig, $io, $this->config, null, $remoteFilesystem);
+        $process = $this->getMockBuilder('Composer\Util\ProcessExecutor')
+            ->disableOriginalConstructor()
+            ->getMock();
+
+        $gitHubDriver = new GitHubDriver($repoConfig, $io, $this->config, $httpDownloader, $process);
         $gitHubDriver->initialize();
         $this->setAttribute($gitHubDriver, 'tags', array($identifier => $sha));
 
@@ -225,30 +239,39 @@ class GitHubDriverTest extends TestCase
             ->method('isInteractive')
             ->will($this->returnValue(true));
 
-        $remoteFilesystem = $this->getMockBuilder('Composer\Util\RemoteFilesystem')
-            ->setConstructorArgs(array($io))
+        $process = $this->getMockBuilder('Composer\Util\ProcessExecutor')
+            ->disableOriginalConstructor()
+            ->getMock();
+
+        $httpDownloader = $this->getMockBuilder('Composer\Util\HttpDownloader')
+            ->setConstructorArgs(array($io, $this->config))
             ->getMock();
 
-        $remoteFilesystem->expects($this->at(0))
-            ->method('getContents')
-            ->with($this->equalTo('github.com'), $this->equalTo($repoApiUrl), $this->equalTo(false))
-            ->will($this->returnValue('{"master_branch": "test_master", "owner": {"login": "composer"}, "name": "packagist", "archived": true}'));
-
-        $remoteFilesystem->expects($this->at(1))
-            ->method('getContents')
-            ->with($this->equalTo('github.com'), $this->equalTo($composerJsonUrl), $this->equalTo(false))
-            ->will($this->returnValue('{"encoding": "base64", "content": "' . base64_encode('{"name": "composer/packagist"}') . '"}'));
-
-        $remoteFilesystem->expects($this->at(2))
-            ->method('getContents')
-            ->with($this->equalTo('github.com'), $this->equalTo('https://api.github.com/repos/composer/packagist/commits/SOMESHA'), $this->equalTo(false))
-            ->will($this->returnValue('{"commit": {"committer":{ "date": "2012-09-10"}}}'));
+        $httpDownloader->expects($this->at(0))
+            ->method('get')
+            ->with($this->equalTo($repoApiUrl))
+            ->will($this->returnValue(new Response(array('url' => $repoApiUrl), 200, array(), '{"master_branch": "test_master", "owner": {"login": "composer"}, "name": "packagist", "archived": true}')));
+
+        $httpDownloader->expects($this->at(1))
+            ->method('get')
+            ->with($this->equalTo($composerJsonUrl))
+            ->will($this->returnValue(new Response(array('url' => $composerJsonUrl), 200, array(), '{"encoding": "base64", "content": "' . base64_encode('{"name": "composer/packagist"}') . '"}')));
+
+        $httpDownloader->expects($this->at(2))
+            ->method('get')
+            ->with($this->equalTo($url = 'https://api.github.com/repos/composer/packagist/commits/'.$sha))
+            ->will($this->returnValue(new Response(array('url' => $url), 200, array(), '{"commit": {"committer":{ "date": "2012-09-10"}}}')));
+
+        $httpDownloader->expects($this->at(3))
+            ->method('get')
+            ->with($this->equalTo($url = 'https://api.github.com/repos/composer/packagist/contents/.github/FUNDING.yml'))
+            ->will($this->returnValue(new Response(array('url' => $url), 200, array(), '{"encoding": "base64", "content": "'.base64_encode("custom: https://example.com").'"}')));
 
         $repoConfig = array(
             'url' => $repoUrl,
         );
 
-        $gitHubDriver = new GitHubDriver($repoConfig, $io, $this->config, null, $remoteFilesystem);
+        $gitHubDriver = new GitHubDriver($repoConfig, $io, $this->config, $httpDownloader, $process);
         $gitHubDriver->initialize();
         $this->setAttribute($gitHubDriver, 'tags', array($identifier => $sha));
 
@@ -274,13 +297,13 @@ class GitHubDriverTest extends TestCase
             ->method('isInteractive')
             ->will($this->returnValue(false));
 
-        $remoteFilesystem = $this->getMockBuilder('Composer\Util\RemoteFilesystem')
-            ->setConstructorArgs(array($io))
+        $httpDownloader = $this->getMockBuilder('Composer\Util\HttpDownloader')
+            ->setConstructorArgs(array($io, $this->config))
             ->getMock();
 
-        $remoteFilesystem->expects($this->at(0))
-            ->method('getContents')
-            ->with($this->equalTo('github.com'), $this->equalTo($repoApiUrl), $this->equalTo(false))
+        $httpDownloader->expects($this->at(0))
+            ->method('get')
+            ->with($this->equalTo($repoApiUrl))
             ->will($this->throwException(new TransportException('HTTP/1.1 404 Not Found', 404)));
 
         // clean local clone if present
@@ -325,7 +348,7 @@ class GitHubDriverTest extends TestCase
             'url' => $repoUrl,
         );
 
-        $gitHubDriver = new GitHubDriver($repoConfig, $io, $this->config, $process, $remoteFilesystem);
+        $gitHubDriver = new GitHubDriver($repoConfig, $io, $this->config, $httpDownloader, $process);
         $gitHubDriver->initialize();
 
         $this->assertEquals('test_master', $gitHubDriver->getRootIdentifier());
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Vcs/GitLabDriverTest.php 2.0.9-1/tests/Composer/Test/Repository/Vcs/GitLabDriverTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/Vcs/GitLabDriverTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Vcs/GitLabDriverTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -17,6 +17,7 @@ use Composer\Config;
 use Composer\Test\TestCase;
 use Composer\Util\Filesystem;
 use Prophecy\Argument;
+use Composer\Util\Http\Response;
 
 /**
  * @author Jérôme Tamarelle <jerome@tamarelle.net>
@@ -27,7 +28,7 @@ class GitLabDriverTest extends TestCase
     private $config;
     private $io;
     private $process;
-    private $remoteFilesystem;
+    private $httpDownloader;
 
     public function setUp()
     {
@@ -47,7 +48,7 @@ class GitLabDriverTest extends TestCase
 
         $this->io = $this->prophesize('Composer\IO\IOInterface');
         $this->process = $this->prophesize('Composer\Util\ProcessExecutor');
-        $this->remoteFilesystem = $this->prophesize('Composer\Util\RemoteFilesystem');
+        $this->httpDownloader = $this->prophesize('Composer\Util\HttpDownloader');
     }
 
     public function tearDown()
@@ -87,13 +88,11 @@ class GitLabDriverTest extends TestCase
 }
 JSON;
 
-        $this->remoteFilesystem
-            ->getContents('gitlab.com', $apiUrl, false, array())
-            ->willReturn($projectData)
+        $this->mockResponse($apiUrl, array(), $projectData)
             ->shouldBeCalledTimes(1)
         ;
 
-        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->process->reveal(), $this->remoteFilesystem->reveal());
+        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->httpDownloader->reveal(), $this->process->reveal());
         $driver->initialize();
 
         $this->assertEquals($apiUrl, $driver->getApiUrl(), 'API URL is derived from the repository URL');
@@ -126,13 +125,11 @@ JSON;
 }
 JSON;
 
-        $this->remoteFilesystem
-            ->getContents('gitlab.com', $apiUrl, false, array())
-            ->willReturn($projectData)
+        $this->mockResponse($apiUrl, array(), $projectData)
             ->shouldBeCalledTimes(1)
         ;
 
-        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->process->reveal(), $this->remoteFilesystem->reveal());
+        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->httpDownloader->reveal(), $this->process->reveal());
         $driver->initialize();
 
         $this->assertEquals($apiUrl, $driver->getApiUrl(), 'API URL is derived from the repository URL');
@@ -164,13 +161,11 @@ JSON;
 }
 JSON;
 
-        $this->remoteFilesystem
-            ->getContents('gitlab.com', $apiUrl, false, array())
-            ->willReturn($projectData)
+        $this->mockResponse($apiUrl, array(), $projectData)
             ->shouldBeCalledTimes(1)
         ;
 
-        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->process->reveal(), $this->remoteFilesystem->reveal());
+        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->httpDownloader->reveal(), $this->process->reveal());
         $driver->initialize();
 
         $this->assertEquals($apiUrl, $driver->getApiUrl(), 'API URL is derived from the repository URL');
@@ -206,12 +201,10 @@ JSON;
 }
 JSON;
 
-        $this->remoteFilesystem
-            ->getContents($domain.':'.$port, $apiUrl, false, array())
-            ->willReturn(sprintf($projectData, $domain, $port, $namespace))
+        $this->mockResponse($apiUrl, array(), sprintf($projectData, $domain, $port, $namespace))
             ->shouldBeCalledTimes(1);
 
-        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->process->reveal(), $this->remoteFilesystem->reveal());
+        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->httpDownloader->reveal(), $this->process->reveal());
         $driver->initialize();
 
         $this->assertEquals($apiUrl, $driver->getApiUrl(), 'API URL is derived from the repository URL');
@@ -289,15 +282,11 @@ JSON;
 ]
 JSON;
 
-        $this->remoteFilesystem
-            ->getContents('gitlab.com', $apiUrl, false, array())
-            ->willReturn($tagData)
+        $this->mockResponse($apiUrl, array(), $tagData)
             ->shouldBeCalledTimes(1)
         ;
-        $this->remoteFilesystem->getLastHeaders()
-            ->willReturn(array());
 
-        $driver->setRemoteFilesystem($this->remoteFilesystem->reveal());
+        $driver->setHttpDownloader($this->httpDownloader->reveal());
 
         $expected = array(
             'v1.0.0' => '092ed2c762bbae331e3f51d4a17f67310bf99a81',
@@ -344,26 +333,20 @@ JSON;
 
         $branchData = json_encode($branchData);
 
-        $this->remoteFilesystem
-            ->getContents('gitlab.com', $apiUrl, false, array())
-            ->willReturn($branchData)
-            ->shouldBeCalledTimes(1)
-        ;
-
-        $this->remoteFilesystem
-            ->getContents('gitlab.com', "http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=2&per_page=20", false, array())
-            ->willReturn($branchData)
-            ->shouldBeCalledTimes(1)
-        ;
+        $headers = array('Link: <http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=2&per_page=20>; rel="next", <http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=1&per_page=20>; rel="first", <http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=3&per_page=20>; rel="last"');
+        $this->httpDownloader
+            ->get($apiUrl, array())
+            ->willReturn(new Response(array('url' => $apiUrl), 200, $headers, $branchData))
+            ->shouldBeCalledTimes(1);
 
-        $this->remoteFilesystem->getLastHeaders()
-            ->willReturn(
-                array('Link: <http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=2&per_page=20>; rel="next", <http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=1&per_page=20>; rel="first", <http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=3&per_page=20>; rel="last"'),
-                array('Link: <http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=2&per_page=20>; rel="prev", <http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=1&per_page=20>; rel="first", <http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=3&per_page=20>; rel="last"')
-            )
-            ->shouldBeCalledTimes(2);
+        $apiUrl = "http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=2&per_page=20";
+        $headers = array('Link: <http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=2&per_page=20>; rel="prev", <http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=1&per_page=20>; rel="first", <http://gitlab.com/api/v4/projects/mygroup%2Fmyproject/repository/tags?id=mygroup%2Fmyproject&page=3&per_page=20>; rel="last"');
+        $this->httpDownloader
+            ->get($apiUrl, array())
+            ->willReturn(new Response(array('url' => $apiUrl), 200, $headers, $branchData))
+            ->shouldBeCalledTimes(1);
 
-        $driver->setRemoteFilesystem($this->remoteFilesystem->reveal());
+        $driver->setHttpDownloader($this->httpDownloader->reveal());
 
         $expected = array(
             'mymaster' => '97eda36b5c1dd953a3792865c222d4e85e5f302e',
@@ -401,15 +384,11 @@ JSON;
 ]
 JSON;
 
-        $this->remoteFilesystem
-            ->getContents('gitlab.com', $apiUrl, false, array())
-            ->willReturn($branchData)
+        $this->mockResponse($apiUrl, array(), $branchData)
             ->shouldBeCalledTimes(1)
         ;
-        $this->remoteFilesystem->getLastHeaders()
-            ->willReturn(array());
 
-        $driver->setRemoteFilesystem($this->remoteFilesystem->reveal());
+        $driver->setHttpDownloader($this->httpDownloader->reveal());
 
         $expected = array(
             'mymaster' => '97eda36b5c1dd953a3792865c222d4e85e5f302e',
@@ -474,13 +453,11 @@ JSON;
 }
 JSON;
 
-        $this->remoteFilesystem
-            ->getContents('mycompany.com/gitlab', $apiUrl, false, array())
-            ->willReturn($projectData)
+        $this->mockResponse($apiUrl, array(), $projectData)
             ->shouldBeCalledTimes(1)
         ;
 
-        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->process->reveal(), $this->remoteFilesystem->reveal());
+        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->httpDownloader->reveal(), $this->process->reveal());
         $driver->initialize();
 
         $this->assertEquals($apiUrl, $driver->getApiUrl(), 'API URL is derived from the repository URL');
@@ -507,13 +484,11 @@ JSON;
 }
 JSON;
 
-        $this->remoteFilesystem
-            ->getContents('gitlab.com', $apiUrl, false, array())
-            ->willReturn($projectData)
+        $this->mockResponse($apiUrl, array(), $projectData)
             ->shouldBeCalledTimes(1)
         ;
 
-        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->process->reveal(), $this->remoteFilesystem->reveal());
+        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->httpDownloader->reveal(), $this->process->reveal());
         $driver->initialize();
 
         $this->assertEquals($apiUrl, $driver->getApiUrl(), 'API URL is derived from the repository URL');
@@ -540,13 +515,11 @@ JSON;
 }
 JSON;
 
-        $this->remoteFilesystem
-            ->getContents('mycompany.com/gitlab', $apiUrl, false, array())
-            ->willReturn($projectData)
+        $this->mockResponse($apiUrl, array(), $projectData)
             ->shouldBeCalledTimes(1)
         ;
 
-        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->process->reveal(), $this->remoteFilesystem->reveal());
+        $driver = new GitLabDriver(array('url' => $url), $this->io->reveal(), $this->config, $this->httpDownloader->reveal(), $this->process->reveal());
         $driver->initialize();
 
         $this->assertEquals($apiUrl, $driver->getApiUrl(), 'API URL is derived from the repository URL');
@@ -575,18 +548,23 @@ JSON;
 }
 JSON;
 
-        $this->remoteFilesystem
-            ->getContents(Argument::cetera(), $options)
-            ->willReturn($projectData)
+        $this->mockResponse(Argument::cetera(), $options, $projectData)
             ->shouldBeCalled();
 
         $driver = new GitLabDriver(
             array('url' => 'https://gitlab.mycompany.local/mygroup/myproject', 'options' => $options),
             $this->io->reveal(),
             $this->config,
-            $this->process->reveal(),
-            $this->remoteFilesystem->reveal()
+            $this->httpDownloader->reveal(),
+            $this->process->reveal()
         );
         $driver->initialize();
     }
+
+    private function mockResponse($url, $options, $return)
+    {
+        return $this->httpDownloader
+            ->get($url, $options)
+            ->willReturn(new Response(array('url' => $url), 200, array(), $return));
+    }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Vcs/PerforceDriverTest.php 2.0.9-1/tests/Composer/Test/Repository/Vcs/PerforceDriverTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/Vcs/PerforceDriverTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Vcs/PerforceDriverTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -26,7 +26,7 @@ class PerforceDriverTest extends TestCas
     protected $config;
     protected $io;
     protected $process;
-    protected $remoteFileSystem;
+    protected $httpDownloader;
     protected $testPath;
     protected $driver;
     protected $repoConfig;
@@ -43,9 +43,9 @@ class PerforceDriverTest extends TestCas
         $this->repoConfig = $this->getTestRepoConfig();
         $this->io = $this->getMockIOInterface();
         $this->process = $this->getMockProcessExecutor();
-        $this->remoteFileSystem = $this->getMockRemoteFilesystem();
+        $this->httpDownloader = $this->getMockHttpDownloader();
         $this->perforce = $this->getMockPerforce();
-        $this->driver = new PerforceDriver($this->repoConfig, $this->io, $this->config, $this->process, $this->remoteFileSystem);
+        $this->driver = new PerforceDriver($this->repoConfig, $this->io, $this->config, $this->httpDownloader, $this->process);
         $this->overrideDriverInternalPerforce($this->perforce);
     }
 
@@ -56,7 +56,7 @@ class PerforceDriverTest extends TestCas
         $fs->removeDirectory($this->testPath);
         $this->driver = null;
         $this->perforce = null;
-        $this->remoteFileSystem = null;
+        $this->httpDownloader = null;
         $this->process = null;
         $this->io = null;
         $this->repoConfig = null;
@@ -99,21 +99,21 @@ class PerforceDriverTest extends TestCas
         return $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
     }
 
-    protected function getMockRemoteFilesystem()
+    protected function getMockHttpDownloader()
     {
-        return $this->getMockBuilder('Composer\Util\RemoteFilesystem')->disableOriginalConstructor()->getMock();
+        return $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock();
     }
 
     protected function getMockPerforce()
     {
         $methods = array('p4login', 'checkStream', 'writeP4ClientSpec', 'connectClient', 'getComposerInformation', 'cleanupClientSpec');
 
-        return $this->getMockBuilder('Composer\Util\Perforce', $methods)->disableOriginalConstructor()->getMock();
+        return $this->getMockBuilder('Composer\Util\Perforce')->disableOriginalConstructor()->getMock();
     }
 
     public function testInitializeCapturesVariablesFromRepoConfig()
     {
-        $driver = new PerforceDriver($this->repoConfig, $this->io, $this->config, $this->process, $this->remoteFileSystem);
+        $driver = new PerforceDriver($this->repoConfig, $this->io, $this->config, $this->httpDownloader, $this->process);
         $driver->initialize();
         $this->assertEquals(self::TEST_URL, $driver->getUrl());
         $this->assertEquals(self::TEST_DEPOT, $driver->getDepot());
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/Vcs/SvnDriverTest.php 2.0.9-1/tests/Composer/Test/Repository/Vcs/SvnDriverTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/Vcs/SvnDriverTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/Vcs/SvnDriverTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,7 +16,6 @@ use Composer\Repository\Vcs\SvnDriver;
 use Composer\Config;
 use Composer\Test\TestCase;
 use Composer\Util\Filesystem;
-use Composer\Util\Platform;
 
 class SvnDriverTest extends TestCase
 {
@@ -40,12 +39,12 @@ class SvnDriverTest extends TestCase
         $fs->removeDirectory($this->home);
     }
 
-    /**
-     * @expectedException RuntimeException
-     */
     public function testWrongCredentialsInUrl()
     {
+        $this->setExpectedException('RuntimeException');
+
         $console = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
+        $httpDownloader = $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock();
 
         $output = "svn: OPTIONS of 'https://corp.svn.local/repo':";
         $output .= " authorization failed: Could not authenticate to server:";
@@ -66,7 +65,7 @@ class SvnDriverTest extends TestCase
             'url' => 'https://till:secret@corp.svn.local/repo',
         );
 
-        $svn = new SvnDriver($repoConfig, $console, $this->config, $process);
+        $svn = new SvnDriver($repoConfig, $console, $this->config, $httpDownloader, $process);
         $svn->initialize();
     }
 
diff -pruN 1.10.19-1/tests/Composer/Test/Repository/VcsRepositoryTest.php 2.0.9-1/tests/Composer/Test/Repository/VcsRepositoryTest.php
--- 1.10.19-1/tests/Composer/Test/Repository/VcsRepositoryTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Repository/VcsRepositoryTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -32,16 +32,17 @@ class VcsRepositoryTest extends TestCase
 
     protected function initialize()
     {
-        $oldCwd = getcwd();
-        self::$composerHome = $this->getUniqueTmpDirectory();
-        self::$gitRepo = $this->getUniqueTmpDirectory();
-
         $locator = new ExecutableFinder();
         if (!$locator->find('git')) {
             $this->skipped = 'This test needs a git binary in the PATH to be able to run';
 
             return;
         }
+
+        $oldCwd = getcwd();
+        self::$composerHome = $this->getUniqueTmpDirectory();
+        self::$gitRepo = $this->getUniqueTmpDirectory();
+
         if (!@chdir(self::$gitRepo)) {
             $this->skipped = 'Could not move into the temp git repo '.self::$gitRepo;
 
@@ -57,9 +58,11 @@ class VcsRepositoryTest extends TestCase
             }
         };
 
-        $exec('git init');
+        $exec('git init -q');
+        $exec('git checkout -b master');
         $exec('git config user.email composertest@example.org');
         $exec('git config user.name ComposerTest');
+        $exec('git config commit.gpgsign false');
         touch('foo');
         $exec('git add foo');
         $exec('git commit -m init');
@@ -142,6 +145,7 @@ class VcsRepositoryTest extends TestCase
             'dev-feature-b' => true,
             'dev-feature/a-1.0-B' => true,
             'dev-master' => true,
+            '9999999-dev' => true, // alias of dev-master
         );
 
         $config = new Config();
@@ -150,7 +154,8 @@ class VcsRepositoryTest extends TestCase
                 'home' => self::$composerHome,
             ),
         ));
-        $repo = new VcsRepository(array('url' => self::$gitRepo, 'type' => 'vcs'), new NullIO, $config);
+        $httpDownloader = $this->getMockBuilder('Composer\Util\HttpDownloader')->disableOriginalConstructor()->getMock();
+        $repo = new VcsRepository(array('url' => self::$gitRepo, 'type' => 'vcs'), new NullIO, $config, $httpDownloader);
         $packages = $repo->getPackages();
         $dumper = new ArrayDumper();
 
diff -pruN 1.10.19-1/tests/Composer/Test/TestCase.php 2.0.9-1/tests/Composer/Test/TestCase.php
--- 1.10.19-1/tests/Composer/Test/TestCase.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/TestCase.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,14 +13,16 @@
 namespace Composer\Test;
 
 use Composer\Semver\VersionParser;
-use Composer\Package\AliasPackage;
+use Composer\Package\RootPackageInterface;
+use Composer\Package\PackageInterface;
 use Composer\Semver\Constraint\Constraint;
 use Composer\Util\Filesystem;
 use Composer\Util\Silencer;
-use PHPUnit\Framework\TestCase as BaseTestCase;
 use Symfony\Component\Process\ExecutableFinder;
+use Composer\Package\Loader\ArrayLoader;
+use Composer\Package\BasePackage;
 
-abstract class TestCase extends BaseTestCase
+abstract class TestCase extends PolyfillTestCase
 {
     private static $parser;
     private static $executableCache = array();
@@ -73,7 +75,31 @@ abstract class TestCase extends BaseTest
     {
         $normVersion = self::getVersionParser()->normalize($version);
 
-        return new AliasPackage($package, $normVersion, $version);
+        $class = 'Composer\Package\AliasPackage';
+        if ($package instanceof RootPackageInterface) {
+            $class = 'Composer\Package\RootAliasPackage';
+        }
+
+        return new $class($package, $normVersion, $version);
+    }
+
+    protected function configureLinks(PackageInterface $package, array $config)
+    {
+        $arrayLoader = new ArrayLoader();
+
+        foreach (BasePackage::$supportedLinkTypes as $type => $opts) {
+            if (isset($config[$type])) {
+                $method = 'set'.ucfirst($opts['method']);
+                $package->{$method}(
+                    $arrayLoader->parseLinks(
+                        $package->getName(),
+                        $package->getPrettyVersion(),
+                        $opts['description'],
+                        $config[$type]
+                    )
+                );
+            }
+        }
     }
 
     protected static function ensureDirectoryExistsAndClear($directory)
diff -pruN 1.10.19-1/tests/Composer/Test/Util/AuthHelperTest.php 2.0.9-1/tests/Composer/Test/Util/AuthHelperTest.php
--- 1.10.19-1/tests/Composer/Test/Util/AuthHelperTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/AuthHelperTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,530 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Util;
+
+use Composer\IO\IOInterface;
+use Composer\Test\TestCase;
+use Composer\Util\AuthHelper;
+use Composer\Util\Bitbucket;
+
+/**
+ * @author Michael Chekin <mchekin@gmail.com>
+ */
+class AuthHelperTest extends TestCase
+{
+    /** @type \Composer\IO\IOInterface|\PHPUnit_Framework_MockObject_MockObject */
+    private $io;
+
+    /** @type \Composer\Config|\PHPUnit_Framework_MockObject_MockObject */
+    private $config;
+
+    /** @type AuthHelper */
+    private $authHelper;
+
+    protected function setUp()
+    {
+        $this->io = $this
+            ->getMockBuilder('Composer\IO\IOInterface')
+            ->disableOriginalConstructor()
+            ->getMock();
+
+        $this->config = $this->getMockBuilder('Composer\Config')->getMock();
+
+        $this->authHelper = new AuthHelper($this->io, $this->config);
+    }
+
+    public function testAddAuthenticationHeaderWithoutAuthCredentials()
+    {
+        $headers = array(
+            'Accept-Encoding: gzip',
+            'Connection: close',
+        );
+        $origin = 'http://example.org';
+        $url = 'file://' . __FILE__;
+
+        $this->io->expects($this->once())
+            ->method('hasAuthentication')
+            ->with($origin)
+            ->willReturn(false);
+
+        $this->assertSame(
+            $headers,
+            $this->authHelper->addAuthenticationHeader($headers, $origin, $url)
+        );
+    }
+
+    public function testAddAuthenticationHeaderWithBearerPassword()
+    {
+        $headers = array(
+            'Accept-Encoding: gzip',
+            'Connection: close',
+        );
+        $origin = 'http://example.org';
+        $url = 'file://' . __FILE__;
+        $auth = array(
+            'username' => 'my_username',
+            'password' => 'bearer',
+        );
+
+        $this->expectsAuthentication($origin, $auth);
+
+        $expectedHeaders = array_merge($headers, array('Authorization: Bearer ' . $auth['username']));
+
+        $this->assertSame(
+            $expectedHeaders,
+            $this->authHelper->addAuthenticationHeader($headers, $origin, $url)
+        );
+    }
+
+    public function testAddAuthenticationHeaderWithGithubToken()
+    {
+        $headers = array(
+            'Accept-Encoding: gzip',
+            'Connection: close',
+        );
+        $origin = 'github.com';
+        $url = 'https://api.github.com/';
+        $auth = array(
+            'username' => 'my_username',
+            'password' => 'x-oauth-basic',
+        );
+
+        $this->expectsAuthentication($origin, $auth);
+
+        $this->io->expects($this->once())
+            ->method('writeError')
+            ->with('Using GitHub token authentication', true, IOInterface::DEBUG);
+
+        $expectedHeaders = array_merge($headers, array('Authorization: token ' . $auth['username']));
+
+        $this->assertSame(
+            $expectedHeaders,
+            $this->authHelper->addAuthenticationHeader($headers, $origin, $url)
+        );
+    }
+
+    public function testAddAuthenticationHeaderWithGitlabOathToken()
+    {
+        $headers = array(
+            'Accept-Encoding: gzip',
+            'Connection: close',
+        );
+        $origin = 'gitlab.com';
+        $url = 'https://api.gitlab.com/';
+        $auth = array(
+            'username' => 'my_username',
+            'password' => 'oauth2',
+        );
+
+        $this->expectsAuthentication($origin, $auth);
+
+        $this->config->expects($this->once())
+            ->method('get')
+            ->with('gitlab-domains')
+            ->willReturn(array($origin));
+
+        $this->io->expects($this->once())
+            ->method('writeError')
+            ->with('Using GitLab OAuth token authentication', true, IOInterface::DEBUG);
+
+        $expectedHeaders = array_merge($headers, array('Authorization: Bearer ' . $auth['username']));
+
+        $this->assertSame(
+            $expectedHeaders,
+            $this->authHelper->addAuthenticationHeader($headers, $origin, $url)
+        );
+    }
+
+    public function gitlabPrivateTokenProvider()
+    {
+        return array(
+          array('private-token'),
+          array('gitlab-ci-token'),
+        );
+    }
+
+    /**
+     * @dataProvider gitlabPrivateTokenProvider
+     *
+     * @param string $password
+     */
+    public function testAddAuthenticationHeaderWithGitlabPrivateToken($password)
+    {
+        $headers = array(
+            'Accept-Encoding: gzip',
+            'Connection: close',
+        );
+        $origin = 'gitlab.com';
+        $url = 'https://api.gitlab.com/';
+        $auth = array(
+            'username' => 'my_username',
+            'password' => $password,
+        );
+
+        $this->expectsAuthentication($origin, $auth);
+
+        $this->config->expects($this->once())
+            ->method('get')
+            ->with('gitlab-domains')
+            ->willReturn(array($origin));
+
+        $this->io->expects($this->once())
+            ->method('writeError')
+            ->with('Using GitLab private token authentication', true, IOInterface::DEBUG);
+
+        $expectedHeaders = array_merge($headers, array('PRIVATE-TOKEN: ' . $auth['username']));
+
+        $this->assertSame(
+            $expectedHeaders,
+            $this->authHelper->addAuthenticationHeader($headers, $origin, $url)
+        );
+    }
+
+    public function testAddAuthenticationHeaderWithBitbucketOathToken()
+    {
+        $headers = array(
+            'Accept-Encoding: gzip',
+            'Connection: close',
+        );
+        $origin = 'bitbucket.org';
+        $url = 'https://bitbucket.org/site/oauth2/authorize';
+        $auth = array(
+            'username' => 'x-token-auth',
+            'password' => 'my_password',
+        );
+
+        $this->expectsAuthentication($origin, $auth);
+
+        $this->config->expects($this->once())
+            ->method('get')
+            ->with('gitlab-domains')
+            ->willReturn(array());
+
+        $this->io->expects($this->once())
+            ->method('writeError')
+            ->with('Using Bitbucket OAuth token authentication', true, IOInterface::DEBUG);
+
+        $expectedHeaders = array_merge($headers, array('Authorization: Bearer ' . $auth['password']));
+
+        $this->assertSame(
+            $expectedHeaders,
+            $this->authHelper->addAuthenticationHeader($headers, $origin, $url)
+        );
+    }
+
+    public function bitbucketPublicUrlProvider()
+    {
+        return array(
+            array('https://bitbucket.org/user/repo/downloads/whatever'),
+            array('https://bbuseruploads.s3.amazonaws.com/9421ee72-638e-43a9-82ea-39cfaae2bfaa/downloads/b87c59d9-54f3-4922-b711-d89059ec3bcf'),
+        );
+    }
+
+    /**
+     * @dataProvider bitbucketPublicUrlProvider
+     *
+     * @param string $url
+     */
+    public function testAddAuthenticationHeaderWithBitbucketPublicUrl($url)
+    {
+        $headers = array(
+            'Accept-Encoding: gzip',
+            'Connection: close',
+        );
+        $origin = 'bitbucket.org';
+        $auth = array(
+            'username' => 'x-token-auth',
+            'password' => 'my_password',
+        );
+
+        $this->expectsAuthentication($origin, $auth);
+
+        $this->config->expects($this->once())
+            ->method('get')
+            ->with('gitlab-domains')
+            ->willReturn(array());
+
+        $this->assertSame(
+            $headers,
+            $this->authHelper->addAuthenticationHeader($headers, $origin, $url)
+        );
+    }
+
+    public function basicHttpAuthenticationProvider()
+    {
+        return array(
+            array(
+                Bitbucket::OAUTH2_ACCESS_TOKEN_URL,
+                'bitbucket.org',
+                array(
+                    'username' => 'x-token-auth',
+                    'password' => 'my_password',
+                ),
+            ),
+            array(
+                'https://some-api.url.com',
+                'some-api.url.com',
+                array(
+                    'username' => 'my_username',
+                    'password' => 'my_password',
+                ),
+            ),
+            array(
+                'https://gitlab.com',
+                'gitlab.com',
+                array(
+                    'username' => 'my_username',
+                    'password' => 'my_password',
+                ),
+            ),
+        );
+    }
+
+    /**
+     * @dataProvider basicHttpAuthenticationProvider
+     *
+     * @param string $url
+     * @param string $origin
+     * @param array  $auth
+     */
+    public function testAddAuthenticationHeaderWithBasicHttpAuthentication($url, $origin, $auth)
+    {
+        $headers = array(
+            'Accept-Encoding: gzip',
+            'Connection: close',
+        );
+
+        $this->expectsAuthentication($origin, $auth);
+
+        $this->config->expects($this->once())
+            ->method('get')
+            ->with('gitlab-domains')
+            ->willReturn(array($origin));
+
+        $this->io->expects($this->once())
+            ->method('writeError')
+            ->with(
+                'Using HTTP basic authentication with username "' . $auth['username'] . '"',
+                true,
+                IOInterface::DEBUG
+            );
+
+        $expectedHeaders = array_merge(
+            $headers,
+            array('Authorization: Basic ' . base64_encode($auth['username'] . ':' . $auth['password']))
+        );
+
+        $this->assertSame(
+            $expectedHeaders,
+            $this->authHelper->addAuthenticationHeader($headers, $origin, $url)
+        );
+    }
+
+    /**
+     * @dataProvider bitbucketPublicUrlProvider
+     *
+     * @param string $url
+     */
+    public function testIsPublicBitBucketDownloadWithBitbucketPublicUrl($url)
+    {
+        $this->assertTrue($this->authHelper->isPublicBitBucketDownload($url));
+    }
+
+    public function testIsPublicBitBucketDownloadWithNonBitbucketPublicUrl()
+    {
+        $this->assertFalse(
+            $this->authHelper->isPublicBitBucketDownload(
+                'https://bitbucket.org/site/oauth2/authorize'
+            )
+        );
+    }
+
+    public function testStoreAuthAutomatically()
+    {
+        $origin = 'github.com';
+        $storeAuth = true;
+        $auth = array(
+            'username' => 'my_username',
+            'password' => 'my_password',
+        );
+
+        /** @var \Composer\Config\ConfigSourceInterface|\PHPUnit_Framework_MockObject_MockObject $configSource */
+        $configSource = $this
+            ->getMockBuilder('Composer\Config\ConfigSourceInterface')
+            ->disableOriginalConstructor()
+            ->getMock();
+
+        $this->config->expects($this->once())
+            ->method('getAuthConfigSource')
+            ->willReturn($configSource);
+
+        $this->io->expects($this->once())
+            ->method('getAuthentication')
+            ->with($origin)
+            ->willReturn($auth);
+
+        $configSource->expects($this->once())
+            ->method('addConfigSetting')
+            ->with('http-basic.'.$origin, $auth)
+            ->willReturn($configSource);
+
+        $this->authHelper->storeAuth($origin, $storeAuth);
+    }
+
+    public function testStoreAuthWithPromptYesAnswer()
+    {
+        $origin = 'github.com';
+        $storeAuth = 'prompt';
+        $auth = array(
+            'username' => 'my_username',
+            'password' => 'my_password',
+        );
+        $answer = 'y';
+        $configSourceName = 'https://api.gitlab.com/source';
+
+        /** @var \Composer\Config\ConfigSourceInterface|\PHPUnit_Framework_MockObject_MockObject $configSource */
+        $configSource = $this
+            ->getMockBuilder('Composer\Config\ConfigSourceInterface')
+            ->disableOriginalConstructor()
+            ->getMock();
+
+        $this->config->expects($this->once())
+            ->method('getAuthConfigSource')
+            ->willReturn($configSource);
+
+        $configSource->expects($this->once())
+            ->method('getName')
+            ->willReturn($configSourceName);
+
+        $this->io->expects($this->once())
+            ->method('askAndValidate')
+            ->with(
+                'Do you want to store credentials for '.$origin.' in '.$configSourceName.' ? [Yn] ',
+                $this->anything(),
+                null,
+                'y'
+            )
+            ->willReturnCallback(function ($question, $validator, $attempts, $default) use ($answer) {
+                $validator($answer);
+
+                return $answer;
+            });
+
+        $this->io->expects($this->once())
+            ->method('getAuthentication')
+            ->with($origin)
+            ->willReturn($auth);
+
+        $configSource->expects($this->once())
+            ->method('addConfigSetting')
+            ->with('http-basic.'.$origin, $auth)
+            ->willReturn($configSource);
+
+        $this->authHelper->storeAuth($origin, $storeAuth);
+    }
+
+    public function testStoreAuthWithPromptNoAnswer()
+    {
+        $origin = 'github.com';
+        $storeAuth = 'prompt';
+        $answer = 'n';
+        $configSourceName = 'https://api.gitlab.com/source';
+
+        /** @var \Composer\Config\ConfigSourceInterface|\PHPUnit_Framework_MockObject_MockObject $configSource */
+        $configSource = $this
+            ->getMockBuilder('Composer\Config\ConfigSourceInterface')
+            ->disableOriginalConstructor()
+            ->getMock();
+
+        $this->config->expects($this->once())
+            ->method('getAuthConfigSource')
+            ->willReturn($configSource);
+
+        $configSource->expects($this->once())
+            ->method('getName')
+            ->willReturn($configSourceName);
+
+        $this->io->expects($this->once())
+            ->method('askAndValidate')
+            ->with(
+                'Do you want to store credentials for '.$origin.' in '.$configSourceName.' ? [Yn] ',
+                $this->anything(),
+                null,
+                'y'
+            )
+            ->willReturnCallback(function ($question, $validator, $attempts, $default) use ($answer) {
+                $validator($answer);
+
+                return $answer;
+            });
+
+        $this->authHelper->storeAuth($origin, $storeAuth);
+    }
+
+    public function testStoreAuthWithPromptInvalidAnswer()
+    {
+        $this->setExpectedException('RuntimeException');
+
+        $origin = 'github.com';
+        $storeAuth = 'prompt';
+        $answer = 'invalid';
+        $configSourceName = 'https://api.gitlab.com/source';
+
+        /** @var \Composer\Config\ConfigSourceInterface|\PHPUnit_Framework_MockObject_MockObject $configSource */
+        $configSource = $this
+            ->getMockBuilder('Composer\Config\ConfigSourceInterface')
+            ->disableOriginalConstructor()
+            ->getMock();
+
+        $this->config->expects($this->once())
+            ->method('getAuthConfigSource')
+            ->willReturn($configSource);
+
+        $configSource->expects($this->once())
+            ->method('getName')
+            ->willReturn($configSourceName);
+
+        $this->io->expects($this->once())
+            ->method('askAndValidate')
+            ->with(
+                'Do you want to store credentials for '.$origin.' in '.$configSourceName.' ? [Yn] ',
+                $this->anything(),
+                null,
+                'y'
+            )
+            ->willReturnCallback(function ($question, $validator, $attempts, $default) use ($answer) {
+                $validator($answer);
+
+                return $answer;
+            });
+
+        $this->authHelper->storeAuth($origin, $storeAuth);
+    }
+
+    /**
+     * @param string $origin
+     * @param array  $auth
+     */
+    private function expectsAuthentication($origin, $auth)
+    {
+        $this->io->expects($this->once())
+            ->method('hasAuthentication')
+            ->with($origin)
+            ->willReturn(true);
+
+        $this->io->expects($this->once())
+            ->method('getAuthentication')
+            ->with($origin)
+            ->willReturn($auth);
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Util/BitbucketTest.php 2.0.9-1/tests/Composer/Test/Util/BitbucketTest.php
--- 1.10.19-1/tests/Composer/Test/Util/BitbucketTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/BitbucketTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -13,6 +13,7 @@
 namespace Composer\Test\Util;
 
 use Composer\Util\Bitbucket;
+use Composer\Util\Http\Response;
 use Composer\Test\TestCase;
 
 /**
@@ -30,8 +31,8 @@ class BitbucketTest extends TestCase
 
     /** @type \Composer\IO\ConsoleIO|\PHPUnit_Framework_MockObject_MockObject */
     private $io;
-    /** @type \Composer\Util\RemoteFilesystem|\PHPUnit_Framework_MockObject_MockObject */
-    private $rfs;
+    /** @type \Composer\Util\HttpDownloader|\PHPUnit_Framework_MockObject_MockObject */
+    private $httpDownloader;
     /** @type \Composer\Config|\PHPUnit_Framework_MockObject_MockObject */
     private $config;
     /** @type Bitbucket */
@@ -47,8 +48,8 @@ class BitbucketTest extends TestCase
             ->getMock()
         ;
 
-        $this->rfs = $this
-            ->getMockBuilder('Composer\Util\RemoteFilesystem')
+        $this->httpDownloader = $this
+            ->getMockBuilder('Composer\Util\HttpDownloader')
             ->disableOriginalConstructor()
             ->getMock()
         ;
@@ -57,7 +58,7 @@ class BitbucketTest extends TestCase
 
         $this->time = time();
 
-        $this->bitbucket = new Bitbucket($this->io, $this->config, null, $this->rfs, $this->time);
+        $this->bitbucket = new Bitbucket($this->io, $this->config, null, $this->httpDownloader, $this->time);
     }
 
     public function testRequestAccessTokenWithValidOAuthConsumer()
@@ -66,12 +67,10 @@ class BitbucketTest extends TestCase
             ->method('setAuthentication')
             ->with($this->origin, $this->consumer_key, $this->consumer_secret);
 
-        $this->rfs->expects($this->once())
-            ->method('getContents')
+        $this->httpDownloader->expects($this->once())
+            ->method('get')
             ->with(
-                $this->origin,
                 Bitbucket::OAUTH2_ACCESS_TOKEN_URL,
-                false,
                 array(
                     'retry-auth-failure' => false,
                     'http' => array(
@@ -81,9 +80,14 @@ class BitbucketTest extends TestCase
                 )
             )
             ->willReturn(
-                sprintf(
-                    '{"access_token": "%s", "scopes": "repository", "expires_in": 3600, "refresh_token": "refreshtoken", "token_type": "bearer"}',
-                    $this->token
+                new Response(
+                    array('url' => Bitbucket::OAUTH2_ACCESS_TOKEN_URL),
+                    200,
+                    array(),
+                    sprintf(
+                        '{"access_token": "%s", "scopes": "repository", "expires_in": 3600, "refresh_token": "refreshtoken", "token_type": "bearer"}',
+                        $this->token
+                    )
                 )
             );
 
@@ -120,6 +124,8 @@ class BitbucketTest extends TestCase
             $this->token,
             $this->bitbucket->requestToken($this->origin, $this->consumer_key, $this->consumer_secret)
         );
+
+        return $this->bitbucket;
     }
 
     public function testRequestAccessTokenWithValidOAuthConsumerAndExpiredAccessToken()
@@ -142,12 +148,10 @@ class BitbucketTest extends TestCase
             ->method('setAuthentication')
             ->with($this->origin, $this->consumer_key, $this->consumer_secret);
 
-        $this->rfs->expects($this->once())
-            ->method('getContents')
+        $this->httpDownloader->expects($this->once())
+            ->method('get')
             ->with(
-                $this->origin,
                 Bitbucket::OAUTH2_ACCESS_TOKEN_URL,
-                false,
                 array(
                     'retry-auth-failure' => false,
                     'http' => array(
@@ -157,9 +161,14 @@ class BitbucketTest extends TestCase
                 )
             )
             ->willReturn(
-                sprintf(
-                    '{"access_token": "%s", "scopes": "repository", "expires_in": 3600, "refresh_token": "refreshtoken", "token_type": "bearer"}',
-                    $this->token
+                new Response(
+                    array('url' => Bitbucket::OAUTH2_ACCESS_TOKEN_URL),
+                    200,
+                    array(),
+                    sprintf(
+                        '{"access_token": "%s", "scopes": "repository", "expires_in": 3600, "refresh_token": "refreshtoken", "token_type": "bearer"}',
+                        $this->token
+                    )
                 )
             );
 
@@ -186,12 +195,10 @@ class BitbucketTest extends TestCase
                 array('2. You are using an OAuth consumer, but didn\'t configure a (dummy) callback url')
             );
 
-        $this->rfs->expects($this->once())
-            ->method('getContents')
+        $this->httpDownloader->expects($this->once())
+            ->method('get')
             ->with(
-                $this->origin,
                 Bitbucket::OAUTH2_ACCESS_TOKEN_URL,
-                false,
                 array(
                     'retry-auth-failure' => false,
                     'http' => array(
@@ -218,6 +225,71 @@ class BitbucketTest extends TestCase
         $this->assertEquals('', $this->bitbucket->requestToken($this->origin, $this->username, $this->password));
     }
 
+    public function testRequestAccessTokenWithUsernameAndPasswordWithUnauthorizedResponse()
+    {
+        $this->config->expects($this->once())
+            ->method('get')
+            ->with('bitbucket-oauth')
+            ->willReturn(null);
+
+        $this->io->expects($this->once())
+            ->method('setAuthentication')
+            ->with($this->origin, $this->username, $this->password);
+
+        $this->io->expects($this->any())
+            ->method('writeError')
+            ->withConsecutive(
+                array('<error>Invalid OAuth consumer provided.</error>'),
+                array('You can also add it manually later by using "composer config --global --auth bitbucket-oauth.bitbucket.org <consumer-key> <consumer-secret>"')
+            );
+
+        $this->httpDownloader->expects($this->once())
+            ->method('get')
+            ->with(
+                Bitbucket::OAUTH2_ACCESS_TOKEN_URL,
+                array(
+                    'retry-auth-failure' => false,
+                    'http' => array(
+                        'method' => 'POST',
+                        'content' => 'grant_type=client_credentials',
+                    ),
+                )
+            )
+            ->willThrowException(new \Composer\Downloader\TransportException('HTTP/1.1 401 UNAUTHORIZED', 401));
+
+        $this->assertEquals('', $this->bitbucket->requestToken($this->origin, $this->username, $this->password));
+    }
+
+    public function testRequestAccessTokenWithUsernameAndPasswordWithNotFoundResponse()
+    {
+        $this->setExpectedException('Composer\Downloader\TransportException');
+        $this->config->expects($this->once())
+            ->method('get')
+            ->with('bitbucket-oauth')
+            ->willReturn(null);
+
+        $this->io->expects($this->once())
+            ->method('setAuthentication')
+            ->with($this->origin, $this->username, $this->password);
+
+        $exception = new \Composer\Downloader\TransportException('HTTP/1.1 404 NOT FOUND', 404);
+        $this->httpDownloader->expects($this->once())
+            ->method('get')
+            ->with(
+                Bitbucket::OAUTH2_ACCESS_TOKEN_URL,
+                array(
+                    'retry-auth-failure' => false,
+                    'http' => array(
+                        'method' => 'POST',
+                        'content' => 'grant_type=client_credentials',
+                    ),
+                )
+            )
+            ->willThrowException($exception);
+
+        $this->bitbucket->requestToken($this->origin, $this->username, $this->password);
+    }
+
     public function testUsernamePasswordAuthenticationFlow()
     {
         $this->io
@@ -234,19 +306,22 @@ class BitbucketTest extends TestCase
             )
             ->willReturnOnConsecutiveCalls($this->consumer_key, $this->consumer_secret);
 
-        $this->rfs
+        $this->httpDownloader
             ->expects($this->once())
-            ->method('getContents')
+            ->method('get')
             ->with(
-                $this->equalTo($this->origin),
-                $this->equalTo(sprintf('https://%s/site/oauth2/access_token', $this->origin)),
-                $this->isFalse(),
+                $this->equalTo($url = sprintf('https://%s/site/oauth2/access_token', $this->origin)),
                 $this->anything()
             )
             ->willReturn(
-                sprintf(
-                    '{"access_token": "%s", "scopes": "repository", "expires_in": 3600, "refresh_token": "refresh_token", "token_type": "bearer"}',
-                    $this->token
+                new Response(
+                    array('url' => $url),
+                    200,
+                    array(),
+                    sprintf(
+                        '{"access_token": "%s", "scopes": "repository", "expires_in": 3600, "refresh_token": "refresh_token", "token_type": "bearer"}',
+                        $this->token
+                    )
                 )
             )
         ;
@@ -256,6 +331,74 @@ class BitbucketTest extends TestCase
         $this->assertTrue($this->bitbucket->authorizeOAuthInteractively($this->origin, $this->message));
     }
 
+    public function testAuthorizeOAuthInteractivelyWithEmptyUsername()
+    {
+        $authConfigSourceMock = $this->getMockBuilder('Composer\Config\ConfigSourceInterface')->getMock();
+        $this->config->expects($this->atLeastOnce())
+            ->method('getAuthConfigSource')
+            ->willReturn($authConfigSourceMock);
+
+        $this->io->expects($this->once())
+            ->method('askAndHideAnswer')
+            ->with('Consumer Key (hidden): ')
+            ->willReturnOnConsecutiveCalls(null);
+
+        $this->assertFalse($this->bitbucket->authorizeOAuthInteractively($this->origin, $this->message));
+    }
+
+    public function testAuthorizeOAuthInteractivelyWithEmptyPassword()
+    {
+        $authConfigSourceMock = $this->getMockBuilder('Composer\Config\ConfigSourceInterface')->getMock();
+        $this->config->expects($this->atLeastOnce())
+            ->method('getAuthConfigSource')
+            ->willReturn($authConfigSourceMock);
+
+        $this->io->expects($this->exactly(2))
+            ->method('askAndHideAnswer')
+            ->withConsecutive(
+                array('Consumer Key (hidden): '),
+                array('Consumer Secret (hidden): ')
+            )
+            ->willReturnOnConsecutiveCalls($this->consumer_key, null);
+
+        $this->assertFalse($this->bitbucket->authorizeOAuthInteractively($this->origin, $this->message));
+    }
+
+    public function testAuthorizeOAuthInteractivelyWithRequestAccessTokenFailure()
+    {
+        $authConfigSourceMock = $this->getMockBuilder('Composer\Config\ConfigSourceInterface')->getMock();
+        $this->config->expects($this->atLeastOnce())
+            ->method('getAuthConfigSource')
+            ->willReturn($authConfigSourceMock);
+
+        $this->io->expects($this->exactly(2))
+            ->method('askAndHideAnswer')
+            ->withConsecutive(
+                array('Consumer Key (hidden): '),
+                array('Consumer Secret (hidden): ')
+            )
+            ->willReturnOnConsecutiveCalls($this->consumer_key, $this->consumer_secret);
+
+        $this->httpDownloader
+            ->expects($this->once())
+            ->method('get')
+            ->with(
+                $this->equalTo($url = sprintf('https://%s/site/oauth2/access_token', $this->origin)),
+                $this->anything()
+            )
+            ->willThrowException(
+                new \Composer\Downloader\TransportException(
+                    sprintf(
+                        'The \'%s\' URL could not be accessed: HTTP/1.1 400 BAD REQUEST',
+                        Bitbucket::OAUTH2_ACCESS_TOKEN_URL
+                    ),
+                    400
+                )
+            );
+
+        $this->assertFalse($this->bitbucket->authorizeOAuthInteractively($this->origin, $this->message));
+    }
+
     private function setExpectationsForStoringAccessToken($removeBasicAuth = false)
     {
         $configSourceMock = $this->getMockBuilder('Composer\Config\ConfigSourceInterface')->getMock();
@@ -290,4 +433,48 @@ class BitbucketTest extends TestCase
                 ->with('http-basic.' . $this->origin);
         }
     }
+
+    public function testGetTokenWithoutAccessToken()
+    {
+        $this->assertSame('', $this->bitbucket->getToken());
+    }
+
+    /**
+     * @depends testRequestAccessTokenWithValidOAuthConsumerAndValidStoredAccessToken
+     *
+     * @param Bitbucket $bitbucket
+     */
+    public function testGetTokenWithAccessToken(Bitbucket $bitbucket)
+    {
+        $this->assertSame($this->token, $bitbucket->getToken());
+    }
+
+    public function testAuthorizeOAuthWithWrongOriginUrl()
+    {
+        $this->assertFalse($this->bitbucket->authorizeOAuth('non-' . $this->origin));
+    }
+
+    public function testAuthorizeOAuthWithoutAvailableGitConfigToken()
+    {
+        $process = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
+        $process->expects($this->once())
+            ->method('execute')
+            ->willReturn(-1);
+
+        $bitbucket = new Bitbucket($this->io, $this->config, $process, $this->httpDownloader, $this->time);
+
+        $this->assertFalse($bitbucket->authorizeOAuth($this->origin));
+    }
+
+    public function testAuthorizeOAuthWithAvailableGitConfigToken()
+    {
+        $process = $this->getMockBuilder('Composer\Util\ProcessExecutor')->getMock();
+        $process->expects($this->once())
+            ->method('execute')
+            ->willReturn(0);
+
+        $bitbucket = new Bitbucket($this->io, $this->config, $process, $this->httpDownloader, $this->time);
+
+        $this->assertTrue($bitbucket->authorizeOAuth($this->origin));
+    }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Util/ErrorHandlerTest.php 2.0.9-1/tests/Composer/Test/Util/ErrorHandlerTest.php
--- 1.10.19-1/tests/Composer/Test/Util/ErrorHandlerTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/ErrorHandlerTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -35,7 +35,11 @@ class ErrorHandlerTest extends TestCase
      */
     public function testErrorHandlerCaptureNotice()
     {
-        $this->setExpectedException('\ErrorException', 'Undefined index: baz');
+        if (PHP_VERSION_ID >= 80000) {
+            $this->setExpectedException('\ErrorException', 'Undefined array key "baz"');
+        } else {
+            $this->setExpectedException('\ErrorException', 'Undefined index: baz');
+        }
 
         $array = array('foo' => 'bar');
         $array['baz'];
@@ -46,7 +50,11 @@ class ErrorHandlerTest extends TestCase
      */
     public function testErrorHandlerCaptureWarning()
     {
-        $this->setExpectedException('\ErrorException', 'array_merge');
+        if (PHP_VERSION_ID >= 80000) {
+            $this->setExpectedException('TypeError', 'array_merge');
+        } else {
+            $this->setExpectedException('ErrorException', 'array_merge');
+        }
 
         array_merge(array(), 'string');
     }
diff -pruN 1.10.19-1/tests/Composer/Test/Util/FilesystemTest.php 2.0.9-1/tests/Composer/Test/Util/FilesystemTest.php
--- 1.10.19-1/tests/Composer/Test/Util/FilesystemTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/FilesystemTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -168,7 +168,7 @@ class FilesystemTest extends TestCase
 
         $fs = new Filesystem;
         $this->assertTrue($fs->removeDirectoryPhp($this->workingDir));
-        $this->assertFileNotExists($this->workingDir . "/level1/level2/hello.txt");
+        $this->assertFileDoesNotExist($this->workingDir . "/level1/level2/hello.txt");
     }
 
     public function testFileSize()
@@ -247,7 +247,7 @@ class FilesystemTest extends TestCase
         $fs = new Filesystem();
         $result = $fs->unlink($symlinked);
         $this->assertTrue($result);
-        $this->assertFileNotExists($symlinked);
+        $this->assertFileDoesNotExist($symlinked);
     }
 
     /**
@@ -279,8 +279,8 @@ class FilesystemTest extends TestCase
 
         $result = $fs->removeDirectory($symlinkedTrailingSlash);
         $this->assertTrue($result);
-        $this->assertFileNotExists($symlinkedTrailingSlash);
-        $this->assertFileNotExists($symlinked);
+        $this->assertFileDoesNotExist($symlinkedTrailingSlash);
+        $this->assertFileDoesNotExist($symlinked);
     }
 
     public function testJunctions()
Binary files 1.10.19-1/tests/Composer/Test/Util/Fixtures/Tar/empty.tar.gz and 2.0.9-1/tests/Composer/Test/Util/Fixtures/Tar/empty.tar.gz differ
Binary files 1.10.19-1/tests/Composer/Test/Util/Fixtures/Tar/folder.tar.gz and 2.0.9-1/tests/Composer/Test/Util/Fixtures/Tar/folder.tar.gz differ
Binary files 1.10.19-1/tests/Composer/Test/Util/Fixtures/Tar/multiple.tar.gz and 2.0.9-1/tests/Composer/Test/Util/Fixtures/Tar/multiple.tar.gz differ
Binary files 1.10.19-1/tests/Composer/Test/Util/Fixtures/Tar/nojson.tar.gz and 2.0.9-1/tests/Composer/Test/Util/Fixtures/Tar/nojson.tar.gz differ
Binary files 1.10.19-1/tests/Composer/Test/Util/Fixtures/Tar/root.tar.gz and 2.0.9-1/tests/Composer/Test/Util/Fixtures/Tar/root.tar.gz differ
Binary files 1.10.19-1/tests/Composer/Test/Util/Fixtures/Tar/subfolders.tar.gz and 2.0.9-1/tests/Composer/Test/Util/Fixtures/Tar/subfolders.tar.gz differ
Binary files 1.10.19-1/tests/Composer/Test/Util/Fixtures/Zip/multiple.zip and 2.0.9-1/tests/Composer/Test/Util/Fixtures/Zip/multiple.zip differ
Binary files 1.10.19-1/tests/Composer/Test/Util/Fixtures/Zip/single-sub.zip and 2.0.9-1/tests/Composer/Test/Util/Fixtures/Zip/single-sub.zip differ
Binary files 1.10.19-1/tests/Composer/Test/Util/Fixtures/Zip/subfolders.zip and 2.0.9-1/tests/Composer/Test/Util/Fixtures/Zip/subfolders.zip differ
Binary files 1.10.19-1/tests/Composer/Test/Util/Fixtures/Zip/subfolder.zip and 2.0.9-1/tests/Composer/Test/Util/Fixtures/Zip/subfolder.zip differ
diff -pruN 1.10.19-1/tests/Composer/Test/Util/GitHubTest.php 2.0.9-1/tests/Composer/Test/Util/GitHubTest.php
--- 1.10.19-1/tests/Composer/Test/Util/GitHubTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/GitHubTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,6 +14,7 @@ namespace Composer\Test\Util;
 
 use Composer\Downloader\TransportException;
 use Composer\Util\GitHub;
+use Composer\Util\Http\Response;
 use Composer\Test\TestCase;
 use RecursiveArrayIterator;
 use RecursiveIteratorIterator;
@@ -42,17 +43,15 @@ class GitHubTest extends TestCase
             ->willReturn($this->password)
         ;
 
-        $rfs = $this->getRemoteFilesystemMock();
-        $rfs
+        $httpDownloader = $this->getHttpDownloaderMock();
+        $httpDownloader
             ->expects($this->once())
-            ->method('getContents')
+            ->method('get')
             ->with(
-                $this->equalTo($this->origin),
-                $this->equalTo(sprintf('https://api.%s/', $this->origin)),
-                $this->isFalse(),
+                $this->equalTo($url = sprintf('https://api.%s/', $this->origin)),
                 $this->anything()
             )
-            ->willReturn('{}')
+            ->willReturn(new Response(array('url' => $url), 200, array(), '{}'))
         ;
 
         $config = $this->getConfigMock();
@@ -67,7 +66,7 @@ class GitHubTest extends TestCase
             ->willReturn($this->getConfJsonMock())
         ;
 
-        $github = new GitHub($io, $config, null, $rfs);
+        $github = new GitHub($io, $config, null, $httpDownloader);
 
         $this->assertTrue($github->authorizeOAuthInteractively($this->origin, $this->message));
     }
@@ -82,10 +81,10 @@ class GitHubTest extends TestCase
             ->willReturn($this->password)
         ;
 
-        $rfs = $this->getRemoteFilesystemMock();
-        $rfs
+        $httpDownloader = $this->getHttpDownloaderMock();
+        $httpDownloader
             ->expects($this->exactly(1))
-            ->method('getContents')
+            ->method('get')
             ->will($this->throwException(new TransportException('', 401)))
         ;
 
@@ -96,7 +95,7 @@ class GitHubTest extends TestCase
             ->willReturn($this->getAuthJsonMock())
         ;
 
-        $github = new GitHub($io, $config, null, $rfs);
+        $github = new GitHub($io, $config, null, $httpDownloader);
 
         $this->assertFalse($github->authorizeOAuthInteractively($this->origin));
     }
@@ -117,15 +116,15 @@ class GitHubTest extends TestCase
         return $this->getMockBuilder('Composer\Config')->getMock();
     }
 
-    private function getRemoteFilesystemMock()
+    private function getHttpDownloaderMock()
     {
-        $rfs = $this
-            ->getMockBuilder('Composer\Util\RemoteFilesystem')
+        $httpDownloader = $this
+            ->getMockBuilder('Composer\Util\HttpDownloader')
             ->disableOriginalConstructor()
             ->getMock()
         ;
 
-        return $rfs;
+        return $httpDownloader;
     }
 
     private function getAuthJsonMock()
diff -pruN 1.10.19-1/tests/Composer/Test/Util/GitLabTest.php 2.0.9-1/tests/Composer/Test/Util/GitLabTest.php
--- 1.10.19-1/tests/Composer/Test/Util/GitLabTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/GitLabTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -14,6 +14,7 @@ namespace Composer\Test\Util;
 
 use Composer\Downloader\TransportException;
 use Composer\Util\GitLab;
+use Composer\Util\Http\Response;
 use Composer\Test\TestCase;
 
 /**
@@ -48,17 +49,15 @@ class GitLabTest extends TestCase
             ->willReturn($this->password)
         ;
 
-        $rfs = $this->getRemoteFilesystemMock();
-        $rfs
+        $httpDownloader = $this->getHttpDownloaderMock();
+        $httpDownloader
             ->expects($this->once())
-            ->method('getContents')
+            ->method('get')
             ->with(
-                $this->equalTo($this->origin),
-                $this->equalTo(sprintf('http://%s/oauth/token', $this->origin)),
-                $this->isFalse(),
+                $this->equalTo($url = sprintf('http://%s/oauth/token', $this->origin)),
                 $this->anything()
             )
-            ->willReturn(sprintf('{"access_token": "%s", "token_type": "bearer", "expires_in": 7200}', $this->token))
+            ->willReturn(new Response(array('url' => $url), 200, array(), sprintf('{"access_token": "%s", "token_type": "bearer", "expires_in": 7200}', $this->token)))
         ;
 
         $config = $this->getConfigMock();
@@ -68,17 +67,14 @@ class GitLabTest extends TestCase
             ->willReturn($this->getAuthJsonMock())
         ;
 
-        $gitLab = new GitLab($io, $config, null, $rfs);
+        $gitLab = new GitLab($io, $config, null, $httpDownloader);
 
         $this->assertTrue($gitLab->authorizeOAuthInteractively('http', $this->origin, $this->message));
     }
 
-    /**
-     * @expectedException \RuntimeException
-     * @expectedExceptionMessage Invalid GitLab credentials 5 times in a row, aborting.
-     */
     public function testUsernamePasswordFailure()
     {
+        $this->setExpectedException('RuntimeException', 'Invalid GitLab credentials 5 times in a row, aborting.');
         $io = $this->getIOMock();
         $io
             ->expects($this->exactly(5))
@@ -93,10 +89,10 @@ class GitLabTest extends TestCase
             ->willReturn($this->password)
         ;
 
-        $rfs = $this->getRemoteFilesystemMock();
-        $rfs
+        $httpDownloader = $this->getHttpDownloaderMock();
+        $httpDownloader
             ->expects($this->exactly(5))
-            ->method('getContents')
+            ->method('get')
             ->will($this->throwException(new TransportException('', 401)))
         ;
 
@@ -107,7 +103,7 @@ class GitLabTest extends TestCase
             ->willReturn($this->getAuthJsonMock())
         ;
 
-        $gitLab = new GitLab($io, $config, null, $rfs);
+        $gitLab = new GitLab($io, $config, null, $httpDownloader);
 
         $gitLab->authorizeOAuthInteractively('https', $this->origin);
     }
@@ -128,15 +124,15 @@ class GitLabTest extends TestCase
         return $this->getMockBuilder('Composer\Config')->getMock();
     }
 
-    private function getRemoteFilesystemMock()
+    private function getHttpDownloaderMock()
     {
-        $rfs = $this
-            ->getMockBuilder('Composer\Util\RemoteFilesystem')
+        $httpDownloader = $this
+            ->getMockBuilder('Composer\Util\HttpDownloader')
             ->disableOriginalConstructor()
             ->getMock()
         ;
 
-        return $rfs;
+        return $httpDownloader;
     }
 
     private function getAuthJsonMock()
diff -pruN 1.10.19-1/tests/Composer/Test/Util/GitTest.php 2.0.9-1/tests/Composer/Test/Util/GitTest.php
--- 1.10.19-1/tests/Composer/Test/Util/GitTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/GitTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -1,5 +1,15 @@
 <?php
 
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
 namespace Composer\Test\Util;
 
 use Composer\Config;
@@ -62,11 +72,10 @@ class GitTest extends TestCase
         );
     }
 
-    /**
-     * @expectedException \RuntimeException
-     */
     public function testRunCommandPrivateGitHubRepositoryNotInitialCloneNotInteractiveWithoutAuthentication()
     {
+        $this->setExpectedException('RuntimeException');
+
         $that = $this;
         $commandCallable = function ($url) use ($that) {
             $that->assertSame('https://github.com/acme/repo', $url);
diff -pruN 1.10.19-1/tests/Composer/Test/Util/Http/ProxyHelperTest.php 2.0.9-1/tests/Composer/Test/Util/Http/ProxyHelperTest.php
--- 1.10.19-1/tests/Composer/Test/Util/Http/ProxyHelperTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/Http/ProxyHelperTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,190 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Util\Http;
+
+use Composer\Util\Http\ProxyHelper;
+use Composer\Test\TestCase;
+
+class ProxyHelperTest extends TestCase
+{
+    protected function setUp()
+    {
+        unset(
+            $_SERVER['HTTP_PROXY'],
+            $_SERVER['http_proxy'],
+            $_SERVER['HTTPS_PROXY'],
+            $_SERVER['https_proxy'],
+            $_SERVER['NO_PROXY'],
+            $_SERVER['no_proxy'],
+            $_SERVER['CGI_HTTP_PROXY']
+        );
+    }
+
+    protected function tearDown()
+    {
+        unset(
+            $_SERVER['HTTP_PROXY'],
+            $_SERVER['http_proxy'],
+            $_SERVER['HTTPS_PROXY'],
+            $_SERVER['https_proxy'],
+            $_SERVER['NO_PROXY'],
+            $_SERVER['no_proxy'],
+            $_SERVER['CGI_HTTP_PROXY']
+        );
+    }
+
+    /**
+     * @dataProvider dataMalformed
+     */
+    public function testThrowsOnMalformedUrl($url)
+    {
+        $_SERVER['http_proxy'] = $url;
+
+        $this->setExpectedException('RuntimeException');
+        ProxyHelper::getProxyData();
+    }
+
+    public function dataMalformed()
+    {
+        return array(
+            'no-host' => array('localhost'),
+            'no-port' => array('scheme://localhost'),
+        );
+    }
+
+    /**
+     * @dataProvider dataFormatting
+     */
+    public function testUrlFormatting($url, $expected)
+    {
+        $_SERVER['http_proxy'] = $url;
+
+        list($httpProxy, $httpsProxy, $noProxy) = ProxyHelper::getProxyData();
+        $this->assertSame($expected, $httpProxy);
+    }
+
+    public function dataFormatting()
+    {
+        // url, expected
+        return array(
+            'lowercases-scheme' => array('HTTP://proxy.com:8888', 'http://proxy.com:8888'),
+            'adds-http-port' => array('http://proxy.com', 'http://proxy.com:80'),
+            'adds-https-port' => array('https://proxy.com', 'https://proxy.com:443'),
+        );
+    }
+
+    /**
+     * @dataProvider dataCaseOverrides
+     */
+    public function testLowercaseOverridesUppercase(array $server, $expected, $index)
+    {
+        $_SERVER = array_merge($_SERVER, $server);
+
+        $list = ProxyHelper::getProxyData();
+        $this->assertSame($expected, $list[$index]);
+    }
+
+    public function dataCaseOverrides()
+    {
+        // server, expected, list index
+        return array(
+            array(array('HTTP_PROXY' => 'http://upper.com', 'http_proxy' => 'http://lower.com'), 'http://lower.com:80', 0),
+            array(array('HTTPS_PROXY' => 'http://upper.com', 'https_proxy' => 'http://lower.com'), 'http://lower.com:80', 1),
+            array(array('NO_PROXY' => 'upper.com', 'no_proxy' => 'lower.com'), 'lower.com', 2),
+        );
+    }
+
+    /**
+     * @dataProvider dataCGIOverrides
+     */
+    public function testCGIUpperCaseOverridesHttp(array $server, $expected, $index)
+    {
+        $_SERVER = array_merge($_SERVER, $server);
+
+        $list = ProxyHelper::getProxyData();
+        $this->assertSame($expected, $list[$index]);
+    }
+
+    public function dataCGIOverrides()
+    {
+        // server, expected, list index
+        return array(
+            array(array('http_proxy' => 'http://http.com', 'CGI_HTTP_PROXY' => 'http://cgi.com'), 'http://cgi.com:80', 0),
+            array(array('http_proxy' => 'http://http.com', 'cgi_http_proxy' => 'http://cgi.com'), 'http://http.com:80', 0),
+        );
+    }
+
+    public function testNoHttpsProxyUsesHttpProxy()
+    {
+        $_SERVER['http_proxy'] = 'http://http.com';
+
+        list($httpProxy, $httpsProxy, $noProxy) = ProxyHelper::getProxyData();
+        $this->assertSame('http://http.com:80', $httpsProxy);
+    }
+
+    public function testNoHttpProxyDoesNotUseHttpsProxy()
+    {
+        $_SERVER['https_proxy'] = 'http://https.com';
+
+        list($httpProxy, $httpsProxy, $noProxy) = ProxyHelper::getProxyData();
+        $this->assertSame(null, $httpProxy);
+    }
+
+    /**
+     * @dataProvider dataContextOptions
+     */
+    public function testGetContextOptions($url, $expected)
+    {
+        $this->assertEquals($expected, ProxyHelper::getContextOptions($url));
+    }
+
+    public function dataContextOptions()
+    {
+        // url, expected
+        return array(
+            array('http://proxy.com', array('http' => array(
+                'proxy' => 'tcp://proxy.com:80',
+            ))),
+            array('https://proxy.com', array('http' => array(
+                'proxy' => 'ssl://proxy.com:443',
+            ))),
+            array('http://user:p%40ss@proxy.com', array('http' => array(
+                'proxy' => 'tcp://proxy.com:80',
+                'header' => 'Proxy-Authorization: Basic dXNlcjpwQHNz',
+            ))),
+        );
+    }
+
+    /**
+     * @dataProvider dataRequestFullUri
+     */
+    public function testSetRequestFullUri($requestUrl, $expected)
+    {
+        $options = array();
+        ProxyHelper::setRequestFullUri($requestUrl, $options);
+
+        $this->assertEquals($expected, $options);
+    }
+
+    public function dataRequestFullUri()
+    {
+        $options = array('http' => array('request_fulluri' => true));
+
+        // $requestUrl, expected
+        return array(
+            'http' => array('http://repo.org', $options),
+            'https' => array('https://repo.org', array()),
+            'no-scheme' => array('repo.org', array()),
+        );
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Util/Http/ProxyManagerTest.php 2.0.9-1/tests/Composer/Test/Util/Http/ProxyManagerTest.php
--- 1.10.19-1/tests/Composer/Test/Util/Http/ProxyManagerTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/Http/ProxyManagerTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,165 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Util\Http;
+
+use Composer\Util\Http\ProxyManager;
+use Composer\Test\TestCase;
+
+class ProxyManagerTest extends TestCase
+{
+    protected function setUp()
+    {
+        unset(
+            $_SERVER['HTTP_PROXY'],
+            $_SERVER['http_proxy'],
+            $_SERVER['HTTPS_PROXY'],
+            $_SERVER['https_proxy'],
+            $_SERVER['NO_PROXY'],
+            $_SERVER['no_proxy'],
+            $_SERVER['CGI_HTTP_PROXY']
+        );
+        ProxyManager::reset();
+    }
+
+    protected function tearDown()
+    {
+        unset(
+            $_SERVER['HTTP_PROXY'],
+            $_SERVER['http_proxy'],
+            $_SERVER['HTTPS_PROXY'],
+            $_SERVER['https_proxy'],
+            $_SERVER['NO_PROXY'],
+            $_SERVER['no_proxy'],
+            $_SERVER['CGI_HTTP_PROXY']
+        );
+        ProxyManager::reset();
+    }
+
+    public function testInstantiation()
+    {
+        $originalInstance = ProxyManager::getInstance();
+        $this->assertInstanceOf('Composer\Util\Http\ProxyManager', $originalInstance);
+
+        $sameInstance = ProxyManager::getInstance();
+        $this->assertTrue($originalInstance === $sameInstance);
+
+        ProxyManager::reset();
+        $newInstance = ProxyManager::getInstance();
+        $this->assertFalse($sameInstance === $newInstance);
+    }
+
+    public function testGetProxyForRequestThrowsOnBadProxyUrl()
+    {
+        $_SERVER['http_proxy'] = 'localhost';
+        $proxyManager = ProxyManager::getInstance();
+        $this->setExpectedException('Composer\Downloader\TransportException');
+        $proxyManager->getProxyForRequest('http://example.com');
+    }
+
+    /**
+     * @dataProvider dataRequest
+     */
+    public function testGetProxyForRequest($server, $url, $expectedUrl, $expectedOptions, $expectedSecure, $expectedMessage)
+    {
+        $_SERVER = array_merge($_SERVER, $server);
+        $proxyManager = ProxyManager::getInstance();
+
+        $proxy = $proxyManager->getProxyForRequest($url);
+        $this->assertInstanceOf('Composer\Util\Http\RequestProxy', $proxy);
+
+        $this->assertSame($expectedUrl, $proxy->getUrl());
+        $this->assertSame($expectedOptions, $proxy->getContextOptions());
+        $this->assertSame($expectedSecure, $proxy->isSecure());
+
+        $message = $proxy->getFormattedUrl();
+
+        if ($expectedMessage) {
+            $condition = stripos($message, $expectedMessage) !== false;
+        } else {
+            $condition = $expectedMessage === $message;
+        }
+
+        $this->assertTrue($condition, 'lastProxy check');
+    }
+
+    public function dataRequest()
+    {
+        $server = array(
+            'http_proxy' => 'http://user:p%40ss@proxy.com',
+            'https_proxy' => 'https://proxy.com:443',
+            'no_proxy' => 'other.repo.org',
+        );
+
+        // server, url, expectedUrl, expectedOptions, expectedSecure, expectedMessage
+        return array(
+            array(array(), 'http://repo.org', '', array(), false, ''),
+            array($server, 'http://repo.org', 'http://user:p%40ss@proxy.com:80',
+                array('http' => array(
+                    'proxy' => 'tcp://proxy.com:80',
+                    'header' => 'Proxy-Authorization: Basic dXNlcjpwQHNz',
+                    'request_fulluri' => true,
+                )),
+                false,
+                'http://user:***@proxy.com:80',
+            ),
+            array(
+                $server, 'https://repo.org', 'https://proxy.com:443',
+                array('http' => array(
+                    'proxy' => 'ssl://proxy.com:443',
+                )),
+                true,
+                'https://proxy.com:443',
+            ),
+            array($server, 'https://other.repo.org', '', array(), false, 'no_proxy'),
+        );
+    }
+
+    /**
+     * @dataProvider dataStatus
+     */
+    public function testGetStatus($server, $expectedStatus, $expectedMessage)
+    {
+        $_SERVER = array_merge($_SERVER, $server);
+        $proxyManager = ProxyManager::getInstance();
+        $status = $proxyManager->isProxying();
+        $message = $proxyManager->getFormattedProxy();
+
+        $this->assertSame($expectedStatus, $status);
+
+        if ($expectedMessage) {
+            $condition = stripos($message, $expectedMessage) !== false;
+        } else {
+            $condition = $expectedMessage === $message;
+        }
+        $this->assertTrue($condition, 'message check');
+    }
+
+    public function dataStatus()
+    {
+        // server, expectedStatus, expectedMessage
+        return array(
+            array(array(), false, null),
+            array(array('http_proxy' => 'localhost'), false, 'malformed'),
+            array(
+                array('http_proxy' => 'http://user:p%40ss@proxy.com:80'),
+                true,
+                'http=http://user:***@proxy.com:80',
+            ),
+            array(
+                array('http_proxy' => 'proxy.com:80', 'https_proxy' => 'proxy.com:80'),
+                true,
+                'http=proxy.com:80, https=proxy.com:80',
+            ),
+        );
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Util/Http/RequestProxyTest.php 2.0.9-1/tests/Composer/Test/Util/Http/RequestProxyTest.php
--- 1.10.19-1/tests/Composer/Test/Util/Http/RequestProxyTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/Http/RequestProxyTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,61 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Util\Http;
+
+use Composer\Util\Http\RequestProxy;
+use Composer\Test\TestCase;
+
+class RequestProxyTest extends TestCase
+{
+    /**
+     * @dataProvider dataSecure
+     */
+    public function testIsSecure($url, $expectedSecure)
+    {
+        $proxy = new RequestProxy($url, array(), '');
+
+        $this->assertSame($expectedSecure, $proxy->isSecure());
+    }
+
+    public function dataSecure()
+    {
+        // url, secure
+        return array(
+            'basic' => array('http://proxy.com:80', false),
+            'secure' => array('https://proxy.com:443', true),
+            'none' => array('', false),
+        );
+    }
+
+    /**
+     * @dataProvider dataProxyUrl
+     */
+    public function testGetFormattedUrlFormat($url, $format, $expected)
+    {
+        $proxy = new RequestProxy($url, array(), $url);
+
+        $message = $proxy->getFormattedUrl($format);
+        $this->assertSame($expected, $message);
+    }
+
+    public function dataProxyUrl()
+    {
+        $format = 'proxy (%s)';
+
+        // url, format, expected
+        return array(
+            array('', $format, ''),
+            array('http://proxy.com:80', $format, 'proxy (http://proxy.com:80)'),
+        );
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Util/HttpDownloaderTest.php 2.0.9-1/tests/Composer/Test/Util/HttpDownloaderTest.php
--- 1.10.19-1/tests/Composer/Test/Util/HttpDownloaderTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/HttpDownloaderTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,51 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Util;
+
+use Composer\Util\HttpDownloader;
+use PHPUnit\Framework\TestCase;
+
+class HttpDownloaderTest extends TestCase
+{
+    private function getConfigMock()
+    {
+        $config = $this->getMockBuilder('Composer\Config')->getMock();
+        $config->expects($this->any())
+            ->method('get')
+            ->will($this->returnCallback(function ($key) {
+                if ($key === 'github-domains' || $key === 'gitlab-domains') {
+                    return array();
+                }
+            }));
+
+        return $config;
+    }
+
+    /**
+     * @group slow
+     */
+    public function testCaptureAuthenticationParamsFromUrl()
+    {
+        $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
+        $io->expects($this->once())
+            ->method('setAuthentication')
+            ->with($this->equalTo('github.com'), $this->equalTo('user'), $this->equalTo('pass'));
+
+        $fs = new HttpDownloader($io, $this->getConfigMock());
+        try {
+            $fs->get('https://user:pass@github.com/composer/composer/404');
+        } catch (\Composer\Downloader\TransportException $e) {
+            $this->assertNotEquals(200, $e->getCode());
+        }
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Util/IniHelperTest.php 2.0.9-1/tests/Composer/Test/Util/IniHelperTest.php
--- 1.10.19-1/tests/Composer/Test/Util/IniHelperTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/IniHelperTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -30,7 +30,7 @@ class IniHelperTest extends TestCase
         );
 
         $this->setEnv($paths);
-        $this->assertContains('does not exist', IniHelper::getMessage());
+        $this->assertStringContainsString('does not exist', IniHelper::getMessage());
         $this->assertEquals($paths, IniHelper::getAll());
     }
 
@@ -41,7 +41,7 @@ class IniHelperTest extends TestCase
         );
 
         $this->setEnv($paths);
-        $this->assertContains('loaded.ini', IniHelper::getMessage());
+        $this->assertStringContainsString('loaded.ini', IniHelper::getMessage());
     }
 
     public function testWithLoadedIniAndAdditional()
@@ -53,7 +53,7 @@ class IniHelperTest extends TestCase
         );
 
         $this->setEnv($paths);
-        $this->assertContains('multiple ini files', IniHelper::getMessage());
+        $this->assertStringContainsString('multiple ini files', IniHelper::getMessage());
         $this->assertEquals($paths, IniHelper::getAll());
     }
 
@@ -66,7 +66,7 @@ class IniHelperTest extends TestCase
         );
 
         $this->setEnv($paths);
-        $this->assertContains('multiple ini files', IniHelper::getMessage());
+        $this->assertStringContainsString('multiple ini files', IniHelper::getMessage());
         $this->assertEquals($paths, IniHelper::getAll());
     }
 
diff -pruN 1.10.19-1/tests/Composer/Test/Util/MetadataMinifierTest.php 2.0.9-1/tests/Composer/Test/Util/MetadataMinifierTest.php
--- 1.10.19-1/tests/Composer/Test/Util/MetadataMinifierTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/MetadataMinifierTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,45 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Util;
+
+use Composer\Util\MetadataMinifier;
+use Composer\Package\CompletePackage;
+use Composer\Package\Dumper\ArrayDumper;
+use PHPUnit\Framework\TestCase;
+
+class MetadataMinifierTest extends TestCase
+{
+    public function testMinifyExpand()
+    {
+        $package1 = new CompletePackage('foo/bar', '2.0.0.0', '2.0.0');
+        $package1->setScripts(array('foo' => 'bar'));
+        $package1->setLicense(array('MIT'));
+        $package2 = new CompletePackage('foo/bar', '1.2.0.0', '1.2.0');
+        $package2->setLicense(array('GPL'));
+        $package2->setHomepage('https://example.org');
+        $package3 = new CompletePackage('foo/bar', '1.0.0.0', '1.0.0');
+        $package3->setLicense(array('GPL'));
+        $dumper = new ArrayDumper();
+
+        $minified = array(
+            array('name' => 'foo/bar', 'version' => '2.0.0', 'version_normalized' => '2.0.0.0', 'type' => 'library', 'scripts' => array('foo' => 'bar'), 'license' => array('MIT')),
+            array('version' => '1.2.0', 'version_normalized' => '1.2.0.0', 'license' => array('GPL'), 'homepage' => 'https://example.org', 'scripts' => '__unset'),
+            array('version' => '1.0.0', 'version_normalized' => '1.0.0.0', 'homepage' => '__unset'),
+        );
+
+        $source = array($dumper->dump($package1), $dumper->dump($package2), $dumper->dump($package3));
+
+        $this->assertSame($minified, MetadataMinifier::minify($source));
+        $this->assertSame($source, MetadataMinifier::expand($minified));
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Util/PackageSorterTest.php 2.0.9-1/tests/Composer/Test/Util/PackageSorterTest.php
--- 1.10.19-1/tests/Composer/Test/Util/PackageSorterTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/PackageSorterTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,132 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Util;
+
+use Composer\Package\Link;
+use Composer\Package\Package;
+use Composer\Test\TestCase;
+use Composer\Util\PackageSorter;
+use Composer\Semver\Constraint\MatchAllConstraint;
+
+class PackageSorterTest extends TestCase
+{
+    public function testSortingDoesNothingWithNoDependencies()
+    {
+        $packages[] = $this->createPackage('foo/bar1', array());
+        $packages[] = $this->createPackage('foo/bar2', array());
+        $packages[] = $this->createPackage('foo/bar3', array());
+        $packages[] = $this->createPackage('foo/bar4', array());
+
+        $sortedPackages = PackageSorter::sortPackages($packages);
+
+        self::assertSame($packages, $sortedPackages);
+    }
+
+    public function sortingOrdersDependenciesHigherThanPackageDataProvider()
+    {
+        return array(
+            'one package is dep' => array(
+                array(
+                    $this->createPackage('foo/bar1', array('foo/bar4')),
+                    $this->createPackage('foo/bar2', array('foo/bar4')),
+                    $this->createPackage('foo/bar3', array('foo/bar4')),
+                    $this->createPackage('foo/bar4', array()),
+                ),
+                array(
+                    'foo/bar4',
+                    'foo/bar1',
+                    'foo/bar2',
+                    'foo/bar3',
+                ),
+            ),
+            'one package has more deps' => array(
+                array(
+                    $this->createPackage('foo/bar1', array('foo/bar2')),
+                    $this->createPackage('foo/bar2', array('foo/bar4')),
+                    $this->createPackage('foo/bar3', array('foo/bar4')),
+                    $this->createPackage('foo/bar4', array()),
+                ),
+                array(
+                    'foo/bar4',
+                    'foo/bar2',
+                    'foo/bar1',
+                    'foo/bar3',
+                ),
+            ),
+            'package is required by many, but requires one other' => array(
+                array(
+                    $this->createPackage('foo/bar1', array('foo/bar3')),
+                    $this->createPackage('foo/bar2', array('foo/bar3')),
+                    $this->createPackage('foo/bar3', array('foo/bar4')),
+                    $this->createPackage('foo/bar4', array()),
+                    $this->createPackage('foo/bar5', array('foo/bar3')),
+                    $this->createPackage('foo/bar6', array('foo/bar3')),
+                ),
+                array(
+                    'foo/bar4',
+                    'foo/bar3',
+                    'foo/bar1',
+                    'foo/bar2',
+                    'foo/bar5',
+                    'foo/bar6',
+                ),
+            ),
+            'one package has many requires' => array(
+                array(
+                    $this->createPackage('foo/bar1', array('foo/bar2')),
+                    $this->createPackage('foo/bar2', array()),
+                    $this->createPackage('foo/bar3', array('foo/bar4')),
+                    $this->createPackage('foo/bar4', array()),
+                    $this->createPackage('foo/bar5', array('foo/bar2')),
+                    $this->createPackage('foo/bar6', array('foo/bar2')),
+                ),
+                array(
+                    'foo/bar2',
+                    'foo/bar4',
+                    'foo/bar1',
+                    'foo/bar3',
+                    'foo/bar5',
+                    'foo/bar6',
+                ),
+            ),
+        );
+    }
+
+    /**
+     * @dataProvider sortingOrdersDependenciesHigherThanPackageDataProvider
+     * @param array $packages
+     * @param array $expectedOrderedList
+     */
+    public function testSortingOrdersDependenciesHigherThanPackage($packages, $expectedOrderedList)
+    {
+        $sortedPackages = PackageSorter::sortPackages($packages);
+        $sortedPackageNames = array_map(function ($package) {
+            return $package->getName();
+        }, $sortedPackages);
+
+        self::assertSame($expectedOrderedList, $sortedPackageNames);
+    }
+
+    private function createPackage($name, $requires)
+    {
+        $package = new Package($name, '1.0.0.0', '1.0.0');
+
+        $links = array();
+        foreach ($requires as $requireName) {
+            $links[] = new Link($package->getName(), $requireName, new MatchAllConstraint);
+        }
+        $package->setRequires($links);
+
+        return $package;
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Util/ProcessExecutorTest.php 2.0.9-1/tests/Composer/Test/Util/ProcessExecutorTest.php
--- 1.10.19-1/tests/Composer/Test/Util/ProcessExecutorTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/ProcessExecutorTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -16,6 +16,7 @@ use Composer\IO\ConsoleIO;
 use Composer\Util\ProcessExecutor;
 use Composer\Test\TestCase;
 use Composer\IO\BufferIO;
+use React\Promise\Promise;
 use Symfony\Component\Console\Helper\HelperSet;
 use Symfony\Component\Console\Input\ArrayInput;
 use Symfony\Component\Console\Output\BufferedOutput;
@@ -44,7 +45,7 @@ class ProcessExecutorTest extends TestCa
     {
         $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
         $io->expects($this->once())
-            ->method('write')
+            ->method('writeRaw')
             ->with($this->equalTo('foo'.PHP_EOL), false);
 
         $process = new ProcessExecutor($io);
@@ -113,4 +114,18 @@ class ProcessExecutorTest extends TestCa
         $process->execute('php -r "echo \'<error>foo</error>\'.PHP_EOL;"');
         $this->assertSame('<error>foo</error>'.PHP_EOL, $output->fetch());
     }
+
+    public function testExecuteAsyncCancel()
+    {
+        $process = new ProcessExecutor($buffer = new BufferIO('', StreamOutput::VERBOSITY_DEBUG));
+        $process->enableAsync();
+        $start = microtime(true);
+        /** @var Promise $promise */
+        $promise = $process->executeAsync('sleep 2');
+        $this->assertEquals(1, $process->countActiveJobs());
+        $promise->cancel();
+        $this->assertEquals(0, $process->countActiveJobs());
+        $end = microtime(true);
+        $this->assertTrue($end - $start < 0.5, 'Canceling took longer than it should, lasted '.($end - $start));
+    }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Util/RemoteFilesystemTest.php 2.0.9-1/tests/Composer/Test/Util/RemoteFilesystemTest.php
--- 1.10.19-1/tests/Composer/Test/Util/RemoteFilesystemTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/RemoteFilesystemTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,18 +12,25 @@
 
 namespace Composer\Test\Util;
 
+use Composer\Config;
+use Composer\IO\ConsoleIO;
+use Composer\IO\IOInterface;
+use Composer\Util\AuthHelper;
 use Composer\Util\RemoteFilesystem;
 use Composer\Test\TestCase;
+use PHPUnit\Framework\MockObject\MockObject;
+use ReflectionMethod;
+use ReflectionProperty;
 
 class RemoteFilesystemTest extends TestCase
 {
     public function testGetOptionsForUrl()
     {
-        $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
+        $io = $this->getIOInterfaceMock();
         $io
             ->expects($this->once())
             ->method('hasAuthentication')
-            ->will($this->returnValue(false))
+            ->willReturn(false)
         ;
 
         $res = $this->callGetOptionsForUrl($io, array('http://example.org', array()));
@@ -32,16 +39,16 @@ class RemoteFilesystemTest extends TestC
 
     public function testGetOptionsForUrlWithAuthorization()
     {
-        $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
+        $io = $this->getIOInterfaceMock();
         $io
             ->expects($this->once())
             ->method('hasAuthentication')
-            ->will($this->returnValue(true))
+            ->willReturn(true)
         ;
         $io
             ->expects($this->once())
             ->method('getAuthentication')
-            ->will($this->returnValue(array('username' => 'login', 'password' => 'password')))
+            ->willReturn(array('username' => 'login', 'password' => 'password'))
         ;
 
         $options = $this->callGetOptionsForUrl($io, array('http://example.org', array()));
@@ -57,17 +64,17 @@ class RemoteFilesystemTest extends TestC
 
     public function testGetOptionsForUrlWithStreamOptions()
     {
-        $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
+        $io = $this->getIOInterfaceMock();
         $io
             ->expects($this->once())
             ->method('hasAuthentication')
-            ->will($this->returnValue(true))
+            ->willReturn(true)
         ;
 
         $io
             ->expects($this->once())
             ->method('getAuthentication')
-            ->will($this->returnValue(array('username' => null, 'password' => null)))
+            ->willReturn(array('username' => null, 'password' => null))
         ;
 
         $streamOptions = array('ssl' => array(
@@ -75,22 +82,25 @@ class RemoteFilesystemTest extends TestC
         ));
 
         $res = $this->callGetOptionsForUrl($io, array('https://example.org', array()), $streamOptions);
-        $this->assertTrue(isset($res['ssl']) && isset($res['ssl']['allow_self_signed']) && true === $res['ssl']['allow_self_signed'], 'getOptions must return an array with a allow_self_signed set to true');
+        $this->assertTrue(
+            isset($res['ssl'], $res['ssl']['allow_self_signed']) && true === $res['ssl']['allow_self_signed'],
+            'getOptions must return an array with a allow_self_signed set to true'
+        );
     }
 
     public function testGetOptionsForUrlWithCallOptionsKeepsHeader()
     {
-        $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
+        $io = $this->getIOInterfaceMock();
         $io
             ->expects($this->once())
             ->method('hasAuthentication')
-            ->will($this->returnValue(true))
+            ->willReturn(true)
         ;
 
         $io
             ->expects($this->once())
             ->method('getAuthentication')
-            ->will($this->returnValue(array('username' => null, 'password' => null)))
+            ->willReturn(array('username' => null, 'password' => null))
         ;
 
         $streamOptions = array('http' => array(
@@ -113,68 +123,118 @@ class RemoteFilesystemTest extends TestC
 
     public function testCallbackGetFileSize()
     {
-        $fs = new RemoteFilesystem($this->getMockBuilder('Composer\IO\IOInterface')->getMock());
+        $fs = new RemoteFilesystem($this->getIOInterfaceMock(), $this->getConfigMock());
         $this->callCallbackGet($fs, STREAM_NOTIFY_FILE_SIZE_IS, 0, '', 0, 0, 20);
-        $this->assertAttributeEquals(20, 'bytesMax', $fs);
+        $this->assertAttributeEqualsCustom(20, 'bytesMax', $fs);
     }
 
     public function testCallbackGetNotifyProgress()
     {
-        $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
+        $io = $this->getIOInterfaceMock();
         $io
             ->expects($this->once())
             ->method('overwriteError')
         ;
 
-        $fs = new RemoteFilesystem($io);
+        $fs = new RemoteFilesystem($io, $this->getConfigMock());
         $this->setAttribute($fs, 'bytesMax', 20);
         $this->setAttribute($fs, 'progress', true);
 
         $this->callCallbackGet($fs, STREAM_NOTIFY_PROGRESS, 0, '', 0, 10, 20);
-        $this->assertAttributeEquals(50, 'lastProgress', $fs);
+        $this->assertAttributeEqualsCustom(50.0, 'lastProgress', $fs);
     }
 
     public function testCallbackGetPassesThrough404()
     {
-        $fs = new RemoteFilesystem($this->getMockBuilder('Composer\IO\IOInterface')->getMock());
+        $fs = new RemoteFilesystem($this->getIOInterfaceMock(), $this->getConfigMock());
 
         $this->assertNull($this->callCallbackGet($fs, STREAM_NOTIFY_FAILURE, 0, 'HTTP/1.1 404 Not Found', 404, 0, 0));
     }
 
-    /**
-     * @group slow
-     */
-    public function testCaptureAuthenticationParamsFromUrl()
-    {
-        $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
-        $io->expects($this->once())
-            ->method('setAuthentication')
-            ->with($this->equalTo('github.com'), $this->equalTo('user'), $this->equalTo('pass'));
-
-        $fs = new RemoteFilesystem($io);
-        try {
-            $fs->getContents('github.com', 'https://user:pass@github.com/composer/composer/404');
-        } catch (\Exception $e) {
-            $this->assertInstanceOf('Composer\Downloader\TransportException', $e);
-            $this->assertNotEquals(200, $e->getCode());
-        }
-    }
-
     public function testGetContents()
     {
-        $fs = new RemoteFilesystem($this->getMockBuilder('Composer\IO\IOInterface')->getMock());
+        $fs = new RemoteFilesystem($this->getIOInterfaceMock(), $this->getConfigMock());
 
-        $this->assertContains('testGetContents', $fs->getContents('http://example.org', 'file://'.__FILE__));
+        $this->assertStringContainsString('testGetContents', $fs->getContents('http://example.org', 'file://'.__FILE__));
     }
 
     public function testCopy()
     {
-        $fs = new RemoteFilesystem($this->getMockBuilder('Composer\IO\IOInterface')->getMock());
+        $fs = new RemoteFilesystem($this->getIOInterfaceMock(), $this->getConfigMock());
 
         $file = tempnam(sys_get_temp_dir(), 'c');
         $this->assertTrue($fs->copy('http://example.org', 'file://'.__FILE__, $file));
         $this->assertFileExists($file);
-        $this->assertContains('testCopy', file_get_contents($file));
+        $this->assertStringContainsString('testCopy', file_get_contents($file));
+        unlink($file);
+    }
+
+    public function testCopyWithNoRetryOnFailure()
+    {
+        $this->setExpectedException('Composer\Downloader\TransportException');
+        $fs = $this->getRemoteFilesystemWithMockedMethods(array('getRemoteContents'));
+
+        $fs->expects($this->once())->method('getRemoteContents')
+            ->willReturnCallback(function ($originUrl, $fileUrl, $ctx, &$http_response_header) {
+                $http_response_header = array('http/1.1 401 unauthorized');
+
+                return '';
+            });
+
+        $file = tempnam(sys_get_temp_dir(), 'z');
+        unlink($file);
+
+        $fs->copy(
+            'http://example.org',
+            'file://' . __FILE__,
+            $file,
+            true,
+            array('retry-auth-failure' => false)
+        );
+    }
+
+    public function testCopyWithSuccessOnRetry()
+    {
+        $authHelper = $this->getAuthHelperWithMockedMethods(array('promptAuthIfNeeded'));
+        $fs = $this->getRemoteFilesystemWithMockedMethods(array('getRemoteContents'), $authHelper);
+
+        $authHelper->expects($this->once())
+            ->method('promptAuthIfNeeded')
+            ->willReturn(array(
+                'storeAuth' => true,
+                'retry' => true,
+            ));
+
+        $fs->expects($this->at(0))
+            ->method('getRemoteContents')
+            ->willReturnCallback(function ($originUrl, $fileUrl, $ctx, &$http_response_header) {
+                $http_response_header = array('http/1.1 401 unauthorized');
+
+                return '';
+            });
+
+        $fs->expects($this->at(1))
+            ->method('getRemoteContents')
+            ->willReturnCallback(function ($originUrl, $fileUrl, $ctx, &$http_response_header) {
+                $http_response_header = array('http/1.1 200 OK');
+
+                return '<?php $copied = "Copied"; ';
+            });
+
+        $file = tempnam(sys_get_temp_dir(), 'z');
+
+        $copyResult = $fs->copy(
+            'http://example.org',
+            'file://' . __FILE__,
+            $file,
+            true,
+            array('retry-auth-failure' => true)
+        );
+
+        $this->assertTrue($copyResult);
+        $this->assertFileExists($file);
+        $this->assertStringContainsString('Copied', file_get_contents($file));
+
         unlink($file);
     }
 
@@ -183,12 +243,12 @@ class RemoteFilesystemTest extends TestC
      */
     public function testGetOptionsForUrlCreatesSecureTlsDefaults()
     {
-        $io = $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
+        $io = $this->getIOInterfaceMock();
 
         $res = $this->callGetOptionsForUrl($io, array('example.org', array('ssl' => array('cafile' => '/some/path/file.crt'))), array(), 'http://www.example.org');
 
         $this->assertTrue(isset($res['ssl']['ciphers']));
-        $this->assertRegExp("|!aNULL:!eNULL:!EXPORT:!DES:!RC4:!MD5:!PSK:!aECDH:!EDH-DSS-DES-CBC3-SHA:!EDH-RSA-DES-CBC3-SHA:!KRB5-DES-CBC3-SHA|", $res['ssl']['ciphers']);
+        $this->assertMatchesRegularExpression('|!aNULL:!eNULL:!EXPORT:!DES:!RC4:!MD5:!PSK:!aECDH:!EDH-DSS-DES-CBC3-SHA:!EDH-RSA-DES-CBC3-SHA:!KRB5-DES-CBC3-SHA|', $res['ssl']['ciphers']);
         $this->assertTrue($res['ssl']['verify_peer']);
         $this->assertTrue($res['ssl']['SNI_enabled']);
         $this->assertEquals(7, $res['ssl']['verify_depth']);
@@ -225,12 +285,13 @@ class RemoteFilesystemTest extends TestC
      */
     public function testBitBucketPublicDownload($url, $contents)
     {
+        /** @var ConsoleIO $io */
         $io = $this
             ->getMockBuilder('Composer\IO\ConsoleIO')
             ->disableOriginalConstructor()
             ->getMock();
 
-        $rfs = new RemoteFilesystem($io);
+        $rfs = new RemoteFilesystem($io, $this->getConfigMock());
         $hostname = parse_url($url, PHP_URL_HOST);
 
         $result = $rfs->getContents($hostname, $url, false);
@@ -247,28 +308,20 @@ class RemoteFilesystemTest extends TestC
      */
     public function testBitBucketPublicDownloadWithAuthConfigured($url, $contents)
     {
+        /** @var MockObject|ConsoleIO $io */
         $io = $this
             ->getMockBuilder('Composer\IO\ConsoleIO')
             ->disableOriginalConstructor()
             ->getMock();
 
-        $config = $this
-            ->getMockBuilder('Composer\Config')
-            ->getMock();
-        $config
-            ->method('get')
-            ->withAnyParameters()
-            ->willReturn(array());
-
         $domains = array();
         $io
-            ->expects($this->any())
             ->method('hasAuthentication')
-            ->will($this->returnCallback(function ($arg) use (&$domains) {
+            ->willReturnCallback(function ($arg) use (&$domains) {
                 $domains[] = $arg;
                 // first time is called with bitbucket.org, then it redirects to bbuseruploads.s3.amazonaws.com so next time we have no auth configured
                 return $arg === 'bitbucket.org';
-            }));
+            });
         $io
             ->expects($this->at(1))
             ->method('getAuthentication')
@@ -279,7 +332,7 @@ class RemoteFilesystemTest extends TestC
                 'password' => '1A0yeK5Po3ZEeiiRiMWLivS0jirLdoGuaSGq9NvESFx1Fsdn493wUDXC8rz_1iKVRTl1GINHEUCsDxGh5lZ=',
             ));
 
-        $rfs = new RemoteFilesystem($io, $config);
+        $rfs = new RemoteFilesystem($io, $this->getConfigMock());
         $hostname = parse_url($url, PHP_URL_HOST);
 
         $result = $rfs->getContents($hostname, $url, false);
@@ -288,11 +341,11 @@ class RemoteFilesystemTest extends TestC
         $this->assertEquals(array('bitbucket.org', 'bbuseruploads.s3.amazonaws.com'), $domains);
     }
 
-    protected function callGetOptionsForUrl($io, array $args = array(), array $options = array(), $fileUrl = '')
+    private function callGetOptionsForUrl($io, array $args = array(), array $options = array(), $fileUrl = '')
     {
-        $fs = new RemoteFilesystem($io, null, $options);
-        $ref = new \ReflectionMethod($fs, 'getOptionsForUrl');
-        $prop = new \ReflectionProperty($fs, 'fileUrl');
+        $fs = new RemoteFilesystem($io, $this->getConfigMock(), $options);
+        $ref = new ReflectionMethod($fs, 'getOptionsForUrl');
+        $prop = new ReflectionProperty($fs, 'fileUrl');
         $ref->setAccessible(true);
         $prop->setAccessible(true);
 
@@ -301,17 +354,87 @@ class RemoteFilesystemTest extends TestC
         return $ref->invokeArgs($fs, $args);
     }
 
-    protected function callCallbackGet(RemoteFilesystem $fs, $notificationCode, $severity, $message, $messageCode, $bytesTransferred, $bytesMax)
+    /**
+     * @return MockObject|Config
+     */
+    private function getConfigMock()
+    {
+        $config = $this->getMockBuilder('Composer\Config')->getMock();
+        $config
+            ->method('get')
+            ->willReturnCallback(function ($key) {
+                if ($key === 'github-domains' || $key === 'gitlab-domains') {
+                    return array();
+                }
+
+                return null;
+            });
+
+        return $config;
+    }
+
+    private function callCallbackGet(RemoteFilesystem $fs, $notificationCode, $severity, $message, $messageCode, $bytesTransferred, $bytesMax)
     {
-        $ref = new \ReflectionMethod($fs, 'callbackGet');
+        $ref = new ReflectionMethod($fs, 'callbackGet');
         $ref->setAccessible(true);
         $ref->invoke($fs, $notificationCode, $severity, $message, $messageCode, $bytesTransferred, $bytesMax);
     }
 
-    protected function setAttribute($object, $attribute, $value)
+    private function setAttribute($object, $attribute, $value)
     {
-        $attr = new \ReflectionProperty($object, $attribute);
+        $attr = new ReflectionProperty($object, $attribute);
         $attr->setAccessible(true);
         $attr->setValue($object, $value);
     }
+
+    private function assertAttributeEqualsCustom($value, $attribute, $object)
+    {
+        $attr = new ReflectionProperty($object, $attribute);
+        $attr->setAccessible(true);
+        $this->assertSame($value, $attr->getValue($object));
+    }
+
+    /**
+     * @return MockObject|IOInterface
+     */
+    private function getIOInterfaceMock()
+    {
+        return $this->getMockBuilder('Composer\IO\IOInterface')->getMock();
+    }
+
+    /**
+     * @param array      $mockedMethods
+     * @param AuthHelper $authHelper
+     *
+     * @return RemoteFilesystem|MockObject
+     */
+    private function getRemoteFilesystemWithMockedMethods(array $mockedMethods, AuthHelper $authHelper = null)
+    {
+        return $this->getMockBuilder('Composer\Util\RemoteFilesystem')
+            ->setConstructorArgs(array(
+                $this->getIOInterfaceMock(),
+                $this->getConfigMock(),
+                array(),
+                false,
+                $authHelper,
+            ))
+            ->setMethods($mockedMethods)
+            ->getMock();
+    }
+
+    /**
+     * @param array $mockedMethods
+     *
+     * @return AuthHelper|MockObject
+     */
+    private function getAuthHelperWithMockedMethods(array $mockedMethods)
+    {
+        return $this->getMockBuilder('Composer\Util\AuthHelper')
+            ->setConstructorArgs(array(
+                $this->getIOInterfaceMock(),
+                $this->getConfigMock(),
+            ))
+            ->setMethods($mockedMethods)
+            ->getMock();
+    }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Util/StreamContextFactoryTest.php 2.0.9-1/tests/Composer/Test/Util/StreamContextFactoryTest.php
--- 1.10.19-1/tests/Composer/Test/Util/StreamContextFactoryTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/StreamContextFactoryTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -12,6 +12,7 @@
 
 namespace Composer\Test\Util;
 
+use Composer\Util\Http\ProxyManager;
 use Composer\Util\StreamContextFactory;
 use Composer\Test\TestCase;
 
@@ -19,22 +20,14 @@ class StreamContextFactoryTest extends T
 {
     protected function setUp()
     {
-        unset($_SERVER['HTTP_PROXY']);
-        unset($_SERVER['http_proxy']);
-        unset($_SERVER['HTTPS_PROXY']);
-        unset($_SERVER['https_proxy']);
-        unset($_SERVER['NO_PROXY']);
-        unset($_SERVER['no_proxy']);
+        unset($_SERVER['HTTP_PROXY'], $_SERVER['http_proxy'], $_SERVER['HTTPS_PROXY'], $_SERVER['https_proxy'], $_SERVER['NO_PROXY'], $_SERVER['no_proxy']);
+        ProxyManager::reset();
     }
 
     protected function tearDown()
     {
-        unset($_SERVER['HTTP_PROXY']);
-        unset($_SERVER['http_proxy']);
-        unset($_SERVER['HTTPS_PROXY']);
-        unset($_SERVER['https_proxy']);
-        unset($_SERVER['NO_PROXY']);
-        unset($_SERVER['no_proxy']);
+        unset($_SERVER['HTTP_PROXY'], $_SERVER['http_proxy'], $_SERVER['HTTPS_PROXY'], $_SERVER['https_proxy'], $_SERVER['NO_PROXY'], $_SERVER['no_proxy']);
+        ProxyManager::reset();
     }
 
     /**
@@ -139,23 +132,13 @@ class StreamContextFactoryTest extends T
         $context = StreamContextFactory::getContext('https://example.org', array('http' => array('method' => 'GET', 'header' => 'User-Agent: foo')));
         $options = stream_context_get_options($context);
 
-        $expected = array(
-            'http' => array(
-                'proxy' => 'tcp://proxyserver.net:80',
-                'request_fulluri' => true,
-                'method' => 'GET',
-                'header' => array('User-Agent: foo', "Proxy-Authorization: Basic " . base64_encode('username:password')),
-                'max_redirects' => 20,
-                'follow_location' => 1,
-            ), 'ssl' => array(
-                'SNI_enabled' => true,
-                'SNI_server_name' => 'example.org',
-            ),
-        );
-        if (PHP_VERSION_ID >= 50600) {
-            unset($expected['ssl']['SNI_server_name']);
-        }
-        $this->assertEquals($expected, $options);
+        $this->assertEquals(array('http' => array(
+            'proxy' => 'tcp://proxyserver.net:80',
+            'method' => 'GET',
+            'header' => array('User-Agent: foo', "Proxy-Authorization: Basic " . base64_encode('username:password')),
+            'max_redirects' => 20,
+            'follow_location' => 1,
+        )), $options);
     }
 
     public function testHttpsProxyOverride()
@@ -167,26 +150,9 @@ class StreamContextFactoryTest extends T
         $_SERVER['http_proxy'] = 'http://username:password@proxyserver.net';
         $_SERVER['https_proxy'] = 'https://woopproxy.net';
 
+        // Pointless test replaced by ProxyHelperTest.php
+        $this->setExpectedException('Composer\Downloader\TransportException');
         $context = StreamContextFactory::getContext('https://example.org', array('http' => array('method' => 'GET', 'header' => 'User-Agent: foo')));
-        $options = stream_context_get_options($context);
-
-        $expected = array(
-            'http' => array(
-                'proxy' => 'ssl://woopproxy.net:443',
-                'request_fulluri' => true,
-                'method' => 'GET',
-                'max_redirects' => 20,
-                'follow_location' => 1,
-                'header' => array('User-Agent: foo'),
-            ), 'ssl' => array(
-                'SNI_enabled' => true,
-                'SNI_server_name' => 'example.org',
-            ),
-        );
-        if (PHP_VERSION_ID >= 50600) {
-            unset($expected['ssl']['SNI_server_name']);
-        }
-        $this->assertEquals($expected, $options);
     }
 
     /**
@@ -212,7 +178,7 @@ class StreamContextFactoryTest extends T
                 StreamContextFactory::getContext('http://example.org');
                 $this->fail();
             } catch (\RuntimeException $e) {
-                $this->assertInstanceOf('RuntimeException', $e);
+                $this->assertInstanceOf('Composer\Downloader\TransportException', $e);
             }
         }
     }
@@ -246,4 +212,30 @@ class StreamContextFactoryTest extends T
         $ctxoptions = stream_context_get_options($context);
         $this->assertEquals(end($expectedOptions['http']['header']), end($ctxoptions['http']['header']));
     }
+
+    public function testInitOptionsDoesIncludeProxyAuthHeaders()
+    {
+        $_SERVER['http_proxy'] = 'http://username:password@proxyserver.net:3128/';
+
+        $options = array();
+        $options = StreamContextFactory::initOptions('https://example.org', $options);
+        $headers = implode(' ', $options['http']['header']);
+
+        $this->assertTrue(false !== stripos($headers, 'Proxy-Authorization'));
+    }
+
+    public function testInitOptionsForCurlDoesNotIncludeProxyAuthHeaders()
+    {
+        if (!extension_loaded('curl')) {
+            $this->markTestSkipped('The curl is not available.');
+        }
+
+        $_SERVER['http_proxy'] = 'http://username:password@proxyserver.net:3128/';
+
+        $options = array();
+        $options = StreamContextFactory::initOptions('https://example.org', $options, true);
+        $headers = implode(' ', $options['http']['header']);
+
+        $this->assertFalse(stripos($headers, 'Proxy-Authorization'));
+    }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Util/TarTest.php 2.0.9-1/tests/Composer/Test/Util/TarTest.php
--- 1.10.19-1/tests/Composer/Test/Util/TarTest.php	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/TarTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,65 @@
+<?php
+
+/*
+ * This file is part of Composer.
+ *
+ * (c) Nils Adermann <naderman@naderman.de>
+ *     Jordi Boggiano <j.boggiano@seld.be>
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Composer\Test\Util;
+
+use Composer\Util\Tar;
+use Composer\Test\TestCase;
+
+/**
+ * @author Wissem Riahi <wissemr@gmail.com>
+ */
+class TarTest extends TestCase
+{
+    public function testReturnsNullifTheTarIsNotFound()
+    {
+        $result = Tar::getComposerJson(__DIR__.'/Fixtures/Tar/invalid.zip');
+
+        $this->assertNull($result);
+    }
+
+    public function testReturnsNullIfTheTarIsEmpty()
+    {
+        $result = Tar::getComposerJson(__DIR__.'/Fixtures/Tar/empty.tar.gz');
+        $this->assertNull($result);
+    }
+
+    public function testThrowsExceptionIfTheTarHasNoComposerJson()
+    {
+        $this->setExpectedException('RuntimeException');
+        Tar::getComposerJson(__DIR__.'/Fixtures/Tar/nojson.tar.gz');
+    }
+
+    public function testThrowsExceptionIfTheComposerJsonIsInASubSubfolder()
+    {
+        $this->setExpectedException('RuntimeException');
+        Tar::getComposerJson(__DIR__.'/Fixtures/Tar/subfolders.tar.gz');
+    }
+
+    public function testReturnsComposerJsonInTarRoot()
+    {
+        $result = Tar::getComposerJson(__DIR__.'/Fixtures/Tar/root.tar.gz');
+        $this->assertEquals("{\n    \"name\": \"foo/bar\"\n}\n", $result);
+    }
+
+    public function testReturnsComposerJsonInFirstFolder()
+    {
+        $result = Tar::getComposerJson(__DIR__.'/Fixtures/Tar/folder.tar.gz');
+        $this->assertEquals("{\n    \"name\": \"foo/bar\"\n}\n", $result);
+    }
+
+    public function testMultipleTopLevelDirsIsInvalid()
+    {
+        $this->setExpectedException('RuntimeException');
+        Tar::getComposerJson(__DIR__.'/Fixtures/Tar/multiple.tar.gz');
+    }
+}
diff -pruN 1.10.19-1/tests/Composer/Test/Util/UrlTest.php 2.0.9-1/tests/Composer/Test/Util/UrlTest.php
--- 1.10.19-1/tests/Composer/Test/Util/UrlTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/UrlTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -58,4 +58,34 @@ class UrlTest extends TestCase
             array('https://mygitlab.com/api/v3/projects/foo%2Fbar/repository/archive.tar.bz2?sha=abcd', 'https://mygitlab.com/api/v3/projects/foo%2Fbar/repository/archive.tar.bz2?sha=65', array('gitlab-domains' => array('mygitlab.com')), '65'),
         );
     }
+
+    /**
+     * @dataProvider sanitizeProvider
+     */
+    public function testSanitize($expected, $url)
+    {
+        $this->assertSame($expected, Url::sanitize($url));
+    }
+
+    public static function sanitizeProvider()
+    {
+        return array(
+            // with scheme
+            array('https://foo:***@example.org/', 'https://foo:bar@example.org/'),
+            array('https://foo@example.org/', 'https://foo@example.org/'),
+            array('https://example.org/', 'https://example.org/'),
+            array('http://***:***@example.org', 'http://10a8f08e8d7b7b9:foo@example.org'),
+            array('https://foo:***@example.org:123/', 'https://foo:bar@example.org:123/'),
+            array('https://example.org/foo/bar?access_token=***', 'https://example.org/foo/bar?access_token=abcdef'),
+            array('https://example.org/foo/bar?foo=bar&access_token=***', 'https://example.org/foo/bar?foo=bar&access_token=abcdef'),
+            // without scheme
+            array('foo:***@example.org/', 'foo:bar@example.org/'),
+            array('foo@example.org/', 'foo@example.org/'),
+            array('example.org/', 'example.org/'),
+            array('***:***@example.org', '10a8f08e8d7b7b9:foo@example.org'),
+            array('foo:***@example.org:123/', 'foo:bar@example.org:123/'),
+            array('example.org/foo/bar?access_token=***', 'example.org/foo/bar?access_token=abcdef'),
+            array('example.org/foo/bar?foo=bar&access_token=***', 'example.org/foo/bar?foo=bar&access_token=abcdef'),
+        );
+    }
 }
diff -pruN 1.10.19-1/tests/Composer/Test/Util/ZipTest.php 2.0.9-1/tests/Composer/Test/Util/ZipTest.php
--- 1.10.19-1/tests/Composer/Test/Util/ZipTest.php	2020-12-11 15:21:48.000000000 +0000
+++ 2.0.9-1/tests/Composer/Test/Util/ZipTest.php	2021-01-27 15:09:27.000000000 +0000
@@ -20,7 +20,7 @@ use Composer\Test\TestCase;
  */
 class ZipTest extends TestCase
 {
-    public function testThrowsExceptionIfZipExcentionIsNotLoaded()
+    public function testThrowsExceptionIfZipExtensionIsNotLoaded()
     {
         if (extension_loaded('zip')) {
             $this->markTestSkipped('The PHP zip extension is loaded.');
@@ -35,6 +35,7 @@ class ZipTest extends TestCase
     {
         if (!extension_loaded('zip')) {
             $this->markTestSkipped('The PHP zip extension is not loaded.');
+
             return;
         }
 
@@ -47,6 +48,7 @@ class ZipTest extends TestCase
     {
         if (!extension_loaded('zip')) {
             $this->markTestSkipped('The PHP zip extension is not loaded.');
+
             return;
         }
 
@@ -55,34 +57,37 @@ class ZipTest extends TestCase
         $this->assertNull($result);
     }
 
-    public function testReturnsNullIfTheZipHasNoComposerJson()
+    public function testThrowsExceptionIfTheZipHasNoComposerJson()
     {
         if (!extension_loaded('zip')) {
             $this->markTestSkipped('The PHP zip extension is not loaded.');
+
             return;
         }
 
-        $result = Zip::getComposerJson(__DIR__.'/Fixtures/Zip/nojson.zip');
+        $this->setExpectedException('\RuntimeException', 'No composer.json found either at the top level or within the topmost directory');
 
-        $this->assertNull($result);
+        Zip::getComposerJson(__DIR__.'/Fixtures/Zip/nojson.zip');
     }
 
-    public function testReturnsNullIfTheComposerJsonIsInASubSubfolder()
+    public function testThrowsExceptionIfTheComposerJsonIsInASubSubfolder()
     {
         if (!extension_loaded('zip')) {
             $this->markTestSkipped('The PHP zip extension is not loaded.');
+
             return;
         }
 
-        $result = Zip::getComposerJson(__DIR__.'/Fixtures/Zip/subfolder.zip');
+        $this->setExpectedException('\RuntimeException', 'No composer.json found either at the top level or within the topmost directory');
 
-        $this->assertNull($result);
+        Zip::getComposerJson(__DIR__.'/Fixtures/Zip/subfolders.zip');
     }
 
     public function testReturnsComposerJsonInZipRoot()
     {
         if (!extension_loaded('zip')) {
             $this->markTestSkipped('The PHP zip extension is not loaded.');
+
             return;
         }
 
@@ -95,22 +100,36 @@ class ZipTest extends TestCase
     {
         if (!extension_loaded('zip')) {
             $this->markTestSkipped('The PHP zip extension is not loaded.');
+
             return;
         }
 
         $result = Zip::getComposerJson(__DIR__.'/Fixtures/Zip/folder.zip');
-
         $this->assertEquals("{\n    \"name\": \"foo/bar\"\n}\n", $result);
     }
 
-    public function testReturnsRootComposerJsonAndSkipsSubfolders()
+    public function testMultipleTopLevelDirsIsInvalid()
+    {
+        if (!extension_loaded('zip')) {
+            $this->markTestSkipped('The PHP zip extension is not loaded.');
+
+            return;
+        }
+
+        $this->setExpectedException('\RuntimeException', 'Archive has more than one top level directories, and no composer.json was found on the top level, so it\'s an invalid archive. Top level paths found were: folder1/,folder2/');
+
+        Zip::getComposerJson(__DIR__.'/Fixtures/Zip/multiple.zip');
+    }
+
+    public function testReturnsComposerJsonFromFirstSubfolder()
     {
         if (!extension_loaded('zip')) {
             $this->markTestSkipped('The PHP zip extension is not loaded.');
+
             return;
         }
 
-        $result = Zip::getComposerJson(__DIR__.'/Fixtures/Zip/multiple.zip');
+        $result = Zip::getComposerJson(__DIR__.'/Fixtures/Zip/single-sub.zip');
 
         $this->assertEquals("{\n    \"name\": \"foo/bar\"\n}\n", $result);
     }
diff -pruN 1.10.19-1/UPGRADE-2.0.md 2.0.9-1/UPGRADE-2.0.md
--- 1.10.19-1/UPGRADE-2.0.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.0.9-1/UPGRADE-2.0.md	2021-01-27 15:09:27.000000000 +0000
@@ -0,0 +1,111 @@
+# Upgrade guides for Composer 1.x to 2.0
+
+## For composer CLI users
+
+- The new platform-check feature means that Composer checks the runtime PHP version and available extensions to ensure they match the project dependencies. If a mismatch is found, it exits with error details to make sure problems are not overlooked. To avoid issues when deploying to production it is recommended to run `composer check-platform-reqs` with the production PHP process as part of your build or deployment process.
+- If a package exists in a higher priority repository, it will now be entirely ignored in lower priority repositories. See [repository priorities](https://getcomposer.org/repoprio) for details.
+- Invalid PSR-0 / PSR-4 class configurations will not autoload anymore in optimized-autoloader mode, as per the warnings introduced in 1.10
+- On linux systems supporting the XDG Base Directory Specification, Composer will now prefer using XDG_CONFIG_DIR/composer over `~/.composer` if both are available (1.x used `~/.composer` first)
+- Package names now must comply to our [naming guidelines](doc/04-schema.md#name) or Composer will abort, as per the warnings introduced in 1.8.1
+- Deprecated --no-suggest flag as it is not needed anymore
+- PEAR support (repository, downloader, etc.) has been removed
+- `update` now lists changes to the lock file first (update step), and then the changes applied when installing the lock file to the vendor dir (install step)
+- `HTTPS_PROXY_REQUEST_FULLURI` if not specified will now default to false as this seems to work better in most environments
+- `dev-trunk`, `dev-master` and `dev-default` are no longer aliases for each other. The exact branch names are now preserved.
+
+## For integrators and plugin authors
+
+- composer-plugin-api has been bumped to 2.0.0 - you can detect which version of Composer you run via `PluginInterface::PLUGIN_API_VERSION`
+- `PluginInterface` added a deactivate (so plugin can stop whatever it is doing) and an uninstall (so the plugin can remove any files it created or do general cleanup) method.
+- Plugins implementing `EventSubscriberInterface` will be deregistered from the EventDispatcher automatically when being deactivated, nothing to do there.
+- `Pool` objects are now created via the `RepositorySet` class, you should use that in case you were using the `Pool` class directly.
+- Custom installers extending from LibraryInstaller should be aware that in Composer 2 it MAY return PromiseInterface instances when calling parent::install/update/uninstall/installCode/removeCode. See [composer/installers](https://github.com/composer/installers/commit/5006d0c28730ade233a8f42ec31ac68fb1c5c9bb) for an example of how to handle this best.
+- The `Composer\Installer` class changed quite a bit internally, but the inputs are almost the same:
+  - `setAdditionalInstalledRepository` is now `setAdditionalFixedRepository`
+  - `setUpdateWhitelist` is now `setUpdateAllowList`
+  - `setWhitelistDependencies`, `setWhitelistTransitiveDependencies` and `setWhitelistAllDependencies` are now all rolled into `setUpdateAllowTransitiveDependencies` which takes one of the `Request::UPDATE_*` constants
+  - `setSkipSuggest` is gone
+- `vendor/composer/installed.json` format changed:
+  - packages are now wrapped into a `"packages"` top level key instead of the whole file being the package array
+  - packages now contain an `"installed-path"` key which lists where they were installed
+  - there is a top level `"dev"` key which stores whether dev requirements were installed or not
+- Removed `OperationInterface::getReason` as the data was not accurate. There is no replacement available.
+- `PreFileDownloadEvent` now receives an `HttpDownloader` instance instead of `RemoteFilesystem`, and that instance cannot be overridden by listeners anymore, you can however call setProcessedUrl or setCustomCacheKey.
+- `VersionSelector::findBestCandidate`'s third argument (phpVersion) was removed in favor of passing in a complete PlatformRepository instance into the constructor
+- `InitCommand::determineRequirements`'s fourth argument (phpVersion) should now receive a complete PlatformRepository instance or null if platform requirements are to be ignored
+- `IOInterface` now extends PSR-3's `LoggerInterface`, and has new `writeRaw` + `writeErrorRaw` methods
+- `RepositoryInterface` changes:
+  - A new `loadPackages(array $packageNameMap, array $acceptableStabilities, array $stabilityFlags)` function was added for use during pool building
+  - `search` now has a third `$type` argument
+  - A new `getRepoName()` function was added to describe the repository
+  - A new `getProviders()` function was added to list packages providing a given package's name
+- Removed `BaseRepository` abstract class
+- `DownloaderInterface` changes:
+  - `download` now receives a third `$prevPackage` argument for updates
+  - `download` should now only do network operations to prepare the package for installation but not actually install anything
+  - `prepare` (do user prompts or any checks which need to happen to make sure that install/update/remove will most likely succeed), `install` (should do the non-network part that `download` used to do) and `cleanup` (cleaning up anything that may be left over) were added as new steps in the package install flow
+  - All packages get first downloaded, then all together prepared, then all together installed/updated/uninstalled, then finally cleanup is called for all. Therefore for error recovery it is important to avoid failing during install/update/uninstall as much as possible, and risky things or user prompts should happen in the prepare step rather. In case of failure, cleanup() will be called so that changes can be undone as much as possible.
+- If you used `RemoteFilesystem` you probably should use `HttpDownloader` instead now
+- `PRE_DEPENDENCIES_SOLVING` and `POST_DEPENDENCIES_SOLVING` events have been removed, use the new `PRE_OPERATIONS_EXEC`, `PRE_POOL_CREATE` or other existing events instead or talk to us if you think you really need this. See below for more details.
+- The bundled composer/semver is now the 3.x range, see release notes for [2.0](https://github.com/composer/semver/releases/tag/2.0.0) and [3.0](https://github.com/composer/semver/releases/tag/3.0.0) for the minor breaking changes there
+- Run Composer with COMPOSER_DEBUG_EVENTS=1 set in the environment to show which events happen which might help you.
+
+### Detailed differences in event flow during dependency resolution, composer updates and installs
+
+#### Composer v1
+
+- Composer resolves dependencies (dispatching PRE/POST_DEPENDENCIES_SOLVING)
+- It then iterates over all packages one by one (dispatching PRE_PACKAGE_INSTALL/UPDATE/UNINSTALL, then PRE_FILE_DOWNLOAD if needed, then POST_PACKAGE_\*)
+- And finally writes the lock file at the end
+
+#### Composer v2
+
+The update and install process have been split up.
+
+Update does:
+
+- Composer resolves dependencies (dispatching PRE_POOL_CREATE)
+- It then writes the lock file and that's the end of the update
+
+Install then does:
+
+- Dispatches PRE_OPERATIONS_EXEC with the full list of operations to be executed
+- Downloads all the packages not in cache yet in parallel (dispatching PRE_FILE_DOWNLOAD for those not in cache yet)
+- It then iterates over all packages and executes updates/installs/uninstalls in parallel (dispatching PRE_PACKAGE_INSTALL/UPDATE/UNINSTALL then POST_PACKAGE_\* but one package started last may finish installing before another is done for example).
+
+## For Composer repository implementors
+
+Composer 2.0 adds support for a new Composer repository format.
+
+It is possible to build a repository which is compatible with both Composer v1 and v2, you keep everything you had and simply add the new fields in `packages.json`.
+
+Here are examples of the new values from packagist.org:
+
+### metadata-url
+
+`"metadata-url": "/p2/%package%.json",`
+
+This new metadata-url should serve all packages which are in the repository.
+
+- Whenever Composer looks for a package, it will replace `%package%` by the package name, and fetch that URL.
+- If dev stability is allowed for the package, it will also load the URL again with `$packageName~dev` (e.g. `/p2/foo/bar~dev.json` to look for `foo/bar`'s dev versions).
+- Caching is done via the use of If-Modified-Since header, so make sure you return Last-Modified headers and that they are accurate.
+- Any requested package which does not exist MUST return a 404 status code, which will indicate to Composer that this package does not exist in your repository. Make sure the 404 response is fast to avoid blocking Composer. Avoid redirects to alternative 404 pages.
+- The `foo/bar.json` and `foo/bar~dev.json` files containing package versions MUST contain only versions for the foo/bar package, as `{"packages":{"foo/bar":[ ... versions here ... ]}}`.
+- The array of versions can also optionally be minified using `Composer\Util\MetadataMinifier::minify()`. If you do that, you should add a `"minified": "composer/2.0"` key at the top level to indicate to Composer it must expand the version list back into the original data. See https://repo.packagist.org/p2/monolog/monolog.json for an example.
+
+If your repository only has a small number of packages, and you want to avoid the 404-requests, you can also specify an `"available-packages"` key in `packages.json` which should be an array with all the package names that your repository contain. Alternatively you can specify an `"available-package-patterns"` key which is an array of package name patterns (with `*` matching any string, e.g. `vendor/*` would make composer look up every matching package name in this repository).
+
+### providers-api
+
+`"providers-api": "https://packagist.org/providers/%package%.json",`
+
+The providers-api is optional, but if you implement it it should return packages which provide a given package name, but not the package which has that name. For example https://packagist.org/providers/monolog/monolog.json lists some package which have a "provide" rule for monolog/monolog, but it does not list monolog/monolog itself.
+
+### list
+
+This is also optional, it should accept an optional `?filter=xx` query param, which can contain `*` as wildcards matching any substring.
+
+It must return an array of package names as `{"packageNames": ["a/b", "c/d"]}`. See <https://packagist.org/packages/list.json?filter=composer/*> for example.
+
+It should return the names of package which names match the filter (or all names if no filter is present). Replace/provide rules should not be considered here.
